set define '^' verify off
prompt ...wwv_flow_t_plugin_attributes.sql
create or replace type wwv_flow_t_plugin_attributes as object (
--------------------------------------------------------------------------------
--
--  Copyright (c) 2024, Oracle and/or its affiliates.
--
--    NAME
--      wwv_flow_t_plugin_attributes.sql
--
--    DESCRIPTION
--      Object type that for reading plug-in attributes
--
--    MODIFIED   (MM/DD/YYYY)
--    sdobre      01/23/2024 - Created
--
--------------------------------------------------------------------------------

l_json sys.json_object_t,

constructor function wwv_flow_t_plugin_attributes (
    self    in out nocopy wwv_flow_t_plugin_attributes,
    p_json  in clob )
    return self as result,

constructor function wwv_flow_t_plugin_attributes (
    self    in out nocopy wwv_flow_t_plugin_attributes,
    p_plist in wwv_flow_t_varchar2 )
    return self as result,

final member function get_varchar2 (
    p_static_id in varchar2 )
    return varchar2,

final member function to_clob
    return clob
)

not persistable
/
show err