/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var labelUtils = require('./labelUtils-47c1d5dd.js');
var UNSAFE_Axis_themes_AxisStyles_css = require('./UNSAFE_Axis/themes/AxisStyles.css.js');
var UNSAFE_Axis_themes_redwood_AxisTheme = require('./UNSAFE_Axis/themes/redwood/AxisTheme.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var classNames = require('./classNames-3bb28eb9.js');
var clientHints = require('./clientHints-666b4780.js');

/**
 * Renders the svg text with given style and svg attributes.
 */
function SVGText({ text, style, textProps, isTitle, isInteractive, id }) {
    const browser = clientHints.getClientHints().browser;
    return (jsxRuntime.jsx("text", { style: style, ...textProps, class: classNames.classNames([
            isInteractive ? UNSAFE_Axis_themes_AxisStyles_css.styles.isInteractive : '',
            isTitle ? UNSAFE_Axis_themes_AxisStyles_css.styles.axisTitle : UNSAFE_Axis_themes_AxisStyles_css.styles.axisLabel,
            !isTitle && browser === 'safari' ? UNSAFE_Axis_themes_AxisStyles_css.styles.middleBaseline : ''
        ]), id: id, children: text }));
}
/**
 * Renders the chart axis.
 */
function Axis({ title, titleStyle, titleProps, tickLabels, tickLabelStyle, focusedGroupIndex, axisPosition, activeId, isTextInteractive }) {
    const { classes } = useComponentTheme.useComponentTheme(UNSAFE_Axis_themes_redwood_AxisTheme.AxisRedwoodTheme);
    return (jsxRuntime.jsxs("g", { class: classes, children: [title && jsxRuntime.jsx(SVGText, { text: title, textProps: titleProps, style: titleStyle, isTitle: true }), tickLabels.length > 0 && (jsxRuntime.jsx("g", { style: tickLabelStyle, children: tickLabels.map(({ label, labelProps, index }, renderedIndex) => {
                    const isFocused = focusedGroupIndex === renderedIndex;
                    return (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [isFocused ? (jsxRuntime.jsx("rect", { ...labelUtils.getEnclosingRectDims(labelProps, axisPosition), class: UNSAFE_Axis_themes_AxisStyles_css.styles.outlineRing })) : (''), jsxRuntime.jsx(SVGText, { textProps: {
                                    ...labelProps,
                                    'data-oj-object': 'group',
                                    'data-oj-group-index': index
                                }, text: label, isInteractive: isTextInteractive?.(index), id: isFocused ? activeId : '' })] }));
                }) }))] }));
}

exports.Axis = Axis;
//# sourceMappingURL=Axis-29b9b5d8.js.map
