/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var Text = require('./Text-15925a9e.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var UNSAFE_ButtonLayout_themes_redwood_ButtonLayoutTheme = require('./UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js');

const isNullOrUndefined = (value) => {
    return value === null || value === undefined;
};
function ButtonLayout({ size = 'md', display = 'all', styling = 'default', ...props }) {
    const isShowIcons = display === 'all' || display === 'icons';
    const isShowText = display === 'all' || display === 'label';
    const isOnlyIcon = props.startIcon && (display === 'icons' || !props.children) && !props.endIcon;
    const hasTextStartIcon = !isNullOrUndefined(props.startIcon) && display === 'all';
    const hasTextEndIcon = !isNullOrUndefined(props.endIcon) && isShowIcons;
    const isTwoIcons = !isNullOrUndefined(props.startIcon) && !isNullOrUndefined(props.endIcon);
    const isTwoIconsOnly = isTwoIcons && display === 'icons';
    const { classes: startIconClasses } = useComponentTheme.useComponentTheme(UNSAFE_ButtonLayout_themes_redwood_ButtonLayoutTheme.ButtonLayoutRedwoodTheme, {
        target: 'startIcon',
        size: styling == 'default' ? size : ('embedded' + size),
        onlyIcon: isOnlyIcon ? 'isOnlyIcon' : 'notOnlyIcon',
        twoIconsOnly: isTwoIconsOnly ? 'isTwoIconsOnly' : 'notTwoIconsOnly'
    });
    const { classes: labelClasses, styles: labelStyles } = useComponentTheme.useComponentTheme(UNSAFE_ButtonLayout_themes_redwood_ButtonLayoutTheme.ButtonLayoutRedwoodTheme, {
        target: 'label',
        size: styling == 'default' ? size : ('embedded' + size),
        textEndIcon: hasTextEndIcon ? 'hasTextEndIcon' : 'notTextEndIcon',
        textStartIcon: hasTextStartIcon ? 'hasTextStartIcon' : 'notTextStartIcon',
        suffix: props.suffix ? 'hasSuffix' : 'notSuffix',
        twoIcons: isTwoIcons ? 'hasTwoIcons' : 'notTwoIcons'
    });
    const { classes: suffixClasses } = useComponentTheme.useComponentTheme(UNSAFE_ButtonLayout_themes_redwood_ButtonLayoutTheme.ButtonLayoutRedwoodTheme, {
        target: 'suffix',
        size: styling == 'default' ? size : ('embedded' + size),
        textStartIcon: hasTextStartIcon ? 'hasTextStartIcon' : 'notTextStartIcon',
        twoIcons: isTwoIcons ? 'hasTwoIcons' : 'notTwoIcons'
    });
    const { classes: endIconClasses } = useComponentTheme.useComponentTheme(UNSAFE_ButtonLayout_themes_redwood_ButtonLayoutTheme.ButtonLayoutRedwoodTheme, {
        target: 'endIcon',
        textEndIcon: hasTextEndIcon ? 'hasTextEndIcon' : 'notTextEndIcon',
        twoIcons: isTwoIcons ? 'hasTwoIcons' : 'notTwoIcons',
        size: styling == 'default' ? size : ('embedded' + size)
    });
    return (jsxRuntime.jsxs("span", { class: labelStyles.container, children: [isShowIcons && props.startIcon && jsxRuntime.jsx("span", { class: startIconClasses, children: props.startIcon }), isShowText && props.children && jsxRuntime.jsxs("span", { class: labelClasses, children: [" ", props.children, " "] }), isShowText && props.suffix && (jsxRuntime.jsx("span", { class: suffixClasses, children: jsxRuntime.jsx(Text.Text, { truncation: 'ellipsis', weight: 'inherit', children: props.suffix }) })), isShowIcons && props.endIcon && jsxRuntime.jsx("span", { class: endIconClasses, children: props.endIcon })] }));
}
ButtonLayout.displayName = 'ButtonLayout';

exports.ButtonLayout = ButtonLayout;
//# sourceMappingURL=ButtonLayout-968b5cb9.js.map
