/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var dimensions = require('./dimensions-77289825.js');
var padding = require('./padding-f5c99049.js');
var colors = require('./colors-52f16e9d.js');
var mergeInterpolations = require('./mergeInterpolations-032e29ea.js');
var aria = require('./aria-1c2e3b5d.js');
var UNSAFE_Card_themes_CardStyles_css = require('./UNSAFE_Card/themes/CardStyles.css.js');
var classNames = require('./classNames-3bb28eb9.js');

const interpolations = [
    ...Object.values(dimensions.dimensionInterpolations),
    ...Object.values(colors.colorInterpolations),
    ...Object.values(padding.paddingInterpolations),
    ...Object.values(aria.ariaInterpolations)
];
const mergedInterpolations = mergeInterpolations.mergeInterpolations(interpolations);
/**
 * A card is a simple container that renders a group of related information in a styled rectangular area.
 * Width, height, padding, and background color are set through props.
 * The aria role for card is normally "group" but this changes to "button" for action cards.
 */
const Card = ({ children, ...rest }) => {
    const { class: mergedClasses, ariaLabel, ariaLabelledBy, ...mergedStyles } = mergedInterpolations(rest);
    const styles = classNames.classNames([UNSAFE_Card_themes_CardStyles_css.baseStyle, mergedClasses]);
    return (jsxRuntime.jsx("div", { "aria-label": ariaLabel, "aria-labelledby": ariaLabelledBy, role: "group", className: styles, style: mergedStyles, children: children }));
};

exports.Card = Card;
//# sourceMappingURL=Card-f545daf9.js.map
