/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var compat = require('preact/compat');
var CheckboxRadioContext = require('./CheckboxRadioContext-45cad1d9.js');
var HiddenAccessible = require('./HiddenAccessible-ce5d15d7.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var useFocus = require('./useFocus-e84e6c2e.js');
var classNames = require('./classNames-3bb28eb9.js');
require('./TabbableModeContext-4fb7c910.js');
var useTabbableMode = require('./useTabbableMode-98443dc8.js');
var useTranslationBundle = require('./useTranslationBundle-9549e176.js');


require('./UNSAFE_UserAssistance/themes/redwood/UserAssistanceVariants.css.js');
require('preact/hooks');
require('./Flex-299660c2.js');


require('./UNSAFE_MessageBanner/themes/redwood/MessageBannerVariants.css.js');
require('preact');
var useId = require('./useId-42e8026e.js');
require('./Floating-8ecf7694.js');
require('./TopLayerHost-b320c750.js');


require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js');

require('./IconButton-df477106.js');

require('./MessageFormattingUtils-034ac55d.js');
require('./logger-01b28029.js');
require('./TransitionGroup-2e7eb24a.js');
require('./MessagesContext-bca47518.js');


require('./UNSAFE_ComponentMessage/themes/redwood/ComponentMessageVariants.css.js');
require('./FormContext-4a2edf25.js');
require('./FormFieldContext-81c48156.js');
require('./InputGroupContext-0da40eb1.js');
require('./Popup-a64bbf6a.js');
require('./UNSAFE_Separator/themes/SeparatorStyles.css.js');
var useFocusWithin = require('./useFocusWithin-85253272.js');


require('./UNSAFE_Label/themes/redwood/LabelVariants.css.js');
var IconUserAssistance = require('./IconUserAssistance-13d746ec.js');
var StyledCheckbox = require('./StyledCheckbox-762a6108.js');
var UNSAFE_Checkbox_themes_redwood_CheckboxTheme = require('./UNSAFE_Checkbox/themes/redwood/CheckboxTheme.js');
var useActive = require('./useActive-5db5a3fb.js');
var stringUtils = require('./stringUtils-5ffab770.js');
var LayoutStyles_css = require('./LayoutStyles.css-4d8455b4.js');

/**
 * CheckboxControl is an internal subcomponent used by both Checkbox and CheckboxItem.
 * It handles styling, placement of label, assistive text, and accessibility text for both parent components.
 * onCommit handling is handled in the parent components.
 */
const CheckboxControl = compat.forwardRef(({ 'aria-describedby': ariaDescribedBy, name, value, children, isChecked, isDisabled, isReadonly, isRequired, onChange, onKeyUp, assistiveText, helpSourceLink, helpSourceText, columnSpan = 1 }, ref = null) => {
    // hooks
    const id = useId.useId();
    const childWrapperRef = compat.useRef(null);
    const { isTabbable } = useTabbableMode.useTabbableMode();
    const { isActive, activeProps } = useActive.useActive();
    const { isFocusRingShown } = CheckboxRadioContext.useCheckboxRadioContext();
    const { isFocus, focusProps: { onFocus, onBlur } } = useFocus.useFocus();
    // styling
    const { classes: checkboxClasses, styles: { valueLabelStyle } } = useComponentTheme.useComponentTheme(UNSAFE_Checkbox_themes_redwood_CheckboxTheme.CheckboxRedwoodTheme, {
        disabled: isDisabled ? 'isDisabled' : 'notDisabled',
        focused: isFocus && isFocusRingShown ? 'isFocused' : 'notFocused'
    });
    // help available
    const hasUserAssistive = !isDisabled && !isReadonly && !!(assistiveText || helpSourceLink);
    const helpAvailableId = hasUserAssistive ? `${id}-help-available` : undefined;
    const uaId = hasUserAssistive ? `${id}-icon-ua` : undefined;
    const { formControl_helpAvailable } = useTranslationBundle.useTranslationBundle('@oracle/oraclejet-preact');
    const helpAvailableString = formControl_helpAvailable();
    const userAssistiveHelp = hasUserAssistive ? (jsxRuntime.jsx(HiddenAccessible.HiddenAccessible, { id: helpAvailableId, children: helpAvailableString })) : undefined;
    // prevent auto scrolling
    const onKeyDown = (event) => {
        const { key } = event;
        if (!isReadonly && key !== undefined && key === ' ') {
            event.preventDefault();
        }
    };
    // we want to prevent mouseDown on Links to set active
    const onMouseDownHandler = (e) => {
        // check to see if the target is within an <a> tag and the tag is within the label
        const closestAnchor = e.target.closest('a');
        closestAnchor && childWrapperRef.current?.contains(closestAnchor)
            ? e.stopPropagation()
            : activeProps['onMouseDown']?.(e);
    };
    // don't allow key down to set active state
    delete activeProps['onKeyDown'];
    const { focusProps, isFocused: isFocusedWithin } = useFocusWithin.useFocusWithin();
    // The top level element needs the column span class on it.
    const classes = LayoutStyles_css.layoutSpanStyles.layoutSpanColumn[columnSpan];
    return (jsxRuntime.jsxs("label", { class: classNames.classNames([checkboxClasses, classes]), children: [jsxRuntime.jsx("span", { ...activeProps, children: jsxRuntime.jsx(StyledCheckbox.StyledCheckbox, { "aria-describedby": stringUtils.merge([ariaDescribedBy, helpAvailableId]), name: name, value: value, onChange: onChange, onBlur: onBlur, onFocus: onFocus, onKeyUp: onKeyUp, onKeyDown: onKeyDown, isActive: isActive, isChecked: isChecked ? 'checked' : 'unchecked', isDisabled: isDisabled, isReadonly: isReadonly, isRequired: isRequired, ref: ref }) }), userAssistiveHelp, jsxRuntime.jsxs("span", { class: valueLabelStyle, children: [jsxRuntime.jsx("span", { ...activeProps, ...focusProps, onMouseDown: onMouseDownHandler, ref: childWrapperRef, children: children }), hasUserAssistive && (jsxRuntime.jsx(IconUserAssistance.IconUserAssistance, { assistiveText: assistiveText, helpSourceLink: helpSourceLink, helpSourceText: helpSourceText, isTabbable: isTabbable && (isFocus || isFocusedWithin), id: uaId }))] })] }));
});

exports.CheckboxControl = CheckboxControl;
//# sourceMappingURL=CheckboxControl-8a863711.js.map
