/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var useActionable = require('./useActionable-604c4209.js');
var hooks = require('preact/hooks');
require('./TabbableModeContext-4fb7c910.js');
var useTabbableMode = require('./useTabbableMode-98443dc8.js');
var UNSAFE_Chip_themes_ChipStyles_css = require('./UNSAFE_Chip/themes/ChipStyles.css.js');
var useInteractionStyle = require('./useInteractionStyle-6e5ba1b2.js');
var mergeProps = require('./mergeProps-f6f4322f.js');
var useTestId = require('./useTestId-4fe30223.js');

function Chip({ isSelected, isDisabled, 'aria-label': accessibleLabel, children, testId, onToggle }) {
    const handleAction = hooks.useCallback(() => {
        onToggle?.({ previousValue: isSelected, value: !isSelected });
    }, [isSelected, onToggle]);
    const { actionableProps } = useActionable.useActionable(handleAction);
    const { interactionProps, applyActiveStyle, applyHoverStyle, applyPseudoHoverStyle } = useInteractionStyle.useInteractionStyle();
    const mergedProps = mergeProps.mergeProps(actionableProps, interactionProps);
    const classes = UNSAFE_Chip_themes_ChipStyles_css.multiVariantStyles({
        disabled: isDisabled ? 'isDisabled' : 'notDisabled',
        hover: applyHoverStyle && !isDisabled && !isSelected ? 'isHover' : 'notHover',
        pseudoHover: applyPseudoHoverStyle && !isDisabled && !isSelected ? 'isPseudoHover' : 'notPseudoHover',
        active: isSelected || applyActiveStyle ? 'isActive' : 'notActive'
    });
    const { isTabbable } = useTabbableMode.useTabbableMode();
    const testIdProps = useTestId.useTestId(testId);
    return isDisabled ? (jsxRuntime.jsx("div", { class: classes, ...testIdProps, children: children })) : (jsxRuntime.jsx("div", { ...mergedProps, class: classes, ...testIdProps, tabIndex: isTabbable ? 0 : -1, "aria-label": accessibleLabel, role: "switch", "aria-checked": isSelected ? 'true' : 'false', children: children }));
}

exports.Chip = Chip;
//# sourceMappingURL=Chip-6292a156.js.map
