/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var hooks = require('preact/hooks');
var usePress = require('./usePress-42f3876b.js');
var useTranslationBundle = require('./useTranslationBundle-9549e176.js');

var classNames = require('./classNames-3bb28eb9.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var UNSAFE_ButtonLayout_themes_redwood_ButtonLayoutTheme = require('./UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js');

var clearIconStyles = 'ClearIconStyles_clearIconStyles__8wwy0m0';

const noop = () => { };
function ClearIcon({ onClick }) {
    const killEvent = hooks.useCallback((event) => {
        event.preventDefault();
    }, []);
    const { pressProps } = usePress.usePress(onClick ?? noop);
    const translations = useTranslationBundle.useTranslationBundle('@oracle/oraclejet-preact');
    const clearStr = translations.formControl_clear();
    // Because the ClearIconStyles.css.ts uses buttonLayoutBaseTheme styles, we
    // need their vars to be loaded as well. This is why we are adding the buttonLayoutBaseTheme
    // style class.
    // TODO: update ButtonLayoutRedwoodTheme once theme switching is re-enabled.
    const { baseTheme: buttonLayoutBaseTheme } = useComponentTheme.useComponentTheme(UNSAFE_ButtonLayout_themes_redwood_ButtonLayoutTheme.ButtonLayoutRedwoodTheme);
    const styleClasses = classNames.classNames([buttonLayoutBaseTheme, clearIconStyles]);
    return (jsxRuntime.jsx("span", { "aria-hidden": "true", class: styleClasses, tabIndex: -1, onMouseDown: killEvent, title: clearStr, ...pressProps, children: jsxRuntime.jsx("svg", { height: "1em", viewBox: "0 0 24 24", width: "1em", xmlns: "http://www.w3.org/2000/svg", children: jsxRuntime.jsx("path", { d: "m12 1c6.065 0 11 4.935 11 11s-4.935 11-11 11-11-4.935-11-11 4.935-11 11-11zm3.4979817 6-3.4979817 3.498-3.49798173-3.498-1.50201827 1.50201827 3.498 3.49798173-3.498 3.4979817 1.50201827 1.5020183 3.49798173-3.498 3.4979817 3.498 1.5020183-1.5020183-3.498-3.4979817 3.498-3.49798173z", fill: "currentcolor", "fill-rule": "evenodd" }) }) }));
}

exports.ClearIcon = ClearIcon;
//# sourceMappingURL=ClearIcon-7f9e3194.js.map
