/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var dimensions = require('./dimensions-77289825.js');
var mergeInterpolations = require('./mergeInterpolations-032e29ea.js');
var boxalignment = require('./boxalignment-e0031b0e.js');
var flexbox = require('./flexbox-07759e95.js');
var flexitem = require('./flexitem-403ef425.js');
var classNames = require('./classNames-3bb28eb9.js');


var baseStyles = 'FlexStyles_baseStyles__10p93f60';
var marginZeroStyles = 'FlexStyles_marginZeroStyles__10p93f61';

const interpolations = [
    ...Object.values(dimensions.dimensionInterpolations),
    ...Object.values(flexbox.flexboxInterpolations),
    ...Object.values(flexitem.flexitemInterpolations),
    ...Object.values(boxalignment.boxAlignmentInterpolations)
];
const styleInterpolations = mergeInterpolations.mergeInterpolations(interpolations);
const Flex = ({ children, hasZeroMargins = true, ...props }) => {
    const flexComponentClasses = classNames.classNames([baseStyles, hasZeroMargins && marginZeroStyles]);
    const { class: cls, ...styles } = styleInterpolations(props);
    return (jsxRuntime.jsx("div", { class: `${flexComponentClasses} ${cls}`, style: styles, children: children }));
};

exports.Flex = Flex;
exports.marginZeroStyles = marginZeroStyles;
//# sourceMappingURL=Flex-299660c2.js.map
