/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var grid = require('./grid-c1c37894.js');
var boxalignment = require('./boxalignment-e0031b0e.js');
var mergeInterpolations = require('./mergeInterpolations-032e29ea.js');


var baseStyles = 'GridStyles_baseStyles__11rn47i0';

const interpolations = [
    ...Object.values(grid.gridInterpolations),
    ...Object.values(boxalignment.boxAlignmentInterpolations)
];
const styleInterpolations = mergeInterpolations.mergeInterpolations(interpolations);
/**
 * An implicit grid. Resize your browser to see how items reflow.
 */
const Grid = ({ children, ...props }) => {
    const { class: cls, ...styles } = styleInterpolations(props);
    const allStyles = { ...styles };
    return (jsxRuntime.jsx("div", { class: `${baseStyles} ${cls}`, style: allStyles, children: children }));
};

exports.Grid = Grid;
//# sourceMappingURL=Grid-b0da0d92.js.map
