/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var ButtonLayout = require('./ButtonLayout-968b5cb9.js');
var ChevronDown = require('./ChevronDown-ee6df8fc.js');
var Menu = require('./Menu-32a465f9.js');
require('./MenuItem-a515fda3.js');
var hooks = require('preact/hooks');
var preact = require('preact');
var useTooltip = require('./useTooltip-ce4554e9.js');
require('./Floating-8ecf7694.js');
var compat = require('preact/compat');
require('./TopLayerHost-b320c750.js');
var mergeProps = require('./mergeProps-f6f4322f.js');
require('./logger-01b28029.js');


require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js');

require('./SelectMenuGroupContext-0b999e09.js');
require('./UNSAFE_Separator/themes/SeparatorStyles.css.js');


require('./UNSAFE_Menu/themes/redwood/MenuSeparatorVariants.css.js');
var useMenuAction = require('./useMenuAction-a28a1551.js');
var BaseButton = require('./BaseButton-1fd978ce.js');

/**
 * A IconMenuButton is a combined action and menu button.
 */
const IconMenuButton = compat.forwardRef(({ children, tooltip, accessibleLabel, variant = 'outlined', isDisabled = false, isMenuOpen = false, isIconOnly = false, onToggleMenu, size = 'md', type: buttonType = 'button', testId, width, icon, 'aria-describedby': ariaDescribedBy }, ref) => {
    const buttonRef = hooks.useRef(null);
    hooks.useImperativeHandle(ref, () => buttonRef.current, [buttonRef]);
    const { triggerProps, menuProps } = useMenuAction.useMenuAction({
        isDisabled: isDisabled,
        onToggleMenu: onToggleMenu,
        isMenuOpen: isMenuOpen,
        anchorRef: buttonRef
    });
    const { tooltipContent, tooltipProps } = useTooltip.useTooltip({
        text: tooltip ? tooltip : accessibleLabel,
        isDisabled: isMenuOpen || isDisabled
    });
    const elementDetails = {
        type: 'button',
        buttonType: buttonType
    };
    const rootButton = (jsxRuntime.jsx(preact.Fragment, { children: jsxRuntime.jsxs(BaseButton.BaseButton, { ...mergeProps.mergeProps(tooltipProps, triggerProps), styling: isMenuOpen ? ['min', 'active'] : ['min'], elementDetails: elementDetails, isDisabled: isDisabled, variant: variant, width: width, size: size, ref: buttonRef, "aria-describedby": ariaDescribedBy, "aria-label": accessibleLabel ?? tooltip, testId: testId, children: [jsxRuntime.jsx(ButtonLayout.ButtonLayout, { display: 'icons', startIcon: icon, endIcon: isIconOnly ? null : jsxRuntime.jsx(ChevronDown.SvgChevronDown, {}), size: size }), tooltipContent] }) }));
    /*TODO: Remove this hardcoded offsetValue so we have dropdown offset only set on one single place.
     Could be done via menu props or having a dropdownMenu component. JET-60595*/
    return isDisabled ? (rootButton) : (jsxRuntime.jsxs(preact.Fragment, { children: [rootButton, jsxRuntime.jsx(Menu.Menu, { ...menuProps, offsetValue: 4, "aria-label": accessibleLabel ?? tooltip, children: children })] }));
});
IconMenuButton.displayName = 'IconMenuButton';

exports.IconMenuButton = IconMenuButton;
//# sourceMappingURL=IconMenuButton-574d55f1.js.map
