/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var compat = require('preact/compat');
var TopLayerHost = require('./TopLayerHost-b320c750.js');

function LayerManager({ children }) {
    const [defaultHost, setDefaultHost] = compat.useState();
    const [defaultTopHost, setDefaultTopHost] = compat.useState();
    //const context = useContext(LayerContext);
    const defaultHostRef = compat.useCallback((el) => {
        // ref callbacks fire after the component has been unnmounted so we do not
        // want to set state in this use-case
        if (el !== null) {
            setDefaultHost(el);
        }
    }, []);
    const defaultTopHostRef = compat.useCallback((el) => {
        // ref callbacks fire after the component has been unnmounted so we do not
        // want to set state in this use-case
        if (el !== null) {
            setDefaultTopHost(el);
        }
    }, []);
    return (jsxRuntime.jsx(TopLayerHost.LayerContext.Consumer, { children: (value) => {
            let defaultHostContext = {};
            if (defaultHost && defaultTopHost) {
                defaultHostContext = {
                    priority: undefined,
                    getHost: (priority) => {
                        return priority === 'top' ? defaultTopHost : defaultHost;
                    }
                };
            }
            const layerContext = value.getHost ? value : defaultHostContext;
            return (jsxRuntime.jsxs(TopLayerHost.LayerContext.Provider, { value: layerContext, children: [children, !value.getHost && jsxRuntime.jsx(TopLayerHost.LayerHost, { ref: defaultHostRef }), !value.getHost && jsxRuntime.jsx(TopLayerHost.TopLayerHost, { ref: defaultTopHostRef })] }));
        } }));
}

exports.LayerManager = LayerManager;
//# sourceMappingURL=LayerManager-70d05a53.js.map
