/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var classNames = require('./classNames-3bb28eb9.js');
var usePress = require('./usePress-42f3876b.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var useInteractionStyle = require('./useInteractionStyle-6e5ba1b2.js');
var UNSAFE_Link_themes_redwood_LinkTheme = require('./UNSAFE_Link/themes/redwood/LinkTheme.js');
require('./TabbableModeContext-4fb7c910.js');
var useTabbableMode = require('./useTabbableMode-98443dc8.js');
var useTestId = require('./useTestId-4fe30223.js');

const noop = () => { };
function Link({ href, variant, placement = 'standalone', target, testId, 'aria-describedby': ariaDescribedBy, 'aria-label': accessibleLabel, 'aria-labelledby': ariaLabelledBy, children, onClick }) {
    const { interactionProps, applyPseudoHoverStyle, applyHoverStyle } = useInteractionStyle.useInteractionStyle();
    const { classes } = useComponentTheme.useComponentTheme(UNSAFE_Link_themes_redwood_LinkTheme.LinkRedwoodTheme, {
        needsEventsHover: applyHoverStyle ? 'isNeedsEventsHover' : 'notNeedsEventsHover',
        pseudoHover: applyPseudoHoverStyle ? 'isPseudoHover' : 'notPseudoHover',
        variant,
        placement
    });
    const { isTabbable } = useTabbableMode.useTabbableMode();
    const linkClasses = classNames.classNames([classes]);
    const { pressProps } = usePress.usePress(onClick ?? noop);
    const testIdProps = useTestId.useTestId(testId);
    return (jsxRuntime.jsx("a", { tabIndex: isTabbable ? 0 : -1, href: href, "aria-describedby": ariaDescribedBy, "aria-label": accessibleLabel, "aria-labelledby": ariaLabelledBy, target: target, ...pressProps, ...interactionProps, ...testIdProps, class: linkClasses, children: children }));
}

exports.Link = Link;
//# sourceMappingURL=Link-667d2f5b.js.map
