/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var List = require('./List-1619c2d0.js');

function ListView(props) {
    const dataMetadata = props.data
        ? props.data.map((aData) => {
            const key = props.getRowKey(aData);
            return { data: aData, metadata: { key } };
        })
        : null;
    const loadRange = props.onLoadMore ? props.onLoadMore : () => { };
    const dataState = dataMetadata
        ? {
            offset: 0,
            data: dataMetadata,
            sizePrecision: props.hasMore ? 'atLeast' : 'exact',
            totalSize: dataMetadata.length
        }
        : null;
    return (jsxRuntime.jsx(List.List, { isVirtualized: false, ...props, onLoadRange: loadRange, data: dataState, children: props.children }));
}

exports.ListView = ListView;
//# sourceMappingURL=ListView-a39b61d7.js.map
