/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var preact = require('preact');
var useDebounce = require('./useDebounce-e9ac1734.js');
var useTranslationBundle = require('./useTranslationBundle-9549e176.js');
var LiveRegion = require('./LiveRegion-30bd9fad.js');

const MAX_LENGTH_UPDATE_DELAY = 500;
function MaxLengthLiveRegion({ isMaxLengthExceeded, maxLength, valueLength = 0 }) {
    // Comment copied from InputBase.js in Big JET:
    // Only update the aria-live div when the user has paused for more than
    // 500 milliseconds. That way, we avoid queued up aria-live messages which
    // would be annoying and not helpful. The 500ms was agreed upon in the
    // accessibility review meeting.
    const debouncedRemainingChars = useDebounce.useDebounce(maxLength - valueLength, MAX_LENGTH_UPDATE_DELAY);
    const translations = useTranslationBundle.useTranslationBundle('@oracle/oraclejet-preact');
    const maxLengthExceededTranslatedString = translations.formControl_maxLengthExceeded({
        MAX_LENGTH: `${maxLength}`
    });
    const remainingCharsTranslatedString = translations.formControl_maxLengthRemaining({
        CHARACTER_COUNT: `${debouncedRemainingChars}`
    });
    return (jsxRuntime.jsxs(preact.Fragment, { children: [jsxRuntime.jsx(LiveRegion.LiveRegion, { children: remainingCharsTranslatedString }), isMaxLengthExceeded && (jsxRuntime.jsx(LiveRegion.LiveRegion, { type: "assertive", children: maxLengthExceededTranslatedString }))] }));
}

exports.MaxLengthLiveRegion = MaxLengthLiveRegion;
//# sourceMappingURL=MaxLengthLiveRegion-177bfbfa.js.map
