/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var ButtonLayout = require('./ButtonLayout-968b5cb9.js');
var ChevronDown = require('./ChevronDown-ee6df8fc.js');
var Menu = require('./Menu-32a465f9.js');
require('./MenuItem-a515fda3.js');
var hooks = require('preact/hooks');
var preact = require('preact');
require('./Floating-8ecf7694.js');
var compat = require('preact/compat');
require('./TopLayerHost-b320c750.js');
var mergeProps = require('./mergeProps-f6f4322f.js');
require('./logger-01b28029.js');


require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js');

require('./SelectMenuGroupContext-0b999e09.js');
require('./UNSAFE_Separator/themes/SeparatorStyles.css.js');


require('./UNSAFE_Menu/themes/redwood/MenuSeparatorVariants.css.js');
var useMenuAction = require('./useMenuAction-a28a1551.js');
var BaseButton = require('./BaseButton-1fd978ce.js');

/**
 * A MenuButton is a combined action and menu button.
 */
const MenuButton = compat.forwardRef(({ children, label, suffix, variant = 'outlined', isDisabled = false, isMenuOpen = false, onToggleMenu, size = 'md', type: buttonType = 'button', width, icon, testId, 'aria-describedby': ariaDescribedBy, onBlur, onFocus, onMouseEnter, onMouseLeave, onTouchEnd, onTouchStart }, ref) => {
    const buttonRef = hooks.useRef(null);
    hooks.useImperativeHandle(ref, () => buttonRef.current, [buttonRef]);
    const { triggerProps, menuProps } = useMenuAction.useMenuAction({
        isDisabled: isDisabled,
        onToggleMenu: onToggleMenu,
        isMenuOpen: isMenuOpen,
        anchorRef: buttonRef
    });
    const elementDetails = {
        type: 'button',
        buttonType: buttonType
    };
    const globalEventProps = {
        onBlur,
        onFocus,
        onMouseEnter,
        onMouseLeave,
        onTouchEnd,
        onTouchStart
    };
    const rootButton = (jsxRuntime.jsx(BaseButton.BaseButton, { ...mergeProps.mergeProps(triggerProps, globalEventProps), styling: isMenuOpen ? ['min', 'active'] : ['min'], elementDetails: elementDetails, isDisabled: isDisabled, variant: variant, width: width, size: size, ref: buttonRef, testId: testId, "aria-label": suffix ? `${label} ${suffix}` : label, "aria-describedby": ariaDescribedBy, children: jsxRuntime.jsx(ButtonLayout.ButtonLayout, { display: 'all', suffix: suffix, startIcon: icon, endIcon: jsxRuntime.jsx(ChevronDown.SvgChevronDown, {}), size: size, children: label }) }));
    /*TODO: Remove this hardcoded offsetValue so we have dropdown offset only set on one single place.
     Could be done via menu props or having a dropdownMenu component. JET-60595*/
    /*TODO: Once menu expose a prop to set min width we would need to calculate offset width of button
      so we set the correct min width since dropdown menus are 200px but if triggered element width is
      bigger should be that size. JET-60745 */
    return isDisabled ? (rootButton) : (jsxRuntime.jsxs(preact.Fragment, { children: [rootButton, jsxRuntime.jsx(Menu.Menu, { ...menuProps, "aria-label": label, offsetValue: 4, children: children })] }));
});
MenuButton.displayName = 'MenuButton';

exports.MenuButton = MenuButton;
//# sourceMappingURL=MenuButton-1bf757b4.js.map
