/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var Close = require('./Close-86d2d000.js');
var IconButton = require('./IconButton-df477106.js');
var useTranslationBundle = require('./useTranslationBundle-9549e176.js');
var classNames = require('./classNames-3bb28eb9.js');
var PRIVATE_Message_themes_MessageStyles_css = require('./PRIVATE_Message/themes/MessageStyles.css.js');

/**
 * A Component for rendering the message close button
 */
function MessageCloseButton({ onAction, variant = 'banner' }) {
    const translations = useTranslationBundle.useTranslationBundle('@oracle/oraclejet-preact');
    const renderedButton = (jsxRuntime.jsx(IconButton.IconButton, { "aria-label": translations.message_close(), size: "sm", variant: "borderless", onAction: onAction, children: jsxRuntime.jsx(Close.SvgClose, {}) }));
    // TODO:  Refactor to utilize useComponentTheme and multiVariantStyles.
    const classes = classNames.classNames([PRIVATE_Message_themes_MessageStyles_css.messageCloseButtonStyles.base, PRIVATE_Message_themes_MessageStyles_css.messageCloseButtonStyles[variant]]);
    // Otherwise, render the close icon
    return (jsxRuntime.jsx("div", { class: classes, "data-oj-message-close-button": "", children: renderedButton }));
}

exports.MessageCloseButton = MessageCloseButton;
//# sourceMappingURL=MessageCloseButton-78f05c99.js.map
