/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var classNames = require('./classNames-3bb28eb9.js');
var SuccessS = require('./SuccessS-3a2c6dd4.js');
var ErrorS = require('./ErrorS-6012f9f3.js');
var InformationS = require('./InformationS-c18dd806.js');
var WarningS = require('./WarningS-5dd358a1.js');
var Flex = require('./Flex-299660c2.js');
var PRIVATE_Message_themes_MessageStyles_css = require('./PRIVATE_Message/themes/MessageStyles.css.js');
var useTranslationBundle = require('./useTranslationBundle-9549e176.js');

const severityIcons = {
    confirmation: SuccessS.SvgSuccessS,
    error: ErrorS.SvgErrorS,
    info: InformationS.SvgInformationS,
    warning: WarningS.SvgWarningS
};
/**
 * StartIcon Component for rendering the severity based icon in Message
 */
function MessageStartIcon({ severity, variant = 'banner' }) {
    const IconComponent = severityIcons[severity];
    const translations = useTranslationBundle.useTranslationBundle('@oracle/oraclejet-preact');
    const labelMap = {
        confirmation: translations.message_confirmation(),
        error: translations.message_error(),
        info: translations.message_info(),
        warning: translations.message_warning()
    };
    // TODO: JET-50793
    const iconContent = variant !== 'inline' ? (jsxRuntime.jsx(Flex.Flex, { align: "center", height: "100%", children: jsxRuntime.jsx("span", { class: PRIVATE_Message_themes_MessageStyles_css.startIconContainerStyles[variant], role: "img", "aria-label": labelMap[severity], children: jsxRuntime.jsx(IconComponent, {}) }) })) : (jsxRuntime.jsx("span", { class: PRIVATE_Message_themes_MessageStyles_css.startIconContainerStyles.inline, role: "img", "aria-label": labelMap[severity], children: jsxRuntime.jsx(IconComponent, {}) }));
    // If detail content is rendered, then wrap it in a div with specified style classes
    return (jsxRuntime.jsx("div", { class: classNames.classNames([
            PRIVATE_Message_themes_MessageStyles_css.messageStartIconStyles.base,
            PRIVATE_Message_themes_MessageStyles_css.messageStartIconStyles[variant],
            PRIVATE_Message_themes_MessageStyles_css.severityIconStyles[variant]
        ]), role: "presentation", children: iconContent }));
}

exports.MessageStartIcon = MessageStartIcon;
//# sourceMappingURL=MessageStartIcon-da24f8bc.js.map
