/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var classNames = require('./classNames-3bb28eb9.js');
var PRIVATE_Message_themes_MessageStyles_css = require('./PRIVATE_Message/themes/MessageStyles.css.js');

/**
 * Summary Component for rendering the summary text of the Message
 */
function MessageSummary({ text, variant = 'banner' }) {
    // If detail content is rendered, then wrap it in a div with specified style classes
    // TODO:  Refactor to utilize useComponentTheme and multiVariantStyles.
    const classes = classNames.classNames([PRIVATE_Message_themes_MessageStyles_css.messageSummaryStyles.base, PRIVATE_Message_themes_MessageStyles_css.messageSummaryStyles[variant]]);
    return (jsxRuntime.jsx("div", { role: "heading", class: classes, children: text }));
}

exports.MessageSummary = MessageSummary;
//# sourceMappingURL=MessageSummary-da4a1807.js.map
