/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var classNames = require('./classNames-3bb28eb9.js');
var PRIVATE_Message_themes_MessageStyles_css = require('./PRIVATE_Message/themes/MessageStyles.css.js');
var MessageFormattingUtils = require('./MessageFormattingUtils-034ac55d.js');

/**
 * Timestamp Component for rendering timestamp in Message
 */
function MessageTimestamp({ value, variant = 'banner' }) {
    // If detail content is rendered, then wrap it in a div with specified style classes
    // TODO:  Refactor to utilize useComponentTheme and multiVariantStyles.
    const classes = classNames.classNames([PRIVATE_Message_themes_MessageStyles_css.messageTimestampStyles[variant]]);
    // Otherwise, render the timestamp
    const formattedTimestamp = MessageFormattingUtils.formatTimestamp(value);
    return jsxRuntime.jsx("div", { class: classes, children: formattedTimestamp });
}

exports.MessageTimestamp = MessageTimestamp;
//# sourceMappingURL=MessageTimestamp-d30bcb99.js.map
