/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('preact/jsx-runtime');
var PRIVATE_StyledDayButton_themes_StyledDayButtonStyles_css = require('./PRIVATE_StyledDayButton/themes/StyledDayButtonStyles.css.js');
var UNSAFE_BaseButton_themes_BaseButtonStyles_css = require('./UNSAFE_BaseButton/themes/BaseButtonStyles.css.js');
var classNames = require('./classNames-3bb28eb9.js');


require('./vanilla-extract-recipes-createRuntimeFn.esm-6fa16b7c.js');

/**
 * StyledDayButton is a controlled component that displays a stylized span for a day that goes into a Calendar grid.
 */
const StyledDayButton = ({ isActivable = false, isAdjacentMonth = false, isDimmed = false, isHoverable = false, isRestricted = false, isSelected = false, isToday = false, label }) => {
    // The multiVariantStyles function is defined in StyledDayButtonStyles.css.ts,
    // using the recipe utility provided by @vanilla-extract/recipes.
    // This function is used to merge the base styles, variants, and compound variants
    // into a single set of styles for text components based on the component's properties.
    const variantClasses = PRIVATE_StyledDayButton_themes_StyledDayButtonStyles_css.multiVariantStyles({
        active: isActivable ? 'isActivable' : 'notActiveable',
        dimmed: isDimmed ? 'isDimmed' : 'notDimmed',
        hover: isHoverable ? 'isHoverable' : 'notHoverable',
        adjacentMonth: isAdjacentMonth ? 'isAdjacentMonth' : 'notAdjacentMonth',
        restricted: isRestricted ? 'isRestricted' : 'notRestricted',
        selected: isSelected ? 'isSelected' : 'notSelected',
        today: isToday ? 'isToday' : 'notToday'
    });
    const classes = classNames.classNames([
        UNSAFE_BaseButton_themes_BaseButtonStyles_css.styles.base,
        UNSAFE_BaseButton_themes_BaseButtonStyles_css.styles.sizes.sm,
        UNSAFE_BaseButton_themes_BaseButtonStyles_css.styles.styled,
        variantClasses
    ]);
    return (jsxRuntime.jsx("span", { class: classes, children: label }));
};

exports.StyledDayButton = StyledDayButton;
//# sourceMappingURL=PRIVATE_StyledDayButton.js.map
