/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var useFocus = require('./useFocus-e84e6c2e.js');
require('./FormContext-4a2edf25.js');
var useFormContext = require('./useFormContext-49a14273.js');
require('./FormFieldContext-81c48156.js');
var useFormFieldContext = require('./useFormFieldContext-35086e86.js');
var useId = require('./useId-42e8026e.js');
require('./TabbableModeContext-4fb7c910.js');
var useTabbableMode = require('./useTabbableMode-98443dc8.js');
var useInteractionStyle = require('./useInteractionStyle-6e5ba1b2.js');
var useTranslationBundle = require('./useTranslationBundle-9549e176.js');
var CheckboxRadioContext = require('./CheckboxRadioContext-45cad1d9.js');
var Check = require('./Check-559fd546.js');
var RadiobuttonOff = require('./RadiobuttonOff-4b9b79e2.js');
var RadiobuttonOn = require('./RadiobuttonOn-2e7978b0.js');
var HiddenAccessible = require('./HiddenAccessible-ce5d15d7.js');
var RadioItemContext = require('./RadioItemContext-679afc50.js');


require('./UNSAFE_UserAssistance/themes/redwood/UserAssistanceVariants.css.js');
require('preact/hooks');
require('./Flex-299660c2.js');


require('./UNSAFE_MessageBanner/themes/redwood/MessageBannerVariants.css.js');
require('preact');
require('./Floating-8ecf7694.js');
require('preact/compat');
require('./TopLayerHost-b320c750.js');


require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js');

require('./IconButton-df477106.js');

require('./MessageFormattingUtils-034ac55d.js');
require('./logger-01b28029.js');
require('./TransitionGroup-2e7eb24a.js');
require('./MessagesContext-bca47518.js');


require('./UNSAFE_ComponentMessage/themes/redwood/ComponentMessageVariants.css.js');
require('./InputGroupContext-0da40eb1.js');
require('./Popup-a64bbf6a.js');
require('./UNSAFE_Separator/themes/SeparatorStyles.css.js');


require('./UNSAFE_Label/themes/redwood/LabelVariants.css.js');
var IconUserAssistance = require('./IconUserAssistance-13d746ec.js');
var UNSAFE_RadioItem_themes_RadioIconContract_css = require('./UNSAFE_RadioItem/themes/RadioIconContract.css.js');
var UNSAFE_RadioItem_themes_redwood_RadioIconTheme = require('./UNSAFE_RadioItem/themes/redwood/RadioIconTheme.js');
var UNSAFE_RadioItem_themes_redwood_RadioTheme = require('./UNSAFE_RadioItem/themes/redwood/RadioTheme.js');

const RadioItem = ({ value, children, ...assistanceProps }) => {
    const { isReadonly: isFormReadonly, isDisabled: isFormDisabled } = useFormContext.useFormContext();
    const { isDisabled: isFieldDisabled, isReadonly: isFieldReadonly } = useFormFieldContext.useFormFieldContext();
    const { name, value: groupValue, onCommit } = RadioItemContext.useRadioSetContext();
    const { isFocusRingShown } = CheckboxRadioContext.useCheckboxRadioContext();
    const { index } = RadioItemContext.useRadioItemContext();
    const { isTabbable } = useTabbableMode.useTabbableMode();
    const id = useId.useId();
    const { isFocus, focusProps } = useFocus.useFocus();
    const isSelected = groupValue === value;
    const isDisabled = isFieldDisabled ?? isFormDisabled;
    const isReadonly = isFieldReadonly ?? isFormReadonly;
    const { interactionProps, applyActiveStyle } = useInteractionStyle.useInteractionStyle();
    const { classes: radioClasses, styles: { valueLabelStyle } } = useComponentTheme.useComponentTheme(UNSAFE_RadioItem_themes_redwood_RadioTheme.RadioRedwoodTheme, {
        disabled: isDisabled ? 'isDisabled' : 'notDisabled',
        focused: isFocus && isFocusRingShown ? 'isFocused' : ''
    });
    const { classes: radioIconClasses } = useComponentTheme.useComponentTheme(UNSAFE_RadioItem_themes_redwood_RadioIconTheme.RadioIconRedwoodTheme, {
        disabled: isDisabled ? 'isDisabled' : 'notDisabled',
        selected: isSelected ? 'isSelected' : 'notSelected',
        readonly: isReadonly ? 'isReadonly' : 'notReadonly',
        active: applyActiveStyle ? 'isActive' : 'notActive'
    });
    const { assistiveText, helpSourceLink } = assistanceProps;
    const hasUserAssistive = !isDisabled && !isReadonly && !!(assistiveText || helpSourceLink);
    const helpAvailableId = hasUserAssistive ? `${id}-help-available` : undefined;
    const uaId = hasUserAssistive ? `${id}-icon-ua` : undefined;
    const translations = useTranslationBundle.useTranslationBundle('@oracle/oraclejet-preact');
    const helpAvailableString = translations.formControl_helpAvailable();
    const IconComp = isReadonly
        ? isSelected
            ? Check.SvgCheck
            : RadiobuttonOff.SvgRadiobuttonOff
        : isSelected
            ? RadiobuttonOn.SvgRadiobuttonOn
            : RadiobuttonOff.SvgRadiobuttonOff;
    const tabIndex = isTabbable !== false && ((index === 0 && !groupValue) || isSelected) ? 0 : -1;
    return (jsxRuntime.jsx("div", { children: jsxRuntime.jsxs("label", { class: radioClasses, children: [jsxRuntime.jsxs(HiddenAccessible.HiddenAccessible, { children: [jsxRuntime.jsx("input", { type: "radio", name: name, id: id, value: value, ...(!isReadonly &&
                                !isDisabled && {
                                onChange: (e) => {
                                    e.stopPropagation();
                                    onCommit?.({ previousValue: groupValue, value });
                                }
                            }), checked: isSelected, disabled: isDisabled, "aria-describedby": helpAvailableId, tabIndex: tabIndex, ...focusProps }), hasUserAssistive && (jsxRuntime.jsx(HiddenAccessible.HiddenAccessible, { id: helpAvailableId, isHidden: true, children: helpAvailableString }))] }), jsxRuntime.jsx("span", { "aria-hidden": "true", class: radioIconClasses, ...interactionProps, children: jsxRuntime.jsx(IconComp, { size: UNSAFE_RadioItem_themes_RadioIconContract_css.radioIconVars.iconSize, color: "currentColor" }) }), jsxRuntime.jsxs("span", { class: valueLabelStyle, children: [jsxRuntime.jsx("span", { ...interactionProps, children: children }), hasUserAssistive && (jsxRuntime.jsx(IconUserAssistance.IconUserAssistance, { ...assistanceProps, isTabbable: isTabbable && isFocus, id: uaId }))] })] }) }));
};

exports.RadioItem = RadioItem;
//# sourceMappingURL=RadioItem-9d2616e8.js.map
