/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var hooks = require('preact/hooks');
var Modal = require('./Modal-387f15cd.js');
var WindowOverlay = require('./WindowOverlay-fd59ce75.js');
var useSheetSwipe = require('./useSheetSwipe-296b6911.js');
var UNSAFE_Sheet_themes_SheetStyles_css = require('./UNSAFE_Sheet/themes/SheetStyles.css.js');

const Sheet = ({ children, onClose, isOpen = false }) => {
    const handlePointerDismissed = hooks.useCallback(() => {
        onClose?.({ reason: 'pointerDismissed' });
    }, [onClose]);
    // TODO: Use useSwipe when it works on components that could scroll. Important to notice all components that have a
    // sheet will use this comp and this comp is going to use useSwipe. So comps that have their own impl (menu right now),
    // will stop having its own implementation
    const { swipeProps } = useSheetSwipe.useSheetSwipe(handlePointerDismissed);
    const handleKeyDown = hooks.useCallback((event) => {
        if (event.defaultPrevented) {
            return;
        }
        switch (event.code) {
            case 'Tab':
            case 'Escape':
                onClose?.({ reason: 'keyboardDismissed' });
        }
    }, [onClose]);
    return (jsxRuntime.jsx(Modal.Modal, { isOpen: isOpen, onBackdropClick: handlePointerDismissed, children: jsxRuntime.jsx(WindowOverlay.WindowOverlay, { placement: "bottom", children: jsxRuntime.jsx("div", { ...swipeProps, class: UNSAFE_Sheet_themes_SheetStyles_css.sheetMenuStyles.sheetMenuContainerWrapper, style: { maxHeight: `calc(100vh - ${TOP_OFFSET}px)` }, onKeyDown: handleKeyDown, children: children }) }) }));
};
const TOP_OFFSET = 96;

exports.Sheet = Sheet;
//# sourceMappingURL=Sheet-8c21ddb8.js.map
