/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var classNames = require('./classNames-3bb28eb9.js');
var dimensions$1 = require('./dimensions-77289825.js');
var mergeInterpolations = require('./mergeInterpolations-032e29ea.js');
var borders = require('./borders-b9e79e7b.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var UNSAFE_Skeleton_themes_redwood_SkeletonTheme = require('./UNSAFE_Skeleton/themes/redwood/SkeletonTheme.js');

const dimensions = ['height', 'width'];
const border = ['borderRadius'];
// Create an array [dimensionInterpolations['height'], dimensionInterpolations['width']]
const skeletonDimensionInterpolation = Array.from(dimensions, (x) => dimensions$1.dimensionInterpolations[x]);
const borderRadiusInterpolation = Array.from(border, (x) => borders.borderInterpolations[x]);
const interpolations = [
    ...Object.values(borderRadiusInterpolation),
    ...Object.values(skeletonDimensionInterpolation)
];
const SkeletonInterpolations = mergeInterpolations.mergeInterpolations(interpolations);
/**
 * Skeleton component allows the appropriate skeleton to be rendered based on the
 * property values
 **/
function Skeleton({ ...props }) {
    const { classes: skeletonBase } = useComponentTheme.useComponentTheme(UNSAFE_Skeleton_themes_redwood_SkeletonTheme.SkeletonRedwoodTheme);
    const classes = classNames.classNames([skeletonBase]);
    const skeletonDimensions = SkeletonInterpolations({ width: '100%', borderRadius: 0, ...props });
    return jsxRuntime.jsx("div", { style: skeletonDimensions, class: classes });
}

exports.Skeleton = Skeleton;
//# sourceMappingURL=Skeleton-85c336fe.js.map
