/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var useRovingTabIndexContainer = require('./useRovingTabIndexContainer-37c591a1.js');
var TabbableModeContext = require('./TabbableModeContext-4fb7c910.js');
var useTabbableMode = require('./useTabbableMode-98443dc8.js');
var UNSAFE_Toolbar_themes_redwood_ToolbarTheme = require('./UNSAFE_Toolbar/themes/redwood/ToolbarTheme.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var classNames = require('./classNames-3bb28eb9.js');
var UNSAFE_Toolbar_themes_ToolbarSeparatorStyles_css = require('./UNSAFE_Toolbar/themes/ToolbarSeparatorStyles.css.js');
var Separator = require('./Separator-2277264f.js');

const Toolbar = ({ 'aria-controls': ariaControls, 'aria-label': ariaLabel, children }) => {
    const { isTabbable } = useTabbableMode.useTabbableMode();
    const { focusedId, rovingTabIndexContainerProps } = useRovingTabIndexContainer.useRovingTabIndexContainer(!isTabbable);
    const { classes, styles } = useComponentTheme.useComponentTheme(UNSAFE_Toolbar_themes_redwood_ToolbarTheme.ToolbarRedwoodTheme);
    const toolbarClasses = classNames.classNames([classes, styles.base]);
    return (jsxRuntime.jsx("div", { "aria-controls": ariaControls, "aria-label": ariaLabel, class: toolbarClasses, role: "toolbar", ...rovingTabIndexContainerProps, children: jsxRuntime.jsx(TabbableModeContext.TabbableModeContext.Provider, { value: { isTabbable: isTabbable, isRoving: true, focusedId: focusedId }, children: children }) }));
};

const ToolbarSeparator = () => {
    return (jsxRuntime.jsx("span", { class: UNSAFE_Toolbar_themes_ToolbarSeparatorStyles_css.styles.separatorBase, children: jsxRuntime.jsx(Separator.Separator, { orientation: "vertical" }) }));
};

exports.Toolbar = Toolbar;
exports.ToolbarSeparator = ToolbarSeparator;
//# sourceMappingURL=ToolbarSeparator-fbd56b79.js.map
