/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var hooks = require('preact/hooks');
var useSize = require('./useSize-83a9b1a0.js');

const TrackResizeContainer = ({ children, width, height }) => {
    const content = !isFixedLength(width) || !isFixedLength(height) ? (jsxRuntime.jsx(TrackResizeOnContainer, { width: width, height: height, children: children })) : (jsxRuntime.jsx("div", { style: { width, height }, children: children(fixedLengthToNumber(width), fixedLengthToNumber(height)) }));
    return content;
};
const TrackResizeOnContainer = ({ children, width, height }) => {
    const ref = hooks.useRef(null);
    const optionsRef = hooks.useRef({ box: 'border-box' });
    const size = useSize.useSize(ref, optionsRef.current);
    return (jsxRuntime.jsx("div", { ref: ref, style: { width, height }, children: size && children(size.width, size.height) }));
};
const isFixedLength = (length) => length.endsWith('px') || length === '0';
const fixedLengthToNumber = (length) => length === '0' ? 0 : Number(length.substring(0, length.length - 2));

exports.TrackResizeContainer = TrackResizeContainer;
//# sourceMappingURL=TrackResizeContainer-75071c52.js.map
