/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('preact/jsx-runtime');
var Flex = require('./Flex-299660c2.js');
require('./dimensions-77289825.js');
require('./size-02d9db33.js');
require('./utils-0015eceb.js');
require('./Common/themes/themeContract.css.js');
require('./colorUtils-9be60515.js');
require('./_curry1-087704d4.js');
require('./mergeInterpolations-032e29ea.js');
require('./classNames-3bb28eb9.js');
require('./_curry3-0631305a.js');
require('./_curry2-e350c665.js');
require('./_isObject-e111cf8c.js');
require('./boxalignment-e0031b0e.js');
require('./arrayUtils-55970503.js');

require('./vanilla-extract-sprinkles-createRuntimeSprinkles.esm-e59ab5d4.js');
require('./flexbox-07759e95.js');

require('./flexitem-403ef425.js');



/**
 * Returns the flex order of the legend and chart in the flex container.
 * @param legendPos The legend position.
 * @returns
 */
function getFlexOrder(legendPos) {
    const isLegendFirst = legendPos === 'start' || legendPos === 'top';
    return {
        chartOrder: isLegendFirst ? 2 : 1,
        legendOrder: isLegendFirst ? 1 : 2
    };
}
/**
 * Returns the legend flex align and justify prop.
 */
function getLegendFlexProps(legendPos) {
    let justifyContent;
    let alignItem;
    if (legendPos === 'top') {
        justifyContent = 'center';
        alignItem = 'end';
    }
    else if (legendPos === 'bottom') {
        justifyContent = 'center';
        alignItem = 'start';
    }
    else if (legendPos === 'start') {
        justifyContent = 'end';
        alignItem = 'center';
    }
    else {
        justifyContent = 'start';
        alignItem = 'center';
    }
    return { justifyContent, alignItem };
}

/**
 * Component responsible for laying out the legend around a chart.
 */
function ChartWithLegend({ chart, legend, position, maxSize, size }) {
    const flexDirection = position === 'start' || position === 'end' ? 'row' : 'column';
    const { chartOrder, legendOrder } = getFlexOrder(position);
    const { justifyContent, alignItem } = getLegendFlexProps(position);
    return (jsxRuntime.jsxs(Flex.Flex, { width: '100%', height: '100%', direction: flexDirection, children: [jsxRuntime.jsx("div", { style: {
                    order: chartOrder,
                    flexGrow: 1
                }, children: chart }), legend && (jsxRuntime.jsx(Flex.Flex, { order: legendOrder, justify: justifyContent, align: alignItem, maxHeight: flexDirection === 'column' ? maxSize : undefined, maxWidth: flexDirection === 'row' ? maxSize : undefined, height: flexDirection === 'column' ? size : undefined, width: flexDirection === 'row' ? size : undefined, children: legend }))] }));
}

exports.ChartWithLegend = ChartWithLegend;
//# sourceMappingURL=UNSAFE_ChartWithLegend.js.map
