/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('preact/jsx-runtime');
var hooks = require('preact/hooks');
var ChevronLeft = require('./ChevronLeft-ad42e5a2.js');
var classNames = require('./classNames-3bb28eb9.js');
var UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css = require('./UNSAFE_ConveyorBelt/themes/ConveyorBeltStyles.css.js');
var useUser = require('./useUser-171bdb32.js');
var TabbableModeContext = require('./TabbableModeContext-4fb7c910.js');
var clientHints = require('./clientHints-666b4780.js');
var utils = require('./utils-0015eceb.js');
var Button = require('./Button-23e05530.js');
require('./Icon-faf50cac.js');
require('preact');
require('./size-02d9db33.js');
require('./useTooltip-ce4554e9.js');
require('./useTooltipControlled-da1c4a13.js');
require('./useId-42e8026e.js');
require('./Floating-8ecf7694.js');
require('preact/compat');
require('./useFloating-4c19cf7f.js');
require('./positionUtils-d40a1e16.js');
require('./refUtils-fce65cbf.js');
require('./useOutsideClick-ab35c77b.js');
require('./arrayUtils-55970503.js');
require('./useComponentTheme-b6e9b324.js');
require('./logger-01b28029.js');
require('./Common/themes/themeContract.css.js');
require('./UNSAFE_Floating/themes/redwood/FloatingTheme.js');
require('./UNSAFE_Floating/themes/FloatingStyles.css.js');

require('./UNSAFE_Floating/themes/redwood/FloatingBaseTheme.css.js');

require('./UNSAFE_Floating/themes/redwood/FloatingVariants.css.js');
require('./vanilla-extract-recipes-createRuntimeFn.esm-6fa16b7c.js');
require('./vanilla-extract-dynamic.esm-dc9e7bcc.js');
require('./UNSAFE_Floating/themes/FloatingContract.css.js');
require('./Layer-c0f805fc.js');
require('./TopLayerHost-b320c750.js');
require('./Common/themes/redwood/theme.js');
require('./useThemeInterpolations-64b0f552.js');
require('./useColorScheme-53b27a87.js');
require('./useScale-a4b30442.js');
require('./theme-ded14524.js');
require('./Theme-415b919e.js');
require('./mergeInterpolations-032e29ea.js');
require('./_curry3-0631305a.js');
require('./_curry1-087704d4.js');
require('./_curry2-e350c665.js');
require('./_isObject-e111cf8c.js');
require('./useHover-8f282a4d.js');
require('./useToggle-36126e66.js');
require('./useFocus-e84e6c2e.js');
require('./useTouch-b01185f2.js');
require('./mergeProps-f6f4322f.js');
require('./useAnimation-07e113f8.js');
require('./useTestId-4fe30223.js');
require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentTheme.js');
require('./hooks/UNSAFE_useTooltip/themes/TooltipContentStyles.css.js');

require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.css.js');

require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js');

require('./EnvironmentProvider-64d57308.js');
require('./LayerManager-70d05a53.js');
require('./UNSAFE_Icon/themes/IconStyle.css.js');


require('./colorUtils-9be60515.js');
require('./BaseButton-1fd978ce.js');
require('./usePress-42f3876b.js');
require('./useActive-5db5a3fb.js');
require('./useTabbableMode-98443dc8.js');
require('./dimensions-77289825.js');
require('./UNSAFE_BaseButton/themes/BaseButtonStyles.css.js');

require('./ButtonLayout-968b5cb9.js');
require('./Text-15925a9e.js');
require('./UNSAFE_Text/themes/TextStyles.css.js');

require('./UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js');
require('./UNSAFE_ButtonLayout/themes/ButtonLayoutStyles.css.js');

require('./UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.css.js');

require('./UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutVariants.css.js');


/**
 * Helper function to determine whether the current device is a mobile device
 * @returns true if runnning on a mobile device, false otherwise
 */
function isMobile() {
    const deviceType = clientHints.getClientHints().deviceType;
    return deviceType === 'phone' || deviceType === 'tablet';
}
function scrollPrevious(direction, overflowContainer, scrollAmount) {
    if (overflowContainer && scrollAmount) {
        if (direction === 'ltr') {
            overflowContainer.scrollTo({
                left: overflowContainer.scrollLeft - scrollAmount
            });
        }
        else {
            overflowContainer.scrollTo({
                left: overflowContainer.scrollLeft + scrollAmount
            });
        }
    }
}
function scrollNext(direction, overflowContainer, scrollAmount) {
    if (overflowContainer && scrollAmount) {
        if (direction === 'ltr') {
            overflowContainer.scrollTo({
                left: overflowContainer.scrollLeft + scrollAmount,
                behavior: 'smooth'
            });
        }
        else {
            overflowContainer.scrollTo({
                left: overflowContainer.scrollLeft - scrollAmount,
                behavior: 'smooth'
            });
        }
    }
}
/**
 * The Conveyor belt component is a container element that manages
 * overflow for its child elements and allows scrolling among them
 */
const ConveyorBelt = ({ children, scrollPosition, onScrollPositionChanged, arrowVisibility = 'auto' }) => {
    const [canPaginateNext, setCanPaginateNext] = hooks.useState(false);
    const [canPaginatePrevious, setCanPaginatePrevious] = hooks.useState(false);
    const overflowContainerRef = hooks.useRef(null);
    const contentContainerRef = hooks.useRef(null);
    const nextButtonContainerRef = hooks.useRef(null);
    const prevButtonContainerRef = hooks.useRef(null);
    const baseRef = hooks.useRef(null);
    const leftRef = hooks.useRef(null);
    const rightRef = hooks.useRef(null);
    const observerRef = hooks.useRef(null);
    const { direction } = useUser.useUser();
    const [buttonsHidden, setButtonsHidden] = hooks.useState((isMobile() && arrowVisibility === 'auto') || arrowVisibility === 'hidden');
    const scrollEndHandler = hooks.useCallback(() => {
        if (onScrollPositionChanged)
            onScrollPositionChanged(overflowContainerRef.current?.scrollLeft);
    }, [onScrollPositionChanged]);
    hooks.useEffect(() => {
        setButtonsHidden((isMobile() && arrowVisibility === 'auto') || arrowVisibility === 'hidden');
    }, [arrowVisibility]);
    hooks.useEffect(() => {
        if (!overflowContainerRef.current)
            return;
        overflowContainerRef.current.scrollTo({
            left: scrollPosition
        });
    }, [scrollPosition]);
    hooks.useEffect(() => {
        const overflowContainer = overflowContainerRef.current;
        const leftGuard = leftRef.current;
        const rightGuard = rightRef.current;
        if (overflowContainer && leftGuard && rightGuard) {
            if (!buttonsHidden) {
                observerRef.current = new IntersectionObserver((entries) => {
                    entries.forEach((entry) => {
                        if (entry.target.getAttribute('data-intersection-id') === 'left') {
                            setCanPaginatePrevious(!entry.isIntersecting);
                        }
                        else {
                            setCanPaginateNext(!entry.isIntersecting);
                        }
                    });
                }, {
                    root: overflowContainer
                });
                observerRef.current.observe(leftGuard);
                observerRef.current.observe(rightGuard);
            }
            overflowContainer.addEventListener('scrollend', scrollEndHandler);
        }
        // Clean-up
        return () => {
            if (!overflowContainer)
                return;
            overflowContainer.removeEventListener('scrollend', scrollEndHandler);
            observerRef.current.unobserve(leftGuard);
            observerRef.current.unobserve(rightGuard);
        };
    }, [buttonsHidden, scrollEndHandler]);
    return (jsxRuntime.jsxs("div", { ref: baseRef, className: classNames.classNames([UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css.styles.baseStyle]), children: [canPaginatePrevious && !buttonsHidden && (jsxRuntime.jsx("div", { "aria-hidden": true, ref: prevButtonContainerRef, class: classNames.classNames([
                    UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css.styles.buttonContainer,
                    direction === 'ltr' ? UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css.styles.previousButton : UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css.styles.nextButton
                ]), children: jsxRuntime.jsx(TabbableModeContext.TabbableModeContext.Provider, { value: { isTabbable: false }, children: jsxRuntime.jsx(Button.Button, { startIcon: direction === 'ltr' ? jsxRuntime.jsx(ChevronLeft.SvgChevronLeft, {}) : jsxRuntime.jsx(ChevronLeft.SvgChevronRight, {}), variant: "borderless", onAction: () => scrollPrevious(direction, overflowContainerRef.current, overflowContainerRef.current?.clientWidth) }) }) })), jsxRuntime.jsx("div", { style: {
                    clipPath: direction === 'ltr' ? `inset(0rem ${canPaginateNext ? utils.xUnits(12) : '0rem'} 0rem ${canPaginatePrevious ? utils.xUnits(12) : 0})` : `inset(0rem ${canPaginatePrevious ? utils.xUnits(12) : '0rem'} 0rem ${canPaginateNext ? utils.xUnits(12) : 0})`
                }, className: UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css.styles.overflowContainer, ref: overflowContainerRef, children: jsxRuntime.jsxs("div", { className: UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css.styles.contentContainer, ref: contentContainerRef, children: [jsxRuntime.jsx("div", { "data-intersection-id": "left", ref: leftRef, style: { minWidth: 1 } }), children, jsxRuntime.jsx("div", { "data-intersection-id": "right", ref: rightRef, style: { minWidth: 1 } })] }) }), canPaginateNext && !buttonsHidden && (jsxRuntime.jsx("div", { "aria-hidden": true, ref: nextButtonContainerRef, class: classNames.classNames([
                    UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css.styles.buttonContainer,
                    direction === 'ltr' ? UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css.styles.nextButton : UNSAFE_ConveyorBelt_themes_ConveyorBeltStyles_css.styles.previousButton
                ]), children: jsxRuntime.jsx(TabbableModeContext.TabbableModeContext.Provider, { value: { isTabbable: false }, children: jsxRuntime.jsx(Button.Button, { startIcon: direction === 'ltr' ? jsxRuntime.jsx(ChevronLeft.SvgChevronRight, {}) : jsxRuntime.jsx(ChevronLeft.SvgChevronLeft, {}), variant: "borderless", onAction: () => scrollNext(direction, overflowContainerRef.current, overflowContainerRef.current?.clientWidth) }) }) }))] }));
};

exports.ConveyorBelt = ConveyorBelt;
//# sourceMappingURL=UNSAFE_ConveyorBelt.js.map
