/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('preact/jsx-runtime');
var compat = require('preact/compat');
var WindowOverlay = require('./WindowOverlay-fd59ce75.js');
var useTestId = require('./useTestId-4fe30223.js');
var useAnimation = require('./useAnimation-07e113f8.js');
var hooks = require('preact/hooks');
var UNSAFE_Dialog_themes_redwood_DialogTheme = require('./UNSAFE_Dialog/themes/redwood/DialogTheme.js');
var FocusTrap = require('./FocusTrap-81eb7b2d.js');
var Layer = require('./Layer-c0f805fc.js');
require('./TopLayerHost-b320c750.js');
var Modal = require('./Modal-387f15cd.js');
var classNames = require('./classNames-3bb28eb9.js');
var ImageVars_css = require('./ImageVars.css-f60e0b2a.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var useId = require('./useId-42e8026e.js');
require('./mergeInterpolations-032e29ea.js');
require('./_curry3-0631305a.js');
require('./_curry1-087704d4.js');
require('./_curry2-e350c665.js');
require('./_isObject-e111cf8c.js');
require('./vanilla-extract-dynamic.esm-dc9e7bcc.js');
require('./UNSAFE_WindowOverlay/themes/WindowOverlayStyles.css.js');

require('./UNSAFE_WindowOverlay/themes/WindowOverlayContract.css.js');
require('./useUser-171bdb32.js');
require('./UNSAFE_WindowOverlay/themes/redwood/WindowOverlayTheme.js');
require('./UNSAFE_WindowOverlay/themes/redwood/WindowOverlayBaseTheme.css.js');

require('./UNSAFE_WindowOverlay/themes/redwood/WindowOverlayVariants.css.js');
require('./vanilla-extract-recipes-createRuntimeFn.esm-6fa16b7c.js');
require('./UNSAFE_Dialog/themes/DialogStyles.css.js');

require('./UNSAFE_Dialog/themes/redwood/DialogBaseTheme.css.js');


require('./UNSAFE_Dialog/themes/redwood/DialogVariants.css.js');
require('./tabbableUtils-ddf81122.js');
require('./head-48317cb1.js');
require('./_arity-199931ab.js');
require('./_isArray-dfe62abd.js');
require('./_isString-6c9a4e52.js');
require('./FocusTracker-875e3d4b.js');
require('preact');
require('./PRIVATE_FocusTracker/themes/FocusTrackerStyles.css.js');

require('./useThemeInterpolations-64b0f552.js');
require('./useColorScheme-53b27a87.js');
require('./useScale-a4b30442.js');
require('./theme-ded14524.js');
require('./Theme-415b919e.js');
require('./Common/themes/redwood/theme.js');
require('./Common/themes/themeContract.css.js');
require('./UNSAFE_Modal/themes/ModalStyles.css.js');

require('./logger-01b28029.js');

const StyledDialogHeader = ({ header, id }) => {
    const { styles } = useComponentTheme.useComponentTheme(UNSAFE_Dialog_themes_redwood_DialogTheme.DialogRedwoodTheme);
    const content = typeof header === 'string' ? (jsxRuntime.jsx("h1", { id: id, className: styles.dialogTitleStyle, children: header })) : (header);
    return jsxRuntime.jsx("div", { className: styles.dialogHeaderStyle, children: content });
};
const StyledDialog = compat.forwardRef(({ children, header, footer, labelId, role, ariaLabelledBy, ariaDescribedBy, onKeyDown, testId }, ref) => {
    const { classes: styleClasses, styles } = useComponentTheme.useComponentTheme(UNSAFE_Dialog_themes_redwood_DialogTheme.DialogRedwoodTheme);
    const testIdProps = useTestId.useTestId(testId);
    return (jsxRuntime.jsx("div", { ref: ref, className: classNames.classNames([styleClasses, ImageVars_css.globalImages]), style: { opacity: 0 }, onKeyDown: onKeyDown, role: role, "aria-labelledby": ariaLabelledBy, "aria-describedby": ariaDescribedBy, ...testIdProps, children: jsxRuntime.jsxs("div", { className: styles.dialogContainerStyle, children: [jsxRuntime.jsx(StyledDialogHeader, { id: labelId, header: header }), jsxRuntime.jsx("div", { className: styles.dialogContentStyle, children: jsxRuntime.jsx("div", { className: styles.dialogBodyStyle, children: children }) }), jsxRuntime.jsx("div", { className: styles.dialogFooterStyle, children: footer })] }) }));
});
// main Dialog component
/**
 * WAI-ARIA-compliant dialog component. A dialog is a floating window that typically contains
 * a title bar and a content area.
 * The dialog is generally placed on top of the rest of the page content. It can be either modal
 * (only the content in the dialog can be interacted with) or non-modal (it's still possible
 * to interact with content outside of the dialog).
 */
const Dialog = ({ autoFocusRef, children, isOpen, header = '', footer, modality = 'modal', placement = 'center', offset = 0, onClose, onTransitionEnd, role = 'dialog', 'aria-labelledby': ariaLabelledBy, 'aria-describedby': ariaDescribedBy, testId }) => {
    const [state, setState] = hooks.useState(isOpen ? 'opening' : 'unmounted');
    const uniqueId = useId.useId();
    const labelId = ariaLabelledBy ? ariaLabelledBy : uniqueId;
    hooks.useEffect(() => {
        // Ignore state update on initial render
        if (state === 'unmounted' && !isOpen) {
            return;
        }
        setState(isOpen ? 'opening' : 'closing');
    }, [isOpen, state]);
    const { nodeRef } = useAnimation.useAnimation(state, {
        animationStates,
        isAnimatedOnMount: true,
        onAnimationEnd: ({ animationState }) => {
            if (animationState === 'closing') {
                setState('unmounted');
                onTransitionEnd?.(false);
            }
            else {
                onTransitionEnd?.(true);
            }
        }
    });
    const handleKeyDown = (event) => {
        switch (event.code) {
            case 'Escape': {
                onClose?.({ reason: 'escapeKey' });
                break;
            }
        }
    };
    const renderDialog = () => {
        return (jsxRuntime.jsx(WindowOverlay.WindowOverlay, { placement: placement, offset: offset, children: jsxRuntime.jsx(FocusTrap.FocusTrap, { autoFocusRef: autoFocusRef, children: jsxRuntime.jsx(StyledDialog, { ref: nodeRef, labelId: labelId, header: header, footer: footer, role: role, ariaLabelledBy: labelId, ariaDescribedBy: ariaDescribedBy, onKeyDown: handleKeyDown, testId: testId, children: children }) }) }));
    };
    if (modality === 'modal') {
        return jsxRuntime.jsx(Modal.Modal, { isOpen: state !== 'unmounted', children: renderDialog() });
    }
    else {
        return state !== 'unmounted' ? jsxRuntime.jsx(Layer.Layer, { children: renderDialog() }) : null;
    }
};
const animationStates = {
    opening: {
        from: {
            scaleX: 0,
            scaleY: 0,
            transformOrigin: 'center',
            opacity: 0
        },
        to: {
            scaleX: 1,
            scaleY: 1,
            opacity: 1
        },
        options: {
            duration: 200
        }
    },
    closing: {
        from: {
            scaleX: 1,
            scaleY: 1,
            transformOrigin: 'center',
            opacity: 1
        },
        to: {
            scaleX: 0,
            scaleY: 0,
            opacity: 0
        },
        options: {
            duration: 200
        }
    }
};

exports.Dialog = Dialog;
//# sourceMappingURL=UNSAFE_Dialog.js.map
