/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('preact/jsx-runtime');
var vanillaExtractDynamic_esm = require('./vanilla-extract-dynamic.esm-dc9e7bcc.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var FormContext = require('./FormContext-4a2edf25.js');
var useFormContext = require('./useFormContext-49a14273.js');
var UNSAFE_FormLayout_themes_FormLayoutStyles_css = require('./UNSAFE_FormLayout/themes/FormLayoutStyles.css.js');
var LayoutStyles_css = require('./LayoutStyles.css-4d8455b4.js');
var UNSAFE_FormLayout_themes_redwood_FormLayoutTheme = require('./UNSAFE_FormLayout/themes/redwood/FormLayoutTheme.js');
var classNames = require('./classNames-3bb28eb9.js');
require('./logger-01b28029.js');
require('preact');
require('preact/hooks');


require('./UNSAFE_FormLayout/themes/redwood/FormLayoutBaseTheme.css.js');

require('./UNSAFE_FormLayout/themes/redwood/FormLayoutVariants.css.js');

require('./vanilla-extract-recipes-createRuntimeFn.esm-6fa16b7c.js');

const FormLayout = ({ columns = 1, columnBehavior = 'responsive', columnSpan = 1, direction = 'row', isFullWidth, isReadonly: propIsReadonly, labelEdge: propLabelEdge, labelStartWidth: propLabelStartWidth, labelWrapping: propLabelWrapping, userAssistanceDensity: propUserAssistanceDensity, children }) => {
    const { isDisabled, isFormLayout: formIsFormLayout, isReadonly: isFormReadonly, labelEdge: formLabelEdge, labelStartWidth: formLabelStartWidth, labelWrapping: formLabelWrapping, textAlign, userAssistanceDensity: formUserAssistanceDensity } = useFormContext.useFormContext();
    const isReadonly = propIsReadonly ?? isFormReadonly;
    const labelEdge = propLabelEdge ?? formLabelEdge;
    const labelStartWidth = propLabelStartWidth ?? formLabelStartWidth;
    const labelWrapping = propLabelWrapping ?? formLabelWrapping;
    // If we have the prop, pass it on, or if we are in a form layout, use the context value, otherwise default to 'efficient'
    const userAssistanceDensity = propUserAssistanceDensity ?? (formIsFormLayout ? formUserAssistanceDensity : 'efficient');
    // We need to set the localVars.columnCount so that we can correctly set the max width to the current column count
    const assignVarStyles = vanillaExtractDynamic_esm.assignInlineVars({
        [LayoutStyles_css.layoutLocalVars.columnCount]: `${columns}`
    });
    const { baseTheme, classes } = useComponentTheme.useComponentTheme(UNSAFE_FormLayout_themes_redwood_FormLayoutTheme.FormLayoutRedwoodTheme, {
        columnBehavior,
        direction
    });
    return (jsxRuntime.jsx(FormContext.FormContext.Provider, { value: {
            isDisabled,
            isFormLayout: true,
            isReadonly,
            labelEdge,
            labelStartWidth,
            labelWrapping,
            textAlign,
            userAssistanceDensity
        }, children: jsxRuntime.jsx("div", { class: classNames.classNames([
                baseTheme,
                UNSAFE_FormLayout_themes_FormLayoutStyles_css.styles.rootWrapperStyle,
                isFullWidth && UNSAFE_FormLayout_themes_FormLayoutStyles_css.styles.rootWrapperFullWidthStyle,
                LayoutStyles_css.layoutSpanStyles.layoutSpanColumn[columnSpan]
            ]), style: assignVarStyles, children: jsxRuntime.jsx("div", { class: classes, children: children }) }) }));
};

exports.compoundVariants = UNSAFE_FormLayout_themes_FormLayoutStyles_css.compoundVariants;
exports.styles = UNSAFE_FormLayout_themes_FormLayoutStyles_css.styles;
exports.variants = UNSAFE_FormLayout_themes_FormLayoutStyles_css.variants;
exports.FormLayout = FormLayout;
//# sourceMappingURL=UNSAFE_FormLayout.js.map
