/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('preact/jsx-runtime');
var hooks = require('preact/hooks');
var Message = require('./Message-8e87f52f.js');
require('preact');
require('./Floating-8ecf7694.js');
require('preact/compat');
require('./TopLayerHost-b320c750.js');
var classNames = require('./classNames-3bb28eb9.js');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var useTestId = require('./useTestId-4fe30223.js');


require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js');

require('./IconButton-df477106.js');
var useTranslationBundle = require('./useTranslationBundle-9549e176.js');

require('./MessageFormattingUtils-034ac55d.js');
var MessagesManager = require('./MessagesManager-92c1c76e.js');
var Flex = require('./Flex-299660c2.js');
var MessageUtils = require('./MessageUtils-9ac635b8.js');
var LiveRegion = require('./LiveRegion-30bd9fad.js');
var useMessagesFocusManager = require('./useMessagesFocusManager-36452f09.js');
var UNSAFE_MessageBanner_themes_redwood_MessageBannerTheme = require('./UNSAFE_MessageBanner/themes/redwood/MessageBannerTheme.js');
require('./timer-92be9c0b.js');
require('./MessageCloseButton-78f05c99.js');
require('./Close-86d2d000.js');
require('./Icon-faf50cac.js');
require('./size-02d9db33.js');
require('./utils-0015eceb.js');
require('./Common/themes/themeContract.css.js');
require('./colorUtils-9be60515.js');
require('./_curry1-087704d4.js');
require('./useTooltip-ce4554e9.js');
require('./useTooltipControlled-da1c4a13.js');
require('./useId-42e8026e.js');
require('./Layer-c0f805fc.js');
require('./useThemeInterpolations-64b0f552.js');
require('./useColorScheme-53b27a87.js');
require('./useScale-a4b30442.js');
require('./theme-ded14524.js');
require('./Theme-415b919e.js');
require('./mergeInterpolations-032e29ea.js');
require('./_curry3-0631305a.js');
require('./_curry2-e350c665.js');
require('./_isObject-e111cf8c.js');
require('./useHover-8f282a4d.js');
require('./useToggle-36126e66.js');
require('./useFocus-e84e6c2e.js');
require('./useTouch-b01185f2.js');
require('./mergeProps-f6f4322f.js');
require('./useAnimation-07e113f8.js');
require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentTheme.js');
require('./hooks/UNSAFE_useTooltip/themes/TooltipContentStyles.css.js');
require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.css.js');

require('./vanilla-extract-recipes-createRuntimeFn.esm-6fa16b7c.js');
require('./EnvironmentProvider-64d57308.js');
require('./LayerManager-70d05a53.js');
require('./logger-01b28029.js');
require('./UNSAFE_Icon/themes/IconStyle.css.js');
require('./PRIVATE_Message/themes/MessageStyles.css.js');
require('./MessageDetail-55843718.js');
require('./MessageStartIcon-da24f8bc.js');
require('./SuccessS-3a2c6dd4.js');
require('./ErrorS-6012f9f3.js');
require('./InformationS-c18dd806.js');
require('./WarningS-5dd358a1.js');
require('./MessageSummary-da4a1807.js');
require('./MessageTimestamp-d30bcb99.js');
require('./useFloating-4c19cf7f.js');
require('./useUser-171bdb32.js');
require('./positionUtils-d40a1e16.js');
require('./refUtils-fce65cbf.js');
require('./useOutsideClick-ab35c77b.js');
require('./arrayUtils-55970503.js');
require('./UNSAFE_Floating/themes/redwood/FloatingTheme.js');
require('./UNSAFE_Floating/themes/FloatingStyles.css.js');

require('./UNSAFE_Floating/themes/redwood/FloatingBaseTheme.css.js');

require('./UNSAFE_Floating/themes/redwood/FloatingVariants.css.js');
require('./vanilla-extract-dynamic.esm-dc9e7bcc.js');
require('./UNSAFE_Floating/themes/FloatingContract.css.js');
require('./Common/themes/redwood/theme.js');
require('./BaseButton-1fd978ce.js');
require('./usePress-42f3876b.js');
require('./useActive-5db5a3fb.js');
require('./TabbableModeContext-4fb7c910.js');
require('./useTabbableMode-98443dc8.js');
require('./dimensions-77289825.js');
require('./clientHints-666b4780.js');
require('./UNSAFE_BaseButton/themes/BaseButtonStyles.css.js');

require('./ButtonLayout-968b5cb9.js');
require('./Text-15925a9e.js');
require('./UNSAFE_Text/themes/TextStyles.css.js');

require('./UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js');
require('./UNSAFE_ButtonLayout/themes/ButtonLayoutStyles.css.js');

require('./UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.css.js');

require('./UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutVariants.css.js');

require('./getLocale-443e0d6a.js');
require('./stringUtils-5ffab770.js');
require('./Message.types-e2326d81.js');
require('./TransitionGroup-2e7eb24a.js');
require('./MessagesContext-bca47518.js');
require('./useMessagesContext-ed7235e0.js');
require('./Transition-a8b02c5a.js');
require('./boxalignment-e0031b0e.js');

require('./vanilla-extract-sprinkles-createRuntimeSprinkles.esm-e59ab5d4.js');
require('./flexbox-07759e95.js');

require('./flexitem-403ef425.js');


require('./soundUtils-941d182b.js');

require('./UNSAFE_MessageBanner/themes/MessageBannerStyles.css.js');

require('./UNSAFE_MessageBanner/themes/redwood/MessageBannerBaseTheme.css.js');

require('./UNSAFE_MessageBanner/themes/redwood/MessageBannerVariants.css.js');


/**
 * Animation states for banner messages
 * TODO: Get this from theme context provider
 */
const animationStates = {
    entering: (node) => ({
        to: {
            maxHeight: `${node.scrollHeight}px`,
            overflow: 'hidden'
        },
        options: {
            duration: 250
        },
        end: {
            maxHeight: 'none',
            overflow: 'initial'
        }
    }),
    exiting: (node) => ({
        ...(node.style.maxHeight === 'none' && {
            from: {
                maxHeight: `${node.scrollHeight}px`,
                overflow: 'hidden'
            }
        }),
        to: {
            maxHeight: 0,
            overflow: 'hidden'
        },
        end: {
            maxHeight: 0,
            overflow: 'hidden'
        },
        options: {
            duration: 250
        }
    })
};
const initialAnimationStyles = {
    maxHeight: 0,
    overflow: 'hidden'
};
/**
 * Renders individual messages based on the provided data
 */
function MessageBanner({ detailRendererKey, data, onClose, renderers, testId, variant = 'section' }) {
    const testIdProps = useTestId.useTestId(testId);
    // Keyboard Navigation and Focus Management
    const messagesRef = hooks.useRef(new Map());
    const containerDivRef = hooks.useRef(null);
    const focusHandleRef = hooks.useRef(null);
    const [liveRegionText, setLiveRegionText] = hooks.useState();
    const [shouldRender, setShouldRender] = hooks.useState(data.length > 0);
    const translations = useTranslationBundle.useTranslationBundle('@oracle/oraclejet-preact');
    // We need a ref that holds the current & previous data length, as the exiting
    // node will always call handleNextFocus with previous data.
    // As in TransitionGroup, when an item is removed from the data, a new vnode
    // will not be created instead previous vnode will be used. So, the new handleNextFocus
    // will not be called when the old vnode exits. Thus, we will be using a ref
    // to always get the correct current data length.
    const dataLengthRef = hooks.useRef(data.length);
    const prevDataLengthRef = hooks.useRef(0);
    // Update the data length ref
    dataLengthRef.current = data.length;
    // We will be using a function based ref to store the refs in the Map
    const setMessageRef = hooks.useCallback(
    // TODO: use ramda.curry here (currently it is throwing ts error when used with generics)
    (key) => {
        return (ref) => messagesRef.current.set(key, ref);
    }, []);
    // Update the focusHandleRef
    hooks.useImperativeHandle(focusHandleRef, () => ({
        focus: () => {
            // Only trigger focus if the component is rendering messages
            if (data.length) {
                const firstItemKey = data[0].key;
                messagesRef.current.get(firstItemKey)?.focus();
                return true;
            }
            return false;
        },
        contains: (element) => {
            // Only invoke method if the component is rendering messages
            if (data.length && element) {
                return containerDivRef.current?.contains(element) ?? false;
            }
            return false;
        }
    }), [data]);
    // Register handlers for focus management
    const { controller, handlers } = useMessagesFocusManager.useMessageFocusManager(focusHandleRef, {
        onFocus: hooks.useCallback(() => {
            setLiveRegionText(translations.message_navigationFromMessagesRegion());
        }, [setLiveRegionText, translations])
    });
    /**
     * Emits onClose event for the provided message.
     * @param item The message which the user tried to close
     */
    const handleClose = hooks.useCallback((item) => {
        onClose?.(item);
    }, [onClose]);
    /**
     * Handles focus when a message is closed and animated away from the DOM
     * @param key The key of the message
     * @param index The index of the message
     */
    const handleNextFocus = hooks.useCallback((_key, index, closedMessageNode) => {
        const isClosedMessageFocused = closedMessageNode?.contains(document.activeElement);
        // If there are no messages, do not render anything. As the old messages
        // are still in the DOM, use the data count to determine what to do next as it
        // represents the next state.
        if (dataLengthRef.current === 0) {
            setShouldRender(false);
            // If the current message holds focus, then restore previous focus
            if (isClosedMessageFocused) {
                controller.restorePriorFocus();
            }
            return;
        }
        // In TransitionGroup, when an item is removed from the data, a new vnode
        // will not be created instead previous vnode will be used. So, the new handleNextFocus
        // will not be called when the old vnode exits. Thus, all the deps will not be pointing to
        // the current references, rather they will be pointing to the ones where this vnode
        // last existed in the data.
        // This means, the data will contain the closing message as well. But, all the ref objects
        // still point to the most up-to-date values. With that in mind, we will be evaluating the
        // following values.
        const renderedMessagesCount = data.length;
        // Now that this message is closed, focus the next message that will take this index. If no
        // message will take this message's index, then it means that this is the last message. If
        // that is the case, focus the message at the previous index.
        // Use the count of the messages that are currently shown in the UI (current state including
        // the message that will be removed). This way we can get the correct item from the data
        // as it will contain the closing message as well.
        const nextMessageIndexToFocus = index + 1 < renderedMessagesCount ? index + 1 : index - 1;
        // if next message is available then transfer the focus to the next element
        if (nextMessageIndexToFocus > -1 && isClosedMessageFocused) {
            const nextMessageKey = data[nextMessageIndexToFocus].key;
            messagesRef.current.get(nextMessageKey)?.focus();
        }
    }, [controller, data]);
    // Prioritize this component whenever the data changes and
    // the new data has at least one message
    hooks.useEffect(() => {
        if (data.length) {
            // set state to render content whenever the data is not empty
            setShouldRender(true);
            if (data.length > prevDataLengthRef.current) {
                // Only when having a new message, update the aria-live area with the
                // text to indicate how to get the focus to the new message.
                setLiveRegionText(translations.message_navigationToMessagesRegion());
            }
            controller.prioritize();
        }
        else {
            // When there are no messages, clear the live region so that
            // the navigation text will be read when a new message appear
            setLiveRegionText('');
        }
        prevDataLengthRef.current = data.length;
    }, [controller, data, translations]);
    const { classes } = useComponentTheme.useComponentTheme(UNSAFE_MessageBanner_themes_redwood_MessageBannerTheme.MessageBannerRedwoodTheme);
    // When both shouldRender flag is false and no data to render, do not render
    // anything
    if (!shouldRender && data.length === 0) {
        return null;
    }
    return (jsxRuntime.jsx("div", { ref: containerDivRef, class: classNames.classNames(['oj-c-messagebanner', classes]), tabIndex: -1, ...handlers, ...testIdProps, children: jsxRuntime.jsxs(Flex.Flex, { direction: "column", gap: variant === 'section' ? '1x' : undefined, children: [jsxRuntime.jsx(MessagesManager.MessagesManager, { animationStates: animationStates, initialAnimationStyles: initialAnimationStyles, data: data, onMessageWillRemove: handleNextFocus, children: ({ item }) => (jsxRuntime.jsx(Message.Message, { messageRef: setMessageRef(item.key), item: item, detailRenderer: MessageUtils.getRenderer(item, detailRendererKey, renderers), variant: variant === 'page' ? 'pageBanner' : 'sectionBanner', onClose: handleClose }, item.key)) }), jsxRuntime.jsx(LiveRegion.LiveRegion, { children: liveRegionText })] }) }));
}

exports.MessageBanner = MessageBanner;
//# sourceMappingURL=UNSAFE_MessageBanner.js.map
