/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('preact/jsx-runtime');
var hooks = require('preact/hooks');
var preact = require('preact');
var useComponentTheme = require('./useComponentTheme-b6e9b324.js');
var useTestId = require('./useTestId-4fe30223.js');
var UNSAFE_Train_themes_redwood_TrainTheme = require('./UNSAFE_Train/themes/redwood/TrainTheme.js');
var usePress = require('./usePress-42f3876b.js');
var useInteractionStyle = require('./useInteractionStyle-6e5ba1b2.js');
var classNames = require('./classNames-3bb28eb9.js');
var mergeProps = require('./mergeProps-f6f4322f.js');
var SuccessS = require('./SuccessS-3a2c6dd4.js');
var ErrorS = require('./ErrorS-6012f9f3.js');
var InformationS = require('./InformationS-c18dd806.js');
var WarningS = require('./WarningS-5dd358a1.js');
var useActive = require('./useActive-5db5a3fb.js');
var useTranslationBundle = require('./useTranslationBundle-9549e176.js');
var HiddenAccessible = require('./HiddenAccessible-ce5d15d7.js');
require('./logger-01b28029.js');
require('./TopLayerHost-b320c750.js');
require('./Common/themes/redwood/theme.js');
require('./Common/themes/themeContract.css.js');
require('preact/compat');
require('./UNSAFE_Train/themes/TrainStyles.css.js');

require('./UNSAFE_Train/themes/redwood/TrainBaseTheme.css.js');

require('./UNSAFE_Train/themes/redwood/TrainVariants.css.js');

require('./vanilla-extract-recipes-createRuntimeFn.esm-6fa16b7c.js');
require('./clientHints-666b4780.js');
require('./useHover-8f282a4d.js');
require('./useToggle-36126e66.js');
require('./Icon-faf50cac.js');
require('./size-02d9db33.js');
require('./utils-0015eceb.js');
require('./colorUtils-9be60515.js');
require('./_curry1-087704d4.js');
require('./useTooltip-ce4554e9.js');
require('./useTooltipControlled-da1c4a13.js');
require('./useId-42e8026e.js');
require('./Floating-8ecf7694.js');
require('./useFloating-4c19cf7f.js');
require('./useUser-171bdb32.js');
require('./positionUtils-d40a1e16.js');
require('./refUtils-fce65cbf.js');
require('./useOutsideClick-ab35c77b.js');
require('./arrayUtils-55970503.js');
require('./UNSAFE_Floating/themes/redwood/FloatingTheme.js');
require('./UNSAFE_Floating/themes/FloatingStyles.css.js');

require('./UNSAFE_Floating/themes/redwood/FloatingBaseTheme.css.js');

require('./UNSAFE_Floating/themes/redwood/FloatingVariants.css.js');
require('./vanilla-extract-dynamic.esm-dc9e7bcc.js');
require('./UNSAFE_Floating/themes/FloatingContract.css.js');
require('./Layer-c0f805fc.js');
require('./useThemeInterpolations-64b0f552.js');
require('./useColorScheme-53b27a87.js');
require('./useScale-a4b30442.js');
require('./theme-ded14524.js');
require('./Theme-415b919e.js');
require('./mergeInterpolations-032e29ea.js');
require('./_curry3-0631305a.js');
require('./_curry2-e350c665.js');
require('./_isObject-e111cf8c.js');
require('./useFocus-e84e6c2e.js');
require('./useTouch-b01185f2.js');
require('./useAnimation-07e113f8.js');
require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentTheme.js');
require('./hooks/UNSAFE_useTooltip/themes/TooltipContentStyles.css.js');

require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.css.js');

require('./hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js');

require('./EnvironmentProvider-64d57308.js');
require('./LayerManager-70d05a53.js');
require('./UNSAFE_Icon/themes/IconStyle.css.js');



const Context = preact.createContext(null);

/**
The JET Train component serves as a visual navigator enabling users to traverse through different 'steps'. Each 'step' is represented by the Step sub-component which can manifest its own state - 'visited', 'unvisited', or 'disabled', and is capable of communicating various message types including 'error', 'confirmation', 'warning', or 'info'.
 */
function Train({ onSelect, selectedStep, children, testId }) {
    const { classes, styles } = useComponentTheme.useComponentTheme(UNSAFE_Train_themes_redwood_TrainTheme.TrainRedwoodTheme);
    const testIdProps = useTestId.useTestId(testId);
    const selectedStepIndex = children.findIndex((step) => step.props.id === selectedStep);
    const onStepSelect = hooks.useCallback((event, stepId) => {
        onSelect?.({
            event: event,
            toStep: stepId
        });
    }, [onSelect]);
    const trainContext = {
        onSelect: onStepSelect,
        selectedStep: selectedStep,
        selectedStepIndex: selectedStepIndex,
        numberOfSteps: children.length,
        index: 0
    };
    const childrenArray = preact.toChildArray(children).filter(Boolean);
    return (jsxRuntime.jsx("div", { class: classes, ...testIdProps, children: childrenArray.map((step, index) => (jsxRuntime.jsx(Context.Provider, { value: { ...trainContext, index }, children: jsxRuntime.jsx("div", { class: styles.baseListStyle, children: step }) }))) }));
}

const Connector = ({ isConnected }) => {
    const { styles, variantClasses } = useComponentTheme.useComponentTheme(UNSAFE_Train_themes_redwood_TrainTheme.TrainRedwoodTheme, {
        connectorConnected: isConnected ? 'isConnected' : 'notConnected'
    });
    return jsxRuntime.jsx("span", { class: classNames.classNames([styles.connectorBaseStyle, variantClasses]) });
};

const messageTypeIcons = {
    confirmation: SuccessS.SvgSuccessS,
    error: ErrorS.SvgErrorS,
    fatal: ErrorS.SvgErrorS,
    info: InformationS.SvgInformationS,
    warning: WarningS.SvgWarningS
};
/**
 * UserChosenIcon Component for rendering the severity based icon in Message
 */
function UserChosenIcon({ messageType, isDisabled = false }) {
    const IconComponent = messageTypeIcons[messageType];
    const { styles, variantClasses } = useComponentTheme.useComponentTheme(UNSAFE_Train_themes_redwood_TrainTheme.TrainRedwoodTheme, {
        messageType: messageType,
        stepIconDisabled: isDisabled ? 'isDisabled' : 'notDisabled'
    });
    return (jsxRuntime.jsx("div", { class: classNames.classNames([styles.messageTypeIconBaseStyle, variantClasses]), role: "presentation", children: jsxRuntime.jsx(IconComponent, {}) }));
}

/**
 * Step icon
 */
const StepIcon = ({ isDisabled, isVisited, messageType }) => {
    const { index, selectedStepIndex } = hooks.useContext(Context);
    const isCurrent = selectedStepIndex === index;
    const { interactionProps, applyPseudoHoverStyle, applyHoverStyle } = useInteractionStyle.useInteractionStyle(isDisabled || isCurrent);
    const { isActive, activeProps } = useActive.useActive({ isDisabled: isDisabled || isCurrent });
    console.log('isActive', isActive);
    const mergedProps = mergeProps.mergeProps(interactionProps, activeProps);
    const { styles, variantClasses } = useComponentTheme.useComponentTheme(UNSAFE_Train_themes_redwood_TrainTheme.TrainRedwoodTheme, {
        stepIconDisabled: isDisabled ? 'isDisabled' : 'notDisabled',
        stepIconCurrent: isCurrent ? 'isCurrent' : 'notCurrent',
        stepIconVisited: isVisited ? 'isVisited' : 'notVisited',
        stepIconNeedsEventsHover: applyHoverStyle ? 'isNeedsEventsHover' : 'notNeedsEventsHover',
        stepIconPseudoHover: applyPseudoHoverStyle ? 'isPseudoHover' : 'notPseudoHover',
        stepIconActive: isActive ? 'isActive' : 'notActive'
    });
    const iconStyles = () => {
        if (messageType) {
            return jsxRuntime.jsx(UserChosenIcon, { messageType: messageType, isDisabled: isDisabled });
        }
        else {
            return (jsxRuntime.jsx("span", { ...mergedProps, class: classNames.classNames([styles.stepIconBaseStyle, variantClasses]), children: index + 1 }));
        }
    };
    return jsxRuntime.jsx("span", { class: styles.stepIconContainerStyle, children: iconStyles() });
};

/**
 * Step label component
 */
const StepLabel = ({ label, isDisabled, isVisited, messageType }) => {
    const { numberOfSteps, index, selectedStepIndex } = hooks.useContext(Context);
    const translations = useTranslationBundle.useTranslationBundle('@oracle/oraclejet-preact');
    const isCurrent = selectedStepIndex === index;
    const { interactionProps, applyPseudoHoverStyle, applyHoverStyle } = useInteractionStyle.useInteractionStyle(isDisabled || isCurrent);
    const currentStepStatus = isCurrent
        ? translations.train_current()
        : isVisited
            ? translations.train_visited()
            : translations.train_not_visited();
    const currentStep = index + 1;
    const statusTextForCurrentStep = messageType
        ? `${translations.train_status({
            currentStep: currentStep.toString(),
            numberOfSteps: numberOfSteps.toString()
        })}. ${currentStepStatus}, ${translations.train_message_type()}: ${messageType}`
        : `${translations.train_status({
            currentStep: currentStep.toString(),
            numberOfSteps: numberOfSteps.toString()
        })}. ${currentStepStatus}`;
    const { styles, variantClasses } = useComponentTheme.useComponentTheme(UNSAFE_Train_themes_redwood_TrainTheme.TrainRedwoodTheme, {
        stepLabelDisabled: isDisabled ? 'isDisabled' : 'notDisabled',
        stepLabelCurrent: isCurrent ? 'isCurrent' : 'notCurrent',
        stepLabelVisited: isVisited ? 'isVisited' : 'notVisited',
        stepLabelNeedsEventsHover: applyHoverStyle ? 'isNeedsEventsHover' : 'notNeedsEventsHover',
        stepLabelPseudoHover: applyPseudoHoverStyle ? 'isPseudoHover' : 'notPseudoHover'
    });
    const handleClick = (event) => {
        event.preventDefault();
    };
    return (jsxRuntime.jsx("span", { class: styles.stepLabelWrapperStyle, children: jsxRuntime.jsxs("a", { ...interactionProps, href: "#", class: classNames.classNames([styles.stepLabelBaseStyle, variantClasses]), onClick: handleClick, children: [label, jsxRuntime.jsx(HiddenAccessible.HiddenAccessible, { children: statusTextForCurrentStep })] }) }));
};

/**
 * Step component
 */
const Step = ({ id, isDisabled, isVisited, messageType, label }) => {
    const { onSelect, /* selectedStep ,*/ numberOfSteps, selectedStepIndex, index } = hooks.useContext(Context) || // get the context object or...
        (() => {
            // if there's no context object, throw an error
            throw new Error('Step component must be rendered within a Train component.');
        })();
    const isCurrent = selectedStepIndex === index;
    const [isActive, setIsActive] = hooks.useState(false);
    const { interactionProps, applyPseudoHoverStyle, applyHoverStyle } = useInteractionStyle.useInteractionStyle(isDisabled || isCurrent);
    const isConnectorConnected = selectedStepIndex > index;
    const onSelectHandler = hooks.useCallback((event) => {
        if (!isDisabled && !isCurrent) {
            onSelect(event, id);
        }
    }, [isDisabled, isCurrent, onSelect, id]);
    const { pressProps } = usePress.usePress(onSelectHandler, {});
    const isLast = index !== numberOfSteps - 1;
    const onMouseUpHandler = hooks.useCallback(() => {
        setIsActive(false);
    }, []);
    const onMouseDownHandler = hooks.useCallback(() => {
        setIsActive(true);
    }, []);
    const { styles, variantClasses } = useComponentTheme.useComponentTheme(UNSAFE_Train_themes_redwood_TrainTheme.TrainRedwoodTheme, {
        stepDisabled: isDisabled ? 'isDisabled' : 'notDisabled',
        needsEventsHover: applyHoverStyle ? 'isNeedsEventsHover' : 'notNeedsEventsHover',
        pseudoHover: applyPseudoHoverStyle ? 'isPseudoHover' : 'notPseudoHover',
        stepActive: isActive && !isCurrent ? 'isActive' : 'notActive'
    });
    const mergedProps = mergeProps.mergeProps(pressProps, interactionProps, {
        onMouseUp: onMouseUpHandler,
        onMouseDown: onMouseDownHandler
    });
    return (jsxRuntime.jsxs("span", { class: styles.stepContainerStyle, children: [isLast && jsxRuntime.jsx(Connector, { isConnected: isConnectorConnected }), jsxRuntime.jsxs("span", { ...mergedProps, class: classNames.classNames([styles.stepBaseStyle, variantClasses]), children: [jsxRuntime.jsx(StepIcon, { isVisited: isVisited, isDisabled: isDisabled, messageType: messageType }), jsxRuntime.jsx(StepLabel, { label: label, isVisited: isVisited, isDisabled: isDisabled, messageType: messageType })] })] }));
};

exports.Step = Step;
exports.Train = Train;
//# sourceMappingURL=UNSAFE_Train.js.map
