/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var UNSAFE_VisStatusMessage_themes_VisStatusMessageStyles_css = require('./UNSAFE_VisStatusMessage/themes/VisStatusMessageStyles.css.js');
var Flex = require('./Flex-299660c2.js');
var classNames = require('./classNames-3bb28eb9.js');
var useTranslationBundle = require('./useTranslationBundle-9549e176.js');
var LayoutUtils = require('./LayoutUtils-d2e22f42.js');

function VisStatusMessage({ children, ...otherProps }) {
    const itemClasses = classNames.classNames([otherProps.isSelectable ? '' : UNSAFE_VisStatusMessage_themes_VisStatusMessageStyles_css.userSelectStyles, UNSAFE_VisStatusMessage_themes_VisStatusMessageStyles_css.baseStyles]);
    return (jsxRuntime.jsx("div", { class: itemClasses, tabIndex: 0, "aria-label": otherProps['aria-label'], "aria-activedescendant": otherProps.activeId, children: jsxRuntime.jsx(Flex.Flex, { width: "100%", height: "100%", justify: "center", align: "center", children: children }) }));
}

function VisNoData(props) {
    const translations = useTranslationBundle.useTranslationBundle('@oracle/oraclejet-preact');
    const noDataMsg = translations.dataVisualization_noData();
    const activeId = LayoutUtils.getRandomId();
    return (jsxRuntime.jsx(VisStatusMessage, { "aria-label": props['aria-label'], activeId: activeId, children: jsxRuntime.jsx("span", { id: activeId, children: noDataMsg }) }));
}

exports.VisNoData = VisNoData;
exports.VisStatusMessage = VisStatusMessage;
//# sourceMappingURL=VisNoData-ccdd1f75.js.map
