/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var useInteractionStyle = require('../useInteractionStyle-6e5ba1b2.js');
require('../mergeProps-f6f4322f.js');
require('../clientHints-666b4780.js');
require('../useHover-8f282a4d.js');
require('../useToggle-36126e66.js');
require('preact/hooks');
require('../useActive-5db5a3fb.js');

/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
/**
 * Collection of helper functions for writing your component styles in our theming system.
 * Pass in your style and it will return an object with the appropriate CSS selector wrapping it.
 */
const wrapWithActiveSelector = (style) => ({
    '&:active': style
});
const wrapWithHoverSelector = (style) => ({
    '&:hover': style
});
const wrapWithFocusSelector = (style) => ({
    '&:focus': style
});
const wrapWithFocusVisibleSelector = (style) => ({
    '&:focus-visible': style
});
const wrapWithVisitedSelector = (style) => ({
    '&:visited': style
});
const wrapWithNotActiveSelector = (style) => ({
    '&:not(:active)': style
});
const wrapWithParentNotActiveSelector = (style, parent) => ({
    [`${parent}:not(:active) > &`]: style
});
const wrapWithPseudoHoverSelector = (style) => ({
    '@media': {
        '(hover: hover)': {
            selectors: {
                '&:hover:not(:active)': style
            }
        }
    }
});
const wrapWithParentPseudoHoverSelector = (style, parent) => ({
    '@media': {
        '(hover: hover)': {
            selectors: {
                [`${parent}:hover:not(:active) > &`]: style
            }
        }
    }
});

exports.useInteractionStyle = useInteractionStyle.useInteractionStyle;
exports.wrapWithActiveSelector = wrapWithActiveSelector;
exports.wrapWithFocusSelector = wrapWithFocusSelector;
exports.wrapWithFocusVisibleSelector = wrapWithFocusVisibleSelector;
exports.wrapWithHoverSelector = wrapWithHoverSelector;
exports.wrapWithNotActiveSelector = wrapWithNotActiveSelector;
exports.wrapWithParentNotActiveSelector = wrapWithParentNotActiveSelector;
exports.wrapWithParentPseudoHoverSelector = wrapWithParentPseudoHoverSelector;
exports.wrapWithPseudoHoverSelector = wrapWithPseudoHoverSelector;
exports.wrapWithVisitedSelector = wrapWithVisitedSelector;
//# sourceMappingURL=UNSAFE_useInteractionStyle.js.map
