/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var size = require('./size-02d9db33.js');
var arrayUtils = require('./arrayUtils-55970503.js');

const paddingInterpolations = {
    padding: ({ padding }) => {
        if (padding === undefined) {
            return {};
        }
        else {
            const [topPadding, rightPadding = topPadding, bottomPadding = topPadding, leftPadding = rightPadding] = arrayUtils.coerceArray(padding);
            return {
                padding: `${size.sizeToCSS(topPadding)} ${size.sizeToCSS(rightPadding)} 
        ${size.sizeToCSS(bottomPadding)} ${size.sizeToCSS(leftPadding)}`
            };
        }
    },
    paddingBlockStart: ({ paddingBlockStart }) => paddingBlockStart === undefined
        ? {}
        : {
            paddingBlockStart: `${size.sizeToCSS(paddingBlockStart)}`
        },
    paddingBlockEnd: ({ paddingBlockEnd }) => paddingBlockEnd === undefined
        ? {}
        : {
            paddingBlockEnd: `${size.sizeToCSS(paddingBlockEnd)}`
        },
    paddingInlineStart: ({ paddingInlineStart }) => paddingInlineStart === undefined
        ? {}
        : {
            paddingInlineStart: `${size.sizeToCSS(paddingInlineStart)}`
        },
    paddingInlineEnd: ({ paddingInlineEnd }) => paddingInlineEnd === undefined
        ? {}
        : {
            paddingInlineEnd: `${size.sizeToCSS(paddingInlineEnd)}`
        }
};

exports.paddingInterpolations = paddingInterpolations;
//# sourceMappingURL=padding-f5c99049.js.map
