/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

function assignRef(ref, value) {
    if (ref == null)
        return;
    if (typeof ref === 'function') {
        ref(value);
        return;
    }
    try {
        ref.current = value;
    }
    catch (error) {
        throw new Error(`Cannot assign value '${value}' to ref '${ref}'`);
    }
}
function mergeRefs(...refs) {
    return (node) => {
        refs.forEach((ref) => assignRef(ref, node));
    };
}

exports.assignRef = assignRef;
exports.mergeRefs = mergeRefs;
//# sourceMappingURL=refUtils-fce65cbf.js.map
