/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var preact = require('@testing-library/preact');
require('./TopLayerHost-b320c750.js');
var EnvironmentProvider = require('./EnvironmentProvider-64d57308.js');
var resources_nls_en_bundle = require('./resources/nls/en/bundle.js');

const defaultEnvironment = {
    translations: { '@oracle/oraclejet-preact': resources_nls_en_bundle["default"] },
    mode: 'test'
};
const renderInEnv = (children, environment = defaultEnvironment, options) => {
    const mergedEnvironment = { ...environment };
    if (mergedEnvironment.translations == null) {
        mergedEnvironment.translations = {
            ...defaultEnvironment.translations
        };
    }
    const { rerender: _rerender, ...result } = preact.render(jsxRuntime.jsx(EnvironmentProvider.RootEnvironmentProvider, { environment: mergedEnvironment, children: children }), options);
    const rerender = (children) => _rerender(jsxRuntime.jsx(EnvironmentProvider.RootEnvironmentProvider, { environment: mergedEnvironment, children: children }));
    return { rerender, ...result };
};

exports.renderInEnv = renderInEnv;
//# sourceMappingURL=render-5d53cd4e.js.map
