/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var hooks = require('preact/hooks');
var preact = require('preact');

/**
 * Context used by the parent to pass accessibility related information.
 */
const AccessibleContext = preact.createContext({
    UNSAFE_ariaLabelledBy: undefined
});

/**
 * Utility hook for consuming the AccessibleContext
 *
 * @returns The value of closest AccessibleContext provider
 */
function useAccessibleContext() {
    return hooks.useContext(AccessibleContext);
}

exports.AccessibleContext = AccessibleContext;
exports.useAccessibleContext = useAccessibleContext;
//# sourceMappingURL=useAccessibleContext-2e263fc7.js.map
