/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var hooks = require('preact/hooks');
var useToggle = require('./useToggle-36126e66.js');

/**
 * A custom hook that handles showing/hiding clear icon
 */
function useClearIcon({ clearIcon, display, hasValue, isEnabled = true, isFocused = false, isHover = false }) {
    const shouldRenderClearIcon = hooks.useCallback(() => isEnabled &&
        (display === 'always' || (display === 'conditionally' && hasValue && (isFocused || isHover))), [display, hasValue, isEnabled, isFocused, isHover]);
    const { bool, setFalse, setTrue } = useToggle.useToggle(shouldRenderClearIcon());
    hooks.useEffect(() => {
        shouldRenderClearIcon() ? setTrue() : setFalse();
    }, [shouldRenderClearIcon, setTrue, setFalse]);
    return bool ? clearIcon : null;
}

exports.useClearIcon = useClearIcon;
//# sourceMappingURL=useClearIcon-cdcec949.js.map
