/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var useToggle = require('./useToggle-36126e66.js');

/**
 * Get status on whether target has focus or not
 * @returns
 */
function useFocus(settings = { isDisabled: false }) {
    const { bool, setTrue, setFalse } = useToggle.useToggle(false);
    const focusProps = settings.isDisabled
        ? {}
        : {
            onFocus: setTrue,
            onBlur: setFalse
        };
    return {
        isFocus: settings.isDisabled ? false : bool,
        focusProps: focusProps
    };
}

exports.useFocus = useFocus;
//# sourceMappingURL=useFocus-e84e6c2e.js.map
