/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var hooks = require('preact/hooks');
var FormContext = require('./FormContext-4a2edf25.js');

/**
 * Utility hook for consuming the FormContext
 *
 * @returns The value of closest FormContext provider
 */
function useFormContext() {
    const context = hooks.useContext(FormContext.FormContext);
    // merge the returned context into the default context so that all props are specified
    const contextWithDefaults = Object.assign({}, FormContext.DefaultFormContext, context);
    return contextWithDefaults;
}

exports.useFormContext = useFormContext;
//# sourceMappingURL=useFormContext-49a14273.js.map
