/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var mergeProps = require('./mergeProps-f6f4322f.js');
var useChartDataCursor = require('./useChartDataCursor-693ae1ae.js');
var useChartDatatip = require('./useChartDatatip-30b2a4e8.js');
var eventsUtils = require('./eventsUtils-086f0e32.js');
require('./accUtils-c4465ee9.js');
var useChartDrill = require('./useChartDrill-7364663e.js');
var useSelection = require('./useSelection-38a198d5.js');

/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
function useChartDatatipAndCursor({ series, groups, width, height, findNearest, onDataCursorPositionChange, isDataCursorEnabled, dataCursorPosition, dataCursorStyle, hoveredItemInfo, focusedItemInfo, getDataItem, getDataItemPos, datatip, valueFormats, isHoriz, xScale, yScale, plotAreaSpace }) {
    const { datatipContent, datatipProps } = useChartDatatip.useChartDatatip({
        series,
        groups,
        width,
        height,
        isDataCursorEnabled,
        dataCursorPosition,
        hoveredItemInfo,
        getDataItem,
        getDataItemPos,
        focusedItemInfo,
        datatip,
        valueFormats,
        isHoriz,
        xScale,
        findNearest
    });
    const { dataCursorContent, dataCursorProps } = useChartDataCursor.useChartDataCursor({
        findNearest,
        dataCursorPosition,
        onDataCursorPositionChange,
        isDataCursorEnabled,
        dataCursorStyle,
        isHoriz,
        focusedItemInfo,
        plotAreaSpace,
        yScale,
        xScale,
        getDataItemPos
    });
    return {
        datatipContent,
        dataCursorContent,
        datatipProps: mergeProps.mergeProps(dataCursorProps, datatipProps)
    };
}

/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
function useSelectDrill({ selectionMode, selection, onChange, rootRef, drilling, onItemDrill, onGroupDrill, focusedGroupInfo, focusedItemInfo, groups, getDataItem }) {
    const idExtracter = (event) => {
        const isItemFocused = focusedItemInfo.isCurrent;
        const info = isItemFocused && event.type === 'keyup' ? focusedItemInfo : eventsUtils.getInfo(rootRef, event);
        return info && info.seriesIndex != null && info.groupIndex != null
            ? getDataItem(info.seriesIndex, info.groupIndex)?.id
            : undefined;
    };
    const selectionProps = useSelection.useSelection({
        idExtracter,
        isDrillEnabled: drilling === 'on',
        selection,
        selectionMode,
        onChange
    });
    const drillProps = useChartDrill.useChartDrill({
        rootRef,
        selectionMode,
        drilling,
        focusedItemInfo,
        focusedGroupInfo,
        groups,
        getDataItem,
        onItemDrill,
        onGroupDrill
    });
    return mergeProps.mergeProps(selectionProps, drillProps);
}

exports.useChartDatatipAndCursor = useChartDatatipAndCursor;
exports.useSelectDrill = useSelectDrill;
//# sourceMappingURL=useSelectDrill-8058c001.js.map
