/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var hooks = require('preact/hooks');
var useResizeObserver = require('./useResizeObserver-1c0c68c4.js');

const useSize = (ref, resizeObserverOptions = { box: 'content-box' }) => {
    const [size, setSize] = hooks.useState();
    useResizeObserver.useResizeObserver({
        ref,
        callback: hooks.useCallback((entry) => {
            const boxSize = resizeObserverOptions.box === 'border-box' ? entry.borderBoxSize : entry.contentBoxSize;
            const newWidth = boxSize[0].inlineSize;
            const newHeight = boxSize[0].blockSize;
            setSize({ width: newWidth, height: newHeight });
        }, [resizeObserverOptions]),
        resizeObserverOptions
    });
    return size;
};

exports.useSize = useSize;
//# sourceMappingURL=useSize-83a9b1a0.js.map
