/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var TopLayerHost = require('./TopLayerHost-b320c750.js');
require('preact/jsx-runtime');
var hooks = require('preact/hooks');
require('preact/compat');

/**
 * Returns the set of attributes to be applied to the DOM node if the application's mode is not
 * set to "production".
 */
function useTestId(testId) {
    const context = hooks.useContext(TopLayerHost.EnvironmentContext);
    return context.mode === 'production' || testId === ''
        ? {}
        : {
            'data-testid': testId
        };
}

exports.useTestId = useTestId;
//# sourceMappingURL=useTestId-4fe30223.js.map
