/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var useToggle = require('./useToggle-36126e66.js');

/**
 * Get status on whether target has touch or not
 * @returns
 */
function useTouch(settings = { isDisabled: false }) {
    const { bool, setTrue, setFalse } = useToggle.useToggle(false);
    const touchProps = settings.isDisabled
        ? {}
        : {
            onTouchStart: setTrue,
            onTouchEnd: setFalse
        };
    return {
        isTouch: settings.isDisabled ? false : bool,
        touchProps: touchProps
    };
}

exports.useTouch = useTouch;
//# sourceMappingURL=useTouch-b01185f2.js.map
