/* @oracle/oraclejet-preact: 16.0.1 */
'use strict';

var jsxRuntime = require('preact/jsx-runtime');
var useUser = require('./useUser-171bdb32.js');

// Returns a component that renders one of the given icon components based on reading direction
const withDirectionIcon = (LtrIcon, RtlIcon) => {
    return (props) => {
        const { direction } = useUser.useUser();
        return direction === 'ltr' ? jsxRuntime.jsx(LtrIcon, { ...props }) : jsxRuntime.jsx(RtlIcon, { ...props });
    };
};

exports.withDirectionIcon = withDirectionIcon;
//# sourceMappingURL=withDirectionIcon-b267fd58.js.map
