/* @oracle/oraclejet-preact: 16.0.1 */
import { jsxs, jsx } from 'preact/jsx-runtime';
import { T as Text } from './Text-ec0e2d47.js';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import { ButtonLayoutRedwoodTheme } from './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js';

const isNullOrUndefined = (value) => {
    return value === null || value === undefined;
};
function ButtonLayout({ size = 'md', display = 'all', styling = 'default', ...props }) {
    const isShowIcons = display === 'all' || display === 'icons';
    const isShowText = display === 'all' || display === 'label';
    const isOnlyIcon = props.startIcon && (display === 'icons' || !props.children) && !props.endIcon;
    const hasTextStartIcon = !isNullOrUndefined(props.startIcon) && display === 'all';
    const hasTextEndIcon = !isNullOrUndefined(props.endIcon) && isShowIcons;
    const isTwoIcons = !isNullOrUndefined(props.startIcon) && !isNullOrUndefined(props.endIcon);
    const isTwoIconsOnly = isTwoIcons && display === 'icons';
    const { classes: startIconClasses } = useComponentTheme(ButtonLayoutRedwoodTheme, {
        target: 'startIcon',
        size: styling == 'default' ? size : ('embedded' + size),
        onlyIcon: isOnlyIcon ? 'isOnlyIcon' : 'notOnlyIcon',
        twoIconsOnly: isTwoIconsOnly ? 'isTwoIconsOnly' : 'notTwoIconsOnly'
    });
    const { classes: labelClasses, styles: labelStyles } = useComponentTheme(ButtonLayoutRedwoodTheme, {
        target: 'label',
        size: styling == 'default' ? size : ('embedded' + size),
        textEndIcon: hasTextEndIcon ? 'hasTextEndIcon' : 'notTextEndIcon',
        textStartIcon: hasTextStartIcon ? 'hasTextStartIcon' : 'notTextStartIcon',
        suffix: props.suffix ? 'hasSuffix' : 'notSuffix',
        twoIcons: isTwoIcons ? 'hasTwoIcons' : 'notTwoIcons'
    });
    const { classes: suffixClasses } = useComponentTheme(ButtonLayoutRedwoodTheme, {
        target: 'suffix',
        size: styling == 'default' ? size : ('embedded' + size),
        textStartIcon: hasTextStartIcon ? 'hasTextStartIcon' : 'notTextStartIcon',
        twoIcons: isTwoIcons ? 'hasTwoIcons' : 'notTwoIcons'
    });
    const { classes: endIconClasses } = useComponentTheme(ButtonLayoutRedwoodTheme, {
        target: 'endIcon',
        textEndIcon: hasTextEndIcon ? 'hasTextEndIcon' : 'notTextEndIcon',
        twoIcons: isTwoIcons ? 'hasTwoIcons' : 'notTwoIcons',
        size: styling == 'default' ? size : ('embedded' + size)
    });
    return (jsxs("span", { class: labelStyles.container, children: [isShowIcons && props.startIcon && jsx("span", { class: startIconClasses, children: props.startIcon }), isShowText && props.children && jsxs("span", { class: labelClasses, children: [" ", props.children, " "] }), isShowText && props.suffix && (jsx("span", { class: suffixClasses, children: jsx(Text, { truncation: 'ellipsis', weight: 'inherit', children: props.suffix }) })), isShowIcons && props.endIcon && jsx("span", { class: endIconClasses, children: props.endIcon })] }));
}
ButtonLayout.displayName = 'ButtonLayout';

export { ButtonLayout as B };
//# sourceMappingURL=ButtonLayout-af96cb96.js.map
