/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { useCallback } from 'preact/hooks';
import { u as usePress } from './usePress-6e2cde1b.js';
import { u as useTranslationBundle } from './useTranslationBundle-95f6039e.js';
import './ClearIconStyles.styles.css';
import { c as classNames } from './classNames-2e96f1d4.js';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import { ButtonLayoutRedwoodTheme } from './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js';

var clearIconStyles = 'ClearIconStyles_clearIconStyles__8wwy0m0';

const noop = () => { };
function ClearIcon({ onClick }) {
    const killEvent = useCallback((event) => {
        event.preventDefault();
    }, []);
    const { pressProps } = usePress(onClick ?? noop);
    const translations = useTranslationBundle('@oracle/oraclejet-preact');
    const clearStr = translations.formControl_clear();
    // Because the ClearIconStyles.css.ts uses buttonLayoutBaseTheme styles, we
    // need their vars to be loaded as well. This is why we are adding the buttonLayoutBaseTheme
    // style class.
    // TODO: update ButtonLayoutRedwoodTheme once theme switching is re-enabled.
    const { baseTheme: buttonLayoutBaseTheme } = useComponentTheme(ButtonLayoutRedwoodTheme);
    const styleClasses = classNames([buttonLayoutBaseTheme, clearIconStyles]);
    return (jsx("span", { "aria-hidden": "true", class: styleClasses, tabIndex: -1, onMouseDown: killEvent, title: clearStr, ...pressProps, children: jsx("svg", { height: "1em", viewBox: "0 0 24 24", width: "1em", xmlns: "http://www.w3.org/2000/svg", children: jsx("path", { d: "m12 1c6.065 0 11 4.935 11 11s-4.935 11-11 11-11-4.935-11-11 4.935-11 11-11zm3.4979817 6-3.4979817 3.498-3.49798173-3.498-1.50201827 1.50201827 3.498 3.49798173-3.498 3.4979817 1.50201827 1.5020183 3.49798173-3.498 3.4979817 3.498 1.5020183-1.5020183-3.498-3.4979817 3.498-3.49798173z", fill: "currentcolor", "fill-rule": "evenodd" }) }) }));
}

export { ClearIcon as C };
//# sourceMappingURL=ClearIcon-b9ef3537.js.map
