/* @oracle/oraclejet-preact: 16.0.1 */
import { x as xUnits, b as max } from '../../../utils-4aa3c8ad.js';
import '../themeContract.css.js';
import '../../../colorUtils-30dc7d3f.js';
import '../../../_curry1-b1d25277.js';

/**
 * Stable theme tokens are manually updated and are not generated from Figma tokens
 */
const typography = {
    heading: {
        xs: {
            fontSize: xUnits(5), //'1.25rem',
            lineHeight: '1.25',
            fontWeight: '800'
        },
        sm: {
            fontSize: xUnits(6), //'1.5rem',
            lineHeight: '1.25',
            fontWeight: '800'
        },
        md: {
            fontSize: xUnits(7), //'1.75rem',
            lineHeight: '1.25',
            fontWeight: '800'
        },
        lg: {
            fontSize: xUnits(8), //'2rem',
            lineHeight: '1.25',
            fontWeight: '800'
        },
        xl: {
            fontSize: xUnits(9), //'2.25rem',
            lineHeight: '1.25',
            fontWeight: '800'
        },
        '2xl': {
            fontSize: xUnits(10), //'2.5rem',
            lineHeight: '1.25',
            fontWeight: '800'
        }
    },
    subheading: {
        '2xs': {
            fontSize: xUnits(3), //'.75rem',
            lineHeight: '1.25',
            fontWeight: '700'
        },
        xs: {
            fontSize: xUnits(4), //'1rem',
            lineHeight: '1.25',
            fontWeight: '700'
        },
        sm: {
            fontSize: xUnits(5), //'1.25rem',
            lineHeight: '1.25',
            fontWeight: '700'
        },
        md: {
            fontSize: xUnits(6), //'1.5rem',
            lineHeight: '1.25',
            fontWeight: '700'
        },
        lg: {
            fontSize: xUnits(7), //'1.75rem',
            lineHeight: '1.25',
            fontWeight: '700'
        },
        xl: {
            fontSize: xUnits(8), //'2rem',
            lineHeight: '1.25',
            fontWeight: '700'
        },
        '2xl': {
            fontSize: xUnits(9), //'2.25rem',
            lineHeight: '1.25',
            fontWeight: '700'
        }
    },
    // min values are px units as they are absolute minimums and shouldn't get smaller (or bigger) if the
    // root font-size changes.
    body: {
        '2xs': {
            fontSize: max(xUnits(2.5), '10px'), //'0.625rem'
            lineHeight: '1.25',
            fontWeight: {
                regular: '400',
                semibold: '600',
                bold: '700'
            }
        },
        xs: {
            fontSize: max(xUnits(3), '12px'), //'0.75rem'
            lineHeight: '1.25',
            fontWeight: {
                regular: '400',
                semibold: '600',
                bold: '700'
            }
        },
        sm: {
            fontSize: max(xUnits(3.4375), '12px'), //'0.859375rem'
            lineHeight: '1.25',
            fontWeight: {
                regular: '400',
                semibold: '600',
                bold: '700'
            }
        },
        md: {
            fontSize: max(xUnits(4), '12px'), //'1rem'
            lineHeight: '1.25',
            fontWeight: {
                regular: '400',
                semibold: '600',
                bold: '700'
            }
        },
        lg: {
            fontSize: max(xUnits(4.5), '14px'), //'1.125rem'
            lineHeight: '1.25',
            fontWeight: {
                regular: '400',
                semibold: '600',
                bold: '700'
            }
        },
        xl: {
            fontSize: max(xUnits(5), '16px'), //'1.25rem'
            lineHeight: '1.25',
            fontWeight: {
                regular: '400',
                semibold: '600',
                bold: '700'
            }
        }
    }
};

export { typography };
//# sourceMappingURL=theme.typography.tokens.js.map
