/* @oracle/oraclejet-preact: 16.0.1 */
import { jsxs, jsx, Fragment } from 'preact/jsx-runtime';
import { u as useTooltip } from './useTooltip-cb4418ec.js';
import 'preact/hooks';
import './Floating-9ce291ba.js';
import 'preact/compat';
import './TopLayerHost-d50e5624.js';
import { c as classNames } from './classNames-2e96f1d4.js';
import './logger-c710d0a3.js';
import './TooltipContentStyles.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js';
import { u as useTranslationBundle } from './useTranslationBundle-95f6039e.js';
import { C as CompactHelpSource } from './CompactHelpSource-d0d5c0bf.js';
import { requiredIconBase, requiredIconLabelEdgeStart } from './UNSAFE_UserAssistance/themes/UserAssistanceStyles.css.js';

const CompactLabelAssistance = ({ helpIconId, helpSourceLink, helpSourceText, isRequiredShown, labelEdge }) => {
    const translations = useTranslationBundle('@oracle/oraclejet-preact');
    const requiredStr = translations.userAssistance_required();
    const { tooltipContent, tooltipProps } = useTooltip({
        text: requiredStr,
        offset: { mainAxis: 8 }
    });
    const requiredStyles = classNames([
        requiredIconBase,
        labelEdge === 'start' && requiredIconLabelEdgeStart
    ]);
    const requiredIndicator = isRequiredShown && (jsxs("span", { children: [jsx("span", { class: requiredStyles, ...tooltipProps }), tooltipContent] }));
    const helpIndicator = (helpSourceLink || helpSourceText) && (jsx(CompactHelpSource, { id: helpIconId, labelEdge: labelEdge, source: helpSourceLink, children: helpSourceText }));
    return (jsxs(Fragment, { children: [labelEdge !== 'start' && requiredIndicator, helpIndicator, labelEdge === 'start' && requiredIndicator] }));
};

export { CompactLabelAssistance as C };
//# sourceMappingURL=CompactLabelAssistance-96f797b7.js.map
