/* @oracle/oraclejet-preact: 16.0.1 */
import { jsxs, jsx } from 'preact/jsx-runtime';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import 'preact/hooks';
import './Flex-47f90e61.js';
import './MessageBannerStyles.styles.css';
import './UNSAFE_MessageBanner/themes/redwood/MessageBannerBaseTheme.styles.css';
import './UNSAFE_MessageBanner/themes/redwood/MessageBannerVariants.css.js';
import 'preact';
import './Floating-9ce291ba.js';
import 'preact/compat';
import './TopLayerHost-d50e5624.js';
import './TooltipContentStyles.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js';
import './IconStyle.styles.css';
import './IconButton-c8fafbab.js';
import './MessageStyles.styles.css';
import './MessageFormattingUtils-56752721.js';
import { M as MessageStartIcon } from './MessageStartIcon-245107bf.js';
import { M as MessageSummary } from './MessageSummary-ede2d018.js';
import { i as isSeverityIconNeeded } from './MessageUtils-a7260514.js';
import './TransitionGroup-a51c7df7.js';
import './MessagesContext-d5efd74c.js';
import { H as HiddenAccessible } from './HiddenAccessible-653c0211.js';
import { ComponentMessageRedwoodTheme } from './UNSAFE_ComponentMessage/themes/redwood/ComponentMessageTheme.js';

/**
 * The component that renders an individual message for inline component messaging.
 */
function ComponentMessage({ detail, fieldLabel, severity = 'error' }) {
    const { classes } = useComponentTheme(ComponentMessageRedwoodTheme, {
        severity: severity ?? 'none'
    });
    return (jsxs("div", { class: classes, role: "alert", "aria-atomic": "true", children: [fieldLabel && jsx(HiddenAccessible, { children: fieldLabel }), isSeverityIconNeeded(severity) && jsx(MessageStartIcon, { variant: "inline", severity: severity }), jsx(MessageSummary, { variant: "inline", text: detail })] }));
}

export { ComponentMessage as C };
//# sourceMappingURL=ComponentMessage-9f28981e.js.map
