/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx, Fragment } from 'preact/jsx-runtime';
import { useRef, useCallback } from 'preact/hooks';
import { F as Floating } from './Floating-9ce291ba.js';
import { L as Layer } from './Layer-c8a9c60e.js';
import 'preact/compat';
import './TopLayerHost-d50e5624.js';
import { K as KEYS } from './keyboardUtils-1e9adef3.js';
import { dropdownStyles } from './UNSAFE_Dropdown/themes/dropdownStyles.css.js';
import { u as useOutsideMousedown } from './useOutsideMousedown-132f6875.js';

const DEFAULT_PLACEMENT = 'bottom-start';
const DEFAULT_OFFSET = { mainAxis: 4, crossAxis: 0 };
const DEFAULT_SIZE_OPTIONS = { isMaxWidthAdjusted: true, isMaxHeightAdjusted: true };
//TODO: Add animation to dropdown. JET-62628
//TODO: Investigate best approach to have different virtual padding depending on the position and implement it.JET-57950
function Dropdown({ isOpen = false, anchorRef, children, id, onClose, minWidth, placement = DEFAULT_PLACEMENT, offset = DEFAULT_OFFSET, onPosition, flipOptions, sizeOptions = DEFAULT_SIZE_OPTIONS }) {
    const dropdownRef = useRef(null);
    const handleMousedownClose = useCallback((event) => {
        onClose?.({ reason: 'outsideMousedown', target: event.target });
    }, [onClose]);
    const handleKeyDown = useCallback((event) => {
        if (event.defaultPrevented) {
            return;
        }
        switch (event.code) {
            case KEYS.ESC:
            case KEYS.TAB:
                onClose?.({ reason: 'dismissed' });
                break;
        }
    }, [onClose]);
    // use the mousedown event to be consistent with legacy JET
    useOutsideMousedown({
        isDisabled: false,
        ref: [dropdownRef],
        handler: handleMousedownClose
    });
    return (jsx(Fragment, { children: isOpen ? (jsx(Layer, { logicalParentRef: anchorRef, children: jsx(Floating, { anchorRef: anchorRef, ref: dropdownRef, placement: placement, flipOptions: flipOptions, shiftOptions: {
                    mainAxis: false,
                    crossAxis: false
                }, sizeOptions: sizeOptions, offsetValue: offset, onPosition: onPosition, children: jsx("div", { id: id, class: dropdownStyles.base, style: { minWidth: `${minWidth || 0}px` }, onKeyDown: handleKeyDown, children: children }) }) })) : null }));
}

export { Dropdown as D };
//# sourceMappingURL=Dropdown-4501737c.js.map
