/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { d as dimensionInterpolations } from './dimensions-d9512d9e.js';
import { m as mergeInterpolations } from './mergeInterpolations-f71c7446.js';
import { b as boxAlignmentInterpolations } from './boxalignment-3404f84f.js';
import { f as flexboxInterpolations } from './flexbox-6adb0f8d.js';
import { f as flexitemInterpolations } from './flexitem-139efd0e.js';
import { c as classNames } from './classNames-2e96f1d4.js';
import './FlexStyles.styles.css';

var baseStyles = 'FlexStyles_baseStyles__10p93f60';
var marginZeroStyles = 'FlexStyles_marginZeroStyles__10p93f61';

const interpolations = [
    ...Object.values(dimensionInterpolations),
    ...Object.values(flexboxInterpolations),
    ...Object.values(flexitemInterpolations),
    ...Object.values(boxAlignmentInterpolations)
];
const styleInterpolations = mergeInterpolations(interpolations);
const Flex = ({ children, hasZeroMargins = true, ...props }) => {
    const flexComponentClasses = classNames([baseStyles, hasZeroMargins && marginZeroStyles]);
    const { class: cls, ...styles } = styleInterpolations(props);
    return (jsx("div", { class: `${flexComponentClasses} ${cls}`, style: styles, children: children }));
};

export { Flex as F, marginZeroStyles as m };
//# sourceMappingURL=Flex-47f90e61.js.map
