/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { g as gridInterpolations } from './grid-9167f9a2.js';
import { b as boxAlignmentInterpolations } from './boxalignment-3404f84f.js';
import { m as mergeInterpolations } from './mergeInterpolations-f71c7446.js';
import './GridStyles.styles.css';

var baseStyles = 'GridStyles_baseStyles__11rn47i0';

const interpolations = [
    ...Object.values(gridInterpolations),
    ...Object.values(boxAlignmentInterpolations)
];
const styleInterpolations = mergeInterpolations(interpolations);
/**
 * An implicit grid. Resize your browser to see how items reflow.
 */
const Grid = ({ children, ...props }) => {
    const { class: cls, ...styles } = styleInterpolations(props);
    const allStyles = { ...styles };
    return (jsx("div", { class: `${baseStyles} ${cls}`, style: allStyles, children: children }));
};

export { Grid as G };
//# sourceMappingURL=Grid-ffd44650.js.map
