/* @oracle/oraclejet-preact: 16.0.1 */
import { jsxs, jsx } from 'preact/jsx-runtime';
import { Fragment } from 'preact';
import { B as BaseButton } from './BaseButton-f9e8c783.js';
import { B as ButtonLayout } from './ButtonLayout-af96cb96.js';
import { forwardRef } from 'preact/compat';
import { u as useTooltip } from './useTooltip-cb4418ec.js';
import 'preact/hooks';
import './Floating-9ce291ba.js';
import './TopLayerHost-d50e5624.js';
import './logger-c710d0a3.js';
import './TooltipContentStyles.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js';

const IconButton = forwardRef(({ variant = 'outlined', isDisabled = false, isRepeat = false, size = 'md', type: buttonType = 'button', autofocus, onAction, tooltip, testId, 'aria-label': accessibleLabel, 'aria-describedby': ariaDescribedBy, ...props }, ref) => {
    const { tooltipContent, tooltipProps } = useTooltip({
        text: tooltip ? tooltip : accessibleLabel,
        isDisabled
    });
    const elementDetails = {
        type: 'button',
        buttonType: buttonType
    };
    return (jsxs(Fragment, { children: [jsx(BaseButton, { ...tooltipProps, ref: ref, elementDetails: elementDetails, isDisabled: isDisabled, isRepeat: isRepeat, size: size, autofocus: autofocus, variant: variant, styling: ['min'], onAction: onAction, "aria-describedby": ariaDescribedBy, "aria-label": accessibleLabel ?? tooltip, testId: testId, children: jsx(ButtonLayout, { display: 'icons', startIcon: props.children, size: size }) }), tooltipContent] }));
});
IconButton.displayName = 'IconButton';

export { IconButton as I };
//# sourceMappingURL=IconButton-c8fafbab.js.map
