/* @oracle/oraclejet-preact: 16.0.1 */
import { jsxs, jsx } from 'preact/jsx-runtime';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import { I as InlineHelpSource } from './InlineHelpSource-51a11052.js';
import { UserAssistanceRedwoodTheme } from './UNSAFE_UserAssistance/themes/redwood/UserAssistanceTheme.js';

function InlineHelp({ assistiveText, sourceLink, sourceText }) {
    const { styles: { helpTextStyles } } = useComponentTheme(UserAssistanceRedwoodTheme);
    return (jsxs("div", { children: [assistiveText && sourceLink ? (jsx("span", { class: helpTextStyles, children: assistiveText })) : (assistiveText), sourceLink && jsx(InlineHelpSource, { source: sourceLink, children: sourceText })] }));
}

export { InlineHelp as I };
//# sourceMappingURL=InlineHelp-c2b08216.js.map
