/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { c as classNames } from './classNames-2e96f1d4.js';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import './TabbableModeContext-1e03f32d.js';
import { u as useTabbableMode } from './useTabbableMode-9c5d5a64.js';
import { u as useTranslationBundle } from './useTranslationBundle-95f6039e.js';
import { UserAssistanceRedwoodTheme } from './UNSAFE_UserAssistance/themes/redwood/UserAssistanceTheme.js';

function InlineHelpSource({ children, source }) {
    const translations = useTranslationBundle('@oracle/oraclejet-preact');
    const userAssistance_learnMoreStr = translations.userAssistance_learnMore();
    children = children ?? userAssistance_learnMoreStr;
    // JET-52914 - Implement Tabbable mode API contract in InputText
    // if not tabbable, spread tabbableModeProps on component
    const { isTabbable, tabbableModeProps } = useTabbableMode();
    // TODO: Implement and use a preact Link component instead of using an anchor tag
    const { classes, styles } = useComponentTheme(UserAssistanceRedwoodTheme);
    const { helpSourceStyles } = styles; // TODO: refactor types so inferring works properly
    return (jsx("a", { class: classNames([classes, helpSourceStyles]), target: "_blank", href: source, ...(!isTabbable && tabbableModeProps), children: children }));
}

export { InlineHelpSource as I };
//# sourceMappingURL=InlineHelpSource-51a11052.js.map
