/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx, jsxs } from 'preact/jsx-runtime';
import { useState, useCallback } from 'preact/compat';
import { L as LayerContext, a as LayerHost, T as TopLayerHost } from './TopLayerHost-d50e5624.js';

function LayerManager({ children }) {
    const [defaultHost, setDefaultHost] = useState();
    const [defaultTopHost, setDefaultTopHost] = useState();
    //const context = useContext(LayerContext);
    const defaultHostRef = useCallback((el) => {
        // ref callbacks fire after the component has been unnmounted so we do not
        // want to set state in this use-case
        if (el !== null) {
            setDefaultHost(el);
        }
    }, []);
    const defaultTopHostRef = useCallback((el) => {
        // ref callbacks fire after the component has been unnmounted so we do not
        // want to set state in this use-case
        if (el !== null) {
            setDefaultTopHost(el);
        }
    }, []);
    return (jsx(LayerContext.Consumer, { children: (value) => {
            let defaultHostContext = {};
            if (defaultHost && defaultTopHost) {
                defaultHostContext = {
                    priority: undefined,
                    getHost: (priority) => {
                        return priority === 'top' ? defaultTopHost : defaultHost;
                    }
                };
            }
            const layerContext = value.getHost ? value : defaultHostContext;
            return (jsxs(LayerContext.Provider, { value: layerContext, children: [children, !value.getHost && jsx(LayerHost, { ref: defaultHostRef }), !value.getHost && jsx(TopLayerHost, { ref: defaultTopHostRef })] }));
        } }));
}

export { LayerManager as L };
//# sourceMappingURL=LayerManager-587f5086.js.map
