/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { c as classNames } from './classNames-2e96f1d4.js';
import { u as usePress } from './usePress-6e2cde1b.js';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import { u as useInteractionStyle } from './useInteractionStyle-43b76a9a.js';
import { LinkRedwoodTheme } from './UNSAFE_Link/themes/redwood/LinkTheme.js';
import './TabbableModeContext-1e03f32d.js';
import { u as useTabbableMode } from './useTabbableMode-9c5d5a64.js';
import { u as useTestId } from './useTestId-5050f73e.js';

const noop = () => { };
function Link({ href, variant, placement = 'standalone', target, testId, 'aria-describedby': ariaDescribedBy, 'aria-label': accessibleLabel, 'aria-labelledby': ariaLabelledBy, children, onClick }) {
    const { interactionProps, applyPseudoHoverStyle, applyHoverStyle } = useInteractionStyle();
    const { classes } = useComponentTheme(LinkRedwoodTheme, {
        needsEventsHover: applyHoverStyle ? 'isNeedsEventsHover' : 'notNeedsEventsHover',
        pseudoHover: applyPseudoHoverStyle ? 'isPseudoHover' : 'notPseudoHover',
        variant,
        placement
    });
    const { isTabbable } = useTabbableMode();
    const linkClasses = classNames([classes]);
    const { pressProps } = usePress(onClick ?? noop);
    const testIdProps = useTestId(testId);
    return (jsx("a", { tabIndex: isTabbable ? 0 : -1, href: href, "aria-describedby": ariaDescribedBy, "aria-label": accessibleLabel, "aria-labelledby": ariaLabelledBy, target: target, ...pressProps, ...interactionProps, ...testIdProps, class: linkClasses, children: children }));
}

export { Link as L };
//# sourceMappingURL=Link-2d28cb94.js.map
