/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { L as List } from './List-6478f583.js';

function ListView(props) {
    const dataMetadata = props.data
        ? props.data.map((aData) => {
            const key = props.getRowKey(aData);
            return { data: aData, metadata: { key } };
        })
        : null;
    const loadRange = props.onLoadMore ? props.onLoadMore : () => { };
    const dataState = dataMetadata
        ? {
            offset: 0,
            data: dataMetadata,
            sizePrecision: props.hasMore ? 'atLeast' : 'exact',
            totalSize: dataMetadata.length
        }
        : null;
    return (jsx(List, { isVirtualized: false, ...props, onLoadRange: loadRange, data: dataState, children: props.children }));
}

export { ListView as L };
//# sourceMappingURL=ListView-491a4b67.js.map
