/* @oracle/oraclejet-preact: 16.0.1 */
import { jsxs, jsx } from 'preact/jsx-runtime';
import { Fragment } from 'preact';
import { u as useDebounce } from './useDebounce-8a4ac77f.js';
import { u as useTranslationBundle } from './useTranslationBundle-95f6039e.js';
import { L as LiveRegion } from './LiveRegion-7a899eb4.js';

const MAX_LENGTH_UPDATE_DELAY = 500;
function MaxLengthLiveRegion({ isMaxLengthExceeded, maxLength, valueLength = 0 }) {
    // Comment copied from InputBase.js in Big JET:
    // Only update the aria-live div when the user has paused for more than
    // 500 milliseconds. That way, we avoid queued up aria-live messages which
    // would be annoying and not helpful. The 500ms was agreed upon in the
    // accessibility review meeting.
    const debouncedRemainingChars = useDebounce(maxLength - valueLength, MAX_LENGTH_UPDATE_DELAY);
    const translations = useTranslationBundle('@oracle/oraclejet-preact');
    const maxLengthExceededTranslatedString = translations.formControl_maxLengthExceeded({
        MAX_LENGTH: `${maxLength}`
    });
    const remainingCharsTranslatedString = translations.formControl_maxLengthRemaining({
        CHARACTER_COUNT: `${debouncedRemainingChars}`
    });
    return (jsxs(Fragment, { children: [jsx(LiveRegion, { children: remainingCharsTranslatedString }), isMaxLengthExceeded && (jsx(LiveRegion, { type: "assertive", children: maxLengthExceededTranslatedString }))] }));
}

export { MaxLengthLiveRegion as M };
//# sourceMappingURL=MaxLengthLiveRegion-8cac0154.js.map
