/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { S as SvgClose } from './Close-9a71cae3.js';
import { I as IconButton } from './IconButton-c8fafbab.js';
import { u as useTranslationBundle } from './useTranslationBundle-95f6039e.js';
import { c as classNames } from './classNames-2e96f1d4.js';
import { messageCloseButtonStyles } from './PRIVATE_Message/themes/MessageStyles.css.js';

/**
 * A Component for rendering the message close button
 */
function MessageCloseButton({ onAction, variant = 'banner' }) {
    const translations = useTranslationBundle('@oracle/oraclejet-preact');
    const renderedButton = (jsx(IconButton, { "aria-label": translations.message_close(), size: "sm", variant: "borderless", onAction: onAction, children: jsx(SvgClose, {}) }));
    // TODO:  Refactor to utilize useComponentTheme and multiVariantStyles.
    const classes = classNames([messageCloseButtonStyles.base, messageCloseButtonStyles[variant]]);
    // Otherwise, render the close icon
    return (jsx("div", { class: classes, "data-oj-message-close-button": "", children: renderedButton }));
}

export { MessageCloseButton as M };
//# sourceMappingURL=MessageCloseButton-b61132f8.js.map
