/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { c as classNames } from './classNames-2e96f1d4.js';
import { messageSummaryStyles } from './PRIVATE_Message/themes/MessageStyles.css.js';

/**
 * Summary Component for rendering the summary text of the Message
 */
function MessageSummary({ text, variant = 'banner' }) {
    // If detail content is rendered, then wrap it in a div with specified style classes
    // TODO:  Refactor to utilize useComponentTheme and multiVariantStyles.
    const classes = classNames([messageSummaryStyles.base, messageSummaryStyles[variant]]);
    return (jsx("div", { role: "heading", class: classes, children: text }));
}

export { MessageSummary as M };
//# sourceMappingURL=MessageSummary-ede2d018.js.map
