/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { c as classNames } from './classNames-2e96f1d4.js';
import { messageTimestampStyles } from './PRIVATE_Message/themes/MessageStyles.css.js';
import { f as formatTimestamp } from './MessageFormattingUtils-56752721.js';

/**
 * Timestamp Component for rendering timestamp in Message
 */
function MessageTimestamp({ value, variant = 'banner' }) {
    // If detail content is rendered, then wrap it in a div with specified style classes
    // TODO:  Refactor to utilize useComponentTheme and multiVariantStyles.
    const classes = classNames([messageTimestampStyles[variant]]);
    // Otherwise, render the timestamp
    const formattedTimestamp = formatTimestamp(value);
    return jsx("div", { class: classes, children: formattedTimestamp });
}

export { MessageTimestamp as M };
//# sourceMappingURL=MessageTimestamp-a1fb08b3.js.map
