/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { useCallback } from 'preact/hooks';
import { u as useHover } from './useHover-693303bd.js';
import { S as SvgClose } from './Close-9a71cae3.js';
import { F as Flex } from './Flex-47f90e61.js';
import { m as mergeInterpolations } from './mergeInterpolations-f71c7446.js';
import { f as flexitemInterpolations } from './flexitem-139efd0e.js';
import { u as useTabBarContext } from './useTabBarContext-3f91c830.js';
import { B as BaseTabBarItem } from './TabBarItem-cb805a59.js';
import { u as useTranslationBundle } from './useTranslationBundle-95f6039e.js';
import { E as EmbeddedIconButton } from './EmbeddedIconButton-842ffa85.js';

function RemovableTabBarItem({ itemKey, label, icon, badge, metadata, severity }) {
    const { selection, currentKey, layout, onRemove } = useTabBarContext();
    const isSelected = selection === itemKey;
    const isCurrent = currentKey === itemKey;
    const handleRemove = useCallback(() => {
        onRemove?.({ value: itemKey });
    }, [onRemove, itemKey]);
    const { hoverProps, isHover } = useHover({});
    //instead of specifying flex: '1 0 auto' in cssProps var
    const styleInterpolations = mergeInterpolations([
        ...Object.values(flexitemInterpolations)
    ]);
    const flexDimensions = styleInterpolations({
        flex: layout === 'stretch' ? '1 0 auto' : '0 0 auto'
    });
    const translations = useTranslationBundle('@oracle/oraclejet-preact');
    //TODO: In addition to aria-label a genric instruction is required for keyboard deletion
    //common to al tabs,after feedback from Curt's investigations.
    return (jsx("div", { ...hoverProps, style: flexDimensions, children: jsx(Flex, { children: jsx(BaseTabBarItem, { itemKey: itemKey, label: label, icon: icon, badge: badge, metadata: metadata, severity: severity, removeIcon: jsx("span", { "data-oj-tabbar-item-remove-icon": "true", children: jsx(EmbeddedIconButton, { "aria-label": translations.tabBarNavigationList_removeCueText(), size: "xs", onAction: handleRemove, children: (isHover || isSelected || isCurrent) && jsx(SvgClose, {}) }) }) }) }) }));
}

export { RemovableTabBarItem as R };
//# sourceMappingURL=RemovableTabBarItem-3a5937d0.js.map
