/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { c as classNames } from './classNames-2e96f1d4.js';
import { d as dimensionInterpolations } from './dimensions-d9512d9e.js';
import { m as mergeInterpolations } from './mergeInterpolations-f71c7446.js';
import { b as borderInterpolations } from './borders-b3ecc067.js';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import { SkeletonRedwoodTheme } from './UNSAFE_Skeleton/themes/redwood/SkeletonTheme.js';

const dimensions = ['height', 'width'];
const border = ['borderRadius'];
// Create an array [dimensionInterpolations['height'], dimensionInterpolations['width']]
const skeletonDimensionInterpolation = Array.from(dimensions, (x) => dimensionInterpolations[x]);
const borderRadiusInterpolation = Array.from(border, (x) => borderInterpolations[x]);
const interpolations = [
    ...Object.values(borderRadiusInterpolation),
    ...Object.values(skeletonDimensionInterpolation)
];
const SkeletonInterpolations = mergeInterpolations(interpolations);
/**
 * Skeleton component allows the appropriate skeleton to be rendered based on the
 * property values
 **/
function Skeleton({ ...props }) {
    const { classes: skeletonBase } = useComponentTheme(SkeletonRedwoodTheme);
    const classes = classNames([skeletonBase]);
    const skeletonDimensions = SkeletonInterpolations({ width: '100%', borderRadius: 0, ...props });
    return jsx("div", { style: skeletonDimensions, class: classes });
}

export { Skeleton as S };
//# sourceMappingURL=Skeleton-337dbf71.js.map
