/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { useRef } from 'preact/hooks';
import './TopLayerHost-d50e5624.js';
import 'preact/compat';
import './UNSAFE_Text/themes/TextStyles.css.js';
import './Flex-47f90e61.js';
import { T as TabBarContext } from './useTabBarContext-3f91c830.js';
import './flexitem-139efd0e.js';
import './logger-c710d0a3.js';
import './TabBarItemStyles.styles.css';
import './UNSAFE_TabBarCommon/themes/redwood/TabBarItemBaseTheme.styles.css';
import './UNSAFE_TabBarCommon/themes/redwood/TabBarItemVariants.css.js';
import 'preact';
import './Floating-9ce291ba.js';
import './TooltipContentStyles.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js';
import './IconStyle.styles.css';
import './Modal-006abcf9.js';
import './WindowOverlayStyles.styles.css';
import './UNSAFE_WindowOverlay/themes/redwood/WindowOverlayBaseTheme.styles.css';
import './UNSAFE_WindowOverlay/themes/redwood/WindowOverlayVariants.css.js';
import './SheetStyles.styles.css';
import { T as TabBarLayout } from './TabBarLayout-c0b57c59.js';
import { styles } from './UNSAFE_TabBar/themes/TabBarStyles.css.js';
import { u as useTabBar } from './useTabBar-1403b23b.js';

function TabBar({ children, layout = 'stretch', display = 'standard', size = 'md', edge = 'top', selection, onSelect, onRemove }) {
    const rootRef = useRef(null);
    const { rootProps, tabBarContext } = useTabBar({
        class: styles.tabBarBase,
        edge: edge,
        onRemove,
        onSelect,
        ref: rootRef,
        selection,
        size,
        children
    });
    return (jsx(TabBarContext.Provider, { value: tabBarContext, children: jsx("div", { ...rootProps, children: jsx(TabBarLayout, { layout: layout, display: display, children: children }) }) }));
}

export { TabBar as T };
//# sourceMappingURL=TabBar-85583ce0.js.map
