/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { c as classNames } from './classNames-2e96f1d4.js';
import { m as mergeInterpolations } from './mergeInterpolations-f71c7446.js';
import { multiVariantStyles, styles } from './UNSAFE_Text/themes/TextStyles.css.js';

const interpolations = [
    ({ lineClamp }) => !lineClamp ? {} : { class: styles.lineClamp, webkitLineClamp: lineClamp }
];
const styleInterpolations = mergeInterpolations(interpolations);
function Text({ children, hyphens, size, truncation, variant = 'inherit', weight, overflowWrap = 'anywhere', ...props }) {
    const variantClasses = multiVariantStyles({
        hyphens,
        size,
        truncation,
        variant,
        weight,
        overflowWrap
    });
    const { class: interpolatedClasses, ...styles } = styleInterpolations(props);
    const classes = classNames([variantClasses, interpolatedClasses]);
    return (jsx("span", { class: classes, style: styles, id: props.id, children: children }));
}

export { Text as T };
//# sourceMappingURL=Text-ec0e2d47.js.map
