/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { u as useRovingTabIndexContainer } from './useRovingTabIndexContainer-ef5c8496.js';
import { T as TabbableModeContext } from './TabbableModeContext-1e03f32d.js';
import { u as useTabbableMode } from './useTabbableMode-9c5d5a64.js';
import { ToolbarRedwoodTheme } from './UNSAFE_Toolbar/themes/redwood/ToolbarTheme.js';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import { c as classNames } from './classNames-2e96f1d4.js';
import { styles } from './UNSAFE_Toolbar/themes/ToolbarSeparatorStyles.css.js';
import { S as Separator } from './Separator-e873d029.js';

const Toolbar = ({ 'aria-controls': ariaControls, 'aria-label': ariaLabel, children }) => {
    const { isTabbable } = useTabbableMode();
    const { focusedId, rovingTabIndexContainerProps } = useRovingTabIndexContainer(!isTabbable);
    const { classes, styles } = useComponentTheme(ToolbarRedwoodTheme);
    const toolbarClasses = classNames([classes, styles.base]);
    return (jsx("div", { "aria-controls": ariaControls, "aria-label": ariaLabel, class: toolbarClasses, role: "toolbar", ...rovingTabIndexContainerProps, children: jsx(TabbableModeContext.Provider, { value: { isTabbable: isTabbable, isRoving: true, focusedId: focusedId }, children: children }) }));
};

const ToolbarSeparator = () => {
    return (jsx("span", { class: styles.separatorBase, children: jsx(Separator, { orientation: "vertical" }) }));
};

export { Toolbar as T, ToolbarSeparator as a };
//# sourceMappingURL=ToolbarSeparator-1a5c3fef.js.map
