/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { useRef } from 'preact/hooks';
import { u as useSize } from './useSize-f3621361.js';

const TrackResizeContainer = ({ children, width, height }) => {
    const content = !isFixedLength(width) || !isFixedLength(height) ? (jsx(TrackResizeOnContainer, { width: width, height: height, children: children })) : (jsx("div", { style: { width, height }, children: children(fixedLengthToNumber(width), fixedLengthToNumber(height)) }));
    return content;
};
const TrackResizeOnContainer = ({ children, width, height }) => {
    const ref = useRef(null);
    const optionsRef = useRef({ box: 'border-box' });
    const size = useSize(ref, optionsRef.current);
    return (jsx("div", { ref: ref, style: { width, height }, children: size && children(size.width, size.height) }));
};
const isFixedLength = (length) => length.endsWith('px') || length === '0';
const fixedLengthToNumber = (length) => length === '0' ? 0 : Number(length.substring(0, length.length - 2));

export { TrackResizeContainer as T };
//# sourceMappingURL=TrackResizeContainer-24a9d2bc.js.map
