/* @oracle/oraclejet-preact: 16.0.1 */
import { jsxs, jsx } from 'preact/jsx-runtime';
import { forwardRef, useRef, useCallback, useImperativeHandle } from 'preact/compat';
import './logger-c710d0a3.js';
import './TabbableModeContext-1e03f32d.js';
import 'preact/hooks';
import { u as useId } from './useId-1bde71ab.js';
import './TopLayerHost-d50e5624.js';
import './UserAssistanceStyles.styles.css';
import './UNSAFE_UserAssistance/themes/redwood/UserAssistanceBaseTheme.styles.css';
import './UNSAFE_UserAssistance/themes/redwood/UserAssistanceVariants.css.js';
import { a as InlineUserAssistance } from './InlineUserAssistance-a843bead.js';
import './Flex-47f90e61.js';
import './MessageBannerStyles.styles.css';
import './UNSAFE_MessageBanner/themes/redwood/MessageBannerBaseTheme.styles.css';
import './UNSAFE_MessageBanner/themes/redwood/MessageBannerVariants.css.js';
import 'preact';
import './Floating-9ce291ba.js';
import './TooltipContentStyles.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js';
import './IconStyle.styles.css';
import './IconButton-c8fafbab.js';
import './MessageStyles.styles.css';
import './MessageFormattingUtils-56752721.js';
import './TransitionGroup-a51c7df7.js';
import './MessagesContext-d5efd74c.js';
import './HiddenAccessibleStyles.styles.css';
import './ComponentMessageStyles.styles.css';
import './UNSAFE_ComponentMessage/themes/redwood/ComponentMessageBaseTheme.styles.css';
import './UNSAFE_ComponentMessage/themes/redwood/ComponentMessageVariants.css.js';
import './FormFieldContext-dea4d4d7.js';
import './Popup-05f6a710.js';
import './UNSAFE_Separator/themes/SeparatorStyles.css.js';
import './LabelStyles.styles.css';
import './UNSAFE_Label/themes/redwood/LabelBaseTheme.styles.css';
import './UNSAFE_Label/themes/redwood/LabelVariants.css.js';
import './InputGroupContext-e6856c27.js';
import './UNSAFE_Popup/themes/redwood/PopupBaseTheme.styles.css';
import './UNSAFE_Popup/themes/redwood/PopupVariants.css.js';
import './FormContext-f5e6dd2a.js';
import { u as useFormContext } from './useFormContext-dcae8120.js';
import { C as CheckboxRadioContext } from './CheckboxRadioContext-660f410d.js';
import { C as CheckboxControl } from './CheckboxControl-b927cd2a.js';
import './Common/themes/redwood/theme.js';
import './Common/themes/themeContract.css.js';
import './vanilla-extract-recipes-createRuntimeFn.esm-8c3e2104.js';
import './ComponentMessageContainer-61ac850c.js';
import './MessagesManager-e48b17b1.js';
import './useAnimation-7d188187.js';
import './useMessagesContext-146fce68.js';
import './Transition-8263b057.js';
import './ComponentMessage-9f28981e.js';
import './useComponentTheme-7202d4c1.js';
import './MessageStartIcon-245107bf.js';
import './classNames-2e96f1d4.js';
import './SuccessS-fd0eaab1.js';
import './Icon-715e5a9e.js';
import './size-aa934024.js';
import './utils-4aa3c8ad.js';
import './colorUtils-30dc7d3f.js';
import './_curry1-b1d25277.js';
import './useTooltip-cb4418ec.js';
import './useTooltipControlled-fe816388.js';
import './Layer-c8a9c60e.js';
import './useThemeInterpolations-f5a207dc.js';
import './useColorScheme-daa151e2.js';
import './useScale-578a7ec2.js';
import './theme-651551cd.js';
import './Theme-99a9e50d.js';
import './mergeInterpolations-f71c7446.js';
import './_curry3-110d1c8b.js';
import './_curry2-3213c7b9.js';
import './_isObject-6f2350ae.js';
import './useHover-693303bd.js';
import './useToggle-7589399a.js';
import './useFocus-1c5b1863.js';
import './useTouch-c052c62f.js';
import './mergeProps-dfdba053.js';
import './useTestId-5050f73e.js';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentTheme.js';
import './hooks/UNSAFE_useTooltip/themes/TooltipContentStyles.css.js';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.css.js';
import './TooltipContentVariants.styles.css';
import './EnvironmentProvider-12bc1f90.js';
import './LayerManager-587f5086.js';
import './UNSAFE_Icon/themes/IconStyle.css.js';
import './ErrorS-a4c64c74.js';
import './InformationS-219d8de8.js';
import './WarningS-542fff95.js';
import './PRIVATE_Message/themes/MessageStyles.css.js';
import './useTranslationBundle-95f6039e.js';
import './MessageSummary-ede2d018.js';
import './MessageUtils-a7260514.js';
import './soundUtils-78333b4a.js';
import './HiddenAccessible-653c0211.js';
import './UNSAFE_ComponentMessage/themes/redwood/ComponentMessageTheme.js';
import './UNSAFE_ComponentMessage/themes/ComponentMessageStyles.css.js';
import './UNSAFE_ComponentMessage/themes/redwood/ComponentMessageBaseTheme.css.js';
import './useFormFieldContext-bc2595da.js';
import './InlineHelp-c2b08216.js';
import './InlineHelpSource-51a11052.js';
import './useTabbableMode-9c5d5a64.js';
import './UNSAFE_UserAssistance/themes/redwood/UserAssistanceTheme.js';
import './UNSAFE_UserAssistance/themes/UserAssistanceStyles.css.js';
import './UNSAFE_UserAssistance/themes/redwood/UserAssistanceBaseTheme.css.js';
import './useInputGroupContext-8405ef6c.js';
import './dimensions-d9512d9e.js';
import './boxalignment-3404f84f.js';
import './arrayUtils-bda0b35d.js';
import './boxalignment.styles.css';
import './vanilla-extract-sprinkles-createRuntimeSprinkles.esm-b8958164.js';
import './flexbox-6adb0f8d.js';
import './flexbox.styles.css';
import './flexitem-139efd0e.js';
import './flexitem.styles.css';
import './FlexStyles.styles.css';
import './MessageBannerVariants.styles.css';
import './useFloating-cec1aeb7.js';
import './useUser-6e653d84.js';
import './positionUtils-c728c841.js';
import './refUtils-54b2b0a5.js';
import './useOutsideClick-113d9979.js';
import './UNSAFE_Floating/themes/redwood/FloatingTheme.js';
import './UNSAFE_Floating/themes/FloatingStyles.css.js';
import './FloatingStyles.styles.css';
import './UNSAFE_Floating/themes/redwood/FloatingBaseTheme.css.js';
import './UNSAFE_Floating/themes/redwood/FloatingBaseTheme.styles.css';
import './UNSAFE_Floating/themes/redwood/FloatingVariants.css.js';
import './vanilla-extract-dynamic.esm-4479b60e.js';
import './UNSAFE_Floating/themes/FloatingContract.css.js';
import './BaseButton-f9e8c783.js';
import './usePress-6e2cde1b.js';
import './useActive-ac391e31.js';
import './clientHints-ee1c8473.js';
import './UNSAFE_BaseButton/themes/BaseButtonStyles.css.js';
import './BaseButtonStyles.styles.css';
import './ButtonLayout-af96cb96.js';
import './Text-ec0e2d47.js';
import './UNSAFE_Text/themes/TextStyles.css.js';
import './TextStyles.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js';
import './UNSAFE_ButtonLayout/themes/ButtonLayoutStyles.css.js';
import './ButtonLayoutStyles.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.css.js';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutVariants.css.js';
import './ButtonLayoutVariants.styles.css';
import './getLocale-5a4f2bcf.js';
import './stringUtils-8521231d.js';
import './Message.types-4c547b8f.js';
import './tabbableUtils-d03bccb0.js';
import './head-6177894e.js';
import './_arity-703022b9.js';
import './_isArray-7f64b525.js';
import './_isString-c97680cd.js';
import './FocusTrap-9a390118.js';
import './FocusTracker-5f9c7635.js';
import './PRIVATE_FocusTracker/themes/FocusTrackerStyles.css.js';
import './FocusTrackerStyles.styles.css';
import './Modal-006abcf9.js';
import './UNSAFE_Modal/themes/ModalStyles.css.js';
import './ModalStyles.styles.css';
import './useAnimationStatus-3a21db4b.js';
import './UNSAFE_Popup/themes/PopupContract.css.js';
import './UNSAFE_Popup/themes/redwood/PopupTheme.js';
import './UNSAFE_Popup/themes/redwood/PopupBaseTheme.css.js';
import './PopupStyles.styles.css';
import './SeparatorStyles.styles.css';
import './useFocusWithin-96e9acb0.js';
import './IconUserAssistance-92d12ea5.js';
import './Help-2f0be11a.js';
import './StyledCheckbox-68bddaad.js';
import './Check-07ab1aa9.js';
import './CheckboxOff-ef4c6fec.js';
import './CheckboxOn-de808e18.js';
import './CheckboxMixed-df4cf0ec.js';
import './UNSAFE_Checkbox/themes/CheckboxIconContract.css.js';
import './UNSAFE_Checkbox/themes/redwood/CheckboxIconTheme.js';
import './UNSAFE_Checkbox/themes/CheckboxIconStyles.css.js';
import './CheckboxIconStyles.styles.css';
import './UNSAFE_Checkbox/themes/redwood/CheckboxIconBaseTheme.css.js';
import './UNSAFE_Checkbox/themes/redwood/CheckboxIconBaseTheme.styles.css';
import './UNSAFE_Checkbox/themes/redwood/CheckboxIconVariants.css.js';
import './CheckboxIconVariants.styles.css';
import './UNSAFE_Checkbox/themes/redwood/CheckboxTheme.js';
import './UNSAFE_Checkbox/themes/CheckboxStyles.css.js';
import './CheckboxStyles.styles.css';
import './UNSAFE_Checkbox/themes/redwood/CheckboxBaseTheme.css.js';
import './UNSAFE_Checkbox/themes/redwood/CheckboxBaseTheme.styles.css';
import './UNSAFE_Checkbox/themes/redwood/CheckboxVariants.css.js';
import './CheckboxVariants.styles.css';
import './LayoutStyles.css-f4783df4.js';
import './LayoutStyles.styles.css';

/**
 * Checkbox is a single standalone checkbox control. It represents a boolean value.
 */
const Checkbox = forwardRef(({ 'aria-describedby': ariaDescribedBy, assistiveText, columnSpan, helpSourceLink, helpSourceText, isDisabled: propIsDisabled, isReadonly: propIsReadonly, isRequired = false, messages, onCommit, userAssistanceDensity: propUserAssistanceDensity, value: propValue, children }, ref = null) => {
    const { isDisabled: isFormDisabled, isReadonly: isFormReadonly, userAssistanceDensity: formUserAssistanceDensity } = useFormContext();
    const checkboxRef = useRef(null);
    const id = useId();
    // default to FormContext values if component properties are not specified
    const isDisabled = propIsDisabled ?? isFormDisabled;
    const isReadonly = propIsReadonly ?? isFormReadonly;
    const userAssistanceDensity = propUserAssistanceDensity ?? formUserAssistanceDensity;
    const isEditable = !isDisabled && !isReadonly;
    const bottomUaId = isEditable ? `${id}-bottom-ua` : undefined;
    const onChangeHandler = useCallback((e) => {
        // return early on keyup if key isn't spacebar
        const { key } = e;
        const hasKey = key !== undefined;
        if (hasKey && key !== ' ') {
            return;
        }
        const input = e.target;
        // While mouse clicking StyledCheckbox results in toggling the checked state on an input element, spacebar key events do not.
        // If it is a spacebar key event, we will return the toggled value of its current state.
        const value = hasKey ? !input.checked : input.checked;
        const previousValue = !!propValue;
        if (previousValue !== value) {
            onCommit({
                value,
                previousValue
            });
        }
    }, [onCommit, propValue]);
    useImperativeHandle(ref, () => ({
        focus: () => {
            !isDisabled && checkboxRef.current?.focus();
        },
        blur: () => {
            const activeElement = document.activeElement;
            checkboxRef.current === activeElement && activeElement.blur();
        }
    }));
    // TODO fix issue with tooltip and link in label
    // 
    return (jsxs(CheckboxRadioContext.Provider, { value: { isFocusRingShown: !isDisabled }, children: [jsx(CheckboxControl, { ...(isEditable
                    ? {
                        onChange: onChangeHandler,
                        onKeyUp: onChangeHandler
                    }
                    : {}), "aria-describedby": ariaDescribedBy, assistiveText: assistiveText, columnSpan: columnSpan, helpSourceLink: helpSourceLink, helpSourceText: helpSourceText, isChecked: propValue, isDisabled: isDisabled, isReadonly: isReadonly, isRequired: isRequired, ref: checkboxRef, children: children }), isEditable && (jsx(InlineUserAssistance, { id: bottomUaId, isRequiredShown: !!isRequired && !propValue, requiredAlignment: "start", messages: messages, userAssistanceDensity: userAssistanceDensity === 'reflow' ? userAssistanceDensity : 'efficient' }))] }));
});

export { Checkbox };
//# sourceMappingURL=UNSAFE_Checkbox.js.map
