/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx, jsxs } from 'preact/jsx-runtime';
import { Fragment } from 'preact';
import { useCallback, useState, useRef } from 'preact/hooks';
import { memo } from 'preact/compat';
import { c as classNames } from './classNames-2e96f1d4.js';
import { u as useId } from './useId-1bde71ab.js';
import { u as useTranslationBundle } from './useTranslationBundle-95f6039e.js';
import { c as containsKey, b as isSameKey } from './keys-d668880e.js';
import { H as HiddenAccessible } from './HiddenAccessible-653c0211.js';
import { S as SvgChevronDown } from './ChevronDown-132b6bbf.js';
import { C as CollapseIcon } from './CollapseIcon-0f656069.js';
import { L as LiveRegion } from './LiveRegion-7a899eb4.js';
import { u as useUser } from './useUser-6e653d84.js';
import { k as keyExtractor } from './collectionUtils-ed8b8b4c.js';
import { expanderStyle } from './UNSAFE_ExpandableList/themes/ExpandableListStyles.css.js';
import { B as Button } from './Button-70c707d8.js';
import { G as GROUP_SELECTOR, e as excludeGroup, a as GroupLoadingIndicator, L as ListGroupHeader } from './GroupLoadingIndicator-a32f6d3f.js';
import { L as List } from './List-6478f583.js';
import './TopLayerHost-d50e5624.js';
import './Common/themes/redwood/theme.js';
import './Common/themes/themeContract.css.js';
import './HiddenAccessibleStyles.styles.css';
import './Icon-715e5a9e.js';
import './size-aa934024.js';
import './utils-4aa3c8ad.js';
import './colorUtils-30dc7d3f.js';
import './_curry1-b1d25277.js';
import './useTooltip-cb4418ec.js';
import './useTooltipControlled-fe816388.js';
import './Floating-9ce291ba.js';
import './useFloating-cec1aeb7.js';
import './positionUtils-c728c841.js';
import './refUtils-54b2b0a5.js';
import './useOutsideClick-113d9979.js';
import './arrayUtils-bda0b35d.js';
import './useComponentTheme-7202d4c1.js';
import './logger-c710d0a3.js';
import './UNSAFE_Floating/themes/redwood/FloatingTheme.js';
import './UNSAFE_Floating/themes/FloatingStyles.css.js';
import './FloatingStyles.styles.css';
import './UNSAFE_Floating/themes/redwood/FloatingBaseTheme.css.js';
import './UNSAFE_Floating/themes/redwood/FloatingBaseTheme.styles.css';
import './UNSAFE_Floating/themes/redwood/FloatingVariants.css.js';
import './vanilla-extract-recipes-createRuntimeFn.esm-8c3e2104.js';
import './vanilla-extract-dynamic.esm-4479b60e.js';
import './UNSAFE_Floating/themes/FloatingContract.css.js';
import './Layer-c8a9c60e.js';
import './useThemeInterpolations-f5a207dc.js';
import './useColorScheme-daa151e2.js';
import './useScale-578a7ec2.js';
import './theme-651551cd.js';
import './Theme-99a9e50d.js';
import './mergeInterpolations-f71c7446.js';
import './_curry3-110d1c8b.js';
import './_curry2-3213c7b9.js';
import './_isObject-6f2350ae.js';
import './useHover-693303bd.js';
import './useToggle-7589399a.js';
import './useFocus-1c5b1863.js';
import './useTouch-c052c62f.js';
import './mergeProps-dfdba053.js';
import './useAnimation-7d188187.js';
import './useTestId-5050f73e.js';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentTheme.js';
import './hooks/UNSAFE_useTooltip/themes/TooltipContentStyles.css.js';
import './TooltipContentStyles.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.css.js';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js';
import './TooltipContentVariants.styles.css';
import './EnvironmentProvider-12bc1f90.js';
import './LayerManager-587f5086.js';
import './UNSAFE_Icon/themes/IconStyle.css.js';
import './IconStyle.styles.css';
import './ChevronLeft-9edee749.js';
import './withDirectionIcon-5db205de.js';
import './LiveRegionStyles.styles.css';
import './clientHints-ee1c8473.js';
import './ExpandableListStyles.styles.css';
import './BaseButton-f9e8c783.js';
import './usePress-6e2cde1b.js';
import './useActive-ac391e31.js';
import './TabbableModeContext-1e03f32d.js';
import './useTabbableMode-9c5d5a64.js';
import './dimensions-d9512d9e.js';
import './UNSAFE_BaseButton/themes/BaseButtonStyles.css.js';
import './BaseButtonStyles.styles.css';
import './ButtonLayout-af96cb96.js';
import './Text-ec0e2d47.js';
import './UNSAFE_Text/themes/TextStyles.css.js';
import './TextStyles.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js';
import './UNSAFE_ButtonLayout/themes/ButtonLayoutStyles.css.js';
import './ButtonLayoutStyles.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.css.js';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutVariants.css.js';
import './ButtonLayoutVariants.styles.css';
import './useViewportIntersect-c6e24c15.js';
import './useInteractionStyle-43b76a9a.js';
import './flexitem-139efd0e.js';
import './flexitem.styles.css';
import './vanilla-extract-sprinkles-createRuntimeSprinkles.esm-b8958164.js';
import './PRIVATE_List/themes/ListStyles.css.js';
import './ImageVars.styles.css';
import './ListStyles.styles.css';
import './UNSAFE_GroupedList/themes/redwood/GroupedListTheme.js';
import './UNSAFE_GroupedList/themes/GroupedListStyles.css.js';
import './GroupedListStyles.styles.css';
import './UNSAFE_GroupedList/themes/redwood/GroupedListBaseTheme.css.js';
import './UNSAFE_GroupedList/themes/redwood/GroupedListBaseTheme.styles.css';
import './Flex-47f90e61.js';
import './boxalignment-3404f84f.js';
import './boxalignment.styles.css';
import './flexbox-6adb0f8d.js';
import './flexbox.styles.css';
import './FlexStyles.styles.css';
import './Skeleton-337dbf71.js';
import './borders-b3ecc067.js';
import './UNSAFE_Skeleton/themes/redwood/SkeletonTheme.js';
import './UNSAFE_Skeleton/themes/SkeletonStyles.css.js';
import './SkeletonStyles.styles.css';
import './UNSAFE_Skeleton/themes/redwood/SkeletonBaseTheme.css.js';
import './UNSAFE_Skeleton/themes/redwood/SkeletonBaseTheme.styles.css';
import './UNSAFE_Skeleton/themes/redwood/SkeletonVariants.css.js';
import './LoadMoreCollection-16698776.js';
import './Collection-43572f98.js';
import './VirtualizedCollection-21207e10.js';
import './FocusTrap-9a390118.js';
import './tabbableUtils-d03bccb0.js';
import './head-6177894e.js';
import './_arity-703022b9.js';
import './_isArray-7f64b525.js';
import './_isString-c97680cd.js';
import './FocusTracker-5f9c7635.js';
import './PRIVATE_FocusTracker/themes/FocusTrackerStyles.css.js';
import './FocusTrackerStyles.styles.css';
import './useSelection-dab6a441.js';
import './useCurrentKey-7e2e0e68.js';
import './useCollectionFocusRing-2fdcd077.js';
import './useTabbableModeSet-9bb10475.js';
import './useItemAction-62c293eb.js';
import './Selector-af4da171.js';
import './UNSAFE_Selector/themes/SelectorStyles.css.js';
import './SelectorStyles.styles.css';
import './StyledCheckbox-68bddaad.js';
import './Check-07ab1aa9.js';
import './CheckboxOff-ef4c6fec.js';
import './CheckboxOn-de808e18.js';
import './CheckboxMixed-df4cf0ec.js';
import './UNSAFE_Checkbox/themes/CheckboxIconContract.css.js';
import './UNSAFE_Checkbox/themes/redwood/CheckboxIconTheme.js';
import './UNSAFE_Checkbox/themes/CheckboxIconStyles.css.js';
import './CheckboxIconStyles.styles.css';
import './UNSAFE_Checkbox/themes/redwood/CheckboxIconBaseTheme.css.js';
import './UNSAFE_Checkbox/themes/redwood/CheckboxIconBaseTheme.styles.css';
import './UNSAFE_Checkbox/themes/redwood/CheckboxIconVariants.css.js';
import './CheckboxIconVariants.styles.css';
import './ImageVars.css-21c6b0f7.js';
import './useTheme-245a0165.js';
import './useCollectionGestureContext-c7405ab9.js';
import './Menu-98442964.js';
import './MenuItem-b7f51744.js';
import './UNSAFE_Menu/themes/redwood/MenuItemTheme.js';
import './UNSAFE_Menu/themes/MenuItemStyles.css.js';
import './MenuItemStyles.styles.css';
import './UNSAFE_Menu/themes/redwood/MenuItemBaseTheme.css.js';
import './UNSAFE_Menu/themes/redwood/MenuItemBaseTheme.styles.css';
import './UNSAFE_Menu/themes/redwood/MenuItemVariants.css.js';
import './MenuItemVariants.styles.css';
import './UNSAFE_Menu/themes/MenuStyles.css.js';
import './MenuStyles.styles.css';
import './UNSAFE_Menu/themes/DropdownMenuStyles.css.js';
import './DropdownMenuStyles.styles.css';
import './Modal-006abcf9.js';
import './UNSAFE_Modal/themes/ModalStyles.css.js';
import './ModalStyles.styles.css';
import './WindowOverlayStyles.styles.css';
import './UNSAFE_WindowOverlay/themes/redwood/WindowOverlayBaseTheme.styles.css';
import './UNSAFE_WindowOverlay/themes/redwood/WindowOverlayVariants.css.js';
import './useSheetSwipe-743b81a4.js';
import './SheetStyles.styles.css';
import './UNSAFE_Menu/themes/SheetMenuStyles.css.js';
import './SheetMenuStyles.styles.css';
import './SelectMenuGroupContext-b0fd7f84.js';
import './UNSAFE_Separator/themes/SeparatorStyles.css.js';
import './SeparatorStyles.styles.css';
import './MenuSeparatorStyles.styles.css';
import './UNSAFE_Menu/themes/redwood/MenuSeparatorBaseTheme.styles.css';
import './UNSAFE_Menu/themes/redwood/MenuSeparatorVariants.css.js';
import './useContextMenuGesture-0fba9aff.js';

/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
/**
 * A hook that handles mouse and keyboard gesture that toggles the expanded state.
 * @param keyExtractor
 * @param expanded
 * @param onToggle
 * @returns
 */
function useExpandCollapse(keyExtractor, expanded, onToggle) {
    const { direction } = useUser();
    const onClick = useCallback((event) => {
        handleToggle(event, keyExtractor, onToggle);
    }, [keyExtractor, onToggle]);
    const onKeyUp = useCallback((event) => {
        if (event.key === 'Enter' || event.key === ' ') {
            handleToggle(event, keyExtractor, onToggle);
        }
        else if (event.key === 'ArrowLeft' || event.key === 'ArrowRight') {
            const isRtl = direction === 'rtl';
            const isLeftArrow = event.key === 'ArrowLeft' && !isRtl;
            handleArrowKey(isLeftArrow, event.target, expanded, keyExtractor, onToggle);
            // arrow key might cause it to scroll horizontally
            event.preventDefault();
            event.stopPropagation();
        }
    }, [keyExtractor, onToggle, expanded, direction]);
    return onToggle ? { onClick, onKeyDown, onKeyUp } : {};
}
// prevent default (propagation) for keyDown to prevent scrolling the container
const onKeyDown = (event) => {
    if (event.key === 'Enter' || event.key === 'ArrowLeft' || event.key === 'ArrowRight') {
        event.preventDefault();
    }
};
const handleArrowKey = (isLeftArrow, target, expanded, keyExtractor, onToggle) => {
    const itemKey = keyExtractor(target);
    if (onToggle && itemKey) {
        const contains = containsKey(expanded, itemKey);
        if ((isLeftArrow && contains) || (!isLeftArrow && !contains)) {
            onToggle({ value: itemKey });
        }
    }
};
const handleToggle = (event, keyExtractor, onToggle) => {
    const itemKey = keyExtractor(event.target);
    if (onToggle && itemKey) {
        onToggle({ value: itemKey });
        if (event.type === 'click') {
            event.stopPropagation();
        }
    }
};

/**
 * An ExpandableList shows a two-level group of items where each group header can be expand or collapse.
 */
function ExpandableList({ children, currentKey, data, onSelectionChange, onToggle, ...props }) {
    const [statusText, setStatusText] = useState('');
    const translations = useTranslationBundle('@oracle/oraclejet-preact');
    const updateStateText = useCallback((detail) => {
        onToggle?.(detail);
        if (data) {
            const previouslyExpanded = containsKey(data?.expanded, detail.value);
            setStatusText(previouslyExpanded
                ? translations.expandableList_groupCollapse()
                : translations.expandableList_groupExpand());
            // we need to clear the live region text otherwise screenreader
            // won't read again if the content did not change the next time
            setTimeout(() => {
                setStatusText('');
            }, 1000);
        }
    }, [onToggle, data, translations]);
    const expandCollapseProps = useExpandCollapse((element) => {
        if (element.getAttribute('role') === 'treegrid') {
            return currentKey === undefined ? null : currentKey;
        }
        return keyExtractor(element, GROUP_SELECTOR);
    }, data == null ? emptyKeys : data.expanded, onToggle && updateStateText);
    const descId = useId();
    const stableDescIdRef = useRef(descId);
    const createHierarchicalContext = (context, options) => {
        const expanderRenderer = options !== undefined
            ? () => (jsx(Expander, { itemKey: context.metadata.key, expanded: options.expanded, onToggle: options.onToggle }))
            : undefined;
        return {
            ...context,
            parentKey: context.metadata.parentKey,
            leaf: context.metadata.isLeaf ?? true,
            depth: context.metadata.treeDepth ?? 1,
            expander: expanderRenderer
        };
    };
    const handleSelectionChange = useCallback((detail) => {
        if (onSelectionChange && data) {
            const keys = excludeGroup(data, detail.value);
            if (isSameKey(keys, detail.value)) {
                onSelectionChange(detail);
            }
            else if (keys.keys && keys.keys.size > 0) {
                onSelectionChange({ ...detail, value: keys });
            }
        }
    }, [onSelectionChange, data]);
    const customItemRenderer = (context) => {
        const itemKey = context.listItemContext.metadata.key;
        const options = data && onToggle ? { expanded: containsKey(data.expanded, itemKey), onToggle } : undefined;
        const itemContext = createHierarchicalContext(context.listItemContext, options);
        if (itemContext.leaf) {
            return context.defaultListItem(itemContext, { itemDepth: itemContext.depth + 1 });
        }
        else {
            return (jsx(ListGroupHeader, { ariaDescribedBy: stableDescIdRef.current, itemKey: itemContext.metadata.key, itemIndex: itemContext.index, itemDepth: itemContext.depth, isFocused: context.isFocused, isFocusRingVisible: context.isFocusRingVisible, isActive: context.isActive, isGridlineVisible: false, isExpandable: true, expandedKeys: data == null ? emptyKeys : data.expanded, onToggle: onToggle, children: children(itemContext) }, itemContext.metadata.key));
        }
    };
    return (jsxs(Fragment, { children: [jsx(List, { isVirtualized: false, currentKey: currentKey, data: data, role: "treegrid", loadingIndicator: jsx(GroupLoadingIndicator, {}), onSelectionChange: handleSelectionChange, customItemRenderer: customItemRenderer, ...props, ...expandCollapseProps, children: (context) => {
                    return children(context);
                } }), onToggle && (jsxs(Fragment, { children: [jsx(LiveRegion, { children: statusText }), jsx("span", { id: stableDescIdRef.current, children: jsx(HiddenAccessible, { children: translations.expandableList_expandCollapseInstructionText() }) })] }))] }));
}
const emptyKeys = { all: false, keys: new Set() };
const Expander = memo((props) => {
    const classes = classNames([expanderStyle, 'oj-listview-expander']);
    const actionHandler = () => {
        props.onToggle({ value: props.itemKey });
    };
    return (jsx("span", { class: classes, role: "presentation", children: jsx(Button, { onAction: actionHandler, variant: "ghost", startIcon: props.expanded ? jsx(SvgChevronDown, { size: "6x" }) : jsx(CollapseIcon, { size: "6x" }) }) }));
}, (prev, next) => {
    return (prev.itemKey === next.itemKey &&
        prev.expanded === next.expanded &&
        prev.onToggle === next.onToggle);
});

export { ExpandableList };
//# sourceMappingURL=UNSAFE_ExpandableList.js.map
