/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { a as assignInlineVars } from './vanilla-extract-dynamic.esm-4479b60e.js';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import { F as FormContext } from './FormContext-f5e6dd2a.js';
import { u as useFormContext } from './useFormContext-dcae8120.js';
import { styles } from './UNSAFE_FormLayout/themes/FormLayoutStyles.css.js';
export { compoundVariants, styles, variants } from './UNSAFE_FormLayout/themes/FormLayoutStyles.css.js';
import { l as layoutSpanStyles, a as layoutLocalVars } from './LayoutStyles.css-f4783df4.js';
import { FormLayoutRedwoodTheme } from './UNSAFE_FormLayout/themes/redwood/FormLayoutTheme.js';
import { c as classNames } from './classNames-2e96f1d4.js';
import './logger-c710d0a3.js';
import 'preact';
import 'preact/hooks';
import './LayoutStyles.styles.css';
import './FormLayoutStyles.styles.css';
import './UNSAFE_FormLayout/themes/redwood/FormLayoutBaseTheme.css.js';
import './UNSAFE_FormLayout/themes/redwood/FormLayoutBaseTheme.styles.css';
import './UNSAFE_FormLayout/themes/redwood/FormLayoutVariants.css.js';
import './FormLayoutVariants.styles.css';
import './vanilla-extract-recipes-createRuntimeFn.esm-8c3e2104.js';

const FormLayout = ({ columns = 1, columnBehavior = 'responsive', columnSpan = 1, direction = 'row', isFullWidth, isReadonly: propIsReadonly, labelEdge: propLabelEdge, labelStartWidth: propLabelStartWidth, labelWrapping: propLabelWrapping, userAssistanceDensity: propUserAssistanceDensity, children }) => {
    const { isDisabled, isFormLayout: formIsFormLayout, isReadonly: isFormReadonly, labelEdge: formLabelEdge, labelStartWidth: formLabelStartWidth, labelWrapping: formLabelWrapping, textAlign, userAssistanceDensity: formUserAssistanceDensity } = useFormContext();
    const isReadonly = propIsReadonly ?? isFormReadonly;
    const labelEdge = propLabelEdge ?? formLabelEdge;
    const labelStartWidth = propLabelStartWidth ?? formLabelStartWidth;
    const labelWrapping = propLabelWrapping ?? formLabelWrapping;
    // If we have the prop, pass it on, or if we are in a form layout, use the context value, otherwise default to 'efficient'
    const userAssistanceDensity = propUserAssistanceDensity ?? (formIsFormLayout ? formUserAssistanceDensity : 'efficient');
    // We need to set the localVars.columnCount so that we can correctly set the max width to the current column count
    const assignVarStyles = assignInlineVars({
        [layoutLocalVars.columnCount]: `${columns}`
    });
    const { baseTheme, classes } = useComponentTheme(FormLayoutRedwoodTheme, {
        columnBehavior,
        direction
    });
    return (jsx(FormContext.Provider, { value: {
            isDisabled,
            isFormLayout: true,
            isReadonly,
            labelEdge,
            labelStartWidth,
            labelWrapping,
            textAlign,
            userAssistanceDensity
        }, children: jsx("div", { class: classNames([
                baseTheme,
                styles.rootWrapperStyle,
                isFullWidth && styles.rootWrapperFullWidthStyle,
                layoutSpanStyles.layoutSpanColumn[columnSpan]
            ]), style: assignVarStyles, children: jsx("div", { class: classes, children: children }) }) }));
};

export { FormLayout };
//# sourceMappingURL=UNSAFE_FormLayout.js.map
