/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx, jsxs } from 'preact/jsx-runtime';
import { L as Label } from './Label-0d816f6b.js';
import { L as Link } from './Link-2d28cb94.js';
import { T as Text } from './Text-ec0e2d47.js';
import { u as useAccessibleContext } from './useAccessibleContext-335f736b.js';
import 'preact/hooks';
import './FormContext-f5e6dd2a.js';
import { u as useFormContext } from './useFormContext-dcae8120.js';
import './TabbableModeContext-1e03f32d.js';
import { t as textInterpolations } from './textAlign-28e187cf.js';
import { F as FormFieldContext } from './FormFieldContext-dea4d4d7.js';
import './logger-c710d0a3.js';
import './ReadonlyTextFieldInputStyles.styles.css';
import './UNSAFE_TextField/themes/redwood/ReadonlyTextFieldInputVariants.css.js';
import './TopLayerHost-d50e5624.js';
import 'preact/compat';
import { R as ReadonlyTextField } from './StyledTextField-6dcd9ff0.js';
import './Flex-47f90e61.js';
import './LabelValueLayoutStyles.styles.css';
import './SkeletonStyles.styles.css';
import './TextFieldLoadingStyles.styles.css';
import './TextFieldStyles.styles.css';
import './UNSAFE_TextField/themes/redwood/TextFieldBaseTheme.styles.css';
import './UNSAFE_TextField/themes/redwood/TextFieldVariants.css.js';
import './RadioStyles.styles.css';
import './UNSAFE_RadioItem/themes/redwood/RadioBaseTheme.styles.css';
import './UNSAFE_RadioItem/themes/redwood/RadioVariants.css.js';
import './LabelStyles.styles.css';
import './UNSAFE_Label/themes/redwood/LabelBaseTheme.styles.css';
import './UNSAFE_Label/themes/redwood/LabelVariants.css.js';
import './UNSAFE_TextField/themes/FormLayoutStyles.css.js';
import './UNSAFE_TextField/themes/redwood/FormLayoutBaseTheme.styles.css';
import './CheckboxStyles.styles.css';
import './UNSAFE_Checkbox/themes/redwood/CheckboxBaseTheme.styles.css';
import './UNSAFE_Checkbox/themes/redwood/CheckboxVariants.css.js';
import './InputGroupContext-e6856c27.js';
import './TextFieldInput-e919c820.js';
import 'preact';
import './LiveRegionStyles.styles.css';
import './UserAssistanceStyles.styles.css';
import './UNSAFE_UserAssistance/themes/redwood/UserAssistanceBaseTheme.styles.css';
import './UNSAFE_UserAssistance/themes/redwood/UserAssistanceVariants.css.js';
import { a as InlineUserAssistance } from './InlineUserAssistance-a843bead.js';
import './MessageBannerStyles.styles.css';
import './UNSAFE_MessageBanner/themes/redwood/MessageBannerBaseTheme.styles.css';
import './UNSAFE_MessageBanner/themes/redwood/MessageBannerVariants.css.js';
import './Floating-9ce291ba.js';
import './TooltipContentStyles.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js';
import './IconStyle.styles.css';
import './IconButton-c8fafbab.js';
import './MessageStyles.styles.css';
import './MessageFormattingUtils-56752721.js';
import './TransitionGroup-a51c7df7.js';
import './MessagesContext-d5efd74c.js';
import './HiddenAccessibleStyles.styles.css';
import './ComponentMessageStyles.styles.css';
import './UNSAFE_ComponentMessage/themes/redwood/ComponentMessageBaseTheme.styles.css';
import './UNSAFE_ComponentMessage/themes/redwood/ComponentMessageVariants.css.js';
import './Popup-05f6a710.js';
import './UNSAFE_Separator/themes/SeparatorStyles.css.js';
import './UNSAFE_Popup/themes/redwood/PopupBaseTheme.styles.css';
import './UNSAFE_Popup/themes/redwood/PopupVariants.css.js';
import { V as View } from './View-e580294d.js';
import { u as useTextField } from './useTextField-852e3d17.js';
import { H as HiddenAccessible } from './HiddenAccessible-653c0211.js';
import { c as classNames } from './classNames-2e96f1d4.js';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import { m as mergeInterpolations } from './mergeInterpolations-f71c7446.js';
import { LabelledLinkRedwoodTheme } from './UNSAFE_LabelledLink/themes/redwood/LabelledLinkTheme.js';
import './useFormFieldContext-bc2595da.js';
import './CompactLabelAssistance-96f797b7.js';
import './useTooltip-cb4418ec.js';
import './useTooltipControlled-fe816388.js';
import './useId-1bde71ab.js';
import './Layer-c8a9c60e.js';
import './useThemeInterpolations-f5a207dc.js';
import './useColorScheme-daa151e2.js';
import './useScale-578a7ec2.js';
import './theme-651551cd.js';
import './Theme-99a9e50d.js';
import './useHover-693303bd.js';
import './useToggle-7589399a.js';
import './useFocus-1c5b1863.js';
import './useTouch-c052c62f.js';
import './mergeProps-dfdba053.js';
import './useAnimation-7d188187.js';
import './useTestId-5050f73e.js';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentTheme.js';
import './hooks/UNSAFE_useTooltip/themes/TooltipContentStyles.css.js';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.css.js';
import './TooltipContentVariants.styles.css';
import './vanilla-extract-recipes-createRuntimeFn.esm-8c3e2104.js';
import './EnvironmentProvider-12bc1f90.js';
import './LayerManager-587f5086.js';
import './useTranslationBundle-95f6039e.js';
import './CompactHelpSource-d0d5c0bf.js';
import './useTabbableMode-9c5d5a64.js';
import './Help-2f0be11a.js';
import './Icon-715e5a9e.js';
import './size-aa934024.js';
import './utils-4aa3c8ad.js';
import './Common/themes/themeContract.css.js';
import './colorUtils-30dc7d3f.js';
import './_curry1-b1d25277.js';
import './UNSAFE_Icon/themes/IconStyle.css.js';
import './useFocusWithin-96e9acb0.js';
import './UNSAFE_UserAssistance/themes/UserAssistanceStyles.css.js';
import './UNSAFE_Label/themes/redwood/LabelTheme.js';
import './UNSAFE_Label/themes/LabelStyles.css.js';
import './UNSAFE_Label/themes/redwood/LabelBaseTheme.css.js';
import './UNSAFE_TextField/themes/redwood/TextFieldTheme.js';
import './UNSAFE_TextField/themes/TextFieldStyles.css.js';
import './UNSAFE_TextField/themes/redwood/TextFieldBaseTheme.css.js';
import './TextFieldVariants.styles.css';
import './usePress-6e2cde1b.js';
import './useInteractionStyle-43b76a9a.js';
import './clientHints-ee1c8473.js';
import './useActive-ac391e31.js';
import './UNSAFE_Link/themes/redwood/LinkTheme.js';
import './UNSAFE_Link/themes/LinkStyles.css.js';
import './LinkStyles.styles.css';
import './UNSAFE_Link/themes/redwood/LinkBaseTheme.css.js';
import './UNSAFE_Link/themes/redwood/LinkBaseTheme.styles.css';
import './UNSAFE_Link/themes/redwood/LinkVariants.css.js';
import './LinkVariants.styles.css';
import './UNSAFE_Text/themes/TextStyles.css.js';
import './TextStyles.styles.css';
import './text.styles.css';
import './vanilla-extract-sprinkles-createRuntimeSprinkles.esm-b8958164.js';
import './Common/themes/redwood/theme.js';
import './LabelValueLayout-f8d166a2.js';
import './UNSAFE_RadioItem/themes/redwood/RadioTheme.js';
import './UNSAFE_RadioItem/themes/RadioStyles.css.js';
import './UNSAFE_RadioItem/themes/redwood/RadioBaseTheme.css.js';
import './UNSAFE_TextField/themes/redwood/FormLayoutTheme.js';
import './UNSAFE_TextField/themes/redwood/FormLayoutBaseTheme.css.js';
import './UNSAFE_Checkbox/themes/redwood/CheckboxTheme.js';
import './UNSAFE_Checkbox/themes/CheckboxStyles.css.js';
import './UNSAFE_Checkbox/themes/redwood/CheckboxBaseTheme.css.js';
import './CheckboxVariants.styles.css';
import './useInputGroupContext-8405ef6c.js';
import './useUser-6e653d84.js';
import './UNSAFE_TextField/themes/redwood/ReadonlyTextFieldTheme.js';
import './UNSAFE_TextField/themes/ReadonlyTextFieldStyles.css.js';
import './ReadonlyTextFieldStyles.styles.css';
import './UNSAFE_TextField/themes/redwood/ReadonlyTextFieldVariants.css.js';
import './ReadonlyTextFieldVariants.styles.css';
import './LayoutStyles.css-f4783df4.js';
import './LayoutStyles.styles.css';
import './UNSAFE_Skeleton/themes/redwood/SkeletonTheme.js';
import './UNSAFE_Skeleton/themes/SkeletonStyles.css.js';
import './UNSAFE_Skeleton/themes/redwood/SkeletonBaseTheme.css.js';
import './UNSAFE_Skeleton/themes/redwood/SkeletonBaseTheme.styles.css';
import './UNSAFE_Skeleton/themes/redwood/SkeletonVariants.css.js';
import './dimensions-d9512d9e.js';
import './boxalignment-3404f84f.js';
import './arrayUtils-bda0b35d.js';
import './boxalignment.styles.css';
import './flexbox-6adb0f8d.js';
import './flexbox.styles.css';
import './flexitem-139efd0e.js';
import './flexitem.styles.css';
import './FlexStyles.styles.css';
import './useTextFieldInputHandlers-49c08f0e.js';
import './TextFieldUtils-7f8a8fb8.js';
import './UNSAFE_TextField/themes/redwood/TextFieldInputTheme.js';
import './UNSAFE_TextField/themes/TextFieldInputStyles.css.js';
import './TextFieldInputStyles.styles.css';
import './UNSAFE_TextField/themes/redwood/TextFieldInputVariants.css.js';
import './TextFieldInputVariants.styles.css';
import './ComponentMessageContainer-61ac850c.js';
import './MessagesManager-e48b17b1.js';
import './useMessagesContext-146fce68.js';
import './Transition-8263b057.js';
import './ComponentMessage-9f28981e.js';
import './MessageStartIcon-245107bf.js';
import './SuccessS-fd0eaab1.js';
import './ErrorS-a4c64c74.js';
import './InformationS-219d8de8.js';
import './WarningS-542fff95.js';
import './PRIVATE_Message/themes/MessageStyles.css.js';
import './MessageSummary-ede2d018.js';
import './MessageUtils-a7260514.js';
import './soundUtils-78333b4a.js';
import './UNSAFE_ComponentMessage/themes/redwood/ComponentMessageTheme.js';
import './UNSAFE_ComponentMessage/themes/ComponentMessageStyles.css.js';
import './UNSAFE_ComponentMessage/themes/redwood/ComponentMessageBaseTheme.css.js';
import './InlineHelp-c2b08216.js';
import './InlineHelpSource-51a11052.js';
import './UNSAFE_UserAssistance/themes/redwood/UserAssistanceTheme.js';
import './UNSAFE_UserAssistance/themes/redwood/UserAssistanceBaseTheme.css.js';
import './MessageBannerVariants.styles.css';
import './useFloating-cec1aeb7.js';
import './positionUtils-c728c841.js';
import './refUtils-54b2b0a5.js';
import './useOutsideClick-113d9979.js';
import './UNSAFE_Floating/themes/redwood/FloatingTheme.js';
import './UNSAFE_Floating/themes/FloatingStyles.css.js';
import './FloatingStyles.styles.css';
import './UNSAFE_Floating/themes/redwood/FloatingBaseTheme.css.js';
import './UNSAFE_Floating/themes/redwood/FloatingBaseTheme.styles.css';
import './UNSAFE_Floating/themes/redwood/FloatingVariants.css.js';
import './vanilla-extract-dynamic.esm-4479b60e.js';
import './UNSAFE_Floating/themes/FloatingContract.css.js';
import './BaseButton-f9e8c783.js';
import './UNSAFE_BaseButton/themes/BaseButtonStyles.css.js';
import './BaseButtonStyles.styles.css';
import './ButtonLayout-af96cb96.js';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js';
import './UNSAFE_ButtonLayout/themes/ButtonLayoutStyles.css.js';
import './ButtonLayoutStyles.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.css.js';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutVariants.css.js';
import './ButtonLayoutVariants.styles.css';
import './getLocale-5a4f2bcf.js';
import './stringUtils-8521231d.js';
import './Message.types-4c547b8f.js';
import './tabbableUtils-d03bccb0.js';
import './head-6177894e.js';
import './_arity-703022b9.js';
import './_curry3-110d1c8b.js';
import './_curry2-3213c7b9.js';
import './_isArray-7f64b525.js';
import './_isString-c97680cd.js';
import './FocusTrap-9a390118.js';
import './FocusTracker-5f9c7635.js';
import './PRIVATE_FocusTracker/themes/FocusTrackerStyles.css.js';
import './FocusTrackerStyles.styles.css';
import './Modal-006abcf9.js';
import './UNSAFE_Modal/themes/ModalStyles.css.js';
import './ModalStyles.styles.css';
import './useAnimationStatus-3a21db4b.js';
import './UNSAFE_Popup/themes/PopupContract.css.js';
import './UNSAFE_Popup/themes/redwood/PopupTheme.js';
import './UNSAFE_Popup/themes/redwood/PopupBaseTheme.css.js';
import './PopupStyles.styles.css';
import './SeparatorStyles.styles.css';
import './borders-b3ecc067.js';
import './colors-8cd7269e.js';
import './padding-532a6a4d.js';
import './aria-20ecc4ae.js';
import './equals-59b7179e.js';
import './_isObject-6f2350ae.js';
import './useMessageSeverity-3586ced7.js';
import './useFormFieldContextProps-a74f741a.js';
import './UNSAFE_LabelledLink/themes/LabelledLinkStyles.css.js';
import './LabelledLinkStyles.styles.css';
import './UNSAFE_LabelledLink/themes/redwood/LabelledLinkVariants.css.js';
import './LabelledLinkVariants.styles.css';

const HiddenLabel = ({ children, id }) => (jsx(HiddenAccessible, { isHidden: true, children: jsx(Label, { id: id, children: children }) }));

function useLabelledLinkAria({ 'aria-describedby': ariaDescribedBy, baseId, hasEmptyLabel, hasHiddenLabel, labelId: propLabelId }) {
    const containerId = `${baseId}--container`;
    const labelId = propLabelId ?? `${baseId}--hidden-label`;
    // JET-52089: add unsafe API for specifying an external label which is added to ariaLabelledBy on the input or div,
    // only when labelEdge is 'none' and label is ''. Since ariaLabelledBy takes precedence over all other
    // kinds of labels, this helps to ensure we don't override a meaningful label.
    const { UNSAFE_ariaLabelledBy } = useAccessibleContext();
    const ariaLabelledBy = classNames([
        labelId,
        hasEmptyLabel && hasHiddenLabel && UNSAFE_ariaLabelledBy,
        containerId
    ]);
    return {
        containerAria: {
            id: containerId
        },
        hiddenLabelAria: hasHiddenLabel
            ? {
                id: labelId
            }
            : {},
        linkAria: {
            'aria-describedby': ariaDescribedBy,
            'aria-labelledby': ariaLabelledBy
        }
    };
}

function useLabelledLinkTheme({ hasInsideLabel, isFormLayout, isFormReadonly, textAlign }) {
    // Style interpolations for text align
    const interpolations = [...Object.values(textInterpolations)];
    const styleInterpolations = mergeInterpolations(interpolations);
    // Calculate the style interpolation classes
    const { class: styleInterpolationClasses } = styleInterpolations({ textAlign });
    // Calculate the theme classes
    const { classes: themeClasses } = useComponentTheme(LabelledLinkRedwoodTheme, {
        formLayout: isFormLayout ? 'isFormLayout' : 'notFormLayout',
        readonlyForm: isFormReadonly ? 'isReadonlyForm' : 'notReadonlyForm',
        insideLabel: hasInsideLabel ? 'hasInsideLabel' : 'noInsideLabel'
    });
    // merge all the classes
    const classes = classNames([styleInterpolationClasses, themeClasses]);
    return { classes };
}

/**
 * LabelledLink component can be used to render a readonly form control field that
 * has a link for its content.
 */
const LabelledLink = ({ 'aria-describedby': ariaDescribedBy, children, columnSpan, href, label, labelEdge: propLabelEdge, labelStartWidth: propLabelStartWidth, onClick, target, textAlign: propTextAlign, userAssistanceDensity: propUserAssistanceDensity }) => {
    // Consume the form context to get the default values
    const { isFormLayout, isReadonly: isFormReadonly, labelEdge: formLabelEdge, labelStartWidth: formLabelStartWidth, textAlign: formTextAlign, userAssistanceDensity: formUserAssistanceDensity } = useFormContext();
    // default to FormContext values if component properties are not specified
    const labelEdge = propLabelEdge ?? formLabelEdge;
    const labelStartWidth = propLabelStartWidth ?? formLabelStartWidth;
    const textAlign = propTextAlign ?? formTextAlign;
    const userAssistanceDensity = propUserAssistanceDensity ?? formUserAssistanceDensity;
    // We will use the URL as text if the link text is not provided as a child
    const linkText = children ?? href;
    // Calculate the text field related props
    const { baseId, formFieldContext, labelProps, inputProps, userAssistanceProps } = useTextField({
        ariaDescribedBy,
        isReadonly: true,
        labelEdge,
        value: linkText
    });
    // Create the label component and the fieldLabelProps
    const labelComp = jsx(Label, { ...labelProps, children: label });
    const fieldLabelProps = {
        label: labelEdge !== 'none' ? labelComp : undefined,
        labelEdge: labelEdge !== 'none' ? labelEdge : undefined,
        labelStartWidth: labelEdge !== 'none' ? labelStartWidth : undefined
    };
    // save space for user assistance if density is 'efficient', even though we don't
    // render user assistance for readonly fields for now.
    const inlineUserAssistance = userAssistanceDensity === 'efficient' ? (jsx(InlineUserAssistance, { userAssistanceDensity: userAssistanceDensity, ...userAssistanceProps })) : undefined;
    // Get the theme classes
    const { classes } = useLabelledLinkTheme({
        hasInsideLabel: labelEdge === 'inside',
        isFormLayout,
        isFormReadonly,
        textAlign
    });
    // Get the aria props
    const hasEmptyLabel = label === '';
    const hasHiddenLabel = labelEdge === 'none';
    const { containerAria, hiddenLabelAria, linkAria } = useLabelledLinkAria({
        'aria-describedby': inputProps['aria-describedby'],
        baseId,
        hasEmptyLabel,
        hasHiddenLabel,
        labelId: labelProps.id
    });
    return (jsx(FormFieldContext.Provider, { value: formFieldContext, children: jsx(ReadonlyTextField, { columnSpan: columnSpan, role: "presentation", inlineUserAssistance: inlineUserAssistance, ...fieldLabelProps, children: jsxs("div", { class: classes, ...containerAria, children: [hasHiddenLabel && jsx(HiddenLabel, { ...hiddenLabelAria, children: label }), jsx(View, { width: "100%", children: jsx(Link, { href: href, target: target, onClick: onClick, ...linkAria, children: jsx(Text, { size: "md", variant: "inherit", children: linkText }) }) })] }) }) }));
};

export { LabelledLink };
//# sourceMappingURL=UNSAFE_LabelledLink.js.map
