/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx, jsxs } from 'preact/jsx-runtime';
import { useRef, useState, useCallback, useImperativeHandle, useEffect } from 'preact/hooks';
import { M as Message } from './Message-0c40f7cf.js';
import 'preact';
import './Floating-9ce291ba.js';
import 'preact/compat';
import './TopLayerHost-d50e5624.js';
import { c as classNames } from './classNames-2e96f1d4.js';
import { u as useComponentTheme } from './useComponentTheme-7202d4c1.js';
import { u as useTestId } from './useTestId-5050f73e.js';
import './TooltipContentStyles.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.styles.css';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentVariants.css.js';
import './IconStyle.styles.css';
import './IconButton-c8fafbab.js';
import { u as useTranslationBundle } from './useTranslationBundle-95f6039e.js';
import './MessageStyles.styles.css';
import './MessageFormattingUtils-56752721.js';
import { M as MessagesManager } from './MessagesManager-e48b17b1.js';
import { F as Flex } from './Flex-47f90e61.js';
import { g as getRenderer } from './MessageUtils-a7260514.js';
import { L as LiveRegion } from './LiveRegion-7a899eb4.js';
import { u as useMessageFocusManager } from './useMessagesFocusManager-16ca1631.js';
import { MessageBannerRedwoodTheme } from './UNSAFE_MessageBanner/themes/redwood/MessageBannerTheme.js';
import './timer-321e5430.js';
import './MessageCloseButton-b61132f8.js';
import './Close-9a71cae3.js';
import './Icon-715e5a9e.js';
import './size-aa934024.js';
import './utils-4aa3c8ad.js';
import './Common/themes/themeContract.css.js';
import './colorUtils-30dc7d3f.js';
import './_curry1-b1d25277.js';
import './useTooltip-cb4418ec.js';
import './useTooltipControlled-fe816388.js';
import './useId-1bde71ab.js';
import './Layer-c8a9c60e.js';
import './useThemeInterpolations-f5a207dc.js';
import './useColorScheme-daa151e2.js';
import './useScale-578a7ec2.js';
import './theme-651551cd.js';
import './Theme-99a9e50d.js';
import './mergeInterpolations-f71c7446.js';
import './_curry3-110d1c8b.js';
import './_curry2-3213c7b9.js';
import './_isObject-6f2350ae.js';
import './useHover-693303bd.js';
import './useToggle-7589399a.js';
import './useFocus-1c5b1863.js';
import './useTouch-c052c62f.js';
import './mergeProps-dfdba053.js';
import './useAnimation-7d188187.js';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentTheme.js';
import './hooks/UNSAFE_useTooltip/themes/TooltipContentStyles.css.js';
import './hooks/UNSAFE_useTooltip/themes/redwood/TooltipContentBaseTheme.css.js';
import './TooltipContentVariants.styles.css';
import './vanilla-extract-recipes-createRuntimeFn.esm-8c3e2104.js';
import './EnvironmentProvider-12bc1f90.js';
import './LayerManager-587f5086.js';
import './logger-c710d0a3.js';
import './UNSAFE_Icon/themes/IconStyle.css.js';
import './PRIVATE_Message/themes/MessageStyles.css.js';
import './MessageDetail-705c7312.js';
import './MessageStartIcon-245107bf.js';
import './SuccessS-fd0eaab1.js';
import './ErrorS-a4c64c74.js';
import './InformationS-219d8de8.js';
import './WarningS-542fff95.js';
import './MessageSummary-ede2d018.js';
import './MessageTimestamp-a1fb08b3.js';
import './useFloating-cec1aeb7.js';
import './useUser-6e653d84.js';
import './positionUtils-c728c841.js';
import './refUtils-54b2b0a5.js';
import './useOutsideClick-113d9979.js';
import './arrayUtils-bda0b35d.js';
import './UNSAFE_Floating/themes/redwood/FloatingTheme.js';
import './UNSAFE_Floating/themes/FloatingStyles.css.js';
import './FloatingStyles.styles.css';
import './UNSAFE_Floating/themes/redwood/FloatingBaseTheme.css.js';
import './UNSAFE_Floating/themes/redwood/FloatingBaseTheme.styles.css';
import './UNSAFE_Floating/themes/redwood/FloatingVariants.css.js';
import './vanilla-extract-dynamic.esm-4479b60e.js';
import './UNSAFE_Floating/themes/FloatingContract.css.js';
import './Common/themes/redwood/theme.js';
import './BaseButton-f9e8c783.js';
import './usePress-6e2cde1b.js';
import './useActive-ac391e31.js';
import './TabbableModeContext-1e03f32d.js';
import './useTabbableMode-9c5d5a64.js';
import './dimensions-d9512d9e.js';
import './clientHints-ee1c8473.js';
import './UNSAFE_BaseButton/themes/BaseButtonStyles.css.js';
import './BaseButtonStyles.styles.css';
import './ButtonLayout-af96cb96.js';
import './Text-ec0e2d47.js';
import './UNSAFE_Text/themes/TextStyles.css.js';
import './TextStyles.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutTheme.js';
import './UNSAFE_ButtonLayout/themes/ButtonLayoutStyles.css.js';
import './ButtonLayoutStyles.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.css.js';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutBaseTheme.styles.css';
import './UNSAFE_ButtonLayout/themes/redwood/ButtonLayoutVariants.css.js';
import './ButtonLayoutVariants.styles.css';
import './getLocale-5a4f2bcf.js';
import './stringUtils-8521231d.js';
import './Message.types-4c547b8f.js';
import './TransitionGroup-a51c7df7.js';
import './MessagesContext-d5efd74c.js';
import './useMessagesContext-146fce68.js';
import './Transition-8263b057.js';
import './boxalignment-3404f84f.js';
import './boxalignment.styles.css';
import './vanilla-extract-sprinkles-createRuntimeSprinkles.esm-b8958164.js';
import './flexbox-6adb0f8d.js';
import './flexbox.styles.css';
import './flexitem-139efd0e.js';
import './flexitem.styles.css';
import './FlexStyles.styles.css';
import './soundUtils-78333b4a.js';
import './LiveRegionStyles.styles.css';
import './UNSAFE_MessageBanner/themes/MessageBannerStyles.css.js';
import './MessageBannerStyles.styles.css';
import './UNSAFE_MessageBanner/themes/redwood/MessageBannerBaseTheme.css.js';
import './UNSAFE_MessageBanner/themes/redwood/MessageBannerBaseTheme.styles.css';
import './UNSAFE_MessageBanner/themes/redwood/MessageBannerVariants.css.js';
import './MessageBannerVariants.styles.css';

/**
 * Animation states for banner messages
 * TODO: Get this from theme context provider
 */
const animationStates = {
    entering: (node) => ({
        to: {
            maxHeight: `${node.scrollHeight}px`,
            overflow: 'hidden'
        },
        options: {
            duration: 250
        },
        end: {
            maxHeight: 'none',
            overflow: 'initial'
        }
    }),
    exiting: (node) => ({
        ...(node.style.maxHeight === 'none' && {
            from: {
                maxHeight: `${node.scrollHeight}px`,
                overflow: 'hidden'
            }
        }),
        to: {
            maxHeight: 0,
            overflow: 'hidden'
        },
        end: {
            maxHeight: 0,
            overflow: 'hidden'
        },
        options: {
            duration: 250
        }
    })
};
const initialAnimationStyles = {
    maxHeight: 0,
    overflow: 'hidden'
};
/**
 * Renders individual messages based on the provided data
 */
function MessageBanner({ detailRendererKey, data, onClose, renderers, testId, variant = 'section' }) {
    const testIdProps = useTestId(testId);
    // Keyboard Navigation and Focus Management
    const messagesRef = useRef(new Map());
    const containerDivRef = useRef(null);
    const focusHandleRef = useRef(null);
    const [liveRegionText, setLiveRegionText] = useState();
    const [shouldRender, setShouldRender] = useState(data.length > 0);
    const translations = useTranslationBundle('@oracle/oraclejet-preact');
    // We need a ref that holds the current & previous data length, as the exiting
    // node will always call handleNextFocus with previous data.
    // As in TransitionGroup, when an item is removed from the data, a new vnode
    // will not be created instead previous vnode will be used. So, the new handleNextFocus
    // will not be called when the old vnode exits. Thus, we will be using a ref
    // to always get the correct current data length.
    const dataLengthRef = useRef(data.length);
    const prevDataLengthRef = useRef(0);
    // Update the data length ref
    dataLengthRef.current = data.length;
    // We will be using a function based ref to store the refs in the Map
    const setMessageRef = useCallback(
    // TODO: use ramda.curry here (currently it is throwing ts error when used with generics)
    (key) => {
        return (ref) => messagesRef.current.set(key, ref);
    }, []);
    // Update the focusHandleRef
    useImperativeHandle(focusHandleRef, () => ({
        focus: () => {
            // Only trigger focus if the component is rendering messages
            if (data.length) {
                const firstItemKey = data[0].key;
                messagesRef.current.get(firstItemKey)?.focus();
                return true;
            }
            return false;
        },
        contains: (element) => {
            // Only invoke method if the component is rendering messages
            if (data.length && element) {
                return containerDivRef.current?.contains(element) ?? false;
            }
            return false;
        }
    }), [data]);
    // Register handlers for focus management
    const { controller, handlers } = useMessageFocusManager(focusHandleRef, {
        onFocus: useCallback(() => {
            setLiveRegionText(translations.message_navigationFromMessagesRegion());
        }, [setLiveRegionText, translations])
    });
    /**
     * Emits onClose event for the provided message.
     * @param item The message which the user tried to close
     */
    const handleClose = useCallback((item) => {
        onClose?.(item);
    }, [onClose]);
    /**
     * Handles focus when a message is closed and animated away from the DOM
     * @param key The key of the message
     * @param index The index of the message
     */
    const handleNextFocus = useCallback((_key, index, closedMessageNode) => {
        const isClosedMessageFocused = closedMessageNode?.contains(document.activeElement);
        // If there are no messages, do not render anything. As the old messages
        // are still in the DOM, use the data count to determine what to do next as it
        // represents the next state.
        if (dataLengthRef.current === 0) {
            setShouldRender(false);
            // If the current message holds focus, then restore previous focus
            if (isClosedMessageFocused) {
                controller.restorePriorFocus();
            }
            return;
        }
        // In TransitionGroup, when an item is removed from the data, a new vnode
        // will not be created instead previous vnode will be used. So, the new handleNextFocus
        // will not be called when the old vnode exits. Thus, all the deps will not be pointing to
        // the current references, rather they will be pointing to the ones where this vnode
        // last existed in the data.
        // This means, the data will contain the closing message as well. But, all the ref objects
        // still point to the most up-to-date values. With that in mind, we will be evaluating the
        // following values.
        const renderedMessagesCount = data.length;
        // Now that this message is closed, focus the next message that will take this index. If no
        // message will take this message's index, then it means that this is the last message. If
        // that is the case, focus the message at the previous index.
        // Use the count of the messages that are currently shown in the UI (current state including
        // the message that will be removed). This way we can get the correct item from the data
        // as it will contain the closing message as well.
        const nextMessageIndexToFocus = index + 1 < renderedMessagesCount ? index + 1 : index - 1;
        // if next message is available then transfer the focus to the next element
        if (nextMessageIndexToFocus > -1 && isClosedMessageFocused) {
            const nextMessageKey = data[nextMessageIndexToFocus].key;
            messagesRef.current.get(nextMessageKey)?.focus();
        }
    }, [controller, data]);
    // Prioritize this component whenever the data changes and
    // the new data has at least one message
    useEffect(() => {
        if (data.length) {
            // set state to render content whenever the data is not empty
            setShouldRender(true);
            if (data.length > prevDataLengthRef.current) {
                // Only when having a new message, update the aria-live area with the
                // text to indicate how to get the focus to the new message.
                setLiveRegionText(translations.message_navigationToMessagesRegion());
            }
            controller.prioritize();
        }
        else {
            // When there are no messages, clear the live region so that
            // the navigation text will be read when a new message appear
            setLiveRegionText('');
        }
        prevDataLengthRef.current = data.length;
    }, [controller, data, translations]);
    const { classes } = useComponentTheme(MessageBannerRedwoodTheme);
    // When both shouldRender flag is false and no data to render, do not render
    // anything
    if (!shouldRender && data.length === 0) {
        return null;
    }
    return (jsx("div", { ref: containerDivRef, class: classNames(['oj-c-messagebanner', classes]), tabIndex: -1, ...handlers, ...testIdProps, children: jsxs(Flex, { direction: "column", gap: variant === 'section' ? '1x' : undefined, children: [jsx(MessagesManager, { animationStates: animationStates, initialAnimationStyles: initialAnimationStyles, data: data, onMessageWillRemove: handleNextFocus, children: ({ item }) => (jsx(Message, { messageRef: setMessageRef(item.key), item: item, detailRenderer: getRenderer(item, detailRendererKey, renderers), variant: variant === 'page' ? 'pageBanner' : 'sectionBanner', onClose: handleClose }, item.key)) }), jsx(LiveRegion, { children: liveRegionText })] }) }));
}

export { MessageBanner };
//# sourceMappingURL=UNSAFE_MessageBanner.js.map
