/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { userSelectStyles, baseStyles } from './UNSAFE_VisStatusMessage/themes/VisStatusMessageStyles.css.js';
import { F as Flex } from './Flex-47f90e61.js';
import { c as classNames } from './classNames-2e96f1d4.js';
import { u as useTranslationBundle } from './useTranslationBundle-95f6039e.js';
import { g as getRandomId } from './LayoutUtils-ac96798e.js';

function VisStatusMessage({ children, ...otherProps }) {
    const itemClasses = classNames([otherProps.isSelectable ? '' : userSelectStyles, baseStyles]);
    return (jsx("div", { class: itemClasses, tabIndex: 0, "aria-label": otherProps['aria-label'], "aria-activedescendant": otherProps.activeId, children: jsx(Flex, { width: "100%", height: "100%", justify: "center", align: "center", children: children }) }));
}

function VisNoData(props) {
    const translations = useTranslationBundle('@oracle/oraclejet-preact');
    const noDataMsg = translations.dataVisualization_noData();
    const activeId = getRandomId();
    return (jsx(VisStatusMessage, { "aria-label": props['aria-label'], activeId: activeId, children: jsx("span", { id: activeId, children: noDataMsg }) }));
}

export { VisStatusMessage as V, VisNoData as a };
//# sourceMappingURL=VisNoData-bb310853.js.map
