/* @oracle/oraclejet-preact: 16.0.1 */
/**
 * Given a set of string arguments, join the values together into a string with
 * spaces. Falsey values will be omitted,
 * e.g. classNames(['A', 'B', false, 'D', false]) --> 'A B D'
 * @param values The set of values
 * @returns The values joined as a string, or blank string if no values
 */
function classNames(values) {
    return values.filter(Boolean).join(' ');
}

export { classNames as c };
//# sourceMappingURL=classNames-2e96f1d4.js.map
