/* @oracle/oraclejet-preact: 16.0.1 */
// Contains utility functions intended to be used to pick files
function pickFiles(callback, { accept = [], capture = 'none', selectionMode = 'single' }) {
    const input = createInput({ accept, capture, selectionMode });
    input.addEventListener('change', () => {
        callback(input.files);
    }, { once: true });
    input.click();
}
const createInput = (fileOptions) => {
    const input = document.createElement('input');
    input.type = 'file';
    if (fileOptions?.capture && fileOptions.capture != 'none') {
        input.capture = fileOptions.capture;
    }
    input.accept = fileOptions.accept.join(',');
    input.multiple = fileOptions.selectionMode === 'multiple';
    input.style.display = 'none';
    return input;
};

export { pickFiles as p };
//# sourceMappingURL=filePickerUtils-093b358d.js.map
