/* @oracle/oraclejet-preact: 16.0.1 */
export { u as useInteractionStyle } from '../useInteractionStyle-43b76a9a.js';
import '../mergeProps-dfdba053.js';
import '../clientHints-ee1c8473.js';
import '../useHover-693303bd.js';
import '../useToggle-7589399a.js';
import 'preact/hooks';
import '../useActive-ac391e31.js';

/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
/**
 * Collection of helper functions for writing your component styles in our theming system.
 * Pass in your style and it will return an object with the appropriate CSS selector wrapping it.
 */
const wrapWithActiveSelector = (style) => ({
    '&:active': style
});
const wrapWithHoverSelector = (style) => ({
    '&:hover': style
});
const wrapWithFocusSelector = (style) => ({
    '&:focus': style
});
const wrapWithFocusVisibleSelector = (style) => ({
    '&:focus-visible': style
});
const wrapWithVisitedSelector = (style) => ({
    '&:visited': style
});
const wrapWithNotActiveSelector = (style) => ({
    '&:not(:active)': style
});
const wrapWithParentNotActiveSelector = (style, parent) => ({
    [`${parent}:not(:active) > &`]: style
});
const wrapWithPseudoHoverSelector = (style) => ({
    '@media': {
        '(hover: hover)': {
            selectors: {
                '&:hover:not(:active)': style
            }
        }
    }
});
const wrapWithParentPseudoHoverSelector = (style, parent) => ({
    '@media': {
        '(hover: hover)': {
            selectors: {
                [`${parent}:hover:not(:active) > &`]: style
            }
        }
    }
});

export { wrapWithActiveSelector, wrapWithFocusSelector, wrapWithFocusVisibleSelector, wrapWithHoverSelector, wrapWithNotActiveSelector, wrapWithParentNotActiveSelector, wrapWithParentPseudoHoverSelector, wrapWithPseudoHoverSelector, wrapWithVisitedSelector };
//# sourceMappingURL=UNSAFE_useInteractionStyle.js.map
