/* @oracle/oraclejet-preact: 16.0.1 */
function assignRef(ref, value) {
    if (ref == null)
        return;
    if (typeof ref === 'function') {
        ref(value);
        return;
    }
    try {
        ref.current = value;
    }
    catch (error) {
        throw new Error(`Cannot assign value '${value}' to ref '${ref}'`);
    }
}
function mergeRefs(...refs) {
    return (node) => {
        refs.forEach((ref) => assignRef(ref, node));
    };
}

export { assignRef as a, mergeRefs as m };
//# sourceMappingURL=refUtils-54b2b0a5.js.map
