/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { render } from '@testing-library/preact';
import './TopLayerHost-d50e5624.js';
import { R as RootEnvironmentProvider } from './EnvironmentProvider-12bc1f90.js';
import bundle from './resources/nls/en/bundle.js';

const defaultEnvironment = {
    translations: { '@oracle/oraclejet-preact': bundle },
    mode: 'test'
};
const renderInEnv = (children, environment = defaultEnvironment, options) => {
    const mergedEnvironment = { ...environment };
    if (mergedEnvironment.translations == null) {
        mergedEnvironment.translations = {
            ...defaultEnvironment.translations
        };
    }
    const { rerender: _rerender, ...result } = render(jsx(RootEnvironmentProvider, { environment: mergedEnvironment, children: children }), options);
    const rerender = (children) => _rerender(jsx(RootEnvironmentProvider, { environment: mergedEnvironment, children: children }));
    return { rerender, ...result };
};

export { renderInEnv as r };
//# sourceMappingURL=render-b8c4d109.js.map
