/* @oracle/oraclejet-preact: 16.0.1 */
import { L as LIGHT_CLASS, C as COLORSCHEME_DEPENDENT_CLASS, S as SCALE_SM_CLASS, a as SCALE_MD_CLASS, b as SCALE_LG_CLASS, c as SCALE_DEPENDENT_CLASS, D as DARK_CLASS, I as INVERT_CLASS } from './Theme-99a9e50d.js';

const DARK_CLASSES = `${DARK_CLASS} ${INVERT_CLASS}`;
const themeInterpolations = {
    colorScheme: ({ colorScheme }) => colorScheme === undefined
        ? {}
        : {
            class: `${colorScheme === 'dark' ? DARK_CLASSES : LIGHT_CLASS} ${COLORSCHEME_DEPENDENT_CLASS}`
        },
    scale: ({ scale }) => scale === undefined
        ? {}
        : {
            class: `${scale === 'sm' ? SCALE_SM_CLASS : scale === 'md' ? SCALE_MD_CLASS : SCALE_LG_CLASS} ${SCALE_DEPENDENT_CLASS}`
        }
};

export { themeInterpolations as t };
//# sourceMappingURL=theme-651551cd.js.map
