/* @oracle/oraclejet-preact: 16.0.1 */
import { useContext } from 'preact/hooks';
import { createContext } from 'preact';

/**
 * Context used by the parent to pass accessibility related information.
 */
const AccessibleContext = createContext({
    UNSAFE_ariaLabelledBy: undefined
});

/**
 * Utility hook for consuming the AccessibleContext
 *
 * @returns The value of closest AccessibleContext provider
 */
function useAccessibleContext() {
    return useContext(AccessibleContext);
}

export { AccessibleContext as A, useAccessibleContext as u };
//# sourceMappingURL=useAccessibleContext-335f736b.js.map
