/* @oracle/oraclejet-preact: 16.0.1 */
import { useCallback, useEffect } from 'preact/hooks';
import { u as useToggle } from './useToggle-7589399a.js';

/**
 * A custom hook that handles showing/hiding clear icon
 */
function useClearIcon({ clearIcon, display, hasValue, isEnabled = true, isFocused = false, isHover = false }) {
    const shouldRenderClearIcon = useCallback(() => isEnabled &&
        (display === 'always' || (display === 'conditionally' && hasValue && (isFocused || isHover))), [display, hasValue, isEnabled, isFocused, isHover]);
    const { bool, setFalse, setTrue } = useToggle(shouldRenderClearIcon());
    useEffect(() => {
        shouldRenderClearIcon() ? setTrue() : setFalse();
    }, [shouldRenderClearIcon, setTrue, setFalse]);
    return bool ? clearIcon : null;
}

export { useClearIcon as u };
//# sourceMappingURL=useClearIcon-f24dd3af.js.map
