/* @oracle/oraclejet-preact: 16.0.1 */
import { u as useToggle } from './useToggle-7589399a.js';

/**
 * Get status on whether target has focus or not
 * @returns
 */
function useFocus(settings = { isDisabled: false }) {
    const { bool, setTrue, setFalse } = useToggle(false);
    const focusProps = settings.isDisabled
        ? {}
        : {
            onFocus: setTrue,
            onBlur: setFalse
        };
    return {
        isFocus: settings.isDisabled ? false : bool,
        focusProps: focusProps
    };
}

export { useFocus as u };
//# sourceMappingURL=useFocus-1c5b1863.js.map
