/* @oracle/oraclejet-preact: 16.0.1 */
import { useContext } from 'preact/hooks';
import { F as FormContext, D as DefaultFormContext } from './FormContext-f5e6dd2a.js';

/**
 * Utility hook for consuming the FormContext
 *
 * @returns The value of closest FormContext provider
 */
function useFormContext() {
    const context = useContext(FormContext);
    // merge the returned context into the default context so that all props are specified
    const contextWithDefaults = Object.assign({}, DefaultFormContext, context);
    return contextWithDefaults;
}

export { useFormContext as u };
//# sourceMappingURL=useFormContext-dcae8120.js.map
