/* @oracle/oraclejet-preact: 16.0.1 */
import { m as mergeProps } from './mergeProps-dfdba053.js';
import { u as useChartDataCursor } from './useChartDataCursor-cbef76df.js';
import { u as useChartDatatip } from './useChartDatatip-94529113.js';
import { g as getInfo } from './eventsUtils-fb41093b.js';
import './accUtils-7cc9e054.js';
import { u as useChartDrill } from './useChartDrill-03475437.js';
import { u as useSelection } from './useSelection-71f25938.js';

/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
function useChartDatatipAndCursor({ series, groups, width, height, findNearest, onDataCursorPositionChange, isDataCursorEnabled, dataCursorPosition, dataCursorStyle, hoveredItemInfo, focusedItemInfo, getDataItem, getDataItemPos, datatip, valueFormats, isHoriz, xScale, yScale, plotAreaSpace }) {
    const { datatipContent, datatipProps } = useChartDatatip({
        series,
        groups,
        width,
        height,
        isDataCursorEnabled,
        dataCursorPosition,
        hoveredItemInfo,
        getDataItem,
        getDataItemPos,
        focusedItemInfo,
        datatip,
        valueFormats,
        isHoriz,
        xScale,
        findNearest
    });
    const { dataCursorContent, dataCursorProps } = useChartDataCursor({
        findNearest,
        dataCursorPosition,
        onDataCursorPositionChange,
        isDataCursorEnabled,
        dataCursorStyle,
        isHoriz,
        focusedItemInfo,
        plotAreaSpace,
        yScale,
        xScale,
        getDataItemPos
    });
    return {
        datatipContent,
        dataCursorContent,
        datatipProps: mergeProps(dataCursorProps, datatipProps)
    };
}

/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
function useSelectDrill({ selectionMode, selection, onChange, rootRef, drilling, onItemDrill, onGroupDrill, focusedGroupInfo, focusedItemInfo, groups, getDataItem }) {
    const idExtracter = (event) => {
        const isItemFocused = focusedItemInfo.isCurrent;
        const info = isItemFocused && event.type === 'keyup' ? focusedItemInfo : getInfo(rootRef, event);
        return info && info.seriesIndex != null && info.groupIndex != null
            ? getDataItem(info.seriesIndex, info.groupIndex)?.id
            : undefined;
    };
    const selectionProps = useSelection({
        idExtracter,
        isDrillEnabled: drilling === 'on',
        selection,
        selectionMode,
        onChange
    });
    const drillProps = useChartDrill({
        rootRef,
        selectionMode,
        drilling,
        focusedItemInfo,
        focusedGroupInfo,
        groups,
        getDataItem,
        onItemDrill,
        onGroupDrill
    });
    return mergeProps(selectionProps, drillProps);
}

export { useSelectDrill as a, useChartDatatipAndCursor as u };
//# sourceMappingURL=useSelectDrill-25bce4e4.js.map
