/* @oracle/oraclejet-preact: 16.0.1 */
import { useState, useCallback } from 'preact/hooks';
import { u as useResizeObserver } from './useResizeObserver-f50e916e.js';

const useSize = (ref, resizeObserverOptions = { box: 'content-box' }) => {
    const [size, setSize] = useState();
    useResizeObserver({
        ref,
        callback: useCallback((entry) => {
            const boxSize = resizeObserverOptions.box === 'border-box' ? entry.borderBoxSize : entry.contentBoxSize;
            const newWidth = boxSize[0].inlineSize;
            const newHeight = boxSize[0].blockSize;
            setSize({ width: newWidth, height: newHeight });
        }, [resizeObserverOptions]),
        resizeObserverOptions
    });
    return size;
};

export { useSize as u };
//# sourceMappingURL=useSize-f3621361.js.map
