/* @oracle/oraclejet-preact: 16.0.1 */
import { u as useColorScheme } from './useColorScheme-daa151e2.js';
import { u as useScale } from './useScale-578a7ec2.js';
import { t as themeInterpolations } from './theme-651551cd.js';
import { m as mergeInterpolations } from './mergeInterpolations-f71c7446.js';
import { D as DefaultEnvironment } from './TopLayerHost-d50e5624.js';

/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
// This hook encasulates the logic required to determine which theme style classes are needed
// for the current environment context's colorScheme and scale value.  This would be used when
// rendering dom outside of the current dom tree, but desire to match the colorScheme and scale
// of the original dom tree.
function useThemeInterpolations() {
    const colorScheme = useColorScheme();
    const currentScale = useScale();
    // We don't want to interpolate the default environment values for scacle.  Those should get picked up by default.
    // This fixes an issue for core pack components that utilize the Layer component, when in a legacy cookbook page.
    const scale = currentScale !== DefaultEnvironment.scale ? currentScale : undefined;
    const interpolations = mergeInterpolations([...Object.values(themeInterpolations)]);
    const { class: classes } = interpolations({ colorScheme, scale });
    return classes;
}

export { useThemeInterpolations as u };
//# sourceMappingURL=useThemeInterpolations-f5a207dc.js.map
