/* @oracle/oraclejet-preact: 16.0.1 */
import { useState, useMemo } from 'preact/hooks';

/**
 * useToggle is a state toggle hook
 *
 * @param defaultValue
 * @returns
 */
function useToggle(defaultValue = false) {
    const [bool, setBool] = useState(defaultValue);
    const toggleHandlers = useMemo(() => {
        return {
            toggle: () => setBool((x) => !x),
            setTrue: () => setBool(true),
            setFalse: () => setBool(false)
        };
    }, []);
    return {
        bool,
        ...toggleHandlers
    };
}

export { useToggle as u };
//# sourceMappingURL=useToggle-7589399a.js.map
