/* @oracle/oraclejet-preact: 16.0.1 */
import { u as useToggle } from './useToggle-7589399a.js';

/**
 * Get status on whether target has touch or not
 * @returns
 */
function useTouch(settings = { isDisabled: false }) {
    const { bool, setTrue, setFalse } = useToggle(false);
    const touchProps = settings.isDisabled
        ? {}
        : {
            onTouchStart: setTrue,
            onTouchEnd: setFalse
        };
    return {
        isTouch: settings.isDisabled ? false : bool,
        touchProps: touchProps
    };
}

export { useTouch as u };
//# sourceMappingURL=useTouch-c052c62f.js.map
