/* @oracle/oraclejet-preact: 16.0.1 */
import { scaleVars } from './Common/themes/themeContract.css.js';
import { r as rgb$1 } from './colorUtils-30dc7d3f.js';

const rgb = (rgb) => rgb$1(rgb);
// TODO: create rgba function in PRIVATE_colorUtils
const rgba = (rgb, alpha) => `rgba(${rgb}, ${alpha})`;
// JET-59344 refactor of 'fallbackVar' from '@vanilla-extract/css'.
// directly importing the function was causing vanilla-extract to be bundled into
// the preact packages and causing issues with testing
const fallbackVar = (...values) => {
    const finalValue = values.reverse().reduce((acc, value) => {
        if (acc === '') {
            acc = String(value);
        }
        else {
            if (typeof value !== 'string' || !/^var\(--.*\)$/.test(value)) {
                throw new Error(`Invalid variable name: ${value}`);
            }
            acc = value.replace(/\)$/, `, ${acc})`);
        }
        return acc;
    }, '');
    return finalValue;
};
// For the default, where no scale var is specified, we use rem units, so that it will scale based on the root font-size.
const fallback = () => fallbackVar(scaleVars.size.units, '0.25rem');
const xUnits = (unit) => (unit === 1 ? fallback() : `calc(${unit} * ${fallback()})`);
const min = (val, minVal) => `min(${val},${minVal})`;
const max = (val, minVal) => `max(${val},${minVal})`;

export { rgba as a, max as b, fallbackVar as f, min as m, rgb as r, xUnits as x };
//# sourceMappingURL=utils-4aa3c8ad.js.map
