/* @oracle/oraclejet-preact: 16.0.1 */
import { jsx } from 'preact/jsx-runtime';
import { u as useUser } from './useUser-6e653d84.js';

// Returns a component that renders one of the given icon components based on reading direction
const withDirectionIcon = (LtrIcon, RtlIcon) => {
    return (props) => {
        const { direction } = useUser();
        return direction === 'ltr' ? jsx(LtrIcon, { ...props }) : jsx(RtlIcon, { ...props });
    };
};

export { withDirectionIcon as w };
//# sourceMappingURL=withDirectionIcon-5db205de.js.map
