/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { JSXInternal } from 'preact/src/jsx';
type SVGTextAttrs = JSXInternal.HTMLAttributes<SVGTextElement>;
type TickLabelInfo = {
    label: string;
    labelProps: {
        x: number;
        y: number;
        height: number;
        width: number;
    };
    index: number;
};
type TextProps = {
    text: string;
    style?: SVGTextAttrs['style'];
    textProps?: SVGTextAttrs & {
        'data-oj-object'?: string;
        'data-oj-group-index'?: string | number;
    };
    isInteractive?: boolean;
    id?: string;
    isTitle?: boolean;
};
type Props = {
    title?: string;
    titleStyle?: SVGTextAttrs['style'];
    titleProps?: SVGTextAttrs;
    tickLabels: TickLabelInfo[];
    tickLabelStyle?: SVGTextAttrs['style'];
    focusedGroupIndex?: number;
    isTextInteractive?: (index: number) => boolean;
    activeId?: string;
    axisPosition: 'left' | 'right' | 'top' | 'bottom';
};
/**
 * Renders the svg text with given style and svg attributes.
 */
export declare function SVGText({ text, style, textProps, isTitle, isInteractive, id }: TextProps): JSXInternal.Element;
/**
 * Renders the chart axis.
 */
export declare function Axis({ title, titleStyle, titleProps, tickLabels, tickLabelStyle, focusedGroupIndex, axisPosition, activeId, isTextInteractive }: Props): JSXInternal.Element;
export {};
