/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { AxisPosition, DataAxisProps, Dimension } from '../axis.types';
import { DataAxisInfo } from '../dataAxisInfo';
import type { useTextDimensions } from '../../hooks/PRIVATE_useTextDimensions';
type GetTextDimensions = NonNullable<ReturnType<typeof useTextDimensions>['getTextDimensions']>;
/**
 * The function that returns the y axis properties.
 * @param dataAxisInfo The DataAxisInfo.
 * @param dataAxis The dataAxis props.
 * @param groups The chart groups.
 * @param position The position of axis in the given space.
 * @param availSpace The available space.
 * @param isRtl Whether the reading direction is right to left.
 * @param getTextDimensions Function for text measurement.
 * @returns
 */
export declare function getDataAxisProps(position: AxisPosition, availSpace: Dimension, isRtl: boolean, dataAxis?: DataAxisProps, dataAxisInfo?: DataAxisInfo, axisFontSize?: string, getTextDimensions?: GetTextDimensions): {
    title: string | undefined;
    titleProps: {} | undefined;
    axisDim: number;
    tickLabels: {
        index: number;
        label: string;
        labelProps: import("../../hooks/PRIVATE_useTextDimensions").TextDimensions;
    }[];
    tickLabelStyle: {
        textAnchor: string;
        dominantBaseline: string;
        color?: import("csstype").Property.Color | undefined;
        fontSize: string | undefined;
        fontWeight?: string | undefined;
        fontStyle?: string | undefined;
        fill: import("csstype").Property.Color | undefined;
    };
    scale: import("../../utils/PRIVATE_chartUtils").ScaleLinear | import("../../utils/PRIVATE_chartUtils").ScaleLog;
};
export {};
