/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { DvtTextStyle } from '../../utils/UNSAFE_visUtils';
import { AxisPosition, Dimension } from '../axis.types';
import type { useTextDimensions } from '../../hooks/PRIVATE_useTextDimensions';
type GetTextDimensions = NonNullable<ReturnType<typeof useTextDimensions>['getTextDimensions']>;
/**
 * Returns the dimension of the title of the chart.
 * @param getTextDimensions
 * @param availSpace
 * @param isHoriz
 * @param title
 * @param titleStyle
 * @returns
 */
export declare function getTitleDimensions(title: string | undefined, titleStyle: DvtTextStyle | undefined, axisMaxDim: number, isHoriz: boolean, getTextDimensions: GetTextDimensions): {
    width: number;
    height: number;
};
/**
 * Returns the (x, y) coordinate of the text given the width and height of the chart.
 * @param position
 * @param availSpace
 * @param textDims
 * @returns
 */
export declare const getTitlePos: (position: AxisPosition, availSpace: Dimension, textDims: {
    width: number;
    height: number;
}) => {
    x: number;
    y: number;
};
/**
 * Returns the title props.
 * @param titleStyle
 * @param availSpace
 * @param dims
 * @param position
 * @returns
 */
export declare function getTitleProps(title: string | undefined, titleStyle: Record<string, any>, maxAxisDims: number, availSpace: Dimension, position: AxisPosition, getTextDimensions?: GetTextDimensions): {
    width: number;
    height: number;
} | {
    x: number | undefined;
    y: number | undefined;
    transform: string | undefined;
    style: {
        fill: any;
    };
    width: number;
    height: number;
};
export {};
