/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { BarItem, BarSeries } from './barChart.types';
import { ColorProps } from '../utils/UNSAFE_interpolations/colors';
import { Info, Scale } from '../UNSAFE_Chart';
import { Group } from '../UNSAFE_Axis/axis.types';
type BarGroupProps<K, D> = {
    yScale: Scale;
    xScale: Scale;
    colors?: ColorProps['color'][];
    series: BarSeries<K, D>[];
    group: Group;
    timeAxisType?: 'enabled' | 'skipGaps' | 'mixedFrequency';
    focusedItemInfo?: Info;
    hoveredItemInfo?: Info;
    isSelectionEnabled: boolean;
    selectedIds?: Set<K>;
    hiddenIds?: Set<K>;
    highlightedIds?: Set<K>;
    groupIndex: number;
    barGapRatio: number;
    dataItemGaps: number;
    groupWidth: number;
    isStacked: boolean;
    activeId?: string;
    orientation: 'horizontal' | 'vertical';
    isDrillEnabled: boolean;
    isLog: boolean;
    isRtl: boolean;
    getDataItem: (seriesIndex: number, groupIndex: number) => D | undefined;
};
export declare function BarGroup<K extends string | number, D extends BarItem<K>>({ yScale, xScale, colors, series, groupIndex, hiddenIds, barGapRatio, dataItemGaps, groupWidth, highlightedIds, selectedIds, orientation, isLog, activeId, getDataItem, isRtl, isStacked, isSelectionEnabled, focusedItemInfo, hoveredItemInfo, isDrillEnabled, group, timeAxisType }: BarGroupProps<K, D>): import("preact").JSX.Element;
export {};
