/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { ChartItem, ChartProps, ChartSeries } from '../UNSAFE_Chart/chart.types';
export type BarItem<K> = ChartItem<K>;
export type BarSeries<K, D> = {
    /**
     * The bar items belonging to the series.
     */
    items: D[];
} & ChartSeries<K, D>;
export type BarChartProps<K, D extends BarItem<K>> = ChartProps<K, D> & {
    /**
     * The array of series for the chart.
     */
    series: BarSeries<K, D>[];
    /**
     * Specifies the presence and size of the gaps between data items (bars).
     * Valid values are fractional from 0 to 1, where 1 produces the maximum supported gaps
     */
    dataItemGaps?: number;
    /**
     * A function that returns the item for each group and series.
     */
    getDataItem: (seriesIndex: number, groupIndex: number) => D | undefined;
};
