export declare const colorSchemeLight: {
    variants: {
        outlined: {
            base: {
                backgroundColor: string;
                borderColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            disabled: {
                backgroundColor: string;
                borderColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            hover: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            active: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
        };
        callToAction: {
            base: {
                backgroundColor: `rgb(var(--${string}))` | `rgb(var(--${string}, ${string}))` | `rgb(var(--${string}, ${number}))`;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            disabled: {
                backgroundColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            hover: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            active: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
        };
        borderless: {
            base: {
                backgroundColor: string;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            disabled: {
                backgroundColor: string;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            hover: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            active: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
        };
        ghost: {
            base: {
                backgroundColor: string;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            disabled: {
                backgroundColor: string;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            hover: {
                backgroundOverlayColor: string;
            };
            active: {
                backgroundOverlayColor: string;
            };
        };
        solid: {
            base: {
                backgroundColor: `rgba(var(--${string}), ${number})` | `rgba(var(--${string}, ${string}), ${number})` | `rgba(var(--${string}, ${number}), ${number})`;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            disabled: {
                backgroundColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            hover: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            active: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
        };
        danger: {
            base: {
                backgroundColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            disabled: {
                backgroundColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
                borderColor: string;
                color: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            hover: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
            active: {
                backgroundOverlayColor: `var(--${string})` | `var(--${string}, ${string})` | `var(--${string}, ${number})`;
            };
        };
    };
};
