/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { ColorProps } from '../utils/UNSAFE_interpolations/colors';
import { LineAreaItem } from '../UNSAFE_LineAreaChart/lineAreaChart.types';
import { MarkerShapes } from '../UNSAFE_SvgShapes';
import { Group } from '../UNSAFE_Axis/axis.types';
import { ChartSeries, Scale } from '.';
type MarkersProps<K, D> = {
    yScale: Scale;
    xScale: Scale;
    startIndex: number;
    endIndex: number;
    seriesIndex: number;
    series: ChartSeries<K, D>;
    markerType: MarkerShapes;
    data: number[];
    color: ColorProps['color'];
    groups: Group[];
    focusedItemIndex?: number;
    isSelectionEnabled: boolean;
    hoveredItemIndex?: number;
    selectedIds?: Set<string | number>;
    hiddenIds?: Set<string | number>;
    activeId?: string;
    orientation: 'horizontal' | 'vertical';
    isDrillEnabled: boolean;
    isLog: boolean;
    getDataItem: (seriesIndex: number, groupIndex: number) => D | undefined;
    timeAxisType?: 'enabled' | 'skipGaps' | 'mixedFrequency';
};
export declare function Markers<K extends string | number, D extends LineAreaItem<K>>({ yScale, xScale, color, seriesIndex, startIndex, endIndex, hiddenIds, selectedIds, orientation, isLog, data, markerType, getDataItem, focusedItemIndex, hoveredItemIndex, isDrillEnabled, activeId, isSelectionEnabled, timeAxisType, series, groups }: MarkersProps<K, D>): import("preact").JSX.Element;
export {};
