import type { DiagramNode, DiagramLink, NodeRendererContext, LinkRendererContext, States, Bounds, DiagramLabelPosition } from './Diagram.types';
import { ComponentChildren } from 'preact';
import type { TextDimensions } from '../hooks/PRIVATE_useTextDimensions';
/**
 * Props for Diagram layers component
 */
type DiagramLayersProps<K1, K2> = {
    nodes: DiagramNode<K1>[];
    links: DiagramLink<K2, K1>[];
    nodeRenderer: (context: NodeRendererContext<K1>) => ComponentChildren;
    linkRenderer?: (context: LinkRendererContext<K2, K1>) => ComponentChildren;
    states: States<K1, K2>;
    previousStates: States<K1, K2>;
    nodeBounds: Bounds[];
    width: number;
    height: number;
    onNodeSizeChanged: (width: number, height: number, idx: number) => void;
    nodeLabelPositions?: (DiagramLabelPosition | undefined)[];
    linkLabelPositions?: (DiagramLabelPosition | undefined)[];
    labelDimensions?: Map<K1 | K2, TextDimensions>;
    supportsSelection: boolean;
};
export declare function DiagramLayers<K1 extends string | number, K2 extends string | number>({ nodes, links, nodeRenderer, linkRenderer, states, previousStates, nodeBounds, onNodeSizeChanged, width, height, nodeLabelPositions, linkLabelPositions, labelDimensions, supportsSelection }: DiagramLayersProps<K1, K2>): import("preact").JSX.Element;
export {};
