import type { Position, State, DiagramNode, NodeRendererContext } from './Diagram.types';
import { ComponentChildren } from 'preact';
/**
 * Props for node component
 */
type NodeProps<K1> = {
    id: K1;
    position: Position;
    label?: string;
    state: State;
    previousState: State;
    isDimmed?: boolean;
    activeId?: string;
    accessibleLabel?: string;
    nodeIndex: number;
    data: DiagramNode<K1>;
    nodeRenderer: (context: NodeRendererContext<K1>) => ComponentChildren;
    onNodeSizeChanged: (width: number, height: number, idx: number) => void;
    supportsSelection: boolean;
};
export declare const DiagramNodeElement: <K1>({ id, state, previousState, position, activeId, nodeRenderer, onNodeSizeChanged, nodeIndex, data, accessibleLabel, isDimmed, supportsSelection }: NodeProps<K1>) => import("preact").JSX.Element;
export {};
