import { ComponentChildren } from 'preact';
import type { DiagramNode, States, NodeRendererContext, Bounds } from './Diagram.types';
type Props<K1, K2> = {
    nodes: DiagramNode<K1>[];
    states: States<K1, K2>;
    previousStates: States<K1, K2>;
    nodeRenderer: (context: NodeRendererContext<K1>) => ComponentChildren;
    onNodeSizeChanged: (width: number, height: number, idx: number) => void;
    nodeBounds?: Bounds[];
    supportsSelection: boolean;
};
export declare function DiagramNodeLayer<K1, K2>({ nodes, states, previousStates, nodeRenderer, nodeBounds, onNodeSizeChanged, supportsSelection }: Props<K1, K2>): import("preact").JSX.Element;
export {};
