/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import type { ItemInfo, Bounds } from '../Diagram.types';
import type { Ref } from 'preact/hooks';
import type { Pan } from '../utils/panUtils';
type props<K1, K2> = {
    text?: string;
    focusedItemInfo: ItemInfo<K1, K2>;
    focusedItemBoundsRef: Ref<Bounds | null>;
    panState: Pan;
    zoom: number;
    width: number;
};
/**
 * Returns the datatip.
 * @param text The text string for the diagram item.
 * @param rootRef The ref for root of the diagram.
 * @param focusedItemBoundsRef The ref for focused item bounds.
 * @param focusedItemInfo The ItemInfo for focused item.
 * @returns
 */
export declare const useDiagramDatatip: <K1, K2>({ text, focusedItemBoundsRef, focusedItemInfo, panState, zoom, width }: props<K1, K2>) => {
    datatipContent: import("preact").JSX.Element | null;
    datatipProps: {
        'aria-describedby': string;
        onKeyUp: (event: KeyboardEvent) => void;
        onPointerLeave: () => void;
        onPointerEnter: (event: PointerEvent) => void;
        onPointerMove: (event: PointerEvent) => void;
        onFocus: (event: FocusEvent) => void;
        onBlur: () => void;
    };
};
export {};
