/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { NavDirection } from '../utils/navUtils';
import type { DiagramNode, DiagramLink, Bounds, ItemInfo } from '../Diagram.types';
export declare function useDiagramNavigation<K1, K2>(nodes: DiagramNode<K1>[], links: DiagramLink<K2, K1>[], bounds: Bounds[], linkIdToDataMap: Map<K2, DiagramLink<K2, K1>>): {
    isNode: (itemInfo: ItemInfo<K1, K2>) => boolean;
    getNextNavigableNode: (direction: NavDirection, compareCenters: boolean, current?: DiagramNode<K1>, listOfObjects?: DiagramNode<K1>[]) => DiagramNode<K1> | undefined;
    getNextNavigableLink: (direction: string, listOfNodes: DiagramNode<K1>[], currentLink?: DiagramLink<K2, K1>, listOfLinks?: DiagramLink<K2, K1>[]) => DiagramLink<K2, K1> | {
        id: K2;
        angle: number;
        distance: number;
        direction: 0 | 1;
    } | undefined;
    navigateFromNodeToLink: (listOfLinks: DiagramLink<K2, K1>[], event: KeyboardEvent, node?: DiagramNode<K1>) => {
        id: K2;
        isNode: boolean;
    } | undefined;
    navigateFromLinkToNode: (linkId: K2, event: KeyboardEvent) => {
        id: K1;
        isNode: boolean;
    } | undefined;
};
