import type { DiagramNode, DiagramLink, ItemInfo } from '../Diagram.types';
import { Ref } from 'preact/hooks';
type SelectionProps<K1, K2> = {
    selectedIds: {
        nodes?: K1[];
        links?: K2[];
    };
    selectionMode: 'none' | 'single' | 'multiple';
    nodeMap: {
        itemIdToDataMap: Map<K1, DiagramNode<K1>>;
        itemIdToIndexMap: Map<K1, number>;
        itemIndexToIdMap: Map<number, K1>;
    };
    linkMap: {
        itemIdToDataMap: Map<K1, DiagramLink<K2, K1>>;
        itemIdToIndexMap: Map<K2, number>;
        itemIndexToIdMap: Map<number, K2>;
    };
    focusedItemInfo: ItemInfo<K1, K2>;
    onSelectionChange?: (detail: {
        nodes: Array<K1>;
        links: Array<K2>;
    }) => void;
    rootRef: Ref<HTMLDivElement>;
};
export declare function useDiagramSelection<K1, K2>({ selectedIds, selectionMode, nodeMap, linkMap, focusedItemInfo, onSelectionChange, rootRef }: SelectionProps<K1, K2>): {
    onKeyUp?: undefined;
    onContextMenu?: undefined;
    onPointerUp?: undefined;
} | {
    onKeyUp: (event: KeyboardEvent) => void;
    onContextMenu: (event: MouseEvent) => void;
    onPointerUp: (event: PointerEvent) => void;
};
export {};
