import { DiagramNode, DiagramLink, ItemInfo, ItemInputDetail, Bounds } from '../Diagram.types';
export declare function useEvents<K1, K2>(initNode: DiagramNode<K1>, nodes: DiagramNode<K1>[], links: DiagramLink<K2, K1>[], nodeBounds: Bounds[], linkIdToDataMap: Map<K2, DiagramLink<K2, K1>>, nodeIdToIndexMap: Map<K1, number>, width: number, height: number, maxZoom: number, onInput?: (detail: ItemInputDetail<K1, K2>) => void, kbPanCallback?: (props: {
    dPan?: {
        dx: number;
        dy: number;
    };
    nPan?: {
        cx: number;
        cy: number;
    };
    center?: boolean;
}) => void, kbZoomCallback?: (props: {
    dZoom?: number;
    nZoom?: number;
}) => void): {
    focusedItemInfo: ItemInfo<K1, K2>;
    hoveredItemInfo: ItemInfo<K1, K2> | undefined;
    'aria-activedescendant': string | undefined;
    onKeyUp: (event: KeyboardEvent) => void;
    onKeyDown: (event: KeyboardEvent) => void;
    onBlur: () => void;
    onPointerUp: (event: PointerEvent) => void;
    onPointerMove: (event: PointerEvent) => void;
    onPointerLeave: () => void;
};
