/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { BundleType } from '../../resources/nls/bundle';
import type { Gantt as GanttProps, GanttRow, GanttTask } from '../Gantt.types';
import { GanttRowLayoutObj, GanttTaskLayoutObj } from './dataLayoutUtils';
/**
 * Gets the aria label for the task.
 * @param taskObj The task layout object.
 * @param rowData The rows data.
 * @param dateFormatter The date formatter.
 * @param translations The translations bundle.
 * @returns The aria label for the task.
 */
declare const getTaskAriaLabel: <K1, K2, D1 extends GanttRow<K1, D1, D2>, D2 extends GanttTask<K2>>(taskObj: GanttTaskLayoutObj<K2>, rowData: D1[], dateFormatter: (date: string) => string, translations: BundleType) => string;
/**
 * Gets the aria label for the row label
 * @param rowObj The row layout object.
 * @param rowData The rows data.
 * @returns The aria label for the row label.
 */
declare const getRowLabelAriaLabel: <K1, K2, D1 extends GanttRow<K1, D1, D2>, D2 extends GanttTask<K2>>(rowObj: GanttRowLayoutObj<K1, K2>, rowData: D1[]) => string;
export { getTaskAriaLabel, getRowLabelAriaLabel };
