/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import type { BundleType } from '../../resources/nls/bundle';
import type { GanttDatatipContext, Gantt as GanttProps, GanttRow, GanttTask } from '../Gantt.types';
/**
 * Gets the default datatip renderer.
 * @param options Relevant information.
 * @returns The default datatip renderer.
 */
declare const getDefaultDatatipRenderer: <K1, K2, D1 extends GanttRow<K1, D1, D2>, D2 extends GanttTask<K2>>(options: {
    translations: BundleType;
    dateFormatter: (date: string) => string;
    isRTL: boolean;
}) => (context: GanttDatatipContext<D1, D2>) => {
    content?: import("preact").ComponentChildren;
    borderColor?: import("csstype").Property.BorderColor | undefined;
};
/**
 * Gets the datatip renderer context.
 * @param rows The rows data.
 * @param layoutObj The task layout object.
 * @returns
 */
declare const getRenderContext: <K1, K2, D1 extends GanttRow<K1, D1, D2>, D2 extends GanttTask<K2>>(rows: D1[], layoutObj: {
    index: number;
    rowIndex: number;
}) => GanttDatatipContext<D1, D2>;
export { getDefaultDatatipRenderer, getRenderContext };
