import { VNode, RefObject } from 'preact';
import { LayerPriority } from './LayerContext';
type Props = {
    /**
     * The content to be re-parented using Portal
     */
    children: VNode;
    /**
     * Logical parent of the re-parented content. Typically the 'launcher' associated
     * with the popup.
     */
    logicalParentRef?: RefObject<Element> | null;
    /**
     * Determines Layer's stacking context. Components that always need to render on top of other popup
     * elements (such as Messages) should use priority='top'. The default priority level is 'normal'.
     */
    priority?: LayerPriority;
};
declare const Layer: (props: Props) => import("preact").JSX.Element;
export default Layer;
