/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { RefObject } from 'preact';
import { LegendItem, LegendSection } from './Legend.type';
import { Font } from '../hooks/PRIVATE_useTextDimensions';
type Props<K> = {
    sections?: LegendSection<K>[];
    items?: LegendItem<K>[];
    resolvedVars: Record<string, any>;
    rootRef: RefObject<HTMLDivElement>;
    rootDimsRef: RefObject<DOMRect | undefined>;
    orientation?: 'vertical' | 'horizontal';
    legendFontStylesObj?: Font;
    symbolWidth?: number;
};
export type LayoutInfo = {
    isWrapped: boolean;
    maxItemWidth: number;
    itemsPerRow: number;
};
export declare function useLegendLayout<K>({ resolvedVars, sections, items, rootRef, rootDimsRef, orientation, legendFontStylesObj, symbolWidth }: Props<K>): {
    textMeasureContent: import("preact").JSX.Element;
    layoutInfo: {
        maxItemWidth: number;
        itemsPerRow: number;
        isWrapped: boolean;
    } | undefined;
};
export {};
