/**
 * @license
 * Copyright (c) %FIRST_YEAR% %CURRENT_YEAR%, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
import { ColorProps } from '../utils/UNSAFE_interpolations/colors';
import { ChartProps, ChartSeries } from '../UNSAFE_Chart/chart.types';
import { MarkerShapes } from '../UNSAFE_SvgShapes';
import { ChartItem } from "../UNSAFE_Chart";
export type LineAreaItem<K> = ChartItem<K> & {
    /**
     * The  color of the marker.
     */
    markerColor?: ColorProps['color'];
    /**
     * The id of the data item.
     */
    id: string | number;
    /**
     * Whether or not the marker is displayed.
     */
    isMarkerDisplayed?: boolean;
    /**
     * The type of marker.
     */
    markerType?: MarkerShapes;
    /**
     * The size of the marker.
     */
    markerSize?: number;
};
export type LineAreaSeries<K, D> = ChartSeries<K, D> & {
    /**
     * The color of the line.
     */
    lineColor?: ColorProps['color'];
    /**
     * The line style the line series.
     */
    lineStyle?: 'solid' | 'dotted' | 'dashed';
    /**
     * The line width of the line series.
     */
    lineWidth?: number;
    /**
     * The type of the line.
     */
    lineType?: 'curved' | 'straight';
    /**
     * The color of the area.
     */
    areaColor?: ColorProps['color'];
};
export type LineAreaChartProps<K, D extends LineAreaItem<K>> = ChartProps<K, D> & {
    /**
     * The array of series for the chart.
     */
    series: LineAreaSeries<K, D>[];
    /**
     * A function that returns the item for each group and series.
     */
    getDataItem: (seriesIndex: number, groupIndex: number) => D | undefined;
    /**
     * Defines the chart type.
     */
    type?: 'line' | 'area' | 'lineWithArea';
};
