import { ComponentProps, ContextType, RefObject } from 'preact';
import type { TabBarContext, TabBarLayout } from '../UNSAFE_TabBarCommon';
type TabBarContextValue = ContextType<typeof TabBarContext>;
export type UseTabBarOptions = {
    class?: string;
    display?: TabBarContextValue['display'];
    edge?: 'bottom' | 'top';
    onRemove?: TabBarContextValue['onRemove'];
    onSelect?: TabBarContextValue['onSelect'];
    ref?: RefObject<HTMLDivElement>;
    selection?: TabBarContextValue['selection'];
    size?: TabBarContextValue['size'];
    children?: ComponentProps<typeof TabBarLayout>['children'];
};
/**
 * Re-implements UNSAFE_TabBar/TabBar behavior for focus and keyboad handling
 */
export declare function useTabBar(options: UseTabBarOptions): {
    readonly rootProps: {};
    readonly tabBarContext: {
        readonly currentKey: string | number | undefined;
        readonly display: "icons" | "standard" | "stacked" | undefined;
        readonly isEdgeBottom: boolean;
        readonly layout: "condense";
        readonly onRemove: (<K extends string | number>(detail: {
            value: K;
        }) => void) | undefined;
        readonly onSelect: (<K_1 extends string | number>(detail: {
            value: K_1;
        }) => void) | undefined;
        readonly showFocusRing: boolean;
        readonly selection: string | number | undefined;
        readonly size: "never" | "md" | "lg" | undefined;
        readonly tabItemPrefix: string;
    };
};
export {};
