prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- Oracle APEX export file
--
-- You should run this script using a SQL client connected to the database as
-- the owner (parsing schema) of the application or as a database user with the
-- APEX_ADMINISTRATOR_ROLE role.
--
-- This export file has been automatically generated. Modifying this file is not
-- supported by Oracle and can lead to unexpected application and/or instance
-- behavior now or in the future.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_imp.import_begin (
 p_version_yyyy_mm_dd=>'2024.05.31'
,p_release=>'24.1.0'
,p_default_workspace_id=>10
,p_default_application_id=>4020
,p_default_id_offset=>0
,p_default_owner=>'APEX_240100'
);
end;
/
 
prompt APPLICATION 4020 - Oracle APEX Create App Wizard
--
-- Application Export:
--   Application:     4020
--   Name:            Oracle APEX Create App Wizard
--   Exported By:     APEX_240100
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                     38
--       Items:                  361
--       Computations:            14
--       Validations:             61
--       Processes:              135
--       Regions:                206
--       Buttons:                187
--       Dynamic Actions:        163
--     Shared Components:
--       Logic:
--         Items:                 58
--         Processes:              1
--         Computations:           3
--         Build Options:         13
--       Navigation:
--         Parent Tabs:            1
--         Lists:                  6
--       Security:
--         Authentication:         1
--         Authorization:         12
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                 4
--           Region:              38
--           Label:               14
--           List:                26
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           1
--           Button:              10
--           Report:              15
--         LOVs:                  43
--         Shortcuts:              3
--         Plug-ins:              14
--       PWA:
--       Globalization:
--         Messages:              48
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--   Version:         24.1.0
--   Instance ID:     1000197243005302
--

prompt --application/delete_application
begin
wwv_flow_imp.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_imp_workspace.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_240100')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Create App Wizard')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'CREATE-APP')
,p_application_group=>wwv_flow_imp.id(91050719712959059)
,p_application_group_name=>'APEX Product'
,p_application_group_comment=>'Applications shipped with the APEX product distribution'
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20240716121407'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.1'
,p_accessible_read_only=>'N'
,p_session_state_commits=>'IMMEDIATE'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_documentation_banner=>'Oracle APEX create application wizard. Allows APEX developers to create fully functional application by adding pages and application-level features.'
,p_authentication_id=>wwv_flow_imp.id(3324722473421190676)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 24.1.0'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O'
,p_pass_ecid=>'N'
,p_security_scheme=>wwv_flow_imp.id(2876432045198950826)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_substitution_string_01=>'PRODUCT_NAME'
,p_substitution_value_01=>'Oracle APEX'
,p_substitution_string_02=>'DONE'
,p_substitution_value_02=>'Done'
,p_substitution_string_03=>'MSG_COMPANY'
,p_substitution_value_03=>'Workspace: &COMPANY.'
,p_substitution_string_04=>'CLOSE'
,p_substitution_value_04=>'Close'
,p_substitution_string_05=>'DATE_FORMAT'
,p_substitution_value_05=>'mm/dd/yyyy'
,p_substitution_string_06=>'LONG_DATE_FORMAT'
,p_substitution_value_06=>'fmDay, Month dd, yyyy'
,p_substitution_string_07=>'TIME_FORMAT'
,p_substitution_value_07=>'hh:mi:ss AM'
,p_substitution_string_08=>'DATE_TIME_FORMAT'
,p_substitution_value_08=>'mm/dd/yyyy hh:mi:ss AM'
,p_substitution_string_09=>'RETURN_TO_APPLICATION'
,p_substitution_value_09=>'Return to Application'
,p_substitution_string_10=>'MSG_LANGUAGE'
,p_substitution_value_10=>'Language'
,p_substitution_string_11=>'MSG_USER'
,p_substitution_value_11=>'User'
,p_substitution_string_12=>'MSG_COPYRIGHT'
,p_substitution_value_12=>'Copyright &copy; 1999, 2024, Oracle and/or its affiliates.'
,p_substitution_string_13=>'MSG_JSCRIPT'
,p_substitution_value_13=>'You must run this product with JavaScript enabled.'
,p_substitution_string_14=>'MSG_WORKSPACE'
,p_substitution_value_14=>'Workspace'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_files_version=>5
,p_print_server_type=>'INSTANCE'
,p_file_storage=>'DB'
,p_is_pwa=>'N'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_imp_shared.create_user_interface(
 p_id=>wwv_flow_imp.id(4020)
,p_theme_id=>101
,p_home_url=>'f?p=4020:1:&SESSION.'
,p_login_url=>'f?p=4550:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>0
,p_nav_list_template_options=>'#DEFAULT#'
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#ui.core#MIN#.js'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/shared_components/navigation/lists/extension_links_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(5401582532816199)
,p_name=>'Extension Links Menu'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lev,',
'       label,',
'       target,',
'       null     as is_current,',
'       null     as image,',
'       null     as image_attrib,',
'       null     as image_alt_attribute,',
'       null     as attribute1,',
'       null     as attribute2,',
'       null     as attribute3,',
'       null     as attribute4,',
'       null     as attribute5,',
'       ''_blank'' as attribute6,',
'       null     as attribute7,',
'       null     as attribute8,',
'       null     as attribute9,',
'       null     as attribute10',
'  from (',
'          select 1                          as lev,',
'                 name                       as label,',
'                 wwv_extension.get_url(url) as target,',
'                 null                       as wsname,',
'                 display_sequence',
'            from wwv_extension_links',
'           where security_group_id = :workspace_id',
'          union all',
'          select 1                                           as lev,',
'                 nvl(eg.menu_label, initcap(c.display_name)) as label,',
'                 null                                        as target,',
'                 c.display_name                              as wsname,',
'                 0                                           as display_sequence',
'            from wwv_extension_grants eg, wwv_flow_companies c',
'           where eg.security_group_id           = :workspace_id',
'             and eg.extension_security_group_id = c.provisioning_company_id',
'             and exists (',
'                   select 1',
'                     from wwv_extension_links l',
'                    where l.security_group_id = eg.extension_security_group_id',
'                      and is_public           = ''Y'' )',
'          union all',
'          select 2                             as lev,',
'                 name                          as label,',
'                 wwv_extension.get_url(el.url) as target,',
'                 eg.wsname                     as wsname,',
'                 el.display_sequence',
'            from (',
'                    select eg.*,',
'                           c.display_name as wsname',
'                      from wwv_extension_grants eg, wwv_flow_companies c',
'                     where eg.security_group_id           = :workspace_id',
'                       and eg.extension_security_group_id = c.provisioning_company_id',
'                 )                         eg, wwv_extension_links el',
'           where el.security_group_id = eg.extension_security_group_id',
'             and el.is_public         = ''Y''',
'       )',
' order by wsname nulls first, lev, display_sequence, label'))
,p_list_status=>'PUBLIC'
,p_reference_id=>2000133062045966
,p_version_scn=>40349138
);
end;
/
prompt --application/shared_components/navigation/lists/additional_page_types
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(599891668290343112)
,p_name=>'Additional Page Types'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556817
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(599891860611343113)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Classic Report'
,p_list_item_link_target=>'REPORT'
,p_list_item_current_for_pages=>'REPORT'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(599892201246343114)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Timeline'
,p_list_item_link_target=>'TIMELINE'
,p_list_item_current_for_pages=>'TIMELINE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_app_wizard
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2558503318577318905)
,p_name=>'Create App Wizard'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556823
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_administration_header
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3078131037146643152)
,p_name=>'APEX 5 - Administration (Header)'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556823
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078131330088643190)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Administration'
,p_list_item_link_target=>'f?p=4350:1:&APP_SESSION.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078131706125643192)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078132165904643193)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Service'
,p_security_scheme=>wwv_flow_imp.id(477032281289042219)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078132505153643193)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Manage Service'
,p_list_item_link_target=>'f?p=4350:21:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078132924385643194)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078133367058643194)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Make a Service Request'
,p_list_item_link_target=>'f?p=4350:96:&SESSION.::NO:49::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(3078132165904643193)
,p_security_scheme=>wwv_flow_imp.id(477032281289042219)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078133750052643195)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Set Workspace Preferences'
,p_list_item_link_target=>'f?p=4350:17:&SESSION.::NO:RP::'
,p_parent_list_item_id=>wwv_flow_imp.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078134173371643195)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Define Workspace Message'
,p_list_item_link_target=>'f?p=4350:35:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(180639817922584588)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Define Environment Banner'
,p_list_item_link_target=>'f?p=4350:105:&SESSION.:::105:P105_LAST_APP_ID,P105_LAST_PAGE_ID:&APP_ID.,&APP_PAGE_ID.'
,p_parent_list_item_id=>wwv_flow_imp.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078134568371643195)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Workspace Utilization'
,p_list_item_link_target=>'f?p=4350:101:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3200295707397847)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Manage Extension Links'
,p_list_item_link_target=>'f?p=4350:110:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078134932669643196)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Users and Groups'
,p_list_item_link_target=>'f?p=4350:55:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(477032281289042219)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078135328636643196)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Monitor Activity'
,p_list_item_link_target=>'f?p=4350:22:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(477074727917083066)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078135799834643196)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dashboards'
,p_list_item_link_target=>'f?p=4350:33:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(477074727917083066)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078136195160643196)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Change My Password'
,p_list_item_link_target=>'f?p=4350:3:&SESSION.::&DEBUG.:3#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(477074727917083066)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3078138630465643203)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556823
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078138974356643203)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentation'
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078139307044643204)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Discussion Forum'
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078139708135643204)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Learn More about Oracle APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078140162161643204)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3078140539384643204)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'About'
,p_list_item_link_target=>'f?p=4350:9:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_shared_navigation_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3078141213440643205)
,p_name=>'APEX Shared Navigation Menu'
,p_list_status=>'PUBLIC'
,p_reference_id=>2206460728364447
,p_version_scn=>117449631
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2076748572227446)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'App Builder'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'App Builder Drill Down'
,p_list_text_01=>'tab-app-builder'
,p_security_scheme=>wwv_flow_imp.id(477075720994096449)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID in ( 4000, 4020 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2077199319227446)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Create'
,p_list_item_link_target=>'f?p=4000:56:&SESSION.::&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID::'
,p_parent_list_item_id=>wwv_flow_imp.id(2076748572227446)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2077564281227446)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=4000:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_parent_list_item_id=>wwv_flow_imp.id(2076748572227446)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2077994341227446)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::&DEBUG.:4900:FB_FLOW_ID,FB_FLOW_PAGE_ID::'
,p_parent_list_item_id=>wwv_flow_imp.id(2076748572227446)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2078318977227446)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2076748572227446)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2078708293227446)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Workspace Utilities'
,p_parent_list_item_id=>wwv_flow_imp.id(2076748572227446)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2079121880227447)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'All Workspace Utilities'
,p_list_item_link_target=>'f?p=4000:182:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2078708293227446)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2079538333227447)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2078708293227446)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2079988889227447)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Workspace Themes'
,p_list_item_link_target=>'f?p=4000:763:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2078708293227446)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2080307678227447)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Application Groups'
,p_list_item_link_target=>'f?p=4000:722:&SESSION.::&DEBUG.:RP'
,p_parent_list_item_id=>wwv_flow_imp.id(2078708293227446)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2080793662227447)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'&PRODUCT_NAME. Views'
,p_list_item_link_target=>'f?p=4000:714:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2078708293227446)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2081163187227447)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Cross Application Reports'
,p_list_item_link_target=>'f?p=4000:9009:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2078708293227446)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2081568414227447)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL Workshop'
,p_list_item_link_target=>'f?p=4500:3002:&SESSION.'
,p_list_item_icon_alt_attribute=>'SQL Workshop Drill Down'
,p_list_text_01=>'tab-sql-workshop'
,p_security_scheme=>wwv_flow_imp.id(477077192833096450)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'( :APP_ID = 4500 and :APP_PAGE_ID not in ( ''1000'',''8000'',''35'', ''900'' ) ) or :APP_ID in ( 4850, 4300 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2081940461227448)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Object Browser'
,p_list_item_link_target=>'f?p=4500:2000:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2081568414227447)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2082302320227448)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'SQL Commands'
,p_list_item_link_target=>'f?p=4500:1003:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2081568414227447)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2082760617227448)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'SQL Scripts'
,p_list_item_link_target=>'f?p=4500:1004:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2081568414227447)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Utilities'
,p_parent_list_item_id=>wwv_flow_imp.id(2081568414227447)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2083546739227448)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'All Utilities'
,p_list_item_link_target=>'f?p=4500:1005:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2083993631227448)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2084317886227448)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Data Workshop'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2084746071227448)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Data Generator'
,p_list_item_link_target=>'f?p=4500:4000:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_security_scheme=>wwv_flow_imp.id(1754429787985104)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2085171398227449)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=4500:1002:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2085506166227449)
,p_list_item_display_sequence=>270
,p_list_item_link_text=>'Quick SQL'
,p_list_item_link_target=>'f?p=4500:1100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2085971722227449)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>'Sample Datasets'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2086300910227449)
,p_list_item_display_sequence=>290
,p_list_item_link_text=>'Generate DDL'
,p_list_item_link_target=>'f?p=4500:12:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2086794772227449)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'UI Defaults'
,p_list_item_link_target=>'f?p=4500:813:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2087183654227449)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Schema Comparison'
,p_list_item_link_target=>'f?p=4500:1350:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2087545045227449)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Methods on Tables'
,p_list_item_link_target=>'f?p=4500:120:&SESSION.:'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2087917235227449)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Recycle Bin'
,p_list_item_link_target=>'f?p=4500:1070:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2088351220227449)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Object Reports'
,p_list_item_link_target=>'f?p=4500:1042:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2088712100227450)
,p_list_item_display_sequence=>350
,p_list_item_link_text=>'About Database'
,p_list_item_link_target=>'f?p=4500:36:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2089178488227450)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Database Monitor'
,p_list_item_link_target=>'f?p=4500:11:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(2083175889227448)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2089560173227450)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'RESTful Services'
,p_list_item_link_target=>'f?p=4850:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2081568414227447)
,p_security_scheme=>wwv_flow_imp.id(477076806710096450)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2089946540227450)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'SQL Developer Web'
,p_list_item_link_target=>'f?p=4500:64:&SESSION.::&DEBUG.:64:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2081568414227447)
,p_security_scheme=>wwv_flow_imp.id(11403882328661629)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2090329379227450)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Team Development'
,p_list_item_link_target=>'f?p=4600:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon_alt_attribute=>'Team Development Drill Down'
,p_list_text_01=>'tab-team-dev'
,p_security_scheme=>wwv_flow_imp.id(477077791361096450)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID in ( 4600, 4650 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2090780885227450)
,p_list_item_display_sequence=>370
,p_list_item_link_text=>'Labels'
,p_list_item_link_target=>'f?p=4600:300:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2090329379227450)
,p_security_scheme=>wwv_flow_imp.id(438801654750439842)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2091113243227450)
,p_list_item_display_sequence=>380
,p_list_item_link_text=>'Milestones'
,p_list_item_link_target=>'f?p=4600:200:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2090329379227450)
,p_security_scheme=>wwv_flow_imp.id(438801654750439842)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2091574057227450)
,p_list_item_display_sequence=>390
,p_list_item_link_text=>'Templates'
,p_list_item_link_target=>'f?p=4600:1000:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2090329379227450)
,p_security_scheme=>wwv_flow_imp.id(438801654750439842)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2091900240227451)
,p_list_item_display_sequence=>400
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=4600:2000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2090329379227450)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2092322223227451)
,p_list_item_display_sequence=>410
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2090329379227450)
,p_security_scheme=>wwv_flow_imp.id(438801654750439842)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2092798923227451)
,p_list_item_display_sequence=>420
,p_list_item_link_text=>'Feedback'
,p_list_item_link_target=>'f?p=4650:8012:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2090329379227450)
,p_security_scheme=>wwv_flow_imp.id(438801654750439842)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2093179012227451)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Gallery'
,p_list_item_link_target=>'f?p=4750:50:&SESSION.'
,p_list_text_01=>'tab-apps'
,p_security_scheme=>wwv_flow_imp.id(438801654750439842)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID = 4750'
,p_list_item_current_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/navigation/listentry
begin
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(804621206458721)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1177257260447301)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SELECT_MANY'
,p_attribute_01=>'separated'
,p_version_scn=>229014804
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1182057727773315)
,p_plugin_type=>'DYNAMIC ACTION'
,p_plugin=>'NATIVE_OPEN_AI_ASSISTANT'
,p_version_scn=>16258294
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(3098166813133682)
,p_plugin_type=>'PROCESS TYPE'
,p_plugin=>'NATIVE_GEOCODING'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_version_scn=>117641975
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(99844462046888906)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(118480729634833028)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_MAP_REGION'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'use_vector_tile_layers', 'Y')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(123213574263478466)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_APEX'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(124389279641989299)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_plugin=>'NATIVE_ADFBC'
,p_version_scn=>37165931336889
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(176128547219506818)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(2573352228768076373)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(4323576260494847496)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'include_slider', 'N')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(4390226133792129319)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'actions_menu_structure', 'IG')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(4476138239762075339)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
,p_version_scn=>37165931336884
);
end;
/
prompt --application/shared_components/security/authorizations/flow_data_generator
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(1754429787985104)
,p_name=>'Flow: DATA_GENERATOR'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'DATA_GENERATOR'
,p_error_message=>'You are not authorized to use Data Generator in SQL Workshop'
,p_reference_id=>2200672316280271
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/extension_links_exist
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(3001064397827272)
,p_name=>'Extension Links Exist'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_extension_links',
' where security_group_id = :workspace_id',
'union all',
'select 1',
'  from wwv_extension_links el, wwv_extension_grants eg',
' where eg.security_group_id           = :workspace_id',
'   and eg.extension_security_group_id = el.security_group_id',
'   and el.is_public = ''Y'''))
,p_reference_id=>2801004939760399
,p_version_scn=>41671338
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/sql_developer_web_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(11403882328661629)
,p_name=>'SQL Developer Web enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_listener.sql_developer_web_enabled;',
'end;'))
,p_error_message=>'SQL Developer Web link is not enabled for this instance.'
,p_reference_id=>11401467991562895
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(438801654750439842)
,p_name=>'Flow: EDIT'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'You are not authorized to edit applications'
,p_reference_id=>12480509677812756
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(477032281289042219)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>'You are not authorized to administer applications'
,p_reference_id=>12511219858301010
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/dashboard_access
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(477074727917083066)
,p_name=>'Dashboard access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'    wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''ADMIN''',
'    )',
'    or wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''EDIT''',
'    );'))
,p_error_message=>'You are not authorized to access Dashboards and Monitor Activity.'
,p_reference_id=>786936829326142579
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>'Used to control access to Dashboards and Monitor Activity under Administration. Developers will have access when Builder is enabled, while Admins will always have access. Prompted by Bug 13859631.'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(477075720994096449)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786516029127697713
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(477076806710096450)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786519856057734816
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(477077192833096450)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'You are not authorized to use SQL Workshop'
,p_reference_id=>786516265251697717
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(477077791361096450)
,p_name=>'APEX 5.0 Team development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>'Team development not enabled for this workspace'
,p_reference_id=>786516861027697723
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_create
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(2876432045198950826)
,p_name=>'Flow: CREATE'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'CREATE'
,p_error_message=>'You are not allowed to create or delete applications'
,p_reference_id=>786942708067207200
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/workspace_requests_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(3069175640501838711)
,p_name=>'Workspace Requests Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''),''MANUAL'') in (''EMAIL'',''4700'') then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>'Workspace requests are not enabled.'
,p_reference_id=>786950454140282960
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_processes/set_translatable_text_strings
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(2621206058206470363)
,p_process_sequence=>1
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set translatable text strings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Set globals used to select features',
':f01 := wwv_flow_lang.custom_runtime_message (''CA.ACCESS.CONTROL.DESC'');',
':f02 := wwv_flow_lang.custom_runtime_message (''CA.USER.PROFILES.DESC'');',
':f03 := wwv_flow_lang.custom_runtime_message (''CA.TIME.ZONE.SUPPORT.DESC'');',
':f04 := wwv_flow_lang.custom_runtime_message (''CA.APPLICATION.SETTINGS.DESC'');',
':f05 := wwv_flow_lang.custom_runtime_message (''CA.HELP.PAGE.DESC'');',
':f06 := wwv_flow_lang.custom_runtime_message (''CA.FEEDBACK.DESC'');',
':f07 := wwv_flow_lang.custom_runtime_message (''CA.THEME.SELECTOR.DESC'');',
':f08 := wwv_flow_lang.custom_runtime_message (''CA.ERROR.REPORTING.DESC'');',
':f09 := wwv_flow_lang.custom_runtime_message (''CA.GLOBAL.SEARCH.DESC'');',
':f10 := wwv_flow_lang.custom_runtime_message (''CA.NOTIFICATION.DESC'');',
':f11 := wwv_flow_lang.custom_runtime_message (''CA.CONFIGURATION.SETTINGS.DESC'');',
':f12 := wwv_flow_lang.custom_runtime_message (''CA.ACTIVITY.REPORTING.DESC'');',
':f13 := wwv_flow_lang.custom_runtime_message (''CA.EMAIL.DESC'');',
':f14 := wwv_flow_lang.custom_runtime_message (''CA.PWA.DESC'');',
':f15 := wwv_flow_lang.custom_runtime_message (''CA.PUSH_NOTIFICATIONS.DESC'');'))
,p_process_clob_language=>'PLSQL'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_items/a1
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584216820885702150)
,p_name=>'A1'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/a10
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584218615128709924)
,p_name=>'A10'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/a2
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584217023655702873)
,p_name=>'A2'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/a3
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584217226079703596)
,p_name=>'A3'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/a4
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584217429542704562)
,p_name=>'A4'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/a5
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584217633005705638)
,p_name=>'A5'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/a6
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584217835776706395)
,p_name=>'A6'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/a7
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584218038893707321)
,p_name=>'A7'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/a8
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584218240970707886)
,p_name=>'A8'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/a9
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584218443395708587)
,p_name=>'A9'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/agreement_accepted
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2702550841505091143)
,p_name=>'AGREEMENT_ACCEPTED'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2902063034370738006)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f01
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620215367360222577)
,p_name=>'F01'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f02
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620215652031223082)
,p_name=>'F02'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f03
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620215829177223685)
,p_name=>'F03'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f04
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620216091988224476)
,p_name=>'F04'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f05
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620216456074224980)
,p_name=>'F05'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f06
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620216646666227625)
,p_name=>'F06'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f07
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620217066393228071)
,p_name=>'F07'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f08
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620217228781228533)
,p_name=>'F08'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f09
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620217428034229023)
,p_name=>'F09'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f10
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620217784983229567)
,p_name=>'F10'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f11
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620219234048254897)
,p_name=>'F11'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f12
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620219635595255705)
,p_name=>'F12'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f13
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620219819242256225)
,p_name=>'F13'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f14
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620220096038256766)
,p_name=>'F14'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f15
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620220261351257355)
,p_name=>'F15'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f16
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620220436881257902)
,p_name=>'F16'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f17
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620220658380258493)
,p_name=>'F17'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f18
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620220815400259098)
,p_name=>'F18'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f19
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620221028508259608)
,p_name=>'F19'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f20
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620221249854260094)
,p_name=>'F20'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f21
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2620221440494260571)
,p_name=>'F21'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4700_req_new_schema
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2661750939169313165)
,p_name=>'F4700_REQ_NEW_SCHEMA'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2927198502727722283)
,p_name=>'FB_FLOW_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/help_page
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2558503632761292870)
,p_name=>'HELP_PAGE'
,p_escape_on_http_output=>'N'
,p_item_comment=>'flow page that you would like help for.'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/login_message
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2567087316471967564)
,p_name=>'LOGIN_MESSAGE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_1
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584285823811390169)
,p_name=>'LOV_1'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_10
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584297318990615933)
,p_name=>'LOV_10'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_2
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584295638252612025)
,p_name=>'LOV_2'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_3
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584295939638612442)
,p_name=>'LOV_3'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_4
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584296141369612948)
,p_name=>'LOV_4'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_5
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584296343101613453)
,p_name=>'LOV_5'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_6
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584296544832613908)
,p_name=>'LOV_6'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_7
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584296714142614506)
,p_name=>'LOV_7'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_8
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584296915873614982)
,p_name=>'LOV_8'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/lov_9
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584297117605615467)
,p_name=>'LOV_9'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/pages_visited
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2567136018491564134)
,p_name=>'PAGES_VISITED'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q1
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584203839503026155)
,p_name=>'Q1'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q10
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584205636863034871)
,p_name=>'Q10'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q2
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584204043312027280)
,p_name=>'Q2'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q3
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584204245736027992)
,p_name=>'Q3'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q4
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584204416085028877)
,p_name=>'Q4'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q5
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584204619202029839)
,p_name=>'Q5'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q6
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584204829591032793)
,p_name=>'Q6'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q7
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584205031322033327)
,p_name=>'Q7'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q8
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584205233054033832)
,p_name=>'Q8'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/q9
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2584205434786034333)
,p_name=>'Q9'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_computations/pages_visited
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(2567153515861648505)
,p_computation_sequence=>1
,p_computation_item=>'PAGES_VISITED'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if instr(:PAGES_VISITED,'':''||wwv_flow.g_flow_step_id) > 0 then',
'   return :PAGES_VISITED;',
'else',
'   return :PAGES_VISITED||'':''||wwv_flow.g_flow_step_id;',
'end if;'))
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(2902063566051747804)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Unable to compute workspace name.'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/f4700_req_new_schema
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(2661751515882325367)
,p_computation_sequence=>10
,p_computation_item=>'F4700_REQ_NEW_SCHEMA'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_platform.get_preference(''REQ_NEW_SCHEMA'')'
,p_compute_when=>'nvl(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''),''MANUAL'') <> ''MANUAL'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
wwv_flow_imp_shared.create_toplevel_tab(
 p_id=>wwv_flow_imp.id(2569953317150029943)
,p_tab_set=>'TOP'
,p_tab_sequence=>20
,p_tab_name=>'T_TOP'
,p_tab_text=>'&PRODUCT_NAME.'
,p_tab_target=>'f?p=&APP_ID.:10:&SESSION.:'
,p_current_on_tabset=>'HOME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/accept_terms
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2638960435990153554)
,p_lov_name=>'ACCEPT TERMS'
,p_lov_query=>'.'||wwv_flow_imp.id(2638960435990153554)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556828
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2638960640110153556)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'I accept the terms'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_item_protection_level
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3348521895514426469)
,p_lov_name=>'APP ITEM PROTECTION LEVEL'
,p_lov_query=>'.'||wwv_flow_imp.id(3348521895514426469)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556828
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3348522133089426483)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unrestricted'
,p_lov_return_value=>'UNRESTRICTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3348522559714426488)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Restricted - May not be set from browser'
,p_lov_return_value=>'RESTRICTED_NO_SET_FROM_BROWSER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_features
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2584581350475987525)
,p_lov_name=>'APPLICATION FEATURES'
,p_lov_query=>'.'||wwv_flow_imp.id(2584581350475987525)||'.'
,p_location=>'STATIC'
,p_version_scn=>183402487
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8201117263399665)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Install Progressive Web App'
,p_lov_return_value=>'PWA'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-package"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F14.</span>',
'</span>'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4275124368902824)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Push Notifications'
,p_lov_return_value=>'PUSH_NOTIFICATIONS'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-bell-o"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F15.</span>',
'</span>'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2584585288683050797)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'About Page'
,p_lov_return_value=>'HELP_PAGE'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-question-circle-o"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F05.</span>',
'</span>'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2584581554892987529)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Access Control'
,p_lov_return_value=>'ACCESS_CONTROL'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-key"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F01.</span>',
'</span>'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595265355306643813)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Activity Reporting'
,p_lov_return_value=>'ACTIVITY_REPORTING'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-user-chart"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F12.</span>',
'</span>'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595261094105593761)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Configuration Options'
,p_lov_return_value=>'BUILD_OPTIONS'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-sliders"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F11.</span>',
'</span>'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2588943841508289264)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Feedback'
,p_lov_return_value=>'APP_FEEDBACK'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-comment-o"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F06.</span>',
'</span>'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2588945090900315875)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Theme Style Selection'
,p_lov_return_value=>'THEME_SELECTOR'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-paint-brush"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F07.</span>',
'</span>'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/authentication_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2935038601795333561)
,p_lov_name=>'AUTHENTICATION.OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.''|| name_with_prefix) as d,',
'       name_with_prefix      as r',
'  from wwv_flow_native_plugins',
' where plugin_type = ''AUTHENTICATION TYPE''',
'   and (          name_with_prefix = ''NATIVE_APEX_ACCOUNTS''',
'         or (     name_with_prefix = ''NATIVE_IAS_SSO''',
'              and wwv_flow_authentication_dev.can_use_sso_yn = ''Y'' )',
'         or (     name_with_prefix = ''NATIVE_SAML'' )',
'         or (     name_with_prefix = ''NATIVE_DB_ACCOUNTS''',
'              and wwv_flow_authentication_dev.get_internal_authentication <> ''CLOUD_IDM'' ) )',
'union all',
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'') d,',
'       ''NATIVE_CLOUD_IDM'' r',
'  from sys.dual',
' where wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556828
);
end;
/
prompt --application/shared_components/user_interface/lovs/available_table_views
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2922437884276753046)
,p_lov_name=>'AVAILABLE_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556828
);
end;
/
prompt --application/shared_components/user_interface/lovs/cards_layout_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13522227592838689)
,p_lov_name=>'CARDS_LAYOUT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(13522227592838689)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556828
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13522936345838714)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Grid'
,p_lov_return_value=>'GRID'
,p_lov_template=>'#DISPLAY_VALUE#|card-grid'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13523313089838714)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Float'
,p_lov_return_value=>'FLOAT'
,p_lov_template=>'#DISPLAY_VALUE#|card-float'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13522520247838713)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Masonry'
,p_lov_return_value=>'MASONRY'
,p_lov_template=>'#DISPLAY_VALUE#|card-masonry'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13523710239838714)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Horizontal (Row)'
,p_lov_return_value=>'ROW'
,p_lov_template=>'#DISPLAY_VALUE#|card-row'
);
end;
/
prompt --application/shared_components/user_interface/lovs/card_link
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3407941302600627214)
,p_lov_name=>'CARD_LINK'
,p_lov_query=>'.'||wwv_flow_imp.id(3407941302600627214)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556828
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3407941652601627216)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Full Card'
,p_lov_return_value=>'FULL_CARD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(667437918766960672)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Title'
,p_lov_return_value=>'TITLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_aggregations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2647168809994648252)
,p_lov_name=>'CHART_AGGREGATIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(2647168809994648252)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556828
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2647169148117648254)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Column Value'
,p_lov_return_value=>'COLVALUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2647169545024648256)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sum'
,p_lov_return_value=>'SUM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2647169964630648256)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Count'
,p_lov_return_value=>'COUNT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/content_delivery_network
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3052348132285494888)
,p_lov_name=>'CONTENT DELIVERY NETWORK'
,p_reference_id=>16362507680404890
,p_lov_query=>'.'||wwv_flow_imp.id(3052348132285494888)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052350732124494891)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Google'
,p_lov_return_value=>'GOOGLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052351106236494891)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Microsoft'
,p_lov_return_value=>'MICROSOFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052351554849494891)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'jQuery'
,p_lov_return_value=>'JQUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/default_error_display_location
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3022423575129113550)
,p_lov_name=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_imp.id(3022423575129113550)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556828
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3022423851399113560)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Inline with Field and in Notification'
,p_lov_return_value=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3022424234362113562)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Inline with Field'
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3022424644160115611)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Inline in Notification'
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/event_name
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3407942220250638520)
,p_lov_name=>'EVENT_NAME'
,p_lov_query=>'.'||wwv_flow_imp.id(3407942220250638520)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556828
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3407942559318638520)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Event Name'
,p_lov_return_value=>'EVENT_TITLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3661865821826250603)
,p_lov_name=>'FORMAT MASK DYNAMIC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from wwv_flow_format_masks'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556829
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2942439030918347706)
,p_lov_name=>'FORM_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2942439030918347706)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556829
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2942440176587347735)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Side by Side'
,p_lov_return_value=>'MD_ON_TABLE_WITH_SELECTOR'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-side-md'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3314917601050455348)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Stacked'
,p_lov_return_value=>'MD_GRID'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-one-md'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_charset
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3032407450767161075)
,p_lov_name=>'I18N_IANA_CHARSET'
,p_reference_id=>144796827445692396
,p_lov_query=>'.'||wwv_flow_imp.id(3032407450767161075)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032428899875161137)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Little Endian'
,p_lov_return_value=>'utf-16le'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032429263656161137)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Big Endian'
,p_lov_return_value=>'utf-16be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032429694795161137)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'us-ascii'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032430094554161138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic ISO-8859-6'
,p_lov_return_value=>'iso-8859-6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032430415842161138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic Windows 1256'
,p_lov_return_value=>'windows-1256'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032430845699161138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese Big5'
,p_lov_return_value=>'big5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032431286916161138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese GBK'
,p_lov_return_value=>'gbk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032431625249161139)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic ISO-8859-5'
,p_lov_return_value=>'iso-8859-5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032432039358161139)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-R'
,p_lov_return_value=>'koi8-r'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032432431696161139)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-U'
,p_lov_return_value=>'koi8-u'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032432804722161139)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic Windows 1251'
,p_lov_return_value=>'windows-1251'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032433258813161140)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European ISO-8859-2'
,p_lov_return_value=>'iso-8859-2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032433604528161140)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European Windows 1250'
,p_lov_return_value=>'windows-1250'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032434018695161140)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek ISO-8859-7'
,p_lov_return_value=>'iso-8859-7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032434461200161140)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek Windows 1253'
,p_lov_return_value=>'windows-1253'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032434883722161141)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew ISO-8859-8-i'
,p_lov_return_value=>'iso-8859-8-i'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032435277346161141)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew Windows 1255'
,p_lov_return_value=>'windows-1255'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032435678437161141)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese EUC'
,p_lov_return_value=>'euc-jp'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032436066715161141)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese Shift JIS'
,p_lov_return_value=>'shift_jis'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032436419408161142)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Korean EUC'
,p_lov_return_value=>'euc-kr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032436830183161142)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European ISO-8859-4'
,p_lov_return_value=>'iso-8859-4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032437259126161142)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European Windows 1257'
,p_lov_return_value=>'windows-1257'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032437659909161143)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Southern European ISO-8859-3'
,p_lov_return_value=>'iso-8859-3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032438037143161143)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Thai TIS-620'
,p_lov_return_value=>'tis-620'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032438462570161143)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish ISO-8859-9'
,p_lov_return_value=>'iso-8859-9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032438818622161143)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish Windows 1254'
,p_lov_return_value=>'windows-1254'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032439229309161144)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-8'
,p_lov_return_value=>'utf-8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032439689379161144)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vietnamese Windows 1258'
,p_lov_return_value=>'windows-1258'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032440086280161144)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European ISO-8859-1'
,p_lov_return_value=>'iso-8859-1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3032440420737161144)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European Windows 1252'
,p_lov_return_value=>'windows-1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(261035724719892504)
,p_lov_name=>'I18N_LANGUAGES_LOCALES'
,p_reference_id=>107899321117195063
,p_lov_query=>'.'||wwv_flow_imp.id(261035724719892504)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296482717323642101)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Azerbaijani (az)'
,p_lov_return_value=>'az'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296483199562642102)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (Cyrillic)(sr-cyrl)'
,p_lov_return_value=>'sr-cyrl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296483586744642102)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (Latin)(sr-latn)'
,p_lov_return_value=>'sr-latn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296483999117642102)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrikaans (af)'
,p_lov_return_value=>'af'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296484342926642102)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (ar)'
,p_lov_return_value=>'ar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296484760282642102)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Algeria) (ar-dz)'
,p_lov_return_value=>'ar-dz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296485197493642103)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Bahrain) (ar-bh)'
,p_lov_return_value=>'ar-bh'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296485530520642103)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Egypt) (ar-eg)'
,p_lov_return_value=>'ar-eg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296485952633642103)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Iraq) (ar-iq)'
,p_lov_return_value=>'ar-iq'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296486378622642105)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Jordan) (ar-jo)'
,p_lov_return_value=>'ar-jo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296486704449642105)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Kuwait) (ar-kw)'
,p_lov_return_value=>'ar-kw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296487119052642106)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Lebanon) (ar-lb)'
,p_lov_return_value=>'ar-lb'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296487515983642106)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Libya) (ar-ly)'
,p_lov_return_value=>'ar-ly'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296487959889642106)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Morocco) (ar-ma)'
,p_lov_return_value=>'ar-ma'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296488363608642106)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Oman) (ar-om)'
,p_lov_return_value=>'ar-om'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296488738951642107)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Qatar) (ar-qa)'
,p_lov_return_value=>'ar-qa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296489191922642107)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Saudi Arabia) (ar-sa)'
,p_lov_return_value=>'ar-sa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296489586417642107)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Syria) (ar-sy)'
,p_lov_return_value=>'ar-sy'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296489992609642107)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Tunisia) (ar-tn)'
,p_lov_return_value=>'ar-tn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296490352659642107)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (U.A.E.) (ar-ae)'
,p_lov_return_value=>'ar-ae'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296490766379642108)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Yemen) (ar-ye)'
,p_lov_return_value=>'ar-ye'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296491133494642108)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Assamese (as)'
,p_lov_return_value=>'as'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296491527502642108)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Basque (eu)'
,p_lov_return_value=>'eu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296491997086642110)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Belarusian (be)'
,p_lov_return_value=>'be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296492341696642111)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bengali (bn)'
,p_lov_return_value=>'bn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296492776420642111)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgarian (bg)'
,p_lov_return_value=>'bg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296493106367642111)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalan (ca)'
,p_lov_return_value=>'ca'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296493576433642111)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (zh)'
,p_lov_return_value=>'zh'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296493945389642111)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (China) (zh-cn)'
,p_lov_return_value=>'zh-cn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296494388388642112)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Hong Kong SAR) (zh-hk)'
,p_lov_return_value=>'zh-hk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296494715258642112)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Macau SAR) (zh-mo)'
,p_lov_return_value=>'zh-mo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296495112486642112)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Singapore) (zh-sg)'
,p_lov_return_value=>'zh-sg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296495540862642112)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Taiwan) (zh-tw)'
,p_lov_return_value=>'zh-tw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296495910389642113)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croatian (hr)'
,p_lov_return_value=>'hr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296496371800642113)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Czech (cs)'
,p_lov_return_value=>'cs'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296496708213642113)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Danish (da)'
,p_lov_return_value=>'da'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296497167617642113)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dutch (Belgium) (nl-be)'
,p_lov_return_value=>'nl-be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296497589922642114)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dutch (Netherlands) (nl)'
,p_lov_return_value=>'nl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296497903409642114)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (en)'
,p_lov_return_value=>'en'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296498393658642114)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Australia) (en-au)'
,p_lov_return_value=>'en-au'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296498767825642114)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Belize) (en-bz)'
,p_lov_return_value=>'en-bz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296499182266642115)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Canada) (en-ca)'
,p_lov_return_value=>'en-ca'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296499505926642115)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Ireland) (en-ie)'
,p_lov_return_value=>'en-ie'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296499999964642115)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Jamaica) (en-jm)'
,p_lov_return_value=>'en-jm'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296500353120642115)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (New Zealand) (en-nz)'
,p_lov_return_value=>'en-nz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296500745596642115)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Philippines) (en-ph)'
,p_lov_return_value=>'en-ph'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296501139415642116)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (South Africa) (en-za)'
,p_lov_return_value=>'en-za'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296501541986642116)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Trinidad) (en-tt)'
,p_lov_return_value=>'en-tt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296501933958642116)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (United Kingdom) (en-gb)'
,p_lov_return_value=>'en-gb'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296502318452642116)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (United States) (en-us)'
,p_lov_return_value=>'en-us'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296502791836642120)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Zimbabwe) (en-zw)'
,p_lov_return_value=>'en-zw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296503126558642120)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonian (et)'
,p_lov_return_value=>'et'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296503560437642120)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'FYRO Macedonian (mk)'
,p_lov_return_value=>'mk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296503990726642120)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Faeroese (fo)'
,p_lov_return_value=>'fo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296504379778642121)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Farsi (fa)'
,p_lov_return_value=>'fa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296504743054642121)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Switzerland) (fr-ch)'
,p_lov_return_value=>'fr-ch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296505195260642121)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finnish (fi)'
,p_lov_return_value=>'fi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296505513232642121)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Belgium) (fr-be)'
,p_lov_return_value=>'fr-be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296505920139642121)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Canada) (fr-ca)'
,p_lov_return_value=>'fr-ca'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296506312396642122)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (France) (fr)'
,p_lov_return_value=>'fr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296506742232642122)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Luxembourg) (fr-lu)'
,p_lov_return_value=>'fr-lu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296507171478642122)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Monaco) (fr-mc)'
,p_lov_return_value=>'fr-mc'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296507595808642122)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gaelic (gd)'
,p_lov_return_value=>'gd'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296507936741642123)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Galician (gl)'
,p_lov_return_value=>'gl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296508307181642123)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Austria) (de-at)'
,p_lov_return_value=>'de-at'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296508773993642123)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Germany) (de)'
,p_lov_return_value=>'de'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296509153713642123)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Liechtenstein) (de-li)'
,p_lov_return_value=>'de-li'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296509517488642124)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Luxemgourg) (de-lu)'
,p_lov_return_value=>'de-lu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296509940150642124)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Switzerland) (de-ch)'
,p_lov_return_value=>'de-ch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296510330758642124)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Greek (el)'
,p_lov_return_value=>'el'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296510796379642124)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gujarati (gu)'
,p_lov_return_value=>'gu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296511194736642124)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hebrew (he)'
,p_lov_return_value=>'he'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296511592198642125)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hindi (hi)'
,p_lov_return_value=>'hi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296511922757642125)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hungarian (hu)'
,p_lov_return_value=>'hu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296512356349642125)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Icelandic (is)'
,p_lov_return_value=>'is'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296512796329642128)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesian (id)'
,p_lov_return_value=>'id'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296513172622642128)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italian (Italy) (it)'
,p_lov_return_value=>'it'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296513524660642128)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italian (Switzerland) (it-ch)'
,p_lov_return_value=>'it-ch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296513912620642128)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japanese (ja)'
,p_lov_return_value=>'ja'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296514319175642129)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kannada (kn)'
,p_lov_return_value=>'kn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296514774305642129)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakh (kk)'
,p_lov_return_value=>'kk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296515133994642129)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Konkani (kok)'
,p_lov_return_value=>'kok'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296515574341642129)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Korean (ko)'
,p_lov_return_value=>'ko'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296515968906642130)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kyrgyz (kz)'
,p_lov_return_value=>'kz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296516363075642130)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Latvian (lv)'
,p_lov_return_value=>'lv'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296516771199642130)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lithuanian (lt)'
,p_lov_return_value=>'lt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296517191200642130)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malay (Malaysia) (ms)'
,p_lov_return_value=>'ms'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296517568622642131)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malayalam (ml)'
,p_lov_return_value=>'ml'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296517929161642131)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Maltese (mt)'
,p_lov_return_value=>'mt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296518380709642131)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marathi (mr)'
,p_lov_return_value=>'mr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296518735532642131)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nepali (India) (ne)'
,p_lov_return_value=>'ne'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296519188847642132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Bokmal) (nb-no)'
,p_lov_return_value=>'nb-no'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296519544264642132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Bokmal) (no)'
,p_lov_return_value=>'no'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296519991628642132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Nynorsk) (nn-no)'
,p_lov_return_value=>'nn-no'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296520337752642132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oriya (or)'
,p_lov_return_value=>'or'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296520740397642133)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polish (pl)'
,p_lov_return_value=>'pl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296521189406642133)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portuguese (Brazil) (pt-br)'
,p_lov_return_value=>'pt-br'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296521552935642133)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portuguese (Portugal) (pt)'
,p_lov_return_value=>'pt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296521957262642133)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Punjabi (pa)'
,p_lov_return_value=>'pa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296522310141642143)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Romanian (ro)'
,p_lov_return_value=>'ro'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296522787167642143)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russian (ru)'
,p_lov_return_value=>'ru'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296523155482642144)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russian (Moldova) (ru-md)'
,p_lov_return_value=>'ru-md'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296523501978642144)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (sr)'
,p_lov_return_value=>'sr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296523932050642144)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovak (sk)'
,p_lov_return_value=>'sk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296524394264642144)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovenian (sl)'
,p_lov_return_value=>'sl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296524748818642145)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Argentina) (es-ar)'
,p_lov_return_value=>'es-ar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296525189525642145)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Bolivia) (es-bo)'
,p_lov_return_value=>'es-bo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296525507671642145)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Chile) (es-cl)'
,p_lov_return_value=>'es-cl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296525987700642145)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Colombia) (es-co)'
,p_lov_return_value=>'es-co'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296526305793642145)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Costa Rica) (es-cr)'
,p_lov_return_value=>'es-cr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296526780633642146)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Dominican Republic) (es-do)'
,p_lov_return_value=>'es-do'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296527105027642146)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Ecuador) (es-ec)'
,p_lov_return_value=>'es-ec'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296527521735642146)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (El Salvador) (es-sv)'
,p_lov_return_value=>'es-sv'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296527910837642147)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Guatemala) (es-gt)'
,p_lov_return_value=>'es-gt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296528368787642147)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Honduras) (es-hn)'
,p_lov_return_value=>'es-hn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296528773411642147)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Mexico) (es-mx)'
,p_lov_return_value=>'es-mx'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296529184135642147)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Nicaragua) (es-ni)'
,p_lov_return_value=>'es-ni'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296529507439642147)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Panama) (es-pa)'
,p_lov_return_value=>'es-pa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296529926557642148)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Paraguay) (es-py)'
,p_lov_return_value=>'es-py'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296530383552642148)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Peru) (es-pe)'
,p_lov_return_value=>'es-pe'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296530715297642148)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Puerto Rico) (es-pr)'
,p_lov_return_value=>'es-pr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296531179227642148)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Traditional Sort) (es)'
,p_lov_return_value=>'es'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296531589511642149)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (United States) (es-us)'
,p_lov_return_value=>'es-us'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296531903782642149)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Uruguay) (es-uy)'
,p_lov_return_value=>'es-uy'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296532332946642149)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Venezuela) (es-ve)'
,p_lov_return_value=>'es-ve'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296532752481642150)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swedish (sv)'
,p_lov_return_value=>'sv'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296533143965642150)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swedish (Finland) (sv-fi)'
,p_lov_return_value=>'sv-fi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296533561181642150)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tamil (ta)'
,p_lov_return_value=>'ta'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296533984687642150)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Telugu (te)'
,p_lov_return_value=>'te'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296534344052642151)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Thai (th)'
,p_lov_return_value=>'th'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296534769456642151)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turkish (tr)'
,p_lov_return_value=>'tr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296535161615642151)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukrainian (uk)'
,p_lov_return_value=>'uk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296535564674642151)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Urdu (ur)'
,p_lov_return_value=>'ur'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296535917575642151)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Uzbek (uz)'
,p_lov_return_value=>'uz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296536397331642152)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnamese (vi)'
,p_lov_return_value=>'vi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296536782028642152)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bosnian (ba)'
,p_lov_return_value=>'ba'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296537142726642152)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Montenegrin (me)'
,p_lov_return_value=>'me'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296537521659642152)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irish (ga)'
,p_lov_return_value=>'ga'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296537987555642153)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Welsh (cy)'
,p_lov_return_value=>'cy'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296538359786642153)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swahili (sw)'
,p_lov_return_value=>'sw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296538768082642153)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Albanian'
,p_lov_return_value=>'sq'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296539113771642153)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Armenian'
,p_lov_return_value=>'hy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_display_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3428075204157397882)
,p_lov_name=>'ITEM_DISPLAY_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name d, name_with_prefix r',
'from wwv_flow_native_plugins',
'where plugin_type = ''ITEM TYPE''',
'and name_with_prefix in (',
'    ''NATIVE_TEXT_FIELD'',',
'    ''NATIVE_TEXTAREA'',',
'    ''NATIVE_SELECT_LIST'',',
'    ''NATIVE_POPUP_LOV'',',
'    ''NATIVE_RADIOGROUP'',',
'    ''NATIVE_CHECKBOX'',',
'    ''NATIVE_YES_NO'',',
'    ''NATIVE_HIDDEN'',',
'    ''NATIVE_DATE_PICKER_APEX'',',
'    ''NATIVE_NUMBER_FIELD'',',
'    ''NATIVE_TEXTAREA'',',
'    ''NATIVE_FILE'')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556838
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_gallery
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2639572067402672315)
,p_lov_name=>'JET_CHART_GALLERY'
,p_lov_query=>'.'||wwv_flow_imp.id(2639572067402672315)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556838
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2639572308217672319)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Area'
,p_lov_return_value=>'area'
,p_lov_template=>'#DISPLAY_VALUE#|chart-area'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2639572724969672320)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bar'
,p_lov_return_value=>'bar'
,p_lov_template=>'#DISPLAY_VALUE#|chart-bar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2639574313919672321)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Donut'
,p_lov_return_value=>'donut'
,p_lov_template=>'#DISPLAY_VALUE#|chart-donut'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2639575505658672323)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'line'
,p_lov_template=>'#DISPLAY_VALUE#|chart-line'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2639575903894672325)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Line with Area'
,p_lov_return_value=>'lineWithArea'
,p_lov_template=>'#DISPLAY_VALUE#|chart-line-area'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2639576794816672326)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Pie'
,p_lov_return_value=>'pie'
,p_lov_template=>'#DISPLAY_VALUE#|chart-pie'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_gallery_select
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2646907365505462337)
,p_lov_name=>'JET_CHART_GALLERY_SELECT'
,p_lov_query=>'.'||wwv_flow_imp.id(2646907365505462337)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556838
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2646907697589462341)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Area'
,p_lov_return_value=>'area'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2646908033307462344)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bar'
,p_lov_return_value=>'bar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2646908742159462345)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'line'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2646909596402462345)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Pie'
,p_lov_return_value=>'pie'
);
end;
/
prompt --application/shared_components/user_interface/lovs/language_derived_from
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3030571620235275777)
,p_lov_name=>'LANGUAGE_DERIVED_FROM'
,p_lov_query=>'.'||wwv_flow_imp.id(3030571620235275777)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556838
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3030571910025275781)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No NLS (Application not translated)'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3030572315095275783)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Application Primary Language'
,p_lov_return_value=>'FLOW_PRIMARY_LANGUAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3030572762231275784)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Browser (use browser language preference)'
,p_lov_return_value=>'BROWSER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3030573197044275784)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Application Preference (use FSP_LANGUAGE_PREFERENCE)'
,p_lov_return_value=>'FLOW_PREFERENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3030573587174275784)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Item Preference (use item containing preference)'
,p_lov_return_value=>'ITEM_PREFERENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3030573997459275784)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Session'
,p_lov_return_value=>'SESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flows
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3674102416840483201)
,p_lov_name=>'LIST FLOWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556838
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2583404809878256688)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) a, schema b',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556838
);
end;
/
prompt --application/shared_components/user_interface/lovs/map_region_geometry_column_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4053243666374435)
,p_lov_name=>'MAP_REGION_GEOMETRY_COLUMN_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(4053243666374435)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556838
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4053546899374449)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Geometry Column'
,p_lov_return_value=>'GEOMETRY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4053958565374450)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Two Numeric Columns'
,p_lov_return_value=>'NUMBER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/map_region_layer_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3749589329218593)
,p_lov_name=>'MAP_REGION_LAYER_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(3749589329218593)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556838
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3749817614218609)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Points'
,p_lov_return_value=>'POINT'
,p_lov_template=>'#DISPLAY_VALUE#|map-points'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3750211117218610)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lines'
,p_lov_return_value=>'LINE'
,p_lov_template=>'#DISPLAY_VALUE#|map-lines'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3750605580218610)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Polygons'
,p_lov_return_value=>'POLYGON'
,p_lov_template=>'#DISPLAY_VALUE#|map-polygons'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3751020180218610)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Heat Map'
,p_lov_return_value=>'HEATMAP'
,p_lov_template=>'#DISPLAY_VALUE#|map-heatmap'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3751473242218610)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Extruded Polygons'
,p_lov_return_value=>'POLYGON_3D'
,p_lov_template=>'#DISPLAY_VALUE#|map-extruded-polgygons'
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_position
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2595597506957104820)
,p_lov_name=>'NAV_POSITION'
,p_lov_query=>'.'||wwv_flow_imp.id(2595597506957104820)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556838
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595597823255104834)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Side'
,p_lov_return_value=>'SIDE'
,p_lov_template=>'<span class="a-Icon icon-nav-side" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595598259378104835)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Top'
,p_lov_return_value=>'TOP'
,p_lov_template=>'<span class="a-Icon icon-nav-top" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_or_existing_schema
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2709274728272946842)
,p_lov_name=>'NEW_OR_EXISTING_SCHEMA'
,p_lov_query=>'.'||wwv_flow_imp.id(2709274728272946842)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556838
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2709275016281946843)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use an existing schema from the database'
,p_lov_return_value=>'NO'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'F4700_REQ_NEW_SCHEMA'
,p_lov_disp_cond2=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2709275215977946843)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Request a new schema'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1000_more_page_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(599910129386444402)
,p_lov_name=>'P1000_MORE_PAGE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(599910129386444402)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556838
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(599919494157448944)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Classic Report'
,p_lov_return_value=>'CLASSIC_REPORT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-classic-rpt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3900754663275661)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Multiple Reports'
,p_lov_return_value=>'MULTI_RPT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-rpt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(599914473819444406)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Timeline'
,p_lov_return_value=>'TIMELINE'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-timeline'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>':P1_THEME_TYPE'
,p_lov_disp_cond2=>'CUSTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4839782074400363)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Wizard'
,p_lov_return_value=>'WIZARD'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-wizard'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1000_page_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2595619325504357130)
,p_lov_name=>'P1000_PAGE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2595619325504357130)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556840
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595619721367357132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Blank'
,p_lov_return_value=>'BLANK'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-blank'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595622554281357135)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-calendar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3314495786637316189)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Cards'
,p_lov_return_value=>'CARDS'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-cards'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'P1_THEME_TYPE'
,p_lov_disp_cond2=>'CUSTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595620547567357132)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'CHART'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-chart'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595620169572357132)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Dashboard'
,p_lov_return_value=>'DASHBOARD'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-dashboard'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(599817715593042666)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Faceted Search'
,p_lov_return_value=>'FACETED_SEARCH'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-faceted-search'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4838887966389682)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Smart Filters'
,p_lov_return_value=>'SMART_FILTERS'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-smart-filters'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3314495333442316187)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Form'
,p_lov_return_value=>'FORM'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-form'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595621784230357135)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Interactive Grid'
,p_lov_return_value=>'INTERACTIVE_GRID'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-grid'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595621327200357134)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-rpt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3755880118235168)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Map'
,p_lov_return_value=>'MAP'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-map'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595622950759357135)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Master Detail'
,p_lov_return_value=>'MASTER_DETAIL'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-master-detail'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1020_fk_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(193526090453792695)
,p_lov_name=>'P1020_FK_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P1020_TABLE',
'and c.child_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'CHILD_COLUMN'
,p_display_column_name=>'CHILD_COLUMN'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'POSITION'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75556840
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1040_detail_tables
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(193968510657395041)
,p_lov_name=>'P1040_DETAIL_TABLES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'CHILD_TABLE'
,p_display_column_name=>'CHILD_TABLE'
,p_default_sort_column_name=>'CHILD_TABLE'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75556840
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1140_report_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(599933630533543253)
,p_lov_name=>'P1140_REPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(599933630533543253)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556840
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(599934700887543254)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'CR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(599935195629543254)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Cards'
,p_lov_return_value=>'CARD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p120_app_colors
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2698004887684998460)
,p_lov_name=>'P120_APP_COLORS'
,p_lov_query=>'.'||wwv_flow_imp.id(2698004887684998460)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556840
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2698005120905998460)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Blue'
,p_lov_return_value=>'#309FDB'
,p_lov_template=>'<span class="app-color app-color-1" title="#DISPLAY_VALUE#" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2698005566340998461)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Light Blue'
,p_lov_return_value=>'#2EBFBC'
,p_lov_template=>'<span class="app-color app-color-2" title="#DISPLAY_VALUE#" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2698005902074998461)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Green'
,p_lov_return_value=>'#81BB5F'
,p_lov_template=>'<span class="app-color app-color-3" title="#DISPLAY_VALUE#" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2698006373906998463)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Orange'
,p_lov_return_value=>'#ED813E'
,p_lov_template=>'<span class="app-color app-color-4" title="#DISPLAY_VALUE#" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2698006700015998463)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Red'
,p_lov_return_value=>'#E95B54'
,p_lov_template=>'<span class="app-color app-color-5" title="#DISPLAY_VALUE#" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2698008277439008881)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Pink'
,p_lov_return_value=>'#CA589D'
,p_lov_template=>'<span class="app-color app-color-6" title="#DISPLAY_VALUE#" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2698008693252008882)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Purple'
,p_lov_return_value=>'#5A68AD'
,p_lov_template=>'<span class="app-color app-color-7" title="#DISPLAY_VALUE#" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2698009071872008882)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Grey'
,p_lov_return_value=>'#6E8598'
,p_lov_template=>'<span class="app-color app-color-8" title="#DISPLAY_VALUE#" aria-label="#DISPLAY_VALUE#"></span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p120_app_icons
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2672360045214033881)
,p_lov_name=>'P120_APP_ICONS'
,p_lov_query=>'.'||wwv_flow_imp.id(2672360045214033881)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556840
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2672360783542033891)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Folder'
,p_lov_return_value=>'folder'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-folder'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2672361118269033891)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Spreadsheet'
,p_lov_return_value=>'spreadsheet'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-spreadsheet'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2672361590756033892)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Messages'
,p_lov_return_value=>'talk-bubbles'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-talk-bubbles'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699145586411626416)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Analytics'
,p_lov_return_value=>'analytics'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-analytics'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699146013974630462)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Bar Chart'
,p_lov_return_value=>'bar-line-chart'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-bar-line-chart'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699146300507631479)
,p_lov_disp_sequence=>34
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'calendar'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-calendar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699147272435638605)
,p_lov_disp_sequence=>44
,p_lov_disp_value=>'Cloud'
,p_lov_return_value=>'cloud'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-cloud'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699147530894639704)
,p_lov_disp_sequence=>54
,p_lov_disp_value=>'Cubes'
,p_lov_return_value=>'cubes'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-cubes'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2672360336003033886)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Mail'
,p_lov_return_value=>'email'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-email'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699147943869640428)
,p_lov_disp_sequence=>64
,p_lov_disp_value=>'Database'
,p_lov_return_value=>'database'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-database'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699148332077641373)
,p_lov_disp_sequence=>74
,p_lov_disp_value=>'Gear'
,p_lov_return_value=>'gear'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-gear'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699148765248642204)
,p_lov_disp_sequence=>84
,p_lov_disp_value=>'Graphs'
,p_lov_return_value=>'graphs'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-graphs'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699149018852643303)
,p_lov_disp_sequence=>94
,p_lov_disp_value=>'Map'
,p_lov_return_value=>'map'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-map'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699149413407644014)
,p_lov_disp_sequence=>104
,p_lov_disp_value=>'People'
,p_lov_return_value=>'people'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-people'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699150110351645207)
,p_lov_disp_sequence=>114
,p_lov_disp_value=>'Smiley'
,p_lov_return_value=>'smiley'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-smiley'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2699150731371656095)
,p_lov_disp_sequence=>124
,p_lov_disp_value=>'To Do'
,p_lov_return_value=>'todo'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-todo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2702987570335615680)
,p_lov_disp_sequence=>134
,p_lov_disp_value=>'Bug'
,p_lov_return_value=>'bug'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-bug'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2702988039145618805)
,p_lov_disp_sequence=>144
,p_lov_disp_value=>'Dots'
,p_lov_return_value=>'dots'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-dots'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2702988335963620469)
,p_lov_disp_sequence=>154
,p_lov_disp_value=>'Gauge'
,p_lov_return_value=>'gauge'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-gauge'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2702989530631642963)
,p_lov_disp_sequence=>164
,p_lov_disp_value=>'Grid'
,p_lov_return_value=>'grid'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-grid'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2702990096402645004)
,p_lov_disp_sequence=>174
,p_lov_disp_value=>'Pencil and Paper'
,p_lov_return_value=>'pencil-paper'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-pencil-paper'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2702990316302646280)
,p_lov_disp_sequence=>184
,p_lov_disp_value=>'Toolbox'
,p_lov_return_value=>'toolbox'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-toolbox'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2702990629320647262)
,p_lov_disp_sequence=>194
,p_lov_disp_value=>'Wrench'
,p_lov_return_value=>'wrench'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-wrench'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2702994227074670326)
,p_lov_disp_sequence=>204
,p_lov_disp_value=>'Activity'
,p_lov_return_value=>'activity'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-activity'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174262117726416555)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>'Stopwatch'
,p_lov_return_value=>'stopwatch'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-stopwatch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174262563826416555)
,p_lov_disp_sequence=>301
,p_lov_disp_value=>'Pie Chart'
,p_lov_return_value=>'pie-chart'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-pie-chart'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174262934715416555)
,p_lov_disp_sequence=>302
,p_lov_disp_value=>'Checkmark'
,p_lov_return_value=>'check-circle'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-check-circle'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174263328775416556)
,p_lov_disp_sequence=>303
,p_lov_disp_value=>'Rocket'
,p_lov_return_value=>'rocket'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-rocket'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174263755285416556)
,p_lov_disp_sequence=>304
,p_lov_disp_value=>'Shield'
,p_lov_return_value=>'shield'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-shield'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174264105771416556)
,p_lov_disp_sequence=>305
,p_lov_disp_value=>'Lightbulb'
,p_lov_return_value=>'lightbulb'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-lightbulb'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174264503042416556)
,p_lov_disp_sequence=>306
,p_lov_disp_value=>'Lock'
,p_lov_return_value=>'lock'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-lock'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174264993774416557)
,p_lov_disp_sequence=>307
,p_lov_disp_value=>'Ship'
,p_lov_return_value=>'ship'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-ship'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1_navigation_position
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2621239147915611502)
,p_lov_name=>'P1_NAVIGATION_POSITION'
,p_lov_query=>'.'||wwv_flow_imp.id(2621239147915611502)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556841
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2621239461519611503)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Side Menu'
,p_lov_return_value=>'SIDE'
,p_lov_template=>'#DISPLAY_VALUE# | ca-Icon nav-icon nav-side'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2621239868592611505)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Top Menu'
,p_lov_return_value=>'TOP'
,p_lov_template=>'#DISPLAY_VALUE# | ca-Icon nav-icon nav-top'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(253970343865000428)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Mega Menu'
,p_lov_return_value=>'MEGA'
,p_lov_template=>'#DISPLAY_VALUE# | ca-Icon nav-icon nav-mega-menu'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1_theme_styles
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2595731361215290332)
,p_lov_name=>'P1_THEME_STYLES'
,p_lov_query=>'.'||wwv_flow_imp.id(2595731361215290332)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556841
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595731647478290334)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vita'
,p_lov_return_value=>'Vita'
,p_lov_template=>'#DISPLAY_VALUE# | theme-icon theme-vita'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595732072323290334)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Vita - Dark'
,p_lov_return_value=>'Vita - Dark'
,p_lov_template=>'#DISPLAY_VALUE# | theme-icon theme-vita-dark'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595732485910290335)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Redwood Light'
,p_lov_return_value=>'Redwood Light'
,p_lov_template=>'#DISPLAY_VALUE# | theme-icon theme-redwood'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3286815898649753964)
,p_lov_name=>'PAGE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(3286815898649753964)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556842
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3286816136407753971)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Blank'
,p_lov_return_value=>'BLANK'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-blank'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3286816423426753976)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Dashboard'
,p_lov_return_value=>'DASHBOARD'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-dashboard'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595567847775637051)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'CHART'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-dashboard'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2561899148127324757)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Classic Report'
,p_lov_return_value=>'CLASSIC_RPT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-classic-rpt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2561902001788398153)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'INTERACTIVE_RPT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-rpt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2577864430538034696)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Interactive Grid'
,p_lov_return_value=>'INTERACTIVE_GRID'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-grid'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2577864810590034698)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Faceted Search'
,p_lov_return_value=>'FACETED_SEARCH'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-card-faceted-search'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2588628706152153910)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-calendar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2588629041652155067)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Form'
,p_lov_return_value=>'FORM'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-form'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3345504345772661039)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Master Detail'
,p_lov_return_value=>'MASTER_DETAIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3447755827550882639)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Cards'
,p_lov_return_value=>'CARDS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3447756177637884382)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Timeline'
,p_lov_return_value=>'TIMELINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3447917238443966847)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Wizard'
,p_lov_return_value=>'WIZARD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5000408550056154)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Map'
,p_lov_return_value=>'MAP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4851809191812526)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Smart Filters'
,p_lov_return_value=>'SMART_FILTERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pagination
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3348566714295666169)
,p_lov_name=>'PAGINATION'
,p_lov_query=>'.'||wwv_flow_imp.id(3348566714295666169)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556842
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3348567074901666172)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Row Ranges X to Y of Z'
,p_lov_return_value=>'ROWS_X_TO_Y_OF_Z'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3348567471986666172)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Row Ranges X to Y'
,p_lov_return_value=>'ROWS_X_TO_Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2595616854306352005)
,p_lov_name=>'REPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2595616854306352005)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556842
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595617121416352006)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'INTERACTIVE_RPT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2595617998727352007)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Classic Report'
,p_lov_return_value=>'CLASSIC_RPT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/right_to_left
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(560908550288645029)
,p_lov_name=>'RIGHT-TO-LEFT'
,p_lov_query=>'.'||wwv_flow_imp.id(560908550288645029)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556842
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(560908890865645033)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Left-To-Right'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(560909229625645034)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Right-To-Left'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3052299639682461644)
,p_lov_name=>'SECONDS'
,p_reference_id=>218750809842831008
,p_lov_query=>'.'||wwv_flow_imp.id(3052299639682461644)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052313333207461705)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'10 seconds'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052313763928461705)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1 minute'
,p_lov_return_value=>'60'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052314194318461706)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'10 minutes'
,p_lov_return_value=>'600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052314561907461706)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'30 minutes'
,p_lov_return_value=>'1800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052314905802461706)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'1 hour'
,p_lov_return_value=>'3600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052315380890461706)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'2 hours'
,p_lov_return_value=>'7200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052315720757461707)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'3 hours'
,p_lov_return_value=>'10800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052316192741461707)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'4 hours'
,p_lov_return_value=>'14400'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052316593027461707)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'6 hours'
,p_lov_return_value=>'21600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052316902496461707)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'12 hours'
,p_lov_return_value=>'43200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052317383400461708)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1 day'
,p_lov_return_value=>'86400'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052317744167461708)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'2 days'
,p_lov_return_value=>'172800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052318196277461708)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'3 days'
,p_lov_return_value=>'259200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052318503570461709)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'4 days'
,p_lov_return_value=>'345600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052318964100461709)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'1 week'
,p_lov_return_value=>'604800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052319386375461709)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'2 weeks'
,p_lov_return_value=>'1209600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052319724314461709)
,p_lov_disp_sequence=>155
,p_lov_disp_value=>'4 Weeks'
,p_lov_return_value=>'2419200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052320114213461710)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'10 Weeks'
,p_lov_return_value=>'6048000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3052320587074461710)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'1 Year'
,p_lov_return_value=>'31536000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/source_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2593539478572840546)
,p_lov_name=>'SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(2593539478572840546)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556842
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2593540111329840547)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Table or View'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2593539775589840547)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/translations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2928230523118997204)
,p_lov_name=>'TRANSLATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.translated_lang_name as lang_name, f.flow_language',
'from ( select flow_language',
'          from wwv_flows f',
'         where id = :APP_ID',
'         union',
'        select flow_language',
'          from wwv_flows f',
'         where id in ( select translation_flow_id',
'                         from wwv_flow_language_map',
'                        where primary_language_flow_id = :APP_ID )',
'      ) f,',
'      wwv_flow_languages l',
'where f.flow_language = l.lang_id',
'order by nlssort( l.translated_lang_name, ''NLS_SORT=binary'' )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556842
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_page_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3315174268901073640)
,p_lov_name=>'WIZARD_PAGE_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(3315174268901073640)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556842
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3315174903811073644)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal Page'
,p_lov_return_value=>'NORMAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3315174580312073643)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Modal Dialog'
,p_lov_return_value=>'MODAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(308890279143049193)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Drawer'
,p_lov_return_value=>'DRAWER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2660244068801532757)
,p_lov_name=>'YES_NO'
,p_lov_query=>'.'||wwv_flow_imp.id(2660244068801532757)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556842
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2660244358492532761)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2660244720718532764)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(2704744005996589822)
,p_theme_id=>101
,p_name=>'[x] APEX 5.0 - Dialog'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,baseDialogClass:''a-Dialog--uiDialog'',dialogClass:#DIALOG_CSS_CLASSES#,jsDialogClass:true,#DIALOG'
||'_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293479160712977311)
,p_page_template_id=>wwv_flow_imp.id(2704744005996589822)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293479621977977311)
,p_page_template_id=>wwv_flow_imp.id(2704744005996589822)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293480146440977311)
,p_page_template_id=>wwv_flow_imp.id(2704744005996589822)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(3221353480673840388)
,p_theme_id=>101
,p_name=>'APEX 5.0 - No Side Bar'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'    #REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'</header>',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div id="main" class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.'' aria-label=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.''><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1496640510768811)
,p_page_template_id=>wwv_flow_imp.id(3221353480673840388)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1497196265768811)
,p_page_template_id=>wwv_flow_imp.id(3221353480673840388)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1497689892768811)
,p_page_template_id=>wwv_flow_imp.id(3221353480673840388)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1498141079768811)
,p_page_template_id=>wwv_flow_imp.id(3221353480673840388)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1498613583768812)
,p_page_template_id=>wwv_flow_imp.id(3221353480673840388)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1499135972768812)
,p_page_template_id=>wwv_flow_imp.id(3221353480673840388)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1499636485768812)
,p_page_template_id=>wwv_flow_imp.id(3221353480673840388)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(3272976625713321802)
,p_theme_id=>101
,p_name=>'[x] Create App Page Wizard Dialog'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'',
'<head>',
'',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'<!--[if lt IE 9]><script src="#IMAGE_PREFIX#libraries/apex/html5_ie.js"></script><![endif]-->',
'  <meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove" aria-hidden="tru'
||'e"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove" aria-hidden="tru'
||'e"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140017184587349540)
,p_page_template_id=>wwv_flow_imp.id(3272976625713321802)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140017222963349540)
,p_page_template_id=>wwv_flow_imp.id(3272976625713321802)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140017317670349539)
,p_page_template_id=>wwv_flow_imp.id(3272976625713321802)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(3286599848719423369)
,p_theme_id=>101
,p_name=>'APEX 5.0 - Wizard Page'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'</header>',
'#REGION_POSITION_08#',
'<main class="a-Main" id="main">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="u-Layout u-Layout--centerVertically">',
'    <div class="a-Wizard a-Wizard--default">',
'      #REGION_POSITION_02#',
'      <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'      <div class="a-Wizard-body">#BODY#</div>',
'      <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'    </div>',
'  </div>',
'</main>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message" role="alert">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="errorMsg" role="region" aria-labelledby="page_warning_id">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''>',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h2 class="u-vh" id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      <div class="a-AlertMessages-messageTitle" id="errorMsg-Message" role="alert">#MESSAGE#</div>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'')'
||';return false;"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3615402879568258)
,p_page_template_id=>wwv_flow_imp.id(3286599848719423369)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3615924192568258)
,p_page_template_id=>wwv_flow_imp.id(3286599848719423369)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3616463286568258)
,p_page_template_id=>wwv_flow_imp.id(3286599848719423369)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3616931415568259)
,p_page_template_id=>wwv_flow_imp.id(3286599848719423369)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3617401053568259)
,p_page_template_id=>wwv_flow_imp.id(3286599848719423369)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3617954100568259)
,p_page_template_id=>wwv_flow_imp.id(3286599848719423369)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3618454679568259)
,p_page_template_id=>wwv_flow_imp.id(3286599848719423369)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(2583919293963280507)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/a_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(2610383412116095734)
,p_template_name=>'<a> button'
,p_internal_name=>'<A>_BUTTON'
,p_template=>'<a href="#LINK#" title="#LABEL!ATTR#" style="font-size:10px;margin:2px;">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>0
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="xpbutton" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tbody class="FFFFFF">',
'<tr>',
'<td class="L" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'<td class="C"><a href="#LINK#">#LABEL#</a></td>',
'<td class="R" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'</tr>',
'</tbody>',
'</table>'))
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(2758666493011882367)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_1_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(2859691107686228274)
,p_template_name=>'APEX 4.1 - Button'
,p_internal_name=>'APEX_4.1_BUTTON'
,p_template=>'<button class="aButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_hot_template=>'<button class="aButton hotButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="button-gray" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> ',
'',
'',
'<a href="#LINK#" class="button-orange" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> '))
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(2937736309958680193)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(2988804730938183125)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/dialog_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3012517609439119859)
,p_template_name=>'Dialog Button'
,p_internal_name=>'DIALOG_BUTTON'
,p_template=>'"#LABEL!ATTR#":#BUTTON_ATTRIBUTES#'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_menu_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3214935748485245802)
,p_template_name=>'APEX 5.0 - Icon Badge Menu Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3214935870969250916)
,p_template_name=>'APEX 5.0 - Icon Badge Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><span class="a-But'
||'ton-badge"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><spa'
||'n class="a-Button-badge"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_text_link
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3365552764774679721)
,p_template_name=>'APEX 5.0 - Text Link'
,p_internal_name=>'APEX_5.0_TEXT_LINK'
,p_template=>'<a href="#LINK#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_hot_template=>'<a href="#LINK#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_1_1_page_wizard_section
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2584574193315975428)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageWizard-section #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-PageWizard-sectionHeader">',
'    <h2>#TITLE#</h2>',
'    #HELP#',
'  </div>',
'  #BODY##SUB_REGIONS#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.1.1 - Page Wizard Section'
,p_internal_name=>'APEX_5.1.1_PAGE_WIZARD_SECTION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140435053356344581)
,p_plug_template_id=>wwv_flow_imp.id(2584574193315975428)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140435119121344581)
,p_plug_template_id=>wwv_flow_imp.id(2584574193315975428)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140435294393344581)
,p_plug_template_id=>wwv_flow_imp.id(2584574193315975428)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_and_region_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2586890391916064979)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 4.0 - Div with ID and Region Attributes'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>2974803291668087
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60414699839125954)
,p_plug_template_id=>wwv_flow_imp.id(2586890391916064979)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60415178298125957)
,p_plug_template_id=>wwv_flow_imp.id(2586890391916064979)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2601269795393996833)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_form_table_attr=>' '
,p_reference_id=>17354206769599941
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135719767664120555)
,p_plug_template_id=>wwv_flow_imp.id(2601269795393996833)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135720298255120555)
,p_plug_template_id=>wwv_flow_imp.id(2601269795393996833)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/top_bar_c_htmldbtopbarm
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2601271888770996836)
,p_layout=>'TABLE'
,p_template=>'<table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class="'
||'R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>'
,p_page_plug_template_name=>'Top Bar (c:htmldbTopBarM)'
,p_internal_name=>'TOP_BAR_C:HTMLDBTOPBARM'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17356300146599944
,p_translate_this_template=>'N'
,p_template_comment=>'<table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td width="10"><img src="#IMAGE_PREFIX#htmldb/builder/bar_top.png" width="10" height="8" alt="" /></td><'
||'td rowspan="3" valign="middle" class="L">#BODY#</td><td rowspan="3" width="30" class="C"><br /></td><td rowspan="3" valign="middle" class="R" align="right" style="white-space:nowrap;"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHAN'
||'GE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr><tr><td style="background-image:url(#IMAGE_PREFIX#htmldb/builder/bar_bg.png)"><br /></td></tr><tr><td><img src="#IMAGE_PREFIX#htmldb/builder/bar_bottom.png" width="10" height="8"  alt="" /></td></tr>'
||'</tbody></table>'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88463364021847092)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88463874085847092)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88464372032847093)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88464849942847093)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88465301842847093)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88465889475847093)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88466350099847094)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88466801937847094)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88467302156847094)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88467888120847094)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88468312480847095)
,p_plug_template_id=>wwv_flow_imp.id(2601271888770996836)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/top_bar_white_collapsed
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2601501911896508337)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="top-bar" #REGION_ATTRIBUTES#><div style="float: left">#BODY#</div><div style="float: left">#CLOSE##EDIT##DELETE##CREATE##CREATE2##PREVIOUS##NEXT#</div></div>',
''))
,p_page_plug_template_name=>'Top Bar (white) (collapsed)'
,p_internal_name=>'TOP_BAR_WHITE_COLLAPSED'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>21
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17586323272111445
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88453958201844685)
,p_plug_template_id=>wwv_flow_imp.id(2601501911896508337)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88454481463844685)
,p_plug_template_id=>wwv_flow_imp.id(2601501911896508337)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88454993670844686)
,p_plug_template_id=>wwv_flow_imp.id(2601501911896508337)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88455445438844686)
,p_plug_template_id=>wwv_flow_imp.id(2601501911896508337)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88455966433844686)
,p_plug_template_id=>wwv_flow_imp.id(2601501911896508337)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88456460244844686)
,p_plug_template_id=>wwv_flow_imp.id(2601501911896508337)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88456971087844687)
,p_plug_template_id=>wwv_flow_imp.id(2601501911896508337)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88457412261844687)
,p_plug_template_id=>wwv_flow_imp.id(2601501911896508337)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88457945212844687)
,p_plug_template_id=>wwv_flow_imp.id(2601501911896508337)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_message_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2613249515740447736)
,p_layout=>'TABLE'
,p_template=>'<div class="a-SystemMessage #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Message Region'
,p_internal_name=>'APEX_5.0_MESSAGE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>29333927116050844
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(229906765841787143)
,p_plug_template_id=>wwv_flow_imp.id(2613249515740447736)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(229907262373787144)
,p_plug_template_id=>wwv_flow_imp.id(2613249515740447736)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2626126299499639372)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>101
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88187222352816927)
,p_plug_template_id=>wwv_flow_imp.id(2626126299499639372)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88187766096816927)
,p_plug_template_id=>wwv_flow_imp.id(2626126299499639372)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/ppr_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2664982500969247843)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_ID#"><htmldb:PPR_#REGION_ID#>#BODY#</htmldb:PPR_#REGION_ID#></div>'
,p_page_plug_template_name=>'PPR Region'
,p_internal_name=>'PPR_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>81066912344850951
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88478737985850449)
,p_plug_template_id=>wwv_flow_imp.id(2664982500969247843)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88479257435850449)
,p_plug_template_id=>wwv_flow_imp.id(2664982500969247843)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/no_buttons_no_title
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2674461889133348159)
,p_layout=>'TABLE'
,p_template=>'<table class="htmldbRR" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#"><tbody><tr><td colspan="2" class="B">#BODY#</td></tr></tbody></table>'
,p_page_plug_template_name=>'No Buttons No Title'
,p_internal_name=>'NO_BUTTONS_NO_TITLE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>90546300508951267
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88481011271851818)
,p_plug_template_id=>wwv_flow_imp.id(2674461889133348159)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88481502986851818)
,p_plug_template_id=>wwv_flow_imp.id(2674461889133348159)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/popup_dialog
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2724541718684288181)
,p_layout=>'TABLE'
,p_template=>'<table style="display:none;position:absolute;background-color:#EEEEEE;border:#000000 solid 1px;padding:0px;text-align:center;font-size:12px;color:#000000;" summary="" cellpadding="0" cellspacing="0" border="0" id="#REGION_STATIC_ID#"><tr><td class="h'
||'tmldbWizardHeader"><h2>#TITLE#</h2></td><td class="htmldbWizardHeader" align="right"><span onClick="dhtml_CloseDialog(this);"><img src="#IMAGE_PREFIX#qb/vertical_close.png" /></span></td></tr><tr><td colspan="2" class="htmldbWizardBody">#BODY#</td></'
||'tr><tr><td colspan="2" align="right">#CLOSE#&nbsp;&nbsp;&nbsp;#DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#</td></tr></table>'
,p_page_plug_template_name=>'Popup Dialog'
,p_internal_name=>'POPUP_DIALOG'
,p_theme_id=>101
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>140626130059891289
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88472987571848536)
,p_plug_template_id=>wwv_flow_imp.id(2724541718684288181)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88473474207848536)
,p_plug_template_id=>wwv_flow_imp.id(2724541718684288181)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88473927188848536)
,p_plug_template_id=>wwv_flow_imp.id(2724541718684288181)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88474484657848536)
,p_plug_template_id=>wwv_flow_imp.id(2724541718684288181)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88474944845848537)
,p_plug_template_id=>wwv_flow_imp.id(2724541718684288181)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88475423530848537)
,p_plug_template_id=>wwv_flow_imp.id(2724541718684288181)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88475943619848537)
,p_plug_template_id=>wwv_flow_imp.id(2724541718684288181)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88476454470848537)
,p_plug_template_id=>wwv_flow_imp.id(2724541718684288181)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88476912093848538)
,p_plug_template_id=>wwv_flow_imp.id(2724541718684288181)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/horizontal_body_and_button_positions
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2733855215457005326)
,p_layout=>'TABLE'
,p_template=>'<table  cellpadding="0" cellspacing="0" border="0" summary="" class="htmldbButtonPositionsOnly" id="#REGION_STATIC_ID#"><tbody><tr><td>#BODY#</td><td style="padding-right:25px;">#CLOSE#</td><td>#PREVIOUS#</td><td>#NEXT#</td><td>#DELETE#</td><td>#CHAN'
||'GE##EDIT#</td><td>#CREATE#</td><td>#CREATE2#</td><td>#HELP#</td></tr></tbody></table>'
,p_page_plug_template_name=>'Horizontal Body and Button Positions'
,p_internal_name=>'HORIZONTAL_BODY_AND_BUTTON_POSITIONS'
,p_theme_id=>101
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>149939626832608434
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88489222792854620)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88489719066854620)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88490262693854620)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88490718310854621)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88491237587854621)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88491701866854621)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88492258309854621)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88492721235854622)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88493259605854622)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88493769621854622)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88494254885854622)
,p_plug_template_id=>wwv_flow_imp.id(2733855215457005326)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2758528811846759332)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-PageColumn-header">',
'    <h2 class="a-PageColumn-heading">#TITLE#</h2>',
'  </div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613223222362440
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88524852437940496)
,p_plug_template_id=>wwv_flow_imp.id(2758528811846759332)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88525314221940496)
,p_plug_template_id=>wwv_flow_imp.id(2758528811846759332)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2758529294157796426)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="toolbar" aria-label="#TITLE!ATTR#" class="a-Toolbar #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Toolbar-items a-Toolbar-items--left">#PREVIOUS#</div>',
'  <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar'
,p_internal_name=>'APEX_5.0_TOOLBAR'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613705533399534
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68591435536251718)
,p_plug_template_id=>wwv_flow_imp.id(2758529294157796426)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68591904493251718)
,p_plug_template_id=>wwv_flow_imp.id(2758529294157796426)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68592423335251719)
,p_plug_template_id=>wwv_flow_imp.id(2758529294157796426)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68592979478251719)
,p_plug_template_id=>wwv_flow_imp.id(2758529294157796426)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_left
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2758544003863874977)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--left #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Left)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_LEFT'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174628415239478085
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88421465401837811)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88421950201837812)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88422489009837812)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88422913805837812)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88423493973837812)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88423963785837813)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88424472350837813)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88424965507837813)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88425452140837814)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88425914755837814)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88426491039837814)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88426971351837814)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88427371344837815)
,p_plug_template_id=>wwv_flow_imp.id(2758544003863874977)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_right
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2758544719016898298)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--right #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Right)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_RIGHT'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174629130392501406
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88409261221836316)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88409760958836317)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88410219821836317)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88410756003836317)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88411204852836317)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88411723571836318)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88412255152836318)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88412728920836318)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88413270303836318)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88413763453836319)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88414228299836319)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88414703490836319)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88415201028836320)
,p_plug_template_id=>wwv_flow_imp.id(2758544719016898298)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column_body
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2758545604256903488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn-body #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column (Body)'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN_BODY'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174630015632506596
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88535634969967963)
,p_plug_template_id=>wwv_flow_imp.id(2758545604256903488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88536140503967963)
,p_plug_template_id=>wwv_flow_imp.id(2758545604256903488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2758664310411868479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>174748721787471587
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32424119848578739)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32424642401578740)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32425119680578740)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32425619811578740)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32426163219578740)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32426653784578741)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32427135548578741)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32427600110578741)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32428107455578742)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32428619121578742)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32429164772578742)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32429646420578743)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32430190168578743)
,p_plug_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/loading_region_hidden_by_default
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2811142913752487499)
,p_layout=>'TABLE'
,p_template=>'<div class="htmldbLoadingRegion" id="#REGION_STATIC_ID#" style="display:none;">#BODY#<br /><img src="#IMAGE_PREFIX#htmldb/icons/wait.gif"  id="loadingIcon" alt="" /></div>'
,p_page_plug_template_name=>'Loading Region (Hidden by Default)'
,p_internal_name=>'LOADING_REGION_HIDDEN_BY_DEFAULT'
,p_theme_id=>101
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>227227325128090607
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88483312150853287)
,p_plug_template_id=>wwv_flow_imp.id(2811142913752487499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88483805119853287)
,p_plug_template_id=>wwv_flow_imp.id(2811142913752487499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2983766147992137991)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>101
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88236720608825389)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88237289591825389)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88237730639825389)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88238267714825390)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88238747640825390)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88239246540825390)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88239775312825390)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88240223372825391)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88240766827825391)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88241246987825391)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88241788178825392)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88242287672825392)
,p_plug_template_id=>wwv_flow_imp.id(2983766147992137991)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_dialog
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3012513290302116971)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#"  class="a-DialogRegion js-regionDialog #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# style="display:none" title="#TITLE#">',
'  <div class="a-DialogRegion-body">',
'#BODY#',
'  </div>',
'  <div class="a-DialogRegion-buttons">',
'     <div class="a-ButtonRegion a-ButtonRegion--dialogRegion">',
'       <div class="a-ButtonRegion-wrap">',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'       </div>',
'     </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region Dialog'
,p_internal_name=>'APEX_5.0_REGION_DIALOG'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_template_options=>'js-draggable:js-resizable:js-modal'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>428597701677720079
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88376784221832841)
,p_plug_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88377273066832841)
,p_plug_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88377782460832842)
,p_plug_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88378233497832842)
,p_plug_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88378744021832842)
,p_plug_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88379208896832842)
,p_plug_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88379778215832843)
,p_plug_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88380210897832843)
,p_plug_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3262269949210718587)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <h2 id="#REGION_STATIC_ID#_heading" class="u-vh a-Region-header">#TITLE#</h2>',
'  #PREVIOUS##BODY##NEXT#',
'</div>',
''))
,p_page_plug_template_name=>'[x] APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>678354360586321695
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1497280921426779)
,p_plug_template_id=>wwv_flow_imp.id(3262269949210718587)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1497746175426779)
,p_plug_template_id=>wwv_flow_imp.id(3262269949210718587)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1498233187426779)
,p_plug_template_id=>wwv_flow_imp.id(3262269949210718587)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1498720624426780)
,p_plug_template_id=>wwv_flow_imp.id(3262269949210718587)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3271069058970016268)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>687153470345619376
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63689428053240642)
,p_plug_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63689977179240643)
,p_plug_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63690468884240643)
,p_plug_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63690977258240643)
,p_plug_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63691494855240644)
,p_plug_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63691974381240644)
,p_plug_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63692480049240644)
,p_plug_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63692988527240645)
,p_plug_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63693335362240645)
,p_plug_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3273871575473525717)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# #REGION_LANDMARK_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>689955986849128825
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1444869885065825)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1445381901065825)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1445830457065825)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1446348152065825)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1446863124065826)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1447307817065826)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1447849851065826)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1448357083065826)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1448890056065826)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1449308415065827)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1449863400065827)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1450337134065827)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1450832299065827)
,p_plug_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3282744828018275829)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span aria-hidden="true" class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>101
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>698829239393878937
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131657052238047146)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131657591849047146)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131658088833047147)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131658599398047147)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131659010529047147)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131659590379047148)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131660023078047148)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131660540017047148)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131661069399047149)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131661530304047149)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131662094891047149)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131662589270047150)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131663038839047150)
,p_plug_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3286693190338347807)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 id="#REGION_STATIC_ID#_TITLE" class="u-vh">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>702777601713950915
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214486418886485461)
,p_plug_template_id=>wwv_flow_imp.id(3286693190338347807)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214486930539485462)
,p_plug_template_id=>wwv_flow_imp.id(3286693190338347807)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3287384588973547661)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88133654162806714)
,p_plug_template_id=>wwv_flow_imp.id(3287384588973547661)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88134128210806714)
,p_plug_template_id=>wwv_flow_imp.id(3287384588973547661)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3300810815961795652)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32596899618747554)
,p_plug_template_id=>wwv_flow_imp.id(3300810815961795652)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32597387883747554)
,p_plug_template_id=>wwv_flow_imp.id(3300810815961795652)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32597826667747554)
,p_plug_template_id=>wwv_flow_imp.id(3300810815961795652)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32598367245747555)
,p_plug_template_id=>wwv_flow_imp.id(3300810815961795652)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_hidden_heading
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3301748405466464586)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region (Hidden Heading)'
,p_internal_name=>'APEX_5.0_REGION_HIDDEN_HEADING'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>717832816842067694
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88071738191788131)
,p_plug_template_id=>wwv_flow_imp.id(3301748405466464586)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88072297848788131)
,p_plug_template_id=>wwv_flow_imp.id(3301748405466464586)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_iframe_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3321664782165928798)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--iframe #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'  <div class="a-Region-iframeButtons">',
'    <div class="a-ButtonRegion">',
'      <div class="a-ButtonRegion-wrap">',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'          <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'        </div>',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - iFrame Region'
,p_internal_name=>'APEX_5.0_IFRAME_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--paddedBody'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>737749193541531906
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88095837177799063)
,p_plug_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88096366248799064)
,p_plug_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88096875536799064)
,p_plug_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88097335122799064)
,p_plug_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88097892834799064)
,p_plug_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88098322318799065)
,p_plug_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88098884793799065)
,p_plug_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88099398829799065)
,p_plug_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88099827122799066)
,p_plug_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3330277939666606656)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div role="alert" class="a-Alert-body">#BODY#</div>',
'    </div>',
'    <div class="a-Alert-buttons">#PREVIOUS##CLOSE##CREATE##NEXT#</div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>101
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>746362351042209764
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4899541076959748)
,p_plug_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4900023864959748)
,p_plug_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4900513248959748)
,p_plug_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4901074930959748)
,p_plug_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4901513006959748)
,p_plug_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4902055364959748)
,p_plug_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_accordion_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3331511935591010485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Accordion Region'
,p_internal_name=>'APEX_5.0_ACCORDION_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>747596346966613593
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60590840981209434)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60591391599209434)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60591878326209435)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60592395419209435)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60592829629209435)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60593394079209435)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60593846792209436)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60594316202209436)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60594856429209437)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60595309628209437)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60595836827209438)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60596300864209438)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60596872143209438)
,p_plug_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_workspace_login_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3365552953046687584)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Login-region a-Form--stretchInputs #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-Login-header">',
'    <span class="a-Login-logo gi-icon-apex-logo-icon" aria-hidden="true"></span>',
'    <h1 class="a-Login-title" id="#REGION_STATIC_ID#_TITLE">#TITLE#</h1>',
'  </div>',
'  <div class="a-Login-body">',
'    #BODY#',
'  </div>',
'  <div class="a-Login-buttons">',
'    #NEXT#',
'  </div>',
'  <div class="a-Login-links">',
'    #EDIT##CREATE#',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Workspace Login Region'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'form'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>781637364422290692
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53924061520418937)
,p_plug_template_id=>wwv_flow_imp.id(3365552953046687584)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53924591522418937)
,p_plug_template_id=>wwv_flow_imp.id(3365552953046687584)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53925088203418938)
,p_plug_template_id=>wwv_flow_imp.id(3365552953046687584)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53925527935418938)
,p_plug_template_id=>wwv_flow_imp.id(3365552953046687584)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53926064407418938)
,p_plug_template_id=>wwv_flow_imp.id(3365552953046687584)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_workspace_login_content_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3365628682004899102)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Login-infoRegion #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-Login-infoRegion-header">',
'    <h2 class="a-Login-infoRegion-title" id="#REGION_STATIC_ID#_TITLE">#TITLE#</h2>',
'  </div>',
'  <div class="a-Login-infoRegion-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Workspace Login Content Region'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_CONTENT_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>781713093380502210
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53938923165563468)
,p_plug_template_id=>wwv_flow_imp.id(3365628682004899102)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53939415744563469)
,p_plug_template_id=>wwv_flow_imp.id(3365628682004899102)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_1_tabs_with_icons_text
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3678578060703653018)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a aria-hidden="true" href="##SUB_REGION_ID#"><span title="#SUB_REGION_TITLE#" class="a-Icon #SUB_REGION_ICON_CSS_CLASSES#"></span><span class="a-Tabs-label">#SUB_REGION_TITLE#</span></a></li>'
,p_sub_plug_template=>'#SUB_REGION#'
,p_page_plug_template_name=>'[x] APEX 5.1 - Tabs with Icons + Text'
,p_internal_name=>'APEX_5.1_TABS_WITH_ICONS_+_TEXT'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_reference_id=>1094662472079256126
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68494839248610287)
,p_plug_template_id=>wwv_flow_imp.id(3678578060703653018)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68495353130610287)
,p_plug_template_id=>wwv_flow_imp.id(3678578060703653018)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68495874429610288)
,p_plug_template_id=>wwv_flow_imp.id(3678578060703653018)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3731195891703350618)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61237374472733466)
,p_plug_template_id=>wwv_flow_imp.id(3731195891703350618)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61237830186733466)
,p_plug_template_id=>wwv_flow_imp.id(3731195891703350618)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_grouping_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(3741609957292929669)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#" role="group" aria-labelledby="#REGION_STATIC_ID#_label">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title" id="#REGION_STATIC_ID#_label">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Grouping Region'
,p_internal_name=>'APEX_5.0_GROUPING_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--paddedBody:a-Region--simple'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1157694368668532777
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60785920533232512)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60786420968232512)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60786905965232513)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60787423717232513)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60787965471232513)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60788439218232513)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60788924409232514)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60789473307232514)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60789958208232514)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60790477210232515)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60790870495232515)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60791313728232515)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60791875991232515)
,p_plug_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_tree_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(4077427275300064682)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="a-PageDesigner-treeRegion resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>',
'  <div class="a-Toolbar a-Toolbar-pageColumn a-Toolbar--treeRegion">',
'    <div class="a-Toolbar-items a-Toolbar-items--left">',
'      <h3 class="a-PageDesigner-treeTitle">#TITLE#</h3>',
'    </div>',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  <div class="a-PageDesigner-treeWrap u-ScrollingViewport resize">',
'    #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Tree Region'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_TREE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>1493511686675667790
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88538334663976777)
,p_plug_template_id=>wwv_flow_imp.id(4077427275300064682)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88538846189976777)
,p_plug_template_id=>wwv_flow_imp.id(4077427275300064682)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88539398922976778)
,p_plug_template_id=>wwv_flow_imp.id(4077427275300064682)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_tabs_with_icons
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(4630165380147676460)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#"><span title="#SUB_REGION_TITLE#" class="a-Icon #SUB_REGION_ICON_CSS_CLASSES#"></span><span class="u-VisuallyHidden">#SUB_REGION_TITLE#</span></a></li>'
,p_sub_plug_template=>'#SUB_REGION#'
,p_page_plug_template_name=>'APEX 5.0 - Tabs with Icons'
,p_internal_name=>'APEX_5.0_TABS_WITH_ICONS'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2046249791523279568
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88642019225987177)
,p_plug_template_id=>wwv_flow_imp.id(4630165380147676460)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88642567849987177)
,p_plug_template_id=>wwv_flow_imp.id(4630165380147676460)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88643094150987178)
,p_plug_template_id=>wwv_flow_imp.id(4630165380147676460)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_standard_list_table_based
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2601300913516285374)
,p_list_template_current=>'<tr><td class="htmldbStandardList1"><a href="#LINK#" class="itemLink" title="#TEXT_ESC_SC#">#TEXT#</a></td></tr>'
,p_list_template_noncurrent=>'<tr><td class="htmldbStandardList2"><a href="#LINK#" class="itemLink" title="#TEXT_ESC_SC#">#TEXT#</a></td></tr>'
,p_list_template_name=>'(Done) Standard List (Table Based)'
,p_internal_name=>'DONE_STANDARD_LIST_TABLE_BASED'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbStandardList" cellpadding="0" cellspacing="0" border="0" summary="">',
'<tbody>'))
,p_list_template_after_rows=>'</tbody></table>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/dhtml_list_button_with_sublist
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2602098713851789269)
,p_list_template_current=>'<li>#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" class="dList" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_list_template_name=>'DHTML List Button with Sublist'
,p_internal_name=>'DHTML_LIST_BUTTON_WITH_SUBLIST'
,p_theme_id=>101
,p_theme_class_id=>10
,p_list_template_before_rows=>'<ul class="dList">'
,p_list_template_after_rows=>'</ul>'
,p_item_templ_curr_w_child=>'<li>#TEXT#</li>'
,p_item_templ_noncurr_w_child=>'<li><a href="#LINK#" class="dList" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_page_tab_navigation
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2602893399962651103)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="current"><div class="tbl"><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div><div class="tbr"><img src="#IMAGE_PREFIX#1px_trans.gif"></div></div>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="non-current"><div class="tbl"><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div><div class="tbr"><img src="#IMAGE_PREFIX#1px_trans.gif"></div></div>',
''))
,p_list_template_name=>'(Done) Page Tab Navigation'
,p_internal_name=>'DONE_PAGE_TAB_NAVIGATION'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div id="tabs">'
,p_list_template_after_rows=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_large_icons_list_5_icons
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2604064395384974004)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_name=>'[EBA] Large Icons List (5 icons)'
,p_internal_name=>'[EBA]_LARGE_ICONS_LIST_5_ICONS'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="ebaLargeIcons" width="100%" cellspacing="0" cellpadding="0" border="0" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2616337216247383620)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_wizard_progress_sidebar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2644133919427537952)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-current"><span>#TEXT#</span></div>',
''))
,p_list_template_noncurrent=>'<div class="apex-wiz-non"><span>#TEXT#</span></div>'
,p_list_template_name=>'APEX 4. 0 - Wizard Progress Sidebar'
,p_internal_name=>'APEX_4._0_WIZARD_PROGRESS_SIDEBAR'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-wiz-bar">'
,p_list_template_after_rows=>'</div>'
,p_between_items=>'<div class="apex-wiz-arrow"></div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2644135096780537975)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>101
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_quick_items
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2667754110651746870)
,p_list_template_current=>'<div><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_noncurrent=>'<div><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_name=>'(Done) Quick Items'
,p_internal_name=>'DONE_QUICK_ITEMS'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="htmldbQuickItems">'
,p_list_template_after_rows=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_simple_tabbed_navigation_list_ppr
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2692764710625953880)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="javascript:ob_PPR_TAB(''#LINK#'')" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="javascript:ob_PPR_TAB(''#LINK#'')" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_list_template_name=>'(Done) Simple Tabbed Navigation List (PPR)'
,p_internal_name=>'DONE_SIMPLE_TABBED_NAVIGATION_LIST_PPR'
,p_theme_id=>101
,p_theme_class_id=>7
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbTabbedNavigationList" border="0" cellpadding="0" cellspacing="0" summary=""><tr>',
'',
''))
,p_list_template_after_rows=>'<td width="100%"><br /></td></tr></table>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_simple_tabbed_navigation_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2692769817191963631)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_list_template_name=>'(Done) Simple Tabbed Navigation List'
,p_internal_name=>'DONE_SIMPLE_TABBED_NAVIGATION_LIST'
,p_theme_id=>101
,p_theme_class_id=>7
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbTabbedNavigationList" border="0" cellpadding="0" cellspacing="0"><tr>',
'',
''))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td width="100%"><br /></td></tr></table>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2752624110726590597)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/tree_context_menu
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2789926011585822220)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_ATTR#:{',
'  is_separator:true,',
'  visible:#A01#',
'}',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_ATTR#:{',
'  label:"#TEXT#", ',
'  icon: "#IMAGE#",',
'  visible:#A01#,',
'  action: #LINK#',
'}',
''))
,p_list_template_name=>'Tree Context Menu'
,p_internal_name=>'TREE_CONTEXT_MENU'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'{items:{create:false,rename:false,remove:false,'
,p_list_template_after_rows=>'}}'
,p_between_items=>','
);
end;
/
prompt --application/shared_components/user_interface/templates/list/image_list_legend
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2821773603397513050)
,p_list_template_current=>'<li><img src="#IMAGE_PREFIX##IMAGE#" style="margin-right:10px;" alt="" />#TEXT#</li>'
,p_list_template_noncurrent=>'<li><img src="#IMAGE_PREFIX##IMAGE#" style="margin-right:10px;" alt="" />#TEXT#</li>'
,p_list_template_name=>'Image List (Legend)'
,p_internal_name=>'IMAGE_LIST_LEGEND'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="htmldbSessionLegend">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_wizard_progress_sidebar_clickable
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2824062405654685023)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-current">',
'  <div class="apex-wiz-top"></div>',
'  <div class="apex-wiz-body">#TEXT#</div>',
'</div>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-non">',
'  <div class="apex-wiz-top"></div>',
'  <div class="apex-wiz-body"><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div>',
'</div>'))
,p_list_template_name=>'APEX 4. 0 - Wizard Progress Sidebar (Clickable)'
,p_internal_name=>'APEX_4._0_WIZARD_PROGRESS_SIDEBAR_CLICKABLE'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-wiz-bar">'
,p_list_template_after_rows=>'</div>'
,p_between_items=>'<div class="apex-wiz-arrow-small"></div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/horizontal_list_with_images_30px_c_htmldblistimages30px
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2922135290041147207)
,p_list_template_current=>'<td align="center" valign="top"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="htmldbGreenIcon" /></a><a href="#LINK#" class="noVisit" title="#TEXT_ESC_SC#">#TEXT#</a></td>'
,p_list_template_noncurrent=>'<td align="center" valign="top"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="htmldbGreenIcon"/></a><a href="#LINK#" class="noVisit" title="#TEXT_ESC_SC#">#TEXT#</a></td>'
,p_list_template_name=>'Horizontal List with Images 30px (c:htmldbListImages30px)'
,p_internal_name=>'HORIZONTAL_LIST_WITH_IMAGES_30PX_C:HTMLDBLISTIMAGES30PX'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table cellspacing="0" cellpadding="0" border="0" class="htmldbListImages30px" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_unordered_list_omit_current
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(2937959307089632175)
,p_list_template_current=>' '
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_list_template_name=>'(Done) Unordered List  (Omit Current)'
,p_internal_name=>'DONE_UNORDERED_LIST_OMIT_CURRENT'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="noIndent">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3065206012515940400)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3157523106769548315)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>101
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3271817654182082202)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>101
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3276636485845180952)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" aria-current="page" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_name=>'[x] APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>101
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3331503598779942021)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>101
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_bar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3509379333604010550)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'APEX 5.0 - Menu Bar'
,p_internal_name=>'APEX_5.0_MENU_BAR'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menubar", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tablike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcon") || null,',
'  slide: e.hasClass("js-slide"),',
'  menubar: true,',
'});',
''))
,p_theme_id=>101
,p_theme_class_id=>7
,p_default_template_options=>'js-tabLike'
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menubar" class="#COMPONENT_CSS_CLASSES#"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_app_cards
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3516165623956683100)
,p_list_template_name=>'APEX 5.0 - App Cards'
,p_internal_name=>'APEX_5.0_APP_CARDS'
,p_theme_id=>101
,p_theme_class_id=>9
,p_list_template_before_rows=>' '
,p_list_template_after_rows=>' '
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_basic_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3725901971624487519)
,p_list_template_current=>'<li class="a-List-item is-current"><a href="#LINK#" class="a-Links-link" #A02#>#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-List-item"><a href="#LINK#" class="a-Links-link" #A02#>#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Basic List'
,p_internal_name=>'APEX_5.0_BASIC_LIST'
,p_theme_id=>101
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="a-List #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_basic_list_no_links
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3725904394519503812)
,p_list_template_current=>'<li class="a-List-item is-current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li class="a-List-item">#TEXT#</li>'
,p_list_template_name=>'APEX 5.0 - Basic List (no links)'
,p_internal_name=>'APEX_5.0_BASIC_LIST_NO_LINKS'
,p_theme_id=>101
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="a-List a-List--basic #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sql_workshop_buttons_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3825565596067563070)
,p_list_template_current=>'<button type="button" onclick="apex.navigation.redirect(''#LINK#'')" class="a-Button">#TEXT#</button>'
,p_list_template_noncurrent=>'<button type="button" onclick="apex.navigation.redirect(''#LINK#'')" class="a-Button">#TEXT#</button>'
,p_list_template_name=>'APEX 5.0 - SQL Workshop Buttons List'
,p_internal_name=>'APEX_5.0_SQL_WORKSHOP_BUTTONS_LIST'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="a-Button-list">'
,p_list_template_after_rows=>'</div>'
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/report/pages
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2583678044278335201)
,p_row_template_name=>'Pages'
,p_internal_name=>'PAGES'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-PWList-item #PAGE_LI_CLASS# #PAGE_DRAGGABLE#" data-seq="#SORT_ORDER#">',
'  <span class="a-PWList-icon">#PAGE_ICON#</span>',
'  <span class="a-PWList-name">#PAGE_TITLE#</span>',
'  <span class="a-PWList-desc">#PAGE_DESC#</span>',
'  <span class="a-PWList-actions">#PAGE_ACTIONS#</span>',
'  #PAGE_DRAG_HANDLE#',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-PWList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2601299300702281738)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>101
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_standard_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2604243400441774005)
,p_row_template_name=>'[EBA] Standard Report'
,p_internal_name=>'[EBA]_STANDARD_REPORT'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="" #REPORT_ATTRIBUTES# id="report_#REGION_STATIC_ID#">#TOP_PAGINATION#',
'<tr>',
'<td><table class="ebaStandardReport" cellspacing="0" cellpadding="0" summary="#REGION_TITLE#" width="100%">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table><div class="CSV">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="#LINK#" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="#LINK#" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="#LINK#" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="#LINK#" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2626935888845593317)
,p_row_template_name=>'APEX 5.0 - Portlet Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>0
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2630679288769520822)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_standard_c_htmldbverticalregion2
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2665894019428237001)
,p_row_template_name=>'Vertical Standard (c:htmldbVerticalRegion2)'
,p_internal_name=>'VERTICAL_STANDARD_C:HTMLDBVERTICALREGION2'
,p_row_template1=>'<tr><td scope="row" class="label">#COLUMN_HEADER#</td><td class="data">#COLUMN_VALUE#</td></tr>'
,p_row_template_before_rows=>'#CSV_LINK#<table class="htmldbVerticalRegion2"  summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>' '
,p_row_template_after_last=>'<tr><td class="blank"><br /></td><td class="blank"><br /></td></tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>101
,p_theme_class_id=>0
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2707641403506668051)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# #ARIA_SORT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/icon_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2718432304985775346)
,p_row_template_name=>'Icon Report'
,p_internal_name=>'ICON_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100" style="float:left;margin:10px;">',
'<tr><td align="center"><a href="#3#"><img src="#IMAGE_PREFIX##1#" title="#2#" alt="#2#" style="display:block;"/></a></td></tr>',
'<tr><td align="center"><a href="#3#" class="htmldbIconName">#4#</a></td></tr>',
'</table>',
'<br style="clear:both;" />'))
,p_row_template_condition1=>'mod (#ROWNUM#, 5) = 0'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100" style="float:left;margin:10px;">',
'<tr><td align="center"><a href="#3#"><img src="#IMAGE_PREFIX##1#" title="#2#" alt="#2#" style="display:block;"/></a></td></tr>',
'<tr><td align="center"><a href="#3#" class="htmldbIconName">#4#</a></td></tr>',
'</table>'))
,p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table class="htmldbListIconHolder" border="0" cellpadding="0" cellpadding="0" summary="">#TOP_PAGINATION#<tr><td>'
,p_row_template_after_rows=>'</td></tr>#PAGINATION#</table></htmldb:#REGION_ID#></div>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_no_background
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2756563315870700241)
,p_row_template_name=>'Vertical - No Background'
,p_internal_name=>'VERTICAL_NO_BACKGROUND'
,p_row_template1=>'<tr><th scope="row" align="right">#COLUMN_HEADER#</th><td>#COLUMN_VALUE#</td></tr>'
,p_row_template_before_rows=>'#CSV_LINK#<table class="htmldbVerticalRptPlain" summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>101
,p_theme_class_id=>0
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/no_background
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2821784192166554137)
,p_row_template_name=>'No Background'
,p_internal_name=>'NO_BACKGROUND'
,p_row_template1=>'<td#ALIGNMENT# id="td#ROWNUM#_#COLNUM#" headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" class="htmldbRptNoBackground" summary="#REGION_TITLE#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_before_first=>'<tr id="row#ROWNUM#">'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/4500_database_browser_trigger_body
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2938873490424743044)
,p_row_template_name=>'(4500) Database Browser Trigger Body'
,p_internal_name=>'4500_DATABASE_BROWSER_TRIGGER_BODY'
,p_row_template1=>'<pre>#TRIGGER_BODY#</pre>'
,p_row_template_before_rows=>'<table><tr><td>'
,p_row_template_after_rows=>'</td></tr></table>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(3072403539858088941)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(3272975836994283240)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>6
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(3516183932083974422)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AppCards a-AppCards--slim  a-AppCards--stacked">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_vertical_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(3710840215749602833)
,p_row_template_name=>'APEX 5.0 - Vertical Report'
,p_internal_name=>'APEX_5.0_VERTICAL_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'  <td class="a-Report-cell a-Report-cell--header" scope="row">#COLUMN_HEADER#</td>',
'  <td class="a-Report-cell">#COLUMN_VALUE#</td>',
'</tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report a-Report--vertical a-Report--staticRowColors #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" summary="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>' '
,p_row_template_after_last=>' '
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/outline_label_optional
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(2584586946052082315)
,p_template_name=>'Outline Label - Optional'
,p_internal_name=>'OUTLINE_LABEL_OPTIONAL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-label__container field-col-3">',
'<label class="field-label" id="#CURRENT_ITEM_ID#_LABEL" for="#CURRENT_ITEM_NAME#">',
''))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="field field--style--boxed #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-input__container field-col-9">',
'<div class="field-input__wrap">'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'</div>',
'#ERROR_TEMPLATE#',
'#HELP_TEMPLATE#',
'#INLINE_HELP_TEMPLATE#'))
,p_inline_help_text=>'<div class="a-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="field-error-message">#ERROR_MESSAGE#</div>'
,p_theme_id=>101
,p_theme_class_id=>3
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(2588818597804368344)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>101
,p_theme_class_id=>13
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/outline_label_required
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(2716804030064502999)
,p_template_name=>'Outline Label - Required'
,p_internal_name=>'OUTLINE_LABEL_-_REQUIRED'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-label__container field-col-3">',
'<label class="field-label" id="#CURRENT_ITEM_ID#_LABEL" for="#CURRENT_ITEM_NAME#">',
''))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="field field--style--boxed field--required #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-input__container field-col-9">',
'<div class="field-input__wrap">'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'</div>',
'#ERROR_TEMPLATE#',
'#HELP_TEMPLATE#',
'#INLINE_HELP_TEMPLATE#'))
,p_inline_help_text=>'<div class="a-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="field-error-message">#ERROR_MESSAGE#</div>'
,p_theme_id=>101
,p_theme_class_id=>3
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/dynamic_attribute
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(2764373305086284113)
,p_template_name=>'Dynamic Attribute'
,p_internal_name=>'DYNAMIC_ATTRIBUTE'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:apex.builder.dynamicAttributes.help(''&FB_FLOW_ID.'',''#CURRENT_ITEM_NAME#'');" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional_with_br
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(2771230409799238960)
,p_template_name=>'FormField_Optional with BR'
,p_internal_name=>'FORMFIELD_OPTIONAL_WITH_BR'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="help optional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label><br />&nbsp;'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_required_with_br
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(2771230604641238960)
,p_template_name=>'FormField_Required with BR'
,p_internal_name=>'FORMFIELD_REQUIRED_WITH_BR'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="help required" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999"><img alt="#VALUE_REQUIRED#" src="#IMAGE_PREFIX#requiredicon_status2.gif" />'
,p_template_body2=>'</a></label><br />&nbsp;'
,p_theme_id=>101
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3071359248210082306)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_reference_id=>487443659585685414
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3071359888141100707)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3076592553081438826)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3076592627306440115)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' </label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_reference_id=>492677038682043223
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3271822809773116508)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3276597163598826691)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="" aria-label="" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span>'
||'</button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_workspace_login_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3365552608730662744)
,p_template_name=>'APEX 5.0 - Workspace Login Label'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Icon a-Login-iconLabel">'
,p_template_body2=>'</label>'
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#"><div class="a-Form-inputContainer">'
,p_after_item=>'</div></div>'
,p_after_element=>'<span class="a-Login-iconValidation a-Icon icon-check"></span>#ERROR_TEMPLATE#'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span class="u-VisuallyHidden">#CURRENT_ITE'
||'M_HELP_LABEL#</span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader_with_span
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3835008919990537112)
,p_template_name=>'Hidden label, read by screen reader with SPAN'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER_WITH_SPAN'
,p_template_body1=>'<span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label></span>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>101
,p_theme_class_id=>13
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(3273201397272801603)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>8
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>101
,p_theme_class_id=>1
,p_reference_id=>689285808648404711
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_imp_shared.create_popup_lov_template(
 p_id=>wwv_flow_imp.id(2601258703618978764)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(2937825491492752143)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table> ',
' <tr>',
'   <td> ',
'     <table width="100%" class="htmldbGrayBox" cellspacing="0" cellpadding="0" border="0" summary="layout">',
'       <tr><td align="center" class="htmldbGrayBoxHeader">#IMONTH#</td></td></tr>',
'     </table>',
'   </td>',
' </tr>'))
,p_month_open_format=>'<table summary="#CALENDAR_TITLE# #IMONTH# #YYYY#"  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"><tr>'
,p_month_close_format=>'</tr></table></table>'
,p_day_title_format=>'<div class="calday">#DD#</div>'
,p_day_open_format=>'<td valign="top" class="calweekday">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="caltoday" style="background:#c5d5c5">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="calday">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="calweekend">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'&nbsp;'
,p_nonday_open_format=>'<td class="calnotmonth">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</td></tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>101
,p_theme_class_id=>1
,p_reference_id=>0
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/htmldb_calendar_from_4350
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(2937840903200925859)
,p_cal_template_name=>'HTMLDB Calendar from 4350'
,p_internal_name=>'HTMLDB_CALENDAR_FROM_4350'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>101
,p_theme_class_id=>1
,p_reference_id=>0
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/subscribe_of_htmldb_calendar_from_4350
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(2938985015947681963)
,p_cal_template_name=>'subscribe of HTMLDB Calendar from 4350'
,p_internal_name=>'SUBSCRIBE_OF_HTMLDB_CALENDAR_FROM_4350'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>101
,p_theme_class_id=>1
,p_reference_id=>0
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_imp_shared.create_theme(
 p_id=>wwv_flow_imp.id(2659055193535481590)
,p_theme_id=>101
,p_theme_name=>'APEX 5.0'
,p_theme_internal_name=>'APEX_5.0'
,p_navigation_type=>'T'
,p_nav_bar_type=>'NAVBAR'
,p_is_locked=>false
,p_default_page_template=>wwv_flow_imp.id(3221353480673840388)
,p_default_dialog_template=>wwv_flow_imp.id(3272976625713321802)
,p_error_template=>wwv_flow_imp.id(3286599848719423369)
,p_printer_friendly_template=>wwv_flow_imp.id(3221353480673840388)
,p_default_button_template=>wwv_flow_imp.id(2758666493011882367)
,p_default_region_template=>wwv_flow_imp.id(2758664310411868479)
,p_default_report_template=>wwv_flow_imp.id(2707641403506668051)
,p_default_label_template=>wwv_flow_imp.id(3071359888141100707)
,p_default_menu_template=>wwv_flow_imp.id(3273201397272801603)
,p_default_calendar_template=>wwv_flow_imp.id(2937825491492752143)
,p_default_list_template=>wwv_flow_imp.id(2644135096780537975)
,p_default_top_nav_list_temp=>wwv_flow_imp.id(3157523106769548315)
,p_default_nav_list_position=>'TOP'
,p_default_dialogbtnr_template=>wwv_flow_imp.id(3271069058970016268)
,p_default_dialogr_template=>wwv_flow_imp.id(3300810815961795652)
,p_theme_description=>'APEX 5.0 - Builder Theme'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(101),'')
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/oracle-fonts/oraclesans-apex#MIN#.css?v=#APEX_VERSION#'
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(72329795312505899)
,p_theme_id=>101
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556395613003092800)
,p_theme_id=>101
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556395924287093657)
,p_theme_id=>101
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(2787940904864180601)
,p_theme_id=>101
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272947108403853347)
,p_theme_id=>101
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272948091579864086)
,p_theme_id=>101
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272952033767924344)
,p_theme_id=>101
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272954073059959815)
,p_theme_id=>101
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272956807976997233)
,p_theme_id=>101
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272957635263003437)
,p_theme_id=>101
,p_name=>'MIN_HEIGHT'
,p_display_name=>'Min Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'No Min Height'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272957927201004807)
,p_theme_id=>101
,p_name=>'MAX_HEIGHT'
,p_display_name=>'Max Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'No Max Height'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272966786960085403)
,p_theme_id=>101
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272966998825101372)
,p_theme_id=>101
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272967382281109834)
,p_theme_id=>101
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272969904335143676)
,p_theme_id=>101
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272971965975243949)
,p_theme_id=>101
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3272972266905244890)
,p_theme_id=>101
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3273503711535111804)
,p_theme_id=>101
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3273504100166113788)
,p_theme_id=>101
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3273504670519116433)
,p_theme_id=>101
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3273504927909124382)
,p_theme_id=>101
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3273505268873125534)
,p_theme_id=>101
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3273505950760134683)
,p_theme_id=>101
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3273878259726558568)
,p_theme_id=>101
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3276635722597176199)
,p_theme_id=>101
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3280531346127474880)
,p_theme_id=>101
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3281138953904089269)
,p_theme_id=>101
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3286594514783296583)
,p_theme_id=>101
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3286594887959299057)
,p_theme_id=>101
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3286595166349303494)
,p_theme_id=>101
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3286597037907377132)
,p_theme_id=>101
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3286597541894380105)
,p_theme_id=>101
,p_name=>'TEXT_ALIGNMENT'
,p_display_name=>'Text Alignment'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3330283282906664432)
,p_theme_id=>101
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3554578106749597184)
,p_theme_id=>101
,p_name=>'FORM_ITEM_ALIGNMENT'
,p_display_name=>'Form Item Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'This option controls how form items are aligned.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(3725370028670731644)
,p_theme_id=>101
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Dialog Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Predefined dialog sizes'
,p_null_text=>'Default Size'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1499529881426780)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden to Assistive Tech'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3262269949210718587)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
,p_help_text=>'By default, region title is hidden but accessible, use this option to remove the header from accessible interface'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3262270231652718591)
,p_theme_id=>101
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(3262269949210718587)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3262270571570718591)
,p_theme_id=>101
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3262269949210718587)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272945950492849549)
,p_theme_id=>101
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272947553810857499)
,p_theme_id=>101
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_imp.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272947826253860428)
,p_theme_id=>101
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_imp.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272948903374868569)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272949699167870094)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272950049203873528)
,p_theme_id=>101
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272951079760914115)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272951692319920329)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272952701469928429)
,p_theme_id=>101
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(3272952033767924344)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272952954669936274)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272954255910963039)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272954430217969881)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272961138986029754)
,p_theme_id=>101
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_imp.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272961370887030558)
,p_theme_id=>101
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_imp.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272961542151031342)
,p_theme_id=>101
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_imp.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272962358006037974)
,p_theme_id=>101
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_imp.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272962503845038900)
,p_theme_id=>101
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_imp.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272962747536039753)
,p_theme_id=>101
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_imp.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272967834831123581)
,p_theme_id=>101
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2707641403506668051)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(3272966998825101372)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272968057448126165)
,p_theme_id=>101
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2707641403506668051)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(3272967382281109834)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272968191501129345)
,p_theme_id=>101
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2707641403506668051)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272968445819130771)
,p_theme_id=>101
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2707641403506668051)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272968608246132125)
,p_theme_id=>101
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2707641403506668051)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272968919298136815)
,p_theme_id=>101
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2707641403506668051)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272970278790147380)
,p_theme_id=>101
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2707641403506668051)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(3272969904335143676)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272972869034260434)
,p_theme_id=>101
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272973086671262192)
,p_theme_id=>101
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272973253261263303)
,p_theme_id=>101
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272973474743265141)
,p_theme_id=>101
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272973618033266123)
,p_theme_id=>101
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272973800081267332)
,p_theme_id=>101
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272974009431268450)
,p_theme_id=>101
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272974260327270307)
,p_theme_id=>101
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272974443197272653)
,p_theme_id=>101
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272974653554274369)
,p_theme_id=>101
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272974882723275389)
,p_theme_id=>101
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272975023683276305)
,p_theme_id=>101
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3272975227337277311)
,p_theme_id=>101
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273718461755706170)
,p_theme_id=>101
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_imp.id(3273503711535111804)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273718623962707342)
,p_theme_id=>101
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_imp.id(3273503711535111804)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273718890233708711)
,p_theme_id=>101
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_imp.id(3273503711535111804)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273719305891709940)
,p_theme_id=>101
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_imp.id(3273504100166113788)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273719586640711433)
,p_theme_id=>101
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_imp.id(3273504100166113788)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273719839810712886)
,p_theme_id=>101
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_imp.id(3273504670519116433)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273720340946719858)
,p_theme_id=>101
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_imp.id(3273504927909124382)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273720525579721240)
,p_theme_id=>101
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_imp.id(3273504927909124382)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273720760921722468)
,p_theme_id=>101
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_imp.id(3273505268873125534)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273720931877723703)
,p_theme_id=>101
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_imp.id(3273505268873125534)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273721140780728323)
,p_theme_id=>101
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273871817323525718)
,p_theme_id=>101
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273872411843525718)
,p_theme_id=>101
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273872723948525718)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273873057755525719)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273873290844525719)
,p_theme_id=>101
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(3272952033767924344)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273873638536525720)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273875126148525721)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273875409775525721)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273878789688562715)
,p_theme_id=>101
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_imp.id(3273878259726558568)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3273879016540564402)
,p_theme_id=>101
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3273871575473525717)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_imp.id(3273878259726558568)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276607386083938689)
,p_theme_id=>101
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3271817654182082202)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276636838044198487)
,p_theme_id=>101
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_imp.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276637064796202531)
,p_theme_id=>101
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_imp.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276637209671203375)
,p_theme_id=>101
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_imp.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276637476000204461)
,p_theme_id=>101
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_imp.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276637736156208731)
,p_theme_id=>101
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_imp.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276637961098212818)
,p_theme_id=>101
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276638122293218782)
,p_theme_id=>101
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276638304849219441)
,p_theme_id=>101
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3276638548238221517)
,p_theme_id=>101
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3277479810838089753)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3280532169788485511)
,p_theme_id=>101
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3280694720327105304)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3280963863176791327)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3280964065307793861)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281117036334023852)
,p_theme_id=>101
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3276636485845180952)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281139167748092929)
,p_theme_id=>101
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(2644135096780537975)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281139506990094782)
,p_theme_id=>101
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(2644135096780537975)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281140071999096157)
,p_theme_id=>101
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(2644135096780537975)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281141078804098444)
,p_theme_id=>101
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(2644135096780537975)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281141213641100590)
,p_theme_id=>101
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(2644135096780537975)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(3281138953904089269)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281141448555102030)
,p_theme_id=>101
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(2644135096780537975)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(3281138953904089269)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281266536726867367)
,p_theme_id=>101
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2601299300702281738)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281266773648869208)
,p_theme_id=>101
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2601299300702281738)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3281266966728871945)
,p_theme_id=>101
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2601299300702281738)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282714713448775707)
,p_theme_id=>101
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282745129348275835)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282746679230275837)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282746942441275837)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282747278902275837)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282747839142275838)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282748118484275838)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282748411243275838)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282749059124275838)
,p_theme_id=>101
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(3272952033767924344)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282749318955275838)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3282842053625616201)
,p_theme_id=>101
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3286595597781327418)
,p_theme_id=>101
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_imp.id(3286594514783296583)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3286595827879334751)
,p_theme_id=>101
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_imp.id(3286595166349303494)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3286596084244340067)
,p_theme_id=>101
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_imp.id(3286594887959299057)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3286596280219344757)
,p_theme_id=>101
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_imp.id(3286594887959299057)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3286596436853346451)
,p_theme_id=>101
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_imp.id(3286594887959299057)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3286596758659356442)
,p_theme_id=>101
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_imp.id(3286594887959299057)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3286598178674389540)
,p_theme_id=>101
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_imp.id(3286597037907377132)
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3321665041873928813)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3321665488779928817)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3321665693602928818)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3321665940405928818)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3321666009451928818)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3321666098572928818)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3321666463761928818)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(3321664782165928798)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3324985134819362058)
,p_theme_id=>101
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3262269949210718587)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3330280566372621950)
,p_theme_id=>101
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3330280598646623793)
,p_theme_id=>101
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3330280783108625349)
,p_theme_id=>101
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3330284462355675023)
,p_theme_id=>101
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_imp.id(3330283282906664432)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3330284727365676939)
,p_theme_id=>101
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_imp.id(3330283282906664432)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3330285032641678042)
,p_theme_id=>101
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_imp.id(3330283282906664432)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3330285174248679384)
,p_theme_id=>101
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_imp.id(3330283282906664432)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3330286246965689845)
,p_theme_id=>101
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_imp.id(3273878259726558568)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3330286358960690808)
,p_theme_id=>101
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3330277939666606656)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_imp.id(3273878259726558568)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331512237109010498)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331512316830010502)
,p_theme_id=>101
,p_name=>'ADDBOTTOMBORDER'
,p_display_name=>'Add Bottom Border'
,p_display_sequence=>13
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--bottomBorder'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331512405035010502)
,p_theme_id=>101
,p_name=>'ADDLEFTBORDER'
,p_display_name=>'Add Left Border'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--borderLeft'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331512520332010502)
,p_theme_id=>101
,p_name=>'ADDRIGHTBORDER'
,p_display_name=>'Add Right Border'
,p_display_sequence=>11
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--rightBorder'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331512588720010502)
,p_theme_id=>101
,p_name=>'ADDTOPBORDER'
,p_display_name=>'Add Top Border'
,p_display_sequence=>12
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--borderTop'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331512751548010502)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331512886222010502)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331512929493010502)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331513066778010502)
,p_theme_id=>101
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331513163911010502)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331513197967010502)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331513365716010502)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3331513444572010502)
,p_theme_id=>101
,p_name=>'SHOWTOPBUTTON'
,p_display_name=>'Show Top Button'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3331511935591010485)
,p_css_classes=>'a-Region--showTopButton'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3334695364652936397)
,p_theme_id=>101
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3335163087575149954)
,p_theme_id=>101
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3282744828018275829)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3342634157267201409)
,p_theme_id=>101
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(3273505950760134683)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3509387538140015679)
,p_theme_id=>101
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3509379333604010550)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3509387639047016742)
,p_theme_id=>101
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3509379333604010550)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3509387743072017994)
,p_theme_id=>101
,p_name=>'SHOW_SUB_MENU_ICON'
,p_display_name=>'Show Sub Menu Icon'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3509379333604010550)
,p_css_classes=>'js-showSubMenuIcon'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3509387792807019253)
,p_theme_id=>101
,p_name=>'ENABLE_SLIDE_ANIMATION'
,p_display_name=>'Enable Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3509379333604010550)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3509438556564410728)
,p_theme_id=>101
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3331503598779942021)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3509438684549411763)
,p_theme_id=>101
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3331503598779942021)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3554588139973710662)
,p_theme_id=>101
,p_name=>'FLOAT_ITEMS_LEFT'
,p_display_name=>'Float Items Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--floatFieldsLeft'
,p_group_id=>wwv_flow_imp.id(3554578106749597184)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to float fields within a region to the left. The width of the field container will be calculated automatically. This option will allow you to position a button or other items immediately after other items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3554588421152717051)
,p_theme_id=>101
,p_name=>'FLOAT_COLUMNS_LEFT'
,p_display_name=>'Float Columns Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--floatColsLeft'
,p_group_id=>wwv_flow_imp.id(3554578106749597184)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to align grid columns within the region to the left. This option will allow you to align multiple columns of items next to each other.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3557616757869674565)
,p_theme_id=>101
,p_name=>'INLINE_FIELD'
,p_display_name=>'Inline Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--floatLeft'
,p_template_types=>'FIELD'
,p_help_text=>'Makes the field container for this item appear inline, so buttons or other objects immediately after show up on same line.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3650400464957171179)
,p_theme_id=>101
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(2758664310411868479)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_imp.id(3272947108403853347)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3710840678302602842)
,p_theme_id=>101
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3710840215749602833)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(3272967382281109834)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3710840717632602842)
,p_theme_id=>101
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3710840215749602833)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3710840865939602843)
,p_theme_id=>101
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3710840215749602833)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3710840901494602844)
,p_theme_id=>101
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3710840215749602833)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3710841004886602845)
,p_theme_id=>101
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3710840215749602833)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(3272969904335143676)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3710841122695602846)
,p_theme_id=>101
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(3710840215749602833)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3721723635433266832)
,p_theme_id=>101
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be resized.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3721729533748272817)
,p_theme_id=>101
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be moved.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3725370863738746403)
,p_theme_id=>101
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_imp.id(3725370028670731644)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3725371274535749580)
,p_theme_id=>101
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_imp.id(3725370028670731644)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3725374150645793950)
,p_theme_id=>101
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
,p_help_text=>'Display as modal.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3726150615094251075)
,p_theme_id=>101
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(3012513290302116971)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_imp.id(3725370028670731644)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741610224559929677)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741610384701929678)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741610396048929678)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741610528314929678)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741610624572929678)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741610694805929678)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741610807878929679)
,p_theme_id=>101
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741610894122929679)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741611021915929679)
,p_theme_id=>101
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(3272952033767924344)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741611178660929679)
,p_theme_id=>101
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_imp.id(3272947108403853347)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3741611246435929679)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(3741609957292929669)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(3825581410111791772)
,p_theme_id=>101
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(3731195891703350618)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2630752535760111599)
,p_translation_flow_id=>4021
,p_translation_flow_language_cd=>'es'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2630752645278111599)
,p_translation_flow_id=>4022
,p_translation_flow_language_cd=>'fr'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2630752735909111599)
,p_translation_flow_id=>4023
,p_translation_flow_language_cd=>'de'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2630752838102111599)
,p_translation_flow_id=>4024
,p_translation_flow_language_cd=>'it'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2630752930302111599)
,p_translation_flow_id=>4025
,p_translation_flow_language_cd=>'pt-br'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2630753022663111599)
,p_translation_flow_id=>4026
,p_translation_flow_language_cd=>'zh-cn'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2630753118245111599)
,p_translation_flow_id=>4027
,p_translation_flow_language_cd=>'zh-tw'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2630753225782111599)
,p_translation_flow_id=>4028
,p_translation_flow_language_cd=>'ko'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2630753343539111600)
,p_translation_flow_id=>4029
,p_translation_flow_language_cd=>'ja'
,p_direction_right_to_left=>'N'
);
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(246928993153707476)
,p_build_option_name=>'NEVER'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_default_on_export=>'EXCLUDE'
,p_on_upgrade_keep_status=>true
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(366100516974803533)
,p_build_option_name=>'email style master detail'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(641974235841696132)
,p_build_option_name=>'Enable APEX Internal Feedback'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_default_on_export=>'EXCLUDE'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(2605452072303844293)
,p_build_option_name=>'company address'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'we can avoid asking internal Oracle folks for address info'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(2698024371153404344)
,p_build_option_name=>'Advanced Form'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Include the ability to define advanced master detail forms.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(2698024578226405812)
,p_build_option_name=>'Language Selection'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(2698024775220408056)
,p_build_option_name=>'Authentication Selection'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Allow developer to select application at time of application creation'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(2746942411136297678)
,p_build_option_name=>'Dashboard'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Include the ability to create dashboard pages.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(3027829547778015556)
,p_build_option_name=>'Advanced Application Settings'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Include the advanced application options as part of the create application wizard.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(3027830547707021532)
,p_build_option_name=>'application defaults'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>117492729
,p_on_upgrade_keep_status=>true
,p_build_option_comment=>'ability to specify ui defaults, lists of values etc.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(3027985170417035432)
,p_build_option_name=>'Blueprints'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Allow for viewing and editing of application blueprints.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(3124271964326242195)
,p_build_option_name=>'supporting objects'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'when creating a new application, allow the inclusion of supporting object scripts'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(3145295462075987142)
,p_build_option_name=>'drill down reporting'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'ability to link a column on one report to another report'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3302267091071310861)
,p_name=>'ADMINISTRATORS'
,p_message_text=>'Administrators'
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3011422020177692)
,p_name=>'AI.APPLICATION_PAGES'
,p_message_text=>'Application Pages'
,p_is_js_message=>true
,p_version_scn=>169050366
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2189576935339418)
,p_name=>'AI.CREATE_APPLICATION'
,p_message_text=>'Create Application'
,p_is_js_message=>true
,p_version_scn=>167409087
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3012296551184801)
,p_name=>'AI.DESCRIPTION'
,p_message_text=>'Description'
,p_is_js_message=>true
,p_version_scn=>169050476
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8413877594006675)
,p_name=>'AI.DISABLED'
,p_message_text=>'AI is disabled at workspace or instance level.'
,p_version_scn=>177967705
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2404429249859727)
,p_name=>'AI.DISCLAIMER'
,p_message_text=>'This assistant lets you use natural language to generate application pages based on database tables. Use it to jump-start the creation of an application with a key subset of the functionality available in Oracle APEX.'
,p_is_js_message=>true
,p_version_scn=>206934009
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2604094974276368)
,p_name=>'AI.FEATURE.ABOUT_PAGE'
,p_message_text=>'About Page'
,p_is_js_message=>true
,p_version_scn=>183381948
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2604360684279939)
,p_name=>'AI.FEATURE.ACCESS_CONTROL'
,p_message_text=>'Access Control'
,p_is_js_message=>true
,p_version_scn=>183382004
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2604511398282422)
,p_name=>'AI.FEATURE.ACTIVITY_REPORTING'
,p_message_text=>'Activity Reporting'
,p_is_js_message=>true
,p_version_scn=>183382042
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2604743699285705)
,p_name=>'AI.FEATURE.CONFIG_OPTIONS'
,p_message_text=>'Configuration Options'
,p_is_js_message=>true
,p_version_scn=>183387482
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2604999193290310)
,p_name=>'AI.FEATURE.FEEDBACK'
,p_message_text=>'Feedback'
,p_is_js_message=>true
,p_version_scn=>183387589
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2603834062274623)
,p_name=>'AI.FEATURE.PUSH_NOTIFICATIONS'
,p_message_text=>'Push Notifications'
,p_is_js_message=>true
,p_version_scn=>183381910
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2603666999272875)
,p_name=>'AI.FEATURE.PWA'
,p_message_text=>'Install Progressive Web App'
,p_is_js_message=>true
,p_version_scn=>183381888
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2608912017311372)
,p_name=>'AI.FEATURE.THEME_STYLE'
,p_message_text=>'Theme Style Selection'
,p_is_js_message=>true
,p_version_scn=>183403194
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8414110881011395)
,p_name=>'AI.OPEN_CHAT'
,p_message_text=>'Open Chat'
,p_version_scn=>174630456
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12196408247128181)
,p_name=>'AI.PAGE_NAME.TYPE'
,p_message_text=>'%0 ( %1 )'
,p_is_js_message=>true
,p_version_scn=>186304328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6406625007055849)
,p_name=>'AI.PAGE_NAME.TYPE.ON_TABLE'
,p_message_text=>'%0 ( %1 on %2 )'
,p_is_js_message=>true
,p_version_scn=>186299593
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8401272811975606)
,p_name=>'AI.PAGE_TYPE.BLANK'
,p_message_text=>'Blank'
,p_is_js_message=>true
,p_version_scn=>174598646
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8402601467990115)
,p_name=>'AI.PAGE_TYPE.CALENDAR'
,p_message_text=>'Calendar'
,p_is_js_message=>true
,p_version_scn=>174598938
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8403078235992796)
,p_name=>'AI.PAGE_TYPE.CARDS'
,p_message_text=>'Cards'
,p_is_js_message=>true
,p_version_scn=>174598993
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8402834075991434)
,p_name=>'AI.PAGE_TYPE.CHART'
,p_message_text=>'Chart'
,p_is_js_message=>true
,p_version_scn=>174598971
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8401805780979633)
,p_name=>'AI.PAGE_TYPE.CR'
,p_message_text=>'Classic Report'
,p_is_js_message=>true
,p_version_scn=>174598796
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8402446006988043)
,p_name=>'AI.PAGE_TYPE.DASHBOARD'
,p_message_text=>'Dashboard'
,p_is_js_message=>true
,p_version_scn=>174598903
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8402043165983967)
,p_name=>'AI.PAGE_TYPE.FACETED_SEARCH'
,p_message_text=>'Faceted Search'
,p_is_js_message=>true
,p_version_scn=>174599257
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8403281516994269)
,p_name=>'AI.PAGE_TYPE.FORM'
,p_message_text=>'Form'
,p_is_js_message=>true
,p_version_scn=>174599016
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8401689143978669)
,p_name=>'AI.PAGE_TYPE.IG'
,p_message_text=>'Interactive Grid'
,p_is_js_message=>true
,p_version_scn=>174598776
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8401475533977233)
,p_name=>'AI.PAGE_TYPE.IR'
,p_message_text=>'Interactive Report'
,p_is_js_message=>true
,p_version_scn=>174598673
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8403872418000067)
,p_name=>'AI.PAGE_TYPE.MAP'
,p_message_text=>'Map'
,p_is_js_message=>true
,p_version_scn=>174599108
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8403694578998775)
,p_name=>'AI.PAGE_TYPE.MD'
,p_message_text=>'Master Detail'
,p_is_js_message=>true
,p_version_scn=>174599080
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8402264247985981)
,p_name=>'AI.PAGE_TYPE.SMART_FILTERS'
,p_message_text=>'Smart Filters'
,p_is_js_message=>true
,p_version_scn=>174598871
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8403446507996616)
,p_name=>'AI.PAGE_TYPE.TIMELINE'
,p_message_text=>'Timeline'
,p_is_js_message=>true
,p_version_scn=>174599056
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8404080297001413)
,p_name=>'AI.PAGE_TYPE.WIZARD'
,p_message_text=>'Wizard'
,p_is_js_message=>true
,p_version_scn=>174599165
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2405116222875625)
,p_name=>'AI.PROMPT.CANNOT_PROCESS'
,p_message_text=>'I''m sorry, I couldn''t process that. Could you please rephrase your question?'
,p_is_js_message=>true
,p_version_scn=>206934067
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6395333577374098)
,p_name=>'AI.REPLY_APP_NAME'
,p_message_text=>'Sure, I can create an application called %0 with the following pages:'
,p_is_js_message=>true
,p_version_scn=>177966981
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6405139931901970)
,p_name=>'AI.REPLY_BLANK_APP'
,p_message_text=>'Sure, would you like to create a blank application called %0?'
,p_is_js_message=>true
,p_version_scn=>186304596
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6395738730385958)
,p_name=>'AI.REPLY_CREATE_OR_CHANGE'
,p_message_text=>'Would you like to create the application now? Or, if you have any changes, just let me know below!'
,p_is_js_message=>true
,p_version_scn=>177967057
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601427795230839)
,p_name=>'AI.REPLY_ENABLED_FEATURES'
,p_message_text=>'With the following features enabled: %0.'
,p_is_js_message=>true
,p_version_scn=>183428574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6400717076765162)
,p_name=>'AI.SAMPLE_MESSAGE.APP_TO_MAINTAIN'
,p_message_text=>'Create an app to maintain %0, and %1, that includes pages for a %2, and %3.'
,p_version_scn=>179107884
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6416174470709244)
,p_name=>'AI.SAMPLE_MESSAGE.APP_TO_MANAGE'
,p_message_text=>'Develop an app to manage %0, and %1, that includes pages for a %2, and %3.'
,p_version_scn=>179107931
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6416431002717756)
,p_name=>'AI.SAMPLE_MESSAGE.BUILD_APP'
,p_message_text=>'Build an app on %0, and %1, that includes pages for a %2, and %3.'
,p_version_scn=>179108049
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6405577995945367)
,p_name=>'AI.SAMPLE_TITLE.APP_TO_MAINTAIN'
,p_message_text=>'Create an app to maintain %0'
,p_version_scn=>178434710
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6416879353727147)
,p_name=>'AI.SAMPLE_TITLE.APP_TO_MANAGE'
,p_message_text=>'Develop an app to manage %0'
,p_version_scn=>178434767
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6417078726730689)
,p_name=>'AI.SAMPLE_TITLE.BUILD_APP'
,p_message_text=>'Build an app on %0'
,p_version_scn=>178434826
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3302269296296316452)
,p_name=>'ALL_USERS'
,p_message_text=>'All Users'
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7858841782073746)
,p_name=>'CA.PAGE_ATTRIBUTE.IS_INVALID'
,p_message_text=>'For %0 page type, "%1" contains invalid value "%2".'
,p_version_scn=>174318166
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1611084795675050)
,p_name=>'CA.PAGE_ATTRIBUTE.IS_NOT_NULL'
,p_message_text=>'For %0 page type, "%1" must be specified.'
,p_version_scn=>171999669
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(79657768024939288)
,p_name=>'CREATE.APP.SELECT_AT_LEAST_ONE_TABLE'
,p_message_text=>'Please select at least one table name to add the page.'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3351293939745557004)
,p_name=>'REPORT'
,p_message_text=>'Report'
,p_version_scn=>37165770887573
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_page_confirm_msg
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(2647222231143044328)
,p_shortcut_name=>'DELETE_PAGE_CONFIRM_MSG'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_version_scn=>75556887
,p_shortcut=>'return replace( wwv_flow_lang.custom_runtime_message( p_name => ''CA.DELETE.CONFIRM'' ),'''''''',''\'''''');'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/creating_application
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(2717735057626016839)
,p_shortcut_name=>'CREATING_APPLICATION'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_version_scn=>75556887
,p_shortcut=>'return replace( wwv_flow_lang.custom_runtime_message( p_name => ''CA.CREATING.APPLICATION'' ),'''''''',''\'''''');'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/item_help
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(2745706623582705225)
,p_shortcut_name=>'ITEM_HELP'
,p_shortcut_type=>'HTML_TEXT'
,p_error_text=>'Unable to show help.'
,p_reference_id=>24184979678
,p_shortcut=>'<a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999" title="Help on this item."><img src="#IMAGE_PREFIX#infoicon_status_gray.gif" width="16" height="16" /></a>'
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(3324722473421190676)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>540226219724705040
);
end;
/
prompt --application/shared_components/plugins/item_type/ai_item_plugin
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1428948731393230)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AI_ITEM_PLUGIN'
,p_display_name=>'AI Chat Item'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AI_ITEM_PLUGIN'),'')
,p_javascript_file_urls=>'#PLUGIN_FILES#script#MIN#.js'
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'procedure render (',
'    p_item   in            wwv_flow_plugin_api.t_item,',
'    p_plugin in            wwv_flow_plugin_api.t_plugin,',
'    p_param  in            wwv_flow_plugin_api.t_item_render_param,',
'    p_result in out nocopy wwv_flow_plugin_api.t_item_render_result )',
'as',
'    l_display_mode  varchar2(10)    := lower( nvl( p_item.attribute_01, ''dialog'' ) );  -- dialog/inline',
'    l_close_mode    varchar2(10)    := lower( nvl( p_item.attribute_02, ''close'' ) );   -- close/hide',
'    l_focus         boolean         := nvl( p_item.attribute_03, ''Y'' ) = ''Y'';',
'',
'    l_id            varchar2(32767) := ''ai_'' || p_item.name;',
'    l_id_escaped    varchar2(32767) := wwv_flow_escape.html_attribute( l_id );',
'begin',
'    if p_item.ai_enabled then',
'        wwv_flow_plugin_util.print_hidden (',
'            p_item  => p_item,',
'            p_param => p_param );',
'',
'        if l_display_mode = ''dialog'' then',
'            sys.htp.p( ''<button class="t-Button" type="button" id="'' || l_id_escaped || ''">''|| wwv_flow_lang.system_message( ''AI.OPEN_CHAT'' ) ||''</button>'' );',
'        elsif l_display_mode = ''inline'' then',
'            sys.htp.p( ''<div id="'' || l_id_escaped || ''" class="a-ChatClient-innerWrapper"></div>'' );',
'        end if;',
'',
'        wwv_flow_json.initialize_clob_output(',
'            p_preserve => true );',
'',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.open_object( ''pluginOptions'' );',
'        wwv_flow_json.write( ''itemName'', p_item.name );',
'        wwv_flow_json.write( ''displayMode'', l_display_mode );',
'        wwv_flow_json.write( ''closeMode'', l_close_mode );',
'        wwv_flow_json.write( ''elemId'', l_id );',
'        wwv_flow_json.write_raw( ''initJsFunc'', nvl( p_item.init_javascript_code, ''null'' ) );',
'        wwv_flow_json.write( ''initialMessage'', p_item.ai_welcome_message );',
'        wwv_flow_json.close_object;',
'',
'        wwv_flow_json.open_object( ''chatOptions'' );',
'        wwv_flow_json.write( ''ajaxId'', wwv_flow_plugin_api.get_ajax_identifier );',
'        wwv_flow_json.close_object;',
'',
'        wwv_flow_json.open_object( ''viewOptions'' );',
'        wwv_flow_json.write( ''focus'', l_focus );',
'        wwv_flow_json.close_object;',
'',
'        wwv_flow_json.close_object;',
'',
'        wwv_flow_javascript_api.add_onload_code( ''aiItemPlugin.init('' || wwv_flow_json.get_clob_output( p_free => true ) || '');'' );',
'    else',
'        sys.htp.p( wwv_flow_lang.system_message( ''AI.DISABLED'' ) );',
'    end if;',
'end render;'))
,p_api_version=>2
,p_render_function=>'render'
,p_standard_attributes=>'INIT_JAVASCRIPT_CODE:AI_ENABLED:AI_SYSTEM_PROMPT:AI_WELCOME_MESSAGE'
,p_substitute_attributes=>true
,p_version_scn=>188875336
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
,p_files_version=>113
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1467965565561260)
,p_plugin_id=>wwv_flow_imp.id(1428948731393230)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Display Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DIALOG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'This setting specifies how the chat should be rendered.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1468356843561260)
,p_plugin_attribute_id=>wwv_flow_imp.id(1467965565561260)
,p_display_sequence=>10
,p_display_value=>'Dialog'
,p_return_value=>'DIALOG'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1468839821561260)
,p_plugin_attribute_id=>wwv_flow_imp.id(1467965565561260)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1469350512561260)
,p_plugin_id=>wwv_flow_imp.id(1428948731393230)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Close Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLOSE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1467965565561260)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>This setting controls what should happen to the chat when the user hits Escape or clicks the Close button.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1469787528561260)
,p_plugin_attribute_id=>wwv_flow_imp.id(1469350512561260)
,p_display_sequence=>10
,p_display_value=>'Close'
,p_return_value=>'CLOSE'
,p_help_text=>'Closes the chat. All history and progress is reset.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1470253918561260)
,p_plugin_attribute_id=>wwv_flow_imp.id(1469350512561260)
,p_display_sequence=>20
,p_display_value=>'Hide'
,p_return_value=>'HIDE'
,p_help_text=>'Hides the dialog. It can be re-opened programatically where it was left off.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1470732906561261)
,p_plugin_id=>wwv_flow_imp.id(1428948731393230)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Focus'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1467965565561260)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'INLINE'
,p_help_text=>'Whether the textarea should receive focus when the chat is opened.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(1471709584561262)
,p_plugin_id=>wwv_flow_imp.id(1428948731393230)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '77696E646F772E61694974656D506C7567696E203D207B0A20202020696E69743A202820646174612029203D3E207B0A20202020202020206C6574207B20706C7567696E4F7074696F6E732C20636861744F7074696F6E732C20766965774F7074696F6E';
wwv_flow_imp.g_varchar2_table(2) := '73207D203D20646174613B0A0A202020202020202069662820706C7567696E4F7074696F6E732E696E69744A7346756E632029207B0A20202020202020202020202028207B20636861744F7074696F6E732C20766965774F7074696F6E73207D203D2070';
wwv_flow_imp.g_varchar2_table(3) := '6C7567696E4F7074696F6E732E696E69744A7346756E6328207B0A20202020202020202020202020202020636861744F7074696F6E732C0A20202020202020202020202020202020766965774F7074696F6E730A2020202020202020202020207D202920';
wwv_flow_imp.g_varchar2_table(4) := '293B0A20202020202020207D0A0A20202020202020206C657420636861743B0A20202020202020206C65742063686174566965773B0A0A202020202020202069662820706C7567696E4F7074696F6E732E646973706C61794D6F6465203D3D3D20226469';
wwv_flow_imp.g_varchar2_table(5) := '616C6F67222029207B0A202020202020202020202020242820222322202B20706C7567696E4F7074696F6E732E656C656D496420292E6F6E282022636C69636B222C202829203D3E207B0A20202020202020202020202020202020617065782E61692E67';
wwv_flow_imp.g_varchar2_table(6) := '657455736572436F6E73656E7428292E7468656E28206772616E746564203D3E207B0A2020202020202020202020202020202020202020696628206772616E7465642029207B0A2020202020202020202020202020202020202020202020206966282021';
wwv_flow_imp.g_varchar2_table(7) := '63686174207C7C202163686174566965772029207B0A202020202020202020202020202020202020202020202020202020206966282021636861742029207B0A202020202020202020202020202020202020202020202020202020202020202063686174';
wwv_flow_imp.g_varchar2_table(8) := '203D206E657720617065782E61692E436861742820636861744F7074696F6E7320293B0A202020202020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020202020202020202020636861745669';
wwv_flow_imp.g_varchar2_table(9) := '6577203D20636861742E6372656174654469616C6F67566965772820766965774F7074696F6E7320293B0A2020202020202020202020202020202020202020202020202020202069662820706C7567696E4F7074696F6E732E696E697469616C4D657373';
wwv_flow_imp.g_varchar2_table(10) := '6167652029207B0A20202020202020202020202020202020202020202020202020202020202020202F2F20646566657272696E6720666F7220636F7272656374204A41575320726561642D6F7574206F662074686520317374206D6573736167650A2020';
wwv_flow_imp.g_varchar2_table(11) := '20202020202020202020202020202020202020202020202020202020202073657454696D656F757428202829203D3E207B0A202020202020202020202020202020202020202020202020202020202020202020202020636861742E61646441694D657373';
wwv_flow_imp.g_varchar2_table(12) := '61676528207B0A20202020202020202020202020202020202020202020202020202020202020202020202020202020636F6E74656E743A20706C7567696E4F7074696F6E732E696E697469616C4D6573736167652C0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(13) := '20202020202020202020202020202020202020202020202020206578636C75646546726F6D436F6D6D6974733A20747275650A2020202020202020202020202020202020202020202020202020202020202020202020207D20293B202F2F206173796E63';
wwv_flow_imp.g_varchar2_table(14) := '0A20202020202020202020202020202020202020202020202020202020202020207D2C203120293B0A202020202020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202020202069';
wwv_flow_imp.g_varchar2_table(15) := '662820706C7567696E4F7074696F6E732E636C6F73654D6F6465203D3D3D2022636C6F7365222029207B0A202020202020202020202020202020202020202020202020202020202020202063686174566965772E6F6E652820226469616C6F67636C6F73';
wwv_flow_imp.g_varchar2_table(16) := '65222C202829203D3E207B0A202020202020202020202020202020202020202020202020202020202020202020202020636861742E64657374726F7928293B0A202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(17) := '63686174203D20756E646566696E65643B0A2020202020202020202020202020202020202020202020202020202020202020202020206368617456696577203D20756E646566696E65643B0A202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(18) := '20202020202020207D20293B0A202020202020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020207D20656C7365207B0A202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(19) := '2020202063686174566965772E73686F7728293B0A2020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D20293B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(20) := '20207D20293B0A20202020202020207D20656C73652069662820706C7567696E4F7074696F6E732E646973706C61794D6F6465203D3D3D2022696E6C696E65222029207B0A202020202020202020202020617065782E61692E67657455736572436F6E73';
wwv_flow_imp.g_varchar2_table(21) := '656E7428292E7468656E28206772616E746564203D3E207B0A20202020202020202020202020202020696628206772616E7465642029207B0A202020202020202020202020202020202020202063686174203D206E657720617065782E61692E43686174';
wwv_flow_imp.g_varchar2_table(22) := '2820636861744F7074696F6E7320293B0A20202020202020202020202020202020202020206368617456696577203D20636861742E637265617465496E6C696E655669657728207B0A202020202020202020202020202020202020202020202020656C3A';
wwv_flow_imp.g_varchar2_table(23) := '20646F63756D656E742E676574456C656D656E74427949642820706C7567696E4F7074696F6E732E656C656D496420292C0A2020202020202020202020202020202020202020202020202E2E2E766965774F7074696F6E730A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(24) := '2020202020202020207D20293B0A202020202020202020202020202020202020202069662820706C7567696E4F7074696F6E732E696E697469616C4D6573736167652029207B0A2020202020202020202020202020202020202020202020202F2F206465';
wwv_flow_imp.g_varchar2_table(25) := '66657272696E6720666F7220636F7272656374204A41575320726561642D6F7574206F662074686520317374206D6573736167650A20202020202020202020202020202020202020202020202073657454696D656F757428202829203D3E207B0A202020';
wwv_flow_imp.g_varchar2_table(26) := '20202020202020202020202020202020202020202020202020636861742E61646441694D65737361676528207B0A2020202020202020202020202020202020202020202020202020202020202020636F6E74656E743A20706C7567696E4F7074696F6E73';
wwv_flow_imp.g_varchar2_table(27) := '2E696E697469616C4D6573736167652C0A20202020202020202020202020202020202020202020202020202020202020206578636C75646546726F6D436F6D6D6974733A20747275650A2020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(28) := '20207D20293B202F2F206173796E630A2020202020202020202020202020202020202020202020207D2C203120293B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(29) := '7D20293B0A20202020202020207D0A0A2020202020202020617065782E6974656D2E6372656174652820706C7567696E4F7074696F6E732E6974656D4E616D652C207B0A2020202020202020202020206974656D5F747970653A202241495F4348415422';
wwv_flow_imp.g_varchar2_table(30) := '2C0A202020202020202020202020676574436861743A202829203D3E207B0A2020202020202020202020202020202072657475726E20636861743B0A2020202020202020202020207D2C0A20202020202020202020202067657443686174566965773A20';
wwv_flow_imp.g_varchar2_table(31) := '2829203D3E207B0A2020202020202020202020202020202072657475726E2063686174566965773B0A2020202020202020202020207D2C0A20202020202020207D20293B0A202020207D0A7D3B';
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(1472100533561262)
,p_plugin_id=>wwv_flow_imp.id(1428948731393230)
,p_file_name=>'script.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '77696E646F772E61694974656D506C7567696E3D7B696E69743A653D3E7B6C657420692C742C7B706C7567696E4F7074696F6E733A6E2C636861744F7074696F6E733A612C766965774F7074696F6E733A737D3D653B6E2E696E69744A7346756E632626';
wwv_flow_imp.g_varchar2_table(2) := '287B636861744F7074696F6E733A612C766965774F7074696F6E733A737D3D6E2E696E69744A7346756E63287B636861744F7074696F6E733A612C766965774F7074696F6E733A737D29292C226469616C6F67223D3D3D6E2E646973706C61794D6F6465';
wwv_flow_imp.g_varchar2_table(3) := '3F24282223222B6E2E656C656D4964292E6F6E2822636C69636B222C2828293D3E7B617065782E61692E67657455736572436F6E73656E7428292E7468656E2828653D3E7B65262628692626743F742E73686F7728293A28697C7C28693D6E6577206170';
wwv_flow_imp.g_varchar2_table(4) := '65782E61692E43686174286129292C743D692E6372656174654469616C6F67566965772873292C6E2E696E697469616C4D657373616765262673657454696D656F7574282828293D3E7B692E61646441694D657373616765287B636F6E74656E743A6E2E';
wwv_flow_imp.g_varchar2_table(5) := '696E697469616C4D6573736167652C6578636C75646546726F6D436F6D6D6974733A21307D297D292C31292C22636C6F7365223D3D3D6E2E636C6F73654D6F64652626742E6F6E6528226469616C6F67636C6F7365222C2828293D3E7B692E6465737472';
wwv_flow_imp.g_varchar2_table(6) := '6F7928292C693D766F696420302C743D766F696420307D292929297D29297D29293A22696E6C696E65223D3D3D6E2E646973706C61794D6F64652626617065782E61692E67657455736572436F6E73656E7428292E7468656E2828653D3E7B6526262869';
wwv_flow_imp.g_varchar2_table(7) := '3D6E657720617065782E61692E436861742861292C743D692E637265617465496E6C696E6556696577287B656C3A646F63756D656E742E676574456C656D656E7442794964286E2E656C656D4964292C2E2E2E737D292C6E2E696E697469616C4D657373';
wwv_flow_imp.g_varchar2_table(8) := '616765262673657454696D656F7574282828293D3E7B692E61646441694D657373616765287B636F6E74656E743A6E2E696E697469616C4D6573736167652C6578636C75646546726F6D436F6D6D6974733A21307D297D292C3129297D29292C61706578';
wwv_flow_imp.g_varchar2_table(9) := '2E6974656D2E637265617465286E2E6974656D4E616D652C7B6974656D5F747970653A2241495F43484154222C676574436861743A28293D3E692C67657443686174566965773A28293D3E747D297D7D3B';
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(3699342441239427)
,p_plugin_id=>wwv_flow_imp.id(1428948731393230)
,p_file_name=>'script.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(44506065542251869)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_reference_id=>77082398185639908
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(118549832896910933)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>'INTERNAL Social Sign-In'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_reference_id=>117694777698093086
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416838229346942507)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416838601415942507)
,p_plugin_attribute_id=>wwv_flow_imp.id(416838229346942507)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416839122722942508)
,p_plugin_attribute_id=>wwv_flow_imp.id(416838229346942507)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416839650738942508)
,p_plugin_attribute_id=>wwv_flow_imp.id(416838229346942507)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416840155231942508)
,p_plugin_attribute_id=>wwv_flow_imp.id(416838229346942507)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416840661671942509)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416838229346942507)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416841077960942509)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416838229346942507)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416841423172942509)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416838229346942507)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416841821427942510)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416838229346942507)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416842275948942510)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Oracle APEX automatically adds the "openid" scope. The authentication '
||'provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416842641238942510)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416843039534942510)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416843443373942511)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416843881250942511)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416844258422942511)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416838229346942507)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416844693274942512)
,p_plugin_attribute_id=>wwv_flow_imp.id(416844258422942511)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416845191699942512)
,p_plugin_attribute_id=>wwv_flow_imp.id(416844258422942511)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416845603211942512)
,p_plugin_attribute_id=>wwv_flow_imp.id(416844258422942511)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416846139737942512)
,p_plugin_attribute_id=>wwv_flow_imp.id(416844258422942511)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416846680928942513)
,p_plugin_id=>wwv_flow_imp.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (for example, "email_verified" for Username Attribute "email"). If the value of this attribute is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(505938009162025794)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Add Check All Checkbox'
,p_category=>'MISC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The "Add Check All Checkbox" dynamic action turns a column heading containing the #CHECK_ALL_CHECKBOX# string into an accessible check all style checkbox, that will check and uncheck all the checkboxes in its corresponding column.<p>',
'<p>',
'To use this plug-in, please ensure the following attributes are set:',
'<ol>',
'<li>In the report column, defined ''#CHECK_ALL_CHECKBOX#'' as the Heading value.</li>',
'<li>For the Dynamic Action When attribute, select the report region containing the column.</li>',
'<li>Define the Dynamic Action to fire ''After Refresh'', and the Action to ''Fire on Page Load''. (Both will default appropriately if the Dynamic Action is created by selecting the region in the ''Rendering'' section of Page Designer and creating the Dynam'
||'ic Action from there.</li>',
'<li>This will not handle the accessibility of the checkboxes rendered on each row, this must be done separately in the region source. (See 4000:656 ''Regions'' region for an example).</li>',
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2876432243634950829)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>'Developer Authorization'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1674054390757946)
,p_plugin_id=>wwv_flow_imp.id(2876432243634950829)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1674923950757947)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1675469074757947)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1675992475757948)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1676416627757948)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1676914042757949)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1677473338757949)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1677998085757949)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1678412541757949)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1678979881757950)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1679460185757950)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1679995683757950)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1680473397757951)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1674457833757947)
,p_plugin_attribute_id=>wwv_flow_imp.id(1674054390757946)
,p_display_sequence=>140
,p_display_value=>'DATA_GENERATOR: Ability to access Data Generator in SQL Workshop'
,p_return_value=>'DATA_GENERATOR'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_editor
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2985465796466205447)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_EDITOR'
,p_display_name=>'Code Editor'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_EDITOR'),'')
,p_api_version=>2
,p_render_function=>'wwv_flow_f4000_plugins.render_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_code_editor'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:ENCRYPT:INIT_JAVASCRIPT_CODE:SESSION_STATE_CLOB:AI_ENABLED_ALWAYS'
,p_substitute_attributes=>true
,p_reference_id=>1114646612921244845
,p_version_scn=>120171691
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2002885375583236)
,p_plugin_id=>wwv_flow_imp.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2003201370583237)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2003704033583238)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2004257269583238)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2004709363583238)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2005277964583238)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2005777754583238)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>43
,p_display_value=>'YAML'
,p_return_value=>'yaml'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2006243441583238)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2006753343583239)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2007234965583239)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>60
,p_display_value=>'PL/SQL Functions/Procedures'
,p_return_value=>'PLSQL_FUNCTIONS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2007782484583239)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2008253324583239)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2008741710583239)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2009238941583239)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript - Module'
,p_return_value=>'mle-javascript-module'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2009794925583239)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>105
,p_display_value=>'MLE - JavaScript - Snippet'
,p_return_value=>'mle-javascript-snippet'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2010232578583240)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>110
,p_display_value=>'File URLs - JavaScript'
,p_return_value=>'file-urls-javascript'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2010756149583240)
,p_plugin_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_display_sequence=>120
,p_display_value=>'File URLs - CSS'
,p_return_value=>'file-urls-css'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2011201903583240)
,p_plugin_id=>wwv_flow_imp.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2011647983583241)
,p_plugin_attribute_id=>wwv_flow_imp.id(2011201903583240)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2012109272583241)
,p_plugin_attribute_id=>wwv_flow_imp.id(2011201903583240)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2012620729583241)
,p_plugin_id=>wwv_flow_imp.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Show Query Builder'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL,PAGE_ITEM'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2013049794583242)
,p_plugin_id=>wwv_flow_imp.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Adjustable Height'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'If Yes the user can adjust the height of the code editor.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2013485414583242)
,p_plugin_id=>wwv_flow_imp.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remote  Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Specify a page item containing the remote database ID to use for code validation.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2013803701583242)
,p_plugin_id=>wwv_flow_imp.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2002885375583236)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'',
'<p>An event listener will be placed on this item, so when its value changes, the editor will change accordingly.</p>',
'',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2014235034583242)
,p_plugin_id=>wwv_flow_imp.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Diff Editor'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When in diff mode, the value is expected to be a stringified JSON of type <code>{"original":"...","modified":"..."}</code></p>',
'<p>Set the session state data type to CLOB when dealing with large values.</p>',
'<p>The original value is not editable. The modified value is editable by default, but this can be changed via the item''s Read Only flag.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2017090316583257)
,p_plugin_id=>wwv_flow_imp.id(2985465796466205447)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3324699829921132577)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>'INTERNAL Oracle APEX Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113737019268347425
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3324700073692132611)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>'INTERNAL Database Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749511183746276
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3324700335694132612)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>'INTERNAL HTTP Header Variable'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>708795120396802284
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308168108303529840)
,p_plugin_id=>wwv_flow_imp.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308168569830529840)
,p_plugin_id=>wwv_flow_imp.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308168914271529841)
,p_plugin_attribute_id=>wwv_flow_imp.id(308168569830529840)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308169423025529841)
,p_plugin_attribute_id=>wwv_flow_imp.id(308168569830529840)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308169950082529841)
,p_plugin_attribute_id=>wwv_flow_imp.id(308168569830529840)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308170436818529841)
,p_plugin_id=>wwv_flow_imp.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(308168569830529840)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308170871240529842)
,p_plugin_id=>wwv_flow_imp.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(308168569830529840)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308171296999529842)
,p_plugin_id=>wwv_flow_imp.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308171618165529842)
,p_plugin_attribute_id=>wwv_flow_imp.id(308171296999529842)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308172180106529843)
,p_plugin_attribute_id=>wwv_flow_imp.id(308171296999529842)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308172696409529843)
,p_plugin_id=>wwv_flow_imp.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3324706481652132628)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'INTERNAL LDAP Directory'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>863910941135523528
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the username and password for authentication against the LDAP directory identified on the login page. Remember, passwords may be case sensitive.</p>',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3324706669002132628)
,p_plugin_id=>wwv_flow_imp.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3324707056596132628)
,p_plugin_id=>wwv_flow_imp.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3324707506505132629)
,p_plugin_id=>wwv_flow_imp.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3324707815545132629)
,p_plugin_attribute_id=>wwv_flow_imp.id(3324707506505132629)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3324708404097132631)
,p_plugin_attribute_id=>wwv_flow_imp.id(3324707506505132629)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3324708840184132631)
,p_plugin_attribute_id=>wwv_flow_imp.id(3324707506505132629)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3324709400834132631)
,p_plugin_id=>wwv_flow_imp.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3324709739771132632)
,p_plugin_id=>wwv_flow_imp.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3324710148854132632)
,p_plugin_id=>wwv_flow_imp.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3324709739771132632)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3324710599897132632)
,p_plugin_id=>wwv_flow_imp.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3324710980739132632)
,p_plugin_id=>wwv_flow_imp.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3324711316335132633)
,p_plugin_attribute_id=>wwv_flow_imp.id(3324710980739132632)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3324711846150132633)
,p_plugin_attribute_id=>wwv_flow_imp.id(3324710980739132632)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3324712402550132633)
,p_plugin_attribute_id=>wwv_flow_imp.id(3324710980739132632)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3324713153644132635)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'INTERNAL Oracle Application Server Single Sign-On'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113750429890071859
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3324713486560132636)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'INTERNAL Oracle Cloud Identity Management'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749806821809026
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_wizard_selection
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3364064701836787185)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.WIZARD_SELECTION'
,p_display_name=>'Wizard Selection'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.WIZARD_SELECTION'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_wizard_selection'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_wizard_selection'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:SOURCE:ELEMENT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_reference_id=>805558538998648898
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3364064996228787343)
,p_plugin_id=>wwv_flow_imp.id(3364064701836787185)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3364065405041787344)
,p_plugin_attribute_id=>wwv_flow_imp.id(3364064996228787343)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'S'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3364065866700787344)
,p_plugin_attribute_id=>wwv_flow_imp.id(3364064996228787343)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'M'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3364066315358787344)
,p_plugin_attribute_id=>wwv_flow_imp.id(3364064996228787343)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'L'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3364066821322787346)
,p_plugin_id=>wwv_flow_imp.id(3364064701836787185)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Submit Page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Select whether or not to submit the page when making a selection'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(3403659208803969971)
,p_plugin_id=>wwv_flow_imp.id(3364064701836787185)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_clob_code_editor
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3503624151937027104)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_display_name=>'CLOB Code Editor'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.CLOB_CODE_EDITOR'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_code_editor'
,p_standard_attributes=>'SOURCE_SQL:NO_DATA_FOUND_MESSAGE:INIT_JAVASCRIPT_CODE:AI_ENABLED_ALWAYS'
,p_substitute_attributes=>true
,p_reference_id=>1127739634804688041
,p_version_scn=>120172118
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2154595985587347)
,p_plugin_id=>wwv_flow_imp.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2154983844587347)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2155439438587347)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2155956435587348)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2156453841587348)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2156983504587348)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2157482121587348)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2157961111587348)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2158455313587348)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2158925693587349)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PL/SQL_FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2159470581587349)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2159946402587349)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript - Module'
,p_return_value=>'mle-javascript-module'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2160476699587349)
,p_plugin_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_display_sequence=>110
,p_display_value=>'MLE - JavaScript - Snippet'
,p_return_value=>'mle-javascript-snippet'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2160951605587349)
,p_plugin_id=>wwv_flow_imp.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'attribute_02'
,p_prompt=>'Height'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2161384953587349)
,p_plugin_attribute_id=>wwv_flow_imp.id(2160951605587349)
,p_display_sequence=>1
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2161879727587349)
,p_plugin_attribute_id=>wwv_flow_imp.id(2160951605587349)
,p_display_sequence=>2
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2162376342587350)
,p_plugin_attribute_id=>wwv_flow_imp.id(2160951605587349)
,p_display_sequence=>3
,p_display_value=>'20'
,p_return_value=>'20'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2162843770587350)
,p_plugin_attribute_id=>wwv_flow_imp.id(2160951605587349)
,p_display_sequence=>10
,p_display_value=>'30'
,p_return_value=>'30'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2163370561587350)
,p_plugin_attribute_id=>wwv_flow_imp.id(2160951605587349)
,p_display_sequence=>20
,p_display_value=>'60'
,p_return_value=>'60'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2163832872587350)
,p_plugin_attribute_id=>wwv_flow_imp.id(2160951605587349)
,p_display_sequence=>25
,p_display_value=>'80'
,p_return_value=>'80'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2164326375587350)
,p_plugin_attribute_id=>wwv_flow_imp.id(2160951605587349)
,p_display_sequence=>30
,p_display_value=>'Automatic'
,p_return_value=>'AUTO'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2164867897587350)
,p_plugin_id=>wwv_flow_imp.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'attribute_03'
,p_prompt=>'Read Only'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2165296231587350)
,p_plugin_id=>wwv_flow_imp.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>15
,p_static_id=>'attribute_04'
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2165635534587351)
,p_plugin_attribute_id=>wwv_flow_imp.id(2165296231587350)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
,p_help_text=>'VARCHAR2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2166130433587351)
,p_plugin_attribute_id=>wwv_flow_imp.id(2165296231587350)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2166633353587351)
,p_plugin_id=>wwv_flow_imp.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'attribute_05'
,p_prompt=>'Remote Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>'Specify the an item containing the ID of the remote database to use for code validation.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2167008586587351)
,p_plugin_id=>wwv_flow_imp.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_static_id=>'attribute_06'
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2154595985587347)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'<p>An event listener will further be placed on this item, so that when its value changes, the editor will change accordingly.</p>',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2168682215587353)
,p_plugin_id=>wwv_flow_imp.id(3503624151937027104)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2169049524587354)
,p_plugin_id=>wwv_flow_imp.id(3503624151937027104)
,p_name=>'SOURCE_SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob_content',
'from demo_scripts'))
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_imp_page.create_page(
 p_id=>0
,p_name=>'0'
,p_step_title=>'0'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'14'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2943195795875068280)
,p_plug_name=>'APEX 5 - Header Old'
,p_region_css_classes=>'a-Header'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_07'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="f?p=4000:1500:&APP_SESSION." class="a-Header-logo" title="Home">',
'  <span class="a-Header-apexLogo"></span>',
'</a>'))
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6545080822676071207)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-app-builder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6545081024953071207)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_imp.id(6545080822676071207)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79231304903259803)
,p_plug_name=>'Navigation Tabs Landmark'
,p_parent_plug_id=>wwv_flow_imp.id(6545081024953071207)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'&PRODUCT_NAME.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6163005498826978606)
,p_plug_name=>'APEX Tabs'
,p_region_name=>'a_Header_menu'
,p_parent_plug_id=>wwv_flow_imp.id(79231304903259803)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(3078141213440643205)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3157523106769548315)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6545081194689071207)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_imp.id(6545081024953071207)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(',
'    ''<a href="'' ||',
'    wwv_flow_utilities.prepare_url(',
'        ''f?p=4100:1:'' || :APP_SESSION || ''::'' || :DEBUG ) ||',
'    ''" class="a-Header-logo"'' ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''title'',',
'        p_value => wwv_flow_lang.system_message( ''HOME_NAV'' ) ) ||',
'    ''><span role="img" aria-labelledby="labelApexLogo" class="a-Header-apexLogo"><span class="u-vh" id="labelApexLogo">'' ||',
'    wwv_flow_lang.system_message( ''HOME_NAV'' ) ||',
'    ''</span></span></a>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Logo'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6545081398411071208)
,p_plug_name=>'APEX 5 - Home Link'
,p_parent_plug_id=>wwv_flow_imp.id(6545081024953071207)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6545081643308071208)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_imp.id(6545080822676071207)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Navigation Bar'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6545081864584071208)
,p_plug_name=>'APEX 5 - Search'
,p_parent_plug_id=>wwv_flow_imp.id(6545081643308071208)
,p_region_css_classes=>'a-Header-search'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-SearchBox a-SearchBox--noGoButton a-SearchBox--autoExpand a-SearchBox--fill">'');',
'sys.htp.p(''  <div class="a-SearchBox-field">'');',
'sys.htp.p(''    <span class="a-SearchBox-icon"><span class="a-Icon icon-search"></span></span>'');',
'sys.htp.p(''    <label for="P0_SEARCH" class="visuallyhidden">Search</label>'');',
'sys.htp.p(''    <input type="text" class="a-SearchBox-input" id="P0_SEARCH" placeholder="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.SEARCH'')||''">'');',
'sys.htp.p(''  </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_landmark_type=>'region'
,p_landmark_label=>'Navigation Bar'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6545082010678071208)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_imp.id(6545081643308071208)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2400612870991803)
,p_plug_name=>'APEX 5 - Extensions Menu'
,p_region_name=>'extensionsMenu'
,p_parent_plug_id=>wwv_flow_imp.id(6545082010678071208)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_location=>null
,p_list_id=>wwv_flow_imp.id(5401582532816199)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3331503598779942021)
,p_translate_title=>'N'
,p_plug_required_role=>wwv_flow_imp.id(3001064397827272)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6545117961709147215)
,p_plug_name=>'APEX 5 - Administration Menu'
,p_region_name=>'adminMenu'
,p_parent_plug_id=>wwv_flow_imp.id(6545082010678071208)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(3078131037146643152)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3331503598779942021)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6643087951170591881)
,p_plug_name=>'APEX 5 - Help Menu'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_imp.id(6545082010678071208)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(3078138630465643203)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3331503598779942021)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6545082204037071208)
,p_plug_name=>'APEX 5 - Header Account'
,p_parent_plug_id=>wwv_flow_imp.id(6545081643308071208)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.account_mega_menu (',
'    p_username          => :APP_USER,',
'    p_workspace_id      => :WORKSPACE_ID,',
'    p_session           => :APP_SESSION,',
'    p_logout_url        => :LOGOUT_URL',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Account'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(735034611616168741)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6545082010678071208)
,p_button_name=>'UPGRADE_AVAILABLE'
,p_button_static_id=>'header-upgradeAvailable'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Upgrade Available'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_AVAILABLE:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-utilities-build-interval'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3078194876396647079)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6545081398411071208)
,p_button_name=>'Home'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Home'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4100:1:&SESSION.::&DEBUG.::::'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-home'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(735034521230168740)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6545082010678071208)
,p_button_name=>'UPGRADE_IN_PROGRESS'
,p_button_static_id=>'header-upgradeInProgress'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Upgrading'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_IN_PROGRESS:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''RUNNING'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-ig-refresh u-Animate-spin'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2400709086991804)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(6545082010678071208)
,p_button_name=>'Extensions'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2583919293963280507)
,p_button_image_alt=>'Extensions'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-extension'
,p_button_cattributes=>'data-menu="extensionsMenu_menu"'
,p_security_scheme=>wwv_flow_imp.id(3001064397827272)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3078196131874647081)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(6545082010678071208)
,p_button_name=>'Administration'
,p_button_static_id=>'header-adminMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2583919293963280507)
,p_button_image_alt=>'Administration'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-gears-alt'
,p_button_cattributes=>'data-menu="adminMenu_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3078196573562647081)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(6545082010678071208)
,p_button_name=>'Feedback'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Feedback'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4750:11001:&SESSION.::&DEBUG.:RP,11001:P11001_APPLICATION_ID,P11001_PAGE_ID:&APP_ID.,&APP_PAGE_ID.:'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-comments'
,p_required_patch=>wwv_flow_imp.id(641974235841696132)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3078196996191647082)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(6545082010678071208)
,p_button_name=>'Help'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2583919293963280507)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_imp_page.create_page(
 p_id=>1
,p_name=>'Create Application'
,p_alias=>'CREATE-APPLICATION'
,p_step_title=>'Create Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.stickyWidget#MIN#.js?v=#APEX_VERSION#',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.cropperEditor#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.iconEditor#MIN#.js'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var MSG_CREATING_APPLICATION = ''"CREATING_APPLICATION"'';',
'',
'(function( $ ){',
'    apex.create_app_wizard = apex.create_app_wizard || {};',
'',
'    apex.create_app_wizard.hasPage = function() {',
'        // If there is no page added to the Pages region, the length will be 1.',
'        return $(".a-PWList-item").length > 1;',
'    };',
'',
'    apex.create_app_wizard.handleCreateBtn = function(){',
'        let createBtn$ = apex.item(''CREATE_APP'');',
'        // App name, id and at least a page is required to create the app.        ',
'        if ( apex.item(''P1_APP_NAME'').isEmpty() || apex.item(''P1_APP_ID'').isEmpty() || !apex.create_app_wizard.hasPage() ) {',
'            createBtn$.disable();',
'        } else {',
'            createBtn$.enable();',
'        }',
'    };',
'',
'    apex.create_app_wizard.pageSort = function () {',
'        var prevSeq,',
'            currentSeq,',
'            moveCount,',
'            action,',
'            pageId;',
'',
'        var getSeq = function ( elem$ ) {',
'            return $( ''li.a-PWList-item'' ).index( elem$ );',
'        };',
'',
'        var move = function( page_id, move_count, v_action ) {',
'            apex.server.process( ''sortPage'', {',
'                x01: page_id,',
'                x02: move_count,',
'                x03: v_action',
'            }, {',
'                success: function( pData ) {',
'                    $( ''#pages'' ).trigger( ''apexrefresh'' );',
'                },',
'                error: function( pData ) {',
'                    alert( pData.responseText );',
'                }',
'            });',
'        };',
'',
'        $(".a-PWList").sortable({',
'            handle: ".a-PWList-dragHandle",',
'            items: "> li.is-draggable",',
'            placeholder: "a-PWList-item is-placeholder",',
'',
'            activate: function( event, ui ) {',
'                pageId = prevSeq = getSeq( ui.item.first() );',
'            },',
'',
'            update: function( event, ui ) {',
'                currentSeq = getSeq( ui.item.first() );',
'',
'                if ( currentSeq > prevSeq ) {',
'                    action = ''down'';',
'                    moveCount = currentSeq - prevSeq;',
'                } else {',
'                    action = ''up'';',
'                    moveCount = prevSeq - currentSeq;',
'                }',
'',
'                move(pageId, moveCount, action );',
'            }',
'',
'        });',
'',
'    };',
'',
'})( apex.jQuery );',
'',
'const showIcon = async () => {',
'    const result = await apex.server.process(''getIcon'');',
'',
'    if ( result.success ) {',
'        apex.jQuery("#AppIcon").css({',
'            ''background-color'': '''',',
'            ''background-image'': `url(''data:image/png;base64,${result.base64.replace(/(\r\n|\n|\r)/gm, "")}'')`',
'        });',
'    }',
'};'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function( $ ){',
'    $("#choose_icon").appendTo(".a-PageWizard-appIconContainer .a-Form-inputContainer");',
'',
'    apex.item( "P1_STATUS" ).setValue( "" );',
'    apex.item( "P1_PCT_COMPLETE" ).setValue( "" );',
'    apex.item( "P1_CURRENT_STATUS" ).setValue( "" );',
'',
'    apex.jQuery(".a-PageWizard-buttons")',
'        .stickyWidget({',
'            isFooter: true, ',
'            toggleWidth: true',
'        });',
'',
'    if ( apex.create_app_wizard.hasPage() ) {',
'        apex.create_app_wizard.pageSort();',
'    }',
'',
'})( apex.jQuery );'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.field.item-app-name {',
'  margin-bottom: 0;',
'}',
'',
'.field--style--boxed .display_only {',
'  line-height: 24px;',
'  white-space: nowrap;',
'  overflow: hidden;',
'  text-overflow: ellipsis;',
'}',
'',
'.apex-col .field.field-item-button-grouping {',
'  margin-right: -1px;',
'}',
'',
'.lang-button {',
'  padding-top: 19px;',
'  padding-bottom: 19px;',
'  width: calc(100% - 16px);',
'  margin-right: 16px;',
'}',
'',
'.advanced-button {',
'  padding-top: 19px;',
'  padding-bottom: 19px;',
'  width: calc(100% - 16px);',
'  margin-right: 16px;',
'}',
'',
'.attribute-button {',
'  padding-top: 19px;',
'  padding-bottom: 19px;',
'  width: calc(100% - 16px);',
'  margin-right: 16px;',
'}',
'',
'.a-BoxedForms .field-item-button-grouping .field-input__wrap {',
'  border-radius: 2px 0 0 2px;',
'}',
'',
'html.no-js .a-BoxedForms .field--style--boxed.label-only .field-label {',
'  padding-top: 1.8rem;',
'  padding-bottom: 1.8rem;',
'}',
'',
'.page-source-table {',
'  font-family: monospace;',
'  font-size: 11px;',
'  line-height: 21px;',
'  margin: 0 4px;',
'}',
'',
'.features-checkbox .apex-item-grid {',
'  width: 100%;',
'  table-layout: fixed;',
'}',
'',
'.field--style--boxed.last-item {',
'  margin-right: 16px !important;',
'}',
'',
'.a-PageWizard-buttons {',
'  margin-top: 0;',
'  padding-top: 32px;',
'  padding-bottom: 16px;',
'}',
'',
'.a-PWList-item--add {',
'  position: relative;',
'}',
'',
'.a-PWList-item--add .a-PWList-name a:before {',
'  position: absolute;',
'  top: 0;',
'  left: 0;',
'  right: 0;',
'  bottom: 0;',
'  content: '''';',
'  display: block;',
'}',
'',
'#AppIcon {',
'  width: 64px;',
'  height: 64px;',
'  border-radius: 4px;',
'  background-size: cover;',
'}',
'',
'.app-icon-column {',
'  max-inline-size: 80px;',
'}'))
,p_step_template=>wwv_flow_imp.id(3221353480673840388)
,p_page_css_classes=>'a-PageWizard-page'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'13'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1007567025794031530)
,p_plug_name=>'Create Application Progress'
,p_region_name=>'createAppProgress'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3012513290302116971)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8119582015725719321)
,p_plug_name=>'Create an Application'
,p_region_css_classes=>'a-PageWizard '
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2588924839213150542)
,p_plug_name=>'Appearance'
,p_region_name=>'appearance'
,p_parent_plug_id=>wwv_flow_imp.id(8119582015725719321)
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(2584574193315975428)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5170953344043764457)
,p_name=>'Pages'
,p_region_name=>'pages'
,p_parent_plug_id=>wwv_flow_imp.id(8119582015725719321)
,p_template=>wwv_flow_imp.id(2584574193315975428)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  0 sort_order,',
'  null id,',
'  ''a-PWList-item--add is-not-draggable'' page_li_class,',
'  ''<span data-href="''||wwv_flow_page_api.get_url(p_page => 1000, p_clear_cache => 1000)||''" class="a-PageWizard-icon page-icon page-add" aria-hidden="true"></span>'' page_icon,',
'  ''<a href="''||wwv_flow_page_api.get_url(p_page => 1000, p_clear_cache => 1000)||''">'' || wwv_flow_lang.custom_runtime_message(''CA.ADD.PAGE'') || ''</a>'' page_title,',
'  '' '' page_desc,',
'  null edit_link,',
'  '' '' page_actions,',
'  wwv_flow_page_api.get_url(p_page => 1000, p_clear_cache => 1000) page_link,',
'  ''n'' admin_page_yn,',
'  ''n'' homepage_yn,',
'  '' '' drag_icon,',
'  '' '' page_draggable,',
'  '' '' page_drag_handle',
'from sys.dual ',
'union all',
'select',
'  seq_id sort_order,',
'  seq_id id,',
'  case when c015 = ''Y'' then ''is-admin-page''',
'       else '' ''',
'  end page_li_class,',
'  ''<span class="a-PageWizard-icon page-icon page-'' || replace(lower(c002), ''_'', ''-'')||''"></span>'' page_icon,',
'  ''<span class="a-PWList-navIcon fa ''|| wwv_flow_escape.html( c013 ) ||''" aria-hidden="true"></span> ''|| wwv_flow_escape.html( c001 ) page_title,',
'  case when c012 = ''Y'' then',
'      wwv_flow_lang.custom_runtime_message(''CA.REPORT.N.WITH.FORM'', htmldb_item.text_from_lov( p_value => c002, p_lov => ''PAGE_TYPES'') )',
'  else',
'      htmldb_item.text_from_lov( p_value => c002, p_lov => ''PAGE_TYPES'')',
'  end||',
'  case when c003 = ''TABLE'' then '' (<span class="page-source-table">''',
'            || wwv_flow_escape.html( lower(c005) )',
'            || wwv_flow_escape.html( nvl2(c025, ''; '' || lower(c025), null) )',
'            || wwv_flow_escape.html( nvl2(c026, '' ...'', null) )',
'            || ''</span>)''',
'       when c003 = ''SQL'' then '' (<span class="page-source-table">''||wwv_flow_lang.custom_runtime_message(''CA.CUSTOM.QRY'')||''</span>)''',
'       when c015 = ''Y'' then '' (''||wwv_flow_lang.custom_runtime_message(''CA.ADMIN.PAGE'')||'')''',
'  end page_desc,',
'  case when c002 = ''BLANK'' then ',
'           wwv_flow_page_api.get_url(p_page => 1010, p_items => ''P1010_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1010'')',
'       when c002 in ( ''INTERACTIVE_RPT'', ''CLASSIC_RPT'' ) then',
'           wwv_flow_page_api.get_url(p_page => 1020, p_items => ''P1020_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1020'')',
'       when c002 = ''FACETED_SEARCH'' then',
'           wwv_flow_page_api.get_url(p_page => 1140, p_items => ''P1140_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1140'')',
'       when c002 = ''INTERACTIVE_GRID'' then',
'           wwv_flow_page_api.get_url(p_page => 1030, p_items => ''P1030_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1030'')',
'       when c002 = ''FORM'' then',
'           wwv_flow_page_api.get_url(p_page => 1100, p_items => ''P1100_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1100'')',
'       when c002 = ''MASTER_DETAIL'' then',
'           wwv_flow_page_api.get_url(p_page => 1040, p_items => ''P1040_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1040'')',
'       when c002 = ''CHART'' then',
'           wwv_flow_page_api.get_url(p_page => 1050, p_items => ''P1050_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1050'')',
'       when c002 = ''DASHBOARD'' then',
'           wwv_flow_page_api.get_url(p_page => 1060, p_items => ''P1060_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1060'')',
'       when c002 = ''CALENDAR'' then',
'           wwv_flow_page_api.get_url(p_page => 1070, p_items => ''P1070_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1070'')',
'       when c002 = ''CARDS'' then',
'           wwv_flow_page_api.get_url(p_page => 1090, p_items => ''P1090_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1090'')',
'       when c002 = ''TIMELINE'' then',
'           wwv_flow_page_api.get_url(p_page => 1110, p_items => ''P1110_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1110'')',
'       when c002 = ''WIZARD'' then',
'           wwv_flow_page_api.get_url(p_page => 1120, p_items => ''P1120_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1120'')',
'       when c002 = ''MAP'' then',
'           wwv_flow_page_api.get_url(p_page => 1150, p_items => ''P1150_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1150'')',
'       when c002 = ''SMART_FILTERS'' then',
'           wwv_flow_page_api.get_url(p_page => 1160, p_items => ''P1160_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1160'')',
'  end edit_link,',
'  '''' page_actions,',
'  '' '' page_link,',
'  c015 admin_page_yn,',
'  c010 homepage_yn,',
'  case when c015 = ''Y'' then ''<span class="fa fa-wrench" aria-hidden="true" title="''||wwv_flow_lang.custom_runtime_message(''CA.ADMIN.PAGE'')||''"></span>'' -- is admin page',
'       when c010 = ''Y'' then ''<span class="fa fa-home" aria-hidden="true" title="''||wwv_flow_lang.custom_runtime_message(''CA.HOME.PAGE'')||''"></span>'' -- is homepage',
'       else ''<span class="fa fa-bars" aria-hidden="true" title="''||wwv_flow_lang.custom_runtime_message(''CA.DRAG.TO.REORDER'')||''"></span>''',
'  end drag_icon,',
'  case c015 when ''Y'' then ''is-not-draggable''',
'            else case c010 when ''Y'' then ''is-not-draggable'' ',
'                 else ''is-draggable'' ',
'            end',
'  end page_draggable,',
'  '' '' page_drag_handle',
'from wwv_flow_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE''',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(2583678044278335201)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592733388174337004)
,p_query_column_id=>1
,p_column_alias=>'SORT_ORDER'
,p_column_display_sequence=>6
,p_column_heading=>'Sort order'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592730594146337001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>8
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592728590024336998)
,p_query_column_id=>3
,p_column_alias=>'PAGE_LI_CLASS'
,p_column_display_sequence=>1
,p_column_heading=>'Page li class'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592728956532337000)
,p_query_column_id=>4
,p_column_alias=>'PAGE_ICON'
,p_column_display_sequence=>2
,p_column_heading=>'Page icon'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592729394433337000)
,p_query_column_id=>5
,p_column_alias=>'PAGE_TITLE'
,p_column_display_sequence=>3
,p_column_heading=>'Page title'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592729720491337001)
,p_query_column_id=>6
,p_column_alias=>'PAGE_DESC'
,p_column_display_sequence=>4
,p_column_heading=>'Page desc'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592731346485337002)
,p_query_column_id=>7
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>10
,p_column_heading=>'Edit link'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592730198916337001)
,p_query_column_id=>8
,p_column_alias=>'PAGE_ACTIONS'
,p_column_display_sequence=>5
,p_column_heading=>'Page actions'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<button class="a-Button" type="button" onclick="#EDIT_LINK#">Edit</button>'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592732981583337004)
,p_query_column_id=>9
,p_column_alias=>'PAGE_LINK'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2934949213997675417)
,p_query_column_id=>10
,p_column_alias=>'ADMIN_PAGE_YN'
,p_column_display_sequence=>14
,p_column_heading=>'Administration page'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592730987527337002)
,p_query_column_id=>11
,p_column_alias=>'HOMEPAGE_YN'
,p_column_display_sequence=>9
,p_column_heading=>'Home page'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592732119674337003)
,p_query_column_id=>12
,p_column_alias=>'DRAG_ICON'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592732504457337003)
,p_query_column_id=>13
,p_column_alias=>'PAGE_DRAGGABLE'
,p_column_display_sequence=>13
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2592731761742337003)
,p_query_column_id=>14
,p_column_alias=>'PAGE_DRAG_HANDLE'
,p_column_display_sequence=>11
,p_column_heading=>'Page drag handle'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="a-PWList-dragHandle #PAGE_DRAGGABLE#">#DRAG_ICON#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5170954103611764465)
,p_plug_name=>'Wizard Header'
,p_parent_plug_id=>wwv_flow_imp.id(8119582015725719321)
,p_region_css_classes=>'a-PageWizard-header'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_blueprint_count number := 0;',
'begin',
'',
'    -- get count of blueprints',
'    select count(*)',
'    into l_blueprint_count',
'    from WWV_FLOW_BLUEPRINT_REPO',
'    where created_by = :APP_USER and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'',
'    sys.htp.p(''<div class="a-PageWizard-preview">'');',
'    -- sys.htp.prn(''<a href="''||htmldb_util.prepare_url(''f?p=4020:900:''||:APP_SESSION||''::::P900_HELP_SECTION:INTRO'')||''">'');',
'    -- sys.htp.prn(wwv_flow_lang.custom_runtime_message(''CA.ABOUT.THIS.PREVIEW.RELEASE''));',
'    -- sys.htp.prn(''</a>'');',
'    sys.htp.prn(''<a href="''||htmldb_util.prepare_url(''f?p=4020:150:''||:APP_SESSION||'':LOAD_CURRENT::150'')||''" id="view_blueprint">'');',
'    sys.htp.prn(wwv_flow_lang.custom_runtime_message(''CA.VIEW.BLUEPRINT''));',
'    sys.htp.prn(''</a>'');',
'    if l_blueprint_count > 0 then',
'      sys.htp.prn(''<a href="''||wwv_flow_page_api.get_url(p_page => 160, p_session => :APP_SESSION, p_request => ''LOAD'', p_items => ''P160_RETURN_TYPE'', p_values => ''LOAD'')||''" class="a-PageWizard-returnLink" id="load_blueprint">'');',
'      sys.htp.prn(wwv_flow_lang.custom_runtime_message(''CA.LOAD.BLUEPRINT''));',
'      sys.htp.prn(''</a>'');',
'    end if;',
'    sys.htp.prn(''</div><h1>''||wwv_flow_lang.custom_runtime_message(''CA.CREATE.APPLICATION'')||''</h1>'');',
'    exception when others then null;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5170954341225764467)
,p_plug_name=>'Features'
,p_region_name=>'features'
,p_parent_plug_id=>wwv_flow_imp.id(8119582015725719321)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2584574193315975428)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5170955245543764476)
,p_plug_name=>'Misc'
,p_parent_plug_id=>wwv_flow_imp.id(8119582015725719321)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7754217211232429554)
,p_plug_name=>'Settings'
,p_region_name=>'advanced'
,p_parent_plug_id=>wwv_flow_imp.id(8119582015725719321)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2584574193315975428)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8119582248366719323)
,p_plug_name=>'Application'
,p_region_name=>'app_info'
,p_parent_plug_id=>wwv_flow_imp.id(8119582015725719321)
,p_region_css_classes=>'a-BoxedForms a-BoxedForms--large'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8119582824709719329)
,p_plug_name=>'Wizard Buttons'
,p_parent_plug_id=>wwv_flow_imp.id(8119582015725719321)
,p_region_css_classes=>'a-PageWizard-buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4242065731012928)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8119582248366719323)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'AppIcon'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:RP,120:P120_ICON_CLASS,P120_ICON_COLOR,P120_ICON_COLOR_CLASS:&P1_APP_ICON_CLASS.,&P1_APP_COLOR_HEX.,&P1_APP_COLOR_CLASS.'
,p_grid_column_attributes=>'app-icon-column padding-right-md'
,p_grid_new_row=>'Y'
,p_grid_column_span=>1
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(161343362574782313)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(8119582248366719323)
,p_button_name=>'SET_UI'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Set Appearance'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'lang-button'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>1
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2929370093940839432)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_button_name=>'SELECT_ADV_SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Define Advanced Settings'
,p_button_redirect_url=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'advanced-button'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>1
,p_required_patch=>wwv_flow_imp.id(3027829547778015556)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2929370286352839434)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_button_name=>'SELECT_ATT_DEF'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Define Attribute Defaults'
,p_button_execute_validations=>'N'
,p_button_css_classes=>'attribute-button is-last'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>1
,p_required_patch=>wwv_flow_imp.id(3027830547707021532)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2796574865702751032)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_button_name=>'SET_SUPOBJ'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Set Supporting Objects'
,p_button_redirect_url=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'lang-button'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>1
,p_required_patch=>wwv_flow_imp.id(3124271964326242195)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2588925400019150548)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_button_name=>'HELP_SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'View Help for Settings'
,p_button_position=>'HELP'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:SETTINGS'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2595754447069422204)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_button_name=>'HELP_UI'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'View Help for Settings'
,p_button_position=>'HELP'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:UI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2595754509287422205)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5170954341225764467)
,p_button_name=>'HELP_FEATURES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'View Help for Features'
,p_button_position=>'HELP'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:FEATURES'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2595755773975422217)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5170953344043764457)
,p_button_name=>'HELP_PAGES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'View Help for Pages'
,p_button_position=>'HELP'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:PAGES'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2816364410490843901)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5170954341225764467)
,p_button_name=>'CHECK_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Check All'
,p_button_position=>'HELP'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698020678343126341)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8119582824709719329)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=4000:1500:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'a-Button--xlarge'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2592727824404336994)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8119582824709719329)
,p_button_name=>'CREATE_APPLICATION'
,p_button_static_id=>'CREATE_APP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'a-Button--xlarge a-Button--createApp'
,p_button_cattributes=>'disabled'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(63351936853934416)
,p_branch_name=>'Create Application Error'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_APP_ERROR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2878625357225257309)
,p_branch_name=>'sup obj install failed'
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_collections',
'where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'and c002 = ''FAIL'''))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2592737935823337026)
,p_branch_name=>'application home'
,p_branch_action=>'f?p=4000:1:&SESSION.::&DEBUG.:RP:FB_FLOW_ID,F4000_P1_FLOW:&P1_APP_ID.,&P1_APP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_collections',
'where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'and c002 = ''FAIL'''))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3398688211863765508)
,p_branch_name=>'attribute defaults'
,p_branch_action=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP,::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2929370286352839434)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1699270756214123)
,p_name=>'P1_NEW_TABLE_NAME'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2710328006383928)
,p_name=>'P1_LAST_PAGE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33865378214899629)
,p_name=>'P1_SAMPLE_JSON_ID'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63351407823934411)
,p_name=>'P1_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8119582824709719329)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63351684305934413)
,p_name=>'P1_CURRENT_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8119582824709719329)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63351739164934414)
,p_name=>'P1_PCT_COMPLETE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8119582824709719329)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63351864236934415)
,p_name=>'P1_ERROR_MESSAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8119582824709719329)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(69711388331469934)
,p_name=>'P1_SCRIPT_FILE_ID'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(84648867843905208)
,p_name=>'P1_THEME_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_item_default=>'UT'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'UT, CUSTOM or CUSTOM_UT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(84648983889905209)
,p_name=>'P1_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101210628211869202)
,p_name=>'P1_THEME_STYLE_CLASS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
,p_item_comment=>'Set in DA, used on Page 1 and 1000'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(161343206126782312)
,p_name=>'P1_APPEARANCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8119582248366719323)
,p_prompt=>'Appearance'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field-item-button-grouping'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2574074743958843405)
,p_name=>'P1_AUTHENTICATION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_prompt=>'Authentication'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default_auth_scheme varchar2(4000) := null;',
'begin',
'    if wwv_flow_authentication_dev.get_internal_authentication in (''CLOUD_IDM'', ''SSO'') then',
'        l_default_auth_scheme := wwv_flow_authentication_dev.get_internal_authentication;',
'    else',
'        l_default_auth_scheme := :PRODUCT_NAME;',
'    end if;',
'      ',
'    return l_default_auth_scheme;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHENTICATION.OPTIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.''|| name_with_prefix) as d,',
'       name_with_prefix      as r',
'  from wwv_flow_native_plugins',
' where plugin_type = ''AUTHENTICATION TYPE''',
'   and (          name_with_prefix = ''NATIVE_APEX_ACCOUNTS''',
'         or (     name_with_prefix = ''NATIVE_IAS_SSO''',
'              and wwv_flow_authentication_dev.can_use_sso_yn = ''Y'' )',
'         or (     name_with_prefix = ''NATIVE_SAML'' )',
'         or (     name_with_prefix = ''NATIVE_DB_ACCOUNTS''',
'              and wwv_flow_authentication_dev.get_internal_authentication <> ''CLOUD_IDM'' ) )',
'union all',
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'') d,',
'       ''NATIVE_CLOUD_IDM'' r',
'  from sys.dual',
' where wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'last-item'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(2698024775220408056)
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2588924959567150543)
,p_name=>'P1_NAV_POSITION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592720665139336973)
,p_name=>'P1_FEATURES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5170954341225764467)
,p_prompt=>'Features'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'APPLICATION FEATURES'
,p_lov=>'.'||wwv_flow_imp.id(2584581350475987525)||'.'
,p_tag_css_classes=>'features-checkbox'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-CBList'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'3'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592721384721336981)
,p_name=>'P1_REMEMBER_WIZARD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5170955245543764476)
,p_prompt=>'Use this wizard next time I create an application'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592722076041336984)
,p_name=>'P1_APP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_prompt=>'Application ID'
,p_source=>'wwv_flow_utilities.minimum_free_flow'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>12
,p_colspan=>4
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_03=>'left'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592722446739336985)
,p_name=>'P1_PRIMARY_LANGUAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_item_default=>':BROWSER_LANGUAGE'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Language'
,p_source=>':BROWSER_LANGUAGE'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_imp.id(261035724719892504)||'.'
,p_cHeight=>1
,p_colspan=>4
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(2698024578226405812)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the primary language for this application.<br /><br />',
'This attribute identifies the language in which an application is developed. This language is the base language from which all translations are made. '))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592723726162336986)
,p_name=>'P1_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) a, schema b',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_colspan=>4
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592725816442336990)
,p_name=>'P1_APP_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8119582248366719323)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'item-app-name'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592726222702336990)
,p_name=>'P1_THEME_APP_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(8119582248366719323)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_theme_app_id number;',
'begin',
'    for c2 in (select t.id id',
'                from wwv_flows f, wwv_flow_themes t',
'               where f.security_group_id = 12',
'                 and f.application_type = ''THEME''',
'                 and f.id = t.flow_id',
'                 and f.theme_id = t.theme_id',
'                 and instr('',''||wwv_flow_platform.get_preference(''DEFAULT_THEMES'')||'','','',''||t.theme_id||'','') > 0 )',
'    loop',
'        l_theme_app_id := c2.id;',
'    end loop;',
'    ',
'    return l_theme_app_id;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592726600519336991)
,p_name=>'P1_THEME_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2647105299483258112)
,p_name=>'P1_APP_COLOR_CLASS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'B'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2698020232651126337)
,p_name=>'P1_APP_COLOR_HEX'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2698020453382126339)
,p_name=>'P1_APP_ICON_CLASS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2796574722343751031)
,p_name=>'P1_SUPPORTING_OBJS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_item_default=>'None'
,p_prompt=>'Supporting Objects'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field-item-button-grouping'
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3124271964326242195)
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2927879450766772209)
,p_name=>'P1_TRANSLATED_LANGS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_required_patch=>wwv_flow_imp.id(2698024578226405812)
,p_help_text=>'Optionally identify additional languages you would like to translate this application into. '
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929369916090839431)
,p_name=>'P1_ADVANCED_SETTINGS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_prompt=>'Advanced Settings'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field-item-button-grouping label-only'
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3027829547778015556)
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929370181863839433)
,p_name=>'P1_APP_DEFAULTS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_prompt=>'UI Defaults'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field-item-button-grouping label-only'
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3027830547707021532)
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3396254935956246644)
,p_name=>'P1_NAV_POSITION_DISP'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2588924839213150542)
,p_item_default=>'SIDE'
,p_prompt=>'New'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1_NAVIGATION_POSITION'
,p_lov=>'.'||wwv_flow_imp.id(2621239147915611502)||'.'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_item_comment=>'Used in DA "Set Appearance" to get displayed value only. Not saved.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4032943218417342948)
,p_name=>'P1_SCRIPT_RESULT_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3773582095982301543)
,p_computation_sequence=>10
,p_computation_item=>'P1_THEME_STYLE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Vita'
,p_compute_when=>'P1_THEME_STYLE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3773582128939301544)
,p_computation_sequence=>20
,p_computation_item=>'P1_NAV_POSITION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'SIDE'
,p_compute_when=>'P1_NAV_POSITION'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2647106702696258127)
,p_computation_sequence=>30
,p_computation_item=>'P1_APP_ICON_CLASS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''app-icon-''||lovd.lov_return_value',
'  from wwv_flow_list_of_values_data lovd,',
'       wwv_flow_lists_of_values$ lov',
' where lov.flow_id            = :app_id',
'   and lovd.lov_id            = lov.id',
'   and lovd.flow_id           = lov.flow_id',
'   and lovd.security_group_id = lov.security_group_id',
'   and lov.lov_name           = ''P120_APP_ICONS''',
' order by sys.dbms_random.value',
' fetch first 1 row only'))
,p_compute_when=>'P1_APP_ICON_CLASS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2647106838317258128)
,p_computation_sequence=>40
,p_computation_item=>'P1_APP_COLOR_CLASS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''app-color-'' || round( sys.dbms_random.value( 1,8 ) ) ',
'  from sys.dual'))
,p_compute_when=>'P1_APP_COLOR_CLASS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2707858906190463440)
,p_computation_sequence=>50
,p_computation_item=>'P1_APP_COLOR_HEX'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lovd.lov_return_value',
'  from wwv_flow_list_of_values_data lovd,',
'       wwv_flow_lists_of_values$ lov',
' where lov.flow_id            = :app_id',
'   and lovd.lov_id            = lov.id',
'   and lovd.flow_id           = lov.flow_id',
'   and lovd.security_group_id = lov.security_group_id',
'   and lov.lov_name           = ''P120_APP_COLORS''',
'   and lovd.lov_disp_sequence = replace(:p1_app_color_class, ''app-color-'');'))
,p_compute_when=>'P1_APP_COLOR_HEX'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2934949192969675416)
,p_computation_sequence=>60
,p_computation_item=>'P1_PRIMARY_LANGUAGE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':BROWSER_LANGUAGE'
,p_compute_when=>'P1_PRIMARY_LANGUAGE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2796575014459751034)
,p_computation_sequence=>70
,p_computation_item=>'P1_SUPPORTING_OBJS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>'select dbms_lob.substr(clob001,30,1) x from wwv_flow_collections where collection_name = ''APEX$CREATEAPPSUPPOBJ'''
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3674119010657496428)
,p_computation_sequence=>10
,p_computation_item=>'P1_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select run_as',
'from wwv_flow_sw_results',
'where id = :P1_SCRIPT_RESULT_ID',
'and security_group_id = :flow_security_group_id'))
,p_compute_when=>'P1_SCRIPT_RESULT_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(63352257772934419)
,p_validation_name=>'Validate application ID'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_application_id (',
'         p_name => :P1_APP_ID);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'CREATE_APP_ERROR'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2592722076041336984)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(63352379251934420)
,p_validation_name=>'Application ID available'
,p_validation_sequence=>20
,p_validation=>'select 1 from wwv_flows where id = :P1_APP_ID'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Application ID already exists, or is reserved for another application.'
,p_validation_condition=>'CREATE_APP_ERROR'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2592722076041336984)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(63352452742934421)
,p_validation_name=>'Validate Application Name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_application_name (',
'  p_name => :P1_APP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'CREATE_APP_ERROR'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2592725816442336990)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(63352073466934417)
,p_validation_name=>'Create Application Error'
,p_validation_sequence=>60
,p_validation=>'return false;'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'&P1_ERROR_MESSAGE.'
,p_validation_condition=>'CREATE_APP_ORA_ERROR'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2592736931000337018)
,p_name=>'Refresh Pages on Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(5170953344043764457)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2592737489815337024)
,p_event_id=>wwv_flow_imp.id(2592736931000337018)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5170953344043764457)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1917402761781338048)
,p_name=>'Save Schema in Session'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1_SCHEMA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'focusout'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1917402832990338049)
,p_event_id=>wwv_flow_imp.id(1917402761781338048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'htmldb_util.set_session_state(''P1_SCHEMA'', :P1_SCHEMA);'
,p_attribute_02=>'P1_SCHEMA'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2595755989816422219)
,p_name=>'Set Appearance and Toggle Features'
,p_event_sequence=>50
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'( this.data && this.data.dialogPageId === 160 ) || ( this.data && this.data.dialogPageId === 170 ) || !this.data'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2595756028896422220)
,p_event_id=>wwv_flow_imp.id(2595755989816422219)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var $ = apex.jQuery,',
'    ajaxData = this.data,',
'    themeType = $v(''P1_THEME_TYPE''),',
'    isCustomTheme = themeType === ''CUSTOM'',',
'    isCustomUT = themeType === ''CUSTOM_UT'',',
'    theme,',
'    nav,',
'    output,',
'    blueprintActions$ = $( ''.a-PageWizard-preview'' ),',
'    features$ = $( ''#features'' ),',
'    page$ = $( ''#pages'' ),',
'    tMapping = {',
'		"Vita": "theme-vita",',
'		"Vita - Slate": "theme-vita-slate",',
'		"Vita - Red": "theme-vita-red",',
'		"Vita - Dark": "theme-vita-dark",',
'        "Redwood Light": "theme-redwood",',
'		"Vista": "theme-vista",',
'	},',
'    // For P1_THEME_STYLE_CLASS that is used on both Page 1 and 1000',
'    themeClass,',
'    defaultThemeClass = tMapping.Vita;',
'',
'var getNavDisp = function( val ){',
'    var txt = $(''#P1_NAV_POSITION_DISP input'').filter(function(){ ',
'                  return this.value === val;',
'              }).next().text();',
'    ',
'    return txt.substr( 0, txt.indexOf(''|'') - 1 ); // remove everything after ''|''',
'};',
'',
'if ( ajaxData ) {',
'    theme = ajaxData.P170_THEME_STYLE;',
'    nav   = ajaxData.P170_NAV_POSITION;',
'    if ( ajaxData.P170_CUSTOM_THEME_YN === ''Y'' ) {',
'        theme = '''',',
'        nav = '''',',
'        isCustomTheme = true;',
'        isCustomUT = ajaxData.P1_THEME_TYPE === ''CUSTOM_UT''',
'    } else {',
'    	isCustomTheme = false;',
'    	isCustomUT = false;',
'    }',
'    ',
'} else {',
'    theme = $v( ''P1_THEME_STYLE'' );',
'    nav   = $v( ''P1_NAV_POSITION'' );',
'}',
'',
'// Display value of P1_APPEARANCE',
'if ( isCustomTheme ) {',
'    output = apex.lang.getMessage( ''CA.CUSTOM_THEME'' );',
'    if (!isCustomUT) {',
'        // clear all feature choices',
'        $( "[name=''P1_FEATURES'']" ).prop( ''checked'', false );',
'        features$.hide();',
'        blueprintActions$.hide();',
'        ',
'    } else {',
'        features$.show();',
'        blueprintActions$.show();',
'    }',
'} else {',
'	$s( ''P1_THEME_TYPE'', ''UT'' );',
'    output = theme + '', '' + getNavDisp( nav ); ',
'    features$.show();',
'    blueprintActions$.show();',
'}',
'',
'// Set P1_APPEARANCE',
'$s( ''P1_APPEARANCE'', output );',
'',
'// Save the class to be reused on Page 1',
'themeClass = tMapping[ theme ] || defaultThemeClass;',
'$s(''P1_THEME_STYLE'', theme );',
'$s(''P1_THEME_STYLE_CLASS'', themeClass );',
'',
'// Update icon theme in "Pages" Region',
'page$',
'	.removeClass( page$.attr(''class'').split('' '').pop() )',
'	.addClass( themeClass );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2647107076010258130)
,p_name=>'Click Create Application Button'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2592727824404336994)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2647107184363258131)
,p_event_id=>wwv_flow_imp.id(2647107076010258130)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2592727824404336994)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2647107202426258132)
,p_event_id=>wwv_flow_imp.id(2647107076010258130)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lProgressTxt, lProgressPct, lLastProgressTxt, lLastProgressPct, lOverlay$,lMessage$, lComplete$,',
'    $ = apex.jQuery,',
'    statusUpdCnt = 0;',
'',
'$(window).scrollTop(0);',
'',
'function updatePageItems(items) {',
'    var i, item;',
'    for (i = 0; i < items.length; i++) {',
'        item = items[i];',
'        $s(item.id, item.value, null, true );',
'    }',
'}',
'',
'var createApp = apex.server.process("createApplication", {',
'    pageItems:["P1_STATUS","P1_APP_ID","P1_APP_NAME","P1_SCHEMA","P1_PRIMARY_LANGUAGE","P1_AUTHENTICATION","P1_FEATURES","P1_TRANSLATED_LANGS"]',
'',
'});',
'',
'// add overlay',
'var lHtml =',
'    ''<div class="a-PWWait-overlay" id="progress_overlay" role="progressbar" aria-busy="true" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" tabindex="-1">''+',
'        ''<div class="a-PWWait-body">''+',
'            ''<div class="a-PWWait-progress">''+',
'                ''<span class="a-PWWait-bar" id="pct_complete"></span>''+',
'            ''</div>''+',
'        ''<div class="a-PWWait-label" id="progress_messages"></div>''+',
'    ''</div>'';',
'',
'$("body").append( lHtml );',
'',
'lOverlay$ = $( ''#progress_overlay'' );',
'lMessage$ = $( ''#progress_messages'', lOverlay$ );',
'lComplete$ = $( ''#pct_complete'', lOverlay$ );',
'',
'// set focus to overlay, this gives better results with screen readers in announcing the progress',
'lOverlay$.focus();',
'',
'createApp.done(function(data) {',
'    if (data && data.items) {',
'        updatePageItems(data.items);',
'    }',
'    currentStatus = $v("P1_STATUS");',
'',
'    if (currentStatus===''DONE'') {',
'        setTimeout(function(){ apex.submit(''CREATE_APP''); }, 500);',
'    } else {',
'        if (currentStatus===''ERROR'') {',
'            apex.submit(''CREATE_APP_ERROR'');',
'        } else {',
'            apex.submit(''CREATE_APP_ORA_ERROR'');',
'        }',
'    }',
'});',
'',
'function waitForStatus() {',
'    setTimeout(function(){',
'        statusUpdCnt = statusUpdCnt + 1;',
'',
'        var getCurrent = apex.server.process("getCurrentStatus", {',
'            pageItems:["P1_PCT_COMPLETE"]',
'        });',
'',
'        getCurrent.done(function(data) {',
'            var currentStatus;',
'',
'            if (data && data.items) {',
'                updatePageItems(data.items);',
'            }',
'',
'            lLastProgressTxt = lProgressTxt;',
'            lLastProgressPct = lProgressPct;',
'',
'            currentStatus = $v("P1_STATUS");',
'            lProgressTxt = $v("P1_CURRENT_STATUS");',
'            lProgressPct = $v("P1_PCT_COMPLETE");',
'',
'            if ((currentStatus!==''DONE'')&&(statusUpdCnt<20)) {',
'',
'                if ((currentStatus===''ERROR'')||(currentStatus===''ORA_ERROR'')) {',
'                    console.log("Error creating application...");',
'                } else {',
'                    waitForStatus();',
'',
'                    // Only update text if text has changed',
'                    if ( lLastProgressTxt !== lProgressTxt ) {',
'                        lMessage$.text( lProgressTxt );',
'                        lOverlay$.attr( ''aria-valuetext'', lProgressTxt );',
'                    }',
'',
'                    // Only update percent complete if it has changed',
'                    if ( lLastProgressPct !== lProgressPct ) {',
'                        lComplete$.css("width",lProgressPct + ''%'');',
'                        lOverlay$.attr( ''aria-valuenow'', lProgressPct );',
'                    }',
'                }',
'            } else {',
'                lMessage$.text($v("P1_CURRENT_STATUS"));',
'                lComplete$.css("width",''100%'');',
'                lOverlay$',
'                    .attr( ''aria-valuenow'', $v("P1_PCT_COMPLETE"))',
'                    .attr( ''aria-valuetext'', ''100'');',
'            }',
'        });',
'    },500);',
'}',
'',
'waitForStatus();',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2816374247679877703)
,p_name=>'Toggle All Features'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2816364410490843901)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2816374331769877704)
,p_event_id=>wwv_flow_imp.id(2816374247679877703)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var flag = apex.create_app_wizard.all_feature_checked;',
'',
'(function( $ ){',
'var c$ = $("[name=''P1_FEATURES'']");',
'	if ( typeof flag === ''undefined'' || !flag ) {',
'		c$.prop(''checked'', true);',
'	    apex.create_app_wizard.all_feature_checked = true;',
'	} else {',
'		c$.prop(''checked'', false);',
'		apex.create_app_wizard.all_feature_checked = false;',
'	}',
'})( apex.jQuery );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2796575266245751036)
,p_name=>'View Blueprint'
,p_event_sequence=>100
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#view_blueprint'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2796575328637751037)
,p_event_id=>wwv_flow_imp.id(2796575266245751036)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P1_FEATURES,P1_NAV_POSITION,P1_APP_NAME,P1_AUTHENTICATION'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3055104896529555207)
,p_name=>'Update Supporting Objects'
,p_event_sequence=>110
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2796574865702751032)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3055104988372555208)
,p_event_id=>wwv_flow_imp.id(3055104896529555207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1_SUPPORTING_OBJS'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>'select dbms_lob.substr(clob001,30,1) x from wwv_flow_collections where collection_name = ''APEX$CREATEAPPSUPPOBJ'''
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(883418702322822207)
,p_name=>'on lang change, set right-to-left'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1_PRIMARY_LANGUAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(883418890017822208)
,p_event_id=>wwv_flow_imp.id(883418702322822207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_direction_right_to_left varchar2(1) := ''N'';',
'begin',
'    for l_lang in (',
'        select distinct direction_right_to_left',
'          from wwv_flow_language_map',
'          where translation_flow_language_code like substr( :P1_PRIMARY_LANGUAGE, 1, 2 )||''%'' )',
'    loop',
'        l_direction_right_to_left := l_lang.direction_right_to_left;',
'        exit;',
'    end loop;',
'',
'    :P5_DOCUMENT_DIRECTION := l_direction_right_to_left;',
'end;',
'    '))
,p_attribute_02=>'P1_PRIMARY_LANGUAGE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5240587654268502)
,p_name=>'onDialogClosed SET_ICON'
,p_event_sequence=>130
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4242065731012928)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5240620181268503)
,p_event_id=>wwv_flow_imp.id(5240587654268502)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showIcon();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4001361250210539)
,p_name=>'onPageLoad Set Default Icon'
,p_event_sequence=>150
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4001779362210572)
,p_event_id=>wwv_flow_imp.id(4001361250210539)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(async () => {',
'    $( "#AppIcon" ).css({"background-color": apex.items.P1_APP_COLOR_HEX.value})',
'',
'    const iconCollection = await apex.server.process(''iconCollection'');',
'',
'    if (!iconCollection.exists) {',
'        await apex.iconEditor.saveStockIcon({',
'            iconClass: apex.items.P1_APP_ICON_CLASS.value.replaceAll(''app-icon-'', ''''),',
'            iconColor: apex.items.P1_APP_COLOR_HEX.value',
'        });',
'    }',
'',
'    await showIcon();',
'})();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6208590684993249)
,p_event_id=>wwv_flow_imp.id(4001361250210539)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(4242065731012928)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(319996190137482703)
,p_name=>'Enable or Disable Create Button'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1_APP_ID,P1_APP_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>300
,p_execution_immediate=>false
,p_bind_event_type=>'keydown'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(319996228857482704)
,p_event_id=>wwv_flow_imp.id(319996190137482703)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Handle Create Button'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.create_app_wizard.handleCreateBtn();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(319996360552482705)
,p_name=>'Page Region Refreshed'
,p_event_sequence=>170
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(5170953344043764457)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(319996415305482706)
,p_event_id=>wwv_flow_imp.id(319996360552482705)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Handle Create Button and Page Sort'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.create_app_wizard.handleCreateBtn();',
'if ( apex.create_app_wizard.hasPage() ) {',
'    apex.create_app_wizard.pageSort();',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2710507116383930)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear page 2000 if not coming from there'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'2000'
,p_process_when=>'P1_LAST_PAGE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'2000'
,p_internal_uid=>2710507116383930
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2594843814366086027)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'initialize the wizard'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.init_wizard;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'NEW'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>2594843814366086027
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4032943314209342949)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pages from script result'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page_from_script(',
'    p_schema             => :P1_SCHEMA,',
'    p_script_result_id   => :P1_SCRIPT_RESULT_ID,',
'    -- out',
'    p_app_name           => :P1_APP_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P1_SCRIPT_RESULT_ID is not null and :REQUEST = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>4032943314209342949
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69711448639469935)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pages from script file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page_from_script(',
'    p_schema   => coalesce( :P1_SCHEMA, wwv_flow_user_api.get_default_schema),',
'    p_file_id  => :P1_SCRIPT_FILE_ID,',
'    -- out',
'    p_app_name => :P1_APP_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P1_SCRIPT_FILE_ID is not null and :REQUEST = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>69711448639469935
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1699344666214124)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pages with new table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page_with_new_table(',
'    p_schema     => :P1_SCHEMA,',
'    p_table_name => :P1_NEW_TABLE_NAME,',
'    -- out',
'    p_app_name   => :P1_APP_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P1_NEW_TABLE_NAME is not null and :REQUEST = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1699344666214124
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33865293426899628)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pages from sample JSON'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page_from_sample_json(',
'    p_json_id               => :p1_sample_json_id,',
'    p_built_with_love       => :p5_built_with_love,',
'    p_learn_app_def         => :p5_learn_ui_def_yn,',
'    p_app_name              => :p1_app_name,',
'    p_app_short_desc        => :p5_app_short_desc,',
'    p_app_desc              => :p5_app_desc,',
'    p_features              => :p1_features,',
'    p_theme_style           => :p170_theme_style,',
'    p_nav_position          => :p170_nav_position,',
'    p_app_icon_class        => :p1_app_icon_class,',
'    p_app_color_class       => :p1_app_color_class,',
'    p_app_color_hex         => :p1_app_color_hex,',
'    p_base_table_prefix     => :p5_base_table_prefix,',
'    p_primary_language      => :p1_primary_language,',
'    p_translated_langs      => :p1_translated_langs,',
'    p_authentication        => :p1_authentication,',
'    p_app_version           => :p5_app_version,',
'    p_app_logging           => :p5_app_logging,',
'    p_app_debugging         => :p5_app_debugging,',
'    p_document_direction    => :p5_document_direction,',
'    p_date_format           => :p5_date_format,',
'    p_date_time_format      => :p5_date_time_format,',
'    p_timestamp_format      => :p5_timestamp_format,',
'    p_timestamp_tz_format   => :p5_timestamp_tz_format,',
'    p_deep_linking          => :p5_deep_linking,',
'    p_max_session_length    => :p5_max_session_length,',
'    p_max_session_idle_time => :p5_max_session_idle_time );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P1_SAMPLE_JSON_ID is not null and :REQUEST = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>33865293426899628
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4405307565351702)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'initialize AI action'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_blueprint_v3.get_session_state_from_json (',
'	p_json_blueprint        => wwv_flow_blueprint_v3.to_blueprint_json(',
'                                   p_ai_json => :P2000_AI_ACTION ),',
'    --',
'    p_schema                => :P1_SCHEMA,',
'    p_built_with_love       => :P5_BUILT_WITH_LOVE,',
'    p_learn_app_def         => :P5_LEARN_UI_DEF_YN,',
'    p_app_name              => :P1_APP_NAME,',
'    p_app_short_desc        => :P5_APP_SHORT_DESC,',
'    p_app_desc              => :P5_APP_DESC,',
'    p_features              => :P1_FEATURES,',
'    p_theme_style           => :P170_THEME_STYLE,',
'    p_nav_position          => :P170_NAV_POSITION,',
'    p_app_icon_class        => :P1_APP_ICON_CLASS,',
'    p_app_color_class       => :P1_APP_COLOR_CLASS,',
'    p_app_color_hex         => :P1_APP_COLOR_HEX,',
'    p_base_table_prefix     => :P5_BASE_TABLE_PREFIX,',
'    p_primary_language      => :P1_PRIMARY_LANGUAGE,',
'    p_translated_langs      => :P1_TRANSLATED_LANGS,',
'    p_authentication        => :P1_AUTHENTICATION,',
'    p_app_version           => :P5_APP_VERSION,',
'    p_app_logging           => :P5_APP_LOGGING,',
'    p_app_debugging         => :P5_APP_DEBUGGING,',
'    p_document_direction    => :P5_DOCUMENT_DIRECTION,',
'    p_date_format           => :P5_DATE_FORMAT,',
'    p_date_time_format      => :P5_DATE_TIME_FORMAT,',
'    p_timestamp_format      => :P5_TIMESTAMP_FORMAT,',
'    p_timestamp_tz_format   => :P5_TIMESTAMP_TZ_FORMAT,',
'    p_deep_linking          => :P5_DEEP_LINKING,',
'    p_max_session_length    => :P5_MAX_SESSION_LENGTH,',
'    p_max_session_idle_time => :P5_MAX_SESSION_IDLE_TIME );',
'   ',
':P1_THEME_STYLE             := :P170_THEME_STYLE;',
':P1_NAV_POSITION            := :P170_NAV_POSITION;',
'',
'wwv_flow_app_def_v3.sync_app_defaults (',
'    p_schema                => :P1_SCHEMA,',
'    p_learn_app_def         => ( nvl(:P5_LEARN_UI_DEF_YN, ''N'') = ''Y'' ),',
'    p_learn_existing_apps   => ( nvl(:P5_LEARN_YN,''N'') = ''Y'' ),',
'    p_base_table_prefix     => :P5_BASE_TABLE_PREFIX );',
'    ',
':P130_PRIMARY_LANGUAGE      := :P1_PRIMARY_LANGUAGE;',
':P130_TRANSLATED_LANGS      := :P1_TRANSLATED_LANGS;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P2000_AI_ACTION is not null and :REQUEST = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>4405307565351702
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2025750408723536749)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sortPage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_internal_page_id number;',
'    l_page_id        number         := wwv_flow.g_x01;',
'    l_moves_count    number         := wwv_flow.g_x02;',
'    l_action         varchar2(10)   := wwv_flow.g_x03;',
'    ',
'begin',
'    l_internal_page_id := wwv_flow_define_app_v3.get_internal_page_id( p_page_id => l_page_id );',
'    ',
'    if l_action = ''up'' then',
'    ',
'        for i in 1..l_moves_count',
'        loop',
'           wwv_flow_define_app_v3.move_page_up( p_page_id => l_page_id );',
'           l_page_id := wwv_flow_define_app_v3.get_page_id( p_internal_page_id => l_internal_page_id );',
'        end loop;',
'        sys.htp.p( ''{"moved_up":'' || l_moves_count ||''}'');',
'',
'    elsif l_action = ''down'' then',
'    ',
'        for j in 1..l_moves_count',
'        loop',
'           wwv_flow_define_app_v3.move_page_down( p_page_id => l_page_id );',
'           l_page_id := wwv_flow_define_app_v3.get_page_id( p_internal_page_id => l_internal_page_id );',
'        end loop;',
'        sys.htp.p( ''{"moved_down":'' || l_moves_count ||''}'');',
'        ',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2025750408723536749
,p_process_comment=>'Called in JavaScript apex.create_app_wizard.pageSort() to allow user to drag and drop to sort pages.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63351383807934410)
,p_process_sequence=>20
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'createApplication'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_theme  wwv_flow_create_app_v3.t_theme;',
'begin',
'    l_theme.theme_type  := coalesce(:P1_THEME_TYPE, ''UT'');',
'    l_theme.id          := :P1_THEME_ID;',
'    l_theme.theme_style := :P1_THEME_STYLE;',
'    ',
'    wwv_flow_create_app_v3.create_app (',
'        p_app_id                   => :P1_APP_ID,',
'        p_app_name                 => :P1_APP_NAME,',
'        p_parsing_schema           => :P1_SCHEMA,',
'        p_app_language             => :P1_PRIMARY_LANGUAGE,',
'        p_theme                    => l_theme,',
'        p_authentication_name      => nvl(:P1_AUTHENTICATION, wwv_flow_authentication_api.c_type_apex_accounts),',
'        p_base_table_prefix        => :P5_BASE_TABLE_PREFIX,',
'        p_features                 => :P1_FEATURES,',
'        p_translated_langs         => :P1_TRANSLATED_LANGS,',
'        -- appearance',
'        p_nav_position             => :P1_NAV_POSITION,',
'        p_app_icon_class           => :P1_APP_ICON_CLASS,',
'        p_app_color_class          => :P1_APP_COLOR_CLASS,',
'        p_app_icon_color_hex       => :P1_APP_COLOR_HEX,',
'        -- advanced general',
'        p_built_with_love          => ( nvl(:P5_BUILT_WITH_LOVE, ''N'') = ''Y'' ),',
'        p_learn_app_def            => ( nvl(:P5_LEARN_UI_DEF_YN, ''N'') = ''Y'' ),',
'        p_learn_existing_apps      => ( nvl(:P5_LEARN_YN,''N'') = ''Y'' ),',
'        p_seed_from_app_id         => :P5_SEED_FROM_APP,',
'        p_short_description        => :P5_APP_SHORT_DESC,',
'        p_long_description         => :P5_APP_DESC,',
'        p_app_version              => :P5_APP_VERSION,',
'        p_app_logging              => ( coalesce(:P5_APP_LOGGING, ''Y'') = ''Y'' ),',
'        p_app_debugging            => ( coalesce(:P5_APP_DEBUGGING, ''Y'') = ''Y'' ),',
'        -- advanced security',
'        p_deep_linking             => ( coalesce(:P5_DEEP_LINKING, ''N'') = ''Y'' ),',
'        p_max_session_length_sec   => :P5_MAX_SESSION_LENGTH,',
'        p_max_session_idle_sec     => :P5_MAX_SESSION_IDLE_TIME,',
'        -- advanced globalization',
'        p_document_direction       => coalesce(:P5_DOCUMENT_DIRECTION, ''N''),',
'        p_date_format              => :P5_DATE_FORMAT,',
'        p_date_time_format         => :P5_DATE_TIME_FORMAT,',
'        p_timestamp_format         => :P5_TIMESTAMP_FORMAT,',
'        p_timestamp_tz_format      => :P5_TIMESTAMP_TZ_FORMAT );',
'',
'    htmldb_util.clear_app_cache(',
'        p_app_id => :P1_APP_ID);',
'',
'    if wwv_flow_error.have_errors_occurred then',
'        wwv_flow_debug.info(''... create_app input validation failed'');',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.open_array(''items'');',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write(''id'', ''P1_STATUS'');',
'        wwv_flow_json.write(''value'', ''ERROR'');',
'        wwv_flow_json.close_object;',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write(''id'', ''P1_ERROR_MESSAGE'');',
'        wwv_flow_json.write(''value'', ''Error creating application.'');',
'        wwv_flow_json.close_object;',
'        wwv_flow_json.close_array;',
'        wwv_flow_json.close_object;',
'',
'    else',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.open_array(''items'');',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write(''id'', ''P1_STATUS'');',
'        wwv_flow_json.write(''value'', ''DONE'');',
'        wwv_flow_json.close_object;',
'        wwv_flow_json.close_array;',
'        wwv_flow_json.close_object;',
'    end if;',
'',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.open_array(''items'');',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write(''id'', ''P1_STATUS'');',
'        wwv_flow_json.write(''value'', ''ORA_ERROR'');',
'        wwv_flow_json.close_object;',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write(''id'', ''P1_ERROR_MESSAGE'');',
'        wwv_flow_json.write(''value'', sqlerrm||'' ''||sys.dbms_utility.format_error_backtrace);',
'        wwv_flow_json.close_object;',
'        wwv_flow_json.close_array;',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>63351383807934410
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63351586647934412)
,p_process_sequence=>30
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getCurrentStatus'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_percent_comp    number;',
'    l_last_event_name varchar2(4000);',
'',
'begin',
'',
'    wwv_flow_create_app_log_v3.get_progress(',
'        p_last_event_name  => l_last_event_name,',
'        p_percent_complete => l_percent_comp ',
'    );',
'',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.open_array(''items'');',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write(''id'', ''P1_CURRENT_STATUS'');',
'    wwv_flow_json.write(''value'', wwv_flow_lang.custom_runtime_message(l_last_event_name));',
'    wwv_flow_json.close_object;',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write(''id'', ''P1_PCT_COMPLETE'');',
'    wwv_flow_json.write(''value'', trunc(l_percent_comp));',
'    wwv_flow_json.close_object;',
'    wwv_flow_json.close_array;',
'    wwv_flow_json.close_object;',
'end;',
'  '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>63351586647934412
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5240867248268505)
,p_process_sequence=>40
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getIcon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_blob blob;',
'begin',
'    select blob001',
'      into l_blob',
'      from wwv_flow_collections',
'     where collection_name = wwv_flow_define_app_v3.c_icons_collection',
'       and c001 = ''icons/app-icon-192.png'';',
' ',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( p_name => ''success'', p_value => true );',
'    wwv_flow_json.write( p_name => ''base64'', p_value => wwv_flow_webservices_api.blob2clobbase64(l_blob) );',
'    wwv_flow_json.close_object;',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( p_name => ''success'', p_value => false );',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5240867248268505
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(106149411975610614)
,p_process_sequence=>50
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'iconCollection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_count number;',
'begin',
'    select count(1)',
'      into l_count',
'      from wwv_flow_collections',
'     where collection_name = wwv_flow_define_app_v3.c_icons_collection;',
' ',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( p_name => ''exists'', p_value => ( l_count > 0 ) );',
'    wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>106149411975610614
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4002516657213788)
,p_process_sequence=>60
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save_icon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.add_member (',
'        p_collection_name => wwv_flow_define_app_v3.c_icons_collection,',
'        p_c001            => ''icons/app-icon-''||wwv_flow.g_x01||''.png'',',
'        p_c002            => ''image/png'',',
'        p_blob001         => wwv_flow_webservices_api.clobbase642blob( p_clob => wwv_flow.g_clob_01 ) );',
'    ',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( p_name => ''success'', p_value => true );',
'    wwv_flow_json.close_object;',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( p_name => ''success'', p_value => false );',
'        wwv_flow_json.write( p_name => ''message'', p_value => sqlerrm );',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4002516657213788
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_imp_page.create_page(
 p_id=>2
,p_name=>'Application Created with Errors'
,p_alias=>'APPLICATION-CREATED-WITH-ERRORS'
,p_step_title=>'Application Created with Errors'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(3286599848719423369)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2878225923368187963)
,p_plug_name=>'Error Installing Supporting Objects'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(3330277939666606656)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_collections',
'where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'and c001 = ''PREREQ_CHECK'''))
,p_plug_header=>'The application created.  However, installation of database objects and seed data has failed.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2878624699511257302)
,p_name=>'Supporting Object Install Summary'
,p_parent_plug_id=>wwv_flow_imp.id(2878225923368187963)
,p_template=>wwv_flow_imp.id(2983766147992137991)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="margin-top:16px"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 script_name, ',
'       decode(c002, ''SUCCESS'', ',
'                    wwv_flow_lang.system_message(''INSTALLER.SCRIPT.SUCCESS''),',
'                    ''FAIL'',',
'                    wwv_flow_lang.system_message(''INSTALLER.SCRIPT.FAIL'')) status,        ',
'       to_number(nvl(c003,0)) fail_count,',
'       to_number(nvl(c004,0)) success_count,',
'       c003 + c004 total_count',
'  from wwv_flow_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
' and c001 != ''PREREQ_CHECK'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(2707641403506668051)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No install results found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2878624700494257303)
,p_query_column_id=>1
,p_column_alias=>'SCRIPT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Script name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2878624845839257304)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>2
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2878624983291257305)
,p_query_column_id=>3
,p_column_alias=>'FAIL_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Fail count'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2878625003191257306)
,p_query_column_id=>4
,p_column_alias=>'SUCCESS_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'Success count'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2878625138395257307)
,p_query_column_id=>5
,p_column_alias=>'TOTAL_COUNT'
,p_column_display_sequence=>5
,p_column_heading=>'Total count'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2878625282128257308)
,p_plug_name=>'Errors'
,p_parent_plug_id=>wwv_flow_imp.id(2878225923368187963)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2983766147992137991)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 script_name, clob001 errors ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'           and c001 != ''PREREQ_CHECK''',
'           and length(clob001) > 0)',
'loop',
'  sys.htp.p(''<strong>''||wwv_flow_escape.html(c1.script_name)||''</strong>'');',
'  sys.htp.p(''<pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.errors);',
'  sys.htp.p(''</pre>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2878226271378193901)
,p_plug_name=>'Prerequisite Check Failed'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(3330277939666606656)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_collections',
'where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'and c001 = ''PREREQ_CHECK'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2878624552166257301)
,p_plug_name=>'Errors'
,p_parent_plug_id=>wwv_flow_imp.id(2878226271378193901)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3286693190338347807)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 script_name, clob001 errors ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'           and c001 = ''PREREQ_CHECK''',
'           and length(clob001) > 0)',
'loop',
'    -- note: populates message is formatted with HTML tag if prerequisite check fails, don''t escape',
'    sys.htp.p( c1.errors );',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2796572679532751010)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2878225923368187963)
,p_button_name=>'GO_TO_APP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Continue to Application'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2881063456729709562)
,p_branch_name=>'Redirect to Application Home'
,p_branch_action=>'f?p=4000:1:&SESSION.::&DEBUG.:RP:FB_FLOW_ID,F4000_P1_FLOW:&P1_APP_ID.,&P1_APP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2796572679532751010)
,p_branch_sequence=>20
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_imp_page.create_page(
 p_id=>5
,p_name=>'Advanced Settings'
,p_alias=>'ADVANCED-SETTINGS'
,p_page_mode=>'MODAL'
,p_step_title=>'Advanced Settings'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.field.item-app-name {margin-bottom:0;}',
'.field--style--boxed .display_only {',
'    line-height: 24px;',
'}',
'.apex-col .field.field-item-button-grouping {',
'    margin-right: -1px;',
'}',
'.lang-button {',
'    padding-top: 19px;',
'    padding-bottom: 19px;',
'    width: calc(100% - 16px);',
'    margin-right: 16px;',
'}',
'',
'.a-BoxedForms .field-item-button-grouping .field-input__wrap {',
'    border-radius: 2px 0 0 2px;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-page'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3027829547778015556)
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2929370393401839435)
,p_plug_name=>'Security'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(2758664310411868479)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2929371486458839446)
,p_plug_name=>'Globalization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(2758664310411868479)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2940046733568003236)
,p_plug_name=>'Settings'
,p_region_name=>'general'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(2758664310411868479)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3504377147071326201)
,p_plug_name=>'User Interface Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(2758664310411868479)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Copy attributes (such as labels, list of values, format masks and more) from other apps within your workspace and apply them to this application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3504377748981326207)
,p_plug_name=>'Description'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(2758664310411868479)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11817120097807501405)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3025635143275097802)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(11817120097807501405)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3025635596494097804)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(11817120097807501405)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3025635979593097804)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(11817120097807501405)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:ADVANCED'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33865152934899627)
,p_name=>'P5_BUILT_WITH_LOVE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2940046733568003236)
,p_item_default=>'N'
,p_prompt=>'Add "Built with APEX" to Footer'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When set to <strong>On</strong>, &PRODUCT_NAME. will add the text "Built with Love using Oracle APEX" to the footer of every page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929369566225839427)
,p_name=>'P5_APP_SHORT_DESC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3504377748981326207)
,p_prompt=>'Short Description'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text to be displayed as a subtitle, under the application name on the home page.</p>',
'<p><em><strong>Note:</strong> This setting requires the <strong>Application Settings</strong> feature to be selected. If it is not selected then the subtitle will not be displayed.</em></p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929369611036839428)
,p_name=>'P5_APP_DESC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3504377748981326207)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text to be displayed on the <strong>About This Application</strong> page, accessed from the help icon in the navigation bar.</p>  ',
'<p><em><strong>Note:</strong> This setting requires the <strong>Help Pages</strong> feature to be selected. If it is not selected the about page will not be generated.</em></p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929370594430839437)
,p_name=>'P5_DEEP_LINKING'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2929370393401839435)
,p_item_default=>'N'
,p_prompt=>'Deep Linking'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_css_classes=>'item-app-name'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This attribute enables or prevents deep linking to an application. Deep linking refers to the ability to link to an &PRODUCT_NAME. page out of context (for example, from a hyperlink in an email or workflow notification). Options include:</p>',
'<ul>',
'<li><strong>Enabled</strong> - If the URL references a specific page in an application, after authentication, &PRODUCT_NAME. automatically displays that specific page.</li>',
'<li><strong>Disabled</strong> - If the URL does not contain a valid session ID, &PRODUCT_NAME. redirects to the application''s home page.</li>',
'</ul><p/>',
'<p>For example, browsers often save the URLs of opened tabs and try to restore the sessions after a restart, causing a deep link. This behavior may be undesirable (for example if a URL points to a page in the middle of a multi-step wizard). By select'
||'ing <strong>Disabled</strong>, &PRODUCT_NAME. starts a new session and redirects to the application''s home page.</p>',
'<p>Note you can override this application setting at page level.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929370739829839439)
,p_name=>'P5_MAX_SESSION_LENGTH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2929370393401839435)
,p_prompt=>'Maximum session length in seconds'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(3052299639682461644)||'.'
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines how long (in seconds) sessions can exist and be used by this application.',
'',
'<ul>',
'    <li>Enter a positive integer to control how long a session can exist.</li>',
'    <li>Enter 0 to have sessions exist indefinitely.</li>',
'    <li>Leave the value empty in order to use the session duration defined at the workspace level or the instance level.</li>',
'</ul>',
'<br />',
'',
'The session duration may be superseded by the operation of the hourly database job, which deletes sessions older than 12 hours.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929370850688839440)
,p_name=>'P5_MAX_SESSION_IDLE_TIME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2929370393401839435)
,p_prompt=>'Maximum session idle time in seconds'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(3052299639682461644)||'.'
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Session Idle Time is the time between the last page request and the next page request.',
'<ul>',
'    <li>Enter a positive integer to control the idle time for sessions used by this application.</li>',
'    <li>Set the value to 0 to prevent session idle time checks from being performed.</li>',
'    <li>Leave the value empty in order to use the idle time defined at the workspace level or the instance level.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929371132330839443)
,p_name=>'P5_APP_VERSION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2940046733568003236)
,p_item_default=>'Release 1.0'
,p_prompt=>'Version'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(2698024775220408056)
,p_help_text=>'<p>Enter the application version. The version is displayed by default on the bottom of each page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929371618618839448)
,p_name=>'P5_DOCUMENT_DIRECTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2929371486458839446)
,p_item_default=>'N'
,p_prompt=>'Document Direction'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RIGHT-TO-LEFT'
,p_lov=>'.'||wwv_flow_imp.id(560908550288645029)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Set document direction left-to-right or right-to-left.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929371717725839449)
,p_name=>'P5_DATE_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2929371486458839446)
,p_prompt=>'Date Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the date format to be used in the application.</p>',
'<p>This date format is used to alter the <code>NLS_DATE_FORMAT</code> database session setting prior to showing or submitting any page in the application. This value can be a literal string containing a valid Oracle date format mask or an item refere'
||'nce using substitution syntax. If no value is specified, the default date format is derived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>Month DD, YYYY</code></li>',
'<li><code>&amp;MY_DATE_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2929371865789839450)
,p_name=>'P5_DATE_TIME_FORMAT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2929371486458839446)
,p_prompt=>'Date Time Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the date time format to be used in the application.</p>',
'<p>This date time format can be referenced in an application using the substitution reference <code>&amp;APP_DATE_TIME_FORMAT.</code>, or in PL/SQL via the function <code>v(''APP_DATE_TIME_FORMAT'')</code>.  This attribute does not alter any NLS settin'
||'gs.  This value can be a literal string containing a valid Oracle date format mask or an item reference using substitution syntax.  If this attribute value is not specified, then a reference to <code>APP_DATE_TIME_FORMAT</code> will return the NLS da'
||'tabase session date format and the NLS time format.</p>',
'Examples:',
'<ul>',
'<li><code>Month DD, RRRR HH24:MI</code></li>',
'<li><code>&amp;MY_DATE_TIME_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940046641169003235)
,p_name=>'P5_APP_DEBUGGING'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2940046733568003236)
,p_item_default=>'Y'
,p_prompt=>'Debugging'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_css_classes=>'item-app-name'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether debug mode can be enabled via the browser. Available options include:<p>',
'<ul>',
'<li><strong>On</strong>. Enables the application to enable debug mode via the browser at runtime.</li>',
'<li><strong>Off</strong>. Disables the application from enabling in debug from a browser.</li>',
'</ul>',
'<p>Running an application in debug mode is useful when an application is under development. However, for a production application, it is a good idea to disable debugging and thus prevent users from viewing application logic.</p>',
'<p>Debug can be enabled programmatically regardless of this debug setting.</p>',
'<p>If the application is run from the &PRODUCT_NAME. development environment, debugging can always be enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940046874787003237)
,p_name=>'P5_COMPATABILITY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2940046733568003236)
,p_prompt=>'Compatibility Mode'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default_auth_scheme varchar2(4000) := null;',
'begin',
'    if wwv_flow_authentication_dev.get_internal_authentication in (''CLOUD_IDM'', ''SSO'') then',
'        l_default_auth_scheme := wwv_flow_authentication_dev.get_internal_authentication;',
'    else',
'        l_default_auth_scheme := :PRODUCT_NAME;',
'    end if;',
'      ',
'    return l_default_auth_scheme;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:5.1;5.1;,Default;DEFAULT'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'This attribute controls the compatibility mode of the &PRODUCT_NAME. runtime engine. Certain runtime behaviors are changed from release to release. Use this attribute to obtain specific application behavior. To realize new behavior in an application,'
||' set the compatibility mode of the application to the current version.',
'</p>',
'<p>',
'For details see chapter ''Changed Behavior - Compatibility Mode'' in the Release Notes.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3022411239924971763)
,p_name=>'P5_APP_LOGGING'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2940046733568003236)
,p_item_default=>'Y'
,p_prompt=>'Logging'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_css_classes=>'item-app-name'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines whether or not user activity is recorded in the activity log. When set to',
'<strong>On</strong>, every page view is logged, enabling an administrator to monitor user',
'activity for each application.<p/>',
'<p>Disabling logging may be advisable for high volume applications.</p>',
'<p>This attribute can only be modified if the feature configuration "Application Activity Logging"',
'is set to "Use Application Settings" in &PRODUCT_NAME. Administration Services.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3028031392407628902)
,p_name=>'P5_TIMESTAMP_FORMAT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2929371486458839446)
,p_prompt=>'Timestamp Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the timestamp format to be used in the application.</p>',
'<p>This timestamp format is used to alter the <code>NLS_TIMESTAMP_FORMAT</code> database session setting prior to showing or submitting any page in the application. This value can be a literal string containing a valid Oracle timestamp format mask or'
||' an item reference using substitution syntax. If no value is specified, the default timestamp format is derived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>DD-MON-RR HH.MI.SSXFF AM</code></li>',
'<li><code>&amp;MY_TIMESTAMP_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3028031441279628903)
,p_name=>'P5_TIMESTAMP_TZ_FORMAT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2929371486458839446)
,p_prompt=>'Timestamp with Timezone Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the timestamp with time zone format to be used in the application.</p>',
'<p>This date format is used to alter the <code>NLS_TIMESTAMP_TZ_FORMAT</code> database session setting prior to showing or submitting any page in the application. This value can be a literal string containing a valid Oracle timestamp with time zone f'
||'ormat mask or an item reference using substitution syntax. If no value is specified, the default timestamp with time zone format is derived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>DD-MON-RR HH.MI.SSXFF AM TZR</code></li>',
'<li><code>&amp;MY_TIMESTAMP_TZ_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3398688067867765506)
,p_name=>'P5_BASE_TABLE_PREFIX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3504377147071326201)
,p_prompt=>'Table Prefixes'
,p_placeholder=>'HR_, OE_'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter table prefixes currently used by existing database tables on which pages are based.  These prefixes may be different from the framework table prefix (for database objects created by this application when generated).</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3504377278993326202)
,p_name=>'P5_LEARN_YN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3504377147071326201)
,p_item_default=>'N'
,p_prompt=>'Copy from Existing Apps'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select <strong>On</strong> if you want the attribute defaults to be based on existing <u>Form</u> pages, based on the same table, in current applications defined within this workspace.</p>',
'<p>For example, if you have an application with a form page based on <code>APEX$DEMO_PROJ_TASKS</code> and you define a report on the same table, then the attribute defaults will be based on the item definitions on that form page, if this option is s'
||'et to <strong>On</strong>.</p>',
'<p><em><strong>Note:</strong> If there are multiple form pages based on the same table, then the definitions from the most recently updated page will be utilized.</em></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3504378824056326218)
,p_name=>'P5_SEED_FROM_APP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3504377147071326201)
,p_prompt=>'Copy Attributes from'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Applications'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_imp.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this application to copy meta data.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3504379001911326220)
,p_name=>'P5_LEARN_UI_DEF_YN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3504377147071326201)
,p_item_default=>'N'
,p_prompt=>'Apply UI Defaults'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select <strong>On</strong> if you want the attribute defaults to be based on existing UI Defaults defined within this workspace.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3035688212550083801)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3025635143275097802)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3035688338214083802)
,p_event_id=>wwv_flow_imp.id(3035688212550083801)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2934952434131675449)
,p_name=>'if learn, show copy from app'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P5_LEARN_YN'
,p_condition_element=>'P5_LEARN_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2934952547911675450)
,p_event_id=>wwv_flow_imp.id(2934952434131675449)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5_SEED_FROM_APP'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3674116303730496401)
,p_event_id=>wwv_flow_imp.id(2934952434131675449)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5_SEED_FROM_APP'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3035688413773083803)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3035688413773083803
);
end;
/
prompt --application/pages/page_00110
begin
wwv_flow_imp_page.create_page(
 p_id=>110
,p_name=>'Select Icon'
,p_alias=>'SELECT-ICON'
,p_page_mode=>'MODAL'
,p_step_title=>'Select Icon'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Init Modal */',
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};',
'',
'',
'apex.create_app_wizard = apex.create_app_wizard || {};',
'',
'(function( $ ){',
'',
'	var icons = {},',
'		iconCont$;',
'',
'	var getIcons = function (){',
'        var data = {},',
'            links$ = $( ''a.a-PWIconPicker-link'' );',
'',
'        links$.each(function( index ) {',
'            var that$ = $( this )',
'            data[ that$.attr( ''id'' ) ] = that$.data( ''filters'' );',
'        });',
'',
'        return data;',
'    };',
'',
'    var search = function( key ){',
'    	var key = key.trim().toLowerCase(),',
'    		keyLen = key.length;',
'',
'    	var resetList = function(){',
'    		iconCont$',
'    			.removeClass( ''js-searching'' )',
'    			.find( ''.js-hit'' )',
'    			.removeClass( ''js-hit'' );',
'    	};',
'',
'    	resetList();',
'',
'    	if ( key.length >= 2 ) {',
'',
'    		iconCont$.addClass( ''js-searching'' );',
'',
'	    	for ( var k in icons ) {',
'	    		if ( icons.hasOwnProperty(k) ) {',
'	    			if ( k.indexOf( key ) != -1 || icons[k].indexOf( key ) != -1 ) {',
'	    				$( ''#'' + k )',
'	    					.parent()',
'	    					.addClass( ''js-hit'' );',
'	    			}',
'	    		}',
'	    	}',
'    	}',
'    };',
'',
'    var passBack = function( icon, passToUi, passToSave ) {',
'        ',
'        var jQueryInOtherDialog$ = parent.window.frames[0].apex.jQuery,',
'        	iconSpan$ = jQueryInOtherDialog$( ''#'' + passToUi ).find( ''span.a-Icon'' ),',
'        	lastClass = iconSpan$.attr(''class'').split('' '').pop();',
'',
'        iconSpan$',
'            .removeClass( lastClass )',
'            .addClass( ''fa '' + icon );',
'',
'        jQueryInOtherDialog$( ''#'' + passToSave ).val( icon );',
'        apex.util.getTopApex().navigation.dialog.cancel(true);',
'    };',
'',
'	apex.create_app_wizard.initIconSearch = function( options ){',
'',
'		icons = getIcons(),',
'',
'		iconCont$ = $( ''#'' + options.container || ''icons'' );',
'',
'		iconCont$.on( ''click'', ''a.a-PWIconPicker-link'', function(){',
'	        var iconName = $( this ).attr( ''id'' );',
'	        passBack( iconName, options.passToUi, options.passToSave );',
'	    } );',
'	    ',
'	    $( ''#'' + options.searchField ).on( ''keyup'', function(){',
'	    	var k = this.value;',
'		    setTimeout(function() {',
'	        	search( k );',
'	        }, 500);',
'	    })',
'	};',
'',
'})( apex.jQuery );'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal();',
'',
'apex.create_app_wizard.initIconSearch({',
'    "container":     "icons",',
'    "searchField":   "P110_SEARCH",',
'    "passToUi":      "&P110_PASS_BACK_TO_UI.",',
'    "passToSave":    "&P110_PASS_BACK_TO_SAVE."',
'});'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.js-searching li {',
'    display: none;',
'}',
'',
'.js-searching li.js-hit {',
'    display: block;',
'}'))
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--icons'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'440'
,p_dialog_width=>'400'
,p_dialog_attributes=>'resizable:true'
,p_dialog_chained=>'N'
,p_browser_cache=>'Y'
,p_cache_mode=>'CACHE'
,p_cache_timeout_seconds=>21600
,p_page_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#themes/theme_42/1.1/demo/demo#MIN#.js',
'#IMAGE_PREFIX#themes/theme_42/1.1/js/demo/icons#MIN#.js'))
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2025750057378536745)
,p_plug_name=>'Search Bar'
,p_region_css_classes=>'a-PWIconPicker-search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2647104751646258107)
,p_plug_name=>'Icon List - PLSQL'
,p_region_name=>'icons'
,p_region_css_classes=>'icon-list'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    sys.htp.p( ''<ul class="a-PWIconPicker">'' );',
'    ',
'    for c1 in ( ',
'        select icon_name, icon_filters',
'          from wwv_flow_standard_icons',
'         where icon_library = ''FONTAPEX''',
'         order by icon_name )',
'    loop',
'',
'        sys.htp.p( ''<li class="a-PWIconPicker-item"><a href="javascript:void(0)" class="a-PWIconPicker-link" id="'' || c1.icon_name || ''" data-filters="'' || c1.icon_filters || ''">''',
'                    || ''<span class="t-Icon fa '' || c1.icon_name || ''" aria-hidden="true"></span>''',
'                    || ''</a></li>'' );',
'    end loop;',
'    ',
'    sys.htp.p( ''</ul>'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>21600
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2025750167049536746)
,p_name=>'P110_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2025750057378536745)
,p_prompt=>'Search Icons'
,p_placeholder=>'Search all &P110_COUNT. icons ...'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_tag_css_classes=>'a-PWIconPicker-searchInput'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2593478457378715617)
,p_name=>'P110_SELECTED_ICON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2025750057378536745)
,p_item_default=>'fa-cloud'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2647104883557258108)
,p_name=>'P110_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2025750057378536745)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
' from wwv_flow_standard_icons',
'where icon_library = ''FONTAPEX'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2647105031292258110)
,p_name=>'P110_PASS_BACK_TO_UI'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2025750057378536745)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2647105144549258111)
,p_name=>'P110_PASS_BACK_TO_SAVE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2025750057378536745)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2595754895632422208)
,p_name=>'Cancel Enter'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_SEARCH'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.which === 13'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2595754930833422209)
,p_event_id=>wwv_flow_imp.id(2595754895632422208)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CANCEL_EVENT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2593478751056715620)
,p_name=>'Close Dialog on Icon Selection'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.a-PWIconPicker-link'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
,p_display_when_type=>'NEVER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2593478824500715621)
,p_event_id=>wwv_flow_imp.id(2593478751056715620)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
,p_attribute_01=>'P110_SELECTED_ICON'
);
end;
/
prompt --application/pages/page_00120
begin
wwv_flow_imp_page.create_page(
 p_id=>120
,p_name=>'Choose Application Icon'
,p_alias=>'CHOOSE-APPLICATION-ICON'
,p_page_mode=>'MODAL'
,p_step_title=>'Choose Application Icon'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.cropperEditor#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.iconEditor#MIN#.js'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$.fn.removeClassWithPrefix = function (prefix) {',
'    $(this).removeClass(function (index, className) {',
'        return (className.match(new RegExp("\\S*" + prefix + "\\S*", ''g'')) || []).join('' '')',
'    });',
'    return this;',
'};'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#P120_CUSTOM_ICON_DISPLAY {',
'  display: block;',
'  max-width: 100%;',
'  height:400px;',
'}',
'',
'#P120_CUSTOM_ICON_CONTAINER,',
'#P120_CUSTOM_ICON_DISPLAY_CONTAINER  {',
'    max-width: 512px!important;',
'    margin: auto!important;',
'}',
'',
'.cropper-face {',
'    border: 2px solid white !important;',
'    opacity: 1;',
'    background-color: transparent;',
'}'))
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--appIconPicker'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'700'
,p_dialog_width=>'760'
,p_dialog_attributes=>'resizable:true'
,p_dialog_chained=>'N'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8201602099126601)
,p_plug_name=>'Crop Icon Help'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(3012513290302116971)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''ICON.EDITOR.CROPPER.HELPTEXT''));'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2595758406326422244)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2661566014835000912)
,p_plug_name=>'Icons'
,p_region_name=>'app_icons_gallery'
,p_region_css_classes=>'a-PageWizard-appIcons'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4242476064012932)
,p_plug_name=>'Or pick an icon'
,p_parent_plug_id=>wwv_flow_imp.id(2661566014835000912)
,p_region_css_classes=>'a-Region-title--separator'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(2758664310411868479)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P120_CUSTOM_ICON'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2595758618998422246)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2595758406326422244)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P120_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7549531355640204)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2595758406326422244)
,p_button_name=>'RESET'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P120_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2595758599738422245)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2595758406326422244)
,p_button_name=>'USE_ICON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Icon'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P120_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1805428596692549)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2595758406326422244)
,p_button_name=>'USE_CUSTOM_ICON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Icon'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P120_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1804910309692544)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2595758406326422244)
,p_button_name=>'BACK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_condition=>'P120_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6208648361993250)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2595758406326422244)
,p_button_name=>'HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P120_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1804339561692538)
,p_name=>'P120_CUSTOM_ICON'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2661566014835000912)
,p_prompt=>'Upload your own icon'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_read_only_when=>'P120_CUSTOM_ICON'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_11=>'image/*'
,p_attribute_12=>'DROPZONE_INLINE'
,p_attribute_13=>'Upload your own icon'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1804426797692539)
,p_name=>'P120_CUSTOM_ICON_DISPLAY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2661566014835000912)
,p_prompt=>'Crop your icon for a perfect fit'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="u-textCenter margin-top-md">',
'<input id="APEXCropperZoom" type="range" min="0" max="100" value="0" step="1">',
'<label class="u-vh" for="APEXCropperZoom">&P120_ZOOM_SLIDER_LABEL.</label>',
'</div>'))
,p_display_as=>'NATIVE_DISPLAY_IMAGE'
,p_display_when=>'P120_CUSTOM_ICON'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'SQL'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select blob_content,',
'       name,',
'       filename,',
'       mime_type',
'  from wwv_flow_temp_files ',
' where name = :P120_CUSTOM_ICON'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2601917758331202)
,p_name=>'P120_ZOOM_SLIDER_LABEL'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(2661566014835000912)
,p_source=>'wwv_flow_lang.system_message(''ICON.EDITOR.CROPPER.ZOOM_SLIDER_LABEL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2647106546767258125)
,p_name=>'P120_ICON_CLASS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2661566014835000912)
,p_source=>'P1_APP_ICON_CLASS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'B'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2661566112535000913)
,p_name=>'P120_ICON_PICKER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4242476064012932)
,p_prompt=>'Icon Picker'
,p_source=>'select replace( :P120_ICON_CLASS, ''app-icon-'', null) as icon from sys.dual;'
,p_source_type=>'QUERY'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P120_APP_ICONS'
,p_lov=>'.'||wwv_flow_imp.id(2672360045214033881)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--AppIcons'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_protection_level=>'B'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2661569781624000949)
,p_name=>'P120_ICON_COLOR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4242476064012932)
,p_prompt=>'Icon Color'
,p_source=>'P1_APP_COLOR_HEX'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P120_APP_COLORS'
,p_lov=>'.'||wwv_flow_imp.id(2698004887684998460)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-PageWizard-appIconColorPicker'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_protection_level=>'B'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'8'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2698019345534126328)
,p_name=>'P120_ICON_COLOR_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2661566014835000912)
,p_source=>'P1_APP_COLOR_CLASS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'B'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48017889191545405)
,p_validation_name=>'P120_CUSTOM_ICON is invalid'
,p_validation_sequence=>10
,p_validation=>'return false;'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid icon file.'
,p_validation_condition=>'UPLOAD_ICON_INVALID'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(1804339561692538)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2595758737946422247)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2595758618998422246)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2595758864422422248)
,p_event_id=>wwv_flow_imp.id(2595758737946422247)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2698019626181126331)
,p_name=>'onPageLoad Set Icon'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P120_CUSTOM_ICON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2698019765387126332)
,p_event_id=>wwv_flow_imp.id(2698019626181126331)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var iconColor = $v(''P120_ICON_COLOR_CLASS'');',
'',
'apex.jQuery("#P120_ICON_COLOR span.app-color").each(function () {',
'    var curItem$ = apex.jQuery(this);',
'    if (curItem$.hasClass(iconColor)) {',
'        curItem$.parent().prev().prop("checked", true);',
'    }',
'});'))
,p_server_condition_type=>'ITEM_IS_NOT_NULL'
,p_server_condition_expr1=>'P120_ICON_COLOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5260081815466723)
,p_event_id=>wwv_flow_imp.id(2698019626181126331)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_ICON_COLOR'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(() => {',
'    const icons = $("[name=P120_ICON_COLOR]").get().map( el => el.value );',
'    return icons[Math.floor(Math.random() * icons.length)];',
'})()'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'ITEM_IS_NULL'
,p_server_condition_expr1=>'P120_ICON_COLOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5260115578466724)
,p_event_id=>wwv_flow_imp.id(2698019626181126331)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_ICON_PICKER'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(() => {',
'    const icons = $("#P120_ICON_PICKER_SELECTION li").get().map( el => $(el).data("value") );',
'    return icons[Math.floor(Math.random() * icons.length)];',
'})()'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'ITEM_IS_NULL'
,p_server_condition_expr1=>'P120_ICON_COLOR'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2698019869993126333)
,p_name=>'onChange P120_ICON_COLOR'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_ICON_COLOR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2698019975244126334)
,p_event_id=>wwv_flow_imp.id(2698019869993126333)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var colorClass = apex.jQuery(this.triggeringElement).find("input[type=''radio'']:checked + label span").attr("class").split(" ").pop();',
'',
'apex.jQuery("#app_icons_gallery")',
'    .removeClassWithPrefix("app-color")',
'    .addClass(colorClass);',
'',
'apex.jQuery("#P120_ICON_COLOR_CLASS").val( colorClass );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2698020086425126335)
,p_name=>'onChange P120_ICON_PICKER'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_ICON_PICKER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2698020187827126336)
,p_event_id=>wwv_flow_imp.id(2698020086425126335)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let iconClass = ''app-icon-'' + $v(this.triggeringElement);',
'apex.jQuery("#P120_ICON_CLASS").val( iconClass );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2647105680018258116)
,p_name=>'onClick USE_ICON'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2595758599738422245)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2602030934331203)
,p_event_id=>wwv_flow_imp.id(2647105680018258116)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'wwv_flow_collection.create_or_truncate_collection( p_collection_name => wwv_flow_define_app_v3.c_icons_collection );'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2647105755022258117)
,p_event_id=>wwv_flow_imp.id(2647105680018258116)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(async () => {',
'    apex.util.showSpinner();',
'    await apex.iconEditor.saveStockIcon({',
'        iconClass: apex.items.P120_ICON_PICKER.value,',
'        iconColor: apex.items.P120_ICON_COLOR.value',
'    });',
'    apex.page.submit(''USE_ICON'');',
'})();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4242767497012935)
,p_name=>'onClick USE_CUSTOM_ICON'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1805428596692549)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2602123422331204)
,p_event_id=>wwv_flow_imp.id(4242767497012935)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'wwv_flow_collection.create_or_truncate_collection( p_collection_name => wwv_flow_define_app_v3.c_icons_collection );'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4242824129012936)
,p_event_id=>wwv_flow_imp.id(4242767497012935)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(async () => {',
'    apex.util.showSpinner();',
'    await apex.iconEditor.saveCustomIcon();',
'    apex.page.submit(''USE_CUSTOM_ICON'');',
'})();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1804581705692540)
,p_name=>'onChange P120_CUSTOM_ICON is valid'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_CUSTOM_ICON'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.triggeringElement.files.length === 1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1804635300692541)
,p_event_id=>wwv_flow_imp.id(1804581705692540)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_ICON'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48017789408545404)
,p_event_id=>wwv_flow_imp.id(1804581705692540)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_ICON_INVALID'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1804764902692542)
,p_name=>'onPageLoad Cropper'
,p_event_sequence=>90
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P120_CUSTOM_ICON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1804863153692543)
,p_event_id=>wwv_flow_imp.id(1804764902692542)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.iconEditor.initCropper({ imageItemName: ''P120_CUSTOM_ICON_DISPLAY'' });'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8201733284126602)
,p_name=>'onClick HELP'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(6208648361993250)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8201885096126603)
,p_event_id=>wwv_flow_imp.id(8201733284126602)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8201602099126601)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7549693741640205)
,p_name=>'onClick RESET'
,p_event_sequence=>110
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7549531355640204)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7549729530640206)
,p_event_id=>wwv_flow_imp.id(7549693741640205)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.iconEditor.resetCropper();'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1805087355692545)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Back'
,p_process_sql_clob=>':P120_CUSTOM_ICON := null;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1804910309692544)
,p_internal_uid=>1805087355692545
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2647106425624258124)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Page 1 Icon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1_APP_COLOR_CLASS := :P120_ICON_COLOR_CLASS;',
':P1_APP_ICON_CLASS  := :P120_ICON_PICKER;',
':P1_APP_COLOR_HEX   := :P120_ICON_COLOR;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2595758599738422245)
,p_internal_uid=>2647106425624258124
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4242376779012931)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Page 1 Custom Icon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1_APP_COLOR_CLASS := null;',
':P1_APP_ICON_CLASS  := null;',
':P1_APP_COLOR_HEX   := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1805428596692549)
,p_internal_uid=>4242376779012931
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2647106282983258122)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P120_ICON_CLASS,P120_ICON_COLOR_CLASS,P120_ICON_COLOR'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'USE_ICON,USE_CUSTOM_ICON'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>2647106282983258122
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(154749298711137306)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load CropperJS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_css.add_3rd_party_library_file( p_library => wwv_flow_cdn.c_library_cropperjs );',
'wwv_flow_javascript.add_3rd_party_library_file( p_library => wwv_flow_cdn.c_library_cropperjs );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>154749298711137306
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4242942187012937)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save_icon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.add_member (',
'        p_collection_name => wwv_flow_define_app_v3.c_icons_collection,',
'        p_c001            => ''icons/app-icon-''||wwv_flow.g_x01||''.png'',',
'        p_c002            => ''image/png'',',
'        p_blob001         => wwv_flow_webservices_api.clobbase642blob( p_clob => wwv_flow.g_clob_01 ) );',
'    ',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( p_name => ''success'', p_value => true );',
'    wwv_flow_json.close_object;',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( p_name => ''success'', p_value => false );',
'        wwv_flow_json.write( p_name => ''message'', p_value => sqlerrm );',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4242942187012937
);
end;
/
prompt --application/pages/page_00130
begin
wwv_flow_imp_page.create_page(
 p_id=>130
,p_name=>'Application Languages'
,p_alias=>'APPLICATION-LANGUAGES'
,p_page_mode=>'MODAL'
,p_step_title=>'Application Languages'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.checkbox_group {',
'    width: 100%;',
'}',
'fieldset.checkbox_group table {',
'    width: 100%;',
'}',
'p.note {',
'margin: 0 8px;',
'color: #707070;',
'font-size: 11px;}',
'',
'.is-disabled {',
'    opacity: .5;',
'    pointer-events: none;',
'    cursor: not-allowed;',
'  }'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(2698024578226405812)
,p_dialog_height=>'360'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2796572808670751012)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2796573006579751014)
,p_plug_name=>'Primary Language'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2796573473167751018)
,p_plug_name=>'Translations'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p class="note">Your application will be displayed in the language(s) selected. If more than one language is selected, users will be be provided links for the different languages on the Sign In page.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2796573782624751021)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2796572808670751012)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2796572933171751013)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2796572808670751012)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2996641060711931005)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2796572808670751012)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:LANG'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2796573199336751015)
,p_name=>'P130_TRANSLATED_LANGS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2796573473167751018)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translations'
,p_source=>'P1_TRANSLATED_LANGS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.translated_lang_name as lang_name, f.flow_language',
'from ( select flow_language',
'          from wwv_flows f',
'         where id = :APP_ID',
'         union',
'        select flow_language',
'          from wwv_flows f',
'         where id in ( select translation_flow_id',
'                         from wwv_flow_language_map',
'                        where primary_language_flow_id = :APP_ID )',
'      ) f,',
'      wwv_flow_languages l',
'where f.flow_language = l.lang_id',
'order by nlssort( l.translated_lang_name, ''NLS_SORT=binary'' )'))
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
,p_item_comment=>'P1_TRANSLATED_LANGS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2939579793710578577)
,p_name=>'P130_PRIMARY_LANGUAGE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2796573006579751014)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&BROWSER_LANGUAGE.'
,p_prompt=>'Primary Language'
,p_source=>'P1_PRIMARY_LANGUAGE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TRANSLATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.translated_lang_name as lang_name, f.flow_language',
'from ( select flow_language',
'          from wwv_flows f',
'         where id = :APP_ID',
'         union',
'        select flow_language',
'          from wwv_flows f',
'         where id in ( select translation_flow_id',
'                         from wwv_flow_language_map',
'                        where primary_language_flow_id = :APP_ID )',
'      ) f,',
'      wwv_flow_languages l',
'where f.flow_language = l.lang_id',
'order by nlssort( l.translated_lang_name, ''NLS_SORT=binary'' )'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_inline_help_text=>'This language is used for development, and controls the text for a variety of components in your application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2796573588692751019)
,p_name=>'Toggle Language in Translations'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_PRIMARY_LANGUAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2796573610505751020)
,p_event_id=>wwv_flow_imp.id(2796573588692751019)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var $ = apex.jQuery,',
'    priLang = $(this.triggeringElement).val().toUpperCase(),',
'	transLang$ = $(''#P130_TRANSLATED_LANGS'');',
'',
'// Uncheck and make primary language in the translations item',
'transLang$',
'    .find(''input[type=checkbox]'')',
'    .each(function(){',
'        var that$ = $(this);',
'        if ( that$.hasClass(''is-disabled'') ){',
'            that$',
'                .prop(''checked'',false)',
'                .removeClass(''is-disabled'');',
'        }',
'});',
'',
'transLang$',
'    .find(''input[value='' + priLang + '']'')',
'	.prop(''checked'', true)',
'	.addClass(''is-disabled'');'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2796573852364751022)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2796573782624751021)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2796573988240751023)
,p_event_id=>wwv_flow_imp.id(2796573852364751022)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2796574456153751028)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Language Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1_TRANSLATED_LANGS := :P130_TRANSLATED_LANGS;',
':P1_PRIMARY_LANGUAGE := :P130_PRIMARY_LANGUAGE;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2796574456153751028
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2796574031129751024)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P130_TRANSLATED_LANGS,P130_PRIMARY_LANGUAGE'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2796574031129751024
);
end;
/
prompt --application/pages/page_00140
begin
wwv_flow_imp_page.create_page(
 p_id=>140
,p_name=>'Supporting Objects'
,p_alias=>'SUPPORTING-OBJECTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Supporting Objects'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.checkbox_group {',
'    width: 100%;',
'}',
'fieldset.checkbox_group table {',
'    width: 100%;',
'}',
'p.note {',
'margin: 0 8px;',
'color: #707070;',
'font-size: 11px;}'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3124271964326242195)
,p_dialog_height=>'580'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5781861774452699579)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5781862438949699585)
,p_plug_name=>'Supporting Objects'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2985289632294948581)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5781861774452699579)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2985290062912948582)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5781861774452699579)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3035688502253083804)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5781861774452699579)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:SUPP_OBJS'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2796574958721751033)
,p_name=>'P140_DEINSTALL_SCRIPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5781862438949699585)
,p_prompt=>'Deinstallation Script'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940046372472003232)
,p_name=>'P140_RUN_SCRIPT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5781862438949699585)
,p_prompt=>'Run when creating application'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--floatLeft:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2985291424860948594)
,p_name=>'P140_INSTALL_SCRIPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5781862438949699585)
,p_prompt=>'Installation Script'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>7
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2985292689933948614)
,p_name=>'Toggle Language in Translations'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P140_PRIMARY_LANGUAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2985293156154948616)
,p_event_id=>wwv_flow_imp.id(2985292689933948614)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Cache Elements */',
'var priLang = $(this.triggeringElement).val().toUpperCase();',
'var translatedItem$ = $(''#P140_TRANSLATED_LANGS'').find(''input[type=checkbox]'');',
'var translatedLangItem$ = $(''#P140_TRANSLATED_LANGS'').find(''input[value=''+priLang+'']'');',
'',
'/* Uncheck and make primary language in the translations item */',
'translatedItem$.each(function(){',
'  if ($(this).prop("disabled") === true){',
'    $(this).prop("checked",false);',
'    $(this).prop("disabled",false);',
'  }',
'});',
'translatedLangItem$.prop(''checked'',true).prop(''disabled'',true);'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2985293424223948616)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2985289632294948581)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2985293903138948617)
,p_event_id=>wwv_flow_imp.id(2985293424223948616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2940046107772003230)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Values from Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_install   clob;',
'   l_deinstall clob;',
'begin',
'    :P140_INSTALL_SCRIPT := null;',
'    :P140_DEINSTALL_SCRIPT := null;',
'    if WWV_FLOW_COLLECTION.COLLECTION_EXISTS(p_collection_name => ''APEX$CREATEAPPSUPPOBJ'') then',
'       for c1 in (select CLOB001 from wwv_flow_collections where collection_name = ''APEX$CREATEAPPSUPPOBJ'' and c001 = ''Install Script'') loop',
'            l_install := c1.CLOB001;',
'            :P140_INSTALL_SCRIPT := l_install;',
'       end loop;',
'       for c1 in (select CLOB001 from wwv_flow_collections where collection_name = ''APEX$CREATEAPPSUPPOBJ'' and c001 = ''Deinstall Script'') loop',
'            l_deinstall := c1.CLOB001;',
'            :P140_DEINSTALL_SCRIPT := l_deinstall;',
'       end loop;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2940046107772003230
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2940045987556003228)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_install   clob;',
'   l_deinstall clob;',
'begin',
'    WWV_FLOW_COLLECTION.CREATE_OR_TRUNCATE_COLLECTION(p_collection_name => ''APEX$CREATEAPPSUPPOBJ'');',
'    l_install := :P140_INSTALL_SCRIPT;',
'    l_deinstall := :P140_DEINSTALL_SCRIPT;',
'    WWV_FLOW_COLLECTION.ADD_MEMBER (p_collection_name => ''APEX$CREATEAPPSUPPOBJ'', p_c001=>''Install Script'', p_clob001 => l_install);',
'    WWV_FLOW_COLLECTION.ADD_MEMBER (p_collection_name => ''APEX$CREATEAPPSUPPOBJ'', p_c001=>''Deinstall Script'', p_clob001 => l_deinstall);',
'end;',
'        '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2940045987556003228
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2985291821695948611)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P140_INSTALL_SCRIPT'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2985291821695948611
);
end;
/
prompt --application/pages/page_00150
begin
wwv_flow_imp_page.create_page(
 p_id=>150
,p_name=>'Application Blueprint'
,p_alias=>'APPLICATION-BLUEPRINT'
,p_page_mode=>'MODAL'
,p_step_title=>'Application Blueprint'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function doSave() {',
'    apex.builder.plugin.codeEditor.saveProcess("#codeEditor_widget", "save_blueprint", "f01")',
'      .done(function() {',
'          apex.submit( ''SAVE'' );',
'      });',
'  }'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.checkbox_group {',
'    width: 100%;',
'}',
'fieldset.checkbox_group table {',
'    width: 100%;',
'}',
'p.note {',
'margin: 0 8px;',
'color: #707070;',
'font-size: 11px;}'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3027985170417035432)
,p_dialog_height=>'660'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2934952369704675448)
,p_plug_name=>'Edit Blueprint'
,p_region_name=>'codeEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob001',
'from wwv_flow_collections',
'where collection_name = ''TEMP_JSON'''))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'json',
  'attribute_02', '30',
  'attribute_03', 'N',
  'attribute_04', 'VARCHAR2')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8791485212424403619)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3009625244862704074)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8791485212424403619)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3009625633237704076)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(8791485212424403619)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Blueprint'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3092828517095849801)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8791485212424403619)
,p_button_name=>'LOAD_BLUEPRINT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Load a Previous Blueprint'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:160:&SESSION.::&DEBUG.:RP,160::'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2796575665900751040)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8791485212424403619)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:BLUEPRINT'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2940046237103003231)
,p_branch_name=>'Reload Home Page'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3009625633237704076)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3096983880958966805)
,p_name=>'P150_BLUEPRINT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2934952369704675448)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3009628557773704106)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3009625244862704074)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3009629083477704108)
,p_event_id=>wwv_flow_imp.id(3009628557773704106)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3096983605390966803)
,p_name=>'Submit Page on Dialog Close'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3092828517095849801)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3172047783258109033)
,p_event_id=>wwv_flow_imp.id(3096983605390966803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P150_BLUEPRINT_ID'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P160_BLUEPRINT_ID'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3172047817701109034)
,p_event_id=>wwv_flow_imp.id(3096983605390966803)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P150_BLUEPRINT_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3172047405728109030)
,p_event_id=>wwv_flow_imp.id(3096983605390966803)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3172047168618109027)
,p_name=>'Save Blueprint'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3009625633237704076)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3172047232011109028)
,p_event_id=>wwv_flow_imp.id(3172047168618109027)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'doSave();'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2940046596425003234)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Blueprint JSON into collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_json_collection constant varchar2(255) := ''TEMP_JSON'';',
'    l_json            clob;',
'begin',
'    if :P150_BLUEPRINT_ID is null then',
'        l_json := wwv_flow_blueprint_v3.gen_json (',
'                    p_built_with_love       =>  :P5_BUILT_WITH_LOVE,',
'                    p_learn_app_def         =>  :P5_LEARN_UI_DEF_YN,',
'                    P_APP_NAME              =>  :P1_APP_NAME,',
'                    P_APP_SHORT_DESC        =>  :P5_APP_SHORT_DESC,',
'                    P_APP_DESC              =>  :P5_APP_DESC,',
'                    P_FEATURES              =>  :P1_FEATURES,',
'                    P_THEME_STYLE           =>  nvl(:P170_THEME_STYLE, :P1_THEME_STYLE),',
'                    P_NAV_POSITION          =>  nvl(:P170_NAV_POSITION, :P1_NAV_POSITION),',
'                    P_APP_ICON_CLASS        =>  :P1_APP_ICON_CLASS,',
'                    P_APP_COLOR_CLASS       =>  :P1_APP_COLOR_CLASS,',
'                    P_APP_COLOR_HEX         =>  :P1_APP_COLOR_HEX,',
'                    P_BASE_TABLE_PREFIX     =>  :P5_BASE_TABLE_PREFIX,',
'                    P_PRIMARY_LANGUAGE      =>  :P1_PRIMARY_LANGUAGE,',
'                    P_TRANSLATED_LANGS      =>  :P1_TRANSLATED_LANGS,',
'                    P_AUTHENTICATION        =>  :P1_AUTHENTICATION,',
'                    P_APP_VERSION           =>  :P5_APP_VERSION,',
'                    P_APP_LOGGING           =>  :P5_APP_LOGGING,',
'                    P_APP_DEBUGGING         =>  :P5_APP_DEBUGGING,',
'                    P_DOCUMENT_DIRECTION    =>  :P5_DOCUMENT_DIRECTION,',
'                    P_DATE_FORMAT           =>  :P5_DATE_FORMAT,',
'                    P_DATE_TIME_FORMAT      =>  :P5_DATE_TIME_FORMAT,',
'                    P_TIMESTAMP_FORMAT      =>  :P5_TIMESTAMP_FORMAT,',
'                    P_TIMESTAMP_TZ_FORMAT   =>  :P5_TIMESTAMP_TZ_FORMAT,',
'                    P_DEEP_LINKING          =>  :P5_DEEP_LINKING,',
'                    P_MAX_SESSION_LENGTH    =>  :P5_MAX_SESSION_LENGTH,',
'                    P_MAX_SESSION_IDLE_TIME =>  :P5_MAX_SESSION_IDLE_TIME,',
'                    p_schema                =>  :P1_SCHEMA',
'                    );',
'    else',
'        l_json := wwv_flow_blueprint_v3.load_blueprint(',
'	                p_blueprint_id => :P150_BLUEPRINT_ID,',
'	                p_app_user     => :APP_USER,',
'                    p_security_group_id => :FLOW_SECURITY_GROUP_ID);',
'    end if;',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => c_json_collection );',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => c_json_collection,',
'        p_clob001         => l_json );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2940046596425003234
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2601332522555503)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save_blueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_json clob;',
'begin    ',
'    sys.dbms_lob.createtemporary( l_json, false, sys.dbms_lob.SESSION );',
'   ',
'    for i in 1..wwv_flow.g_f01.count loop ',
'        sys.dbms_lob.writeappend( l_json, length(wwv_flow.g_f01(i)), wwv_flow.g_f01(i) );        ',
'    end loop;        ',
'    ',
'    wwv_flow_blueprint_v3.get_session_state_from_json (',
'    	p_json_blueprint        => l_json,',
'        p_raise_error           => true,',
'        --',
'        p_schema                => :P1_SCHEMA,',
'        p_built_with_love       => :P5_BUILT_WITH_LOVE,',
'        p_learn_app_def         => :P5_LEARN_UI_DEF_YN,',
'        p_app_name              => :P1_APP_NAME,',
'        p_app_short_desc        => :P5_APP_SHORT_DESC,',
'        p_app_desc              => :P5_APP_DESC,',
'        p_features              => :P1_FEATURES,',
'        p_theme_style           => :P170_THEME_STYLE,',
'        p_nav_position          => :P170_NAV_POSITION,',
'        p_app_icon_class        => :P1_APP_ICON_CLASS,',
'        p_app_color_class       => :P1_APP_COLOR_CLASS,',
'        p_app_color_hex         => :P1_APP_COLOR_HEX,',
'        p_base_table_prefix     => :P5_BASE_TABLE_PREFIX,',
'        p_primary_language      => :P1_PRIMARY_LANGUAGE,',
'        p_translated_langs      => :P1_TRANSLATED_LANGS,',
'        p_authentication        => :P1_AUTHENTICATION,',
'        p_app_version           => :P5_APP_VERSION,',
'        p_app_logging           => :P5_APP_LOGGING,',
'        p_app_debugging         => :P5_APP_DEBUGGING,',
'        p_document_direction    => :P5_DOCUMENT_DIRECTION,',
'        p_date_format           => :P5_DATE_FORMAT,',
'        p_date_time_format      => :P5_DATE_TIME_FORMAT,',
'        p_timestamp_format      => :P5_TIMESTAMP_FORMAT,',
'        p_timestamp_tz_format   => :P5_TIMESTAMP_TZ_FORMAT,',
'        p_deep_linking          => :P5_DEEP_LINKING,',
'        p_max_session_length    => :P5_MAX_SESSION_LENGTH,',
'        p_max_session_idle_time => :P5_MAX_SESSION_IDLE_TIME );',
'       ',
'    :P1_THEME_STYLE := :P170_THEME_STYLE;',
'    :P1_NAV_POSITION := :P170_NAV_POSITION;',
'    ',
'    wwv_flow_app_def_v3.sync_app_defaults (',
'        p_schema              => :P1_SCHEMA,',
'        p_learn_app_def       => ( nvl(:P5_LEARN_UI_DEF_YN, ''N'') = ''Y'' ),',
'        p_learn_existing_apps => ( nvl(:P5_LEARN_YN,''N'') = ''Y'' ),',
'        p_base_table_prefix   => :P5_BASE_TABLE_PREFIX );',
'        ',
'    :P130_PRIMARY_LANGUAGE := :P1_PRIMARY_LANGUAGE;',
'    :P130_TRANSLATED_LANGS := :P1_TRANSLATED_LANGS;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2601332522555503
);
end;
/
prompt --application/pages/page_00160
begin
wwv_flow_imp_page.create_page(
 p_id=>160
,p_name=>'Load Blueprint'
,p_alias=>'LOAD-BLUEPRINT'
,p_page_mode=>'MODAL'
,p_step_title=>'Load Blueprint'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.icon-preview {',
'  width: 24px;',
'  height: 24px;',
'  display: block;',
'  border-radius: 2px;',
'  background-color: currentColor;',
'}',
'',
'.a-Report-cell {',
'  line-height: 24px;',
'}',
'',
'.delete-button {',
'  color: var(--a-palette-danger);',
'}',
'',
'.nodatafound {',
'  text-align: center;',
'  padding: 64px 16px;',
'  font-size: 16px;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'400'
,p_dialog_width=>'640'
,p_dialog_chained=>'N'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(3092828716344849803)
,p_name=>'Blueprints'
,p_region_name=>'blueprints_report'
,p_template=>wwv_flow_imp.id(3300810815961795652)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  icon_class icon,',
'  icon_color_class,',
'  name,',
'  page_count,',
'  feature_count,',
'  created_on created,',
'  null select_action,',
'  null load_action,',
'  null delete_action,',
'  name clean_name',
'from WWV_FLOW_BLUEPRINT_REPO',
'where created_by = :APP_USER and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by created_on desc'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(2707641403506668051)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Blueprints Found'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2940047222737003241)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3092828828392849804)
,p_query_column_id=>2
,p_column_alias=>'ICON'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3092828993907849805)
,p_query_column_id=>3
,p_column_alias=>'ICON_COLOR_CLASS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3092829049410849806)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-MediaBlock">',
'  <div class="a-MediaBlock-graphic icon-preview #ICON# #ICON_COLOR_CLASS#"></div>',
'  <div class="a-MediaBlock-content">#NAME#</div>',
'</div>'))
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2940047394433003242)
,p_query_column_id=>5
,p_column_alias=>'PAGE_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'Page count'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3040394562753894745)
,p_query_column_id=>6
,p_column_alias=>'FEATURE_COUNT'
,p_column_display_sequence=>5
,p_column_heading=>'Features'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3092829341232849809)
,p_query_column_id=>7
,p_column_alias=>'CREATED'
,p_column_display_sequence=>6
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3040394614917894746)
,p_query_column_id=>8
,p_column_alias=>'SELECT_ACTION'
,p_column_display_sequence=>8
,p_column_heading=>'<span class="u-VisuallyHidden">Select Blueprint</span>'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<button type="button" class="a-Button a-Button--small select-button" data-id="#ID#">Select</button>'
,p_column_alignment=>'CENTER'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_condition=>'P160_RETURN_TYPE'
,p_display_when_condition2=>'LOAD'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>24
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3210720416272760404)
,p_query_column_id=>9
,p_column_alias=>'LOAD_ACTION'
,p_column_display_sequence=>9
,p_column_heading=>'<span class="u-VisuallyHidden">Load Blueprint</span>'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<button type="button" class="a-Button a-Button--small load-button" data-id="#ID#">Load</button>'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P160_RETURN_TYPE'
,p_display_when_condition2=>'LOAD'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3040394722705894747)
,p_query_column_id=>10
,p_column_alias=>'DELETE_ACTION'
,p_column_display_sequence=>10
,p_column_heading=>'<span class="u-VisuallyHidden">Delete Blueprint</span>'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<button type="button" title="Delete Blueprint #CLEAN_NAME#" class="a-Button a-Button--small a-Button--noUI delete-button" data-id="#ID#"><span class="a-Icon icon-remove" aria-hidden="true"></span></button>'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>24
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3217864403847443003)
,p_query_column_id=>11
,p_column_alias=>'CLEAN_NAME'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3210721976980760419)
,p_branch_name=>'Go to Create Wizard Home Page'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'LOAD_BLUEPRINT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3040395074343894750)
,p_name=>'P160_BLUEPRINT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3092828716344849803)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3217864528853443004)
,p_name=>'P160_RETURN_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3092828716344849803)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3040394824972894748)
,p_name=>'Send Blueprint Back to Page'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.select-button'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
,p_display_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_display_when_cond=>'LOAD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3040394906737894749)
,p_event_id=>wwv_flow_imp.id(3040394824972894748)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P160_BLUEPRINT_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id");'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3172047584383109031)
,p_event_id=>wwv_flow_imp.id(3040394824972894748)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
,p_attribute_01=>'P160_BLUEPRINT_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3210720549847760405)
,p_name=>'Load Blueprint'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.load-button'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
,p_display_when_type=>'REQUEST_EQUALS_CONDITION'
,p_display_when_cond=>'LOAD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3210720684856760406)
,p_event_id=>wwv_flow_imp.id(3210720549847760405)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P160_BLUEPRINT_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id");'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3210720871116760408)
,p_event_id=>wwv_flow_imp.id(3210720549847760405)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'LOAD_BLUEPRINT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3096984274263966809)
,p_name=>'Delete Blueprint (Refresh Report)'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.delete-button'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
,p_display_when_type=>'NEVER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3096984318923966810)
,p_event_id=>wwv_flow_imp.id(3096984274263966809)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P160_BLUEPRINT_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id");'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3217864239961443001)
,p_event_id=>wwv_flow_imp.id(3096984274263966809)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_blueprint_v3.remove_blueprint (',
'	p_blueprint_id => :P160_BLUEPRINT_ID, ',
'	p_app_user => :APP_USER,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID);'))
,p_attribute_02=>'P160_BLUEPRINT_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3217864378761443002)
,p_event_id=>wwv_flow_imp.id(3096984274263966809)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3092828716344849803)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3217864682642443005)
,p_name=>'Delete Blueprint (AJAX)'
,p_event_sequence=>40
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.delete-button'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3217864778596443006)
,p_event_id=>wwv_flow_imp.id(3217864682642443005)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// cache common elements',
'var blueprint$    = $(this.triggeringElement),',
'    blueprintId   = blueprint$.data("id"),',
'    blueprintRow$ = blueprint$.parents("tr");',
'',
'// hide blueprint from UI',
'blueprint$.parents("tr").addClass("is-disabled");',
'',
'// run ajax process to remove blueprint',
'apex.server.process( "removeBlueprint", {',
'    x01: blueprintId',
'}, {',
'    success: function( commentID ) {',
'        blueprintRow$.remove();',
'    }',
'});'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3210720931436760409)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Blueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_blueprint clob;',
'begin',
'',
'l_blueprint := wwv_flow_blueprint_v3.load_blueprint(',
'	p_blueprint_id => :P160_BLUEPRINT_ID,',
'	p_app_user=> :APP_USER,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID);',
'	',
'wwv_flow_blueprint_v3.get_session_state_from_json (',
'    P_JSON_BLUEPRINT        => l_blueprint,',
'    p_schema                => :P1_SCHEMA,',
'    p_built_with_love       => :P5_BUILT_WITH_LOVE,',
'    p_learn_app_def         => :P5_LEARN_UI_DEF_YN,',
'    P_APP_NAME              => :P1_APP_NAME,',
'    P_APP_SHORT_DESC        => :P5_APP_SHORT_DESC,',
'    P_APP_DESC              => :P5_APP_DESC,',
'    P_FEATURES              => :P1_FEATURES,',
'    P_THEME_STYLE           => :P170_THEME_STYLE,',
'    P_NAV_POSITION          => :P170_NAV_POSITION,',
'    P_APP_ICON_CLASS        => :P1_APP_ICON_CLASS,',
'    P_APP_COLOR_CLASS       => :P1_APP_COLOR_CLASS,',
'    P_APP_COLOR_HEX         => :P1_APP_COLOR_HEX,',
'    P_BASE_TABLE_PREFIX     => :P5_BASE_TABLE_PREFIX,',
'    P_PRIMARY_LANGUAGE      => :P1_PRIMARY_LANGUAGE,',
'    P_TRANSLATED_LANGS      => :P1_TRANSLATED_LANGS,',
'    P_AUTHENTICATION        => :P1_AUTHENTICATION,',
'    P_APP_VERSION           => :P5_APP_VERSION,',
'    P_APP_LOGGING           => :P5_APP_LOGGING,',
'    P_APP_DEBUGGING         => :P5_APP_DEBUGGING,',
'    P_DOCUMENT_DIRECTION    => :P5_DOCUMENT_DIRECTION,',
'    P_DATE_FORMAT           => :P5_DATE_FORMAT,',
'    P_DATE_TIME_FORMAT      => :P5_DATE_TIME_FORMAT,',
'    P_TIMESTAMP_FORMAT      => :P5_TIMESTAMP_FORMAT,',
'    P_TIMESTAMP_TZ_FORMAT   => :P5_TIMESTAMP_TZ_FORMAT,',
'    P_DEEP_LINKING          => :P5_DEEP_LINKING,',
'    P_MAX_SESSION_LENGTH    => :P5_MAX_SESSION_LENGTH,',
'    P_MAX_SESSION_IDLE_TIME => :P5_MAX_SESSION_IDLE_TIME',
'    );',
'    ',
'    :P1_THEME_STYLE := :P170_THEME_STYLE;',
'    :P1_NAV_POSITION := :P170_NAV_POSITION;',
'',
'exception when others then null;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error Loading Blueprint'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'LOAD_BLUEPRINT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>3210720931436760409
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3217865010876443009)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'removeBlueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'  	wwv_flow_blueprint_v3.remove_blueprint (',
'    	p_blueprint_id => wwv_flow.g_x01, ',
'    	p_app_user => :APP_USER,',
'    	p_security_group_id => :FLOW_SECURITY_GROUP_ID);',
'		',
'	wwv_flow_plugin_util.print_json_http_header;',
'	wwv_flow_json.open_object;',
'	wwv_flow_json.write(''status'',''deleted'');',
'    wwv_flow_json.close_object;',
'	',
'exception when others then ',
'',
'	wwv_flow_plugin_util.print_json_http_header;',
'	wwv_flow_json.open_object;',
'	wwv_flow_json.write(''error'',''unable to delete blueprint ''||sqlerrm );',
'    wwv_flow_json.close_object;',
'	rollback;',
'	',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3217865010876443009
);
end;
/
prompt --application/pages/page_00170
begin
wwv_flow_imp_page.create_page(
 p_id=>170
,p_name=>'Appearance'
,p_alias=>'APPEARANCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Appearance'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.field.item-app-name { margin-bottom: 0; }',
'.field--style--boxed .display_only { line-height: 24px; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; }',
'.apex-col .field.field-item-button-grouping { margin-right: -1px; }',
'.lang-button { padding-top: 19px; padding-bottom: 19px; width: calc(100% - 16px); margin-right: 16px; }',
'.advanced-button { padding-top: 19px; padding-bottom: 19px; width: calc(100% - 16px); margin-right: 16px; }',
'.attribute-button { padding-top: 19px; padding-bottom: 19px; width: calc(100% - 16px); margin-right: 16px; }',
'.a-BoxedForms .field-item-button-grouping .field-input__wrap { border-radius: 2px 0 0 2px; }',
'html.no-js .a-BoxedForms .field--style--boxed.label-only .field-label { padding-top: 1.8rem; padding-bottom: 1.8rem; }',
'.page-source-table { font-family: monospace; font-size: 11px; line-height: 21px; margin: 0 4px; }'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'550'
,p_dialog_width=>'880'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52409446028114501)
,p_plug_name=>'Appearance - Custom Theme'
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P170_CUSTOM_THEME_YN'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52409790570114504)
,p_plug_name=>'Hidden Items'
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3718779288454226401)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6307699474464365654)
,p_plug_name=>'Appearance - UT'
,p_region_name=>'appearance'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P170_CUSTOM_THEME_YN'
,p_plug_display_when_cond2=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3396254080746246635)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3718779288454226401)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--gapRight'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(645332378727941501)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3718779288454226401)
,p_button_name=>'CUSTOM_THEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Use Custom Theme'
,p_button_position=>'NEXT'
,p_button_condition=>'P170_CUSTOM_THEME_YN'
,p_button_condition2=>'N'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(52410326133114510)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3718779288454226401)
,p_button_name=>'UNIVERSAL_THEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Use Universal Theme'
,p_button_position=>'NEXT'
,p_button_condition=>'P170_CUSTOM_THEME_YN'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3396253804956246633)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(3718779288454226401)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3718775307196215133)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3718779288454226401)
,p_button_name=>'HELP_UI'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'View Help for Appearance'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:UI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(52410470000114511)
,p_branch_name=>'Reload Page'
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'CUSTOM_THEME,UNIVERSAL_THEME'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52409521057114502)
,p_name=>'P170_CUSTOM_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(52409446028114501)
,p_prompt=>'Workspace Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       t.theme_name,',
'       t.id',
'  from wwv_flow_themes t',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Custom Theme -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a workspace theme to use when generating the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52409663240114503)
,p_name=>'P170_CUSTOM_THEME_STYLE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(52409446028114501)
,p_prompt=>'Theme Style'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   s.name || ',
'       case is_accessible',
'           when ''Y'' then '' ('' || wwv_flow_lang.system_message(''ACCESSIBILITY_TESTED'') || '')''',
'           else ''''',
'        end name,   ',
'   s.id ',
'from wwv_flow_themes t, wwv_flow_theme_styles s',
'where t.id = :P170_CUSTOM_THEME_ID',
'and t.theme_id = s.theme_id',
'and t.flow_id = s.flow_id',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Theme Style -'
,p_lov_cascade_parent_items=>'P170_CUSTOM_THEME_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'If supported by the custom theme, select the style to be used when generating the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52409875575114505)
,p_name=>'P170_CUSTOM_THEME_YN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(52409790570114504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3396254608905246641)
,p_name=>'P170_NAV_POSITION_DISP'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(6307699474464365654)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3718775740605215139)
,p_name=>'P170_THEME_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6307699474464365654)
,p_prompt=>'Theme Style'
,p_source=>'P1_THEME_STYLE'
,p_source_type=>'ITEM'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P1_THEME_STYLES'
,p_lov=>'.'||wwv_flow_imp.id(2595731361215290332)||'.'
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_css_classes=>'a-IconList--PageWizard a-IconList--LargeIcons'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3718776124351215148)
,p_name=>'P170_NAV_POSITION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6307699474464365654)
,p_prompt=>'Navigation'
,p_source=>'P1_NAV_POSITION'
,p_source_type=>'ITEM'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P1_NAVIGATION_POSITION'
,p_lov=>'.'||wwv_flow_imp.id(2621239147915611502)||'.'
,p_colspan=>6
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_css_classes=>'a-IconList--PageWizard a-IconList--SmallIcons'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(52410594310114512)
,p_computation_sequence=>10
,p_computation_item=>'P170_CUSTOM_THEME_YN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( :P1_THEME_TYPE in (''CUSTOM'',''CUSTOM_UT'') ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_compute_when=>'P170_CUSTOM_THEME_YN'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101210759019869203)
,p_validation_name=>'Custom Theme not null'
,p_validation_sequence=>10
,p_validation=>'P170_CUSTOM_THEME_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P170_CUSTOM_THEME_YN'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3396253804956246633)
,p_associated_item=>wwv_flow_imp.id(52409521057114502)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3396254181242246636)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3396254080746246635)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1156925167756672917)
,p_event_id=>wwv_flow_imp.id(3396254181242246636)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>':P170_CUSTOM_THEME_YN := null;'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3396254200111246637)
,p_event_id=>wwv_flow_imp.id(3396254181242246636)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3396254707676246642)
,p_name=>'Get Displayed Value'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P170_NAV_POSITION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3396254800162246643)
,p_event_id=>wwv_flow_imp.id(3396254707676246642)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>':P170_NAV_POSITION_DISP := initCap( lower(:P170_NAV_POSITION) );'
,p_attribute_02=>'P170_NAV_POSITION'
,p_attribute_03=>'P170_NAV_POSITION_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(52410061763114507)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Use Custom Theme'
,p_process_sql_clob=>':P170_CUSTOM_THEME_YN := ''Y'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(645332378727941501)
,p_internal_uid=>52410061763114507
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(52410267134114509)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Use Universal Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P170_CUSTOM_THEME_YN := ''N'';',
'-- Avoid empty values',
':P170_NAV_POSITION    := ''SIDE'';'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(52410326133114510)
,p_internal_uid=>52410267134114509
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3396254345369246638)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Page 1 Item Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P170_CUSTOM_THEME_YN = ''N'' then',
'',
'    :P1_THEME_TYPE      := ''UT'';',
'    :P1_THEME_STYLE     := :P170_THEME_STYLE;',
'    ',
'    :P1_NAV_POSITION    := :P170_NAV_POSITION;',
'',
'elsif :P170_CUSTOM_THEME_YN = ''Y'' then',
'',
'    if wwv_flow_theme_dev.is_universal_theme ( p_theme_id => :P170_CUSTOM_THEME_ID ) then',
'        :P1_THEME_TYPE  := ''CUSTOM_UT'';',
'    else',
'        :P1_THEME_TYPE  := ''CUSTOM'';',
'    end if;',
'    ',
'    :P1_THEME_ID    := :P170_CUSTOM_THEME_ID;',
'    :P1_THEME_STYLE := :P170_CUSTOM_THEME_STYLE_ID;',
'',
'    -- clean up',
'    :P170_NAV_POSITION      := '''';',
'    :P1_NAV_POSITION        := '''';',
'    ',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3396253804956246633)
,p_internal_uid=>3396254345369246638
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3396253968011246634)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog for UT'
,p_attribute_01=>'P170_THEME_STYLE,P170_NAV_POSITION,P170_CUSTOM_THEME_YN,P1_THEME_TYPE'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3396253804956246633)
,p_internal_uid=>3396253968011246634
);
end;
/
prompt --application/pages/page_00250
begin
wwv_flow_imp_page.create_page(
 p_id=>250
,p_name=>'Attribute Defaults'
,p_alias=>'ATTRIBUTE-DEFAULTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Attribute Defaults'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function pageSubmit(req) {',
'  apex.builder.plugin.codeEditor.saveSubmit("#codeEditor_widget", "f01", {request: req, showWait: true});',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.checkbox_group {',
'    width: 100%;',
'}',
'fieldset.checkbox_group table {',
'    width: 100%;',
'}',
'p.note {',
'margin: 0 8px;',
'color: #707070;',
'font-size: 11px;}'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3027830547707021532)
,p_dialog_height=>'650'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11817121936578509579)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11817122601075509585)
,p_plug_name=>'Edit Attribute Defaults'
,p_region_name=>'codeEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob001',
'from wwv_flow_collections',
'where collection_name = ''TEMP_JSON'''))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'SQL',
  'attribute_02', '30',
  'attribute_03', 'N',
  'attribute_04', 'VARCHAR2')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3025638933882105990)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(11817121936578509579)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:DEFAULTS'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3025638183876105989)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(11817121936578509579)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3025638589266105990)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(11817121936578509579)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Attribute Defaults'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3025642886946106023)
,p_branch_name=>'Reload attribute values page'
,p_branch_action=>'f?p=&APP_ID.:250:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3025640911556106018)
,p_name=>'Toggle Language in Translations'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P250_PRIMARY_LANGUAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3025641493679106020)
,p_event_id=>wwv_flow_imp.id(3025640911556106018)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Cache Elements */',
'var priLang = $(this.triggeringElement).val().toUpperCase();',
'var translatedItem$ = $(''#P250_TRANSLATED_LANGS'').find(''input[type=checkbox]'');',
'var translatedLangItem$ = $(''#P250_TRANSLATED_LANGS'').find(''input[value=''+priLang+'']'');',
'',
'/* Uncheck and make primary language in the translations item */',
'translatedItem$.each(function(){',
'  if ($(this).prop("disabled") === true){',
'    $(this).prop("checked",false);',
'    $(this).prop("disabled",false);',
'  }',
'});',
'translatedLangItem$.prop(''checked'',true).prop(''disabled'',true);'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3025641847966106021)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3025638183876105989)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3025642367939106021)
,p_event_id=>wwv_flow_imp.id(3025641847966106021)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3172047965255109035)
,p_name=>'Save App Defaults'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3025638589266105990)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3172048020273109036)
,p_event_id=>wwv_flow_imp.id(3172047965255109035)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'pageSubmit("SAVE");'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3025639737610106015)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load app def JSON into collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_json_collection constant varchar2(255) := ''TEMP_JSON'';',
'    l_json            clob;',
'begin',
'    l_json := wwv_flow_app_def_v3.gen_app_defaults_from_coll;',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => c_json_collection );',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => c_json_collection,',
'        p_clob001         => l_json );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3025639737610106015
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3025640182714106016)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Parse JSON and Set Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_json clob;',
'begin',
'    sys.dbms_lob.createtemporary( l_json, false, sys.dbms_lob.SESSION );',
'    for i in 1..wwv_flow.g_f01.count loop ',
'        sys.dbms_lob.writeappend( l_json, length(wwv_flow.g_f01(i)), wwv_flow.g_f01(i) );        ',
'    end loop;',
'    ',
'    wwv_flow_app_def_v3.gen_apply_app_defaults_sql(',
'        p_app_defaults => l_json );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save attribute defaults to collection.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3025640182714106016
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3025640544461106016)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3025640544461106016
);
end;
/
prompt --application/pages/page_00260
begin
wwv_flow_imp_page.create_page(
 p_id=>260
,p_name=>'UI Defaults'
,p_alias=>'UI-DEFAULTS'
,p_step_title=>'UI Defaults'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-IRR-table tr:nth-child(even) td {',
'    background-color: inherit;',
'}',
'.a-IRR-table tr:hover td  .a-AVPList--blocks .a-AVPList-item, ',
'.a-IRR-table tr:nth-child(even):hover td .a-AVPList--blocks .a-AVPList-item,',
'.a-AVPList--blocks .a-AVPList-item:hover {',
'  background-color: #FFF;',
'}',
'',
'td[headers=attr_id],',
'td[headers=attr_settings] {',
'    padding: 0;',
'    vertical-align: top;',
'}',
'',
'.a-AVPList.a-AVPList--blocks {',
'    display: flex;',
'    flex-wrap: wrap;',
'    margin: 4px 0 0 4px;',
'}',
'',
'.a-AVPList--blocks .a-AVPList-item {',
'    display: block;',
'    padding: 8px;',
'    box-shadow: none;',
'    width: 160px;',
'    margin: 0 4px 4px 0;',
'    border-radius: 2px;',
'    background: #F8F8F8;',
'}',
'.a-AVPList--blocks .a-AVPList-item:last-child {',
'  margin-right: 0;',
'  border-right-width: 0;',
'}',
'',
'.a-AVPList--blocks .a-AVPList-label, ',
'.a-AVPList--blocks .a-AVPList-value {',
'    display: block;',
'    padding: 0;',
'    text-align: left;',
'}',
'',
'.a-AVPList--blocks .a-AVPList-label {',
'    font-size: 11px;',
'    color: #707070;',
'}',
'',
'.a-AVPList--blocks .a-AVPList-value {',
'    color: #404040;',
'    white-space: nowrap;',
'    text-overflow: ellipsis;',
'    overflow: hidden;',
'    font-family: monospace;',
'}',
'',
'/* Enable filtering / searching of settings, but do not allow click on header */',
'th#attr_settings > a {',
'    pointer-events: none;',
'    color: #404040;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3145297382377009606)
,p_plug_name=>'Application Defaults'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with lbls as (',
'    select ',
'        wwv_flow_lang.custom_runtime_message(''CA.table'')                  table_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.itemName'')               itemName_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.identification'')         identification_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.column'')                 column_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.name'')                   name_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.description'')            description_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.scope'')                  scope_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.dataType'')               dataType_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.sessionStateProtection'') sessionStateProtection_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.comments'')               comments_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.label'')                  label_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.includeOnForms'')         includeOnForms_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.includeOnReports'')       includeOnReports_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.formatMask'')             formatMask_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.staticDefault'')          staticDefault_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.type'')                   type_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.definition'')             definition_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.rowsPerPage'')            rowsPerPage_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.numberFormatMask'')       numberFormatMask_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.dateFormatMask'')         dateFormatMask_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.primaryDisplayColumn'')   primaryDisplayColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.secondaryDisplayColumn'') secondaryDisplayColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.suggestedVisulization'')  suggestedVisulization_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.labelSingular'')          labelSingular_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.labelPlural'')            labelPlural_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.primaryKeyColumn'')       primaryKeyColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.labelColumn'')            labelColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.primaryUse'')             primaryUse_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.primaryParentTable'')     primaryParentTable_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.tableColumn'')            tableColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.general'')                general_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.displayColumn'')          displayColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.keyColumn'')              keyColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.function'')               function_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.valueColumn'')            valueColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.maximumRows'')            maximumRows_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.query'')                  query_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.Form'')                   form_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.Reports'')                report_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.Metric'')                 metric_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.ApplicationItem'')        applicationItem_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.HELP'')                   help_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.REQUIRED'')               required_l,',
'        --',
'       ''<span class="a-AVPList-item"><span class="a-AVPList-label">'' o1,',
'       ''</span>'' c1,',
'       ''<span class="a-AVPList-value">'' o2,',
'       ''</span></span>'' c2',
'    from dual',
')',
'select',
'    attribute_type,',
'    attribute_settings,',
'    last_updated,',
'    wwv_flow_page_api.get_url(p_page => edit_page, p_items => ''P''||edit_page||''_ID'', p_values => seq_id, p_clear_cache => edit_page) edit_link,',
'    OB,',
'    c040 sourced_from,',
'    wwv_flow_lang.system_message(''EDIT_LINK_TEXT'', wwv_flow_escape.html(attribute_type)) link_text',
'from (',
'    select ',
'        decode(upper(c002), ',
'              ''APPLICATION_ITEM'',l.applicationItem_l,',
'              ''TABLE_COLUMN'',l.tablecolumn_l,',
'              ''TABLE'',l.table_l,',
'              ''METRIC'',l.metric_l,',
'              ''REPORT'',l.report_l,',
'              ''FORM'',l.form_l,',
'              wwv_flow_escape.html(c002)) attribute_type,',
'        decode(upper(c002), ',
'              ''APPLICATION_ITEM'',',
'                l.o1||l.itemName_l||l.c1||l.o2||wwv_flow_escape.html(c003)||l.c2||',
'                l.o1||l.scope_l||l.c1||l.o2||wwv_flow_escape.html(c004)||l.c2||',
'                l.o1||l.dataType_l||l.c1||l.o2||wwv_flow_escape.html(c005)||l.c2||',
'                l.o1||l.sessionStateProtection_l||l.c1||l.o2||wwv_flow_escape.html(c006)||l.c2||',
'                decode(trim(c007),null,null,l.o1||l.comments_l||l.c1||l.o2||wwv_flow_escape.html(c007)||l.c2),',
'              ''FORM'',',
'                l.o1||l.type_l||l.c1||l.o2||l.general_l||l.c2,',
'              ''TABLE_COLUMN'',',
'                l.o1||l.table_l||l.c1||l.o2||wwv_flow_escape.html(c003)||l.c2||',
'                l.o1||l.column_l||l.c1||l.o2||wwv_flow_escape.html(c004)||l.c2||',
'                l.o1||l.label_l||l.c1||l.o2||wwv_flow_escape.html(c005)||l.c2||',
'                l.o1||l.includeOnForms_l||l.c1||l.o2||wwv_flow_escape.html(decode(c007,''Y'',''true'',''N'',''false'',c007))||l.c2||',
'                l.o1||l.includeOnReports_l||l.c1||l.o2||wwv_flow_escape.html(decode(c008,''Y'',''true'',''N'',''false'',c008))||l.c2||',
'                decode(trim(c010),null,null,l.o1||l.formatMask_l||l.c1||l.o2||wwv_flow_escape.html(c010)||l.c2)||',
'                decode(trim(c011),null,null,l.o1||l.staticDefault_l||l.c1||l.o2||wwv_flow_escape.html(c011)||l.c2)||',
'                decode(trim(c016),null,null,l.o1||l.required_l||l.c1||l.o2||wwv_flow_escape.html(decode(c016,''Y'',''true'',''N'',''false'',c016))||l.c2)||',
'                decode(trim(c014),null,null,l.o1||l.help_l||l.c1||l.o2||wwv_flow_escape.html(c014)||l.c2),',
'              ''LOV'',',
'                l.o1||l.name_l||l.c1||l.o2||wwv_flow_escape.html(c003)||l.c1||l.c1||',
'                l.o1||l.type_l||l.c1||l.o2||wwv_flow_escape.html(lower(c004))||l.c2||',
'                decode(trim(c005),null,null,l.o1||l.definition_l||l.c1||l.o2||wwv_flow_escape.html(c005)||l.c2)||',
'                decode(trim(c006),null,null,l.o1||l.table_l||l.c1||l.o2||wwv_flow_escape.html(c006)||l.c2)||',
'                decode(trim(c007),null,null,l.o1||l.displayColumn_l||l.c1||l.o2||wwv_flow_escape.html(c007)||l.c2)||',
'                decode(trim(c008),null,null,l.o1||l.keycolumn_l||l.c1||l.o2||wwv_flow_escape.html(c008)||l.c2),',
'              ''REPORT'',',
'                l.o1||l.rowsPerPage_l||l.c1||l.o2||wwv_flow_escape.html(c003)||l.c2||',
'                decode(trim(c006),null,null,l.o1||l.numberFormatMask_l||l.c1||l.o2||wwv_flow_escape.html(c006)||l.c2)||',
'                decode(trim(c009),null,null,l.o1||l.dateFormatMask_l||l.c1||l.o2||wwv_flow_escape.html(c009)||l.c2),',
'              ''TABLE'',',
'                l.o1||l.table_l||l.c1||l.o2||wwv_flow_escape.html(c003)||l.c2||',
'                l.o1||l.labelSingular_l||l.c1||l.o2||wwv_flow_escape.html(c004)||l.c2||',
'                l.o1||l.labelPlural_l||l.c1||l.o2||wwv_flow_escape.html(c005)||l.c2||',
'                decode(trim(c006),null,null,l.o1||l.primaryDisplayColumn_l||l.c1||l.o2||wwv_flow_escape.html(c006)||l.c2)||',
'                decode(trim(c007),null,null,l.o1||l.secondaryDisplayColumn_l||l.c1||l.o2||wwv_flow_escape.html(c007)||l.c2)||',
'                decode(trim(c008),null,null,l.o1||l.primaryKeyColumn_l||l.c1||l.o2||wwv_flow_escape.html(c008)||l.c2),',
'                --decode(trim(c009),null,null,l.o1||l.primaryParentTable_l||l.c1||l.o2||wwv_flow_escape.html(c009)||l.c2),',
'              ''METRIC'',',
'                l.o1||l.name_l||l.c1||l.o2||wwv_flow_escape.html(c003)||l.c2||',
'                l.o1||l.type_l||l.c1||l.o2||wwv_flow_escape.html(c004)||l.c2||',
'                l.o1||l.suggestedVisulization_l||l.c1||l.o2||wwv_flow_escape.html(c005)||l.c2||',
'                decode(trim(c006),null,null,l.o1||l.table_l||l.c1||l.o2||wwv_flow_escape.html(c006)||l.c2)||',
'                decode(trim(c007),null,null,l.o1||l.labelColumn_l||l.c1||l.o2||wwv_flow_escape.html(c007)||l.c2)||',
'                decode(trim(c008),null,null,l.o1||l.function_l||l.c1||l.o2||wwv_flow_escape.html(c008)||l.c2)||',
'                decode(trim(c009),null,null,l.o1||l.valueColumn_l||l.c1||l.o2||wwv_flow_escape.html(c009)||l.c2)||',
'                decode(trim(c010),null,null,l.o1||l.maximumRows_l||l.c1||l.o2||wwv_flow_escape.html(c010)||l.c2)||',
'                decode(trim(c011),null,null,l.o1||l.query_l||l.c1||l.o2||wwv_flow_escape.html(c011)||l.c2),',
'              c003) attribute_settings,',
'        decode(upper(c002), ',
'              ''DESCRIPTION'',''360'',',
'              ''APPLICATION_ITEM'',''350'',',
'              ''TABLE_COLUMN'', ''310'',',
'              ''LOV'',''320'',',
'              ''REPORT'',''340'',',
'              ''METRIC'',''370'',',
'              ''TABLE'',''430'',',
'              ''#'') edit_page,',
'        d001 last_updated,',
'        seq_id,',
'        decode(upper(c002), ',
'            ''TABLE'', ''01''||c003,',
'            ''TABLE_COLUMN'',''01''||c003||''.''||c004,',
'            ''02''||c002||''.''||c003) OB,',
'        c040',
'    from wwv_flow_collections c, lbls l',
'    where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and ',
'          c002 != ''DESCRIPTION'' and ',
'          c002 != ''LOV_DATA''',
') c',
'order by 5',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3145297412606009607)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'100000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>3145297412606009607
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2940047455175003243)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>10
,p_column_identifier=>'V'
,p_column_label=>'<span class="u-VisuallyHidden">Edit</span>'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-pencil.png" class="apex-edit-pencil" alt="#LINK_TEXT#">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3145299438285009627)
,p_db_column_name=>'ATTRIBUTE_SETTINGS'
,p_display_order=>30
,p_column_identifier=>'R'
,p_column_label=>'Settings'
,p_column_html_expression=>'<div class="a-AVPList a-AVPList--blocks">#ATTRIBUTE_SETTINGS#</div>'
,p_allow_sorting=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_static_id=>'attr_settings'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3145299737570009630)
,p_db_column_name=>'ATTRIBUTE_TYPE'
,p_display_order=>50
,p_column_identifier=>'U'
,p_column_label=>'Attribute'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3302183738582908704)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>60
,p_column_identifier=>'W'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3504378962894326219)
,p_db_column_name=>'OB'
,p_display_order=>70
,p_column_identifier=>'X'
,p_column_label=>'Object Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3504379178256326221)
,p_db_column_name=>'SOURCED_FROM'
,p_display_order=>80
,p_column_identifier=>'Y'
,p_column_label=>'Sourced from'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247044351762377608)
,p_db_column_name=>'LINK_TEXT'
,p_display_order=>90
,p_column_identifier=>'Z'
,p_column_label=>'Link Text'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3157538733289778409)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'31575388'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'EDIT_LINK:ATTRIBUTE_TYPE:ATTRIBUTE_SETTINGS:LINK_TEXT'
,p_sort_column_1=>'OB'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'ATTRIBUTE_TYPE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'ATTRIBTE_IDENTIFICATION'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3145298064428009613)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--slimPadding:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3302186513250908732)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3145298064428009613)
,p_button_name=>'EDIT_DEFAULTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Edit Defaults'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:360:&SESSION.::&DEBUG.:RP,360:P360_ID:1'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3775764374844368406)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3145298064428009613)
,p_button_name=>'VIEW_JSON'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'View JSON'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:250:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3504377853063326208)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3145298064428009613)
,p_button_name=>'Reset'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3165201469772852632)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3145298064428009613)
,p_button_name=>'RETURN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Return to Create App Wizard'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3311213706143042513)
,p_name=>'Refresh on Add / Edit JSON'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(3145298064428009613)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3311213808853042514)
,p_event_id=>wwv_flow_imp.id(3311213706143042513)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3145297382377009606)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3311213930056042515)
,p_name=>'Refresh on Edit'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(3145297382377009606)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3311214084567042516)
,p_event_id=>wwv_flow_imp.id(3311213930056042515)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3145297382377009606)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3504378201458326212)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset App Defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_def_v3.gen_apply_app_defaults_sql(',
'        p_app_defaults => wwv_flow_app_def_v3.gen_sample_app_defaults );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3504377853063326208)
,p_internal_uid=>3504378201458326212
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3398687947504765505)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync_app_defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_def_v3.sync_app_defaults (',
'    p_schema              => :P1_SCHEMA,',
'    p_learn_app_def       => ( nvl(:P5_LEARN_UI_DEF_YN, ''N'') = ''Y'' ),',
'    p_learn_existing_apps => ( nvl(:P5_LEARN_YN,''N'') = ''Y'' ),',
'    p_base_table_prefix   => :P5_BASE_TABLE_PREFIX,',
'    p_seed_from_app_id    => :P5_SEED_FROM_APP  );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3398687947504765505
);
end;
/
prompt --application/pages/page_00310
begin
wwv_flow_imp_page.create_page(
 p_id=>310
,p_name=>'Table Column Attribute'
,p_alias=>'TABLE-COLUMN-ATTRIBUTE'
,p_page_mode=>'MODAL'
,p_step_title=>'Table Column Attribute'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3165199154732852609)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3165199598158852613)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3165200470552852622)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3348512942953385903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(3165200470552852622)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:TABLE_COLUMN_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3165200574372852623)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(3165200470552852622)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P310_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413428923693144818)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(3165200470552852622)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P310_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413425189221121582)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3165200470552852622)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P310_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3165200697778852624)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3165200470552852622)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3399173947389626661)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3165200470552852622)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165199280082852610)
,p_name=>'P310_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3165199154732852609)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165199343513852611)
,p_name=>'P310_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3165199154732852609)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165199490675852612)
,p_name=>'P310_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3165199154732852609)
,p_prompt=>'Column'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P310_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id'))
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165199779910852615)
,p_name=>'P310_LABEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_prompt=>'Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165199918382852617)
,p_name=>'P310_INCLUDE_ON_FORMS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_item_default=>'Y'
,p_prompt=>'Include on Forms'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165200005104852618)
,p_name=>'P310_INCLUDE_ON_REPORTS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_item_default=>'Y'
,p_prompt=>'Include on Reports'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165200278962852620)
,p_name=>'P310_FORMAT_MASK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_prompt=>'Format Mask'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT MASK DYNAMIC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from wwv_flow_format_masks'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165200367649852621)
,p_name=>'P310_STATIC_DEFAULT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_prompt=>'Static Default Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302186977757908736)
,p_name=>'P310_COMMENTS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_prompt=>'Comments'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>5
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302187004171908737)
,p_name=>'P310_HELP'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_prompt=>'Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302187144353908738)
,p_name=>'P310_WIDTH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302187242801908739)
,p_name=>'P310_MAXIMUM_WIDTH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302187326328908740)
,p_name=>'P310_REQUIRED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3165199598158852613)
,p_item_default=>'N'
,p_prompt=>'Required'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3165200716200852625)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3165200697778852624)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3165200807942852626)
,p_event_id=>wwv_flow_imp.id(3165200716200852625)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3171727591584100416)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'    for c1 in (select c001 ',
'               from wwv_flow_collections ',
'               where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P310_ID) loop',
'       l_name := c1.c001;',
'    end loop;',
'    ',
'    if :REQUEST = ''DELETE'' then',
'        WWV_FLOW_COLLECTION.DELETE_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_seq             => :P320_ID);',
'    else',
'        if :P310_ID is not null then',
'      ',
'            WWV_FLOW_COLLECTION.UPDATE_MEMBER (',
'                p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'                p_seq             => :P310_ID,',
'                p_c001            => l_name,',
'                p_c002            => ''TABLE_COLUMN'',',
'                p_c003            => :P310_TABLE ,',
'                p_c004            => :p310_column,',
'                p_c005            => :p310_label,',
'                p_c007            => :P310_include_on_forms,',
'                p_c008            => :P310_include_on_reports,',
'                p_c010            => :p310_format_mask,',
'                p_c011            => :p310_static_default,',
'                p_c012            => :p310_comments,',
'                p_c013            => :p310_help,',
'                p_c014            => :P310_WIDTH,',
'                p_c015            => :P310_MAXIMUM_WIDTH,',
'                p_c016            => :P310_REQUIRED,',
'                p_d001            => sysdate',
'                );',
'                ',
'        else',
'        ',
'            WWV_FLOW_COLLECTION.ADD_MEMBER (',
'                p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'                p_c001            => ''attribute defaults'',',
'                p_c002            => ''PAGE_ITEM'',',
'                p_c003            => :P310_TABLE ,',
'                p_c004            => :p310_column,',
'                p_c005            => :p310_label,',
'                p_c007            => :P310_include_on_forms,',
'                p_c008            => :P310_include_on_reports,',
'                p_c010            => :p310_format_mask,',
'                p_c011            => :p310_static_default,',
'                p_c012            => :p310_comments,',
'                p_c013            => :p310_help,',
'                p_c014            => :P310_WIDTH,',
'                p_c015            => :P310_MAXIMUM_WIDTH,',
'                 --p_c016            => :P310_REQUIRED,',
'                p_d001            => sysdate',
'                );',
'                ',
'        end if;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3171727591584100416
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3311214178033042517)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3311214178033042517
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3171727440794100415)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P310_ID) loop',
'   :P310_TABLE              := C1.C003;',
'   :P310_COLUMN             := C1.C004;',
'   :P310_LABEL              := C1.C005;',
'   :P310_INCLUDE_ON_FORMS   := C1.C007;',
'   :P310_INCLUDE_ON_REPORTS := C1.C008;',
'   :P310_FORMAT_MASK        := C1.C010;',
'   :P310_STATIC_DEFAULT     := C1.C011;',
'   :P310_COMMENTS           := C1.C012;',
'   :P310_HELP               := C1.C013;',
'   :P310_WIDTH              := C1.C014;',
'   :P310_MAXIMUM_WIDTH      := C1.C015;',
'   :P310_required           := NVL(C1.C016,''N'');',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3171727440794100415
);
end;
/
prompt --application/pages/page_00340
begin
wwv_flow_imp_page.create_page(
 p_id=>340
,p_name=>'Report Attributes'
,p_alias=>'REPORT-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Report Attributes'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16557748491182994796)
,p_plug_name=>'Reports'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16557749807002994809)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413432445171186417)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(16557749807002994809)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:REPORT_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3348535073365543309)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(16557749807002994809)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P340_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413434096915203320)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(16557749807002994809)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P340_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3348535876220543315)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(16557749807002994809)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P340_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3348535421704543314)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(16557749807002994809)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3399172753722601202)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(16557749807002994809)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302184569021908712)
,p_name=>'P340_NUMERIC_FORMAT_MASK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(16557748491182994796)
,p_item_default=>'VARCHAR'
,p_prompt=>'Numeric Format Mask'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302184673340908713)
,p_name=>'P340_DATE_FORMAT_MASK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(16557748491182994796)
,p_item_default=>'VARCHAR'
,p_prompt=>'Date Format Mask'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3348536510841543325)
,p_name=>'P340_ROWS_PER_PAGE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(16557748491182994796)
,p_prompt=>'Rows Per Page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3348538127232543336)
,p_name=>'P340_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(16557748491182994796)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3348539709689543350)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3348535421704543314)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3348540225331543354)
,p_event_id=>wwv_flow_imp.id(3348539709689543350)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348538994862543348)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P340_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'if :REQUEST = ''DELETE'' then',
'    WWV_FLOW_COLLECTION.DELETE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P320_ID);',
'else',
'    if :P340_ID is not null then',
'        WWV_FLOW_COLLECTION.UPDATE_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_seq             => :P340_ID,',
'            p_c001            => l_name,',
'            p_c002            => ''REPORT'',',
'            p_c003            => :P340_ROWS_PER_PAGE,',
'            p_c006            => :P340_NUMERIC_FORMAT_MASK,',
'            p_c009            => :P340_DATE_FORMAT_MASK,',
'            p_d001            => sysdate',
'            );',
'            ',
'    else',
'    ',
'        WWV_FLOW_COLLECTION.ADD_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_c001            => l_name,',
'            p_c002            => ''REPORT'',',
'            p_c003            => :P340_ROWS_PER_PAGE,',
'            p_c006            => :P340_NUMERIC_FORMAT_MASK,',
'            p_c009            => :P340_DATE_FORMAT_MASK,',
'            p_d001            => sysdate',
'            );',
'    end if;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348538994862543348
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348539352524543349)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348539352524543349
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348538515225543345)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P340_ID) loop',
'   :P340_ROWS_PER_PAGE          := C1.C003;',
'   :P340_NUMERIC_FORMAT_MASK    := C1.C006;',
'   :P340_DATE_FORMAT_MASK       := C1.C009;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348538515225543345
);
end;
/
prompt --application/pages/page_00350
begin
wwv_flow_imp_page.create_page(
 p_id=>350
,p_name=>'Application Item Attribute'
,p_alias=>'APPLICATION-ITEM-ATTRIBUTE'
,p_page_mode=>'MODAL'
,p_step_title=>'Application Item Attribute'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.textarea {',
'    width: 100%;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13209214060330451553)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13209215376150451566)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413435103918209273)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(13209215376150451566)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:APP_ITEM_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3348482906620943332)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(13209215376150451566)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P350_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413435465052210463)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(13209215376150451566)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P350_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413434588859206469)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(13209215376150451566)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P350_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3348483347387943333)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(13209215376150451566)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3399171947930582197)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(13209215376150451566)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_condition=>'P350_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302184386601908710)
,p_name=>'P350_PROTECTION_LEVEL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13209214060330451553)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP ITEM PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_imp.id(3348521895514426469)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302184404464908711)
,p_name=>'P350_DATA_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(13209214060330451553)
,p_item_default=>'VARCHAR'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:NUMBER;NUMBER,VARCHAR;VARCHAR'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3348484492788943334)
,p_name=>'P350_DESCRIPTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(13209214060330451553)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3348485161446943335)
,p_name=>'P350_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13209214060330451553)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3348485563930943336)
,p_name=>'P350_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(13209214060330451553)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3348487139406943338)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3348483347387943333)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3348487623366943338)
,p_event_id=>wwv_flow_imp.id(3348487139406943338)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348486307197943337)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P350_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'if :REQUEST = ''DELETE'' then',
'    WWV_FLOW_COLLECTION.DELETE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P320_ID);',
'else',
'    if l_name is not null then',
'        WWV_FLOW_COLLECTION.UPDATE_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_seq             => :P350_ID,',
'            p_c001            => l_name,',
'            p_c002            => ''APPLICATION_ITEM'',',
'            p_c003            => :P350_NAME ,',
'            p_c004            => :P350_DESCRIPTION,',
'            p_c005            => :P350_DATA_TYPE,',
'            p_c006            => :P350_PROTECTION_LEVEL,',
'            p_d001            => sysdate',
'            );',
'    else',
'        WWV_FLOW_COLLECTION.ADD_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_c001            => l_name,',
'            p_c002            => ''APPLICATION_ITEM'',',
'            p_c003            => :P350_NAME ,',
'            p_c004            => :P350_DESCRIPTION,',
'            p_c005            => :P350_DATA_TYPE,',
'            p_c006            => :P350_PROTECTION_LEVEL,',
'            p_d001            => sysdate',
'            );',
'            ',
'    end if;',
'end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348486307197943337
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348486702879943337)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348486702879943337
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348485937407943337)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P350_ID) loop',
'   :P350_NAME              := C1.C003; ',
'   :P350_DESCRIPTION       := C1.C004;',
'   :P350_PROTECTION_LEVEL  := c1.C006;',
'   :P350_DATA_TYPE         := c1.C005;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348485937407943337
);
end;
/
prompt --application/pages/page_00360
begin
wwv_flow_imp_page.create_page(
 p_id=>360
,p_name=>'Attribute Defaults'
,p_alias=>'ATTRIBUTE-DEFAULTS1'
,p_page_mode=>'MODAL'
,p_step_title=>'Attribute Defaults'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.textarea {',
'    width: 100%;',
'}'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9860731784394508223)
,p_plug_name=>'Application Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9860733100214508236)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3348472554245871537)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(9860733100214508236)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3348472124424871535)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(9860733100214508236)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3348472949876871537)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(9860733100214508236)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3348473679834871547)
,p_name=>'P360_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(9860731784394508223)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3348474395392871549)
,p_name=>'P360_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(9860731784394508223)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3348474768226871550)
,p_name=>'P360_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(9860731784394508223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3398688431885765510)
,p_name=>'P360_TABLE_PREFIX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(9860731784394508223)
,p_prompt=>'Table Prefixes'
,p_placeholder=>'HR_, OE_'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3348477337785871572)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3348472949876871537)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3348477811897871574)
,p_event_id=>wwv_flow_imp.id(3348477337785871572)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348476532811871570)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P360_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'',
'if l_name is not null then',
'    WWV_FLOW_COLLECTION.UPDATE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P360_ID,',
'        p_c001            => l_name,',
'        p_c002            => ''DESCRIPTION'',',
'        p_c003            => :P360_NAME ,',
'        p_c004            => :P360_DESCRIPTION,',
'        p_c005            => :P360_TABLE_PREFIX,',
'        p_d001            => sysdate',
'        );',
'        ',
'else',
'    WWV_FLOW_COLLECTION.ADD_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_c001            => l_name,',
'        p_c002            => ''DESCRIPTION'',',
'        p_c003            => :P360_NAME ,',
'        p_c004            => :P360_DESCRIPTION,',
'        p_c005            => :P360_TABLE_PREFIX,',
'        p_d001            => sysdate',
'        );',
'        ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348476532811871570
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348476925784871570)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348476925784871570
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348476235977871569)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P360_ID) loop',
'   :P360_NAME         := C1.C003; ',
'   :P360_DESCRIPTION  := C1.C004;',
'   :P360_TABLE_PREFIX := c1.c005;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348476235977871569
);
end;
/
prompt --application/pages/page_00370
begin
wwv_flow_imp_page.create_page(
 p_id=>370
,p_name=>'Metric Attribute'
,p_alias=>'METRIC-ATTRIBUTE'
,p_page_mode=>'MODAL'
,p_step_title=>'Metric Attribute'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.textarea {',
'    width: 100%;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19986845055119921212)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19986846370939921225)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413437829392225465)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(19986846370939921225)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:METRIC_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3390655510072107123)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(19986846370939921225)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P370_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413438184903226621)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(19986846370939921225)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P370_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3390656395943107125)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(19986846370939921225)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P370_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3390655951355107124)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(19986846370939921225)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413437554209224194)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(19986846370939921225)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_condition=>'P370_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302186616857908733)
,p_name=>'P370_MAX_ROWS'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Maximum Rows'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302186769395908734)
,p_name=>'P370_QUERY'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_prompt=>'Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3390657024350107137)
,p_name=>'P370_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3390657483773107143)
,p_name=>'P370_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_item_default=>'VARCHAR'
,p_prompt=>'Type'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3390657834687107144)
,p_name=>'P370_VISUAL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Suggested Visualization'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3390658259292107144)
,p_name=>'P370_TABLE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3390658672796107144)
,p_name=>'P370_LABEL_COLUMN'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3390659000295107145)
,p_name=>'P370_FUNCTION'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Function'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3390659475333107145)
,p_name=>'P370_VALUE_COLUMN'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3390659860641107145)
,p_name=>'P370_DESCRIPTION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3390660238480107146)
,p_name=>'P370_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(19986845055119921212)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3390661800831107158)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3390655951355107124)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3390662387399107162)
,p_event_id=>wwv_flow_imp.id(3390661800831107158)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3390661080178107156)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P370_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'if :P370_ID is not null then',
'    WWV_FLOW_COLLECTION.UPDATE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P370_ID,',
'        p_c001            => l_name,',
'        p_c002            => ''METRIC'',',
'        p_c003            => :P370_NAME ,',
'        p_c004            => :P370_TYPE,',
'        p_c005            => :P370_VISUAL,',
'        p_c006            => :P370_TABLE,',
'        p_c007            => :P370_LABEL_COLUMN,',
'        p_c008            => :P370_FUNCTION,',
'        p_c009            => :P370_VALUE_COLUMN,',
'        p_c010            => :P370_max_rows,',
'        p_c011            => :P370_query,',
'        p_c012            => :P370_DESCRIPTION,',
'        p_d001            => sysdate',
'        );',
'        ',
'else',
'',
'    WWV_FLOW_COLLECTION.ADD_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_c001            => l_name,',
'        p_c002            => ''METRIC'',',
'        p_c003            => :P370_NAME ,',
'        p_c004            => :P370_TYPE,',
'        p_c005            => :P370_VISUAL,',
'        p_c006            => :P370_TABLE,',
'        p_c007            => :P370_LABEL_COLUMN,',
'        p_c008            => :P370_FUNCTION,',
'        p_c009            => :P370_VALUE_COLUMN,',
'        p_c010            => :P370_max_rows,',
'        p_c011            => :P370_query,',
'        p_c012            => :P370_DESCRIPTION,',
'        p_d001            => sysdate',
'        );',
'        ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3390661080178107156
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3390661441567107156)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3390661441567107156
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3390660616365107155)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P370_ID) loop',
'   :P370_NAME                := C1.C003; ',
'   :P370_TYPE                := C1.C004;',
'   :P370_VISUAL              := c1.C005;',
'   :P370_TABLE               := c1.C006;',
'   :P370_LABEL_COLUMN        := c1.C007;',
'   :P370_FUNCTION            := c1.C008;',
'   :P370_VALUE_COLUMN        := c1.C009;',
'   :P370_max_rows            := c1.C010;',
'   :P370_query               := c1.C011;',
'   :P370_DESCRIPTION         := c1.C012;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3390660616365107155
);
end;
/
prompt --application/pages/page_00430
begin
wwv_flow_imp_page.create_page(
 p_id=>430
,p_name=>'Table Attributes'
,p_alias=>'TABLE-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Table Attributes'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.textarea {',
'    width: 100%;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16596190157842814110)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16596191473662814123)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413432138761184593)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(16596191473662814123)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:TABLE_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3386976797955362578)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(16596191473662814123)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P430_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413430002096162654)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(16596191473662814123)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P430_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3413429752498161137)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(16596191473662814123)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P430_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3386977162047362581)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(16596191473662814123)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3399173202354615854)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(16596191473662814123)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302186049381908727)
,p_name=>'P430_PRIMARY_DISP_COL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(16596190157842814110)
,p_prompt=>'Primary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P430_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P430_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302186179851908728)
,p_name=>'P430_SECONDARY_DISP_COL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(16596190157842814110)
,p_prompt=>'Secondary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P430_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P430_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302186202907908729)
,p_name=>'P430_PRIMARY_KEY_COL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(16596190157842814110)
,p_prompt=>'Primary Key Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P430_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P430_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302186390183908730)
,p_name=>'P430_PRIMARY_PARENT_TAB'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(16596190157842814110)
,p_prompt=>'Primary Parent Table'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3386978206250362593)
,p_name=>'P430_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(16596190157842814110)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3386978692839362596)
,p_name=>'P430_LABEL_SINGULAR'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(16596190157842814110)
,p_prompt=>'Label, Singular'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3386979044174362597)
,p_name=>'P430_LABEL_PLURAL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(16596190157842814110)
,p_prompt=>'Label, Plural'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3386979477235362598)
,p_name=>'P430_DESCRIPTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(16596190157842814110)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3386979869914362599)
,p_name=>'P430_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(16596190157842814110)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3019481184533899636)
,p_validation_name=>'Check for Duplicate table names'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_error_msg varchar2(255) := wwv_flow_lang.custom_runtime_message(''CA.ATTR.DEFAULT.DUPLICATE'',''table'');',
'begin',
'  for c1 in (select c001',
'             from wwv_flow_collections ',
'             where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' ',
'             and   c002 = ''TABLE''',
'             and   c003 = :P430_TABLE',
'             and   seq_id <> nvl(:P430_ID,0)',
'            ) loop',
'     return l_error_msg; ',
'  end loop;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3386981448432362612)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3386977162047362581)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3386981912464362614)
,p_event_id=>wwv_flow_imp.id(3386981448432362612)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3386980650627362609)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P430_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'if :REQUEST = ''DELETE'' then',
'    WWV_FLOW_COLLECTION.DELETE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P320_ID);',
'else',
'    if :P430_ID is not null then',
'        WWV_FLOW_COLLECTION.UPDATE_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_seq             => :P430_ID,',
'            p_c001            => l_name,',
'            p_c002            => ''TABLE'',',
'            p_c003            => :P430_TABLE ,',
'            p_c004            => :P430_LABEL_SINGULAR,',
'            p_c005            => :P430_LABEL_PLURAL,',
'            p_c006            => :P430_PRIMARY_DISP_COL,',
'            p_c007            => :P430_SECONDARY_DISP_COL,',
'            p_c008            => :P430_PRIMARY_KEY_COL,',
'            p_c009            => :P430_PRIMARY_PARENT_TAB,',
'            p_c011            => :P430_DESCRIPTION,',
'            p_d001            => sysdate',
'            );',
'            ',
'    else',
'    ',
'        WWV_FLOW_COLLECTION.ADD_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_c001            => l_name,',
'            p_c002            => ''TABLE'',',
'            p_c003            => :P430_TABLE ,',
'            p_c004            => :P430_LABEL_SINGULAR,',
'            p_c005            => :P430_LABEL_PLURAL,',
'            p_c006            => :P430_PRIMARY_DISP_COL,',
'            p_c007            => :P430_SECONDARY_DISP_COL,',
'            p_c008            => :P430_PRIMARY_KEY_COL,',
'            p_c009            => :P430_PRIMARY_PARENT_TAB,',
'            p_c011            => :P430_DESCRIPTION,',
'            p_d001            => sysdate',
'            );',
'    end if;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3386980650627362609
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3386981046942362610)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3386981046942362610
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3386980239265362609)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P430_ID) loop',
'   :P430_TABLE               := C1.C003; ',
'   :P430_LABEL_SINGULAR      := C1.C004;',
'   :P430_LABEL_PLURAL        := c1.C005;',
'   :P430_PRIMARY_DISP_COL    := c1.C006;',
'   :P430_SECONDARY_DISP_COL  := c1.C007;',
'   :P430_PRIMARY_KEY_COL     := c1.C008;',
'   :P430_PRIMARY_PARENT_TAB  := c1.C009;',
'   :P430_DESCRIPTION         := c1.C011;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3386980239265362609
);
end;
/
prompt --application/pages/page_00900
begin
wwv_flow_imp_page.create_page(
 p_id=>900
,p_name=>'Help'
,p_alias=>'HELP'
,p_page_mode=>'MODAL'
,p_step_title=>'Help'
,p_autocomplete_on_off=>'OFF'
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true'
,p_dialog_chained=>'N'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(784428987692840031)
,p_plug_name=>'Intro Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.INTRO.TITLE'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.INTRO.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.INTRO.HOWTO.TITLE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.INTRO.HOWTO.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.INTRO.RELEASE.TITLE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.INTRO.RELEASE.DETAIL'',:RELEASE_DATE));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.INTRO.KNOWN.ISSUES.TITLE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.INTRO.KNOWN.ISSUES.DETAIL''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'INTRO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2588925584975150549)
,p_plug_name=>'Settings Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.SETTINGS'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.SETTINGS.DESC'')||''</p>'');',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.APPLICATION.ID'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.APPLICATION.ID.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.SCHEMA'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.SCHEMA.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.LANGUAGE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.LANGUAGE.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.AUTHENTICATION'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.AUTHENTICATION.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.SETTINGS'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.ADVANCED.SETTINGS.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.UI.DEFAULTS'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.UI.DEFAULTS.DETAIL''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'SETTINGS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2588925676389150550)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2595754206267422202)
,p_plug_name=>'Appearance Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.APPEARANCE'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.APPEARANCE.DESC'')||''</p>'');',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.THEME.STYLE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.THEME.STYLE.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.NAVIGATION'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.NAVIGATION.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.APPLICATION.ICON'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.APPLICATION.ICON.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.CUSTOM.THEME'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.CUSTOM.THEME.DETAIL''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'UI'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2595754351455422203)
,p_plug_name=>'Features Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.FEATURES'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.FEATURES.DESC'')||''</p>'');',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.PWA'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.PWA.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.PUSH_NOTIFICATIONS'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.PUSH_NOTIFICATIONS.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ABOUT.PAGE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ABOUT.PAGE.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ACCESS.CONTROL'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.ACCESS.CONTROL.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ACTIVITY.REPORTING'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ACTIVITY.REPORTING.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.CONFIGURATION.SETTINGS'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CONFIGURATION.SETTINGS.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.FEEDBACK'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.FEEDBACK.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.THEME.SELECTOR'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.THEME.SELECTOR.DETAIL''));',
'',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'FEATURES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2595755838165422218)
,p_plug_name=>'Pages Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.PAGES'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.PAGES.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ADDING.PAGES'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADDING.PAGES.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ORGANIZING.PAGES'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ORGANIZING.PAGES.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.REMOVING.PAGES'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.REMOVING.PAGES.DETAIL''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'PAGES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2698018669168126321)
,p_plug_name=>'Page Level Help'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57830928122033942)
,p_plug_name=>'Multiple Reports Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>130
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.MULTIPLE.REPORTS'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.MULTIPLE.REPORTS.DETAILS''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'MULTIPLE_REPORTS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2698017996079126314)
,p_plug_name=>'Blank Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.BLANK'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.BLANK.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'BLANK_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2698018731554126322)
,p_plug_name=>'Chart Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.CHART'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CHART.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CHART.EXAMPLES''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'CHART_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2698018814955126323)
,p_plug_name=>'Report Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>100
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.REPORT'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.REPORT.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.DRILL.DOWN.LINK''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'REPORT_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2698019051695126325)
,p_plug_name=>'Interactive Grid Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.GRID'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.GRID.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'IG_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2698019116640126326)
,p_plug_name=>'Calendar Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.CALENDAR'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CALENDAR.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'CALENDAR_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2698019235455126327)
,p_plug_name=>'Dashboard Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DASHBOARD'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.DASHBOARD.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'DASHBOARD_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2707858861836463439)
,p_plug_name=>'Form Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.FORM'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.FORM.DETAILS''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'FORM_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3019481736029899642)
,p_plug_name=>'Card Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.CARD'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CARD.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.DRILL.DOWN.LINK''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'CARD_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3019481836722899643)
,p_plug_name=>'Timeline Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.TIMELINE'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.TIMELINE.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.DRILL.DOWN.LINK''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'TIMELINE_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3019481930301899644)
,p_plug_name=>'Master Detail Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.MASTER'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.MASTER.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.PAGE_HELP''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'MASTER_DETAIL_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3613185396099513507)
,p_plug_name=>'Wizard Page Help'
,p_parent_plug_id=>wwv_flow_imp.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>120
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.WIZARD'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.WIZARD.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'WIZARD_PAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2796575515210751039)
,p_plug_name=>'Blueprint Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.BLUEPRINT'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.BLUEPRINT.DETAIL''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'BLUEPRINT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3019480338579899628)
,p_plug_name=>'Languages Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.LANGUAGE'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.LANGUAGE.DETAIL''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.LANGUAGE.PAGE''));',
'',
'',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3034953264948022701)
,p_plug_name=>'Advanced Settings Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.SETTINGS'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.SETTINGS.DETAIL'')||''</p>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.SETTINGS.PAGE'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'ADVANCED'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3035688619153083805)
,p_plug_name=>'Supporting Objects Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.SUPPORTING.OBJECTS'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.SUPPORTING.OBJECTS.DETAIL''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.SUPPORTING.OBJECTS.PAGE''));',
'',
'',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3613185016564513504)
,p_plug_name=>'Application Defaults Level'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3034953327661022702)
,p_plug_name=>'Application Defaults Help'
,p_parent_plug_id=>wwv_flow_imp.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'DEFAULTS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3348513411644390602)
,p_plug_name=>'Table Column Attribute Help'
,p_parent_plug_id=>wwv_flow_imp.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.TABLE.COLUMN'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.TABLE.COLUMN.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'TABLE_COLUMN_ATTRIBUTE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3348513524697390603)
,p_plug_name=>'LOV Attribute Help'
,p_parent_plug_id=>wwv_flow_imp.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.LOV'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.LOV.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'LOV_ATTRIBUTE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3613185101621513505)
,p_plug_name=>'Table Attribute Help'
,p_parent_plug_id=>wwv_flow_imp.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.TABLE'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.TABLE.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'TABLE_ATTRIBUTE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3613185249191513506)
,p_plug_name=>'Report Attribute Help'
,p_parent_plug_id=>wwv_flow_imp.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.REPORT'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.REPORT.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'REPORT_ATTRIBUTE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2595754126973422201)
,p_name=>'P900_HELP_SECTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2588925676389150550)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_01000
begin
wwv_flow_imp_page.create_page(
 p_id=>1000
,p_name=>'Create Page Wizard'
,p_alias=>'CREATE-PAGE-WIZARD'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-WizardSteps-step.is-active .a-WizardSteps-label {',
'    display: block;',
'}',
'.a-WizardSteps-step .a-WizardSteps-label {',
'    display: none;',
'}',
'.a-PageWizard-dialog--startWizard .a-Dialog-body {display: block;}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--startWizard a-PageWizard-dialog--centeredContent'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'640'
,p_dialog_width=>'800'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(597621241273219128)
,p_plug_name=>'Additional Pages'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5521047782961084873)
,p_plug_name=>'Wizard Form'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3286693190338347807)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2578235721023427523)
,p_branch_name=>'Create Blank Page'
,p_branch_action=>'f?p=&APP_ID.:1010:&SESSION.::&DEBUG.:RP,1010::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2698020755463126342)
,p_branch_name=>'Create Faceted Search Page'
,p_branch_action=>'f?p=&APP_ID.:1140:&SESSION.::&DEBUG.:RP,1140::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'FACETED_SEARCH'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2588921964261150513)
,p_branch_name=>'Create Interactive Report Page'
,p_branch_action=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.:RP,1020:P1020_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'REPORT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(597621458148219130)
,p_branch_name=>'Create Classic Report Page'
,p_branch_action=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.:RP,1020:P1020_PAGE_TYPE,P1020_REPORT_TYPE:REPORT,CLASSIC_RPT&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_branch_condition_text=>'CLASSIC_REPORT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2594841882553086007)
,p_branch_name=>'Create Interactive Grid Page'
,p_branch_action=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:RP,1030:P1030_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'INTERACTIVE_GRID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2594841993570086008)
,p_branch_name=>'Create Master Detail Page'
,p_branch_action=>'f?p=&APP_ID.:1040:&SESSION.::&DEBUG.:RP,1040:P1040_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'MASTER_DETAIL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3314909449082435901)
,p_branch_name=>'Create Form Page'
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:RP,1100:P1100_PAGE_TYPE,P1100_FORM_TYPE:&P1000_PAGE_TYPE.,FORM_ON_PAGE&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'FORM'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3314909517129435902)
,p_branch_name=>'Create Cards Page'
,p_branch_action=>'f?p=&APP_ID.:1090:&SESSION.::&DEBUG.:RP,1090:P1090_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'CARDS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2594842391030086012)
,p_branch_name=>'Create Chart Page'
,p_branch_action=>'f?p=&APP_ID.:1050:&SESSION.::&DEBUG.:RP,1050:P1050_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'CHART'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2595755545557422215)
,p_branch_name=>'Create Dashboard Page'
,p_branch_action=>'f?p=&APP_ID.:1060:&SESSION.::&DEBUG.:RP,1060:P1060_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'DASHBOARD'
,p_required_patch=>wwv_flow_imp.id(2746942411136297678)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2593478104225715614)
,p_branch_name=>'Create Calendar Page'
,p_branch_action=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.:RP,1070:P1070_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'CALENDAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3800179275245101)
,p_branch_name=>'Create Map Page'
,p_branch_action=>'f?p=&APP_ID.:1150:&SESSION.::&DEBUG.:RP,1150:P1150_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>120
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'MAP'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3315107867862942902)
,p_branch_name=>'Create Wizard Page'
,p_branch_action=>'f?p=&APP_ID.:1120:&SESSION.::&DEBUG.:RP,1120:P1120_PAGE_TYPE:&P1000_ADDITIONAL_PAGE_TYPES.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>130
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_branch_condition_text=>'WIZARD'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3315107717051942901)
,p_branch_name=>'Create Timeline Page'
,p_branch_action=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.:RP,1110:P1110_PAGE_TYPE:&P1000_ADDITIONAL_PAGE_TYPES.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_branch_condition_text=>'TIMELINE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4212071896991544845)
,p_branch_name=>'Create Multiple Report Pages'
,p_branch_action=>'f?p=&APP_ID.:1130:&SESSION.::&DEBUG.:RP,1130::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>150
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_branch_condition_text=>'MULTI_RPT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4841891610495601)
,p_branch_name=>'Create Smart Filters Page'
,p_branch_action=>'f?p=&APP_ID.:1160:&SESSION.::&DEBUG.:1160::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>160
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'SMART_FILTERS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(597621334457219129)
,p_name=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(597621241273219128)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Additional Page Types'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P1000_MORE_PAGE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(599910129386444402)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--LargeIcons a-IconList--PageWizard a-IconList--AddPage'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2577830533539778509)
,p_name=>'P1000_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5521047782961084873)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P1000_PAGE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2595619325504357130)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--LargeIcons a-IconList--PageWizard a-IconList--AddPage'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2647104303557258103)
,p_name=>'Set Theme'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2647104482047258104)
,p_event_id=>wwv_flow_imp.id(2647104303557258103)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery( ''.a-IconList--wizard'' ).addClass( apex.util.getTopApex().jQuery( ''#P1_THEME_STYLE_CLASS'' ).val() );'
);
end;
/
prompt --application/pages/page_01010
begin
wwv_flow_imp_page.create_page(
 p_id=>1010
,p_name=>'Create Blank Page'
,p_alias=>'CREATE-BLANK-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Blank Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_PAGE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2714282414911099412)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8109678764558259639)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8109679340901259645)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2595756247498422222)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8109678764558259639)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1010_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1010_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2595754753405422207)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8109679340901259645)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7261709060772831)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8109679340901259645)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2595756425669422224)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8109679340901259645)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:BLANK_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2578237017465427536)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8109679340901259645)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2588632343330174811)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(8109679340901259645)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2588632773127174813)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(8109679340901259645)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2588633535842174842)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2588632773127174813)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2578235418160427520)
,p_name=>'P1010_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8109678764558259639)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2578236174264427527)
,p_name=>'P1010_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2714282414911099412)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1010_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1010_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2578236647392427532)
,p_name=>'P1010_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8109678764558259639)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2595756375058422223)
,p_name=>'P1010_PAGE_ICON'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8109678764558259639)
,p_item_default=>'fa-file-o'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940045201067003221)
,p_name=>'P1010_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2714282414911099412)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165198319373852601)
,p_name=>'P1010_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2714282414911099412)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2578238416659427550)
,p_name=>'Focus on Page Load'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2588920766832150501)
,p_event_id=>wwv_flow_imp.id(2578238416659427550)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2647104509836258105)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2595754753405422207)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2647104607860258106)
,p_event_id=>wwv_flow_imp.id(2647104509836258105)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(784429169065840033)
,p_name=>'Disable Admin'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1010_HOMEPAGE'
,p_condition_element=>'P1010_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784429296653840034)
,p_event_id=>wwv_flow_imp.id(784429169065840033)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784429321110840035)
,p_event_id=>wwv_flow_imp.id(784429169065840033)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(784430362487840045)
,p_name=>'Disable Home Page'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1010_ADMIN'
,p_condition_element=>'P1010_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784430410144840046)
,p_event_id=>wwv_flow_imp.id(784430362487840045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784430522821840047)
,p_event_id=>wwv_flow_imp.id(784430362487840045)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_HOMEPAGE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7261168887772825)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page(',
'    p_page_name        => :P1010_PAGE_NAME,',
'    p_page_type        => wwv_flow_define_app_v3.c_page_blank,',
'    p_page_icon        => :P1010_PAGE_ICON,',
'    p_is_homepage      => ( :P1010_HOMEPAGE = ''Y'' ),',
'    p_is_admin_page    => ( :P1010_ADMIN = ''Y''),',
'    p_page_help        => :P1010_PAGE_HELP);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2588632343330174811)
,p_internal_uid=>7261168887772825
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2578237153283427537)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.edit_page(',
'    p_page_id          => :P1010_SEQ_ID,',
'    p_page_name        => :P1010_PAGE_NAME,',
'    p_page_type        => wwv_flow_define_app_v3.c_page_blank,',
'    p_page_icon        => :P1010_PAGE_ICON,',
'    p_is_homepage      => ( :P1010_HOMEPAGE = ''Y'' ),',
'    p_is_admin_page    => ( :P1010_ADMIN = ''Y'' ),',
'    p_page_help        => :P1010_PAGE_HELP);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2578237017465427536)
,p_internal_uid=>2578237153283427537
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7261877275772832)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1010_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7261709060772831)
,p_internal_uid=>7261877275772832
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2588921336190150507)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2588921336190150507
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2650783314597687601)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Page Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c040 help',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1010_SEQ_ID )',
'loop',
'    :P1010_PAGE_NAME := l_page.page_name;',
'    :P1010_PAGE_ICON := l_page.page_icon;',
'    :P1010_ADMIN     := l_page.is_admin_page;',
'    :P1010_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1010_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2650783314597687601
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2816364515854843902)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Home Page Defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1010_PAGE_NAME := ''Home'';',
':P1010_PAGE_ICON := ''fa-home'';'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1010_SEQ_ID ) ',
'   and :P1010_PAGE_NAME is null ',
'then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2816364515854843902
);
end;
/
prompt --application/pages/page_01020
begin
wwv_flow_imp_page.create_page(
 p_id=>1020
,p_name=>'Create Report Page'
,p_alias=>'CREATE-REPORT-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Report Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2588922374251150517)
,p_plug_name=>'SQL Form Container'
,p_region_name=>'page_source_sql'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 12px 16px 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2588922563259150519)
,p_plug_name=>'Table or View'
,p_region_name=>'page_source_table'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2588925184942150545)
,p_plug_name=>'Table Container'
,p_parent_plug_id=>wwv_flow_imp.id(2588922563259150519)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2588925205406150546)
,p_plug_name=>'Include Form'
,p_parent_plug_id=>wwv_flow_imp.id(2588922563259150519)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2588922930744150523)
,p_plug_name=>'Page Source Container'
,p_region_css_classes=>'a-BoxedLabels'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3096986813591966835)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3210720104674760401)
,p_plug_name=>'Drill Down Link'
,p_region_name=>'drill_down_link_region'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion a-BoxedForms'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE'' and',
'    c002 in ( ''INTERACTIVE_RPT'',  ''MASTER_DETAIL'' )'))
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10702437105165739245)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10702437681508739251)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2671764041415861323)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(10702437105165739245)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1020_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1020_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698016791258126302)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10702437681508739251)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7261489151772828)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(10702437681508739251)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698315076305799695)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(10702437681508739251)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:REPORT_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2592760790910479646)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(10702437681508739251)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2592761156064479648)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(10702437681508739251)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2592761502988479649)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(10702437681508739251)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7261992641772833)
,p_name=>'P1020_REPORT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2588922930744150523)
,p_item_default=>'INTERACTIVE_RPT'
,p_prompt=>'Report Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REPORT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2595616854306352005)||'.'
,p_tag_css_classes=>'apex-button-group report-type'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'page-source-field'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7262007597772834)
,p_name=>'P1020_INCLUDE_FORM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2588925205406150546)
,p_prompt=>'Include Form'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'disabled'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2588922023118150514)
,p_name=>'P1020_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(10702437105165739245)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2588922105431150515)
,p_name=>'P1020_PAGE_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2588922930744150523)
,p_item_default=>'TABLE'
,p_prompt=>'Page Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(2593539478572840546)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'page-source-field'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2588922280227150516)
,p_name=>'P1020_SQL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2588922374251150517)
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>14
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2588922436215150518)
,p_name=>'P1020_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2588925184942150545)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--marginTop field--noBottomPadding field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_item_comment=>'field--marginTop field--noBottomPadding'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592759016419479632)
,p_name=>'P1020_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3096986813591966835)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1020_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1020_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592759685908479645)
,p_name=>'P1020_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(10702437105165739245)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2592760051591479645)
,p_name=>'P1020_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(10702437105165739245)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2671764303864862891)
,p_name=>'P1020_PAGE_ICON'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(10702437105165739245)
,p_item_default=>'fa-table'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714284610729099434)
,p_name=>'P1020_OBJ_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(10702437105165739245)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940045540690003224)
,p_name=>'P1020_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3096986813591966835)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3145293105679922083)
,p_name=>'P1020_LINK_COLUMN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3210720104674760401)
,p_prompt=>'Link Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1020_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3145296910442009602)
,p_name=>'P1020_LINK_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3210720104674760401)
,p_prompt=>'Link to Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, n002 r ',
'from wwv_flow_collections ',
'where collection_name = ''APEX$CREATE_APP_PAGE''',
'and (   ( c002 = ''INTERACTIVE_RPT'' )',
'     or ( c002 = ''MASTER_DETAIL'' and c014 =''MD_ON_TABLE_WITH_SELECTOR'' )',
'    )',
'and ( seq_id !=  :P1020_SEQ_ID or :P1020_SEQ_ID is null )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3145297198215009604)
,p_name=>'P1020_LINK_KEY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3210720104674760401)
,p_prompt=>'Link Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1020_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT''))',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3145297249722009605)
,p_name=>'P1020_LINK_TARGET_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3210720104674760401)
,p_prompt=>'Target Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from wwv_flow_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1020_LINK_TO_PAGE',
'                     and c002 = ''INTERACTIVE_RPT''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE''))',
'    union all',
'    -- drill down to master detail',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from wwv_flow_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1020_LINK_TO_PAGE',
'                     and c002 = ''MASTER_DETAIL''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''CHAR'',''NCHAR'',''VARCHAR2'',''NVARCHAR2'',''NUMBER'',''BINARY_FLOAT'',''BINARY_DOUBLE''))',
'    union all ',
'    -- drill down to IR on SQL',
'    select wwv_flow_escape.html(c005) d, c005 r, seq_id n',
'    from wwv_flow_collections ',
'    where collection_name = ''APEX$CREATE_APP_PAGE_COLUMN''',
'    and n002 = :P1020_LINK_TO_PAGE',
'    and c002 = ''INTERACTIVE_RPT''',
'    and c006 in (''VARCHAR2'',''NUMBER'',''DATE'')',
'    and c003 = ''SQL'' ) x',
'order by x.n'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_LINK_TO_PAGE'
,p_ajax_items_to_submit=>'P1020_LINK_TO_PAGE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165198538983852603)
,p_name=>'P1020_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3096986813591966835)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1917402362739338044)
,p_validation_name=>'SQL Not Null'
,p_validation_sequence=>10
,p_validation=>'P1020_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Report SQL must be specified.'
,p_validation_condition=>'P1020_PAGE_SOURCE'
,p_validation_condition2=>'SQL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2588922280227150516)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594841332254086002)
,p_validation_name=>'valid query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P1020_SQL,',
'                            p_application_id       => null,',
'                            p_parse_as_schema      => :P1_SCHEMA );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1020_PAGE_SOURCE = ''SQL'' and :P1020_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594841230551086001)
,p_validation_name=>'P1020_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1020_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>'P1020_PAGE_SOURCE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934951585068675440)
,p_validation_name=>'P1020_LINK_COLUMN not null'
,p_validation_sequence=>100
,p_validation=>'P1020_LINK_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1020_LINK_KEY is not null or',
':P1020_LINK_TO_PAGE is not null or',
':P1020_LINK_TARGET_KEY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3172045030132109006)
,p_validation_name=>'P1020_LINK_KEY not null'
,p_validation_sequence=>110
,p_validation=>'P1020_LINK_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1020_LINK_COLUMN is not null or',
':P1020_LINK_TO_PAGE is not null or',
':P1020_LINK_TARGET_KEY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3172045192137109007)
,p_validation_name=>'P1020_LINK_TO_PAGE not null'
,p_validation_sequence=>120
,p_validation=>'P1020_LINK_TO_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1020_LINK_COLUMN is not null or',
':P1020_LINK_KEY is not null or',
':P1020_LINK_TARGET_KEY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3172045272382109008)
,p_validation_name=>'P1020_LINK_TARGET_KEY not null'
,p_validation_sequence=>130
,p_validation=>'P1020_LINK_TARGET_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1020_LINK_COLUMN is not null or',
':P1020_LINK_KEY is not null or',
':P1020_LINK_TO_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2588922623166150520)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2588922714412150521)
,p_event_id=>wwv_flow_imp.id(2588922623166150520)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var page_source_sql$ = $("#page_source_sql"),',
'    page_source_table$ = $("#page_source_table"),',
'    drill_down_link_region$ = $("#drill_down_link_region"),',
'    rptType = $v(''P1020_REPORT_TYPE''),',
'    pageType = $v(''P1020_PAGE_SOURCE'');',
'',
'if (pageType === ''SQL'') {',
'    page_source_sql$.show();',
'    page_source_table$.hide();',
'    drill_down_link_region$.hide();',
'} else if (pageType === ''TABLE'') {',
'    page_source_sql$.hide();',
'    page_source_table$.show();',
'	if (rptType === ''INTERACTIVE_RPT'') {',
'		drill_down_link_region$.show();',
'	} else {',
'		drill_down_link_region$.hide();',
'	}',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2714284462652099432)
,p_name=>'Check Object Type'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2714284589477099433)
,p_event_id=>wwv_flow_imp.id(2714284462652099432)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select object_type ',
'from sys.dba_objects ',
'where owner = :P1_SCHEMA ',
'      and object_name = :P1020_TABLE',
') loop',
'    :P1020_OBJ_TYPE := c1.object_type;',
'end loop;'))
,p_attribute_02=>'P1020_TABLE'
,p_attribute_03=>'P1020_OBJ_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2698016887785126303)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2698016791258126302)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2698016913389126304)
,p_event_id=>wwv_flow_imp.id(2698016887785126303)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2714285100069099439)
,p_name=>'Enable or Disable Include Form'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_OBJ_TYPE'
,p_condition_element=>'P1020_OBJ_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2714285223777099440)
,p_event_id=>wwv_flow_imp.id(2714285100069099439)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_INCLUDE_FORM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2714285556367099443)
,p_event_id=>wwv_flow_imp.id(2714285100069099439)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_INCLUDE_FORM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2714285429349099442)
,p_event_id=>wwv_flow_imp.id(2714285100069099439)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_INCLUDE_FORM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(784430682090840048)
,p_name=>'Disable Admin'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_HOMEPAGE'
,p_condition_element=>'P1020_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784430732956840049)
,p_event_id=>wwv_flow_imp.id(784430682090840048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784430879070840050)
,p_event_id=>wwv_flow_imp.id(784430682090840048)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019477620145899601)
,p_name=>'Disable Home Page'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_ADMIN'
,p_condition_element=>'P1020_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019477752300899602)
,p_event_id=>wwv_flow_imp.id(3019477620145899601)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019477891506899603)
,p_event_id=>wwv_flow_imp.id(3019477620145899601)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3210720298049760402)
,p_name=>'Show or Hide Drill Down'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_REPORT_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3210720372779760403)
,p_event_id=>wwv_flow_imp.id(3210720298049760402)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var curItem = $v(this.triggeringElement);',
'var curType = $v(''P1020_PAGE_SOURCE'');',
'var drill_down_link_region$ = $("#drill_down_link_region");',
'',
'if (curType === ''TABLE'') {',
'	if (curItem === ''INTERACTIVE_RPT'') {',
'		drill_down_link_region$.show();',
'	} else {',
'		drill_down_link_region$.hide();',
'	}',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3674117008533496408)
,p_name=>'Set data dictionary cache if table chang'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_TABLE'
,p_condition_element=>'P1020_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(193529846293845802)
,p_event_id=>wwv_flow_imp.id(3674117008533496408)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1020_TABLE,',
'        p_cache_fk_references     => true );',
'end;'))
,p_attribute_02=>'P1020_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2592761932386479677)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_define_app_v3.add_page(',
'         p_page_name        => :P1020_PAGE_NAME,',
'         p_page_type        => :P1020_REPORT_TYPE,',
'         p_page_icon        => :P1020_PAGE_ICON,',
'         p_schema           => :P1_SCHEMA,',
'         p_source_type      => :P1020_PAGE_SOURCE,',
'         p_source           => ( case when :P1020_PAGE_SOURCE = ''SQL'' then :P1020_SQL end ),',
'         p_table_name       => ( case when :P1020_PAGE_SOURCE = ''TABLE'' then :P1020_TABLE end ),',
'         p_include_form     => ( case when :P1020_PAGE_SOURCE = ''TABLE'' then :P1020_INCLUDE_FORM = ''Y'' end ),',
'         p_is_homepage      => ( :P1020_HOMEPAGE = ''Y'' ),',
'         p_is_admin_page    => ( :P1020_ADMIN = ''Y''),',
'         --',
'         p_link_column      => :P1020_LINK_COLUMN,',
'         p_link_key         => :P1020_LINK_KEY,',
'         p_link_to_page     => :P1020_LINK_TO_PAGE,',
'         p_link_target_key  => :P1020_LINK_TARGET_KEY,',
'         p_page_help        => :P1020_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2592761156064479648)
,p_internal_uid=>2592761932386479677
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2592762301456479678)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id          => :P1020_SEQ_ID,',
'        p_page_name        => :P1020_PAGE_NAME,',
'        p_page_type        => :P1020_REPORT_TYPE,',
'        p_page_icon        => :P1020_PAGE_ICON,',
'        p_schema           => :P1_SCHEMA,',
'        p_source_type      => :P1020_PAGE_SOURCE,',
'        p_source           => ( case when :P1020_PAGE_SOURCE = ''SQL''   then :P1020_SQL end ),',
'        p_table_name       => ( case when :P1020_PAGE_SOURCE = ''TABLE'' then :P1020_TABLE end ),',
'        p_include_form     => ( case when :P1020_PAGE_SOURCE = ''TABLE'' then :P1020_INCLUDE_FORM = ''Y'' end ),',
'        p_is_homepage      => ( :P1020_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page    => ( :P1020_ADMIN = ''Y''),',
'        --',
'        p_link_column      => :P1020_LINK_COLUMN,',
'        p_link_key         => :P1020_LINK_KEY,',
'        p_link_to_page     => :P1020_LINK_TO_PAGE,',
'        p_link_target_key  => :P1020_LINK_TARGET_KEY,',
'        --',
'        p_page_help        => :P1020_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2592760790910479646)
,p_internal_uid=>2592762301456479678
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7261597284772829)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1020_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7261489151772828)
,p_internal_uid=>7261597284772829
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2592762751551479678)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2592762751551479678
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1917402084172338041)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Page Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cnt  pls_integer := 0;',
'begin',
'    for l_page in (select c001 page_name,',
'                          c002 page_type,',
'                          c003 source_type,',
'                          c005 table_name,',
'                          c013 page_icon,',
'                          C011 ig_is_editable,',
'                          c012 include_form,',
'                          c015 is_admin_page,',
'                          c040 help,',
'                          c041 link_column,',
'                          c042 link_key,',
'                          c043 link_to_page,',
'                          c044 link_target_key,',
'                          clob001 source,',
'                          n002    internal_page_id',
'                   from wwv_flow_collections',
'                   where collection_name = ''APEX$CREATE_APP_PAGE''',
'                   and seq_id = :P1020_SEQ_ID )',
'    loop',
'        :P1020_PAGE_NAME := l_page.page_name;',
'        :P1020_PAGE_TYPE := l_page.page_type;',
'        :P1020_REPORT_TYPE := l_page.page_type;',
'        :P1020_PAGE_ICON := l_page.page_icon;',
'        :P1020_PAGE_SOURCE := l_page.source_type;',
'        if l_page.source_type = ''TABLE'' then',
'            :P1020_TABLE := l_page.table_name;',
'            :P1020_INCLUDE_FORM := l_page.include_form;',
'        else',
'            :P1020_SQL := l_page.source;',
'        end if;',
'        :P1020_ADMIN := l_page.is_admin_page;',
'        -- drill down',
'        :P1020_LINK_COLUMN     := l_page.link_column;',
'        :P1020_LINK_KEY        := l_page.link_key;',
'        :P1020_LINK_TO_PAGE    := l_page.link_to_page;',
'        :P1020_LINK_TARGET_KEY := l_page.link_target_key;',
'        :P1020_PAGE_HELP       := l_page.help;',
'        ',
'        -- set object type (used for Include Form item)',
'        for l_obj in (',
'            select object_type ',
'            from sys.dba_objects ',
'            where owner = :P1_SCHEMA ',
'            and object_name = l_page.table_name )',
'        loop',
'            :P1020_OBJ_TYPE := l_obj.object_type;',
'        end loop;',
'    ',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1020_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>1917402084172338041
);
end;
/
prompt --application/pages/page_01030
begin
wwv_flow_imp_page.create_page(
 p_id=>1030
,p_name=>'Create Interactive Grid Page'
,p_alias=>'CREATE-INTERACTIVE-GRID-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Interactive Grid Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-WizardSteps-step.is-active .a-WizardSteps-label {',
'    display: block;',
'}',
'.a-WizardSteps-step .a-WizardSteps-label {',
'    display: none;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3096986940908966836)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5209282746703118901)
,p_plug_name=>'SQL Form Container'
,p_region_name=>'page_source_sql'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 12px 16px 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5209283303196118907)
,p_plug_name=>'Page Source Container'
,p_region_css_classes=>'a-BoxedLabels'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5209285557394118929)
,p_plug_name=>'Table Container'
,p_region_name=>'page_source_table'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13322797477617707629)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13322798053960707635)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2671789543360157933)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(13322797477617707629)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1030_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1030_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698017027394126305)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(13322798053960707635)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2620363606665968428)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(13322798053960707635)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698315796021803108)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(13322798053960707635)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:IG_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2620363965012968430)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(13322798053960707635)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2620364307266968431)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(13322798053960707635)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2620364759002968431)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(13322798053960707635)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2620376281143968497)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2620364759002968431)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620361070869968411)
,p_name=>'P1030_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3096986940908966836)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1030_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1030_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620361747958968424)
,p_name=>'P1030_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13322797477617707629)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620362127911968425)
,p_name=>'P1030_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(13322797477617707629)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620362596892968425)
,p_name=>'P1030_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13322797477617707629)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620365401635968434)
,p_name=>'P1030_SQL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5209282746703118901)
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>14
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620366463781968436)
,p_name=>'P1030_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5209285557394118929)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620367820576968439)
,p_name=>'P1030_PAGE_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5209283303196118907)
,p_item_default=>'TABLE'
,p_prompt=>'Page Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(2593539478572840546)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'page-source-field'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620368548967968440)
,p_name=>'P1030_IG_EDITABLE_YN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5209283303196118907)
,p_item_default=>'Y'
,p_prompt=>'Data Editing'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:&APP_TEXT$IG_ALLOW_EDITING.;Y,&APP_TEXT$IG_READ_ONLY.;N'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'page-source-field '
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2671789034358154476)
,p_name=>'P1030_PAGE_ICON'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(13322797477617707629)
,p_item_default=>'fa-table-pointer'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940045628659003225)
,p_name=>'P1030_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3096986940908966836)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165198615195852604)
,p_name=>'P1030_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3096986940908966836)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2620369451280968470)
,p_validation_name=>'SQL Not Null'
,p_validation_sequence=>10
,p_validation=>'P1030_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Report SQL must be specified.'
,p_validation_condition=>'P1030_PAGE_SOURCE'
,p_validation_condition2=>'SQL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2620365401635968434)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2620370612340968476)
,p_validation_name=>'valid query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P1030_SQL,',
'                            p_application_id       => null,',
'                            p_parse_as_schema      => :P1_SCHEMA );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1030_PAGE_SOURCE = ''SQL'' and :P1030_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2620370256129968476)
,p_validation_name=>'P1030_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1030_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>'P1030_PAGE_SOURCE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2620374385077968493)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620374812216968493)
,p_event_id=>wwv_flow_imp.id(2620374385077968493)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2620375219790968493)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1030_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620375713529968494)
,p_event_id=>wwv_flow_imp.id(2620375219790968493)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2698017159231126306)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2698017027394126305)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2698017213884126307)
,p_event_id=>wwv_flow_imp.id(2698017159231126306)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019477985806899604)
,p_name=>'Disable Admin'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1030_HOMEPAGE'
,p_condition_element=>'P1030_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019478057964899605)
,p_event_id=>wwv_flow_imp.id(3019477985806899604)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019478137839899606)
,p_event_id=>wwv_flow_imp.id(3019477985806899604)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019478223224899607)
,p_name=>'Disable Home Page'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1030_ADMIN'
,p_condition_element=>'P1030_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019478333617899608)
,p_event_id=>wwv_flow_imp.id(3019478223224899607)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019478491854899609)
,p_event_id=>wwv_flow_imp.id(3019478223224899607)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_HOMEPAGE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2620371727718968477)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id   number;',
'begin',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name        => :P1030_PAGE_NAME,',
'                     p_page_type        => :P1030_PAGE_TYPE,',
'                     p_page_icon        => :P1030_PAGE_ICON,',
'                     p_schema           => :P1_SCHEMA,',
'                     p_source_type      => :P1030_PAGE_SOURCE,',
'                     p_source           => ( case when :P1030_PAGE_SOURCE = ''SQL'' then :P1030_SQL end ),',
'                     p_table_name       => ( case when :P1030_PAGE_SOURCE = ''TABLE'' then :P1030_TABLE end ),',
'                     p_ig_is_editable   => ( :P1030_IG_EDITABLE_YN = ''Y'' ),',
'                     p_is_homepage      => ( :P1030_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page    => ( :P1030_ADMIN = ''Y''),',
'                     p_page_help        => :P1030_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2620364307266968431)
,p_internal_uid=>2620371727718968477
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2620372135306968478)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.edit_page(',
'    p_page_id          => :P1030_SEQ_ID,',
'    p_page_name        => :P1030_PAGE_NAME,',
'    p_page_type        => :P1030_PAGE_TYPE,',
'    p_page_icon        => :P1030_PAGE_ICON,',
'    p_schema           => :P1_SCHEMA,',
'    p_source_type      => :P1030_PAGE_SOURCE,',
'    p_source           => ( case when :P1030_PAGE_SOURCE = ''SQL'' then :P1030_SQL end ),',
'    p_table_name       => ( case when :P1030_PAGE_SOURCE = ''TABLE'' then :P1030_TABLE end ),',
'    p_ig_is_editable   => ( :P1030_IG_EDITABLE_YN = ''Y'' ),',
'    p_is_homepage      => ( :P1030_HOMEPAGE = ''Y'' ),',
'    p_is_admin_page    => ( :P1030_ADMIN = ''Y''),',
'    p_page_help        => :P1030_PAGE_HELP);',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2620363965012968430)
,p_internal_uid=>2620372135306968478
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2620370923417968477)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1030_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2620363606665968428)
,p_internal_uid=>2620370923417968477
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2620372574722968478)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2620372574722968478
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2620371358169968477)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      c003 source_type,',
'                      c005 table_name,',
'                      c011 ig_is_editable,',
'                      c012 include_form,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c040 help,',
'                      clob001 source',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1030_SEQ_ID )',
'loop',
'    :P1030_PAGE_NAME := l_page.page_name;',
'    :P1030_PAGE_TYPE := l_page.page_type;',
'    :P1030_PAGE_ICON := l_page.page_icon;',
'    :P1030_PAGE_SOURCE := l_page.source_type;',
'    if l_page.source_type = ''TABLE'' then',
'        :P1030_TABLE := l_page.table_name;',
'    else',
'        :P1030_SQL := l_page.source;',
'    end if;',
'    :P1030_IG_EDITABLE_YN := l_page.ig_is_editable;',
'    :P1030_ADMIN := l_page.is_admin_page;',
'    :P1030_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1030_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2620371358169968477
);
end;
/
prompt --application/pages/page_01040
begin
wwv_flow_imp_page.create_page(
 p_id=>1040
,p_name=>'Master Detail Page'
,p_alias=>'MASTER-DETAIL-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Master Detail Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.apex-button-group table {',
'    border-spacing: 0;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2940043412213003203)
,p_plug_name=>'Component Type'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-left: 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_grid_column_span=>4
,p_plug_item_display_point=>'BELOW'
,p_required_patch=>wwv_flow_imp.id(366100516974803533)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3096987050948966837)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7848768047077673684)
,p_plug_name=>'Table Container'
,p_region_name=>'page_source_table'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3055104276958555201)
,p_plug_name=>'Switch Container'
,p_parent_plug_id=>wwv_flow_imp.id(7848768047077673684)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3055104370263555202)
,p_plug_name=>'Form Container'
,p_parent_plug_id=>wwv_flow_imp.id(7848768047077673684)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15962279967301262384)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15962280543644262390)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2671801985743376320)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(15962279967301262384)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1040_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1040_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698017645866126311)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(15962280543644262390)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2639485336716554781)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(15962280543644262390)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698316230651804379)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(15962280543644262390)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:MASTER_DETAIL_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2639485718498554783)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(15962280543644262390)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2639486124889554784)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(15962280543644262390)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2639486580151554784)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(15962280543644262390)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2639495883273554816)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2639486580151554784)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2574075162235843409)
,p_name=>'P1040_OPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3055104276958555201)
,p_item_default=>'EDIT_ONLY'
,p_prompt=>'Option'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Edit Only;EDIT_ONLY,Read and Edit;READ_AND_EDIT'
,p_tag_css_classes=>'apex-button-group report-type'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(2588818597804368344)
,p_item_css_classes=>'page-source-field'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_imp.id(2698024371153404344)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2594842701044086016)
,p_name=>'P1040_PAGE_SOURCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(15962279967301262384)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639483117670554773)
,p_name=>'P1040_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3096987050948966837)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1040_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when_type=>'NEVER'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1040_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639483839061554780)
,p_name=>'P1040_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15962279967301262384)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639484261945554780)
,p_name=>'P1040_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15962279967301262384)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639484696211554780)
,p_name=>'P1040_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(15962279967301262384)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639488256403554787)
,p_name=>'P1040_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3055104370263555202)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2671801686921375222)
,p_name=>'P1040_PAGE_ICON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(15962279967301262384)
,p_item_default=>'fa-layout-header-sidebar-left'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2927878671232772201)
,p_name=>'P1040_DETAIL_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3055104370263555202)
,p_prompt=>'Detail Table'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1040_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2927878762313772202)
,p_name=>'P1040_DETAIL_2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3055104370263555202)
,p_prompt=>'Detail Table 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1040_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2927878857943772203)
,p_name=>'P1040_DETAIL_3'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3055104370263555202)
,p_prompt=>'Detail Table 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1040_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2927878904909772204)
,p_name=>'P1040_DETAIL_4'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3055104370263555202)
,p_prompt=>'Detail Table 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1040_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940043313717003202)
,p_name=>'P1040_FORM_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2940043412213003203)
,p_item_default=>'MD_ON_TABLE_WITH_SELECTOR'
,p_prompt=>'Form Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'FORM_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2942439030918347706)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-IconList--stackedItems a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940045864148003227)
,p_name=>'P1040_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3096987050948966837)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940047004127003239)
,p_name=>'P1040_PRIMARY_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3055104370263555202)
,p_prompt=>'Primary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1040_TABLE',
'  and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(366100516974803533)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940047166449003240)
,p_name=>'P1040_SECONDARY_LABEL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3055104370263555202)
,p_prompt=>'Secondary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1040_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(366100516974803533)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165198702245852605)
,p_name=>'P1040_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3096987050948966837)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2639491275696554805)
,p_validation_name=>'P1040_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1040_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3096987439653966841)
,p_validation_name=>'Primary Label cannot be null'
,p_validation_sequence=>60
,p_validation=>'P1040_PRIMARY_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Primary Display Column cannot be null'
,p_validation_condition=>'P1040_FORM_TYPE'
,p_validation_condition2=>'MD_ON_TABLE_WITH_SELECTOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2940047004127003239)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3096987600561966843)
,p_validation_name=>'Secondary Label cannot be null'
,p_validation_sequence=>70
,p_validation=>'P1040_SECONDARY_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Secondary Display Column cannot be null'
,p_validation_condition=>'P1040_FORM_TYPE'
,p_validation_condition2=>'MD_ON_TABLE_WITH_SELECTOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2940047166449003240)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934950514946675430)
,p_validation_name=>'detail table not null'
,p_validation_sequence=>80
,p_validation=>'P1040_DETAIL_1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2639493996827554812)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2639494408792554814)
,p_event_id=>wwv_flow_imp.id(2639493996827554812)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2639494863780554815)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2639495382898554815)
,p_event_id=>wwv_flow_imp.id(2639494863780554815)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2698017785855126312)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2698017645866126311)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2698017852618126313)
,p_event_id=>wwv_flow_imp.id(2698017785855126312)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2934948644852675411)
,p_name=>'Handle MD Type'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_FORM_TYPE'
,p_condition_element=>'P1040_FORM_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'MD_GRID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_required_patch=>wwv_flow_imp.id(366100516974803533)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2934948736100675412)
,p_event_id=>wwv_flow_imp.id(2934948644852675411)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_PRIMARY_LABEL,P1040_SECONDARY_LABEL,P1040_DETAIL_2,P1040_DETAIL_3,P1040_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2934948808362675413)
,p_event_id=>wwv_flow_imp.id(2934948644852675411)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_PRIMARY_LABEL,P1040_SECONDARY_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3454843493582233103)
,p_event_id=>wwv_flow_imp.id(2934948644852675411)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_2,P1040_DETAIL_3,P1040_DETAIL_4'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019478590222899610)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_HOMEPAGE'
,p_condition_element=>'P1040_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019478626438899611)
,p_event_id=>wwv_flow_imp.id(3019478590222899610)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019478790621899612)
,p_event_id=>wwv_flow_imp.id(3019478590222899610)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019478806723899613)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_ADMIN'
,p_condition_element=>'P1040_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019478947984899614)
,p_event_id=>wwv_flow_imp.id(3019478806723899613)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019479049588899615)
,p_event_id=>wwv_flow_imp.id(3019478806723899613)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2996641202568931007)
,p_name=>'Toggle Details 2'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_DETAIL_1'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P1040_DETAIL_1'') !== '''' && $v(''P1040_FORM_TYPE'') !== ''MD_GRID'''
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2996641341760931008)
,p_event_id=>wwv_flow_imp.id(2996641202568931007)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_2'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2996641405213931009)
,p_event_id=>wwv_flow_imp.id(2996641202568931007)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_2'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2996641754503931012)
,p_name=>'Toggle Details 3'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_DETAIL_2'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P1040_DETAIL_2'') !== '''' && $v(''P1040_FORM_TYPE'') !== ''MD_GRID'''
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2996641876475931013)
,p_event_id=>wwv_flow_imp.id(2996641754503931012)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_3'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2996641955014931014)
,p_event_id=>wwv_flow_imp.id(2996641754503931012)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_3'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2996642030588931015)
,p_name=>'Toggle Details 4'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_DETAIL_3'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P1040_DETAIL_3'') !== '''' && $v(''P1040_FORM_TYPE'') !== ''MD_GRID'''
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2996642147835931016)
,p_event_id=>wwv_flow_imp.id(2996642030588931015)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2996642233838931017)
,p_event_id=>wwv_flow_imp.id(2996642030588931015)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(193529976800845803)
,p_name=>'Set data dictionary cache if table chang'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_TABLE'
,p_condition_element=>'P1040_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(193530037006845804)
,p_event_id=>wwv_flow_imp.id(193529976800845803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1040_TABLE,',
'        p_cache_fk_references      => true,',
'        p_cache_child_tables       => true );',
'end;'))
,p_attribute_02=>'P1040_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(632193606778032127)
,p_event_id=>wwv_flow_imp.id(193529976800845803)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_1,P1040_DETAIL_2,P1040_DETAIL_3,P1040_DETAIL_4'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639492727480554810)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id           number;',
'    l_md                wwv_flow_define_app_v3.t_md;',
'    l_detail_table_list wwv_flow_define_app_v3.t_table_list;',
'begin',
'    l_md.primary_label_column := :P1040_PRIMARY_LABEL;',
'    l_md.secondary_label_column := :P1040_SECONDARY_LABEL;',
'    ',
'    l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_1;',
'    if :P1040_DETAIL_2 != :P1040_DETAIL_1 or :P1040_DETAIL_2 != :P1040_DETAIL_3 or :P1040_DETAIL_2 != :P1040_DETAIL_4 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_2;',
'    end if;',
'    if :P1040_DETAIL_3 != :P1040_DETAIL_1 or :P1040_DETAIL_3 != :P1040_DETAIL_2 or :P1040_DETAIL_3 != :P1040_DETAIL_4 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_3;',
'    end if;',
'    if :P1040_DETAIL_4 != :P1040_DETAIL_1 or :P1040_DETAIL_4 != :P1040_DETAIL_2 or :P1040_DETAIL_4 != :P1040_DETAIL_3 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_4;',
'    end if;',
'    ',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name         => :P1040_PAGE_NAME,',
'                     p_page_type         => :P1040_PAGE_TYPE,',
'                     p_page_icon         => :P1040_PAGE_ICON,',
'                     p_schema            => :P1_SCHEMA,',
'                     p_source_type       => :P1040_PAGE_SOURCE,',
'                     p_table_name        => ( case when :P1040_PAGE_SOURCE = ''TABLE'' then :P1040_TABLE end ),',
'                     p_is_homepage       => ( :P1040_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page     => ( :P1040_ADMIN = ''Y''),',
'                     p_form_type         => :P1040_FORM_TYPE,',
'                     p_md                => l_md,',
'                     p_detail_table_list => l_detail_table_list,',
'                     p_page_help         => :P1040_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2639486124889554784)
,p_internal_uid=>2639492727480554810
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639493194754554810)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_detail_table_list wwv_flow_define_app_v3.t_table_list;',
'    l_md                wwv_flow_define_app_v3.t_md;',
'begin',
'    l_md.primary_label_column   := :P1040_PRIMARY_LABEL;',
'    l_md.secondary_label_column := :P1040_SECONDARY_LABEL;',
'    --insert into x (m) values (''l_md.secondary_label_column=''||l_md.secondary_label_column);',
'    ',
'    l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_1;',
'    if :P1040_DETAIL_2 != :P1040_DETAIL_1 or :P1040_DETAIL_2 != :P1040_DETAIL_3 or :P1040_DETAIL_2 != :P1040_DETAIL_4 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_2;',
'    end if;',
'    if :P1040_DETAIL_3 != :P1040_DETAIL_1 or :P1040_DETAIL_3 != :P1040_DETAIL_2 or :P1040_DETAIL_3 != :P1040_DETAIL_4 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_3;',
'    end if;',
'    if :P1040_DETAIL_4 != :P1040_DETAIL_1 or :P1040_DETAIL_4 != :P1040_DETAIL_2 or :P1040_DETAIL_4 != :P1040_DETAIL_3 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_4;',
'    end if;',
'    ',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id           => :P1040_SEQ_ID,',
'        p_page_name         => :P1040_PAGE_NAME,',
'        p_page_type         => :P1040_PAGE_TYPE,',
'        p_page_icon         => :P1040_PAGE_ICON,',
'        p_schema            => :P1_SCHEMA,',
'        p_source_type       => :P1040_PAGE_SOURCE,',
'        p_table_name        => :P1040_TABLE,',
'        p_is_homepage       => ( :P1040_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page     => ( :P1040_ADMIN = ''Y'' ),',
'        p_form_type         => :P1040_FORM_TYPE,',
'        p_md                => l_md,',
'        p_detail_table_list => l_detail_table_list,',
'        p_page_help         => :P1040_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2639485718498554783)
,p_internal_uid=>2639493194754554810
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639491965325554808)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1040_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2639485336716554781)
,p_internal_uid=>2639491965325554808
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639493564646554811)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2639493564646554811
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639492378581554808)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c014 form_type,',
'                      c015 is_admin_page,',
'                      c016 primary_label_col,',
'                      c017 secondary_label_col,',
'                      c025 detail_1,',
'                      c026 detail_2,',
'                      c027 detail_3,',
'                      c028 detail_4,',
'                      c040 help',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1040_SEQ_ID )',
'loop',
'    :P1040_PAGE_NAME := l_page.page_name;',
'    :P1040_PAGE_TYPE := l_page.page_type;',
'    :P1040_PAGE_SOURCE := l_page.source_type;',
'    :P1040_TABLE := l_page.table_name;',
'    :P1040_PAGE_ICON := l_page.page_icon;',
'    :P1040_FORM_TYPE := l_page.form_type;',
'    ',
'    :P1040_PRIMARY_LABEL := l_page.primary_label_col;',
'    :P1040_SECONDARY_LABEL := l_page.secondary_label_col;',
'    ',
'    :P1040_DETAIL_1 := l_page.detail_1;',
'    :P1040_DETAIL_2 := l_page.detail_2;',
'    :P1040_DETAIL_3 := l_page.detail_3;',
'    :P1040_DETAIL_4 := l_page.detail_4;',
'    ',
'    :P1040_ADMIN := l_page.is_admin_page;',
'    :P1040_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1040_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2639492378581554808
);
end;
/
prompt --application/pages/page_01050
begin
wwv_flow_imp_page.create_page(
 p_id=>1050
,p_name=>'Create Chart Page'
,p_alias=>'CREATE-CHART-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Chart Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};'))
,p_javascript_code_onload=>'initWizardModal();'
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2594842049919086009)
,p_plug_name=>'Chart Type'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-left: 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3096987189025966838)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10488286239238324054)
,p_plug_name=>'Chart Items'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-right: 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18601798159461912754)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18601798735804912760)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2671803432393386955)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(18601798159461912754)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1050_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1050_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2593477821069715611)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(18601798735804912760)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2639521574533650398)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(18601798735804912760)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698316596757805321)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(18601798735804912760)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:CHART_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2639521904729650400)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(18601798735804912760)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2639522360799650400)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(18601798735804912760)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2639522706259650400)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(18601798735804912760)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2639528374900650428)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2639522706259650400)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2594842156498086010)
,p_name=>'P1050_CHART_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2594842049919086009)
,p_item_default=>'area'
,p_prompt=>'Chart Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_imp.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2594842456077086013)
,p_name=>'P1050_LABEL_COL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(10488286239238324054)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1050_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1050_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2594842500048086014)
,p_name=>'P1050_VALUE_COL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(10488286239238324054)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1050_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1050_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2594842862730086017)
,p_name=>'P1050_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(18601798159461912754)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2594843297167086021)
,p_name=>'P1050_VALUE_COL_COUNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(10488286239238324054)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1050_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1050_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2595756113911422221)
,p_name=>'P1050_AGGREGATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(10488286239238324054)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_imp.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639518926167650387)
,p_name=>'P1050_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3096987189025966838)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1050_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1050_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639520021600650396)
,p_name=>'P1050_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18601798159461912754)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639520496632650397)
,p_name=>'P1050_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(18601798159461912754)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639520816555650397)
,p_name=>'P1050_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(18601798159461912754)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2639523780856650402)
,p_name=>'P1050_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(10488286239238324054)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2671803192866385840)
,p_name=>'P1050_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(18601798159461912754)
,p_item_default=>'fa-area-chart'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940045451585003223)
,p_name=>'P1050_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3096987189025966838)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165198803153852606)
,p_name=>'P1050_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3096987189025966838)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594842989466086018)
,p_validation_name=>'table not null'
,p_validation_sequence=>10
,p_validation=>'P1050_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594843059697086019)
,p_validation_name=>'value column not null'
,p_validation_sequence=>20
,p_validation=>'P1050_VALUE_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1050_AGGREGATE != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594843115955086020)
,p_validation_name=>'label column not null'
,p_validation_sequence=>30
,p_validation=>'P1050_LABEL_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2639527328628650427)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2639527850148650427)
,p_event_id=>wwv_flow_imp.id(2639527328628650427)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2639526447938650424)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1050_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2639526976903650426)
,p_event_id=>wwv_flow_imp.id(2639526447938650424)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2593477900416715612)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2593477821069715611)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2593478072345715613)
,p_event_id=>wwv_flow_imp.id(2593477900416715612)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2594843352995086022)
,p_name=>'show value column count'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1050_AGGREGATE'
,p_condition_element=>'P1050_AGGREGATE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594843410985086023)
,p_event_id=>wwv_flow_imp.id(2594843352995086022)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_VALUE_COL_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594843552744086024)
,p_event_id=>wwv_flow_imp.id(2594843352995086022)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_VALUE_COL_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594843615287086025)
,p_event_id=>wwv_flow_imp.id(2594843352995086022)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594843746146086026)
,p_event_id=>wwv_flow_imp.id(2594843352995086022)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019479100725899616)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1050_HOMEPAGE'
,p_condition_element=>'P1050_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019479243195899617)
,p_event_id=>wwv_flow_imp.id(3019479100725899616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019479387309899618)
,p_event_id=>wwv_flow_imp.id(3019479100725899616)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019479447877899619)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1050_ADMIN'
,p_condition_element=>'P1050_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019479501463899620)
,p_event_id=>wwv_flow_imp.id(3019479447877899619)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019479683459899621)
,p_event_id=>wwv_flow_imp.id(3019479447877899619)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_HOMEPAGE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639525258409650421)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id    number;',
'    l_chart_list wwv_flow_define_app_v3.t_chart_list;',
'begin',
'    l_chart_list(1).chart_type     := :P1050_CHART_TYPE;',
'    l_chart_list(1).table_name     := :P1050_TABLE;',
'    l_chart_list(1).label_column   := :P1050_LABEL_COL;',
'    l_chart_list(1).value_column   := ( case when :P1050_AGGREGATE = ''COUNT'' then :P1050_VALUE_COL_COUNT else :P1050_VALUE_COL end );',
'    l_chart_list(1).value_function := :P1050_AGGREGATE;',
'',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name   => :P1050_PAGE_NAME,',
'                     p_page_type   => :P1050_PAGE_TYPE,',
'                     p_page_icon   => :P1050_PAGE_ICON,',
'                     p_schema      => :P1_SCHEMA,',
'                     p_source_type => :P1050_PAGE_SOURCE,',
'                     p_table_name  => ( case when :P1050_PAGE_SOURCE = ''TABLE'' then :P1050_TABLE end ),',
'                     p_is_homepage => ( :P1050_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page => ( :P1050_ADMIN = ''Y'' ),',
'                     p_chart_list    => l_chart_list,',
'                     p_page_help     => :P1050_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2639522360799650400)
,p_internal_uid=>2639525258409650421
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639525682626650422)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_chart_list    wwv_flow_define_app_v3.t_chart_list;',
'begin',
'    l_chart_list(1).chart_type     := :P1050_CHART_TYPE;',
'    l_chart_list(1).table_name     := :P1050_TABLE;',
'    l_chart_list(1).label_column   := :P1050_LABEL_COL;',
'    l_chart_list(1).value_column   := ( case when :P1050_AGGREGATE = ''COUNT'' then :P1050_VALUE_COL_COUNT else :P1050_VALUE_COL end );',
'    l_chart_list(1).value_function := :P1050_AGGREGATE;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id      => :P1050_SEQ_ID,',
'        p_page_name    => :P1050_PAGE_NAME,',
'        p_page_type    => :P1050_PAGE_TYPE,',
'        p_page_icon    => :P1050_PAGE_ICON,',
'        p_schema       => :P1_SCHEMA,',
'        p_source_type  => :P1050_PAGE_SOURCE,',
'        p_table_name   => ( case when :P1050_PAGE_SOURCE = ''TABLE'' then :P1050_TABLE end ),',
'        p_is_homepage  => ( :P1050_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page => ( :P1050_ADMIN = ''Y'' ),',
'        p_chart_list    => l_chart_list,',
'        p_page_help     => :P1050_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2639521904729650400)
,p_internal_uid=>2639525682626650422
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639524499585650421)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1050_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2639521574533650398)
,p_internal_uid=>2639524499585650421
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639526017877650422)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2639526017877650422
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2639524836075650421)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c025 chart_type,',
'                      c026 label_column,',
'                      c027 value_column,',
'                      c028 value_function,',
'                      c040 help',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1050_SEQ_ID )',
'loop',
'    :P1050_PAGE_NAME := l_page.page_name;',
'    :P1050_PAGE_TYPE := l_page.page_type;',
'    :P1050_PAGE_SOURCE := l_page.source_type;',
'    :P1050_TABLE := l_page.table_name;',
'    :P1050_PAGE_ICON := l_page.page_icon;    ',
'',
'    :P1050_CHART_TYPE := l_page.chart_type;',
'    :P1050_LABEL_COL := l_page.label_column;',
'    :P1050_AGGREGATE := l_page.value_function;',
'    if l_page.value_function = ''COUNT'' then',
'        :P1050_VALUE_COL_COUNT := l_page.value_column;',
'    else',
'        :P1050_VALUE_COL := l_page.value_column;',
'    end if;',
'    :P1050_ADMIN := l_page.is_admin_page;',
'    :P1060_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1050_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2639524836075650421
);
end;
/
prompt --application/pages/page_01060
begin
wwv_flow_imp_page.create_page(
 p_id=>1060
,p_name=>'Create Dashboard Page'
,p_alias=>'CREATE-DASHBOARD-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Dashboard Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};'))
,p_javascript_code_onload=>'initWizardModal();'
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--dashboard'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2593479581440715628)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2593481794265715650)
,p_plug_name=>'Chart 1'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5308969562394168086)
,p_plug_name=>'Chart Type'
,p_parent_plug_id=>wwv_flow_imp.id(2593481794265715650)
,p_region_css_classes=>'a-PageWizard-dialogDashboardType'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13202411519473405102)
,p_plug_name=>'Chart Items'
,p_parent_plug_id=>wwv_flow_imp.id(2593481794265715650)
,p_region_css_classes=>'a-BoxedForms a-PageWizard-dialogDashboardItems'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2707855318607463404)
,p_plug_name=>'Chart 3'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2707855428793463405)
,p_plug_name=>'Chart Type'
,p_parent_plug_id=>wwv_flow_imp.id(2707855318607463404)
,p_region_css_classes=>'a-PageWizard-dialogDashboardType'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2707855635559463407)
,p_plug_name=>'Chart Items'
,p_parent_plug_id=>wwv_flow_imp.id(2707855318607463404)
,p_region_css_classes=>'a-BoxedForms a-PageWizard-dialogDashboardItems'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2707856130870463412)
,p_plug_name=>'Chart 4'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2707856276658463413)
,p_plug_name=>'Chart Type'
,p_parent_plug_id=>wwv_flow_imp.id(2707856130870463412)
,p_region_css_classes=>'a-PageWizard-dialogDashboardType'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2707856468726463415)
,p_plug_name=>'Chart Items'
,p_parent_plug_id=>wwv_flow_imp.id(2707856130870463412)
,p_region_css_classes=>'a-BoxedForms a-PageWizard-dialogDashboardItems'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2714281532692099403)
,p_plug_name=>'Chart 2'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2714281678979099404)
,p_plug_name=>'Chart Items'
,p_parent_plug_id=>wwv_flow_imp.id(2714281532692099403)
,p_region_css_classes=>'a-BoxedForms a-PageWizard-dialogDashboardItems'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2714282293366099410)
,p_plug_name=>'Chart Type'
,p_parent_plug_id=>wwv_flow_imp.id(2714281532692099403)
,p_region_css_classes=>'a-PageWizard-dialogDashboardType'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3096987286892966839)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>70
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21248689087502320587)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21248689663845320593)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2671804802505402186)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(21248689087502320587)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1060_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1060_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2646894890426407959)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(21248689663845320593)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2646895667231407965)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(21248689663845320593)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698316879439806458)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(21248689663845320593)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:DASHBOARD_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2646895254841407964)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(21248689663845320593)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2646896051751407965)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(21248689663845320593)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2646896431495407966)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(21248689663845320593)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2646904682195408048)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2646896431495407966)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2594844614787086035)
,p_name=>'P1060_CHART_2_VALUE_COUNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2714281678979099404)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_2_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1060_CHART_2_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2594844785140086036)
,p_name=>'P1060_CHART_3_VALUE_COUNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2707855635559463407)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_3_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1060_CHART_3_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2594844838720086037)
,p_name=>'P1060_CHART_4_VALUE_COUNT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2707856468726463415)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_4_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1060_CHART_4_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2646892278266407954)
,p_name=>'P1060_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3096987286892966839)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1060_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1060_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2646892922846407956)
,p_name=>'P1060_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(21248689087502320587)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2646893315172407957)
,p_name=>'P1060_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(21248689087502320587)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2646893793432407957)
,p_name=>'P1060_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(21248689087502320587)
,p_item_default=>'wwv_flow_lang.system_message(p_name => ''CA.ADMIN.DASHBOARD'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2646894115973407958)
,p_name=>'P1060_PAGE_SOURCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(21248689087502320587)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2671804547208400973)
,p_name=>'P1060_PAGE_ICON'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(21248689087502320587)
,p_item_default=>'fa-dashboard'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707855554456463406)
,p_name=>'P1060_CHART_3_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2707855428793463405)
,p_item_default=>'line'
,p_prompt=>'Chart 3 Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_imp.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707855758652463408)
,p_name=>'P1060_CHART_3_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2707855635559463407)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''CA.DASHBOARD.CHART.N'',',
'    p0     => ''3'' )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Chart Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707855807689463409)
,p_name=>'P1060_CHART_3_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2707855635559463407)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sample Data'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707855928039463410)
,p_name=>'P1060_CHART_3_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2707855635559463407)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_3_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_3_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707856007509463411)
,p_name=>'P1060_CHART_3_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2707855635559463407)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_3_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_3_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707856324771463414)
,p_name=>'P1060_CHART_4_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2707856276658463413)
,p_item_default=>'pie'
,p_prompt=>'Chart 4 Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_imp.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707856506168463416)
,p_name=>'P1060_CHART_4_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2707856468726463415)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''CA.DASHBOARD.CHART.N'',',
'    p0     => ''4'' )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Chart Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707856613115463417)
,p_name=>'P1060_CHART_4_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2707856468726463415)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sample Data'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707856781516463418)
,p_name=>'P1060_CHART_4_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2707856468726463415)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_4_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_4_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707856813162463419)
,p_name=>'P1060_CHART_4_VALUE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2707856468726463415)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_4_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_4_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714125537468081057)
,p_name=>'P1060_CHART_1_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(13202411519473405102)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sample Data'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714125948732081059)
,p_name=>'P1060_CHART_1_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13202411519473405102)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_1_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_1_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714126793128081060)
,p_name=>'P1060_CHART_1_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(13202411519473405102)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_1_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_1_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714127897478082077)
,p_name=>'P1060_CHART_1_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5308969562394168086)
,p_item_default=>'area'
,p_prompt=>'Chart 1 Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_imp.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714281305832099401)
,p_name=>'P1060_CHART_1_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13202411519473405102)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''CA.DASHBOARD.CHART.N'',',
'    p0     => ''1'' )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Chart Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714281797967099405)
,p_name=>'P1060_CHART_2_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2714281678979099404)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sample Data'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714281886161099406)
,p_name=>'P1060_CHART_2_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2714281678979099404)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_2_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_2_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714281907095099407)
,p_name=>'P1060_CHART_2_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2714281678979099404)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_2_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_2_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714282119933099409)
,p_name=>'P1060_CHART_2_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2714281678979099404)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''CA.DASHBOARD.CHART.N'',',
'    p0     => ''2'' )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Chart Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2714282307261099411)
,p_name=>'P1060_CHART_2_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2714282293366099410)
,p_item_default=>'bar'
,p_prompt=>'Chart 2 Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_imp.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2928043282080578616)
,p_name=>'P1060_CHART_1_AGG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(13202411519473405102)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_imp.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2928044683501623808)
,p_name=>'P1060_CHART_2_AGG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2714281678979099404)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_imp.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2928044787933623809)
,p_name=>'P1060_CHART_3_AGG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2707855635559463407)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_imp.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2928044896798623810)
,p_name=>'P1060_CHART_4_AGG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2707856468726463415)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_imp.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2934916327383378883)
,p_name=>'P1060_CHART_1_VALUE_COUNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(13202411519473405102)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_1_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1060_CHART_1_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940045399375003222)
,p_name=>'P1060_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3096987286892966839)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165198487374852602)
,p_name=>'P1060_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3096987286892966839)
,p_prompt=>'Page help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2646899146783408028)
,p_validation_name=>'chart 1 value column not null'
,p_validation_sequence=>20
,p_validation=>'P1060_CHART_1_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 1 value column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_1_TABLE is not null and :P1060_CHART_1_AGG != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594844086207086029)
,p_validation_name=>'chart 2 value column not null'
,p_validation_sequence=>30
,p_validation=>'P1060_CHART_2_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 2 value column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_2_TABLE is not null and :P1060_CHART_2_AGG != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594844156498086030)
,p_validation_name=>'chart 3 value column not null'
,p_validation_sequence=>40
,p_validation=>'P1060_CHART_3_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 3 value column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_3_TABLE is not null and :P1060_CHART_3_AGG != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594844205097086031)
,p_validation_name=>'chart 4 value column not null'
,p_validation_sequence=>50
,p_validation=>'P1060_CHART_4_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 4 value column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_4_TABLE is not null and :P1060_CHART_4_AGG != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2646899528210408028)
,p_validation_name=>'chart 1 label column not null'
,p_validation_sequence=>60
,p_validation=>'P1060_CHART_1_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 1 label column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_1_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594844364429086032)
,p_validation_name=>'chart 2 label column not null'
,p_validation_sequence=>70
,p_validation=>'P1060_CHART_2_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 2 label column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_2_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594844482726086033)
,p_validation_name=>'chart 3 label column not null'
,p_validation_sequence=>80
,p_validation=>'P1060_CHART_3_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 3 label column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_3_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594844531124086034)
,p_validation_name=>'chart 4 label column not null'
,p_validation_sequence=>90
,p_validation=>'P1060_CHART_4_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 4 label column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_4_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2646902720515408045)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2646903273441408045)
,p_event_id=>wwv_flow_imp.id(2646902720515408045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2646901833828408039)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2646902357097408042)
,p_event_id=>wwv_flow_imp.id(2646901833828408039)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2646903627217408045)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2646894890426407959)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2646904125113408046)
,p_event_id=>wwv_flow_imp.id(2646903627217408045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2707857450888463425)
,p_name=>'Chart 1 - Show Cols when Table Selected'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_1_TABLE'
,p_condition_element=>'P1060_CHART_1_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2707857571528463426)
,p_event_id=>wwv_flow_imp.id(2707857450888463425)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_LABEL,P1060_CHART_1_VALUE,P1060_CHART_1_AGG'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2707857660707463427)
,p_event_id=>wwv_flow_imp.id(2707857450888463425)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_LABEL,P1060_CHART_1_VALUE,P1060_CHART_1_AGG,P1060_CHART_1_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3096987836300966845)
,p_event_id=>wwv_flow_imp.id(2707857450888463425)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_AGG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'COLVALUE'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2707857777845463428)
,p_name=>'Chart 2 - Show Cols when Table Selected'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_2_TABLE'
,p_condition_element=>'P1060_CHART_2_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2707857840034463429)
,p_event_id=>wwv_flow_imp.id(2707857777845463428)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_LABEL,P1060_CHART_2_VALUE,P1060_CHART_2_AGG'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2707857937380463430)
,p_event_id=>wwv_flow_imp.id(2707857777845463428)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_LABEL,P1060_CHART_2_VALUE,P1060_CHART_2_AGG,P1060_CHART_2_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3096987991633966846)
,p_event_id=>wwv_flow_imp.id(2707857777845463428)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_AGG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'COLVALUE'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2707858041112463431)
,p_name=>'Chart 3 - Show Cols when Table Selected'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_3_TABLE'
,p_condition_element=>'P1060_CHART_3_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2707858119407463432)
,p_event_id=>wwv_flow_imp.id(2707858041112463431)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_LABEL,P1060_CHART_3_VALUE,P1060_CHART_3_AGG'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2707858243354463433)
,p_event_id=>wwv_flow_imp.id(2707858041112463431)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_LABEL,P1060_CHART_3_VALUE,P1060_CHART_3_AGG,P1060_CHART_3_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3096988039282966847)
,p_event_id=>wwv_flow_imp.id(2707858041112463431)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_AGG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'COLVALUE'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2707858393690463434)
,p_name=>'Chart 4 - Show Cols when Table Selected'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_4_TABLE'
,p_condition_element=>'P1060_CHART_4_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2707858468022463435)
,p_event_id=>wwv_flow_imp.id(2707858393690463434)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_LABEL,P1060_CHART_4_VALUE,P1060_CHART_4_AGG'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2707858548483463436)
,p_event_id=>wwv_flow_imp.id(2707858393690463434)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_LABEL,P1060_CHART_4_VALUE,P1060_CHART_4_AGG,P1060_CHART_4_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3096988115205966848)
,p_event_id=>wwv_flow_imp.id(2707858393690463434)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_AGG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'COLVALUE'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2594844973566086038)
,p_name=>'show chart 1 value column count'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_1_AGG'
,p_condition_element=>'P1060_CHART_1_AGG'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594845059368086039)
,p_event_id=>wwv_flow_imp.id(2594844973566086038)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594845103431086040)
,p_event_id=>wwv_flow_imp.id(2594844973566086038)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594845204754086041)
,p_event_id=>wwv_flow_imp.id(2594844973566086038)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594845341410086042)
,p_event_id=>wwv_flow_imp.id(2594844973566086038)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2594845480053086043)
,p_name=>'show chart 2 value column count'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_2_AGG'
,p_condition_element=>'P1060_CHART_2_AGG'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594845508618086044)
,p_event_id=>wwv_flow_imp.id(2594845480053086043)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594845613489086045)
,p_event_id=>wwv_flow_imp.id(2594845480053086043)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594845742004086046)
,p_event_id=>wwv_flow_imp.id(2594845480053086043)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594845884816086047)
,p_event_id=>wwv_flow_imp.id(2594845480053086043)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2594845943262086048)
,p_name=>'show chart 3 value column count'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_3_AGG'
,p_condition_element=>'P1060_CHART_3_AGG'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594846051763086049)
,p_event_id=>wwv_flow_imp.id(2594845943262086048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2594846154164086050)
,p_event_id=>wwv_flow_imp.id(2594845943262086048)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2934947678029675401)
,p_event_id=>wwv_flow_imp.id(2594845943262086048)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2934947752485675402)
,p_event_id=>wwv_flow_imp.id(2594845943262086048)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2934947882288675403)
,p_name=>'show chart 4 value column count'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_4_AGG'
,p_condition_element=>'P1060_CHART_4_AGG'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2934947931675675404)
,p_event_id=>wwv_flow_imp.id(2934947882288675403)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2934948014983675405)
,p_event_id=>wwv_flow_imp.id(2934947882288675403)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2934948169714675406)
,p_event_id=>wwv_flow_imp.id(2934947882288675403)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2934948238765675407)
,p_event_id=>wwv_flow_imp.id(2934947882288675403)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(784429773886840039)
,p_name=>'Disable Admin'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_HOMEPAGE'
,p_condition_element=>'P1060_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784429816739840040)
,p_event_id=>wwv_flow_imp.id(784429773886840039)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784429929217840041)
,p_event_id=>wwv_flow_imp.id(784429773886840039)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(784430053816840042)
,p_name=>'Disable Home Page'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_ADMIN'
,p_condition_element=>'P1060_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784430165989840043)
,p_event_id=>wwv_flow_imp.id(784430053816840042)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784430286239840044)
,p_event_id=>wwv_flow_imp.id(784430053816840042)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_HOMEPAGE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2646900616539408032)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id    number;',
'    l_chart_list wwv_flow_define_app_v3.t_chart_list;',
'begin',
'    l_chart_list(1).chart_name     := :P1060_CHART_1_NAME;',
'    l_chart_list(1).chart_type     := :P1060_CHART_1_TYPE;',
'    l_chart_list(1).table_name     := :P1060_CHART_1_TABLE;',
'    l_chart_list(1).label_column   := :P1060_CHART_1_LABEL;',
'    l_chart_list(1).value_column   := ( case when :P1060_CHART_1_AGG = ''COUNT'' then :P1060_CHART_1_VALUE_COUNT else :P1060_CHART_1_VALUE end );',
'    l_chart_list(1).value_function := :P1060_CHART_1_AGG;',
'',
'    l_chart_list(2).chart_name     := :P1060_CHART_2_NAME;',
'    l_chart_list(2).chart_type     := :P1060_CHART_2_TYPE;',
'    l_chart_list(2).table_name     := :P1060_CHART_2_TABLE;',
'    l_chart_list(2).label_column   := :P1060_CHART_2_LABEL;',
'    l_chart_list(2).value_column   := ( case when :P1060_CHART_2_AGG = ''COUNT'' then :P1060_CHART_2_VALUE_COUNT else :P1060_CHART_2_VALUE end );',
'    l_chart_list(2).value_function := :P1060_CHART_2_AGG;',
'',
'    l_chart_list(3).chart_name     := :P1060_CHART_3_NAME;',
'    l_chart_list(3).chart_type     := :P1060_CHART_3_TYPE;',
'    l_chart_list(3).table_name     := :P1060_CHART_3_TABLE;',
'    l_chart_list(3).label_column   := :P1060_CHART_3_LABEL;',
'    l_chart_list(3).value_column   := ( case when :P1060_CHART_3_AGG = ''COUNT'' then :P1060_CHART_3_VALUE_COUNT else :P1060_CHART_3_VALUE end );',
'    l_chart_list(3).value_function := :P1060_CHART_3_AGG;',
'',
'    l_chart_list(4).chart_name     := :P1060_CHART_4_NAME;',
'    l_chart_list(4).chart_type     := :P1060_CHART_4_TYPE;',
'    l_chart_list(4).table_name     := :P1060_CHART_4_TABLE;',
'    l_chart_list(4).label_column   := :P1060_CHART_4_LABEL;',
'    l_chart_list(4).value_column   := ( case when :P1060_CHART_4_AGG = ''COUNT'' then :P1060_CHART_4_VALUE_COUNT else :P1060_CHART_4_VALUE end );',
'    l_chart_list(4).value_function := :P1060_CHART_4_AGG;',
'',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name        => :P1060_PAGE_NAME,',
'                     p_page_type        => :P1060_PAGE_TYPE,',
'                     p_page_icon        => :P1060_PAGE_ICON,',
'                     p_schema           => :P1_SCHEMA,',
'                     p_is_homepage      => ( :P1060_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page    => ( :P1060_ADMIN = ''Y''),',
'                     p_chart_list       => l_chart_list,',
'                     p_page_help        => :P1060_PAGE_HELP);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2646896051751407965)
,p_internal_uid=>2646900616539408032
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2646901087005408036)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_chart_list wwv_flow_define_app_v3.t_chart_list;',
'begin',
'    l_chart_list(1).chart_name     := :P1060_CHART_1_NAME;',
'    l_chart_list(1).chart_type     := :P1060_CHART_1_TYPE;',
'    l_chart_list(1).table_name     := :P1060_CHART_1_TABLE;',
'    l_chart_list(1).label_column   := :P1060_CHART_1_LABEL;',
'    l_chart_list(1).value_column   := ( case when :P1060_CHART_1_AGG = ''COUNT'' then :P1060_CHART_1_VALUE_COUNT else :P1060_CHART_1_VALUE end );',
'    l_chart_list(1).value_function := :P1060_CHART_1_AGG;',
'',
'    l_chart_list(2).chart_name     := :P1060_CHART_2_NAME;',
'    l_chart_list(2).chart_type     := :P1060_CHART_2_TYPE;',
'    l_chart_list(2).table_name     := :P1060_CHART_2_TABLE;',
'    l_chart_list(2).label_column   := :P1060_CHART_2_LABEL;',
'    l_chart_list(2).value_column   := ( case when :P1060_CHART_2_AGG = ''COUNT'' then :P1060_CHART_2_VALUE_COUNT else :P1060_CHART_2_VALUE end );',
'    l_chart_list(2).value_function := :P1060_CHART_2_AGG;',
'',
'    l_chart_list(3).chart_name     := :P1060_CHART_3_NAME;',
'    l_chart_list(3).chart_type     := :P1060_CHART_3_TYPE;',
'    l_chart_list(3).table_name     := :P1060_CHART_3_TABLE;',
'    l_chart_list(3).label_column   := :P1060_CHART_3_LABEL;',
'    l_chart_list(3).value_column   := ( case when :P1060_CHART_3_AGG = ''COUNT'' then :P1060_CHART_3_VALUE_COUNT else :P1060_CHART_3_VALUE end );',
'    l_chart_list(3).value_function := :P1060_CHART_3_AGG;',
'',
'    l_chart_list(4).chart_name     := :P1060_CHART_4_NAME;',
'    l_chart_list(4).chart_type     := :P1060_CHART_4_TYPE;',
'    l_chart_list(4).table_name     := :P1060_CHART_4_TABLE;',
'    l_chart_list(4).label_column   := :P1060_CHART_4_LABEL;',
'    l_chart_list(4).value_column   := ( case when :P1060_CHART_4_AGG = ''COUNT'' then :P1060_CHART_4_VALUE_COUNT else :P1060_CHART_4_VALUE end );',
'    l_chart_list(4).value_function := :P1060_CHART_4_AGG;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id          => :P1060_SEQ_ID,',
'        p_page_name        => :P1060_PAGE_NAME,',
'        p_page_type        => :P1060_PAGE_TYPE,',
'        p_page_icon        => :P1060_PAGE_ICON,',
'        p_schema           => :P1_SCHEMA,',
'        p_is_homepage      => ( :P1060_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page    => ( :P1060_ADMIN = ''Y'' ),',
'        p_chart_list       => l_chart_list,',
'        p_page_help        => :P1060_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2646895254841407964)
,p_internal_uid=>2646901087005408036
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2646899880434408028)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1060_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2646895667231407965)
,p_internal_uid=>2646899880434408028
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2646901492499408037)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2646901492499408037
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2646900204603408032)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cnt pls_integer := 0;',
'begin',
'    for l_page in (select seq_id id,',
'                          n002 internal_page_id,',
'                          c001 page_name,',
'                          c002 page_type,',
'                          c013 page_icon,',
'                          c015 is_admin_page,',
'                          c040 help',
'                   from wwv_flow_collections',
'                   where collection_name = ''APEX$CREATE_APP_PAGE''',
'                   and seq_id = :P1060_SEQ_ID )',
'    loop',
'        :P1060_PAGE_NAME := l_page.page_name;',
'        :P1060_PAGE_TYPE := l_page.page_type;',
'        :P1060_PAGE_ICON := l_page.page_icon;',
'        :P1060_ADMIN     := l_page.is_admin_page;',
'        :P1060_PAGE_HELP := l_page.help;',
'    ',
'        for l_chart in (select seq_id,',
'                               c001 chart_name,',
'                               c002 chart_type,',
'                               c003 table_name,',
'                               c004 label_col,',
'                               c005 value_col,',
'                               c006 value_function',
'                        from wwv_flow_collections',
'                        where collection_name = ''APEX$CREATE_APP_PAGE_CHART''',
'                        and n001 = l_page.id',
'                        and n002 = l_page.internal_page_id',
'                        order by seq_id  )',
'        loop',
'            l_cnt := l_cnt + 1;',
'            if l_cnt = 1 then',
'                :P1060_CHART_1_NAME  := l_chart.chart_name;',
'                :P1060_CHART_1_TYPE  := l_chart.chart_type;',
'                :P1060_CHART_1_TABLE := l_chart.table_name;',
'                :P1060_CHART_1_LABEL := l_chart.label_col;',
'                if l_chart.value_function = ''COUNT'' then',
'                    :P1060_CHART_1_VALUE_COUNT := l_chart.value_col;',
'                else',
'                    :P1060_CHART_1_VALUE := l_chart.value_col;',
'                end if;',
'                :P1060_CHART_1_AGG   := l_chart.value_function;',
'            end if;',
'        ',
'            if l_cnt = 2 then',
'                :P1060_CHART_2_NAME  := l_chart.chart_name;',
'                :P1060_CHART_2_TYPE  := l_chart.chart_type;',
'                :P1060_CHART_2_TABLE := l_chart.table_name;',
'                :P1060_CHART_2_LABEL := l_chart.label_col;',
'                if l_chart.value_function = ''COUNT'' then',
'                    :P1060_CHART_2_VALUE_COUNT := l_chart.value_col;',
'                else',
'                    :P1060_CHART_2_VALUE := l_chart.value_col;',
'                end if;',
'                :P1060_CHART_2_AGG   := l_chart.value_function;',
'            end if;',
'        ',
'            if l_cnt = 3 then',
'                :P1060_CHART_3_NAME  := l_chart.chart_name;',
'                :P1060_CHART_3_TYPE  := l_chart.chart_type;',
'                :P1060_CHART_3_TABLE := l_chart.table_name;',
'                :P1060_CHART_3_LABEL := l_chart.label_col;',
'                if l_chart.value_function = ''COUNT'' then',
'                    :P1060_CHART_3_VALUE_COUNT := l_chart.value_col;',
'                else',
'                    :P1060_CHART_3_VALUE := l_chart.value_col;',
'                end if;',
'                :P1060_CHART_3_AGG   := l_chart.value_function;',
'            end if;',
'        ',
'            if l_cnt = 4 then',
'                :P1060_CHART_4_NAME  := l_chart.chart_name;',
'                :P1060_CHART_4_TYPE  := l_chart.chart_type;',
'                :P1060_CHART_4_TABLE := l_chart.table_name;',
'                :P1060_CHART_4_LABEL := l_chart.label_col;',
'                if l_chart.value_function = ''COUNT'' then',
'                    :P1060_CHART_4_VALUE_COUNT := l_chart.value_col;',
'                else',
'                    :P1060_CHART_4_VALUE := l_chart.value_col;',
'                end if;',
'                :P1060_CHART_4_AGG   := l_chart.value_function;',
'            end if;',
'        end loop;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1060_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2646900204603408032
);
end;
/
prompt --application/pages/page_01061
begin
wwv_flow_imp_page.create_page(
 p_id=>1061
,p_name=>'Create Dashboard Page'
,p_alias=>'CREATE-DASHBOARD-PAGE1'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Dashboard Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--centeredContent'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>-wwv_flow_imp.id(2746942411136297678)
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13567353174284584354)
,p_plug_name=>'Coming Soon!'
,p_region_css_classes=>'a-Alert--comingSoon'
,p_icon_css_classes=>'fa fa-clock-o'
,p_region_template_options=>'a-Alert--info:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3330277939666606656)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'We''re still working on the finishing touches!'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13567353750627584360)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2750397042704325449)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(13567353750627584360)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1061_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2750401550974325457)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2750397042704325449)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2750397718142325450)
,p_name=>'P1061_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13567353174284584354)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2750398194257325454)
,p_name=>'P1061_PAGE_ICON'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13567353174284584354)
,p_item_default=>'fa-file-o'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2750400539692325456)
,p_name=>'Focus on Page Load'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2750401024165325456)
,p_event_id=>wwv_flow_imp.id(2750400539692325456)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1061_PAGE_NAME'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2750398581550325454)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page(',
'    p_page_name        => :P1061_PAGE_NAME,',
'    p_page_type        => wwv_flow_define_app_v3.c_page_blank,',
'    p_page_icon       => :P1061_PAGE_ICON,',
'    p_is_homepage      => ( :P1061_HOMEPAGE = ''Y'' ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2750398581550325454
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2750399394869325455)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.edit_page(',
'    p_page_id          => :P1061_SEQ_ID,',
'    p_page_name        => :P1061_PAGE_NAME,',
'    p_page_type        => wwv_flow_define_app_v3.c_page_blank,',
'    p_page_icon        => :P1061_PAGE_ICON,',
'    p_is_homepage      => ( :P1061_HOMEPAGE = ''Y'' ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2750399394869325455
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2750398999555325455)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1061_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2750398999555325455
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2750399750791325455)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2750399750791325455
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2750400184752325455)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      c013 page_icon',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1061_SEQ_ID )',
'loop',
'    :P1061_PAGE_NAME := l_page.page_name;',
'    :P1061_PAGE_ICON := l_page.page_icon;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1061_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2750400184752325455
);
end;
/
prompt --application/pages/page_01070
begin
wwv_flow_imp_page.create_page(
 p_id=>1070
,p_name=>'Create Calendar Page'
,p_alias=>'CREATE-CALENDAR-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Calendar Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};'))
,p_javascript_code_onload=>'initWizardModal();'
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3096987315318966840)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10508080234298704472)
,p_plug_name=>'Table Container'
,p_region_css_classes=>'a-BoxedForms a-PageWizard-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18621592154522293172)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18621592730865293178)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2671805636387411310)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1070_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1070_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698017377448126308)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(18621592730865293178)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2659314770638030824)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(18621592730865293178)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2698324017500897718)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(18621592730865293178)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:CALENDAR_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2659315104992030825)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(18621592730865293178)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2659315588213030826)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(18621592730865293178)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2659315944231030826)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(18621592730865293178)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2659322052210030863)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2659315944231030826)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2593478213418715615)
,p_name=>'P1070_DISPLAY_COL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_prompt=>'Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1070_TABLE',
'  and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Display Column -'
,p_lov_cascade_parent_items=>'P1070_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2593479126866715624)
,p_name=>'P1070_START_DATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_prompt=>'Start Date Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1070_TABLE',
'  and (data_type in (''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Start Date -'
,p_lov_cascade_parent_items=>'P1070_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2593479379176715626)
,p_name=>'P1070_END_DATE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_prompt=>'End Date Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1070_TABLE',
'  and (data_type in (''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select End Date -'
,p_lov_cascade_parent_items=>'P1070_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_inline_help_text=>'Select this column to show events that span multiple days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2593479463664715627)
,p_name=>'P1070_SHOW_TIME_YN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_item_default=>'N'
,p_prompt=>'Show Time'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO'
,p_lov=>'.'||wwv_flow_imp.id(2660244068801532757)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2659312827404030812)
,p_name=>'P1070_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2659313297848030815)
,p_name=>'P1070_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2659313625666030815)
,p_name=>'P1070_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2659314097451030815)
,p_name=>'P1070_PAGE_SOURCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2659316383857030827)
,p_name=>'P1070_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3096987315318966840)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1070_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1070_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2659317337078030831)
,p_name=>'P1070_TABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2671805395057410150)
,p_name=>'P1070_PAGE_ICON'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(18621592154522293172)
,p_item_default=>'fa-calendar-o'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940045709486003226)
,p_name=>'P1070_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3096987315318966840)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3165198978345852607)
,p_name=>'P1070_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3096987315318966840)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2659317868568030855)
,p_validation_name=>'P1070_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1070_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934950030132675425)
,p_validation_name=>'display column not null'
,p_validation_sequence=>50
,p_validation=>'P1070_DISPLAY_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934950134523675426)
,p_validation_name=>'start date column not null'
,p_validation_sequence=>60
,p_validation=>'P1070_START_DATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2659321029873030861)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2659321525605030861)
,p_event_id=>wwv_flow_imp.id(2659321029873030861)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2659320101071030858)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1070_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2659320616579030861)
,p_event_id=>wwv_flow_imp.id(2659320101071030858)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2698017422394126309)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2698017377448126308)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2698017536263126310)
,p_event_id=>wwv_flow_imp.id(2698017422394126309)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019479715146899622)
,p_name=>'Disable Admin'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1070_HOMEPAGE'
,p_condition_element=>'P1070_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019479809615899623)
,p_event_id=>wwv_flow_imp.id(3019479715146899622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019479914995899624)
,p_event_id=>wwv_flow_imp.id(3019479715146899622)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019480067678899625)
,p_name=>'Disable Home Page'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1070_ADMIN'
,p_condition_element=>'P1070_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019480154520899626)
,p_event_id=>wwv_flow_imp.id(3019480067678899625)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019480205629899627)
,p_event_id=>wwv_flow_imp.id(3019480067678899625)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_HOMEPAGE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2659318919200030856)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id number;',
'    l_calendar wwv_flow_define_app_v3.t_calendar;',
'begin',
'    l_calendar.display_column := :P1070_DISPLAY_COL;',
'    l_calendar.start_date_column := :P1070_START_DATE;',
'    l_calendar.end_date_column := :P1070_END_DATE;',
'    l_calendar.show_time := :P1070_SHOW_TIME_YN;',
'',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name        => :P1070_PAGE_NAME,',
'                     p_page_type        => :P1070_PAGE_TYPE,',
'                     p_page_icon        => :P1070_PAGE_ICON,',
'                     p_schema           => :P1_SCHEMA,',
'                     p_source_type      => :P1070_PAGE_SOURCE,',
'                     p_table_name       => ( case when :P1070_PAGE_SOURCE = ''TABLE'' then :P1070_TABLE end ),',
'                     p_is_homepage      => ( :P1070_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page    => ( :P1070_ADMIN = ''Y''),',
'                     p_calendar         => l_calendar,',
'                     p_page_help        => :P1070_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2659315588213030826)
,p_internal_uid=>2659318919200030856
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2659319353958030857)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id number;',
'    l_calendar wwv_flow_define_app_v3.t_calendar;',
'begin',
'    l_calendar.display_column := :P1070_DISPLAY_COL;',
'    l_calendar.start_date_column := :P1070_START_DATE;',
'    l_calendar.end_date_column := :P1070_END_DATE;',
'    l_calendar.show_time := :P1070_SHOW_TIME_YN;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id          => :P1070_SEQ_ID,',
'        p_page_name        => :P1070_PAGE_NAME,',
'        p_page_type        => :P1070_PAGE_TYPE,',
'        p_page_icon        => :P1070_PAGE_ICON,',
'        p_schema           => :P1_SCHEMA,',
'        p_source_type      => :P1070_PAGE_SOURCE,',
'        p_table_name       => :P1070_TABLE,',
'        p_is_homepage      => ( :P1070_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page    => ( :P1070_ADMIN = ''Y'' ),',
'        p_calendar         => l_calendar,',
'        p_page_help        => :P1070_PAGE_HELP);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2659315104992030825)
,p_internal_uid=>2659319353958030857
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2659318190271030855)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1070_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2659314770638030824)
,p_internal_uid=>2659318190271030855
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2659319712486030857)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2659319712486030857
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2659318556722030856)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c025 display_column,',
'                      c026 start_date_column,',
'                      c027 end_date_column,',
'                      c028 show_time,',
'                      c040 help',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1070_SEQ_ID )',
'loop',
'    :P1070_PAGE_NAME := l_page.page_name;',
'    :P1070_PAGE_TYPE := l_page.page_type;',
'    :P1070_PAGE_SOURCE := l_page.source_type;',
'    :P1070_TABLE := l_page.table_name;',
'    :P1070_PAGE_ICON := l_page.page_icon;',
'',
'    :P1070_DISPLAY_COL := l_page.display_column;',
'    :P1070_START_DATE := l_page.start_date_column;',
'    :P1070_END_DATE := l_page.end_date_column;',
'    :P1070_SHOW_TIME_YN := l_page.show_time;',
'    :P1070_ADMIN := l_page.is_admin_page;',
'    :P1070_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1070_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2659318556722030856
);
end;
/
prompt --application/pages/page_01090
begin
wwv_flow_imp_page.create_page(
 p_id=>1090
,p_name=>'Add Cards Page'
,p_alias=>'ADD-CARDS-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Cards Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_PAGE_CONFIRM_MSG"'';'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6412055982372737385)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6571976926738979190)
,p_plug_name=>'Drill Down Link'
,p_region_name=>'drill_down_link_region'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion a-BoxedForms'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1090_HAS_DRILLDOWN'
,p_plug_display_when_cond2=>'Y'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13803355032585094601)
,p_plug_name=>'Cards'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13427405318384615)
,p_plug_name=>'Card Columns'
,p_region_name=>'card-columns'
,p_parent_plug_id=>wwv_flow_imp.id(13803355032585094601)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21916866952808683301)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21916867529151683307)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315072439421770578)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(21916866952808683301)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1090_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1090_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315075933210770583)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(21916867529151683307)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315076380769770584)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(21916867529151683307)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315075145784770583)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(21916867529151683307)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:CARD_PAGE'
,p_button_condition_type=>'NEVER'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315075571323770583)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(21916867529151683307)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315076728337770584)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(21916867529151683307)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315077192826770584)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(21916867529151683307)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13427126749384612)
,p_name=>'P1090_LAYOUT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13803355032585094601)
,p_item_default=>'GRID'
,p_prompt=>'Layout Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CARDS_LAYOUT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(13522227592838689)||'.'
,p_grid_column=>4
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13427236036384613)
,p_name=>'P1090_BADGE_COLUMN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(13427405318384615)
,p_prompt=>'Badge Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314909601952435903)
,p_name=>'P1090_ICON_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(13427405318384615)
,p_prompt=>'Icon Initials Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315070129719770574)
,p_name=>'P1090_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(13803355032585094601)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315070518628770576)
,p_name=>'P1090_TITLE_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13427405318384615)
,p_prompt=>'Title Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315071324821770577)
,p_name=>'P1090_BODY_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(13427405318384615)
,p_prompt=>'Body Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315072892160770579)
,p_name=>'P1090_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(21916866952808683301)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315073242679770579)
,p_name=>'P1090_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(21916866952808683301)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315073633463770580)
,p_name=>'P1090_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(21916866952808683301)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315074021686770580)
,p_name=>'P1090_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(21916866952808683301)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315074463580770580)
,p_name=>'P1090_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(21916866952808683301)
,p_item_default=>'fa-cards'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315077752338770585)
,p_name=>'P1090_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6412055982372737385)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1090_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1090_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315078124605770586)
,p_name=>'P1090_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6412055982372737385)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315078526162770587)
,p_name=>'P1090_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6412055982372737385)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3361257124596218807)
,p_name=>'P1090_LINK_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6571976926738979190)
,p_prompt=>'Link Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CARD_LINK'
,p_lov=>'.'||wwv_flow_imp.id(3407941302600627214)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Type -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3361257541240218810)
,p_name=>'P1090_LINK_KEY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6571976926738979190)
,p_prompt=>'Link Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT''))',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3361257973662218810)
,p_name=>'P1090_LINK_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6571976926738979190)
,p_prompt=>'Link to Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, n002 r ',
'from wwv_flow_collections ',
'where collection_name = ''APEX$CREATE_APP_PAGE''',
'and (   ( c002 = ''INTERACTIVE_RPT'' )',
'     or ( c002 = ''MASTER_DETAIL'' and c014 =''MD_ON_TABLE_WITH_SELECTOR'' )',
'    )',
'and ( seq_id !=  :P1090_SEQ_ID or :P1090_SEQ_ID is null )',
'',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3361258332680218810)
,p_name=>'P1090_LINK_TARGET_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6571976926738979190)
,p_prompt=>'Target Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from wwv_flow_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1090_LINK_TO_PAGE',
'                     and c002 = ''INTERACTIVE_RPT''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE''))',
'    union all ',
'    -- drill down to master detail',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from wwv_flow_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1090_LINK_TO_PAGE',
'                     and c002 = ''MASTER_DETAIL''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''CHAR'',''NCHAR'',''VARCHAR2'',''NVARCHAR2'',''NUMBER'',''BINARY_FLOAT'',''BINARY_DOUBLE''))',
'    union all ',
'    -- drill down to IR on SQL',
'    select wwv_flow_escape.html(c005) d, c005 r, seq_id n',
'    from wwv_flow_collections ',
'    where collection_name = ''APEX$CREATE_APP_PAGE_COLUMN''',
'    and n002 = :P1090_LINK_TO_PAGE',
'    and c002 = ''INTERACTIVE_RPT''',
'    and c006 in (''VARCHAR2'',''NUMBER'',''DATE'')',
'    and c003 = ''SQL'' ) x',
'order by x.n'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_LINK_TO_PAGE'
,p_ajax_items_to_submit=>'P1090_LINK_TO_PAGE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4052496154736255103)
,p_name=>'P1090_HAS_DRILLDOWN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(21916866952808683301)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4052496218308255104)
,p_computation_sequence=>10
,p_computation_item=>'P1090_HAS_DRILLDOWN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Y''',
'from wwv_flow_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE'' and',
'    c002 in ( ''INTERACTIVE_RPT'',  ''MASTER_DETAIL'' )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3315079028450770597)
,p_validation_name=>'table not null'
,p_validation_sequence=>10
,p_validation=>'P1090_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934949443116675419)
,p_validation_name=>'cart title not null'
,p_validation_sequence=>20
,p_validation=>'P1090_TITLE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934951487720675439)
,p_validation_name=>'P1090_LINK_TO_PAGE not null'
,p_validation_sequence=>50
,p_validation=>'P1090_LINK_TO_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1090_HAS_DRILLDOWN = ''Y'' and (',
':P1090_LINK_KEY is not null or',
':P1090_LINK_TARGET_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3361257973662218810)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934950739796675432)
,p_validation_name=>'P1090_LINK_TARGET_KEY not null'
,p_validation_sequence=>60
,p_validation=>'P1090_LINK_TARGET_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1090_HAS_DRILLDOWN = ''Y'' and (',
':P1090_LINK_TO_PAGE is not null or',
':P1090_LINK_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3361258332680218810)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(632193570339032126)
,p_validation_name=>'P1090_LINK_TYPE not null'
,p_validation_sequence=>70
,p_validation=>'P1090_LINK_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1090_LINK_KEY is not null or',
':P1090_LINK_TO_PAGE is not null or',
':P1090_LINK_TARGET_KEY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315083949350770606)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3315075933210770583)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315084472817770607)
,p_event_id=>wwv_flow_imp.id(3315083949350770606)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315087230908770610)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_HOMEPAGE'
,p_condition_element=>'P1090_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315087770096770610)
,p_event_id=>wwv_flow_imp.id(3315087230908770610)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315088251425770611)
,p_event_id=>wwv_flow_imp.id(3315087230908770610)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315088671727770611)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_ADMIN'
,p_condition_element=>'P1090_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315089165238770611)
,p_event_id=>wwv_flow_imp.id(3315088671727770611)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315089681396770612)
,p_event_id=>wwv_flow_imp.id(3315088671727770611)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13427534702384616)
,p_name=>'show card columns'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_TABLE'
,p_condition_element=>'P1090_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(629617727580772002)
,p_event_id=>wwv_flow_imp.id(13427534702384616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1090_TABLE,',
'        p_cache_fk_references     => true );',
'end;'))
,p_attribute_02=>'P1090_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(629617892452772003)
,p_event_id=>wwv_flow_imp.id(13427534702384616)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_TITLE_COLUMN,P1090_BODY_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(629617987997772004)
,p_name=>'Get Card Title'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_TITLE_COLUMN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(629618010115772005)
,p_event_id=>wwv_flow_imp.id(629617987997772004)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1090_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1090_TITLE_COLUMN := c1.title;',
'end loop;'))
,p_attribute_03=>'P1090_TITLE_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(629618129656772006)
,p_name=>'Get Card Body Column'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_BODY_COLUMN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(629618281619772007)
,p_event_id=>wwv_flow_imp.id(629618129656772006)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_2 as description',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1090_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1090_BODY_COLUMN  := c1.description;',
'end loop;'))
,p_attribute_03=>'P1090_BODY_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315080965743770599)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'begin',
'    l_card.layout_type    := :P1090_LAYOUT_TYPE;',
'    l_card.title_column   := :P1090_TITLE_COLUMN;',
'    l_card.body_column    := :P1090_BODY_COLUMN;',
'    l_card.icon_column    := :P1090_ICON_COLUMN;',
'    l_card.badge_column   := :P1090_BADGE_COLUMN;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1090_PAGE_NAME,',
'        p_page_type       => :P1090_PAGE_TYPE,',
'        p_page_icon       => :P1090_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1090_TABLE,',
'        p_is_homepage     => ( :P1090_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1090_ADMIN = ''Y'' ),',
'        p_card            => l_card,',
'        p_page_help       => :P1090_PAGE_HELP,',
'        p_link_column     => :P1090_LINK_TYPE,',
'        p_link_key        => :P1090_LINK_KEY,',
'        p_link_to_page    => :P1090_LINK_TO_PAGE,',
'        p_link_target_key => :P1090_LINK_TARGET_KEY );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3315076728337770584)
,p_internal_uid=>3315080965743770599
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315081334815770600)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'begin',
'    l_card.layout_type    := :P1090_LAYOUT_TYPE;',
'    l_card.title_column   := :P1090_TITLE_COLUMN;',
'    l_card.body_column    := :P1090_BODY_COLUMN;',
'    l_card.icon_column    := :P1090_ICON_COLUMN;',
'    l_card.badge_column   := :P1090_BADGE_COLUMN;',
'    ',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1090_SEQ_ID,',
'        p_page_name       => :P1090_PAGE_NAME,',
'        p_page_type       => :P1090_PAGE_TYPE,',
'        p_page_icon       => :P1090_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1090_TABLE,',
'        p_is_homepage     => ( :P1090_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1090_ADMIN = ''Y'' ),',
'        p_card            => l_card,',
'        p_page_help       => :P1090_PAGE_HELP,',
'        p_link_column     => :P1090_LINK_TYPE,',
'        p_link_key        => :P1090_LINK_KEY,',
'        p_link_to_page    => :P1090_LINK_TO_PAGE,',
'        p_link_target_key => :P1090_LINK_TARGET_KEY );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3315075571323770583)
,p_internal_uid=>3315081334815770600
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315080146927770599)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1090_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3315076380769770584)
,p_internal_uid=>3315080146927770599
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315081787795770601)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3315081787795770601
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315080565973770599)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c016 layout_type,',
'                      c017 title_column,',
'                      c018 body_column,',
'                      c019 icon_column,',
'                      c020 badge_column,',
'                      c040 help,',
'                      c041 link_type,',
'                      c042 link_key,',
'                      c043 link_to_page,',
'                      c044 link_target_key',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1090_SEQ_ID )',
'loop',
'    :P1090_PAGE_NAME := l_page.page_name;',
'    :P1090_PAGE_TYPE := l_page.page_type;',
'    :P1090_PAGE_SOURCE := l_page.source_type;',
'    :P1090_TABLE := l_page.table_name;',
'    :P1090_PAGE_ICON := l_page.page_icon;    ',
'',
'    :P1090_LAYOUT_TYPE  := l_page.layout_type;',
'    :P1090_TITLE_COLUMN := l_page.title_column;',
'    :P1090_BODY_COLUMN  := l_page.body_column;',
'    :P1090_ICON_COLUMN  := l_page.icon_column;',
'    :P1090_BADGE_COLUMN := l_page.badge_column;',
'',
'    :P1090_LINK_TYPE := l_page.link_type;',
'    :P1090_LINK_KEY := l_page.link_key;',
'    :P1090_LINK_TO_PAGE := l_page.link_to_page;',
'    :P1090_LINK_TARGET_KEY := l_page.link_target_key;',
'    ',
'    :P1090_ADMIN := l_page.is_admin_page;',
'    :P1060_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1090_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>3315080565973770599
);
end;
/
prompt --application/pages/page_01100
begin
wwv_flow_imp_page.create_page(
 p_id=>1100
,p_name=>'Create Form Page'
,p_alias=>'CREATE-FORM-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.apex-button-group table {',
'    border-spacing: 0;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6411863642286386018)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11163644638415092865)
,p_plug_name=>'Table Container'
,p_region_name=>'page_source_table'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2942643391689249188)
,p_plug_name=>'Include Report'
,p_parent_plug_id=>wwv_flow_imp.id(11163644638415092865)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6369980961600974383)
,p_plug_name=>'Form Container'
,p_parent_plug_id=>wwv_flow_imp.id(11163644638415092865)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19277156558638681565)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19277157134981681571)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3314882086365419193)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(19277156558638681565)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1100_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1100_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3314884773135419195)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(19277157134981681571)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3314885194186419196)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(19277157134981681571)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3314885569453419196)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(19277157134981681571)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:FORM_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3314885986098419196)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(19277157134981681571)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3314886328123419197)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(19277157134981681571)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3314886741033419197)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(19277157134981681571)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(353718430581098652)
,p_name=>'P1100_INCLUDE_REPORT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2942643391689249188)
,p_prompt=>'Include Report'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314878938317419189)
,p_name=>'P1100_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6369980961600974383)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314882480517419193)
,p_name=>'P1100_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(19277156558638681565)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314882827576419194)
,p_name=>'P1100_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(19277156558638681565)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314883251386419194)
,p_name=>'P1100_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(19277156558638681565)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314883619464419194)
,p_name=>'P1100_PAGE_SOURCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(19277156558638681565)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314884053168419195)
,p_name=>'P1100_PAGE_ICON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(19277156558638681565)
,p_item_default=>'fa-forms'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314887445076419198)
,p_name=>'P1100_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6411863642286386018)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1100_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when_type=>'NEVER'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1100_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314887808299419200)
,p_name=>'P1100_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6411863642286386018)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314888218957419201)
,p_name=>'P1100_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6411863642286386018)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314920902353478248)
,p_name=>'P1100_FORM_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(11163644638415092865)
,p_item_default=>'MD_ON_TABLE_WITH_SELECTOR'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3314888792221419202)
,p_validation_name=>'P1100_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1100_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(3314886328123419197)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3314891801429419206)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314892313511419206)
,p_event_id=>wwv_flow_imp.id(3314891801429419206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3314892770864419207)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314893286994419209)
,p_event_id=>wwv_flow_imp.id(3314892770864419207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3314893613018419209)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3314884773135419195)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314894120904419209)
,p_event_id=>wwv_flow_imp.id(3314893613018419209)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3314895975111419211)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_HOMEPAGE'
,p_condition_element=>'P1100_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314896420319419211)
,p_event_id=>wwv_flow_imp.id(3314895975111419211)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314896927364419212)
,p_event_id=>wwv_flow_imp.id(3314895975111419211)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3314897315556419212)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_ADMIN'
,p_condition_element=>'P1100_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314897846261419212)
,p_event_id=>wwv_flow_imp.id(3314897315556419212)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314898357158419213)
,p_event_id=>wwv_flow_imp.id(3314897315556419212)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3314898752379419213)
,p_name=>'Toggle Details 2'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_DETAIL_1'
,p_condition_element=>'P1100_DETAIL_1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314899246647419213)
,p_event_id=>wwv_flow_imp.id(3314898752379419213)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_2'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314899773115419214)
,p_event_id=>wwv_flow_imp.id(3314898752379419213)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_2'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3314900133566419214)
,p_name=>'Toggle Details 3'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_DETAIL_2'
,p_condition_element=>'P1100_DETAIL_2'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314900664010419214)
,p_event_id=>wwv_flow_imp.id(3314900133566419214)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_3'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314901101359419215)
,p_event_id=>wwv_flow_imp.id(3314900133566419214)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_3'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3314901591522419215)
,p_name=>'Toggle Details 4'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_DETAIL_3'
,p_condition_element=>'P1100_DETAIL_3'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314902042570419215)
,p_event_id=>wwv_flow_imp.id(3314901591522419215)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3314902549862419216)
,p_event_id=>wwv_flow_imp.id(3314901591522419215)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3314890693375419205)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id           number;',
'begin',
'',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name         => :P1100_PAGE_NAME,',
'                     p_page_type         => :P1100_PAGE_TYPE,',
'                     p_page_icon         => :P1100_PAGE_ICON,',
'                     p_schema            => :P1_SCHEMA,',
'                     p_source_type       => :P1100_PAGE_SOURCE,',
'                     p_table_name        => ( case when :P1100_PAGE_SOURCE = ''TABLE'' then :P1100_TABLE end ),',
'                     p_include_report    => ( :P1100_INCLUDE_REPORT = ''Y'' ),',
'                     p_is_homepage       => ( :P1100_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page     => ( :P1100_ADMIN = ''Y''),',
'                     p_form_type         => :P1100_FORM_TYPE,',
'                     p_page_help         => :P1100_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3314886328123419197)
,p_internal_uid=>3314890693375419205
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3314891046972419205)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id           => :P1100_SEQ_ID,',
'        p_page_name         => :P1100_PAGE_NAME,',
'        p_page_type         => :P1100_PAGE_TYPE,',
'        p_page_icon         => :P1100_PAGE_ICON,',
'        p_schema            => :P1_SCHEMA,',
'        p_source_type       => :P1100_PAGE_SOURCE,',
'        p_table_name        => :P1100_TABLE,',
'        p_include_report    => ( :P1100_INCLUDE_REPORT = ''Y'' ),',
'        p_is_homepage       => ( :P1100_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page     => ( :P1100_ADMIN = ''Y'' ),',
'        p_form_type         => :P1100_FORM_TYPE,',
'        p_page_help         => :P1100_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3314885986098419196)
,p_internal_uid=>3314891046972419205
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3314889896608419204)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1100_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3314885194186419196)
,p_internal_uid=>3314889896608419204
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3314891403945419206)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3314891403945419206
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3314890208990419205)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c030 include_report,',
'                      c013 page_icon,',
'                      c014 form_type,',
'                      c015 is_admin_page,',
'                      c016 primary_label_col,',
'                      c017 secondary_label_col,',
'                      c025 detail_1,',
'                      c026 detail_2,',
'                      c027 detail_3,',
'                      c028 detail_4,',
'                      c040 help',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1100_SEQ_ID )',
'loop',
'    :P1100_PAGE_NAME := l_page.page_name;',
'    :P1100_PAGE_TYPE := l_page.page_type;',
'    :P1100_PAGE_SOURCE := l_page.source_type;',
'	:P1100_FORM_TYPE := l_page.form_type;',
'    :P1100_TABLE := l_page.table_name;',
'    :P1100_INCLUDE_REPORT := l_page.include_report;',
'    :P1100_PAGE_ICON := l_page.page_icon;    ',
'    :P1100_ADMIN := l_page.is_admin_page;',
'    :P1100_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1100_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>3314890208990419205
);
end;
/
prompt --application/pages/page_01110
begin
wwv_flow_imp_page.create_page(
 p_id=>1110
,p_name=>'Create Timeline Page'
,p_alias=>'CREATE-TIMELINE-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Timeline Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}',
'.a-Button.a-PWIconPicker-pickerButton--inline  {',
'     width: calc(100% - 16px);',
'	     padding-left: 36px;',
'	     text-align: left;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9727170382582688517)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9934464922380461272)
,p_plug_name=>'Drill Down Link'
,p_region_name=>'drill_down_link_region'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion a-BoxedForms'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1110_HAS_DRILLDOWN'
,p_plug_display_when_cond2=>'Y'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17118469432795045733)
,p_plug_name=>'Card Items'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25231981353018634433)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25231981929361634439)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315116967854951159)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(25231981353018634433)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1110_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1110_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315120412069951164)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(25231981929361634439)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315120842117951164)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(25231981929361634439)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315119628353951163)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(25231981929361634439)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:TIMELINE_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315120034382951164)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(25231981929361634439)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315121221162951164)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(25231981929361634439)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315121616605951166)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(25231981929361634439)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108010290942904)
,p_name=>'P1110_EVENT_DESC'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17118469432795045733)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108105129942905)
,p_name=>'P1110_EVENT_DATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17118469432795045733)
,p_prompt=>'Date'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315115189488951151)
,p_name=>'P1110_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17118469432795045733)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315115594638951153)
,p_name=>'P1110_USER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17118469432795045733)
,p_prompt=>'User Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''VARCHAR2''))',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315115907964951153)
,p_name=>'P1110_EVENT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17118469432795045733)
,p_prompt=>'Event Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''VARCHAR2''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315117300510951160)
,p_name=>'P1110_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(25231981353018634433)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315117733702951160)
,p_name=>'P1110_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(25231981353018634433)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315118149304951161)
,p_name=>'P1110_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(25231981353018634433)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315118575131951161)
,p_name=>'P1110_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(25231981353018634433)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315118970275951161)
,p_name=>'P1110_PAGE_ICON'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(25231981353018634433)
,p_item_default=>'fa-history'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315122343330951166)
,p_name=>'P1110_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(9727170382582688517)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1110_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1110_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315122728664951168)
,p_name=>'P1110_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(9727170382582688517)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315123125267951168)
,p_name=>'P1110_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(9727170382582688517)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3362488202696482094)
,p_name=>'P1110_LINK_COLUMN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(9934464922380461272)
,p_item_default=>'EVENT_TITLE'
,p_prompt=>'Link Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EVENT_NAME'
,p_lov=>'.'||wwv_flow_imp.id(3407942220250638520)||'.'
,p_cHeight=>1
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3362488540549482098)
,p_name=>'P1110_LINK_KEY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(9934464922380461272)
,p_prompt=>'Link Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3362488924075482098)
,p_name=>'P1110_LINK_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(9934464922380461272)
,p_prompt=>'Link to Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, n002 r ',
'from wwv_flow_collections ',
'where collection_name = ''APEX$CREATE_APP_PAGE''',
'and (   ( c002 = ''INTERACTIVE_RPT'' )',
'     or ( c002 = ''MASTER_DETAIL'' and c014 =''MD_ON_TABLE_WITH_SELECTOR'' )',
'    )',
'and ( seq_id !=  :P1110_SEQ_ID or :P1110_SEQ_ID is null )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3362489357583482098)
,p_name=>'P1110_LINK_TARGET_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(9934464922380461272)
,p_prompt=>'Target Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           --:P1110_SEQ_ID is null and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from wwv_flow_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1110_LINK_TO_PAGE',
'                     and c002 = ''INTERACTIVE_RPT''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE''))',
'    union all ',
'    -- drill down to master detail',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from wwv_flow_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1110_LINK_TO_PAGE',
'                     and c002 = ''MASTER_DETAIL''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''CHAR'',''NCHAR'',''VARCHAR2'',''NVARCHAR2'',''NUMBER'',''BINARY_FLOAT'',''BINARY_DOUBLE''))',
'    union all  ',
'    -- drill down to IR on SQL',
'    select wwv_flow_escape.html(c005) d, c005 r, seq_id n',
'    from wwv_flow_collections ',
'    where collection_name = ''APEX$CREATE_APP_PAGE_COLUMN''',
'    and n002 = :P1110_LINK_TO_PAGE',
'    and c002 = ''INTERACTIVE_RPT''',
'    and c006 in (''VARCHAR2'',''NUMBER'',''DATE'')',
'    and c003 = ''SQL'' ) x',
'order by x.n'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_LINK_TO_PAGE'
,p_ajax_items_to_submit=>'P1110_LINK_TO_PAGE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4053364638768613001)
,p_name=>'P1110_HAS_DRILLDOWN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(25231981353018634433)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4053364749481613002)
,p_computation_sequence=>10
,p_computation_item=>'P1110_HAS_DRILLDOWN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Y''',
'from wwv_flow_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE'' and',
'    c002 in ( ''INTERACTIVE_RPT'',  ''MASTER_DETAIL'' )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3315123645199951191)
,p_validation_name=>'table not null'
,p_validation_sequence=>10
,p_validation=>'P1110_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934949791560675422)
,p_validation_name=>'user name not null'
,p_validation_sequence=>20
,p_validation=>'P1110_USER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934949878085675423)
,p_validation_name=>'date not null'
,p_validation_sequence=>30
,p_validation=>'P1110_EVENT_DATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934949933031675424)
,p_validation_name=>'event name not null'
,p_validation_sequence=>40
,p_validation=>'P1110_EVENT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934950918882675434)
,p_validation_name=>'P1110_LINK_KEY not null'
,p_validation_sequence=>50
,p_validation=>'P1110_LINK_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1110_HAS_DRILLDOWN = ''Y'' and (',
'    :P1110_LINK_TO_PAGE is not null or',
'    :P1110_LINK_TARGET_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934951364555675438)
,p_validation_name=>'P1110_LINK_TO_PAGE not null'
,p_validation_sequence=>60
,p_validation=>'P1110_LINK_TO_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1110_HAS_DRILLDOWN = ''Y'' and (',
'    :P1110_LINK_KEY is not null or',
'    :P1110_LINK_TARGET_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2934951218986675437)
,p_validation_name=>'P1110_LINK_TARGET_KEY not null'
,p_validation_sequence=>70
,p_validation=>'P1110_LINK_TARGET_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1110_HAS_DRILLDOWN = ''Y'' and (',
'    :P1110_LINK_TO_PAGE is not null or',
'    :P1110_LINK_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315127725600951200)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3315120412069951164)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315128245308951200)
,p_event_id=>wwv_flow_imp.id(3315127725600951200)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315131087942951202)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1110_HOMEPAGE'
,p_condition_element=>'P1110_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315131598827951202)
,p_event_id=>wwv_flow_imp.id(3315131087942951202)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315132028664951203)
,p_event_id=>wwv_flow_imp.id(3315131087942951202)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315132424232951204)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1110_ADMIN'
,p_condition_element=>'P1110_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315132956745951204)
,p_event_id=>wwv_flow_imp.id(3315132424232951204)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315133440762951205)
,p_event_id=>wwv_flow_imp.id(3315132424232951204)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_HOMEPAGE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315124700583951192)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_timeline wwv_flow_define_app_v3.t_timeline;',
'begin',
'    l_timeline.username_column := :P1110_USER;',
'    l_timeline.date_column := :P1110_EVENT_DATE;',
'    l_timeline.event_name_column := :P1110_EVENT_NAME;',
'    l_timeline.desc_column := :P1110_EVENT_DESC;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1110_PAGE_NAME,',
'        p_page_type       => :P1110_PAGE_TYPE,',
'        p_page_icon       => :P1110_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1110_TABLE,',
'        p_is_homepage     => ( :P1110_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1110_ADMIN = ''Y'' ),',
'        p_timeline        => l_timeline,',
'        p_page_help       => :P1110_PAGE_HELP,',
'        p_link_column     => :P1110_LINK_COLUMN,',
'        p_link_key        => :P1110_LINK_KEY,',
'        p_link_to_page    => :P1110_LINK_TO_PAGE,',
'        p_link_target_key => :P1110_LINK_TARGET_KEY );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3315121221162951164)
,p_internal_uid=>3315124700583951192
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315125151526951195)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_timeline wwv_flow_define_app_v3.t_timeline;',
'begin',
'    l_timeline.username_column := :P1110_USER;',
'    l_timeline.date_column := :P1110_EVENT_DATE;',
'    l_timeline.event_name_column := :P1110_EVENT_NAME;',
'    l_timeline.desc_column := :P1110_EVENT_DESC;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1110_SEQ_ID,',
'        p_page_name       => :P1110_PAGE_NAME,',
'        p_page_type       => :P1110_PAGE_TYPE,',
'        p_page_icon       => :P1110_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1110_TABLE,',
'        p_is_homepage     => ( :P1110_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1110_ADMIN = ''Y'' ),',
'        p_timeline        => l_timeline,',
'        p_page_help       => :P1110_PAGE_HELP,',
'        p_link_column     => :P1110_LINK_COLUMN,',
'        p_link_key        => :P1110_LINK_KEY,',
'        p_link_to_page    => :P1110_LINK_TO_PAGE,',
'        p_link_target_key => :P1110_LINK_TARGET_KEY );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3315120034382951164)
,p_internal_uid=>3315125151526951195
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315123948369951192)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1110_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3315120842117951164)
,p_internal_uid=>3315123948369951192
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315125543820951195)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3315125543820951195
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315124362001951192)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      --',
'                      c016 username_col,',
'                      c017 event_date_col,',
'                      c018 event_name_col,',
'                      c019 event_desc_col,',
'                      --',
'                      c040 help,',
'                      --',
'                      c041 link_col,',
'                      c042 link_key,',
'                      c043 link_to_page,',
'                      c044 link_target_key',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1110_SEQ_ID )',
'loop',
'    :P1110_PAGE_NAME := l_page.page_name;',
'    :P1110_PAGE_TYPE := l_page.page_type;',
'    :P1110_PAGE_SOURCE := l_page.source_type;',
'    :P1110_TABLE := l_page.table_name;',
'    :P1110_PAGE_ICON := l_page.page_icon;    ',
'',
'    :P1110_USER := l_page.username_col;',
'    :P1110_EVENT_DATE := l_page.event_date_col;',
'    :P1110_EVENT_NAME := l_page.event_name_col;',
'    :P1110_EVENT_DESC := l_page.event_desc_col;',
'',
'    :P1110_LINK_COLUMN := l_page.link_col;',
'    :P1110_LINK_KEY := l_page.link_key;',
'    :P1110_LINK_TO_PAGE := l_page.link_to_page;',
'    :P1110_LINK_TARGET_KEY := l_page.link_target_key;',
'',
'    :P1110_ADMIN := l_page.is_admin_page;',
'    :P1060_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1110_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>3315124362001951192
);
end;
/
prompt --application/pages/page_01120
begin
wwv_flow_imp_page.create_page(
 p_id=>1120
,p_name=>'Create Wizard Pages'
,p_alias=>'CREATE-WIZARD-PAGES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Wizard Pages'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};'))
,p_javascript_code_onload=>'initWizardModal();'
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3398990797712869201)
,p_plug_name=>'Items'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px 8px 16px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13042305435186644880)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20433604485399002096)
,p_plug_name=>'Items'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28547116405622590796)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28547116981965590802)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315139146989956369)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(28547116405622590796)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1120_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1120_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315142668733956373)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(28547116981965590802)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315143034235956374)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(28547116981965590802)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315141834544956373)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(28547116981965590802)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:WIZARD_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315142257278956373)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(28547116981965590802)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315143452750956374)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(28547116981965590802)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3315143822412956374)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(28547116981965590802)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3315154608148956385)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3315143822412956374)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108253332942906)
,p_name=>'P1120_PAGE_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3398990797712869201)
,p_item_default=>'NORMAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD_PAGE_MODE'
,p_lov=>'.'||wwv_flow_imp.id(3315174268901073640)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108318250942907)
,p_name=>'P1120_STEP_1'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20433604485399002096)
,p_prompt=>'Step 1'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108410895942908)
,p_name=>'P1120_STEP_2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(20433604485399002096)
,p_prompt=>'Step 2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108538632942909)
,p_name=>'P1120_STEP_3'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(20433604485399002096)
,p_prompt=>'Step 3'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108659665942910)
,p_name=>'P1120_STEP_4'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(20433604485399002096)
,p_prompt=>'Step 4'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108729582942911)
,p_name=>'P1120_STEP_5'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(20433604485399002096)
,p_prompt=>'Step 5'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108865844942912)
,p_name=>'P1120_NUM_STEPS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20433604485399002096)
,p_prompt=>'Number of Steps'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Display1;Return1,Display2;Return2'
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315108965374942913)
,p_name=>'P1120_STEP_6'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(20433604485399002096)
,p_prompt=>'Step 6'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315109029456942914)
,p_name=>'P1120_STEP_7'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(20433604485399002096)
,p_prompt=>'Step 7'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315109107204942915)
,p_name=>'P1120_STEP_8'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(20433604485399002096)
,p_prompt=>'Step 8'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315135720945956365)
,p_name=>'P1120_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13042305435186644880)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1120_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when_type=>'NEVER'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1120_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315136134402956366)
,p_name=>'P1120_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(13042305435186644880)
,p_prompt=>'Set as Administration Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315136597850956366)
,p_name=>'P1120_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13042305435186644880)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315139593972956370)
,p_name=>'P1120_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(28547116405622590796)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315139956976956371)
,p_name=>'P1120_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(28547116405622590796)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315140305757956371)
,p_name=>'P1120_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(28547116405622590796)
,p_prompt=>'Wizard Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315141179283956372)
,p_name=>'P1120_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(28547116405622590796)
,p_item_default=>'fa-magic'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315147579038956378)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315148056940956378)
,p_event_id=>wwv_flow_imp.id(3315147579038956378)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019482085105899645)
,p_name=>'Initialize Step 5 and 6'
,p_event_sequence=>20
,p_condition_element=>'P1120_STEP_5'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3019482264333899647)
,p_event_id=>wwv_flow_imp.id(3019482085105899645)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_5,P1120_STEP_6'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3019482573000899650)
,p_name=>'Initialize Step 7 and 8'
,p_event_sequence=>40
,p_condition_element=>'P1120_STEP_7'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3613184770663513501)
,p_event_id=>wwv_flow_imp.id(3019482573000899650)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_7,P1120_STEP_8'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315146623568956377)
,p_name=>'Show Page Source'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315147155671956377)
,p_event_id=>wwv_flow_imp.id(3315146623568956377)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315148450270956378)
,p_name=>'Cancel Dialog'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3315142668733956373)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315148978147956379)
,p_event_id=>wwv_flow_imp.id(3315148450270956378)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315149342648956380)
,p_name=>'show value column count'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_AGGREGATE'
,p_condition_element=>'P1120_AGGREGATE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315149817154956381)
,p_event_id=>wwv_flow_imp.id(3315149342648956380)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_VALUE_COL_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315150304030956381)
,p_event_id=>wwv_flow_imp.id(3315149342648956380)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_VALUE_COL_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315150812795956382)
,p_event_id=>wwv_flow_imp.id(3315149342648956380)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315151311119956382)
,p_event_id=>wwv_flow_imp.id(3315149342648956380)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315151776228956382)
,p_name=>'Disable Admin'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_HOMEPAGE'
,p_condition_element=>'P1120_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315152229710956383)
,p_event_id=>wwv_flow_imp.id(3315151776228956382)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315152787409956383)
,p_event_id=>wwv_flow_imp.id(3315151776228956382)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3315153159093956383)
,p_name=>'Disable Home Page'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_ADMIN'
,p_condition_element=>'P1120_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315153675261956384)
,p_event_id=>wwv_flow_imp.id(3315153159093956383)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3315154180989956384)
,p_event_id=>wwv_flow_imp.id(3315153159093956383)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3361781368765335801)
,p_name=>'Show Step 5'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_STEP_4'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$(this.triggeringElement).val().length > 0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keyup'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3361781433472335802)
,p_event_id=>wwv_flow_imp.id(3361781368765335801)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_5'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3361782134361335809)
,p_name=>'Show Step 6'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_STEP_5'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$(this.triggeringElement).val().length > 0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keyup'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3361782219248335810)
,p_event_id=>wwv_flow_imp.id(3361782134361335809)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_6'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3361782507610335813)
,p_name=>'Show Step 7'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_STEP_6'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$(this.triggeringElement).val().length > 0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keyup'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3361782660288335814)
,p_event_id=>wwv_flow_imp.id(3361782507610335813)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_7'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3361782962378335817)
,p_name=>'Show Step 8'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_STEP_7'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$(this.triggeringElement).val().length > 0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keyup'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3361783016076335818)
,p_event_id=>wwv_flow_imp.id(3361782962378335817)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_8'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315145462753956376)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_wizard wwv_flow_define_app_v3.t_wizard;',
'begin',
'    l_wizard.page_mode   := :P1120_PAGE_MODE;',
'    l_wizard.page_name_1 := :P1120_STEP_1;',
'    l_wizard.page_name_2 := :P1120_STEP_2;',
'    l_wizard.page_name_3 := :P1120_STEP_3;',
'    l_wizard.page_name_4 := :P1120_STEP_4;',
'    l_wizard.page_name_5 := :P1120_STEP_5;',
'    l_wizard.page_name_6 := :P1120_STEP_6;',
'    l_wizard.page_name_7 := :P1120_STEP_7;',
'    l_wizard.page_name_8 := :P1120_STEP_8;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name     => :P1120_PAGE_NAME,',
'        p_page_type     => :P1120_PAGE_TYPE,',
'        p_page_icon     => :P1120_PAGE_ICON,',
'        p_schema        => :P1_SCHEMA,',
'        p_is_homepage   => ( :P1120_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page => ( :P1120_ADMIN = ''Y'' ),',
'        p_wizard        => l_wizard,',
'        p_page_help     => :P1120_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3315143452750956374)
,p_internal_uid=>3315145462753956376
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315145833332956376)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_wizard wwv_flow_define_app_v3.t_wizard;',
'begin',
'    l_wizard.page_mode   := :P1120_PAGE_MODE;',
'    l_wizard.page_name_1 := :P1120_STEP_1;',
'    l_wizard.page_name_2 := :P1120_STEP_2;',
'    l_wizard.page_name_3 := :P1120_STEP_3;',
'    l_wizard.page_name_4 := :P1120_STEP_4;',
'    l_wizard.page_name_5 := :P1120_STEP_5;',
'    l_wizard.page_name_6 := :P1120_STEP_6;',
'    l_wizard.page_name_7 := :P1120_STEP_7;',
'    l_wizard.page_name_8 := :P1120_STEP_8;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id      => :P1120_SEQ_ID,',
'        p_page_name    => :P1120_PAGE_NAME,',
'        p_page_type    => :P1120_PAGE_TYPE,',
'        p_page_icon    => :P1120_PAGE_ICON,',
'        p_schema       => :P1_SCHEMA,',
'        p_is_homepage  => ( :P1120_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page => ( :P1120_ADMIN = ''Y'' ),',
'        p_wizard        => l_wizard,',
'        p_page_help     => :P1120_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3315142257278956373)
,p_internal_uid=>3315145833332956376
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315144652345956375)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1120_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3315143034235956374)
,p_internal_uid=>3315144652345956375
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315146226576956377)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3315146226576956377
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3315145046240956376)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      --',
'                      upper( c016 ) page_mode,',
'                      c017 step_1,',
'                      c018 step_2,',
'                      c019 step_3,',
'                      c020 step_4,',
'                      c021 step_5,',
'                      c022 step_6,',
'                      c023 step_7,',
'                      c024 step_8,',
'                      --',
'                      c040 help',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1120_SEQ_ID )',
'loop',
'    :P1120_PAGE_NAME := l_page.page_name;',
'    :P1120_PAGE_TYPE := l_page.page_type;',
'    :P1120_PAGE_ICON := l_page.page_icon; ',
'    :P1120_ADMIN     := l_page.is_admin_page;',
'    :P1120_PAGE_HELP := l_page.help;',
'',
'    :P1120_PAGE_MODE := l_page.page_mode;',
'    :P1120_STEP_1    := l_page.step_1;',
'    :P1120_STEP_2    := l_page.step_2;',
'    :P1120_STEP_3    := l_page.step_3;',
'    :P1120_STEP_4    := l_page.step_4;',
'    :P1120_STEP_5    := l_page.step_5;',
'    :P1120_STEP_6    := l_page.step_6;',
'    :P1120_STEP_7    := l_page.step_7;',
'    :P1120_STEP_8    := l_page.step_8;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1120_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>3315145046240956376
);
end;
/
prompt --application/pages/page_01130
begin
wwv_flow_imp_page.create_page(
 p_id=>1130
,p_name=>'Add Multiple Reports'
,p_alias=>'ADD-MULTIPLE-REPORTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Multiple Reports'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function($) {',
'    // do this after the page loads but before the IG is initialized to catch the initial events',
'    $(function() {',
'        // listen for view change events to find out when grid views are created ',
'        $("#validTables").on("interactivegridviewchange", function(event, data) {',
'            if ( data.view === "grid" && data.created ) {',
'                // no single declarative or advanced option will turn off the column header menu',
'                // because on IG init, reset or change report it gets added back.',
'                // this is what it takes to turn it off',
'                apex.region("validTables").call("getCurrentView").view$',
'                    .grid("option", "activateColumnHeader", null);',
'            }',
'        });',
'    });',
'})(apex.jQuery);',
''))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79626216072002201)
,p_plug_name=>'Available Tables'
,p_region_name=>'validTables'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3262269949210718587)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id,',
'       object_name table_name',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and object_name not in (select c005 table_name',
'                           from wwv_flow_collections',
'                           where collection_name = ''APEX$CREATE_APP_PAGE''',
'                           and c002 = ''INTERACTIVE_RPT''',
'                           and c003 = ''TABLE'')',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)'))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Available Tables'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(79626483697002203)
,p_name=>'OBJECT_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'OBJECT_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(79626557637002204)
,p_name=>'TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TABLE_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Table Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(79626756910002206)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(79626328415002202)
,p_internal_uid=>79626328415002202
,p_is_editable=>true
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>true
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>518
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        activateColumnHeader: null,',
'        reorderColumns: false,',
'        resizeColumns: false,',
'        persistSelection: true,',
'        pagination: {',
'            virtual: true',
'        }',
'    };',
'    config.defaultModelOptions = {',
'        pageSize: 500',
'    };',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(79632265457995706)
,p_interactive_grid_id=>wwv_flow_imp.id(79626328415002202)
,p_static_id=>'796323'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_rows_per_page=>100
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(79632438323995706)
,p_report_id=>wwv_flow_imp.id(79632265457995706)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(79632978605995704)
,p_view_id=>wwv_flow_imp.id(79632438323995706)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(79626483697002203)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(79633832570995698)
,p_view_id=>wwv_flow_imp.id(79632438323995706)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(79626557637002204)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14050749179235766488)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110401630005485833)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(14050749179235766488)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:MULTIPLE_REPORTS'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4212071953625544846)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(14050749179235766488)
,p_button_name=>'ADD_PAGES'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Pages'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(483397257373182151)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(14050749179235766488)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(79627128214002210)
,p_name=>'P1130_SELECTED_ROWS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(79626216072002201)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(79626958911002208)
,p_name=>'Save Selected Rows'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4212071953625544846)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(79627079658002209)
,p_event_id=>wwv_flow_imp.id(79626958911002208)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Clear previous selections, if any',
'$s("P1130_SELECTED_ROWS", "");',
'',
'let gridView = apex.region("validTables").call("getViews").grid,',
'    records = gridView.getSelectedRecords(),',
'    tableName,',
'    selRecords,',
'    selRecordsJSON;',
'',
'if (records.length > 0) {',
'    selRecords  = {',
'        rows: records.map( r => gridView.model.getValue( r, "TABLE_NAME") )',
'    };',
'	// convert JSON into string',
'	selRecordsJSON = JSON.stringify( selRecords );',
'	apex.page.submit({',
'		request: "ADD_PAGES",',
'		set: {',
'			"P1130_SELECTED_ROWS": selRecordsJSON',
'		},',
'		showWait: true',
'	});',
'} else {',
'	apex.message.alert( apex.lang.getMessage("CREATE.APP.SELECT_AT_LEAST_ONE_TABLE") );',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(79627232136002211)
,p_name=>'Focus, resize Available Tables IG'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(79627356760002212)
,p_event_id=>wwv_flow_imp.id(79627232136002211)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let validTables = apex.region("validTables");',
'',
'// set focus on IG',
'validTables.call("focus");',
'',
'// the dialog seems to take a moment to get sized right so delay sizing IG region just a bit',
'setTimeout(function() {',
'    validTables.widget().height($(".a-Dialog-body").height());',
'}, 0);'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3674119118132496429)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add multiple report pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_ir_pages(',
'    p_schema              => :P1_SCHEMA,',
'    p_selected_rows_json  => :P1130_SELECTED_ROWS );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4212071953625544846)
,p_internal_uid=>3674119118132496429
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(483398895373182165)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>483398895373182165
);
end;
/
prompt --application/pages/page_01140
begin
wwv_flow_imp_page.create_page(
 p_id=>1140
,p_name=>'Add Faceted Search Page'
,p_alias=>'ADD-FACETED-SEARCH-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Faceted Search Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_PAGE_CONFIRM_MSG"'';'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(597620541688219121)
,p_plug_name=>'Report Source Container'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(597619783321219113)
,p_plug_name=>'Table or View'
,p_parent_plug_id=>wwv_flow_imp.id(597620541688219121)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(597620272474219118)
,p_plug_name=>'Include Form'
,p_region_name=>'reg_include_form'
,p_parent_plug_id=>wwv_flow_imp.id(597620541688219121)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(598174350262635603)
,p_plug_name=>'Card Page'
,p_region_name=>'reg_cards_form'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13816932270841065363)
,p_plug_name=>'Card Columns'
,p_region_name=>'reg_card_cols'
,p_parent_plug_id=>wwv_flow_imp.id(598174350262635603)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px; display: none;"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(598174468843635604)
,p_plug_name=>'Classic Report Page'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2586890391916064979)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(598174545583635605)
,p_plug_name=>'Faceted Search Type'
,p_region_css_classes=>'a-BoxedLabels a-BoxedForms margin-md margin-top-none'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7011877070127798069)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22516688040563743985)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22516688616906743991)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(599826999140060723)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(22516688040563743985)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1140_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1140_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(599830061458060730)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(22516688616906743991)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(599830415982060732)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(22516688616906743991)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(599830831720060733)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(22516688616906743991)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:CARD_PAGE'
,p_button_condition_type=>'NEVER'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(599831211883060733)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(22516688616906743991)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(599831639690060733)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(22516688616906743991)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(599832024596060734)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(22516688616906743991)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13577954947970770)
,p_name=>'P1140_LAYOUT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(597619783321219113)
,p_item_default=>'GRID'
,p_prompt=>'Layout Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CARDS_LAYOUT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(13522227592838689)||'.'
,p_grid_column=>4
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13578312329970770)
,p_name=>'P1140_TITLE_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13816932270841065363)
,p_prompt=>'Title Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1140_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1140_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13578717566970770)
,p_name=>'P1140_BODY_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(13816932270841065363)
,p_prompt=>'Body Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1140_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1140_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13579135759970770)
,p_name=>'P1140_ICON_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(13816932270841065363)
,p_prompt=>'Icon Initials Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1140_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1140_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13579522236970771)
,p_name=>'P1140_BADGE_COLUMN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(13816932270841065363)
,p_prompt=>'Badge Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1140_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1140_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(597620403327219120)
,p_name=>'P1140_INCLUDE_FORM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(597620272474219118)
,p_prompt=>'Include Form'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'disabled'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(598174603004635606)
,p_name=>'P1140_REPORT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(598174545583635605)
,p_item_default=>'CR'
,p_prompt=>'Report Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1140_REPORT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(599933630533543253)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599821678943060708)
,p_name=>'P1140_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7011877070127798069)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1140_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1140_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599822421465060712)
,p_name=>'P1140_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(7011877070127798069)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599825078086060719)
,p_name=>'P1140_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(597619783321219113)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--marginTop field--noBottomPadding field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_07=>'Select Table'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599827399665060727)
,p_name=>'P1140_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(22516688040563743985)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599827796968060728)
,p_name=>'P1140_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22516688040563743985)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599828140398060728)
,p_name=>'P1140_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(22516688040563743985)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599828537718060729)
,p_name=>'P1140_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(22516688040563743985)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599828917752060729)
,p_name=>'P1140_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(22516688040563743985)
,p_item_default=>'fa-table-search'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599829399260060729)
,p_name=>'P1140_HAS_DRILLDOWN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(22516688040563743985)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(876906373199696724)
,p_name=>'P1140_OBJ_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(22516688040563743985)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(599832501490060748)
,p_computation_sequence=>10
,p_computation_item=>'P1140_HAS_DRILLDOWN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Y''',
'from wwv_flow_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE'' and',
'    c002 in ( ''INTERACTIVE_RPT'',  ''MASTER_DETAIL'' )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(599834913431060754)
,p_validation_name=>'Table cannot be null'
,p_validation_sequence=>10
,p_validation=>'P1140_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(649585402986583201)
,p_validation_name=>'is valid faceted search source'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_valid_filter_source  boolean;',
'    l_top5_facet_column_names wwv_flow_t_varchar2;',
'begin',
'    l_top5_facet_column_names := wwv_flow_faceted_search_dev.get_top5_facet_columns(',
'                                     p_table_owner    => :P1_SCHEMA,',
'                                     p_table_name     => :P1140_TABLE );',
'    ',
'    l_is_valid_filter_source := wwv_flow_faceted_search_dev.valid_faceted_search_source(',
'        p_parse_as_schema      => :P1_SCHEMA,',
'        p_location             => wwv_flow_exec_api.c_location_local_db,',
'        p_query_type           => wwv_flow_exec_api.c_query_type_table, ',
'        p_table_owner          => :P1_SCHEMA,',
'        p_table_name           => :P1140_TABLE,',
'        p_facet_columns        => l_top5_facet_column_names );',
'',
'    if l_is_valid_filter_source then',
'        return true;',
'    else',
'        -- raise validation error if not valid',
'        return false;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The wizard cannot create a faceted search using the report source.  There are no columns to search.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1140_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13218885055147305)
,p_validation_name=>'card layout type not null'
,p_validation_sequence=>80
,p_validation=>'P1140_LAYOUT_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1140_REPORT_TYPE = ''CARD'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(13577954947970770)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13427899978384619)
,p_validation_name=>'card title not null'
,p_validation_sequence=>90
,p_validation=>'P1140_TITLE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1140_REPORT_TYPE = ''CARD'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(13578312329970770)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(599837250841060757)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(599830061458060730)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(599837764916060758)
,p_event_id=>wwv_flow_imp.id(599837250841060757)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(599838141158060759)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_HOMEPAGE'
,p_condition_element=>'P1140_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(599838624143060759)
,p_event_id=>wwv_flow_imp.id(599838141158060759)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(599839149269060759)
,p_event_id=>wwv_flow_imp.id(599838141158060759)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(599839504180060760)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_ADMIN'
,p_condition_element=>'P1140_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(599840027926060760)
,p_event_id=>wwv_flow_imp.id(599839504180060760)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(599840570414060760)
,p_event_id=>wwv_flow_imp.id(599839504180060760)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(597620634470219122)
,p_name=>'Toggle Cards or Reports'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_REPORT_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(597621525200219131)
,p_event_id=>wwv_flow_imp.id(597620634470219122)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var reportType = $v(''P1140_REPORT_TYPE''),',
'    pageIcon = $v(''P1140_PAGE_ICON''),',
'    iconPicker$ = $("#icon_picker .a-Icon"),',
'    cardsIcon = ''fa-cards'',',
'    reportIcon = ''fa-table-search'',',
'    includeFormRegion$ = $("#reg_include_form"),',
'    cardsFormRegion$ = $("#reg_cards_form");',
'',
'// Hide Impacted Regions',
'includeFormRegion$.hide();',
'cardsFormRegion$.hide();',
'',
'if (reportType === ''CR'') {',
'    includeFormRegion$.show();',
'    if (pageIcon === cardsIcon) {',
'        iconPicker$.removeClass(cardsIcon).addClass(reportIcon);',
'        $s(''P1140_PAGE_ICON'',reportIcon);',
'    }',
'} else if (reportType === ''CARD'') {',
'    cardsFormRegion$.show();',
'    if (pageIcon === reportIcon) {',
'        iconPicker$.removeClass(reportIcon).addClass(cardsIcon);',
'        $s(''P1140_PAGE_ICON'',cardsIcon);',
'    }',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(601373136772988615)
,p_name=>'Get Card Title'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_TITLE_COLUMN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(601373270391988616)
,p_event_id=>wwv_flow_imp.id(601373136772988615)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1140_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1140_TITLE_COLUMN := c1.title;',
'end loop;'))
,p_attribute_03=>'P1140_TITLE_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(601373811781988622)
,p_name=>'Get Card Description'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_BODY_COLUMN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(601373928331988623)
,p_event_id=>wwv_flow_imp.id(601373811781988622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_2 as description',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1140_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1140_BODY_COLUMN  := c1.description;',
'end loop;'))
,p_attribute_03=>'P1140_BODY_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(579566279113721530)
,p_name=>'set table cache'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_TABLE'
,p_condition_element=>'P1140_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(579566318010721531)
,p_event_id=>wwv_flow_imp.id(579566279113721530)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1140_TABLE,',
'        p_cache_fk_references     => true );',
'end;'))
,p_attribute_02=>'P1140_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(601373730031988621)
,p_event_id=>wwv_flow_imp.id(579566279113721530)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_TITLE_COLUMN,P1140_BODY_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(876906762849699545)
,p_name=>'Enable or Disable Include Form'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_OBJ_TYPE'
,p_condition_element=>'P1140_OBJ_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(876907164929699548)
,p_event_id=>wwv_flow_imp.id(876906762849699545)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_INCLUDE_FORM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(876907629593699548)
,p_event_id=>wwv_flow_imp.id(876906762849699545)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_INCLUDE_FORM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(876908125797699549)
,p_event_id=>wwv_flow_imp.id(876906762849699545)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_INCLUDE_FORM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(876908598747702563)
,p_name=>'Get Object Type'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(876908994862702563)
,p_event_id=>wwv_flow_imp.id(876908598747702563)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select object_type ',
'from sys.dba_objects ',
'where owner = :P1_SCHEMA ',
'      and object_name = :P1140_TABLE',
') loop',
'    :P1140_OBJ_TYPE := c1.object_type;',
'end loop;'))
,p_attribute_02=>'P1140_TABLE'
,p_attribute_03=>'P1140_OBJ_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(632191061786032101)
,p_name=>'show/hide card attr'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_REPORT_TYPE'
,p_condition_element=>'P1140_REPORT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CARD'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(632191109860032102)
,p_event_id=>wwv_flow_imp.id(632191061786032101)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_LAYOUT_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(597621744704219133)
,p_event_id=>wwv_flow_imp.id(632191061786032101)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#reg_card_cols'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(632191285105032103)
,p_event_id=>wwv_flow_imp.id(632191061786032101)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_LAYOUT_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(597621889165219134)
,p_event_id=>wwv_flow_imp.id(632191061786032101)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#reg_card_cols'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(599836045385060756)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'    l_facet_type varchar2(255) := :P1140_REPORT_TYPE;',
'begin',
'    if :P1140_REPORT_TYPE = ''CARD'' then',
'        l_card.layout_type    := :P1140_LAYOUT_TYPE;',
'        l_card.title_column   := :P1140_TITLE_COLUMN;',
'        l_card.body_column    := :P1140_BODY_COLUMN;',
'        l_card.icon_column    := :P1140_ICON_COLUMN;',
'        l_card.badge_column   := :P1140_BADGE_COLUMN;',
'    end if;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1140_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_faceted_search,',
'        p_page_icon       => :P1140_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1140_TABLE,',
'        p_is_homepage     => ( :P1140_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1140_ADMIN = ''Y'' ),',
'        p_fs_report_type  => :P1140_REPORT_TYPE,',
'        p_card            => case when l_facet_type = ''CARD'' then l_card else null end,',
'        p_page_help       => :P1140_PAGE_HELP,',
'        p_include_form     => ( :P1140_INCLUDE_FORM = ''Y'' ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(599831639690060733)
,p_internal_uid=>599836045385060756
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(599836404251060756)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'begin',
'    if :P1140_REPORT_TYPE = ''CARD'' then',
'        l_card.layout_type    := :P1140_LAYOUT_TYPE;',
'        l_card.title_column   := :P1140_TITLE_COLUMN;',
'        l_card.body_column    := :P1140_BODY_COLUMN;',
'        l_card.icon_column    := :P1140_ICON_COLUMN;',
'        l_card.badge_column   := :P1140_BADGE_COLUMN;',
'    end if;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1140_SEQ_ID,',
'        p_page_name       => :P1140_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_faceted_search,',
'        p_page_icon       => :P1140_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1140_TABLE,',
'        p_is_homepage     => ( :P1140_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1140_ADMIN = ''Y'' ),',
'        p_fs_report_type  => :P1140_REPORT_TYPE,',
'        p_card            => l_card,',
'        p_page_help       => :P1140_PAGE_HELP,',
'        p_include_form     => ( :P1140_INCLUDE_FORM = ''Y'' ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(599831211883060733)
,p_internal_uid=>599836404251060756
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(599835231239060754)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1140_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(599830415982060732)
,p_internal_uid=>599835231239060754
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(599836885761060757)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>599836885761060757
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(599835694409060754)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c012 include_form,',
'                      c015 is_admin_page,',
'                      c016 layout_type,',
'                      c017 title_column,',
'                      c018 body_column,',
'                      c019 icon_column,',
'                      c020 badge_column,',
'                      c031 fs_report_type,',
'                      c040 help',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1140_SEQ_ID )',
'loop',
'    :P1140_PAGE_NAME := l_page.page_name;',
'    :P1140_PAGE_TYPE := l_page.page_type;',
'    :P1140_PAGE_SOURCE := l_page.source_type;',
'    :P1140_TABLE := l_page.table_name;',
'    :P1140_PAGE_ICON := l_page.page_icon;',
'    ',
'    :P1140_REPORT_TYPE := l_page.fs_report_type;',
'    :P1140_INCLUDE_FORM := l_page.include_form;',
'    ',
'    if l_page.fs_report_type = ''CARD'' then',
'        :P1140_LAYOUT_TYPE  := l_page.layout_type;',
'        :P1140_TITLE_COLUMN := l_page.title_column;',
'        :P1140_BODY_COLUMN  := l_page.body_column;',
'        :P1140_ICON_COLUMN  := l_page.icon_column;',
'        :P1140_BADGE_COLUMN := l_page.badge_column;',
'    end if;',
'',
'    :P1140_PAGE_HELP := l_page.help;',
'    ',
'    -- set object type (used for Include Form item)',
'    for l_obj in (',
'        select object_type ',
'        from sys.dba_objects ',
'        where owner = :P1_SCHEMA ',
'        and object_name = l_page.table_name )',
'    loop',
'        :P1140_OBJ_TYPE := l_obj.object_type;',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1140_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>599835694409060754
);
end;
/
prompt --application/pages/page_01150
begin
wwv_flow_imp_page.create_page(
 p_id=>1150
,p_name=>'Create Map Page'
,p_alias=>'CREATE-MAP-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Map Page'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3802851654245128)
,p_plug_name=>'Layer Type'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(601020734473382940)
,p_plug_name=>'Map Source'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7015377219709967515)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22519989627857903240)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22520288724559916920)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3301856841159279)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(22519989627857903240)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1150_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1150_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3600454290172970)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(22520288724559916920)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3600882245172971)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(22520288724559916920)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3601600683172972)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(22520288724559916920)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3602048392172972)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(22520288724559916920)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3602410675172972)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(22520288724559916920)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302215827159283)
,p_name=>'P1150_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(22519989627857903240)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302694877159285)
,p_name=>'P1150_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22519989627857903240)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3303030698159285)
,p_name=>'P1150_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(22519989627857903240)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3303464317159285)
,p_name=>'P1150_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(22519989627857903240)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3303814188159285)
,p_name=>'P1150_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(22519989627857903240)
,p_item_default=>'fa-map-marker'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3400738384163847)
,p_name=>'P1150_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3802851654245128)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_07=>'Select Table'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3401168750163849)
,p_name=>'P1150_LAYER_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3802851654245128)
,p_item_default=>'POINT'
,p_prompt=>'Layer Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'MAP_REGION_LAYER_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(3749589329218593)||'.'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3500467148169480)
,p_name=>'P1150_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7015377219709967515)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1150_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1150_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3500871641169482)
,p_name=>'P1150_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(7015377219709967515)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3800471518245104)
,p_name=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(601020734473382940)
,p_item_default=>'GEOMETRY'
,p_prompt=>'Geometry Column Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'MAP_REGION_GEOMETRY_COLUMN_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(4053243666374435)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3800655351245106)
,p_name=>'P1150_GEOM_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(601020734473382940)
,p_prompt=>'Geometry Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type in (''CLOB'', ''VARCHAR2'', ''SDO_GEOMETRY'' )',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3800753486245107)
,p_name=>'P1150_LON_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(601020734473382940)
,p_prompt=>'Longitude Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3800841041245108)
,p_name=>'P1150_LAT_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(601020734473382940)
,p_prompt=>'Latitude Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3800911929245109)
,p_name=>'P1150_3D_VALUE_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(601020734473382940)
,p_prompt=>'Extrusion Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3801001591245110)
,p_name=>'P1150_VALUE_COLUMN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(601020734473382940)
,p_prompt=>'Color Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3801102417245111)
,p_name=>'P1150_HEAT_VALUE_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(601020734473382940)
,p_prompt=>'Color Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3801242705245112)
,p_name=>'P1150_TOOLTIP_COLUMN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(601020734473382940)
,p_prompt=>'Tooltip Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4611639347161305)
,p_validation_name=>'Table cannot be null'
,p_validation_sequence=>10
,p_validation=>'P1150_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_imp.id(3400738384163847)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4611762141161306)
,p_validation_name=>'Geometry Column NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P1150_GEOM_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1150_GEOMETRY_COLUMN_TYPE = ''GEOMETRY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3800655351245106)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4611823227161307)
,p_validation_name=>'Longitude Column NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P1150_LON_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1150_GEOMETRY_COLUMN_TYPE = ''NUMBER'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3800753486245107)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4611991542161308)
,p_validation_name=>'Latitude Column NOT NULL'
,p_validation_sequence=>40
,p_validation=>'P1150_LAT_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1150_GEOMETRY_COLUMN_TYPE = ''NUMBER'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3800841041245108)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4612139308161310)
,p_validation_name=>'3D Value Column NOT NULL'
,p_validation_sequence=>50
,p_validation=>'P1150_3D_VALUE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1150_LAYER_TYPE = ''POLYGON_3D'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3800911929245109)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3801381918245113)
,p_name=>'Polygon/Line Layer'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'LINE,POLYGON'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3801457282245114)
,p_event_id=>wwv_flow_imp.id(3801381918245113)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3801534476245115)
,p_event_id=>wwv_flow_imp.id(3801381918245113)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE,P1150_3D_VALUE_COLUMN,P1150_HEAT_VALUE_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3801640037245116)
,p_event_id=>wwv_flow_imp.id(3801381918245113)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_VALUE_COLUMN,P1150_TOOLTIP_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4611264989161301)
,p_name=>'Line Layer'
,p_event_sequence=>15
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LINE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4611340754161302)
,p_event_id=>wwv_flow_imp.id(4611264989161301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_VALUE_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3801712304245117)
,p_name=>'3D Polygon Layer'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POLYGON_3D'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3801840095245118)
,p_event_id=>wwv_flow_imp.id(3801712304245117)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3801929883245119)
,p_event_id=>wwv_flow_imp.id(3801712304245117)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE,P1150_HEAT_VALUE_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3802004717245120)
,p_event_id=>wwv_flow_imp.id(3801712304245117)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_3D_VALUE_COLUMN,P1150_VALUE_COLUMN,P1150_TOOLTIP_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3802113049245121)
,p_name=>'Point Layer'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POINT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3802218260245122)
,p_event_id=>wwv_flow_imp.id(3802113049245121)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE,P1150_TOOLTIP_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3802319580245123)
,p_event_id=>wwv_flow_imp.id(3802113049245121)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_3D_VALUE_COLUMN,P1150_HEAT_VALUE_COLUMN,P1150_VALUE_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3802432466245124)
,p_name=>'Heatmap Layer'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEATMAP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3802520283245125)
,p_event_id=>wwv_flow_imp.id(3802432466245124)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE,P1150_HEAT_VALUE_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3802692377245126)
,p_event_id=>wwv_flow_imp.id(3802432466245124)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_3D_VALUE_COLUMN,P1150_VALUE_COLUMN,P1150_TOOLTIP_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3802999867245129)
,p_name=>'Geometry Column Type'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_condition_element=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOMETRY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803059472245130)
,p_event_id=>wwv_flow_imp.id(3802999867245129)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOM_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803384241245133)
,p_event_id=>wwv_flow_imp.id(3802999867245129)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_LAT_COLUMN,P1150_LON_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803181887245131)
,p_event_id=>wwv_flow_imp.id(3802999867245129)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOM_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803245447245132)
,p_event_id=>wwv_flow_imp.id(3802999867245129)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_LAT_COLUMN,P1150_LON_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3803627614245136)
,p_name=>'Cancel Dialog'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3600454290172970)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803722804245137)
,p_event_id=>wwv_flow_imp.id(3803627614245136)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4602612581701101)
,p_name=>'set table cache'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_TABLE'
,p_condition_element=>'P1150_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4602756096701102)
,p_event_id=>wwv_flow_imp.id(4602612581701101)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1150_TABLE,',
'        p_cache_fk_references      => true );',
'',
'    select case geometry_type',
'           when ''UNKNOWN'' then ''POINT''',
'           else geometry_type',
'           end',
'      into :P1150_LAYER_TYPE',
'      from wwv_dictionary_cache_obj',
'     where object_owner      = :P1_SCHEMA',
'       and object_name       = :P1150_TABLE',
'       and security_group_id = :WORKSPACE_ID;',
'exception',
'    when NO_DATA_FOUND then',
'        :P1150_LAYER_TYPE := ''POINT'';',
'end;'))
,p_attribute_02=>'P1150_TABLE'
,p_attribute_03=>'P1150_LAYER_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4619081291196647)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_map       wwv_flow_define_app_v3.t_map;',
'begin',
'    l_map.layer_type             := :P1150_LAYER_TYPE;',
'    l_map.geometry_column_type   := :P1150_GEOMETRY_COLUMN_TYPE;',
'    l_map.geometry_column        := :P1150_GEOM_COLUMN;',
'    l_map.longitude_column       := :P1150_LON_COLUMN;',
'    l_map.latitude_column        := :P1150_LAT_COLUMN;',
'    l_map.extrusion_value_column := :P1150_3D_VALUE_COLUMN;',
'    l_map.value_column           := :P1150_VALUE_COLUMN;',
'    l_map.heat_value_column      := :P1150_HEAT_VALUE_COLUMN;',
'    l_map.tooltip_column         := :P1150_TOOLTIP_COLUMN;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1150_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_map,',
'        p_page_icon       => :P1150_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1150_TABLE,',
'        p_is_homepage     => ( :P1150_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1150_ADMIN = ''Y'' ),',
'        p_map             => l_map,',
'        p_page_help       => :P1150_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3602048392172972)
,p_internal_uid=>4619081291196647
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4619335407197905)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_map       wwv_flow_define_app_v3.t_map;',
'begin',
'    l_map.layer_type             := :P1150_LAYER_TYPE;',
'    l_map.geometry_column_type   := :P1150_GEOMETRY_COLUMN_TYPE;',
'    l_map.geometry_column        := :P1150_GEOM_COLUMN;',
'    l_map.longitude_column       := :P1150_LON_COLUMN;',
'    l_map.latitude_column        := :P1150_LAT_COLUMN;',
'    l_map.extrusion_value_column := :P1150_3D_VALUE_COLUMN;',
'    l_map.value_column           := :P1150_VALUE_COLUMN;',
'    l_map.heat_value_column      := :P1150_HEAT_VALUE_COLUMN;',
'    l_map.tooltip_column         := :P1150_TOOLTIP_COLUMN;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1150_SEQ_ID,',
'        p_page_name       => :P1150_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_map,',
'        p_page_icon       => :P1150_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1150_TABLE,',
'        p_is_homepage     => ( :P1150_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1150_ADMIN = ''Y'' ),',
'        p_map             => l_map,',
'        p_page_help       => :P1150_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3601600683172972)
,p_internal_uid=>4619335407197905
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4619631855199387)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1150_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3600882245172971)
,p_internal_uid=>4619631855199387
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4619920946201686)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4619920946201686
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4627312625003033)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c012 include_form,',
'                      c015 is_admin_page,',
'                      c016 layer_type,',
'                      c017 geometry_column_type,',
'                      c018 geometry_column,',
'                      c019 longitude_column,',
'                      c020 latitude_column,',
'                      c021 extrusion_value_column,',
'                      c022 value_column,',
'                      c023 heat_value_column,',
'                      c024 tooltip_column,',
'                      c040 help',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1150_SEQ_ID )',
'loop',
'    :P1150_PAGE_NAME := l_page.page_name;',
'    :P1150_PAGE_TYPE := l_page.page_type;',
'    :P1150_PAGE_SOURCE := l_page.source_type;',
'    :P1150_TABLE := l_page.table_name;',
'    :P1150_PAGE_ICON := l_page.page_icon;',
'    ',
'    :P1150_LAYER_TYPE           := l_page.layer_type;',
'    :P1150_GEOMETRY_COLUMN_TYPE := l_page.geometry_column_type;',
'    :P1150_GEOM_COLUMN          := l_page.geometry_column;',
'    :P1150_LON_COLUMN           := l_page.longitude_column;',
'    :P1150_LAT_COLUMN           := l_page.latitude_column;',
'    :P1150_3D_VALUE_COLUMN      := l_page.extrusion_value_column;',
'    :P1150_VALUE_COLUMN         := l_page.value_column;',
'    :P1150_HEAT_VALUE_COLUMN    := l_page.heat_value_column;',
'    :P1150_TOOLTIP_COLUMN       := l_page.tooltip_column;',
'',
'    :P1150_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1150_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>4627312625003033
);
end;
/
prompt --application/pages/page_01160
begin
wwv_flow_imp_page.create_page(
 p_id=>1160
,p_name=>'Add Smart Filters Page'
,p_alias=>'ADD-SMART-FILTERS-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Smart Filters Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_PAGE_CONFIRM_MSG"'';'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_imp.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(602425565337582495)
,p_plug_name=>'Report Source Container'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(602424806970582487)
,p_plug_name=>'Table or View'
,p_parent_plug_id=>wwv_flow_imp.id(602425565337582495)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(602425296123582492)
,p_plug_name=>'Include Form'
,p_region_name=>'reg_include_form'
,p_parent_plug_id=>wwv_flow_imp.id(602425565337582495)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(602979373911998977)
,p_plug_name=>'Card Page'
,p_region_name=>'reg_cards_form'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13821737294490428737)
,p_plug_name=>'Card Columns'
,p_region_name=>'reg_card_cols'
,p_parent_plug_id=>wwv_flow_imp.id(602979373911998977)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px; display: none;"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(602979492492998978)
,p_plug_name=>'Classic Report Page'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2586890391916064979)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(602979569232998979)
,p_plug_name=>'Result Region Type'
,p_region_css_classes=>'a-BoxedLabels a-BoxedForms margin-md margin-top-none'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7016682093777161443)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_imp.id(3273871575473525717)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22521493064213107359)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22521493640556107365)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4812077941363415)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(22521493064213107359)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1160_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1160_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4815547868363419)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(22521493640556107365)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4815948157363419)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(22521493640556107365)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4816745857363420)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(22521493640556107365)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4817127380363420)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(22521493640556107365)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4817588275363420)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(22521493640556107365)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4805929940363405)
,p_name=>'P1160_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(602424806970582487)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_css_classes=>'field--marginTop field--noBottomPadding field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_07=>'Select Table'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4806373120363410)
,p_name=>'P1160_LAYOUT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(602424806970582487)
,p_item_default=>'GRID'
,p_prompt=>'Layout Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CARDS_LAYOUT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(13522227592838689)||'.'
,p_grid_column=>4
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4807097552363410)
,p_name=>'P1160_INCLUDE_FORM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(602425296123582492)
,p_prompt=>'Include Form'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'disabled'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4808010728363412)
,p_name=>'P1160_TITLE_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13821737294490428737)
,p_prompt=>'Title Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1160_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1160_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4808494254363412)
,p_name=>'P1160_BODY_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(13821737294490428737)
,p_prompt=>'Body Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1160_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1160_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4808883215363412)
,p_name=>'P1160_ICON_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(13821737294490428737)
,p_prompt=>'Icon Initials Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1160_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1160_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4809239153363412)
,p_name=>'P1160_BADGE_COLUMN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(13821737294490428737)
,p_prompt=>'Badge Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1160_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1160_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4810299762363413)
,p_name=>'P1160_REPORT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(602979569232998979)
,p_item_default=>'CR'
,p_prompt=>'Report Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1140_REPORT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(599933630533543253)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4810917271363414)
,p_name=>'P1160_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7016682093777161443)
,p_prompt=>'Set as Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1160_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1160_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4811315719363415)
,p_name=>'P1160_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(7016682093777161443)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4812402283363417)
,p_name=>'P1160_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(22521493064213107359)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4812894499363418)
,p_name=>'P1160_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22521493064213107359)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4813231579363418)
,p_name=>'P1160_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(22521493064213107359)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4813665278363418)
,p_name=>'P1160_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(22521493064213107359)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4814085822363418)
,p_name=>'P1160_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(22521493064213107359)
,p_item_default=>'fa-table-search'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4814841316363418)
,p_name=>'P1160_OBJ_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(22521493064213107359)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4819210388363441)
,p_validation_name=>'Table cannot be null'
,p_validation_sequence=>10
,p_validation=>'P1160_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4819612958363441)
,p_validation_name=>'is valid smart filter source'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_valid_filter_source  boolean;',
'    l_top5_facet_column_names wwv_flow_t_varchar2;',
'begin',
'    l_top5_facet_column_names := wwv_flow_faceted_search_dev.get_top5_facet_columns(',
'                                     p_table_owner    => :P1_SCHEMA,',
'                                     p_table_name     => :P1160_TABLE );',
'    ',
'    l_is_valid_filter_source := wwv_flow_faceted_search_dev.valid_faceted_search_source(',
'        p_parse_as_schema      => :P1_SCHEMA,',
'        p_location             => wwv_flow_exec_api.c_location_local_db,',
'        p_query_type           => wwv_flow_exec_api.c_query_type_table, ',
'        p_table_owner          => :P1_SCHEMA,',
'        p_table_name           => :P1160_TABLE,',
'        p_facet_columns        => l_top5_facet_column_names );',
'',
'    if l_is_valid_filter_source then',
'        return true;',
'    else',
'        -- raise validation error if not valid',
'        return false;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The wizard cannot create a smart filters using the report source.  There are no columns to search.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1160_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4818472649363440)
,p_validation_name=>'card layout type not null'
,p_validation_sequence=>80
,p_validation=>'P1160_LAYOUT_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1160_REPORT_TYPE = ''CARD'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(4806373120363410)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4818824054363440)
,p_validation_name=>'card title not null'
,p_validation_sequence=>90
,p_validation=>'P1160_TITLE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1160_REPORT_TYPE = ''CARD'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(4808010728363412)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4821986179363443)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4815547868363419)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4822435578363446)
,p_event_id=>wwv_flow_imp.id(4821986179363443)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4822873245363446)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_HOMEPAGE'
,p_condition_element=>'P1160_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4823347672363446)
,p_event_id=>wwv_flow_imp.id(4822873245363446)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_ADMIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4823862577363446)
,p_event_id=>wwv_flow_imp.id(4822873245363446)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_ADMIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4824274270363447)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_ADMIN'
,p_condition_element=>'P1160_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4824786351363447)
,p_event_id=>wwv_flow_imp.id(4824274270363447)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4825266842363447)
,p_event_id=>wwv_flow_imp.id(4824274270363447)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_HOMEPAGE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4825658999363447)
,p_name=>'Toggle Cards or Reports'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_REPORT_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4826180204363448)
,p_event_id=>wwv_flow_imp.id(4825658999363447)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var reportType = $v(''P1160_REPORT_TYPE''),',
'    pageIcon = $v(''P1160_PAGE_ICON''),',
'    iconPicker$ = $("#icon_picker .a-Icon"),',
'    cardsIcon = ''fa-cards'',',
'    reportIcon = ''fa-table-search'',',
'    includeFormRegion$ = $("#reg_include_form"),',
'    cardsFormRegion$ = $("#reg_cards_form");',
'',
'// Hide Impacted Regions',
'includeFormRegion$.hide();',
'cardsFormRegion$.hide();',
'',
'if (reportType === ''CR'') {',
'    includeFormRegion$.show();',
'    if (pageIcon === cardsIcon) {',
'        iconPicker$.removeClass(cardsIcon).addClass(reportIcon);',
'        $s(''P1160_PAGE_ICON'',reportIcon);',
'    }',
'} else if (reportType === ''CARD'') {',
'    cardsFormRegion$.show();',
'    if (pageIcon === reportIcon) {',
'        iconPicker$.removeClass(reportIcon).addClass(cardsIcon);',
'        $s(''P1160_PAGE_ICON'',cardsIcon);',
'    }',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4826578679363448)
,p_name=>'Get Card Title'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_TITLE_COLUMN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4827061493363448)
,p_event_id=>wwv_flow_imp.id(4826578679363448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1160_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1160_TITLE_COLUMN := c1.title;',
'end loop;'))
,p_attribute_03=>'P1160_TITLE_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4827479800363448)
,p_name=>'Get Card Description'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_BODY_COLUMN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4827924026363448)
,p_event_id=>wwv_flow_imp.id(4827479800363448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_2 as description',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1160_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1160_BODY_COLUMN  := c1.description;',
'end loop;'))
,p_attribute_03=>'P1160_BODY_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4828333012363448)
,p_name=>'set table cache'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_TABLE'
,p_condition_element=>'P1160_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4828863312363449)
,p_event_id=>wwv_flow_imp.id(4828333012363448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1160_TABLE,',
'        p_cache_fk_references     => true );',
'end;'))
,p_attribute_02=>'P1160_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4829367827363449)
,p_event_id=>wwv_flow_imp.id(4828333012363448)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_TITLE_COLUMN,P1160_BODY_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4829703065363449)
,p_name=>'Enable or Disable Include Form'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_OBJ_TYPE'
,p_condition_element=>'P1160_OBJ_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4830294754363449)
,p_event_id=>wwv_flow_imp.id(4829703065363449)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_INCLUDE_FORM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4830716977363449)
,p_event_id=>wwv_flow_imp.id(4829703065363449)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_INCLUDE_FORM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4831279592363450)
,p_event_id=>wwv_flow_imp.id(4829703065363449)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_INCLUDE_FORM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4831661448363451)
,p_name=>'Get Object Type'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4832193814363451)
,p_event_id=>wwv_flow_imp.id(4831661448363451)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select object_type ',
'from sys.dba_objects ',
'where owner = :P1_SCHEMA ',
'      and object_name = :P1160_TABLE',
') loop',
'    :P1160_OBJ_TYPE := c1.object_type;',
'end loop;'))
,p_attribute_02=>'P1160_TABLE'
,p_attribute_03=>'P1160_OBJ_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4832583833363451)
,p_name=>'show/hide card attr'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_REPORT_TYPE'
,p_condition_element=>'P1160_REPORT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CARD'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4833082504363451)
,p_event_id=>wwv_flow_imp.id(4832583833363451)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_LAYOUT_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4833547225363451)
,p_event_id=>wwv_flow_imp.id(4832583833363451)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#reg_card_cols'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4834074587363451)
,p_event_id=>wwv_flow_imp.id(4832583833363451)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_LAYOUT_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4834521988363452)
,p_event_id=>wwv_flow_imp.id(4832583833363451)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#reg_card_cols'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4820769444363442)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'    l_facet_type varchar2(255) := :P1160_REPORT_TYPE;',
'begin',
'    if :P1160_REPORT_TYPE = ''CARD'' then',
'        l_card.layout_type    := :P1160_LAYOUT_TYPE;',
'        l_card.title_column   := :P1160_TITLE_COLUMN;',
'        l_card.body_column    := :P1160_BODY_COLUMN;',
'        l_card.icon_column    := :P1160_ICON_COLUMN;',
'        l_card.badge_column   := :P1160_BADGE_COLUMN;',
'    end if;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1160_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_smart_filters,',
'        p_page_icon       => :P1160_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1160_TABLE,',
'        p_is_homepage     => ( :P1160_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1160_ADMIN = ''Y'' ),',
'        p_fs_report_type  => :P1160_REPORT_TYPE,',
'        p_card            => case when l_facet_type = ''CARD'' then l_card else null end,',
'        p_page_help       => :P1160_PAGE_HELP,',
'        p_include_form     => ( :P1160_INCLUDE_FORM = ''Y'' ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4817127380363420)
,p_internal_uid=>4820769444363442
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4821179934363443)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'begin',
'    if :P1160_REPORT_TYPE = ''CARD'' then',
'        l_card.layout_type    := :P1160_LAYOUT_TYPE;',
'        l_card.title_column   := :P1160_TITLE_COLUMN;',
'        l_card.body_column    := :P1160_BODY_COLUMN;',
'        l_card.icon_column    := :P1160_ICON_COLUMN;',
'        l_card.badge_column   := :P1160_BADGE_COLUMN;',
'    end if;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1160_SEQ_ID,',
'        p_page_name       => :P1160_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_smart_filters,',
'        p_page_icon       => :P1160_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1160_TABLE,',
'        p_is_homepage     => ( :P1160_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1160_ADMIN = ''Y'' ),',
'        p_fs_report_type  => :P1160_REPORT_TYPE,',
'        p_card            => l_card,',
'        p_page_help       => :P1160_PAGE_HELP,',
'        p_include_form     => ( :P1160_INCLUDE_FORM = ''Y'' ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4816745857363420)
,p_internal_uid=>4821179934363443
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4819923666363441)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1160_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4815948157363419)
,p_internal_uid=>4819923666363441
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4821581610363443)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4821581610363443
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4820379609363442)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c012 include_form,',
'                      c015 is_admin_page,',
'                      c016 layout_type,',
'                      c017 title_column,',
'                      c018 body_column,',
'                      c019 icon_column,',
'                      c020 badge_column,',
'                      c031 fs_report_type,',
'                      c040 help',
'               from wwv_flow_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1160_SEQ_ID )',
'loop',
'    :P1160_PAGE_NAME := l_page.page_name;',
'    :P1160_PAGE_TYPE := l_page.page_type;',
'    :P1160_PAGE_SOURCE := l_page.source_type;',
'    :P1160_TABLE := l_page.table_name;',
'    :P1160_PAGE_ICON := l_page.page_icon;',
'    ',
'    :P1160_REPORT_TYPE := l_page.fs_report_type;',
'    :P1160_INCLUDE_FORM := l_page.include_form;',
'    ',
'    if l_page.fs_report_type = ''CARD'' then',
'        :P1160_LAYOUT_TYPE  := l_page.layout_type;',
'        :P1160_TITLE_COLUMN := l_page.title_column;',
'        :P1160_BODY_COLUMN  := l_page.body_column;',
'        :P1160_ICON_COLUMN  := l_page.icon_column;',
'        :P1160_BADGE_COLUMN := l_page.badge_column;',
'    end if;',
'',
'    :P1160_PAGE_HELP := l_page.help;',
'    ',
'    -- set object type (used for Include Form item)',
'    for l_obj in (',
'        select object_type ',
'        from sys.dba_objects ',
'        where owner = :P1_SCHEMA ',
'        and object_name = l_page.table_name )',
'    loop',
'        :P1160_OBJ_TYPE := l_obj.object_type;',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1160_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>4820379609363442
);
end;
/
prompt --application/pages/page_02000
begin
wwv_flow_imp_page.create_page(
 p_id=>2000
,p_name=>'APEX Assistant'
,p_alias=>'APEX-ASSISTANT'
,p_page_mode=>'MODAL'
,p_step_title=>'APEX Assistant'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4020_p2000#MIN#.js'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1516172930017302)
,p_plug_name=>'No Tables Found'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(3330277939666606656)
,p_plug_display_sequence=>30
,p_location=>null
,p_plug_source=>'To create an application using AI, you first need to have some tables in your workspace. Get started by installing one of the provided Sample Datasets and then return to this wizard to continue.'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_tables',
' where owner = :P2000_DEFAULT_SCHEMA'))
,p_ai_enabled=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_objects',
' where object_type = ''TABLE''',
'   and owner       = :P2000_DEFAULT_SCHEMA',
'   or 1 = 1'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1612689903817303)
,p_plug_name=>'Data Dictionary Cache Needs Refresh'
,p_region_name=>'refresh_cache'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle a-Alert--inline a-Alert--flushed'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(3330277939666606656)
,p_plug_display_sequence=>10
,p_location=>null
,p_plug_source=>'It looks like there are some changes to tables in your workspace. Please refresh the data dictionary cache to work with the latest tables.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_dictionary_cache_dev.table_cache_in_sync'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2708283841383907)
,p_plug_name=>'Create App Using Generative AI'
,p_region_css_classes=>'a-ChatClient-outerWrapper'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_location=>null
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_dictionary_cache_dev.table_cache_found'
,p_plug_display_when_cond2=>'PLSQL'
,p_ai_enabled=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_dictionary_cache_obj',
' where security_group_id = :WORKSPACE_ID',
'   and object_owner      = :P2000_DEFAULT_SCHEMA'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2708838217383913)
,p_plug_name=>'No Data Dictionary Cache Found'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(3330277939666606656)
,p_plug_display_sequence=>40
,p_location=>null
,p_plug_source=>'It looks like the data dictionary cache does NOT have any data for your workspace tables. You will need to refresh the data dictionary cache before you can proceed.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_dictionary_cache_dev.table_cache_found'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1516564127017306)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2708838217383913)
,p_button_name=>'REFRESH_CACHE_ALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Cache'
,p_button_position=>'CREATE'
,p_show_processing=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2709017215383915)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1516172930017302)
,p_button_name=>'INSTALL_SAMPLE_DATA'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Browse Sample Datasets'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=4300:100:&SESSION.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1612793737817304)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1612689903817303)
,p_button_name=>'REFRESH_CACHE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(2758666493011882367)
,p_button_image_alt=>'Refresh Cache'
,p_button_position=>'CREATE'
,p_show_processing=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4601521538636903)
,p_branch_name=>'Go To Create App Wizard'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.:NEW:&DEBUG.:1:P1_SCHEMA,P1_LAST_PAGE:&P2000_DEFAULT_SCHEMA.,2000'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_APP'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1516348400017304)
,p_name=>'P2000_DEFAULT_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2708283841383907)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2708332882383908)
,p_name=>'P2000_AI_PROMPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2708283841383907)
,p_display_as=>'PLUGIN_AI_ITEM_PLUGIN'
,p_plugin_init_javascript_code=>'aiChatWidgetInit'
,p_attribute_01=>'INLINE'
,p_attribute_03=>'Y'
,p_ai_enabled=>true
,p_ai_system_prompt=>'APEX$CREATE_APP'
,p_ai_welcome_message=>'Let''s create an app together. Describe the app you want to create, including the data or tables it will use.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2709448298383919)
,p_name=>'P2000_AI_SAMPLES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2708283841383907)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4405245348351701)
,p_name=>'P2000_AI_ACTION'
,p_data_type=>'CLOB'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2708283841383907)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
,p_ai_enabled=>false
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1516465450017305)
,p_computation_sequence=>10
,p_computation_item=>'P2000_DEFAULT_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2710164782383926)
,p_computation_sequence=>20
,p_computation_item=>'P2000_AI_SAMPLES'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_blueprint_v3.get_ai_sample_actions( p_schema => :P2000_DEFAULT_SCHEMA );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4601399894636901)
,p_name=>'On Chat Button Click'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.a-ChatItem-messageButton'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4601415458636902)
,p_event_id=>wwv_flow_imp.id(4601399894636901)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'console.log(''clicked'', this);'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2709150223383916)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.set_workspace_cache(',
'    p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'    p_gather_stats            => false,',
'    p_max_cache_stale_seconds => 2,  ',
'    p_max_tables_per_schema   => 1000);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REFRESH_CACHE, REFRESH_CACHE_ALL'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>2709150223383916
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_imp_shared.create_install(
 p_id=>wwv_flow_imp.id(2593465981597452926)
);
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_imp.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false)
);
commit;
end;
/
set verify on feedback on define on
prompt  ...done
