prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- Oracle APEX export file
--
-- You should run this script using a SQL client connected to the database as
-- the owner (parsing schema) of the application or as a database user with the
-- APEX_ADMINISTRATOR_ROLE role.
--
-- This export file has been automatically generated. Modifying this file is not
-- supported by Oracle and can lead to unexpected application and/or instance
-- behavior now or in the future.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_imp.import_begin (
 p_version_yyyy_mm_dd=>'2024.05.31'
,p_release=>'24.1.0'
,p_default_workspace_id=>10
,p_default_application_id=>4050
,p_default_id_offset=>0
,p_default_owner=>'APEX_240100'
);
end;
/
 
prompt APPLICATION 4050 - Oracle APEX Internal Administration
--
-- Application Export:
--   Application:     4050
--   Name:            Oracle APEX Internal Administration
--   Exported By:     APEX_240100
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    201
--       Items:                  635
--       Computations:            61
--       Validations:            190
--       Processes:              187
--       Regions:                748
--       Buttons:                361
--       Dynamic Actions:         86
--     Shared Components:
--       Logic:
--         Items:                  8
--         Processes:              1
--         Computations:           6
--         Build Options:          4
--       Navigation:
--         Lists:                 48
--         Breadcrumbs:            1
--           Entries:            184
--         NavBar Entries:         4
--       Security:
--         Authentication:         9
--         Authorization:          8
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                 8
--           Region:              41
--           Label:               13
--           List:                15
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           2
--           Button:              12
--           Report:              13
--         LOVs:                 123
--         Shortcuts:              5
--         Plug-ins:              13
--       PWA:
--       Globalization:
--         Messages:               3
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--   Version:         24.1.0
--   Instance ID:     1000197243005302
--

prompt --application/delete_application
begin
wwv_flow_imp.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_imp_workspace.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_240100')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Internal Administration')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'INSTANCE-ADMIN')
,p_application_group=>wwv_flow_imp.id(91050719712959059)
,p_application_group_name=>'APEX Product'
,p_application_group_comment=>'Applications shipped with the APEX product distribution'
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20240716121407'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_accessible_read_only=>'N'
,p_session_state_commits=>'IMMEDIATE'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_publish_yn=>'Y'
,p_documentation_banner=>'Oracle APEX instance wide administration user interface.  Provides a privileged APEX administrator management control over all APEX workspaces.'
,p_authentication_id=>wwv_flow_imp.id(540226219724705040)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 24.1.0'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_pass_ecid=>'N'
,p_security_scheme=>wwv_flow_imp.id(1018002984071621)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_substitution_string_01=>'LOGOUT'
,p_substitution_value_01=>'Logout'
,p_substitution_string_02=>'DELETE_MSG'
,p_substitution_value_02=>'Would you like to perform this delete action?'
,p_substitution_string_03=>'HELP'
,p_substitution_value_03=>'Help'
,p_substitution_string_04=>'PRODUCT_NAME'
,p_substitution_value_04=>'Oracle APEX'
,p_substitution_string_05=>'COMPANY_NAME'
,p_substitution_value_05=>'Workspace'
,p_substitution_string_06=>'MSG_COMPANY'
,p_substitution_value_06=>'Workspace: &COMPANY.'
,p_substitution_string_07=>'MSG_LANGUAGE'
,p_substitution_value_07=>'Language'
,p_substitution_string_08=>'MSG_COPYRIGHT'
,p_substitution_value_08=>'Copyright &copy; 1999, 2024, Oracle and/or its affiliates.'
,p_substitution_string_09=>'MSG_USER'
,p_substitution_value_09=>'User'
,p_substitution_string_10=>'MSG_JSCRIPT'
,p_substitution_value_10=>'You must run this product with JavaScript enabled.'
,p_substitution_string_11=>'MSG_TBL_SUMMARY'
,p_substitution_value_11=>'Page Layout Table'
,p_substitution_string_12=>'EDIT'
,p_substitution_value_12=>'Edit'
,p_substitution_string_13=>'MSG_WORKSPACE'
,p_substitution_value_13=>'Workspace'
,p_substitution_string_14=>'TOP'
,p_substitution_value_14=>'Top'
,p_substitution_string_15=>'CLOSE'
,p_substitution_value_15=>'Close'
,p_substitution_string_16=>'DATE_FORMAT'
,p_substitution_value_16=>'mm/dd/yyyy'
,p_substitution_string_17=>'LONG_DATE_FORMAT'
,p_substitution_value_17=>'fmDay, Month dd, yyyy'
,p_substitution_string_18=>'TIME_FORMAT'
,p_substitution_value_18=>'fmhh:mi:ss AM'
,p_substitution_string_19=>'DATE_TIME_FORMAT'
,p_substitution_value_19=>'mm/dd/yyyy hh:mi:ss AM'
,p_substitution_string_20=>'RETURN_TO_APP'
,p_substitution_value_20=>'Return to Application'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_print_server_type=>'INSTANCE'
,p_file_storage=>'DB'
,p_is_pwa=>'N'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_imp_shared.create_user_interface(
 p_id=>wwv_flow_imp.id(4050)
,p_theme_id=>3
,p_home_url=>'f?p=4050:3:&SESSION.'
,p_login_url=>'f?p=4550:10:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>0
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_include_jquery_migrate=>true
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_create_options
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2335847754387056)
,p_name=>'workspace.create.options'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557188
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2336044457387057)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'New Schema'
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142:P142_NEW_USER_YN:Y:'
,p_list_item_icon=>'icon-database-object'
,p_list_text_01=>'Create a new database schema for your workspace'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2336499120387059)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Existing Schema'
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142:P142_NEW_USER_YN:N:'
,p_list_item_icon=>'icon-util-workspace-actions'
,p_list_text_01=>'Associate your workspace with an existing database schema'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workload
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2800747079731824)
,p_name=>'Workload'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2801361336731843)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Instance Metrics'
,p_list_item_link_target=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-instance-metrics'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2800977995731841)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Workspace Metrics'
,p_list_item_link_target=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-workspace-metrics'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2801762750731843)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Schema Metrics'
,p_list_item_link_target=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-schema-metrics'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(19505672154149561)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Summary Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:1029:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-summary-dashboard'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/session_state_management
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3417102067886535)
,p_name=>'session.state.management'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3439527750998023)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Recent Sessions'
,p_list_item_link_target=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-recent-sessions'
,p_list_text_01=>'Review the recent sessions instance-wide, including username and workspace.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3462301271103893)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Purge Sessions'
,p_list_item_link_target=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge session state information based on the age of the session.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3417616612890680)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Session State Statistics'
,p_list_item_link_target=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-session-state-statistics'
,p_list_text_01=>'Statistics on the number of sessions and cached entries.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2103565402757427)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Background Executions'
,p_list_item_link_target=>'f?p=&APP_ID.:191:&SESSION.::&DEBUG.:191,192:::'
,p_list_item_icon=>'icon-util-gear'
,p_list_text_01=>'Review recent background executions for page processes, instance-wide.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/log_management
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(5021913929565780)
,p_name=>'log.management'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(217657516318353638)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Manage Log Interval'
,p_list_item_link_target=>'f?p=&APP_ID.:119:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1218056692025697508)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Archive Activity Log'
,p_list_item_link_target=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22612925776612371)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'SQL Workshop Log'
,p_list_item_link_target=>'f?p=&APP_ID.:46:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'46'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5024227220579151)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Page View Activity Log'
,p_list_item_link_target=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5032419648605291)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Developer Activity Log'
,p_list_item_link_target=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5141329999655580)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'External Click Counting Log'
,p_list_item_link_target=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15382629387113488)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Login Access Log'
,p_list_item_link_target=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(620861715997218025)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Web Service Activity Log'
,p_list_item_link_target=>'f?p=&APP_ID.:139:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1415760425022980)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'REST Synchronization Log'
,p_list_item_link_target=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1592978610657004)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Automation Log'
,p_list_item_link_target=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(10332318553893424)
,p_name=>'workspace reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10336708903919077)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Existing Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10338404532927250)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Workspace Details'
,p_list_item_link_target=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:RP,14:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10335923317913792)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Workspace Database Privileges'
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168488129805460181)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Manage File Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1222568618805757405)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Find and Email Workspace Summary'
,p_list_item_link_target=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(524767964229086348)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Data Dictionary Cache'
,p_list_item_link_target=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP,150:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/auto_provision_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(12048115202363924)
,p_name=>'auto.provision.progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12057805252417809)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identify Workspace'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'27'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12659809588228188)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Identify Schema'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'79'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12058110447419334)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identify Administrator'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'72'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12058415642420858)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirm Request'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'73'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168860731992836215)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Success Confirmation'
,p_list_item_link_target=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'74'
);
end;
/
prompt --application/shared_components/navigation/lists/top_activity
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(12200122728308114)
,p_name=>'Top  Activity'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12200375677308138)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Top Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12200755605308141)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Top Applications'
,p_list_item_link_target=>'f?p=&APP_ID.:1021:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(19038392191052555)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Top Users'
,p_list_item_link_target=>'f?p=&APP_ID.:1035:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/company_admin_remove
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(14571819699173520)
,p_name=>'company.admin.remove'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14575726756185055)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identify Workspace'
,p_list_item_link_target=>'f?p=&FLOW_ID.:81:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'81'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14576220654192685)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Verify Applications'
,p_list_item_link_target=>'f?p=&FLOW_ID.:82:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'82'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14576707972198542)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirm Workspace Removal'
,p_list_item_link_target=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'83'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activtiy_date_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(14738731575074699)
,p_name=>'monitor.activtiy.date.reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14743211405087780)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Workspace Last Used'
,p_list_item_link_target=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_disp_cond_type=>'NOT_EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flows where id = 4000 and FLOW_VERSION like ''% 2.1.%'''
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14744721102090541)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'By Day by Application and User'
,p_list_item_link_target=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14745728374092653)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'By Hour'
,p_list_item_link_target=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_os_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(14750409028115431)
,p_name=>'monitor.activity.os.reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14750617712115433)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'By Operating System'
,p_list_item_link_target=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14751517869115434)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'By Browser'
,p_list_item_link_target=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14750901683115434)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'By User Agent'
,p_list_item_link_target=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14751217522115434)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'By External Site'
,p_list_item_link_target=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/instance_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(17630360313346135)
,p_name=>'Instance Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(17630537030346137)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Events'
,p_list_item_link_target=>'f?p=&APP_ID.:1025:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(17630931453346138)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Database & APEX versions'
,p_list_item_link_target=>'f?p=&APP_ID.:1033:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/company_admin_schema
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(18701007817245520)
,p_name=>'company.admin.schema'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(18701529288251758)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'New or Existing'
,p_list_item_link_target=>'f?p=4050:105:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'105'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(18702119030258176)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Choose Workspace'
,p_list_item_link_target=>'f?p=4050:107:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'107'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(18701805178254192)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Identify Schema'
,p_list_item_link_target=>'f?p=&FLOW_ID.:106:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'106'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(18702425610260147)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=4050:108:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'108'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_service
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(19017202882431374)
,p_name=>'manage.service'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(75154318706107288)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Site-Specific Tasks'
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:17:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2584422400873819)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Session State'
,p_list_item_link_target=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(50289618943123605)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Mail Queue'
,p_list_item_link_target=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2008440837899400)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Push Notifications Queue'
,p_list_item_link_target=>'f?p=&APP_ID.:125:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2702728512959332)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Manage Download Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_disp_cond_type=>'HTTP_HOST_EQ_CONDITION'
,p_list_item_disp_condition=>'marvel.oracle.com'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3573418802449584)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'File Permissions'
,p_list_item_link_target=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(201522704568695924)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Installed Translations'
,p_list_item_link_target=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(274115211211763732)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Interactive Report Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_workspace
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(19017606691432489)
,p_name=>'Manage Workspace'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2569313499653574)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(384629092101759662)
,p_list_item_display_sequence=>10.5
,p_list_item_link_text=>'Create Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:142:LAST_VIEW:10:'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(203140401722334966)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'Create Multiple Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:115,116,117:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14538928292646129)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Remove Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81,82:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(74659715539048394)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Lock Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:89,90:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(19720903523535398)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Manage Workspace to Schema Assignments'
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14539719765653081)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Manage Developers and Users'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(173286806863766271)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Manage Component Availability'
,p_list_item_link_target=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/admin_digest_workspace_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(20824651862610331)
,p_name=>'Admin Digest - Workspace Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20824841674610333)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Existing Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20825208823610335)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Workspace Metrics'
,p_list_item_link_target=>'f?p=&APP_ID.:1001:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20825606070610335)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Active Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:1005:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20827744519628249)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Top Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/admin_digest_application_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(20826645134625313)
,p_name=>'Admin Digest - Application Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20826841855625313)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Active Applications'
,p_list_item_link_target=>'f?p=&APP_ID.:1007:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20827244162625314)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Top Applications'
,p_list_item_link_target=>'f?p=&APP_ID.:1021:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/admin_digest_schema_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(20828148654638359)
,p_name=>'Admin Digest - Schema Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20828324279638359)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Parsing Schemas'
,p_list_item_link_target=>'f?p=&APP_ID.:401:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20828732453638360)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Schema Metrics'
,p_list_item_link_target=>'f?p=&APP_ID.:1003:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20829150197638360)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Workspace Schemas'
,p_list_item_link_target=>'f?p=&APP_ID.:1004:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/admin_digest_user_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(20829938868705277)
,p_name=>'Admin Digest - User Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20830135136705277)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Developers and Users'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20830534979705278)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Workspace Users'
,p_list_item_link_target=>'f?p=&APP_ID.:1006:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20830944471705278)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Top Users'
,p_list_item_link_target=>'f?p=&APP_ID.:1035:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(29722514446881924)
,p_name=>'Workspace Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(29722732656881928)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74:::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(385021728151143594)
,p_list_item_display_sequence=>10.5
,p_list_item_link_text=>'Create Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:142:LAST_VIEW:3:'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(203154302892486334)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'Create Multiple Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:RP,115,116,117:::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(29758112134439446)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Find a Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(29723016608881931)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:81,82:::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46460724791484872)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Create User'
,p_list_item_link_target=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:23,EDIT_USER_PRIVS:::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46461311070490353)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Find a User'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168923102453062025)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Reset User Password'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(40102013671283832)
,p_name=>'Tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557190
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40120501775346610)
,p_list_item_display_sequence=>0
,p_list_item_link_text=>'Home'
,p_list_item_link_target=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3,8000'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40102417827285020)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'Manage Requests Drill Down'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4,5,6,7,8,26,28,55,56,110'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192003502869565470)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'All Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(40102417827285020)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192008121139589728)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Workspace Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RIR:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40102417827285020)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192008426680591330)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Change Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RIR:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40102417827285020)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Manage Instance'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'Manage Instance Drill Down'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9,16,17,18,19,42,46,47,48,51,57,58,61,62,63,64,65,66,67,70,75,85,97,100,103,109,112,120,121,125,130,131,132,133,555,104,126,127,128,129,139'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192009126119600562)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Feature Configuration'
,p_list_item_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:16:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192009404086603691)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Security'
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:RP,130:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192021904535736262)
,p_list_item_display_sequence=>91
,p_list_item_link_text=>'...Manage Password Complexity'
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:130:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192009919323608095)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Instance Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:RP,131:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(505869000009873298)
,p_list_item_display_sequence=>101
,p_list_item_link_text=>'Workspace Purge'
,p_list_item_link_target=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:133:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192010225903610036)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Login Message'
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:41:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192010501793612513)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'System Message'
,p_list_item_link_target=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:132:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192010809065614604)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Mail Queue'
,p_list_item_link_target=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:120:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2008005846893498)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Push Notifications Queue'
,p_list_item_link_target=>'f?p=&APP_ID.:125:&SESSION.::&DEBUG.:125:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192011102270622092)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Manage Public Themes'
,p_list_item_link_target=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:555:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192011427682638942)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Manage Site-Specific Resources'
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:RP,18,RIR:::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192011731491640037)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'More...'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(168497310730577652)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Manage Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'Manage Workspaces Drill Down'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1,2,10,11,12,14,20,21,22,23,27,52,53,72,73,74,78,79,81,82,83,84,89,90,105,106,107,108,163,165,173,277,278,400,401,460,461,4001'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192012018809645759)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Create Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:RP,27,79,72,73,74:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(384636912354118367)
,p_list_item_display_sequence=>175
,p_list_item_link_text=>'Create Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:RP,142:LAST_VIEW:&APP_PAGE_ID.:'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192012326774648053)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'Remove Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81,82:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192012604395651102)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Lock Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:89,90:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192012915477654263)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Manage Schema Assignments'
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:21:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192013221710656102)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Manage Developers and Users'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:RP,RIR,12:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192013528290657957)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'Component Availability'
,p_list_item_link_target=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:52:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192013809374661985)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192014115261663655)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:461:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192037810881946241)
,p_list_item_display_sequence=>245
,p_list_item_link_text=>'Find Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:8000,RIR:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192014424612666345)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'More...'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(40117612941330955)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40118231988336452)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Monitor Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'Monitor Activity Drill Down'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'15,24,25,29,30,33,35,36,37,38,40,43,45,49,54,68,69,77,80,87,91,98,99,122,123,500,501,94,101'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(97482876556871897)
,p_list_item_display_sequence=>255
,p_list_item_link_text=>'Administrator Digest'
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(40118231988336452)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192015123011675355)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'By Page View'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:30,RIR:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40118231988336452)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192022507006765338)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>'By Application and User'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:49,RIR:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40118231988336452)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192023224668770519)
,p_list_item_display_sequence=>290
,p_list_item_link_text=>'By User'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:RIR,36:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40118231988336452)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192023531594772458)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'By Application'
,p_list_item_link_target=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:44,RIR:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40118231988336452)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192023804367774121)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'By Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:33,RIR:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40118231988336452)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192024111293776033)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'By Day'
,p_list_item_link_target=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:54,RIR:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40118231988336452)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(505871428238919208)
,p_list_item_display_sequence=>321
,p_list_item_link_text=>'Workspace Purge'
,p_list_item_link_target=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:RP,99:::'
,p_parent_list_item_id=>wwv_flow_imp.id(40118231988336452)
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192024420643778774)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'More...'
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(40118231988336452)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_import_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(44758222502979988)
,p_name=>'workspace.import.progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557196
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(44758413648979994)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Specify File'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(44758705753979997)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'File Import Confirmation'
,p_list_item_link_target=>'f?p=&APP_ID.:163:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(44772030609546251)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Install'
,p_list_item_link_target=>'f?p=&APP_ID.:165:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_install_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(44806708563745373)
,p_name=>'workspace.install.progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557196
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(44807506675745375)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Choose Schema'
,p_list_item_link_target=>'f?p=&APP_ID.:277:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(44807814227745375)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirmation'
,p_list_item_link_target=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(44808114099745375)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Install'
,p_list_item_link_target=>'f?p=&APP_ID.:165:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_environment_settings
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47534314618390800)
,p_name=>'Manage Environment Settings'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557196
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47534823276393319)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Feature Configuration'
,p_list_item_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47535207130398100)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Security'
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47556700138566373)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Instance Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(499030206357384810)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Workspace Purge'
,p_list_item_link_target=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(617444115874754241)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Workspace Purge Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:RP,133:::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25757200722107116)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Manage New Service Signup Wizard'
,p_list_item_link_target=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.::P111_ID:1:'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_workspace_export_import
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47558804136960608)
,p_name=>'Manage Workspace Export Import'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557200
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47560509223960618)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Import Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47560826571960618)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Export Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/login_attempts
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(49036204543378170)
,p_name=>'Login Attempts'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557200
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49037015450378171)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Login Attempts'
,p_list_item_link_target=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49037309244378171)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Developer Last Login'
,p_list_item_link_target=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/export_install_navigate
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(79863815294295743)
,p_name=>'export.install.navigate'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557200
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(166801801886544568)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'View Imported Workspace Export Files'
,p_list_item_link_target=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_app_temp_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(122623332344967000)
,p_name=>'workspace_app_temp_progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557200
);
end;
/
prompt --application/shared_components/navigation/lists/service_requests
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(130557109467559465)
,p_name=>'Service Requests'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557200
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(132554913295711981)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'New Service Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:114:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(130557304381559466)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Signup Survey'
,p_list_item_link_target=>'f?p=&APP_ID.:113:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_public_themes
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(137961006165346808)
,p_name=>'Manage Public Themes'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557200
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(137961613784349078)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Public Themes'
,p_list_item_link_target=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'height="20" width="20" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_theme_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(138045104803643281)
,p_name=>'workspace theme progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557200
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(138155608448962419)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'47'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(138156115720964594)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application'
,p_list_item_link_target=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'57'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(138045412824643282)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'58'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(138045720718643283)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Name'
,p_list_item_link_target=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'48'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(138046016071643283)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'51'
);
end;
/
prompt --application/shared_components/navigation/lists/instance_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(156499890019184474)
,p_name=>'Instance Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557202
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(156500036255184475)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Feature Configuration'
,p_list_item_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(156500454288184476)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Security'
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(156500851035184476)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Instance Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(156501207041184476)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Workspace Purge'
,p_list_item_link_target=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(156501635648184476)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Workspace Purge Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:RP,133:::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(156502033281184477)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Manage New Service Signup Wizard'
,p_list_item_link_target=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.::P111_ID:1:'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(156508644294219862)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Administrator Digest'
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_page_views
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(159973015345793688)
,p_name=>'monitor.activity.page.views'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557202
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1218051315822598819)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47119805406156631)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'By View'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(159976029543797841)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'By Application and User'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14732210619030758)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'By User'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1813874215800004904)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Page Views by User by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:94:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(159984106949810197)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'By Application'
,p_list_item_link_target=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(159989500154817684)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'By Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(500564182435006003)
,p_list_item_display_sequence=>51
,p_list_item_link_text=>'By Workspace Faceted Search'
,p_list_item_link_target=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47158410057668832)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'By Day'
,p_list_item_link_target=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(253974113497584304)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'By REST Access'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RP:IR_APPLICATION_INFO:REST access:'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_messages
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(168505619846788416)
,p_name=>'Manage Messages'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557202
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2600434502630589)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Define Environment Banner'
,p_list_item_link_target=>'f?p=&APP_ID.:280:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168505927811790760)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Define Login Message'
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168506130928791641)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Define System Message'
,p_list_item_link_target=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168524005844973626)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Site-Specific Resources'
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_service_requests
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(168703120343616153)
,p_name=>'manage service requests'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557202
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168703604544621069)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Open Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168704030863628594)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'All Workspace Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'26'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168704311255632456)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'All Change Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'28'
);
end;
/
prompt --application/shared_components/navigation/lists/home_page_list
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(168902912946497370)
,p_name=>'home page list'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557202
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168917021744935171)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Requests'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-requests'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168904404204513786)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Manage Instance'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-instance'
,p_list_item_icon_attributes=>'alt="" height="128" width="128"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168918009062940911)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-workspaces'
,p_list_item_icon_attributes=>'alt="" height="128" width="128"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168918216334942988)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Monitor Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-monitor-activity'
,p_list_item_icon_attributes=>'alt="" height="128" width="128"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/archived_activity_report
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(201292222959269624)
,p_name=>'archived activity report'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557202
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(201292732309272286)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Activity by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:68:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(201293002658273224)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Activity by Application by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(219090408531367773)
,p_list_item_display_sequence=>22
,p_list_item_link_text=>'Application Hash by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(880162413033281115)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Activity by Application'
,p_list_item_link_target=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(201293307160274558)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Activity by Workspace by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(879916141112685248)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Activity by Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(491858502361188089)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Chart of Page Events by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(629291230431615041)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Chart of Active Workspaces by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/self_service_sign_up
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(203028225668057376)
,p_name=>'Self Service Sign Up'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557202
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(203028409925057378)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage New Service Signup Wizard'
,p_list_item_link_target=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.::P111_ID:1:'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_icon_alt_attribute=>'target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(203028703930057378)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Run New Service Signup Wizard'
,p_list_item_link_target=>'f?p=4700:2:0'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_icon_alt_attribute=>'target="_blank'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10368005804337269)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Configure Email Restrictions'
,p_list_item_link_target=>'f?p=&APP_ID.:1026:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_multiple_workspaces
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(203141106443364145)
,p_name=>'create multiple workspaces'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557202
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(203141300332364146)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:115:&SESSION.:'
,p_list_item_current_for_pages=>'115'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(203141609069364146)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Review and Adjust'
,p_list_item_link_target=>'f?p=&APP_ID.:116:&SESSION.:'
,p_list_item_current_for_pages=>'116'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(203141924809364146)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:117:&SESSION.:'
,p_list_item_current_for_pages=>'117'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(388185523452601754)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Provisioning Complete'
,p_list_item_link_target=>'f?p=&APP_ID.:135:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_workspace_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(204654810731392335)
,p_name=>'create workspace tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557203
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(204655032658392336)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create Multiple Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:115,116,117:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/developer_activity_for_monitor_page
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(206097723808588940)
,p_name=>'Developer.Activity for Monitor Page'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557203
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(206104006324621767)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Changes by Developer'
,p_list_item_link_target=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(206104915674624470)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Application Changes by Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(155239711934611887)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Native Component Utilization Chart'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.:RP,102:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(155378603841184844)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Native Component Utilization Report'
,p_list_item_link_target=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:RP,140:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(284069028112259316)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Data Loading Jobs'
,p_list_item_link_target=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.:RP,144:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_applications
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(244253103570784647)
,p_name=>'Manage Applications'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557203
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(244660222438102395)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(244256510842786771)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Build Status'
,p_list_item_link_target=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(244631813556033582)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Parsing Schemas'
,p_list_item_link_target=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_tasks_002
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(254179102637013097)
,p_name=>'workspace tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557203
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(254179620116013099)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Add Schema'
,p_list_item_link_target=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:105,106,107:P107_SGID,P107_COMPANY:&P78_PROVISIONING_COMPANY_ID.,&P78_SN.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'nvl(:P78_PROVISIONING_COMPANY_ID, 0) not in (0, 10, 11, 12)'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(254179909753013099)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Add APEX User'
,p_list_item_link_target=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:23:F4050_P23_SECURITY_GROUP_ID:&P78_PROVISIONING_COMPANY_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(254180228149013099)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'View Detailed Report'
,p_list_item_link_target=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:14:SGID:&P78_PROVISIONING_COMPANY_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(44856918100412133)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Export Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:461:&SESSION.:EXPORT:&DEBUG.::P461_WORKSPACE:&P78_SN.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(254179324916013098)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Remove Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81,82,83:P81_COMPANY:&P78_SN.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'nvl(:P78_PROVISIONING_COMPANY_ID, 0) not in (0, 10, 11, 12)'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_purge_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(505826028978247783)
,p_name=>'Workspace Purge Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557203
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(505851803884704060)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'99'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(505826223784247787)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Inactive Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(505826523106247841)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Workspaces Purged'
,p_list_item_link_target=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(505826717378247841)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Workspaces that became Active'
,p_list_item_link_target=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(505827020036247842)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Workspace Purge Log'
,p_list_item_link_target=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_logs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(619447801744923075)
,p_name=>'monitor.activity.logs'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557203
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(619449225128923086)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Mail Log'
,p_list_item_link_target=>'f?p=&APP_ID.:121:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(619989320793200782)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Web Service Activity Log'
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1591898376570636)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Automation Log'
,p_list_item_link_target=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1393413220759055)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'REST Synchronization Log'
,p_list_item_link_target=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(619449815929923087)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Jobs'
,p_list_item_link_target=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(162310507366326382)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Automatic File Delete Log'
,p_list_item_link_target=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(78215125733433815)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Backup Log'
,p_list_item_link_target=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/security_second_level_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(799821322334262935)
,p_name=>'Security Second Level Tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557203
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(799821514224262975)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Security Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(799821821208262984)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Authorized URLs'
,p_list_item_link_target=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/activity_detail_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(831980164720776427)
,p_name=>'Activity Detail Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557203
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(831980344863776428)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Workspace Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:153:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(832233468708869758)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Page Events'
,p_list_item_link_target=>'f?p=&APP_ID.:153:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(831980793531776430)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Application Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:155:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(831981122169776430)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Developer Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:RP,156:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(831981576548776430)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Runtime Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:157:&SESSION.::&DEBUG.:RP,157:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/activity_summary
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(880586104026852286)
,p_name=>'Activity Summary'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557203
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3003187778245028)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Administrator Digest'
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-digest'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(880586395598852287)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Top Applications'
,p_list_item_link_target=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-top-apps'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(880586795096852288)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Top Workspaces'
,p_list_item_link_target=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-top-workspaces'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(880587111792852289)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Activity Summary'
,p_list_item_link_target=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-activity-summary'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2105958267784095383)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
,p_version_scn=>75557205
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2105958451628095386)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentation'
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2105958820660095393)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Discussion Forum'
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2185440443171474333)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Learn More about Oracle APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/listentry
begin
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(845762696461912)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1218032068449020)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SELECT_MANY'
,p_attribute_01=>'separated'
,p_version_scn=>229015180
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1223049383775232)
,p_plugin_type=>'DYNAMIC ACTION'
,p_plugin=>'NATIVE_OPEN_AI_ASSISTANT'
,p_version_scn=>16258645
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(3138142977135018)
,p_plugin_type=>'PROCESS TYPE'
,p_plugin=>'NATIVE_GEOCODING'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_version_scn=>117642346
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(14858702119941037)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(99844533606888906)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(118480866057833028)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_MAP_REGION'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'use_vector_tile_layers', 'Y')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(123213629940478466)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_APEX'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(124389341238989299)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_plugin=>'NATIVE_ADFBC'
,p_version_scn=>37165931336889
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(176128658842506818)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1765072144481712054)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'include_slider', 'N')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1831779972543994153)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'actions_menu_structure', 'IG')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1917680565173940128)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
,p_version_scn=>37165931336884
);
end;
/
prompt --application/shared_components/security/authorizations/apex_authentication
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(3699181830199)
,p_name=>'APEX authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication = ''APEX'';'
,p_error_message=>'APEX Authentication not enabled'
,p_version_scn=>75557205
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This authorization scheme checks whether the builder authentication can be used for single sign-on to workspaces. This includes SSO, header-based and LDAP authentication, but not',
'',
'  - APEX: login requires a workspace name',
'  - CLOUD_IDM: external login to IDM, but switching workspaces is not allowed, since the login is for a single tenant only'))
);
end;
/
prompt --application/shared_components/security/authorizations/user_is_internal
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(1018002984071621)
,p_name=>'user_is_internal'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_security.user_is_internal;'
,p_error_message=>'unable to determine if user is an internal user.'
,p_reference_id=>786938711256163276
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sso_authentication
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(9398622791321084)
,p_name=>'SSO authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication not in (''APEX'',''CLOUD_IDM'',''LDAP'',''DB'');'
,p_error_message=>'Builder SSO is not enabled'
,p_reference_id=>6738410669854771
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This authorization scheme checks whether the builder authentication can be used for single sign-on to workspaces. This includes SSO, header-based and LDAP authentication, but not',
'',
'  - APEX: login requires a workspace name',
'  - CLOUD_IDM: external login to IDM, but switching workspaces is not allowed, since the login is for a single tenant only'))
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(12523219193527909)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>'You are not authorized to administer applications'
,p_reference_id=>12511219858301010
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/is_dev
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(141670018067969246)
,p_name=>'is_dev'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return not wwv_flow_isc.deployment_environment;'
,p_error_message=>'is not a development instance'
,p_reference_id=>786949644903267343
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/dashboard_access
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(517385971569230930)
,p_name=>'Dashboard access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'    wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''ADMIN''',
'    )',
'    or wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''EDIT''',
'    );'))
,p_error_message=>'You are not authorized to access Dashboards and Monitor Activity.'
,p_reference_id=>786936829326142579
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>'Used to control access to Dashboards and Monitor Activity under Administration. Developers will have access when Builder is enabled, while Admins will always have access. Prompted by Bug 13859631.'
);
end;
/
prompt --application/shared_components/security/authorizations/display_usage_info_questions
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(825639761147256575)
,p_name=>'Display Usage Info Questions'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce( wwv_flow_platform.get_preference(''WS_REQUEST_USAGE_Q''), ''N'' ) = ''Y'' then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_error_message=>'Display usage information questions not enabled.'
,p_reference_id=>825639089215245042
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(1137280212017725373)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786519856057734816
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(652214800522885)
,p_icon_sequence=>10
,p_icon_image=>'htmldb/icons/navbarhelp_25x25.gif'
,p_icon_subtext=>'Help'
,p_icon_target=>'&SYSTEM_HELP_URL.'
,p_icon_image_alt=>'Help'
,p_icon_height=>25
,p_icon_width=>25
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond_type=>'NEVER'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_icon_bar_comment=>'Display same page with print view page template'
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(1365423778229905)
,p_icon_sequence=>20
,p_icon_subtext=>'Welcome &APP_USER.'
,p_icon_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_icon_image_alt=>'Welcome &APP_USER.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(333595616893904221)
,p_icon_sequence=>30
,p_icon_image=>'htmldb/icons/navbarlogout_25x25.gif'
,p_icon_subtext=>'( <span style="text-decoration:underline;">Switch Workspace</span> )'
,p_icon_target=>'f?p=4550:20'
,p_icon_image_alt=>'alt=""'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_security_scheme=>wwv_flow_imp.id(9398622791321084)
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(24559226221)
,p_icon_sequence=>40
,p_icon_image=>'htmldb/icons/navbarlogout_25x25.gif'
,p_icon_image2=>'wwv_logout24.gif'
,p_icon_subtext=>'( <span style="text-decoration:underline;">Logout</span> )'
,p_icon_target=>'&LOGOUT_URL.'
,p_icon_image_alt=>'Logout'
,p_icon_height=>25
,p_icon_width=>25
,p_icon_height2=>24
,p_icon_width2=>24
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond_type=>'CURRENT_LOOK_IS_1'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_icon_bar_comment=>'Navigate to Flow Attribute LOGOUT_URL when pressed.'
);
end;
/
prompt --application/shared_components/logic/application_processes/ajax_set_ui_mode
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(44840766812672473)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ajax_set_ui_mode'
,p_process_sql_clob=>'wwv_flow_4050_ui.ajax_set_ui_mode;'
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_items/ai_default_reporting_period
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(16933338579143801)
,p_name=>'AI_DEFAULT_REPORTING_PERIOD'
,p_data_type=>'NUMBER'
,p_protection_level=>'I'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/ai_max_reporting_period
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(152239928235132208)
,p_name=>'AI_MAX_REPORTING_PERIOD'
,p_data_type=>'NUMBER'
,p_protection_level=>'I'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/ai_workspace_free_space_limit
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(22252773405394309)
,p_name=>'AI_WORKSPACE_FREE_SPACE_LIMIT'
,p_data_type=>'NUMBER'
,p_protection_level=>'I'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(24661497730)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_item_comment=>'company logged into flow'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4050_password_region_title
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(341498316040067852)
,p_name=>'F4050_PASSWORD_REGION_TITLE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(69693210447779230)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by Custom2 authentication for deep linking support'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/is_dev
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(144247012389386369)
,p_name=>'IS_DEV'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/last_view
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(48673315869342015)
,p_name=>'LAST_VIEW'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'used for help'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(24663499759)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name;'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Unable to get workspace name.'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/ai_default_reporting_period
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(16934160451154947)
,p_computation_sequence=>10
,p_computation_item=>'AI_DEFAULT_REPORTING_PERIOD'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_platform.get_preference(',
'           p_preference_name => ''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'');'))
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/ai_workspace_free_space_limit
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(22318392603961500)
,p_computation_sequence=>10
,p_computation_item=>'AI_WORKSPACE_FREE_SPACE_LIMIT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'return wwv_flow_platform.get_preference(''WORKSPACE_FREE_SPACE_LIMIT'');'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/ai_max_reporting_period
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(152240285672153272)
,p_computation_sequence=>10
,p_computation_item=>'AI_MAX_REPORTING_PERIOD'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'return wwv_flow_platform.get_preference( p_preference_name => ''ADMIN_DIGEST_MAX_REPORTING_PERIOD'' );'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/f4050_password_region_title
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(341513728853071507)
,p_computation_sequence=>10
,p_computation_item=>'F4050_PASSWORD_REGION_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_lang.system_message(''APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.''||replace(wwv_flow_authentication_dev.get_internal_authentication,''DB'',''LDAP'')||''-AUTH'')'
,p_compute_when=>'F4050_PASSWORD_REGION_TITLE'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/is_dev
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(144247705463419984)
,p_computation_sequence=>10
,p_computation_item=>'IS_DEV'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_authorization_api.is_authorized(''is_dev'') then ',
'  return ''Y'';',
'else',
'  return ''N'';',
'end if;'))
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/accessibility_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1141279207071321310)
,p_lov_name=>'ACCESSIBILITY_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(1141279207071321310)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557205
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1141279512218321311)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Screen Reader'
,p_lov_return_value=>'SCREEN_READER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/account_lock_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(12506800188785204)
,p_lov_name=>'ACCOUNT_LOCK_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(12506800188785204)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557205
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(12507123798785207)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Locked'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(12507312044785207)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Unlocked'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/activity_log_request_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1582102292640264559)
,p_lov_name=>'ACTIVITY_LOG.REQUEST_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1582102292640264559)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557206
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1582102573870264598)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Other'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1582102817593264600)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Processing'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1582103136401264600)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Rendering'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1582103436851264600)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'AJAX'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1582103735724264600)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Logout'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1582104088572264603)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Authentication Callback'
,p_lov_return_value=>'5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/admin_digest_recent_time
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(18950659073704475)
,p_lov_name=>'ADMIN_DIGEST.RECENT_TIME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct d, t from (',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.DAY'')          d,    1 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''2'' ) d,    2 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''7'' ) d,    7 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''15'') d,   15 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''30'') d,   30 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''45'') d,   45 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''60'') d,   60 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''90'') d,   90 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message (',
'           case default_reporting_period',
'                when 1 then ''APEX.TIME.DAY''',
'                else ''APEX.TIME.N_DAYS''',
'           end,',
'           default_reporting_period) as d,',
'       default_reporting_period as t',
'  from (select to_number(wwv_flow_platform.get_preference(''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'')) default_reporting_period',
'          from sys.dual)',
'union all',
'select wwv_flow_lang_dev.builder_message(''CUSTOM'') d, 100 t from sys.dual)',
'order by 2'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'T'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75557206
);
end;
/
prompt --application/shared_components/user_interface/lovs/admin_digest_top_n_activity
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(18953694156990390)
,p_lov_name=>'ADMIN_DIGEST.TOP_N_ACTIVITY'
,p_lov_query=>'.'||wwv_flow_imp.id(18953694156990390)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557206
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(18953943032990390)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Top 5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(18954399054990391)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Top 10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(18954719355990392)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Top 15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(18955155473990392)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Top 20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(18955540797990392)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Top 25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(18955953763990392)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Top 30'
,p_lov_return_value=>'30'
);
end;
/
prompt --application/shared_components/user_interface/lovs/admin_digest_workspace_size_grouping
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(20891720183467722)
,p_lov_name=>'ADMIN_DIGEST.WORKSPACE_SIZE_GROUPING'
,p_lov_query=>'.'||wwv_flow_imp.id(20891720183467722)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557206
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20892037077467729)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Less than 100MB'
,p_lov_return_value=>'LT100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20892467357467729)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'100MB to 500MB'
,p_lov_return_value=>'100-500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20892875001467730)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'500MB to 1GB'
,p_lov_return_value=>'500-1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20893205485467730)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'1GB to 5GB'
,p_lov_return_value=>'1000-5000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20893654055467730)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5GB to 10GB'
,p_lov_return_value=>'5000-10000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20894006507467730)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'More than 10GB'
,p_lov_return_value=>'GT10000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(139570103313563167)
,p_lov_name=>'APP STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(139570103313563167)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557206
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139570418445563171)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Available'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139570712580563173)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Coming Soon'
,p_lov_return_value=>'COMING_SOON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139571006146563174)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Hidden'
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_activity_logging
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15203330831314824)
,p_lov_name=>'APPLICATION ACTIVITY LOGGING'
,p_lov_query=>'.'||wwv_flow_imp.id(15203330831314824)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557207
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15204014153314828)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Use Application Settings (default)'
,p_lov_return_value=>'U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15203630055314827)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15203809369314828)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Never'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1820304753496015763)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Initially Disabled for New Applications'
,p_lov_return_value=>'O'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_logo_image_or_text
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(361753932557528086)
,p_lov_name=>'APPLICATION LOGO IMAGE OR TEXT'
,p_reference_id=>210991102136588089
,p_lov_query=>'.'||wwv_flow_imp.id(361753932557528086)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361754906572528090)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Image'
,p_lov_return_value=>'IMAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361755120114528090)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_themes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(138044801783643280)
,p_lov_name=>'APPLICATION THEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :fb_flow_id',
'order by theme_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557207
);
end;
/
prompt --application/shared_components/user_interface/lovs/audit_naming
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(192906504723933391)
,p_lov_name=>'AUDIT_NAMING'
,p_lov_query=>'.'||wwv_flow_imp.id(192906504723933391)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557207
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192906720941933395)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Attributes'
,p_lov_return_value=>'WWV_FLOWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192906908350933397)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Page Template'
,p_lov_return_value=>'WWV_FLOW_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192907100225933398)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Navigation Bar'
,p_lov_return_value=>'WWV_FLOW_ICON_BAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192907329971933398)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Application Process'
,p_lov_return_value=>'WWV_FLOW_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192907525100933398)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Application Item'
,p_lov_return_value=>'WWV_FLOW_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192907723181933398)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Application Computation'
,p_lov_return_value=>'WWV_FLOW_COMPUTATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192907918785933401)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Tabs'
,p_lov_return_value=>'WWV_FLOW_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192908101742933401)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Parent Tab'
,p_lov_return_value=>'WWV_FLOW_TOPLEVEL_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192908312729933401)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'List of Values'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES$'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192908508490933401)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Static LOV Values'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES_DATA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192908720172933401)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Breadcrumb Entry'
,p_lov_return_value=>'WWV_FLOW_MENU_OPTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192917410258942992)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Themes'
,p_lov_return_value=>'WWV_FLOW_THEMES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192908929274933402)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Page Attributes'
,p_lov_return_value=>'WWV_FLOW_STEPS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192909112437933402)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Page Button'
,p_lov_return_value=>'WWV_FLOW_STEP_BUTTONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192909326218933402)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Page Branch'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCHES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192909515542933402)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Page Branch Args'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCH_ARGS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192909710968933403)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Page Item'
,p_lov_return_value=>'WWV_FLOW_STEP_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192909909431933403)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Page Computation'
,p_lov_return_value=>'WWV_FLOW_STEP_COMPUTATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192910102627933403)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Page Validation'
,p_lov_return_value=>'WWV_FLOW_STEP_VALIDATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192910304404933403)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Page Process'
,p_lov_return_value=>'WWV_FLOW_STEP_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192910501092933404)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Region Template'
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUG_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192910701238933404)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Row Template'
,p_lov_return_value=>'WWV_FLOW_ROW_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192910921309933404)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'List Template'
,p_lov_return_value=>'WWV_FLOW_LIST_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192911107468933404)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Region Attributes'
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUGS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192911327453933408)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Messages'
,p_lov_return_value=>'WWV_FLOW_MESSAGES$'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192911518683933408)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Build Options'
,p_lov_return_value=>'WWV_FLOW_PATCHES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192911719543933408)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Application Developers (Administration)'
,p_lov_return_value=>'WWV_FLOW_DEVELOPERS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192911931458933408)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Lists'
,p_lov_return_value=>'WWV_FLOW_LISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192912106135933409)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>'List Item'
,p_lov_return_value=>'WWV_FLOW_LIST_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192912316871933409)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>'Effective UserID (Administration)'
,p_lov_return_value=>'WWV_FLOW_EFFECTIVE_USERID_MAP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192912501053933409)
,p_lov_disp_sequence=>29
,p_lov_disp_value=>'Shortcuts'
,p_lov_return_value=>'WWV_FLOW_SHORTCUTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192912709920933409)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Page Item Help Text'
,p_lov_return_value=>'WWV_FLOW_STEP_ITEM_HELP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192912922654933410)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'Authentication Schemes'
,p_lov_return_value=>'WWV_FLOW_AUTHENTICATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192913116096933410)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Entry Points'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192913326886933410)
,p_lov_disp_sequence=>33
,p_lov_disp_value=>'Entry Point Args'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINT_ARGS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1581480830428587)
,p_lov_name=>'AUTOMATION_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(1581480830428587)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557207
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1581704766428589)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Running'
,p_lov_return_value=>'RUNNING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1582169050428591)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Success'
,p_lov_return_value=>'SUCCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1582581957428591)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No Action'
,p_lov_return_value=>'NO_ACTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1582955319428591)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Incomplete'
,p_lov_return_value=>'INCOMPLETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1583342009428592)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Failure'
,p_lov_return_value=>'FAILURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1583720083428592)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'ABORTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1584187107428592)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Job already running'
,p_lov_return_value=>'JOB_ALREADY_RUNNING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/auto_file_delete_file_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(164450631905355420)
,p_lov_name=>'AUTO_FILE_DELETE_FILE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(164450631905355420)||'.'
,p_location=>'STATIC'
,p_version_scn=>117497853
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164450903335355422)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Export'
,p_lov_return_value=>'FLOW_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164451116825355423)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Workspace Export'
,p_lov_return_value=>'COMPANY_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164451305638355423)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Export'
,p_lov_return_value=>'PAGE_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164451704038355423)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'XML Data Import'
,p_lov_return_value=>'XML_DATA_IMPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164451927196355423)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Data Import'
,p_lov_return_value=>'DATA_IMPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172380721498781950)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Plug-In'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172384726000783329)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CSS Export'
,p_lov_return_value=>'CSS_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172388731887784963)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Images Export'
,p_lov_return_value=>'IMAGE_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172392705352786807)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Static Files Export'
,p_lov_return_value=>'FILE_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172396718166790478)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Scripts'
,p_lov_return_value=>'SCRIPT_FILE_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172400721975791606)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Themes'
,p_lov_return_value=>'THEME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172404727169793117)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'UI Defaults'
,p_lov_return_value=>'UI_DEFAULTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/background_execution_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2050649672720692)
,p_lov_name=>'BACKGROUND_EXECUTION_STATUS'
,p_reference_id=>1814559837736230
,p_lov_query=>'.'||wwv_flow_imp.id(2050649672720692)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1479516356011983)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Submitted for Execution'
,p_lov_return_value=>'ENQUEUED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1479967167011983)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Scheduler Job Created'
,p_lov_return_value=>'SCHEDULED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1480359137011983)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Executing'
,p_lov_return_value=>'EXECUTING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1480749358011983)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Finished Successfully'
,p_lov_return_value=>'SUCCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1481149119011982)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'ABORTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1481528508011982)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Failed'
,p_lov_return_value=>'FAILED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/bipublisher_support
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(66524307689014582)
,p_lov_name=>'BIPUBLISHER_SUPPORT'
,p_lov_query=>'.'||wwv_flow_imp.id(66524307689014582)||'.'
,p_location=>'STATIC'
,p_version_scn=>7919243
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(309001880327416982)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(66524606927014584)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'External (Apache FOP)'
,p_lov_return_value=>'STANDARD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(66524808931014584)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Oracle BI Publisher'
,p_lov_return_value=>'ADVANCED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(665784884034387187)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'APEX Office Print'
,p_lov_return_value=>'AOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1602871345670094)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Oracle Document Generator Pre-built Function'
,p_lov_return_value=>'DOCUMENT_GENERATOR'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_db_version.c_has_dbms_cloud'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/build_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(244320808989852457)
,p_lov_name=>'BUILD_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(244320808989852457)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557208
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244321119544852463)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Run Application Only'
,p_lov_return_value=>'RUN_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244321323574852464)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Run and Build Application'
,p_lov_return_value=>'RUN_AND_BUILD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3932329947881245316)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Run and Hidden'
,p_lov_return_value=>'RUN_AND_HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_y_noprompt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(363978124517039324)
,p_lov_name=>'CHECKBOX_Y_NOPROMPT'
,p_reference_id=>84715102189754797
,p_lov_query=>'.'||wwv_flow_imp.id(363978124517039324)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(363978829122039326)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/clone_sessions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(924631310481901445)
,p_lov_name=>'CLONE_SESSIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(924631310481901445)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557208
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(924631660343901447)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(924632065917901449)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_pwd_removal
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(35215801480283409)
,p_lov_name=>'CONFIRM.PWD.REMOVAL'
,p_lov_query=>'.'||wwv_flow_imp.id(35215801480283409)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557208
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35216131980283418)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Check to confirm that you wish to change the wallet password'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_remove_request
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87819107787091340)
,p_lov_name=>'CONFIRM.REMOVE.REQUEST'
,p_lov_query=>'.'||wwv_flow_imp.id(87819107787091340)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557208
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87819312320091340)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Check if you wish to also remove the request for this workspace.'
,p_lov_return_value=>'Yes'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_smtp_pwd_removal
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(391596105997880413)
,p_lov_name=>'CONFIRM.SMTP.PWD.REMOVAL'
,p_lov_query=>'.'||wwv_flow_imp.id(391596105997880413)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557208
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(391596477310880416)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Check to confirm that you wish to change the password for the SMTP authentication username'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/countries
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(825654386458276754)
,p_lov_name=>'COUNTRIES'
,p_reference_id=>823478261872577596
,p_lov_query=>'.'||wwv_flow_imp.id(825654386458276754)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825828986618276883)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Afghanistan'
,p_lov_return_value=>'AFG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825829327821276883)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Albania'
,p_lov_return_value=>'ALB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825829771504276883)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Algeria'
,p_lov_return_value=>'DZA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825830143577276883)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'American Samoa'
,p_lov_return_value=>'ASM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825830589742276883)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Andorra'
,p_lov_return_value=>'AND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825830942025276883)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Angola'
,p_lov_return_value=>'AGO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825831327018276884)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Anguilla'
,p_lov_return_value=>'AIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825831783243276884)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Antarctica'
,p_lov_return_value=>'ATA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825832171105276884)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Antigua and Barbuda'
,p_lov_return_value=>'ATG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825832592077276884)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Argentina'
,p_lov_return_value=>'ARG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825832902048276884)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Armenia'
,p_lov_return_value=>'ARM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825833377631276885)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Aruba'
,p_lov_return_value=>'ABW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825833706795276885)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Australia'
,p_lov_return_value=>'AUS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825834127317276885)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Austria'
,p_lov_return_value=>'AUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825834533647276885)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Azerbaijan'
,p_lov_return_value=>'AZE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825834961281276885)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Bahamas'
,p_lov_return_value=>'BHS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825835377279276886)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Bahrain'
,p_lov_return_value=>'BHR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825835787578276886)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Bangladesh'
,p_lov_return_value=>'BGD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825836191800276886)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Barbados'
,p_lov_return_value=>'BRB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825836587620276886)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Belarus'
,p_lov_return_value=>'BLR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825836985180276886)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Belgium'
,p_lov_return_value=>'BEL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825837306454276886)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Belize'
,p_lov_return_value=>'BLZ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825837729129276887)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Benin'
,p_lov_return_value=>'BEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825838125317276887)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Bermuda'
,p_lov_return_value=>'BMU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825838582461276887)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Bhutan'
,p_lov_return_value=>'BTN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825838990241276887)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Bolivia (Plurinational State of)'
,p_lov_return_value=>'BOL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825839319978276887)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>'Bonaire, Sint Eustatius and Saba'
,p_lov_return_value=>'BES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825839734289276888)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>'Bosnia and Herzegovina'
,p_lov_return_value=>'BIH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825840195543276888)
,p_lov_disp_sequence=>29
,p_lov_disp_value=>'Botswana'
,p_lov_return_value=>'BWA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825840512692276888)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Bouvet Island'
,p_lov_return_value=>'BVT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825840953474276888)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'Brazil'
,p_lov_return_value=>'BRA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825841315787276888)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'British Indian Ocean Territory'
,p_lov_return_value=>'IOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825841782513276889)
,p_lov_disp_sequence=>33
,p_lov_disp_value=>'Brunei Darussalam'
,p_lov_return_value=>'BRN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825842190941276889)
,p_lov_disp_sequence=>34
,p_lov_disp_value=>'Bulgaria'
,p_lov_return_value=>'BGR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825842556704276889)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Burkina Faso'
,p_lov_return_value=>'BFA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825842976244276889)
,p_lov_disp_sequence=>36
,p_lov_disp_value=>'Burundi'
,p_lov_return_value=>'BDI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825843367058276889)
,p_lov_disp_sequence=>37
,p_lov_disp_value=>'Cabo Verde'
,p_lov_return_value=>'CPV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825843796250276889)
,p_lov_disp_sequence=>38
,p_lov_disp_value=>'Cambodia'
,p_lov_return_value=>'KHM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825844132289276890)
,p_lov_disp_sequence=>39
,p_lov_disp_value=>'Cameroon'
,p_lov_return_value=>'CMR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825844566311276891)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Canada'
,p_lov_return_value=>'CAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825844918384276891)
,p_lov_disp_sequence=>41
,p_lov_disp_value=>'Cayman Islands'
,p_lov_return_value=>'CYM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825845383573276891)
,p_lov_disp_sequence=>42
,p_lov_disp_value=>'Central African Republic'
,p_lov_return_value=>'CAF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825845751840276891)
,p_lov_disp_sequence=>43
,p_lov_disp_value=>'Chad'
,p_lov_return_value=>'TCD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825846166268276891)
,p_lov_disp_sequence=>44
,p_lov_disp_value=>'Chile'
,p_lov_return_value=>'CHL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825846577200276891)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'China'
,p_lov_return_value=>'CHN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825846995553276892)
,p_lov_disp_sequence=>46
,p_lov_disp_value=>'Christmas Island'
,p_lov_return_value=>'CXR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825847352853276892)
,p_lov_disp_sequence=>47
,p_lov_disp_value=>'Cocos (Keeling) Islands'
,p_lov_return_value=>'CCK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825847727858276892)
,p_lov_disp_sequence=>48
,p_lov_disp_value=>'Colombia'
,p_lov_return_value=>'COL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825848132050276892)
,p_lov_disp_sequence=>49
,p_lov_disp_value=>'Comoros'
,p_lov_return_value=>'COM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825848551594276892)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Congo'
,p_lov_return_value=>'COG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825848938265276893)
,p_lov_disp_sequence=>51
,p_lov_disp_value=>'Congo, Democratic Republic of the'
,p_lov_return_value=>'COD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825849350304276893)
,p_lov_disp_sequence=>52
,p_lov_disp_value=>'Cook Islands'
,p_lov_return_value=>'COK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825849724333276893)
,p_lov_disp_sequence=>53
,p_lov_disp_value=>'Costa Rica'
,p_lov_return_value=>'CRI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825850188413276893)
,p_lov_disp_sequence=>54
,p_lov_disp_value=>'Croatia'
,p_lov_return_value=>'HRV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825850540688276893)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>'Cuba'
,p_lov_return_value=>'CUB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825850932138276894)
,p_lov_disp_sequence=>56
,p_lov_disp_value=>unistr('Cura\00E7ao')
,p_lov_return_value=>'CUW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825851308142276894)
,p_lov_disp_sequence=>57
,p_lov_disp_value=>'Cyprus'
,p_lov_return_value=>'CYP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825851761180276894)
,p_lov_disp_sequence=>58
,p_lov_disp_value=>'Czechia'
,p_lov_return_value=>'CZE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825852155300276894)
,p_lov_disp_sequence=>59
,p_lov_disp_value=>unistr('C\00F4te d''Ivoire')
,p_lov_return_value=>'CIV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825852558437276894)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Denmark'
,p_lov_return_value=>'DNK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825852946066276895)
,p_lov_disp_sequence=>61
,p_lov_disp_value=>'Djibouti'
,p_lov_return_value=>'DJI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825853362054276895)
,p_lov_disp_sequence=>62
,p_lov_disp_value=>'Dominica'
,p_lov_return_value=>'DMA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825853757610276895)
,p_lov_disp_sequence=>63
,p_lov_disp_value=>'Dominican Republic'
,p_lov_return_value=>'DOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825854193798276895)
,p_lov_disp_sequence=>64
,p_lov_disp_value=>'Ecuador'
,p_lov_return_value=>'ECU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825854523179276895)
,p_lov_disp_sequence=>65
,p_lov_disp_value=>'Egypt'
,p_lov_return_value=>'EGY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825854974439276896)
,p_lov_disp_sequence=>66
,p_lov_disp_value=>'El Salvador'
,p_lov_return_value=>'SLV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825855379830276896)
,p_lov_disp_sequence=>67
,p_lov_disp_value=>'Equatorial Guinea'
,p_lov_return_value=>'GNQ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825855778939276896)
,p_lov_disp_sequence=>68
,p_lov_disp_value=>'Eritrea'
,p_lov_return_value=>'ERI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825856175255276896)
,p_lov_disp_sequence=>69
,p_lov_disp_value=>'Estonia'
,p_lov_return_value=>'EST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825856589758276896)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Eswatini'
,p_lov_return_value=>'SWZ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825856923318276896)
,p_lov_disp_sequence=>71
,p_lov_disp_value=>'Ethiopia'
,p_lov_return_value=>'ETH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825857301067276897)
,p_lov_disp_sequence=>72
,p_lov_disp_value=>'Falkland Islands (Malvinas)'
,p_lov_return_value=>'FLK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825857748095276897)
,p_lov_disp_sequence=>73
,p_lov_disp_value=>'Faroe Islands'
,p_lov_return_value=>'FRO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825858169835276897)
,p_lov_disp_sequence=>74
,p_lov_disp_value=>'Fiji'
,p_lov_return_value=>'FJI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825858578669276897)
,p_lov_disp_sequence=>75
,p_lov_disp_value=>'Finland'
,p_lov_return_value=>'FIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825858962903276897)
,p_lov_disp_sequence=>76
,p_lov_disp_value=>'France'
,p_lov_return_value=>'FRA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825859369920276898)
,p_lov_disp_sequence=>77
,p_lov_disp_value=>'French Guiana'
,p_lov_return_value=>'GUF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825859722685276898)
,p_lov_disp_sequence=>78
,p_lov_disp_value=>'French Polynesia'
,p_lov_return_value=>'PYF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825860168382276898)
,p_lov_disp_sequence=>79
,p_lov_disp_value=>'French Southern Territories'
,p_lov_return_value=>'ATF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825860537480276898)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Gabon'
,p_lov_return_value=>'GAB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825860968028276898)
,p_lov_disp_sequence=>81
,p_lov_disp_value=>'Gambia'
,p_lov_return_value=>'GMB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825861391692276898)
,p_lov_disp_sequence=>82
,p_lov_disp_value=>'Georgia'
,p_lov_return_value=>'GEO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825861731223276899)
,p_lov_disp_sequence=>83
,p_lov_disp_value=>'Germany'
,p_lov_return_value=>'DEU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825862111275276899)
,p_lov_disp_sequence=>84
,p_lov_disp_value=>'Ghana'
,p_lov_return_value=>'GHA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825862578738276899)
,p_lov_disp_sequence=>85
,p_lov_disp_value=>'Gibraltar'
,p_lov_return_value=>'GIB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825862936293276899)
,p_lov_disp_sequence=>86
,p_lov_disp_value=>'Greece'
,p_lov_return_value=>'GRC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825863304019276899)
,p_lov_disp_sequence=>87
,p_lov_disp_value=>'Greenland'
,p_lov_return_value=>'GRL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825863700485276900)
,p_lov_disp_sequence=>88
,p_lov_disp_value=>'Grenada'
,p_lov_return_value=>'GRD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825864153392276900)
,p_lov_disp_sequence=>89
,p_lov_disp_value=>'Guadeloupe'
,p_lov_return_value=>'GLP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825864504580276900)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Guam'
,p_lov_return_value=>'GUM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825864938354276900)
,p_lov_disp_sequence=>91
,p_lov_disp_value=>'Guatemala'
,p_lov_return_value=>'GTM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825865328711276900)
,p_lov_disp_sequence=>92
,p_lov_disp_value=>'Guernsey'
,p_lov_return_value=>'GGY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825865761129276901)
,p_lov_disp_sequence=>93
,p_lov_disp_value=>'Guinea'
,p_lov_return_value=>'GIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825866137901276901)
,p_lov_disp_sequence=>94
,p_lov_disp_value=>'Guinea-Bissau'
,p_lov_return_value=>'GNB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825866597136276901)
,p_lov_disp_sequence=>95
,p_lov_disp_value=>'Guyana'
,p_lov_return_value=>'GUY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825866991467276901)
,p_lov_disp_sequence=>96
,p_lov_disp_value=>'Haiti'
,p_lov_return_value=>'HTI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825867359739276901)
,p_lov_disp_sequence=>97
,p_lov_disp_value=>'Heard Island and McDonald Islands'
,p_lov_return_value=>'HMD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825867793643276901)
,p_lov_disp_sequence=>98
,p_lov_disp_value=>'Holy See'
,p_lov_return_value=>'VAT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825868116514276902)
,p_lov_disp_sequence=>99
,p_lov_disp_value=>'Honduras'
,p_lov_return_value=>'HND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825868599147276902)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Hong Kong'
,p_lov_return_value=>'HKG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825868929222276902)
,p_lov_disp_sequence=>101
,p_lov_disp_value=>'Hungary'
,p_lov_return_value=>'HUN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825869314307276902)
,p_lov_disp_sequence=>102
,p_lov_disp_value=>'Iceland'
,p_lov_return_value=>'ISL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825869788511276902)
,p_lov_disp_sequence=>103
,p_lov_disp_value=>'India'
,p_lov_return_value=>'IND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825870107082276903)
,p_lov_disp_sequence=>104
,p_lov_disp_value=>'Indonesia'
,p_lov_return_value=>'IDN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825870592905276903)
,p_lov_disp_sequence=>105
,p_lov_disp_value=>'Iran (Islamic Republic of)'
,p_lov_return_value=>'IRN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825870961884276903)
,p_lov_disp_sequence=>106
,p_lov_disp_value=>'Iraq'
,p_lov_return_value=>'IRQ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825871373033276903)
,p_lov_disp_sequence=>107
,p_lov_disp_value=>'Ireland'
,p_lov_return_value=>'IRL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825871765525276903)
,p_lov_disp_sequence=>108
,p_lov_disp_value=>'Isle of Man'
,p_lov_return_value=>'IMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825872138253276904)
,p_lov_disp_sequence=>109
,p_lov_disp_value=>'Israel'
,p_lov_return_value=>'ISR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825872519288276904)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Italy'
,p_lov_return_value=>'ITA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825872986754276904)
,p_lov_disp_sequence=>111
,p_lov_disp_value=>'Jamaica'
,p_lov_return_value=>'JAM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825873344716276904)
,p_lov_disp_sequence=>112
,p_lov_disp_value=>'Japan'
,p_lov_return_value=>'JPN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825873704589276904)
,p_lov_disp_sequence=>113
,p_lov_disp_value=>'Jersey'
,p_lov_return_value=>'JEY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825874131739276904)
,p_lov_disp_sequence=>114
,p_lov_disp_value=>'Jordan'
,p_lov_return_value=>'JOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825874580186276905)
,p_lov_disp_sequence=>115
,p_lov_disp_value=>'Kazakhstan'
,p_lov_return_value=>'KAZ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825874975940276905)
,p_lov_disp_sequence=>116
,p_lov_disp_value=>'Kenya'
,p_lov_return_value=>'KEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825875365933276905)
,p_lov_disp_sequence=>117
,p_lov_disp_value=>'Kiribati'
,p_lov_return_value=>'KIR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825875770424276905)
,p_lov_disp_sequence=>118
,p_lov_disp_value=>'Kuwait'
,p_lov_return_value=>'KWT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825876111066276905)
,p_lov_disp_sequence=>119
,p_lov_disp_value=>'Kyrgyzstan'
,p_lov_return_value=>'KGZ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825876586908276906)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Laos, People''s Democratic Republic'
,p_lov_return_value=>'LAO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825876951921276906)
,p_lov_disp_sequence=>121
,p_lov_disp_value=>'Latvia'
,p_lov_return_value=>'LVA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825877356147276906)
,p_lov_disp_sequence=>122
,p_lov_disp_value=>'Lebanon'
,p_lov_return_value=>'LBN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825877726325276906)
,p_lov_disp_sequence=>123
,p_lov_disp_value=>'Lesotho'
,p_lov_return_value=>'LSO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825878113894276906)
,p_lov_disp_sequence=>124
,p_lov_disp_value=>'Liberia'
,p_lov_return_value=>'LBR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825878594036276907)
,p_lov_disp_sequence=>125
,p_lov_disp_value=>'Libya'
,p_lov_return_value=>'LBY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825878909866276907)
,p_lov_disp_sequence=>126
,p_lov_disp_value=>'Liechtenstein'
,p_lov_return_value=>'LIE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825879393532276907)
,p_lov_disp_sequence=>127
,p_lov_disp_value=>'Lithuania'
,p_lov_return_value=>'LTU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825879773232276907)
,p_lov_disp_sequence=>128
,p_lov_disp_value=>'Luxembourg'
,p_lov_return_value=>'LUX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825880134430276907)
,p_lov_disp_sequence=>129
,p_lov_disp_value=>'Macau'
,p_lov_return_value=>'MAC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825880561767276907)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Madagascar'
,p_lov_return_value=>'MDG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825880967943276908)
,p_lov_disp_sequence=>131
,p_lov_disp_value=>'Malawi'
,p_lov_return_value=>'MWI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825881305433276908)
,p_lov_disp_sequence=>132
,p_lov_disp_value=>'Malaysia'
,p_lov_return_value=>'MYS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825881704610276908)
,p_lov_disp_sequence=>133
,p_lov_disp_value=>'Maldives'
,p_lov_return_value=>'MDV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825882119253276908)
,p_lov_disp_sequence=>134
,p_lov_disp_value=>'Mali'
,p_lov_return_value=>'MLI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825882563797276908)
,p_lov_disp_sequence=>135
,p_lov_disp_value=>'Malta'
,p_lov_return_value=>'MLT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825882947105276909)
,p_lov_disp_sequence=>136
,p_lov_disp_value=>'Marshall Islands'
,p_lov_return_value=>'MHL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825883325187276909)
,p_lov_disp_sequence=>137
,p_lov_disp_value=>'Martinique'
,p_lov_return_value=>'MTQ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825883707866276909)
,p_lov_disp_sequence=>138
,p_lov_disp_value=>'Mauritania'
,p_lov_return_value=>'MRT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825884188442276909)
,p_lov_disp_sequence=>139
,p_lov_disp_value=>'Mauritius'
,p_lov_return_value=>'MUS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825884544188276909)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Mayotte'
,p_lov_return_value=>'MYT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825884930655276909)
,p_lov_disp_sequence=>141
,p_lov_disp_value=>'Mexico'
,p_lov_return_value=>'MEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825885322708276910)
,p_lov_disp_sequence=>142
,p_lov_disp_value=>'Micronesia (Federated States of)'
,p_lov_return_value=>'FSM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825885769657276910)
,p_lov_disp_sequence=>143
,p_lov_disp_value=>'Moldova, Republic of'
,p_lov_return_value=>'MDA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825886192981276910)
,p_lov_disp_sequence=>144
,p_lov_disp_value=>'Monaco'
,p_lov_return_value=>'MCO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825886582724276910)
,p_lov_disp_sequence=>145
,p_lov_disp_value=>'Mongolia'
,p_lov_return_value=>'MNG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825886993780276910)
,p_lov_disp_sequence=>146
,p_lov_disp_value=>'Montenegro'
,p_lov_return_value=>'MNE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825887392313276911)
,p_lov_disp_sequence=>147
,p_lov_disp_value=>'Montserrat'
,p_lov_return_value=>'MSR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825887778990276911)
,p_lov_disp_sequence=>148
,p_lov_disp_value=>'Morocco'
,p_lov_return_value=>'MAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825888183428276911)
,p_lov_disp_sequence=>149
,p_lov_disp_value=>'Mozambique'
,p_lov_return_value=>'MOZ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825888530594276911)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Myanmar'
,p_lov_return_value=>'MMR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825888910703276911)
,p_lov_disp_sequence=>151
,p_lov_disp_value=>'Namibia'
,p_lov_return_value=>'NAM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825889307523276911)
,p_lov_disp_sequence=>152
,p_lov_disp_value=>'Nauru'
,p_lov_return_value=>'NRU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825889715474276912)
,p_lov_disp_sequence=>153
,p_lov_disp_value=>'Nepal'
,p_lov_return_value=>'NPL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825890173081276912)
,p_lov_disp_sequence=>154
,p_lov_disp_value=>'Netherlands'
,p_lov_return_value=>'NLD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825890583991276912)
,p_lov_disp_sequence=>155
,p_lov_disp_value=>'New Caledonia'
,p_lov_return_value=>'NCL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825890980343276912)
,p_lov_disp_sequence=>156
,p_lov_disp_value=>'New Zealand'
,p_lov_return_value=>'NZL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825891310391276912)
,p_lov_disp_sequence=>157
,p_lov_disp_value=>'Nicaragua'
,p_lov_return_value=>'NIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825891764424276913)
,p_lov_disp_sequence=>158
,p_lov_disp_value=>'Niger'
,p_lov_return_value=>'NER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825892178880276913)
,p_lov_disp_sequence=>159
,p_lov_disp_value=>'Nigeria'
,p_lov_return_value=>'NGA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825892586586276913)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Niue'
,p_lov_return_value=>'NIU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825892932251276913)
,p_lov_disp_sequence=>161
,p_lov_disp_value=>'Norfolk Island'
,p_lov_return_value=>'NFK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825893317790276913)
,p_lov_disp_sequence=>162
,p_lov_disp_value=>'North Korea (Democratic People''s Republic of)'
,p_lov_return_value=>'PRK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825893763078276914)
,p_lov_disp_sequence=>163
,p_lov_disp_value=>'North Macedonia'
,p_lov_return_value=>'MKD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825894130064276914)
,p_lov_disp_sequence=>164
,p_lov_disp_value=>'Northern Mariana Islands'
,p_lov_return_value=>'MNP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825894506244276914)
,p_lov_disp_sequence=>165
,p_lov_disp_value=>'Norway'
,p_lov_return_value=>'NOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825894979561276915)
,p_lov_disp_sequence=>166
,p_lov_disp_value=>'Oman'
,p_lov_return_value=>'OMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825895305615276915)
,p_lov_disp_sequence=>167
,p_lov_disp_value=>'Pakistan'
,p_lov_return_value=>'PAK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825895737444276915)
,p_lov_disp_sequence=>168
,p_lov_disp_value=>'Palau'
,p_lov_return_value=>'PLW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825896173319276916)
,p_lov_disp_sequence=>169
,p_lov_disp_value=>'Palestine, State of'
,p_lov_return_value=>'PSE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825896520712276916)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Panama'
,p_lov_return_value=>'PAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825896973195276916)
,p_lov_disp_sequence=>171
,p_lov_disp_value=>'Papua New Guinea'
,p_lov_return_value=>'PNG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825897330162276916)
,p_lov_disp_sequence=>172
,p_lov_disp_value=>'Paraguay'
,p_lov_return_value=>'PRY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825897730820276916)
,p_lov_disp_sequence=>173
,p_lov_disp_value=>'Peru'
,p_lov_return_value=>'PER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825898113595276917)
,p_lov_disp_sequence=>174
,p_lov_disp_value=>'Philippines'
,p_lov_return_value=>'PHL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825898521565276917)
,p_lov_disp_sequence=>175
,p_lov_disp_value=>'Pitcairn'
,p_lov_return_value=>'PCN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825898923467276917)
,p_lov_disp_sequence=>176
,p_lov_disp_value=>'Poland'
,p_lov_return_value=>'POL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825899305049276917)
,p_lov_disp_sequence=>177
,p_lov_disp_value=>'Portugal'
,p_lov_return_value=>'PRT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825899754328276917)
,p_lov_disp_sequence=>178
,p_lov_disp_value=>'Puerto Rico'
,p_lov_return_value=>'PRI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825900194972276919)
,p_lov_disp_sequence=>179
,p_lov_disp_value=>'Qatar'
,p_lov_return_value=>'QAT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825900527948276919)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Romania'
,p_lov_return_value=>'ROU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825900965393276920)
,p_lov_disp_sequence=>181
,p_lov_disp_value=>'Russian Federation'
,p_lov_return_value=>'RUS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825901319523276920)
,p_lov_disp_sequence=>182
,p_lov_disp_value=>'Rwanda'
,p_lov_return_value=>'RWA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825901741930276920)
,p_lov_disp_sequence=>183
,p_lov_disp_value=>unistr('R\00E9union')
,p_lov_return_value=>'REU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825902186193276920)
,p_lov_disp_sequence=>184
,p_lov_disp_value=>unistr('Saint Barth\00E9lemy')
,p_lov_return_value=>'BLM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825902571781276920)
,p_lov_disp_sequence=>185
,p_lov_disp_value=>'Saint Helena, Ascension and Tristan da Cunha'
,p_lov_return_value=>'SHN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825902987947276920)
,p_lov_disp_sequence=>186
,p_lov_disp_value=>'Saint Kitts and Nevis'
,p_lov_return_value=>'KNA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825903370219276921)
,p_lov_disp_sequence=>187
,p_lov_disp_value=>'Saint Lucia'
,p_lov_return_value=>'LCA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825903723148276921)
,p_lov_disp_sequence=>188
,p_lov_disp_value=>'Saint Martin (French part)'
,p_lov_return_value=>'MAF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825904147719276921)
,p_lov_disp_sequence=>189
,p_lov_disp_value=>'Saint Pierre and Miquelon'
,p_lov_return_value=>'SPM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825904592478276921)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Saint Vincent and the Grenadines'
,p_lov_return_value=>'VCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825904916537276921)
,p_lov_disp_sequence=>191
,p_lov_disp_value=>'Samoa'
,p_lov_return_value=>'WSM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825905384376276922)
,p_lov_disp_sequence=>192
,p_lov_disp_value=>'San Marino'
,p_lov_return_value=>'SMR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825905752137276922)
,p_lov_disp_sequence=>193
,p_lov_disp_value=>'Sao Tome and Principe'
,p_lov_return_value=>'STP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825906165213276922)
,p_lov_disp_sequence=>194
,p_lov_disp_value=>'Saudi Arabia'
,p_lov_return_value=>'SAU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825906527584276922)
,p_lov_disp_sequence=>195
,p_lov_disp_value=>'Senegal'
,p_lov_return_value=>'SEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825906909103276922)
,p_lov_disp_sequence=>196
,p_lov_disp_value=>'Serbia'
,p_lov_return_value=>'SRB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825907325092276922)
,p_lov_disp_sequence=>197
,p_lov_disp_value=>'Seychelles'
,p_lov_return_value=>'SYC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825907727129276923)
,p_lov_disp_sequence=>198
,p_lov_disp_value=>'Sierra Leone'
,p_lov_return_value=>'SLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825908172230276923)
,p_lov_disp_sequence=>199
,p_lov_disp_value=>'Singapore'
,p_lov_return_value=>'SGP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825908590713276923)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Sint Maarten (Dutch part)'
,p_lov_return_value=>'SXM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825908968311276923)
,p_lov_disp_sequence=>201
,p_lov_disp_value=>'Slovakia'
,p_lov_return_value=>'SVK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825909353469276923)
,p_lov_disp_sequence=>202
,p_lov_disp_value=>'Slovenia'
,p_lov_return_value=>'SVN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825909711211276924)
,p_lov_disp_sequence=>203
,p_lov_disp_value=>'Solomon Islands'
,p_lov_return_value=>'SLB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825910116576276924)
,p_lov_disp_sequence=>204
,p_lov_disp_value=>'Somalia'
,p_lov_return_value=>'SOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825910507104276924)
,p_lov_disp_sequence=>205
,p_lov_disp_value=>'South Africa'
,p_lov_return_value=>'ZAF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825910923668276924)
,p_lov_disp_sequence=>206
,p_lov_disp_value=>'South Georgia and the South Sandwich Islands'
,p_lov_return_value=>'SGS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825911323973276924)
,p_lov_disp_sequence=>207
,p_lov_disp_value=>'South Korea (Republic of)'
,p_lov_return_value=>'KOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825911777749276925)
,p_lov_disp_sequence=>208
,p_lov_disp_value=>'South Sudan'
,p_lov_return_value=>'SSD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825912118903276925)
,p_lov_disp_sequence=>209
,p_lov_disp_value=>'Spain'
,p_lov_return_value=>'ESP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825912561193276925)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'Sri Lanka'
,p_lov_return_value=>'LKA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825912924033276925)
,p_lov_disp_sequence=>211
,p_lov_disp_value=>'Sudan'
,p_lov_return_value=>'SDN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825913319072276925)
,p_lov_disp_sequence=>212
,p_lov_disp_value=>'Suriname'
,p_lov_return_value=>'SUR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825913775276276926)
,p_lov_disp_sequence=>213
,p_lov_disp_value=>'Svalbard and Jan Mayen'
,p_lov_return_value=>'SJM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825914131489276926)
,p_lov_disp_sequence=>214
,p_lov_disp_value=>'Sweden'
,p_lov_return_value=>'SWE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825914579565276926)
,p_lov_disp_sequence=>215
,p_lov_disp_value=>'Switzerland'
,p_lov_return_value=>'CHE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825914943996276926)
,p_lov_disp_sequence=>216
,p_lov_disp_value=>'Syrian Arab Republic'
,p_lov_return_value=>'SYR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825915320020276926)
,p_lov_disp_sequence=>217
,p_lov_disp_value=>'Taiwan (Province of China)'
,p_lov_return_value=>'TWN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825915790478276927)
,p_lov_disp_sequence=>218
,p_lov_disp_value=>'Tajikistan'
,p_lov_return_value=>'TJK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825916163490276927)
,p_lov_disp_sequence=>219
,p_lov_disp_value=>'Tanzania (United Republic of)'
,p_lov_return_value=>'TZA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825916529887276927)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Thailand'
,p_lov_return_value=>'THA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825916960711276927)
,p_lov_disp_sequence=>221
,p_lov_disp_value=>'Timor-Leste'
,p_lov_return_value=>'TLS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825917361523276928)
,p_lov_disp_sequence=>222
,p_lov_disp_value=>'Togo'
,p_lov_return_value=>'TGO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825917781777276928)
,p_lov_disp_sequence=>223
,p_lov_disp_value=>'Tokelau'
,p_lov_return_value=>'TKL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825918105350276928)
,p_lov_disp_sequence=>224
,p_lov_disp_value=>'Tonga'
,p_lov_return_value=>'TON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825918560450276928)
,p_lov_disp_sequence=>225
,p_lov_disp_value=>'Trinidad and Tobago'
,p_lov_return_value=>'TTO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825918990154276928)
,p_lov_disp_sequence=>226
,p_lov_disp_value=>'Tunisia'
,p_lov_return_value=>'TUN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825919368202276929)
,p_lov_disp_sequence=>227
,p_lov_disp_value=>'Turkey'
,p_lov_return_value=>'TUR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825919704933276929)
,p_lov_disp_sequence=>228
,p_lov_disp_value=>'Turkmenistan'
,p_lov_return_value=>'TKM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825920118239276929)
,p_lov_disp_sequence=>229
,p_lov_disp_value=>'Turks and Caicos Islands'
,p_lov_return_value=>'TCA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825920509259276929)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Tuvalu'
,p_lov_return_value=>'TUV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825920928756276929)
,p_lov_disp_sequence=>231
,p_lov_disp_value=>'Uganda'
,p_lov_return_value=>'UGA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825921395061276929)
,p_lov_disp_sequence=>232
,p_lov_disp_value=>'Ukraine'
,p_lov_return_value=>'UKR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825921723040276930)
,p_lov_disp_sequence=>233
,p_lov_disp_value=>'United Arab Emirates'
,p_lov_return_value=>'ARE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825922100997276930)
,p_lov_disp_sequence=>234
,p_lov_disp_value=>'United Kingdom of Great Britain and Northern Ireland'
,p_lov_return_value=>'GBR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825922598731276930)
,p_lov_disp_sequence=>235
,p_lov_disp_value=>'United States Minor Outlying Islands'
,p_lov_return_value=>'UMI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825922942720276930)
,p_lov_disp_sequence=>236
,p_lov_disp_value=>'United States of America'
,p_lov_return_value=>'USA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825923369763276930)
,p_lov_disp_sequence=>237
,p_lov_disp_value=>'Uruguay'
,p_lov_return_value=>'URY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825923723825276931)
,p_lov_disp_sequence=>238
,p_lov_disp_value=>'Uzbekistan'
,p_lov_return_value=>'UZB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825924166994276931)
,p_lov_disp_sequence=>239
,p_lov_disp_value=>'Vanuatu'
,p_lov_return_value=>'VUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825924539566276931)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'Venezuela (Bolivarian Republic of)'
,p_lov_return_value=>'VEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825924969601276931)
,p_lov_disp_sequence=>241
,p_lov_disp_value=>'Vietnam'
,p_lov_return_value=>'VNM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825925367357276931)
,p_lov_disp_sequence=>242
,p_lov_disp_value=>'Virgin Islands (British)'
,p_lov_return_value=>'VGB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825925707805276932)
,p_lov_disp_sequence=>243
,p_lov_disp_value=>'Virgin Islands (U.S.)'
,p_lov_return_value=>'VIR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825926101219276932)
,p_lov_disp_sequence=>244
,p_lov_disp_value=>'Wallis and Futuna'
,p_lov_return_value=>'WLF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825926525342276932)
,p_lov_disp_sequence=>245
,p_lov_disp_value=>'Western Sahara'
,p_lov_return_value=>'ESH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825926910133276932)
,p_lov_disp_sequence=>246
,p_lov_disp_value=>'Yemen'
,p_lov_return_value=>'YEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825927329247276932)
,p_lov_disp_sequence=>247
,p_lov_disp_value=>'Zambia'
,p_lov_return_value=>'ZMB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825927705388276932)
,p_lov_disp_sequence=>248
,p_lov_disp_value=>'Zimbabwe'
,p_lov_return_value=>'ZWE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825928166569276933)
,p_lov_disp_sequence=>249
,p_lov_disp_value=>unistr('\00C5land Islands')
,p_lov_return_value=>'ALA'
);
end;
/
prompt --application/shared_components/user_interface/lovs/date_format_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(847446100928128573)
,p_lov_name=>'DATE_FORMAT_LOV'
,p_reference_id=>460719917105668922
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_tablespaces
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(161644121203686372)
,p_lov_name=>'DB.TABLESPACES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tablespace_name tname_disp, tablespace_name tname_ret',
'  from sys.dba_tablespaces'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557220
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_temp_tablespaces
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(22927715080990907)
,p_lov_name=>'DB.TEMP.TABLESPACES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tablespace_name tname_disp, tablespace_name tname_ret',
'  from sys.dba_tablespaces',
' where contents = ''TEMPORARY'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557220
);
end;
/
prompt --application/shared_components/user_interface/lovs/default_error_display_location
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(360596400783208409)
,p_lov_name=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_reference_id=>191207805708435328
,p_lov_query=>'.'||wwv_flow_imp.id(360596400783208409)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(360597710469208433)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Inline with Field and in Notification'
,p_lov_return_value=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(360597900558208433)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Inline with Field'
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(360598129380208433)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Inline in Notification'
,p_lov_return_value=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/developer_activity_action
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(110357115975241430)
,p_lov_name=>'DEVELOPER ACTIVITY ACTION'
,p_lov_query=>'.'||wwv_flow_imp.id(110357115975241430)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557220
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(110357309735241430)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Create'
,p_lov_return_value=>'I'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(110357503716241431)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Delete'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(110357728444241431)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Change'
,p_lov_return_value=>'U'
);
end;
/
prompt --application/shared_components/user_interface/lovs/developer_privs
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(182796815771077530)
,p_lov_name=>'DEVELOPER.PRIVS'
,p_lov_query=>'.'||wwv_flow_imp.id(182796815771077530)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557220
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87840032028448399)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Administration'
,p_lov_return_value=>'ADMIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87840228629448402)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Browse'
,p_lov_return_value=>'BROWSE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87840406518448402)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Create'
,p_lov_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87840629693448402)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Data Loader'
,p_lov_return_value=>'DATA_LOADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87840818626448402)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'DB Monitor'
,p_lov_return_value=>'DB_MONITOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87841009541448403)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Edit'
,p_lov_return_value=>'EDIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87841204704448403)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Help'
,p_lov_return_value=>'HELP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87841420783448403)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Monitor'
,p_lov_return_value=>'MONITOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87841623734448404)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87841806856448404)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'User Manager'
,p_lov_return_value=>'USER_MANAGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/disable_apps_login
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2284565770730489)
,p_lov_name=>'DISABLE_APPS_LOGIN'
,p_lov_query=>'.'||wwv_flow_imp.id(2284565770730489)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557220
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2284864837730506)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2285213430730507)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Only for specific Apps'
,p_lov_return_value=>'LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2285640560730507)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_y_disable_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(484964000318931321)
,p_lov_name=>'ENABLE Y, DISABLE N'
,p_lov_query=>'.'||wwv_flow_imp.id(484964000318931321)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557220
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484964223962931324)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Enable'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484964415569931326)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Disable'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enabled_true_false
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1351993194329853612)
,p_lov_name=>'ENABLED_TRUE_FALSE'
,p_lov_query=>'.'||wwv_flow_imp.id(1351993194329853612)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557222
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1351993418924853622)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'True'
,p_lov_return_value=>'TRUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1351993885783853625)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'False'
,p_lov_return_value=>'FALSE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exact_subs_y_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(370686604633893239)
,p_lov_name=>'EXACT_SUBS_Y_N'
,p_reference_id=>84908521896674445
,p_lov_query=>'.'||wwv_flow_imp.id(370686604633893239)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370687632719893241)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No - Perform non exact substitutions as well'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370687828235893241)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Yes - Perform only exact substitutions'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2046991831712786495)
,p_lov_name=>'EXPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2046991831712786495)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2046992184705786498)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Full'
,p_lov_return_value=>'FULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2046992509267786499)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Minimal'
,p_lov_return_value=>'MIN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/file_format
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(175743214959227187)
,p_lov_name=>'FILE_FORMAT'
,p_lov_query=>'.'||wwv_flow_imp.id(175743214959227187)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(175743601146227192)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'UNIX'
,p_lov_return_value=>'UNIX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(175743426983227191)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_no_since
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(348972227781434779)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_reference_id=>170713321121898589
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_no_since
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(348972603598434786)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_NO_SINCE'
,p_reference_id=>170713631164901556
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_tzr_no_since
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(348973028981434786)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_TZR_NO_SINCE'
,p_reference_id=>170713910516904980
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''Z'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/geometry_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(564921851272063247)
,p_lov_name=>'GEOMETRY_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(564921851272063247)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564922134126063248)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Points'
,p_lov_return_value=>'POINT'
,p_lov_template=>'#DISPLAY_VALUE#|map-points'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564922549275063248)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lines'
,p_lov_return_value=>'LINE'
,p_lov_template=>'#DISPLAY_VALUE#|map-lines'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564922930077063248)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Polygons'
,p_lov_return_value=>'POLYGON'
,p_lov_template=>'#DISPLAY_VALUE#|map-polygons'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564923359512063251)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Heat Map'
,p_lov_return_value=>'HEATMAP'
,p_lov_template=>'#DISPLAY_VALUE#|map-heatmap'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564923718918063251)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Extruded Polygons'
,p_lov_return_value=>'POLYGON_3D'
,p_lov_template=>'#DISPLAY_VALUE#|map-extruded-polgygons'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564983780209097093)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Unknown'
,p_lov_return_value=>'UNKNOWN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/hash_function
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(366796514610241309)
,p_lov_name=>'HASH_FUNCTION'
,p_lov_query=>'.'||wwv_flow_imp.id(366796514610241309)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(366797127072241312)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SHA-1 [Deprecated]'
,p_lov_return_value=>'SH1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(366797426883241313)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SHA-2, 256 bit'
,p_lov_return_value=>'SH256'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(366797730058241314)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SHA-2, 384 bit'
,p_lov_return_value=>'SH384'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(366798016860241314)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'SHA-2, 512 bit'
,p_lov_return_value=>'SH512'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(366796820622241310)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'MD5 [Deprecated]'
,p_lov_return_value=>'MD5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_charset
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(175798011541253458)
,p_lov_name=>'I18N_IANA_CHARSET'
,p_reference_id=>144796827445692396
,p_lov_query=>'.'||wwv_flow_imp.id(175798011541253458)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9219501049925452)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic ISO-8859-6'
,p_lov_return_value=>'iso-8859-6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9219717725925452)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic Windows 1256'
,p_lov_return_value=>'windows-1256'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9219915396925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese Big5'
,p_lov_return_value=>'big5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9220105075925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese GBK'
,p_lov_return_value=>'gbk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9220309171925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic ISO-8859-5'
,p_lov_return_value=>'iso-8859-5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9220531506925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-R'
,p_lov_return_value=>'koi8-r'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9220716176925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-U'
,p_lov_return_value=>'koi8-u'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9220921806925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic Windows 1251'
,p_lov_return_value=>'windows-1251'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9221127254925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European ISO-8859-2'
,p_lov_return_value=>'iso-8859-2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9221328423925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European Windows 1250'
,p_lov_return_value=>'windows-1250'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9221530241925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek ISO-8859-7'
,p_lov_return_value=>'iso-8859-7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9221716263925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek Windows 1253'
,p_lov_return_value=>'windows-1253'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9221926948925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew ISO-8859-8-i'
,p_lov_return_value=>'iso-8859-8-i'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9222100762925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew Windows 1255'
,p_lov_return_value=>'windows-1255'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9222325282925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese EUC'
,p_lov_return_value=>'euc-jp'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9222500466925453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese Shift JIS'
,p_lov_return_value=>'shift_jis'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9222730026925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Korean EUC'
,p_lov_return_value=>'euc-kr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9222922148925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European ISO-8859-4'
,p_lov_return_value=>'iso-8859-4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9223125383925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European Windows 1257'
,p_lov_return_value=>'windows-1257'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9223328804925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Southern European ISO-8859-3'
,p_lov_return_value=>'iso-8859-3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9223507735925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Thai TIS-620'
,p_lov_return_value=>'tis-620'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9223727278925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish ISO-8859-9'
,p_lov_return_value=>'iso-8859-9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9223913742925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish Windows 1254'
,p_lov_return_value=>'windows-1254'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9224108380925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-8'
,p_lov_return_value=>'utf-8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9224313943925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Big Endian'
,p_lov_return_value=>'utf-16be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9224522296925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Little Endian'
,p_lov_return_value=>'utf-16le'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9224717469925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'us-ascii'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9224917326925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vietnamese Windows 1258'
,p_lov_return_value=>'windows-1258'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9225110387925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European ISO-8859-1'
,p_lov_return_value=>'iso-8859-1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9225332582925454)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European Windows 1252'
,p_lov_return_value=>'windows-1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(348975927644434787)
,p_lov_name=>'I18N_LANGUAGES_LOCALES'
,p_reference_id=>107899321117195063
,p_lov_query=>'.'||wwv_flow_imp.id(348975927644434787)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296581333833648563)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Azerbaijani (az)'
,p_lov_return_value=>'az'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296581766236648563)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (Cyrillic)(sr-cyrl)'
,p_lov_return_value=>'sr-cyrl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296582189912648564)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (Latin)(sr-latn)'
,p_lov_return_value=>'sr-latn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296582552116648564)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrikaans (af)'
,p_lov_return_value=>'af'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296582983279648564)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (ar)'
,p_lov_return_value=>'ar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296583396255648564)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Algeria) (ar-dz)'
,p_lov_return_value=>'ar-dz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296583756719648565)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Bahrain) (ar-bh)'
,p_lov_return_value=>'ar-bh'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296584112761648565)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Egypt) (ar-eg)'
,p_lov_return_value=>'ar-eg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296584589896648565)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Iraq) (ar-iq)'
,p_lov_return_value=>'ar-iq'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296584961987648565)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Jordan) (ar-jo)'
,p_lov_return_value=>'ar-jo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296585372530648565)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Kuwait) (ar-kw)'
,p_lov_return_value=>'ar-kw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296585707558648566)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Lebanon) (ar-lb)'
,p_lov_return_value=>'ar-lb'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296586194238648566)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Libya) (ar-ly)'
,p_lov_return_value=>'ar-ly'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296586586556648566)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Morocco) (ar-ma)'
,p_lov_return_value=>'ar-ma'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296586957740648567)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Oman) (ar-om)'
,p_lov_return_value=>'ar-om'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296587379097648568)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Qatar) (ar-qa)'
,p_lov_return_value=>'ar-qa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296587796118648568)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Saudi Arabia) (ar-sa)'
,p_lov_return_value=>'ar-sa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296588137162648568)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Syria) (ar-sy)'
,p_lov_return_value=>'ar-sy'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296588597099648568)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Tunisia) (ar-tn)'
,p_lov_return_value=>'ar-tn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296588992984648568)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (U.A.E.) (ar-ae)'
,p_lov_return_value=>'ar-ae'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296589362892648569)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Yemen) (ar-ye)'
,p_lov_return_value=>'ar-ye'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296589702005648570)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Assamese (as)'
,p_lov_return_value=>'as'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296590194303648570)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Basque (eu)'
,p_lov_return_value=>'eu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296590531942648571)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Belarusian (be)'
,p_lov_return_value=>'be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296590901376648571)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bengali (bn)'
,p_lov_return_value=>'bn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296591399961648571)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgarian (bg)'
,p_lov_return_value=>'bg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296591799969648571)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalan (ca)'
,p_lov_return_value=>'ca'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296592101822648571)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (zh)'
,p_lov_return_value=>'zh'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296592587451648572)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (China) (zh-cn)'
,p_lov_return_value=>'zh-cn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296592915082648572)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Hong Kong SAR) (zh-hk)'
,p_lov_return_value=>'zh-hk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296593325684648572)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Macau SAR) (zh-mo)'
,p_lov_return_value=>'zh-mo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296593754306648572)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Singapore) (zh-sg)'
,p_lov_return_value=>'zh-sg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296594146750648573)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Taiwan) (zh-tw)'
,p_lov_return_value=>'zh-tw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296594546311648573)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croatian (hr)'
,p_lov_return_value=>'hr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296594944541648573)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Czech (cs)'
,p_lov_return_value=>'cs'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296595330977648573)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Danish (da)'
,p_lov_return_value=>'da'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296595705228648573)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dutch (Belgium) (nl-be)'
,p_lov_return_value=>'nl-be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296596170635648574)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dutch (Netherlands) (nl)'
,p_lov_return_value=>'nl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296596502555648574)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (en)'
,p_lov_return_value=>'en'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296596943417648574)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Australia) (en-au)'
,p_lov_return_value=>'en-au'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296597325113648576)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Belize) (en-bz)'
,p_lov_return_value=>'en-bz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296597730934648576)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Canada) (en-ca)'
,p_lov_return_value=>'en-ca'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296598189761648576)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Ireland) (en-ie)'
,p_lov_return_value=>'en-ie'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296598574337648577)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Jamaica) (en-jm)'
,p_lov_return_value=>'en-jm'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296598991931648577)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (New Zealand) (en-nz)'
,p_lov_return_value=>'en-nz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296599318254648577)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Philippines) (en-ph)'
,p_lov_return_value=>'en-ph'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296599730424648577)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (South Africa) (en-za)'
,p_lov_return_value=>'en-za'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296600130225648577)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Trinidad) (en-tt)'
,p_lov_return_value=>'en-tt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296600574024648578)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (United Kingdom) (en-gb)'
,p_lov_return_value=>'en-gb'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296600919441648578)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (United States) (en-us)'
,p_lov_return_value=>'en-us'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296601372216648578)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Zimbabwe) (en-zw)'
,p_lov_return_value=>'en-zw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296601794226648578)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonian (et)'
,p_lov_return_value=>'et'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296602149743648579)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'FYRO Macedonian (mk)'
,p_lov_return_value=>'mk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296602551235648579)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Faeroese (fo)'
,p_lov_return_value=>'fo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296602925621648579)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Farsi (fa)'
,p_lov_return_value=>'fa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296603344514648579)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Switzerland) (fr-ch)'
,p_lov_return_value=>'fr-ch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296603772733648579)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finnish (fi)'
,p_lov_return_value=>'fi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296604124446648580)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Belgium) (fr-be)'
,p_lov_return_value=>'fr-be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296604567417648580)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Canada) (fr-ca)'
,p_lov_return_value=>'fr-ca'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296604932561648580)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (France) (fr)'
,p_lov_return_value=>'fr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296605343983648580)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Luxembourg) (fr-lu)'
,p_lov_return_value=>'fr-lu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296605732591648581)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Monaco) (fr-mc)'
,p_lov_return_value=>'fr-mc'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296606155834648581)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gaelic (gd)'
,p_lov_return_value=>'gd'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296606512413648581)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Galician (gl)'
,p_lov_return_value=>'gl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296606942158648581)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Austria) (de-at)'
,p_lov_return_value=>'de-at'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296607310601648581)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Germany) (de)'
,p_lov_return_value=>'de'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296607781166648582)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Liechtenstein) (de-li)'
,p_lov_return_value=>'de-li'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296608158689648582)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Luxemgourg) (de-lu)'
,p_lov_return_value=>'de-lu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296608503276648582)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Switzerland) (de-ch)'
,p_lov_return_value=>'de-ch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296608960442648582)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Greek (el)'
,p_lov_return_value=>'el'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296609363710648583)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gujarati (gu)'
,p_lov_return_value=>'gu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296609702070648583)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hebrew (he)'
,p_lov_return_value=>'he'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296610192721648583)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hindi (hi)'
,p_lov_return_value=>'hi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296610579310648583)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hungarian (hu)'
,p_lov_return_value=>'hu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296610986281648584)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Icelandic (is)'
,p_lov_return_value=>'is'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296611365736648584)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesian (id)'
,p_lov_return_value=>'id'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296611749151648584)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italian (Italy) (it)'
,p_lov_return_value=>'it'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296612163423648584)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italian (Switzerland) (it-ch)'
,p_lov_return_value=>'it-ch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296612529724648585)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japanese (ja)'
,p_lov_return_value=>'ja'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296612939942648585)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kannada (kn)'
,p_lov_return_value=>'kn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296613384233648585)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakh (kk)'
,p_lov_return_value=>'kk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296613740859648585)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Konkani (kok)'
,p_lov_return_value=>'kok'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296614189687648586)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Korean (ko)'
,p_lov_return_value=>'ko'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296614572648648586)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kyrgyz (kz)'
,p_lov_return_value=>'kz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296614914571648586)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Latvian (lv)'
,p_lov_return_value=>'lv'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296615324796648587)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lithuanian (lt)'
,p_lov_return_value=>'lt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296615729490648587)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malay (Malaysia) (ms)'
,p_lov_return_value=>'ms'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296616158838648587)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malayalam (ml)'
,p_lov_return_value=>'ml'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296616595426648588)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Maltese (mt)'
,p_lov_return_value=>'mt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296616934337648588)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marathi (mr)'
,p_lov_return_value=>'mr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296617346922648588)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nepali (India) (ne)'
,p_lov_return_value=>'ne'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296617734087648588)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Bokmal) (nb-no)'
,p_lov_return_value=>'nb-no'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296618131505648589)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Bokmal) (no)'
,p_lov_return_value=>'no'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296618500558648589)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Nynorsk) (nn-no)'
,p_lov_return_value=>'nn-no'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296618920392648589)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oriya (or)'
,p_lov_return_value=>'or'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296619368254648589)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polish (pl)'
,p_lov_return_value=>'pl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296619769972648589)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portuguese (Brazil) (pt-br)'
,p_lov_return_value=>'pt-br'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296620114741648590)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portuguese (Portugal) (pt)'
,p_lov_return_value=>'pt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296620508619648590)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Punjabi (pa)'
,p_lov_return_value=>'pa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296620933364648590)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Romanian (ro)'
,p_lov_return_value=>'ro'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296621323191648590)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russian (ru)'
,p_lov_return_value=>'ru'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296621703786648591)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russian (Moldova) (ru-md)'
,p_lov_return_value=>'ru-md'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296622118135648591)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (sr)'
,p_lov_return_value=>'sr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296622521763648591)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovak (sk)'
,p_lov_return_value=>'sk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296622950016648591)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovenian (sl)'
,p_lov_return_value=>'sl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296623399260648592)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Argentina) (es-ar)'
,p_lov_return_value=>'es-ar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296623762688648592)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Bolivia) (es-bo)'
,p_lov_return_value=>'es-bo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296624178812648592)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Chile) (es-cl)'
,p_lov_return_value=>'es-cl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296624565227648592)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Colombia) (es-co)'
,p_lov_return_value=>'es-co'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296624904675648592)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Costa Rica) (es-cr)'
,p_lov_return_value=>'es-cr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296625384946648593)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Dominican Republic) (es-do)'
,p_lov_return_value=>'es-do'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296625751939648593)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Ecuador) (es-ec)'
,p_lov_return_value=>'es-ec'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296626139826648593)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (El Salvador) (es-sv)'
,p_lov_return_value=>'es-sv'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296626540422648593)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Guatemala) (es-gt)'
,p_lov_return_value=>'es-gt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296626981975648594)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Honduras) (es-hn)'
,p_lov_return_value=>'es-hn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296627391709648594)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Mexico) (es-mx)'
,p_lov_return_value=>'es-mx'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296627748133648595)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Nicaragua) (es-ni)'
,p_lov_return_value=>'es-ni'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296628113886648595)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Panama) (es-pa)'
,p_lov_return_value=>'es-pa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296628595473648596)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Paraguay) (es-py)'
,p_lov_return_value=>'es-py'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296628969891648596)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Peru) (es-pe)'
,p_lov_return_value=>'es-pe'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296629342052648596)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Puerto Rico) (es-pr)'
,p_lov_return_value=>'es-pr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296629754406648596)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Traditional Sort) (es)'
,p_lov_return_value=>'es'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296630120538648597)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (United States) (es-us)'
,p_lov_return_value=>'es-us'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296630527097648597)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Uruguay) (es-uy)'
,p_lov_return_value=>'es-uy'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296630973789648597)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Venezuela) (es-ve)'
,p_lov_return_value=>'es-ve'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296631367009648597)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swedish (sv)'
,p_lov_return_value=>'sv'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296631752787648598)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swedish (Finland) (sv-fi)'
,p_lov_return_value=>'sv-fi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296632159700648598)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tamil (ta)'
,p_lov_return_value=>'ta'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296632542264648598)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Telugu (te)'
,p_lov_return_value=>'te'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296632948065648598)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Thai (th)'
,p_lov_return_value=>'th'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296633315215648598)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turkish (tr)'
,p_lov_return_value=>'tr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296633778731648599)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukrainian (uk)'
,p_lov_return_value=>'uk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296634131334648599)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Urdu (ur)'
,p_lov_return_value=>'ur'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296634527012648602)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Uzbek (uz)'
,p_lov_return_value=>'uz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296634951366648603)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnamese (vi)'
,p_lov_return_value=>'vi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296635341823648603)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bosnian (ba)'
,p_lov_return_value=>'ba'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296635734483648603)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Montenegrin (me)'
,p_lov_return_value=>'me'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296636149816648603)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irish (ga)'
,p_lov_return_value=>'ga'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296636548804648604)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Welsh (cy)'
,p_lov_return_value=>'cy'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296636918864648604)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swahili (sw)'
,p_lov_return_value=>'sw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296637301156648604)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Albanian'
,p_lov_return_value=>'sq'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296637734964648604)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Armenian'
,p_lov_return_value=>'hy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_territories
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(788953931940024140)
,p_lov_name=>'I18N_TERRITORIES'
,p_reference_id=>634612723768159258
,p_lov_query=>'.'||wwv_flow_imp.id(788953931940024140)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62829689894442518)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Azerbaijan'
,p_lov_return_value=>'AZERBAIJAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788980130880024177)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Algeria'
,p_lov_return_value=>'ALGERIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788980318501024177)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'America'
,p_lov_return_value=>'AMERICA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788980524096024178)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Argentina'
,p_lov_return_value=>'ARGENTINA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788980702992024178)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Australia'
,p_lov_return_value=>'AUSTRALIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788980909354024178)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Austria'
,p_lov_return_value=>'AUSTRIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788981104201024178)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bahrain'
,p_lov_return_value=>'BAHRAIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788981314054024178)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bangladesh'
,p_lov_return_value=>'BANGLADESH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788981506304024178)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Belgium'
,p_lov_return_value=>'BELGIUM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788981731301024178)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Brazil'
,p_lov_return_value=>'BRAZIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788981915417024179)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgaria'
,p_lov_return_value=>'BULGARIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788982112997024179)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Canada'
,p_lov_return_value=>'CANADA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788982320274024179)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalonia'
,p_lov_return_value=>'CATALONIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788982522979024182)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chile'
,p_lov_return_value=>'CHILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788982702173024182)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'China'
,p_lov_return_value=>'CHINA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788982929275024182)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Colombia'
,p_lov_return_value=>'COLOMBIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788983110411024182)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Costa Rica'
,p_lov_return_value=>'COSTA RICA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788983318760024182)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croatia'
,p_lov_return_value=>'CROATIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788983519697024182)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Czech Republic'
,p_lov_return_value=>'CZECH REPUBLIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788983711192024182)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Denmark'
,p_lov_return_value=>'DENMARK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788983924185024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ecuador'
,p_lov_return_value=>'ECUADOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788984103258024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Egypt'
,p_lov_return_value=>'EGYPT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788984330459024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'El Salvador'
,p_lov_return_value=>'EL SALVADOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788984523371024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonia'
,p_lov_return_value=>'ESTONIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788984729453024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finland'
,p_lov_return_value=>'FINLAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788984900811024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'France'
,p_lov_return_value=>'FRANCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788985104013024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Macedonia'
,p_lov_return_value=>'FYR MACEDONIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788985318698024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Germany'
,p_lov_return_value=>'GERMANY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788985511253024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Greece'
,p_lov_return_value=>'GREECE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788985730373024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Guatemala'
,p_lov_return_value=>'GUATEMALA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788985926875024183)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hong Kong'
,p_lov_return_value=>'HONG KONG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788986111750024187)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hungary'
,p_lov_return_value=>'HUNGARY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788986314654024187)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Iceland'
,p_lov_return_value=>'ICELAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788986518997024187)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'India'
,p_lov_return_value=>'INDIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788986720030024188)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesia'
,p_lov_return_value=>'INDONESIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788986901390024188)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Iraq'
,p_lov_return_value=>'IRAQ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788987101545024188)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ireland'
,p_lov_return_value=>'IRELAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788987312858024188)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Israel'
,p_lov_return_value=>'ISRAEL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788987521480024188)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italy'
,p_lov_return_value=>'ITALY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788987722466024188)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japan'
,p_lov_return_value=>'JAPAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788987928268024188)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Jordan'
,p_lov_return_value=>'JORDAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788988125327024189)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakhstan'
,p_lov_return_value=>'KAZAKHSTAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788988308841024189)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Korea'
,p_lov_return_value=>'KOREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788988501979024189)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kuwait'
,p_lov_return_value=>'KUWAIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788988722156024189)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Latvia'
,p_lov_return_value=>'LATVIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788988924887024189)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lebanon'
,p_lov_return_value=>'LEBANON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788989122787024189)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Libya'
,p_lov_return_value=>'LIBYA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788989329016024189)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lithuania'
,p_lov_return_value=>'LITHUANIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788989524312024189)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Luxembourg'
,p_lov_return_value=>'LUXEMBOURG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788989725001024189)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malaysia'
,p_lov_return_value=>'MALAYSIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788989925098024190)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mexico'
,p_lov_return_value=>'MEXICO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788990125708024190)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Morocco'
,p_lov_return_value=>'MOROCCO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788990312872024190)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'New Zealand'
,p_lov_return_value=>'NEW ZEALAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788990525052024190)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nicaragua'
,p_lov_return_value=>'NICARAGUA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788990722751024190)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norway'
,p_lov_return_value=>'NORWAY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788990918310024190)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oman'
,p_lov_return_value=>'OMAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788991110230024191)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Panama'
,p_lov_return_value=>'PANAMA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788991326612024191)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Peru'
,p_lov_return_value=>'PERU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788991522861024191)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Philippines'
,p_lov_return_value=>'PHILIPPINES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788991728449024191)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Poland'
,p_lov_return_value=>'POLAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788991914460024191)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugal'
,p_lov_return_value=>'PORTUGAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788992105229024191)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Puerto Rico'
,p_lov_return_value=>'PUERTO RICO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788992322244024195)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Qatar'
,p_lov_return_value=>'QATAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788992529965024195)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Romania'
,p_lov_return_value=>'ROMANIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788992732431024195)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russia'
,p_lov_return_value=>'RUSSIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788992929223024196)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Saudi Arabia'
,p_lov_return_value=>'SAUDI ARABIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788993122388024196)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbia and Montenegro'
,p_lov_return_value=>'SERBIA AND MONTENEGRO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788993307197024196)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Singapore'
,p_lov_return_value=>'SINGAPORE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788993516987024196)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovakia'
,p_lov_return_value=>'SLOVAKIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788993712467024196)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovenia'
,p_lov_return_value=>'SLOVENIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788993911470024196)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'South Africa'
,p_lov_return_value=>'SOUTH AFRICA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788994103090024197)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spain'
,p_lov_return_value=>'SPAIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788994318464024197)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sweden'
,p_lov_return_value=>'SWEDEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788994513532024197)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Switzerland'
,p_lov_return_value=>'SWITZERLAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788994702487024197)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Syria'
,p_lov_return_value=>'SYRIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788994929127024197)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Taiwan'
,p_lov_return_value=>'TAIWAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788995125228024197)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Thailand'
,p_lov_return_value=>'THAILAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788995311129024198)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Netherlands'
,p_lov_return_value=>'THE NETHERLANDS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788995503628024198)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tunisia'
,p_lov_return_value=>'TUNISIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788995720383024198)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turkey'
,p_lov_return_value=>'TURKEY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788995900122024198)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukraine'
,p_lov_return_value=>'UKRAINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788996102675024198)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'United Arab Emirates'
,p_lov_return_value=>'UNITED ARAB EMIRATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788996309949024198)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'United Kingdom'
,p_lov_return_value=>'UNITED KINGDOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788996502604024198)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Uzbekistan'
,p_lov_return_value=>'UZBEKISTAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788996713482024199)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Venezuela'
,p_lov_return_value=>'VENEZUELA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788996911281024199)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnam'
,p_lov_return_value=>'VIETNAM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788997123524024199)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yemen'
,p_lov_return_value=>'YEMEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_interval
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(274103227902682659)
,p_lov_name=>'IR_NOTIFY_INTERVAL'
,p_lov_query=>'.'||wwv_flow_imp.id(274103227902682659)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557227
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(274103521636682659)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Daily'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(274103811250682659)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Weekly'
,p_lov_return_value=>'W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(274104111453682659)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Monthly'
,p_lov_return_value=>'M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_report_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(262846363440568824)
,p_lov_name=>'IR_NOTIFY_REPORT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(262846363440568824)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557227
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(262846678033568848)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Primary Default'
,p_lov_return_value=>'PRIMARY_DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(262847021237568854)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Alternative Default'
,p_lov_return_value=>'ALTERNATIVE_DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(262847486056568854)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Public'
,p_lov_return_value=>'PUBLIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(262847815854568854)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Private'
,p_lov_return_value=>'PRIVATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(294656516286709966)
,p_lov_name=>'IR_NOTIFY_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(294656516286709966)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557227
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(294656824018709967)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Submitted'
,p_lov_return_value=>'SUBMITTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(294657122464709967)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sent'
,p_lov_return_value=>'SENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(294657432339709967)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Error'
,p_lov_return_value=>'ERROR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jump_app_lookup
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(259545535374884220)
,p_lov_name=>'JUMP_APP_LOOKUP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.ID as r,',
'       id || nvl2(f.alias,''/''||f.alias,null) as d',
'from   WWV_FLOWS f',
'where  f.security_group_id not in (10, 11, 12)'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/jump_user_lookup
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(262196629795621784)
,p_lov_name=>'JUMP_USER_LOOKUP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct ',
'       u."USER" as r,',
'       u."USER" as d',
'from   wwv_flow_workspace_users u',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/jump_workspace_lookup
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(832231721829846651)
,p_lov_name=>'JUMP_WORKSPACE_LOOKUP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/languages_installed
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(502998721971236943)
,p_lov_name=>'LANGUAGES_INSTALLED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lang_name, flow_language from ',
'(select (select max( translated_lang_name) from wwv_flow_languages l where l.lang_id = f.flow_language) lang_name, flow_language',
'  from wwv_flows f',
' where id = 4411',
'   and security_group_id = 10',
' union',
' select (select max(translated_lang_name) from wwv_flow_languages l where l.lang_id = f.flow_language) lang_name, flow_language',
'   from wwv_flows f',
'  where security_group_id = 10',
'    and id in ',
'      ( select translation_flow_id',
'          from wwv_flow_language_map',
'         where security_group_id = 10',
'           and primary_language_flow_id = 4411)',
'  order by 1)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/ldap_ssl_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(795103713402787381)
,p_lov_name=>'LDAP_SSL_LOV'
,p_reference_id=>487674627120619297
,p_lov_query=>'.'||wwv_flow_imp.id(795103713402787381)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(795105028361787385)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SSL'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(795105207558787386)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SSL with Authentication'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(795105423579787386)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No SSL'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_workspaces
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159434915946336703)
,p_lov_name=>'LIST.WORKSPACES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_all_companies
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(41061332989455513)
,p_lov_name=>'LIST_ALL_COMPANIES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''F4050_SHOW_ALL_WORKSPACES'')||',
''' -'' d, 0 r from dual union all',
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_all_companies_escaped
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(33198215215866564)
,p_lov_name=>'LIST_ALL_COMPANIES_ESCAPED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''F4050_SHOW_ALL_WORKSPACES'')||',
''' -'' d, 0 r from dual union all',
'select wwv_flow_escape.html(short_name)||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_all_companies_no_null_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(71982116125334375)
,p_lov_name=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_developer_workspaces
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(245468425022265187)
,p_lov_name=>'LIST_DEVELOPER_WORKSPACES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''F4050_SHOW_ALL_WORKSPACES'')||',
''' -'' d, 0 r from dual union all',
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id not in (0,10,11)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_developer_workspaces_no_null_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(201412507067809360)
,p_lov_name=>'LIST_DEVELOPER_WORKSPACES_NO_NULL_OPTION'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id not in (0,10,11, 12)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557227
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flow_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(85746300886317667)
,p_lov_name=>'LIST_FLOW_STATUS'
,p_reference_id=>634347472712995
,p_lov_query=>'.'||wwv_flow_imp.id(85746300886317667)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741162715995290705)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Available'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741163096116290707)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Available with Developer Toolbar'
,p_lov_return_value=>'AVAILABLE_W_EDIT_LINK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741163344386290707)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Available to Developers Only'
,p_lov_return_value=>'DEVELOPERS_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741163691224290707)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Restricted Access'
,p_lov_return_value=>'RESTRICTED_ACCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741163965010290707)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Unavailable'
,p_lov_return_value=>'UNAVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741164248206290708)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Unavailable (Status Shown with PL/SQL)'
,p_lov_return_value=>'UNAVAILABLE_PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741164577629290708)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Unavailable (Redirect to URL)'
,p_lov_return_value=>'UNAVAILABLE_URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/log_names
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(220529904687804674)
,p_lov_name=>'LOG NAMES'
,p_lov_query=>'.'||wwv_flow_imp.id(220529904687804674)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557228
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(220530223169804674)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Access Log'
,p_lov_return_value=>'ACCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(220530529937804674)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Activity Log'
,p_lov_return_value=>'ACTIVITY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(220530813867804675)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Debug Messages'
,p_lov_return_value=>'DEBUG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(220531102895804675)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'External Click Count Log'
,p_lov_return_value=>'CLICKTHRU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(642230510529647347)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Web Service'
,p_lov_return_value=>'WEBSERVICE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1408552545940823)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'REST Synchronization'
,p_lov_return_value=>'WEBSOURCESYNC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1403678011163749)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Automation'
,p_lov_return_value=>'AUTOMATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15366577927800365)
,p_lov_disp_sequence=>44
,p_lov_disp_value=>'Events'
,p_lov_return_value=>'EVENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_status_codes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(46388624571234535)
,p_lov_name=>'LOGIN STATUS CODES'
,p_lov_query=>'.'||wwv_flow_imp.id(46388624571234535)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557228
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46388926156234544)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal, successful authentication'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46389114667234544)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unknown User Name'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46389305475234544)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Account Locked'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46389507635234544)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Account Expired'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46389702262234544)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Incorrect Password'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46389924389234544)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Password First Use'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46390117950234544)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Maximum Login Attempts Exceeded'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46390320270234545)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Unknown Internal Error'
,p_lov_return_value=>'7'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_throttle_methods
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(244019724554013154)
,p_lov_name=>'LOGIN THROTTLE METHODS'
,p_lov_query=>'.'||wwv_flow_imp.id(244019724554013154)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557228
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244020024066013155)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Username and Client IP Address'
,p_lov_return_value=>'USERNAME_IP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244020707400018951)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Username'
,p_lov_return_value=>'USERNAME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244021027221018951)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Client IP Address'
,p_lov_return_value=>'IP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(245893700052641142)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Username or Client IP Address'
,p_lov_return_value=>'USERNAME:IP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_message
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(138589612463299624)
,p_lov_name=>'LOGIN_MESSAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(138589612463299624)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557228
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(138589828636299629)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Message'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(138590030175299632)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom Message'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/logo_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(361197800293344621)
,p_lov_name=>'LOGO ATTRIBUTES'
,p_reference_id=>461376702019738964
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLACK_TEXT'') d, ''style="font-family:Arial; color:#000000; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''BLUE_TEXT'') d, ''style="font-family:Arial; color:#004C66; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''WHITE_TEXT'') d, ''style="font-family:Arial; color:#FFFFFF; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''GRAY_TEXT'') d, ''style="font-family:Arial; color:#303030; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''image_attributes'') d, ''alt="Application" title="Application"'' r from dual '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_a
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87504531900192794)
,p_lov_name=>'MAX_ROWS_A'
,p_lov_query=>'.'||wwv_flow_imp.id(87504531900192794)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557228
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87504713683192797)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87504927403192799)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87505127136192799)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87505325056192799)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87505511346192800)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87505729136192800)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87505932223192800)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87506102365192800)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87506312795192801)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87506502410192801)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87506703570192801)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87506912687192801)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_b
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87717417968152000)
,p_lov_name=>'MAX_ROWS_B'
,p_lov_query=>'.'||wwv_flow_imp.id(87717417968152000)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557228
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87717608742152001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87717807507152001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87718000141152003)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87718209200152003)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87718403676152003)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87718622762152003)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87718817778152004)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87719020177152004)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87719230831152004)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87719426010152005)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87719614892152005)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87719804628152005)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'2000'
,p_lov_return_value=>'2000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_c
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87727319971247226)
,p_lov_name=>'MAX_ROWS_C'
,p_lov_query=>'.'||wwv_flow_imp.id(87727319971247226)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557229
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87727500041247227)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87727716571247227)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87727920372247227)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87728108070247227)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87728307878247228)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87728503519247228)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87728723800247228)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87728931351247228)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87729117092247229)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87729303121247229)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87729526911247229)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87729730366247229)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_d
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87730331399250507)
,p_lov_name=>'MAX_ROWS_D'
,p_lov_query=>'.'||wwv_flow_imp.id(87730331399250507)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557230
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87730525692250508)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87730714234250508)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87730921624250509)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87731129062250509)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87731321929250509)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87731521610250509)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87731715300250510)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87731919898250510)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87732124808250510)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87732326765250510)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87732513594250511)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_e
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87733213522254832)
,p_lov_name=>'MAX_ROWS_E'
,p_lov_query=>'.'||wwv_flow_imp.id(87733213522254832)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557230
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87733416419254833)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87733622113254833)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87733822263254833)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87734024639254833)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87734223358254834)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87734413410254834)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87734626070254834)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87734809939254834)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87735015995254834)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87735225800254835)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87735423051254835)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87735614522254835)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_f
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87736221141257059)
,p_lov_name=>'MAX_ROWS_F'
,p_lov_query=>'.'||wwv_flow_imp.id(87736221141257059)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557230
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87736411674257059)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87736631478257060)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87736801252257060)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87737027711257060)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87737221803257060)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87737414548257062)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87737609481257062)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87737813226257062)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87738032062257063)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87738230641257063)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_g
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87738929453259457)
,p_lov_name=>'MAX_ROWS_G'
,p_lov_query=>'.'||wwv_flow_imp.id(87738929453259457)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557230
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87739106498259457)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87739329779259460)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87739525994259460)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87739719147259460)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87739911170259460)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87740103875259461)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87740303300259461)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87740516812259461)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87740731715259461)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87740924006259462)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87741116404259462)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87741300621259463)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_h
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87745327899296842)
,p_lov_name=>'MAX_ROWS_H'
,p_lov_query=>'.'||wwv_flow_imp.id(87745327899296842)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557230
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87745524146296844)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87745725148296845)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87745929261296845)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87746105830296845)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87746317502296845)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87746523232296846)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87746716198296846)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87746907159296846)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87747109934296846)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87747307992296846)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_workspace_request_storage_sizes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(388034003778139782)
,p_lov_name=>'NEW WORKSPACE REQUEST STORAGE SIZES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'order by to_number(req_size)',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557230
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_or_existing
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87820927180096887)
,p_lov_name=>'NEW_OR_EXISTING'
,p_lov_query=>'.'||wwv_flow_imp.id(87820927180096887)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87821100243096888)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Existing'
,p_lov_return_value=>'Existing'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87821304136096888)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'New'
,p_lov_return_value=>'New'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p100_language_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2314968086831771)
,p_lov_name=>'P100_LANGUAGE_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(2314968086831771)||'.'
,p_location=>'STATIC'
,p_version_scn=>11928558
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2315200467831772)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Installed'
,p_lov_return_value=>'INSTALLED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2315632338831773)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unsupported'
,p_lov_return_value=>'UNSUPPORTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2316098511831773)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Not Installed'
,p_lov_return_value=>'NOT_INSTALLED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p104_report_row_per_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(786397812796590139)
,p_lov_name=>'P104_Report Row Per Page'
,p_lov_query=>'.'||wwv_flow_imp.id(786397812796590139)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786398123613590140)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786398320925590141)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786398521498590141)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786398729631590141)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786398928953590141)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786399112218590141)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786399324445590141)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786399515204590142)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786399715492590142)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(786399932299590142)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p131_smtp_tls_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(44180513498106696)
,p_lov_name=>'P131_SMTP_TLS_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(44180513498106696)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44180826675106699)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44181001563106699)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'After connection is established'
,p_lov_return_value=>'STARTTLS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44181213027106699)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p16_printsvr_protocol
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(41576101209699161)
,p_lov_name=>'P16.PRINTSVR.PROTOCOL'
,p_lov_query=>'.'||wwv_flow_imp.id(41576101209699161)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41576425139699162)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'HTTP'
,p_lov_return_value=>'http'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41576620353699162)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'HTTPS'
,p_lov_return_value=>'https'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p280_env_banner_colors
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2805702200728881)
,p_lov_name=>'P280_ENV_BANNER_COLORS'
,p_lov_query=>'.'||wwv_flow_imp.id(2805702200728881)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2806011133728888)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Neutral'
,p_lov_return_value=>'accent-1'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--1" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2806470563728890)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sienna'
,p_lov_return_value=>'accent-2'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--2" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2806848354728890)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Pine'
,p_lov_return_value=>'accent-3'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--3" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2807223525728890)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Teal'
,p_lov_return_value=>'accent-4'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--4" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2807684975728891)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Ocean'
,p_lov_return_value=>'accent-5'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--5" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2808012563728891)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Fog'
,p_lov_return_value=>'accent-6'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--6" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2808447823728891)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Lilac'
,p_lov_return_value=>'accent-7'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--7" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2808838195728892)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Plum'
,p_lov_return_value=>'accent-8'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--8" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1715129969025965)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Rose'
,p_lov_return_value=>'accent-9'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--9" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1715437229025965)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slate'
,p_lov_return_value=>'accent-10'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--10" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1715896618025965)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Pebble'
,p_lov_return_value=>'accent-11'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--11" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1716207338025965)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Beige'
,p_lov_return_value=>'accent-12'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--12" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1716639869025966)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Blue'
,p_lov_return_value=>'accent-13'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--13" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1717018496025966)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Red'
,p_lov_return_value=>'accent-14'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--14" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1717463920025966)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Orange'
,p_lov_return_value=>'accent-15'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--15" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1717876517025966)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Green'
,p_lov_return_value=>'accent-16'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--16" title="#DISPLAY_VALUE#"></span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p280_env_banner_pos
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(147094582352565991)
,p_lov_name=>'P280_ENV_BANNER_POS'
,p_lov_query=>'.'||wwv_flow_imp.id(147094582352565991)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147094804613565991)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Left'
,p_lov_return_value=>'LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147095201995565991)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Top'
,p_lov_return_value=>'TOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p40_recent_time
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(858080230485699950)
,p_lov_name=>'P40_RECENT_TIME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, to_char(t) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5*60 t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15*60 t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 3600 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 2*3600  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3*3600  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4*3600  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6*3600 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8*3600 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12*3600 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 18*3600 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1*24*60*60 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2*24*60*60 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3*24*60*60 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4*24*60*60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5*24*60*60 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 6*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7*24*60*60 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14*24*60*60 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365*24*60*60 t from dual order by 2',
') q'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557234
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_view_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(131020216973707367)
,p_lov_name=>'PAGE VIEW MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(131020216973707367)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131020902774707369)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamic Page'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131020730367707369)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Page Processing'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131020524068707368)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Partial Page'
,p_lov_return_value=>'P'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131023120221717730)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Cache Created'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131023727840719977)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Cached Page'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/password_generation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(203295405272404658)
,p_lov_name=>'PASSWORD GENERATION'
,p_lov_query=>'.'||wwv_flow_imp.id(203295405272404658)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(203295628313404659)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Randomly Generated'
,p_lov_return_value=>'RANDOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(203295931728404663)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Fixed Specified Value'
,p_lov_return_value=>'FIXED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/productivity_and_sample_application_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(255033227550969526)
,p_lov_name=>'PRODUCTIVITY AND SAMPLE APPLICATION STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(255033227550969526)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(255033522048969526)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Available'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(255033800732969526)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Hidden'
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(255034107216969526)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Coming Soon'
,p_lov_return_value=>'COMING_SOON'
);
end;
/
prompt --application/shared_components/user_interface/lovs/project_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87715313766122404)
,p_lov_name=>'PROJECT.STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(87715313766122404)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87715507041122405)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Declined'
,p_lov_return_value=>'DECLINED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87715706617122406)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Requested'
,p_lov_return_value=>'REQUESTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87715911749122406)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'TERMINATED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/provisioning_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87819917137094037)
,p_lov_name=>'PROVISIONING.STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(87819917137094037)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87820106497094037)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Manual - An administrator must manually create each workspace'
,p_lov_return_value=>'MANUAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87820317112094038)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Request - Link displayed on login page enabling users to request workspaces'
,p_lov_return_value=>'4700'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27774028242361017)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Request - Link displayed on login page. Requests require administrator approval.'
,p_lov_return_value=>'EMAIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5680416359052583)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Automatic - Link displayed on login page. Requests automatically approved.'
,p_lov_return_value=>'AUTO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_theme_app_selector
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(138968902616481833)
,p_lov_name=>'PUBLIC.THEME.APP.SELECTOR'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id v',
'  from WWV_FLOWS',
' where security_group_id = :P47_WORKSPACE',
'   and security_group_id not in (0,10,11)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557234
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_app_templates_regiontemps
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(346773209253201282)
,p_lov_name=>'PUBLIC_APP_TEMPLATES_REGIONTEMPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''NO_TEMPLATE'') d, 0 r from dual union all',
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :P125_ID and',
'       (:P125_THEME_ID is null or theme_id = :P125_THEME_ID)',
'order  by upper(page_plug_template_name) ) t'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557234
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_app_temp_defaults
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(340605730286750195)
,p_lov_name=>'PUBLIC_APP_TEMP_DEFAULTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from wwv_flow_templates',
'where flow_id = :P125_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557234
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_app_temp_fielddefs
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(340711321937795147)
,p_lov_name=>'PUBLIC_APP_TEMP_FIELDDEFS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id',
'from   wwv_flow_field_templates',
'where flow_id = :P125_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557234
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_days_list
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(615512721869254091)
,p_lov_name=>'PURGE.DAYS_LIST'
,p_lov_query=>'.'||wwv_flow_imp.id(615512721869254091)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615512924322254091)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 day'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615513111695254091)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2 days'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615513323497254091)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3 days'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615513531494254114)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4 days'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615513714171254114)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5 days'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615513926201254115)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'6 days '
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615514125167254115)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'7 days'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615514314553254115)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'14 days'
,p_lov_return_value=>'14'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615514527430254115)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'28 days'
,p_lov_return_value=>'28'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615514712006254115)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'180 days'
,p_lov_return_value=>'180'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615514906451254115)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'365 days'
,p_lov_return_value=>'365'
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_log_codes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(615495005199220912)
,p_lov_name=>'PURGE.LOG_CODES'
,p_lov_query=>'.'||wwv_flow_imp.id(615495005199220912)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615495230385220912)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Added to Purge List'
,p_lov_return_value=>'NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615495413353220912)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Removed from Purge List'
,p_lov_return_value=>'DELETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615495630761220912)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sent Email'
,p_lov_return_value=>'EMAIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615495829822220912)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Do not Purge'
,p_lov_return_value=>'RESPONSE_RETAIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615496013807220912)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Okay to Purge'
,p_lov_return_value=>'RESPONSE_PURGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615496220933220912)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Moved to Purge List'
,p_lov_return_value=>'MOVED_TO_NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615496401451220912)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Email Complete'
,p_lov_return_value=>'EMAIL_COMPLETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615496630482220913)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Reminder Email Complete'
,p_lov_return_value=>'REMINDER_EMAIL_COMPLETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615496832221220915)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Begin Purge of Workspace'
,p_lov_return_value=>'BEGIN_PURGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615497016409220915)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Evaluated Workspace Schema'
,p_lov_return_value=>'PURGE_SCHEMA_EVAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615497230209220915)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Evaluated Workspace Tablespace'
,p_lov_return_value=>'PURGE_TABLESPACE_EVAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615497410161220915)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Purge Complete'
,p_lov_return_value=>'PURGE_COMPLETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615497604761220915)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Error Dropping User'
,p_lov_return_value=>'ERROR_DROP_USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615497814829220915)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Error Dropping Tablespace'
,p_lov_return_value=>'ERROR_DROP_TABLESPACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615498029973220915)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Begin Drop of Database User'
,p_lov_return_value=>'BEGIN_DROP_USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615500216627224175)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'End Drop User'
,p_lov_return_value=>'END_DROP_USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615500722515225866)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Begin Drop Tablespace'
,p_lov_return_value=>'BEGIN_DROP_TABLESPACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615504427017227199)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'End Drop Tablespace'
,p_lov_return_value=>'END_DROP_TABLESPACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615504631865228563)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Begin Deletion of Workspace'
,p_lov_return_value=>'BEGIN_DELETE_WORKSPACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615504903599229872)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'End Deletion of Workspace'
,p_lov_return_value=>'END_DELETE_WORKSPACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615505608101231192)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Error Deleting Workspace'
,p_lov_return_value=>'ERROR_DELETE_WORKSPACE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_workspace_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(615479015710157661)
,p_lov_name=>'PURGE.WORKSPACE_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(615479015710157661)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557237
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615479202843157669)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Added to Purge List'
,p_lov_return_value=>'NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615479403481157676)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'To Be Purged, Email Sent'
,p_lov_return_value=>'STAGE1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615479623663157676)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'To Be Purged, Reminder Email Sent'
,p_lov_return_value=>'STAGE2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615479804138157676)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Retained'
,p_lov_return_value=>'RETAIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615480031669157676)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Being Purged'
,p_lov_return_value=>'PURGING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615480218013157676)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Purged'
,p_lov_return_value=>'PURGED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88332700235936298)
,p_lov_name=>'RECENT_TIME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557239
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time_archive
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(879932532606742210)
,p_lov_name=>'RECENT_TIME_ARCHIVE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557239
);
end;
/
prompt --application/shared_components/user_interface/lovs/rejoin_existing_sessions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(492748357556507488)
,p_lov_name=>'REJOIN_EXISTING_SESSIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(492748357556507488)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557239
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(492748670516507489)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(492748976232507489)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Enabled for Public Sessions'
,p_lov_return_value=>'P'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(492749211223507489)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Enabled for All Sessions'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reporting_period
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(180726228364333770)
,p_lov_name=>'REPORTING PERIOD'
,p_lov_query=>'.'||wwv_flow_imp.id(180726228364333770)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557239
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180726414372333772)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Day'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180726626461333773)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Week'
,p_lov_return_value=>'W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180726828392333773)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'2 Weeks'
,p_lov_return_value=>'2W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180727012432333773)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Month'
,p_lov_return_value=>'M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180727220433333773)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'2 Months'
,p_lov_return_value=>'2M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180727427905333773)
,p_lov_disp_sequence=>31.5
,p_lov_disp_value=>'3 Months'
,p_lov_return_value=>'3M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180727608631333773)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'6 Months'
,p_lov_return_value=>'6M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180727828386333774)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Year'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180728029949333774)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'2 Years'
,p_lov_return_value=>'2Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180728214594333774)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'5 Years'
,p_lov_return_value=>'5Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/request_status_show
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87760131282243533)
,p_lov_name=>'REQUEST.STATUS.SHOW'
,p_lov_query=>'.'||wwv_flow_imp.id(87760131282243533)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557241
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87760332362243533)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All'
,p_lov_return_value=>'All'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87760505501243533)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Approved'
,p_lov_return_value=>'Approved'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87760729237243534)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Denied'
,p_lov_return_value=>'Denied'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87760900898243534)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Open'
,p_lov_return_value=>'Open'
);
end;
/
prompt --application/shared_components/user_interface/lovs/require_https
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(403484377450328143)
,p_lov_name=>'REQUIRE_HTTPS'
,p_lov_query=>'.'||wwv_flow_imp.id(403484377450328143)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557241
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(403484695431328151)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(403484928622328157)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'For Development and Administration'
,p_lov_return_value=>'I'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(403485262310328157)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Application specific'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_password_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(25472316973371525)
,p_lov_name=>'RESET PASSWORD TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(25472316973371525)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557241
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25472613858371526)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Randomly Generated'
,p_lov_return_value=>'G'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25472824725371527)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Provided'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/resource_consumer_groups_non_system
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13874928060276355)
,p_lov_name=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557241
);
end;
/
prompt --application/shared_components/user_interface/lovs/scheduled_job_state
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1352009278507904884)
,p_lov_name=>'SCHEDULED_JOB_STATE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    select wwv_flow_lang.system_message(''F4050.CHAIN_STALLED'') d,''CHAIN_STALLED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.SUCCEEDED'') d,''SUCCEEDED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.RETRY SCHEDULED'') d,''RETRY SCHEDULED'' r from dual where :APP_PAGE_ID <> 26',
'    union',
'    select wwv_flow_lang.system_message(''F4050.REMOTE'') d, ''REMOTE'' r  from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.FAILED'') d, ''FAILED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.BROKEN'') d,''BROKEN'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.COMPLETED'') d, ''COMPLETED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.RUNNING'') d, ''RUNNING'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.DISABLED'') d, ''DISABLED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.SCHEDULED'') d, ''SCHEDULED'' r from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557241
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15314811390892155)
,p_lov_name=>'SECONDS'
,p_lov_query=>'.'||wwv_flow_imp.id(15314811390892155)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557241
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15315103445892221)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 Minute'
,p_lov_return_value=>'60'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15315321205892225)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'5 Minutes'
,p_lov_return_value=>'300'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15315517639892226)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'10 Minutes'
,p_lov_return_value=>'600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15315725224892226)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'30 Minutes'
,p_lov_return_value=>'1800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15315913935892226)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'1 Hour'
,p_lov_return_value=>'3600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15316108518892226)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'2 Hours'
,p_lov_return_value=>'7200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15316322196892226)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'5 Hours'
,p_lov_return_value=>'18000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15316515182892228)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'10 Hours'
,p_lov_return_value=>'36000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds_small
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1501535454230180)
,p_lov_name=>'SECONDS_SMALL'
,p_lov_query=>'.'||wwv_flow_imp.id(1501535454230180)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557241
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1501847119230194)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 Minute'
,p_lov_return_value=>'60'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1502254509230197)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2 Minutes'
,p_lov_return_value=>'120'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1502672891230197)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3 Minutes'
,p_lov_return_value=>'180'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1503034047230197)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4 Minutes'
,p_lov_return_value=>'240'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1503448296230198)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5 Minutes'
,p_lov_return_value=>'300'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1503832865230198)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'10 Minutes'
,p_lov_return_value=>'600'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_name
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(110368323210290856)
,p_lov_name=>'SERVICE.REQUEST.NAME'
,p_lov_query=>'.'||wwv_flow_imp.id(110368323210290856)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557241
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(110368501503290856)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'New Schema'
,p_lov_return_value=>'NEW_SCHEMA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(110368723358290857)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Remove Workspace'
,p_lov_return_value=>'REMOVE_EXISTING_SERVICE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(110368924348290857)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Remove Schema'
,p_lov_return_value=>'REMOVE_EXISTING_SCHEMA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(110369132258290857)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Request Storage'
,p_lov_return_value=>'CHANGE_DB_SIZE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87755726864223308)
,p_lov_name=>'SERVICE.REQUEST.STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(87755726864223308)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557241
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87755910389223309)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Approved'
,p_lov_return_value=>'APPROVED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87756108879223309)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Declined'
,p_lov_return_value=>'DECLINED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87756328524223309)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'In Progress'
,p_lov_return_value=>'IN_PROGRESS'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'26'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87756529293223310)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Requested'
,p_lov_return_value=>'REQUESTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87756716926223310)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'TERMINATED'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22138608522000517)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Accepted'
,p_lov_return_value=>'ACCEPTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_status_002
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(316820619150159698)
,p_lov_name=>'SERVICE_REQUEST_STATUS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    select wwv_flow_lang.system_message(''F4050.APPROVED'') d,''APPROVED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.DECLINED'') d,''DECLINED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.IN_PROGRESS'') d,''IN_PROGRESS'' r from dual where :APP_PAGE_ID <> 26',
'    union',
'    select wwv_flow_lang.system_message(''F4050.REQUESTED'') d, ''REQUESTED'' r  from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATED'') d, ''TERMINATED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.ACCEPTED_MSG'') d,''ACCEPTED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS2'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS3'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS4'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS5'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS6'' r from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557241
);
end;
/
prompt --application/shared_components/user_interface/lovs/site_admin_password_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(25698924524085246)
,p_lov_name=>'SITE ADMIN PASSWORD OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(25698924524085246)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557241
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89831430148813773)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use policy specified in Workspace Password Policy'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25699227500085250)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Use default strong password policy'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_display_location
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(75242612126455451)
,p_lov_name=>'TASK_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_imp.id(75242612126455451)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557241
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(75243106849455455)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Workspace Login'
,p_lov_return_value=>'WORKSPACE_LOGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(75242903496455454)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Workspace Home'
,p_lov_return_value=>'WORKSPACE_HOME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/team_dev_fs_limit
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(689538645438591983)
,p_lov_name=>'TEAM_DEV_FS_LIMIT'
,p_reference_id=>689579484876680828
,p_lov_query=>'.'||wwv_flow_imp.id(689538645438591983)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(689584332672694643)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5242880'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(689584683398694643)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10485760'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(689584997130694643)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15728640'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(689585237571694643)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20971520'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(689585513830694643)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'25'
,p_lov_return_value=>'26214400'
);
end;
/
prompt --application/shared_components/user_interface/lovs/time_intervals
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87720511660244788)
,p_lov_name=>'TIME_INTERVALS'
,p_lov_query=>'.'||wwv_flow_imp.id(87720511660244788)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557242
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87720705217244789)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87720918270244790)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87721128398244790)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'3'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87721316635244790)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'4'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87721518511244790)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87721714192244790)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'6'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87721929981244791)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'7'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87722127765244791)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'8'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87722317438244791)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'9'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87722509755244791)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87722724680244792)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'11'
,p_lov_return_value=>'11'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87722931920244792)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'12'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87723110878244792)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'13'
,p_lov_return_value=>'13'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87723310283244792)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'14'
,p_lov_return_value=>'14'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87723528574244793)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87723715299244793)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'16'
,p_lov_return_value=>'16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87723913501244793)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'17'
,p_lov_return_value=>'17'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87724129057244793)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'18'
,p_lov_return_value=>'18'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87724326333244793)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'19'
,p_lov_return_value=>'19'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87724500227244794)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87724715549244794)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'21'
,p_lov_return_value=>'21'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87724919187244794)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'22'
,p_lov_return_value=>'22'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87725132288244794)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'23'
,p_lov_return_value=>'23'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87725315196244795)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'24'
,p_lov_return_value=>'24'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87725519222244795)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87725726981244795)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'26'
,p_lov_return_value=>'26'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87725929193244795)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>'27'
,p_lov_return_value=>'27'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87726105331244796)
,p_lov_disp_sequence=>280
,p_lov_disp_value=>'28'
,p_lov_return_value=>'28'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87726330087244796)
,p_lov_disp_sequence=>290
,p_lov_disp_value=>'29'
,p_lov_return_value=>'29'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87726525128244796)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87726708945244797)
,p_lov_disp_sequence=>310
,p_lov_disp_value=>'31'
,p_lov_return_value=>'31'
);
end;
/
prompt --application/shared_components/user_interface/lovs/unhandled_errors
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(818371130728427287)
,p_lov_name=>'UNHANDLED ERRORS'
,p_lov_query=>'.'||wwv_flow_imp.id(818371130728427287)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557244
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(818371498373427288)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Show Error Page'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(818371769110427289)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Return HTTP 400'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/usage_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(825928575701276934)
,p_lov_name=>'USAGE_TYPE'
,p_reference_id=>824610978117256327
,p_lov_query=>'.'||wwv_flow_imp.id(825928575701276934)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825930514175276935)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personal'
,p_lov_return_value=>'PERSONAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(825930970103276935)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Organization'
,p_lov_return_value=>'ORG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/user_groups
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(161727824824923998)
,p_lov_name=>'USER.GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r',
'from wwv_flow_fnd_user_groups_noapp',
'where security_group_id = :F4050_P23_SECURITY_GROUP_ID order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75557244
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_list_or_icons
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(138021018445611867)
,p_lov_name=>'VIEW AS LIST OR ICONS'
,p_lov_query=>'.'||wwv_flow_imp.id(138021018445611867)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557244
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(138021303911611867)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Icons'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(138021517322611867)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Details'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/webservice_logging
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(582428114482274404)
,p_lov_name=>'WEBSERVICE LOGGING'
,p_lov_query=>'.'||wwv_flow_imp.id(582428114482274404)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557244
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(582428454798274405)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Use Workspace Settings (default)'
,p_lov_return_value=>'U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(582428895116274405)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(582429260294274406)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Never'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/workspace_name_computation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(203194513911255730)
,p_lov_name=>'WORKSPACE NAME COMPUTATION'
,p_lov_query=>'.'||wwv_flow_imp.id(203194513911255730)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557244
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(203194724498255732)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'System Generated Workspace Names'
,p_lov_return_value=>'GENERATED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(203195007395255734)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Statically Prefixed Workspace Name with Sequential Integer Suffix'
,p_lov_return_value=>'PREFIX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(203195313535255734)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Email Domain Name as Workspace Name, with Sequential Integer Suffix for duplicates'
,p_lov_return_value=>'DOMAIN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/workspace_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2379160755129464721)
,p_lov_name=>'WORKSPACE STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(2379160755129464721)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557244
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2379161043169464735)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Available'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2379161436349464739)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Assigned'
,p_lov_return_value=>'ASSIGNED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2379161846315464740)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Suspended'
,p_lov_return_value=>'SUSPENDED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2379162230719464740)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'TERMINATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2379162625399464740)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Locked'
,p_lov_return_value=>'ASSIGN_LCK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_acl_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(789504612333102303)
,p_lov_name=>'WS_APP_ACL_TYPE'
,p_reference_id=>460746220203713213
,p_lov_query=>'.'||wwv_flow_imp.id(789504612333102303)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(789505600468102306)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Default'
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(789505802137102306)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Custom'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(787558207696790415)
,p_lov_name=>'WS_APP_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(787558207696790415)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557245
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(787558503193790416)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Available'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(787558723914790416)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unavailable'
,p_lov_return_value=>'UNAVAILABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_logo_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(788592429400938627)
,p_lov_name=>'WS_LOGO_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(788592429400938627)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557245
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788592711265938628)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(788592917302938628)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_provisioning_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(113228404836854036)
,p_lov_name=>'WS_PROVISIONING_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(113228404836854036)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557245
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113228711736854036)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113228921295854036)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_yes_or_no
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(110344620122166929)
,p_lov_name=>'YES NO RETURNS YES OR NO'
,p_lov_query=>'.'||wwv_flow_imp.id(110344620122166929)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557245
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(110344806562166931)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'YES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(110345012767166934)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_1_or_0
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87817312158083090)
,p_lov_name=>'YES.NO.RETURNS.1_OR_0'
,p_lov_query=>'.'||wwv_flow_imp.id(87817312158083090)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557245
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87817530004083091)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87817713905083091)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_or_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(157992123774592395)
,p_lov_name=>'YES_NO_RETURNS_Y_OR_N'
,p_lov_query=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557245
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(157992405775592399)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(157992613021592401)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/pages/page_groups
begin
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(11152563947112359)
,p_group_name=>'Administrator Digest'
,p_group_desc=>'feature #4087 - APEX Administrator Digest scheduled for 23.1 release'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216766702444596508)
,p_group_name=>'Engine Settings'
,p_group_desc=>'Manage configuration and settings.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216800021154677630)
,p_group_name=>'Home Page'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216784309333645873)
,p_group_name=>'Mail Queue'
,p_group_desc=>'Manage mail queue'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(3931176884177111905)
,p_group_name=>'Manage Instance'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216783731365642767)
,p_group_name=>'Manage Logs'
,p_group_desc=>'Log table management.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216766430018595041)
,p_group_name=>'Manage Provisioning Services'
,p_group_desc=>'Manage service requests.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(3931176750964111248)
,p_group_name=>'Manage Requests'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(275228225185505839)
,p_group_name=>'Managing Applications'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216662902659587159)
,p_group_name=>'Monitor Activity'
,p_group_desc=>'Monitor workspace at a super user level.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216784004831644541)
,p_group_name=>'Session State Management'
,p_group_desc=>'Manage and report on htmldb session state.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216789322970659213)
,p_group_name=>'Task Management'
,p_group_desc=>'Manage task lists on service home page and on app builder home page.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216787602191653217)
,p_group_name=>'User Management'
,p_group_desc=>'Manage htmldb defined users.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216765317551591446)
,p_group_name=>'Workspace Management'
,p_group_desc=>'Manage workspace settings.'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbs/internal_admin_menu
begin
wwv_flow_imp_shared.create_menu(
 p_id=>wwv_flow_imp.id(4585800473139662)
,p_name=>'internal.admin.menu'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1592430921650085)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Automation Log'
,p_link=>'f?p=&FLOW_ID.:181:&SESSION.'
,p_page_id=>181
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1593639653666254)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Automation Log'
,p_link=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.:::'
,p_page_id=>182
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2589300985659863)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by Operating System'
,p_link=>'f?p=&FLOW_ID.:13:&SESSION.'
,p_page_id=>13
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2600224886694329)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by Browser'
,p_link=>'f?p=&FLOW_ID.:15:&SESSION.'
,p_page_id=>15
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2801145508857537)
,p_parent_id=>wwv_flow_imp.id(11129922058879863)
,p_short_name=>'Page Events'
,p_link=>'f?p=&APP_ID.:1024:&SESSION.::&DEBUG.:::'
,p_page_id=>1024
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3001161891860892)
,p_parent_id=>wwv_flow_imp.id(11130427473887697)
,p_short_name=>'Events'
,p_link=>'f?p=&APP_ID.:1025:&SESSION.::&DEBUG.:::'
,p_page_id=>1025
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4586800042158416)
,p_short_name=>'<span class="u-VisuallyHidden">Home</span><span class="a-Icon icon-breadcrumb-previous" title="Home"></span>'
,p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
,p_page_id=>3
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4587312509162011)
,p_parent_id=>wwv_flow_imp.id(6027506192823381)
,p_short_name=>'Workspace Requests'
,p_link=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_page_id=>26
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4587825323165692)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Session State'
,p_link=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:::'
,p_page_id=>63
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4603211003239218)
,p_parent_id=>wwv_flow_imp.id(6027506192823381)
,p_short_name=>'Change Requests'
,p_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::'
,p_page_id=>28
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4608012500253721)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Create Workspace'
,p_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_page_id=>27
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4611726506262368)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Feature Configuration'
,p_link=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
,p_page_id=>16
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4617723690278867)
,p_parent_id=>wwv_flow_imp.id(4586800042158416)
,p_short_name=>'Monitor Activity'
,p_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:::'
,p_page_id=>29
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4623831010290711)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by Application'
,p_link=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:::'
,p_page_id=>44
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4626009659300609)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by Application and User'
,p_link=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_page_id=>49
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4645824047369956)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by User Agent'
,p_link=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:::'
,p_page_id=>38
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4652116893418791)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Page View Activity Logs'
,p_link=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:::'
,p_page_id=>61
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4653409561422233)
,p_parent_id=>wwv_flow_imp.id(4652116893418791)
,p_short_name=>'Truncate Logs'
,p_link=>'f?p=&FLOW_ID.:62:&SESSION.'
,p_page_id=>62
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4720402234683880)
,p_parent_id=>wwv_flow_imp.id(4587825323165692)
,p_short_name=>'Purge Sessions'
,p_link=>'f?p=&FLOW_ID.:66:&SESSION.'
,p_page_id=>66
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4722132186700450)
,p_parent_id=>wwv_flow_imp.id(4587825323165692)
,p_short_name=>'Recent Sessions'
,p_link=>'f?p=&FLOW_ID.:65:&SESSION.'
,p_page_id=>65
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4728709418862901)
,p_parent_id=>wwv_flow_imp.id(4587825323165692)
,p_short_name=>'Session State Statistics'
,p_link=>'f?p=&FLOW_ID.:64:&SESSION.'
,p_page_id=>64
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4737627256930650)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'SQL Workshop Logs'
,p_link=>'f?p=&APP_ID.:46:&SESSION.::&DEBUG.:::'
,p_page_id=>46
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4738821217933374)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Existing Workspaces'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>1
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4742104180941272)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Workspace Details'
,p_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_page_id=>14
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4747925937961632)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Manage Developers and Users'
,p_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_page_id=>12
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4754008241985056)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by Workspace'
,p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_page_id=>33
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4756326991991493)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by External Site'
,p_link=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:::'
,p_page_id=>45
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4760620508009758)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by Day by Application and User'
,p_link=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::'
,p_page_id=>37
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4762212745013281)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by View'
,p_link=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:::'
,p_page_id=>30
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4764402609017998)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Events by Day'
,p_link=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:::'
,p_page_id=>54
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4767612301028720)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by Workspace and User'
,p_link=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:::'
,p_page_id=>36
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4770921778039473)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Application Changes by Developer'
,p_link=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::'
,p_page_id=>43
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5077608631625856)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Developer Activity Log'
,p_link=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:::'
,p_page_id=>19
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5087818742651531)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'External Click Counting Log'
,p_link=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:::'
,p_page_id=>85
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6027506192823381)
,p_parent_id=>wwv_flow_imp.id(4586800042158416)
,p_short_name=>'Manage Requests'
,p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::'
,p_page_id=>5
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6052324602932730)
,p_parent_id=>wwv_flow_imp.id(4586800042158416)
,p_short_name=>'Manage Workspaces'
,p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_page_id=>10
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8781730446978159)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Workspace Database Privileges'
,p_link=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_page_id=>22
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10132224222229347)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views By Hour'
,p_link=>'f?p=&FLOW_ID.:69:&SESSION.'
,p_page_id=>69
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10220331920006034)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_short_name=>'Summary Dashboard'
,p_link=>'f?p=&APP_ID.:1029:&SESSION.::&DEBUG.:::'
,p_page_id=>1029
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10923210895673049)
,p_parent_id=>wwv_flow_imp.id(11130427473887697)
,p_short_name=>'Database Errors'
,p_link=>'f?p=&APP_ID.:1031:&SESSION.::&DEBUG.:::'
,p_page_id=>1031
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10925315811698769)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_short_name=>'Top Users'
,p_link=>'f?p=&APP_ID.:1035:&SESSION.::&DEBUG.:::'
,p_page_id=>1035
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11129280693874096)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Administrator Digest'
,p_link=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::'
,p_page_id=>1000
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11130427473887697)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_short_name=>'Instance Metrics'
,p_link=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.:::'
,p_page_id=>1002
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11138825669009971)
,p_short_name=>'User Accounts - Details'
,p_link=>'f?p=&APP_ID.:1016:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1016
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11139342901013920)
,p_short_name=>'Emails Sent - Details'
,p_link=>'f?p=&APP_ID.:1017:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1017
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11139884737020901)
,p_short_name=>'Errors Count - Details'
,p_link=>'f?p=&APP_ID.:1018:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1018
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11140355377028379)
,p_short_name=>'Distinct IP Addresses  - Details'
,p_link=>'f?p=&APP_ID.:1019:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1019
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(12733917471664461)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Login Attempts'
,p_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:::'
,p_page_id=>24
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13410721423753289)
,p_parent_id=>wwv_flow_imp.id(11140835075039373)
,p_short_name=>'Workspace Details'
,p_long_name=>'Workspace Details'
,p_link=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:::'
,p_page_id=>1030
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13869232224656033)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Create Workspace'
,p_link=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.:::'
,p_page_id=>72
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13871226833658518)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Create Workspace'
,p_link=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_page_id=>73
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13872723167660259)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Create Workspace'
,p_link=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.:::'
,p_page_id=>74
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13874119069662163)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Create Workspace'
,p_link=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.:::'
,p_page_id=>79
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(14583119493258633)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Remove Workspace'
,p_link=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:::'
,p_page_id=>81
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(14583529882261640)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Remove Workspace'
,p_link=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.:::'
,p_page_id=>82
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(14583906465264336)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Remove Workspace'
,p_link=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.:::'
,p_page_id=>83
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(14584921356268633)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Remove Workspace'
,p_link=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.:::'
,p_page_id=>84
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15366805621981104)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Login Access Log'
,p_link=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_page_id=>31
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15549610245678522)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Application Changes by Workspace'
,p_link=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:::'
,p_page_id=>500
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(18703821024277695)
,p_parent_id=>wwv_flow_imp.id(19718719669530547)
,p_short_name=>'Add Schema'
,p_link=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:::'
,p_page_id=>105
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(18704130374280378)
,p_parent_id=>wwv_flow_imp.id(19718719669530547)
,p_short_name=>'Add Schema'
,p_link=>'f?p=&APP_ID.:106:&SESSION.::&DEBUG.:::'
,p_page_id=>106
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(18704412151284643)
,p_parent_id=>wwv_flow_imp.id(19718719669530547)
,p_short_name=>'Add Schema'
,p_link=>'f?p=&APP_ID.:107:&SESSION.::&DEBUG.:::'
,p_page_id=>107
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(18704723233287852)
,p_parent_id=>wwv_flow_imp.id(19718719669530547)
,p_short_name=>'Add Schema'
,p_link=>'f?p=&APP_ID.:108:&SESSION.::&DEBUG.:::'
,p_page_id=>108
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(19718719669530547)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Manage Workspace to Schema Assignments'
,p_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_page_id=>21
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(20501516629215230)
,p_parent_id=>wwv_flow_imp.id(4603211003239218)
,p_short_name=>'View Change Request'
,p_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:110::'
,p_page_id=>110
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22715826706534997)
,p_parent_id=>wwv_flow_imp.id(15549610245678522)
,p_short_name=>'Workspace Activity Details'
,p_link=>'f?p=&APP_ID.:501:&SESSION.::&DEBUG.:::'
,p_page_id=>501
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(23596724286518552)
,p_parent_id=>wwv_flow_imp.id(4737627256930650)
,p_short_name=>'Clean up Logs'
,p_link=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::'
,p_page_id=>75
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(25769124953813347)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Service Signup Wizard'
,p_link=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.:::'
,p_page_id=>111
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(29801815135014216)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Workspace Search'
,p_link=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:::'
,p_page_id=>8000
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(29817826940342994)
,p_parent_id=>wwv_flow_imp.id(29801815135014216)
,p_short_name=>'Workspace'
,p_link=>'f?p=&FLOW_ID.:8001:&SESSION.'
,p_page_id=>8001
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(36782390065115467)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'REST Synchronization Log'
,p_link=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.:::'
,p_page_id=>161
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(39295630191089140)
,p_parent_id=>wwv_flow_imp.id(4747925937961632)
,p_short_name=>'Create / Edit User'
,p_link=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:::'
,p_page_id=>23
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40438104699665664)
,p_parent_id=>wwv_flow_imp.id(4587312509162011)
,p_short_name=>'Provisioning Administration'
,p_link=>'f?p=&FLOW_ID.:4:&SESSION.'
,p_page_id=>4
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40439200601667531)
,p_parent_id=>wwv_flow_imp.id(4587312509162011)
,p_short_name=>'Approve Provision Request'
,p_link=>'f?p=&FLOW_ID.:55:&SESSION.'
,p_page_id=>55
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40440327331670342)
,p_parent_id=>wwv_flow_imp.id(4587312509162011)
,p_short_name=>'Decline Provision Request'
,p_link=>'f?p=&FLOW_ID.:56:&SESSION.'
,p_page_id=>56
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40441522370672659)
,p_parent_id=>wwv_flow_imp.id(4587312509162011)
,p_short_name=>'Provision Request'
,p_link=>'f?p=&FLOW_ID.:6:&SESSION.'
,p_page_id=>6
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47181408364860054)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Developer Last Login'
,p_link=>'f?p=&FLOW_ID.:35:&SESSION.'
,p_page_id=>35
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47636522749932000)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Security'
,p_link=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::'
,p_page_id=>130
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48366213770241935)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Mail Queue'
,p_long_name=>'Mail Queue'
,p_link=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:::'
,p_page_id=>120
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(50513708160442260)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Mail Log'
,p_long_name=>'Mail Log'
,p_link=>'f?p=&APP_ID.:121:&SESSION.::&DEBUG.:::'
,p_page_id=>121
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(51163924477211254)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Instance Settings'
,p_link=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
,p_page_id=>131
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(51281405952355975)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Set System Message'
,p_link=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:::'
,p_page_id=>132
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(63533206146931905)
,p_parent_id=>wwv_flow_imp.id(4747925937961632)
,p_short_name=>'Reset Password'
,p_link=>'f?p=&FLOW_ID.:53:&SESSION.'
,p_page_id=>53
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(63706904690661881)
,p_parent_id=>wwv_flow_imp.id(4722132186700450)
,p_short_name=>'Session Details'
,p_link=>'f?p=&FLOW_ID.:67:&SESSION.'
,p_page_id=>67
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(68357616835819088)
,p_parent_id=>wwv_flow_imp.id(4587312509162011)
,p_short_name=>'Adjust Request'
,p_link=>'f?p=&FLOW_ID.:7:&SESSION.::&DEBUG.:::'
,p_page_id=>7
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(68369605800844354)
,p_parent_id=>wwv_flow_imp.id(4587312509162011)
,p_short_name=>'Delete Request'
,p_link=>'f?p=&FLOW_ID.:8:&SESSION.::&DEBUG.:::'
,p_page_id=>8
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(68455820429179669)
,p_parent_id=>wwv_flow_imp.id(4738821217933374)
,p_short_name=>'Edit Workspace Information'
,p_link=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:::'
,p_page_id=>78
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(74653816579025410)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Lock Workspace'
,p_link=>'f?p=&FLOW_ID.:89:&SESSION.'
,p_page_id=>89
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(74669930632071892)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Lock Workspace'
,p_link=>'f?p=&FLOW_ID.:90:&SESSION.'
,p_page_id=>90
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(75184116621221469)
,p_parent_id=>wwv_flow_imp.id(79867419412344264)
,p_short_name=>'Install Workspace'
,p_link=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.:::'
,p_page_id=>278
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(75265816075541761)
,p_parent_id=>wwv_flow_imp.id(75266632352546405)
,p_short_name=>'Create/Edit Site-Specific Resource'
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(75266632352546405)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Site-Specific Resources'
,p_link=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:17::'
,p_page_id=>18
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79867419412344264)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Import Workspace'
,p_long_name=>'Import Workspace'
,p_link=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_page_id=>460
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79869300066366991)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Import Workspace'
,p_link=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:::'
,p_page_id=>163
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79871328247384629)
,p_parent_id=>wwv_flow_imp.id(79867419412344264)
,p_short_name=>'Install Workspace'
,p_long_name=>'Install Workspace'
,p_link=>'f?p=&FLOW_ID.:277:&SESSION.::&DEBUG.:::'
,p_page_id=>277
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79871614873390258)
,p_parent_id=>wwv_flow_imp.id(79867419412344264)
,p_short_name=>'Install Workspace'
,p_long_name=>'Install Workspace'
,p_link=>'f?p=&FLOW_ID.:165:&SESSION.::&DEBUG.:::'
,p_page_id=>165
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79871930110394643)
,p_parent_id=>wwv_flow_imp.id(79867419412344264)
,p_short_name=>'Imported Workspace Export Files'
,p_link=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_page_id=>173
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(81363923500633767)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Export Workspace'
,p_link=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:::'
,p_page_id=>461
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(90106925888696249)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Backup Log'
,p_link=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:::'
,p_page_id=>147
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(98196930690236730)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Workspace Last Used'
,p_link=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:::'
,p_page_id=>25
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(112305571542063518)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Push Notifications Queue'
,p_link=>'f?p=&APP_ID.:125:&SESSION.::&DEBUG.:::'
,p_page_id=>125
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(130330112588540496)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Signup Survey'
,p_link=>'f?p=&APP_ID.:113:&SESSION.::&DEBUG.:::'
,p_page_id=>113
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(132784419557719566)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'New Service Requests'
,p_link=>'f?p=&FLOW_ID.:114:&SESSION.'
,p_page_id=>114
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(138018800392611865)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Public Themes'
,p_link=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
,p_page_id=>555
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(138031613241631494)
,p_parent_id=>wwv_flow_imp.id(138018800392611865)
,p_short_name=>'Edit Public Theme'
,p_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::'
,p_page_id=>42
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(138042916646643273)
,p_parent_id=>wwv_flow_imp.id(138018800392611865)
,p_short_name=>'Create Public Theme'
,p_link=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:::'
,p_page_id=>47
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(138053929247655080)
,p_parent_id=>wwv_flow_imp.id(138018800392611865)
,p_short_name=>'Create Public Theme'
,p_link=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::'
,p_page_id=>48
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(138064613747663617)
,p_parent_id=>wwv_flow_imp.id(138018800392611865)
,p_short_name=>'Create Public Theme'
,p_link=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:::'
,p_page_id=>51
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(138137024290914175)
,p_parent_id=>wwv_flow_imp.id(138018800392611865)
,p_short_name=>'Create Public Theme'
,p_link=>'f?p=&FLOW_ID.:57:&SESSION.'
,p_page_id=>57
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(138141916090918467)
,p_parent_id=>wwv_flow_imp.id(138018800392611865)
,p_short_name=>'Create Public Theme'
,p_link=>'f?p=&FLOW_ID.:58:&SESSION.'
,p_page_id=>58
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(141709314755230984)
,p_parent_id=>wwv_flow_imp.id(47636522749932000)
,p_short_name=>'Edit Scheme'
,p_link=>'f?p=&APP_ID.:136:&SESSION.'
,p_page_id=>136
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(155227327828557571)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Native Component Utilization Chart'
,p_link=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.:::'
,p_page_id=>102
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(155371253393130044)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Native Component Utilization Report'
,p_link=>'f?p=&APP_ID.:140:&SESSION.'
,p_page_id=>140
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(160878928251538142)
,p_parent_id=>wwv_flow_imp.id(4587825323165692)
,p_short_name=>'Background Executions'
,p_link=>'f?p=&APP_ID.:191:&SESSION.::&DEBUG.:191::'
,p_page_id=>191
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(161279124919280651)
,p_parent_id=>wwv_flow_imp.id(19718719669530547)
,p_short_name=>'Edit Schema to Workspace Assignment'
,p_link=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_page_id=>20
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(161577505898240777)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Automatic File Delete Log'
,p_link=>'f?p=&FLOW_ID.:124:&SESSION.'
,p_page_id=>124
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162274419076104279)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Archive Activity Log'
,p_link=>'f?p=&FLOW_ID.:34:&SESSION.'
,p_page_id=>34
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(168488515060465304)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'File Utilization by Workspace'
,p_link=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::'
,p_page_id=>39
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(168496516199569448)
,p_parent_id=>wwv_flow_imp.id(4586800042158416)
,p_short_name=>'Manage Instance'
,p_link=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_page_id=>9
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(168519007394879035)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Dashboard'
,p_link=>'f?p=&FLOW_ID.:40:&SESSION.'
,p_page_id=>40
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(168811125378155218)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Login Message'
,p_link=>'f?p=&FLOW_ID.:41:&SESSION.'
,p_page_id=>41
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(173287416442781913)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Component Availability'
,p_link=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:::'
,p_page_id=>52
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(173291712511844438)
,p_parent_id=>wwv_flow_imp.id(173287416442781913)
,p_short_name=>'Workspace Settings'
,p_link=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.:::'
,p_page_id=>59
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(184032326132147079)
,p_parent_id=>wwv_flow_imp.id(29817826940342994)
,p_short_name=>'Email'
,p_link=>'f?p=&FLOW_ID.:76:&SESSION.'
,p_page_id=>76
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201319721952457221)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Activity by Day'
,p_link=>'f?p=&APP_ID.:68:&SESSION.::&DEBUG.:::'
,p_page_id=>68
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201371611286583623)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Activity by Application by Day'
,p_link=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.:::'
,p_page_id=>77
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201377704576617189)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Activity by Workspace'
,p_link=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:::'
,p_page_id=>80
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201525025478711489)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Installed Translations'
,p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::'
,p_page_id=>100
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(203154703095491475)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Create Multiple Workspaces'
,p_link=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:::'
,p_page_id=>115
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(204695329206748522)
,p_parent_id=>wwv_flow_imp.id(204699118900792039)
,p_short_name=>'Edit Workspace Provision Request'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(204698620127790065)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Create Multiple Workspaces'
,p_link=>'f?p=&FLOW_ID.:117:&SESSION.'
,p_page_id=>117
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(204699118900792039)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Create Multiple Workspaces'
,p_link=>'f?p=&FLOW_ID.:116:&SESSION.'
,p_page_id=>116
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(217657129689347489)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Manage Log Interval'
,p_link=>'f?p=&APP_ID.:119:&SESSION.::&DEBUG.:::'
,p_page_id=>119
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(219091801243391095)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Application Hash By Day'
,p_link=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:RP::'
,p_page_id=>141
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(244316400794845905)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Build Status'
,p_link=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::'
,p_page_id=>400
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(244644212695071158)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Parsing Schemas'
,p_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::'
,p_page_id=>401
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(244652210402079945)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Application Attributes'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(274120800045824670)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Interactive Report Subscriptions'
,p_link=>'f?p=&FLOW_ID.:129:&SESSION.'
,p_page_id=>129
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(284066358933239262)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Data Loading Jobs'
,p_link=>'f?p=&FLOW_ID.:144:&SESSION.'
,p_page_id=>144
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(388179526938368968)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Create Multiple Workspaces'
,p_link=>'f?p=&APP_ID.:135:&SESSION.'
,p_page_id=>135
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(491859103758196049)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Events by Day'
,p_link=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:::'
,p_page_id=>86
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(499049929999448400)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Workspace Purge Settings'
,p_link=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:::'
,p_page_id=>133
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(500561475728993019)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Faceted Workspace Search'
,p_link=>'f?p=&APP_ID.:152:&SESSION.'
,p_page_id=>152
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(505832201115288634)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Inactive Workspaces'
,p_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:::'
,p_page_id=>87
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(505837505674514394)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Workspaces Purged'
,p_link=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::'
,p_page_id=>91
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(505839217307524193)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Workspaces that became Active'
,p_link=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:::'
,p_page_id=>92
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(505845507756604641)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Workspace Purge Log'
,p_link=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:::'
,p_page_id=>98
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(505847206006635779)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Workspace Purge Dashboard'
,p_link=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:::'
,p_page_id=>99
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(524767132718077538)
,p_parent_id=>wwv_flow_imp.id(525071413296326430)
,p_short_name=>'Workspace Cache'
,p_link=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.:::'
,p_page_id=>148
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(524799538487232706)
,p_parent_id=>wwv_flow_imp.id(524767132718077538)
,p_short_name=>' Table Column Cache'
,p_link=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:::'
,p_page_id=>149
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(525071413296326430)
,p_parent_id=>wwv_flow_imp.id(6052324602932730)
,p_short_name=>'Data Dictionary Cache'
,p_link=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:::'
,p_page_id=>150
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(619289932752143228)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Jobs'
,p_link=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:::'
,p_page_id=>122
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(619327423899379390)
,p_parent_id=>wwv_flow_imp.id(619289932752143228)
,p_short_name=>'Job Details'
,p_link=>'f?p=&FLOW_ID.:123:&SESSION.'
,p_page_id=>123
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(619970453087121945)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Web Service Activity Log'
,p_link=>'f?p=&APP_ID.:101:&SESSION.'
,p_page_id=>101
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(620805257997072192)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Manage Web Service Activity Log'
,p_link=>'f?p=&APP_ID.:139:&SESSION.::&DEBUG.:::'
,p_page_id=>139
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(629290306954602539)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Active Workspaces by Day'
,p_link=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.:::'
,p_page_id=>93
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(799823828864286581)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_short_name=>'Security'
,p_link=>'f?p=&FLOW_ID.:95:&SESSION.'
,p_page_id=>95
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(799824316355292355)
,p_parent_id=>wwv_flow_imp.id(799823828864286581)
,p_short_name=>'Authorized URL'
,p_link=>'f?p=&FLOW_ID.:96:&SESSION.'
,p_page_id=>96
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(831620316700274606)
,p_parent_id=>wwv_flow_imp.id(880634492387323345)
,p_short_name=>'Active Usage Detail'
,p_link=>'f?p=&APP_ID.:153:&SESSION.::&DEBUG.:::'
,p_page_id=>153
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(832244909161904272)
,p_parent_id=>wwv_flow_imp.id(880634492387323345)
,p_short_name=>'Application Activity Detail'
,p_link=>'f?p=&APP_ID.:155:&SESSION.::&DEBUG.:RP::'
,p_page_id=>155
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(832531037162024796)
,p_parent_id=>wwv_flow_imp.id(880634492387323345)
,p_short_name=>'Developer Activity Detail'
,p_link=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:RP::'
,p_page_id=>156
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(833032301623192501)
,p_parent_id=>wwv_flow_imp.id(880634492387323345)
,p_short_name=>'Runtime Application Activity'
,p_link=>'f?p=&APP_ID.:157:&SESSION.::&DEBUG.:RP::'
,p_page_id=>157
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(879929448434711077)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Activity by Workspace'
,p_link=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:::'
,p_page_id=>32
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(880163125476291015)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Activity by Application'
,p_link=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:::'
,p_page_id=>50
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(880595981114924695)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Top Applications'
,p_link=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_page_id=>71
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(880632289691302686)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Top Workspaces'
,p_link=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:::'
,p_page_id=>137
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(880634492387323345)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Activity Summary'
,p_link=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.:::'
,p_page_id=>138
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1813869716370998260)
,p_parent_id=>wwv_flow_imp.id(4617723690278867)
,p_short_name=>'Page Views by User by Day'
,p_link=>'f?p=&APP_ID.:94:&SESSION.'
,p_page_id=>94
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5001087621822912)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>20
,p_short_name=>'Schema Metrics'
,p_link=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.:::'
,p_page_id=>1003
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10371685460386112)
,p_parent_id=>wwv_flow_imp.id(168496516199569448)
,p_option_sequence=>30
,p_short_name=>'Configure Email Restrictions'
,p_link=>'f?p=&APP_ID.:1026:&SESSION.::&DEBUG.:::'
,p_page_id=>1026
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11129922058879863)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>30
,p_short_name=>'Workspace Metrics'
,p_link=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.:::'
,p_page_id=>1001
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11131954240904753)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>40
,p_short_name=>'Active Workspaces'
,p_link=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.:::'
,p_page_id=>1005
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11132495501914845)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>50
,p_short_name=>'Workspace Users'
,p_link=>'f?p=&APP_ID.:1006:&SESSION.::&DEBUG.:::'
,p_page_id=>1006
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11131433994894509)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>60
,p_short_name=>'Workspace Schemas'
,p_link=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_page_id=>1004
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11132960142919364)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>60
,p_short_name=>'Active Applications'
,p_link=>'f?p=&APP_ID.:1007:&SESSION.::&DEBUG.:::'
,p_page_id=>1007
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11134573304947522)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>90
,p_short_name=>'Workspace Users - Last &AI_DEFAULT_REPORTING_PERIOD. days'
,p_link=>'f?p=&APP_ID.:1010:&SESSION.::&DEBUG.:::'
,p_page_id=>1010
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11135077254949976)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>110
,p_short_name=>'Applications - Last &AI_DEFAULT_REPORTING_PERIOD. days'
,p_link=>'f?p=&APP_ID.:1011:&SESSION.::&DEBUG.:::'
,p_page_id=>1011
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11135579353956138)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>120
,p_short_name=>'User Scheduler Jobs'
,p_link=>'f?p=&APP_ID.:1012:&SESSION.::&DEBUG.:::'
,p_page_id=>1012
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11136559527967160)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>140
,p_short_name=>'User Database Links'
,p_link=>'f?p=&APP_ID.:1014:&SESSION.::&DEBUG.:::'
,p_page_id=>1014
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11137042860972839)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>150
,p_short_name=>'Workspaces with &AI_WORKSPACE_FREE_SPACE_LIMIT.% Free Space Remaining'
,p_link=>'f?p=&APP_ID.:1015:&SESSION.::&DEBUG.:::'
,p_page_id=>1015
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3002180973882846)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>160
,p_short_name=>'System Scheduler Jobs'
,p_link=>'f?p=&APP_ID.:1027:&SESSION.::&DEBUG.:::'
,p_page_id=>1027
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3002619209885615)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>170
,p_short_name=>'Instance Failed Jobs'
,p_link=>'f?p=&APP_ID.:1028:&SESSION.::&DEBUG.:::'
,p_page_id=>1028
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11140835075039373)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>180
,p_short_name=>'Top Workspaces'
,p_link=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.:::'
,p_page_id=>1020
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11141311003042807)
,p_parent_id=>wwv_flow_imp.id(11129280693874096)
,p_option_sequence=>190
,p_short_name=>'Top Applications'
,p_link=>'f?p=&APP_ID.:1021:&SESSION.::&DEBUG.:::'
,p_page_id=>1021
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/done_popup
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(20939016234587158)
,p_theme_id=>3
,p_name=>'[x] Popup'
,p_internal_name=>'DONE_POPUP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8">',
'    <title>#TITLE#</title>',
'    <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'    ',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="aPopupPage">',
'    <noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>#REGION_POSITION_02##REGION_POSITION_03##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##BODY#</div>',
'<div style="text-align:middle;">#REGION_POSITION_08#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden" role="alert">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>19940022257958945
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72741308804039234)
,p_page_template_id=>wwv_flow_imp.id(20939016234587158)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72741865715039235)
,p_page_template_id=>wwv_flow_imp.id(20939016234587158)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72742327279039235)
,p_page_template_id=>wwv_flow_imp.id(20939016234587158)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72742800231039236)
,p_page_template_id=>wwv_flow_imp.id(20939016234587158)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72743323343039237)
,p_page_template_id=>wwv_flow_imp.id(20939016234587158)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72743830563039238)
,p_page_template_id=>wwv_flow_imp.id(20939016234587158)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72744365831039238)
,p_page_template_id=>wwv_flow_imp.id(20939016234587158)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_rw_faceted_search
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(500583153011311249)
,p_theme_id=>3
,p_name=>'APEX RW - Faceted Search'
,p_internal_name=>'APEX_RW_-_FACETED_SEARCH'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES# a-Page--facetedSearch" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div id="main" class="a-Body">',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>383682332851249713
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293459701078956036)
,p_page_template_id=>wwv_flow_imp.id(500583153011311249)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293460264436956036)
,p_page_template_id=>wwv_flow_imp.id(500583153011311249)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293460749907956036)
,p_page_template_id=>wwv_flow_imp.id(500583153011311249)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293461287564956037)
,p_page_template_id=>wwv_flow_imp.id(500583153011311249)
,p_name=>'Facets'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293461788422956037)
,p_page_template_id=>wwv_flow_imp.id(500583153011311249)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293462240403956037)
,p_page_template_id=>wwv_flow_imp.id(500583153011311249)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293462783707956037)
,p_page_template_id=>wwv_flow_imp.id(500583153011311249)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(517336519765126407)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'</header>',
'  <div id="main" class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293171451583857419)
,p_page_template_id=>wwv_flow_imp.id(517336519765126407)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293171932118857419)
,p_page_template_id=>wwv_flow_imp.id(517336519765126407)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293172480834857420)
,p_page_template_id=>wwv_flow_imp.id(517336519765126407)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293172905584857420)
,p_page_template_id=>wwv_flow_imp.id(517336519765126407)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293173431788857420)
,p_page_template_id=>wwv_flow_imp.id(517336519765126407)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293173903181857421)
,p_page_template_id=>wwv_flow_imp.id(517336519765126407)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293174475595857421)
,p_page_template_id=>wwv_flow_imp.id(517336519765126407)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(704456563630760825)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Edit Screen'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'</header>',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main id="main" class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER.">',
'        <span class="u-vh">&MSG_USER.</span>',
'      </span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE.">',
'        <span class="u-vh">&MSG_WORKSPACE.</span>',
'      </span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE.">',
'        <span class="u-vh">&MSG_LANGUAGE.</span>',
'      </span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293319682261925379)
,p_page_template_id=>wwv_flow_imp.id(704456563630760825)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293320198535925379)
,p_page_template_id=>wwv_flow_imp.id(704456563630760825)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293320699675925379)
,p_page_template_id=>wwv_flow_imp.id(704456563630760825)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293321163284925380)
,p_page_template_id=>wwv_flow_imp.id(704456563630760825)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293321675884925380)
,p_page_template_id=>wwv_flow_imp.id(704456563630760825)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293322198940925380)
,p_page_template_id=>wwv_flow_imp.id(704456563630760825)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293322648718925381)
,p_page_template_id=>wwv_flow_imp.id(704456563630760825)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293323187160925381)
,p_page_template_id=>wwv_flow_imp.id(704456563630760825)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(721098050798687927)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Dialog'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,baseDialogClass:''a-Dialog--uiDialog'',dialogClass:#DIALOG_CSS_CLASSES#,jsDialogClass:true,#DIALOG'
||'_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293484956221977315)
,p_page_template_id=>wwv_flow_imp.id(721098050798687927)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293485432745977316)
,p_page_template_id=>wwv_flow_imp.id(721098050798687927)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293485903438977316)
,p_page_template_id=>wwv_flow_imp.id(721098050798687927)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(721098416706687971)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'    #REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'</header>',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div id="main" class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.'' aria-label=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.''><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1509680865768817)
,p_page_template_id=>wwv_flow_imp.id(721098416706687971)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1510131616768818)
,p_page_template_id=>wwv_flow_imp.id(721098416706687971)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1510687659768818)
,p_page_template_id=>wwv_flow_imp.id(721098416706687971)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1511112412768818)
,p_page_template_id=>wwv_flow_imp.id(721098416706687971)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1511677034768818)
,p_page_template_id=>wwv_flow_imp.id(721098416706687971)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1512193221768818)
,p_page_template_id=>wwv_flow_imp.id(721098416706687971)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1512615160768819)
,p_page_template_id=>wwv_flow_imp.id(721098416706687971)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(721099117305687972)
,p_theme_id=>3
,p_name=>'[x] Internal Admin Wizard'
,p_internal_name=>'APEX_5.0_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message" role="alert">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140031761677349515)
,p_page_template_id=>wwv_flow_imp.id(721099117305687972)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140031889545349515)
,p_page_template_id=>wwv_flow_imp.id(721099117305687972)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140031968654349514)
,p_page_template_id=>wwv_flow_imp.id(721099117305687972)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1898412455616603153)
,p_page_template_id=>wwv_flow_imp.id(721099117305687972)
,p_name=>'Wizard Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1898412520151603153)
,p_page_template_id=>wwv_flow_imp.id(721099117305687972)
,p_name=>'Wizard Progress List'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1898412622980603153)
,p_page_template_id=>wwv_flow_imp.id(721099117305687972)
,p_name=>'Wizard Title'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1898412708480603153)
,p_page_template_id=>wwv_flow_imp.id(721099117305687972)
,p_name=>'Wizard Buttons'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(721103220819687982)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Wizard Dialog'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,baseDialogClass:''a-Dialog--wizard'',dialogClass:#DIALOG_CSS_CLASSES#,jsDialogClass:true,#DIALOG_A'
||'TTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293531975115992200)
,p_page_template_id=>wwv_flow_imp.id(721103220819687982)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293532458230992200)
,p_page_template_id=>wwv_flow_imp.id(721103220819687982)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293532908746992201)
,p_page_template_id=>wwv_flow_imp.id(721103220819687982)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_image_legacy_apex_5_migration
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3791713542864)
,p_template_name=>'HTML image (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_IMAGE_LEGACY_APEX_5_MIGRATION'
,p_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_hot_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_icon_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(202619211737261364)
,p_template_name=>'APEX 4.2 - Icon Button'
,p_internal_name=>'APEX_4.2_ICON_BUTTON'
,p_template=>'<a href="#LINK#" class="aIconButton" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES# role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" /></a>'
,p_hot_template=>'<a href="#LINK#" class="aIconButton" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES# role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" /></a>'
,p_reference_id=>46198532248154431
,p_translate_this_template=>'N'
,p_theme_class_id=>0
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="xpbutton" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tbody class="FFFFFF">',
'<tr>',
'<td class="L" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'<td class="C"><a href="#LINK#">#LABEL#</a></td>',
'<td class="R" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'</tr>',
'</tbody>',
'</table>'))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_next_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(202619414551261366)
,p_template_name=>'APEX 4.2 - Next Button'
,p_internal_name=>'APEX_4.2_NEXT_BUTTON'
,p_template=>'<button class="aButton nextButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" class="nextBlack" alt=""/></span></button>'
,p_hot_template=>'<button class="aButton hotButton nextButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" class="nextWhite" alt=""/></span></button>'
,p_reference_id=>40780910892272674
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_previous_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(202619726455261367)
,p_template_name=>'APEX 4.2 - Previous Button'
,p_internal_name=>'APEX_4.2_PREVIOUS_BUTTON'
,p_template=>'<button title="#LABEL!ATTR#" class="aButton prevButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevBlack" alt="#LABEL!ATTR#" /></span></button>'
,p_hot_template=>'<button title="#LABEL!ATTR#" class="aButton hotButton prevButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevWhite" alt="#LABEL!ATTR#" /></span></button>'
,p_reference_id=>40781222929295107
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_1_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(296326723097791037)
,p_template_name=>'APEX 4.1 - Button'
,p_internal_name=>'APEX_4.1_BUTTON'
,p_template=>'<button class="aButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_hot_template=>'<button class="aButton hotButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_reference_id=>275775519061831382
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="button-gray" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> ',
'',
'',
'<a href="#LINK#" class="button-orange" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> '))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_0_next_gray_bg
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(504434004298772014)
,p_template_name=>'APEX 4.0 - Next (gray bg)'
,p_internal_name=>'APEX_4.0_NEXT_GRAY_BG'
,p_template=>'<button onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" class="aButton nextButton rightPill #BUTTON_CSS_CLASSES#" title="#LABEL!ATTR#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="nextBlack" alt="#LABEL!ATTR#" /></span></but'
||'ton> '
,p_hot_template=>'<button onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" class="aButton hotButton nextButton rightPill #BUTTON_CSS_CLASSES#" title="#LABEL!ATTR#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="nextWhite" alt="#LABEL!ATTR#" /></'
||'span></button> '
,p_reference_id=>430240008284905073
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_0_previous_gray_bg
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(504434222085772019)
,p_template_name=>'APEX 4.0 - Previous (gray bg)'
,p_internal_name=>'APEX_4.0_PREVIOUS_GRAY_BG'
,p_template=>'<button onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" class="aButton prevButton leftPill #BUTTON_CSS_CLASSES#" title="#LABEL!ATTR#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevBlack" alt="#LABEL!ATTR#" /></span></butt'
||'on>'
,p_hot_template=>'<button onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" class="aButton hotButton prevButton leftPill #BUTTON_CSS_CLASSES#" title="#LABEL!ATTR#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevWhite" alt="#LABEL!ATTR#" /></s'
||'pan></button>'
,p_reference_id=>430240500796912446
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(517372214551202759)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(517372670814202760)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(517372928661202760)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(517373248988202760)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_button_legacy_apex_5_migration
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(517849275695867600)
,p_template_name=>'HTML button (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_BUTTON_LEGACY_APEX_5_MIGRATION'
,p_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_hot_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_hide_and_show_region_2
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(24425502725250282)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="hide-show-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="hide-show-top">',
'    <div class="hide-show-title"><h3>',
'      <a href="#" onclick="htmldb_ToggleTableBody(''i#REGION_STATIC_ID#'',''body#REGION_STATIC_ID#''); return false;">',
'        <img src="#IMAGE_PREFIX#htmldb/builder/rollup_plus_dgray.gif" class="pseudoButtonActive" id="i#REGION_STATIC_ID#" alt="" />',
'        #TITLE#',
'      </a></h3>    ',
'    </div>',
'  </div>',
'  <div class="hide-show-body" style="display:none;" id="body#REGION_STATIC_ID#">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 -  Hide and Show Region 2'
,p_internal_name=>'APEX_4.0__HIDE_AND_SHOW_REGION_2'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>106535103160611208
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60381940387097888)
,p_plug_template_id=>wwv_flow_imp.id(24425502725250282)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60382428962097888)
,p_plug_template_id=>wwv_flow_imp.id(24425502725250282)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_large
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(29320203159835418)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Rounded Corner Large (2)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_LARGE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>27763613494297374
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92227740375205908)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92228245799205909)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92228796070205909)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92229275166205909)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92229742190205909)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92230277042205910)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92230779501205910)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92231240689205910)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92231706648205911)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92232242225205911)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92232757850205911)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92233254252205911)
,p_plug_template_id=>wwv_flow_imp.id(29320203159835418)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small_blue_top
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(29321105756835436)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Rounded Corner Small (Blue Top)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL_BLUE_TOP'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>26881811222918187
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92272231021210747)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92272709521210747)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92273270656210747)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92273760646210748)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92274256823210748)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92274740477210748)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92275252189210748)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92275720105210749)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92276270888210749)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92276720133210749)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92277239669210749)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92277732764210750)
,p_plug_template_id=>wwv_flow_imp.id(29321105756835436)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_message_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(29446610665366048)
,p_layout=>'TABLE'
,p_template=>'<div class="a-SystemMessage #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Message Region'
,p_internal_name=>'APEX_5.0_MESSAGE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>29333927116050844
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(229912792741787149)
,p_plug_template_id=>wwv_flow_imp.id(29446610665366048)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(229913286645787150)
,p_plug_template_id=>wwv_flow_imp.id(29446610665366048)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_c_htmldbhid
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(29794925290987920)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 4.0 Div  with ID (c:htmldbHID)'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_C:HTMLDBHID'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>245224629509817478
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140495645115344519)
,p_plug_template_id=>wwv_flow_imp.id(29794925290987920)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140495713682344519)
,p_plug_template_id=>wwv_flow_imp.id(29794925290987920)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small_gray_top
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(46791917808357778)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Rounded Corner Small (Gray Top)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL_GRAY_TOP'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>32612420016685806
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92296763075260724)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92297234806260724)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92297709755260725)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92298255812260725)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92298766322260725)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92299248978260725)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92299729379260726)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92300243387260726)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92300715985260726)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92301226605260727)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92301713321260727)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92302218880260727)
,p_plug_template_id=>wwv_flow_imp.id(46791917808357778)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_c_htmldbhid_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(47529013609325628)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 4.0 - Div  with ID (c:htmldbHID)'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_C:HTMLDBHID'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>245224629509817478
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140497072317344517)
,p_plug_template_id=>wwv_flow_imp.id(47529013609325628)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140497193915344517)
,p_plug_template_id=>wwv_flow_imp.id(47529013609325628)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar_100
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(47530423486325747)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion buttonRegion" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    #BODY#',
'    <span class="aButtonContainer">',
'      #CLOSE##COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#',
'    </span>',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Top Bar (100%)'
,p_internal_name=>'APEX_4.0_TOP_BAR_100%'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17357218626599946
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92502316281295494)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92502820428295494)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92503387855295494)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92503844288295494)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92504331521295496)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92504838789295496)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92505372900295496)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92505865646295496)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92506379424295497)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92506890170295497)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92507331377295497)
,p_plug_template_id=>wwv_flow_imp.id(47530423486325747)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_float_left
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(47565030313994649)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# style="float:left;clear:both;">#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 4.0 - Div (Float Left)'
,p_internal_name=>'APEX_4.0_DIV_FLOAT_LEFT'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>35964702876463547
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60403829129110459)
,p_plug_template_id=>wwv_flow_imp.id(47565030313994649)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60404342671110459)
,p_plug_template_id=>wwv_flow_imp.id(47565030313994649)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_reports_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(75821319588166981)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-region" id="#REGION_STATIC_ID#" style="width:100%">',
'  <div class="rc-gray-top"><div class="rc-gray-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Reports Region'
,p_internal_name=>'APEX_4.0_REPORTS_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17354512447599941
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92135703121172795)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92136284011172795)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92136737068172796)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92137290715172796)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92137799853172796)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92138223537172796)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92138766957172797)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92139211210172797)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92139795541172797)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92140267748172797)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92140713234172799)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92141288953172799)
,p_plug_template_id=>wwv_flow_imp.id(75821319588166981)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(79623830123907946)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Sidebar (Gray Header) (2)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92391507627283248)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92392051842283249)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92392500531283249)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92393080126283249)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92393587914283249)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92394078021283250)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92394530072283250)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92395009597283250)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92395509133283251)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92396018700283251)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92396515265283251)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92397020881283251)
,p_plug_template_id=>wwv_flow_imp.id(79623830123907946)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_reports_region_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(102441323786892882)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-region" id="#REGION_STATIC_ID#" style="width:100%">',
'  <div class="rc-gray-top"><div class="rc-gray-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Reports Region (2)'
,p_internal_name=>'APEX_4.0_REPORTS_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17354512447599941
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92146764620172826)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92147264881172826)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92147769659172826)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92148263731172827)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92148743025172827)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92149227246172827)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92149781827172828)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92150225614172828)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92150705936172828)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92151206174172828)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92151726010172829)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92152207740172829)
,p_plug_template_id=>wwv_flow_imp.id(102441323786892882)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/loading_region_hidden_by_default
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(120649317132520102)
,p_layout=>'TABLE'
,p_template=>'<div class="htmldbLoadingRegion" id="#REGION_STATIC_ID#" style="display:none;">#BODY#<br /><img src="#IMAGE_PREFIX#htmldb/icons/wait.gif"  id="loadingIcon" alt="" /></div>'
,p_page_plug_template_name=>'Loading Region (Hidden by Default)'
,p_internal_name=>'LOADING_REGION_HIDDEN_BY_DEFAULT'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>227227325128090607
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140502116163344512)
,p_plug_template_id=>wwv_flow_imp.id(120649317132520102)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140502224222344512)
,p_plug_template_id=>wwv_flow_imp.id(120649317132520102)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_confirm
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(162417015526175958)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (Confirm)'
,p_internal_name=>'APEX_4.2_ACTION_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93511701936376131)
,p_plug_template_id=>wwv_flow_imp.id(162417015526175958)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93512271405376131)
,p_plug_template_id=>wwv_flow_imp.id(162417015526175958)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93512773590376132)
,p_plug_template_id=>wwv_flow_imp.id(162417015526175958)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93513266930376132)
,p_plug_template_id=>wwv_flow_imp.id(162417015526175958)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93513788825376132)
,p_plug_template_id=>wwv_flow_imp.id(162417015526175958)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93514238737376134)
,p_plug_template_id=>wwv_flow_imp.id(162417015526175958)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93514748519376134)
,p_plug_template_id=>wwv_flow_imp.id(162417015526175958)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93515283777376135)
,p_plug_template_id=>wwv_flow_imp.id(162417015526175958)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93515730758376135)
,p_plug_template_id=>wwv_flow_imp.id(162417015526175958)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(195768826832737518)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Sidebar (Gray Header)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92380488210283241)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92380905476283241)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92381432986283241)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92381926366283242)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92382495080283242)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92382976467283242)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92383471483283242)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92383969843283243)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92384484561283244)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92384954771283244)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92385401904283244)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92385974719283245)
,p_plug_template_id=>wwv_flow_imp.id(195768826832737518)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(195775112470763477)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_form_table_attr=>' '
,p_reference_id=>17354206769599941
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135725769602120561)
,p_plug_template_id=>wwv_flow_imp.id(195775112470763477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135726275356120561)
,p_plug_template_id=>wwv_flow_imp.id(195775112470763477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(195777031029763479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box'
,p_internal_name=>'APEX_4.2_ACTION_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93436144703371989)
,p_plug_template_id=>wwv_flow_imp.id(195777031029763479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93436657560371989)
,p_plug_template_id=>wwv_flow_imp.id(195777031029763479)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93437110996371989)
,p_plug_template_id=>wwv_flow_imp.id(195777031029763479)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93437678706371990)
,p_plug_template_id=>wwv_flow_imp.id(195777031029763479)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93438153744371990)
,p_plug_template_id=>wwv_flow_imp.id(195777031029763479)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93438661200371990)
,p_plug_template_id=>wwv_flow_imp.id(195777031029763479)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93439131696371991)
,p_plug_template_id=>wwv_flow_imp.id(195777031029763479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93439685470371991)
,p_plug_template_id=>wwv_flow_imp.id(195777031029763479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93440158709371991)
,p_plug_template_id=>wwv_flow_imp.id(195777031029763479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box_wide
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(195777618558763486)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-wiz-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# style="width:100%;">',
'  <div class="rc-blue-top"><div class="rc-blue-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Wizard Box (wide)'
,p_internal_name=>'APEX_4.0_WIZARD_BOX_WIDE'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>35936104232216540
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93385799189364298)
,p_plug_template_id=>wwv_flow_imp.id(195777618558763486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93386204001364299)
,p_plug_template_id=>wwv_flow_imp.id(195777618558763486)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93386721882364299)
,p_plug_template_id=>wwv_flow_imp.id(195777618558763486)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93387287471364299)
,p_plug_template_id=>wwv_flow_imp.id(195777618558763486)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93387721187364299)
,p_plug_template_id=>wwv_flow_imp.id(195777618558763486)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93388244408364300)
,p_plug_template_id=>wwv_flow_imp.id(195777618558763486)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93388792253364300)
,p_plug_template_id=>wwv_flow_imp.id(195777618558763486)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93389266909364301)
,p_plug_template_id=>wwv_flow_imp.id(195777618558763486)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93389788574364301)
,p_plug_template_id=>wwv_flow_imp.id(195777618558763486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(202652905551384773)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (2)'
,p_internal_name=>'APEX_4.2_ACTION_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93444588924371995)
,p_plug_template_id=>wwv_flow_imp.id(202652905551384773)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93445008221371995)
,p_plug_template_id=>wwv_flow_imp.id(202652905551384773)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93445599679371995)
,p_plug_template_id=>wwv_flow_imp.id(202652905551384773)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93446042021371995)
,p_plug_template_id=>wwv_flow_imp.id(202652905551384773)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93446533283371996)
,p_plug_template_id=>wwv_flow_imp.id(202652905551384773)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93447040596371996)
,p_plug_template_id=>wwv_flow_imp.id(202652905551384773)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93447522485371996)
,p_plug_template_id=>wwv_flow_imp.id(202652905551384773)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93448050488371997)
,p_plug_template_id=>wwv_flow_imp.id(202652905551384773)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93448595822371997)
,p_plug_template_id=>wwv_flow_imp.id(202652905551384773)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_confirm_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(202653318365384775)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (Confirm) (2)'
,p_internal_name=>'APEX_4.2_ACTION_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93520149701376138)
,p_plug_template_id=>wwv_flow_imp.id(202653318365384775)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93520616214376138)
,p_plug_template_id=>wwv_flow_imp.id(202653318365384775)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93521130320376139)
,p_plug_template_id=>wwv_flow_imp.id(202653318365384775)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93521678233376139)
,p_plug_template_id=>wwv_flow_imp.id(202653318365384775)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93522179926376139)
,p_plug_template_id=>wwv_flow_imp.id(202653318365384775)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93522678077376140)
,p_plug_template_id=>wwv_flow_imp.id(202653318365384775)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93523124714376140)
,p_plug_template_id=>wwv_flow_imp.id(202653318365384775)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93523638086376140)
,p_plug_template_id=>wwv_flow_imp.id(202653318365384775)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93524136364376140)
,p_plug_template_id=>wwv_flow_imp.id(202653318365384775)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(202653921804384775)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Wizard Body'
,p_internal_name=>'APEX_4.2_WIZARD_BODY'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209615589242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93614534496534535)
,p_plug_template_id=>wwv_flow_imp.id(202653921804384775)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93615048720534549)
,p_plug_template_id=>wwv_flow_imp.id(202653921804384775)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_divider
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(202654431224384775)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'<div class="wizardRegionHeading">',
'  <h1>#TITLE#</h1>',
'  <div class="buttonContainer">',
'#EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'  </div>',
'</div>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Wizard Body (Divider)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_DIVIDER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209811475242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93642053590541279)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93642580402541280)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93643002589541280)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93643542683541280)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93644090822541283)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93644515705541283)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93645001297541283)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93645530463541284)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93646090362541284)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93646585966541284)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93647077778541285)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93647516610541285)
,p_plug_template_id=>wwv_flow_imp.id(202654431224384775)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_hide_show
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(202654901374384775)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h1><a href="javascript:void(0);" onclick="$(''##REGION_STATIC_ID#_content'').slideToggle();$(''##REGION_STATIC_ID#_img'').toggleClass(''expanded'');" class="hideShowLink"><img src="#IMAGE_PREFIX#f_spacer.gif" class="hideShow" alt="" id="#REGION_STATIC'
||'_ID#_img"/>#TITLE#</a></h1>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_HIDE/SHOW'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210116661242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93697485495549094)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93697951745549094)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93698411728549094)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93698935604549095)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93699481187549095)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93699955139549095)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93700481716549095)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93700963082549096)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93701452651549096)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93701942453549096)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93702439790549096)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93702998012549099)
,p_plug_template_id=>wwv_flow_imp.id(202654901374384775)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_confirm_003
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(203640520174520127)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (Confirm) (2) (3)'
,p_internal_name=>'APEX_4.2_ACTION_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93528502420376146)
,p_plug_template_id=>wwv_flow_imp.id(203640520174520127)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93529003072376146)
,p_plug_template_id=>wwv_flow_imp.id(203640520174520127)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93529580387376146)
,p_plug_template_id=>wwv_flow_imp.id(203640520174520127)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93530083642376146)
,p_plug_template_id=>wwv_flow_imp.id(203640520174520127)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93530564636376147)
,p_plug_template_id=>wwv_flow_imp.id(203640520174520127)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93531058789376147)
,p_plug_template_id=>wwv_flow_imp.id(203640520174520127)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93531569541376147)
,p_plug_template_id=>wwv_flow_imp.id(203640520174520127)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93532046294376148)
,p_plug_template_id=>wwv_flow_imp.id(203640520174520127)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93532509169376148)
,p_plug_template_id=>wwv_flow_imp.id(203640520174520127)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_navigation
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(466735715814370929)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion sideNavRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Sidebar Navigation'
,p_internal_name=>'APEX_4.0_SIDEBAR_NAVIGATION'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>456726627253419549
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60504020453151488)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60504557686151488)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60505056025151488)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60505580919151488)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60506028708151489)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60506525081151489)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60507034790151489)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60507585340151489)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60508094388151490)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60508527612151490)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60509067324151490)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60509583128151490)
,p_plug_template_id=>wwv_flow_imp.id(466735715814370929)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_hide_and_show_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(472643325100618624)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="hide-show-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="hide-show-top">',
'    <div class="hide-show-title"><h3>',
'      <a href="#" onclick="htmldb_ToggleTableBody(''i#REGION_STATIC_ID#'',''body#REGION_STATIC_ID#''); return false;">',
'        <img src="#IMAGE_PREFIX#htmldb/builder/rollup_plus_dgray.gif" class="pseudoButtonActive" id="i#REGION_STATIC_ID#" alt="" />',
'        #TITLE#',
'      </a></h3>    ',
'    </div>',
'  </div>',
'  <div class="hide-show-body" style="display:none;" id="body#REGION_STATIC_ID#">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Hide and Show Region'
,p_internal_name=>'APEX_4.0_HIDE_AND_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18662712241194598
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60493031697146154)
,p_plug_template_id=>wwv_flow_imp.id(472643325100618624)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60493552026146155)
,p_plug_template_id=>wwv_flow_imp.id(472643325100618624)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_large_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(484944923953702457)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Rounded Corner Large'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_LARGE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>27763613494297374
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92216633753205902)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92217146306205902)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92217670215205903)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92218196395205903)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92218661704205903)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92219159484205903)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92219696822205904)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92220102893205904)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92220693133205904)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92221177034205904)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92221644326205905)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92222159131205905)
,p_plug_template_id=>wwv_flow_imp.id(484944923953702457)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(517376500704206647)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32600645175747556)
,p_plug_template_id=>wwv_flow_imp.id(517376500704206647)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32601181702747557)
,p_plug_template_id=>wwv_flow_imp.id(517376500704206647)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32601613721747557)
,p_plug_template_id=>wwv_flow_imp.id(517376500704206647)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32602122570747557)
,p_plug_template_id=>wwv_flow_imp.id(517376500704206647)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(517418631967368160)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>174748721787471587
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32460518086578767)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32461068735578767)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32461546068578767)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32462036337578768)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32462571188578768)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32463010606578768)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32463514039578769)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32464069264578769)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32464587088578769)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32465037550578769)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32465502222578770)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32466043400578770)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32466513109578770)
,p_plug_template_id=>wwv_flow_imp.id(517418631967368160)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_top_buttons
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(517418935080368162)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--left">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--right">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region (Top Buttons)'
,p_internal_name=>'APEX_5.0_REGION_TOP_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174747104640428780
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140478301979344537)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140478441212344537)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140478551032344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140478676399344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140478793229344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140478875553344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140478900956344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140479051835344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140479157088344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140479226013344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140479396803344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140479466959344536)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140479573644344535)
,p_plug_template_id=>wwv_flow_imp.id(517418935080368162)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(721110277025730268)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>687153470345619376
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63701829656240652)
,p_plug_template_id=>wwv_flow_imp.id(721110277025730268)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63702316988240652)
,p_plug_template_id=>wwv_flow_imp.id(721110277025730268)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63702893642240652)
,p_plug_template_id=>wwv_flow_imp.id(721110277025730268)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63703397369240653)
,p_plug_template_id=>wwv_flow_imp.id(721110277025730268)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63703886720240653)
,p_plug_template_id=>wwv_flow_imp.id(721110277025730268)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63704327224240653)
,p_plug_template_id=>wwv_flow_imp.id(721110277025730268)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63704838393240654)
,p_plug_template_id=>wwv_flow_imp.id(721110277025730268)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63705345644240654)
,p_plug_template_id=>wwv_flow_imp.id(721110277025730268)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63705872318240654)
,p_plug_template_id=>wwv_flow_imp.id(721110277025730268)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(721115784857730284)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# #REGION_LANDMARK_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>689955986849128825
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61014235554684359)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61014785300684361)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61015290436684361)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61015704649684362)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61016255493684362)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61016785740684362)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61017278581684363)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61017716693684363)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61018220444684363)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61018704497684364)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61019212381684364)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61019757804684364)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61020227282684365)
,p_plug_template_id=>wwv_flow_imp.id(721115784857730284)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(721125879764730304)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <h2 id="#REGION_STATIC_ID#_heading" class="u-vh a-Region-header">#TITLE#</h2>',
'  #PREVIOUS##BODY##NEXT#',
'</div>',
''))
,p_page_plug_template_name=>'[x] APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>678354360586321695
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1503211462426782)
,p_plug_template_id=>wwv_flow_imp.id(721125879764730304)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1503778805426783)
,p_plug_template_id=>wwv_flow_imp.id(721125879764730304)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1504259939426783)
,p_plug_template_id=>wwv_flow_imp.id(721125879764730304)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1504782901426783)
,p_plug_template_id=>wwv_flow_imp.id(721125879764730304)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(721128767486730308)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88269737652825413)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88270210246825413)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88270711147825413)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88271254809825413)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88271795688825414)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88272298531825414)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88272722362825414)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88273227103825415)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88273727016825415)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88274215869825415)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88274744108825415)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88275233098825417)
,p_plug_template_id=>wwv_flow_imp.id(721128767486730308)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(721129403626730309)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88191230199816930)
,p_plug_template_id=>wwv_flow_imp.id(721129403626730309)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88191717796816930)
,p_plug_template_id=>wwv_flow_imp.id(721129403626730309)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(721130166613730309)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 id="#REGION_STATIC_ID#_TITLE" class="u-vh">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>702777601713950915
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214490401678485464)
,p_plug_template_id=>wwv_flow_imp.id(721130166613730309)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214490936884485465)
,p_plug_template_id=>wwv_flow_imp.id(721130166613730309)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(721130822791730313)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88139629846806719)
,p_plug_template_id=>wwv_flow_imp.id(721130822791730313)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88140156123806719)
,p_plug_template_id=>wwv_flow_imp.id(721130822791730313)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_and_region_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(810047731426039801)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 4.0 - Div with ID and Region Attributes'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>2974803291668087
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60416681050125958)
,p_plug_template_id=>wwv_flow_imp.id(810047731426039801)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60417107906125959)
,p_plug_template_id=>wwv_flow_imp.id(810047731426039801)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(829706609080810173)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div role="alert" class="a-Alert-body">#BODY#</div>',
'    </div>',
'    <div class="a-Alert-buttons">#PREVIOUS##CLOSE##CREATE##NEXT#</div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>746362351042209764
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4869263699959732)
,p_plug_template_id=>wwv_flow_imp.id(829706609080810173)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4869767312959732)
,p_plug_template_id=>wwv_flow_imp.id(829706609080810173)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4870229240959732)
,p_plug_template_id=>wwv_flow_imp.id(829706609080810173)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4870716319959732)
,p_plug_template_id=>wwv_flow_imp.id(829706609080810173)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4871288714959733)
,p_plug_template_id=>wwv_flow_imp.id(829706609080810173)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4871717690959733)
,p_plug_template_id=>wwv_flow_imp.id(829706609080810173)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(966388705490342505)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span aria-hidden="true" class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>698829239393878937
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131674636160047159)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131675141131047160)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131675657963047160)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131676119285047160)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131676610750047161)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131677185719047161)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131677642027047161)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131678105698047162)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131678645254047162)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131679157560047162)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131679664823047163)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131680183449047163)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131680649035047163)
,p_plug_template_id=>wwv_flow_imp.id(966388705490342505)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(1150740889542098395)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61239623250733467)
,p_plug_template_id=>wwv_flow_imp.id(1150740889542098395)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61240197277733467)
,p_plug_template_id=>wwv_flow_imp.id(1150740889542098395)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(15441414872198826)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>32421627622986728
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_large_icons_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(20308202747121796)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_name=>'[EBA] Large Icons List'
,p_internal_name=>'[EBA]_LARGE_ICONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="ebaLargeIcons" width="100%" cellspacing="0" cellpadding="0" border="0" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_reference_id=>20148806760577112
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(27525012681104508)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List (2)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(40112922633318119)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/horizontal_with_images
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(82702000896937873)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="current">',
'  <div class="image">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a>',
'  </div>',
'  <div class="label">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'  </div>',
'</div>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="noncurrent">',
'  <div class="image">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a>',
'  </div>',
'  <div class="label">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'  </div>',
'</div>'))
,p_list_template_name=>'horizontal with images'
,p_internal_name=>'HORIZONTAL_WITH_IMAGES'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-list-horizontal">'
,p_list_template_after_rows=>'</div>'
,p_reference_id=>17386714276888490
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs_002
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(169533626431592276)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs (2)'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_standard_tabs_with_pull_down
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(192005124361583785)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_list_template_name=>'APEX Standard Tabs with pull down'
,p_internal_name=>'APEX_STANDARD_TABS_WITH_PULL_DOWN'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div id="tabs" class="dhtmlMenuLG">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul id="S#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="aTabs dhtmlSubMenu pulldown-tabs" style="display:none;">',
''))
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_f_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current-first">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_f_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current-first">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_f_item_template_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current-first">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_fi_template_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current-first">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_reference_id=>9651611091899590
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_002
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(202626814415270397)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List (2) (3)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_wizard_progress_bar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(202627300168270397)
,p_list_template_current=>'<li class="#LIST_STATUS#"><span>#TEXT#</span></li>'
,p_list_template_noncurrent=>'<li class="#LIST_STATUS#"><span>#TEXT#</span></li>'
,p_list_template_name=>'APEX 4.2 - Wizard Progress Bar'
,p_internal_name=>'APEX_4.2_WIZARD_PROGRESS_BAR'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardProgress">',
'<ul>'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'</div>'))
,p_reference_id=>42216127932260877
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(517380133540212757)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_a06_label=>'Link Target'
,p_reference_id=>573607518145151423
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(517380464558212757)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a06_label=>'Target'
,p_reference_id=>747588010155545129
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(517410251255325302)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_003
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(517410627877325303)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(721136580461780231)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(1104606511149216228)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" aria-current="page" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_name=>'[x] APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(6897002870390711)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report  from 4999'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_1_eba_standard_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(20400705845449628)
,p_row_template_name=>'APEX 4.1 [EBA] Standard Report'
,p_internal_name=>'APEX_4.1_[EBA]_STANDARD_REPORT'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="" #REPORT_ATTRIBUTES# id="report_#REGION_STATIC_ID#">#TOP_PAGINATION#',
'<tr>',
'<td><table class="ebaStandardReport" cellspacing="0" cellpadding="0" summary="#REGION_TITLE#" width="100%">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table><div class="CSV">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="#LINK#" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="#LINK#" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="#LINK#" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="#LINK#" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>20327811817377113
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_plain_c_htmldbverticalregion
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(22621917280199870)
,p_row_template_name=>'Vertical Plain (c:htmldbVerticalRegion)'
,p_internal_name=>'VERTICAL_PLAIN_C:HTMLDBVERTICALREGION'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'<th scope="row" style="text-align:right;" align="right">#COLUMN_HEADER#</th>',
'<td width="100%">#COLUMN_VALUE#</td>',
'</tr>'))
,p_row_template_before_rows=>'#CSV_LINK#<table class="apex-vertical-region"  summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>82057303211040344
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(46450823627307947)
,p_row_template_name=>'APEX 4.0 - Portlet Report'
,p_internal_name=>'APEX_4.0_PORTLET_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_row_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(47555718632924155)
,p_row_template_name=>'APEX 4.0 - Portlet Row Template'
,p_internal_name=>'APEX_4.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/2_dhtml_automatic_ppr_pagination_report_from_4999
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(81008210556197147)
,p_row_template_name=>'(2) (DHTML) Automatic PPR Pagination Report From 4999 '
,p_internal_name=>'2_DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999_'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(805663950138677747)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(805668813229677842)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(805669497254677844)
,p_row_template_name=>' APEX 5.0 - Links List'
,p_internal_name=>'_APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(805670753642677848)
,p_row_template_name=>'APEX 5.0 - Portlet Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(805671421026677848)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(805672157251677851)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# #ARIA_SORT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_standard_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(833359513519625692)
,p_row_template_name=>'APEX 4.0 - Standard Report'
,p_internal_name=>'APEX_4.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# #ARIA_SORT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/label_tag_only
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(4925632660752163)
,p_template_name=>'LABEL Tag Only'
,p_internal_name=>'LABEL_TAG_ONLY'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/form_field_optional
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(111843720754869910)
,p_template_name=>'Form Field Optional'
,p_internal_name=>'FORM_FIELD_OPTIONAL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/f_fromfield_required
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(111844628719872228)
,p_template_name=>'f: FromField_Required'
,p_internal_name=>'F:_FROMFIELD_REQUIRED'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>2
,p_reference_id=>17388508175892042
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/dynamic_attribute
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(143266721929021448)
,p_template_name=>'Dynamic Attribute'
,p_internal_name=>'DYNAMIC_ATTRIBUTE'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:apex.builder.dynamicAttributes.help(''&FB_FLOW_ID.'',''#CURRENT_ITEM_NAME#'');" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>180457716461887221
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/done_label_optional_no_link
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(148842116797733609)
,p_template_name=>'(Done) Label Optional (No Link)'
,p_internal_name=>'DONE_LABEL_OPTIONAL_NO_LINK'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><span class="htmldbLabelOptional">'
,p_template_body2=>'</span></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>238114715839717766
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/htmldb_greenarealabel_c_htmldbgalabel
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(343399818250317904)
,p_template_name=>'htmldb_GreenAreaLabel (c:htmldbGALabel)'
,p_internal_name=>'HTMLDB_GREENAREALABEL_C:HTMLDBGALABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(452952500586130526)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(721133390982759781)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(721133403814759785)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(721133598269759785)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(721133686751759785)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' </label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(832237223281900733)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(1405202261752384510)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumbs
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(4589126493175495)
,p_name=>'breadcrumbs'
,p_internal_name=>'BREADCRUMBS'
,p_current_page_option=>'<span class="htmldbBreadcrumb">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#" class="htmldbBreadcrumb" title="#NAME#">#NAME#</a>'
,p_between_levels=>'<span class="htmldbBreadcrumbSep"><img alt="" src="#IMAGE_PREFIX#apex/apex_top_sep.gif"></span>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>60115300853820165
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(517472004210010979)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>8
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_imp_shared.create_popup_lov_template(
 p_id=>wwv_flow_imp.id(19619131469326417)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/htmldb_calendar_from_4350
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(291623505663181263)
,p_cal_template_name=>'HTMLDB Calendar from 4350'
,p_internal_name=>'HTMLDB_CALENDAR_FROM_4350'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_imp_shared.create_theme(
 p_id=>wwv_flow_imp.id(75126825401031586)
,p_theme_id=>3
,p_theme_name=>'APEX 4.0'
,p_theme_internal_name=>'APEX_4.0'
,p_navigation_type=>'T'
,p_nav_bar_type=>'NAVBAR'
,p_is_locked=>false
,p_default_page_template=>wwv_flow_imp.id(517336519765126407)
,p_default_dialog_template=>wwv_flow_imp.id(721098050798687927)
,p_error_template=>wwv_flow_imp.id(721099117305687972)
,p_printer_friendly_template=>wwv_flow_imp.id(517336519765126407)
,p_default_button_template=>wwv_flow_imp.id(517372214551202759)
,p_default_region_template=>wwv_flow_imp.id(517418631967368160)
,p_default_report_template=>wwv_flow_imp.id(6897002870390711)
,p_default_label_template=>wwv_flow_imp.id(721133390982759781)
,p_default_menu_template=>wwv_flow_imp.id(517472004210010979)
,p_default_calendar_template=>wwv_flow_imp.id(291623505663181263)
,p_default_list_template=>wwv_flow_imp.id(517410251255325302)
,p_default_nav_list_template=>wwv_flow_imp.id(517380133540212757)
,p_default_top_nav_list_temp=>wwv_flow_imp.id(517380133540212757)
,p_default_nav_list_position=>'TOP'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(3),'')
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(72330278206509731)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(204023405870765307)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556396783772095832)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556397202054096672)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689622957538993961)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689623969329993963)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689624693980993963)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689626529804993964)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(697060993016402983)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(697230396344708843)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(698684569822187813)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(698685246722187813)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(698685982234187814)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(698687551302187815)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(721118031100730295)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741002786712616811)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741003546630616812)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741003881511616812)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741004108847616813)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741004885396616813)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741005111768616813)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741005400644616813)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741005709269616813)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741006077738616813)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741006441348616813)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741006771182616813)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(805664352602677797)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(805665239190677809)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(829707024511810176)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(1104606929671216232)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1505549012426784)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden to Assistive Tech'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721125879764730304)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(697060993016402983)
,p_template_types=>'REGION'
,p_help_text=>'By default, region title is hidden but accessible, use this option to remove the header from accessible interface'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741058941526941269)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_imp.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741059100079941270)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_imp.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741059383377941271)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_imp.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741059547362941271)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_imp.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741059767574941271)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_imp.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741059963746941271)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_imp.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741060150257941271)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_imp.id(741003546630616812)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741060352743941271)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_imp.id(741003881511616812)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741060562611941271)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_imp.id(741004108847616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741060777764941272)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_imp.id(741003881511616812)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741060923252941272)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_imp.id(741003881511616812)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741061147880941272)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_imp.id(741003881511616812)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741061355608941272)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_imp.id(741004108847616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741061562454941272)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_imp.id(741004885396616813)
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741061785251941272)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_imp.id(741005111768616813)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741061930408941272)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_imp.id(741005400644616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741062140679941272)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_imp.id(741005709269616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741062374659941272)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_imp.id(741006077738616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741062572126941272)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_imp.id(741004108847616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741062777866941272)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(741006441348616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741062993093941272)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_imp.id(741006771182616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741063041165941273)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741063226712941273)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_imp.id(741005400644616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741063478339941273)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_imp.id(741005709269616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741063652736941273)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_imp.id(741006077738616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741063738666941273)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741063868051941273)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787115814178949708)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(833359513519625692)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(698684569822187813)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787116053276949708)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(833359513519625692)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(698685246722187813)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787116272015949709)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(833359513519625692)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787116463221949709)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(833359513519625692)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787116655041949709)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(833359513519625692)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787116768540949709)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(833359513519625692)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787116930836949713)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(833359513519625692)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(698687551302187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(926398446964707528)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(517380464558212757)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(926398552870707528)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(517380464558212757)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(940696902849341582)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967652406149899654)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721110277025730268)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967652677759899654)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721110277025730268)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_imp.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967652870869899654)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721110277025730268)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_imp.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967653049020899654)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721110277025730268)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967653251462899654)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721110277025730268)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967653316877899654)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721110277025730268)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967653518578899654)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721110277025730268)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_imp.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967653745948899654)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721110277025730268)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_imp.id(697060993016402983)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967654517211901036)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967654725307901036)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967654990742901036)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967655151651901036)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967655310868901036)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967655531082901036)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967655733265901036)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967655999997901036)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967656143487901036)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967656346981901036)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967656530819901037)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967656779856901037)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967656945340901037)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805663950138677747)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967717343742903434)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805672157251677851)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(698684569822187813)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967717571202903434)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805672157251677851)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(698685246722187813)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967717740507903435)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805672157251677851)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967717902448903435)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805672157251677851)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967718196465903435)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805672157251677851)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967718265262903435)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805672157251677851)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967718461294903435)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805672157251677851)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(698687551302187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967719843756911507)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829706609080810173)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967719965533911507)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829706609080810173)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967720120106911508)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829706609080810173)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_imp.id(829707024511810176)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967720327654911509)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829706609080810173)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_imp.id(829707024511810176)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967720583879911509)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829706609080810173)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_imp.id(829707024511810176)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967720733358911509)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829706609080810173)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_imp.id(721118031100730295)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967720959540911509)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829706609080810173)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_imp.id(721118031100730295)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967721004874911509)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829706609080810173)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(967721285604911509)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829706609080810173)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_imp.id(829707024511810176)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104608494214216242)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_imp.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104608656046216242)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_imp.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104608867454216242)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_imp.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104609040571216242)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_imp.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104609259667216242)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_imp.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104609398533216242)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104609436927216242)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104609518065216242)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104609672179216242)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1104609733068216242)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1199562374089032433)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(741006441348616813)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1241666318933396953)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1150740889542098395)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525651284559182055)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525651360640182055)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525651434587182055)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525651525816182055)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525651779626182055)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525651978926182055)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525653392112182064)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525653440648182064)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525653596475182064)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525653658347182064)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525653836168182064)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525654036872182064)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525657387923182087)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525657473823182087)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525657543497182087)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525657663628182087)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525657833692182087)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525658090172182088)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544818255170478020)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805669497254677844)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544818366864478020)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805669497254677844)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544818490278478020)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(805669497254677844)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554805829158408352)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554806001590408352)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554806241730408352)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554806417746408352)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554806699208408352)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689623969329993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554806824411408353)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554807043080408353)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554807217289408353)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554807484461408353)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554807578586408353)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554807728864408353)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(517418631967368160)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_imp.id(689624693980993963)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554832646705526808)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(721125879764730304)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554832743576526808)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721125879764730304)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554832892239526808)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721125879764730304)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554844990556542270)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554845094082542270)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554845229074542270)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554845436412542270)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554845665255542270)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689623969329993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554845827258542271)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554846022920542271)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554846298269542271)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554846416962542271)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_imp.id(721118031100730295)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554846634990542271)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(721115784857730284)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_imp.id(721118031100730295)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554858103728550790)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554858341380550790)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554858589140550790)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554858747894550790)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554858923710550790)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554859100162550790)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554859327262550790)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554859544487550790)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554859732911550790)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689623969329993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554859906782550790)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(966388705490342505)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/globalization/language
begin
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241112933976151)
,p_translation_flow_id=>4051
,p_translation_flow_language_cd=>'es'
,p_translation_comments=>'Internal Administration - Spanish'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241216908976151)
,p_translation_flow_id=>4052
,p_translation_flow_language_cd=>'fr'
,p_translation_comments=>'Internal Administration - French'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241304711976151)
,p_translation_flow_id=>4053
,p_translation_flow_language_cd=>'de'
,p_translation_comments=>'Internal Administration - German'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241422723976151)
,p_translation_flow_id=>4054
,p_translation_flow_language_cd=>'it'
,p_translation_comments=>'Internal Administration - Italian'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241522243976151)
,p_translation_flow_id=>4055
,p_translation_flow_language_cd=>'pt-br'
,p_translation_comments=>'Internal Administration - Brazilian Portuguese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241604248976151)
,p_translation_flow_id=>4056
,p_translation_flow_language_cd=>'zh-cn'
,p_translation_comments=>'Internal Administration - Simplified Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241709119976152)
,p_translation_flow_id=>4057
,p_translation_flow_language_cd=>'zh-tw'
,p_translation_comments=>'Internal Administration - Traditional Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241807783976152)
,p_translation_flow_id=>4058
,p_translation_flow_language_cd=>'ko'
,p_translation_comments=>'Internal Administration - Korean'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241908068976152)
,p_translation_flow_id=>4059
,p_translation_flow_language_cd=>'ja'
,p_translation_comments=>'Internal Administration - Japanese'
,p_direction_right_to_left=>'N'
);
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(115385817770766958)
,p_build_option_name=>'Exclude on 23.1'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_on_upgrade_keep_status=>true
,p_build_option_comment=>'The build option is used to hide components from Admin Digest requiring changes in the data model and subject to improvement in the future releases.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(1082456635473282144)
,p_build_option_name=>'To Be Deleted'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Components which should be deleted once verified that it is safe to do so.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(3913175260740993520)
,p_build_option_name=>'Full Access Only'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_on_upgrade_keep_status=>true
,p_build_option_comment=>'Elements marked with this build option are only to be available to a full (aka on-prem) release of apex.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(4226407758971148501)
,p_build_option_name=>'Exclude on 5.1.4'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'This build option is used to exclude changes to 5.1.4''s 4050 which were actually made for 5.2 or newer. We are actively developing in 5.1.4 and at some time importing the patchset''s 4050 into trunk.'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5207369508140476)
,p_name=>'P100_ABOUT_ADB'
,p_message_text=>'The %0 development environment is available in 9 standard languages. The runtime messages, which are used by application components, are available in additional languages. This report indicates which languages have been installed in this instance. Or'
||'acle manages product translations in Oracle Autonomous Database.'
,p_version_scn=>11949993
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1409666071418558)
,p_name=>'P100_ABOUT_NON_ADB'
,p_message_text=>'The %0 development environment is available in 9 standard languages. The runtime messages, which are used by application components, are available in additional languages. This report indicates which languages have been installed in this instance.'
,p_version_scn=>11952780
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2311057542041165)
,p_name=>'P131_EMAIL_NOT_CONFIGURED'
,p_message_text=>'Email is not configured. You will not be able to change this option until email is configured.'
,p_version_scn=>37165770887573
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/mon_sessions
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(3410213449861369)
,p_shortcut_name=>'MON_SESSIONS'
,p_shortcut_type=>'HTML_TEXT'
,p_version_scn=>75557284
,p_shortcut=>'<table class="instructiontext" ><tr><td>&nbsp;</td><td><table class="instructiontext" bgcolor="#ffffff" cellspacing=0 cellpadding=0 border="1"><tr><td><a href="f?p=&FLOW_ID.:63:&SESSION."><img src="#IMAGE_PREFIX#monitor_icons_pipes.gif" width="100" h'
||'eight="75" border="0"></a><br/><span class="tiny">&nbsp;Session&nbsp;Menu...</span></td></tr></table></td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/item_help
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(181820822914271039)
,p_shortcut_name=>'ITEM_HELP'
,p_shortcut_type=>'HTML_TEXT'
,p_error_text=>'Unable to show help.'
,p_reference_id=>24184979678
,p_shortcut=>'<a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999"><img src="#IMAGE_PREFIX#infoicon_status_gray.gif" width=16 height=16 border=0></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/mon_home
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(190225219130761917)
,p_shortcut_name=>'MON_HOME'
,p_shortcut_type=>'HTML_TEXT'
,p_version_scn=>75557284
,p_shortcut=>'<table><tr><td>&nbsp;</td><td><table bgcolor="#ffffff" cellspacing=0 cellpadding=0 border="1"><tr><td><a href="f?p=4050:29:&SESSION."><img src="#IMAGE_PREFIX#flow_monitor2.gif" width="100" height="75" border="0"></a><br><font size="-2" face="arial">M'
||'onitor&nbsp;Menu...</font></td></tr></table></td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/install_svg_plugin
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(277012116764271142)
,p_shortcut_name=>'INSTALL_SVG_PLUGIN'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75557284
,p_shortcut=>'Please install SVG Viewer to view the chart.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(277511229763806315)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75557284
,p_shortcut=>'Would you like to perform this delete action?'
);
end;
/
prompt --application/shared_components/security/authentications/saml
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(38542995972952686)
,p_name=>'SAML'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>'This scheme uses SAML authentication. Oracle APEX presents the available workspaces for the user.'
,p_version_scn=>75557284
);
end;
/
prompt --application/shared_components/security/authentications/social_sign_in
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(117701201325189372)
,p_name=>'Social Sign-In'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_attribute_02=>'OPENID_CONNECT'
,p_attribute_03=>'https://accounts.example.com/.well-known/openid-configuration'
,p_attribute_07=>'profile'
,p_attribute_09=>'email'
,p_attribute_12=>'BASIC_AND_CLID'
,p_attribute_13=>'Y'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>'This scheme uses OAuth2 with a third party authentication provider such as Oracle Identity Cloud Service.'
,p_version_scn=>75557284
);
end;
/
prompt --application/shared_components/security/authentications/database_accounts
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(141712901769416420)
,p_name=>'Database Accounts'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>'This scheme utilizes database credentials. The user name and password of the database account is used to authenticate the user.'
,p_version_scn=>75557284
);
end;
/
prompt --application/shared_components/security/authentications/oracle_apex_accounts
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(142379011979648757)
,p_name=>'Oracle APEX Accounts'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This is the default authentication scheme.',
'It authenticates users against the workspace user repository.'))
,p_version_scn=>75557284
);
end;
/
prompt --application/shared_components/security/authentications/http_header_variable
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(142379504646652140)
,p_name=>'HTTP Header Variable'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_attribute_01=>'OAM_REMOTE_USER'
,p_attribute_02=>'BUILTIN_URL'
,p_attribute_06=>'ALWAYS'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This scheme relies on an HTTP header variable to contain the username and on an external login method to log in.',
'Oracle APEX presents the available workspaces for the user.'))
,p_version_scn=>75557284
);
end;
/
prompt --application/shared_components/security/authentications/oracle_application_server_single_sign_on
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(155904925460322166)
,p_name=>'Oracle Application Server Single Sign-On'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_invalid_session_type=>'URL'
,p_invalid_session_url=>'f?p=4550:20:&SESSION.:::SESSION'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This scheme authenticates developers with Oracle Single Sign-On,',
'using SSO''s external login page.',
'After authentication, Oracle APEX presents the available workspaces for the user.'))
,p_version_scn=>75557284
);
end;
/
prompt --application/shared_components/security/authentications/oracle_cloud_identity_management
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(155905406697330949)
,p_name=>'Oracle Cloud Identity Management'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_version_scn=>75557284
);
end;
/
prompt --application/shared_components/security/authentications/ldap_directory
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(156147800875761157)
,p_name=>'LDAP Directory'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_attribute_01=>'ldap.example.com'
,p_attribute_03=>'NO_SSL'
,p_attribute_04=>'dc=example,dc=com'
,p_attribute_05=>'N'
,p_attribute_06=>'uid=%LDAP_USER%'
,p_attribute_08=>'STD'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>'This scheme checks credentials against an LDAP repository.'
,p_version_scn=>75557284
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(540226219724705040)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>142379011979648757
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1900106178348190)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>'Search Box'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513165269066230017)
,p_plugin_id=>wwv_flow_imp.id(1900106178348190)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513165627970230017)
,p_plugin_id=>wwv_flow_imp.id(1900106178348190)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/template_component/theme_3_badge
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2406704445260525)
,p_plugin_type=>'TEMPLATE COMPONENT'
,p_theme_id=>nvl(wwv_flow_application_install.get_theme_id, '3')
,p_name=>'THEME_3$BADGE'
,p_display_name=>'Badge'
,p_supported_component_types=>'PARTIAL:REPORT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('TEMPLATE COMPONENT','THEME_3$BADGE'),'')
,p_partial_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if APEX$IS_LAZY_LOADING/}',
'  <span class="b-Badge is-placeholder{if ?SIZE/} #SIZE#{endif/}{if ?SHAPE/} #SHAPE#{endif/}"></span>',
'{else/}',
'  {if ?LINK/}<a href="#LINK#" #LINK_ATTR#{else/}<span{endif/} class="b-Badge{if ?STATE/} b-Badge--#STATE#{endif/}{if ?STYLE/} #STYLE#{endif/}{if ?SIZE/} #SIZE#{endif/}{if ?SHAPE/} #SHAPE#{endif/}" role="status" aria-label="#LABEL!STRIPHTML# #VALUE#" '
||'title="#LABEL!STRIPHTML# #VALUE#">',
'    {if ?ICON/}<span class="b-Badge-icon #ICON#" aria-hidden="true"></span>{endif/}',
'    {if LABEL_DISPLAY/}<span class="b-Badge-label">#LABEL#</span>{endif/}',
'    <span class="b-Badge-value">#VALUE#</span>',
'  {if ?LINK/}</a>{else/}</span>{endif/}',
'{endif/}',
''))
,p_default_escape_mode=>'HTML'
,p_translate_this_template=>true
,p_api_version=>1
,p_report_body_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if !APEX$HAS_MESSAGE/}',
'  <ul class="b-Badges #APEX$COMPONENT_CSS_CLASSES#">#APEX$ROWS#</ul>',
'{endif/}'))
,p_report_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="b-Badges-item" #APEX$ROW_IDENTIFICATION#>#APEX$PARTIAL#</li>',
''))
,p_report_placeholder_count=>1
,p_standard_attributes=>'REGION_TEMPLATE'
,p_substitute_attributes=>true
,p_version_scn=>75214156
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display content within a badge. Available for multiple report rows or a single row.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2407110076260541)
,p_plugin_id=>wwv_flow_imp.id(2406704445260525)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'LABEL'
,p_prompt=>'Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_escape_mode=>'RAW'
,p_is_translatable=>true
,p_help_text=>'Enter a value for the badge label or select a source column from the quick pick options.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2407691774260542)
,p_plugin_id=>wwv_flow_imp.id(2406704445260525)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'VALUE'
,p_prompt=>'Value'
,p_attribute_type=>'SESSION STATE VALUE'
,p_is_required=>true
,p_escape_mode=>'STRIPHTML'
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_help_text=>'Select a source column for the badge value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2408145102260543)
,p_plugin_id=>wwv_flow_imp.id(2406704445260525)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'STATE'
,p_prompt=>'State'
,p_attribute_type=>'SESSION STATE VALUE'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'Select the source column for the state of the badge. Substitute column value with "danger", "warning", "success" or "info" for default styling.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2408637519260543)
,p_plugin_id=>wwv_flow_imp.id(2406704445260525)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'ICON'
,p_prompt=>'Icon'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_help_text=>'Enter an icon class or use the Pick Icon dialog to select the icon you want to add to display in the badge.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2409103209260543)
,p_plugin_id=>wwv_flow_imp.id(2406704445260525)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'LABEL_DISPLAY'
,p_prompt=>'Display Label'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_help_text=>'Specify whether to display or hide the badge label. When set to Yes, the badge label will be displayed in addition to the badge value. When set to No, only the badge value will be displayed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2409696574260544)
,p_plugin_id=>wwv_flow_imp.id(2406704445260525)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'STYLE'
,p_prompt=>'Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Select the badge style. Default inherits the style set by the containing template.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2410199712260544)
,p_plugin_attribute_id=>wwv_flow_imp.id(2409696574260544)
,p_display_sequence=>10
,p_display_value=>'Subtle'
,p_return_value=>'b-Badge--subtle'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2410750107260545)
,p_plugin_attribute_id=>wwv_flow_imp.id(2409696574260544)
,p_display_sequence=>20
,p_display_value=>'Outline'
,p_return_value=>'b-Badge--outline'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2411373919260545)
,p_plugin_id=>wwv_flow_imp.id(2406704445260525)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_static_id=>'SHAPE'
,p_prompt=>'Shape'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Select the shape of the badge. Default inherits the shape set by the containing template.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2411815601260545)
,p_plugin_attribute_id=>wwv_flow_imp.id(2411373919260545)
,p_display_sequence=>10
,p_display_value=>'Rounded'
,p_return_value=>'b-Badge--rounded'
,p_help_text=>'Displayed with rounded corners.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2412495436260545)
,p_plugin_attribute_id=>wwv_flow_imp.id(2411373919260545)
,p_display_sequence=>20
,p_display_value=>'Circular'
,p_return_value=>'b-Badge--circle'
,p_help_text=>'Displayed with circular edges.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2413082048260546)
,p_plugin_attribute_id=>wwv_flow_imp.id(2411373919260545)
,p_display_sequence=>30
,p_display_value=>'Square'
,p_return_value=>'b-Badge--square'
,p_help_text=>'Displayed with squared edges.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2413616109260546)
,p_plugin_id=>wwv_flow_imp.id(2406704445260525)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'SIZE'
,p_prompt=>'Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Set the size of the badge. The default inherits the sizing set by the containing template.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2414135241260546)
,p_plugin_attribute_id=>wwv_flow_imp.id(2413616109260546)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'b-Badge--sm'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2414707830260546)
,p_plugin_attribute_id=>wwv_flow_imp.id(2413616109260546)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'b-Badge--md'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2415348382260547)
,p_plugin_attribute_id=>wwv_flow_imp.id(2413616109260546)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'b-Badge--lg'
);
wwv_flow_imp_shared.create_plugin_act_position(
 p_id=>wwv_flow_imp.id(222214404510962051)
,p_plugin_id=>wwv_flow_imp.id(2406704445260525)
,p_name=>'Link'
,p_static_id=>'LINK'
,p_display_sequence=>10
,p_type=>'LINK'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(12523412714527909)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>'Developer Authorization'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(651539069522363731)
,p_plugin_id=>wwv_flow_imp.id(12523412714527909)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651539479622363731)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651539960533363731)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651540498558363732)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651540919126363741)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651541427607363741)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651541944399363741)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651542483083363741)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651542992412363742)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651543405662363742)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651543919894363742)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651544498595363743)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(651544925039363743)
,p_plugin_attribute_id=>wwv_flow_imp.id(651539069522363731)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(77082398185639908)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_version_scn=>75557288
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(113737019268347425)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>'INTERNAL Oracle APEX Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>75557288
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(113749511183746276)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>'INTERNAL Database Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>75557288
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(113749806821809026)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'INTERNAL Oracle Cloud Identity Management'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>75557288
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(113750429890071859)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'INTERNAL Oracle Application Server Single Sign-On'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>75557288
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(117694777698093086)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>'INTERNAL Social Sign-In'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_version_scn=>75557288
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(117695687338118595)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(117695928229119805)
,p_plugin_attribute_id=>wwv_flow_imp.id(117695687338118595)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(117696352639120891)
,p_plugin_attribute_id=>wwv_flow_imp.id(117695687338118595)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(117696783335121519)
,p_plugin_attribute_id=>wwv_flow_imp.id(117695687338118595)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(117697164316122317)
,p_plugin_attribute_id=>wwv_flow_imp.id(117695687338118595)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(117697531642127596)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(117695687338118595)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(117697833997131789)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(117695687338118595)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(117698773594144445)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(117695687338118595)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(117699026040147499)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(117695687338118595)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(117699383669150422)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Oracle APEX automatically adds the "openid" scope. The authentication '
||'provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(117699669144153515)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(117699930798156032)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(117700266287158350)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(118714805380694539)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(545772663404782860)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(117695687338118595)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(545773635912787511)
,p_plugin_attribute_id=>wwv_flow_imp.id(545772663404782860)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(545774284399794249)
,p_plugin_attribute_id=>wwv_flow_imp.id(545772663404782860)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(545774656584796082)
,p_plugin_attribute_id=>wwv_flow_imp.id(545772663404782860)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(829911836468674176)
,p_plugin_attribute_id=>wwv_flow_imp.id(545772663404782860)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(328065699619423743)
,p_plugin_id=>wwv_flow_imp.id(117694777698093086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (for example, "email_verified" for Username Attribute "email"). If the value of this attribute is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_plugin_dynamic_attribute
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(143089423556992866)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_display_name=>'Plug-In Dynamic Attribute'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_plugin_attribute'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_plugin_attribute'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_reference_id=>6480508142096556
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_clob_textarea
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(202899010831671075)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_display_name=>'CLOB Textarea'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CLOB_TEXTAREA'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_textarea'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_textarea'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:ELEMENT:WIDTH:HEIGHT'
,p_substitute_attributes=>false
,p_reference_id=>200125518386793215
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9437274255687901)
,p_plugin_id=>wwv_flow_imp.id(202899010831671075)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'SQL or PL/SQL to get CLOB value'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_display_length=>80
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This item supports sql statements, like',
'<pre>',
'select big_data',
'from my_table',
'where id=:P4711_ID',
'</pre>',
'and function results, like',
'<pre>',
'return wwv_flow_xxx.get_big_data(p_id => :P4711_ID);',
'</pre>',
'to get a clob value for rendering.',
'',
'To write the data back, the CLOB Textarea makes an AJAX call before the actual page submit, which stores the clob value in wwv_flow_collections.clob001, with a collection name that equals the item name.',
'Developers can then define a page process that stores the clob value where it belongs, either directly',
'<pre>',
'update my_table',
'   set big_data = (select clob001',
'                     from wwv_flow_collections',
'                    where collection_name=''P4711_BIG_DATA'')',
' where id = :P4711_ID;',
'</pre>',
'or via the built-in function wwv_flow_f4000_plugins.get_clob_textarea_value:',
'',
'<pre>',
'update my_table',
'   set agreement_text = wwv_flow_f4000_plugins.get_clob_textarea_value(''P4711_BIG_DATA'')',
' where id = :P4711_ID;',
'</pre>',
''))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(708795120396802284)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>'INTERNAL HTTP Header Variable'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>75557288
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708802916025810450)
,p_plugin_id=>wwv_flow_imp.id(708795120396802284)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708807203689816438)
,p_plugin_id=>wwv_flow_imp.id(708795120396802284)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(708811517195820338)
,p_plugin_attribute_id=>wwv_flow_imp.id(708807203689816438)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(708823430832833673)
,p_plugin_attribute_id=>wwv_flow_imp.id(708807203689816438)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(708843733040843771)
,p_plugin_attribute_id=>wwv_flow_imp.id(708807203689816438)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708855521528859444)
,p_plugin_id=>wwv_flow_imp.id(708795120396802284)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(708807203689816438)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708859829493861703)
,p_plugin_id=>wwv_flow_imp.id(708795120396802284)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(708807203689816438)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1035483720020538244)
,p_plugin_id=>wwv_flow_imp.id(708795120396802284)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1035499301796542365)
,p_plugin_attribute_id=>wwv_flow_imp.id(1035483720020538244)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1035503608376544352)
,p_plugin_attribute_id=>wwv_flow_imp.id(1035483720020538244)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(195660709366291246)
,p_plugin_id=>wwv_flow_imp.id(708795120396802284)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(863910941135523528)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'INTERNAL LDAP Directory'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>75557288
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>Enter the username and password for authentication against the LDAP directory identified on the login page. Remember, passwords may be case sensitive.</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(864164037419579163)
,p_plugin_id=>wwv_flow_imp.id(863910941135523528)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(864172428546586063)
,p_plugin_id=>wwv_flow_imp.id(863910941135523528)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(864187751403592682)
,p_plugin_id=>wwv_flow_imp.id(863910941135523528)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(864195025907594763)
,p_plugin_attribute_id=>wwv_flow_imp.id(864187751403592682)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(864199231794596530)
,p_plugin_attribute_id=>wwv_flow_imp.id(864187751403592682)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(864203434218597234)
,p_plugin_attribute_id=>wwv_flow_imp.id(864187751403592682)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(864316046947619765)
,p_plugin_id=>wwv_flow_imp.id(863910941135523528)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(864250538851608010)
,p_plugin_id=>wwv_flow_imp.id(863910941135523528)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(864353444308628540)
,p_plugin_id=>wwv_flow_imp.id(863910941135523528)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(864250538851608010)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(864446826908642374)
,p_plugin_id=>wwv_flow_imp.id(863910941135523528)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(194434206895698724)
,p_plugin_id=>wwv_flow_imp.id(863910941135523528)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'</p><p>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(194434514860701032)
,p_plugin_attribute_id=>wwv_flow_imp.id(194434206895698724)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(194434920747702762)
,p_plugin_attribute_id=>wwv_flow_imp.id(194434206895698724)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(194435325596704212)
,p_plugin_attribute_id=>wwv_flow_imp.id(194434206895698724)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2446594583478207883)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Add Check All Checkbox'
,p_category=>'MISC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The "Add Check All Checkbox" dynamic action turns a column heading containing the #CHECK_ALL_CHECKBOX# string into an accessible check all style checkbox, that will check and uncheck all the checkboxes in its corresponding column.<p>',
'<p>',
'To use this plug-in, please ensure the following attributes are set:',
'<ol>',
'<li>In the report column, defined ''#CHECK_ALL_CHECKBOX#'' as the Heading value.</li>',
'<li>For the Dynamic Action When attribute, select the report region containing the column.</li>',
'<li>Define the Dynamic Action to fire ''After Refresh'', and the Action to ''Fire on Page Load''. (Both will default appropriately if the Dynamic Action is created by selecting the region in the ''Rendering'' section of Page Designer and creating the Dynam'
||'ic Action from there.</li>',
'<li>This will not handle the accessibility of the checkboxes rendered on each row, this must be done separately in the region source. (See 4000:656 ''Regions'' region for an example).</li>',
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_imp_page.create_page(
 p_id=>0
,p_name=>'zero'
,p_alias=>'ZERO'
,p_step_title=>'zero'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'14'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517338613979160813)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-instance-admin'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517338869335160813)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_imp.id(517338613979160813)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79231407185259804)
,p_plug_name=>'Navigation Tabs Landmark'
,p_parent_plug_id=>wwv_flow_imp.id(517338869335160813)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'&PRODUCT_NAME.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517339235689160818)
,p_plug_name=>'APEX 5 - Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(79231407185259804)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>50
,p_list_id=>wwv_flow_imp.id(40102013671283832)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517380133540212757)
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517339036280160813)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_imp.id(517338869335160813)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'    ''<a href="'' ||',
'    htmldb_util.prepare_url( ''f?p=4050:3:'' || :APP_SESSION || ''::'' || :DEBUG ) ||',
'    ''" class="a-Header-logo"'' ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''title'',',
'        p_value => wwv_flow_lang_dev.builder_message( ''INSTANCE_ADMIN_HOME_NAV'' ) ) ||',
'    case when :APP_PAGE_ID = 3 then '' aria-current="page"'' end ||',
'    ''><span role="img" aria-labelledby="labelApexLogo" class="a-Header-apexLogo"><span class="u-vh" id="labelApexLogo">''  ||',
'    wwv_flow_escape.html(',
'        wwv_flow_lang_dev.builder_message( ''INSTANCE_ADMIN_HOME_NAV'' ) ) ||',
'    ''</span></span></a>'';'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Logo'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517339498543160818)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_imp.id(517338613979160813)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Navigation Bar'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517339884402160818)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_imp.id(517339498543160818)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517340077689160819)
,p_plug_name=>'APEX 5 - Admin Menu'
,p_parent_plug_id=>wwv_flow_imp.id(517339884402160818)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2101406451333034428)
,p_plug_name=>'APEX 5 - Help'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_imp.id(517339884402160818)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(2105958267784095383)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517380464558212757)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517340236798160820)
,p_plug_name=>'APEX 5 - Account'
,p_parent_plug_id=>wwv_flow_imp.id(517339498543160818)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_4000_ui.get_account_mega_menu (',
'            p_username          => :APP_USER,',
'            p_workspace_id      => :WORKSPACE_ID,',
'            p_session           => :APP_SESSION,',
'            p_logout_url        => :LOGOUT_URL );'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Account'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517340434349160820)
,p_plug_name=>'APEX 5 - Control Bar'
,p_region_css_classes=>'a-ControlBar apex-instance-admin'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'3'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517340605882160820)
,p_plug_name=>'APEX 5 - Control Bar Left'
,p_parent_plug_id=>wwv_flow_imp.id(517340434349160820)
,p_region_css_classes=>'a-ControlBar-col a-ControlBar-col--noPadding'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517340807756160820)
,p_plug_name=>'APEX 5 - Breadcrumb'
,p_parent_plug_id=>wwv_flow_imp.id(517340605882160820)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>120
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_imp.id(4585800473139662)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(517472004210010979)
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2101406596781034429)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(517339884402160818)
,p_button_name=>'Help'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372928661202760)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_imp_page.create_page(
 p_id=>1
,p_name=>'Existing Workspaces'
,p_alias=>'EXISTING-WORKSPACES'
,p_step_title=>'Existing Workspaces'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_existing.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24550226216)
,p_plug_name=>'Workspaces'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use this page to search the workspaces provisioned.  Click the workspace name for a detailed report of a specific workspace. Click <strong>Delete</strong> in the action column to start the Remove Workspace Wizard.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated by create flow wizard'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1123402460345350)
,p_plug_name=>'Workspaces'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P1a */',
'       short_name,',
'       (case account_status ',
'        when ''AVAILABLE'' then wwv_flow_lang.system_message(''F4050.AVAILABLE'')',
'        when ''ASSIGNED'' then wwv_flow_lang.system_message(''F4050.ASSIGNED'')',
'        when ''SUSPENDED'' then wwv_flow_lang.system_message(''F4050.SUSPENDED'')',
'        when ''TERMINATE'' then wwv_flow_lang.system_message(''F4050.TERMINATE'')',
'        else account_status',
'        end ) account_status ,',
'       display_name,',
'       rm_consumer_group,',
'       nvl(ALLOW_TO_BE_PURGED_YN,''Y'') auto_purge,',
'       (select count(*) from wwv_flow_fnd_user where  SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) c, ',
'       (select count(*) c from wwv_flow_developers where security_group_id=c.PROVISIONING_COMPANY_ID) d,',
'       (select count(*) c from wwv_flows where security_group_id = c.PROVISIONING_COMPANY_ID) f,',
'       (select project_status from wwv_flow_provision_company where security_group_id=c.PROVISIONING_COMPANY_ID) status,',
'       (select project_approval_date from wwv_flow_provision_company where security_group_id=c.PROVISIONING_COMPANY_ID) provision_date,',
'       (select project_approval_date from wwv_flow_provision_company where security_group_id=c.PROVISIONING_COMPANY_ID) provision_date2,',
'       PROVISIONING_COMPANY_ID,',
'       SOURCE_IDENTIFIER,',
'       allow_restful_services_yn,',
'       is_extension_yn,',
'       path_prefix,',
'       decode( provisioning_company_id,',
'               ''10'', '' '',',
'               ''<a href="''||',
'               wwv_flow_utilities.prepare_url (',
'                   ''f?p=4050:81:''||:flow_session||',
'                   '':BRANCH_TO_PAGE_ACCEPT|NEXT::81,82:P81_COMPANY:''||',
'                   short_name )||',
'               ''">''||',
'               wwv_flow_lang.system_message(''F4350.DELETE'') ) || ''</a>'' delete_me',
'  from WWV_FLOW_COMPANIES c ',
' where upper(short_name) != ''UNKNOWN'' ',
'   and provisioning_company_id not in ( 11, 12 )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1123501416345350)
,p_name=>'Workspaces'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1123707388345359)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace Name'
,p_column_link=>'f?p=&APP_ID.:78:&SESSION.:REPORT:&DEBUG.:RP,78:P78_PROVISIONING_COMPANY_ID:#PROVISIONING_COMPANY_ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1123820269345360)
,p_db_column_name=>'C'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1123913070345360)
,p_db_column_name=>'D'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Developers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1124007202345360)
,p_db_column_name=>'F'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1124118550345360)
,p_db_column_name=>'STATUS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Provision Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(316820619150159698)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1124224550345360)
,p_db_column_name=>'PROVISION_DATE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Provision Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1124324365345361)
,p_db_column_name=>'PROVISIONING_COMPANY_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1124415825345361)
,p_db_column_name=>'DELETE_ME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(484700015910994745)
,p_db_column_name=>'AUTO_PURGE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Auto Purge'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(484701200027018549)
,p_db_column_name=>'PROVISION_DATE2'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Provisioned'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(484860511289026229)
,p_db_column_name=>'SOURCE_IDENTIFIER'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Source Identifier'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(356783130548564595)
,p_db_column_name=>'ACCOUNT_STATUS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Workspace Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(378216319396668186)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Display Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16904813381618873)
,p_db_column_name=>'RM_CONSUMER_GROUP'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Consumer Group'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(385885140328363834)
,p_db_column_name=>'ALLOW_RESTFUL_SERVICES_YN'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'RESTful Services'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(385885208621363841)
,p_db_column_name=>'PATH_PREFIX'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Path Prefix'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1646450516649807)
,p_db_column_name=>'IS_EXTENSION_YN'
,p_display_order=>26
,p_column_identifier=>'Q'
,p_column_label=>'Extensions'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1125603305352700)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1312706958536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:DISPLAY_NAME:C:D:F:STATUS:ACCOUNT_STATUS:IS_EXTENSION_YN:PROVISION_DATE2:AUTO_PURGE:SOURCE_IDENTIFIER:RM_CONSUMER_GROUP:DELETE_ME:'
,p_sort_column_1=>'PROVISION_DATE2'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'SHORT_NAME'
,p_sort_direction_2=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74306967921839166)
,p_plug_name=>'Workspace Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20824651862610331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(484700307037001616)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1123402460345350)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:1,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(254106119813882628)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1123402460345350)
,p_button_name=>'CREATE_WORKSPACE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:RP,27,79,72,73,74::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(357640492667810948)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1123402460345350)
,p_button_name=>'CREATE_WORKSPACE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:RP,142:LAST_VIEW:1'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(24599238284)
,p_branch_action=>'1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(270581419969760339)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_imp_page.create_page(
 p_id=>3
,p_name=>'&PRODUCT_NAME. Administration Services'
,p_alias=>'ADMINISTRATION-SERVICES'
,p_step_title=>'&PRODUCT_NAME. Administration Services'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216800021154677630)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'#fixed_height_region .rc-content {min-height: 200px; padding: 0;}',
'</style>'))
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_deep_linking=>'Y'
,p_help_text=>'AEADM/adm_wrkspc.htm'
,p_page_component_map=>'13'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(118635692071)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Access and perform administration tasks for an entire &PRODUCT_NAME. instance.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20401325723455881)
,p_name=>'New Service Requests'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_report_attributes=>'width="100%"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P4651d */',
'    ''<a href="''||provision_link||''">''||',
'       wwv_flow_escape.html(',
'          wwv_flow_lang.system_message(''REQUEST_WORKSPACE'',',
'              admin_email,',
'              workspace_name,',
'              request_size))||''</a>''',
'       the_request,',
'    request_date',
'from',
'(',
'select ',
'    ADMIN_EMAIL,',
'    COMPANY_NAME                         workspace_name,',
'    DATABASE_SIZE||''MB''                  request_size,',
'    request_date                         request_date,',
'    ''f?p=4050:4:''||:app_session||',
'       ''::NO::PROVISION_ID:''||id         provision_link',
'from WWV_FLOW_PROVISION_COMPANY',
'where project_status = ''REQUESTED''',
')',
'union',
'select ',
'        decode(m.request_status,',
'          ''REQUESTED'',''<a href="f?p=4050:110:''||:flow_session||''::NO:110:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id,',
'          ''APPROVED'', ''<a href="f?p=4050:110:''||:flow_session||''::NO:110,RP:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id',
'          ) ||''">''||',
'        wwv_flow_escape.html(',
'          decode(m.service_name,',
'          ''NEW_SCHEMA'',wwv_flow_lang.system_message(',
'                 ''REQUEST_NEW_SCHEMA'',',
'                 m.REQUESTED_BY, ',
'                 c.short_name, ',
'                 m.service_attribute_1',
'                 ),',
'          ''CHANGE_DB_SIZE'',       wwv_flow_lang.system_message(',
'                          ''REQUEST_CHANGE_DB_SIZE'',',
'                          m.REQUESTED_BY, ',
'                          c.short_name, ',
'                          m.service_attribute_1||''MB''',
'                          ),',
'           c.short_name ||',
'           '' - ''||m.service_name || ',
'           '' - ''||m.service_attribute_1)',
'        )||',
'        ''</a>'' the_request,',
'         m.requested_on        request_date',
'    from wwv_flow_provision_serice_mod m, ',
'         wwv_flow_companies c',
'   where m.security_group_id = c.provisioning_company_id',
'             and   m.request_status = ''REQUESTED''',
'order by 2 desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No New Service Requests.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(20401325723455881)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20401615462455886)
,p_query_column_id=>1
,p_column_alias=>'THE_REQUEST'
,p_column_display_sequence=>1
,p_column_heading=>'Request'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20401715743455886)
,p_query_column_id=>2
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>2
,p_column_heading=>'Date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29327206513889261)
,p_plug_name=>'Instance Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(156499890019184474)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29719518059693725)
,p_plug_name=>'Workspace Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(29722514446881924)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29937821359675476)
,p_plug_name=>'Provisioning'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_request_pref varchar2(4000) := wwv_flow_platform.get_preference(p_preference_name => ''SERVICE_REQUEST_FLOW'');',
'begin',
'    return case l_request_pref',
'                  when ''MANUAL'' then wwv_flow_lang_dev.builder_message(''PROVISIONING_MODE_MANUAL'')',
'                  when ''4700''   then wwv_flow_lang_dev.builder_message(''PROVISIONING_MODE_REQUEST'')',
'                  when ''EMAIL''  then wwv_flow_lang_dev.builder_message(''PROVISIONING_MODE_EMAIL'')',
'                  else ''<p>'' || wwv_flow_escape.html(l_request_pref) || ''</p>''',
'           end;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46453013260349027)
,p_name=>'Workspace Summary'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P3a */',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from wwv_flow_companies ',
'     where PROVISIONING_COMPANY_ID not in (0,10,11)) ',
'    workspaces,',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from WWV_FLOW_COMPANY_SCHEMAS ',
'     where security_group_id not in (0,10,11)) ',
'    schemas,',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from WWV_FLOWS ',
'     where SECURITY_GROUP_ID not in (0,10,11)) ',
'    Applications,',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from WWV_FLOW_FND_USER ',
'     ) ',
'    users,',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from wwv_flow_mail_queue',
'     ) ',
'    mail_queue_entries,',
'    null sql_scripts',
'from sys.dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46450823627307947)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(46453013260349027)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46453303454349039)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACES'
,p_column_display_sequence=>1
,p_column_heading=>'Workspaces'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46453400739349041)
,p_query_column_id=>2
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>2
,p_column_heading=>'Schemas'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46453525576349042)
,p_query_column_id=>3
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>3
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46453620768349042)
,p_query_column_id=>4
,p_column_alias=>'USERS'
,p_column_display_sequence=>4
,p_column_heading=>'Users'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46453725854349042)
,p_query_column_id=>5
,p_column_alias=>'MAIL_QUEUE_ENTRIES'
,p_column_display_sequence=>5
,p_column_heading=>'Mail Queue Entries'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47526519634265779)
,p_query_column_id=>6
,p_column_alias=>'SQL_SCRIPTS'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168904510438515608)
,p_plug_name=>'Instance Administration'
,p_region_sub_css_classes=>'instance-admin'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(168902912946497370)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410251255325302)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168920123999973593)
,p_plug_name=>'System Message'
,p_region_css_classes=>'a-Alert--inline'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--noIcon:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>40
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return wwv_flow_4050_ui.get_system_message(p_app_session => :APP_SESSION);'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(183463511911929201)
,p_name=>'Instance Settings'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4050P4651c */',
'    wwv_flow_platform.get_preference(''INSTANCE_ID'') instance_id,',
'    wwv_flow_platform.get_preference(''NOTIFICATION_EMAIL'' ) ',
'        notification_email,',
'    wwv_flow_platform.get_preference(''EMAIL_INSTANCE_URL'' )',
'        instance_url,',
'    decode(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''),',
'        ''EMAIL'',wwv_flow_lang.system_message(''PROVISIONING_MODE_EMAIL''),',
'        ''4700'',wwv_flow_lang.system_message(''PROVISIONING_MODE_REQUEST''),',
'        ''MANUAL'',wwv_flow_lang.system_message(''PROVISIONING_MODE_MANUAL''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        provisioning_mode,',
'    decode ( wwv_flow_platform.get_preference(''REQ_NEW_SCHEMA'' ) ,',
'        ''Y'',wwv_flow_lang.system_message(''YES''),',
'        ''N'',wwv_flow_lang.system_message(''NO''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        new_schema,',
'    decode(wwv_flow_platform.get_preference(''PRINT_BIB_LICENSED'' ),',
'        ''ADVANCED'',wwv_flow_lang.system_message(''print_server_advanced''),',
'        ''STANDARD'',wwv_flow_lang.system_message(''STANDARD''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        print_server,',
'    wwv_flow_platform.get_preference(''PRINT_SVR_HOST'' )',
'        print_server_host_address,',
'    wwv_flow_platform.get_preference(''SMTP_HOST_ADDRESS'' )',
'        SMTP_HOST_ADDRESS',
'from sys.dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46450823627307947)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(183463511911929201)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16863222023876407)
,p_query_column_id=>1
,p_column_alias=>'INSTANCE_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Instance ID'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183463813490929210)
,p_query_column_id=>2
,p_column_alias=>'NOTIFICATION_EMAIL'
,p_column_display_sequence=>2
,p_column_heading=>'Notification Email'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20133310180661802)
,p_query_column_id=>3
,p_column_alias=>'INSTANCE_URL'
,p_column_display_sequence=>3
,p_column_heading=>'Instance URL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183465031566953824)
,p_query_column_id=>4
,p_column_alias=>'PROVISIONING_MODE'
,p_column_display_sequence=>4
,p_column_heading=>'Provisioning Mode'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183765727327988271)
,p_query_column_id=>5
,p_column_alias=>'NEW_SCHEMA'
,p_column_display_sequence=>5
,p_column_heading=>'Require new schema?'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183766604733000610)
,p_query_column_id=>6
,p_column_alias=>'PRINT_SERVER'
,p_column_display_sequence=>6
,p_column_heading=>'Print Server'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183769506773048520)
,p_query_column_id=>7
,p_column_alias=>'PRINT_SERVER_HOST_ADDRESS'
,p_column_display_sequence=>7
,p_column_heading=>'Print Server Host Address'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183766808327011155)
,p_query_column_id=>8
,p_column_alias=>'SMTP_HOST_ADDRESS'
,p_column_display_sequence=>8
,p_column_heading=>'SMTP Host Address'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(183769726644063701)
,p_name=>'Security Settings'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4050P4651b */',
'    decode(',
'    wwv_flow_platform.get_preference(''REQUIRE_HTTPS'' ) ,',
'        ''Y'',wwv_flow_lang.system_message(''YES''),',
'        ''N'',wwv_flow_lang.system_message(''NO''),',
'        ''A'',wwv_flow_lang.system_message(''ALWAYS''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        require_https,',
'    nvl(wwv_flow_platform.get_preference(''MAX_SESSION_IDLE_SEC''),3600)',
'        maximum_session_idle_seconds,',
'    nvl(wwv_flow_platform.get_preference(''MAX_SESSION_LENGTH_SEC''),28800)',
'        maximum_session_length_seconds,',
'    decode(wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS''),',
'        ''Y'',wwv_flow_lang.system_message(''YES''),',
'        ''N'',wwv_flow_lang.system_message(''NO''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        expire_user_accounts,',
'    wwv_flow_platform.get_preference(''MAX_LOGIN_FAILURES'')',
'        max_login_failures,',
'    wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS'')',
'        password_lifetime_days,',
'    decode(wwv_flow_platform.get_preference(''STRONG_SITE_ADMIN_PASSWORD'') ,',
'        ''Y'',wwv_flow_lang.system_message(''YES''),',
'        ''N'',wwv_flow_lang.system_message(''NO''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        require_strong_admin_password',
'from sys.dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46450823627307947)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(183769726644063701)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183772408383115226)
,p_query_column_id=>1
,p_column_alias=>'REQUIRE_HTTPS'
,p_column_display_sequence=>1
,p_column_heading=>'Require HTTPS'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183772517652115226)
,p_query_column_id=>2
,p_column_alias=>'MAXIMUM_SESSION_IDLE_SECONDS'
,p_column_display_sequence=>2
,p_column_heading=>'Maximum Session Idle Seconds'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183772604474115226)
,p_query_column_id=>3
,p_column_alias=>'MAXIMUM_SESSION_LENGTH_SECONDS'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183772700820115226)
,p_query_column_id=>4
,p_column_alias=>'EXPIRE_USER_ACCOUNTS'
,p_column_display_sequence=>4
,p_column_heading=>'Expire User Accounts'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183772814386115227)
,p_query_column_id=>5
,p_column_alias=>'MAX_LOGIN_FAILURES'
,p_column_display_sequence=>5
,p_column_heading=>'Maximum Login Failures'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183772932553115227)
,p_query_column_id=>6
,p_column_alias=>'PASSWORD_LIFETIME_DAYS'
,p_column_display_sequence=>6
,p_column_heading=>'Password Lifetime Days'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183773017254115227)
,p_query_column_id=>7
,p_column_alias=>'REQUIRE_STRONG_ADMIN_PASSWORD'
,p_column_display_sequence=>7
,p_column_heading=>'Require Strong Admin Password'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(466818203845023502)
,p_plug_name=>'Language'
,p_region_name=>'builder_home_lang_selector'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>120
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return wwv_flow_lang.get_language_selector_list;'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_4000_ui.is_translation_installed( p_flow_id => 4000 )'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(619976314155172583)
,p_name=>'Jobs'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.job_name,',
'       case when j.job_name is not null then htmldb_util.get_since_tswtz(j.last_start_date)',
'            else wwv_flow_lang.system_message(''NOT_FOUND'')',
'       end as last_start_date',
'  from ( select decode(level, 1, ''ORACLE_APEX_AUTO_APPROVAL'',',
'                              2, ''ORACLE_APEX_PURGE_SESSIONS'',',
'                              3, ''ORACLE_APEX_MAIL_QUEUE'',',
'                              4, ''ORACLE_APEX_WS_NOTIFICATIONS'',',
'                              5, ''ORACLE_APEX_DAILY_MAINTENANCE'',',
'                              6, ''ORACLE_APEX_DAILY_METRICS''',
'                      ) as job_name',
'           from sys.dual',
'        connect by level <= 6) x,',
'       sys.user_scheduler_jobs j',
' where x.job_name = j.job_name (+)',
' order by x.job_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47555718632924155)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(619976605315172588)
,p_query_column_id=>1
,p_column_alias=>'JOB_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Job Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(619976727550172590)
,p_query_column_id=>2
,p_column_alias=>'LAST_START_DATE'
,p_column_display_sequence=>2
,p_column_heading=>'Last Start Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620840201547500783)
,p_plug_name=>'Jobs'
,p_parent_plug_id=>wwv_flow_imp.id(619976314155172583)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return ''<p class="margin-bottom-none padding-sm">''',
'       || wwv_flow_escape.html(wwv_flow_lang_dev.builder_message(''DATE_OF_LAST_RUN''))',
'       || ''</p>'';'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(663451466498166105)
,p_plug_name=>'Available Updates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>190
,p_plug_display_point=>'REGION_POSITION_03'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_free_instance  constant varchar2(4) := ''FREE'';',
'    c_state_running  constant varchar2(7) := ''RUNNING'';',
'    l_instance_type  varchar2(4);',
'    l_upgrade_status wwv_flow_cloud_db_services.t_upgrade_status;',
'    l_result         wwv_flow_t_clob_writer := wwv_flow_t_clob_writer();',
'begin',
'    l_instance_type := case upper(substr(sys_context(''userenv'', ''instance_name''), 1, 1))',
'                            when ''F'' then c_free_instance',
'                            else ''PAID''',
'                       end;',
'    l_upgrade_status := wwv_flow_cloud_db_services.get_upgrade_status;',
'',
'    if l_upgrade_status.state = c_state_running then',
'        l_result.prn(''<span class="u-Processing-spinner" style="float: left;margin-right: 8px;--a-spinner-border-color: transparent;"></span>'');',
'',
'        l_result.prn(''<p style="margin-left: 40px">'' ||',
'                  wwv_flow_lang_dev.builder_message(',
'                      ''F4050_P3_UPGRADING'',',
'                      :PRODUCT_NAME,',
'                      l_upgrade_status.upgrade_version) ||',
'                  ''</p>'');',
'',
'    elsif l_upgrade_status.upgrade_date is not null then',
'        l_result.prn(''<p>'' ||',
'                  wwv_flow_lang_dev.builder_message(',
'                      ''F4050_P3_UPGRADE_AVAILABLE'',',
'                      :PRODUCT_NAME,',
'                      l_upgrade_status.upgrade_version,',
'                      ''https://apex.oracle.com/adb-latest'') ||',
'                  ''</p>'');',
'        l_result.prn(''<p>'' ||',
'                  wwv_flow_lang_dev.builder_message(',
'                      ''F4050_P3_UPGRADE_DEFERRED_P'',',
'                      to_char(l_upgrade_status.upgrade_date, :LONG_DATE_FORMAT )) ||',
'                  ''</p>'');',
'        l_result.prn(''<button class="a-Button a-Button--hot" onclick="'' || ',
'                      wwv_flow_page_api.get_url(p_page => 158, p_clear_cache => ''158'') || ''" type="button" id="upgrade_now_button">'' ||',
'                      wwv_flow_lang_dev.builder_message(''F4050_P3_UPGRADE_NOW'') || ',
'                  ''</button>'');',
'',
'    else',
'        l_result.prn(''<p>'' ||',
'                  wwv_flow_lang_dev.builder_message(''F4050_P3_SYSTEM_UP_TO_DATE'') ||',
'                  ''</p>'');',
'        if wwv_flow_platform.get_preference(''UPGRADE_DEFERRED'') = ''Y''',
'           or l_instance_type = c_free_instance then',
'            -- Message: You will have 30/90 days.',
'            l_result.prn(wwv_flow_lang_dev.builder_message(',
'                ''F4050_P3_UPGRADE_DEFERRED_Y'',',
'                :PRODUCT_NAME,',
'                case when l_instance_type = c_free_instance then',
'                          wwv_flow_platform.get_preference(''UPGRADE_DEFER_DAYS'')',
'                     else wwv_flow_platform.get_preference(''UPGRADE_DEFER_DAYS_MAX'')',
'                end));',
'        else',
'            -- Message: You will have 30 days. If you need more time, click the gear icon to increase',
'            -- the upgrade window.',
'            l_result.prn(wwv_flow_lang_dev.builder_message(',
'                ''F4050_P3_UPGRADE_DEFERRED_N'',',
'                :PRODUCT_NAME,',
'                wwv_flow_platform.get_preference(''UPGRADE_DEFER_DAYS'')));',
'        end if;',
'    end if;',
'    l_result.flush;',
'    return l_result.get_value;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
,p_plug_comment=>'Feature #1437 and #4150'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(777604149198624201)
,p_plug_name=>'Available Updates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>180
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<div id="updates"></div>'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Feature #1437'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(926451766177861836)
,p_plug_name=>'Pending Requests'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(926449801871861817)
,p_name=>'Pending Requests'
,p_parent_plug_id=>wwv_flow_imp.id(926451766177861836)
,p_template=>wwv_flow_imp.id(517376500704206647)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--xlarge'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4500P1000cMH */',
'    wwv_flow_provisioning.total_open_service_requests new_service,',
'    --',
'    wwv_flow_provisioning.total_open_change_requests service_change',
'from sys.dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805663950138677747)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(968678541063060714)
,p_query_column_id=>1
,p_column_alias=>'NEW_SERVICE'
,p_column_display_sequence=>1
,p_column_heading=>'New Service'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#NEW_SERVICE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(968798125219081788)
,p_query_column_id=>2
,p_column_alias=>'SERVICE_CHANGE'
,p_column_display_sequence=>2
,p_column_heading=>'Service Change'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#SERVICE_CHANGE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(926451651092861835)
,p_plug_name=>'Mode'
,p_parent_plug_id=>wwv_flow_imp.id(926451766177861836)
,p_region_css_classes=>'padding-md apex-col--bottomBorder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Provisioning Mode: Self-Service Provisioning'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(926451866270861837)
,p_plug_name=>'Administration Services'
,p_region_css_classes=>'a-Region--noTopBorder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(183774608083143536)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(183463511911929201)
,p_button_name=>'EDIT_SET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Edit'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:131::'
,p_icon_css_classes=>'icon-edit'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203133126735284812)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(183463511911929201)
,p_button_name=>'VIEW_INSTANCE_SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Instance Settings'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(183774323405129018)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(183769726644063701)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Edit'
,p_button_position=>'CREATE2'
,p_button_redirect_url=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:130::'
,p_icon_css_classes=>'icon-edit'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(256279016122801246)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46453013260349027)
,p_button_name=>'VIEW_MONITOR'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Monitor Activity'
,p_button_position=>'CREATE2'
,p_button_redirect_url=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202704411977539506)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(926451766177861836)
,p_button_name=>'VIEW_REQUESTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Requests'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202796708138602663)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(926451866270861837)
,p_button_name=>'CREATE_workspace'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(663451568099166106)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(663451466498166105)
,p_button_name=>'set_deferred_preference'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Set Upgrade Preferences'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:158:&SESSION.::&DEBUG.:RP,158::'
,p_button_condition=>'coalesce(upper(substr(sys_context(''userenv'', ''instance_name''), 1, 1)), ''P'') != ''F'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button a-Button--withIcon a-Button--noLabel a-Button--small a-Button--noUI'
,p_icon_css_classes=>'icon-gear'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1143246809648567421)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168920123999973593)
,p_button_name=>'EDIT_MESSAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Edit System Message'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:132:::'
,p_icon_css_classes=>'icon-edit'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1427416875824615006)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(777604149198624201)
,p_button_name=>'set_preferences_updates'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Set Preferences for Available Updates'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RP,70::'
,p_button_css_classes=>'a-Button a-Button--withIcon a-Button--noLabel a-Button--small a-Button--noUI'
,p_icon_css_classes=>'icon-gear'
,p_button_comment=>'See feature #1437.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(357640585498810948)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(926451866270861837)
,p_button_name=>'CREATE_workspace_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:142:LAST_VIEW:3'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(831947701939695434)
,p_branch_name=>'Jump to Workspace'
,p_branch_action=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:RR,78:P78_PROVISIONING_COMPANY_ID:&P3_WORKSPACE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'JUMP_TO_WORKSPACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(458104549385000549)
,p_branch_name=>'Jump to App'
,p_branch_action=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RR,11:IR_ID:&P3_APP.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'JUMP_TO_APP'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(458104688206000550)
,p_branch_name=>'Jump to User'
,p_branch_action=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:RR,12:IR_USER:&P3_USER.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'JUMP_TO_USER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(262162305779555001)
,p_name=>'P3_USER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(29327206513889261)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Jump to User'
,p_placeholder=>'Jump to user...'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'JUMP_USER_LOOKUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct ',
'       u."USER" as r,',
'       u."USER" as d',
'from   wwv_flow_workspace_users u',
'order by 1'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(832237223281900733)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'NO_FETCH'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'2'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(458104113007000545)
,p_name=>'P3_APP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(29327206513889261)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Jump to Application'
,p_placeholder=>'Jump to app...'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'JUMP_APP_LOOKUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.ID as r,',
'       id || nvl2(f.alias,''/''||f.alias,null) as d',
'from   WWV_FLOWS f',
'where  f.security_group_id not in (10, 11, 12)'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(832237223281900733)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'NO_FETCH'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'2'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(663451828304166109)
,p_name=>'P3_UPGRADE_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(926451866270861837)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(831947441311695431)
,p_name=>'P3_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(29327206513889261)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace'
,p_placeholder=>'Jump to workspace...'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'JUMP_WORKSPACE_LOOKUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(832237223281900733)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'NO_FETCH'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29945304933859964)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1427416964580615007)
,p_name=>'Updates - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1427416875824615006)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1427417053117615008)
,p_event_id=>wwv_flow_imp.id(1427416964580615007)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(777604149198624201)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Reload page. We have to do it with a timer, because Firefox prevents the redirect otherwise',
'setTimeout( function() {',
'    apex.navigation.redirect( apex.util.makeApplicationUrl( {} ));',
'}, 0 );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(831947586611695432)
,p_name=>'Jump to Workspace Details Page'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3_WORKSPACE'
,p_condition_element=>'P3_WORKSPACE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(831947696975695433)
,p_event_id=>wwv_flow_imp.id(831947586611695432)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'JUMP_TO_WORKSPACE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(458104260729000546)
,p_name=>'Jump to App Details Page'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3_APP'
,p_condition_element=>'P3_APP'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(458104324913000547)
,p_event_id=>wwv_flow_imp.id(458104260729000546)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'JUMP_TO_APP'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(262162414747555002)
,p_name=>'Jump to App User Report'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3_USER'
,p_condition_element=>'P3_USER'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(262162573062555003)
,p_event_id=>wwv_flow_imp.id(262162414747555002)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'JUMP_TO_USER'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(777604227083624202)
,p_process_sequence=>10
,p_process_point=>'BEFORE_FOOTER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check for updates'
,p_process_sql_clob=>'wwv_flow_4000_ui.updates();'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>777604227083624202
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(359767105825562475)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4050_P72_ADMIN_PASS,F4050_P79_SCHEMA_PASSWORD,F4050_P23_WEB_PASSWORD,P53_PASSWORD,P53_PASSWORD2,P53_GEN_PASSWORD,P106_PASSWORD,P277_SCHEMA_PASSWORD'
,p_internal_uid=>359767105825562475
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_imp_page.create_page(
 p_id=>4
,p_name=>'Provisioning Administration'
,p_alias=>'PROVISIONING-ADMINISTRATION'
,p_step_title=>'Provisioning Administration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(173724892445)
,p_name=>'Workspace Request'
,p_template=>wwv_flow_imp.id(829706609080810173)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Alert--defaultIcons:a-Alert--warning:a-Alert--wizard'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select     ',
'    COMPANY_NAME,',
'    ADMIN_FIRST_NAME,',
'    ADMIN_LAST_NAME,',
'    ADMIN_TITLE,',
'    ADMIN_EMAIL,',
'    ADMIN_PHONE,',
'    ADMIN_USERID,',
'    COMPANY_ADDRESS,',
'    CITY,',
'    STATE,',
'    ZIP,',
'    COUNTRY,',
'    COMPANY_TYPE,',
'    COMPANY_WEBSITE,',
'    NUMBER_OF_EMPLOYEES,',
'    COMPANY_PHONE,',
'    COMPANY_FAX,',
'    ORACLE_PARTNER,',
'    HOW_DID_YOU_HEAR_ABOUT_US,',
'    SERVICE_USE_STATUS,',
'    DATABASE_SIZE,',
'    SERVICE_START_DATE,',
'    SERVICE_TERMINATION_DATE,',
'    SCHEMA_NAME,',
'    ESTIMATED_END_USERS,',
'    PAGE_VIEWS_PER_DAY,',
'    PROJECT_DESCRIPTION,',
'    PROJECT_JUSTIFICATION,',
'    PROJECT_APPROVAL_DATE,',
'    PROJECT_ACTUAL_BEGIN_DATE,',
'    PROJECT_ACTUAL_END_DATE,',
'    PROJECT_STATUS,',
'    request_date,',
'    SECURITY_GROUP_ID,',
'    id',
'from WWV_FLOW_PROVISION_COMPANY',
'where id = :provision_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48687419982771655)
,p_query_column_id=>1
,p_column_alias=>'COMPANY_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48687515843771656)
,p_query_column_id=>2
,p_column_alias=>'ADMIN_FIRST_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Administrator First Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48687628068771656)
,p_query_column_id=>3
,p_column_alias=>'ADMIN_LAST_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Administrator Last Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48687729004771656)
,p_query_column_id=>4
,p_column_alias=>'ADMIN_TITLE'
,p_column_display_sequence=>4
,p_column_heading=>'Admin Title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48687805987771656)
,p_query_column_id=>5
,p_column_alias=>'ADMIN_EMAIL'
,p_column_display_sequence=>5
,p_column_heading=>'Administrator Email'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48687909288771656)
,p_query_column_id=>6
,p_column_alias=>'ADMIN_PHONE'
,p_column_display_sequence=>6
,p_column_heading=>'Admin Phone'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688029577771656)
,p_query_column_id=>7
,p_column_alias=>'ADMIN_USERID'
,p_column_display_sequence=>7
,p_column_heading=>'Administrator Userid'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688118304771656)
,p_query_column_id=>8
,p_column_alias=>'COMPANY_ADDRESS'
,p_column_display_sequence=>8
,p_column_heading=>'Company Address'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688207126771656)
,p_query_column_id=>9
,p_column_alias=>'CITY'
,p_column_display_sequence=>9
,p_column_heading=>'City'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688309531771656)
,p_query_column_id=>10
,p_column_alias=>'STATE'
,p_column_display_sequence=>10
,p_column_heading=>'State'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688426433771657)
,p_query_column_id=>11
,p_column_alias=>'ZIP'
,p_column_display_sequence=>11
,p_column_heading=>'Zip'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688501652771657)
,p_query_column_id=>12
,p_column_alias=>'COUNTRY'
,p_column_display_sequence=>12
,p_column_heading=>'Country'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688632281771657)
,p_query_column_id=>13
,p_column_alias=>'COMPANY_TYPE'
,p_column_display_sequence=>13
,p_column_heading=>'Company Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688721428771657)
,p_query_column_id=>14
,p_column_alias=>'COMPANY_WEBSITE'
,p_column_display_sequence=>14
,p_column_heading=>'Company Website'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688808773771657)
,p_query_column_id=>15
,p_column_alias=>'NUMBER_OF_EMPLOYEES'
,p_column_display_sequence=>15
,p_column_heading=>'Number Of Employees'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48688903783771657)
,p_query_column_id=>16
,p_column_alias=>'COMPANY_PHONE'
,p_column_display_sequence=>16
,p_column_heading=>'Company Phone'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689016797771657)
,p_query_column_id=>17
,p_column_alias=>'COMPANY_FAX'
,p_column_display_sequence=>17
,p_column_heading=>'Company Fax'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689116782771657)
,p_query_column_id=>18
,p_column_alias=>'ORACLE_PARTNER'
,p_column_display_sequence=>18
,p_column_heading=>'Oracle Partner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689200152771658)
,p_query_column_id=>19
,p_column_alias=>'HOW_DID_YOU_HEAR_ABOUT_US'
,p_column_display_sequence=>19
,p_column_heading=>'How Did You Hear About Us'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689300933771658)
,p_query_column_id=>20
,p_column_alias=>'SERVICE_USE_STATUS'
,p_column_display_sequence=>20
,p_column_heading=>'Workspace Use Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689400444771658)
,p_query_column_id=>21
,p_column_alias=>'DATABASE_SIZE'
,p_column_display_sequence=>21
,p_column_heading=>'Database Size'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689521409771658)
,p_query_column_id=>22
,p_column_alias=>'SERVICE_START_DATE'
,p_column_display_sequence=>22
,p_column_heading=>'Service Start Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689621142771658)
,p_query_column_id=>23
,p_column_alias=>'SERVICE_TERMINATION_DATE'
,p_column_display_sequence=>23
,p_column_heading=>'Service Termination Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689700511771658)
,p_query_column_id=>24
,p_column_alias=>'SCHEMA_NAME'
,p_column_display_sequence=>24
,p_column_heading=>'Schema Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689810534771658)
,p_query_column_id=>25
,p_column_alias=>'ESTIMATED_END_USERS'
,p_column_display_sequence=>25
,p_column_heading=>'Estimated End Users'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48689908996771658)
,p_query_column_id=>26
,p_column_alias=>'PAGE_VIEWS_PER_DAY'
,p_column_display_sequence=>26
,p_column_heading=>'Page Views Per Day'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48690003327771658)
,p_query_column_id=>27
,p_column_alias=>'PROJECT_DESCRIPTION'
,p_column_display_sequence=>27
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48690115108771658)
,p_query_column_id=>28
,p_column_alias=>'PROJECT_JUSTIFICATION'
,p_column_display_sequence=>28
,p_column_heading=>'Justification'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48690213710771659)
,p_query_column_id=>29
,p_column_alias=>'PROJECT_APPROVAL_DATE'
,p_column_display_sequence=>29
,p_column_heading=>'Project Approval Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48690326689771659)
,p_query_column_id=>30
,p_column_alias=>'PROJECT_ACTUAL_BEGIN_DATE'
,p_column_display_sequence=>30
,p_column_heading=>'Project Actual Begin Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48690425411771659)
,p_query_column_id=>31
,p_column_alias=>'PROJECT_ACTUAL_END_DATE'
,p_column_display_sequence=>31
,p_column_heading=>'Project Actual End Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48690503555771659)
,p_query_column_id=>32
,p_column_alias=>'PROJECT_STATUS'
,p_column_display_sequence=>32
,p_column_heading=>'Project Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48690621397771659)
,p_query_column_id=>33
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>33
,p_column_heading=>'Request Date'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48690710746771659)
,p_query_column_id=>34
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>34
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48690814352771659)
,p_query_column_id=>35
,p_column_alias=>'ID'
,p_column_display_sequence=>35
,p_column_heading=>'Identification Number'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179795422363234062)
,p_plug_name=>'Warnings'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>40
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_schema        wwv_flow_provision_company.schema_name%type;',
'    l_schema_status wwv_flow_4050_ui.t_schema_status;',
'begin',
'    for c1 in (',
'        select upper(schema_name) sa1',
'          from wwv_flow_provision_company',
'         where id = :PROVISION_ID )',
'    loop',
'        l_schema := c1.sa1;',
'    end loop;',
'',
'    l_schema_status := wwv_flow_4050_ui.get_schema_status(',
'                           p_schema => l_schema,',
'                           p_sgid   => wwv_flow_security.find_security_group_id( p_company => :P4_COMPANY_NAME ) );',
'',
'    return ''<br />'' || ''<br />''',
'           || case',
'                when l_schema_status.schema_type is not null then ''<p />'' || wwv_flow_lang_dev.builder_message(''F4050.SCHEMA_EXISTS'')',
'                when l_schema_status.schema_in_use then ''<p />'' || wwv_flow_lang_dev.builder_message(''F4050.SCHEMA_ASSIGNED'')',
'                when l_schema_status.schema_restricted then ''<p />'' || wwv_flow_lang_dev.builder_message(''F4050.RESTRICTED_ADMIN'')',
'              end;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_schema        wwv_flow_provision_company.schema_name%type;',
'    l_schema_status wwv_flow_4050_ui.t_schema_status;',
'begin',
'    for c1 in (',
'        select upper(schema_name) sa1',
'          from wwv_flow_provision_company',
'         where id = :PROVISION_ID )',
'    loop',
'        l_schema := c1.sa1;',
'    end loop;',
'    l_schema_status := wwv_flow_4050_ui.get_schema_status(',
'                           p_schema => l_schema,',
'                           p_sgid   => wwv_flow_security.find_security_group_id( p_company => :P4_COMPANY_NAME ) );',
'',
'    if   l_schema_status.schema_type is not null',
'      or l_schema_status.schema_in_use',
'      or l_schema_status.schema_restricted',
'    then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(179796001715237593)
,p_name=>'Workspaces That Use Requested Schema'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name from wwv_flow_companies where provisioning_company_id in (select security_group_id from wwv_flow_company_schemas where schema = (',
' select upper(schema_name)',
'    from wwv_flow_provision_company',
'    where id = :PROVISION_ID))'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_company_schemas where schema = (',
' select upper(schema_name)',
'    from wwv_flow_provision_company',
'    where id = :PROVISION_ID)'))
,p_display_condition_type=>'EXISTS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(6897002870390711)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(179796231768237594)
,p_query_column_id=>1
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955890703465997318)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1433457275968958953)
,p_name=>'Survey Responses'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select     ',
'    survey_question_01,',
'    survey_answer_01,',
'    survey_question_02,',
'    survey_answer_02,',
'    survey_question_03,',
'    survey_answer_03,',
'    survey_question_04,',
'    survey_answer_04,',
'    survey_question_05,',
'    survey_answer_05,',
'    survey_question_06,',
'    survey_answer_06,',
'    survey_question_07,',
'    survey_answer_07,',
'    survey_question_08,',
'    survey_answer_08,',
'    survey_question_09,',
'    survey_answer_09,',
'    survey_question_10,',
'    survey_answer_10',
'from WWV_FLOW_PROVISION_COMPANY',
'where id = :provision_id'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null      ',
'from WWV_FLOW_PROVISION_COMPANY',
'where id = :provision_id and',
'    ( survey_answer_01 is not null or',
'      survey_answer_02 is not null or',
'      survey_answer_03 is not null or',
'      survey_answer_04 is not null or',
'      survey_answer_05 is not null or',
'      survey_answer_06 is not null or',
'      survey_answer_07 is not null or',
'      survey_answer_08 is not null or',
'      survey_answer_09 is not null or',
'      survey_answer_10 is not null )'))
,p_display_condition_type=>'EXISTS'
,p_ajax_items_to_submit=>'PROVISION_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805670753642677848)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433457585099958965)
,p_query_column_id=>1
,p_column_alias=>'SURVEY_QUESTION_01'
,p_column_display_sequence=>1
,p_column_heading=>'Question 1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433457692977958969)
,p_query_column_id=>2
,p_column_alias=>'SURVEY_ANSWER_01'
,p_column_display_sequence=>2
,p_column_heading=>'Answer 1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433457710480958969)
,p_query_column_id=>3
,p_column_alias=>'SURVEY_QUESTION_02'
,p_column_display_sequence=>3
,p_column_heading=>'Question 2'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433457800100958969)
,p_query_column_id=>4
,p_column_alias=>'SURVEY_ANSWER_02'
,p_column_display_sequence=>4
,p_column_heading=>'Answer 2'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433457960885958969)
,p_query_column_id=>5
,p_column_alias=>'SURVEY_QUESTION_03'
,p_column_display_sequence=>5
,p_column_heading=>'Question 3'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458067626958969)
,p_query_column_id=>6
,p_column_alias=>'SURVEY_ANSWER_03'
,p_column_display_sequence=>6
,p_column_heading=>'Answer 3'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458181108958970)
,p_query_column_id=>7
,p_column_alias=>'SURVEY_QUESTION_04'
,p_column_display_sequence=>7
,p_column_heading=>'Question 4'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458215472958970)
,p_query_column_id=>8
,p_column_alias=>'SURVEY_ANSWER_04'
,p_column_display_sequence=>8
,p_column_heading=>'Answer 4'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458355035958970)
,p_query_column_id=>9
,p_column_alias=>'SURVEY_QUESTION_05'
,p_column_display_sequence=>9
,p_column_heading=>'Question 5'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458464778958970)
,p_query_column_id=>10
,p_column_alias=>'SURVEY_ANSWER_05'
,p_column_display_sequence=>10
,p_column_heading=>'Answer 5'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458525808958970)
,p_query_column_id=>11
,p_column_alias=>'SURVEY_QUESTION_06'
,p_column_display_sequence=>11
,p_column_heading=>'Question 6'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458664310958970)
,p_query_column_id=>12
,p_column_alias=>'SURVEY_ANSWER_06'
,p_column_display_sequence=>12
,p_column_heading=>'Answer 6'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458782369958971)
,p_query_column_id=>13
,p_column_alias=>'SURVEY_QUESTION_07'
,p_column_display_sequence=>13
,p_column_heading=>'Question 7'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458832624958971)
,p_query_column_id=>14
,p_column_alias=>'SURVEY_ANSWER_07'
,p_column_display_sequence=>14
,p_column_heading=>'Answer 7'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433458949321958971)
,p_query_column_id=>15
,p_column_alias=>'SURVEY_QUESTION_08'
,p_column_display_sequence=>15
,p_column_heading=>'Question 8'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433459046464958971)
,p_query_column_id=>16
,p_column_alias=>'SURVEY_ANSWER_08'
,p_column_display_sequence=>16
,p_column_heading=>'Answer 8'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433459117563958971)
,p_query_column_id=>17
,p_column_alias=>'SURVEY_QUESTION_09'
,p_column_display_sequence=>17
,p_column_heading=>'Question 9'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433459281317958971)
,p_query_column_id=>18
,p_column_alias=>'SURVEY_ANSWER_09'
,p_column_display_sequence=>18
,p_column_heading=>'Answer 9'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433459328870958971)
,p_query_column_id=>19
,p_column_alias=>'SURVEY_QUESTION_10'
,p_column_display_sequence=>19
,p_column_heading=>'Question 10'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1433459404441958971)
,p_query_column_id=>20
,p_column_alias=>'SURVEY_ANSWER_10'
,p_column_display_sequence=>20
,p_column_heading=>'Answer 10'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225165738087)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(955890703465997318)
,p_button_name=>'DECLINE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Decline'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:56::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200345928591)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(955890703465997318)
,p_button_name=>'Approve'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Approve'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:55::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_schema varchar2(30) := null;',
'begin',
'    for c1 in (select upper(schema_name) sa1',
'        from wwv_flow_provision_company',
'        where id = :PROVISION_ID) loop',
'        l_schema := c1.sa1;',
'    end loop;',
'    ',
'    if l_schema is not null then        ',
'        for c1 in (',
'          select 1 from dual',
'          where ',
'(wwv_flow_provisioning.reserved_schema_i(l_schema) = 1)',
' or',
'(wwv_flow_provisioning.restricted_schema_i(l_schema,:P4_COMPANY_NAME) = 1)) loop',
'            return false;',
'        end loop;',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203403932651)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(955890703465997318)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168826226311399329)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183253903897)
,p_name=>'PROVISION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(173724892445)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48853112333141000)
,p_name=>'P4_COMPANY_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(173724892445)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48857919699199941)
,p_computation_sequence=>10
,p_computation_item=>'P4_COMPANY_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select company_name from wwv_flow_provision_company',
' where id = :PROVISION_ID'))
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_imp_page.create_page(
 p_id=>5
,p_name=>'Manage Requests'
,p_alias=>'MANAGE-REQUESTS'
,p_step_title=>'Manage Requests'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216800021154677630)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_ser_rqst.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6119928615239299)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Approve or decline service requests made by workspace administrators</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168703709392622412)
,p_plug_name=>'manage service requests'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(168703120343616153)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(169533626431592276)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(363047307212822256)
,p_plug_name=>'Pending Requests'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return ''<p>'' || wwv_flow_lang_dev.builder_message(''INST_RUNNING_IN_MAN_MODE_4050'') || ''</p>'';'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''), ''MANUAL'') = ''MANUAL'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(466784027754334318)
,p_plug_name=>'New Service Requests'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P5a */',
'    provision_link the_link,',
'    wwv_flow_lang.system_message(''REQUEST_WORKSPACE'',',
'        admin_email,',
'        workspace_name,',
'        request_size ) as the_request,',
'    request_date',
'from',
'(',
'select ',
'    ADMIN_EMAIL,',
'    COMPANY_NAME                         workspace_name,',
'    DATABASE_SIZE||''MB''                  request_size,',
'    request_date                         request_date,',
'    ''f?p=4050:4:''||:app_session||',
'       ''::NO::PROVISION_ID:''||id         provision_link',
'from WWV_FLOW_PROVISION_COMPANY',
'where project_status = ''REQUESTED''',
')',
'union',
'select ',
'        decode(m.request_status,',
'          ''REQUESTED'',''f?p=4050:110:''||:flow_session||',
'                      ''::NO:110:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||',
'                      m.security_group_id,',
'          ''APPROVED'', ''f?p=4050:110:''||:flow_session||',
'                      ''::NO:110,RP:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||',
'                      m.security_group_id) the_link,',
'          decode(m.service_name,',
'          ''NEW_SCHEMA'',wwv_flow_lang.system_message(',
'                 ''REQUEST_NEW_SCHEMA'',',
'                 m.REQUESTED_BY, ',
'                 c.short_name, ',
'                 m.service_attribute_1',
'                 ),',
'          ''CHANGE_DB_SIZE'',       wwv_flow_lang.system_message(',
'                          ''REQUEST_CHANGE_DB_SIZE'',',
'                          m.REQUESTED_BY, ',
'                          c.short_name, ',
'                          m.service_attribute_1||''MB''',
'                          ),',
'           c.short_name ||',
'           '' - ''||m.service_name || ',
'           '' - ''||m.service_attribute_1) as the_request,',
'         m.requested_on        request_date',
'    from wwv_flow_provision_serice_mod m, ',
'         wwv_flow_companies c',
'   where m.security_group_id = c.provisioning_company_id',
'             and   m.request_status = ''REQUESTED'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(466784129153334318)
,p_name=>'New Service Requests'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_aggregate=>'N'
,p_show_group_by=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_detail_link=>'#THE_LINK#'
,p_detail_link_text=>'<span class="a-Icon icon-edit"></span>'
,p_detail_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(466784329387334331)
,p_db_column_name=>'THE_REQUEST'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Service Request'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(466784425269334336)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Date of Request'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472988616335136594)
,p_db_column_name=>'THE_LINK'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'The Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(466784609864334568)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1312906812536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'THE_REQUEST:REQUEST_DATE:THE_LINK'
,p_sort_column_1=>'REQUEST_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1080987107325523904)
,p_name=>'Pending Requests'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--large'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_provisioning.total_open_service_requests new_services,',
'    wwv_flow_provisioning.total_open_change_requests service_change',
'from dual'))
,p_display_when_condition=>'nvl(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''), ''MANUAL'') != ''MANUAL'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805663950138677747)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080987275465523905)
,p_query_column_id=>1
,p_column_alias=>'NEW_SERVICES'
,p_column_display_sequence=>1
,p_column_heading=>'New Service'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#NEW_SERVICES#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080987374026523906)
,p_query_column_id=>2
,p_column_alias=>'SERVICE_CHANGE'
,p_column_display_sequence=>2
,p_column_heading=>'Service Change'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#SERVICE_CHANGE#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(484348231779602259)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(466784027754334318)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:5,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202780809310222232)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(466784027754334318)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(357640393972810948)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(466784027754334318)
,p_button_name=>'CREATE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:142:LAST_VIEW:5'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168507612620814711)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'5'
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_imp_page.create_page(
 p_id=>6
,p_name=>'Provision Request'
,p_alias=>'PROVISION-REQUEST'
,p_step_title=>'Provision Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_ser_rqst.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225183790487)
,p_plug_name=>'Request Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 23-FEB-2001 17:53:48'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(825539548181735504)
,p_plug_name=>'Usage Info'
,p_parent_plug_id=>wwv_flow_imp.id(225183790487)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_required_role=>wwv_flow_imp.id(825639761147256575)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225294842695)
,p_plug_name=>'Edit Request'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edit the current workspace request.</p>',
'<p>Click the <strong>Apply Changes</strong> button, if present, to save your changes. Click the <strong>Terminate or Delete</strong> button, if present, to terminate the request. Click the <strong>Delete</strong> button, if present, to delete the req'
||'uest.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195699107817256786)
,p_plug_name=>'Edit Provisioning Request'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225186790489)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(195699107817256786)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2934116575079521)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(195699107817256786)
,p_button_name=>'Terminate_or_Delete'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Terminate or Delete'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_provision_company',
'',
'where id = :F4050_P6_ID',
'',
'and project_status = ''APPROVED'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(52722223258062562)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(195699107817256786)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.::D_PROVISION_ID:&F4050_P6_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_provision_company',
'',
'where id = :F4050_P6_ID',
'',
'and project_status = ''APPROVED'''))
,p_button_condition_type=>'NOT_EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225190790490)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(195699107817256786)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P6_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(135407227774354772)
,p_branch_action=>'f?p=&FLOW_ID.:81:&SESSION.::&DEBUG.:81,82:P81_COMPANY:&F4050_P6_COMPANY_NAME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2934116575079521)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(225180790486)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(225182790487)
,p_branch_action=>'26'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Cancel'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225194790494)
,p_name=>'F4050_P6_ID'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225196790494)
,p_name=>'F4050_P6_SECURITY_GROUP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225198790495)
,p_name=>'F4050_P6_COMPANY_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace'
,p_source=>'COMPANY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225200790495)
,p_name=>'F4050_P6_ADMIN_FIRST_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Admin First Name'
,p_source=>'ADMIN_FIRST_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter first name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225202790496)
,p_name=>'F4050_P6_ADMIN_LAST_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Admin Last Name'
,p_source=>'ADMIN_LAST_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter last name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225204790497)
,p_name=>'F4050_P6_ADMIN_TITLE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'ADMIN_TITLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225206790497)
,p_name=>'F4050_P6_ADMIN_EMAIL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Admin Email'
,p_source=>'ADMIN_EMAIL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter email address.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225208790498)
,p_name=>'F4050_P6_ADMIN_PHONE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'ADMIN_PHONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225210790498)
,p_name=>'F4050_P6_ADMIN_USERID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Admin UserID'
,p_source=>'ADMIN_USERID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify administrator''s user ID.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225212790499)
,p_name=>'F4050_P6_COMPANY_ADDRESS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'COMPANY_ADDRESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225214790500)
,p_name=>'F4050_P6_CITY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'CITY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225216790500)
,p_name=>'F4050_P6_STATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'STATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225218790501)
,p_name=>'F4050_P6_ZIP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'ZIP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225220790501)
,p_name=>'P6_COUNTRY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(825539548181735504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Country'
,p_source=>'COUNTRY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COUNTRIES'
,p_lov=>'.'||wwv_flow_imp.id(825654386458276754)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225222790502)
,p_name=>'F4050_P6_COMPANY_TYPE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'COMPANY_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225236790507)
,p_name=>'F4050_P6_SERVICE_USE_STATUS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'SERVICE_USE_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225238790508)
,p_name=>'F4050_P6_DATABASE_SIZE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Database Size'
,p_source=>'DATABASE_SIZE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify database size.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225240790509)
,p_name=>'F4050_P6_SERVICE_START_DATE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'SERVICE_START_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify service start date.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225242790509)
,p_name=>'F4050_P6_SERVICE_TERMINATION_DATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'SERVICE_TERMINATION_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify service termination date.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225244790510)
,p_name=>'F4050_P6_SCHEMA_NAME'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema Name'
,p_source=>'SCHEMA_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d,',
'       username r',
'  from wwv_flow_admin_all_schemas s',
' where (   restricted_to_workspace is null',
'        or restricted_to_workspace = upper(:F4050_P6_COMPANY_NAME))',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identify schema name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225250790511)
,p_name=>'F4050_P6_PROJECT_DESCRIPTION'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Project Description'
,p_source=>'PROJECT_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify project description'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225254790513)
,p_name=>'F4050_P6_PROJECT_APPROVAL_DATE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'PROJECT_APPROVAL_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies approval date.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225256790513)
,p_name=>'F4050_P6_PROJECT_ACTUAL_BEGIN_DATE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_source=>'PROJECT_ACTUAL_BEGIN_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies provisioning date.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225260790515)
,p_name=>'F4050_P6_PROJECT_STATUS'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(225183790487)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Project Status:'
,p_source=>'PROJECT_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SERVICE.REQUEST.STATUS'
,p_lov=>'.'||wwv_flow_imp.id(87755726864223308)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify project status.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(825539691666735505)
,p_name=>'P6_USAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(825539548181735504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Usage'
,p_source=>'USAGE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'USAGE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(825928575701276934)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(825539783247735506)
,p_name=>'P6_ORG_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(825539548181735504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Organization'
,p_source=>'ORG_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P6_USAGE_TYPE'
,p_display_when2=>'ORG'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(183384800804268476)
,p_validation_name=>'schema not restricted'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (wwv_flow_provisioning.site_admin_is_restricted and',
'     wwv_flow_provisioning.restricted_schema(',
'         p_schema => upper(:F4050_P6_SCHEMA_NAME),',
'         p_workspace_name => upper(:F4050_P6_COMPANY_NAME)',
'         )) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The requested schema is restricted. Restricted schemas cannot be assigned to workspaces.'
,p_when_button_pressed=>wwv_flow_imp.id(225190790490)
,p_associated_item=>wwv_flow_imp.id(225244790510)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(183404521151643333)
,p_validation_name=>'schema not reserved'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_provisioning.reserved_schema(p_schema =>   ',
'    upper(:F4050_P6_SCHEMA_NAME)) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Requested schema is reserved.'
,p_when_button_pressed=>wwv_flow_imp.id(225190790490)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225264790516)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PROVISION_COMPANY'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROVISION_COMPANY'
,p_attribute_03=>'F4050_P6_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>225264790516
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225266790517)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PROVISION_COMPANY'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROVISION_COMPANY'
,p_attribute_03=>'F4050_P6_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_when_button_id=>wwv_flow_imp.id(225190790490)
,p_process_success_message=>'Action processed.'
,p_internal_uid=>225266790517
);
end;
/
prompt --application/pages/page_00007
begin
wwv_flow_imp_page.create_page(
 p_id=>7
,p_name=>'Adjust Request'
,p_alias=>'ADJUST-REQUEST'
,p_step_title=>'Adjust Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(43187720190328736)
,p_plug_name=>'Change Status Provisioning Attribute'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>5
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_footer=>'<div class="htmldbInstructionText">The information above is from the workspace request.  The actual name of the workspace and other attributes may be different for a provisioned user, this is only the request.</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 16-MAR-2001 18:11:26'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(43202121056423198)
,p_plug_name=>'Change Status'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page enables workspace administrators to change the status of a workspace request.</p>',
'<p>Resetting a request to <strong>Requested</strong> enables a workspace to be re-provisioned.</p>',
'<p><strong>Note:</strong> Be cautious when setting the Project Status to <strong>Requested</strong>. Although <strong>Requested</strong> enables you to reprovision a workspace, it could result in data corruption due to the manner in which accounts ar'
||'e provisioned.  The provisioning system assumes <strong>Requested</strong> workspace requests do not have the corresponding schemas and dictionary entries for a workspace administrator or developers. If you need to change the Project Status for an <s'
||'trong>Approved</strong> workspace to <strong>Requested</strong>, terminate the workspace first and then change the status to <strong>Requested</strong>.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>5
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(48679045286466446)
,p_name=>'Provisioning Request Report'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ID,',
'    SECURITY_GROUP_ID,',
'    COMPANY_NAME,',
'    ADMIN_FIRST_NAME,',
'    ADMIN_LAST_NAME,',
'    ADMIN_TITLE,',
'    ADMIN_EMAIL,',
'    ADMIN_PHONE,',
'    ADMIN_ID,',
'    ADMIN_USERID,',
'    COMPANY_ADDRESS,',
'    CITY,',
'    STATE,',
'    ZIP,',
'    COUNTRY,',
'    SERVICE_USE_STATUS,',
'    DATABASE_SIZE,',
'    SERVICE_START_DATE,',
'    SERVICE_TERMINATION_DATE,',
'    SCHEMA_NAME,',
'    ESTIMATED_END_USERS,',
'    PAGE_VIEWS_PER_DAY,',
'    PROJECT_DESCRIPTION,',
'    PROJECT_JUSTIFICATION,',
'    PROJECT_STATUS,',
'    REQUEST_DATE,',
'   SURVEY_QUESTION_01,',
'    SURVEY_ANSWER_01,',
'    SURVEY_QUESTION_02,',
'    SURVEY_ANSWER_02,',
'    SURVEY_QUESTION_03,',
'    SURVEY_ANSWER_03,',
'    SURVEY_QUESTION_04,',
'    SURVEY_ANSWER_04,',
'    SURVEY_QUESTION_05,',
'    SURVEY_ANSWER_05,',
'    SURVEY_QUESTION_06,',
'    SURVEY_ANSWER_06,',
'    SURVEY_QUESTION_07,',
'    SURVEY_ANSWER_07,',
'    SURVEY_QUESTION_08,',
'    SURVEY_ANSWER_08,',
'    SURVEY_QUESTION_09,',
'    SURVEY_ANSWER_09,',
'    SURVEY_QUESTION_10,',
'    SURVEY_ANSWER_10,',
'    AGREEMENT_ACCEPTANCE_DATE,',
'    AGREEMENT_NAME,',
'    AGREEMENT_USER_ENV',
'from WWV_FLOW_PROVISION_COMPANY',
'where id = :T_PROVISION_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48556132422770818)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48556223377770818)
,p_query_column_id=>2
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48556324615770818)
,p_query_column_id=>3
,p_column_alias=>'COMPANY_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Workspace Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48556402156770818)
,p_query_column_id=>4
,p_column_alias=>'ADMIN_FIRST_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'First Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48556509895770818)
,p_query_column_id=>5
,p_column_alias=>'ADMIN_LAST_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Last Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48556604610770818)
,p_query_column_id=>6
,p_column_alias=>'ADMIN_TITLE'
,p_column_display_sequence=>6
,p_column_heading=>'Title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48556719143770818)
,p_query_column_id=>7
,p_column_alias=>'ADMIN_EMAIL'
,p_column_display_sequence=>7
,p_column_heading=>'Email'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48556819251770818)
,p_query_column_id=>8
,p_column_alias=>'ADMIN_PHONE'
,p_column_display_sequence=>8
,p_column_heading=>'Phone'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48556903983770819)
,p_query_column_id=>9
,p_column_alias=>'ADMIN_ID'
,p_column_display_sequence=>9
,p_column_heading=>'Administrator ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48557019200770819)
,p_query_column_id=>10
,p_column_alias=>'ADMIN_USERID'
,p_column_display_sequence=>10
,p_column_heading=>'Admininstrator User'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48557116708770819)
,p_query_column_id=>11
,p_column_alias=>'COMPANY_ADDRESS'
,p_column_display_sequence=>11
,p_column_heading=>'Address'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48557212730770819)
,p_query_column_id=>12
,p_column_alias=>'CITY'
,p_column_display_sequence=>12
,p_column_heading=>'City'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48557300303770819)
,p_query_column_id=>13
,p_column_alias=>'STATE'
,p_column_display_sequence=>13
,p_column_heading=>'State'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48557417190770819)
,p_query_column_id=>14
,p_column_alias=>'ZIP'
,p_column_display_sequence=>14
,p_column_heading=>'ZIP'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48557531161770819)
,p_query_column_id=>15
,p_column_alias=>'COUNTRY'
,p_column_display_sequence=>15
,p_column_heading=>'Country'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48558301343770820)
,p_query_column_id=>16
,p_column_alias=>'SERVICE_USE_STATUS'
,p_column_display_sequence=>16
,p_column_heading=>'Workspace Use Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48558416989770820)
,p_query_column_id=>17
,p_column_alias=>'DATABASE_SIZE'
,p_column_display_sequence=>17
,p_column_heading=>'Database Size'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48558502328770820)
,p_query_column_id=>18
,p_column_alias=>'SERVICE_START_DATE'
,p_column_display_sequence=>18
,p_column_heading=>'Workspace Start Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48558608436770821)
,p_query_column_id=>19
,p_column_alias=>'SERVICE_TERMINATION_DATE'
,p_column_display_sequence=>19
,p_column_heading=>'Workspace Termination Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48558732412770821)
,p_query_column_id=>20
,p_column_alias=>'SCHEMA_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Schema Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48558828706770821)
,p_query_column_id=>21
,p_column_alias=>'ESTIMATED_END_USERS'
,p_column_display_sequence=>21
,p_column_heading=>'Estimated End Users'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48558926502770821)
,p_query_column_id=>22
,p_column_alias=>'PAGE_VIEWS_PER_DAY'
,p_column_display_sequence=>22
,p_column_heading=>'Page Views Per Day'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48559028941770821)
,p_query_column_id=>23
,p_column_alias=>'PROJECT_DESCRIPTION'
,p_column_display_sequence=>23
,p_column_heading=>'Project Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48559105122770821)
,p_query_column_id=>24
,p_column_alias=>'PROJECT_JUSTIFICATION'
,p_column_display_sequence=>24
,p_column_heading=>'Project Justification'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48559505641770822)
,p_query_column_id=>25
,p_column_alias=>'PROJECT_STATUS'
,p_column_display_sequence=>25
,p_column_heading=>'Project Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(316820619150159698)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48559715673770822)
,p_query_column_id=>26
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>26
,p_column_heading=>'Request Date'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127233300885112327)
,p_query_column_id=>27
,p_column_alias=>'SURVEY_QUESTION_01'
,p_column_display_sequence=>27
,p_column_heading=>'Survey Question 1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127233418541112327)
,p_query_column_id=>28
,p_column_alias=>'SURVEY_ANSWER_01'
,p_column_display_sequence=>28
,p_column_heading=>'Survey Answer 1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127233515172112327)
,p_query_column_id=>29
,p_column_alias=>'SURVEY_QUESTION_02'
,p_column_display_sequence=>29
,p_column_heading=>'Survey Question 2'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127233615113112327)
,p_query_column_id=>30
,p_column_alias=>'SURVEY_ANSWER_02'
,p_column_display_sequence=>30
,p_column_heading=>'Survey Answer 2'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127233706102112327)
,p_query_column_id=>31
,p_column_alias=>'SURVEY_QUESTION_03'
,p_column_display_sequence=>31
,p_column_heading=>'Survey Question 3'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127233801078112327)
,p_query_column_id=>32
,p_column_alias=>'SURVEY_ANSWER_03'
,p_column_display_sequence=>32
,p_column_heading=>'Survey Answer 3'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127233932661112327)
,p_query_column_id=>33
,p_column_alias=>'SURVEY_QUESTION_04'
,p_column_display_sequence=>33
,p_column_heading=>'Survey Question 4'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234021629112327)
,p_query_column_id=>34
,p_column_alias=>'SURVEY_ANSWER_04'
,p_column_display_sequence=>34
,p_column_heading=>'Survey Answer 4'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234122858112327)
,p_query_column_id=>35
,p_column_alias=>'SURVEY_QUESTION_05'
,p_column_display_sequence=>35
,p_column_heading=>'Survey Question 5'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234232119112327)
,p_query_column_id=>36
,p_column_alias=>'SURVEY_ANSWER_05'
,p_column_display_sequence=>36
,p_column_heading=>'Survey Answer 5'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234323875112327)
,p_query_column_id=>37
,p_column_alias=>'SURVEY_QUESTION_06'
,p_column_display_sequence=>37
,p_column_heading=>'Survey Question 6'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234415961112327)
,p_query_column_id=>38
,p_column_alias=>'SURVEY_ANSWER_06'
,p_column_display_sequence=>38
,p_column_heading=>'Survey Answer 6'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234512307112327)
,p_query_column_id=>39
,p_column_alias=>'SURVEY_QUESTION_07'
,p_column_display_sequence=>39
,p_column_heading=>'Survey Question 7'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234601873112328)
,p_query_column_id=>40
,p_column_alias=>'SURVEY_ANSWER_07'
,p_column_display_sequence=>40
,p_column_heading=>'Survey Answer 7'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234717583112328)
,p_query_column_id=>41
,p_column_alias=>'SURVEY_QUESTION_08'
,p_column_display_sequence=>41
,p_column_heading=>'Survey Question 8'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234801062112328)
,p_query_column_id=>42
,p_column_alias=>'SURVEY_ANSWER_08'
,p_column_display_sequence=>42
,p_column_heading=>'Survey Answer 8'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127234916016112328)
,p_query_column_id=>43
,p_column_alias=>'SURVEY_QUESTION_09'
,p_column_display_sequence=>43
,p_column_heading=>'Survey Question 9'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127235000735112328)
,p_query_column_id=>44
,p_column_alias=>'SURVEY_ANSWER_09'
,p_column_display_sequence=>44
,p_column_heading=>'Survey Answer 9'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127235111807112328)
,p_query_column_id=>45
,p_column_alias=>'SURVEY_QUESTION_10'
,p_column_display_sequence=>45
,p_column_heading=>'Survey Question 10'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127235211618112328)
,p_query_column_id=>46
,p_column_alias=>'SURVEY_ANSWER_10'
,p_column_display_sequence=>46
,p_column_heading=>'Survey Answer 10'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127235322684112328)
,p_query_column_id=>47
,p_column_alias=>'AGREEMENT_ACCEPTANCE_DATE'
,p_column_display_sequence=>47
,p_column_heading=>'Agreement Acceptance Date'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127235407487112328)
,p_query_column_id=>48
,p_column_alias=>'AGREEMENT_NAME'
,p_column_display_sequence=>48
,p_column_heading=>'Agreement Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(127235506714112328)
,p_query_column_id=>49
,p_column_alias=>'AGREEMENT_USER_ENV'
,p_column_display_sequence=>49
,p_column_heading=>'Agreement User Env'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168823108472356352)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(227262248958)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168823108472356352)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(43186036285311765)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168823108472356352)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'(:T_PROVISION_ID is not null)'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23895428675298516)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(168823108472356352)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_button_condition=>'F4050_P26_STATUS'
,p_button_condition2=>'ACCEPTED'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168825819600387963)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(227275281088)
,p_name=>'T_PROVISION_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'<strong>New Service Provisioning Request ID</strong>:'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3143616388404027)
,p_name=>'F4050_P7_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(43187720190328736)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Request ID:'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'ID number of the provisioning request.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3147132094442338)
,p_name=>'F4050_P7_SECURITY_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(43187720190328736)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Security Group ID (identifies workspace):'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'ID number of the provisioned workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3149427134444600)
,p_name=>'F4050_P7_COMPANY_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(43187720190328736)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace:'
,p_source=>'COMPANY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Name of the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3151719586448120)
,p_name=>'F4050_P7_ADMIN_EMAIL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(43187720190328736)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Admin Email:'
,p_source=>'ADMIN_EMAIL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Administrator''s email address for the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3154014626450405)
,p_name=>'F4050_P7_SCHEMA_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(43187720190328736)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema Name:'
,p_source=>'SCHEMA_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Schema to be provisioned.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3156308803453087)
,p_name=>'F4050_P7_PROJECT_STATUS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(43187720190328736)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Project Status'
,p_source=>'PROJECT_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SERVICE.REQUEST.STATUS'
,p_lov=>'.'||wwv_flow_imp.id(87755726864223308)||'.'
,p_cHeight=>1
,p_read_only_when=>'F4050_P7_PROJECT_STATUS'
,p_read_only_when2=>'TERMINATED'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Project status.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52855125454514117)
,p_name=>'F4050_P7_PREV_PROJ_STATUS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(43187720190328736)
,p_use_cache_before_default=>'NO'
,p_prompt=>'F4050_P7_PREV_PROJ_STATUS'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select project_status',
'',
'from wwv_flow_provision_company',
'',
'where id = :F4050_P7_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(52862315508549089)
,p_validation_name=>'status error'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4050_P7_PREV_PROJ_STATUS = ''APPROVED'' then',
'  if :F4050_P7_PROJECT_STATUS = ''TERMINATED'' then',
'    return true;',
'  else',
'    return false;',
'  end if;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Approved service can only be terminated.  Other status change will result in data corruption.'
,p_when_button_pressed=>wwv_flow_imp.id(43186036285311765)
,p_associated_item=>wwv_flow_imp.id(3156308803453087)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(43195820508328757)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PROVISION_COMPANY'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROVISION_COMPANY'
,p_attribute_03=>'T_PROVISION_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>43195820508328757
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(43196090106328758)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PROVISION_COMPANY'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROVISION_COMPANY'
,p_attribute_03=>'T_PROVISION_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_when_button_id=>wwv_flow_imp.id(43186036285311765)
,p_process_when=>'F4050_P7_PROJECT_STATUS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'TERMINATED'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>43196090106328758
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(52670212528973146)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'terminate service'
,p_process_sql_clob=>'wwv_flow_provisioning.terminate_service(p_id=>:F4050_P7_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error terminating service.'
,p_process_when_button_id=>wwv_flow_imp.id(43186036285311765)
,p_process_when=>'F4050_P7_PROJECT_STATUS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'TERMINATED'
,p_process_success_message=>'Service terminated.'
,p_internal_uid=>52670212528973146
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22250501311969152)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete service'
,p_process_sql_clob=>'wwv_flow_provisioning.delete_accepted_request(p_id=>:F4050_P7_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting service.'
,p_process_when_button_id=>wwv_flow_imp.id(23895428675298516)
,p_process_when=>'F4050_P26_STATUS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'ACCEPTED'
,p_process_success_message=>'Service deleted.'
,p_internal_uid=>22250501311969152
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_imp_page.create_page(
 p_id=>8
,p_name=>'Delete Request'
,p_alias=>'DELETE-REQUEST'
,p_step_title=>'Delete Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2842620068855323)
,p_name=>'Provisioning Request'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select * from wwv_flow_provision_company where id = :D_PROVISION_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48631213889771330)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48631331903771330)
,p_query_column_id=>2
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48631423316771330)
,p_query_column_id=>3
,p_column_alias=>'COMPANY_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Workspace Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48631502805771331)
,p_query_column_id=>4
,p_column_alias=>'ADMIN_FIRST_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Admin First Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48631615946771331)
,p_query_column_id=>5
,p_column_alias=>'ADMIN_LAST_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Admin Last Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48631701678771331)
,p_query_column_id=>6
,p_column_alias=>'ADMIN_TITLE'
,p_column_display_sequence=>6
,p_column_heading=>'Admin Title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48631811461771331)
,p_query_column_id=>7
,p_column_alias=>'ADMIN_EMAIL'
,p_column_display_sequence=>7
,p_column_heading=>'Admin Email'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48631925591771331)
,p_query_column_id=>8
,p_column_alias=>'ADMIN_PHONE'
,p_column_display_sequence=>8
,p_column_heading=>'Admin Phone'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632024673771331)
,p_query_column_id=>9
,p_column_alias=>'ADMIN_ID'
,p_column_display_sequence=>9
,p_column_heading=>'Admin'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632117814771331)
,p_query_column_id=>10
,p_column_alias=>'ADMIN_USERID'
,p_column_display_sequence=>10
,p_column_heading=>'Admin Userid'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632218354771331)
,p_query_column_id=>11
,p_column_alias=>'COMPANY_ADDRESS'
,p_column_display_sequence=>11
,p_column_heading=>'Company Address'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632328727771331)
,p_query_column_id=>12
,p_column_alias=>'CITY'
,p_column_display_sequence=>12
,p_column_heading=>'City'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632405878771332)
,p_query_column_id=>13
,p_column_alias=>'STATE'
,p_column_display_sequence=>13
,p_column_heading=>'State'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632521698771332)
,p_query_column_id=>14
,p_column_alias=>'ZIP'
,p_column_display_sequence=>14
,p_column_heading=>'Zip'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632632685771332)
,p_query_column_id=>15
,p_column_alias=>'COUNTRY'
,p_column_display_sequence=>17
,p_column_heading=>'Country'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_report_column_required_role=>wwv_flow_imp.id(825639761147256575)
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(825654386458276754)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632706380771332)
,p_query_column_id=>16
,p_column_alias=>'COMPANY_TYPE'
,p_column_display_sequence=>20
,p_column_heading=>'Company Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632818574771332)
,p_query_column_id=>17
,p_column_alias=>'COMPANY_WEBSITE'
,p_column_display_sequence=>21
,p_column_heading=>'Company Website'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48632908699771332)
,p_query_column_id=>18
,p_column_alias=>'NUMBER_OF_EMPLOYEES'
,p_column_display_sequence=>22
,p_column_heading=>'Number Of Employees'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633014812771332)
,p_query_column_id=>19
,p_column_alias=>'COMPANY_PHONE'
,p_column_display_sequence=>23
,p_column_heading=>'Company Phone'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633113309771332)
,p_query_column_id=>20
,p_column_alias=>'COMPANY_FAX'
,p_column_display_sequence=>24
,p_column_heading=>'Company Fax'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633231303771332)
,p_query_column_id=>21
,p_column_alias=>'ORACLE_PARTNER'
,p_column_display_sequence=>25
,p_column_heading=>'Oracle Partner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633303328771333)
,p_query_column_id=>22
,p_column_alias=>'HOW_DID_YOU_HEAR_ABOUT_US'
,p_column_display_sequence=>26
,p_column_heading=>'How Did You Hear About Us'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633407898771333)
,p_query_column_id=>23
,p_column_alias=>'SERVICE_USE_STATUS'
,p_column_display_sequence=>27
,p_column_heading=>'Workspace Use Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633520261771333)
,p_query_column_id=>24
,p_column_alias=>'DATABASE_SIZE'
,p_column_display_sequence=>28
,p_column_heading=>'Database Size'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236237917010177041)
,p_query_column_id=>25
,p_column_alias=>'DATABASE_INITIAL_SIZE'
,p_column_display_sequence=>42
,p_column_heading=>'Database Initial Size'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633625766771333)
,p_query_column_id=>26
,p_column_alias=>'SERVICE_START_DATE'
,p_column_display_sequence=>29
,p_column_heading=>'Workspace Start Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633723979771333)
,p_query_column_id=>27
,p_column_alias=>'SERVICE_TERMINATION_DATE'
,p_column_display_sequence=>30
,p_column_heading=>'Workspace Termination Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633823851771333)
,p_query_column_id=>28
,p_column_alias=>'SCHEMA_NAME'
,p_column_display_sequence=>31
,p_column_heading=>'Schema Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48633922599771333)
,p_query_column_id=>29
,p_column_alias=>'ESTIMATED_END_USERS'
,p_column_display_sequence=>32
,p_column_heading=>'Estimated End Users'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48634022185771333)
,p_query_column_id=>30
,p_column_alias=>'PAGE_VIEWS_PER_DAY'
,p_column_display_sequence=>33
,p_column_heading=>'Page Views Per Day'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238009656177041)
,p_query_column_id=>31
,p_column_alias=>'SURVEY_QUESTION_01'
,p_column_display_sequence=>43
,p_column_heading=>'Survey Question 01'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238124332177041)
,p_query_column_id=>32
,p_column_alias=>'SURVEY_ANSWER_01'
,p_column_display_sequence=>44
,p_column_heading=>'Survey Answer 01'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238225708177041)
,p_query_column_id=>33
,p_column_alias=>'SURVEY_QUESTION_02'
,p_column_display_sequence=>45
,p_column_heading=>'Survey Question 02'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238319647177041)
,p_query_column_id=>34
,p_column_alias=>'SURVEY_ANSWER_02'
,p_column_display_sequence=>46
,p_column_heading=>'Survey Answer 02'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238404563177041)
,p_query_column_id=>35
,p_column_alias=>'SURVEY_QUESTION_03'
,p_column_display_sequence=>47
,p_column_heading=>'Survey Question 03'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238510917177041)
,p_query_column_id=>36
,p_column_alias=>'SURVEY_ANSWER_03'
,p_column_display_sequence=>48
,p_column_heading=>'Survey Answer 03'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238617141177041)
,p_query_column_id=>37
,p_column_alias=>'SURVEY_QUESTION_04'
,p_column_display_sequence=>49
,p_column_heading=>'Survey Question 04'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238722774177041)
,p_query_column_id=>38
,p_column_alias=>'SURVEY_ANSWER_04'
,p_column_display_sequence=>50
,p_column_heading=>'Survey Answer 04'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238832744177041)
,p_query_column_id=>39
,p_column_alias=>'SURVEY_QUESTION_05'
,p_column_display_sequence=>51
,p_column_heading=>'Survey Question 05'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236238918528177041)
,p_query_column_id=>40
,p_column_alias=>'SURVEY_ANSWER_05'
,p_column_display_sequence=>52
,p_column_heading=>'Survey Answer 05'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239032365177041)
,p_query_column_id=>41
,p_column_alias=>'SURVEY_QUESTION_06'
,p_column_display_sequence=>53
,p_column_heading=>'Survey Question 06'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239120445177041)
,p_query_column_id=>42
,p_column_alias=>'SURVEY_ANSWER_06'
,p_column_display_sequence=>54
,p_column_heading=>'Survey Answer 06'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239200835177041)
,p_query_column_id=>43
,p_column_alias=>'SURVEY_QUESTION_07'
,p_column_display_sequence=>55
,p_column_heading=>'Survey Question 07'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239311259177041)
,p_query_column_id=>44
,p_column_alias=>'SURVEY_ANSWER_07'
,p_column_display_sequence=>56
,p_column_heading=>'Survey Answer 07'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239414214177041)
,p_query_column_id=>45
,p_column_alias=>'SURVEY_QUESTION_08'
,p_column_display_sequence=>57
,p_column_heading=>'Survey Question 08'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239531458177042)
,p_query_column_id=>46
,p_column_alias=>'SURVEY_ANSWER_08'
,p_column_display_sequence=>58
,p_column_heading=>'Survey Answer 08'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239615538177042)
,p_query_column_id=>47
,p_column_alias=>'SURVEY_QUESTION_09'
,p_column_display_sequence=>59
,p_column_heading=>'Survey Question 09'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239730325177042)
,p_query_column_id=>48
,p_column_alias=>'SURVEY_ANSWER_09'
,p_column_display_sequence=>60
,p_column_heading=>'Survey Answer 09'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239807463177042)
,p_query_column_id=>49
,p_column_alias=>'SURVEY_QUESTION_10'
,p_column_display_sequence=>61
,p_column_heading=>'Survey Question 10'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236239927232177042)
,p_query_column_id=>50
,p_column_alias=>'SURVEY_ANSWER_10'
,p_column_display_sequence=>62
,p_column_heading=>'Survey Answer 10'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236240012349177042)
,p_query_column_id=>51
,p_column_alias=>'AGREEMENT_ACCEPTANCE_DATE'
,p_column_display_sequence=>63
,p_column_heading=>'Agreement Acceptance Date'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236240132249177042)
,p_query_column_id=>52
,p_column_alias=>'AGREEMENT_NAME'
,p_column_display_sequence=>64
,p_column_heading=>'Agreement Name'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236240230795177042)
,p_query_column_id=>53
,p_column_alias=>'AGREEMENT_USER_ENV'
,p_column_display_sequence=>65
,p_column_heading=>'Agreement User Env'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236240329233177042)
,p_query_column_id=>54
,p_column_alias=>'AGREEMENT_CHECKSUM'
,p_column_display_sequence=>66
,p_column_heading=>'Agreement Checksum'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48634128002771334)
,p_query_column_id=>55
,p_column_alias=>'PROJECT_DESCRIPTION'
,p_column_display_sequence=>34
,p_column_heading=>'Project Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48634202021771334)
,p_query_column_id=>56
,p_column_alias=>'PROJECT_JUSTIFICATION'
,p_column_display_sequence=>35
,p_column_heading=>'Project Justification'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48634307951771334)
,p_query_column_id=>57
,p_column_alias=>'PROJECT_APPROVAL_DATE'
,p_column_display_sequence=>36
,p_column_heading=>'Project Approval Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48634404873771334)
,p_query_column_id=>58
,p_column_alias=>'PROJECT_ACTUAL_BEGIN_DATE'
,p_column_display_sequence=>37
,p_column_heading=>'Project Actual Begin Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48634508156771334)
,p_query_column_id=>59
,p_column_alias=>'PROJECT_ACTUAL_END_DATE'
,p_column_display_sequence=>38
,p_column_heading=>'Project Actual End Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48634623965771334)
,p_query_column_id=>60
,p_column_alias=>'PROJECT_STATUS'
,p_column_display_sequence=>39
,p_column_heading=>'Project Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48634727595771334)
,p_query_column_id=>61
,p_column_alias=>'WORK_LOG'
,p_column_display_sequence=>40
,p_column_heading=>'Work Log'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48634805072771335)
,p_query_column_id=>62
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>41
,p_column_heading=>'Request Date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(852083723823313781)
,p_query_column_id=>63
,p_column_alias=>'WORKSPACE_TYPE'
,p_column_display_sequence=>67
,p_column_heading=>'Workspace Type'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825539888042735507)
,p_query_column_id=>64
,p_column_alias=>'IP_ADDRESS'
,p_column_display_sequence=>68
,p_column_heading=>'IP Address'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825539908447735508)
,p_query_column_id=>65
,p_column_alias=>'USAGE_TYPE'
,p_column_display_sequence=>18
,p_column_heading=>'Usage'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_report_column_required_role=>wwv_flow_imp.id(825639761147256575)
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(825928575701276934)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825540065042735509)
,p_query_column_id=>66
,p_column_alias=>'ORG_NAME'
,p_column_display_sequence=>19
,p_column_heading=>'Organization'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_report_column_required_role=>wwv_flow_imp.id(825639761147256575)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(56499914833442395)
,p_plug_name=>'Delete Request'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'If workspace is terminated or denied you can delete the entire request from the system using this page.  '
,p_plug_query_headings=>'Edit:Seq.:Col.:Name:Display:Template:Source:Items:Buttons:BuildOption:DisplayWhenType'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_plug_query_col_allignments=>'L:L:L:L:L:L:L:R:R:L:L:L:L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(227287494596)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2842620068855323)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(227285494595)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2842620068855323)
,p_button_name=>'DeleteRequest'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Request'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(227291494598)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(227285494595)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(227319764028)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(227293494598)
,p_branch_action=>'26'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(227287494596)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2847701305864055)
,p_name=>'D_PROVISION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2842620068855323)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2855101293879192)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete request'
,p_process_sql_clob=>'wwv_flow_provisioning.delete_provision_request(p_id=>:D_PROVISION_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting workspace request.'
,p_process_when_button_id=>wwv_flow_imp.id(227285494595)
,p_process_success_message=>'Request deleted.'
,p_internal_uid=>2855101293879192
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_imp_page.create_page(
 p_id=>9
,p_name=>'Manage Instance'
,p_alias=>'MANAGE-INSTANCE'
,p_step_title=>'Manage Instance'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_ser_rqst.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168495707597569444)
,p_plug_name=>'Instance Settings'
,p_icon_css_classes=>'icon-utilities-ui-defaults'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(47534314618390800)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168503102999717326)
,p_plug_name=>'Manage Shared Components'
,p_icon_css_classes=>'icon-util-shared-components'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(137961006165346808)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168503812265738931)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this page to control and set the features and functionality of this &PRODUCT_NAME. instance.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168504112396748429)
,p_plug_name=>'Manage Meta Data'
,p_icon_css_classes=>'icon-util-object-dependencies'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(19017202882431374)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168506212358795720)
,p_plug_name=>'Messages'
,p_icon_css_classes=>'icon-sc-list'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(168505619846788416)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192441415743903627)
,p_plug_name=>'Manage Logs and Files'
,p_region_css_classes=>'h400'
,p_icon_css_classes=>'icon-util-logs'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>50
,p_list_id=>wwv_flow_imp.id(5021913929565780)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203029008911057378)
,p_plug_name=>'Self Service Sign Up'
,p_region_css_classes=>'h400'
,p_icon_css_classes=>'icon-admin-service-request'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(203028225668057376)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(254701518341001744)
,p_plug_name=>'Provisioning Mode'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_session_id   varchar2(255) := :APP_SESSION;',
'    l_request_pref varchar2(4000);',
'begin',
'    l_request_pref := wwv_flow_platform.get_preference(p_preference_name => ''SERVICE_REQUEST_FLOW'');',
'',
'    return ''<strong><a href="f?p='' || :APP_ID || '':131:'' || l_session_id || '':::RIR:">''',
'           || case l_request_pref',
'                  when ''EMAIL'' then wwv_flow_lang_dev.builder_message(''SELF_SERVICE_WITH_EMAIL'')',
'                  when ''4700''  then wwv_flow_lang_dev.builder_message(''SELF_SERVICE'')',
'                  when ''AUTO''  then wwv_flow_lang_dev.builder_message(''F4050.AUTOMATIC'')',
'                  else              wwv_flow_lang_dev.builder_message(''MANUAL'')',
'              end',
'           || ''</a></strong>'';  ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(968837253318525063)
,p_name=>'Metrics'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--xlarge'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4500P1000cMH9 */',
'   (select to_char(nvl(wwv_flow_platform.get_preference( p_preference_name => ''MAX_SESSION_IDLE_SEC''),3600),''999G999G999G999G990'') x from sys.dual)  max_session_idle_time',
'from sys.dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805663950138677747)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(968839153112542694)
,p_query_column_id=>1
,p_column_alias=>'MAX_SESSION_IDLE_TIME'
,p_column_display_sequence=>1
,p_column_heading=>'Max Session Idle Time in seconds'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168507403963812268)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'9'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1364682309896820101)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(192441415743903627)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1364682468819820102)
,p_event_id=>wwv_flow_imp.id(1364682309896820101)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    // use new API to show the success message if any that came from the dialog',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_imp_page.create_page(
 p_id=>10
,p_name=>'Manage Workspaces'
,p_alias=>'MANAGE-WORKSPACES'
,p_step_title=>'Manage Workspaces'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'#fixed_height_region .rc-content {min-height: 200px; padding: 0;}',
'</style>'))
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc_pg.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6049701880928601)
,p_plug_name=>'Workspace Actions'
,p_region_css_classes=>'h360'
,p_icon_css_classes=>'icon-util-workspace-actions'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(19017606691432489)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6144611534376254)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A workspace is a shared work area where multiple developers can create applications.  Each workspace has the privilege to parse as one or more database schemas.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10332829289896519)
,p_plug_name=>'Workspace Reports'
,p_region_css_classes=>'h360'
,p_icon_css_classes=>'icon-sc-report-query'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(10332318553893424)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47561719374965004)
,p_plug_name=>'Export Import'
,p_region_css_classes=>'h240'
,p_icon_css_classes=>'icon-utilities-data-workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>40
,p_list_id=>wwv_flow_imp.id(47558804136960608)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168490221110504940)
,p_plug_name=>'Manage Applications'
,p_region_css_classes=>'h240'
,p_icon_css_classes=>'icon-util-manage'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(244253103570784647)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1080988572880523918)
,p_name=>'Current Status'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--large'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    (   select count(*) c',
'        from wwv_flow_companies',
'        where provisioning_company_id not in (0,10,11) )  workspace_count,',
'    (   select count(*) c',
'        from wwv_flow_fnd_user ) workspace_users,',
'    (   select count(*) c',
'        from wwv_flow_company_schemas cs,',
'             wwv_flow_companies c',
'        where cs.security_group_id = c.provisioning_company_id(+)',
'             and short_name != ''INTERNAL'' ) workspace_schemas,',
'    (   select count(*) c',
'        from wwv_flows',
'        where security_group_id not in (0,10,11) ) applications',
'from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805663950138677747)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'0'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080988619379523919)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_COUNT'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace Count'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#WORKSPACE_COUNT#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080988755941523920)
,p_query_column_id=>2
,p_column_alias=>'WORKSPACE_USERS'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace Users'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#WORKSPACE_USERS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080988827320523921)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE_SCHEMAS'
,p_column_display_sequence=>3
,p_column_heading=>'Workspace Schemas'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#WORKSPACE_SCHEMAS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080988927572523922)
,p_query_column_id=>4
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>4
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#APPLICATIONS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30177820127829133)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'10'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2609714500735301)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Set Item F4050_P79_SCHEMA_PASSWORD to null'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4050_P79_SCHEMA_PASSWORD'
,p_internal_uid=>2609714500735301
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_imp_page.create_page(
 p_id=>11
,p_name=>'Application Attributes'
,p_alias=>'APPLICATION-ATTRIBUTES'
,p_step_title=>'Application Attributes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(275228225185505839)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_app.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1154929605958289)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.ID, ',
'       c.short_name as SECURITY_GROUP_ID,',
'       f.SECURITY_GROUP_ID as workspace_id,',
'       f.OWNER,',
'       f.NAME,',
'       f.alias,',
'       f.LAST_UPDATED_BY,',
'       f.LAST_UPDATED_ON,',
'       (select count(*) from wwv_flow_steps where flow_id = f.id) as pages,',
'       f.CHARSET,',
'       f.CREATED_ON as created,',
'       f.FLOW_LANGUAGE,',
'       f.WEBDB_LOGGING as logging,',
'       f.DATE_FORMAT,',
'       f.FLOW_IMAGE_PREFIX as image_prefix,',
'       f.FLOW_VERSION as version,',
'       f.FLOW_STATUS as application_status,',
'       f.FLOW_UNAVAILABLE_TEXT as unavailable_text,',
'       f.RESTRICT_TO_USER_LIST as restrict_to_users,',
'    --    HTMLDB_ITEM.TEXT_FROM_LOV(f.BUILD_STATUS,''BUILD_STATUS'') as BUILD_STATUS,',
'       f.BUILD_STATUS as BUILD_STATUS,',
'       f.SECURITY_SCHEME',
'  from WWV_FLOWS f,',
'       WWV_FLOW_COMPANIES c',
' where f.security_group_id = c.provisioning_company_id',
'   and f.security_group_id not in (10, 11, 12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1155017179958289)
,p_name=>'Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1155308703958298)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_link=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:RR,78:P78_PROVISIONING_COMPANY_ID:#WORKSPACE_ID#'
,p_column_linktext=>'#SECURITY_GROUP_ID#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1155213723958298)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1155425625958298)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Parsing Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1155519945958298)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1155614168958299)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1155710134958299)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1155820920958299)
,p_db_column_name=>'PAGES'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1155923375958299)
,p_db_column_name=>'CHARSET'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Character Set'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1156000595958300)
,p_db_column_name=>'FLOW_LANGUAGE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1170023688080440)
,p_db_column_name=>'LOGGING'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Logging'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(110344620122166929)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1170128212080441)
,p_db_column_name=>'DATE_FORMAT'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Date Format'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1170207128080445)
,p_db_column_name=>'IMAGE_PREFIX'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Image Prefix'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1170516700080446)
,p_db_column_name=>'VERSION'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Version'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1170611697080446)
,p_db_column_name=>'APPLICATION_STATUS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Status'
,p_column_link=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:P4001_ID,P4001_ATTRIBUTE:#ID#,Application'
,p_column_linktext=>'#APPLICATION_STATUS#'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(85746300886317667)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1171928667091381)
,p_db_column_name=>'UNAVAILABLE_TEXT'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Unavailable Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1172004705091382)
,p_db_column_name=>'RESTRICT_TO_USERS'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Restrict To Users'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1172110334091382)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Build Status'
,p_column_link=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:P4001_ID,P4001_ATTRIBUTE:#ID#,Build'
,p_column_linktext=>'#BUILD_STATUS#'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(244320808989852457)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1172220531091382)
,p_db_column_name=>'SECURITY_SCHEME'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Security Scheme'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1173327198109877)
,p_db_column_name=>'CREATED'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(254152603061181874)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(144298924302584758)
,p_db_column_name=>'ALIAS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1156228564958887)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1313008436536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SECURITY_GROUP_ID:ID:OWNER:NAME:LAST_UPDATED_BY:LAST_UPDATED_ON:PAGES:FLOW_LANGUAGE:LOGGING:BUILD_STATUS:APPLICATION_STATUS:CREATED:WORKSPACE_ID:ALIAS'
,p_sort_column_1=>'CREATED'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'LAST_UPDATED_ON'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(254091311699719427)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1154929605958289)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset Report'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(244651516120077672)
,p_branch_action=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(262162602983555004)
,p_name=>'Refresh - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1154929605958289)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(262162758586555005)
,p_event_id=>wwv_flow_imp.id(262162602983555004)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1154929605958289)
);
end;
/
prompt --application/pages/page_00012
begin
wwv_flow_imp_page.create_page(
 p_id=>12
,p_name=>'Manage Developers and Users'
,p_alias=>'MANAGE-DEVELOPERS-AND-USERS'
,p_step_title=>'Manage Developers and Users'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216787602191653217)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_users.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6318778195)
,p_plug_name=>'Developers and Users'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>&PRODUCT_NAME. internal applications (such as App Builder, SQL Workshop, and so on) authenticate user',
'credentials against entries in the &PRODUCT_NAME. account repository. User-developed applications may use that',
'account repository as well for authentication.</p>',
'',
'<p>This report shows user name entries in that repository by workspace. Click the name of a user in the report to edit',
'that user, or click <strong>Create</strong> to create a new user. Select the <strong>Reset</strong> link to change the password for that user.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(116013241709082034)
,p_plug_name=>'User Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20829938868705277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1301955870026853711)
,p_plug_name=>'Manage Application Developers and Users'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select u.user_id,',
'       u.workspace_id,',
'       u."USER",',
'       u.first_name||'' ''||u.last_name full_name,',
'       lower(u."eMail") as email,',
'       u.df, -- default schema',
'       u.ul, -- is user locked?',
'       u.dev_type account_type,',
'       u.last_update_date,',
'       u.creation_date,',
'       c.short_name workspace,',
'       (select ''<a href="f?p=4050:53:''||:flow_session||',
'               ''::NO:53:F4050_P53_USER_ID:''||wwv_flow_escape.html(u.user_id)||''">''||',
'               wwv_flow_lang.system_message(''F4050.RESET'')||''</a>''',
'          from wwv_flow_workspace_users',
'         where user_id = u.user_id',
'           and "USER" <> ''ADMIN''',
'           and "eMail" is not null',
'           and (wwv_flow_authentication_dev.get_internal_authentication <> ''DB'' or u.dev_type = ''End User'')',
'        ) p',
'  from wwv_flow_workspace_users u,',
'       wwv_flow_companies c',
' where u.workspace_id = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1301955948511853712)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'JASON'
,p_internal_uid=>1301955948511853712
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1301956426284853717)
,p_db_column_name=>'USER_ID'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'User ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1301956557228853718)
,p_db_column_name=>'USER'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'User'
,p_column_link=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:RP,23:F4050_P23_USER_ID:#USER_ID#'
,p_column_linktext=>'#USER#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1301956930963853722)
,p_db_column_name=>'DF'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Default Schema'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(222860275257540030)
,p_db_column_name=>'EMAIL'
,p_display_order=>110
,p_column_identifier=>'AT'
,p_column_label=>'Email Address'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1301957424892853727)
,p_db_column_name=>'UL'
,p_display_order=>120
,p_column_identifier=>'O'
,p_column_label=>'Locked'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1301958980212853742)
,p_db_column_name=>'LAST_UPDATE_DATE'
,p_display_order=>130
,p_column_identifier=>'AD'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1301959124887853744)
,p_db_column_name=>'CREATION_DATE'
,p_display_order=>140
,p_column_identifier=>'AF'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1796417210487006101)
,p_db_column_name=>'FULL_NAME'
,p_display_order=>150
,p_column_identifier=>'AM'
,p_column_label=>'Full Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1796417582391006104)
,p_db_column_name=>'ACCOUNT_TYPE'
,p_display_order=>160
,p_column_identifier=>'AP'
,p_column_label=>'Account Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1796417696532006105)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>170
,p_column_identifier=>'AQ'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1796417728321006106)
,p_db_column_name=>'P'
,p_display_order=>180
,p_column_identifier=>'AR'
,p_column_label=>'Password'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>'wwv_flow_platform.get_preference(p_preference_name  => ''SMTP_HOST_ADDRESS'') is not null'
,p_display_condition2=>'PLSQL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2024852857686481305)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>190
,p_column_identifier=>'AS'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1795767872937959948)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'17957679'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'USER:FULL_NAME:WORKSPACE:DF:ACCOUNT_TYPE:UL:CREATION_DATE:LAST_UPDATE_DATE:P:'
,p_sort_column_1=>'USER'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(484702204098038644)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1301955870026853711)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:12,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(43040243631941918)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1301955870026853711)
,p_button_name=>'Create_New'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create User'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:23,EDIT_USER_PRIVS::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(25567619615581607)
,p_branch_action=>'f?p=&FLOW_ID.:12:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(25564831604575604)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>25564831604575604
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_imp_page.create_page(
 p_id=>13
,p_name=>'Page Views by Operating System'
,p_alias=>'PAGE-VIEWS-BY-OPERATING-SYSTEM'
,p_step_title=>'Page Views by Operating System'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_inline_css=>'td[headers=GRAPH] {min-width: 150px;}'
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2584726337646135)
,p_name=>'Page Views by Operating System'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_count as',
'(select /* APEX 4050P13a */ count(*) a ',
'from wwv_flow_activity_log ',
'where security_group_id = :flow_security_group_id and ',
'time_stamp >= sysdate - nvl(:P13_TIME,1)',
') ',
'select os, page_views , 100*page_views/total_count.a pct, round(100*page_views/total_count.a) graph',
'from (',
'select ',
' x.os, ',
' sum(x.c) page_views',
'from',
'(',
'select session_id, max(decode(user_agent,null,'' Null'',',
'       nvl(',
'       decode(instr(user_agent,''Mac OS X''),0,'''',''Mac OS X'')||',
'       decode(instr(user_agent,''Linux''),0,'''',''Linux'')||',
'       decode(instr(user_agent,''Windows NT 5.0''),0,'''',''Windows 2000'')||',
'       decode(instr(user_agent,''Windows NT 6.0''),0,'''',''Windows Vista'')||',
'       decode(instr(user_agent,''Windows NT 7''),0,'''',''Windows 7'')||',
'       decode(instr(user_agent,''Windows NT 8''),0,'''',''Windows 8'')||',
'       decode(instr(user_agent,''Windows NT 9''),0,'''',''Windows 9'')||',
'       decode(instr(user_agent,''Windows NT 10''),0,'''',''Windows 10'')||',
'       decode(instr(user_agent,''Windows NT 11''),0,'''',''Windows 11'')||',
'       decode(instr(user_agent,''Windows NT 5.1''),0,'''',''Windows XP''),',
'       t.other))) os, count(*) c',
'from wwv_flow_activity_log, ',
'    (select wwv_flow_lang.system_message(''other'') other from dual) t',
'where security_group_id = :flow_security_group_id',
'       and time_stamp >= sysdate - nvl(:P13_TIME,1)',
'group by session_id',
') x',
'group by os) d, ',
'total_count',
'where (:P13_SEARCH is null or instr(upper(os),upper(:P13_SEARCH)) > 0)'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Page Views found.'
,p_query_num_rows_item=>'P13_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'Y'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Print'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'&PRODUCT_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3213125863900959)
,p_query_column_id=>1
,p_column_alias=>'OS'
,p_column_display_sequence=>1
,p_column_heading=>'Operating System'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'40'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2585103254646189)
,p_query_column_id=>2
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>2
,p_column_heading=>'Page Views'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'30'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3213229658900959)
,p_query_column_id=>3
,p_column_alias=>'PCT'
,p_column_display_sequence=>3
,p_column_heading=>'Percentage'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'30'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3213317952900970)
,p_query_column_id=>4
,p_column_alias=>'GRAPH'
,p_column_display_sequence=>4
,p_column_heading=>'Graph'
,p_use_as_row_header=>'N'
,p_column_format=>'PCT_GRAPH:#cccccc:#777777:'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(108275219905850320)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3216622316918896)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(108275219905850320)
,p_button_name=>'P13_GO'
,p_button_static_id=>'P13_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3215505347913957)
,p_name=>'P13_TIME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(108275219905850320)
,p_item_default=>'1'
,p_prompt=>'Include'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92431227952006274)
,p_name=>'P13_ROWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(108275219905850320)
,p_item_default=>'100'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_G'
,p_lov=>'.'||wwv_flow_imp.id(87738929453259457)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the number of rows to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92433515962012317)
,p_name=>'P13_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(108275219905850320)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter case insensitive query criteria and press <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_imp_page.create_page(
 p_id=>14
,p_name=>'Workspace Details'
,p_alias=>'WORKSPACE-DETAILS'
,p_step_title=>'Workspace Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_details.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2882705150907846)
,p_plug_name=>'Workspace Details'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--labelsAbove:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_imp.id(81008210556197147)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|2,3,4\1|',
'',
'&nbsp;:',
'',
'<font color="black" class="nounderline">Schema</font>:',
'',
'<font color="black" class="nounderline">Company</font>:',
'',
'<font color="black" class="nounderline">CompanyID</font>'))
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177744611327233052)
,p_plug_name=>'Workspace Details'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page shows key attributes about the selected workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180211706270323234)
,p_plug_name=>'Workspace Summary Report'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_workspace_reports.get_report_workspace_usage (',
'           p_security_group_id => :SGID,',
'           p_max_apps          => 5,',
'           p_max_db_objects    => 5,',
'           p_time_frame_DWMY   => nvl(:P14_REPORTING_PERIOD,''W''),',
'           p_date_format       => :DATE_TIME_FORMAT );'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_ajax_items_to_submit=>'SGID,P14_REPORTING_PERIOD'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'SGID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180427220917510105)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19471711351438457)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(2882705150907846)
,p_button_name=>'P14_GO'
,p_button_static_id=>'P14_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(180478505463215176)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2882705150907846)
,p_button_name=>'REMOVE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Remove'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81:P81_COMPANY:&P14_WORKSPACE_NAME.'
,p_button_condition=>'SGID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(360939525109430983)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2882705150907846)
,p_button_name=>'EDIT_WS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Edit'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.::P78_PROVISIONING_COMPANY_ID:&SGID.'
,p_button_condition=>'SGID'
,p_button_condition2=>'10'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(360949518239533093)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2882705150907846)
,p_button_name=>'MAN_WS_SCHEMAS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Schema Assignments'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:21,RIR:IR_SECURITY_GROUP_ID:&SGID.'
,p_button_condition=>'SGID'
,p_button_condition2=>'10'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(361023100417991549)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2882705150907846)
,p_button_name=>'MAN_USERS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Manage Users'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:12,RIR:IR_WORKSPACE_ID:&SGID.'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184089511347405635)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(2882705150907846)
,p_button_name=>'EMAIL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Email'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.::P76_REPORTING_PERIOD,P76_WORKSPACE_ID:&P14_REPORTING_PERIOD.,&SGID.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(317937565640)
,p_branch_action=>'14'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(297977429861)
,p_name=>'SGID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2882705150907846)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name, PROVISIONING_COMPANY_ID',
'from   WWV_FLOW_COMPANIES',
'where provisioning_company_id not in (0, 11)',
'order  by short_name'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select a workspace and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180427011913507481)
,p_name=>'P14_WORKSPACE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2882705150907846)
,p_prompt=>'Workspace Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180730012565372136)
,p_name=>'P14_REPORTING_PERIOD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2882705150907846)
,p_item_default=>'W'
,p_prompt=>'Reporting Period'
,p_source=>'W'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_imp.id(180726228364333770)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(180427400962513786)
,p_computation_sequence=>10
,p_computation_item=>'P14_WORKSPACE_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select short_name from wwv_flow_companies where provisioning_company_id = :SGID'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(180400628882162317)
,p_computation_sequence=>20
,p_computation_item=>'SGID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_name varchar2(255);',
'   l_next_sgid number;',
'begin',
'   select short_name into l_name ',
'   from wwv_flow_companies ',
'   where provisioning_company_id = :SGID;',
'   for c1 in (select provisioning_company_id',
'              from wwv_flow_companies ',
'              where short_name > l_name',
'              order by short_name) loop',
'       l_next_sgid := c1.provisioning_company_id;',
'       exit;',
'   end loop;',
'   return nvl(l_next_sgid,:SGID);',
'end;'))
,p_compute_when=>'NEXT'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(180401916892168333)
,p_computation_sequence=>30
,p_computation_item=>'SGID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_name varchar2(255);',
'   l_next_sgid number;',
'begin',
'   select short_name into l_name ',
'   from wwv_flow_companies ',
'   where provisioning_company_id = :SGID;',
'   for c1 in (select provisioning_company_id',
'              from wwv_flow_companies ',
'              where short_name < l_name',
'              order by short_name desc) loop',
'       l_next_sgid := c1.provisioning_company_id;',
'       exit;',
'   end loop;',
'   return nvl(l_next_sgid,:SGID);',
'end;'))
,p_compute_when=>'PREVIOUS'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19034431362034300)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(19471711351438457)
,p_internal_uid=>19034431362034300
);
end;
/
prompt --application/pages/page_00015
begin
wwv_flow_imp_page.create_page(
 p_id=>15
,p_name=>'Page Views by Browser'
,p_alias=>'PAGE-VIEWS-BY-BROWSER'
,p_step_title=>'Page Views by Browser'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_inline_css=>'td[headers=GRAPH] {min-width: 150px;}'
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2597607668687988)
,p_name=>'Page Views by Browser'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_count as',
'(',
'select /* APEX 4050P15a */ count(*) a ',
'from   wwv_flow_activity_log ',
'where  security_group_id = :flow_security_group_id and ',
'       time_stamp >= sysdate - nvl(:P15_TIME,1) and',
'       user_agent is not null',
') ',
'select os, page_views , 100*page_views/total_count.a pct, round(100*page_views/total_count.a) graph',
'from (',
'select ',
' x.os, ',
' sum(x.c) page_views',
'from',
'(',
'select session_id, ',
'       case ',
'       when user_agent is null then ''No User Agent''',
'       when instr(user_agent,''Chrome/'') > 0 then ''Chrome''',
'       when instr(user_agent,''Edge/'') > 0 then ''Edge''',
'       when instr(user_agent,''Safari/'') > 0 then ''Safari''',
'       when instr(user_agent,''Opera/'') > 0 then ''Opera''',
'       when instr(user_agent,''Firefox/'') > 0 then ''Firefox''',
'       when instr(user_agent,''AppleWebKit/'') > 0 then ''AppleWebKit''',
'       when instr(user_agent,''Mozilla/'') > 0 then ''Mozilla''',
'       when instr(user_agent,''Trident/'') > 0 then ''Trident''',
'       else ''Unkonwn'' end os,',
'       count(*) c',
'from wwv_flow_activity_log',
'where security_group_id = :flow_security_group_id',
'       and time_stamp >= sysdate - nvl(:P15_TIME,1)',
'       and user_agent is not null',
'group by session_id,',
'case ',
'       when user_agent is null then ''No User Agent''',
'       when instr(user_agent,''Chrome/'') > 0 then ''Chrome''',
'       when instr(user_agent,''Edge/'') > 0 then ''Edge''',
'       when instr(user_agent,''Safari/'') > 0 then ''Safari''',
'       when instr(user_agent,''Opera/'') > 0 then ''Opera''',
'       when instr(user_agent,''Firefox/'') > 0 then ''Firefox''',
'       when instr(user_agent,''AppleWebKit/'') > 0 then ''AppleWebKit''',
'       when instr(user_agent,''Mozilla/'') > 0 then ''Mozilla''',
'       when instr(user_agent,''Trident/'') > 0 then ''Trident''',
'       else ''Unkonwn'' end',
') x',
'group by os) d, total_count'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No Page Views found.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'Y'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Print'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'&PRODUCT_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2597921064687990)
,p_query_column_id=>1
,p_column_alias=>'OS'
,p_column_display_sequence=>1
,p_column_heading=>'Browser'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2598028849688000)
,p_query_column_id=>2
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>2
,p_column_heading=>'Page Views'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'25'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3207811487858971)
,p_query_column_id=>3
,p_column_alias=>'PCT'
,p_column_display_sequence=>3
,p_column_heading=>'Percentage'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'25'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3207921931858972)
,p_query_column_id=>4
,p_column_alias=>'GRAPH'
,p_column_display_sequence=>4
,p_column_heading=>'Graph'
,p_use_as_row_header=>'N'
,p_column_format=>'PCT_GRAPH:#cccccc:#777777:'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(108279024884861232)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3210024085872083)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(108279024884861232)
,p_button_name=>'P15_GO'
,p_button_static_id=>'P15_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200369623299026784)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(108279024884861232)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:15,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3208727763863613)
,p_name=>'P15_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(108279024884861232)
,p_item_default=>'1'
,p_prompt=>'Include'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_imp_page.create_page(
 p_id=>16
,p_name=>'Feature Configuration'
,p_alias=>'FEATURE-CONFIGURATION'
,p_step_title=>'Feature Configuration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766702444596508)
,p_step_template=>wwv_flow_imp.id(704456563630760825)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_config_feature.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1220877187620120)
,p_plug_name=>'Team Development'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169304800930079016)
,p_plug_name=>'Application Development'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169306214436082917)
,p_plug_name=>'SQL Workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169312431105116196)
,p_plug_name=>'Monitoring'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169386325798256586)
,p_plug_name=>'Feature Configuration'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(521637608266366438)
,p_plug_name=>'REST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617449525355766463)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Manage settings that apply to the entire &PRODUCT_NAME. instance.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(907405108418643658)
,p_plug_name=>'Anchor'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(195775112470763477)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(908012317600684138)
,p_plug_name=>'Workspace Administration'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12936728094071536)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(169386325798256586)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169388709307261209)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(169386325798256586)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168521612246937591)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1220904441620121)
,p_name=>'P16_ISSUE_FILES_YN'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1220877187620120)
,p_item_default=>'Y'
,p_prompt=>'Enable Issue File Repository'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select <strong>Yes</strong> for all new workspaces created in this instance to allow files to be uploaded into the Team Development central file repository. Select <strong>No</strong> for all new workspaces created in this instance to not allow files'
||' to be uploaded into the Team Development central file repository.',
'<br>',
'<br>',
'This setting does not affect existing workspaces.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1221084382620122)
,p_name=>'P16_ISSUE_FS_LIMIT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1220877187620120)
,p_item_default=>'15728640'
,p_prompt=>'Maximum Issue File Size (in MB)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEAM_DEV_FS_LIMIT'
,p_lov=>'.'||wwv_flow_imp.id(689538645438591983)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the maximum file size for any file uploaded into the Team Development central file repository. The default value is 15 MB.</p>',
'',
'<p>This setting does not affect existing workspaces.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13154621528187520)
,p_name=>'P16_BACKUP_LIMIT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(169304800930079016)
,p_prompt=>'Number of backups per application'
,p_source=>'return wwv_flow_backup.backup_limit();'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the maximum number of backups to keep per application. Older backups will be deleted during daily maintenance to make room for new ones.</p>',
'<p>A value of null or zero (0) will disable the automated backup feature. No more than 30 backups will be kept per application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_02=>'30'
,p_attribute_03=>'left'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14401859113070004)
,p_name=>'P16_ALLOW_SQL_DEVELOPER_WEB'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(169306214436082917)
,p_item_default=>'Y'
,p_prompt=>'Enable SQL Developer Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enable or disable SQL Developer Web menu entry in the SQL Workshop menu.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15317323587906632)
,p_name=>'P16_APP_ACTIVITY_LOGGING'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(169312431105116196)
,p_item_default=>'U'
,p_prompt=>'Application Activity Logging'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION ACTIVITY LOGGING'
,p_lov=>'.'||wwv_flow_imp.id(15203330831314824)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how application activity is logged for all applications on this instance.',
'<p>Options include:',
'<ul>',
'<li><strong>Use Application Settings (default)</strong> - Use the Logging attribute of each application to determine if activity is logged.</li>',
'<li><strong>Never</strong> - Disable activity logging for all applications in the instance.</li>',
'<li><strong>Always</strong> - Enable activity logging for all applications in the instance.</li>',
'<li><strong>Initially Disabled for New Applications</strong> - New applications will initially have activity logging disabled.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169297610580053441)
,p_name=>'P16_ALLOW_DB_MONITOR'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(169312431105116196)
,p_item_default=>'Y'
,p_prompt=>'Enable Database Monitoring'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enable or disable monitoring within the SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169297816049053446)
,p_name=>'P16_PLSQL_EDITING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(169304800930079016)
,p_item_default=>'Y'
,p_prompt=>'Allow PL/SQL Program Unit Editing'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'By default, developers can change and compile PL/SQL source code when browsing database procedures, packages, and functions in Object Browser.  To disable editing and compilation of PL/SQL program units from within the Object Browser, select <strong>'
||'No</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169298013657053447)
,p_name=>'P16_WORKSPACE_P_DEMO_OBJECT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(169304800930079016)
,p_item_default=>'Y'
,p_prompt=>'Create demonstration objects in new workspaces'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Controls the creation of demonstration database objects when creating new workspaces. To disable the creation of demonstration database objects, select <strong>No</strong>.  ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169299221292053451)
,p_name=>'P16_SQL_C_MAX_INACTIVITY'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(169306214436082917)
,p_item_default=>'60'
,p_prompt=>'SQL Commands Maximum Inactivity in minutes'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the maximum amount of time a transactional command in the SQL Command Processor waits before timing out.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169299418817053452)
,p_name=>'P16_SQL_SCRIPT_MAX_OUTPUT_SIZE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(169306214436082917)
,p_prompt=>'SQL Scripts Maximum Script Output Size in bytes'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the maximum amount of output a single SQL Script can generate.  SQL scripts are run from the SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169299604071053452)
,p_name=>'P16_WORKSPACE_MAX_OUTPUT_SIZE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(169306214436082917)
,p_prompt=>'SQL Scripts Maximum Workspace Output Size in bytes'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the maximum amount of space all scripts within a workspace may consume.  SQL Script results are the output generated when running SQL Scripts from the SQL command processor.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169299802122053454)
,p_name=>'P16_MAX_SCRIPT_SIZE'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(169306214436082917)
,p_prompt=>'SQL Scripts Maximum Script Size in bytes'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the maximum size of a SQL script used within the SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(175483619946469918)
,p_name=>'P16_ENABLE_TRANSACTIONAL_SQL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(169306214436082917)
,p_item_default=>'N'
,p_prompt=>'Enable Transactional SQL Commands'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enable Transactional SQL Commands for the entire instance.  Enabling this feature permits users of SQL Commands to issue multiple SQL commands within the same physical database transaction.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(218527933367706511)
,p_name=>'P16_DATA_LOADING_JOB_CLASS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(169306214436082917)
,p_prompt=>'Data Loading Job Class'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Identify the DBMS_SCHEDULER Job Class for SQL Workshop Data Loading jobs to run in. This allows to assign Data Loading jobs to a specific Resource Manager Consumer group. If not set, the job class <strong>SYS.DEFAULT_JOB_CLASS</strong> will be us'
||'ed. For more information on job classes, consult the Oracle Database Administrators Guide.',
'</p>',
'<p>',
'    Example. Execute with DBA privileges:',
'</p>',
'<pre>',
'-- 1. create the job class',
'--   ',
'begin ',
'    dbms_scheduler.create_job_class(',
'         job_class_name          => ''MY_LOADER_CLASS'', ',
'         resource_consumer_group => ''RES_MGR_LOW_PRIO_GROUP'', -- this assumes, that a RES_MGR_LOW_PRIO_GROUP consumer group exists',
'         comments                => ''This is a job class for SQL Workshop Data Loading jobs'' );',
'end;',
'/',
'',
'-- 2. grant EXECUTE privilege on the job class to the APEX engine user',
'--',
'grant execute on MY_LOADER_CLASS to apex_NNNNNN',
'/',
'',
'-- 3. configure the job class here or use APEX_INSTANCE_ADMIN.SET_PARAMETER',
'--',
'begin ',
'    apex_instance_admin.set_parameter( ',
'        p_parameter => ''DATA_LOADING_JOB_CLASS'', ',
'        p_value     => ''MY_LOADER_CLASS'' ); ',
'end;',
'/',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(335464077854351503)
,p_name=>'P16_DATA_LOADING_MAX_FILE_SIZE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(169306214436082917)
,p_prompt=>'Maximum File size for Data Loading in bytes'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the overall maximum file size for SQL Workshop Data Loading. Note that smaller limits exist for XML and XSLX files as well as for JSON files on 11.2 and 12.1 databases. This setting configures the overall file size limitation for all file typ'
||'es.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(337361432473658487)
,p_name=>'P16_ALLOW_TRACING'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(169312431105116196)
,p_item_default=>'Y'
,p_prompt=>'Enable Application Tracing'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enable or disable application tracing of &PRODUCT_NAME. applications.  When enabled, developers will be able to generate database trace file for the entire execution of a page event.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(521637788671366439)
,p_name=>'P16_SWAGGER_UI_URL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(521637608266366438)
,p_prompt=>'Swagger UI URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines a URL pointing to the SWAGGER UI 2.0+ server to be used by the ORDS REST Workshop when generating documentation for a module. If a URL is specified, the URI to the web service''s swagger documentation will be passed to the Swagger UI server'
||'. If a there is no URL specified, raw JSON will be produced.</p>',
'',
'<p>The Swagger UI server must be able to reach the referenced web service URI in order to generate the documentation. When using a third party Swagger UI service, review its privacy policy to understand how information it collects may be used and sha'
||'red.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(582421357301226501)
,p_name=>'P16_WEBSERVICE_LOGGING'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(169312431105116196)
,p_item_default=>'U'
,p_prompt=>'Web Service Activity Logging'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSERVICE LOGGING'
,p_lov=>'.'||wwv_flow_imp.id(582428114482274404)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how web service activity is logged for all workspaces on this instance.',
'<p>Options include:',
'<ul>',
'<li><strong>Use Workspace Settings (default)</strong> - Use the Web Service Logging attribute of each workspace to determine if activity is logged.</li>',
'<li><strong>Never</strong> - Disable web service logging for all workspaces in the instance.</li>',
'<li><strong>Always</strong> - Enable web service logging for all workspaces in the instance.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(689844200493496911)
,p_name=>'P16_TEAM_DEV_FILES_YN'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1220877187620120)
,p_item_default=>'Y'
,p_prompt=>'Enable Feedback File Repository'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select <strong>Yes</strong> for all new workspaces created in this instance to allow files to be uploaded into the Feedback file repository. Select <strong>No</strong> for all new workspaces created in this instance to not allow files to be uploaded '
||'into the Feedback file repository.',
'<br>',
'<br>',
'This setting does not affect existing workspaces.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(689845678483533445)
,p_name=>'P16_TEAM_DEV_FS_LIMIT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1220877187620120)
,p_item_default=>'15728640'
,p_prompt=>'Maximum Feedback File Size (in MB)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEAM_DEV_FS_LIMIT'
,p_lov=>'.'||wwv_flow_imp.id(689538645438591983)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the maximum file size for any file uploaded into the Feedback file repository. The default value is 15 MB.</p>',
'',
'<p>This setting does not affect existing workspaces.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(801931419084659361)
,p_name=>'P16_RESTFUL_SERVICES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(521637608266366438)
,p_item_default=>'Y'
,p_prompt=>'Enable RESTful Services'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<p>Controls the ability to create and access RESTful Services mapped to SQL and PL/SQL. RESTful Services can also be enabled or disabled for individual workspaces.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(908176812321701564)
,p_name=>'P16_SERVICE_REQUESTS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(908012317600684138)
,p_item_default=>'Y'
,p_prompt=>'Enable Service Requests'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Controls the ability for workspace administrators to make service requests from Workspace Administration.  Service Requests include the ability to request a new schema, request storage, or request termination of their workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(637919682872057)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P15_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(171947423698040938)
,p_validation_name=>'P16_SQL_C_MAX_INACTIVITY must be positive integer'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P16_SQL_C_MAX_INACTIVITY );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(169388709307261209)
,p_associated_item=>wwv_flow_imp.id(169299221292053451)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(172007922499154166)
,p_validation_name=>'P16_SQL_SCRIPT_MAX_OUTPUT_SIZE positive integer'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P16_SQL_SCRIPT_MAX_OUTPUT_SIZE );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(169388709307261209)
,p_associated_item=>wwv_flow_imp.id(169299418817053452)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(172010617436162145)
,p_validation_name=>'P16_WORKSPACE_MAX_OUTPUT_SIZE positive integer'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P16_WORKSPACE_MAX_OUTPUT_SIZE );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(169388709307261209)
,p_associated_item=>wwv_flow_imp.id(169299604071053452)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(172014314796170894)
,p_validation_name=>'P16_MAX_SCRIPT_SIZE positive integer'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P16_MAX_SCRIPT_SIZE );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(169388709307261209)
,p_associated_item=>wwv_flow_imp.id(169299802122053454)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(689846059611545544)
,p_name=>'Show/Hide Team Dev File Size Limit'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P16_TEAM_DEV_FILES_YN'
,p_condition_element=>'P16_TEAM_DEV_FILES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(689846384315545545)
,p_event_id=>wwv_flow_imp.id(689846059611545544)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P16_TEAM_DEV_FS_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(689846540959545546)
,p_event_id=>wwv_flow_imp.id(689846059611545544)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P16_TEAM_DEV_FS_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1221105941620123)
,p_name=>'Show/Hide Issue File Size'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P16_ISSUE_FILES_YN'
,p_condition_element=>'P16_ISSUE_FILES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1221256529620124)
,p_event_id=>wwv_flow_imp.id(1221105941620123)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P16_ISSUE_FS_LIMIT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1221395384620125)
,p_event_id=>wwv_flow_imp.id(1221105941620123)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P16_ISSUE_FS_LIMIT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(169602917870557035)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P16_PLSQL_EDITING := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PLSQL_EDITING'' );',
'',
':P16_WORKSPACE_P_DEMO_OBJECT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_PROVISION_DEMO_OBJECTS'' );',
'',
':P16_SQL_C_MAX_INACTIVITY := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SQL_COMMAND_MAX_INACTIVITY'' );',
'',
':P16_SQL_SCRIPT_MAX_OUTPUT_SIZE := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SQL_SCRIPT_MAX_OUTPUT_SIZE'' );',
'',
':P16_WORKSPACE_MAX_OUTPUT_SIZE := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_MAX_OUTPUT_SIZE'' );',
'',
':P16_MAX_SCRIPT_SIZE := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''MAX_SCRIPT_SIZE'' );',
'',
':P16_ALLOW_DB_MONITOR := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''ALLOW_DB_MONITOR'' );',
'',
':P16_ENABLE_TRANSACTIONAL_SQL := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''ENABLE_TRANSACTIONAL_SQL'' );',
'',
':P16_APP_ACTIVITY_LOGGING := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''APPLICATION_ACTIVITY_LOGGING'' );',
'    ',
':P16_WEBSERVICE_LOGGING := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''WEBSERVICE_LOGGING'' );',
'',
':P16_RESTFUL_SERVICES :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''RESTFUL_SERVICES_ENABLED'' );',
'',
':P16_SWAGGER_UI_URL :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''SWAGGER_UI_URL'' );',
'    ',
':P16_SERVICE_REQUESTS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''SERVICE_REQUESTS_ENABLED'' );',
'',
':P16_ALLOW_TRACING :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''TRACING_ENABLED'' );',
'',
':P16_TEAM_DEV_FILES_YN :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_TEAM_DEV_FILES_YN'' );',
'',
':P16_TEAM_DEV_FS_LIMIT :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_TEAM_DEV_FS_LIMIT'' );',
'    ',
'    ',
':P16_DATA_LOADING_JOB_CLASS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DATA_LOADING_JOB_CLASS'' );',
'',
':P16_DATA_LOADING_MAX_FILE_SIZE :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DATA_LOADING_MAX_FILE_SIZE'' );',
'    ',
':P16_ISSUE_FILES_YN :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_ISSUE_FILES_YN'' );',
'',
':P16_ISSUE_FS_LIMIT :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_ISSUE_FS_LIMIT'' );',
'',
':P16_ALLOW_SQL_DEVELOPER_WEB :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''ALLOW_SQL_DEVELOPER_WEB'' );',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>169602917870557035
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1222261495620134)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Remove Spaces from File Types'
,p_process_sql_clob=>':P16_ISSUE_ALLOWED_FILE_TYPES := trim(BOTH '':'' FROM replace(:P16_ISSUE_ALLOWED_FILE_TYPES,'' '',''''));'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1222261495620134
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(169524720875349790)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- See if the preference value for activity logging has changed, and if so, then update the logging attribute of all non-internal applications in the instance',
'--',
'if nvl(wwv_flow_platform.get_preference( p_preference_name => ''APPLICATION_ACTIVITY_LOGGING'' ),''X'') <> nvl(:P16_APP_ACTIVITY_LOGGING,''Y'') then',
'    update wwv_flows',
'       set webdb_logging = decode(:P16_APP_ACTIVITY_LOGGING,''A'',''YES'',''N'',''NO'',webdb_logging)',
'     where security_group_id not in (10,11);',
'end if;',
'',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''PLSQL_EDITING'',',
'                                  p_preference_value => :P16_PLSQL_EDITING );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_PROVISION_DEMO_OBJECTS'',',
'                                  p_preference_value => :P16_WORKSPACE_P_DEMO_OBJECT );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''SQL_COMMAND_MAX_INACTIVITY'',',
'                                  p_preference_value => :P16_SQL_C_MAX_INACTIVITY );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''SQL_SCRIPT_MAX_OUTPUT_SIZE'',',
'                                  p_preference_value => :P16_SQL_SCRIPT_MAX_OUTPUT_SIZE );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_MAX_OUTPUT_SIZE'',',
'                                  p_preference_value => :P16_WORKSPACE_MAX_OUTPUT_SIZE );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_SCRIPT_SIZE'',',
'                                  p_preference_value => :P16_MAX_SCRIPT_SIZE );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_DB_MONITOR'',',
'                                  p_preference_value => :P16_ALLOW_DB_MONITOR );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''ENABLE_TRANSACTIONAL_SQL'',',
'                                  p_preference_value => :P16_ENABLE_TRANSACTIONAL_SQL );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''APPLICATION_ACTIVITY_LOGGING'',',
'                                  p_preference_value => :P16_APP_ACTIVITY_LOGGING );',
'if :P16_WEBSERVICE_LOGGING is not null then                                  ',
'wwv_flow_platform.set_preference( p_preference_name => ''WEBSERVICE_LOGGING'',',
'                                  p_preference_value => :P16_WEBSERVICE_LOGGING );',
'end if;',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''RESTFUL_SERVICES_ENABLED'',',
'                                  p_preference_value => :P16_RESTFUL_SERVICES );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''SWAGGER_UI_URL'',',
'                                  p_preference_value => :P16_SWAGGER_UI_URL );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''SERVICE_REQUESTS_ENABLED'',',
'                                  p_preference_value => :P16_SERVICE_REQUESTS );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''TRACING_ENABLED'',',
'                                  p_preference_value => :P16_ALLOW_TRACING );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_TEAM_DEV_FILES_YN'',',
'                                  p_preference_value => :P16_TEAM_DEV_FILES_YN );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_TEAM_DEV_FS_LIMIT'',',
'                                  p_preference_value => :P16_TEAM_DEV_FS_LIMIT );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''DATA_LOADING_JOB_CLASS'',',
'                                  p_preference_value => :P16_DATA_LOADING_JOB_CLASS );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''DATA_LOADING_MAX_FILE_SIZE'',',
'                                  p_preference_value => :P16_DATA_LOADING_MAX_FILE_SIZE );',
'                                  ',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_ISSUE_FILES_YN'',',
'                                  p_preference_value => :P16_ISSUE_FILES_YN );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_ISSUE_FS_LIMIT'',',
'                                  p_preference_value => :P16_ISSUE_FS_LIMIT );',
'                                  ',
'wwv_flow_instance_admin.set_parameter( p_parameter => ''MAX_APPLICATION_BACKUPS'',',
'                                       p_value => :P16_BACKUP_LIMIT );                                 ',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_SQL_DEVELOPER_WEB'',',
'                                  p_preference_value => :P16_ALLOW_SQL_DEVELOPER_WEB );',
'commit;',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save Feature Configuration settings.'
,p_process_when_button_id=>wwv_flow_imp.id(169388709307261209)
,p_process_success_message=>'Feature Configuration settings saved.'
,p_internal_uid=>169524720875349790
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35198113704069357)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'16'
,p_internal_uid=>35198113704069357
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_imp_page.create_page(
 p_id=>17
,p_name=>'Create/Edit Site-Specific Resources'
,p_alias=>'CREATE-EDIT-SITE-SPECIFIC-RESOURCES'
,p_step_title=>'Create/Edit Site-Specific Resources'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216789322970659213)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_env_sec.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(951627136736335)
,p_plug_name=>'Site-Specific Resources'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 04-MAR-2001 19:43:24'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(952029128736337)
,p_plug_name=>'Site-Specific Resources'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Specify resources that appear on the Workspace Login page and the Workspace Home page.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168832320396520620)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>5
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(952714907736406)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(168832320396520620)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(953528940736408)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168832320396520620)
,p_button_name=>'Delete'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_button_condition=>'P17_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(952400766736345)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168832320396520620)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P17_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(953110060736407)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(168832320396520620)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P17_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(75294331022650118)
,p_branch_action=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:17::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(75293614053645275)
,p_branch_action=>'f?p=&FLOW_ID.:18:&SESSION.::&DEBUG.:17::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(952714907736406)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(953917950736415)
,p_name=>'P17_TASK_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(951627136736335)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'TASK_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter text to be displayed with the link target.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(954517336736480)
,p_name=>'P17_TASK_LINK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(951627136736335)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Link'
,p_source=>'TASK_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the link target for this resource. For example:',
'<pre>https://www.oracle.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(955210485736485)
,p_name=>'P17_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(951627136736335)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75234509655426344)
,p_name=>'P17_DISPLAY_SEQUENCE'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(951627136736335)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>'Display Sequence'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the relative order that the links appear within the list of resources.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75236031126432516)
,p_name=>'P17_DISPLAYED'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(951627136736335)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Displayed'
,p_source=>'DISPLAYED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determines whether this resource is displayed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75239916843447392)
,p_name=>'P17_DISPLAY_LOCATION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(951627136736335)
,p_use_cache_before_default=>'NO'
,p_item_default=>'WORKSPACE_HOME'
,p_prompt=>'Display Location'
,p_source=>'DISPLAY_LOCATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TASK_DISPLAY_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(75242612126455451)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the location this resource should appear on. Options include:',
'<ul>',
'<li>Workspace Home page</li>',
'<li>Workspace Login page</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(956110817736502)
,p_validation_name=>'value is required'
,p_validation_sequence=>20
,p_validation=>'P17_TASK_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Text must be specified.'
,p_validation_condition=>'Create,ApplyChanges'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(953917950736415)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(152718005693876831)
,p_validation_name=>'name not whitespace'
,p_validation_sequence=>30
,p_validation=>'replace(:P17_TASK_NAME,'' '',null) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Link name may not be all whitespace'
,p_validation_condition=>'ApplyChanges,Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(953917950736415)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(202090127032390388)
,p_validation_name=>'display sequence must be numeric'
,p_validation_sequence=>40
,p_validation=>'P17_DISPLAY_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_validation_condition=>'Create, ApplyChanges'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(75234509655426344)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(956523719736519)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CUSTOMIZED_TASKS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CUSTOMIZED_TASKS'
,p_attribute_03=>'P17_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>956523719736519
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(152749516531012440)
,p_process_sequence=>11
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set ID'
,p_process_sql_clob=>':P17_ID := wwv_flow_id.next_val;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P17_ID'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>152749516531012440
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(956903422736535)
,p_process_sequence=>21
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CUSTOMIZED_TASKS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CUSTOMIZED_TASKS'
,p_attribute_03=>'P17_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row of table WWV_FLOW_CUSTOMIZED_TASKS.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>956903422736535
);
end;
/
prompt --application/pages/page_00018
begin
wwv_flow_imp_page.create_page(
 p_id=>18
,p_name=>'Site-Specific Resources'
,p_alias=>'SITE-SPECIFIC-RESOURCES'
,p_step_title=>'Site-Specific Resources'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_env_sec.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(960020599743353)
,p_plug_name=>'Site-Specific Resources'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'These links display on the Workspace Home page and on the Workspace Login page as lists of site-specific resources.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(964406793756833)
,p_name=>'Site-Specific Resources'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'   display_sequence, ',
'   task_name, ',
'   task_link, ',
'   decode(',
'      display_location,',
'     ''WORKSPACE_HOME'',',
'      wwv_flow_lang.system_message(''F4050.WORKSPACE_HOME''),',
'     ''WORKSPACE_LOGIN'',',
'     wwv_flow_lang.system_message(''F4050.WORKSPACE_LOGIN'')',
'     ) display_location, ',
'   decode(',
'     displayed,',
'     ''Y'',',
'     wwv_flow_lang.system_message(''F4000.YES''),',
'     wwv_flow_lang.system_message(''F4000.NO'')',
'     ) displayed',
'from wwv_flow_customized_tasks'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No tasks found'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(75164114382143826)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(965130942757270)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>11
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>2
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(964932084757269)
,p_query_column_id=>3
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:P17_ID:#ID#'
,p_column_linktext=>'#TASK_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(965011042757269)
,p_query_column_id=>4
,p_column_alias=>'TASK_LINK'
,p_column_display_sequence=>41
,p_column_heading=>'Link'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(965232430757270)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_LOCATION'
,p_column_display_sequence=>31
,p_column_heading=>'Displayed On Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(965320533757270)
,p_query_column_id=>6
,p_column_alias=>'DISPLAYED'
,p_column_display_sequence=>51
,p_column_heading=>'Display'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200723903023857946)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(961500556743430)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200723903023857946)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(961902894743435)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200723903023857946)
,p_button_name=>'CREATE_ROW'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(962710881743501)
,p_branch_action=>'17'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>1
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_ROW'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(963118584743503)
,p_branch_action=>'5'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(962412919743490)
,p_computation_sequence=>1
,p_computation_item=>'P17_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_imp_page.create_page(
 p_id=>19
,p_name=>'Manage Developer Activity Log'
,p_alias=>'MANAGE-DEVELOPER-ACTIVITY-LOG'
,p_step_title=>'Manage Developer Activity Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19799503430565082)
,p_plug_name=>'Developer Activity Log Entries'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_dev number := 0;',
'begin',
'    select count(*)',
'      into c_dev',
'      from wwv_flow_builder_audit_trail;',
'',
'    return ''<p>'' ',
'           || wwv_flow_lang_dev.builder_message(''4050_19_LOG_ENTRIES'') || '': ''',
'           || to_char(c_dev, ''999,999,999,990'')',
'           || ''</p>'';',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982230745511899631)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(582425076905226538)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(982230745511899631)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Save Retention Setting'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19803315335578026)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(982230745511899631)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Entries'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19847614137691252)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(982230745511899631)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(19803703152578047)
,p_branch_action=>'19'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(19803315335578026)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19801228364572352)
,p_name=>'P19_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(19799503430565082)
,p_prompt=>'Delete entries this number of days and older:'
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_imp.id(87720511660244788)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Delete entries in the activity log that are older than the identified number of days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(582424812492226536)
,p_name=>'P19_AUDIT_LOG_RETENTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(19799503430565082)
,p_prompt=>'Developer Log Retention Days'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the number of days to retain developer log entries. Entries older than this setting will be deleted during daily maintenance.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19880014493766985)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>'delete from WWV_FLOW_BUILDER_AUDIT_TRAIL where AUDIT_DATE < (sysdate - nvl(:p19_time,31))'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting developer activity log.'
,p_process_when_button_id=>wwv_flow_imp.id(19803315335578026)
,p_process_success_message=>'Developer activity log deleted.'
,p_internal_uid=>19880014493766985
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(582425141822226539)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''AUDIT_LOG_RETENTION'',',
'    p_preference_value => :P19_AUDIT_LOG_RETENTION );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(582425076905226538)
,p_internal_uid=>582425141822226539
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(582424972443226537)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch value from platform_prefs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P19_AUDIT_LOG_RETENTION := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''AUDIT_LOG_RETENTION'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>582424972443226537
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_imp_page.create_page(
 p_id=>20
,p_name=>'Edit Schema to Workspace Assignment'
,p_alias=>'P20'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Schema to Workspace Assignment'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098050798687927)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'250'
,p_dialog_width=>'450'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(680521474522216)
,p_plug_name=>'Workspace Schema Assignment'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 10-MAR-2001 10:51:46'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982230881241899632)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(681012794522218)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(982230881241899632)
,p_button_name=>'Delete'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_condition=>':F4050_P20_ID is not null and :P20_IS_FIRST_SCHEMA = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(681208267522219)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(982230881241899632)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P20_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_comment=>':F4050_P20_ID is not null and :P20_IS_FIRST_SCHEMA = ''N'''
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(681404738522220)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(982230881241899632)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P20_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(680801594522218)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(982230881241899632)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(680228915522216)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(274506709117217135)
,p_branch_action=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.::P78_PROVISIONING_COMPANY_ID:&F4050_P20_SECURITY_GROUP_ID.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4050_P20_SECURITY_GROUP_ID'
,p_branch_condition_text=>'10'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681626422522223)
,p_name=>'F4050_P20_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(680521474522216)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681827271522225)
,p_name=>'F4050_P20_SECURITY_GROUP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(680521474522216)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_DEVELOPER_WORKSPACES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id not in (0,10,11, 12)',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(682001271522225)
,p_name=>'F4050_P20_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(680521474522216)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Database Schema'
,p_source=>'SCHEMA'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d,',
'       username r',
'  from wwv_flow_admin_all_schemas s,',
'       ( select short_name',
'           from wwv_flow_companies',
'          where provisioning_company_id = :F4050_P20_SECURITY_GROUP_ID ) ws',
' where (   restricted_to_workspace is null',
'        or restricted_to_workspace = ws.short_name)',
' order by 1'))
,p_lov_cascade_parent_items=>'F4050_P20_SECURITY_GROUP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify corresponding schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12950002945536473)
,p_name=>'P20_PREVIOUS_SCHEMA'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(680521474522216)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(135418406612396046)
,p_name=>'P20_IS_FIRST_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(680521474522216)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(12950302646564854)
,p_computation_sequence=>10
,p_computation_item=>'P20_PREVIOUS_SCHEMA'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'     l_schema varchar2(4000);',
'begin',
'     for c1 in (select schema from wwv_flow_company_schemas where security_group_id = :F4050_P20_SECURITY_GROUP_ID and id = :F4050_P20_ID) loop',
'         l_schema := c1.schema;',
'     end loop;',
'    return l_schema;',
'end;  '))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(135422609644415804)
,p_computation_sequence=>10
,p_computation_item=>'P20_IS_FIRST_SCHEMA'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select a.schema, b.first_schema_provisioned',
'             from wwv_flow_company_schemas a, wwv_flow_companies b',
'            where a.security_group_id = b.provisioning_company_id',
'              and a.id = :F4050_P20_ID ) loop',
'  if c1.schema = c1.first_schema_provisioned then',
'    return ''Y'';',
'  else ',
'    return ''N'';',
'  end if;',
'  exit;',
'end loop;'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(206354662431953019)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(680801594522218)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(206354732706953020)
,p_event_id=>wwv_flow_imp.id(206354662431953019)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(682212029522226)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_COMPANY_SCHEMAS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANY_SCHEMAS'
,p_attribute_03=>'F4050_P20_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>682212029522226
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(274482203755203147)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_provisioning.reserved_schema(p_schema => :F4050_P20_SCHEMA)',
' or ',
'  (wwv_flow_provisioning.site_admin_is_restricted and ',
'   wwv_flow_provisioning.restricted_schema(',
'     p_schema =>  :F4050_P20_SCHEMA, ',
'     p_workspace_name => wwv_flow_security.find_company_name(:F4050_P20_SECURITY_GROUP_ID))) then',
'  :F4050_P20_SCHEMA := ''INVALID'';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>274482203755203147
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(682401703522227)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_COMPANY_SCHEMAS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANY_SCHEMAS'
,p_attribute_03=>'F4050_P20_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>682401703522227
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12121519965351173)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Users'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4050_P20_SCHEMA <> ''INVALID'' then',
'  wwv_flow_provisioning.update_user_default_schema(',
'           p_security_group_id     => :F4050_P20_SECURITY_GROUP_ID,',
'           p_new_schema            => :F4050_P20_SCHEMA,',
'           p_old_schema            => :P20_PREVIOUS_SCHEMA);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(681208267522219)
,p_process_success_message=>'Action processed.'
,p_internal_uid=>12121519965351173
);
end;
/
prompt --application/pages/page_00021
begin
wwv_flow_imp_page.create_page(
 p_id=>21
,p_name=>'Manage Workspace to Schema Assignments'
,p_alias=>'MANAGE-WORKSPACE-TO-SCHEMA-ASSIGNMENTS'
,p_step_title=>'Manage Workspace to Schema Assignments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19713719462515413)
,p_plug_name=>'Workspace Schemas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This report lists the schemas in which a given workspace can build. When developers create new applications they must choose a "build in" schema to have their SQL "parsed as", from the list of schemas assigned to the workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472503211871482476)
,p_plug_name=>'Schemas Provisioned by Workspace'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cs.SCHEMA,',
'       c.short_name,',
'       cs.SECURITY_GROUP_ID,',
'       cs.id,',
'       case when u.username is not null then ''Y'' else ''N'' end as schema_exists,',
'       case when cs.schema = c.first_schema_provisioned then ''Y'' else ''N'' end as first_schema_provisioned',
'  from WWV_FLOW_COMPANY_SCHEMAS cs,',
'       wwv_flow_companies c,',
'       sys.all_users u',
' where cs.security_group_id = c.PROVISIONING_COMPANY_ID (+)',
'   and cs.schema = u.username (+)',
'   and cs.security_group_id not in ( 10, 11, 12 )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472503303297482477)
,p_name=>'Schemas Provisioned by Workspace'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472503608089482489)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_link=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.::F4050_P20_ID:#ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472503509106482485)
,p_db_column_name=>'SCHEMA'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(206354546530953018)
,p_db_column_name=>'SCHEMA_EXISTS'
,p_display_order=>12
,p_column_identifier=>'E'
,p_column_label=>'Schema Exists'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(279108352595806131)
,p_db_column_name=>'FIRST_SCHEMA_PROVISIONED'
,p_display_order=>22
,p_column_identifier=>'F'
,p_column_label=>'First Schema Provisioned'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472503726508482490)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>32
,p_column_identifier=>'C'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472503806891482491)
,p_db_column_name=>'ID'
,p_display_order=>42
,p_column_identifier=>'D'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472504025145482810)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1313216389536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:SCHEMA:SECURITY_GROUP_ID:'
,p_sort_column_1=>'SHORT_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'SCHEMA'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(472517919866500137)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(472503211871482476)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19713915330515414)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(472503211871482476)
,p_button_name=>'Create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Schema'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:105,106,107::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(19715800116515426)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(982230976761899633)
,p_name=>'Handle Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(472503211871482476)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(982231061401899634)
,p_event_id=>wwv_flow_imp.id(982230976761899633)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(472503211871482476)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2609888286735302)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Set Item P106_PASSWORD to null'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P106_PASSWORD'
,p_internal_uid=>2609888286735302
);
end;
/
prompt --application/pages/page_00022
begin
wwv_flow_imp_page.create_page(
 p_id=>22
,p_name=>'Manage Workspace Database Privileges'
,p_alias=>'MANAGE-WORKSPACE-DATABASE-PRIVILEGES'
,p_step_title=>'Manage Workspace Database Privileges'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_privs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168541603401017650)
,p_plug_name=>'Workspace Privileges'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P22a */',
'  cs.SCHEMA,',
'  c.short_name,',
'  cs.SECURITY_GROUP_ID,',
'  cs.id, p.privilege, p.admin_option',
'from ',
'  WWV_FLOW_COMPANY_SCHEMAS cs, ',
'  wwv_flow_companies c, ',
'  sys.dba_sys_privs p',
'where ',
'cs.schema = p.grantee and',
'(:P22_FIND is null or ',
' instr(p.privilege,upper(:P22_FIND)) > 0 or',
' instr(upper(cs.schema),upper(:P22_FIND)) > 0 or',
' instr(upper(c.short_name),upper(:P22_FIND)) > 0)  and',
'cs.security_group_id = c.PROVISIONING_COMPANY_ID(+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(168541709855017650)
,p_name=>'Workspace Privileges'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168542020537017667)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_link=>'f?p=4050:14:&SESSION.:REPORT:NO:14:SGID:#SECURITY_GROUP_ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168541906509017665)
,p_db_column_name=>'SCHEMA'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168542124780017668)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Security Group ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168542210066017668)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168542300521017669)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Privilege'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168542430129017669)
,p_db_column_name=>'ADMIN_OPTION'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Administration Option'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(110344620122166929)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(168542800612019384)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1313320341536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:SCHEMA:SECURITY_GROUP_ID:ID:PRIVILEGE:ADMIN_OPTION'
,p_sort_column_1=>'SHORT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(982231175324899635)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168541603401017650)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:RP,RIR,22:::'
);
end;
/
prompt --application/pages/page_00023
begin
wwv_flow_imp_page.create_page(
 p_id=>23
,p_name=>'Create / Edit User'
,p_alias=>'CREATE-EDIT-USER'
,p_step_title=>'Create / Edit User'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216787602191653217)
,p_step_template=>wwv_flow_imp.id(704456563630760825)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_users.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4789806742494505)
,p_plug_name=>'Account Privileges'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(43032554506866236)
,p_plug_name=>'User Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings=>'UserID:Security<br>GroupID:<font color=green>Company</font>:Web<br>Password'
,p_plug_query_num_rows=>15
,p_plug_query_no_data_found=>'No cookie based users have been defined.  Click the add icon to create a new user.'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 16-MAR-2001 11:21:01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61303115419117985)
,p_plug_name=>'&F4050_PASSWORD_REGION_TITLE.'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(161703707200871657)
,p_plug_name=>'Links'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(182517420179163788)
,p_plug_name=>'Create / Edit User'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(190667230101179100)
,p_plug_name=>'User Groups'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings=>'&nbsp;:Flow:User:Developer Role(s)'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_fnd boolean default false;',
'begin',
'for c1 in (',
'select 1',
'from wwv_flow_fnd_user_groups_noapp',
'where security_group_id = :F4050_P23_SECURITY_GROUP_ID ) loop',
'  l_fnd := true;',
'end loop;',
'return l_fnd;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(254117224240978570)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(195775112470763477)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(504825819331106161)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Administrators of the &PRODUCT_NAME. service can manage user accounts for any workspace.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(43032820185866237)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(182517420179163788)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:23::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(43033071157866237)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(182517420179163788)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete User'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>':F4050_P23_USER_ID is not null and :F4050_P23_USER_ID != wwv_flow_user_api.get_user_id(:FLOW_USER)'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(43033257856866238)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(182517420179163788)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P23_USER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(39279805171990401)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(182517420179163788)
,p_button_name=>'CREATE_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P23_USER_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(43033414946866238)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(182517420179163788)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create User'
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P23_USER_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(43031812037866231)
,p_branch_name=>'Go To Page 12'
,p_branch_action=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:23::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(39280113672990404)
,p_branch_name=>'Go To Page 23'
,p_branch_action=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:23,EDIT_USER_PRIVS:F4050_P23_SECURITY_GROUP_ID:&F4050_P23_SECURITY_GROUP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(39279805171990401)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(43032215890866234)
,p_branch_name=>'Go To Page 12'
,p_branch_action=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:23::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2691628386326712)
,p_name=>'F4050_P23_DEFAULT_SCHEMA'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_prompt=>'Default Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select schema d, schema r',
' from wwv_flow_company_schemas',
'where security_group_id = :F4050_P23_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_lov_cascade_parent_items=>'F4050_P23_SECURITY_GROUP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The default schema for this user.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12480015129149970)
,p_name=>'P23_ACCOUNT_EXPIRY'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12480931059154603)
,p_name=>'P23_ACCOUNT_LOCKED'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_item_default=>'N'
,p_prompt=>'Account Availability'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ACCOUNT_LOCK_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(12506800188785204)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Available options:',
'<ul>',
'<li>Select <strong>Locked</strong> to prevent the account from being used.</li> ',
'<li>Select <strong>Unlocked</strong> to enable the account to be used.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12481506257156915)
,p_name=>'P23_FAILED_ACCESS_ATTEMPTS'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(61303115419117985)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12482115260159568)
,p_name=>'P23_CHANGE_PWD_ON_FIRST_USE'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(61303115419117985)
,p_item_default=>'''Y'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Require Change of Password on First Use'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select <strong>Yes</strong> to require the user to change the password immediately after logging in with the current, temporary password. ',
'<p>This rule applies to the use of this account for developers and Workspace administrators. It also applies to all users who use this account when logging in to developed applications.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12482722533161601)
,p_name=>'P23_FIRST_PWD_USE_OCCURRED'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(61303115419117985)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12496823435353552)
,p_name=>'P23_SHOW_EXPIRE_FLAG'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(61303115419117985)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12498809783385770)
,p_name=>'P23_EXPIRATION_STATUS1'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(61303115419117985)
,p_prompt=>'Developer/Administrator Password:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>':F4050_P23_USER_ID is not null and :P23_EXPIRATION_STATUS1 <> ''NA'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates whether password is expired or valid for Developer or Administrator login.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12499022628385770)
,p_name=>'P23_EXPIRATION_STATUS2'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(61303115419117985)
,p_prompt=>'End User Password:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>':F4050_P23_USER_ID is not null and :P23_EXPIRATION_STATUS2 <> ''NA'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates whether password is expired or valid for End User login.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12501217642408601)
,p_name=>'P23_EXPIRE'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(61303115419117985)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expire Password'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'select null d, ''Y'' r from sys.dual'
,p_display_when=>':P23_SHOW_EXPIRE_FLAG = ''Y'' and :F4050_P23_USER_ID is not null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Check to expire the user''s password.  This affects both their developer/administrator login and access as an end user.  If expired, the next time this account is accessed, the user will be required to provide their old password along with a new passw'
||'ord in order to login.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43033620636866241)
,p_name=>'F4050_P23_USER_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(43032554506866236)
,p_prompt=>'User ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43033813964866242)
,p_name=>'F4050_P23_USER_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(43032554506866236)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the user name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43034067641866243)
,p_name=>'F4050_P23_FIRST_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(43032554506866236)
,p_prompt=>'First Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the user''s first name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43034227119866244)
,p_name=>'F4050_P23_LAST_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(43032554506866236)
,p_prompt=>'Last Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the user''s last name.',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43035819093866248)
,p_name=>'F4050_P23_DESCRIPTION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(43032554506866236)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>200
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter an optional description for this user.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43037241672866252)
,p_name=>'F4050_P23_EMAIL_ADDRESS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(43032554506866236)
,p_prompt=>'Email Address'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>240
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the user''s e-mail address.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43037870063866254)
,p_name=>'F4050_P23_WEB_PASSWORD'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(61303115419117985)
,p_prompt=>'Password'
,p_post_element_text=>' <span class="instructiontext">Passwords are case sensitive</span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the password (do not enter unless you are creating a new account with a password or you are updating the password for an existing account).'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43042986599987259)
,p_name=>'F4050_P23_SECURITY_GROUP_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_read_only_when=>':F4050_P23_USER_ID is not null'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Choose a workspace for the user from the popup list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(157994413889601615)
,p_name=>'P23_DEVELOPER'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_item_default=>'Y'
,p_prompt=>'User is a developer:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_tag_attributes=>'onClick="javascript:if (document.forms[0].P23_ADMIN_0.checked) document.forms[0].P23_DEVELOPER_0.checked = true;"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify if this user should have developer privileges. Developers must have access to either the App Builder, the SQL Workshop, or both.',
'',
'Components may not be available if they are switched off by Instance Administrators.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(157996406317627808)
,p_name=>'P23_ADMIN'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_item_default=>'Y'
,p_prompt=>'User is an administrator:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onClick="javascript:if (document.forms[0].P23_ADMIN_0.checked) document.forms[0].P23_DEVELOPER_0.checked = true;"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify if this user should have workspace administrator privileges. Administrators are given access to all components. Additionally, they can also manage user accounts, groups, and development services.',
'',
'Components may not be available if they are switched off by Instance Administrators.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(182810818563091386)
,p_name=>'F4050_P23_DEV_PRIVS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_prompt=>'Developer Privileges (Click only ADMIN to receive all privileges)'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190665205313175398)
,p_name=>'F4050_P23_GROUPS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(190667230101179100)
,p_prompt=>'Groups'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'USER.GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r',
'from wwv_flow_fnd_user_groups_noapp',
'where security_group_id = :F4050_P23_SECURITY_GROUP_ID order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>8
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify which groups the user belongs to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(240387620119665972)
,p_name=>'F4050_P23_CONFIRM_PASSWD'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(61303115419117985)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Confirm Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the password again to confirm (do not enter unless you are creating a new account with a password or you are updating the password for an existing account).'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(351317726029487696)
,p_name=>'P23_ALLOW_ACCESS_SCHEMAS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_prompt=>'Accessible Schemas (null for all)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_read_only_when=>'F4050_P23_SECURITY_GROUP_ID'
,p_read_only_when2=>'10'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a colon-delimited list of schemas for which this developer has permissions when using the SQL Workshop. The list of schemas you enter here restricts the user to a subset of the full set of schemas provisioned for the workspace and determines wh'
||'at schema names the user sees in SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(367577404458914012)
,p_name=>'P23_DEFAULT_DATE_FORMAT'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(43032554506866236)
,p_prompt=>'Default Date Format'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATE_FORMAT_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the default Oracle date format for the user.  This will control the default date format within SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499671720750978400)
,p_name=>'P23_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_item_default=>'Y'
,p_prompt=>'App Builder Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where (provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and    NVL(allow_app_building_yn,''Y'') = ''Y'')',
'or :F4050_P23_SECURITY_GROUP_ID IS NULL'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to the App Builder.<br>',
'<br>',
'An Administrator will always have access to the App Builder.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when App Builder Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499672130451978402)
,p_name=>'P23_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_item_default=>'Y'
,p_prompt=>'SQL Workshop Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where (provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and    NVL(allow_sql_workshop_yn,''Y'') = ''Y'')',
'or :F4050_P23_SECURITY_GROUP_ID IS NULL'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to SQL Workshop.<br>',
'<br>',
'An Administrator will always have access to SQL Workshop.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when SQL Workshop Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499672303492978402)
,p_name=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_item_default=>'Y'
,p_prompt=>'Team Development Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where (provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and    NVL(allow_team_development_yn,''Y'') = ''Y'')',
'or :F4050_P23_SECURITY_GROUP_ID IS NULL'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a user has access to Team Development.<br>',
'<br>',
'An Administrator will always have access to Team Development.<br>',
'<br>',
'This attribute is always disabled when Team Development Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499944115009587837)
,p_name=>'P23_DISALLOW_APP_BUILDING'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'App Builder Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and   NVL(allow_app_building_yn,''Y'') = ''N'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to the App Builder.<br>',
'<br>',
'An Administrator will always have access to the App Builder.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when App Builder Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499945108907595575)
,p_name=>'P23_DISALLOW_SQL_WORKSHOP'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'SQL Workshop Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and   NVL(allow_sql_workshop_yn,''Y'') = ''N'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to SQL Workshop.<br>',
'<br>',
'An Administrator will always have access to SQL Workshop.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when SQL Workshop Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499945618950598529)
,p_name=>'P23_DISALLOW_TEAM_DEVELOPMENT'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(4789806742494505)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Team Development Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and   NVL(allow_team_development_yn,''Y'') = ''N'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a user has access to Team Development.<br>',
'<br>',
'An Administrator will always have access to Team Development.<br>',
'<br>',
'This attribute is always disabled when Team Development Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(316540319552589525)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P23_DEFAULT_SCHEMA'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(:F4050_P23_DEFAULT_SCHEMA,''%''||''null%'',null)'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(240393507137700064)
,p_computation_sequence=>20
,p_computation_item=>'F4050_P23_CONFIRM_PASSWD'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'ltrim(rtrim(:F4050_P23_CONFIRM_PASSWD))'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(12554726371767163)
,p_computation_sequence=>40
,p_computation_item=>'P23_EXPIRE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P23_EXPIRE,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;'))
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(12555506070770774)
,p_computation_sequence=>50
,p_computation_item=>'P23_ACCOUNT_LOCKED'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P23_ACCOUNT_LOCKED,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(182745532211009071)
,p_validation_name=>'F4050_P23_USER_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4050_P23_USER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Username must be specified.'
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43033813964866242)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 22-FEB-2002 12:40'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(111539302381125034)
,p_validation_name=>'Invalid characters in username'
,p_validation_sequence=>20
,p_validation=>'F4050_P23_USER_NAME'
,p_validation2=>'<>'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Invalid Username.'
,p_validation_condition=>'Apply_Changes,CREATE,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(43033813964866242)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164285025826484749)
,p_validation_name=>'prevent duplicate username'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 r',
'  from wwv_flow_fnd_user',
' where user_name = upper(:F4050_P23_USER_NAME)',
'   and security_group_id = :F4050_P23_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'User Name must be unique within workspace.'
,p_validation_condition=>':REQUEST in (''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43033813964866242)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(182742403109007422)
,p_validation_name=>'F4050_P23_EMAIL_ADDRESS Not Null'
,p_validation_sequence=>40
,p_validation=>'F4050_P23_EMAIL_ADDRESS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Email Address must be specified.'
,p_validation_condition=>':REQUEST IN (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43037241672866252)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 22-FEB-2002 12:40'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(39286930629035660)
,p_validation_name=>'workspace not null'
,p_validation_sequence=>50
,p_validation=>'F4050_P23_SECURITY_GROUP_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Workspace must be specified.'
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43042986599987259)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(149174714581321552)
,p_validation_name=>'WorkspaceNumeric'
,p_validation_sequence=>60
,p_validation=>'F4050_P23_SECURITY_GROUP_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Workspace must be numeric.'
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43042986599987259)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(488453630588913316)
,p_validation_name=>'when username change, password must be set'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select user_name',
'     from wwv_flow_fnd_user',
'    where user_id = :F4050_P23_USER_ID',
'      and security_group_id = :F4050_P23_SECURITY_GROUP_ID )',
'loop',
'   if c1.user_name != :F4050_P23_USER_NAME and',
'      :F4050_P23_WEB_PASSWORD is null then',
'   return false;',
'   else return true;',
'   end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'If you update the Username, you must provide a new password.'
,p_when_button_pressed=>wwv_flow_imp.id(43033257856866238)
,p_associated_item=>wwv_flow_imp.id(43037870063866254)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(182742730875007426)
,p_validation_name=>'F4050_P23_WEB_PASSWORD Not Null'
,p_validation_sequence=>90
,p_validation=>'F4050_P23_WEB_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Password must be specified.'
,p_validation_condition=>'CREATE,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(43037870063866254)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 22-FEB-2002 12:40'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23877827234193982)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_use_strong_rules boolean;',
'begin',
'  if :F4050_P23_SECURITY_GROUP_ID = 10 and nvl(wwv_flow_platform.get_preference(''STRONG_SITE_ADMIN_PASSWORD''),''N'') = ''Y'' then',
'    l_use_strong_rules := true;',
'  else',
'    l_use_strong_rules := false;',
'  end if;',
'  ',
'  return wwv_flow_security.strong_password_validation(',
'      p_username              => :F4050_P23_USER_NAME,',
'      p_password              => :F4050_P23_WEB_PASSWORD,',
'      p_old_password          => null,',
'      p_workspace_name        => wwv_flow_security.find_company_name(:F4050_P23_SECURITY_GROUP_ID),',
'      p_use_strong_rules      => l_use_strong_rules);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :REQUEST IN (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')',
'and wwv_flow_authentication_dev.is_builder_password_required (',
'        p_developer_yn => :P23_DEVELOPER )',
'and wwv_flow_authentication_dev.get_internal_authentication <> ''DB'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43037870063866254)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384616289309738714)
,p_validation_name=>'Validate DB Password'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4050_P23_WEB_PASSWORD is null then',
'    return false;',
'else',
'    return wwv_flow_security.password_validation(',
'               p_username => upper(:F4050_P23_USER_NAME),',
'               p_password => :F4050_P23_WEB_PASSWORD );',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The password does not conform to the database password complexity policy.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:REQUEST IN (''CREATE'',''CREATE_ANOTHER'') ',
'   and :P23_DEVELOPER = ''Y'' ',
'   and wwv_flow_authentication_dev.get_internal_authentication = ''DB'')',
'or',
'(:REQUEST = ''Apply_Changes'' ',
'   and :P23_DEVELOPER = ''Y'' ',
'   and wwv_flow_authentication_dev.get_internal_authentication = ''DB''',
'   and :F4050_P23_DEV_PRIVS is null)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43037870063866254)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(240392628824696884)
,p_validation_name=>'Confirm PAssword'
,p_validation_sequence=>120
,p_validation=>':F4050_P23_WEB_PASSWORD = :F4050_P23_CONFIRM_PASSWD'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Password not properly confirmed, enter your password two times exactly the same.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST IN (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')',
'and ( :F4050_P23_WEB_PASSWORD is not null ',
'      or :F4050_P23_CONFIRM_PASSWD is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43037870063866254)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(499739807740135447)
,p_validation_name=>'Developer must have Access'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF :P23_DEVELOPER = ''Y'' THEN',
'    IF :P23_ALLOW_APP_BUILDING_YN = ''N''',
'    AND :P23_ALLOW_SQL_WORKSHOP_YN = ''N'' THEN',
'      RETURN FALSE;',
'    END IF;',
'  END IF;',
'',
'  RETURN TRUE;',
'END;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'A Developer must have access to either the App Builder, the SQL Workshop, or both.'
,p_validation_condition=>'CREATE,CREATE_ANOTHER,Apply_Changes'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(157994413889601615)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(609896630929899250)
,p_validation_name=>'non APEX auth username validate'
,p_validation_sequence=>140
,p_validation=>'return regexp_like(:F4050_P23_USER_NAME,wwv_flow_platform.get_preference(''USERNAME_VALIDATION''));'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Username does not match expression defined for the instance.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :REQUEST in (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')',
'and nvl(wwv_flow_platform.get_preference(''USERNAME_VALIDATION''),''*'') != ''*''',
'and (:P23_ADMIN = ''Y'' or :P23_DEVELOPER = ''Y'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43033813964866242)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(354473531133800559)
,p_validation_name=>'Default schema in accessible schemas'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'instr(upper(:P23_ALLOW_ACCESS_SCHEMAS),:F4050_P23_DEFAULT_SCHEMA) > 0 or',
'v(''P23_ALLOW_ACCESS_SCHEMAS'') is null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Default Schema must be within Accessible Schemas.'
,p_validation_condition=>':REQUEST in (''CREATE'',''CREATE_ANOTHER'',''Apply_Changes'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2691628386326712)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10407066342361223)
,p_validation_name=>'F4050_P23_EMAIL_ADDRESS valid pattern'
,p_validation_sequence=>160
,p_validation=>'return wwv_flow_instance_admin.is_valid_provisioning_email( p_email => :F4050_P23_EMAIL_ADDRESS );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address format. Please provide a valid email address.'
,p_validation_condition=>':REQUEST IN (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(43037241672866252)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(36064434890423301)
,p_validation_name=>'Check accessible schema names'
,p_validation_sequence=>170
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P23_ALLOW_ACCESS_SCHEMAS is null',
'    or not exists (',
'            select upper(column_value) as schema',
'              from table( wwv_flow_string.split(:P23_ALLOW_ACCESS_SCHEMAS,'':'') ) ',
'            minus',
'            select schema',
'              from  wwv_flow_company_schemas cs',
'             where cs.security_group_id = :F4050_P23_SECURITY_GROUP_ID )'))
,p_validation2=>'SQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Only schemas assigned to the workspace are allowed.'
,p_associated_item=>wwv_flow_imp.id(351317726029487696)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(480959017736120646)
,p_name=>'default schema'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P23_SECURITY_GROUP_ID'
,p_condition_element=>'F4050_P23_SECURITY_GROUP_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(480958907602115765)
,p_event_id=>wwv_flow_imp.id(480959017736120646)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P23_DEFAULT_SCHEMA'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(480959329587120647)
,p_event_id=>wwv_flow_imp.id(480959017736120646)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P23_DEFAULT_SCHEMA'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(499697614357090089)
,p_name=>'Set Admin Defaults'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_ADMIN'
,p_condition_element=>'P23_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499697929955090089)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DEVELOPER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499698127833090090)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DEVELOPER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499830900523587430)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DEVELOPER'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499921922469353484)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499735730765104258)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499698800636095529)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499922306670358385)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499922808317377807)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499813118803337317)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499809324774320148)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499922602430376131)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499709507216097424)
,p_event_id=>wwv_flow_imp.id(499697614357090089)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(499737110941117419)
,p_name=>'Set Developer Defaults'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DEVELOPER'
,p_condition_element=>'P23_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499737403632117420)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499737619358117420)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499738123062120991)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499739114535127949)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499814504735342729)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499818103182380057)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499815726206348925)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499818719458384786)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'FALSE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150598110355090725)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150598356406090727)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'FALSE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150598244537090726)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150598427398090728)
,p_event_id=>wwv_flow_imp.id(499737110941117419)
,p_event_result=>'FALSE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1318698319941939287)
,p_name=>'Set Admin Defaults - ADW'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_ADMIN'
,p_condition_element=>'P23_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1318698735426939344)
,p_event_id=>wwv_flow_imp.id(1318698319941939287)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1318699187539939369)
,p_event_id=>wwv_flow_imp.id(1318698319941939287)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504001616238039246)
,p_name=>'Disable Disallow App Building'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DISALLOW_APP_BUILDING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504001915415039251)
,p_event_id=>wwv_flow_imp.id(504001616238039246)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DISALLOW_APP_BUILDING'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1318699502648948371)
,p_name=>'Set Developer Defaults - ADW'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DEVELOPER'
,p_condition_element=>'P23_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1318699953045948371)
,p_event_id=>wwv_flow_imp.id(1318699502648948371)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1318700465969948372)
,p_event_id=>wwv_flow_imp.id(1318699502648948371)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1318700964715948372)
,p_event_id=>wwv_flow_imp.id(1318699502648948371)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1318701487141948372)
,p_event_id=>wwv_flow_imp.id(1318699502648948371)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'ITEM_IS_NULL'
,p_server_condition_expr1=>'F4050_P23_USER_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504036521572475963)
,p_name=>'Disable Disallow SQL Workshop'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DISALLOW_SQL_WORKSHOP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504036823683475964)
,p_event_id=>wwv_flow_imp.id(504036521572475963)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DISALLOW_SQL_WORKSHOP'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504037206466481072)
,p_name=>'Disable Disallow Team Development'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DISALLOW_TEAM_DEVELOPMENT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504037512684481073)
,p_event_id=>wwv_flow_imp.id(504037206466481072)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DISALLOW_TEAM_DEVELOPMENT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9870827930449349)
,p_name=>'Copy User name to Email'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P23_USER_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.triggeringElement.value.match(/@/)!=null'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9871100461449350)
,p_event_id=>wwv_flow_imp.id(9870827930449349)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P23_EMAIL_ADDRESS'
,p_attribute_01=>'$s(''F4050_P23_EMAIL_ADDRESS'',$v(''F4050_P23_USER_NAME''));'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(43038016537866257)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch user information'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_admin_api.fetch_user (     ',
'     p_user_id         => :F4050_P23_USER_ID,     ',
'     p_user_name       => :F4050_P23_USER_NAME,',
'     p_first_name      => :F4050_P23_FIRST_NAME,',
'     p_last_name       => :F4050_P23_LAST_NAME,     ',
'     p_email_address   => :F4050_P23_EMAIL_ADDRESS,     ',
'     p_groups          => :F4050_P23_GROUPS,',
'     p_developer_role  => :F4050_P23_DEV_PRIVS,',
'     p_default_schema  => :F4050_P23_DEFAULT_SCHEMA,',
'     p_description     => :F4050_P23_DESCRIPTION,',
'     p_account_expiry     => :P23_ACCOUNT_EXPIRY,',
'     p_account_locked     => :P23_ACCOUNT_LOCKED,',
'     p_failed_access_attempts     => :P23_FAILED_ACCESS_ATTEMPTS,',
'     p_change_password_on_first_use     => :P23_CHANGE_PWD_ON_FIRST_USE, ',
'     p_first_password_use_occurred     => :P23_FIRST_PWD_USE_OCCURRED,',
'     p_security_group_id => :F4050_P23_SECURITY_GROUP_ID',
'     );',
'',
'if :F4050_P23_DEV_PRIVS is null then',
'  :P23_DEVELOPER := ''N'';',
'  :P23_ADMIN := ''N'';',
'elsif instr(:F4050_P23_DEV_PRIVS,''ADMIN'') > 0 then',
'  :P23_DEVELOPER := ''Y'';',
'  :P23_ADMIN := ''Y'';',
'else',
'  :P23_DEVELOPER := ''Y'';',
'  :P23_ADMIN := ''N'';',
'end if;',
'',
'FOR c1 IN (select ALLOW_APP_BUILDING_YN',
'           ,      ALLOW_SQL_WORKSHOP_YN',
'           ,      ALLOW_TEAM_DEVELOPMENT_YN ',
'           ,      allow_access_to_schemas',
'           ,      default_date_format',
'           from wwv_flow_fnd_user',
'           where user_id = :F4050_P23_USER_ID',
'          ) LOOP',
'  :P23_ALLOW_APP_BUILDING_YN := c1.ALLOW_APP_BUILDING_YN;',
'  :P23_ALLOW_SQL_WORKSHOP_YN := c1.ALLOW_SQL_WORKSHOP_YN;',
'  :P23_ALLOW_TEAM_DEVELOPMENT_YN := c1.ALLOW_TEAM_DEVELOPMENT_YN;',
'  :P23_ALLOW_ACCESS_SCHEMAS := c1.allow_access_to_schemas;',
'  :P23_DEFAULT_DATE_FORMAT := c1.default_date_format;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_process_when=>'F4050_P23_USER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>43038016537866257
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(68692203366535952)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_site_account_lifetime number := ',
'    nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),45);',
'  l_workspace_account_lifetime number;',
'  l_account_last_updated date;',
'  l_dev_admin_expired boolean := false;',
'  l_end_user_expired boolean := false;',
'  l_found boolean := false;',
'begin',
'',
'--',
'-- account expiration notices',
'--',
'l_account_last_updated := nvl(:P23_ACCOUNT_EXPIRY, trunc(sysdate));',
'for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID) loop',
'  l_workspace_account_lifetime := c1.account_lifetime_days;',
'end loop;',
'',
':P23_SHOW_EXPIRE_FLAG := ''N'';',
'if :P23_DEVELOPER = ''Y'' then',
'  if l_account_last_updated + l_site_account_lifetime < sysdate then',
'    l_dev_admin_expired := true;',
'    :P23_EXPIRATION_STATUS1 := wwv_flow_lang.system_message(''EXPIRED'');',
'  else',
'    :P23_EXPIRATION_STATUS1 := wwv_flow_lang.system_message(''VALID'');',
'    :P23_SHOW_EXPIRE_FLAG := ''Y'';',
'  end if;',
'else',
'  :P23_EXPIRATION_STATUS1 := ''NA'';',
'end if;',
'',
'for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where EXPIRE_FND_USER_ACCOUNTS = ''Y''',
'           and provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID) loop',
'  l_found := true;',
'  if l_account_last_updated + l_workspace_account_lifetime < sysdate then',
'    l_end_user_expired := true;',
'    :P23_EXPIRATION_STATUS2 := wwv_flow_lang.system_message(''EXPIRED'');',
'  else',
'    :P23_EXPIRATION_STATUS2 := wwv_flow_lang.system_message(''VALID'');',
'    :P23_SHOW_EXPIRE_FLAG := ''Y'';',
'  end if;',
'end loop;',
'if not l_found then',
'  :P23_EXPIRATION_STATUS2 := ''NA'';',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>68692203366535952
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2600224758498701)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Set Items F4050_P23_WEB_PASSWORD, F4050_P23_CONFIRM_PASSWD to null'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4050_P23_WEB_PASSWORD,F4050_P23_CONFIRM_PASSWD'
,p_internal_uid=>2600224758498701
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(384616171979738713)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create DB user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_num number;',
'begin',
'    select count(*) into l_num from sys.dba_users where username = upper(:F4050_P23_USER_NAME);',
'    ',
'    if l_num = 0 then',
'        wwv_flow_provision.create_user(',
'            p_username    => upper(:F4050_P23_USER_NAME),',
'            p_password    => :f4050_p23_web_password);',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:REQUEST IN (''CREATE'',''CREATE_ANOTHER'') ',
'   and :P23_DEVELOPER = ''Y'' ',
'   and wwv_flow_authentication_dev.get_internal_authentication = ''DB'')',
'or',
'(:REQUEST = ''Apply_Changes'' ',
'   and :P23_DEVELOPER = ''Y'' ',
'   and wwv_flow_authentication_dev.get_internal_authentication = ''DB''',
'   and :F4050_P23_DEV_PRIVS is null)'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>384616171979738713
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(182690830061736577)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'cascade delete to developer privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_admin_api.remove_user (p_user_id => :F4050_P23_USER_ID,',
'                                p_security_group_id => :F4050_P23_SECURITY_GROUP_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting user.'
,p_process_when_button_id=>wwv_flow_imp.id(43033071157866237)
,p_process_success_message=>'User &F4050_P23_USER_NAME. deleted.'
,p_internal_uid=>182690830061736577
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(43038214859866258)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'edit user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_p1 varchar2(256) := v(''F4050_P23_WEB_PASSWORD'');',
'  l_p2 varchar2(256) := v(''F4050_P23_CONFIRM_PASSWD'');',
'  l_site_account_lifetime number :=',
'    nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),45);',
'  l_workspace_account_lifetime number;',
'  l_account_last_updated date;',
'  l_account_next_updated date;',
'  l_new_expiry date;',
'  l_developer_roles varchar2(255) := null;',
'  l_ALLOW_APP_BUILDING_YN     varchar2(1);',
'  l_ALLOW_SQL_WORKSHOP_YN  varchar2(1);',
'  l_ALLOW_TEAM_DEVELOPMENT_YN varchar2(1);',
'begin',
'    l_ALLOW_APP_BUILDING_YN     := v(''P23_ALLOW_APP_BUILDING_YN'');',
'    l_ALLOW_SQL_WORKSHOP_YN     := v(''P23_ALLOW_SQL_WORKSHOP_YN'');',
'    l_ALLOW_TEAM_DEVELOPMENT_YN := v(''P23_ALLOW_TEAM_DEVELOPMENT_YN'');',
'',
'  l_account_last_updated := nvl(:P23_ACCOUNT_EXPIRY, trunc(sysdate));',
'  for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID) loop',
'    l_workspace_account_lifetime := nvl(c1.account_lifetime_days,l_site_account_lifetime);',
'  end loop;',
'  l_account_next_updated := trunc(sysdate) -',
'    greatest(l_workspace_account_lifetime,l_site_account_lifetime);',
'  if v(''P23_EXPIRE'') = ''N'' then',
'    l_new_expiry := l_account_last_updated;',
'  else',
'    l_new_expiry := l_account_next_updated;',
'  end if;',
'',
'  wwv_flow.update_cache_with_write(''F4050_P23_WEB_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''F4050_P23_CONFIRM_PASSWD'',null);',
'',
'wwv_flow_admin_api.edit_user_and_group (',
'     p_user_id            => :F4050_P23_USER_ID,',
'     p_security_group_id  => :F4050_P23_SECURITY_GROUP_ID,',
'     p_user_name          => :F4050_P23_USER_NAME,',
'     p_first_name         => :F4050_P23_FIRST_NAME,',
'     p_last_name          => :F4050_P23_LAST_NAME,',
'     p_web_password       => l_p1,',
'     p_new_password       => l_p2,',
'     p_email_address      => :F4050_P23_EMAIL_ADDRESS,',
'     p_default_schema     => :F4050_P23_DEFAULT_SCHEMA,',
'     p_default_date_format => :P23_DEFAULT_DATE_FORMAT,',
'     p_allow_access_to_schemas => :P23_ALLOW_ACCESS_SCHEMAS,',
'     p_group_ids          => :F4050_P23_GROUPS,',
'     p_description        => :F4050_P23_DESCRIPTION,',
'     p_account_expiry     => l_new_expiry,',
'     p_account_locked     => :P23_ACCOUNT_LOCKED,',
'     p_failed_access_attempts => 0,',
'     p_change_password_on_first_use => nvl(:P23_CHANGE_PWD_ON_FIRST_USE,''N''),',
'     --',
'     p_allow_app_building_yn   => l_allow_app_building_yn,',
'     p_allow_sql_workshop_yn   => l_allow_sql_workshop_yn,',
'     p_allow_team_development_yn => l_allow_team_development_yn );',
'  --',
'  -- Developer and Admin roles',
'  --',
'  if :P23_ADMIN = ''N'' and :P23_DEVELOPER = ''N'' then',
'    delete from wwv_flow_developers where user_id = :F4050_P23_USER_ID;',
'  else',
'    -- {Trigger on WWV_FLOW_DEVELOPERS sets all developer roles for ADMINS',
'    --  irrespective of what set here providing includes ''ADMIN''}',
'    if :P23_ADMIN = ''Y'' then',
'      l_developer_roles := ''ADMIN'';',
'    end if;',
'    if v(''P23_ALLOW_APP_BUILDING_YN'') = ''Y'' then',
'      if l_developer_roles is not null then',
'        l_developer_roles := l_developer_roles||'':'';',
'      end if;',
'      l_developer_roles := l_developer_roles||''CREATE:EDIT:HELP:MONITOR'';',
'    end if;',
'    if v(''P23_ALLOW_SQL_WORKSHOP_YN'') = ''Y'' then',
'      if l_developer_roles is not null then',
'        l_developer_roles := l_developer_roles||'':'';',
'      end if;',
'      l_developer_roles := l_developer_roles||''SQL:MONITOR:DATA_LOADER'';',
'    end if;',
'    wwv_flow_admin_api.edit_developer_role(',
'             p_id => 1,',
'             p_user_id => :F4050_P23_USER_ID,',
'             p_security_group_id => :F4050_P23_SECURITY_GROUP_ID,',
'             p_user_name => :F4050_P23_USER_NAME,',
'             p_developer_roles => l_developer_roles);',
'  end if;',
'',
'commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error updating user.'
,p_process_when_button_id=>wwv_flow_imp.id(43033257856866238)
,p_process_success_message=>'User &F4050_P23_USER_NAME. updated.'
,p_internal_uid=>43038214859866258
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(190972529902954165)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_ALLOW_APP_BUILDING_YN     varchar2(1);',
'  l_ALLOW_SQL_WORKSHOP_YN     varchar2(1);',
'  l_ALLOW_TEAM_DEVELOPMENT_YN varchar2(1);',
'  l_change_password_on_first_use varchar2(1)   := ''N'';',
'begin',
'  -- ',
'  -- Set ALLOW Values as necessary',
'  --',
'  l_ALLOW_APP_BUILDING_YN     := nvl(v(''P23_ALLOW_APP_BUILDING_YN''),''N'');',
'  l_ALLOW_SQL_WORKSHOP_YN     := nvl(v(''P23_ALLOW_SQL_WORKSHOP_YN''),''N'');',
'  l_ALLOW_TEAM_DEVELOPMENT_YN := nvl(v(''P23_ALLOW_TEAM_DEVELOPMENT_YN''),''N'');',
' ',
'  IF :P23_ADMIN = ''Y'' THEN',
'    l_ALLOW_APP_BUILDING_YN     := ''Y'';',
'    l_ALLOW_SQL_WORKSHOP_YN     := ''Y'';',
'    l_ALLOW_TEAM_DEVELOPMENT_YN := ''Y'';',
'  ELSIF :P23_DEVELOPER = ''N'' THEN',
'    l_ALLOW_APP_BUILDING_YN     := ''N'';',
'    l_ALLOW_SQL_WORKSHOP_YN     := ''N'';',
'  END IF;',
'  ',
'  if :P23_CHANGE_PWD_ON_FIRST_USE = ''Y'' then',
'    l_change_password_on_first_use := ''Y'';',
'  end if;',
'',
'wwv_flow_admin_api.create_user (    ',
'    p_security_group_id            => :F4050_P23_SECURITY_GROUP_ID,',
'    p_user_name                    => :F4050_P23_USER_NAME,',
'    p_first_name                   => :F4050_P23_FIRST_NAME,',
'    p_last_name                    => :F4050_P23_LAST_NAME,',
'    p_description                  => :F4050_P23_DESCRIPTION,',
'    p_email_address                => :F4050_P23_EMAIL_ADDRESS,',
'    p_default_schema               => :F4050_P23_DEFAULT_SCHEMA,',
'    p_default_date_format          => :P23_DEFAULT_DATE_FORMAT,',
'    p_allow_access_to_schemas      => :P23_ALLOW_ACCESS_SCHEMAS,  ',
'    p_web_password                 => :F4050_P23_WEB_PASSWORD,    ',
'    p_group_ids                    => :F4050_P23_GROUPS,',
'    p_account_expiry               => :P23_ACCOUNT_EXPIRY,              ',
'    p_account_locked               => :P23_ACCOUNT_LOCKED,              ',
'    p_failed_access_attempts       => :P23_FAILED_ACCESS_ATTEMPTS,      ',
'    p_change_password_on_first_use => l_change_password_on_first_use,',
'    p_first_password_use_occurred  => :P23_FIRST_PWD_USE_OCCURRED,',
'    --',
'    p_is_admin                     => :P23_ADMIN,',
'    p_allow_app_building_yn        => l_allow_app_building_yn,',
'    p_allow_sql_workshop_yn        => l_allow_sql_workshop_yn,',
'    p_allow_team_development_yn    => l_allow_team_development_yn',
'    );',
'',
'  wwv_flow.update_cache_with_write(''F4050_P23_WEB_PASSWORD'',null);',
'',
'  commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating user.'
,p_process_when=>'CREATE,CREATE_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'User &F4050_P23_USER_NAME. created.'
,p_internal_uid=>190972529902954165
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(356667207485298761)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'always developer if admin'
,p_process_sql_clob=>':P23_DEVELOPER := ''Y'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P23_ADMIN'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_internal_uid=>356667207485298761
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(341059407111970570)
,p_process_sequence=>70
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'generate random password for SSO accounts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_random_password boolean;',
'begin',
'    --',
'    -- if external user (who does not have to enter a password)',
'    --    and password field is null',
'    --    and either',
'    --        - create / create_another pressed',
'    --        - apply_changes pressed and user name changed',
'    --',
'    -- => create random password',
'    --',
'    if wwv_flow_authentication_dev.is_builder_password_required (',
'           p_developer_yn => :P23_DEVELOPER )',
'    then',
'        l_random_password := false;',
'    elsif :F4050_P23_WEB_PASSWORD is not null then',
'        l_random_password := false;',
'    elsif wwv_flow_authentication_dev.get_internal_authentication = ''DB'' then',
'        l_random_password := false;',
'    elsif :request in (''CREATE'',''CREATE_ANOTHER'') then',
'        l_random_password := true;',
'    elsif :request = ''Apply_Changes'' then',
'        for c1 in ( select user_name',
'                      from wwv_flow_fnd_user',
'                     where user_id = :F4050_P23_USER_ID',
'                       and security_group_id = :F4050_P23_SECURITY_GROUP_ID',
'                       and user_name         <> :F4050_P23_USER_NAME )',
'        loop',
'            l_random_password := true;',
'        end loop;',
'    end if;',
'    ',
'    if l_random_password then',
'        :F4050_P23_WEB_PASSWORD   := wwv_flow_authentication_dev.create_shadow_user_password;',
'        :F4050_P23_CONFIRM_PASSWD := :F4050_P23_WEB_PASSWORD;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>341059407111970570
);
end;
/
prompt --application/pages/page_00024
begin
wwv_flow_imp_page.create_page(
 p_id=>24
,p_name=>'Login Attempts'
,p_alias=>'LOGIN-ATTEMPTS'
,p_step_title=>'Login Attempts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12733303372664460)
,p_plug_name=>'Login Attempts'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This report shows the recent logins to workspaces and applications. All logins to the &PRODUCT_NAME. service, developer logins to workspaces, and end user logins to applications that use the &PRODUCT_NAME. login API in their authentication scheme are'
||' logged.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472565327781535916)
,p_plug_name=>'login attempts'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P24a */',
'       login_name,',
'       application,',
'       owner,',
'       decode(authentication_method,''FND_ACCOUNT'',v(''PRODUCT_NAME''),',
'        ''CUSTOM'',wwv_flow_lang.system_message(''CUSTOM_AUTH_SCHEME_DESC''),',
'        ''$SITE_INTERNAL$'',wwv_flow_lang.system_message(''SERVICE_LOGIN''),',
'        ''$WORKSPACE_INTERNAL$'',wwv_flow_lang.system_message(''WORKSPACE_LOGIN''),',
'        ''DB ACCOUNT'',wwv_flow_lang.system_message(''DBACCOUNT_AUTH_SCHEME_DESC''),',
'        ''LDAP'',wwv_flow_lang.system_message(''LDAP_AUTH_SCHEME_DESC''),',
'         authentication_method) authentication_method,',
'       access_date,',
'       access_date access_time,',
'       decode(nvl(authentication_result,0),',
'            0,wwv_flow_lang.system_message(''AUTH_SUCCESS''),',
'            1,wwv_flow_lang.system_message(''AUTH_UNKNOWN_USER''),',
'            2,wwv_flow_lang.system_message(''AUTH_ACCOUNT_LOCKED''),',
'            3,wwv_flow_lang.system_message(''AUTH_ACCOUNT_EXPIRED''),',
'            4,wwv_flow_lang.system_message(''AUTH_PASSWORD_INCORRECT''),',
'            5,wwv_flow_lang.system_message(''AUTH_PASSWORD_FIRST_USE''),',
'            6,wwv_flow_lang.system_message(''AUTH_ATTEMPTS_EXCEEDED''),',
'            7,wwv_flow_lang.system_message(''AUTH_INTERNAL_ERROR''),',
'            8,wwv_flow_lang.system_message(''AUTH_UNKNOWN_WORKSPACE''),',
'            authentication_result) authentication_result,',
'       custom_status_text,',
'       wwv_flow_security.find_company_name(security_group_id) workspace',
'  from wwv_flow_user_access_log_v'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472565431030535916)
,p_name=>'login attempts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472565602555535921)
,p_db_column_name=>'LOGIN_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Login Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472565714133535923)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472565827489535924)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472565931549535925)
,p_db_column_name=>'AUTHENTICATION_METHOD'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Authentication Method'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472566027408535926)
,p_db_column_name=>'ACCESS_DATE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Access Date'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472566102099535927)
,p_db_column_name=>'ACCESS_TIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Accessed'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472566227798535928)
,p_db_column_name=>'AUTHENTICATION_RESULT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Authentication Result'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472566308258535929)
,p_db_column_name=>'CUSTOM_STATUS_TEXT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Custom Status'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472566420014535930)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472566514849536587)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1313418735536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOGIN_NAME:WORKSPACE:APPLICATION:OWNER:AUTHENTICATION_RESULT:AUTHENTICATION_METHOD:ACCESS_DATE:ACCESS_TIME:CUSTOM_STATUS_TEXT'
,p_sort_column_1=>'LOGIN_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(982231297425899636)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(472565327781535916)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:RP,RIR,24:::'
);
end;
/
prompt --application/pages/page_00025
begin
wwv_flow_imp_page.create_page(
 p_id=>25
,p_name=>'Workspace Last Used'
,p_alias=>'WORKSPACE-LAST-USED'
,p_step_title=>'Workspace Last Used'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472575120602615156)
,p_plug_name=>'Workspace Usage'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P25a */',
'    short_name,',
'    last_login,',
'    LAST_LOGIN since',
'from   WWV_FLOW_COMPANIES c ',
'where short_name <> ''Unknown''',
'  and provisioning_company_id <> 11'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472575218581615156)
,p_name=>'Workspace Usage'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472575422712615160)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472575504208615161)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Last Session Purged'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472575632503615162)
,p_db_column_name=>'SINCE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472575826633615663)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1313509945536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:LAST_LOGIN:SINCE'
,p_sort_column_1=>'SHORT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(982231305764899637)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(472575120602615156)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:RP,RIR,25:::'
);
end;
/
prompt --application/pages/page_00026
begin
wwv_flow_imp_page.create_page(
 p_id=>26
,p_name=>'Workspace Requests'
,p_alias=>'WORKSPACE-REQUESTS'
,p_step_title=>'Workspace Requests'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176750964111248)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_ser_rqst.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47544422518431589)
,p_plug_name=>'Provisioning Requests'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P26a */',
'    id,',
'    COMPANY_NAME,',
'    schema_name,',
'    lower(ADMIN_userid),',
'    ''<a href="mailto:''||wwv_flow_escape.html(admin_email)||''">''||wwv_flow_escape.html(admin_email)||''</a>'' admin_email,',
'    DATABASE_SIZE,',
'    country,',
'    usage_type,',
'    org_name,',
'    request_date,',
'    decode(project_status,',
'            ''REQUESTED'',m_requested,',
'            ''APPROVED'',m_approved,',
'            ''ACCEPTED'',m_accepted,',
'            ''DECLINED'', m_declined,',
'            ''TERMINATED'', m_terminated)',
'            project_status,',
'    decode(project_status,',
'            ''REQUESTED'',''1'',',
'            ''APPROVED'',''2'',',
'            ''ACCEPTED'',''3'',',
'            ''DECLINED'', ''4'',',
'            ''5'')',
'            status_code,',
'    decode(project_status,',
'      ''REQUESTED'',''f?p=4050:4:''||:flow_session||''::NO::PROVISION_ID:''||id,',
'      ''APPROVED'', ''f?p=4050:7:''||:flow_session||''::NO::T_PROVISION_ID:''||id,',
'      ''ACCEPTED'',''f?p=4050:7:''||:flow_session||''::NO::T_PROVISION_ID:''||id,',
'      ''f?p=4050:7:''||:flow_session||''::NO::T_PROVISION_ID:''||id',
'      ) action,',
'    decode(project_status,',
'      ''REQUESTED'',m.f4050_provision,',
'      ''APPROVED'',m.f4050_adjust,',
'      ''ACCEPTED'',m.f4050_adjust,',
'       m.f4050_adjust',
'       ) action_label',
'from WWV_FLOW_PROVISION_COMPANY p,',
'  (select wwv_flow_lang.system_message(''F4050.ADJUST'') f4050_adjust,',
'       wwv_flow_lang.system_message(''F4050.PROVISION'') f4050_provision,',
'       wwv_flow_lang.system_message(''APPROVED'') m_approved ,',
'       wwv_flow_lang.system_message(''ACCEPTED'') m_accepted,',
'       wwv_flow_lang.system_message(''REQUESTED'') m_requested,',
'       wwv_flow_lang.system_message(''DECLINED'') m_DECLINED,',
'       wwv_flow_lang.system_message(''F4050.TERMINATED'') m_terminated',
'  from dual) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47544525436431589)
,p_name=>'Provisioning Requests'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47544808184431599)
,p_db_column_name=>'COMPANY_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_link=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:F4050_P6_ID:#ID#:'
,p_column_linktext=>'#COMPANY_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47544922561431600)
,p_db_column_name=>'SCHEMA_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Schema '
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47545013912431600)
,p_db_column_name=>'LOWER(ADMIN_USERID)'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Administrator'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47545102155431601)
,p_db_column_name=>'ADMIN_EMAIL'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Admin Email'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47545227637431601)
,p_db_column_name=>'DATABASE_SIZE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Database Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47545321456431602)
,p_db_column_name=>'COUNTRY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Country'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(825654386458276754)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
,p_security_scheme=>wwv_flow_imp.id(825639761147256575)
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825539320755735502)
,p_db_column_name=>'USAGE_TYPE'
,p_display_order=>17
,p_column_identifier=>'N'
,p_column_label=>'Usage'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(825928575701276934)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
,p_security_scheme=>wwv_flow_imp.id(825639761147256575)
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825539491815735503)
,p_db_column_name=>'ORG_NAME'
,p_display_order=>27
,p_column_identifier=>'O'
,p_column_label=>'Organization'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
,p_security_scheme=>wwv_flow_imp.id(825639761147256575)
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47545420976431602)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>37
,p_column_identifier=>'H'
,p_column_label=>'Request Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47545519532431602)
,p_db_column_name=>'PROJECT_STATUS'
,p_display_order=>47
,p_column_identifier=>'I'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47545614820431603)
,p_db_column_name=>'ACTION'
,p_display_order=>57
,p_column_identifier=>'J'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195687823513119397)
,p_db_column_name=>'STATUS_CODE'
,p_display_order=>67
,p_column_identifier=>'K'
,p_column_label=>'Status Code'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(255467506347301520)
,p_db_column_name=>'ACTION_LABEL'
,p_display_order=>77
,p_column_identifier=>'L'
,p_column_label=>'Action'
,p_column_link=>'#ACTION#'
,p_column_linktext=>'#ACTION_LABEL#'
,p_column_link_attr=>'class="a-Button a-Button--primary" role="button"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1143247153210567424)
,p_db_column_name=>'ID'
,p_display_order=>87
,p_column_identifier=>'M'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47545707881431859)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1313612631536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COMPANY_NAME:SCHEMA_NAME:LOWER(ADMIN_USERID):DATABASE_SIZE:COUNTRY:REQUEST_DATE:PROJECT_STATUS:ACTION_LABEL:'
,p_sort_column_1=>'REQUEST_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_worksheet_condition(
 p_id=>wwv_flow_imp.id(825651296066267651)
,p_report_id=>wwv_flow_imp.id(47545707881431859)
,p_condition_type=>'FILTER'
,p_allow_delete=>'Y'
,p_column_name=>'STATUS_CODE'
,p_operator=>'='
,p_expr=>'1'
,p_condition_sql=>'"STATUS_CODE" = #APXWS_EXPR#'
,p_condition_display=>'#APXWS_COL_NAME# = ''1''  '
,p_enabled=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168707426642147776)
,p_plug_name=>'manage service requests'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(168703120343616153)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(169533626431592276)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195677710307087167)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47544422518431589)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:26,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202781117061233804)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47544422518431589)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(357640242999810948)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47544422518431589)
,p_button_name=>'CREATE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:142:LAST_VIEW:26'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168823031543353530)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'26'
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_imp_page.create_page(
 p_id=>27
,p_name=>'Create Workspace - Identify Workspace'
,p_alias=>'CREATE-WORKSPACE-IDENTIFY-WORKSPACE'
,p_step_title=>'Create Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931243707245169747)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12052824814385644)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12048115202363924)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51837012095286656)
,p_plug_name=>'Create &P27_WORKSPACE_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202717910302643127)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204655309624392338)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(202654431224384775)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_imp.id(204654810731392335)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(15441414872198826)
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752110175246695866)
,p_plug_name=>'Create Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51838114075301402)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202717910302643127)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12005721821568003)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202717910302643127)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next '
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12006017199568012)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(12005721821568003)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(56575929733626519)
,p_branch_action=>'27'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51839319663316706)
,p_name=>'F4050_P27_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(51837012095286656)
,p_prompt=>'Workspace Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a name for the workspace. A workspace is  a shared work area where multiple developers can create applications.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52809911597500660)
,p_name=>'F4050_P27_PROJDESC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(51837012095286656)
,p_prompt=>'Workspace Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>32767
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a description for this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(102040200715981237)
,p_name=>'F4050_P27_SECURITY_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(51837012095286656)
,p_prompt=>'Workspace ID'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Leave Workspace ID blank to have the new Workspace ID automatically generated.  A Workspace ID must be a positive integer greater than 100000.',
'<br /><br />',
'The Workspace ID is typically only specified when you wish to have a workspace with the identical Workspace ID among two or more &PRODUCT_NAME. instances.  It is not common to specify the Workspace ID when manually creating a workspace.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'100000'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1140167911817840047)
,p_name=>'P27_WORKSPACE_TITLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(51837012095286656)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1140210524284843727)
,p_computation_sequence=>10
,p_computation_item=>'P27_WORKSPACE_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''WORKSPACE_INIT_CAP'');'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(175961730770991651)
,p_validation_name=>'F4050_P27_COMPANY Not Null'
,p_validation_sequence=>10
,p_validation=>'F4050_P27_COMPANY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Workspace must be specified.'
,p_associated_item=>wwv_flow_imp.id(51839319663316706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 15-FEB-2002 13:56'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13103125946032313)
,p_validation_name=>'security group id not exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where provisioning_company_id = :F4050_P27_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Workspace ID already exists.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'begin',
'  l_num := to_number(nvl(:F4050_P27_SECURITY_GROUP_ID,''1''));',
'  return true;',
'exception when others then',
'  return false;',
'end;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(12005721821568003)
,p_associated_item=>wwv_flow_imp.id(102040200715981237)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(72385310766234746)
,p_validation_name=>'reserved company name'
,p_validation_sequence=>30
,p_validation=>'nvl(upper(:F4050_P27_COMPANY),''x'') not in (''INTERNAL'',''UNKNOWN'',''CSS'',''JAVASCRIPT'',''THEMES'',''TUTORIAL'',''XML'',''DOC'',''DP'',''TEMPLATES'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Workspace is a reserved name, request denied.'
,p_associated_item=>wwv_flow_imp.id(51839319663316706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(14411726317427900)
,p_validation_name=>'company already exists or requested'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_provision_company',
'            where company_name = upper(:F4050_P27_COMPANY)',
'  ) loop',
'  return false;',
'  exit;',
'end loop;',
'for c1 in (select null',
'             from wwv_flow_companies',
'            where short_name = upper(:F4050_P27_COMPANY) ) loop',
'   return false;',
'   exit;',
'end loop;',
'',
'if not nvl(length(trim(:F4050_P27_COMPANY)),0) > 0 then',
'  return false;',
'end if;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Workspace name already exists'
,p_validation_condition=>'F4050_P27_COMPANY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(12005721821568003)
,p_associated_item=>wwv_flow_imp.id(51839319663316706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(111441226211952153)
,p_validation_name=>'Invalid characters in workspace name'
,p_validation_sequence=>50
,p_validation=>'F4050_P27_COMPANY'
,p_validation2=>'<>:/'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Invalid #LABEL#'
,p_when_button_pressed=>wwv_flow_imp.id(12005721821568003)
,p_associated_item=>wwv_flow_imp.id(51839319663316706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(505004404683036318)
,p_validation_name=>'F4050_P27_SECURITY_GROUP_ID'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if abs(trunc(:F4050_P27_SECURITY_GROUP_ID)) = :F4050_P27_SECURITY_GROUP_ID then',
'        return TRUE;',
'    else',
'        return FALSE;',
'    end if;',
'exception when others then',
'    return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Workspace ID must be a positive integer greater than 100000.'
,p_validation_condition=>'F4050_P27_SECURITY_GROUP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(12005721821568003)
,p_associated_item=>wwv_flow_imp.id(102040200715981237)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2610078003735304)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Set Item F4050_P79_SCHEMA_PASSWORD to null'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4050_P79_SCHEMA_PASSWORD'
,p_internal_uid=>2610078003735304
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_imp_page.create_page(
 p_id=>28
,p_name=>'Change Requests'
,p_alias=>'CHANGE-REQUESTS'
,p_step_title=>'Change Requests'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176750964111248)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_chg_rqst.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47550321334827183)
,p_plug_name=>'Change Requests'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P28a */',
'        c.short_name           workspace,',
'        m.service_name        requested_change,',
'        m.service_attribute_1 value,',
'        m.requested_on        request_date,',
'        m.requested_by        requested_by,',
'       decode(m.request_status,',
'            ''REQUESTED'',m_requested,',
'            ''APPROVED'',m_approved,',
'            ''ACCEPTED'',m_accepted,',
'            ''DECLINED'',m_DECLINED,',
'            m.request_status)',
'            project_status,',
'       decode(m.request_status,',
'            ''REQUESTED'',''1'',',
'            ''APPROVED'',''2'',',
'            ''ACCEPTED'',''3'',',
'            ''DECLINED'',''4'',',
'            ''5'')',
'            status_code,',
'        request_status,',
'        decode(m.request_status,',
'          ''REQUESTED'',sm.f4050_request,',
'          ''APPROVED'',sm.f4050_request,',
'          ''DECLINED'',sm.f4050_request,',
'          '''') ',
'         action,',
'        decode(m.request_status,',
'          ''REQUESTED'',''f?p=4050:110:''||:flow_session||''::NO:110:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id,',
'          ''APPROVED'',''f?p=4050:110:''||:flow_session||''::NO:110,RP:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id,',
'          ''DECLINED'',''f?p=4050:110:''||:flow_session||''::NO:110,RP:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id,',
'          ''#'') ',
'         action_url',
'    from wwv_flow_provision_serice_mod m, ',
'         wwv_flow_companies c,',
'         (select wwv_flow_lang.system_message(''F4050.NO_ACTION'') f4050_action,',
'                 wwv_flow_lang.system_message(''F4050.VIEW_REQUEST'') f4050_request,',
'                 wwv_flow_lang.system_message(''REQUESTED'') m_requested,',
'                 wwv_flow_lang.system_message(''APPROVED'') m_approved,',
'                 wwv_flow_lang.system_message(''ACCEPTED'') m_accepted,',
'                 wwv_flow_lang.system_message(''DECLINED'') m_DECLINED',
'          from dual) sm',
'   where m.security_group_id = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47550429366827183)
,p_name=>'Change Requests'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47550607307827218)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47550727309827219)
,p_db_column_name=>'REQUESTED_CHANGE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Requested Change'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(110368323210290856)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47550822950827219)
,p_db_column_name=>'VALUE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47550913112827220)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47551009969827221)
,p_db_column_name=>'REQUESTED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Requested By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47551128912827222)
,p_db_column_name=>'REQUEST_STATUS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195675721688062095)
,p_db_column_name=>'PROJECT_STATUS'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47551326543834614)
,p_db_column_name=>'ACTION'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Action'
,p_column_link=>'#ACTION_URL#'
,p_column_linktext=>'<span>#ACTION#</span>'
,p_column_link_attr=>'class="a-Button a-Button--primary" role="button"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195688928146130168)
,p_db_column_name=>'STATUS_CODE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Status Code'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(256232203074880367)
,p_db_column_name=>'ACTION_URL'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Action URL'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47551427236834868)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1313730059536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE:REQUESTED_CHANGE:VALUE:REQUEST_DATE:REQUESTED_BY:PROJECT_STATUS:ACTION:'
,p_sort_column_1=>'REQUEST_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_worksheet_condition(
 p_id=>wwv_flow_imp.id(256232505152888923)
,p_report_id=>wwv_flow_imp.id(47551427236834868)
,p_condition_type=>'FILTER'
,p_allow_delete=>'Y'
,p_column_name=>'STATUS_CODE'
,p_operator=>'='
,p_expr=>'1'
,p_condition_sql=>'"STATUS_CODE" = #APXWS_EXPR#'
,p_condition_display=>'#APXWS_COL_NAME# = ''1''  '
,p_enabled=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(59534981464167587)
,p_plug_name=>'Change Requests'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This page lists requests for changes to existing services. To review a request, click <strong>View Request</strong>. Click on the action for the specific workspace you wish to process.  Actions that are listed as <strong>No Action</strong> are comple'
||'te, and therefore require no action.'
,p_plug_query_row_template=>wwv_flow_imp.id(81008210556197147)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|2,3\1,9|',
'',
'&nbsp;:',
'',
'<font class="nounderline" color="black">Company</font>:',
'',
'<font class="nounderline" color="black">Schema</font>:',
'',
'<font class="nounderline" color="black">AdminUserID</font>:',
'',
'<font class="nounderline" color="black">Email</font>:',
'',
'<font class="nounderline" color="black">DBsize</font>:',
'',
'<font class="nounderline" color="black">Requested</font>:',
'',
'<font class="nounderline" color="black">Status</font>:',
'',
'<font class="nounderline" color="black">Action</font>'))
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'No data found.'
,p_plug_query_show_nulls_as=>'-'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168706908287142461)
,p_plug_name=>'manage service requests'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(168703120343616153)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(169533626431592276)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195681908360096073)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47550321334827183)
,p_button_name=>'reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:28,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168822021023341018)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'28'
);
end;
/
prompt --application/pages/page_00029
begin
wwv_flow_imp_page.create_page(
 p_id=>29
,p_name=>'Monitor Activity'
,p_alias=>'MONITOR-ACTIVITY'
,p_step_title=>'Monitor Activity'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14723216460004096)
,p_plug_name=>'Calendar  Reports'
,p_icon_css_classes=>'icon-util-calendar-reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>90
,p_plug_grid_column_span=>4
,p_list_id=>wwv_flow_imp.id(14738731575074699)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_column_width=>'apex-col--rightBorder  apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14755429806121434)
,p_plug_name=>'Developer Activity'
,p_icon_css_classes=>'icon-util-developer-activity'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>4
,p_list_id=>wwv_flow_imp.id(206097723808588940)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_column_width=>'apex-col--rightBorder  apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49038908699379385)
,p_plug_name=>'Login Attempts'
,p_icon_css_classes=>'icon-util-login-attempts'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(49036204543378170)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(82696814914931381)
,p_plug_name=>'Page Views'
,p_icon_css_classes=>'icon-util-page-views'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(159973015345793688)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130807619772581428)
,p_plug_name=>'Service Requests'
,p_icon_css_classes=>'icon-util-manage-dynamic-translation'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(130557109467559465)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder '
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179853623006946463)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the links on this page to see various reports on application, developer, and session activity in all workspaces.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206100700867601271)
,p_plug_name=>'Environment Reports'
,p_icon_css_classes=>'icon-util-environment-reports'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(14750409028115431)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505825804390240661)
,p_plug_name=>'Workspace Purge'
,p_icon_css_classes=>'icon-util-purge-sessions-age'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(505826028978247783)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(619444920398900055)
,p_plug_name=>'Logs'
,p_icon_css_classes=>'icon-util-logs'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_imp.id(619447801744923075)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(880587954287852291)
,p_plug_name=>'Activity Summary'
,p_region_sub_css_classes=>'instance-admin'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_imp.id(880586104026852286)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410251255325302)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1066580874943368101)
,p_plug_name=>'Archived Activity'
,p_icon_css_classes=>'icon-database-object'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(966388705490342505)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(201292222959269624)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410627877325303)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1066581069870368105)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1066580874943368101)
,p_button_name=>'ARCHIVE_ACTIVITY_LOG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Archive Activity Log'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(162276418488133798)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'29'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_imp_page.create_page(
 p_id=>30
,p_name=>'Activity by Page View'
,p_alias=>'ACTIVITY-BY-PAGE-VIEW'
,p_step_title=>'Activity by Page View'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1144801668849676)
,p_plug_name=>'Recent Page Views'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P30a */',
' security_group_id,',
' time_stamp page_view,',
' time_stamp t2,',
' lower(l.userid) userid,',
' lower(c.short_name) company,',
' elap,',
' num_rows,',
' l.flow_id,',
' content_length,',
' (select name ',
'  from wwv_flows ',
'  where id = l.flow_id) application_name,',
' step_id page_id,',
' (select name ',
'  from wwv_flow_steps ',
'  where flow_id = l.flow_id and id=l.step_id) page_name,',
' cached_regions,',
' decode(page_mode,',
'        ''A'',m.m_PAGE_PROCESSING,',
'        ''C'',m.m_CACHE_CREATED,',
'        ''D'',m.m_DYNAMIC,',
'        ''P'',m.m_PARTIAL_PAGE, ',
'        ''R'',m.m_CACHED,',
'        page_mode) page_mode,',
' sqlerrm,',
' page_view_type,',
' request_value,',
' debug_page_view_id',
' from (',
'select ',
' security_group_id,',
' time_stamp,',
' userid,',
' elap,',
' num_rows,',
' cached_regions,',
' flow_id,',
' step_id,',
' page_mode,',
' sqlerrm,',
' content_length,',
' page_view_type,',
' request_value,',
' debug_page_view_id',
'from   #OWNER#.wwv_flow_activity_log',
'where time_stamp > (sysdate - :P30_SINCE)',
'order  by time_stamp desc) l,',
'wwv_flow_companies c,',
'   (select wwv_flow_lang.system_message(''PAGE_PROCESSING'') m_PAGE_PROCESSING,',
'           wwv_flow_lang.system_message(''CACHE_CREATED'') m_CACHE_CREATED,',
'           wwv_flow_lang.system_message(''F4000.DYNAMIC'') m_DYNAMIC,',
'           wwv_flow_lang.system_message(''PARTIAL_PAGE'') m_PARTIAL_PAGE,',
'           wwv_flow_lang.system_message(''CACHED'') m_CACHED',
'    from dual) m',
'where security_group_id = provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P30_SINCE'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1144928525849676)
,p_name=>'Recent Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1145108267849684)
,p_db_column_name=>'PAGE_VIEW'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'Dy &DATE_TIME_FORMAT.'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1145203039849685)
,p_db_column_name=>'T2'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Time'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1145307063849685)
,p_db_column_name=>'USERID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1145411401849685)
,p_db_column_name=>'COMPANY'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1145720209849685)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'G'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1145828697849686)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>6
,p_column_identifier=>'H'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1145611705849685)
,p_db_column_name=>'ELAP'
,p_display_order=>8
,p_column_identifier=>'F'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1145930736849686)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Cached Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1146029978849686)
,p_db_column_name=>'PAGE_MODE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Page Mode'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1149606738876853)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1151320029890154)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201520806846077646)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(473017014819476725)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Selected Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475460660459625311)
,p_db_column_name=>'PAGE_VIEW_TYPE'
,p_display_order=>27
,p_column_identifier=>'R'
,p_column_label=>'Page View Type'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(1582102292640264559)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475460717902625312)
,p_db_column_name=>'REQUEST_VALUE'
,p_display_order=>37
,p_column_identifier=>'S'
,p_column_label=>'Request Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475460887017625313)
,p_db_column_name=>'DEBUG_PAGE_VIEW_ID'
,p_display_order=>47
,p_column_identifier=>'T'
,p_column_label=>'Debug ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475460953195625314)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>57
,p_column_identifier=>'U'
,p_column_label=>'Query Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475461081382625315)
,p_db_column_name=>'SQLERRM'
,p_display_order=>67
,p_column_identifier=>'V'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1146220543852537)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1313807462536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'T2:USERID:COMPANY:FLOW_ID:PAGE_ID:PAGE_NAME:ELAP:PAGE_MODE:CONTENT_LENGTH:SECURITY_GROUP_ID:PAGE_VIEW_TYPE:REQUEST_VALUE:DEBUG_PAGE_VIEW_ID:NUM_ROWS:SQLERRM'
,p_sort_column_1=>'T2'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'PAGE_VIEW'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(190796222078501880)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(59665949535463099)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(190796222078501880)
,p_button_name=>'F4050_P30_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(192026400173820140)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(190796222078501880)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:30,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47128703206222148)
,p_name=>'P30_SINCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(190796222078501880)
,p_item_default=>'1'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Set</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_imp_page.create_page(
 p_id=>31
,p_name=>'Login Access Log'
,p_alias=>'LOGIN-ACCESS-LOG'
,p_step_title=>'Login Access Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15366007090981094)
,p_plug_name=>'Login Access Log Entries'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_dev number := 0;',
'begin',
'    select count(*)',
'      into c_dev',
'      from wwv_flow_user_access_log_v;',
'',
'    return ''<p>'' ',
'           || wwv_flow_lang_dev.builder_message(''4050_31_LOG_COUNT'') || '': ''',
'           || to_char(c_dev, ''999,999,999,990'')',
'           || ''</p>'';    ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982231408806899638)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15367111801981107)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(982231408806899638)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Entries'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15366901763981105)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(982231408806899638)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15368103316981118)
,p_branch_action=>'31'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(15367111801981107)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15367328334981108)
,p_name=>'P31_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15366007090981094)
,p_prompt=>'Delete entries this number of days and older:'
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_imp.id(87720511660244788)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Purge entries older than this number of days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15367807877981115)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_user_access_log1$',
'where access_date < (sysdate - nvl(:p31_time,31));',
'delete from wwv_flow_user_access_log2$',
'where access_date < (sysdate - nvl(:p31_time,31));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error purging Login Access log.'
,p_process_when_button_id=>wwv_flow_imp.id(15367111801981107)
,p_process_success_message=>'Login Access log purged.'
,p_internal_uid=>15367807877981115
);
end;
/
prompt --application/pages/page_00032
begin
wwv_flow_imp_page.create_page(
 p_id=>32
,p_name=>'Activity by Workspace'
,p_alias=>'ACTIVITY-BY-WORKSPACE'
,p_step_title=>'Activity by Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(758054002774278408)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1081290709913302621)
,p_plug_name=>'Activity by Workspace'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    --WORKSPACE_ID workspace,',
'    max(LOG_DAY) last_day,',
'    min(LOG_DAY) min_day,',
'    nvl(workspace_name, ''- Removed Workspaces -'') as workspace_name,',
'    count(distinct APPLICATION_ID) applications,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY_V',
'where log_day >= sysdate-NVL(:P32_SINCE,365)',
'group by workspace_name'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1081290886190302628)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1081290886190302628
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879918052750689306)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879918453481689307)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879924498725689317)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'T'
,p_column_label=>'Public Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879918882121689311)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879919255306689311)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Page Posts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879919621539689312)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879920450211689313)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Rows Fetched'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879920814584689313)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>'Interactive Report Searches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879921212650689314)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879921655636689315)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879922016471689315)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879922424269689315)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Total Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879922805299689316)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879923255906689316)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879924062356689317)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(758053744109278405)
,p_db_column_name=>'LAST_DAY'
,p_display_order=>165
,p_column_identifier=>'U'
,p_column_label=>'Last day'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(758053867239278406)
,p_db_column_name=>'MIN_DAY'
,p_display_order=>175
,p_column_identifier=>'V'
,p_column_label=>'Min day'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1081292901175302648)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'8799248'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:APPLICATIONS:PAGE_EVENTS:ROWS_FETCHED:DISTINCT_PAGES:DISTINCT_USERS:DISTINCT_SESSIONS:TOTAL_RENDER_TIME:ERROR_COUNT:CONTENT_LENGTH::LAST_DAY:MIN_DAY'
,p_sort_column_1=>'PAGE_EVENTS'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'LOG_DAY'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(758054454402278412)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(758054002774278408)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(879925217543689326)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1081290709913302621)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:80,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(758053904365278407)
,p_name=>'P32_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(758054002774278408)
,p_item_default=>'365'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_imp_page.create_page(
 p_id=>33
,p_name=>'Page Views by Workspace'
,p_alias=>'PAGE-VIEWS-BY-WORKSPACE'
,p_step_title=>'Page Views by Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61103509800592682)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192031217790858683)
,p_plug_name=>'Page Events by Workspace'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_views as (',
'select /* APEX 4050P33a */ count(*) tv ',
'from WWV_FLOW_ACTIVITY_LOG ',
' where time_stamp>=(select sysdate - to_number(:P33_DAYS) from dual) )',
'select c.short_name workspace, ',
'       count(*) page_views, ',
'       sum(elap) elapsed, ',
'       count(distinct ip_address) ip_addresses, ',
'       sum(num_rows) report_rows, ',
'       100*count(*)/max(tv) pct, ',
'       round(100*count(*)/max(tv)) graph,',
'       sum(nvl(content_length,0)) content_length',
'from WWV_FLOW_ACTIVITY_LOG l, ',
'     wwv_flow_companies c, total_views',
'where l.security_group_id = c.provisioning_company_id(+)',
'--and l.page_mode != ''A''',
'and l.time_stamp>=(select sysdate - to_number(',
':P33_DAYS) x from dual ) ',
'group by c.short_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P33_DAYS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192031320627858683)
,p_name=>'Page Views by Workspace'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192031514692858685)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192031600401858687)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192032016190858690)
,p_db_column_name=>'PCT'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192032125647858690)
,p_db_column_name=>'GRAPH'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>'Page View Percentage'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192031720928858687)
,p_db_column_name=>'ELAPSED'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Elapsed Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192031803217858688)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'IP Addresses'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192031927191858689)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>7
,p_column_identifier=>'E'
,p_column_label=>'Report Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200561403147891384)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192032303122858864)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1313928519536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE:PAGE_VIEWS:PCT:GRAPH:ELAPSED:IP_ADDRESSES:REPORT_ROWS:CONTENT_LENGTH'
,p_sort_column_1=>'PAGE_VIEWS'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(61106528978607676)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(61103509800592682)
,p_button_name=>'P33_GO'
,p_button_static_id=>'P33_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(192030908878851071)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(61103509800592682)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:33,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61104914087603350)
,p_name=>'P33_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(61103509800592682)
,p_item_default=>'to_number(.000694444)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Include'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Set</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(276626302334689749)
,p_computation_sequence=>10
,p_computation_item=>'P33_DAYS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:P33_DAYS);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00034
begin
wwv_flow_imp_page.create_page(
 p_id=>34
,p_name=>'Archive Activity Log'
,p_alias=>'ARCHIVE-ACTIVITY-LOG'
,p_page_mode=>'MODAL'
,p_step_title=>'Archive Activity Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'300'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982231502665899639)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2024852435896481301)
,p_name=>'Archive Activity'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(log_day) d,',
'       count(distinct(log_day)) c,',
'       count(distinct workspace_id) w',
'  from wwv_flow_log_history'))
,p_header=>'<p>This process will take the &PRODUCT_NAME. activity log, summarize it, and write the results to the archived activity log.</p>'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2024852704122481304)
,p_query_column_id=>1
,p_column_alias=>'D'
,p_column_display_sequence=>1
,p_column_heading=>'Date of Last Archive:'
,p_use_as_row_header=>'N'
,p_column_format=>'&LONG_DATE_FORMAT.'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2024852684404481303)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Archive Day Count:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2024852595428481302)
,p_query_column_id=>3
,p_column_alias=>'W'
,p_column_display_sequence=>3
,p_column_heading=>'Workspace Count:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(162275803752126514)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(982231502665899639)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Archive Activity Summary'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(162275625976126513)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(982231502665899639)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(162274914763113875)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'archive activity summary'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'  select PROVISIONING_COMPANY_ID',
'  from WWV_FLOW_COMPANIES) loop',
'wwv_flow_admin_api.archive_activity_log (',
'   p_workspace_id  => c1.PROVISIONING_COMPANY_ID);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error archiving activity log.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(162275803752126514)
,p_internal_uid=>162274914763113875
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(982231774544899641)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Activity log archived.'
,p_internal_uid=>982231774544899641
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(982231615649899640)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Cancel Modal'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(162275625976126513)
,p_internal_uid=>982231615649899640
);
end;
/
prompt --application/pages/page_00035
begin
wwv_flow_imp_page.create_page(
 p_id=>35
,p_name=>'Developer Last Login'
,p_alias=>'DEVELOPER-LAST-LOGIN'
,p_step_title=>'Developer Last Login'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472578008272666412)
,p_plug_name=>'Developer Last Login'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4050P35a */ ',
'         u.USER_NAME, u.EMAIL_ADDRESS, u.LAST_LOGIN, u.LAST_IP, u.LAST_AGENT, w.short_name',
'from  WWV_FLOW_FND_USER u,',
'         WWV_FLOW_COMPANIES w',
'where u.security_group_id = w.PROVISIONING_COMPANY_ID',
'  and u.last_login is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472578115032666412)
,p_name=>'Developer Last Login'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472578800631666423)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'F'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472578327281666418)
,p_db_column_name=>'USER_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472578417746666419)
,p_db_column_name=>'EMAIL_ADDRESS'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Email'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472578530500666420)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Login'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472578618711666421)
,p_db_column_name=>'LAST_IP'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'IP Address'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472578707789666422)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Agent'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472579007334666823)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314014588536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:USER_NAME:EMAIL_ADDRESS:LAST_LOGIN:LAST_IP:LAST_AGENT'
,p_sort_column_1=>'SHORT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(982231807874899642)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(472578008272666412)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:RP,RIR,35:::'
);
end;
/
prompt --application/pages/page_00036
begin
wwv_flow_imp_page.create_page(
 p_id=>36
,p_name=>'Page Views by Workspace and User'
,p_alias=>'PAGE-VIEWS-BY-WORKSPACE-AND-USER'
,p_step_title=>'Page Views by Workspace and User'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29699608010437593)
,p_plug_name=>'Page Views by User'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'select /* APEX 4050P36a */ wwv_flow_lang.system_message(''AUTH.LOGIN_PAGE'') login_page,',
'wwv_flow_lang.system_message(''UNAUTHENTICATED_USER'') unauth_user,',
'(select count(*) tv',
'from wwv_flow_activity_log l',
'where l.time_stamp>=(select sysdate - to_number(',
':F4050_P36_DAYS) x from dual )  ) tv',
'from dual)',
'select ',
'decode(lower(l.userid),null,',
'  messages.login_page,''nobody'',',
'  messages.unauth_user,lower(l.userid))',
'   user_name,',
'lower(c.short_name) workspace,',
' sum(nvl(content_length,0)) content_length,',
' count(*) page_views, ',
' 100*count(*)/tv pct, ',
' sum(num_rows) report_rows, count(distinct(ip_address)) ip_addresses, sum(elap) total_elapsed, avg(elap) average_elapsed, count(distinct to_char(time_stamp,''YYYYMMDDHH24'')) distinct_hours, count(distinct to_char(time_stamp,''YYYYMMDD'')) distinct_days',
'from wwv_flow_activity_log l, ',
'     wwv_flow_companies c, messages',
'where l.security_group_id = c.provisioning_company_id (+)',
'and page_mode != ''A''',
'and l.time_stamp>=(select sysdate - to_number(',
':F4050_P36_DAYS) x from dual )  ',
'group by decode(lower(l.userid),null,',
'  login_page,''nobody'',',
'  unauth_user,lower(l.userid)),',
'  lower(c.short_name),',
'  tv'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'F4050_P36_DAYS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(29699725380437593)
,p_name=>'Page Views by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29700017280437611)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29699919697437605)
,p_db_column_name=>'USER_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'User Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29700119116437611)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29700209070437611)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29700329762437611)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Report Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29700428081437611)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'IP Addresses'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29700530668437612)
,p_db_column_name=>'TOTAL_ELAPSED'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Total Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29700630362437612)
,p_db_column_name=>'AVERAGE_ELAPSED'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Average Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29700720568437612)
,p_db_column_name=>'DISTINCT_HOURS'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Distinct Hours'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29700820921437612)
,p_db_column_name=>'DISTINCT_DAYS'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Distinct Days'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201522023038101249)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(29701022140439422)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314118947536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE:USER_NAME:PAGE_VIEWS:PCT:REPORT_ROWS:IP_ADDRESSES:TOTAL_ELAPSED:AVERAGE_ELAPSED:DISTINCT_HOURS:DISTINCT_DAYS:CONTENT_LENGTH'
,p_sort_column_1=>'PAGE_VIEWS'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(190804631770512632)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78416586194793694)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(190804631770512632)
,p_button_name=>'P36_GO'
,p_button_static_id=>'P36_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201522110702107141)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(190804631770512632)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:36,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(78411482361787247)
,p_name=>'F4050_P36_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(190804631770512632)
,p_item_default=>'to_number(.000694444)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(276626473692689750)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P36_DAYS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:F4050_P36_DAYS);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_imp_page.create_page(
 p_id=>37
,p_name=>'Page Views by Day by Application and User'
,p_alias=>'PAGE-VIEWS-BY-DAY-BY-APPLICATION-AND-USER'
,p_step_title=>'Page Views by Day by Application and User'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'08'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982231934072899643)
,p_plug_name=>'Calendar of Page Views'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P37a */',
'    trunc(TIME_STAMP) ts, ',
'    wwv_flow_lang.system_message(''views'')||'': ''',
'        ||to_char(count(*),''999G999G999G999G990'')||''<br>''',
'        ||chr(10)',
'        ||wwv_flow_lang.system_message(''users'')||'': ''',
'        ||count(distinct upper(USERID))||''<br>''',
'        ||chr(10)',
'        ||wwv_flow_lang.system_message(''applications'')||'': ''',
'        ||to_char(count(distinct flow_id),''999G999G999G990'')||''<br>''',
'        ||chr(10)',
'        ||wwv_flow_lang.system_message(''pages'')||'': ''',
'        ||to_char(count(distinct step_id),''999G999G990'') display',
'from WWV_FLOW_ACTIVITY_LOG',
'group by trunc(time_stamp)'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'additional_calendar_views', 'month:list:navigation',
  'display_column', 'DISPLAY',
  'maximum_events_day', '10',
  'multiple_line_event', 'Y',
  'show_time', 'N',
  'show_tooltip', 'N',
  'show_weekend', 'Y',
  'start_date_column', 'TS')).to_clob
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(291646014277240138)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Previous'
,p_process_sql_clob=>' wwv_flow_utilities.decrement_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing calendar date.'
,p_internal_uid=>291646014277240138
,p_process_comment=>'Generated 06-AUG-04'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(291646406278240158)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Next'
,p_process_sql_clob=>' wwv_flow_utilities.increment_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing calendar date.'
,p_internal_uid=>291646406278240158
,p_process_comment=>'Generated 06-AUG-04'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(291646229414240158)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Today'
,p_process_sql_clob=>' wwv_flow_utilities.today_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing calendar date.'
,p_internal_uid=>291646229414240158
,p_process_comment=>'Generated 06-AUG-04'
);
end;
/
prompt --application/pages/page_00038
begin
wwv_flow_imp_page.create_page(
 p_id=>38
,p_name=>'Page Views by User Agent'
,p_alias=>'PAGE-VIEWS-BY-USER-AGENT'
,p_step_title=>'Page Views by User Agent'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1139626278807865)
,p_plug_name=>'Page Views by User Agent'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_views as (',
'select /* APEX 4050P38a */ count(*) tv ',
'    from wwv_flow_activity_log ',
'    where (:P38_SEARCH is null or instr(upper(user_agent),upper(:P38_SEARCH))>0)',
'          and user_agent is not null',
'    )',
'select user_agent, count(distinct ip_address) ip_addresses, ',
'       sum(the_count) page_views, ',
'       100*sum(the_count)/max(tv) pct, ',
'       round(100*sum(the_count)/max(tv)) graph',
'  from',
'   (select   session_id, ',
'             max(substr(nvl(user_agent,'' Unknown''),1,100)) user_agent, ',
'             count(*) the_count,',
'             max(ip_address) ip_address',
'      from   wwv_flow_activity_log',
'      where  time_stamp >= (select sysdate - to_number(:p38_include) x from dual)',
'             and (:P38_SEARCH is null or instr(upper(user_agent),upper(:P38_SEARCH))>0)',
'             and user_agent is not null',
'      group  by session_id) l,',
'total_views',
' group by user_agent'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P38_INCLUDE'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1139714426807865)
,p_name=>'Page Views by User Agent'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1139914254807872)
,p_db_column_name=>'USER_AGENT'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'User Agent'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1140010212807873)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'IP Addresses'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1140103841807873)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1140222535807873)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1140319248807873)
,p_db_column_name=>'GRAPH'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1140602704809460)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314213532536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'USER_AGENT:IP_ADDRESSES:PAGE_VIEWS:PCT:GRAPH'
,p_sort_column_1=>'PAGE_VIEWS'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7600207230119070)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200336310009013487)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7600207230119070)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:38,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7601517273121938)
,p_name=>'P38_INCLUDE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7600207230119070)
,p_item_default=>'1'
,p_prompt=>'Include'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(514940926156998805)
,p_computation_sequence=>10
,p_computation_item=>'P38_INCLUDE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:P38_INCLUDE);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;       ',
''))
);
end;
/
prompt --application/pages/page_00039
begin
wwv_flow_imp_page.create_page(
 p_id=>39
,p_name=>'File Utilization by Workspace'
,p_alias=>'FILE-UTILIZATION-BY-WORKSPACE'
,p_step_title=>'File Utilization by Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_file_util.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168486127574421772)
,p_plug_name=>'File Utilization by Workspace'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P39a */',
'    (select short_name from wwv_flow_companies where PROVISIONING_COMPANY_ID = q.workspace_id) workspace_name,',
'    total_file_size,',
'    count_of_files,',
'    workspace_id,',
'    newest_file,',
'    oldest_file',
'from (',
'select security_group_id workspace_id, nvl(sum(sys.dbms_lob.getlength(BLOB_CONTENT)),0) total_file_size, count(*) count_of_files,',
'max(created_on) newest_file,',
'min(created_on) oldest_file',
'from WWV_FLOW_FILE_OBJECTS$ ',
'group by security_group_id',
') q'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(168486201858421772)
,p_name=>'File Utiliaztion by Workspace'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168486406232421778)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168486506600421780)
,p_db_column_name=>'TOTAL_FILE_SIZE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Total File Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168486627845421780)
,p_db_column_name=>'COUNT_OF_FILES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Count of Files'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168487624348439653)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168487830928441569)
,p_db_column_name=>'NEWEST_FILE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Newest File'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168487900636441570)
,p_db_column_name=>'OLDEST_FILE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Oldest File'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(168486928242421921)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314303127536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:TOTAL_FILE_SIZE:COUNT_OF_FILES:NEWEST_FILE:OLDEST_FILE'
,p_sort_column_1=>'TOTAL_FILE_SIZE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'OLDEST_FILE'
,p_sort_direction_2=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(468245232054195576)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168486127574421772)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00040
begin
wwv_flow_imp_page.create_page(
 p_id=>40
,p_name=>'Dashboard'
,p_alias=>'DASHBOARD'
,p_step_title=>'Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(168510101521826105)
,p_name=>'Top Workspaces'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with all_workspaces as (',
'    select row_number() over( order by sum(logs) desc ) as workspace_order,',
'           max(short_name) as workspace,',
'           wwv_flow_page_api.get_url(',
'                                    p_page => 30,',
'                                    p_debug => ''NO'',',
'                                    p_clear_cache => ''30,RIR'',',
'                                    p_items => ''P30_SINCE,IR_SECURITY_GROUP_ID'',',
'                                    p_values => 1 || '','' || l.security_group_id) as workspace_link,',
'           sum(logs) activity_logs',
'    from ( ',
'        select security_group_id,            ',
'               count(*) logs',
'         from WWV_FLOW_ACTIVITY_LOG1$',
'        where time_stamp > sysdate - :P40_TIME/86400',
'          and userid not in (''APEX_PUBLIC_USER'',''nobody'')',
'     group by security_group_id',
'        union all',
'        select security_group_id,',
'               count(*) logs',
'          from WWV_FLOW_ACTIVITY_LOG2$',
'         where time_stamp > sysdate - :P40_TIME/86400',
'           and userid not in (''APEX_PUBLIC_USER'',''nobody'')',
'      group by security_group_id ) l,',
'               wwv_flow_companies c',
'         where c.provisioning_company_id = l.security_group_id',
'      group by security_group_id )',
'      select workspace,',
'             workspace_link,',
'             activity_logs',
'        from all_workspaces',
'       where workspace_order <= 10'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P40_TIME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201083983668005)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>10
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'Y'
,p_column_link=>'#WORKSPACE_LINK#'
,p_column_linktext=>'#WORKSPACE#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201139297668006)
,p_query_column_id=>2
,p_column_alias=>'WORKSPACE_LINK'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201225822668007)
,p_query_column_id=>3
,p_column_alias=>'ACTIVITY_LOGS'
,p_column_display_sequence=>30
,p_column_heading=>'Activity Logs'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(168510500623826106)
,p_name=>'Top Applications'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with all_applications as (',
'    select row_number() over( order by sum(logs) desc ) as application_order,',
'           max(short_name) as workspace,',
'           max(name) as application_name,',
'           wwv_flow_page_api.get_url(',
'                                p_page => 30,',
'                                p_debug => ''NO'',',
'                                p_clear_cache => ''30,RIR'',',
'                                p_items => ''P30_SINCE,IR_FLOW_ID,IR_SECURITY_GROUP_ID'',',
'                                p_values => 1 || '','' || l.flow_id || '','' || l.security_group_id) as application_link,',
'           sum(logs) activity_logs',
'    from ( ',
'        select security_group_id,',
'               flow_id,',
'               count(*) logs',
'          from WWV_FLOW_ACTIVITY_LOG1$',
'         where time_stamp > sysdate - :P40_TIME/86400',
'           and userid not in (''APEX_PUBLIC_USER'',''nobody'')',
'      group by security_group_id,',
'               flow_id',
'        union all',
'        select security_group_id,',
'               flow_id,',
'               count(*) logs',
'          from WWV_FLOW_ACTIVITY_LOG2$',
'         where time_stamp > sysdate - :P40_TIME/86400',
'           and userid not in (''APEX_PUBLIC_USER'',''nobody'')',
'      group by security_group_id,',
'               flow_id ) l,',
'               wwv_flow_companies c,',
'               wwv_flows f',
'      where c.provisioning_company_id = l.security_group_id',
'        and f.id = l.flow_id',
'        and f.security_group_id = l.security_group_id     ',
'    group by l.security_group_id,',
'             l.flow_id )',
'    select workspace,',
'           application_name,',
'           application_link,',
'           activity_logs',
'      from all_applications',
'     where application_order <= 10         ',
'    '))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P40_TIME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201311187668008)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>10
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201464123668009)
,p_query_column_id=>2
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Application Name'
,p_use_as_row_header=>'Y'
,p_column_link=>'#APPLICATION_LINK#'
,p_column_linktext=>'#APPLICATION_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201551564668010)
,p_query_column_id=>3
,p_column_alias=>'APPLICATION_LINK'
,p_column_display_sequence=>30
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201687007668011)
,p_query_column_id=>4
,p_column_alias=>'ACTIVITY_LOGS'
,p_column_display_sequence=>40
,p_column_heading=>'Activity Logs'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(168510708105826106)
,p_name=>'Top Users'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with all_users as (',
'    select row_number() over( order by sum(l.logs) desc ) as user_order,',
'           l.userid,',
'           wwv_flow_page_api.get_url(',
'                                p_page => 30,',
'                                p_debug => ''NO'',',
'                                p_clear_cache => ''30,RIR'',',
'                                p_items => ''P30_SINCE,IR_SECURITY_GROUP_ID,IR_USERID'',',
'                                p_values => 1 || '','' || l.security_group_id || '','' ',
'                                            || wwv_flow_escape.html_attribute(wwv_flow_security.lower_sec_ok(l.userid))) as user_link,',
'            max(c.short_name) as workspace,',
'            sum(l.logs) activity_logs',
'      from (',
'        select userid,',
'               security_group_id,',
'               count(*) logs',
'          from wwv_flow_activity_log1$',
'         where time_stamp > sysdate - :P40_TIME/86400',
'           and userid not in (''APEX_PUBLIC_USER'',''nobody'')',
'      group by userid,',
'               security_group_id',
'        union all',
'        select userid,',
'               security_group_id,',
'               count(*) logs',
'          from wwv_flow_activity_log2$',
'         where time_stamp > sysdate - :P40_TIME/86400',
'           and userid not in (''APEX_PUBLIC_USER'',''nobody'')',
'      group by userid,',
'               security_group_id ) l,',
'               wwv_flow_companies c',
'         where c.provisioning_company_id = l.security_group_id',
'    group by l.userid,',
'             l.security_group_id )',
'    select userid,',
'           user_link,',
'           workspace,',
'           activity_logs',
'      from all_users',
'     where user_order <= 10',
'      '))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P40_TIME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8200666900668001)
,p_query_column_id=>1
,p_column_alias=>'USERID'
,p_column_display_sequence=>10
,p_column_heading=>'User ID'
,p_use_as_row_header=>'Y'
,p_column_link=>'#USER_LINK#'
,p_column_linktext=>'#USERID#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8200734347668002)
,p_query_column_id=>2
,p_column_alias=>'USER_LINK'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8200864539668003)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>30
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8200927755668004)
,p_query_column_id=>4
,p_column_alias=>'ACTIVITY_LOGS'
,p_column_display_sequence=>40
,p_column_heading=>'Activity Logs'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168510902814826107)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201291722136259899)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168510902814826107)
,p_button_name=>'P40_SET'
,p_button_static_id=>'P40_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168654712688961177)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168510902814826107)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:40,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168655015458961962)
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(168511327180826108)
,p_name=>'P40_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(168510902814826107)
,p_item_default=>'43200'
,p_prompt=>'Time'
,p_source=>'43200'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P40_RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, to_char(t) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5*60 t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15*60 t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 3600 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 2*3600  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3*3600  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4*3600  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6*3600 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8*3600 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12*3600 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 18*3600 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1*24*60*60 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2*24*60*60 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3*24*60*60 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4*24*60*60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5*24*60*60 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 6*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7*24*60*60 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14*24*60*60 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365*24*60*60 t from dual order by 2',
') q'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168511623943826111)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'29'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00041
begin
wwv_flow_imp_page.create_page(
 p_id=>41
,p_name=>'Login Message'
,p_alias=>'LOGIN-MESSAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Login Message'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766702444596508)
,p_step_template=>wwv_flow_imp.id(721103220819687982)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'450'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_env_sec.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168805726894149252)
,p_plug_name=>'Login Message'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168806123768149255)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955890401700997315)
,p_plug_name=>'Login Message'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168807329606149261)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168806123768149255)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168807109764149260)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168806123768149255)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168810627520149271)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(168808009400149264)
,p_name=>'P41_CUSTOM_MESSAGE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(168805726894149252)
,p_prompt=>'Message'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the text to be displayed on the login page.  This text can include HTML.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(108575323261463401)
,p_validation_name=>'Login message cannot be greater than 4000 bytes'
,p_validation_sequence=>10
,p_validation=>'lengthb(:P41_CUSTOM_MESSAGE) <= 4000'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The message cannot contain more than 4000 characters.'
,p_associated_item=>wwv_flow_imp.id(168808009400149264)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(206354858435953021)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(168807109764149260)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(206354902602953022)
,p_event_id=>wwv_flow_imp.id(206354858435953021)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(168809920803149267)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Login message',
'--',
':P41_CUSTOM_MESSAGE := wwv_flow_platform.get_preference( p_preference_name => ''LOGIN_MESSAGE'' );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>168809920803149267
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(168810111601149270)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- If custom login message, then set the actual message to be displayed.',
'--',
'if trim( :P41_CUSTOM_MESSAGE ) is not null then',
'    wwv_flow_platform.set_preference( p_preference_name  => ''LOGIN_MESSAGE'',',
'                                      p_preference_value => trim( :P41_CUSTOM_MESSAGE ) );',
'else',
'    --',
'    -- Otherwise, clear out the message',
'    --',
'    wwv_flow_platform.set_preference( p_preference_name => ''LOGIN_MESSAGE'',',
'                                      p_preference_value => null );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to update Login Message.'
,p_process_when_button_id=>wwv_flow_imp.id(168807329606149261)
,p_process_success_message=>'Login Message updated.'
,p_internal_uid=>168810111601149270
);
end;
/
prompt --application/pages/page_00042
begin
wwv_flow_imp_page.create_page(
 p_id=>42
,p_name=>'Edit Public Theme'
,p_alias=>'EDIT-PUBLIC-THEME'
,p_step_title=>'Edit Public Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138031028642631493)
,p_plug_name=>'Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(231656925133898319)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752110265314695866)
,p_plug_name=>'Edit Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138031725433631494)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(231656925133898319)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1429076119383875907)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(231656925133898319)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Refresh Theme'
,p_button_position=>'CREATE'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138032120818631497)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(231656925133898319)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P42_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138031909392631497)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(231656925133898319)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P42_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(138035131295631504)
,p_branch_action=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138032320063631498)
,p_name=>'P42_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(138031028642631493)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(148842116797733609)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138032507109631498)
,p_name=>'P42_THEME_ID'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(138031028642631493)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Number'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The number uniquely identifies a theme within a workspace. You must enter a value greater than 100.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138033017002631498)
,p_name=>'P42_THEME_NAME'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_imp.id(138031028642631493)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'THEME_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the workspace theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138033530776631499)
,p_name=>'P42_THEME_DESCRIPTION'
,p_item_sequence=>41
,p_item_plug_id=>wwv_flow_imp.id(138031028642631493)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'THEME_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'A short description of the theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2026325277918671801)
,p_name=>'P42_REFERENCE_ID'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(138031028642631493)
,p_use_cache_before_default=>'NO'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(138034118219631500)
,p_validation_name=>'P42_THEME_ID not null'
,p_validation_sequence=>30
,p_validation=>'P42_THEME_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Theme Number must have some value.'
,p_associated_item=>wwv_flow_imp.id(138032507109631498)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(138034321549631503)
,p_validation_name=>'P42_THEME_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P42_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Theme Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(138033017002631498)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(138034819862631504)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_THEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_THEMES'
,p_attribute_03=>'P42_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>138034819862631504
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(138034431628631503)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'apply changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.change_public_theme (',
'   p_id           => :P42_ID,',
'   p_theme_name   => :P42_THEME_NAME,',
'   p_theme_number => :P42_THEME_ID,',
'   p_theme_desc   => :P42_THEME_DESCRIPTION);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(138032120818631497)
,p_process_success_message=>'Action Processed'
,p_internal_uid=>138034431628631503
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(138034606078631504)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.delete_public_theme (',
'p_id=>:P42_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(138031909392631497)
,p_process_success_message=>'Action Processed'
,p_internal_uid=>138034606078631504
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1429076290019875908)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'null;',
'-- to be completed'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing theme'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1429076119383875907)
,p_process_success_message=>'Theme refreshed'
,p_internal_uid=>1429076290019875908
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1331351348942223315)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P42_REFERENCE_ID,',
'    p_subscribing_theme_id => :P42_ID',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing theme.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1429076119383875907)
,p_process_success_message=>'Theme refreshed successfully.'
,p_internal_uid=>1331351348942223315
);
end;
/
prompt --application/pages/page_00043
begin
wwv_flow_imp_page.create_page(
 p_id=>43
,p_name=>'Application Changes by Developer'
,p_alias=>'APPLICATION-CHANGES-BY-DEVELOPER'
,p_step_title=>'Application Changes by Developer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472582008463696710)
,p_plug_name=>'Application Changes by Workspace and Developer'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P43a */',
'a.flow_user uu, ',
'c.short_name,                            ',
'count(*) c ,',
'min(a.audit_date) first_change,',
'max(a.audit_date) last_change,',
'count(distinct FLOW_ID) applications,',
'count(distinct page_id) pages,',
'count(distinct FLOW_TABLE) components',
'from ',
'   wwv_flow_builder_audit_trail a, ',
'   wwv_flow_companies c ',
'where ',
'  c.provisioning_company_id = a.security_group_id  ',
'group by a.flow_user ,c.short_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472582126350696710)
,p_name=>'Application Changes by Workspace and Developer'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472582407921696718)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472582311966696717)
,p_db_column_name=>'UU'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472582531424696719)
,p_db_column_name=>'C'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472582615030696720)
,p_db_column_name=>'FIRST_CHANGE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'First Change'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472582728052696722)
,p_db_column_name=>'LAST_CHANGE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Last Change'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472582829521696723)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472582912769696724)
,p_db_column_name=>'PAGES'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472583000344696725)
,p_db_column_name=>'COMPONENTS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Components'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472583920194698919)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314401955536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:UU:C:FIRST_CHANGE:LAST_CHANGE:APPLICATIONS:PAGES:COMPONENTS'
,p_sort_column_1=>'SHORT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_worksheet_condition(
 p_id=>wwv_flow_imp.id(472584803487713037)
,p_report_id=>wwv_flow_imp.id(472583920194698919)
,p_condition_type=>'FILTER'
,p_allow_delete=>'Y'
,p_column_name=>'LAST_CHANGE'
,p_operator=>'is in the last'
,p_expr_type=>'VALUE'
,p_expr=>'1'
,p_expr2=>'days'
,p_condition_sql=>'"LAST_CHANGE" between localtimestamp - numtodsinterval(1 * #APXWS_EXPR#,  ''day'') and localtimestamp'
,p_condition_display=>'#APXWS_COL_NAME# #APXWS_OP_NAME# 1 #APXWS_EXPR2_NAME#'
,p_enabled=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(982232095154899644)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(472582008463696710)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:RP,RIR,43:::'
);
end;
/
prompt --application/pages/page_00044
begin
wwv_flow_imp_page.create_page(
 p_id=>44
,p_name=>'Page Views by Application'
,p_alias=>'MON_BY_FLOW'
,p_step_title=>'Page Views by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(134117404639991595)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|3,3,4\1,2|',
'',
'&nbsp;:',
'',
'<font class="nounderline" color="black">CompanyShortName</font>:',
'',
'<font class="nounderline" color="green">Users</font>:',
'',
'<font class="nounderline" color="green">Developers</font>:',
'',
'<font class="nounderline" color="green">Flows</font>:<font color=green>ProvStatus</font>:',
'',
'<font class="nounderline" color="black">CompanyID</font>:'))
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_item=>'F4050_P1_ROWS'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:L:R:R:R:L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192033217981888915)
,p_plug_name=>'Page Views by Application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_views as (select /* APEX 4050P44a */ count(*) tv from wwv_flow_activity_log',
'where  time_stamp >= (select sysdate - to_number(:F4050_P44_DAYS) x from dual) and page_mode != ''A'')',
'select f.name,  x.flow_id application, x.c page_views, f.security_group_id, 100*x.c/tv pct, round(100*x.c/tv ) graph, c.short_name',
'from (',
'select flow_id, count(*) c',
'from   wwv_flow_activity_log',
'where  time_stamp >= (select sysdate - to_number(:F4050_P44_DAYS) x from dual) and page_mode != ''A''',
'group by flow_id) x, ',
'wwv_flows f,',
'total_views,',
'wwv_flow_companies c',
'where x.flow_id = f.id and f.security_group_id = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'F4050_P44_DAYS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192033331944888915)
,p_name=>'Page Views by Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192034113082888923)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'G'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192033623344888919)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192033532146888918)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192033832304888920)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192033721853888920)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192033914686888921)
,p_db_column_name=>'PCT'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192034012312888922)
,p_db_column_name=>'GRAPH'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192034427063894138)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314506258536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:APPLICATION:NAME:SECURITY_GROUP_ID:PAGE_VIEWS:PCT:GRAPH'
,p_sort_column_1=>'PAGE_VIEWS'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(134122621233999084)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(134117404639991595)
,p_button_name=>'F4050_P44_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(192030007015841102)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(134117404639991595)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:RP,44,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(134120128565995681)
,p_name=>'F4050_P44_DAYS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(134117404639991595)
,p_item_default=>'1'
,p_prompt=>'Include'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Set</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(514940572159998801)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P44_DAYS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:F4050_P44_DAYS);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00045
begin
wwv_flow_imp_page.create_page(
 p_id=>45
,p_name=>'Page Views by External Site'
,p_alias=>'TOP_CLICKS'
,p_step_title=>'Page Views by External Site'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(7686024329483531)
,p_name=>'Page Views by External Site'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_clicks as (',
'select /* APEX 4050P45a */ count(*) tc',
'from wwv_flow_clickthru_log_v ',
'where clickdate >= (sysdate - (select :F4050_P45_DAYS from dual)) )',
'select  category, count(*) clicks, 100*count(*)/max(tc) pct, 100*count(*)/max(tc) graph',
'from wwv_flow_clickthru_log_v , total_clicks',
'where clickdate >= (sysdate - (select :F4050_P45_DAYS from dual)) ',
'group by category'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no data'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7686327013483538)
,p_query_column_id=>1
,p_column_alias=>'CATEGORY'
,p_column_display_sequence=>1
,p_column_heading=>'Category'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7686410853483538)
,p_query_column_id=>2
,p_column_alias=>'CLICKS'
,p_column_display_sequence=>2
,p_column_heading=>'Clicks'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7690220436501333)
,p_query_column_id=>3
,p_column_alias=>'PCT'
,p_column_display_sequence=>3
,p_column_heading=>'Percentage'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7690321393501333)
,p_query_column_id=>4
,p_column_alias=>'GRAPH'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_column_format=>'PCT_GRAPH'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145277907592163494)
,p_plug_name=>'External Click Counting'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This page reports user clicks on links to external sites.   These clicks were captured using the &PRODUCT_NAME. procedure <code>APEX_UTIL.COUNT_CLICK</code>, or by list items which are configured to count clicks.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(190854513377597141)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(145349821954263192)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(190854513377597141)
,p_button_name=>'F4050_P45_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(145345501048257700)
,p_name=>'F4050_P45_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(190854513377597141)
,p_item_default=>'1'
,p_prompt=>'Include'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00046
begin
wwv_flow_imp_page.create_page(
 p_id=>46
,p_name=>'SQL Workshop Logs'
,p_alias=>'SQL-WORKSHOP-LOGS'
,p_step_title=>'SQL Workshop Logs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22617807253644948)
,p_plug_name=>'SQL Workshop Logs'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result wwv_flow_t_clob_writer := wwv_flow_t_clob_writer();',
'begin',
'',
'    l_result.prn(''<table class="instructiontext" role="presentation">'');',
'    l_result.prn(''<tr>'');',
'    l_result.prn(''<td align="right">'');',
'    l_result.prn(''<a href="'' || wwv_flow_utilities.prepare_url(''f?p=4050:75:'' || :flow_session || ''::::P75_LOG_TYPE:SCRIPT'') ',
'                                || ''">'' || wwv_flow_lang_dev.builder_message(''4050_46_SCRIPT_FILE'') || ''</a>'' || '':'' );',
'',
'    l_result.prn(''</td>'');',
'    l_result.prn(''<td align="left">'');',
'',
'    for c1 in ( ',
'        select count(*) cnt_result',
'          from wwv_flow_sw_results )',
'    loop            ',
'        l_result.prn(to_char(c1.cnt_result, ''999,999,999,999,990''));',
'    end loop;',
'    ',
'    l_result.prn(''</td>'');',
'    l_result.prn(''</tr>'');',
'    l_result.prn(''<tr>'');',
'    l_result.prn(''<td align="right">'');',
'    l_result.prn(''<a href="'' || wwv_flow_utilities.prepare_url(''f?p=4050:75:'' || :flow_session',
'                              || ''::::P75_LOG_TYPE:HISTORY'')',
'                              || ''">'' || wwv_flow_lang_dev.builder_message(''4050_46_AD_HOC'') || ''</a>'' || '':'' );',
'    l_result.prn(''</td>'');',
'    l_result.prn(''<td align="left">'');',
'',
'    for c1 in ( ',
'        select count(*) cnt_result',
'          from wwv_flow_sw_sql_cmds)',
'    loop',
'        l_result.prn(to_char(c1.cnt_result, ''999,999,999,999,990''));',
'    end loop;',
'',
'    l_result.prn(''</td>'');',
'    l_result.prn(''</tr>'');',
'    l_result.prn(''</table>'');',
'    l_result.flush;',
'    return l_result.get_value;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22619003706662819)
,p_plug_name=>'SQL Workshop Logs'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'The SQL Workshop maintains a history of SQL statements.  This history is available SQL Workshop users in the history utility.  This table can be truncated to reduce space utilization.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982232116190899645)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1080989976388523932)
,p_plug_name=>'SQL Workshop Logs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(161897913639838567)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(982232116190899645)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22620213748665756)
,p_branch_action=>'46'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00047
begin
wwv_flow_imp_page.create_page(
 p_id=>47
,p_name=>'Create Public Theme - Workspace'
,p_alias=>'CREATE-PUBLIC-THEME-WORKSPACE'
,p_step_title=>'Create Public Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138041907898643265)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(138045104803643281)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138042300956643271)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Public themes are themes available to all workspaces.  When creating applications, developers will have the option to select a public theme in addition to the &PRODUCT_NAME. themes and any workspace themes. ',
'<p/>',
'Identify the workspace that owns the application theme to be copied into the public theme repository.',
'<p/>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208270002919476408)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752110359958695866)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138043401976643278)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208270002919476408)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138043000845643273)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208270002919476408)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(138044704585643280)
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(138043000845643273)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138044131207643279)
,p_name=>'P47_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(138042300956643271)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_DEVELOPER_WORKSPACES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id not in (0,10,11, 12)',
'order by 1'))
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the workspace in which the application theme to be copied resides.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(138164321008022878)
,p_validation_name=>'P47_WORKSPACE'
,p_validation_sequence=>10
,p_validation=>'P47_WORKSPACE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Workspace must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(138043000845643273)
,p_associated_item=>wwv_flow_imp.id(138044131207643279)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00048
begin
wwv_flow_imp_page.create_page(
 p_id=>48
,p_name=>'Create Public Theme - Name'
,p_alias=>'CREATE-PUBLIC-THEME-NAME'
,p_step_title=>'Create Public Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138052410467655077)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>You can change the name and number for the new public theme to be created.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138052802537655078)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(138045104803643281)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(138053023370655078)
,p_name=>'Existing Public Themes'
,p_template=>wwv_flow_imp.id(202654901374384775)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.theme_id,',
'       t.theme_name,',
'       t.theme_description',
'  from wwv_flow_themes t, wwv_flows f',
' where t.flow_id = f.id',
'   and f.application_type = ''STANDARD''',
'   and t.theme_security_group_id is null',
'   and f.security_group_id = 11',
' order by t.theme_id',
' ',
' '))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where theme_security_group_id is null',
'   and security_group_id = 11'))
,p_display_condition_type=>'EXISTS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(6897002870390711)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Public Themes exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(138053207858655079)
,p_query_column_id=>1
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Number'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(138053325066655079)
,p_query_column_id=>2
,p_column_alias=>'THEME_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(138053423313655079)
,p_query_column_id=>3
,p_column_alias=>'THEME_DESCRIPTION'
,p_column_display_sequence=>3
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208271825344501885)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752110451825695867)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138054212644655080)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208271825344501885)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138054424254655080)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208271825344501885)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138054000479655080)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208271825344501885)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(138057525436655086)
,p_branch_action=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(138054000479655080)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138054611163655081)
,p_name=>'P48_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(138052410467655077)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Selected Theme:'
,p_source=>'P58_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||theme_name d, theme_id',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'  and flow_id = :P57_APPLICATION',
'order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to be copied to the workspace theme repository.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138055124156655081)
,p_name=>'P48_THEME_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(138052410467655077)
,p_prompt=>'Theme Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_name',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'   and flow_id = :P57_APPLICATION',
'   and theme_id = :P58_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the workspace theme, this name can be the same or different from the application theme name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138055609809655082)
,p_name=>'P48_THEME_NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(138052410467655077)
,p_prompt=>'Theme Number'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(greatest(theme_id,99),99,theme_id+100,theme_id) theme_id',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'   and flow_id = :P57_APPLICATION',
'   and theme_id = :P58_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The number uniquely identifies a theme within a workspace.  You must enter a value greater than 100.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138056117408655083)
,p_name=>'P48_DESCRIPTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(138052410467655077)
,p_prompt=>'Description'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select THEME_DESCRIPTION',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'   and flow_id = :P57_APPLICATION',
'   and theme_id = :P58_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'A short description of the theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138251117956901802)
,p_name=>'P48_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(138052410467655077)
,p_prompt=>'Workspace:'
,p_source=>'P47_WORKSPACE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the workspace in which the application theme to be copied resides.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138252024536903773)
,p_name=>'P48_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(138052410467655077)
,p_prompt=>'Application:'
,p_source=>'P57_APPLICATION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PUBLIC.THEME.APP.SELECTOR'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id v',
'  from WWV_FLOWS',
' where security_group_id = :P47_WORKSPACE',
'   and security_group_id not in (0,10,11)',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application in which the theme to be copied resides.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(138057110365655085)
,p_validation_name=>'P48_THEME_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P48_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(138055124156655081)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 28-NOV-2007 17:59'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(138057314081655085)
,p_validation_name=>'P48_THEME_NUMBER Not Null'
,p_validation_sequence=>20
,p_validation=>'P48_THEME_NUMBER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(138055609809655082)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 28-NOV-2007 17:59'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(138056920473655085)
,p_validation_name=>'valid theme number'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :P48_THEME_NUMBER < 100 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be 100 or greater.'
,p_when_button_pressed=>wwv_flow_imp.id(138054000479655080)
,p_associated_item=>wwv_flow_imp.id(138055609809655082)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(138056707385655083)
,p_validation_name=>'theme number unique (edit me)'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where theme_id = :P48_THEME_NUMBER',
'   and security_group_id = 11',
'   and theme_security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The number must be unique within a workspace.'
,p_when_button_pressed=>wwv_flow_imp.id(138054000479655080)
,p_associated_item=>wwv_flow_imp.id(138055609809655082)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00049
begin
wwv_flow_imp_page.create_page(
 p_id=>49
,p_name=>'Page Views by Application and User'
,p_alias=>'PAGE-VIEWS-BY-APPLICATION-AND-USER'
,p_step_title=>'Page Views by Application and User'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(68967412200798364)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings=>'Company:Flow:User:Avg:Max:Min:Count'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:R:R:R:R'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192019632350715193)
,p_plug_name=>'Page Views by Workspace, Application and User'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P49a */',
'    w.short_name,',
'    l.flow_id,',
'    l.userid,',
'    avg(l.elap) avg_elap,',
'    median(l.elap) median_elap,',
'    max(l.elap) max_elap,',
'    min(l.elap) min_elap,',
'    count(*) c,',
'    sum(nvl(content_length,0)) content_length',
'from WWV_FLOW_ACTIVITY_LOG l, wwv_flow_companies w ',
'where l.time_stamp > (sysdate - nvl(:F4050_P49_SINCE,1))',
'  and w.provisioning_company_id=l.security_group_id',
'  and page_mode != ''A''',
'group by l.userid,l.flow_id,w.short_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'F4050_P49_SINCE'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192019712989715193)
,p_name=>'Page Views by Workspace, Application and User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192019920820715257)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192020010055715261)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192020113630715262)
,p_db_column_name=>'USERID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192020207889715262)
,p_db_column_name=>'AVG_ELAP'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Average Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(499022627220371913)
,p_db_column_name=>'MEDIAN_ELAP'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Median Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990D999'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192020314500715263)
,p_db_column_name=>'MAX_ELAP'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Maximum Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192020414767715264)
,p_db_column_name=>'MIN_ELAP'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Minimum Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192020521781715265)
,p_db_column_name=>'C'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200533800068843164)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192020730808715447)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314627173536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:FLOW_ID:USERID:MEDIAN_ELAP:MAX_ELAP:MIN_ELAP:C:CONTENT_LENGTH'
,p_sort_column_1=>'C'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(68983926625822046)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(68967412200798364)
,p_button_name=>'F4050_P49_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(192027532380829469)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(68967412200798364)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:49,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68978320814809562)
,p_name=>'F4050_P49_SINCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(68967412200798364)
,p_item_default=>'1'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Set</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(276960932086906566)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P49_SINCE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
,p_compute_when=>'F4050_P49_SINCE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38536518152143458)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rest pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>38536518152143458
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_imp_page.create_page(
 p_id=>50
,p_name=>'Activity by Application'
,p_alias=>'ACTIVITY-BY-APPLICATION'
,p_step_title=>'Activity by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1081487685020772212)
,p_plug_name=>'Activity by Application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    WORKSPACE_ID workspace,',
'    min(LOG_DAY) first_day,',
'    max(log_day) last_day,',
'    (select short_name from wwv_flow_companies where provisioning_company_id = workspace_id) workspace_name,',
'    APPLICATION_ID applications,',
'    (select max(name) from wwv_flows where id = application_id) application_name,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'where log_day >= sysdate - (NVL(:P50_SINCE,365) + 1)',
'group by workspace_id, application_id'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1081487887243772215)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1081487887243772215
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880154177420277485)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880154509535277486)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880160928322277496)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'U'
,p_column_label=>'Public Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880154952458277486)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880155310320277487)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Page Posts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880155784363277489)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880156577105277490)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Rows Fetched'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880156927005277490)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>'Interactive Report Searches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880157319628277491)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880157763288277491)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880158149745277492)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880158590150277493)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Total Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880158971246277494)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880159314715277494)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880159712423277494)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880160110386277495)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(880160557330277495)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>165
,p_column_identifier=>'T'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(758054560886278413)
,p_db_column_name=>'FIRST_DAY'
,p_display_order=>175
,p_column_identifier=>'V'
,p_column_label=>'First day'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(758054693598278414)
,p_db_column_name=>'LAST_DAY'
,p_display_order=>185
,p_column_identifier=>'W'
,p_column_label=>'Last day'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1081489687315772235)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'8801613'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:APPLICATIONS:APPLICATION_NAME:PAGE_EVENTS:ROWS_FETCHED:DISTINCT_PAGES:DISTINCT_USERS:DISTINCT_SESSIONS:ERROR_COUNT:CONTENT_LENGTH::FIRST_DAY:LAST_DAY'
,p_sort_column_1=>'PAGE_EVENTS'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'LOG_DAY'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1638217419722573136)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(880163742133294728)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1638217419722573136)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(880161731332277508)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1081487685020772212)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:77,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(880164170584294729)
,p_name=>'P50_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1638217419722573136)
,p_item_default=>'365'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_imp_page.create_page(
 p_id=>51
,p_name=>'Create Public Theme - Confirm'
,p_alias=>'CREATE-PUBLIC-THEME-CONFIRM'
,p_step_title=>'Create Public Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138063615372663615)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(138045104803643281)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138063831884663615)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Any missing template classes indicates that the selected theme is incomplete.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208277100719542102)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752110574623695867)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138065123623663617)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208277100719542102)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138064919629663617)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208277100719542102)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138065416670663617)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208277100719542102)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Public Theme'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(138067408337663624)
,p_branch_action=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138066127066663621)
,p_name=>'P51_THEME_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(138063831884663615)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme Name:'
,p_source=>'&P48_THEME_NAME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the name of the workspace theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138066630251663622)
,p_name=>'P51_THEME_NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(138063831884663615)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme Number:'
,p_source=>'&P48_THEME_NUMBER.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme number of the workspace theme.  These numbers are used to uniquely identify a theme within a workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(138067113086663622)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create public theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.create_new_public_theme (',
'   p_workspace_id     => :P47_WORKSPACE,',
'   p_app_id           => :P57_APPLICATION,',
'   p_app_theme_id     => :P58_THEME,',
'   p_theme_name       => :P48_THEME_NAME,',
'   p_theme_number     => :P48_THEME_NUMBER,',
'   p_theme_desc       => :P48_DESCRIPTION,',
'   p_subscribe_theme  => :P58_SUBSCRIBE_THEME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_process_when_button_id=>wwv_flow_imp.id(138065416670663617)
,p_process_success_message=>'Public Theme Created'
,p_internal_uid=>138067113086663622
);
end;
/
prompt --application/pages/page_00052
begin
wwv_flow_imp_page.create_page(
 p_id=>52
,p_name=>'Workspace Components'
,p_alias=>'WORKSPACE-COMPONENTS'
,p_step_title=>'Workspace Components'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_comp.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(173284328782752219)
,p_plug_name=>'Workspace Components'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4050P52a */',
'  "ID", ',
'  "PROVISIONING_COMPANY_ID",',
'  "SHORT_NAME",',
'  "FIRST_SCHEMA_PROVISIONED",',
'  decode(nvl(ALLOW_PLSQL_EDITING,''Y''),''Y'',m.yes,m.n) ALLOW_PLSQL_EDITING,',
'  "LAST_LOGIN",',
'  "BUILDER_NOTIFICATION_MESSAGE",',
'  decode(nvl(ALLOW_APP_BUILDING_YN,''Y''),''Y'',m.yes,m.n) ALLOW_APP_BUILDING_YN,',
'  decode(nvl(ALLOW_SQL_WORKSHOP_YN,''Y''),''Y'',m.yes,m.n) ALLOW_SQL_WORKSHOP_YN,',
'  decode(nvl(ALLOW_TEAM_DEVELOPMENT_YN,''Y''),''Y'',m.yes,m.n) ALLOW_TEAM_DEVELOPMENT_YN',
'from WWV_FLOW_COMPANIES w,',
'    (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
'where provisioning_company_id not in (0, 10, 11, 12)  ',
''))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(173284520699752220)
,p_name=>'Workspace Components'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173284618560752223)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173284700127752227)
,p_db_column_name=>'PROVISIONING_COMPANY_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Security Group ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173284830050752228)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Workspace'
,p_column_link=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.::P59_ID,LAST_VIEW:#ID#,52'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173284913038752228)
,p_db_column_name=>'FIRST_SCHEMA_PROVISIONED'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'First Schema Provisioned'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173285002538752229)
,p_db_column_name=>'ALLOW_PLSQL_EDITING'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Allow PL/SQL Editing'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173285119516752229)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Last Login'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173285522534752235)
,p_db_column_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Builder Notification Message'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173285614402752236)
,p_db_column_name=>'ALLOW_APP_BUILDING_YN'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Allow Application Building'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173285717153752236)
,p_db_column_name=>'ALLOW_SQL_WORKSHOP_YN'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Allow SQL Workshop'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(173285911306752238)
,p_db_column_name=>'ALLOW_TEAM_DEVELOPMENT_YN'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Allow Team Development'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(173286224609752460)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314703771536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:ALLOW_APP_BUILDING_YN:ALLOW_SQL_WORKSHOP_YN:ALLOW_PLSQL_EDITING:ALLOW_TEAM_DEVELOPMENT_YN'
,p_sort_column_1=>'SHORT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(484952701077761252)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(173284328782752219)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:52,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(173287818900788701)
,p_branch_action=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(173291107088832520)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'52'
);
end;
/
prompt --application/pages/page_00053
begin
wwv_flow_imp_page.create_page(
 p_id=>53
,p_name=>'Reset Password'
,p_alias=>'RESET-PASSWORD'
,p_step_title=>'Reset Password'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216787602191653217)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_users.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(71896102812290746)
,p_plug_name=>'Reset Password'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(71892807988288321)
,p_name=>'User Information'
,p_parent_plug_id=>wwv_flow_imp.id(71896102812290746)
,p_template=>wwv_flow_imp.id(721115784857730284)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:is-expanded:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_name,',
'       first_name,',
'       last_name,',
'       description,',
'       email_address,',
'       default_schema,',
'       security_group_id',
'  from wwv_flow_fnd_user',
' where user_id = :F4050_P53_USER_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48946423742773239)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'User Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48946512249773239)
,p_query_column_id=>2
,p_column_alias=>'FIRST_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'First Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48946614685773239)
,p_query_column_id=>3
,p_column_alias=>'LAST_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Last Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48946718700773239)
,p_query_column_id=>4
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>4
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48946830175773239)
,p_query_column_id=>5
,p_column_alias=>'EMAIL_ADDRESS'
,p_column_display_sequence=>5
,p_column_heading=>'Email'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48946902018773239)
,p_query_column_id=>6
,p_column_alias=>'DEFAULT_SCHEMA'
,p_column_display_sequence=>6
,p_column_heading=>'Default Schema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48947006063773239)
,p_query_column_id=>7
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(71920520447343310)
,p_plug_name=>'Reset Password'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Reset user''s password by generating a random password or entering a new password. Email will be sent to the user to notify that the password has been changed.'
,p_plug_query_headings=>'User Name:First Name:Last Name:Description:Email:Default Schema:Security Group ID'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_mail.is_email_configured'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222860680683540034)
,p_plug_name=>'Reset Password'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Reset user''s password by generating a random password or entering a new password.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_mail.is_email_configured'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(71928331765356926)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(71896102812290746)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:53::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(71930910079360146)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(71896102812290746)
,p_button_name=>'Save'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Change Password'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(71931303937360148)
,p_branch_action=>'12'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(71898928679293879)
,p_name=>'P53_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(71896102812290746)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter new password.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(71906923922311296)
,p_name=>'F4050_P53_USER_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(71892807988288321)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(481109527842703479)
,p_name=>'P53_PASSWORD2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(71896102812290746)
,p_prompt=>'Confirm Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password again.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(481110803517715438)
,p_name=>'P53_PASSWORD_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(71896102812290746)
,p_item_default=>'G'
,p_prompt=>'Password Type:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'RESET PASSWORD TYPE'
,p_lov=>'.'||wwv_flow_imp.id(25472316973371525)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select whether you want to generate the new password or enter one.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(481155122573796532)
,p_name=>'P53_GEN_PASSWORD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(71896102812290746)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_provision.get_random_password(6)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(71901726307295001)
,p_validation_name=>'P53_PASSWORD Not Null'
,p_validation_sequence=>10
,p_validation=>'P53_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Password must be specified.'
,p_validation_condition=>'P53_PASSWORD_TYPE'
,p_validation_condition2=>'D'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(71898928679293879)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-JUL-2002 09:59'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(481133310836745905)
,p_validation_name=>'P53_PASSWORD2 Not Null'
,p_validation_sequence=>20
,p_validation=>'P53_PASSWORD2'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Confirm Password must be specified.'
,p_validation_condition=>'P53_PASSWORD_TYPE'
,p_validation_condition2=>'D'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(481109527842703479)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-JUL-2002 09:59'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(481134317678766766)
,p_validation_name=>'P53_PASSWORD matches P53_PASSWORD2'
,p_validation_sequence=>30
,p_validation=>':P53_PASSWORD = :P53_PASSWORD2'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Password not properly confirmed, enter the password two times exactly the same.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P53_PASSWORD is not null and',
':P53_PASSWORD2 is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(71898928679293879)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(481158606821829923)
,p_name=>'hide password'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P53_PASSWORD_TYPE'
,p_condition_element=>'P53_PASSWORD_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'G'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(481158912890829933)
,p_event_id=>wwv_flow_imp.id(481158606821829923)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P53_PASSWORD,P53_PASSWORD2'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(481159325998844871)
,p_name=>'show password'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P53_PASSWORD_TYPE'
,p_condition_element=>'P53_PASSWORD_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'D'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(481159613309844872)
,p_event_id=>wwv_flow_imp.id(481159325998844871)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P53_PASSWORD,P53_PASSWORD2'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(71891512517286221)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update passwd'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P53_PASSWORD_TYPE = ''D'' then',
'',
'begin',
'  wwv_flow_imp.g_fnd_user_password_action := true;',
'  update wwv_flow_fnd_user ',
'     set web_password = :P53_PASSWORD,',
'         change_password_on_first_use = ''Y'', ',
'         first_password_use_occurred = ''N''',
'   where user_id = :F4050_P53_USER_ID;',
'  wwv_flow_imp.g_fnd_user_password_action := false;',
'exception when others then  ',
'  wwv_flow.update_cache_with_write(''P53_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''P53_PASSWORD2'',null);',
'  wwv_flow.update_cache_with_write(''P53_GEN_PASSWORD'',null);',
'  raise_application_error(-20001,wwv_flow_lang.system_message(''WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR''));',
'end;',
'',
'else',
'',
'begin',
'  wwv_flow_imp.g_fnd_user_password_action := true;',
'  update wwv_flow_fnd_user ',
'     set web_password = :P53_GEN_PASSWORD,',
'         change_password_on_first_use = ''Y'', ',
'         first_password_use_occurred = ''N''',
'   where user_id = :F4050_P53_USER_ID;',
'  wwv_flow_imp.g_fnd_user_password_action := false;',
'exception when others then',
'  wwv_flow.update_cache_with_write(''P53_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''P53_PASSWORD2'',null);',
'  wwv_flow.update_cache_with_write(''P53_GEN_PASSWORD'',null);',
'',
' raise_application_error(-20001,wwv_flow_lang.system_message(''WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR''));',
'end;',
'',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error resetting password.'
,p_process_when=>'nvl(:REQUEST,''Save'') = ''Save'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Password reset.  '
,p_internal_uid=>71891512517286221
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(71951012622422885)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'send email'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_msg    varchar2(4000);',
'   l_subj   varchar2(255);',
'   l_p      varchar2(256);     ',
'begin',
'if :P53_PASSWORD_TYPE = ''D'' then',
'   l_p := v(''P53_PASSWORD'');',
'else',
'   l_p := v(''P53_GEN_PASSWORD'');',
'end if;',
'   ',
'wwv_flow.update_cache_with_write(''P53_PASSWORD'',null);',
'wwv_flow.update_cache_with_write(''P53_PASSWORD2'',null);',
'wwv_flow.update_cache_with_write(''P53_GEN_PASSWORD'',null);',
'',
'for  c1 in (select user_name, last_name, first_name, email_address, security_group_id',
'            from wwv_flow_fnd_user',
'            where user_id = :F4050_P53_USER_ID) ',
'loop',
'  l_subj:= wwv_flow_lang.system_message(''F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'');',
'  l_msg:=l_msg || wwv_flow_lang.system_message(''F4050_EMAIL_BODY_PASSWORD_CHANGED'',c1.user_name) || ',
'          chr(10) || chr(10);',
'  l_msg:=l_msg || wwv_flow_lang.system_message(''F4050_EMAIL_BODY_NEW_PASSWORD'')||'':  '' || l_p || ',
'          chr(10) || chr(10);',
'',
'  l_msg:=l_msg || wwv_flow_mail.get_instance_url (p_security_group_id => c1.security_group_id ) || chr(10); ',
'',
'  wwv_flow_mail.send(p_to    => c1.email_address,                     ',
'                     p_from  => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),c1.email_address),',
'                     p_body  => l_msg,',
'                     p_subj  => l_subj,',
'                     p_cc    => null);',
'end loop;',
'wwv_flow_mail.push_queue_background;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error sending email.'
,p_process_when=>'wwv_flow_mail.is_email_configured'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Email sent.'
,p_internal_uid=>71951012622422885
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(359769230375616804)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'53'
,p_internal_uid=>359769230375616804
);
end;
/
prompt --application/pages/page_00054
begin
wwv_flow_imp_page.create_page(
 p_id=>54
,p_name=>'Page Events by Day'
,p_alias=>'PAGE-EVENTS-BY-DAY'
,p_step_title=>'Page Events by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(171237511268284524)
,p_plug_name=>'Page Events by Day'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P54a */',
'       to_char(time_stamp,''YYYY.MM.DD Day'') day, ',
'       count(*) page_events, ',
'       sum(decode(PAGE_MODE,''A'',0,1)) page_views, ',
'       count(distinct security_group_id) workspaces,',
'       sum(nvl(content_length,0)) content_length',
'from wwv_flow_activity_log l',
'where l.time_stamp>=(select sysdate - to_number(',
'nvl(:P54_INCLUDE,1)) x from dual ) ',
'group by to_char(time_stamp,''YYYY.MM.DD Day'')',
'order by 1 desc'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(171237618830284524)
,p_name=>'Page Views by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(171237827128284533)
,p_db_column_name=>'DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Day'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(171237930312284535)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(171239512278309693)
,p_db_column_name=>'WORKSPACES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Workspaces'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(171240226607323292)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200564107218911437)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(171238325044285017)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314807684536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DAY:PAGE_VIEWS:WORKSPACES:PAGE_EVENTS:PERCENTAGE:GRAPH:CONTENT_LENGTH'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200563315745904438)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(248917204401238233)
,p_plug_name=>'Page Views by Day'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This report shows all page views for this instance aggregated by day.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200570012113941288)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200563315745904438)
,p_button_name=>'P54_SET'
,p_button_static_id=>'P54_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200569504841939221)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200563315745904438)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:54,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200564508735921337)
,p_name=>'P54_INCLUDE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(200563315745904438)
,p_item_default=>'to_number(.000694444)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Time'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Set</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(514940685077998802)
,p_computation_sequence=>10
,p_computation_item=>'P54_INCLUDE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:P54_INCLUDE);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00055
begin
wwv_flow_imp_page.create_page(
 p_id=>55
,p_name=>'Approve Provision Request'
,p_alias=>'APPROVE-PROVISION-REQUEST'
,p_step_title=>'Approve Provision Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225164729934)
,p_plug_name=>'Approve'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(72893511420289265)
,p_plug_name=>'Approve Provision Request'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>20
,p_plug_source=>'Approving this request will create a database schema, create a login for a workspace administrator, and send an approval email. Please allow up to 30 seconds for account to be created.'
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(72938202558059173)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(225164729934)
,p_button_name=>'Approve'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Approve and Send Email'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(72933229308047993)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(225164729934)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:55::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(231152215417604601)
,p_branch_action=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(72938202558059173)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22117323900740039)
,p_name=>'F4050_P55_ACCEPT_MSG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(72893511420289265)
,p_prompt=>'Email Message: '
,p_source=>'wwv_flow_lang.system_message(''APEX.EMAIL.WS_REQ_APPR_INTRO'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>15
,p_display_when=>'wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW'') = ''EMAIL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72898300637294240)
,p_name=>'F4050_P55_APPROVE_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(72893511420289265)
,p_prompt=>'Email Message'
,p_source=>'wwv_flow_lang.system_message(''APEX.EMAIL.WS_REQ_APPR_READY_INTRO'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>15
,p_display_when=>'wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW'') = ''4700'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(213504146316)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Provision company now'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_developer_api.f4050_55_provision_workspace(',
'   p_provision_id       => :PROVISION_ID,',
'   p_approval_message   => :F4050_P55_APPROVE_MSG,',
'   p_acceptance_message => :F4050_P55_ACCEPT_MSG',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error provisioning workspace &P4_COMPANY_NAME..'
,p_process_when_button_id=>wwv_flow_imp.id(72938202558059173)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_schema varchar2(30);',
'begin',
'    for c1 in (select upper(schema_name) sa1',
'                 from wwv_flow_provision_company',
'                where id = :PROVISION_ID) loop',
'        l_schema := c1.sa1;',
'    end loop;',
'',
'    if l_schema is not null then        ',
'        for c1 in (select 1',
'                     from sys.dual',
'                    where wwv_flow_provisioning.restricted_schema_i(',
'                          l_schema, :P4_COMPANY_NAME) = 1',
'                      and wwv_flow_provisioning.site_admin_is_restricted_i = 1) loop',
'            return false;',
'        end loop;',
'',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Workspace &P4_COMPANY_NAME. accepted and approval email sent.'
,p_internal_uid=>213504146316
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(359770518516632382)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'55'
,p_internal_uid=>359770518516632382
);
end;
/
prompt --application/pages/page_00056
begin
wwv_flow_imp_page.create_page(
 p_id=>56
,p_name=>'Decline Provision Request'
,p_alias=>'DECLINE-PROVISION-REQUEST'
,p_step_title=>'Decline Provision Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(73108300635357821)
,p_plug_name=>'Decline Provision Request'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>30
,p_plug_source=>'Declining the request will reject the workspace request and notify the requestor via email that the request has been declined. You must choose Delete Request if you wish to allow a workspace by the same name to be requested again.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955890678433997317)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73116915409365767)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(955890678433997317)
,p_button_name=>'Decline'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Decline and Send Email'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73113102942362154)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(955890678433997317)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:56::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(73117322203365771)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(73116915409365767)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73135015059381475)
,p_name=>'F4050_P56_DECLINE_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(73108300635357821)
,p_prompt=>'Email Message'
,p_source=>'wwv_flow_lang.system_message(''APEX.EMAIL.WS_REQ_DECL_INTRO'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>15
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Custom message to the Workspace requestor.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(663452364602166114)
,p_name=>'P56_DELETE_REQUEST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(73108300635357821)
,p_item_default=>'Y'
,p_prompt=>'Delete Request'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225170763161)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Decline request'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_subj             varchar2(255);',
'   l_plain_format     varchar2(32767);',
'   l_formatted_html   varchar2(32767);',
'begin',
'    wwv_flow_provisioning.deny_request(p_id => :PROVISION_ID);',
'',
'    for  c1 in (select prov.admin_email, prov.admin_first_name, prov.admin_last_name, prov.security_group_id',
'                  from wwv_flow_provision_company prov',
'                 where prov.id = :PROVISION_ID',
'                   and prov.PROJECT_STATUS = ''DECLINED'') ',
'    loop',
'          wwv_flow_mail.get_formatted_message(',
'             p_provision_id      => :PROVISION_ID,',
'             p_message_type      => ''DECLINED'',',
'             p_custom_msg        => :F4050_P56_DECLINE_MSG,',
'             out_html            => l_formatted_html,',
'             out_plain           => l_plain_format);',
'        ',
'        l_subj := wwv_flow_lang.system_message(',
'            p_name => ''F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'',',
'            p0     => c1.ADMIN_FIRST_NAME || '' '' ||c1.ADMIN_LAST_NAME',
'        );',
'',
'        wwv_flow_mail.send(',
'            p_to        => c1.admin_email,',
'            p_from      => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''), c1.admin_email),',
'            p_body      => l_plain_format,',
'            p_body_html => l_formatted_html,',
'            p_subj      => l_subj,',
'            p_cc        => null',
'        );',
'    end loop;',
'',
'    if nvl(:P56_DELETE_REQUEST,''N'') = ''Y'' then',
'        delete from wwv_flow_provision_company where id = :PROVISION_ID;',
'    end if;',
'',
'    wwv_flow_mail.push_queue_background();',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing request.'
,p_process_when_button_id=>wwv_flow_imp.id(73116915409365767)
,p_process_success_message=>'Request &P4_COMPANY_NAME. status set to declined and email sent.'
,p_internal_uid=>225170763161
);
end;
/
prompt --application/pages/page_00057
begin
wwv_flow_imp_page.create_page(
 p_id=>57
,p_name=>'Create Public Theme - Application'
,p_alias=>'CREATE-PUBLIC-THEME-APPLICATION'
,p_step_title=>'Create Public Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138136012726914164)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(138045104803643281)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138136215748914164)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Identify the application, within the selected workspace, where the theme to be copied resides.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208279100850551554)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752110668997695867)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138153021345947268)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208279100850551554)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138137300856914177)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208279100850551554)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138137124005914175)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208279100850551554)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(138139124623914184)
,p_branch_action=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(138137124005914175)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138137503839914178)
,p_name=>'P57_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(138136215748914164)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PUBLIC.THEME.APP.SELECTOR'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id v',
'  from WWV_FLOWS',
' where security_group_id = :P47_WORKSPACE',
'   and security_group_id not in (0,10,11)',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application in which the theme to be copied resides.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138175212575086624)
,p_name=>'P57_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(138136215748914164)
,p_prompt=>'Workspace:'
,p_source=>'P47_WORKSPACE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the workspace in which the application theme to be copied resides.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(138209025445194385)
,p_validation_name=>'P57_APPLICATION'
,p_validation_sequence=>10
,p_validation=>'P57_APPLICATION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(138137124005914175)
,p_associated_item=>wwv_flow_imp.id(138137503839914178)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00058
begin
wwv_flow_imp_page.create_page(
 p_id=>58
,p_name=>'Create Public Theme - Theme'
,p_alias=>'CREATE-PUBLIC-THEME-THEME'
,p_step_title=>'Create Public Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138140920605918465)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(138045104803643281)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138141116387918465)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Identify the theme to be copied into the public theme repository.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208327612465668473)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752110789883695868)
,p_plug_name=>'Create Public Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138158100614969669)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208327612465668473)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138142223665918467)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208327612465668473)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138142002007918467)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208327612465668473)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(138144008862918469)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(138142002007918467)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138142915903918468)
,p_name=>'P58_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(138141116387918465)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme to Copy'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'  and flow_id = :P57_APPLICATION',
'order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme you would like to copy to the public theme repository.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138192524789146971)
,p_name=>'P58_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(138141116387918465)
,p_prompt=>'Workspace:'
,p_source=>'P47_WORKSPACE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the workspace in which the application theme to be copied resides.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138194511068152390)
,p_name=>'P58_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(138141116387918465)
,p_prompt=>'Application:'
,p_source=>'P57_APPLICATION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PUBLIC.THEME.APP.SELECTOR'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id v',
'  from WWV_FLOWS',
' where security_group_id = :P47_WORKSPACE',
'   and security_group_id not in (0,10,11)',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application in which the theme to be copied resides.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1429076056376875906)
,p_name=>'P58_SUBSCRIBE_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(138141116387918465)
,p_item_default=>'N'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Select whether to subscribe the public theme to the selected theme. This allows for updating the public theme with changes to the selected theme in the future.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00059
begin
wwv_flow_imp_page.create_page(
 p_id=>59
,p_name=>'Workspace Settings'
,p_alias=>'WORKSPACE-SETTINGS'
,p_step_title=>'Workspace Settings'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(704456563630760825)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_comp.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(173281331752752178)
,p_plug_name=>'Workspace Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(173288117299797704)
,p_plug_name=>'Workspace Settings &P59_SHORT_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(173290507996823360)
,p_plug_name=>'Workspace Message'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(502221800416182760)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Control component availability by workspace.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955890812785997319)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(195775112470763477)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(173281732345752184)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(173288117299797704)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(173281530427752183)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(173288117299797704)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P59_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(173281906971752184)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173282117191752185)
,p_name=>'P59_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(173281331752752178)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173282307369752201)
,p_name=>'P59_BUILDER_NOTIFICATION_MESSA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(173290507996823360)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Message'
,p_source=>'BUILDER_NOTIFICATION_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a message to be displayed on the home page of this workspace and in the App Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173282502471752203)
,p_name=>'P59_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(173281331752752178)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Enable App Builder'
,p_source=>'ALLOW_APP_BUILDING_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determines availability of the App Builder for this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173282723495752204)
,p_name=>'P59_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(173281331752752178)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Enable SQL Workshop'
,p_source=>'ALLOW_SQL_WORKSHOP_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determines availability of the SQL Workshop for this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173283131136752205)
,p_name=>'P59_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(173281331752752178)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Enable Team Development'
,p_source=>'ALLOW_TEAM_DEVELOPMENT_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determines availability of the Team Development for this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(500066311950007719)
,p_name=>'P59_ALLOW_PLSQL_EDITING_YN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(173281331752752178)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Allow PL/SQL Editing in SQL Workshop'
,p_source=>'ALLOW_PLSQL_EDITING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Allow PL/SQL procedures, packages, functions, and triggers to be edited in the browser.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(955890992447997320)
,p_name=>'P59_SHORT_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(173281331752752178)
,p_use_cache_before_default=>'NO'
,p_source=>'SHORT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(378102002917566360)
,p_computation_sequence=>20
,p_computation_item=>'P59_ALLOW_PLSQL_EDITING_YN'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P59_ALLOW_SQL_WORKSHOP_YN'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504251027783126810)
,p_name=>'Show/Hide Allow PLSQL'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P59_ALLOW_SQL_WORKSHOP_YN'
,p_condition_element=>'P59_ALLOW_SQL_WORKSHOP_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504251307730126815)
,p_event_id=>wwv_flow_imp.id(504251027783126810)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P59_ALLOW_PLSQL_EDITING_YN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504251508368126817)
,p_event_id=>wwv_flow_imp.id(504251027783126810)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P59_ALLOW_PLSQL_EDITING_YN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(173283405938752205)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P59_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>173283405938752205
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(173283624443752206)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P59_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_COMPANIES.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>173283624443752206
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(173283826209752207)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'59'
,p_internal_uid=>173283826209752207
);
end;
/
prompt --application/pages/page_00061
begin
wwv_flow_imp_page.create_page(
 p_id=>61
,p_name=>'Page View Activity Logs'
,p_alias=>'PAGE-VIEW-ACTIVITY-LOGS'
,p_step_title=>'Page View Activity Logs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2613425363735338)
,p_name=>'Log Status'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1: WWV_FLOW_ACTIVITY_LOG1$'' as log_tracker,',
'       min(time_stamp) as first_entry,',
'       max(time_stamp) as last_entry,',
'       count(*) as count_logs',
'  from wwv_flow_activity_log1$',
'union all',
'select ''2: WWV_FLOW_ACTIVITY_LOG2$'' as log_tracker,',
'       min(time_stamp) as first_entry,',
'       max(time_stamp) as last_entry,',
'       count(*) as count_logs',
'  from wwv_flow_activity_log2$'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>2
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'n/a'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201785027668012)
,p_query_column_id=>1
,p_column_alias=>'LOG_TRACKER'
,p_column_display_sequence=>10
,p_column_heading=>'Log Tracker'
,p_use_as_row_header=>'Y'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201867717668013)
,p_query_column_id=>2
,p_column_alias=>'FIRST_ENTRY'
,p_column_display_sequence=>20
,p_column_heading=>'First Entry'
,p_use_as_row_header=>'N'
,p_column_format=>'&LONG_DATE_FORMAT. &TIME_FORMAT.'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8201913457668014)
,p_query_column_id=>3
,p_column_alias=>'LAST_ENTRY'
,p_column_display_sequence=>30
,p_column_heading=>'Last Entry'
,p_use_as_row_header=>'N'
,p_column_format=>'&LONG_DATE_FORMAT. &TIME_FORMAT.'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202069661668015)
,p_query_column_id=>4
,p_column_alias=>'COUNT_LOGS'
,p_column_display_sequence=>40
,p_column_heading=>'Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2614218311735346)
,p_name=>'Log Information'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select current_log_number,',
'       log_switched_date as current_log_timestamp,',
'       log_switch_after_days as interval_days,',
'       log_switched_date + log_switch_after_days as next_log_switch,',
'       ((log_switched_date + log_switch_after_days) - sysdate) * 24 as hours_until',
'  from wwv_flow_log_numbers',
' where log_name = ''ACTIVITY'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'n/a'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202179793668016)
,p_query_column_id=>1
,p_column_alias=>'CURRENT_LOG_NUMBER'
,p_column_display_sequence=>10
,p_column_heading=>'Current Log Number'
,p_use_as_row_header=>'Y'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202240894668017)
,p_query_column_id=>2
,p_column_alias=>'CURRENT_LOG_TIMESTAMP'
,p_column_display_sequence=>20
,p_column_heading=>'Current Log Timestamp'
,p_use_as_row_header=>'N'
,p_column_format=>'&LONG_DATE_FORMAT. &TIME_FORMAT.'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202308671668018)
,p_query_column_id=>3
,p_column_alias=>'INTERVAL_DAYS'
,p_column_display_sequence=>30
,p_column_heading=>'Interval in Days'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202437943668019)
,p_query_column_id=>4
,p_column_alias=>'NEXT_LOG_SWITCH'
,p_column_display_sequence=>40
,p_column_heading=>'Next Log Switch'
,p_use_as_row_header=>'N'
,p_column_format=>'&LONG_DATE_FORMAT. &TIME_FORMAT.'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202592581668020)
,p_query_column_id=>5
,p_column_alias=>'HOURS_UNTIL'
,p_column_display_sequence=>50
,p_column_heading=>'Hours Until Next Log Switch'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3365902695706940)
,p_plug_name=>'Page View Activity Logs'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'&PRODUCT_NAME. uses two logs to track user activity. At any given time, one log is designated as current. For each rendered page view, the &PRODUCT_NAME. engine inserts one row into the log file. A log switch occurs at the interval listed on this pag'
||'e. At that point, the &PRODUCT_NAME. engine removes all entries in the noncurrent log and designates it as current. '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982232364415899647)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1080990124415523934)
,p_plug_name=>'Page View Activity Logs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3380119972759223)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(982232364415899647)
,p_button_name=>'MANAGE_LOGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Truncate Logs'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&FLOW_ID.:62:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37832832720730254)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(982232364415899647)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:RP:::'
,p_button_cattributes=>'class="button10"'
);
end;
/
prompt --application/pages/page_00062
begin
wwv_flow_imp_page.create_page(
 p_id=>62
,p_name=>'Truncate Logs'
,p_alias=>'TRUNCATE-LOGS'
,p_step_title=>'Truncate Logs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3378319841749695)
,p_plug_name=>'Log Truncation'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Truncating the log tables will remove all log entries.  Log entries are generated by applications that are running in "logging mode".'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982232597134899649)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3382006251764735)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(982232597134899649)
,p_button_name=>'TRUNCATE_LOG_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Truncate Log 1'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3386510192775267)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(982232597134899649)
,p_button_name=>'TRUNCATE_LOG_2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Truncate Log 2'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3379103350754380)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(982232597134899649)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3386829123775269)
,p_branch_action=>'61'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3384323220769569)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate log 1'
,p_process_sql_clob=>'execute immediate ''truncate table wwv_flow_activity_log1$'';'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating log 1.'
,p_process_when_button_id=>wwv_flow_imp.id(3382006251764735)
,p_process_success_message=>'Log 1 truncated.'
,p_internal_uid=>3384323220769569
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3392115864786425)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate log 2'
,p_process_sql_clob=>'execute immediate ''truncate table wwv_flow_activity_log2$'';'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating log 2.'
,p_process_when_button_id=>wwv_flow_imp.id(3386510192775267)
,p_process_success_message=>'Log 2 truncated.'
,p_internal_uid=>3392115864786425
);
end;
/
prompt --application/pages/page_00063
begin
wwv_flow_imp_page.create_page(
 p_id=>63
,p_name=>'Session State'
,p_alias=>'SESSION-STATE'
,p_step_title=>'Session State'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784004831644541)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3414400551876616)
,p_plug_name=>'Session State Management'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(3417102067886535)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3416327217884305)
,p_plug_name=>'Session State'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Click the links on this page to monitor and manage the session state repository.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_00064
begin
wwv_flow_imp_page.create_page(
 p_id=>64
,p_name=>'Session State Statistics'
,p_alias=>'SESSION-STATE-STATISTICS'
,p_step_title=>'Session State Statistics'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784004831644541)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(26076915239076069)
,p_name=>'Session State Statistics'
,p_template=>wwv_flow_imp.id(721130166613730309)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select count(*) from wwv_flow_sessions$) thecount,',
'       (select count(*) from wwv_flow_data) cache_entries,',
'       (select count(*) from wwv_flow_data)/(select count(*) from wwv_flow_sessions$) avg_per_session',
'  from dual'))
,p_header=>'<p>Application sessions maintain session state between application page views.  Each session can have zero or more entries (items) used to maintain session state.  Each user can have one or more sessions.</p>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26077314226076090)
,p_query_column_id=>1
,p_column_alias=>'THECOUNT'
,p_column_display_sequence=>1
,p_column_heading=>'Sessions'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26077427148076090)
,p_query_column_id=>2
,p_column_alias=>'CACHE_ENTRIES'
,p_column_display_sequence=>2
,p_column_heading=>'Total Session State Entries'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26077613945076090)
,p_query_column_id=>3
,p_column_alias=>'AVG_PER_SESSION'
,p_column_display_sequence=>3
,p_column_heading=>'Average Number of Entries per Session'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982232636079899650)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1080986871939523901)
,p_plug_name=>'Session State Statistics'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3481228031168376)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(982232636079899650)
,p_button_name=>'PURGE_SESSIONS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Sessions'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19629412621244661)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(982232636079899650)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_00065
begin
wwv_flow_imp_page.create_page(
 p_id=>65
,p_name=>'Recent Sessions'
,p_alias=>'RECENT-SESSIONS'
,p_step_title=>'Recent Sessions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784004831644541)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3426218737919742)
,p_plug_name=>'Recent Sessions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page lists all sessions for all workspaces managed by this service.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472649322781647206)
,p_plug_name=>'Recent Sessions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id session_id,',
'       s.created_on,',
'       s.username,',
'       c.short_name workspace_name,',
'       s.remote_addr,',
'       s.idle_timeout_on,',
'       s.life_timeout_on,',
'       s.is_subscription_session',
' from WWV_FLOW_SESSIONS$ s,',
'      wwv_flow_companies c',
'where s.security_group_id = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472649430593647206)
,p_name=>'Recent Sessions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(32047283456500918)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Session'
,p_column_link=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.:67:P67_SESSION_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472649805920647214)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>20
,p_column_identifier=>'C'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT. HH24:MI:SS Day'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(217246420447662394)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>30
,p_column_identifier=>'E'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(93233311113568936)
,p_db_column_name=>'USERNAME'
,p_display_order=>40
,p_column_identifier=>'F'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(93233529432575589)
,p_db_column_name=>'IDLE_TIMEOUT_ON'
,p_display_order=>50
,p_column_identifier=>'G'
,p_column_label=>'Idle<br/>Timeout'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT. HH24:MI:SS Day'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(93233618362575590)
,p_db_column_name=>'LIFE_TIMEOUT_ON'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>'Life<br/>Timeout'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT. HH24:MI:SS Day'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(93233808716600352)
,p_db_column_name=>'REMOTE_ADDR'
,p_display_order=>70
,p_column_identifier=>'I'
,p_column_label=>'Remote Addr'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(32047357308500919)
,p_db_column_name=>'IS_SUBSCRIPTION_SESSION'
,p_display_order=>90
,p_column_identifier=>'K'
,p_column_label=>'Subscription Session'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472650129140647626)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1314929425536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SESSION_ID:CREATED_ON:USERNAME:WORKSPACE_NAME:'
,p_sort_column_1=>'CREATED_ON'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'ID'
,p_sort_direction_2=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195763010848676782)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(472649322781647206)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:RP,65,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3484821928176079)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(472649322781647206)
,p_button_name=>'PURGE_SESSIONS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Sessions'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&FLOW_ID.:66:&SESSION.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3424913014912195)
,p_branch_action=>'65'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(25337511380084159)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(195763010848676782)
,p_internal_uid=>25337511380084159
);
end;
/
prompt --application/pages/page_00066
begin
wwv_flow_imp_page.create_page(
 p_id=>66
,p_name=>'Purge Sessions'
,p_alias=>'PURGE-SESSIONS'
,p_step_title=>'Purge Sessions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784004831644541)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3449327235035686)
,p_plug_name=>'Purge Sessions'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1080987058332523903)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3467901665132376)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1080987058332523903)
,p_button_name=>'PURGE_SESSIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Sessions'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3456216462079941)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1080987058332523903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&FLOW_ID.:63:&SESSION.'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3468212665132377)
,p_branch_action=>'66'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(3467901665132376)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3468906167133685)
,p_branch_action=>'63'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3451813299050623)
,p_name=>'P66_MAX_SESSIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3449327235035686)
,p_item_default=>'1000'
,p_prompt=>'Maximum Sessions to Purge'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the maximum number of sessions to delete.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3453000270056286)
,p_name=>'P66_AGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3449327235035686)
,p_prompt=>'Only Purge Sessions Older Than'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Delete sessions that are at least this old.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(149034515911867765)
,p_validation_name=>'MaxSessionsNumeric'
,p_validation_sequence=>10
,p_validation=>'P66_MAX_SESSIONS'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Max Sessions must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(3467901665132376)
,p_associated_item=>wwv_flow_imp.id(3451813299050623)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3469927637139934)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge sessions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_cache.purge_oldest_sessions (',
'p_num_sessions_to_purge     => :P66_MAX_SESSIONS,',
'p_purge_sess_older_then_hrs => :P66_AGE * 24);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error purging sessions.'
,p_process_when_button_id=>wwv_flow_imp.id(3467901665132376)
,p_process_success_message=>'Sessions purged.'
,p_internal_uid=>3469927637139934
);
end;
/
prompt --application/pages/page_00067
begin
wwv_flow_imp_page.create_page(
 p_id=>67
,p_name=>'Session Details'
,p_alias=>'SESSION-DETAILS'
,p_step_title=>'Session Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784004831644541)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(3500119382241626)
,p_name=>'Session'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID, ',
'       CREATED_ON,',
'       USERNAME,',
'       ON_NEW_INSTANCE_FIRED_FOR, ',
'       COOKIE_VALUE,',
'       SECURITY_GROUP_ID',
'  from WWV_FLOW_SESSIONS$',
'where id = :P67_SESSION_ID'))
,p_display_condition_type=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No session data found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48918208799773092)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Session ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48918511397773093)
,p_query_column_id=>2
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>3
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(93232619524565011)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48918702625773093)
,p_query_column_id=>4
,p_column_alias=>'ON_NEW_INSTANCE_FIRED_FOR'
,p_column_display_sequence=>7
,p_column_heading=>'On New Instance Fired For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(93232714943565012)
,p_query_column_id=>5
,p_column_alias=>'COOKIE_VALUE'
,p_column_display_sequence=>6
,p_column_heading=>'Cookie Value'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48919009084773093)
,p_query_column_id=>6
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22404018785536392)
,p_plug_name=>'Session State'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_name,',
'       item_value,',
'       data_item_id item_id,',
'       session_state_status,',
'       application_id flow_id',
'  from wwv_flow_data_view',
' where session_id = :P67_SESSION_ID',
'order by 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(22404119048536392)
,p_name=>'Session State'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No session state found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22404301361536429)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Item Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22404403927536434)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Session State Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22404501293536434)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Item Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22405709352553829)
,p_db_column_name=>'SESSION_STATE_STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Session State Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22405814028553829)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(22404918787537585)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1315023906536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ITEM_NAME:ITEM_VALUE:ITEM_ID:SESSION_STATE_STATUS:FLOW_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(72939501718823858)
,p_plug_name=>'Select'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(262457896829319726)
,p_name=>'Subscription Referencing This Session'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select r.flow_id application_id,',
'       r.page_id,',
'       ( select pr.plug_name from wwv_flow_page_plugs pr where pr.id = i.region_id ) region_name,',
'       case',
'         when r.is_default = ''Y'' and r.application_user = ''APXWS_DEFAULT'' then m.m_primary_report',
'         else r.name',
'       end as report_name,',
'       case',
'         when r.is_default = ''Y'' and r.application_user = ''APXWS_DEFAULT''        then ''PRIMARY_DEFAULT''',
'         when r.is_default = ''Y'' and r.application_user = ''APXWS_ALTERNATIVE''    then ''ALTERNATIVE_DEFAULT''',
'         when r.is_default = ''N'' and r.status = ''PUBLIC''  and r.session_id is null then ''PUBLIC''',
'         when r.is_default = ''N'' and r.status = ''PRIVATE'' and r.session_id is null then ''PRIVATE''',
'       end as report_type,',
'       n.owner subscribed_by,',
'       n.status,',
'       n.notify_interval frequency,',
'       n.start_date,',
'       n.end_date,',
'       n.offset_date',
'  from wwv_flow_worksheets i,',
'       wwv_flow_worksheet_rpts r,',
'       wwv_flow_worksheet_notify n,',
'       wwv_flow_sessions$ s,',
'       (select wwv_flow_lang_dev.builder_message( ''SAVED_REPORTS.PRIMARY_REPORT'' ) m_primary_report',
'          from dual) m',
'where i.id = r.worksheet_id',
'  and r.id = n.report_id',
'  and i.id = n.worksheet_id',
'  and n.session_id = s.id',
'  and n.security_group_id = s.security_group_id',
'  and s.id = :P67_SESSION_ID'))
,p_display_when_condition=>'P67_IS_SUBSCRIPTION_SESSION'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No subscription found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262457970444319727)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_ID'
,p_column_display_sequence=>10
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458091491319728)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>20
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458155710319729)
,p_query_column_id=>3
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>30
,p_column_heading=>'Region Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458249006319730)
,p_query_column_id=>4
,p_column_alias=>'REPORT_NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Report Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458388192319731)
,p_query_column_id=>5
,p_column_alias=>'REPORT_TYPE'
,p_column_display_sequence=>50
,p_column_heading=>'Report Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(262846363440568824)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458463477319732)
,p_query_column_id=>6
,p_column_alias=>'SUBSCRIBED_BY'
,p_column_display_sequence=>60
,p_column_heading=>'Subscribed By'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458562286319733)
,p_query_column_id=>7
,p_column_alias=>'STATUS'
,p_column_display_sequence=>70
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(294656516286709966)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458605037319734)
,p_query_column_id=>8
,p_column_alias=>'FREQUENCY'
,p_column_display_sequence=>80
,p_column_heading=>'Frequency'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(274103227902682659)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458746798319735)
,p_query_column_id=>9
,p_column_alias=>'START_DATE'
,p_column_display_sequence=>90
,p_column_heading=>'Start Date'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458887544319736)
,p_query_column_id=>10
,p_column_alias=>'END_DATE'
,p_column_display_sequence=>100
,p_column_heading=>'End Date'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262458999835319737)
,p_query_column_id=>11
,p_column_alias=>'OFFSET_DATE'
,p_column_display_sequence=>110
,p_column_heading=>'Offset Date'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3503225747252936)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(72939501718823858)
,p_button_name=>'P67_GO'
,p_button_static_id=>'P67_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3505105446256528)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3500824577243155)
,p_name=>'P67_SESSION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(72939501718823858)
,p_prompt=>'Session ID'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>'select id||'' - ''||nvl(username,wwv_flow_lang.system_message(''NULL_IN_PAREN''))||'' ''||security_group_id a, id from wwv_flow_sessions$ order by created_on desc'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(343399818250317904)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identify session ID.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(262457688764319724)
,p_name=>'P67_IS_SUBSCRIPTION_SESSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(72939501718823858)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(72924925155622381)
,p_computation_sequence=>10
,p_computation_item=>'P67_SESSION_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'trim(:P67_SESSION_ID)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(262457728021319725)
,p_computation_sequence=>10
,p_computation_item=>'P67_IS_SUBSCRIPTION_SESSION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select is_subscription_session',
'  from wwv_flow_sessions$',
' where id = :P67_SESSION_ID;'))
,p_compute_when=>'P67_SESSION_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(72925505893626312)
,p_validation_name=>'session numeric'
,p_validation_sequence=>10
,p_validation=>'P67_SESSION_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Session ID must be numeric.'
,p_associated_item=>wwv_flow_imp.id(3500824577243155)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3503931288254475)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>3503931288254475
);
end;
/
prompt --application/pages/page_00068
begin
wwv_flow_imp_page.create_page(
 p_id=>68
,p_name=>'Activity by Day'
,p_alias=>'ACTIVITY-BY-DAY'
,p_step_title=>'Activity by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201316113467446335)
,p_plug_name=>'Activity by Day'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    count(distinct WORKSPACE_ID) workspaces,',
'    count(distinct APPLICATION_ID) applications,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'group by LOG_DAY'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(201316216575446335)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201316428056446338)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201316500422446339)
,p_db_column_name=>'DAY'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Day'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201316621937446340)
,p_db_column_name=>'WORKSPACES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Workspaces'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201316706177446341)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201316823094446342)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582264300897682814)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'R'
,p_column_label=>'Public Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201316916848446343)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201317015142446344)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Page Posts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201317116723446345)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201317314218446347)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Rows Fetched'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201317419181446348)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>'Interactive Report Searches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201317507501446349)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201317609579446350)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201317725892446351)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201317813682446352)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Total Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201317914296446353)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Error Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201318025927446354)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(201318113674446645)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1315111556536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:DAY:WORKSPACES:APPLICATIONS:PAGE_EVENTS:PUBLIC_PAGE_EVENTS:ROWS_FETCHED:DISTINCT_PAGES:DISTINCT_USERS:DISTINCT_SESSIONS:TOTAL_RENDER_TIME:ERROR_COUNT:CONTENT_LENGTH'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(484703226739054598)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(201316113467446335)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:68:&SESSION.::&DEBUG.:68,RIR::'
);
end;
/
prompt --application/pages/page_00069
begin
wwv_flow_imp_page.create_page(
 p_id=>69
,p_name=>'Page Views by Hour'
,p_alias=>'PAGE-VIEWS-BY-HOUR'
,p_step_title=>'Page Views by Hour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23251413763556683)
,p_plug_name=>'Button Bar'
,p_region_css_classes=>'a-Region--noTopBorder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201523520914118911)
,p_plug_name=>'Page Views by Hour'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P69a */',
'    to_char(time_stamp,''YYYY.MM.DD HH24'') ts, ',
'count(*), ',
'sum(decode(page_mode,''A'',0,1)) page_views,',
'sum(decode(page_mode,''A'',1,0)) page_processing,',
'max(elap) max_elap, ',
'min(elap) min_elap, ',
'avg(elap) avg_elap,',
'count(distinct flow_id) distinct_applications,',
'count(distinct flow_id||''.''||step_id) distinct_pages,',
'sum(cached_regions) cached_regions,',
'count(distinct to_char(time_stamp,''YYYYMMDDHH24MI'')) distinct_minutes,',
'count(distinct userid) distinct_users',
'from WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - nvl(:P69_TIME,1)',
'group by to_char(time_stamp,''YYYY.MM.DD HH24'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(201523601755118911)
,p_name=>'Page Views by Hour'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201523804138118920)
,p_db_column_name=>'TS'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Hour'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201523927023118922)
,p_db_column_name=>'COUNT(*)'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page<br />Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524028456118924)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page<br />Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524104608118925)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page<br />Processing'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524215350118926)
,p_db_column_name=>'MAX_ELAP'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Maximum<br />Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524306502118927)
,p_db_column_name=>'MIN_ELAP'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Minimum<br />Elapsed '
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524411012118928)
,p_db_column_name=>'AVG_ELAP'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Average<br />Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524715586118931)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>8
,p_column_identifier=>'J'
,p_column_label=>'Cached<br />Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524915127118933)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>9
,p_column_identifier=>'L'
,p_column_label=>'Distinct<br />Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524818861118932)
,p_db_column_name=>'DISTINCT_MINUTES'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Distinct<br />Minutes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524518368118929)
,p_db_column_name=>'DISTINCT_APPLICATIONS'
,p_display_order=>11
,p_column_identifier=>'H'
,p_column_label=>'Distinct<br />Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201524622664118930)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>12
,p_column_identifier=>'I'
,p_column_label=>'Distinct<br />Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(468248012492227699)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1315204025536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TS:COUNT(*):PAGE_VIEWS:PAGE_PROCESSING:MAX_ELAP:MIN_ELAP:AVG_ELAP:CACHED_REGIONS:DISTINCT_USERS:DISTINCT_MINUTES:DISTINCT_APPLICATIONS:DISTINCT_PAGES'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10154323915376546)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(23251413763556683)
,p_button_name=>'P69_GO'
,p_button_static_id=>'P69_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(468249015740238071)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(23251413763556683)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10139722558253165)
,p_name=>'P69_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(23251413763556683)
,p_item_default=>'1'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00070
begin
wwv_flow_imp_page.create_page(
 p_id=>70
,p_name=>'Check for Available Updates'
,p_alias=>'CHECK-FOR-AVAILABLE-UPDATES'
,p_page_mode=>'MODAL'
,p_step_title=>' Available Updates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721098050798687927)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_dialog_height=>'240'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1143248891749567441)
,p_plug_name=>'Check for Available Updates'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_header=>'<p>This page controls what information is queried and posted to Oracle Corporation from this &PRODUCT_NAME. instance.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1143248948629567442)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1143249049592567443)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1143248948629567442)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1143249116879567444)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1143248948629567442)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1143249422016567447)
,p_name=>'P70_SHOW_UPDATES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1143248891749567441)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Check for Available Updates'
,p_source=>'nvl( wwv_flow_platform.get_preference( ''CHECK_FOR_UPDATES'' ), ''Y'' )'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This attribute controls if this &PRODUCT_NAME. instance is permitted to check if updates are available for &PRODUCT_NAME. and Oracle REST Data Services. If the check for product updates is disabled in Administration Services, it takes precedence o'
||'ver preferences specified by individual developers.</p>',
'',
'<p>Note: To perform this check, &PRODUCT_NAME. transmits the version number of &PRODUCT_NAME. and other system components to Oracle Corporation. In order to continuously improve our products, Oracle is interested in learning about product usage. To t'
||'hat end, statistics can occasionally be sent to Oracle describing the product features in use. No personally identifiable information will be sent. You can review <a rel="noopener noreferrer" href="https://www.oracle.com/privacy">Oracle Privacy Polic'
||'y</a>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Feature #1437'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1143249283022567445)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1143249116879567444)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1143249314939567446)
,p_event_id=>wwv_flow_imp.id(1143249283022567445)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1143249593714567448)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set CHECK_FOR_UPDATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference( p_preference_name  => ''CHECK_FOR_UPDATES'',',
'                                  p_preference_value => :P70_SHOW_UPDATES );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1143249049592567443)
,p_internal_uid=>1143249593714567448
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1143249613585567449)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1143249613585567449
);
end;
/
prompt --application/pages/page_00071
begin
wwv_flow_imp_page.create_page(
 p_id=>71
,p_name=>'Top 10 Applications'
,p_alias=>'TOP-10-APPLICATIONS'
,p_step_title=>'Top 10 Applications'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(825642334996263219)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(880590463437877633)
,p_plug_name=>'Top 10 Applications'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>21
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(880590808162877633)
,p_region_id=>wwv_flow_imp.id(880590463437877633)
,p_chart_type=>'bar'
,p_height=>'320'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(880592091145877634)
,p_chart_id=>wwv_flow_imp.id(880590808162877633)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'    select sum(page_events) Page_Events,',
'    NVL((select max(name||'' - ''||f.id) from wwv_flows f where f.id = h.application_id), ''Unknown'') App_Name',
'from WWV_FLOW_LOG_HISTORY h',
'where log_day > sysdate - (NVL(:P71_SINCE,7)+1)',
'      and application_id not between 4000 and 5000',
'group by application_id',
'order by 1 desc) where rownum <= 10'))
,p_ajax_items_to_submit=>'P71_SINCE'
,p_items_value_column_name=>'PAGE_EVENTS'
,p_group_name_column_name=>'APP_NAME'
,p_items_label_column_name=>'APP_NAME'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(880591690727877634)
,p_chart_id=>wwv_flow_imp.id(880590808162877633)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(880591227860877634)
,p_chart_id=>wwv_flow_imp.id(880590808162877633)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1651120171573687541)
,p_name=>'Top Applications Report'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>31
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       errors,',
'       "App Name",',
'       "App ID",',
'       max_DISTINCT_PAGES,',
'       most_recent_event,',
'       workspace_id,',
'       (select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id) workspace_name,',
'       (select count(*) from wwv_flow_steps s where s.flow_id = "App ID") app_pages,',
'       RANK() OVER (ORDER BY "Page Events" desc) app_rank',
'from (',
'select sum(page_events) "Page Events",',
'    nvl((select max(name) from wwv_flows where id = application_id),sm.t_not_available) "App Name",',
'    APPLICATION_ID "App ID", ',
'    workspace_id, ',
'    max(log_day) most_recent_event,',
'    sum(ERROR_COUNT) errors,',
'    max(DISTINCT_PAGES) max_DISTINCT_PAGES',
'from WWV_FLOW_LOG_HISTORY,',
'     (select wwv_flow_lang.system_message(''NOT AVAILABLE'') t_not_available from dual) sm',
'where log_day > sysdate - (NVL(:P71_SINCE,7)+1)',
'  and application_id not between 4000 and 5000',
'group by application_id, workspace_id, t_not_available',
'order by 1 desc) x',
'where rownum < 1001',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P71_SINCE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>1001
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825610633969086340)
,p_query_column_id=>1
,p_column_alias=>'Page Events'
,p_column_display_sequence=>5
,p_column_heading=>'Page Events'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825514194192601245)
,p_query_column_id=>2
,p_column_alias=>'ERRORS'
,p_column_display_sequence=>6
,p_column_heading=>'Errors'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825611015173086340)
,p_query_column_id=>3
,p_column_alias=>'App Name'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825611493328086341)
,p_query_column_id=>4
,p_column_alias=>'App ID'
,p_column_display_sequence=>3
,p_column_heading=>'Application ID'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825514501334601249)
,p_query_column_id=>5
,p_column_alias=>'MAX_DISTINCT_PAGES'
,p_column_display_sequence=>8
,p_column_heading=>'Daily Maximum Active Pages'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825611801482086341)
,p_query_column_id=>6
,p_column_alias=>'MOST_RECENT_EVENT'
,p_column_display_sequence=>9
,p_column_heading=>'Most Recent Event'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825612268515086341)
,p_query_column_id=>7
,p_column_alias=>'WORKSPACE_ID'
,p_column_display_sequence=>10
,p_column_heading=>'Workspace ID'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825612667154086341)
,p_query_column_id=>8
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825514679478601250)
,p_query_column_id=>9
,p_column_alias=>'APP_PAGES'
,p_column_display_sequence=>7
,p_column_heading=>'Application Pages'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825613007733086342)
,p_query_column_id=>10
,p_column_alias=>'APP_RANK'
,p_column_display_sequence=>1
,p_column_heading=>'Rank'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2518812136188497587)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(825613563870088243)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2518812136188497587)
,p_button_name=>'RESET_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:RR,71::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(880595465785924453)
,p_name=>'P71_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2518812136188497587)
,p_item_default=>'7'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(390435721015898133)
,p_name=>'Refresh Report'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P71_SINCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(390435829900898134)
,p_event_id=>wwv_flow_imp.id(390435721015898133)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(880590463437877633)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(390435936009898135)
,p_event_id=>wwv_flow_imp.id(390435721015898133)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1651120171573687541)
);
end;
/
prompt --application/pages/page_00072
begin
wwv_flow_imp_page.create_page(
 p_id=>72
,p_name=>'Create Workspace - Identify Administrator'
,p_alias=>'CREATE-WORKSPACE-IDENTIFY-ADMINISTRATOR'
,p_step_title=>'Create Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(3931243707245169747)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12012705423629513)
,p_plug_name=>'Create &P27_WORKSPACE_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(187657525264854490)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12048115202363924)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202756611350719138)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752110819847695868)
,p_plug_name=>'Create Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13216515182502313)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202756611350719138)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12021900060665808)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202756611350719138)
,p_button_name=>'next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12022102892665810)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202756611350719138)
,p_button_name=>'previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12023517029670675)
,p_branch_action=>'73'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(12021900060665808)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12024121877672100)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(12022102892665810)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13216829929502321)
,p_branch_action=>'10'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(13216515182502313)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12014129318636436)
,p_name=>'F4050_P72_ADMINNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12012705423629513)
,p_prompt=>'Administrator Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the username of the workspace administrator.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12020406163658104)
,p_name=>'F4050_P72_EMAIL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(12012705423629513)
,p_prompt=>'Email'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the email address of the workspace administrator.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12850829056207052)
,p_name=>'F4050_P72_ADMIN_PASS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12012705423629513)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Administrator Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_display_when=>'nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') in (''APEX'',''DB'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the workspace administrator''s password.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13027609755658621)
,p_name=>'F4050_P72_FIRSTNAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12012705423629513)
,p_prompt=>'First Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify first name of administrator.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13029600189665308)
,p_name=>'F4050_P72_LASTNAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12012705423629513)
,p_prompt=>'Last Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify last name of administrator.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3699176817193)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P72_ADMIN_PASS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_authentication_dev.create_shadow_user_password'
,p_security_scheme=>'!'||wwv_flow_imp.id(3699181830199)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12975203588136370)
,p_validation_name=>'username required'
,p_validation_sequence=>10
,p_validation=>'F4050_P72_ADMINNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Username must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(12021900060665808)
,p_associated_item=>wwv_flow_imp.id(12014129318636436)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12987418375358280)
,p_validation_name=>'admin password not null'
,p_validation_sequence=>20
,p_validation=>'F4050_P72_ADMIN_PASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'An Administrator Password must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(12021900060665808)
,p_associated_item=>wwv_flow_imp.id(12850829056207052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(111257629778385447)
,p_validation_name=>'strong password'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'    p_username              => :F4050_P72_ADMINNAME,',
'    p_password              => :F4050_P72_ADMIN_PASS,',
'    p_old_password          => null,',
'    p_workspace_name        => :F4050_P27_COMPANY);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Error'
,p_validation_condition=>'F4050_P72_ADMIN_PASS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(12021900060665808)
,p_associated_item=>wwv_flow_imp.id(12850829056207052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_security_scheme=>wwv_flow_imp.id(3699181830199)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(330963499344982247)
,p_validation_name=>'Validate DB Password'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.password_validation (',
'           p_username => :F4050_P72_ADMINNAME,',
'           p_password => :F4050_P72_ADMIN_PASS );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The password does not conform to the database password complexity rules.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB'' ',
'  and :F4050_P72_ADMIN_PASS is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(12021900060665808)
,p_associated_item=>wwv_flow_imp.id(12850829056207052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(162086921320715301)
,p_validation_name=>'Is valid Provisioning Email'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_at number;',
'    l_dot number;',
'begin',
'    l_at  := instr(nvl(:F4050_P72_EMAIL,''x''),''@'');',
'    l_dot := instr(nvl(:F4050_P72_EMAIL,''x''),''.'',l_at);',
'    if l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1 then',
'        return wwv_flow_instance_admin.is_valid_provisioning_email( p_email => :F4050_P72_EMAIL );',
'    else return false;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The email address is invalid.'
,p_when_button_pressed=>wwv_flow_imp.id(12021900060665808)
,p_associated_item=>wwv_flow_imp.id(12020406163658104)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9873516568625893)
,p_name=>'Copy User name to Email'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P72_ADMINNAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.triggeringElement.value.match(/@/)!=null'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9873813037625894)
,p_event_id=>wwv_flow_imp.id(9873516568625893)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P72_EMAIL'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s(''F4050_P72_EMAIL'',$v(''F4050_P72_ADMINNAME''));',
''))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13033112918687930)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow.update_cache_with_write(''F4050_P72_ADMINNAME'', :FLOW_USER);',
'  for c1 in (select * ',
'               from wwv_flow_fnd_user',
'              where user_name = upper(:FLOW_USER)',
'                and security_group_id = :FLOW_SECURITY_GROUP_ID) loop',
'    wwv_flow.update_cache_with_write(''F4050_P72_FIRSTNAME'', nvl(c1.FIRST_NAME,''''));',
'    wwv_flow.update_cache_with_write(''F4050_P72_LASTNAME'', nvl(c1.LAST_NAME,''''));',
'    wwv_flow.update_cache_with_write(''F4050_P72_EMAIL'', c1.EMAIL_ADDRESS);',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
,p_internal_uid=>13033112918687930
,p_process_comment=>'When we are creating a new workspace (most likely for someone else), not sure why we would want to use the current Instance Administrator''s information. Set this process to NEVER. Vlad, 11-JUL-2019'
);
end;
/
prompt --application/pages/page_00073
begin
wwv_flow_imp_page.create_page(
 p_id=>73
,p_name=>'Create Workspace - Confirm Request'
,p_alias=>'CREATE-WORKSPACE-CONFIRM-REQUEST'
,p_step_title=>'Create Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931243707245169747)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12994410158412679)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12048115202363924)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202760814382738900)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752110980519695868)
,p_plug_name=>'Create Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1339901111918284611)
,p_plug_name=>'Region Container'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 auto; max-width: 640px;"'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(924624894430884402)
,p_plug_name=>'Workspace Information'
,p_parent_plug_id=>wwv_flow_imp.id(1339901111918284611)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Form--leftLabels:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(924624933224884403)
,p_plug_name=>'Administrator Information'
,p_parent_plug_id=>wwv_flow_imp.id(1339901111918284611)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Form--leftLabels:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(924625061933884404)
,p_plug_name=>'Database Schema Information'
,p_parent_plug_id=>wwv_flow_imp.id(1339901111918284611)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Form--leftLabels:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12027510019687640)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202760814382738900)
,p_button_name=>'back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13260331814582778)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202760814382738900)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12027721414687641)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202760814382738900)
,p_button_name=>'provision'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(282434411208624614)
,p_branch_action=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P73_CREATED'
,p_branch_condition_text=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12029125602692160)
,p_branch_action=>'72'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(12027510019687640)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10290320351706181)
,p_name=>'P73_CREATED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12994410158412679)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924625113182884405)
,p_name=>'P73_WORKSPACE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(924624894430884402)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace name'
,p_source=>'F4050_P27_COMPANY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924625243443884406)
,p_name=>'P73_WORKSPACE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(924624894430884402)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace ID'
,p_source=>'nvl(:F4050_P27_SECURITY_GROUP_ID,wwv_flow_lang.system_message(p_name=>''PROVISION_REQUEST.SYSTEM_ASSIGNED''))'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924625333830884407)
,p_name=>'P73_WORKSPACE_DESCRIPTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(924624894430884402)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'F4050_P27_PROJDESC'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924625460542884408)
,p_name=>'P73_USER_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(924624933224884403)
,p_use_cache_before_default=>'NO'
,p_prompt=>'User name'
,p_source=>'F4050_P72_ADMINNAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924625526487884409)
,p_name=>'P73_EMAIL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(924624933224884403)
,p_use_cache_before_default=>'NO'
,p_prompt=>'E-Mail'
,p_source=>'F4050_P72_EMAIL'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924625667230884410)
,p_name=>'P73_REUSE_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(924625061933884404)
,p_prompt=>'Reuse Existing Schema'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4050_P79_EXISTING = ''1'' then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924625745577884411)
,p_name=>'P73_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(924625061933884404)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema Name'
,p_source=>'F4050_P79_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924625862320884412)
,p_name=>'P73_TABLESPACE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(924625061933884404)
,p_prompt=>'Tablespace'
,p_source=>'coalesce(wwv_flow_instance_admin.get_parameter(''INSTANCE_TABLESPACE''),''APEX_XXX'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'F4050_P79_EXISTING'
,p_display_when2=>'0'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924625946739884413)
,p_name=>'P73_DATAFILE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(924625061933884404)
,p_prompt=>'Datafile'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_ts_path varchar2(512);',
'  l_omf     boolean := FALSE;',
'begin',
'    for c1 in (select null',
'                 from v$parameter',
'                where upper(name) = ''DB_CREATE_FILE_DEST''',
'                  and trim(value) is not null) loop',
'        -- OMF is potentially in use',
'        l_omf := TRUE;',
'        exit;',
'    end loop;',
'',
'    --',
'    -- Only compute the file path if OMF is not in use',
'    -- ',
'    if l_omf = FALSE and wwv_flow_instance_admin.get_parameter(''INSTANCE_TABLESPACE'') is null then',
'        select replace(f.file_name,''\'',''/'')',
'          into l_ts_path',
'          from sys.dba_data_files f, sys.dba_tables t',
'         where t.table_name = ''WWV_FLOWS''',
'           and t.tablespace_name = f.tablespace_name',
'           and rownum = 1;',
'',
'        <<stripfilename>>',
'        for i in reverse 1 .. length(l_ts_path) loop',
'            if substr(l_ts_path,i,1) = ''/'' then',
'                l_ts_path := substr(l_ts_path,1,i);',
'                exit stripfilename;',
'            end if;',
'        end loop;',
'        --',
'        return wwv_flow_escape.html(l_ts_path) || ''APEX_XXX.DBF'';',
'    elsif wwv_flow_instance_admin.get_parameter(''INSTANCE_TABLESPACE'') is not null and l_omf = FALSE then',
'        for c1 in (select replace(f.file_name,''\'',''/'') file_name',
'          from sys.dba_data_files f  ',
'         where f.tablespace_name = wwv_flow_instance_admin.get_parameter(''INSTANCE_TABLESPACE'') ',
'           and rownum=1) loop',
'             return wwv_flow_escape.html(c1.file_name);',
'         end loop;',
'    else',
'        return wwv_flow_lang.system_message(p_name=>''PROVISION_REQUEST.SYSTEM_ASSIGNED'');',
'    end if;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'F4050_P79_EXISTING'
,p_display_when2=>'0'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(217808816560578351)
,p_name=>'Show Waiting on Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(12027721414687641)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(217809121167578351)
,p_event_id=>wwv_flow_imp.id(217808816560578351)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'provision'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12036710522324711)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Provision company'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_p1                  varchar2(256)  := :F4050_P79_SCHEMA_PASSWORD;',
'    l_p2                  varchar2(256)  := :F4050_P72_ADMIN_PASS;',
'    l_username_asserted   varchar2(4000) := wwv_flow_assert.enquote_name(upper(:F4050_P72_ADMINNAME));',
'    l_password_asserted   varchar2(4000) := wwv_flow_assert.enquote_name(:F4050_P72_ADMIN_PASS);',
'    l_sql                 varchar2(32767);',
'    user_exists           exception;',
'    pragma exception_init(user_exists,-01920);',
'begin',
'    wwv_flow.update_cache_with_write(''F4050_P79_SCHEMA_PASSWORD'', null);',
'    wwv_flow.update_cache_with_write(''F4050_P72_ADMIN_PASS'', null);',
'',
'    wwv_flow_provisioning.auto_provision_company(',
'        p_company_name        => :F4050_P27_COMPANY,',
'        p_schema_name         => :F4050_P79_SCHEMA,',
'        p_schema_password     => l_p1,',
'        p_admin_password      => l_p2,',
'        p_database_size       => :F4050_P79_QUOTA,',
'        p_admin_userid        => :F4050_P72_ADMINNAME,',
'        p_admin_first_name    => :F4050_P72_FIRSTNAME,',
'        p_admin_last_name     => :F4050_P72_LASTNAME,',
'        p_admin_title         => :F4050_P72_TITLE,',
'        p_admin_email         => :F4050_P72_EMAIL,',
'        --',
'        p_project_description => :F4050_P27_PROJDESC,',
'        p_security_group_id   => :F4050_P27_SECURITY_GROUP_ID',
'    );',
'',
'    --',
'    -- Create workspace administrator DB user if builder auth is DB',
'    -- allow this user to already exist  ',
'    --',
'    l_sql := ''create user ''||l_username_asserted||'' identified by ''||l_password_asserted;',
'',
'    begin',
'        if nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB'' then',
'            execute immediate l_sql;',
'        end if;',
'    exception ',
'        when user_exists then',
'            null;',
'    end;',
'',
'    :P73_CREATED := ''Y'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error provisioning &F4050_P27_COMPANY..'
,p_process_when_button_id=>wwv_flow_imp.id(12027721414687641)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provisioning.reserved_schema(p_schema => upper(:F4050_P79_SCHEMA)) = false and ',
'not (wwv_flow_provisioning.site_admin_is_restricted and wwv_flow_provisioning.restricted_schema(p_schema => upper(:F4050_P79_SCHEMA),p_workspace_name => :F4050_P27_COMPANY) )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>12036710522324711
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(267835524796024753)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear pw'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4050_P72_ADMIN_PASS,F4050_P79_SCHEMA_PASSWORD'
,p_process_when_button_id=>wwv_flow_imp.id(12027721414687641)
,p_internal_uid=>267835524796024753
);
end;
/
prompt --application/pages/page_00074
begin
wwv_flow_imp_page.create_page(
 p_id=>74
,p_name=>'Create Workspace - Success Confirmation'
,p_alias=>'CREATE-WORKSPACE-SUCCESS-CONFIRMATION'
,p_step_title=>'Create Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.wrap-region .a-Alert-body {',
'word-break: break-all;',
'}'))
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12026518199680536)
,p_plug_name=>'Workspace Created'
,p_region_css_classes=>'wrap-region'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_result wwv_flow_t_clob_writer := wwv_flow_t_clob_writer();',
'begin',
'    if :F4050_P79_EXISTING = ''0'' then',
'        for c1 in (select b.default_tablespace,',
'                          a.file_name ',
'                     from sys.dba_data_files a, sys.dba_users b',
'                    where b.default_tablespace = a.tablespace_name',
'                      and b.username = upper(:F4050_P79_SCHEMA) ) ',
'            loop',
'                l_result.prn( wwv_flow_lang_dev.builder_message( ',
'                                    p_name => ''F4050_P74_PROVISION1'',',
'                                    p0     => wwv_flow_escape.html(:F4050_P27_COMPANY),',
'                                    p1     => wwv_flow_escape.html(:F4050_P72_ADMINNAME) ) ||',
'                             '' '' || ',
'                             wwv_flow_lang_dev.builder_message(',
'                                    p_name => ''F4050_P74_PROVISION'',',
'                                    p0     => upper(wwv_flow_escape.html(:F4050_P79_SCHEMA)),',
'                                    p1     => c1.default_tablespace,',
'                                    p2     => c1.file_name ) );',
'            end loop;',
'    else    ',
'        l_result.prn( wwv_flow_lang_dev.builder_message( ',
'                            p_name => ''F4050_P74_PROVISION1'',',
'                            p0 => wwv_flow_escape.html(:F4050_P27_COMPANY),',
'                            p1 => wwv_flow_escape.html(:F4050_P72_ADMINNAME) ) );',
'    end if;',
'    l_result.flush;',
'    return l_result.get_value;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(207916425010826926)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10040114009483080)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(207916425010826926)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Edit Workspace'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.:REPORT:&DEBUG.:RP,78:P78_PROVISIONING_COMPANY_ID:&P74_PROVISIONING_COMPANY_ID.'
,p_button_condition=>'P74_PROVISIONING_COMPANY_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19144406840293644)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(207916425010826926)
,p_button_name=>'DONE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Done'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10058931905548807)
,p_name=>'P74_PROVISIONING_COMPANY_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(207916425010826926)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(10059331233579580)
,p_computation_sequence=>10
,p_computation_item=>'P74_PROVISIONING_COMPANY_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_security.find_security_group_id(p_company => :F4050_P27_COMPANY)'
);
end;
/
prompt --application/pages/page_00075
begin
wwv_flow_imp_page.create_page(
 p_id=>75
,p_name=>'Clean up Logs'
,p_alias=>'CLEAN-UP-LOGS'
,p_step_title=>'Clean up Logs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23588620617408071)
,p_plug_name=>'Clean up Logs'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c number := 0;',
'    l_result wwv_flow_t_clob_writer := wwv_flow_t_clob_writer();',
'begin',
'    l_result.prn(''<table class="instructiontext" role="presentation">'');',
'',
'    if :P75_LOG_TYPE = ''SCRIPT'' then',
'        select count(*)',
'          into c',
'          from wwv_flow_sw_results;',
'        l_result.prn(''<tr><td>'' || wwv_flow_lang_dev.builder_message(''4050_75_SCRIPT_FILE'') || '': </td><td align="right">'');',
'        l_result.prn(to_char(c, ''999,999,999,990''));',
'',
'    elsif :P75_LOG_TYPE = ''HISTORY'' then',
'        select count(*)',
'          into c',
'          from wwv_flow_sw_sql_cmds;',
'        l_result.prn(''<tr><td>'' || wwv_flow_lang_dev.builder_message(''4050_75_AD_HOC'') || '': </td><td align="right">'');',
'        l_result.prn(to_char(c, ''999,999,999,990''));',
'',
'    end if;',
'',
'    l_result.prn(''</td><td><br /></td></tr>'');',
'    l_result.prn(''</table>'');',
'    l_result.flush;',
'    return l_result.get_value;       ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_ajax_items_to_submit=>'P75_LOG_TYPE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(199174420727145797)
,p_plug_name=>'SQL Workshop Logs'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<strong>Truncate Log</strong> deletes all entries in the selected log.  <strong>Delete Entries</strong> deletes all entries older than the number of days selected.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(982232224821899646)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23614222816410273)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(982232224821899646)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Truncate Log'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23589416938416560)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(982232224821899646)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Entries'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23590525942419157)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(982232224821899646)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(23589714883416570)
,p_branch_action=>'75'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(23590809276419158)
,p_branch_action=>'46'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(23590525942419157)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23592027805429118)
,p_name=>'P75_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(23588620617408071)
,p_item_default=>'31'
,p_prompt=>'Delete entries this number of days and older:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_imp.id(87720511660244788)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Delete entries that are at least this number of days old.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23593431183448977)
,p_name=>'P75_LOG_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(23588620617408071)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23623509692409481)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete script logs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_sw_results ',
'where started < (sysdate - nvl(:P75_TIME,31));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing Script File execution log.'
,p_process_when_button_id=>wwv_flow_imp.id(23589416938416560)
,p_process_when=>'P75_LOG_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SCRIPT'
,p_process_success_message=>'Script File execution log processed.'
,p_internal_uid=>23623509692409481
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23625811171466668)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete history'
,p_process_sql_clob=>'delete from wwv_flow_sw_sql_cmds where created_on < (sysdate - nvl(:P75_TIME,31));'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing SQL Command Processor history.'
,p_process_when_button_id=>wwv_flow_imp.id(23589416938416560)
,p_process_when=>'P75_LOG_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'HISTORY'
,p_process_success_message=>'SQL Command Processor history processed.'
,p_internal_uid=>23625811171466668
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23628422693526797)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate script logs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_sw_results;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating Script File execution log.'
,p_process_when_button_id=>wwv_flow_imp.id(23614222816410273)
,p_process_when=>'P75_LOG_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SCRIPT'
,p_process_success_message=>'Script File execution log truncated.'
,p_internal_uid=>23628422693526797
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23630707811598252)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate history'
,p_process_sql_clob=>'execute immediate(''truncate table wwv_flow_sw_sql_cmds'');'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating SQL Command Processor history.'
,p_process_when_button_id=>wwv_flow_imp.id(23614222816410273)
,p_process_when=>'P75_LOG_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'HISTORY'
,p_process_success_message=>'SQL Command Processor history truncated.'
,p_internal_uid=>23630707811598252
);
end;
/
prompt --application/pages/page_00076
begin
wwv_flow_imp_page.create_page(
 p_id=>76
,p_name=>'Email'
,p_alias=>'EMAIL'
,p_step_title=>'Email'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_details.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(184031003334137773)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(184031224534137777)
,p_plug_name=>'Email'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184034721016181323)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(184031003334137773)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184034917696181328)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(184031003334137773)
,p_button_name=>'email'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Email'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(184035526126201755)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184033318329161657)
,p_name=>'P76_TO'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(184031224534137777)
,p_use_cache_before_default=>'NO'
,p_prompt=>'To'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select email_address ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id and ',
'      user_name = :app_user'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184033527414161659)
,p_name=>'P76_SUBJECT'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(184031224534137777)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Subject'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''WORKSPACE_WORKSPACE_SUMMARY'',:P76_WORKSPACE_NAME) m',
'from dual'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184033708260161659)
,p_name=>'P76_BODY'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(184031224534137777)
,p_prompt=>'Body'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184038131021231488)
,p_name=>'P76_REPORTING_PERIOD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(184031003334137773)
,p_item_default=>'W'
,p_prompt=>'Reporting Period'
,p_source=>'W'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_imp.id(180726228364333770)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify reporting period'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184084915709321735)
,p_name=>'P76_WORKSPACE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(184031003334137773)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184086521034332765)
,p_name=>'P76_WORKSPACE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(184031003334137773)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(184085521942323519)
,p_computation_sequence=>10
,p_computation_item=>'P76_WORKSPACE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name',
'from wwv_flow_companies',
'where provisioning_company_id = :P76_WORKSPACE_ID'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(184033008633158879)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'send email'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4350_ui.p83_send_ws_usage_mail (',
'    p_security_group_id => :P76_WORKSPACE_ID,',
'    p_to                => :P76_TO,',
'    p_subject           => :P76_SUBJECT,',
'    p_body              => :P76_BODY,',
'    p_reporting_period  => :P76_REPORTING_PERIOD,',
'    p_date_time_format  => :DATE_TIME_FORMAT );'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'EMail Sent'
,p_internal_uid=>184033008633158879
);
end;
/
prompt --application/pages/page_00077
begin
wwv_flow_imp_page.create_page(
 p_id=>77
,p_name=>'Activity by Application'
,p_alias=>'ACTIVITY-BY-APPLICATION1'
,p_step_title=>'Activity by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201334900977494764)
,p_plug_name=>'Activity by Application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    WORKSPACE_ID workspace,',
'    (select short_name from wwv_flow_companies where provisioning_company_id = workspace_id) workspace_name,',
'    APPLICATION_ID applications,',
'    (select max(name) from wwv_flows where id = application_id) application_name,',
'    page_events PAGE_EVENTS,',
'    page_views PAGE_VIEWS,',
'    page_accepts PAGE_ACCEPTS,',
'    partial_page_views PARTIAL_PAGE_VIEWS,',
'    rows_fetched ROWS_FETCHED,',
'    ir_searches IR_SEARCHES,',
'    distinct_pages DISTINCT_PAGES,',
'    distinct_users DISTINCT_USERS,',
'    distinct_sessions DISTINCT_SESSIONS,',
'    total_render_time TOTAL_RENDER_TIME,',
'    error_count ERROR_COUNT,',
'    nvl(content_length,0) content_length,',
'    public_page_events public_page_events,',
'    additional_attributes,',
'    case when application_id between 4000 and 4999 then t.y else t.n end apex_application,',
'    nvl(decode(instr(additional_attributes,''"hash":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8),'','')-2)),null)  application_hash,',
'    nvl(decode(instr(additional_attributes,''"pages":''),0,''0'',',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"pages":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"pages":'')+8),'','')-1)),''0'')  pages,',
'    nvl(decode(instr(additional_attributes,''"jetCharts":''),0,''0'',',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"jetCharts":'')+12,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"jetCharts":'')+12),'','')-1)),''0'') jetcharts,',
'    nvl(decode(instr(additional_attributes,''"interactiveReports":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveReports":'')+21,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveReports":'')+21),'','')-1)),''0'')  interactiveReports,',
'    nvl(decode(instr(additional_attributes,''"classicReports":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"classicReports":'')+length(''classicReports'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"classicReports":'')+length(''classicReports'')+3),'','')-1)),''0'')  classicReports,',
'    nvl(decode(instr(additional_attributes,''"interactiveGrids":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveGrids":'')+length(''interactiveGrids'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveGrids":'')+length(''interactiveGrids'')+3),'','')-1)),''0'')  interactiveGrids,',
'    nvl(decode(instr(additional_attributes,''"aclUsers":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"aclUsers":'')+length(''aclUsers'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"aclUsers":'')+length(''aclUsers'')+3),'','')-1)),''0'')  aclUsers,        ',
'    nvl(decode(instr(additional_attributes,''"appSettings":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"appSettings":'')+length(''appSettings'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"appSettings":'')+length(''appSettings'')+3),'','')-1)),''0'')  appSettings,          ',
'    nvl(decode(instr(additional_attributes,''"buildOptions":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"buildOptions":'')+length(''buildOptions'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"buildOptions":'')+length(''buildOptions'')+3),'','')-1)),''0'')  buildOptions,         ',
'    nvl(decode(instr(additional_attributes,''"emailTemplates":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"emailTemplates":'')+length(''emailTemplates'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"emailTemplates":'')+length(''emailTemplates'')+3),'','')-1)),''0'')  emailTemplates,         ',
'    nvl(decode(instr(additional_attributes,''"plugins":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"plugins":'')+length(''plugins'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"plugins":'')+length(''plugins'')+3),'','')-1)),''0'')  plugins,       ',
'    nvl(decode(instr(additional_attributes,''"tabularForms":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"tabularForms":'')+length(''tabularForms'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"tabularForms":'')+length(''tabularForms'')+3),'','')-1)),''0'')  tabularForms      ',
'from WWV_FLOW_LOG_HISTORY h, (select wwv_flow_lang.system_message(''Yes'') y, wwv_flow_lang.system_message(''No'') n from dual) t',
''))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(201335103200494767)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201335207896494770)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201335327208494771)
,p_db_column_name=>'DAY'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Day'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201335523254494773)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201335613642494774)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582264440165682815)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'U'
,p_column_label=>'Public Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201335718041494775)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201335801210494776)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Page Posts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201335923569494777)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201336107132494779)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Rows Fetched'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201336221224494780)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>'Interactive Report Searches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201336321763494781)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Active Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201336408590494782)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201336505856494783)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201336612996494784)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Total Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201336722324494785)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201336815191494786)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201370019533571396)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201373110576597156)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201373214940597158)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>165
,p_column_identifier=>'T'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84538753787706813)
,p_db_column_name=>'ADDITIONAL_ATTRIBUTES'
,p_display_order=>175
,p_column_identifier=>'V'
,p_column_label=>'Additional Attributes'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84539045432706816)
,p_db_column_name=>'APEX_APPLICATION'
,p_display_order=>185
,p_column_identifier=>'W'
,p_column_label=>'APEX Internal Application'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176252184846916921)
,p_db_column_name=>'JETCHARTS'
,p_display_order=>205
,p_column_identifier=>'AC'
,p_column_label=>'JET Charts'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176252270600916922)
,p_db_column_name=>'INTERACTIVEREPORTS'
,p_display_order=>215
,p_column_identifier=>'AD'
,p_column_label=>'Interactive Reports'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176252389058916923)
,p_db_column_name=>'CLASSICREPORTS'
,p_display_order=>225
,p_column_identifier=>'AE'
,p_column_label=>'Classic Reports'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176252454408916924)
,p_db_column_name=>'INTERACTIVEGRIDS'
,p_display_order=>235
,p_column_identifier=>'AF'
,p_column_label=>'Interactive Grids'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176252507712916925)
,p_db_column_name=>'ACLUSERS'
,p_display_order=>245
,p_column_identifier=>'AG'
,p_column_label=>'ACL Users'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176252647407916926)
,p_db_column_name=>'APPSETTINGS'
,p_display_order=>255
,p_column_identifier=>'AH'
,p_column_label=>'Application Settings'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176252745489916927)
,p_db_column_name=>'BUILDOPTIONS'
,p_display_order=>265
,p_column_identifier=>'AI'
,p_column_label=>'Build Options'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176252882601916928)
,p_db_column_name=>'EMAILTEMPLATES'
,p_display_order=>275
,p_column_identifier=>'AJ'
,p_column_label=>'Email Templates'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176252984135916929)
,p_db_column_name=>'PLUGINS'
,p_display_order=>285
,p_column_identifier=>'AK'
,p_column_label=>'Plugins'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176253185667916931)
,p_db_column_name=>'TABULARFORMS'
,p_display_order=>305
,p_column_identifier=>'AM'
,p_column_label=>'Tabular Forms'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176253500432916935)
,p_db_column_name=>'PAGES'
,p_display_order=>315
,p_column_identifier=>'AQ'
,p_column_label=>'Pages'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176253673764916936)
,p_db_column_name=>'APPLICATION_HASH'
,p_display_order=>325
,p_column_identifier=>'AR'
,p_column_label=>'Application Hash'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(201336903272494787)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1315304675536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:WORKSPACE_NAME:APPLICATIONS:APPLICATION_NAME:PAGE_EVENTS:ROWS_FETCHED:DISTINCT_SESSIONS:ERROR_COUNT:APEX_APPLICATION'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'DISTINCT_PAGES'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(484704101222057793)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(201334900977494764)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.:77,RIR::'
);
end;
/
prompt --application/pages/page_00078
begin
wwv_flow_imp_page.create_page(
 p_id=>78
,p_name=>'Edit Workspace Information'
,p_alias=>'EDIT-WORKSPACE-INFORMATION'
,p_step_title=>'Edit Workspace Information'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(704456563630760825)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1716213517659202)
,p_plug_name=>'AI Services'
,p_title=>'AI Services'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16616205365518560)
,p_plug_name=>'Workspace Appearance'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(64856003162546445)
,p_plug_name=>'Edit Workspace Information'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P78_PROVISIONING_COMPANY_ID'
,p_plug_display_when_cond2=>'10'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 20-JUN-2003 14:39:53'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(68662405051157913)
,p_plug_name=>'Internal Workspace'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>'You cannot edit the internal workspace. This workspace is reserved for operation of &PRODUCT_NAME..'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P78_PROVISIONING_COMPANY_ID'
,p_plug_display_when_cond2=>'10'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(254114322593959129)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(195775112470763477)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(254180529905013099)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>65
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(254179102637013097)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(484950212196717193)
,p_plug_name=>'Edit Workspace Information'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(484963511353906096)
,p_plug_name=>'Login Control'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(484966712963972830)
,p_plug_name=>'Component Availability'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(495344484107866205)
,p_plug_name=>'Workspace Isolation'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(503818025402228218)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Manage selected workspace settings.  Use the tasks region below to perform additional actions.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(537738109072133270)
,p_plug_name=>'Session Timeout'
,p_region_name=>'sessiontimeout'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1119586265779190522)
,p_name=>'Workspace Information'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--xlarge'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ( select count(*) as workspace_users',
'           from wwv_flow_fnd_user',
'          where security_group_id = sgid.id ) as workspace_users,',
'       ( select count(*) as workspace_schemas',
'           from wwv_flow_company_schemas cs,',
'                wwv_flow_companies c',
'          where cs.security_group_id = c.provisioning_company_id (+)',
'            and security_group_id = sgid.id',
'            and short_name != ''INTERNAL'' ) as workspace_schemas,',
'       ( select count(*) as applications',
'           from wwv_flows',
'          where security_group_id not in ( 0, 10, 11 )',
'            and security_group_id = sgid.id ) as applications,',
'       sgid.id as sgid',
'  from ( select provisioning_company_id as id',
'           from WWV_FLOW_COMPANIES',
'          where id = :P78_ID ) sgid'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P78_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805663950138677747)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1119586383992190523)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_USERS'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace Users'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:RP,RIR:IR_WORKSPACE_ID:#SGID#'
,p_column_linktext=>'#WORKSPACE_USERS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1119586422447190524)
,p_query_column_id=>2
,p_column_alias=>'WORKSPACE_SCHEMAS'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace Schemas'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:RP,RIR:IR_SECURITY_GROUP_ID:#SGID#:'
,p_column_linktext=>'#WORKSPACE_SCHEMAS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1119586570285190525)
,p_query_column_id=>3
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>3
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RP,RIR:IR_WORKSPACE_ID:#SGID#:'
,p_column_linktext=>'#APPLICATIONS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1119586604568190526)
,p_query_column_id=>4
,p_column_alias=>'SGID'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(64856327858546450)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(484950212196717193)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(68666010900206937)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(484950212196717193)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(64856416813546450)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(484950212196717193)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>':P78_ID is not null and :P78_PROVISIONING_COMPANY_ID != ''10'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(503857325907464969)
,p_branch_action=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P78_PROVISIONING_COMPANY_ID'
,p_branch_condition_text=>'P14_SGID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(64857217258546458)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_comment=>'Generated 20-JUN-2003 14:39:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1589702746325019)
,p_name=>'P78_SESSION_TIMEOUT_WARN_SEC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(537738109072133270)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Session Timeout Warning in Seconds'
,p_source=>'SESSION_TIMEOUT_WARNING_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS_SMALL'
,p_lov=>'.'||wwv_flow_imp.id(1501535454230180)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The session timeout warning time defines (in seconds) how long before a session times out (either maximum session length, or maximum session idle time), to warn the user. For the maximum session idle time warning, the user will have the opportunit'
||'y to extend the session. For maximum session length warning, the user will be prompted to save any work, to avoid loss of data when the session maximum time is reached.</p>',
'<p>Note: This setting is superseded by the corresponding application level setting.</p>',
'<p>',
'<ul>',
'    <li>Enter a positive integer to control the default idle time for sessions used by applications in this workspace.</li>',
'    <li>Enter 0 to switch off session timeout warnings for sessions used by applications in this workspace.</li>',
'    <li>Leave the value empty in order to use the warning time defined at instance level.</li>',
'</ul>  ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1716558388659205)
,p_name=>'P78_AI_IS_ENABLED'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1716213517659202)
,p_use_cache_before_default=>'NO'
,p_prompt=>'AI Enabled'
,p_source=>'AI_IS_ENABLED_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Determines if AI Services can be used in this workspace.</p>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2319419563424419)
,p_name=>'P78_MAX_SCHEDULER_JOBS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Background Page Process Jobs'
,p_source=>'MAX_SCHEDULER_JOBS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the maximum number of scheduler jobs being available for ',
'    background execution of page processes for this workspace (applies to all applications). ',
'    Only the configured number of jobs will run at the same time to execute page processes ',
'    in the background. If the configured maximum amount of scheduler jobs is active, new ',
'    submitted executions will wait until a job becomes available.',
'</p>',
'<p>',
'    Setting the attribute to zero disables background executions; new submitted ',
'    executions will stay in enqueued state. Leaving the attribute empty leads to the',
'    instance default being used, which can be set using the ',
'    <strong>MAX_PROCESS_SCHEDULER_JOBS_DEFAULT</strong>',
'    instance parameter.',
'</p>',
'',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2802235393892301)
,p_name=>'P78_TO_HOST_EXTENSIONS_YN'
,p_is_required=>true
,p_item_sequence=>216
,p_item_plug_id=>wwv_flow_imp.id(484966712963972830)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Allow Hosting Extensions'
,p_source=>'IS_EXTENSION_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'This flag will determine whether a  workspace can host extensions and publish links to other workspaces.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13874018831207468)
,p_name=>'P78_RM_CONSUMER_GROUP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Resource Consumer Group'
,p_source=>'RM_CONSUMER_GROUP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Database Resource Manager consumer group to be used for all page events associated with this workspace.',
'If you leave this attribute empty, the instance level value applies.',
'At the beginning of every request, the &PRODUCT_NAME. engine switches the current consumer group of the current database session to the workspace''s consumer group.  This applies to both executing applications as well as any of the applications used w'
||'ithin the &PRODUCT_NAME. development environment.',
'',
'<p />',
'',
'The privilege to switch to this consumer group must be granted to either PUBLIC or the &PRODUCT_NAME. schema.  This privilege is typically granted using the procedure DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16617016362540639)
,p_name=>'P78_DISPLAY_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(16616205365518560)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display Name'
,p_source=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Display name is an alternative name for a workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64857525070546458)
,p_name=>'P78_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 20-JUN-2003 14:39:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64857823340546465)
,p_name=>'P78_PROVISIONING_COMPANY_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace Identifier:'
,p_source=>'PROVISIONING_COMPANY_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 20-JUN-2003 14:39:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64858304246546470)
,p_name=>'P78_SHORT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace Name'
,p_source=>'SHORT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the workspace name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 20-JUN-2003 14:39:54'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64858932679546471)
,p_name=>'P78_FIRST_SCHEMA_PROVISIONED'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'First Schema Provisioned'
,p_source=>'FIRST_SCHEMA_PROVISIONED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the original schema to provision.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 20-JUN-2003 14:39:54'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(254190316454208827)
,p_name=>'P78_SN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(356927208955624683)
,p_name=>'P78_ACCOUNT_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace Status:'
,p_source=>'ACCOUNT_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'WORKSPACE STATUS'
,p_lov=>'.'||wwv_flow_imp.id(2379160755129464721)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies the status of workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(385817323351295593)
,p_name=>'P78_ALLOW_RESTFUL_SERVICES_YN'
,p_item_sequence=>185
,p_item_plug_id=>wwv_flow_imp.id(484966712963972830)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Allow RESTful Services'
,p_source=>'ALLOW_RESTFUL_SERVICES_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Controls the ability to create and access RESTful Services in the current workspace. This preference is ignored if RESTful Services are disabled at the instance level.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(385818782057330239)
,p_name=>'P78_PATH_PREFIX'
,p_item_sequence=>186
,p_item_plug_id=>wwv_flow_imp.id(484966712963972830)
,p_use_cache_before_default=>'NO'
,p_prompt=>'RESTful Path Prefix'
,p_source=>'PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the unique URI path prefix to be used to access RESTful Services in the current workspace. The default path prefix value is the name of the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484699530539980014)
,p_name=>'P78_ALLOW_TO_BE_PURGED_YN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Allow workspace to be automatically purged'
,p_source=>'ALLOW_TO_BE_PURGED_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'Determines if this workspace is a candidate for automatic purging of unused workspaces.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484863413498036412)
,p_name=>'P78_SOURCE_IDENTIFIER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Feedback Synchronization Source Identifier'
,p_source=>'SOURCE_IDENTIFIER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>12
,p_cMaxlength=>8
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use this attribute to identify the source of application feedback.  For example, if you are synchronizing feedback from a production system to your development system, you can identify the source of the feedback and prevent feature number collisions.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484883430747211661)
,p_name=>'P78_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(484966712963972830)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Allow App Builder'
,p_source=>'ALLOW_APP_BUILDING_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enable App Builder for this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484883707676214401)
,p_name=>'P78_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(484966712963972830)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Allow SQL Workshop'
,p_source=>'ALLOW_SQL_WORKSHOP_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enable SQL Workshop for this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484884523260218887)
,p_name=>'P78_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>206
,p_item_plug_id=>wwv_flow_imp.id(484966712963972830)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Allow Team Development'
,p_source=>'ALLOW_TEAM_DEVELOPMENT_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enable Team Development in this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484885405729223343)
,p_name=>'P78_BUILDER_NOTIFICATION_MESSAGE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace Message'
,p_source=>'BUILDER_NOTIFICATION_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a message to be displayed on the home page of this workspace and in the App Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484891004952242081)
,p_name=>'P78_ALLOW_PLSQL_EDITING'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(484966712963972830)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Allow PL/SQL Editing in SQL Workshop'
,p_source=>'ALLOW_PLSQL_EDITING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Allow PL/SQL procedures, packages, functions, and triggers to be edited in the browser.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484963722912918937)
,p_name=>'P78_EXPIRE_FND_USER_ACCOUNTS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(484963511353906096)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Account Expiration and Locking:'
,p_source=>'EXPIRE_FND_USER_ACCOUNTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ENABLE Y, DISABLE N'
,p_lov=>'.'||wwv_flow_imp.id(484964000318931321)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Make a selection to determine whether &PRODUCT_NAME. end user accounts can be expired or locked. This feature applies only to end-user accounts created using the &PRODUCT_NAME. user management interface. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484965522398956659)
,p_name=>'P78_FND_USER_MAX_LOGIN_FAILURES'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(484963511353906096)
,p_use_cache_before_default=>'NO'
,p_item_default=>'15'
,p_prompt=>'Maximum Login Failures Allowed'
,p_source=>'FND_USER_MAX_LOGIN_FAILURES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a positive integer to be used as the maximum number of consecutive unsuccessful authentication',
'attempts allowed before an end-user account is locked. If you do not specify a value in this field,',
'the <strong>Maximum Login Failures Allowed</strong> instance parameter will be used.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484965707637961794)
,p_name=>'P78_ACCOUNT_LIFETIME_DAYS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(484963511353906096)
,p_use_cache_before_default=>'NO'
,p_prompt=>'End User Account Lifetime (days)'
,p_source=>'ACCOUNT_LIFETIME_DAYS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a positive integer to be used as the maximum number of days an end-user account password may be used before the account is expired. If you do not specify a value in this field, the site-level Account Password Lifetime Environment Setting will b'
||'e used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(495344596646866206)
,p_name=>'P78_QOS_MAX_WORKSPACE_REQUESTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Concurrent Workspace Requests'
,p_source=>'QOS_MAX_WORKSPACE_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the maximum number of concurrent page events that &PRODUCT_NAME. supports for all applications of this workspace.',
'If you leave this attribute empty, the instance level value applies.',
'Instead of processing a page event, &PRODUCT_NAME. shows an error message when the limit is already reached.',
'</p>',
'<p>',
'&PRODUCT_NAME. keeps track of workspace requests by querying the CLIENT_INFO column of GV$SESSION.',
'This tracking will not work if developers overwrite CLIENT_INFO, e.g. with a call to DBMS_APPLICATION_INFO.SET_CLIENT_INFO.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(495345284427866213)
,p_name=>'P78_QOS_MAX_SESSION_REQUESTS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Concurrent Session Requests'
,p_source=>'QOS_MAX_SESSION_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the maximum number of concurrent page events that &PRODUCT_NAME. allows for each session of this workspace''s applications.',
'Instead of processing a new page event, &PRODUCT_NAME. shows an error message when the limit is already reached.',
'Alternatively, you can use the <em>Concurrent Session Requests Kill Timeout</em> attribute to kill an active database session, to process the new page event.',
'</p>',
'<p>',
'&PRODUCT_NAME. keeps track of session requests by querying the CLIENT_IDENTIFIER column of GV$SESSION.',
'This tracking will not work if developers overwrite CLIENT_IDENTIFIER, e.g. with a call to DBMS_SESSION.SET_IDENTIFIER.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(495345336315866214)
,p_name=>'P78_QOS_MAX_SESSION_KILL_TIMEOUT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Concurrent Session Requests Kill Timeout'
,p_source=>'QOS_MAX_SESSION_KILL_TIMEOUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If a new page event comes in that is outside the limits of',
'<em>Maximum Concurrent Session Requests</em>,',
'&PRODUCT_NAME. can execute <code>alter system kill session</code> on the',
'oldest active database session which processes another page event for this &PRODUCT_NAME. session.',
'The <em>Concurrent Session Requests Kill Timeout</em> attribute specifies the number of seconds',
'a database process has to be active, before it can be killed.',
'If you leave this attribute empty, the instance level value applies.',
'</p>',
'<p>',
'<strong>Warning:</strong> Killing sessions can cause problems with the application server''s database session pool.    ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(495345482229866215)
,p_name=>'P78_HOST_PREFIX'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Hostnames'
,p_source=>'HOST_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter a comma separated list of hostnames that can be used to access this workspace.',
'If you leave this attribute empty, the instance level value applies.',
'If you enter one or more hostnames,',
'the incoming HTTP request URL''s hostname part must match one of the listed hostnames.',
'</p>',
'<p>',
'For example, you can register the DNS alias "hr.example.com" for your web server "www.example.com".',
'If you set the HR workspace''s <em>Allow Hostnames</em> to "hr.example.com",',
'users have to access HR applications via "hr.example.com"',
'and all other applications of this instance via "www.example.com".',
'With this configuration,',
'the browser''s <strong>Same Origin security policy</strong> provides a client-side barrier between HR applications',
'and other applications of the instance,',
'which run in another browser tab or window.',
'</p>',
'<p>',
'If your workspace uses RESTful services,',
'you have to additionally configure a pool in the <strong>url-mapping.xml</strong>',
'configuration file of <strong>Oracle REST Data Services</strong> for isolation.',
'Note that Oracle REST Data Services will ignore the <strong>RESTful Path Prefix</strong>',
'workspace attribute if <strong>Allow Hostnames</strong> is configured.',
'</p>',
'<p>',
'The configuration example below specifies that RESTful services of the HR workspace can only be accessed via',
'https://hr.example.com/apex/<em>resource-handler</em>:',
'<pre>',
'  &lt;pool base-url="https://hr.example.com/apex" name="apex" workspace-id="hr" /&gt;',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537738384746133274)
,p_name=>'P78_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(537738109072133270)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Session Length in Seconds'
,p_source=>'MAX_SESSION_LENGTH_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(15314811390892155)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines how long (in seconds) sessions can exist and be used by applications in this workspace. This setting is superseded by the',
'corresponding application level setting.',
'',
'<ul>',
'    <li>Enter a positive integer to control how long a session can exist.</li>',
'    <li>Enter 0 to have sessions exist indefinitely.</li>',
'    <li>Leave the value empty in order to use the time defined at the instance level.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537738844730133278)
,p_name=>'P78_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(537738109072133270)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Session Idle Time in Seconds'
,p_source=>'MAX_SESSION_IDLE_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(15314811390892155)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Session Idle Time is the time between the last page request and the next page request. This setting is superseded by the corresponding',
'application level setting.',
'',
'<ul>',
'    <li>Enter a positive integer to control the default idle time for sessions used by applications in this workspace.</li>',
'    <li>Leave the value empty in order to use the idle time defined at the instance level.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(582421442619226502)
,p_name=>'P78_WEBSERVICE_LOGGING_YN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(64856003162546445)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Log Web Service Requests'
,p_source=>'WEBSERVICE_LOGGING_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Determines if web service requests are logged for this workspace. This setting is only relevant if the instance setting Web Service Activity Logging is set to Use Workspace Settings.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(582421516116226503)
,p_name=>'P78_MAX_WEBSERVICE_REQUESTS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Web Service Requests'
,p_source=>'MAX_WEBSERVICE_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the maximum number of web service requests that can be sent per 24 hour period.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(620835263564373115)
,p_name=>'P78_MAX_FILE_BYTES'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Size of Files in Workspace'
,p_source=>'MAX_FILE_BYTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the total size (in bytes) of all files that can be uploaded to this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(644504642352249007)
,p_name=>'P78_CONTENT_CACHE_TARGET_SIZE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Content Cache target size'
,p_source=>'CONTENT_CACHE_SIZE_TARGET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Denotes the target size for the content cache on workspace level. The content cache can currently being used by Web Source and REST Enabled SQL services. The Cache Size Target acts as a soft limit, which, for performance reasons, is only maintained b'
||'y the &PRODUCT_NAME. scheduler jobs. That means, &PRODUCT_NAME. might exceed the specified limit during normal operations. With the next run of the maintenance job, cached content with the shortest remaining validity will be removed until the cache s'
||'ize is below the specified limit.</p>',
'<p>',
'    This value will override the instance-level setting.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(644504774903249008)
,p_name=>'P78_CONTENT_CACHE_MAX_FILE_SIZE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Content Cache maximum entry size'
,p_source=>'CONTENT_CACHE_MAX_FILE_SIZE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Denotes the maximum size for content to be placed into the content cache. This value will override the instance-level setting.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741568130904681315)
,p_name=>'P78_MAX_EMAIL_MESSAGES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(495344484107866205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Email Messages'
,p_source=>'MAX_EMAIL_MESSAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the maximum number of email messages that can be sent with the <code>APEX_MAIL</code> API per 24 hour period.  This value will override the instance-level setting.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(64863709969555108)
,p_computation_sequence=>10
,p_computation_item=>'P78_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_companies where provisioning_company_id = :P78_PROVISIONING_COMPANY_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(254190817089223715)
,p_computation_sequence=>20
,p_computation_item=>'P78_SN'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name',
'from wwv_flow_companies',
'where id = :P78_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(64858201225546468)
,p_validation_name=>'P78_PROVISIONING_COMPANY_ID not null'
,p_validation_sequence=>10
,p_validation=>'P78_PROVISIONING_COMPANY_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Provisioning workspace must be specified.'
,p_associated_item=>wwv_flow_imp.id(64857823340546465)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1143247246142567425)
,p_validation_name=>'P78_PROVISIONING_COMPANY_ID not internal'
,p_validation_sequence=>20
,p_validation=>'to_number( :P78_PROVISIONING_COMPANY_ID ) != 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You cannot edit the internal workspace.'
,p_associated_item=>wwv_flow_imp.id(64857823340546465)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(64858728443546471)
,p_validation_name=>'P78_SHORT_NAME not null'
,p_validation_sequence=>30
,p_validation=>'P78_SHORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Short Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(64858304246546470)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(64859332313546472)
,p_validation_name=>'P78_FIRST_SCHEMA_PROVISIONED not null'
,p_validation_sequence=>40
,p_validation=>'P78_FIRST_SCHEMA_PROVISIONED'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'First Schema Provisioned must be specified.'
,p_associated_item=>wwv_flow_imp.id(64858932679546471)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(111447707426965624)
,p_validation_name=>'Invalid characters in workspace name'
,p_validation_sequence=>50
,p_validation=>'P78_SHORT_NAME'
,p_validation2=>'<>/:'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Invalid #LABEL#.'
,p_when_button_pressed=>wwv_flow_imp.id(64856416813546450)
,p_associated_item=>wwv_flow_imp.id(64858304246546470)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(385905783290008661)
,p_validation_name=>'Path Prefix must have value'
,p_validation_sequence=>60
,p_validation=>'trim( :P78_PATH_PREFIX ) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(64856416813546450)
,p_associated_item=>wwv_flow_imp.id(385818782057330239)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(385887145438492395)
,p_validation_name=>'Path Prefix already exists'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select null',
'              from wwv_flow_companies',
'             where path_prefix = upper( trim( :P78_PATH_PREFIX ) )',
'               and id != :P78_ID ) loop',
'    return false;',
'    exit;',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# already exists.'
,p_when_button_pressed=>wwv_flow_imp.id(64856416813546450)
,p_associated_item=>wwv_flow_imp.id(385818782057330239)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1405738480336504)
,p_validation_name=>'P78_MAX_SESSION_LENGTH_SEC is positive integer'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P78_MAX_SESSION_LENGTH_SEC is null ',
'       or to_number(:P78_MAX_SESSION_LENGTH_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(64856416813546450)
,p_associated_item=>wwv_flow_imp.id(537738384746133274)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1405894281336505)
,p_validation_name=>'P78_MAX_SESSION_IDLE_SEC is positive integer'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P78_MAX_SESSION_IDLE_SEC is null ',
'       or to_number(:P78_MAX_SESSION_IDLE_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(64856416813546450)
,p_associated_item=>wwv_flow_imp.id(537738844730133278)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1405904601336506)
,p_validation_name=>'P78_SESSION_TIMEOUT_WARN_SEC is positive integer'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P78_SESSION_TIMEOUT_WARN_SEC is null ',
'       or to_number(:P78_SESSION_TIMEOUT_WARN_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(64856416813546450)
,p_associated_item=>wwv_flow_imp.id(1589702746325019)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(64859623535546474)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P78_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>64859623535546474
,p_process_comment=>'Generated 20-JUN-2003 14:39:54'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(64859916890546475)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P78_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row of table WWV_FLOW_COMPANIES.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>64859916890546475
,p_process_comment=>'Generated 20-JUN-2003 14:39:54'
);
end;
/
prompt --application/pages/page_00079
begin
wwv_flow_imp_page.create_page(
 p_id=>79
,p_name=>'Create Workspace - Identify Schema'
,p_alias=>'CREATE-WORKSPACE-IDENTIFY-SCHEMA'
,p_step_title=>'Create Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(3931243707245169747)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12534431790828540)
,p_plug_name=>'Create &P27_WORKSPACE_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_plug_header=>'<p>Select whether or not the schema already exists. If the schema exists, select the schema from the list. If the schema does not exist, enter a name and password and choose the size of the associated tablespace to be created.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(500069818015047367)
,p_plug_name=>'Component Availability'
,p_parent_plug_id=>wwv_flow_imp.id(12534431790828540)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(102441323786892882)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12661715260239327)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12048115202363924)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202750517190692387)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(241507625027179516)
,p_name=>'Information on Schema &F4050_P79_SCHEMA.'
,p_region_name=>'missing_privs'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with user_roles as (',
'    select upper(:F4050_P79_SCHEMA) ur from sys.dual',
'    union',
'    select granted_role',
'      from sys.dba_role_privs',
'     start with grantee = upper(:F4050_P79_SCHEMA)',
'     connect by grantee = prior granted_role ),',
'ur_privs as (',
'    select p.privilege',
'      from sys.dba_sys_privs p,',
'           user_roles ur',
'     where p.grantee = ur.ur ),',
'missing as (',
'select privilege',
'  from sys.dba_sys_privs p',
' where grantee = ''APEX_GRANTS_FOR_NEW_USERS_ROLE''',
'   and exists ( select null',
'                  from sys.dba_users',
'                 where username = upper(:F4050_P79_SCHEMA) )',
' minus',
'select privilege',
'  from ur_privs )',
'select account_status,',
'       default_tablespace,',
'       ( select listagg(privilege, '', '') within group (order by privilege) from missing ) missing_privs',
'  from sys.dba_users',
' where username = upper(:F4050_P79_SCHEMA)'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'F4050_P79_SCHEMA'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805670753642677848)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Schema &F4050_P79_SCHEMA. not found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
,p_required_patch=>wwv_flow_imp.id(4226407758971148501)
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241507755929179517)
,p_query_column_id=>1
,p_column_alias=>'ACCOUNT_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Account Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241507836534179518)
,p_query_column_id=>2
,p_column_alias=>'DEFAULT_TABLESPACE'
,p_column_display_sequence=>2
,p_column_heading=>'Default Tablespace'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241507985246179519)
,p_query_column_id=>3
,p_column_alias=>'MISSING_PRIVS'
,p_column_display_sequence=>3
,p_column_heading=>'Suggested Additional Privileges'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752111107467695869)
,p_plug_name=>'Create Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12557314353889752)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202750517190692387)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12559200978895311)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202750517190692387)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12562912752898723)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202750517190692387)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12557622294889762)
,p_branch_action=>'10'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(12557314353889752)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12563202884898724)
,p_branch_action=>'27'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(12562912752898723)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12559510217895312)
,p_branch_action=>'72'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(12559200978895311)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12536920970844342)
,p_name=>'F4050_P79_SCHEMA'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12534431790828540)
,p_prompt=>'Schema Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d,',
'       username r',
'  from wwv_flow_admin_all_schemas',
' where (   restricted_to_workspace is null',
'        or restricted_to_workspace = upper(:F4050_P27_COMPANY))',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'If you are reusing an existing schema, select it from list. If you are creating a new schema, enter the name here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12541530105856426)
,p_name=>'F4050_P79_SCHEMA_PASSWORD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12534431790828540)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a password for the schema.  A password is required only if you are creating a new schema.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12543318462862552)
,p_name=>'F4050_P79_QUOTA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12534431790828540)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''N''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Space Quota (MB)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NEW WORKSPACE REQUEST STORAGE SIZES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'order by to_number(req_size)',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'If creating a new schema, select the maximum size of the tablespace to be associated with that schema. You can adjust this limit later.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12579427045959576)
,p_name=>'F4050_P79_EXISTING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12534431790828540)
,p_item_default=>'0'
,p_prompt=>'Re-use existing schema?'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.1_OR_0'
,p_lov=>'.'||wwv_flow_imp.id(87817312158083090)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicate whether this workspace will initially use an existing database schema or a newly created one.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(500070508436047375)
,p_name=>'P79_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(500069818015047367)
,p_item_default=>'Y'
,p_prompt=>'Allow App Builder'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enable App Builder for this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(500071003880047376)
,p_name=>'P79_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(500069818015047367)
,p_item_default=>'Y'
,p_prompt=>'Allow SQL Workshop'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enable SQL Workshop for this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(500071507566047376)
,p_name=>'P79_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(500069818015047367)
,p_item_default=>'Y'
,p_prompt=>'Allow Team Development'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enable Team Development in this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(500072025033047378)
,p_name=>'P79_ALLOW_PLSQL_EDITING'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(500069818015047367)
,p_item_default=>'Y'
,p_prompt=>'Allow PL/SQL Editing in SQL Workshop'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Allow PL/SQL procedures, packages, functions, and triggers to be edited in the browser.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(114756701339208327)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P79_SCHEMA'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'ltrim(rtrim(upper(:F4050_P79_SCHEMA)))'
,p_compute_when=>'F4050_P79_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12903312985817444)
,p_validation_name=>'schema name is valid'
,p_validation_sequence=>20
,p_validation=>'wwv_flow_utilities.is_valid_identifier(p_identifier=>:F4050_P79_SCHEMA,p_quote=>true)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Schema name must be a valid Oracle identifier.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = ''ANONYMOUS'''))
,p_validation_condition_type=>'EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(12559200978895311)
,p_associated_item=>wwv_flow_imp.id(12536920970844342)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12907532640841968)
,p_validation_name=>'check if schema exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = upper(:F4050_P79_SCHEMA)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Schema does not exist.'
,p_validation_condition=>':F4050_P79_EXISTING = ''1'' and :F4050_P79_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(12559200978895311)
,p_associated_item=>wwv_flow_imp.id(12536920970844342)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12920702259889987)
,p_validation_name=>'password required'
,p_validation_sequence=>40
,p_validation=>'F4050_P79_SCHEMA_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Password must be specified.'
,p_validation_condition=>':F4050_P79_EXISTING = ''0'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(12559200978895311)
,p_associated_item=>wwv_flow_imp.id(12541530105856426)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12941526463944301)
,p_validation_name=>'quota not 0'
,p_validation_sequence=>50
,p_validation=>'F4050_P79_QUOTA'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Quota must be specified.'
,p_validation_condition=>':F4050_P79_EXISTING = ''0'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(12559200978895311)
,p_associated_item=>wwv_flow_imp.id(12543318462862552)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13051609305876166)
,p_validation_name=>'check if schema doesn''t exist'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = upper(:F4050_P79_SCHEMA)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Schema already exists.'
,p_validation_condition=>':F4050_P79_EXISTING = ''0'' and :F4050_P79_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(12559200978895311)
,p_associated_item=>wwv_flow_imp.id(12536920970844342)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(68152924708064446)
,p_validation_name=>'check existing schema not internal'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where provisioning_company_id = 10',
'   and first_schema_provisioned = upper(:F4050_P79_SCHEMA)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Cannot use INTERNAL schema.'
,p_validation_condition=>':F4050_P79_EXISTING = ''1'' and :F4050_P79_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(12559200978895311)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114752711027135415)
,p_validation_name=>'schema not reserved/restricted'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provision.schema_name_valid(',
'    p_schema            => :F4050_P79_SCHEMA,',
'    p_workspace_name    => :F4050_P27_COMPANY);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Schema is reserved or restricted'
,p_when_button_pressed=>wwv_flow_imp.id(12559200978895311)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(56740204823780291)
,p_validation_name=>'password format rules'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.password_validation(',
'           p_username => :F4050_P79_SCHEMA,',
'           p_password => :F4050_P79_SCHEMA_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Schema password must be 30 ASCII characters or less, and not include a double quote. The password must also conform to any password complexity rules defined for the database. '
,p_validation_condition=>':F4050_P79_EXISTING = ''0'' and :F4050_P79_SCHEMA_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(12559200978895311)
,p_associated_item=>wwv_flow_imp.id(12541530105856426)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1213282613785258420)
,p_name=>'Reuse Schema'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P79_EXISTING'
,p_condition_element=>'F4050_P79_EXISTING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1213282932418258421)
,p_event_id=>wwv_flow_imp.id(1213282613785258420)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P79_SCHEMA_PASSWORD,F4050_P79_QUOTA'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1213283115062258422)
,p_event_id=>wwv_flow_imp.id(1213282613785258420)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P79_SCHEMA_PASSWORD,F4050_P79_QUOTA'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(241508530030179525)
,p_name=>'Refresh Schema Info if Reuse'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P79_EXISTING'
,p_condition_element=>'F4050_P79_EXISTING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_required_patch=>wwv_flow_imp.id(4226407758971148501)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(241508851019179528)
,p_event_id=>wwv_flow_imp.id(241508530030179525)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(241507625027179516)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(241508974917179529)
,p_event_id=>wwv_flow_imp.id(241508530030179525)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(241507625027179516)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(241509064010179530)
,p_event_id=>wwv_flow_imp.id(241508530030179525)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(241507625027179516)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(241508317987179523)
,p_name=>'Refresh Schema Info if schema changed'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P79_SCHEMA'
,p_condition_element=>'F4050_P79_EXISTING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_required_patch=>wwv_flow_imp.id(4226407758971148501)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(241508422473179524)
,p_event_id=>wwv_flow_imp.id(241508317987179523)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(241507625027179516)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2600305730498702)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Set Item F4050_P79_SCHEMA_PASSWORD to null'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4050_P79_SCHEMA_PASSWORD'
,p_internal_uid=>2600305730498702
);
end;
/
prompt --application/pages/page_00080
begin
wwv_flow_imp_page.create_page(
 p_id=>80
,p_name=>'Activity by Workspace by Day'
,p_alias=>'ACTIVITY-BY-WORKSPACE-BY-DAY'
,p_step_title=>'Activity by Workspace by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201374126243613345)
,p_plug_name=>'Activity by Workspace'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    WORKSPACE_ID workspace,',
'    (select short_name from wwv_flow_companies where provisioning_company_id = workspace_id) workspace_name,',
'    count(distinct APPLICATION_ID) applications,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'group by LOG_DAY, workspace_id'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(201374302520613352)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201374421565613353)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201374517849613354)
,p_db_column_name=>'DAY'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Day'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201374632459613355)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201374701774613356)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582264518231682816)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'T'
,p_column_label=>'Public Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201374827012613357)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201374917308613358)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Page Posts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201375011933613359)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201375224837613361)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Rows Fetched'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201375302032613362)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>'Interactive Report Searches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201375427908613363)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201375519884613364)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201375629818613365)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201375713682613366)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Total Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201375809425613367)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201375906686613368)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201376015353613369)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201376117728613370)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(201376317505613372)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1315425982536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:WORKSPACE_NAME:APPLICATIONS:PAGE_EVENTS:ROWS_FETCHED:DISTINCT_PAGES:DISTINCT_USERS:DISTINCT_SESSIONS:TOTAL_RENDER_TIME:ERROR_COUNT:CONTENT_LENGTH'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(484705024716062089)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(201374126243613345)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:80,RIR::'
);
end;
/
prompt --application/pages/page_00081
begin
wwv_flow_imp_page.create_page(
 p_id=>81
,p_name=>'Remove Workspace'
,p_alias=>'REMOVE-WORKSPACE'
,p_step_title=>'Remove Workspace - Identify Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14594219371324854)
,p_plug_name=>'Select Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14913329255048880)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(14571819699173520)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202765904517773962)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752111225869695869)
,p_plug_name=>'Remove Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14602029470431848)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202765904517773962)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14602914018436860)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202765904517773962)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14603212719436863)
,p_branch_action=>'82'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14602323502431864)
,p_branch_action=>'3'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(14602029470431848)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14614023639074072)
,p_name=>'P81_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(14594219371324854)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.WORKSPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a workspace from the list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14614600006086241)
,p_name=>'P81_SGID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(14594219371324854)
,p_prompt=>'Sgid'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(14617300446143134)
,p_validation_name=>'valid company'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_sgid number;',
'begin',
'for c1 in (select provisioning_company_id',
'             from wwv_flow_companies',
'            where short_name = upper(:P81_COMPANY) ) loop',
'  l_sgid := c1.provisioning_company_id;',
'  exit;',
'end loop;',
':P81_SGID := l_sgid;',
'return nvl(:P81_SGID,''0'') not in (''0'',''10'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid workspace.'
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00082
begin
wwv_flow_imp_page.create_page(
 p_id=>82
,p_name=>'Remove Workspace'
,p_alias=>'REMOVE-WORKSPACE2'
,p_step_title=>'Remove Workspace - Verify Applications'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_lock.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14593705173320764)
,p_plug_name=>'Applications and Users'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cc number;',
'    l_uc number;',
'begin',
'    select count(*)',
'      into l_cc',
'      from wwv_flows',
'     where security_group_id = :P81_SGID;',
'',
'    select count(*)',
'      into l_uc',
'      from wwv_flow_fnd_user',
'     where security_group_id = :P81_SGID;',
' ',
'    return ''<p>'' || wwv_flow_lang_dev.builder_message(',
'                        p_name => ''4050_82_WORKSPACE'',',
'                        p1     => wwv_flow_escape.html(:P81_COMPANY),',
'                        p2     => l_cc,',
'                        p3     => l_uc)',
'                 || ''</p>'';    ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_plug_header=>'Note the number of applications and users in &P81_COMPANY.. Make a selection to indicate whether you wish to proceed, and if you wish to also delete the request.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14914429863067996)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(14571819699173520)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202768115037786443)
,p_plug_name=>'wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752111382363695869)
,p_plug_name=>'Remove Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14603914495446450)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202768115037786443)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14604824538449331)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202768115037786443)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14605700081451745)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202768115037786443)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14604224784446451)
,p_branch_action=>'3'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(14603914495446450)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14606013354451746)
,p_branch_action=>'81'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(14605700081451745)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14605118530449332)
,p_branch_action=>'83'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(14604824538449331)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14923621870188674)
,p_name=>'P82_PROCEED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(14593705173320764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Check to confirm that you wish to proceed with the removal.'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Yes'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14924614036195964)
,p_name=>'P82_REQUEST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(14593705173320764)
,p_item_default=>'Yes'
,p_source=>'Yes'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes2=>'class="instructiontext"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify if you wish to also remove the request for the workspace in question.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(14931826737341549)
,p_validation_name=>'must check proceed'
,p_validation_sequence=>10
,p_validation=>'nvl(:P82_PROCEED,''No'') = ''Yes'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Must check to proceed.'
,p_when_button_pressed=>wwv_flow_imp.id(14604824538449331)
,p_associated_item=>wwv_flow_imp.id(14923621870188674)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
end;
/
prompt --application/pages/page_00083
begin
wwv_flow_imp_page.create_page(
 p_id=>83
,p_name=>'Remove Workspace'
,p_alias=>'REMOVE-WORKSPACE1'
,p_step_title=>'Remove Workspace - Confirm Workspace Removal'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(14593004003310937)
,p_name=>'Database Objects'
,p_template=>wwv_flow_imp.id(721130166613730309)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner user_name,',
'       tablespace_name tblspc_name',
'  from sys.dba_segments',
' where owner in (select schema',
'                   from wwv_flow_company_schemas',
'                  where security_group_id = :P81_SGID)',
' group by owner,',
'          tablespace_name'))
,p_header=>'<p>You may wish to remove the following database objects associated with the workspace. utilizing your preferred database administration tool.  Clicking on the "Remove" button <strong>will not</strong> remove these objects from the database.</p>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48758313236772048)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48758414533772048)
,p_query_column_id=>2
,p_column_alias=>'TBLSPC_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Tablespaces'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14917018912074297)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(14571819699173520)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(15181710710380687)
,p_name=>'Other schemas using above tablespaces'
,p_template=>wwv_flow_imp.id(202654431224384775)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.default_tablespace, a.username',
'  from sys.dba_users a',
' where default_tablespace in (select default_tablespace ',
'                                from sys.dba_users',
'                               where username in (select schema ',
'                      from wwv_flow_company_schemas d',
'                     where d.security_group_id = :P81_SGID))',
'group by a.username, a.default_tablespace'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'<p />No other schemas found using above tablespaces.'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(27281122243677013)
,p_query_column_id=>1
,p_column_alias=>'DEFAULT_TABLESPACE'
,p_column_display_sequence=>1
,p_column_heading=>'Tablespace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(27281231350677018)
,p_query_column_id=>2
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>2
,p_column_heading=>'Schemas'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19230510658720488)
,p_plug_name=>'DB Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(202654431224384775)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Read the information about the reports on this page. Use this information to decide whether to use a database administration tool to remove the database objects associated with the workspace. Click <strong>Remove Workspace</strong> to remove the w'
||'orkspace.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202769707334803166)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752111474238695870)
,p_plug_name=>'Remove Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14606702898020828)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202769707334803166)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14608612726033126)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202769707334803166)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Remove Workspace'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14607701644029883)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202769707334803166)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14607015917020918)
,p_branch_action=>'3'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(14606702898020828)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14608922159033128)
,p_branch_action=>'84'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(14608612726033126)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14608029060029885)
,p_branch_action=>'82'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(14607701644029883)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15237905291663011)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove company'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provisioning.terminate_service_by_sgid(:P81_SGID);',
'if :P82_REQUEST = ''Yes'' then',
'  for c1 in (select id',
'               from wwv_flow_provision_company',
'              where security_group_id = :P81_SGID ) loop',
'    wwv_flow_provisioning.delete_provision_request(c1.id);',
'    exit;',
'  end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error removing workspace.'
,p_process_when_button_id=>wwv_flow_imp.id(14608612726033126)
,p_process_success_message=>'Workspace removed'
,p_internal_uid=>15237905291663011
);
end;
/
prompt --application/pages/page_00084
begin
wwv_flow_imp_page.create_page(
 p_id=>84
,p_name=>'Remove Workspace'
,p_alias=>'REMOVE-WORKSPACE3'
,p_step_title=>'Remove Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14592527767308349)
,p_plug_name=>'Success'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wiz_confirm.display_create_success_page(',
'                p_success_msg => wwv_flow_lang_dev.builder_message(''REMOVE_WORKSPACE_SUCCESS_MSG''));'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(207758923297627802)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752111523341695870)
,p_plug_name=>'Remove Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19257111051749035)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(207758923297627802)
,p_button_name=>'DONE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Done'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_00085
begin
wwv_flow_imp_page.create_page(
 p_id=>85
,p_name=>'Manage Click Counting Log'
,p_alias=>'MANAGE-CLICK-COUNTING-LOG'
,p_step_title=>'Manage Click Counting Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(64963723000904073)
,p_plug_name=>'Delete Click Counting Log Entries'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_dev number := 0;',
'begin',
'    select count(*)',
'      into c_dev',
'      from wwv_flow_clickthru_log_v;',
'',
'    return ''<p>''',
'           || wwv_flow_lang_dev.builder_message(''4050_85_CLICK_COUNT'') || '': ''',
'           || to_char(c_dev, ''999,999,999,990'')',
'           || ''</p>'';        ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1080987434530523907)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1082458667726299596)
,p_plug_name=>'External Click Counting Log'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Links to external URLs can be counted using the APEX_UTIL.COUNT_CLICK procedure. '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(64964604942904082)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1080987434530523907)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Entries'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(64964329194904080)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1080987434530523907)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(64965617138904089)
,p_branch_action=>'85'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(64964604942904082)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64964910248904083)
,p_name=>'P85_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(64963723000904073)
,p_prompt=>'Delete entries this number of days and older:'
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_imp.id(87720511660244788)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Purge entries older than this number of days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(64965310351904088)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_clickthru_log$',
'where clickdate < (sysdate - nvl(:p85_time,31));',
'delete from wwv_flow_clickthru_log2$',
'where clickdate < (sysdate - nvl(:p85_time,31));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error purging Click Counting log.'
,p_process_when_button_id=>wwv_flow_imp.id(64964604942904082)
,p_process_success_message=>'External Click Counting Log purged.'
,p_internal_uid=>64965310351904088
);
end;
/
prompt --application/pages/page_00086
begin
wwv_flow_imp_page.create_page(
 p_id=>86
,p_name=>'Page Events by Day'
,p_alias=>'PAGE-EVENTS-BY-DAY1'
,p_step_title=>'Page Events by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'04'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(692988924470464115)
,p_plug_name=>'Page Events by Day'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_comment=>'NOTE: the Time Axis Type attribute cannot be used with this chart, as it will render the chart data in chronological order instead of reverse order. Have discussed with the JET team, and the only way around this is to apply formatting in the query. A'
||' Format Type of date will not work in this situation either.'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(692989033227464116)
,p_region_id=>wwv_flow_imp.id(692988924470464115)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'on'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ){',
'    options.initialZooming = ''first'';',
'    return options;',
'}'))
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(692989152686464117)
,p_chart_id=>wwv_flow_imp.id(692989033227464116)
,p_seq=>10
,p_name=>'Page Events'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(LOG_DAY,''&DATE_FORMAT.'') LOG_DAY_FORMAT,',
'       sum(page_events) PAGE_EVENTS,',
'       to_char(LOG_DAY,''&DATE_FORMAT.'') ||'' - ''||sum(page_events) TOOLTIP',
' from WWV_FLOW_LOG_HISTORY ',
' where log_day >= sysdate - (nvl(:P86_SINCE,365)+ 1)',
'group by LOG_DAY',
'order by log_day desc'))
,p_ajax_items_to_submit=>'DATE_FORMAT'
,p_items_value_column_name=>'PAGE_EVENTS'
,p_items_label_column_name=>'LOG_DAY_FORMAT'
,p_items_short_desc_column_name=>'TOOLTIP'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692989208016464118)
,p_chart_id=>wwv_flow_imp.id(692989033227464116)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692989348943464119)
,p_chart_id=>wwv_flow_imp.id(692989033227464116)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2518799722329348512)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(880582675247775376)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2518799722329348512)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(880583028228775377)
,p_name=>'P86_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2518799722329348512)
,p_item_default=>'365'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00087
begin
wwv_flow_imp_page.create_page(
 p_id=>87
,p_name=>'Inactive Workspaces'
,p_alias=>'INACTIVE-WORKSPACES'
,p_step_title=>'Inactive Workspaces'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505829811233279931)
,p_plug_name=>'Inactive workspaces'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.security_group_id, p.workspace_name, p.admin_email, p.status, p.date_to_purge, p.purged_ts, ',
'case when status in (''NEW'',''STAGE1'',''STAGE2'')  then trunc(date_to_purge - sysdate + 1)',
'else null end days_until_purge',
'  from wwv_purge_workspaces p'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(505829910729279931)
,p_name=>'Inactive workspaces'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505830114353279935)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505830215491279937)
,p_db_column_name=>'ADMIN_EMAIL'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Administrator Email'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505830310938279937)
,p_db_column_name=>'STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(615479015710157661)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505830425352279937)
,p_db_column_name=>'DATE_TO_PURGE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Date to Purge'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(615371414664780015)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(628538101320762044)
,p_db_column_name=>'PURGED_TS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Date Purged'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(628538231731762047)
,p_db_column_name=>'DAYS_UNTIL_PURGE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Days Until Purge'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(505830610109280139)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1315514731536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:ADMIN_EMAIL:STATUS:DATE_TO_PURGE:SECURITY_GROUP_ID:DAYS_TO_PURGE:PURGED_TS:DAYS_UNTIL_PURGE'
,p_sort_column_1=>'DATE_TO_PURGE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'WORKSPACE_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
end;
/
prompt --application/pages/page_00088
begin
wwv_flow_imp_page.create_page(
 p_id=>88
,p_name=>'Workspace Tablespace Utilization Details'
,p_alias=>'WORKSPACE-TABLESPACE-UTILIZATION-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Workspace Tablespace Utilization Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098050798687927)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20473405904587601)
,p_name=>'Workspace Tablespace Utilization'
,p_template=>wwv_flow_imp.id(721130166613730309)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with workspace_tablespace as',
'    ( select distinct default_tablespace',
'        from sys.dba_users',
'       where username in ',
'             (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :P88_SGID)',
'    )',
'select tm.tablespace_name name,',
'       tm.tablespace_size * ts.block_size bytes,',
'       (tm.tablespace_size-tm.used_space) * ts.block_size free,',
'       tm.used_space * ts.block_size used,',
'       tm.used_percent pct_used',
'  from workspace_tablespace wt,',
'       sys.dba_tablespaces  ts,',
'       sys.dba_tablespace_usage_metrics tm',
' where wt.default_tablespace = ts.tablespace_name',
'   and ts.tablespace_name    = tm.tablespace_name',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select name, bytes, bytes-free used, free, (bytes-free)/bytes*100 pct_used from',
'(select t.tablespace_name name,',
'       ( select sum(user_blocks * t.block_size)',
'             from sys.dba_data_files',
'            where tablespace_name = t.tablespace_name ) bytes,',
'       ( select sum(bytes)',
'             from sys.dba_free_space',
'            where tablespace_name = t.tablespace_name ) free',
'   from sys.dba_tablespaces t',
'  where tablespace_name in (select default_tablespace',
'           from sys.dba_users where username in (select schema from wwv_flow_company_schemas',
'           where security_group_id= :P88_SGID )))',
'  order by 1'))
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48758714618772055)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Tablespace Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48758816637772055)
,p_query_column_id=>2
,p_column_alias=>'BYTES'
,p_column_display_sequence=>2
,p_column_heading=>'Bytes'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48759019303772055)
,p_query_column_id=>3
,p_column_alias=>'FREE'
,p_column_display_sequence=>4
,p_column_heading=>'Amount Free'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48758922966772055)
,p_query_column_id=>4
,p_column_alias=>'USED'
,p_column_display_sequence=>3
,p_column_heading=>'Amount Used'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48759100469772055)
,p_query_column_id=>5
,p_column_alias=>'PCT_USED'
,p_column_display_sequence=>5
,p_column_heading=>'Percentage Used'
,p_use_as_row_header=>'N'
,p_column_format=>'999D99'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955891504788997326)
,p_plug_name=>'New'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(955891291846997323)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(955891504788997326)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Close'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20474119756591606)
,p_name=>'P88_SGID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20473405904587601)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(955891358314997324)
,p_name=>'Close dialogue'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(955891291846997323)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(955891426517997325)
,p_event_id=>wwv_flow_imp.id(955891358314997324)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
end;
/
prompt --application/pages/page_00089
begin
wwv_flow_imp_page.create_page(
 p_id=>89
,p_name=>'Lock Workspace'
,p_alias=>'LOCK-WORKSPACE'
,p_step_title=>'Lock Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_lock.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74652808599025380)
,p_plug_name=>'Select Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(85915716857846509)
,p_plug_name=>'Lock Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(202654431224384775)
,p_plug_display_sequence=>200
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Lock Workspace locks all workspace administrator, developer and user accounts in the workspace.  Lock Workspace also changes the status of all applications in the workspace to <strong>Unavailable</strong>.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202792128823310849)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752111603710695870)
,p_plug_name=>'Lock Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(74653918545025411)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202792128823310849)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(74654109803025411)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202792128823310849)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(74655525602025412)
,p_branch_action=>'90'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74654301592025411)
,p_name=>'P89_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(74652808599025380)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.WORKSPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the name of the workspace, or choose one from the popup list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74654819424025411)
,p_name=>'P89_SGID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(74652808599025380)
,p_prompt=>'Workspace ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(74655127973025412)
,p_validation_name=>'valid company'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_sgid number;',
'begin',
'for c1 in (select provisioning_company_id',
'             from wwv_flow_companies',
'            where short_name = upper(:P89_COMPANY) ) loop',
'  l_sgid := c1.provisioning_company_id;',
'  exit;',
'end loop;',
':P89_SGID := l_sgid;',
'return nvl(:P89_SGID,''0'') not in (''0'',''10'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid workspace.'
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(74654301592025411)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00090
begin
wwv_flow_imp_page.create_page(
 p_id=>90
,p_name=>'Lock Workspace'
,p_alias=>'LOCK-WORKSPACE1'
,p_step_title=>'Lock Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_lock.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74669328104071891)
,p_plug_name=>'Lock Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>5
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Lock Workspace will lock all workspace administrator, developer and user accounts in the workspace.  Lock Workspace will also change the status of all applications in the workspace to Unavailable.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(85653808387907448)
,p_plug_name=>'Lock Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(85674623437148366)
,p_name=>'Applications'
,p_template=>wwv_flow_imp.id(721128767486730308)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, owner, flow_status',
'  from wwv_flows',
' where security_group_id = :P90_SGID',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No applications found in workspace.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(85675011809148369)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(85674820363148369)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Application Name'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(85674919778148369)
,p_query_column_id=>3
,p_column_alias=>'OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Application Schema'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(85780729736329933)
,p_query_column_id=>4
,p_column_alias=>'FLOW_STATUS'
,p_column_display_sequence=>4
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(85746300886317667)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(85676332095150788)
,p_name=>'&PRODUCT_NAME. Users'
,p_template=>wwv_flow_imp.id(721128767486730308)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_name, default_schema, email_address, nvl(account_locked,''N'') account_locked',
'  from wwv_flow_fnd_user',
' where security_group_id = :P90_SGID',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No users found.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(85676514972150788)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'User'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(85676628931150788)
,p_query_column_id=>2
,p_column_alias=>'DEFAULT_SCHEMA'
,p_column_display_sequence=>2
,p_column_heading=>'Default Schema'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(85676726660150788)
,p_query_column_id=>3
,p_column_alias=>'EMAIL_ADDRESS'
,p_column_display_sequence=>3
,p_column_heading=>'Email'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(85689614658212069)
,p_query_column_id=>4
,p_column_alias=>'ACCOUNT_LOCKED'
,p_column_display_sequence=>4
,p_column_heading=>'Account Availability'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(12506800188785204)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168835408368573854)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752111718873695870)
,p_plug_name=>'Lock Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(74670426220071893)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(168835408368573854)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(74670021900071892)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168835408368573854)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(74670217088071892)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(168835408368573854)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Lock Workspace'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(74671131723071894)
,p_branch_action=>'89'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(74670426220071893)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(85925801975917954)
,p_branch_action=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(74670217088071892)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85656725141921763)
,p_name=>'P90_SGID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(85653808387907448)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace:'
,p_source=>'P89_SGID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Name of the workspace to be locked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(74670619125071893)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lock workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P89_SGID,''0'') not in (''0'',''10'') then',
'  wwv_flow_admin_api.lock_workspace( p_security_group_id => :P89_SGID );',
'  commit;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error locking workspace.'
,p_process_when_button_id=>wwv_flow_imp.id(74670217088071892)
,p_process_success_message=>'Workspace locked.'
,p_internal_uid=>74670619125071893
);
end;
/
prompt --application/pages/page_00091
begin
wwv_flow_imp_page.create_page(
 p_id=>91
,p_name=>'Workspaces Purged'
,p_alias=>'WORKSPACES-PURGED'
,p_step_title=>'Workspaces Purged'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505836210479512428)
,p_plug_name=>'Workspaces Purged'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct w.workspace_name, s.schema, d.tablespace_name, d.bytes',
'                 from wwv_purge_log w, wwv_purge_schemas s, wwv_purge_datafiles d',
'                where w.log_code = ''PURGE_COMPLETE''',
'                  and w.created_ts > (systimestamp - numtodsinterval(nvl(:P91_DAYS,1), ''day''))',
'                  and w.security_group_id = s.security_group_id',
'                  and w.security_group_id = d.security_group_id',
'                order by 1, 2, 3, 4'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(505836315529512428)
,p_name=>'Workspaces Purged Today'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505836503851512431)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505836613500512432)
,p_db_column_name=>'SCHEMA'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505836725519512432)
,p_db_column_name=>'TABLESPACE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Tablespace Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505836816343512432)
,p_db_column_name=>'BYTES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Bytes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(505836928837512643)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1315605980536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:SCHEMA:TABLESPACE_NAME:BYTES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505847413010640446)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(505848023530652971)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(505847413010640446)
,p_button_name=>'P91_SET'
,p_button_static_id=>'P91_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(505848407731657863)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(505847413010640446)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:91,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(505848201681652972)
,p_branch_action=>'f?p=&FLOW_ID.:91:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(505847814526650412)
,p_name=>'P91_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(505847413010640446)
,p_item_default=>'1'
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PURGE.DAYS_LIST'
,p_lov=>'.'||wwv_flow_imp.id(615512721869254091)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Set</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00092
begin
wwv_flow_imp_page.create_page(
 p_id=>92
,p_name=>'Workspaces that became Active'
,p_alias=>'WORKSPACES-THAT-BECAME-ACTIVE'
,p_step_title=>'Workspaces that became Active'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505838125174522495)
,p_plug_name=>'Workspaces that became Active'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P92 */ distinct workspace_name, security_group_id',
'from wwv_purge_log',
'where log_code = ''DELETE''',
'   and created_ts > (systimestamp - numtodsinterval(nvl(:P92_DAYS,1), ''day''))'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(505838232270522495)
,p_name=>'Workspaces Removed from the Purge List today'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505838422421522498)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505838513808522499)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(505838631046522712)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1315701923536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:SECURITY_GROUP_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505849527948673205)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615472630424124073)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Workspaces that become active during the designated Days Until Purge are automatically removed from the Inactive Workspace list and are no longer candidates for purging.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(505850123231681263)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(505849527948673205)
,p_button_name=>'P92_SET'
,p_button_static_id=>'P92_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(505850309163686715)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(505849527948673205)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:92,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(505849812149678096)
,p_name=>'P92_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(505849527948673205)
,p_item_default=>'1'
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PURGE.DAYS_LIST'
,p_lov=>'.'||wwv_flow_imp.id(615512721869254091)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Set</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00093
begin
wwv_flow_imp_page.create_page(
 p_id=>93
,p_name=>'Active Workspaces by Day'
,p_alias=>'ACTIVE-WORKSPACES-BY-DAY'
,p_step_title=>'Active Workspaces by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'04'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(692989966723464125)
,p_plug_name=>'Page Events by Day'
,p_region_name=>'pageeventsbyday'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(692990050991464126)
,p_region_id=>wwv_flow_imp.id(692989966723464125)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_initial_zooming=>'none'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'on'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ){',
'    options.initialZooming = ''last'';',
'    return options;',
'}'))
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(692990176523464127)
,p_chart_id=>wwv_flow_imp.id(692990050991464126)
,p_seq=>10
,p_name=>'Page Events'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(LOG_DAY,''&DATE_FORMAT.'') LOG_DAY_FORMAT,',
'       count(distinct workspace_id) PAGE_EVENTS,',
'       to_char(LOG_DAY,''&DATE_FORMAT.'')||'' - ''||count(distinct workspace_id) TOOLTIP',
'from WWV_FLOW_LOG_HISTORY ',
'group by LOG_DAY',
'order by log_day asc'))
,p_ajax_items_to_submit=>'DATE_FORMAT'
,p_items_value_column_name=>'PAGE_EVENTS'
,p_items_label_column_name=>'LOG_DAY_FORMAT'
,p_items_short_desc_column_name=>'TOOLTIP'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692990212509464128)
,p_chart_id=>wwv_flow_imp.id(692990050991464126)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692990324626464129)
,p_chart_id=>wwv_flow_imp.id(692990050991464126)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00094
begin
wwv_flow_imp_page.create_page(
 p_id=>94
,p_name=>'Page Views by User by Day'
,p_alias=>'PAGE-VIEWS-BY-USER-BY-DAY'
,p_step_title=>'Page Views by User by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1843561779293435779)
,p_plug_name=>'Page Views by User'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'select /* APEX 4050P94a */ wwv_flow_lang.system_message(''AUTH.LOGIN_PAGE'') login_page,',
'wwv_flow_lang.system_message(''UNAUTHENTICATED_USER'') unauth_user,',
'(select count(*) tv',
'from wwv_flow_activity_log l',
'where l.time_stamp>=(select sysdate - to_number(',
':F4050_P94_DAYS) x from dual )  ) tv',
'from dual)',
'select ',
'decode(lower(l.userid),null,',
'  messages.login_page,''nobody'',',
'  messages.unauth_user,lower(l.userid))',
'   user_name,',
'lower(c.short_name) workspace,',
' sum(nvl(content_length,0)) content_length,',
' count(*) page_views, ',
' 100*count(*)/tv pct, ',
' sum(num_rows) report_rows, count(distinct(ip_address)) ip_addresses, sum(elap) total_elapsed, avg(elap) average_elapsed, count(distinct to_char(time_stamp,''YYYYMMDDHH24'')) distinct_hours, count(distinct to_char(time_stamp,''YYYYMMDD'')) distinct_days',
'from wwv_flow_activity_log l, ',
'     wwv_flow_companies c, messages',
'where l.security_group_id = c.provisioning_company_id (+)',
'and page_mode != ''A''',
'and l.time_stamp>=(select sysdate - to_number(',
':F4050_P94_DAYS) x from dual )  ',
'group by decode(lower(l.userid),null,',
'  login_page,''nobody'',',
'  unauth_user,lower(l.userid)),',
'  lower(c.short_name),',
'  tv'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'F4050_P94_DAYS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1843561896663435779)
,p_name=>'Page Views by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1843561896663435779
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813863265807998223)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813862802541998218)
,p_db_column_name=>'USER_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'User Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813863605962998223)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813864037040998224)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813864435773998224)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Report Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813864800637998224)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'IP Addresses'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813865255820998225)
,p_db_column_name=>'TOTAL_ELAPSED'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Total Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813865674712998225)
,p_db_column_name=>'AVERAGE_ELAPSED'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Average Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813866074061998225)
,p_db_column_name=>'DISTINCT_HOURS'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Distinct Hours'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813866401301998226)
,p_db_column_name=>'DISTINCT_DAYS'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Distinct Days'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1813866865177998226)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1843563193423437608)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'18138672'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE:USER_NAME:PAGE_VIEWS:PCT:REPORT_ROWS:IP_ADDRESSES:TOTAL_ELAPSED:AVERAGE_ELAPSED:DISTINCT_HOURS:DISTINCT_DAYS:CONTENT_LENGTH'
,p_sort_column_1=>'PAGE_VIEWS'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2004666803053510818)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1813867914075998239)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2004666803053510818)
,p_button_name=>'P94_GO'
,p_button_static_id=>'P36_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1813868379678998241)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2004666803053510818)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:94:&SESSION.::&DEBUG.:36,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1813868711832998242)
,p_name=>'F4050_P94_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2004666803053510818)
,p_item_default=>'to_number(.000694444)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1813870099414998271)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P94_DAYS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:F4050_P94_DAYS);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00095
begin
wwv_flow_imp_page.create_page(
 p_id=>95
,p_name=>'Authorized URLs'
,p_alias=>'AUTHORIZED-URLS'
,p_step_title=>'Authorized URLs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_config_sec.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(799808515820155857)
,p_plug_name=>'Authorized URLs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  url,',
'  description,',
'  created_on created,',
'  created_by,',
'  last_updated_on updated,',
'  last_updated_by updated_by',
'from wwv_flow_authorized_urls'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(799808631492155857)
,p_name=>'Authorized URLs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_detail_link=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:96:P96_ID:#ID#'
,p_detail_link_text=>'<span class="a-Icon icon-edit"></span>'
,p_detail_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(799808828808155888)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(799808912154155890)
,p_db_column_name=>'URL'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(799809012209155891)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(799809122999155891)
,p_db_column_name=>'CREATED'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(799809210914155891)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(799809302456155891)
,p_db_column_name=>'UPDATED'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(799809408125155892)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(799809512928156136)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1315801833536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:URL:DESCRIPTION:UPDATED:UPDATED_BY'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(799822323172262989)
,p_plug_name=>'Security Second Level Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(799821322334262935)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(169533626431592276)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(799823125582273390)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(799808515820155857)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:95,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(799822914500270176)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(799808515820155857)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Authorized URL'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:96::'
,p_icon_css_classes=>'icon-right-chevron'
);
end;
/
prompt --application/pages/page_00096
begin
wwv_flow_imp_page.create_page(
 p_id=>96
,p_name=>'Authorized URL'
,p_alias=>'AUTHORIZED-URL'
,p_step_title=>'Authorized URL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_config_sec.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(799810302142166499)
,p_plug_name=>'URL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(799815518609242981)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Authorized URLs identify the list of URLs that can be used as parameter values of certain &PRODUCT_NAME. procedures. This includes the <code>APEX_UTIL.COUNT_CLICK</code> procedure, which has an input parameter named <code>P_NEXT_URL</code>. If the pa'
||'rameter value to <code>P_NEXT_URL</code> is not a relative URL and not to the current host name, then it must be contained in this list of Authorized URLs.',
'<p><br />Authorized URLs also are used to define allowable endpoints for webservice requests. If at least one Authorized URL is defined, then only endpoints in the Authorized URL list can be accessed.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(799824626106311381)
,p_name=>'Currently Defined Authorized URLs'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select url from wwv_flow_authorized_urls order by 1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Authorized URLs currently defined.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(799824908148311388)
,p_query_column_id=>1
,p_column_alias=>'URL'
,p_column_display_sequence=>1
,p_column_heading=>'Authorized URL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955891803989997329)
,p_plug_name=>'Authorized URL'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(799810819548166502)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(955891803989997329)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(799810722590166501)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(955891803989997329)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P96_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(799810618017166501)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(955891803989997329)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P96_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(799810528858166501)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(955891803989997329)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Authorized URL'
,p_button_position=>'NEXT'
,p_button_condition=>'P96_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(799811505458166508)
,p_branch_action=>'f?p=&APP_ID.:95:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(799811718294166515)
,p_name=>'P96_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(799810302142166499)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(799811922979166616)
,p_name=>'P96_URL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(799810302142166499)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Authorized URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identify an authorized URL that can be used as the parameter value to certain &PRODUCT_NAME. procedures, including <code>APEX_UTIL.COUNT_CLICK</code>.</p>',
'',
'<p>The entire Authorized URL value will be compared with the URL parameter value in these procedures. If there is an exact match up to and including the entire length of the Authorized URL value, then the URL parameter value will be permitted.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(799812102826166621)
,p_name=>'P96_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(799810302142166499)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Description of URL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(801767632534619488)
,p_validation_name=>'P96_URL'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_duplicate_found boolean := FALSE;',
'begin',
'    for c1 in (select null',
'                 from wwv_flow_authorized_urls',
'                where url = trim(lower(:P96_URL))',
'                  and (:P96_ID is null or id <> :P96_ID)) loop',
'        l_duplicate_found := TRUE;',
'        exit;',
'    end loop;',
'    return not l_duplicate_found;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'&P96_URL. is already defined as an authorized URL.'
,p_associated_item=>wwv_flow_imp.id(799811922979166616)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(799812316965166623)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_AUTHORIZED_URLS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_AUTHORIZED_URLS'
,p_attribute_03=>'P96_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>799812316965166623
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(799812507948166628)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_AUTHORIZED_URLS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_AUTHORIZED_URLS'
,p_attribute_03=>'P96_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing Authorized URL.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>799812507948166628
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(799812701639166628)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'96'
,p_process_when_button_id=>wwv_flow_imp.id(799810722590166501)
,p_internal_uid=>799812701639166628
);
end;
/
prompt --application/pages/page_00098
begin
wwv_flow_imp_page.create_page(
 p_id=>98
,p_name=>'Workspace Purge Log'
,p_alias=>'WORKSPACE-PURGE-LOG'
,p_step_title=>'Workspace Purge Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505840525468583836)
,p_plug_name=>'Workspace Purge Log'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.workspace_name, l.purge_workspace_id, l.security_group_id, l.created_ts, l.log_code, l.log_action, l.log_statement, l.log_error',
'  from wwv_purge_log l;'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(505840630703583836)
,p_name=>'Workspace Purge Log'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505840811195583839)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505840916651583842)
,p_db_column_name=>'PURGE_WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Purge Identification Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505841002894583842)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Workspace Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505841129052583842)
,p_db_column_name=>'CREATED_TS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505841212471583842)
,p_db_column_name=>'LOG_CODE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Code'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(615495005199220912)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505841319355583843)
,p_db_column_name=>'LOG_ACTION'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505841431546583843)
,p_db_column_name=>'LOG_STATEMENT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Statement'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(505841513103583843)
,p_db_column_name=>'LOG_ERROR'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Error'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(505844503351590378)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316014307536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:CREATED_TS:LOG_CODE:LOG_ACTION:LOG_STATEMENT:LOG_ERROR'
,p_sort_column_1=>'CREATED_TS'
,p_sort_direction_1=>'DESC'
);
end;
/
prompt --application/pages/page_00099
begin
wwv_flow_imp_page.create_page(
 p_id=>99
,p_name=>'Workspace Purge Dashboard'
,p_alias=>'WORKSPACE-PURGE-DASHBOARD'
,p_step_title=>'Workspace Purge Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(''#psummary .rc-content-bin'').css(''height'',''270px'');',
'apex.jQuery(''#psettings .rc-content-bin'').css(''height'',''270px'');',
''))
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505853305316732860)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Workspaces that are inactive for more than the designated Days Inactive are candidates for purging.  If the workspace continues to be inactive and a workspace administrator does not indicate that they wish to have their workspace retained, the wor'
||'kspace will be purged.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(505863112813801279)
,p_name=>'Settings'
,p_region_name=>'psettings'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h480'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'wwv_flow_platform.get_preference( ''PURGE_ENABLED'' ),',
'''Y'',wwv_flow_lang.system_message(''YES''),wwv_flow_lang.system_message(''NO'')) purge_enabled,',
'wwv_flow_platform.get_preference( ''EMAIL_INSTANCE_URL'' ) instance_url,',
'wwv_flow_platform.get_preference( ''PURGE_DAYS_TO_PURGE'' ) days_to_purge,',
'wwv_flow_platform.get_preference( ''PURGE_REMINDER_DAYS_IN_ADVANCE'' ) reminder_days_in_advance,',
'wwv_flow_platform.get_preference( ''PURGE_DAYS_INACTIVE'' ) days_inactive,',
'wwv_flow_platform.get_preference( ''PURGE_GRACE_PERIOD_DAYS'' ) grace_period,',
'wwv_flow_platform.get_preference( ''PURGE_MAX_RUN_HOURS'' ) max_run_hours,',
'wwv_flow_platform.get_preference( ''PURGE_MAX_WORKSPACES'' ) max_workspaces_to_purge,',
'wwv_flow_platform.get_preference( ''PURGE_LANG'' ) purge_language',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46450823627307947)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505863409536801393)
,p_query_column_id=>1
,p_column_alias=>'PURGE_ENABLED'
,p_column_display_sequence=>1
,p_column_heading=>'Automatic Purge Enabled'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505863502565801395)
,p_query_column_id=>2
,p_column_alias=>'INSTANCE_URL'
,p_column_display_sequence=>2
,p_column_heading=>'Instance URL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505863611939801395)
,p_query_column_id=>3
,p_column_alias=>'DAYS_TO_PURGE'
,p_column_display_sequence=>3
,p_column_heading=>'Days Until Purge'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505863721454801395)
,p_query_column_id=>4
,p_column_alias=>'REMINDER_DAYS_IN_ADVANCE'
,p_column_display_sequence=>4
,p_column_heading=>'Reminder Days In Advance'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505863807390801395)
,p_query_column_id=>5
,p_column_alias=>'DAYS_INACTIVE'
,p_column_display_sequence=>5
,p_column_heading=>'Days Inactive'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505863918648801395)
,p_query_column_id=>6
,p_column_alias=>'GRACE_PERIOD'
,p_column_display_sequence=>6
,p_column_heading=>'Grace Period'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505864025910801395)
,p_query_column_id=>7
,p_column_alias=>'MAX_RUN_HOURS'
,p_column_display_sequence=>7
,p_column_heading=>'Maximum Run Hours'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505864126160801395)
,p_query_column_id=>8
,p_column_alias=>'MAX_WORKSPACES_TO_PURGE'
,p_column_display_sequence=>8
,p_column_heading=>'Maximum Workspaces To Purge'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505864212540801395)
,p_query_column_id=>9
,p_column_alias=>'PURGE_LANGUAGE'
,p_column_display_sequence=>9
,p_column_heading=>'Purge Language'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505873013656962336)
,p_plug_name=>'Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(505826028978247783)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(505876725523022507)
,p_name=>'Recently Retained'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h480'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select workspace_name, created_ts from',
'(select l.workspace_name, max(l.created_ts) created_ts',
'  from wwv_purge_log l',
' where l.log_code  = ''RESPONSE_RETAIN''',
' group by l.workspace_name)',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47555718632924155)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Workspaces recently retained.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505877023800022511)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(505877307229022512)
,p_query_column_id=>2
,p_column_alias=>'CREATED_TS'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1080987645373523909)
,p_name=>'Weekly Summary'
,p_region_name=>'psummary'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    (   select count(distinct security_group_id )',
'        from wwv_purge_log',
'        where log_code = ''PURGE_COMPLETE''',
'            and created_ts > (systimestamp - numtodsinterval(7, ''day'')) ) purged,',
'    (   select count(distinct security_group_id )',
'        from wwv_purge_workspaces',
'        where status = ''RETAIN''',
'            and updated_ts > (systimestamp - numtodsinterval(7, ''day'')) ) retained,',
'    (   select count(distinct security_group_id )',
'        from wwv_purge_log',
'        where log_code = ''DELETE''',
'            and created_ts > (systimestamp - numtodsinterval(7, ''day'')) ) removed_due_to_activity,',
'    (   select count(distinct security_group_id )',
'        from wwv_purge_log',
'        where log_code = ''NEW''',
'            and created_ts > (systimestamp - numtodsinterval(7, ''day'')) ) added_to_purge_list',
'from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805663950138677747)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080987729929523910)
,p_query_column_id=>1
,p_column_alias=>'PURGED'
,p_column_display_sequence=>1
,p_column_heading=>'Purged'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080987895339523911)
,p_query_column_id=>2
,p_column_alias=>'RETAINED'
,p_column_display_sequence=>2
,p_column_heading=>'Retained'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080987997883523912)
,p_query_column_id=>3
,p_column_alias=>'REMOVED_DUE_TO_ACTIVITY'
,p_column_display_sequence=>3
,p_column_heading=>'Removed due to Activity'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080988062718523913)
,p_query_column_id=>4
,p_column_alias=>'ADDED_TO_PURGE_LIST'
,p_column_display_sequence=>4
,p_column_heading=>'Added to Purge List'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1080988148411523914)
,p_name=>'Workspaces to be Purged'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    (   select count(distinct security_group_id ) c',
'        from wwv_purge_workspaces',
'        where status in (''NEW'',''STAGE1'',''STAGE2'')',
'            and date_to_purge < (systimestamp + numtodsinterval(1, ''day'')) )  within_next_1_day,',
'    (   select count(distinct security_group_id ) c',
'        from wwv_purge_workspaces',
'        where status in (''NEW'',''STAGE1'',''STAGE2'')',
'            and date_to_purge < (systimestamp + numtodsinterval(3, ''day'')) ) within_next_3_days,',
'    (   select count(distinct security_group_id ) c',
'        from wwv_purge_workspaces',
'        where status in (''NEW'',''STAGE1'',''STAGE2'')',
'            and date_to_purge < (systimestamp + numtodsinterval(7, ''day'')) ) within_next_7_days',
'from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805663950138677747)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080988255613523915)
,p_query_column_id=>1
,p_column_alias=>'WITHIN_NEXT_1_DAY'
,p_column_display_sequence=>1
,p_column_heading=>'Within next 1 day'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:RP,RIR:IRLTE_DAYS_UNTIL_PURGE:1:'
,p_column_linktext=>'#WITHIN_NEXT_1_DAY#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080988396270523916)
,p_query_column_id=>2
,p_column_alias=>'WITHIN_NEXT_3_DAYS'
,p_column_display_sequence=>2
,p_column_heading=>'Within next 3 days'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:RP,RIR:IRLTE_DAYS_UNTIL_PURGE:3:'
,p_column_linktext=>'#WITHIN_NEXT_3_DAYS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1080988456169523917)
,p_query_column_id=>3
,p_column_alias=>'WITHIN_NEXT_7_DAYS'
,p_column_display_sequence=>3
,p_column_heading=>'Within next 7 days'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:RP,RIR:IRLTE_DAYS_UNTIL_PURGE:7:'
,p_column_linktext=>'#WITHIN_NEXT_7_DAYS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(505871108367904029)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(505863112813801279)
,p_button_name=>'MANAGE_SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Manage Settings'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:133::'
,p_icon_css_classes=>'icon-edit'
);
end;
/
prompt --application/pages/page_00100
begin
wwv_flow_imp_page.create_page(
 p_id=>100
,p_name=>'Installed Translations'
,p_alias=>'INSTALLED-TRANSLATIONS'
,p_step_title=>'Installed Translations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_translate.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1410017331653501)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_location=>null
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_output clob;',
'begin',
'    if wwv_flow_global.g_cloud then',
'        l_output := wwv_flow_lang.message(',
'                      ''P100_ABOUT_ADB'',',
'                      :PRODUCT_NAME);',
'    else',
'        l_output := wwv_flow_lang.message(',
'                      ''P100_ABOUT_NON_ADB'',',
'                      :PRODUCT_NAME);',
'    end if;',
'',
'    return ''<p>'' || l_output || ''</p>'' || ',
'           ''<p><a target="_blank" href="'' || :SYSTEM_HELP_URL || ''">'' ||',
'           wwv_flow_lang.system_message(''LEARN MORE'') || '' ...</a></p>'';',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1602561728687311)
,p_plug_name=>'Character Set'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This database is using <strong>&F4050_P100_CHARSET.</strong> character set. The database character set determines which languages &PRODUCT_NAME. supports in this instance.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195763900538696201)
,p_plug_name=>'Translations Loaded'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select translation_flow_language_code,',
'       case when dev_exists_flag = ''Y'' then ''INSTALLED''',
'            when dev_exists_flag = ''N'' then ''UNSUPPORTED''',
'            else ''NOT_INSTALLED''',
'       end as dev_exists,',
'       case when runtime_exists_flag = ''Y'' then ''INSTALLED''',
'            when runtime_exists_flag = ''N'' then ''UNSUPPORTED''',
'            else ''NOT_INSTALLED''',
'       end as runtime_exists,',
'       case when dev_exists_flag = ''Y'' then ''success''',
'            when dev_exists_flag = ''N'' then ''info''',
'       end as dev_exists_css,',
'       case when runtime_exists_flag = ''Y'' then ''success''',
'            when runtime_exists_flag = ''N'' then ''info''',
'       end as runtime_exists_css',
'  from (select translation_flow_language_code,',
'               max(case when primary_language_flow_id = 4000 and flows_id is not null and (nls_db_charset = :F4050_P100_CHARSET or :F4050_P100_CHARSET like ''%UTF8%'')',
'                        then ''Y''',
'                        when primary_language_flow_id = 4000 and flows_id is not null and nls_db_charset is null',
'                        then ''N''',
'                        else null end) as dev_exists_flag,',
'               max(case when primary_language_flow_id = 4470 and flows_id is not null and (nls_db_charset = :F4050_P100_CHARSET or :F4050_P100_CHARSET like ''%UTF8%'')',
'                        then ''Y''',
'                        when primary_language_flow_id = 4470 and flows_id is not null and nls_db_charset is null',
'                        then ''N''',
'                        else null end) as runtime_exists_flag',
'          from (select f.id as flows_id,',
'                       m.primary_language_flow_id, ',
'                       m.translation_flow_language_code',
'                  from (select primary_language_flow_id, translation_flow_id, translation_flow_language_code',
'                          from wwv_flow_language_map',
'                         where security_group_id = 10',
'                         union all',
'                        select 4000, 4000, ''en'' from sys.dual',
'                         union all',
'                        select 4470, 4470, ''en'' from sys.dual) m,',
'                        wwv_flows f',
'                  where m.translation_flow_id = f.id (+)',
'                    and m.primary_language_flow_id in (4000, 4470)) a,',
'               (select language_code,',
'                       nls_db_charset',
'                  from wwv_flow_dbcharset_lang_map',
'                 where nls_db_charset = :F4050_P100_CHARSET) b',
'         where a.translation_flow_language_code = b.language_code (+)',
'         group by a.translation_flow_language_code);'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(195764012510696201)
,p_name=>'Translations Loaded'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1601826342687304)
,p_db_column_name=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_display_order=>10
,p_column_identifier=>'C'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(348975927644434787)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1601900219687305)
,p_db_column_name=>'DEV_EXISTS'
,p_display_order=>20
,p_column_identifier=>'D'
,p_column_label=>'Development Environment'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if ?DEV_EXISTS_CSS/}',
'    {with/}',
'    STATE:=#DEV_EXISTS_CSS#',
'    VALUE:=#DEV_EXISTS#',
'    {apply THEME$BADGE/}',
'{else/}',
'    <span role="status" aria-label="#DEV_EXISTS#" title="#DEV_EXISTS#"></span>',
'{endif/}'))
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(2314968086831771)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1602047194687306)
,p_db_column_name=>'RUNTIME_EXISTS'
,p_display_order=>30
,p_column_identifier=>'E'
,p_column_label=>'Runtime Messages'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if ?RUNTIME_EXISTS_CSS/}',
'    {with/}',
'    STATE:=#RUNTIME_EXISTS_CSS#',
'    VALUE:=#RUNTIME_EXISTS#',
'    {apply THEME$BADGE/}',
'{else/}',
'    <span role="status" aria-label="#RUNTIME_EXISTS#" title="#RUNTIME_EXISTS#"></span>',
'{endif/}'))
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(2314968086831771)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1604303796687329)
,p_db_column_name=>'DEV_EXISTS_CSS'
,p_display_order=>40
,p_column_identifier=>'O'
,p_column_label=>'DEV_EXISTS_CSS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1604469640687330)
,p_db_column_name=>'RUNTIME_EXISTS_CSS'
,p_display_order=>50
,p_column_identifier=>'P'
,p_column_label=>'RUNTIME_EXISTS_CSS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(195764721152698648)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316111315536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TRANSLATION_FLOW_LANGUAGE_CODE:DEV_EXISTS:RUNTIME_EXISTS:DEV_EXISTS_CSS:RUNTIME_EXISTS_CSS'
,p_sort_column_1=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'L'
,p_sort_direction_2=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195765915527715946)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(195763900538696201)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.:100,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1602311030687309)
,p_name=>'F4050_P100_CHARSET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1602561728687311)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1604718038687333)
,p_computation_sequence=>20
,p_computation_item=>'F4050_P100_CHARSET'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select value',
'  from sys.nls_database_parameters',
' where parameter = ''NLS_CHARACTERSET'''))
,p_compute_when=>'F4050_P100_CHARSET'
,p_compute_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_imp_page.create_page(
 p_id=>101
,p_name=>'Web Service Activity Log'
,p_alias=>'WEB-SERVICE-ACTIVITY-LOG'
,p_step_title=>'Web Service Activity Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784309333645873)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*.break-url {',
'    word-break: break-all;',
'}*/'))
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(670457839215463341)
,p_plug_name=>'Web Service Activity Log'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'The Web Service Activity Log contains the URL, HTTP method, request length, the HTTP status code, length of the response, elapsed seconds, application user, and date of outbound web service calls made from this &PRODUCT_NAME. instance.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(670458250602463344)
,p_plug_name=>'Web Service Activity Log'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(812399646803979420)
,p_plug_name=>'Web Service Activity Log'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(l.url,''/'',''/<wbr>'') "url", ',
'       l.http_method,',
'       l.content_length,',
'       l.status_code,',
'       l.resp_content_length,',
'       l.elapsed_sec,',
'       l.flow_user application_user,',
'       c.short_name,',
'       l.request_date,',
'       l.ecid,',
'       l.activity_log_id',
'from  wwv_flow_webservice_log l, wwv_flow_companies c',
'where c.provisioning_company_id = l.security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(812399756925979420)
,p_name=>'Mail Log'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>812399756925979420
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582423922173226527)
,p_db_column_name=>'url'
,p_display_order=>10
,p_column_identifier=>'Z'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582423009729226518)
,p_db_column_name=>'HTTP_METHOD'
,p_display_order=>20
,p_column_identifier=>'R'
,p_column_label=>'HTTP Method'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582423199685226519)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>30
,p_column_identifier=>'S'
,p_column_label=>'Request Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582423592823226523)
,p_db_column_name=>'STATUS_CODE'
,p_display_order=>40
,p_column_identifier=>'W'
,p_column_label=>'Status Code'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582423785181226525)
,p_db_column_name=>'RESP_CONTENT_LENGTH'
,p_display_order=>50
,p_column_identifier=>'Y'
,p_column_label=>'Response Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582423680714226524)
,p_db_column_name=>'ELAPSED_SEC'
,p_display_order=>60
,p_column_identifier=>'X'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582423284263226520)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>70
,p_column_identifier=>'T'
,p_column_label=>'Application User'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582423323091226521)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>80
,p_column_identifier=>'U'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582423498136226522)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>90
,p_column_identifier=>'V'
,p_column_label=>'Request Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(66731551847543503)
,p_db_column_name=>'ECID'
,p_display_order=>100
,p_column_identifier=>'AA'
,p_column_label=>'ECID'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(66731673662543504)
,p_db_column_name=>'ACTIVITY_LOG_ID'
,p_display_order=>110
,p_column_identifier=>'AB'
,p_column_label=>'Activity Log ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(812400960996980359)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'6199699'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'url:HTTP_METHOD:CONTENT_LENGTH:STATUS_CODE:RESP_CONTENT_LENGTH:ELAPSED_SEC:APPLICATION_USER:SHORT_NAME:REQUEST_DATE:'
,p_sort_column_1=>'REQUEST_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'LAST_UPDATED_ON'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'SINCE_DATE'
,p_sort_direction_3=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(619962444515121928)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(670458250602463344)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:RIR,121::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(619962846891121930)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(670458250602463344)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Truncate'
,p_button_position=>'CREATE'
,p_confirm_message=>'Do you really want to truncate the Web Service Activity Log?'
,p_confirm_style=>'danger'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(619971577290121956)
,p_branch_action=>'f?p=&FLOW_ID.:101:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(619970665525121953)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_webservice_log1$;',
'delete from wwv_flow_webservice_log2$;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating Web Service Activity Log.'
,p_process_when_button_id=>wwv_flow_imp.id(619962846891121930)
,p_process_success_message=>'Successfully truncated Web Service Activity Log.'
,p_internal_uid=>619970665525121953
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(619971052060121953)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(619962444515121928)
,p_internal_uid=>619971052060121953
);
end;
/
prompt --application/pages/page_00102
begin
wwv_flow_imp_page.create_page(
 p_id=>102
,p_name=>'Native Component Utilization Chart'
,p_alias=>'NATIVE-COMPONENT-UTILIZATION-CHART'
,p_step_title=>'Native Component Utilization Chart'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'04'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1916526379032165170)
,p_plug_name=>'Report'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_footer=>'This chart excludes internal applications.'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(155223489191557546)
,p_region_id=>wwv_flow_imp.id(1916526379032165170)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'value-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(155225145484557548)
,p_chart_id=>wwv_flow_imp.id(155223489191557546)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from wwv_flow_page_plugs r',
'where plug_source_type not like ''PLUGIN%'' and security_group_id != 10',
'group by substr(plug_source_type,8)',
'order by 2 desc'))
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(155223966323557546)
,p_chart_id=>wwv_flow_imp.id(155223489191557546)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(155224546840557547)
,p_chart_id=>wwv_flow_imp.id(155223489191557546)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00105
begin
wwv_flow_imp_page.create_page(
 p_id=>105
,p_name=>'Add Schema'
,p_alias=>'ADD-SCHEMA'
,p_step_title=>'Add Schema - New or Existing'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18707931422356386)
,p_plug_name=>'New or Existing Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18714129138440964)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(18701007817245520)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19062129715751379)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(202654431224384775)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Specify whether you would like to add an existing schema or a new schema to workspace mapping. Choosing new schema will create the database user for you. Click <strong>Next</strong> to continue.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202781828945244607)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752111942043695871)
,p_plug_name=>'Add Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18708408351359249)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202781828945244607)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18712526930430865)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202781828945244607)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18712821032430866)
,p_branch_action=>'107'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(18712526930430865)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18708711604359253)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(18708408351359249)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18709815193380164)
,p_name=>'P105_NEW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18707931422356386)
,p_item_default=>'Existing'
,p_prompt=>'The schema is: '
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NEW_OR_EXISTING'
,p_lov=>'.'||wwv_flow_imp.id(87820927180096887)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify if the schema to be provisioned for the workspace exists or not.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00106
begin
wwv_flow_imp_page.create_page(
 p_id=>106
,p_name=>'Add Schema'
,p_alias=>'ADD-SCHEMA1'
,p_step_title=>'Add Schema- Identify Schema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18717630140488489)
,p_plug_name=>'Identify Schema'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return ''<p>''',
'       || case when :P105_NEW = ''New'' then wwv_flow_lang_dev.builder_message(''4050_106_ENTER_SCHEMA_NAME'')',
'               else                        wwv_flow_lang_dev.builder_message(''4050_106_EXISTING_SCHEMA'')',
'          end',
'       || wwv_flow_lang_dev.builder_message(''4050_106_WHEN_DONE'')',
'       || ''</p>'';'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18722616297560221)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(18701007817245520)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202785409945267526)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752112028982695871)
,p_plug_name=>'Add Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18719928539497524)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202785409945267526)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18719018150494496)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(202785409945267526)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18718107415491444)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202785409945267526)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18718421414491445)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(18718107415491444)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18720208258497525)
,p_branch_action=>'108'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(18719928539497524)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18719314728494497)
,p_branch_action=>'107'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(18719018150494496)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2881275008923401)
,p_name=>'P106_GRANT_APEX_PRIVILEGES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(18717630140488489)
,p_item_default=>'Y'
,p_prompt=>'Grant APEX Privileges'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Grant the privileges needed by APEX to this schema'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18721014303540748)
,p_name=>'P106_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18717630140488489)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d,',
'       username r',
'  from wwv_flow_admin_all_schemas s',
' where (   restricted_to_workspace is null',
'        or restricted_to_workspace = upper(:P107_COMPANY))',
'   and username not in ( select cs.schema',
'                           from wwv_flow_company_schemas cs,',
'                                wwv_flow_companies c',
'                          where cs.security_group_id = c.provisioning_company_id',
'                            and cs.schema = s.username',
'                            and c.short_name = upper(:P107_COMPANY) )',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_css_classes=>'u-textUpper'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter new schema name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18721601275546427)
,p_name=>'P106_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(18717630140488489)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_display_when=>'P105_NEW'
,p_display_when2=>'New'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter password for schema.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18783728660131536)
,p_name=>'P106_DEFAULT_TS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(18717630140488489)
,p_prompt=>'Default Tablespace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DB.TABLESPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tablespace_name tname_disp, tablespace_name tname_ret',
'  from sys.dba_tablespaces'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_display_when=>'P105_NEW'
,p_display_when2=>'New'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is not null'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the default tablespace for the provisioned schema, or choose one from the popup list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18784705242134205)
,p_name=>'P106_TEMPORARY_TS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(18717630140488489)
,p_prompt=>'Temporary Tablespace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DB.TEMP.TABLESPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tablespace_name tname_disp, tablespace_name tname_ret',
'  from sys.dba_tablespaces',
' where contents = ''TEMPORARY'''))
,p_cSize=>30
,p_cMaxlength=>2000
,p_display_when=>'P105_NEW'
,p_display_when2=>'New'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is not null'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the temporary tablespace for the provisioned schema, or choose one from the popup list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(384615932078738711)
,p_computation_sequence=>10
,p_computation_item=>'P106_SCHEMA'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P106_SCHEMA)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(384615659188738708)
,p_computation_sequence=>10
,p_computation_item=>'P106_DEFAULT_TS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'');'
,p_compute_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(384615792981738709)
,p_computation_sequence=>20
,p_computation_item=>'P106_TEMPORARY_TS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select property_value ',
'  from database_properties ',
' where property_name = ''DEFAULT_TEMP_TABLESPACE'';'))
,p_compute_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18726721885590232)
,p_validation_name=>'schema not null'
,p_validation_sequence=>10
,p_validation=>'P106_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Schema must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18721014303540748)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18727325825600827)
,p_validation_name=>'schema exists'
,p_validation_sequence=>20
,p_validation=>'wwv_flow_security.exists_db_user(p_username => upper(:P106_SCHEMA))'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Schema must exist.'
,p_validation_condition=>':P106_SCHEMA is not null and :P105_NEW = ''Existing'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18721014303540748)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18727925263610141)
,p_validation_name=>'schema does not exist'
,p_validation_sequence=>30
,p_validation=>'wwv_flow_security.get_db_user_or_role(p_username => upper(:P106_SCHEMA)) is null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Schema must not exist.'
,p_validation_condition=>':P106_SCHEMA is not null and :P105_NEW = ''New'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18721014303540748)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73770513847184141)
,p_validation_name=>'mapping doesn''t already exist'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_company_schemas',
' where schema = upper(:P106_SCHEMA)',
'   and security_group_id = :P107_SGID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Schema mapping already exists.'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18721014303540748)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18729518599627072)
,p_validation_name=>'password not null'
,p_validation_sequence=>50
,p_validation=>'P106_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Password must be specified.'
,p_validation_condition=>':P105_NEW = ''New'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18721601275546427)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(22928290717012301)
,p_validation_name=>'password must conform to db'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.password_validation(',
'           p_username => :P106_SCHEMA,',
'           p_password => :P106_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The password does not conform to the database password complexity rules.'
,p_validation_condition=>':P105_NEW = ''New'' and :P106_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18721601275546427)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18797002781180853)
,p_validation_name=>'defaut ts not null'
,p_validation_sequence=>70
,p_validation=>'P106_DEFAULT_TS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Default Tablespace must be specified.'
,p_validation_condition=>':P105_NEW = ''New'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18783728660131536)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18799024944187246)
,p_validation_name=>'temporary ts not null'
,p_validation_sequence=>80
,p_validation=>'P106_TEMPORARY_TS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Temporary tablespace must be specified.'
,p_validation_condition=>':P105_NEW = ''New'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18784705242134205)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18807120620223811)
,p_validation_name=>'default ts exists'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_tablespaces',
' where tablespace_name = upper(:P106_DEFAULT_TS)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Tablespace does not exist.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P105_NEW = ''New'' ',
'    and :P106_DEFAULT_TS is not null ',
'    and wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18783728660131536)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18808118673232702)
,p_validation_name=>'temporary tablespace exists'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_tablespaces',
' where tablespace_name = upper(:P106_TEMPORARY_TS)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Tablespace does not exist.'
,p_validation_condition=>':P105_NEW = ''New'' and :P106_TEMPORARY_TS is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18784705242134205)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(161245717628127122)
,p_validation_name=>'cannot add internal schema'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where first_schema_provisioned = upper(:P106_SCHEMA)',
'   and provisioning_company_id = 10'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Internal schema cannot be mapped.'
,p_validation_condition=>'P105_NEW'
,p_validation_condition2=>'Existing'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_associated_item=>wwv_flow_imp.id(18721014303540748)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(183395003986449179)
,p_validation_name=>'schema not reserved/restricted'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provision.schema_name_valid(',
'    p_schema            => upper(:P106_SCHEMA),',
'    p_workspace_name    => :P107_COMPANY);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The requested schema is reserved or is restricted and cannot be assigned to a workspace.'
,p_when_button_pressed=>wwv_flow_imp.id(18719928539497524)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2600492121498703)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Set P106_PASSWORD to null'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P106_PASSWORD'
,p_internal_uid=>2600492121498703
);
end;
/
prompt --application/pages/page_00107
begin
wwv_flow_imp_page.create_page(
 p_id=>107
,p_name=>'Add Schema'
,p_alias=>'ADD-SCHEMA2'
,p_step_title=>'Add Schema - Choose Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18731208472643073)
,p_plug_name=>'Select Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18748418103816181)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(18701007817245520)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202783403927256373)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752112181943695872)
,p_plug_name=>'Add Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18735306011689736)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202783403927256373)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18734429428687003)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(202783403927256373)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18733414406673241)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202783403927256373)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18735619743689738)
,p_branch_action=>'106'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18734725566687004)
,p_branch_action=>'105'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(18734429428687003)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2882065794923409)
,p_name=>'P107_SGID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(18731208472643073)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18731914968663934)
,p_name=>'P107_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18731208472643073)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.WORKSPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the name of the workspace, or choose one from the popup list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18736308219699832)
,p_validation_name=>'company not null'
,p_validation_sequence=>10
,p_validation=>'P107_COMPANY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Workspace must be specified.'
,p_associated_item=>wwv_flow_imp.id(18731914968663934)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18736902809707708)
,p_validation_name=>'company exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where short_name = upper(:P107_COMPANY)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Workspace must exist.'
,p_validation_condition=>':P107_COMPANY is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(18731914968663934)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2611783992735321)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Set Item P106_PASSWORD to null'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P106_PASSWORD'
,p_internal_uid=>2611783992735321
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18738207096718392)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop sgid'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select provisioning_company_id',
'             from wwv_flow_companies',
'            where short_name = upper(:P107_COMPANY)) loop',
'  :P107_SGID := c1.provisioning_company_id;',
'  exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>18738207096718392
);
end;
/
prompt --application/pages/page_00108
begin
wwv_flow_imp_page.create_page(
 p_id=>108
,p_name=>'Add Schema'
,p_alias=>'ADD-SCHEMA3'
,p_step_title=>'Add Schema - Confirm'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2612211168735326)
,p_name=>'Confirmation - when schema is new'
,p_template=>wwv_flow_imp.id(721130166613730309)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    :P105_NEW as new_or_existing,',
'    :P106_SCHEMA as schema,',
'    rpad(''*'',length(:P106_PASSWORD),''*'') as schema_password,',
'    :P106_DEFAULT_TS as default_tablespace,',
'    :P106_TEMPORARY_TS as temporary_tablespace,',
'    :P107_COMPANY as workspace,',
'    :P106_GRANT_APEX_PRIVILEGES as grant_privileges',
'from sys.dual'))
,p_display_when_condition=>'P105_NEW'
,p_display_when_cond2=>'New'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Please proceed with schema assignment steps again!'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202943068668024)
,p_query_column_id=>1
,p_column_alias=>'NEW_OR_EXISTING'
,p_column_display_sequence=>10
,p_column_heading=>'New Or Existing'
,p_use_as_row_header=>'Y'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8203078139668025)
,p_query_column_id=>2
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>20
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8203131868668026)
,p_query_column_id=>3
,p_column_alias=>'SCHEMA_PASSWORD'
,p_column_display_sequence=>30
,p_column_heading=>'Schema Password'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8203271495668027)
,p_query_column_id=>4
,p_column_alias=>'DEFAULT_TABLESPACE'
,p_column_display_sequence=>40
,p_column_heading=>'Default Tablespace'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8203382748668028)
,p_query_column_id=>5
,p_column_alias=>'TEMPORARY_TABLESPACE'
,p_column_display_sequence=>50
,p_column_heading=>'Temporary Tablespace'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8203452423668029)
,p_query_column_id=>6
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>60
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2881793217923406)
,p_query_column_id=>7
,p_column_alias=>'GRANT_PRIVILEGES'
,p_column_display_sequence=>70
,p_column_heading=>'Grant APEX Privileges'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18742411345776408)
,p_name=>'Confirmation - when schema is an existing one'
,p_template=>wwv_flow_imp.id(721130166613730309)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    :P105_NEW as new_or_existing,',
'    :P106_SCHEMA as schema,',
'    :P107_COMPANY as workspace,',
'    :P106_GRANT_APEX_PRIVILEGES as grant_privileges',
'from sys.dual'))
,p_display_when_condition=>'P105_NEW'
,p_display_when_cond2=>'New'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'n/a'
,p_query_no_data_found=>'Please proceed with schema assignment steps again!'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202657616668021)
,p_query_column_id=>1
,p_column_alias=>'NEW_OR_EXISTING'
,p_column_display_sequence=>10
,p_column_heading=>'New Or Existing'
,p_use_as_row_header=>'Y'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202702297668022)
,p_query_column_id=>2
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>20
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8202863391668023)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>30
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2881661355923405)
,p_query_column_id=>4
,p_column_alias=>'GRANT_PRIVILEGES'
,p_column_display_sequence=>40
,p_column_heading=>'Grant APEX Privileges'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18746317972806666)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(18701007817245520)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19697422692474698)
,p_plug_name=>'Add Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Review the information in the table below. If the information is correct, click <strong>Add Schema</strong> to add this schema to the &P107_COMPANY. workspace. If incorrect, click <strong>Previous</strong>.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202788304666284965)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752112260763695872)
,p_plug_name=>'Add Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18745102950792918)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202788304666284965)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Schema'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18743915978787185)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(202788304666284965)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18742925198780454)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202788304666284965)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18744206082787186)
,p_branch_action=>'106'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(18743915978787185)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18743220747780455)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18817308247277016)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_p varchar2(256) := v(''P106_PASSWORD'');',
'begin',
'  wwv_flow.update_cache_with_write(''P106_PASSWORD'',null);',
'',
'wwv_flow_provision.create_user(',
'    p_username    => :P106_SCHEMA,',
'    p_password    => l_p);',
'',
'wwv_flow_provision.set_user_tablespace(',
'    p_username    => :P106_SCHEMA,',
'    p_default_ts  => :P106_DEFAULT_TS,',
'    p_temp_ts     => :P106_TEMPORARY_TS);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(18745102950792918)
,p_process_when=>':P105_NEW = ''New'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>18817308247277016
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18823010849315600)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_instance_admin.add_schema(',
'        p_workspace             => :P107_COMPANY,',
'        p_schema                => :P106_SCHEMA,',
'        p_grant_apex_privileges => (:P106_GRANT_APEX_PRIVILEGES = ''Y'') );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error adding schema.'
,p_process_when_button_id=>wwv_flow_imp.id(18745102950792918)
,p_process_success_message=>'Schema added to &P107_COMPANY..'
,p_internal_uid=>18823010849315600
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(359762415297498901)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'106'
,p_process_when=>'CANCEL,CREATE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>359762415297498901
);
end;
/
prompt --application/pages/page_00110
begin
wwv_flow_imp_page.create_page(
 p_id=>110
,p_name=>'View Change Request'
,p_alias=>'VIEW-CHANGE-REQUEST'
,p_step_title=>'View Change Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(704456563630760825)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_chg_rqst.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20489617348146909)
,p_name=>'Schema Tablespaces'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner schemas1, tablespace_name tablespaces2',
'  from sys.dba_segments',
' where owner in ( select schema',
'                    from wwv_flow_company_schemas',
'                   where security_group_id = :P110_SGID )',
'group by owner,',
'         tablespace_name'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47555718632924155)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No schemas found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(167797424959859102)
,p_query_column_id=>1
,p_column_alias=>'SCHEMAS1'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(167797513180859103)
,p_query_column_id=>2
,p_column_alias=>'TABLESPACES2'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20489920551146915)
,p_name=>'Application to Schema Mappings'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name name, owner',
'  from wwv_flows',
' where security_group_id = :P110_SGID',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47555718632924155)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No application found in workspace.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(20489920551146915)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48612823196771186)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48612923298771186)
,p_query_column_id=>2
,p_column_alias=>'OWNER'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20490805037146920)
,p_plug_name=>'Change Request'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Click the button corresponding to the appropriate action for a specific change request.</p>',
'<p>To deny and delete a request, select <strong>Delete this request if denying?</strong> and then click <strong>Deny Request</strong>.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20491723109146926)
,p_name=>'Workspace Schemas and Default Tablespaces'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.schema schemas2, c.tablespace_name  ||'' - '' ||c.file_name default_tablespaces',
'  from wwv_flow_company_schemas a, sys.dba_users b , sys.dba_data_files c',
' where a.schema = b.username',
'   and b.default_tablespace  = c.tablespace_name',
'   and a.security_group_id = :P110_SGID',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47555718632924155)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(167816703666890783)
,p_query_column_id=>1
,p_column_alias=>'SCHEMAS2'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(167811004326878369)
,p_query_column_id=>2
,p_column_alias=>'DEFAULT_TABLESPACES'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20492023928146928)
,p_name=>'Objects Counts'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.object_type,',
'       count(*) cnt',
'  from sys.dba_objects o, wwv_flow_company_schemas s',
' where o.owner = s.schema',
'   and s.security_group_id = :P110_SGID',
' group by o.object_type',
' order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47555718632924155)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No database objects found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(20492023928146928)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48555719955770792)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48555820934770792)
,p_query_column_id=>2
,p_column_alias=>'CNT'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20514532353304920)
,p_name=>'Change Request'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select service_name,',
'       service_attribute_1,',
'       requested_on,',
'       requested_by,',
'       request_status STATUS,',
'       case',
'       when request_work_log is null',
'       then null',
'       when regexp_like(request_work_log,''^\d+$'')',
'       then wwv_flow_lang.system_message (',
'                ''APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'',',
'                request_work_log )',
'       else request_work_log',
'       end request_work_log,',
'       request_comments',
'  from wwv_flow_provision_serice_mod',
' where id = :P110_REQUEST_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48768306417772111)
,p_query_column_id=>1
,p_column_alias=>'SERVICE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Service Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(110368323210290856)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48768422851772111)
,p_query_column_id=>2
,p_column_alias=>'SERVICE_ATTRIBUTE_1'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48768515025772112)
,p_query_column_id=>3
,p_column_alias=>'REQUESTED_ON'
,p_column_display_sequence=>3
,p_column_heading=>'Requested On'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT. Day'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48768631295772112)
,p_query_column_id=>4
,p_column_alias=>'REQUESTED_BY'
,p_column_display_sequence=>4
,p_column_heading=>'Requested By'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162850504660813639)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>7
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(87755726864223308)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48768807098772112)
,p_query_column_id=>6
,p_column_alias=>'REQUEST_WORK_LOG'
,p_column_display_sequence=>5
,p_column_heading=>'Request Work Log'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48768922367772112)
,p_query_column_id=>7
,p_column_alias=>'REQUEST_COMMENTS'
,p_column_display_sequence=>6
,p_column_heading=>'Request Comments'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46266312139679026)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(195775112470763477)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168501300266669286)
,p_plug_name=>'View Change Request'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(179770911638256315)
,p_name=>'Workspaces That Use Requested Schema'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name from wwv_flow_companies where provisioning_company_id in (select security_group_id from wwv_flow_company_schemas where schema = (',
' select upper(service_attribute_1)',
'    from wwv_flow_provision_serice_mod',
'    where id = :P110_REQUEST_ID))'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_company_schemas where schema = (',
' select upper(service_attribute_1)',
'    from wwv_flow_provision_serice_mod',
'    where id = :P110_REQUEST_ID)'))
,p_display_condition_type=>'EXISTS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47555718632924155)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(179772831489470215)
,p_query_column_id=>1
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179776307837681077)
,p_plug_name=>'Warnings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_schema        wwv_flow_provision_serice_mod.service_attribute_1%type;',
'    l_schema_status wwv_flow_4050_ui.t_schema_status;',
'begin',
'    for c1 in (',
'        select upper(service_attribute_1) sa1',
'          from wwv_flow_provision_serice_mod',
'         where id = :P110_REQUEST_ID )',
'    loop',
'        l_schema := c1.sa1;',
'    end loop;',
'',
'    l_schema_status := wwv_flow_4050_ui.get_schema_status(',
'                           p_schema => l_schema,',
'                           p_sgid   => :P110_SGID );',
'',
'    return ''<br /><br />''',
'           || case',
'                when l_schema_status.schema_type is not null then',
'                        ''<p />'' || wwv_flow_lang_dev.builder_message(''F4050.SCHEMA_EXISTS'')',
'                when l_schema_status.schema_in_use then',
'                        ''<p />'' || wwv_flow_lang_dev.builder_message(''F4050.SCHEMA_ASSIGNED'')',
'                when l_schema_status.schema_restricted then',
'                        ''<p />'' || wwv_flow_lang_dev.builder_message(''F4050.RESTRICTED_ADMIN'')',
'              end;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_schema wwv_flow_provision_serice_mod.service_attribute_1%type;',
'    l_schema_status wwv_flow_4050_ui.t_schema_status;',
'begin',
'    for c1 in (',
'        select upper(service_attribute_1) sa1',
'          from wwv_flow_provision_serice_mod',
'         where id = :P110_REQUEST_ID )',
'    loop',
'        l_schema := c1.sa1;',
'    end loop;',
'    l_schema_status := wwv_flow_4050_ui.get_schema_status(',
'                           p_schema => l_schema,',
'                           p_sgid   => :P110_SGID );',
'',
'    if    l_schema_status.schema_type is not null',
'       or l_schema_status.schema_in_use',
'       or l_schema_status.schema_restricted',
'    then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>'<table alt=""><tr><td valign="top"><img src="	#IMAGE_PREFIX#menu/alarm_bell_wbg_64x64.png" height="64" width="64" alt="" /></td><td valign="top">'
,p_plug_footer=>'</td></tr></table>'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(361089923326552991)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(20489617348146909)
,p_button_name=>'UTIL_RPT'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Show Details'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.:RP:P88_SGID:&P110_SGID.:'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202272511206460867)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(168501300266669286)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20596428918530967)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168501300266669286)
,p_button_name=>'DENY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Deny Request'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20601325024548816)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(168501300266669286)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Schema'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PROVISION_SERICE_MOD m',
' where id = :P110_REQUEST_ID',
'   and service_name = ''NEW_SCHEMA''                  ',
'   and not exists ( select null',
'                      from sys.all_users u',
'                     where u.username = upper(m.SERVICE_ATTRIBUTE_1))',
' and not exists',
'  (select 1 from dual where (wwv_flow_provisioning.reserved_schema_i(upper(m.SERVICE_ATTRIBUTE_1)) = 1)',
'    or',
'    (wwv_flow_provisioning.site_admin_is_restricted_i = 1',
'     and',
'     wwv_flow_provisioning.restricted_schema_i(',
'    upper(m.SERVICE_ATTRIBUTE_1),',
'    wwv_flow_security.find_company_name(:P110_SGID)) = 1)',
'   );'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20603005069552511)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(168501300266669286)
,p_button_name=>'CREATE2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Space'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_provision_serice_mod',
' where service_name = ''CHANGE_DB_SIZE''',
'   and id = :P110_REQUEST_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(179763609196754195)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(168501300266669286)
,p_button_name=>'CREATE1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Assign Schema'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_schema varchar2(30) := null;',
'l_sgid number := 0;',
'begin',
'    for c1 in (select upper(service_attribute_1) sa1,',
'                      security_group_id sgid',
'                 from wwv_flow_provision_serice_mod m',
'                where id = :P110_REQUEST_ID',
'                  and service_name = ''NEW_SCHEMA''                  ',
'                  and exists ( select 1',
'                                 from sys.all_users',
'                                where username = upper(m.SERVICE_ATTRIBUTE_1)))',
'    loop',
'      l_schema := c1.sa1;',
'      l_sgid := c1.sgid;',
'    end loop;',
'    if l_schema is not null then',
'        for c1 in (select 1 from wwv_flow_company_schemas',
'          where schema = l_schema and security_group_id =',
'          l_sgid) loop',
'          return false;',
'        end loop;    ',
'        for c1 in (',
'          select 1 from dual',
'          where',
'    (wwv_flow_provisioning.reserved_schema_i(l_schema) = 1) ',
' or (wwv_flow_provisioning.restricted_schema_i(l_schema,',
'       wwv_flow_security.find_company_name(:P110_SGID)) = 1',
'     and wwv_flow_provisioning.site_admin_is_restricted_i = 1)) loop',
'            return false;',
'        end loop;',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20624429367663600)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(168501300266669286)
,p_button_name=>'TERMINATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminate Service'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_provision_serice_mod',
' where service_name = ''REMOVE_EXISTING_SERVICE''',
'   and id = :P110_REQUEST_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168821700937335203)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20521406212335229)
,p_name=>'P110_REQUEST_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20514532353304920)
,p_prompt=>'Request Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20523821449339566)
,p_name=>'P110_SGID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20514532353304920)
,p_prompt=>'Sgid'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20621819062641674)
,p_name=>'P110_DELETE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(20514532353304920)
,p_prompt=>'Delete this request if denying?'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox if this request should be deleted if it is denied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26721610368198076)
,p_name=>'P110_COMMENTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20514532353304920)
,p_prompt=>'Comments: '
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a comment about this change request.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(109497808800721425)
,p_name=>'P110_DROP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(20514532353304920)
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''4050_110_DROP_USERS'', ''<font class="fielddatabold">'' || wwv_flow_provisioning.get_schemas_by_sgid(:P110_SGID,'', '',''Y'') || ',
'''</font>'') d, ''U'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''4050_110_DROP_TABLESPACES'', ''<font class="fielddatabold">'' || wwv_flow_provisioning.get_tablespaces_by_sgid( :P110_SGID,'', '') || ''</font>'') d, ''T'' r from dual'))
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result            boolean := FALSE;',
'    l_security_group_id number;',
'begin',
'    -- Show if service request is to terminate',
'    for c1 in (select security_group_id',
'                 from wwv_flow_provision_serice_mod',
'                where service_name = ''REMOVE_EXISTING_SERVICE''',
'                  and id = :P110_REQUEST_ID) loop',
'        l_security_group_id := c1.security_group_id;',
'        l_result := TRUE;',
'        exit;',
'    end loop;',
'    -- Don''t show if a restricted schema',
'    if l_result = TRUE then',
'        for c1 in (select null',
'                     from wwv_flow_company_schemas s',
'                    where security_group_id = l_security_group_id',
'                      and exists (select null',
'                                    from wwv_flow_restricted_schemas r',
'                                   where r.schema = s.schema)) loop',
'            l_result := FALSE;',
'            exit;',
'        end loop;',
'    end if;',
'    -- Don''t show if a restricted tablespace',
'    if l_result = TRUE then',
'        for c1 in (select u.default_tablespace',
'                     from wwv_flow_company_schemas s,',
'                          sys.dba_users u',
'                    where s.schema          = u.username',
'                      and security_group_id = l_security_group_id)',
'        loop',
'            if c1.default_tablespace in (''SYSTEM'',''SYSAUX'',''TEMP'',''USERS'') then',
'                l_result := FALSE;',
'                exit;',
'            end if;',
'        end loop;',
'    end if;',
'    --',
'    return l_result;',
'end;',
''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(20698013240819860)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_msg varchar2(4000);',
'  l_email varchar2(4000);',
'  l_schema_exists boolean := false;',
'  l_body_html varchar2(32767);',
'  l_workspace_id number;',
'begin',
'  for c1 in (select m.service_attribute_1',
'               from WWV_FLOW_PROVISION_SERICE_MOD m',
'              where id           = :P110_REQUEST_ID',
'                and service_name = ''NEW_SCHEMA'')',
'  loop',
'     l_schema_exists := wwv_flow_security.get_db_user_or_role(p_username => upper(c1.service_attribute_1)) is not null;',
'  end loop;  ',
' ',
'  wwv_flow_provisioning.add_schema_by_request(',
'    p_request_id   => :P110_REQUEST_ID,',
'    p_use_existing => l_schema_exists);',
'                 ',
'    for c1 in (select a.service_attribute_1, a.service_attribute_2 email_address, c.short_name, a.security_group_id',
'                   from wwv_flow_provision_serice_mod a,',
'                        wwv_flow_companies c',
'                  where a.security_group_id = c.provisioning_company_id',
'                    and a.id                = :P110_REQUEST_ID',
'                    and a.request_status    = ''APPROVED'') loop',
'        l_msg := chr(10)||',
'          wwv_flow_lang.system_message(p_name=>''F4050.PROV_SCHEMA_REQ_APPROVED'',',
'            p0=>c1.service_attribute_1,p1=>c1.short_name)||',
'          chr(10)||chr(10);',
'        l_email := c1.email_address;',
'        l_workspace_id := c1.security_group_id;',
'    end loop;',
'    ',
'    if l_workspace_id is null then',
'        raise program_error;',
'    end if;',
'        ',
'    l_msg := l_msg || :P110_Comments || chr(10) || chr(10);',
'    l_msg := l_msg || wwv_flow_mail.get_instance_url(p_security_group_id => l_workspace_id) || chr(10);',
'    l_body_html := wwv_flow_mail.convert_txt_to_html(p_txt_message => l_msg,p_security_group_id => l_workspace_id);',
'',
'    if l_email is null then',
'        for c1 in ( select ',
'                    b.email_address from wwv_flow_provision_serice_mod a, wwv_flow_fnd_user b               ',
'                    where a.security_group_id = b.security_group_id',
'                    and a.requested_by = b.user_name',
'                    and a.id = :P110_REQUEST_ID) loop',
'            l_email := c1.email_address;',
'        end loop;',
'    end if;',
'    ',
'    if l_email is not null then',
'        wwv_flow_mail.send(',
'            p_to     => l_email,',
'            p_from   => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),l_email),',
'            p_subj   => wwv_flow_lang.system_message(''F4050.PROV_CHANGE_REQ_APPROVED''),',
'            p_body   => l_msg,',
'            p_body_html => l_body_html); ',
'        wwv_flow_mail.push_queue_background;',
'    end if;           ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating or assigning schema.'
,p_process_when=>'CREATE1,CREATE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Schema created or assigned.'
,p_internal_uid=>20698013240819860
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(20701804367826675)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Provision Space'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_msg varchar2(4000);',
'  l_email varchar2(4000) := null;',
'  l_body_html varchar2(32767) := null;',
'  l_workspace_id number;',
'begin',
'',
'   wwv_flow_provisioning.provision_storage_by_request(p_request_id=>:P110_REQUEST_ID );',
'',
'   for c1 in (select a.service_attribute_1, a.service_attribute_2 email_address, c.short_name, a.security_group_id',
'                from wwv_flow_provision_serice_mod a, wwv_flow_companies c',
'               where a.security_group_id = c.provisioning_company_id',
'                 and a.id = :P110_REQUEST_ID',
'                 and a.request_status = ''APPROVED'') loop',
'     l_msg := chr(10)||wwv_flow_lang.system_message(',
'        ''F4050.APPROVE_ADD_STORAGE_EMAIL'',',
'        p0=>c1.service_attribute_1,p1=>c1.short_name)||chr(10)||chr(10);',
'     l_email := c1.email_address;',
'     l_workspace_id := c1.security_group_id;',
'   end loop;',
'   ',
'   if l_workspace_id is null then',
'       commit;',
'       raise program_error;',
'   end if;',
'',
'   l_msg := l_msg || :P110_Comments || chr(10) || chr(10);',
'   l_msg := l_msg || wwv_flow_mail.get_instance_url(p_security_group_id => l_workspace_id) || chr(10);',
'   l_body_html := wwv_flow_mail.convert_txt_to_html(p_txt_message => l_msg, p_security_group_id => l_workspace_id);',
'',
'   if l_email is null then',
'       for c1 in ( select ',
'                    b.email_address from wwv_flow_provision_serice_mod a, wwv_flow_fnd_user b               ',
'                    where a.security_group_id = b.security_group_id',
'                    and a.requested_by = b.user_name',
'                    and a.id = :P110_REQUEST_ID) loop',
'            l_email := c1.email_address;',
'        end loop;',
'   end if;',
'    ',
'   if l_email is not null then',
'        wwv_flow_mail.send(',
'          p_to        => l_email,',
'          p_from      => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),l_email),',
'          p_subj      => wwv_flow_lang.system_message(''F4050.CHANGE_APPROVED_EMAIL''),',
'          p_body      => l_msg,',
'          p_body_html => l_body_html );',
'        wwv_flow_mail.push_queue_background;',
'   end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error adding space.'
,p_process_when_button_id=>wwv_flow_imp.id(20603005069552511)
,p_process_success_message=>'Space added.'
,p_internal_uid=>20701804367826675
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(20696321420812715)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reject Request'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_msg varchar2(4000);',
'  l_email varchar2(4000) := null;',
'  l_body_html varchar2(32767) := null;',
'  l_workspace_id number;',
'begin',
'',
'  wwv_flow_provisioning.reject_modification_request (',
'    p_request_id => :P110_REQUEST_ID);',
'',
'  for c1 in (select a.service_attribute_1, a.service_name, ',
'                    a.service_attribute_2 email_address, c.short_name, a.security_group_id',
'               from wwv_flow_provision_serice_mod a, wwv_flow_companies c',
'              where a.security_group_id = c.provisioning_company_id',
'                and a.id = :P110_REQUEST_ID) loop',
'    if c1.service_name = ''NEW_SCHEMA'' then',
'      l_msg := chr(10)||wwv_flow_lang.system_message(p_name=>''F4050.DENY_NEW_SCHEMA_EMAIL'',',
'        p0=>c1.service_attribute_1,p1=>c1.short_name)||chr(10)||chr(10);      ',
'    elsif c1.service_name = ''REMOVE_EXISTING_SERVICE'' then',
'      l_msg := chr(10)||wwv_flow_lang.system_message(p_name=>''F4050.DENY_REMOVE_SERVICE_EMAIL'',p0=>c1.short_name)||chr(10)||chr(10);',
'    else',
'      l_msg := wwv_flow_lang.system_message(p_name=>''F4050.DENY_ADD_STORAGE_EMAIL'',p0=>c1.service_attribute_1,p1=>c1.short_name)||chr(10)||chr(10);',
'    end if;',
'    l_email := c1.email_address;',
'    l_workspace_id := c1.security_group_id;',
'  end loop;',
'  ',
'  l_msg := l_msg || :P110_Comments || chr(10) || chr(10);',
'  l_msg := l_msg || wwv_flow_mail.get_instance_url(p_security_group_id => l_workspace_id) || chr(10);',
'  l_body_html := wwv_flow_mail.convert_txt_to_html(p_txt_message => l_msg,p_security_group_id => l_workspace_id);',
'',
'  if l_email is null then',
'      for c1 in ( select ',
'                  b.email_address from wwv_flow_provision_serice_mod a, wwv_flow_fnd_user b               ',
'                  where a.security_group_id = b.security_group_id',
'                  and a.requested_by = b.user_name',
'                  and a.id = :P110_REQUEST_ID) loop',
'          l_email := c1.email_address;',
'      end loop;',
'  end if;',
'        ',
'  if :P110_DELETE = ''YES'' then',
'    wwv_flow_provisioning.delete_modification_request(p_request_id=>:P110_REQUEST_ID);',
'  end if;',
'',
'  if l_email is not null then',
'      wwv_flow_mail.send(',
'        p_to     => l_email,',
'        p_from   => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),l_email),',
'        p_subj   => wwv_flow_lang.system_message(''F4050.CHANGE_DENIED_EMAIL''),',
'        p_body   => l_msg,',
'        p_body_html => l_body_html);',
'        wwv_flow_mail.push_queue_background;',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error denying request.'
,p_process_when_button_id=>wwv_flow_imp.id(20596428918530967)
,p_process_success_message=>'Request denied.'
,p_internal_uid=>20696321420812715
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(20705626924861635)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Terminate Service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_msg              varchar2(4000);',
'  l_email            varchar2(4000) := null;',
'  l_body_html        varchar2(32767) := null;',
'  l_drop_users       varchar2(2);',
'  l_drop_tablespaces varchar2(2);',
'  l_workspace_id     number;',
'begin',
'',
'  for c1 in (select a.service_attribute_2 email_address, c.short_name, a.security_group_id',
'               from wwv_flow_provision_serice_mod a, wwv_flow_companies c',
'                where a.security_group_id = c.provisioning_company_id',
'                and a.id = :P110_REQUEST_ID) loop',
'    l_msg := chr(10)||wwv_flow_lang.system_message(p_name=>''F4050.SERVICE_TERMINATED_EMAIL_BODY'',',
'      p0=>c1.short_name)||chr(10)||chr(10)||chr(10);',
'    l_email := c1.email_address;',
'    l_workspace_id := c1.security_group_id;',
'  end loop;',
'',
'  l_msg := l_msg || :P110_Comments || chr(10) || chr(10);',
'  l_msg := l_msg || wwv_flow_mail.get_instance_url(p_security_group_id => l_workspace_id) || chr(10);',
'  l_body_html := wwv_flow_mail.convert_txt_to_html(p_txt_message => l_msg,p_security_group_id => l_workspace_id);',
'',
'  if l_email is null then',
'      for c1 in ( select ',
'                  b.email_address from wwv_flow_provision_serice_mod a, wwv_flow_fnd_user b               ',
'                  where a.security_group_id = b.security_group_id',
'                  and a.requested_by = b.user_name',
'                  and a.id = :P110_REQUEST_ID) loop',
'          l_email := c1.email_address;',
'      end loop;',
'  end if;',
'',
'  if l_email is not null then',
'      wwv_flow_mail.send(',
'        p_to     => l_email,',
'        p_from   => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),l_email),',
'        p_subj   => wwv_flow_lang.system_message(''F4050.SERVICE_TERMINATED_EMAIL''),',
'        p_body   => l_msg,',
'        p_body_html => l_body_html );',
'  end if;',
'',
'  if instr(:P110_DROP,''U'') > 0 then',
'      l_drop_users := ''Y'';',
'  else',
'      l_drop_users := ''N'';',
'  end if;',
'',
'  if instr(:P110_DROP,''T'') > 0 then',
'      l_drop_tablespaces := ''Y'';',
'  else',
'      l_drop_tablespaces := ''N'';',
'  end if;',
'',
'  wwv_flow_provisioning.terminate_service_by_sgid(',
'      p_security_group_id => :P110_SGID,',
'      p_drop_users        => l_drop_users,',
'      p_drop_tablespaces  => l_drop_tablespaces );',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error terminating service.'
,p_process_when_button_id=>wwv_flow_imp.id(20624429367663600)
,p_process_success_message=>'Service terminated.'
,p_internal_uid=>20705626924861635
);
end;
/
prompt --application/pages/page_00111
begin
wwv_flow_imp_page.create_page(
 p_id=>111
,p_name=>'Service Signup Wizard'
,p_alias=>'SERVICE-SIGNUP-WIZARD'
,p_step_title=>'Service Signup Wizard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25757919570127293)
,p_plug_name=>'Survey Questions'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25766127986758492)
,p_plug_name=>'Free Text'
,p_parent_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25765312963744663)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25776204287940829)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(195775112470763477)
,p_plug_display_sequence=>20
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26171132179430105)
,p_plug_name=>'Survey Questions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'You can also include a survey when users run the New Service Signup Wizard. To include a survey, select <strong>Yes</strong> for Enable Survey and enter your survey questions. Each question can have any number of answers. Enter all answers for each q'
||'uestion in one field, delimited by a new line.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27046311255907726)
,p_plug_name=>'Options'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27048505761934540)
,p_plug_name=>'Options'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'As an instance administrator, you can require users fill out a justification and accept an agreement before the New Service Signup Wizard submits a request.  To require a justification, select <strong>Yes</strong> for Require Justification. To enable'
||' agreements, select <strong>Yes</strong> for Enable Agreement and enter the agreement text.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(25758324210127295)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(25765312963744663)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(25758126701127295)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(25765312963744663)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P111_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(25758512252127297)
,p_branch_action=>'f?p=&APP_ID.:9:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25758722630127301)
,p_name=>'P111_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25758928149127308)
,p_name=>'P111_SURVEY_ENABLED_YN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Enable Survey'
,p_source=>'SURVEY_ENABLED_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Determines whether to include or exclude the survey. Select <strong>Yes</strong> to display the survey questions you define during the New Service Signup Wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25759109354127309)
,p_name=>'P111_PRE_SURVEY_TEXT'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(25766127986758492)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Pre Text'
,p_source=>'PRE_SURVEY_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter text that displays before the survey questions.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25759318323127310)
,p_name=>'P111_POST_SURVEY_TEXT'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(25766127986758492)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Post Text'
,p_source=>'POST_SURVEY_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter text that displays after the survey questions.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25759525123127311)
,p_name=>'P111_SURVEY_QUESTION_01'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'1'
,p_source=>'SURVEY_QUESTION_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25759726384127311)
,p_name=>'P111_SURVEY_ANSWER_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'1'
,p_source=>'SURVEY_ANSWER_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25759919171127311)
,p_name=>'P111_SURVEY_QUESTION_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'2'
,p_source=>'SURVEY_QUESTION_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25760106891127311)
,p_name=>'P111_SURVEY_ANSWER_02'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'2'
,p_source=>'SURVEY_ANSWER_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25760327261127311)
,p_name=>'P111_SURVEY_QUESTION_03'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'3'
,p_source=>'SURVEY_QUESTION_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25760505242127312)
,p_name=>'P111_SURVEY_ANSWER_03'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'3'
,p_source=>'SURVEY_ANSWER_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25760728486127313)
,p_name=>'P111_SURVEY_QUESTION_04'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'4'
,p_source=>'SURVEY_QUESTION_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25760930263127313)
,p_name=>'P111_SURVEY_ANSWER_04'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'4'
,p_source=>'SURVEY_ANSWER_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25761101337127313)
,p_name=>'P111_SURVEY_QUESTION_05'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'5'
,p_source=>'SURVEY_QUESTION_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25761327565127313)
,p_name=>'P111_SURVEY_ANSWER_05'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'5'
,p_source=>'SURVEY_ANSWER_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25761519360127313)
,p_name=>'P111_SURVEY_QUESTION_06'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'6'
,p_source=>'SURVEY_QUESTION_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25761732052127313)
,p_name=>'P111_SURVEY_ANSWER_06'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'6'
,p_source=>'SURVEY_ANSWER_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25761923300127313)
,p_name=>'P111_SURVEY_QUESTION_07'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'7'
,p_source=>'SURVEY_QUESTION_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25762118414127313)
,p_name=>'P111_SURVEY_ANSWER_07'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'7'
,p_source=>'SURVEY_ANSWER_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25762319516127314)
,p_name=>'P111_SURVEY_QUESTION_08'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'8'
,p_source=>'SURVEY_QUESTION_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25762518135127314)
,p_name=>'P111_SURVEY_ANSWER_08'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'8'
,p_source=>'SURVEY_ANSWER_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25762704783127315)
,p_name=>'P111_SURVEY_QUESTION_09'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'9'
,p_source=>'SURVEY_QUESTION_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25762931672127315)
,p_name=>'P111_SURVEY_ANSWER_09'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'9'
,p_source=>'SURVEY_ANSWER_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25763104897127315)
,p_name=>'P111_SURVEY_QUESTION_10'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'10'
,p_source=>'SURVEY_QUESTION_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25763305979127315)
,p_name=>'P111_SURVEY_ANSWER_10'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_use_cache_before_default=>'NO'
,p_prompt=>'10'
,p_source=>'SURVEY_ANSWER_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26172118289473345)
,p_name=>'P111_QUESTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_source=>'return wwv_flow_lang.system_message(''QUESTIONS'');'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26172914957481925)
,p_name=>'P111_ANSWERS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(25757919570127293)
,p_source=>'return wwv_flow_lang.system_message(''ANSWERS'');'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27046932726913906)
,p_name=>'P111_AGREEMENT_ENABLED_YN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(27046311255907726)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Enable Agreement'
,p_source=>'AGREEMENT_ENABLED_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Determines whether to include or exclude an agreement. Select <strong>Yes</strong> to display the agreement you define during the New Service Signup Wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27048327794931424)
,p_name=>'P111_AGREEMENT_TEXT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(27046311255907726)
,p_prompt=>'Agreement Text'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the text of the agreement.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select agreement_text',
'from wwv_flow_prov_signup_q',
'where id = :P111_ID'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63400686627961702)
,p_name=>'P111_SHOW_SCHEMA_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(27046311255907726)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Enable Schema Selection '
,p_source=>'SHOW_SCHEMA_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'Determines whether the user will be prompted for the database schema information or whether the schema will be defaulted instead.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(80388818537961401)
,p_name=>'P111_REQUEST_SUCCESS_MSG'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(27046311255907726)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Request Success Message'
,p_source=>'REQUEST_SUCCESS_MSG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>90
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Message to be shown to the user when they get to the Workspace Request successful page.<br>',
'<em><strong>Note:</strong> This will replace the standard message provided.</em>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(516327521980435333)
,p_name=>'P111_JUSTIFICATION_REQUIRED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(27046311255907726)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Require Justification'
,p_source=>'JUSTIFICATION_REQUIRED_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Determines whether to prompt the user for a justification for creating the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(504761321518822989)
,p_validation_name=>'P111_SURVEY_ANSWER_01'
,p_validation_sequence=>10
,p_validation=>'P111_SURVEY_ANSWER_01'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_01'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25759726384127311)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(504810824765833328)
,p_validation_name=>'P111_SURVEY_ANSWER_02'
,p_validation_sequence=>20
,p_validation=>'P111_SURVEY_ANSWER_02'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_02'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25760106891127311)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(504949812261877054)
,p_validation_name=>'P111_SURVEY_ANSWER_03'
,p_validation_sequence=>30
,p_validation=>'P111_SURVEY_ANSWER_03'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_03'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25760505242127312)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(505048426852909686)
,p_validation_name=>'P111_SURVEY_ANSWER_04'
,p_validation_sequence=>40
,p_validation=>'P111_SURVEY_ANSWER_04'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_04'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25760930263127313)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(505071005859913035)
,p_validation_name=>'P111_SURVEY_ANSWER_05'
,p_validation_sequence=>50
,p_validation=>'P111_SURVEY_ANSWER_05'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_05'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25761327565127313)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(505093622481917841)
,p_validation_name=>'P111_SURVEY_ANSWER_06'
,p_validation_sequence=>60
,p_validation=>'P111_SURVEY_ANSWER_06'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_06'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25761732052127313)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(505148414994925171)
,p_validation_name=>'P111_SURVEY_ANSWER_07'
,p_validation_sequence=>70
,p_validation=>'P111_SURVEY_ANSWER_07'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_07'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25762118414127313)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(505190731616929904)
,p_validation_name=>'P111_SURVEY_ANSWER_08'
,p_validation_sequence=>80
,p_validation=>'P111_SURVEY_ANSWER_08'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_08'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25762518135127314)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(505236310277933237)
,p_validation_name=>'P111_SURVEY_ANSWER_09'
,p_validation_sequence=>90
,p_validation=>'P111_SURVEY_ANSWER_09'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_09'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25762931672127315)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(505267522397936778)
,p_validation_name=>'P111_SURVEY_ANSWER_10'
,p_validation_sequence=>100
,p_validation=>'P111_SURVEY_ANSWER_10'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Answers for question #LABEL# must have some value.'
,p_validation_condition=>'P111_SURVEY_QUESTION_10'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(25758126701127295)
,p_associated_item=>wwv_flow_imp.id(25763305979127315)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(25763632173127315)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PROV_SIGNUP_Q'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROV_SIGNUP_Q'
,p_attribute_03=>'P111_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_internal_uid=>25763632173127315
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(25763820070127316)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PROV_SIGNUP_Q'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROV_SIGNUP_Q'
,p_attribute_03=>'P111_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>25763820070127316
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(203269131787714919)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update AGREEMENT_TEXT (clob value)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_prov_signup_q',
'   set agreement_text = (select clob001',
'                           from wwv_flow_collections',
'                          where collection_name=''P111_AGREEMENT_TEXT'')',
' where id = :P111_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error saving Agreement Text: #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25758126701127295)
,p_internal_uid=>203269131787714919
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(25764025774127317)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'111'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>25764025774127317
);
end;
/
prompt --application/pages/page_00113
begin
wwv_flow_imp_page.create_page(
 p_id=>113
,p_name=>'Signup Survey'
,p_alias=>'SIGNUP-SURVEY'
,p_step_title=>'Signup Survey'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(131604720559638411)
,p_name=>'Survey Answers'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1. ''||SURVEY_QUESTION_01 survey_question, SURVEY_ANSWER_01 survey_answer, count(*) answer_count, 1 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_01 is not null',
'group by ''1. ''||SURVEY_QUESTION_01, SURVEY_ANSWER_01',
'union all',
'select ''2. ''||SURVEY_QUESTION_02 survey_question, SURVEY_ANSWER_02 survey_answer, count(*) answer_count, 2 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_02 is not null',
'group by ''2. ''||SURVEY_QUESTION_02, SURVEY_ANSWER_02',
'union all',
'select ''3. ''||SURVEY_QUESTION_03 survey_question, SURVEY_ANSWER_03 survey_answer, count(*) answer_count, 3 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_03 is not null',
'group by ''3. ''||SURVEY_QUESTION_03, SURVEY_ANSWER_03',
'union all',
'select ''4. ''||SURVEY_QUESTION_04 survey_question, SURVEY_ANSWER_04 survey_answer, count(*) answer_count, 4 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_04 is not null',
'group by ''4. ''||SURVEY_QUESTION_04, SURVEY_ANSWER_04',
'union all',
'select ''5. ''||SURVEY_QUESTION_05 survey_question, SURVEY_ANSWER_05 survey_answer, count(*) answer_count, 5 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_05 is not null',
'group by ''5. ''||SURVEY_QUESTION_05, SURVEY_ANSWER_05',
'union all',
'select ''6. ''||SURVEY_QUESTION_06 survey_question, SURVEY_ANSWER_06 survey_answer, count(*) answer_count, 6 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_06 is not null',
'group by ''6. ''||SURVEY_QUESTION_06, SURVEY_ANSWER_06',
'union all',
'select ''7. ''||SURVEY_QUESTION_07 survey_question, SURVEY_ANSWER_07 survey_answer, count(*) answer_count, 7 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_07 is not null',
'group by ''7. ''||SURVEY_QUESTION_07, SURVEY_ANSWER_07',
'union all',
'select ''8. ''||SURVEY_QUESTION_08 survey_question, SURVEY_ANSWER_08 survey_answer, count(*) answer_count, 8 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_08 is not null',
'group by ''8. ''||SURVEY_QUESTION_08, SURVEY_ANSWER_08',
'union all',
'select ''9. ''||SURVEY_QUESTION_09 survey_question, SURVEY_ANSWER_09 survey_answer, count(*) answer_count, 9 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_09 is not null',
'group by ''9. ''||SURVEY_QUESTION_09, SURVEY_ANSWER_09',
'union all',
'select ''10. ''||SURVEY_QUESTION_10 survey_question, SURVEY_ANSWER_10 survey_answer, count(*) answer_count, 10 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_10 is not null',
'group by ''10. ''||SURVEY_QUESTION_10, SURVEY_ANSWER_10',
'order by 4, 3 desc, 2'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No Survey Answers found.'
,p_query_row_count_max=>5000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Print'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width_units=>'PERCENTAGE'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(131605030833638415)
,p_query_column_id=>1
,p_column_alias=>'SURVEY_QUESTION'
,p_column_display_sequence=>1
,p_column_heading=>'Survey Question'
,p_use_as_row_header=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'33'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(131605125021638415)
,p_query_column_id=>2
,p_column_alias=>'SURVEY_ANSWER'
,p_column_display_sequence=>2
,p_column_heading=>'Survey Answer'
,p_use_as_row_header=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'33'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(131605210163638415)
,p_query_column_id=>3
,p_column_alias=>'ANSWER_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Responses'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'33'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(132129429179688152)
,p_query_column_id=>4
,p_column_alias=>'SEQ'
,p_column_display_sequence=>4
,p_column_heading=>'Question Number'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_include_in_export=>'N'
,p_print_col_width=>'0'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(131809401905661364)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(131872714372664990)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(131809401905661364)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset Report'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:113:&SESSION.::&DEBUG.:RP,113::'
);
end;
/
prompt --application/pages/page_00114
begin
wwv_flow_imp_page.create_page(
 p_id=>114
,p_name=>'New Service Requests'
,p_alias=>'NEW-SERVICE-REQUESTS'
,p_step_title=>'New Service Requests'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766430018595041)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(132942231190729355)
,p_plug_name=>'New Service Requests'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>11
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ID,',
'    SECURITY_GROUP_ID,',
'    COMPANY_NAME,',
'    ADMIN_FIRST_NAME first_name,',
'    ADMIN_LAST_NAME last_name,',
'    ADMIN_TITLE,',
'    ADMIN_EMAIL email,',
'    ADMIN_PHONE phone,',
'    ADMIN_ID,',
'    lower(admin_userid) ADMIN_USERID,',
'    DATABASE_SIZE,',
'    SERVICE_START_DATE,',
'    SERVICE_TERMINATION_DATE,',
'    SCHEMA_NAME,',
'    PROJECT_DESCRIPTION,',
'    PROJECT_JUSTIFICATION,',
'    PROJECT_STATUS,',
'    WORK_LOG,',
'    REQUEST_DATE',
'from WWV_FLOW_PROVISION_COMPANY'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(132942304290729355)
,p_name=>'New Service Requests'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132942519864729357)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132942632134729357)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Security Group ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132942707252729357)
,p_db_column_name=>'COMPANY_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132942807981729357)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'First Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132942905076729357)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Last Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943011031729357)
,p_db_column_name=>'ADMIN_TITLE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Admin Title'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943100401729358)
,p_db_column_name=>'EMAIL'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Email'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943221788729358)
,p_db_column_name=>'PHONE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Phone'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943316044729358)
,p_db_column_name=>'ADMIN_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Admin Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943405944729358)
,p_db_column_name=>'ADMIN_USERID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Admin Userid'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943509408729358)
,p_db_column_name=>'DATABASE_SIZE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Database Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943609456729358)
,p_db_column_name=>'SERVICE_START_DATE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Start Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943724496729359)
,p_db_column_name=>'SERVICE_TERMINATION_DATE'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Terminated'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943817284729359)
,p_db_column_name=>'SCHEMA_NAME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132943930652729359)
,p_db_column_name=>'PROJECT_DESCRIPTION'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132944016379729359)
,p_db_column_name=>'PROJECT_JUSTIFICATION'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Justification'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132944131871729359)
,p_db_column_name=>'PROJECT_STATUS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(316820619150159698)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132944231402729359)
,p_db_column_name=>'WORK_LOG'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Log'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132944307335729360)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Requested'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(132962512723729537)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316220308536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'REQUEST_DATE:COMPANY_NAME:DATABASE_SIZE:SERVICE_START_DATE:SERVICE_TERMINATION_DATE:SCHEMA_NAME:PROJECT_DESCRIPTION:PROJECT_STATUS:EMAIL:ADMIN_USERID'
,p_sort_column_1=>'REQUEST_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(163634703537874157)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(132942231190729355)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset Report'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:114:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00115
begin
wwv_flow_imp_page.create_page(
 p_id=>115
,p_name=>'Create Multiple Workspaces'
,p_alias=>'CREATE-MULTIPLE-WORKSPACES1'
,p_step_title=>'Create Multiple Workspaces'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931243707245169747)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203134704189329471)
,p_plug_name=>'Create Multiple Workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203135026158329473)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_source=>'<p>Use this wizard to create multiple workspaces.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203142214430364147)
,p_plug_name=>'create multiple workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(203141106443364145)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203142925490369582)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752112544307695872)
,p_plug_name=>'Create Multiple Workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203135318288329474)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(203142925490369582)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203135632207329474)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(203142925490369582)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203136017877329476)
,p_branch_action=>'f?p=&APP_ID.:116:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(203135632207329474)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203152218241433622)
,p_name=>'P115_EMAIL_ADDRESSES'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_prompt=>'Email Addresses (cut and paste any text that contains email addresses)'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203193808097243593)
,p_name=>'P115_WORKSPACE_NAMES'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_item_default=>'DOMAIN'
,p_prompt=>'Provision Workspaces Using'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WORKSPACE NAME COMPUTATION'
,p_lov=>'.'||wwv_flow_imp.id(203194513911255730)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify the method to be used to create multiple workspaces.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203196329195279379)
,p_name=>'P115_WORKSPACE_PREFIX'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_prompt=>'Workspace Prefix'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter the prefix to use when generating workspaces names.  For example, if a prefix of ''DB'' is specified, then the generated workspace names will be like DB_001, DB_002, DB_003.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203291518171314934)
,p_name=>'P115_BATCH_IDENTIFIER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_item_default=>'return to_char(sysdate,''YYYYMMDDHH24MI'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Batch Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203291925276326850)
,p_name=>'P115_INSTALL_SAMPLE_TABLES'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_prompt=>'Install Sample EMP and DEPT Tables'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Install the sample EMP and DEPT tables into each workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203293032571369004)
,p_name=>'P115_QUOTA'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''N''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Space Quota (MB)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NEW WORKSPACE REQUEST STORAGE SIZES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'order by to_number(req_size)',
''))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'If creating a new schema, select the maximum size of the tablespace to be associated with that schema. You can adjust this limit later.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203295328449401307)
,p_name=>'P115_PASSWORD_GENERATION'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_item_default=>'RANDOM'
,p_prompt=>'Password Generation'
,p_source=>'STATIC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Passwords for workspaces can be system generated or a fixed value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204258530823279427)
,p_name=>'P115_WORKSPACE_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_item_default=>'10'
,p_prompt=>'Workspace Count'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter the total number of workspaces to create.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'200'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204311127557584792)
,p_name=>'P115_RM_CONSUMER_GROUP'
,p_item_sequence=>145
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_prompt=>'Resource Manager Consumer Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Do Not Set -'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Database Resource Manager consumer group to be used for all page events associated with this workspace.  At the beginning of every request, the &PRODUCT_NAME. engine switches the current consumer group of the current database session to t'
||'he workspace''s consumer group.  This applies to both executing applications as well as any of the applications used within the &PRODUCT_NAME. development environment.',
'',
'<p />',
'',
'The privilege to switch to this consumer group must be granted to either PUBLIC or the &PRODUCT_NAME. schema.  This privilege is typically granted using the procedure DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204337203125672113)
,p_name=>'P115_SEND_EMAIL'
,p_item_sequence=>167
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_item_default=>'Y'
,p_prompt=>'Send Email Invitation'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204801825868457264)
,p_name=>'P115_AUTO_PURGE'
,p_item_sequence=>155
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_item_default=>'Y'
,p_prompt=>'Allow workspaces to be automatically purged'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Determines if the workspace is a candidate for automatic purging of unused workspaces.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204802717031719730)
,p_name=>'P115_COMMENTS'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(203134704189329471)
,p_prompt=>'Workspace Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter an optional comment or description of the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(204681222200605271)
,p_validation_name=>'P115_EMAIL_ADDRESSES'
,p_validation_sequence=>10
,p_validation=>'P115_EMAIL_ADDRESSES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P115_WORKSPACE_NAMES'
,p_validation_condition2=>'DOMAIN'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(203152218241433622)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(204682131461616196)
,p_validation_name=>'Workspace Prefix NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P115_WORKSPACE_PREFIX'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P115_WORKSPACE_NAMES'
,p_validation_condition2=>'PREFIX'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(203196329195279379)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(60731306072074850)
,p_validation_name=>'No Invalid Chars in Workspace Prefix'
,p_validation_sequence=>30
,p_validation=>'P115_WORKSPACE_PREFIX'
,p_validation2=>'<>:/'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Invalid #LABEL#'
,p_validation_condition=>'P115_WORKSPACE_NAMES'
,p_validation_condition2=>'PREFIX'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(203196329195279379)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(204682424991619233)
,p_validation_name=>'P115_WORKSPACE_COUNT'
,p_validation_sequence=>40
,p_validation=>'P115_WORKSPACE_COUNT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P115_WORKSPACE_NAMES'
,p_validation_condition2=>'DOMAIN'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(204258530823279427)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(211624009309511306)
,p_validation_name=>'P115_PASSWORD_CONFIRM'
,p_validation_sequence=>50
,p_validation=>'P115_PASSWORD_CONFIRM'
,p_validation2=>'&P115_PASSWORD.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'Password does not match password confirmation'
,p_validation_condition=>'P115_PASSWORD_GENERATION'
,p_validation_condition2=>'FIXED'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(203135632207329474)
,p_associated_item=>wwv_flow_imp.id(211623229809486651)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(91866592255317503)
,p_validation_name=>'Check email addresses for valid pattern'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_4350_ui.check_email_list_pattern(',
'           p_users_email => :P115_EMAIL_ADDRESSES );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address pattern found. Please provide a valid email addresses list.'
,p_when_button_pressed=>wwv_flow_imp.id(203135632207329474)
,p_associated_item=>wwv_flow_imp.id(203152218241433622)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(204256632755263181)
,p_name=>'show hide prefix'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P115_WORKSPACE_NAMES'
,p_condition_element=>'P115_WORKSPACE_NAMES'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PREFIX'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(204256919762263182)
,p_event_id=>wwv_flow_imp.id(204256632755263181)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_WORKSPACE_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(204257110865263183)
,p_event_id=>wwv_flow_imp.id(204256632755263181)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_WORKSPACE_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(204257223536270067)
,p_name=>'show hide email & workspace count'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P115_WORKSPACE_NAMES'
,p_condition_element=>'P115_WORKSPACE_NAMES'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DOMAIN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(204257502482270067)
,p_event_id=>wwv_flow_imp.id(204257223536270067)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_EMAIL_ADDRESSES,P115_SEND_EMAIL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(204257729890270067)
,p_event_id=>wwv_flow_imp.id(204257223536270067)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_EMAIL_ADDRESSES,P115_SEND_EMAIL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(378139003180037220)
,p_event_id=>wwv_flow_imp.id(204257223536270067)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_WORKSPACE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(378139326244041710)
,p_event_id=>wwv_flow_imp.id(204257223536270067)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_WORKSPACE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(204269515318324376)
,p_name=>'show hide pw'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P115_PASSWORD_GENERATION'
,p_condition_element=>'P115_PASSWORD_GENERATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'RANDOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(204269828087324376)
,p_event_id=>wwv_flow_imp.id(204269515318324376)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(211623522908489869)
,p_event_id=>wwv_flow_imp.id(204269515318324376)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_PASSWORD_CONFIRM'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(204270018247324376)
,p_event_id=>wwv_flow_imp.id(204269515318324376)
,p_event_result=>'FALSE'
,p_action_sequence=>22
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(211623717085492498)
,p_event_id=>wwv_flow_imp.id(204269515318324376)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_PASSWORD_CONFIRM'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(203152328831436871)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_count     integer;',
'   l_workspace varchar2(255);',
'   l_username  varchar2(255);',
'   l_domain    varchar2(255);',
'   l_email     varchar2(255);',
'   l_schema    varchar2(255);',
'   c_collection_name constant varchar2(255) := ''BULK_USER_CREATE'';',
'   x           integer;',
'   function workspace_exists (p_workspace_name in varchar2) return boolean',
'   is',
'       l_found boolean := false;',
'   begin',
'       for c1 in (select 1 x from wwv_flow_companies where short_name = upper(p_workspace_name)) loop',
'          l_found := true;',
'       end loop;',
'       return l_found;',
'   end;',
'   function schema_exists (p_schema_name in varchar2) return boolean',
'   is',
'       l_found boolean := false;',
'   begin',
'       for c1 in (select 1 x from sys.dba_users where username = upper(p_schema_name)) loop',
'          l_found := true;',
'       end loop;',
'       return l_found;',
'   end;',
'   function workspace_in_collection (p_workspace_name in varchar2) return boolean',
'   is',
'       l_found boolean := false;',
'   begin',
'       for c1 in (select 1 x ',
'                  from   wwv_flow_collections ',
'                  where  collection_name = c_collection_name and ',
'                         upper(c003) = upper(p_workspace_name)  ) loop',
'          l_found := true;',
'       end loop;',
'       return l_found;',
'   end;',
'begin',
'    if :P115_WORKSPACE_NAMES = ''DOMAIN'' then',
'        wwv_flow_fnd_user_api.create_user_coll_from_csv (',
'            p_users => :P115_EMAIL_ADDRESSES,',
'            p_security_group_id => :flow_security_group_id,',
'            p_strip_domain => ''N'' );',
'        commit;',
'        for c1 in (',
'             select seq_id , c001, c002',
'             from wwv_flow_collections ',
'             where collection_name = c_collection_name order by 1) loop',
'             --',
'             l_email     := lower(c1.c002);',
'             --l_username  := upper(htmldb_util.compress_int(wwv_flow_id.next_val));',
'             l_username  := l_email;',
'             l_workspace := substr(c1.c001,instr(c1.c001,''@'')+1);',
'             l_workspace := substr(l_workspace,1,instr(l_workspace,''.'')-1);',
'             l_workspace := replace(trim(l_workspace),'' '',''_'');',
'             l_domain    := l_workspace;',
'             x := 0;',
'             for j in 1..999 loop',
'                 if not workspace_exists(p_workspace_name=>l_workspace) and',
'                    not workspace_in_collection(p_workspace_name=>l_workspace) and',
'                    not schema_exists(p_schema_name=>l_workspace',
'                    ) then',
'                    exit;',
'                 end if;',
'                 x := x + 1;',
'                 l_workspace := l_domain||''_''||lpad(x,3,''000'');',
'             end loop;',
'             --',
'             --l_username := l_workspace;',
'             l_schema := l_workspace;',
'             ',
'             wwv_flow_collection.update_member(',
'                p_collection_name => c_collection_name,',
'                p_seq => c1.seq_id,',
'                p_c001 => l_username,',
'                p_c002 => l_email,',
'                p_c003 => l_workspace,',
'                p_c006 => :P115_INSTALL_SAMPLE_TABLES,',
'                p_c007 => :P115_QUOTA,',
'                p_c009 => :P115_RM_CONSUMER_GROUP,',
'                p_c010 => :P115_SEND_EMAIL,',
'                p_c011 => :P115_AUTO_PURGE,',
'                p_c012 => :P115_COMMENTS,',
'                p_c013 => l_schema',
'                );',
'        end loop;',
'        commit;',
'    elsif :P115_WORKSPACE_NAMES = ''GENERATED'' then',
'         l_count := :P115_WORKSPACE_COUNT;',
'         wwv_flow_collection.create_or_truncate_collection(',
'            p_collection_name => c_collection_name);',
'         x := 0;',
'         for i in 1..l_count loop',
'             x := x + 1;',
'             l_email := '''';',
'             for j in 0..100 loop',
'                  x := x + j;',
'                  l_workspace := upper(htmldb_util.compress_int(wwv_flow_id.next_val));',
'                  l_username  := lower(l_workspace);',
'                  if not workspace_exists(p_workspace_name=>l_workspace) and',
'                     not schema_exists(p_schema_name=>l_workspace) ',
'                     then',
'                     exit;',
'                  end if;',
'             end loop;',
'             l_schema := l_workspace;',
'             --',
'             wwv_flow_collection.add_member (',
'                p_collection_name => c_collection_name,',
'                p_c001 => l_username,',
'                p_c002 => l_email,',
'                p_c003 => l_workspace,',
'                p_c006 => :P115_INSTALL_SAMPLE_TABLES,',
'                p_c007 => :P115_QUOTA,',
'                p_c009 => :P115_RM_CONSUMER_GROUP,',
'                p_c010 => :P115_SEND_EMAIL,',
'                p_c011 => :P115_AUTO_PURGE,',
'                p_c012 => :P115_COMMENTS,',
'                p_c013 => l_schema',
'                );',
'         end loop;',
'         commit;',
'    elsif :P115_WORKSPACE_NAMES = ''PREFIX'' then',
'         l_count := :P115_WORKSPACE_COUNT;',
'         wwv_flow_collection.create_or_truncate_collection(',
'            p_collection_name => c_collection_name);',
'         x := 0;',
'         for i in 1..l_count loop',
'             x := x + 1;',
'             for j in 0..100 loop',
'                  x := x + j;',
'                  l_workspace := upper(:P115_WORKSPACE_PREFIX)||''_''||lpad(x,3,''000'');',
'                  l_workspace := replace(trim(l_workspace),'' '',''_'');',
'                  if not workspace_exists(p_workspace_name=>l_workspace) and',
'                     not schema_exists(p_schema_name=>l_workspace) ',
'                     then',
'                     exit;',
'                  end if;',
'             end loop;',
'             l_email     := '''';',
'             l_username  := lower(l_workspace);',
'             l_schema := l_workspace;',
'             --',
'             wwv_flow_collection.add_member (',
'                p_collection_name => c_collection_name,',
'                p_c001 => l_username,',
'                p_c002 => l_email,',
'                p_c003 => l_workspace,',
'                p_c006 => :P115_INSTALL_SAMPLE_TABLES,',
'                p_c007 => :P115_QUOTA,',
'                p_c009 => :P115_RM_CONSUMER_GROUP,',
'                p_c010 => :P115_SEND_EMAIL,',
'                p_c011 => :P115_AUTO_PURGE,',
'                p_c012 => :P115_COMMENTS,',
'                p_c013 => l_schema',
'                );',
'         end loop;',
'         commit;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>203152328831436871
);
end;
/
prompt --application/pages/page_00116
begin
wwv_flow_imp_page.create_page(
 p_id=>116
,p_name=>'Create Multiple Workspaces'
,p_alias=>'CREATE-MULTIPLE-WORKSPACES2'
,p_step_title=>'Create Multiple Workspaces'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931243707245169747)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203136525128329478)
,p_plug_name=>'Create Multiple Workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(203155004253505460)
,p_name=>'Workspace Administrators'
,p_parent_plug_id=>wwv_flow_imp.id(203136525128329478)
,p_template=>wwv_flow_imp.id(721130166613730309)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null as edit_link,',
'       lower(c001) username, ',
'       lower(c002) email, ',
'       c003 workspace,',
'       c013 schema,',
'       c006 tab,',
'       c007 quota,',
'       c009 consumer_group,',
'       c010 invite,',
'       c011 auto_purge,',
'       decode(c012,null,null,trim(substr(c012,1,5))||''...'') comments,',
'       SEQ_ID',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No workspaces to create.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10660903644899003)
,p_query_column_id=>1
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203155327273505476)
,p_query_column_id=>2
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>3
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203155422558505479)
,p_query_column_id=>3
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>4
,p_column_heading=>'Email'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203180629534127281)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:RP,118:P118_SEQ_ID:#SEQ_ID#:'
,p_column_linktext=>'#WORKSPACE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388223026397691509)
,p_query_column_id=>5
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>5
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204291616462482173)
,p_query_column_id=>6
,p_column_alias=>'TAB'
,p_column_display_sequence=>9
,p_column_heading=>'Tables'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203297621112430175)
,p_query_column_id=>7
,p_column_alias=>'QUOTA'
,p_column_display_sequence=>6
,p_column_heading=>'Quota (MB)'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204327009010593464)
,p_query_column_id=>8
,p_column_alias=>'CONSUMER_GROUP'
,p_column_display_sequence=>12
,p_column_heading=>'Consumer Group'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204739012340065688)
,p_query_column_id=>9
,p_column_alias=>'INVITE'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204803331456743407)
,p_query_column_id=>10
,p_column_alias=>'AUTO_PURGE'
,p_column_display_sequence=>10
,p_column_heading=>'Automatic Purge'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204803406634743408)
,p_query_column_id=>11
,p_column_alias=>'COMMENTS'
,p_column_display_sequence=>13
,p_column_heading=>'Comments'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204702515773821001)
,p_query_column_id=>12
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>14
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(203156112134526583)
,p_name=>'Invalid Email Addresses'
,p_parent_plug_id=>wwv_flow_imp.id(203136525128329478)
,p_template=>wwv_flow_imp.id(721128767486730308)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lower(c001) username, lower(c002) email, c003 error',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_INVALID''',
'order by c001'))
,p_display_when_condition=>'P115_WORKSPACE_NAMES'
,p_display_when_cond2=>'DOMAIN'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No invalid email addresses found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203156427373526584)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>1
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203156501517526584)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>2
,p_column_heading=>'Email Address'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203156605916526584)
,p_query_column_id=>3
,p_column_alias=>'ERROR'
,p_column_display_sequence=>3
,p_column_heading=>'Error'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203136813721329479)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_source=>'<p>Review the list of workspaces that will be created. You can edit an entry to adjust workspace settings or remove workspace provision request.</p>'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203142400911364147)
,p_plug_name=>'create multiple workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(203141106443364145)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203144411900384588)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752112632459695873)
,p_plug_name=>'Create Multiple Workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203137121232329479)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(203144411900384588)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203137425162329479)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(203144411900384588)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203137304527329479)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(203144411900384588)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203138127529329480)
,p_branch_action=>'f?p=&APP_ID.:117:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(203137425162329479)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203137825813329480)
,p_branch_action=>'f?p=&APP_ID.:115:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(203137304527329479)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10659826615751613)
,p_validation_name=>'Workspaces exist in list'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE'''))
,p_validation_type=>'EXISTS'
,p_error_message=>'No workspaces to create.'
,p_when_button_pressed=>wwv_flow_imp.id(203137425162329479)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00117
begin
wwv_flow_imp_page.create_page(
 p_id=>117
,p_name=>'Create Multiple Workspaces'
,p_alias=>'CREATE-MULTIPLE-WORKSPACES3'
,p_step_title=>'Create Multiple Workspaces'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(3931243707245169747)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203142625502364148)
,p_plug_name=>'create multiple workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(203141106443364145)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203145321035396682)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(204747326360125429)
,p_name=>'Workspaces (&P117_WORKSPACE_COUNT.)'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lower(c001) username, ',
'       lower(c002) email, ',
'       c003 workspace,',
'       c013 schema,',
'       c006 tab,',
'       c007 quota,',
'       c009 consumer_group,',
'       c010 invite,',
'       SEQ_ID',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No workspaces to create.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204747527037125436)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>2
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204747604390125436)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>3
,p_column_heading=>'Email'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204748507975125438)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388224100302703612)
,p_query_column_id=>4
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>4
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204748201325125437)
,p_query_column_id=>5
,p_column_alias=>'TAB'
,p_column_display_sequence=>8
,p_column_heading=>'Tables'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204747929987125437)
,p_query_column_id=>6
,p_column_alias=>'QUOTA'
,p_column_display_sequence=>5
,p_column_heading=>'Quota (MB)'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204747706388125436)
,p_query_column_id=>7
,p_column_alias=>'CONSUMER_GROUP'
,p_column_display_sequence=>10
,p_column_heading=>'Consumer Group'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204747826149125437)
,p_query_column_id=>8
,p_column_alias=>'INVITE'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204748408256125437)
,p_query_column_id=>9
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388982521929319912)
,p_plug_name=>'&PRODUCT_NAME. Password'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>35
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Enter the password for workspace administrator accounts and confirm the list of workspaces that will be created.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752112771229695873)
,p_plug_name=>'Create Multiple Workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203139215977329481)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(203145321035396682)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203139300916329481)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(203145321035396682)
,p_button_name=>'FINISH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Provision Workspaces'
,p_button_position=>'CREATE'
,p_button_condition=>'to_number(:P117_WORKSPACE_COUNT) > 0'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203139424404329481)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(203145321035396682)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203140209185329481)
,p_branch_action=>'f?p=&APP_ID.:135:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(203139300916329481)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203139928802329481)
,p_branch_action=>'f?p=&APP_ID.:116:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(203139424404329481)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10525617128224276)
,p_name=>'P117_WORKSPACE_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(388982521929319912)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(388982807343323259)
,p_name=>'P117_PASSWORD'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(388982521929319912)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password for &PRODUCT_NAME. workspace administrator accounts. All accounts will be created with the same password, which can be changed later.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(388983301089326245)
,p_name=>'P117_PASSWORD_CONFIRM'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(388982521929319912)
,p_prompt=>'Confirm Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Confirm password for workspace administrator accounts.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(10657900354703091)
,p_computation_sequence=>10
,p_computation_item=>'P117_WORKSPACE_COUNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) as cnt',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE'''))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(390370505112415516)
,p_validation_name=>'P117_PASSWORD_CONFIRM'
,p_validation_sequence=>10
,p_validation=>'P117_PASSWORD'
,p_validation2=>'&P117_PASSWORD_CONFIRM.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'Password confirmation does not match password.'
,p_validation_condition=>':P117_PASSWORD is not null and :P117_PASSWORD_CONFIRM is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(203139300916329481)
,p_associated_item=>wwv_flow_imp.id(388983301089326245)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1475459903460625304)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    declare',
'        l_error varchar2(32767);',
'    begin',
'        --',
'        -- return message for first validation error or null',
'        --',
'        for c1 in ( select upper(c001) username,',
'                           upper(c003) workspace',
'                      from wwv_flow_collections',
'                     where collection_name = ''BULK_USER_CREATE''',
'                     order by 1 )',
'        loop',
'',
'            l_error := wwv_flow_security.strong_password_validation(',
'                           p_username       => c1.username,',
'                           p_password       => :P117_PASSWORD,',
'                           p_old_password   => null,',
'                           p_workspace_name => c1.workspace );',
'            exit when l_error is not null;',
'        end loop;',
'',
'        return l_error;',
'    end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'error'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.is_builder_password_required (',
'    p_developer_yn => ''Y'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(388982807343323259)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(204714102784891523)
,p_name=>'Finish'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(203139300916329481)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(204714407002891533)
,p_event_id=>wwv_flow_imp.id(204714102784891523)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'FINISH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(203182018750181417)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create workspaces'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_security_group_id number;',
'   l_password          varchar2(255);',
'   l_email             varchar2(512);',
'   function get_security_group_id( p_workspace_name in varchar2 ) return number',
'   is',
'       l_security_group_id number := null;',
'   begin',
'       for c1 in (select provisioning_company_id',
'                    from wwv_flow_companies',
'                   where short_name = trim(upper(p_workspace_name))) loop',
'           l_security_group_id := c1.provisioning_company_id;',
'           exit;',
'       end loop;',
'       --',
'       return l_security_group_id;',
'   end get_security_group_id;',
'   ',
'begin',
'',
'    l_password := :P117_PASSWORD;',
'    :P117_PASSWORD := null;',
'',
'for c1 in (',
'select upper(c001) username, ',
'       lower(c002) email, ',
'       upper(c003) workspace,',
'       upper(c013) schema,',
'       c006 tab,',
'       c007 quota,',
'       c009 consumer_group,',
'       c010 invite,',
'       c011 auto_purge,',
'       c012 comments,',
'       SEQ_ID',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1) loop',
'',
'    wwv_flow_cloud_db_services.create_workspace(',
'        p_workspace_name         => c1.workspace,',
'        p_schema_name            => c1.schema,',
'        p_max_size_mb            => c1.quota,',
'        p_install_sample_app     => ''N'',',
'        p_install_sample_ws      => ''N'',',
'        p_install_emp_dept       => c1.tab,',
'        p_allow_to_be_purged_yn  => c1.auto_purge,',
'        p_rm_consumer_group      => c1.consumer_group,',
'        p_workspace_description  => c1.comments);',
'',
'    wwv_flow_cloud_db_services.set_workspace_status(',
'        p_workspace_name => c1.workspace,',
'        p_workspace_status => ''ASSIGNED'' );',
'',
'    l_security_group_id  := get_security_group_id( p_workspace_name => c1.workspace );',
'    --    l_password := wwv_flow_provision.get_random_password( 32 );',
'',
'',
'    if instr(c1.username,''@'') > 0 and instr(c1.username,''.'') > 0 then',
'        l_email := c1.username;',
'    else',
'        l_email := null;',
'    end if;',
'',
'    wwv_flow_admin_api.create_user(',
'            p_security_group_id            => l_security_group_id,',
'            p_user_name                    => c1.username,',
'            p_first_name                   => null,',
'            p_last_name                    => null,',
'            p_web_password                 => l_password,',
'            p_email_address                => l_email,',
'            p_is_admin                     => ''Y'',',
'            p_change_password_on_first_use => ''N'' );',
'',
'end loop;',
'commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating workspaces.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Workspaces successfully created.'
,p_internal_uid=>203182018750181417
);
end;
/
prompt --application/pages/page_00118
begin
wwv_flow_imp_page.create_page(
 p_id=>118
,p_name=>'Edit Workspace Provision Request'
,p_alias=>'EDIT-WORKSPACE-PROVISION-REQUEST'
,p_step_title=>'Edit Workspace Provision Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176750964111248)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10529205453313232)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204693530359730650)
,p_plug_name=>'Workspace Request'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752112842780695873)
,p_plug_name=>'Edit Workspace Provision Request'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(204704923093832859)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10529205453313232)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:116:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(204705303596832861)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(10529205453313232)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(204705113527832861)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(10529205453313232)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(204723032686965081)
,p_branch_name=>'back to wizard'
,p_branch_action=>'f?p=&APP_ID.:116:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204700124196801945)
,p_name=>'P118_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204711717233881083)
,p_name=>'P118_WORKSPACE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Workspace Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>35
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter the name of the workspace to be created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204711919936881083)
,p_name=>'P118_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>35
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter the name of the database schema to be created and associated with this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204712106692881084)
,p_name=>'P118_EMAIL'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Email'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the email address of the workspace administrator.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204712313604881085)
,p_name=>'P118_QUOTA'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Space Quota (MB)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter the maximum size of the tablespace to be associated with the workspace schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'10000'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204712912974881089)
,p_name=>'P118_INSTALL_SAMPLE_TAB'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Install Sample EMP and DEPT tables'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Install the sample EMP and DEPT tables into this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204713128286881089)
,p_name=>'P118_CONSUMER_GROUP'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Resource Manager Consumer Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Do Not Set -'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Database Resource Manager consumer group to be used for all page events associated with this workspace.  At the beginning of every request, the &PRODUCT_NAME. engine switches the current consumer group of the current database session to t'
||'he workspace''s consumer group.  This applies to both executing applications as well as any of the applications used within the &PRODUCT_NAME. development environment.',
'',
'<p />',
'',
'The privilege to switch to this consumer group must be granted to either PUBLIC or the &PRODUCT_NAME. schema.  This privilege is typically granted using the procedure DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204740226561074303)
,p_name=>'P118_SEND_EMAIL'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Send Email Invite'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204803923199823235)
,p_name=>'P118_AUTO_PURGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Allow workspace to be automatically purged'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Determines if the workspace is a candidate for automatic purging of unused workspaces.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204804212188843537)
,p_name=>'P118_COMMENTS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Workspace Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter an optional comment or description of the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(388229314702757742)
,p_name=>'P118_USERNAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(204693530359730650)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter the username for the workspace administrator.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(204722307164959043)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_member (',
'    p_collection_name => ''BULK_USER_CREATE'',',
'    p_seq             => :P118_SEQ_ID,',
'    p_c001            => upper(:P118_USERNAME),',
'    p_c002            => lower(:P118_EMAIL),',
'    p_c003            => upper(:P118_WORKSPACE),',
'    p_c006            => :P118_INSTALL_SAMPLE_TAB,',
'    p_c007            => :P118_QUOTA,',
'    p_c009            => :P118_CONSUMER_GROUP,',
'    p_c010            => :P118_SEND_EMAIL,',
'    p_c011            => :P118_AUTO_PURGE,',
'    p_c012            => :P118_COMMENTS,',
'    p_c013            => :P118_SCHEMA );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(204705113527832861)
,p_process_success_message=>'Workspace provision request updated.'
,p_internal_uid=>204722307164959043
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10657131894604722)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.delete_member (',
'    p_collection_name => ''BULK_USER_CREATE'',',
'    p_seq             => :P118_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(204705303596832861)
,p_process_success_message=>'Workspace provision request deleted.'
,p_internal_uid=>10657131894604722
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(204721213005932269)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select upper(c001) un, ',
'       lower(c002) email, ',
'       c003 workspace,',
'       c006 tab,',
'       c007 quota,',
'       c008 password,',
'       c009 consumer_group,',
'       c010 send_mail,',
'       c011 auto_purge,',
'       c012 comments,',
'       c013 schema',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE'' and ',
'       seq_id = :P118_SEQ_ID',
'     ) loop',
'    :P118_WORKSPACE := c1.workspace;',
'    :P118_USERNAME  := c1.un;',
'    :P118_SCHEMA    := c1.schema;',
'    :P118_EMAIL     := c1.email;',
'    :P118_QUOTA     := c1.quota;',
'    :P118_INSTALL_SAMPLE_TAB := c1.tab;',
'    :P118_CONSUMER_GROUP     := c1.consumer_group;',
'    :P118_SEND_EMAIL         := c1.send_mail;',
'    :P118_AUTO_PURGE         := c1.auto_purge;',
'    :P118_COMMENTS           := c1.comments;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>204721213005932269
);
end;
/
prompt --application/pages/page_00119
begin
wwv_flow_imp_page.create_page(
 p_id=>119
,p_name=>'Manage Log Interval'
,p_alias=>'MANAGE-LOG-INTERVAL'
,p_step_title=>'Manage Log Interval'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(217670729607373979)
,p_plug_name=>'Manage Log Interval'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Set the minimum number of days to retain the log information for the specified logs.  The maximum value that can be specified is 180 days, with a default value of 14 days.  Keeping log information for longer periods can degrade runtime performance'
||'.</p>',
'',
'<p>Logs are implemented using two underlying tables, with a switch between the log tables after the number of days specified in "Log Switch After Days".</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(220474109124626169)
,p_name=>'Manage Log Interval'
,p_template=>wwv_flow_imp.id(721130166613730309)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"LOG_NAME",',
'"CURRENT_LOG_NUMBER",',
'"LOG_SWITCHED_DATE",',
'"LOG_SWITCH_AFTER_DAYS",',
'"LOG_NAME" LOG_NAME_DISPLAY',
'from "#OWNER#"."WWV_FLOW_LOG_NUMBERS"',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>10
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(220474418004626171)
,p_query_column_id=>1
,p_column_alias=>'LOG_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Log Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'LOG_NAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(220474520209626171)
,p_query_column_id=>2
,p_column_alias=>'CURRENT_LOG_NUMBER'
,p_column_display_sequence=>3
,p_column_heading=>'Current Log Number'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'CURRENT_LOG_NUMBER'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(220474606112626171)
,p_query_column_id=>3
,p_column_alias=>'LOG_SWITCHED_DATE'
,p_column_display_sequence=>4
,p_column_heading=>'Log Switched Date'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_column_width=>7
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'LOG_SWITCHED_DATE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(220474704579626171)
,p_query_column_id=>4
,p_column_alias=>'LOG_SWITCH_AFTER_DAYS'
,p_column_display_sequence=>5
,p_column_heading=>'Log Switch After Days'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'LOG_SWITCH_AFTER_DAYS'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(220474822223626171)
,p_query_column_id=>5
,p_column_alias=>'LOG_NAME_DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Log Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(220529904687804674)
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'LOG_NAME_DISPLAY'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(220476731217631908)
,p_column_sequence=>1
,p_query_column_name=>'LOG_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(220476821007631909)
,p_column_sequence=>2
,p_query_column_name=>'CURRENT_LOG_NUMBER'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(220476901338631909)
,p_column_sequence=>3
,p_query_column_name=>'LOG_SWITCHED_DATE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(220477010434631909)
,p_column_sequence=>4
,p_query_column_name=>'LOG_SWITCH_AFTER_DAYS'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(220477104991631909)
,p_column_sequence=>5
,p_query_column_name=>'LOG_NAME_DISPLAY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1080989061119523923)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(220475031437626173)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1080989061119523923)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(220474918866626173)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1080989061119523923)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(220476109027626175)
,p_branch_action=>'f?p=&APP_ID.:119:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(220475612889626174)
,p_tabular_form_region_id=>wwv_flow_imp.id(220474109124626169)
,p_validation_name=>'LOG_SWITCH_AFTER_DAYS not null'
,p_validation_sequence=>40
,p_validation=>'LOG_SWITCH_AFTER_DAYS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must have a value.'
,p_when_button_pressed=>wwv_flow_imp.id(220475031437626173)
,p_associated_column=>'LOG_SWITCH_AFTER_DAYS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(220475820099626174)
,p_tabular_form_region_id=>wwv_flow_imp.id(220474109124626169)
,p_validation_name=>'LOG_SWITCH_AFTER_DAYS must be numeric'
,p_validation_sequence=>40
,p_validation=>'LOG_SWITCH_AFTER_DAYS'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'#COLUMN_HEADER# must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(220475031437626173)
,p_associated_column=>'LOG_SWITCH_AFTER_DAYS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(220561017110808463)
,p_tabular_form_region_id=>wwv_flow_imp.id(220474109124626169)
,p_validation_name=>'Log Switch After Days must be a positive integer between 1 and 180'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if abs(trunc(to_number(:LOG_SWITCH_AFTER_DAYS))) <> to_number(:LOG_SWITCH_AFTER_DAYS) then',
'        return FALSE;',
'    end if;',
'    if to_number(:LOG_SWITCH_AFTER_DAYS) between 1 and 180 then',
'        return TRUE;',
'    else',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#COLUMN_HEADER# must be a positive integer between 1 and 180.'
,p_when_button_pressed=>wwv_flow_imp.id(220475031437626173)
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'LOG_SWITCH_AFTER_DAYS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(582425338101226541)
,p_tabular_form_region_id=>wwv_flow_imp.id(220474109124626169)
,p_validation_name=>'Log Switch After Days must be a positive integer greater than 14 for cloud'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if to_number(:LOG_SWITCH_AFTER_DAYS) > 13 then',
'        return TRUE;',
'    else',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#COLUMN_HEADER# must be at least 14.'
,p_validation_condition=>'return wwv_flow_global.g_cloud;'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(220475031437626173)
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'LOG_SWITCH_AFTER_DAYS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(220475920386626174)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(220474109124626169)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_LOG_NUMBERS'
,p_attribute_03=>'LOG_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(220475031437626173)
,p_process_success_message=>'#MRU_COUNT# row(s) updated'
,p_internal_uid=>220475920386626174
);
end;
/
prompt --application/pages/page_00120
begin
wwv_flow_imp_page.create_page(
 p_id=>120
,p_name=>'Mail Queue'
,p_alias=>'MAIL-QUEUE'
,p_step_title=>'Mail Queue'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784309333645873)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_mail.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49446201769803487)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>15
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(50268723520030341)
,p_plug_name=>'Mail Queue'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Monitor email messages in the mail queue.  Individual mail messages can be deleted from the queue.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(52072302092220942)
,p_name=>'Mail Queue'
,p_template=>wwv_flow_imp.id(517376500704206647)
,p_display_sequence=>25
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'       mail_to, ',
'       mail_from, ',
'       mail_subj, ',
'       mail_cc, ',
'       mail_bcc, ',
'       last_updated_on, ',
'       last_updated_by,',
'       mail_send_error,',
'       mail_send_count',
'from wwv_flow_mail_queue'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_no_data_found=>'Report contains no data.'
,p_query_num_rows_item=>'P120_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(52079921055245360)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(52072918944220953)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(52073024837220953)
,p_query_column_id=>3
,p_column_alias=>'MAIL_TO'
,p_column_display_sequence=>3
,p_column_heading=>'To'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(52073128821220954)
,p_query_column_id=>4
,p_column_alias=>'MAIL_FROM'
,p_column_display_sequence=>4
,p_column_heading=>'From'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(52073227085220954)
,p_query_column_id=>5
,p_column_alias=>'MAIL_SUBJ'
,p_column_display_sequence=>5
,p_column_heading=>'Subject'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(52073318409220954)
,p_query_column_id=>6
,p_column_alias=>'MAIL_CC'
,p_column_display_sequence=>6
,p_column_heading=>'CC'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(52073402357220954)
,p_query_column_id=>7
,p_column_alias=>'MAIL_BCC'
,p_column_display_sequence=>7
,p_column_heading=>'BCC'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(52073505633220954)
,p_query_column_id=>8
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>8
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(52073606743220954)
,p_query_column_id=>9
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>9
,p_column_heading=>'Created By'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(27759304778424826)
,p_query_column_id=>10
,p_column_alias=>'MAIL_SEND_ERROR'
,p_column_display_sequence=>11
,p_column_heading=>'Error'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(345054819878396473)
,p_query_column_id=>11
,p_column_alias=>'MAIL_SEND_COUNT'
,p_column_display_sequence=>10
,p_column_heading=>'Mail Send Count'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(52076517114234733)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(52076621951234734)
,p_column_sequence=>2
,p_query_column_name=>'MAIL_TO'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(52076715067234734)
,p_column_sequence=>3
,p_query_column_name=>'MAIL_FROM'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(52076807247234734)
,p_column_sequence=>4
,p_query_column_name=>'MAIL_SUBJ'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(52076910607234734)
,p_column_sequence=>5
,p_query_column_name=>'MAIL_CC'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(52077014613234734)
,p_column_sequence=>6
,p_query_column_name=>'MAIL_BCC'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(52077106520234734)
,p_column_sequence=>7
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(52077202857234734)
,p_column_sequence=>8
,p_query_column_name=>'LAST_UPDATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(27759202939424825)
,p_column_sequence=>9
,p_query_column_name=>'MAIL_SEND_ERROR'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(345054619550396473)
,p_column_sequence=>10
,p_query_column_name=>'MAIL_SEND_COUNT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195763210632686096)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(49446201769803487)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:RP,120,RIR::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48462126508690371)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(49446201769803487)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(345061314377421688)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(49446201769803487)
,p_button_name=>'FORCESEND'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Force Send All Mail'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(50605032251638488)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(49446201769803487)
,p_button_name=>'SEND'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Send All Mail'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48515711186704875)
,p_branch_action=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(61617713712144160)
,p_validation_name=>'Something checked on delete'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'No messages checked to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(48462126508690371)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48518317897716201)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(52072302092220942)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'Delete Checked'
,p_attribute_02=>'WWV_FLOW_MAIL_QUEUE'
,p_attribute_03=>'ID'
,p_process_error_message=>'Error deleting mail messages from the queue.'
,p_process_when_button_id=>wwv_flow_imp.id(48462126508690371)
,p_process_success_message=>'Successfully deleted mail messages from the queue.'
,p_internal_uid=>48518317897716201
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(50611232167657317)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Send Mail'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_mail.push_queue_immediate( p_force_yn => ''N'');',
'--',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error sending mail.'
,p_process_when_button_id=>wwv_flow_imp.id(50605032251638488)
,p_process_success_message=>'Successfully sent mail.'
,p_internal_uid=>50611232167657317
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(345064911254426069)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Force Send Mail'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_mail.push_queue_immediate( p_force_yn => ''Y'');',
'--',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error sending mail.'
,p_process_when_button_id=>wwv_flow_imp.id(345061314377421688)
,p_process_success_message=>'Successfully sent mail.'
,p_internal_uid=>345064911254426069
);
end;
/
prompt --application/pages/page_00121
begin
wwv_flow_imp_page.create_page(
 p_id=>121
,p_name=>'Mail Log'
,p_alias=>'MAIL-LOG'
,p_step_title=>'Mail Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784309333645873)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(50496401272341432)
,p_plug_name=>'&PRODUCT_NAME. Mail Log'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'The Mail Log contains the mail message header fields and the date of all messages sent successfully.  '
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(50496812659341435)
,p_plug_name=>'Mail Log'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192438208860857511)
,p_plug_name=>'Mail Log'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(mail_to,'','','', '') mail_to, ',
'       mail_from, ',
'       mail_subj, ',
'       mail_cc,',
'       mail_bcc, ',
'       last_updated_on, ',
'       last_updated_on since_date,',
'       last_updated_by,',
'       mail_send_error,',
'       mail_message_created,',
'       mail_message_send_begin,',
'       mail_message_send_end,',
'       mail_body_size,',
'       mail_body_html_size,',
'       mail_attachment_count,',
'       mail_attachment_size,',
'       mail_message_id',
'from wwv_flow_mail_log'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192438318982857511)
,p_name=>'Mail Log'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192438507088857516)
,p_db_column_name=>'MAIL_TO'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'To'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192438629698857518)
,p_db_column_name=>'MAIL_FROM'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'From'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192438715159857518)
,p_db_column_name=>'MAIL_SUBJ'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Subject'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192438831304857519)
,p_db_column_name=>'MAIL_CC'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'CC'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192438914422857520)
,p_db_column_name=>'MAIL_BCC'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'BCC'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192439021960857521)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Log Entry Created'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192439104693857521)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Message Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192439215943857522)
,p_db_column_name=>'MAIL_SEND_ERROR'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Error'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192440600375889711)
,p_db_column_name=>'SINCE_DATE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Log Entry Created Since'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(741568285578681316)
,p_db_column_name=>'MAIL_MESSAGE_CREATED'
,p_display_order=>19
,p_column_identifier=>'J'
,p_column_label=>'Message Created'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(279105603897806104)
,p_db_column_name=>'MAIL_MESSAGE_ID'
,p_display_order=>29
,p_column_identifier=>'Q'
,p_column_label=>'Message ID'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(741568340024681317)
,p_db_column_name=>'MAIL_MESSAGE_SEND_BEGIN'
,p_display_order=>39
,p_column_identifier=>'K'
,p_column_label=>'Message Send Begin'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(741568428493681318)
,p_db_column_name=>'MAIL_MESSAGE_SEND_END'
,p_display_order=>49
,p_column_identifier=>'L'
,p_column_label=>'Message Send End'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(741568555179681319)
,p_db_column_name=>'MAIL_BODY_SIZE'
,p_display_order=>59
,p_column_identifier=>'M'
,p_column_label=>'Message Body Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(741568632901681320)
,p_db_column_name=>'MAIL_BODY_HTML_SIZE'
,p_display_order=>69
,p_column_identifier=>'N'
,p_column_label=>'HTML Message Body Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(741568730024681321)
,p_db_column_name=>'MAIL_ATTACHMENT_COUNT'
,p_display_order=>79
,p_column_identifier=>'O'
,p_column_label=>'Attachment Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(741568816710681322)
,p_db_column_name=>'MAIL_ATTACHMENT_SIZE'
,p_display_order=>89
,p_column_identifier=>'P'
,p_column_label=>'Attachment Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192439523053858450)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316318715536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'MAIL_TO:MAIL_FROM:MAIL_SUBJ:LAST_UPDATED_ON:LAST_UPDATED_BY:MAIL_SEND_ERROR:MAIL_MESSAGE_CREATED'
,p_sort_column_1=>'LAST_UPDATED_ON'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'SINCE_DATE'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(192440923924896543)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(50496812659341435)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:121:&SESSION.::&DEBUG.:RIR,121::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(108302731174967188)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(50496812659341435)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Truncate'
,p_button_position=>'CREATE'
,p_confirm_message=>'Do you really want to truncate the Mail Log?'
,p_confirm_style=>'danger'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(50500825272341463)
,p_branch_action=>'f?p=&FLOW_ID.:121:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(50542609292499337)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_mail_log;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating Mail Log.'
,p_process_when_button_id=>wwv_flow_imp.id(108302731174967188)
,p_process_success_message=>'Successfully truncated Mail Log.'
,p_internal_uid=>50542609292499337
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(108304121608973821)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(192440923924896543)
,p_internal_uid=>108304121608973821
);
end;
/
prompt --application/pages/page_00122
begin
wwv_flow_imp_page.create_page(
 p_id=>122
,p_name=>'Jobs'
,p_alias=>'JOBS'
,p_step_title=>'Jobs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(619287213627143211)
,p_plug_name=>'Jobs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Jobs report contains a listing of all of the database jobs associated with &PRODUCT_NAME..',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(619293913679166083)
,p_plug_name=>'Jobs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>'select * from user_scheduler_jobs'
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(619294030254166083)
,p_name=>'Jobs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619294232226166109)
,p_db_column_name=>'JOB_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Job Name'
,p_column_link=>'f?p=&APP_ID.:123:&SESSION.::&DEBUG.:123,RIR:IR_JOB_NAME:#JOB_NAME#'
,p_column_linktext=>'#JOB_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619294305961166110)
,p_db_column_name=>'JOB_SUBNAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Job Subname'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619294416630166110)
,p_db_column_name=>'JOB_STYLE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Job Style'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619294516377166110)
,p_db_column_name=>'JOB_CREATOR'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Job Creator'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619294621699166110)
,p_db_column_name=>'CLIENT_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Client ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619294719986166111)
,p_db_column_name=>'GLOBAL_UID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Global UID'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619294804252166111)
,p_db_column_name=>'PROGRAM_OWNER'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Program Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619294901886166111)
,p_db_column_name=>'PROGRAM_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Program Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295019204166111)
,p_db_column_name=>'JOB_TYPE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Job Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295100644166111)
,p_db_column_name=>'JOB_ACTION'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Job Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295227963166112)
,p_db_column_name=>'NUMBER_OF_ARGUMENTS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Number of Arguments'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295306216166112)
,p_db_column_name=>'SCHEDULE_OWNER'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Schedule Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295409833166112)
,p_db_column_name=>'SCHEDULE_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Schedule Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295532117166112)
,p_db_column_name=>'SCHEDULE_TYPE'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Schedule Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295616537166112)
,p_db_column_name=>'START_DATE'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Start Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295702828166113)
,p_db_column_name=>'REPEAT_INTERVAL'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Repeat Interval'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295804093166113)
,p_db_column_name=>'EVENT_QUEUE_OWNER'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Event Queue Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619295913719166113)
,p_db_column_name=>'EVENT_QUEUE_NAME'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Event Queue Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296031026166113)
,p_db_column_name=>'EVENT_QUEUE_AGENT'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Event Queue Agent'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296105540166113)
,p_db_column_name=>'EVENT_CONDITION'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Event Condition'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296211650166114)
,p_db_column_name=>'EVENT_RULE'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Event Rule'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296331450166114)
,p_db_column_name=>'END_DATE'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'End Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296403147166114)
,p_db_column_name=>'JOB_CLASS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Job Class'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296508234166114)
,p_db_column_name=>'ENABLED'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Enabled'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1351993194329853612)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296610013166114)
,p_db_column_name=>'AUTO_DROP'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Auto Drop'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296702820166115)
,p_db_column_name=>'RESTARTABLE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Restartable'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296816948166115)
,p_db_column_name=>'STATE'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'State'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1352009278507904884)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619296914488166115)
,p_db_column_name=>'JOB_PRIORITY'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Job Priority'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297025922166115)
,p_db_column_name=>'RUN_COUNT'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Run Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297119343166115)
,p_db_column_name=>'MAX_RUNS'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Maximum Runs'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297214556166116)
,p_db_column_name=>'FAILURE_COUNT'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Failure Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297316831166116)
,p_db_column_name=>'MAX_FAILURES'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'Maximum Failures'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297404830166116)
,p_db_column_name=>'RETRY_COUNT'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Retry Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297509411166116)
,p_db_column_name=>'LAST_START_DATE'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'Last Start Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297618587166116)
,p_db_column_name=>'LAST_RUN_DURATION'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>'Last Run Duration'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297731109166117)
,p_db_column_name=>'NEXT_RUN_DATE'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'Next Run Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297812228166117)
,p_db_column_name=>'SCHEDULE_LIMIT'
,p_display_order=>37
,p_column_identifier=>'AK'
,p_column_label=>'Schedule Limit'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619297914868166117)
,p_db_column_name=>'MAX_RUN_DURATION'
,p_display_order=>38
,p_column_identifier=>'AL'
,p_column_label=>'Max Run Duration'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298014140166122)
,p_db_column_name=>'LOGGING_LEVEL'
,p_display_order=>39
,p_column_identifier=>'AM'
,p_column_label=>'Logging Level'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298112899166122)
,p_db_column_name=>'STOP_ON_WINDOW_CLOSE'
,p_display_order=>40
,p_column_identifier=>'AN'
,p_column_label=>'Stop on Window Close'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298216218166122)
,p_db_column_name=>'INSTANCE_STICKINESS'
,p_display_order=>41
,p_column_identifier=>'AO'
,p_column_label=>'Instance Stickiness'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298331678166123)
,p_db_column_name=>'RAISE_EVENTS'
,p_display_order=>42
,p_column_identifier=>'AP'
,p_column_label=>'Raise Events'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298425930166123)
,p_db_column_name=>'SYSTEM'
,p_display_order=>43
,p_column_identifier=>'AQ'
,p_column_label=>'System'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298523582166123)
,p_db_column_name=>'JOB_WEIGHT'
,p_display_order=>44
,p_column_identifier=>'AR'
,p_column_label=>'Job Weight'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298624453166123)
,p_db_column_name=>'NLS_ENV'
,p_display_order=>45
,p_column_identifier=>'AS'
,p_column_label=>'NLS Environment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298719871166124)
,p_db_column_name=>'SOURCE'
,p_display_order=>46
,p_column_identifier=>'AT'
,p_column_label=>'Source'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298824989166124)
,p_db_column_name=>'DESTINATION'
,p_display_order=>47
,p_column_identifier=>'AU'
,p_column_label=>'Destination'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619298914276166124)
,p_db_column_name=>'CREDENTIAL_OWNER'
,p_display_order=>48
,p_column_identifier=>'AV'
,p_column_label=>'Credential Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619299021458166124)
,p_db_column_name=>'CREDENTIAL_NAME'
,p_display_order=>49
,p_column_identifier=>'AW'
,p_column_label=>'Credential Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619299116212166124)
,p_db_column_name=>'INSTANCE_ID'
,p_display_order=>50
,p_column_identifier=>'AX'
,p_column_label=>'Instance ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619299203876166125)
,p_db_column_name=>'DEFERRED_DROP'
,p_display_order=>51
,p_column_identifier=>'AY'
,p_column_label=>'Deferred Drop'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619299321227166125)
,p_db_column_name=>'COMMENTS'
,p_display_order=>52
,p_column_identifier=>'AZ'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619299420709166125)
,p_db_column_name=>'FLAGS'
,p_display_order=>53
,p_column_identifier=>'BA'
,p_column_label=>'Flags'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(619299502344166376)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316426424536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'JOB_NAME:ENABLED:STATE:RUN_COUNT:FAILURE_COUNT:RETRY_COUNT:LAST_START_DATE:LAST_RUN_DURATION:NEXT_RUN_DATE'
,p_sort_column_1=>'JOB_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(619290502375143231)
,p_branch_action=>'f?p=&FLOW_ID.:122:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00123
begin
wwv_flow_imp_page.create_page(
 p_id=>123
,p_name=>'Job Details'
,p_alias=>'JOB-DETAILS'
,p_step_title=>'Job Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(619320610324379345)
,p_plug_name=>'Job Details'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Job Details report contains a detailed listing of all of the database jobs associated with &PRODUCT_NAME..',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(619328401632399515)
,p_plug_name=>'Job Details'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>'select * from user_scheduler_job_run_details'
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(619328506946399515)
,p_name=>'Job Details'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619328703645399517)
,p_db_column_name=>'LOG_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Log Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619328802813399517)
,p_db_column_name=>'LOG_DATE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Log Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619328902016399517)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329004665399517)
,p_db_column_name=>'JOB_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Job Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329131960399517)
,p_db_column_name=>'JOB_SUBNAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Job Subname'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329224814399518)
,p_db_column_name=>'STATUS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329327897399518)
,p_db_column_name=>'ERROR#'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Error Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329422639399518)
,p_db_column_name=>'REQ_START_DATE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Requested Start Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329512301399518)
,p_db_column_name=>'ACTUAL_START_DATE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Actual Start Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329602367399518)
,p_db_column_name=>'RUN_DURATION'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Run Duration'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329724251399519)
,p_db_column_name=>'INSTANCE_ID'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Instance ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329818078399519)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Session ID'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619329917351399519)
,p_db_column_name=>'SLAVE_PID'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Slave PID'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619330022964399519)
,p_db_column_name=>'CPU_USED'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'CPU Used'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619330130204399519)
,p_db_column_name=>'DESTINATION'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Destination'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619330222156399520)
,p_db_column_name=>'ADDITIONAL_INFO'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Additional Information'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(619330324536399766)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316531874536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DATE:JOB_NAME:STATUS:ERROR#:REQ_START_DATE:ACTUAL_START_DATE:RUN_DURATION:CPU_USED:ADDITIONAL_INFO'
,p_sort_column_1=>'LOG_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(619327605091379390)
,p_branch_action=>'f?p=&FLOW_ID.:123:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00124
begin
wwv_flow_imp_page.create_page(
 p_id=>124
,p_name=>'Automatic File Delete Log'
,p_alias=>'AUTOMATIC-FILE-DELETE-LOG'
,p_step_title=>'Automatic File Delete Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784309333645873)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(161574730450240735)
,p_plug_name=>'Automatic File Delete Log'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Automatic File Delete Log contains a listing of those files removed by the daily maintenance job.',
'This process is controlled in Instance Settings in Administration Services.'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(161574904734240739)
,p_plug_name=>'Automatic File Delete Log'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(161978910035273483)
,p_plug_name=>'Automatic File Delete Log'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>'select * from wwv_flow_auto_file_delete_log'
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(161979018152273483)
,p_name=>'Automatic File Delete Log'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(161979204270273485)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(161979315225273485)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(161979425537273485)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(161979510903273485)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'File Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(161979602399273485)
,p_db_column_name=>'FILE_TYPE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'File Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(164450631905355420)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(161979701670273485)
,p_db_column_name=>'FILE_SIZE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'File Size (bytes)'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(161979807752273485)
,p_db_column_name=>'DELETED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Date File Deleted'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(161979923095273485)
,p_db_column_name=>'WORKSPACE_DISPLAY_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Workspace Display Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(161980008445273485)
,p_db_column_name=>'FILE_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'File ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(161994825310273648)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316611501536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:WORKSPACE_DISPLAY_NAME:FILE_NAME:FILE_TYPE:FILE_SIZE:DELETED_ON'
,p_sort_column_1=>'DELETED_ON'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(161575123049240741)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(161574904734240739)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:RIR,124::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(161575307016240741)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(161574904734240739)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Truncate'
,p_button_position=>'CREATE'
,p_confirm_message=>'Do you really want to truncate the Automatic File Delete Log?'
,p_confirm_style=>'danger'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(161578102866240779)
,p_branch_action=>'f?p=&FLOW_ID.:124:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(161577605948240778)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_auto_file_delete_log;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating Automatic File Delete Log.'
,p_process_when_button_id=>wwv_flow_imp.id(161575307016240741)
,p_process_success_message=>'Successfully truncated Automatic File Delete Log.'
,p_internal_uid=>161577605948240778
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(161577812626240778)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(161575123049240741)
,p_internal_uid=>161577812626240778
);
end;
/
prompt --application/pages/page_00125
begin
wwv_flow_imp_page.create_page(
 p_id=>125
,p_name=>'Push Notifications Queue'
,p_alias=>'PUSH-NOTIFICATIONS-QUEUE'
,p_step_title=>'Push Notifications Queue'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1989164288839293)
,p_plug_name=>'Push Notifications Queue'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select pq.id,',
'       pq.flow_id,',
'       pq.security_group_id,',
'       ( select ps.user_name ',
'           from wwv_flow_push_subscriptions$ ps',
'          where ps.security_group_id = pq.security_group_id',
'            and ps.flow_id           = pq.flow_id',
'            and ps.id                = pq.push_subscription_id ) user_name,',
'       pq.title,',
'       pq.body,',
'       pq.icon_url,',
'       pq.target_url,',
'       pq.send_attempts_count,',
'       pq.error_message,',
'       pq.created_on,',
'       pq.created_by,',
'       pq.last_updated_on,',
'       pq.last_updated_by',
'  from wwv_flow_push_queue pq'))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_page_header=>'Push Notifications Queue'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1741956656494512)
,p_name=>'USER_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'USER_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'User Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1990472358839306)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_enable_hide=>true
,p_is_primary_key=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1990908040839308)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_label=>'Actions'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>20
,p_value_alignment=>'CENTER'
,p_use_as_row_header=>false
,p_enable_hide=>true
,p_is_primary_key=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1991959325839315)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_enable_filter=>false
,p_use_as_row_header=>false
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1992932934839317)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Application'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>50
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1993951780839319)
,p_name=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Workspace'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(832231721829846651)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1995930412839323)
,p_name=>'TITLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TITLE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Title'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1996956813839325)
,p_name=>'BODY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BODY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Body'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1997914656839326)
,p_name=>'ICON_URL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ICON_URL'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Icon URL'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1998912778839329)
,p_name=>'TARGET_URL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TARGET_URL'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Target URL'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1999924464839331)
,p_name=>'SEND_ATTEMPTS_COUNT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEND_ATTEMPTS_COUNT'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Send Attempts'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2000951400839333)
,p_name=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ERROR_MESSAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Error Message'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2001904541839335)
,p_name=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Created On'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2002969367839336)
,p_name=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Created By'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2003961303839338)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Last Updated On'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2004945333839339)
,p_name=>'LAST_UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Last Updated By'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(1989672775839297)
,p_internal_uid=>1989672775839297
,p_is_editable=>true
,p_edit_operations=>'d'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No push notifications in the queue.'
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>true
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(1990033630839299)
,p_interactive_grid_id=>wwv_flow_imp.id(1989672775839297)
,p_static_id=>'19901'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(1990208355839300)
,p_report_id=>wwv_flow_imp.id(1990033630839299)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1009908021241)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(1741956656494512)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>95.85159999999999
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1991326549839310)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(1990908040839308)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>40
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1992313160839316)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(1991959325839315)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1993350748839318)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(1992932934839317)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>94
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1994368869839319)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(1993951780839319)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>99.8516
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1996302072839324)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(1995930412839323)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>228
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1997325837839325)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(1996956813839325)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>281
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1998365695839328)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(1997914656839326)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1999380251839329)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(1998912778839329)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2000315306839332)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(1999924464839331)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2001345466839333)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(2000951400839333)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2002373321839335)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(2001904541839335)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2003391803839338)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(2002969367839336)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2004329194839339)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(2003961303839338)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2005311339839340)
,p_view_id=>wwv_flow_imp.id(1990208355839300)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(2004945333839339)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51470107143834881)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52294626256137175)
,p_plug_name=>'Push Notifications Queue'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Monitor push notifications in the queue.</p>',
'<p>Remove individual notifications from the queue.</p>',
'<p>Push the queue to trigger sending all pending push notifications.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1742225843494515)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(51470107143834881)
,p_button_name=>'FORCE_PUSH_QUEUE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Force Push Queue'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1742090621494513)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(51470107143834881)
,p_button_name=>'PUSH_QUEUE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Push Queue'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2006635014839352)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1989164288839293)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Push Notifications Queue - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2006635014839352
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1742176141494514)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Push Queue'
,p_process_sql_clob=>'wwv_flow_pwa.push_queue_immediate;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1742090621494513)
,p_internal_uid=>1742176141494514
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1742356781494516)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Force Push Queue'
,p_process_sql_clob=>'wwv_flow_pwa.push_queue_immediate( p_force_yn => ''Y'' );'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1742225843494515)
,p_internal_uid=>1742356781494516
);
end;
/
prompt --application/pages/page_00129
begin
wwv_flow_imp_page.create_page(
 p_id=>129
,p_name=>'Interactive Report Subscriptions'
,p_alias=>'INTERACTIVE-REPORT-SUBSCRIPTIONS'
,p_step_title=>'Interactive Report Subscriptions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(274054417366299775)
,p_plug_name=>'Interactive Report Subscriptions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1, n.id, null,null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'wwv_flow_lang.system_message(''IR_SUBSCRIPTION_LABEL'',i.flow_id,i.page_id,n.owner))||wwv_flow_item.hidden(2,n.id)||wwv_flow_item.hidden(3,n.security_group_id) id,',
'i.flow_id nflow_id,',
'i.page_id npage_id,',
'region_id nregion_id,',
'(select short_name from wwv_flow_companies c where c.provisioning_company_id = n.security_group_id) workspace,',
'(select plug_name from wwv_flow_page_plugs where id = i.region_id) region_name,',
'n.owner    application_user,',
'n.language language,',
'decode(n.download_format,',
'    ''XLSX'',''Excel'',',
'    n.download_format) download_format,',
'decode(n.strip_rich_text,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) strip_rich_text,',
'decode(n.data_only,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no,',
'    m.m_no) data_only,',
'decode(n.pdf_page_size,',
'    ''A3'',m.m_a3,',
'    ''A4'',m.m_a4,',
'    ''LEGAL'',m.m_legal,',
'    ''LETTER'',m.m_letter,',
'    ''CUSTOM'',m.m_custom,',
'    ''TABLOID'',m.m_tabloid,',
'    pdf_page_size) pdf_page_size,',
'decode(n.pdf_page_orientation,',
'    ''VERTICAL'',m.m_vertical,',
'    ''HORIZONTAL'',m.m_horizontal,',
'    pdf_page_orientation) pdf_page_orientation,',
'decode(n.pdf_accessible,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) pdf_accessible,',
'decode(n.skip_no_data_found,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) skip_no_data_found,',
'n.start_date at time zone sessiontimezone start_date,',
'n.end_date at time zone sessiontimezone end_date,',
'case when nvl(n.end_date,systimestamp) >= systimestamp then',
'    n.offset_date',
'end offset_date,',
'n.notify_interval,',
'n.status,',
'n.notify_error,',
'n.email_from,',
'n.email_address,',
'n.created_by,',
'n.created_on,',
'case when :flow_security_group_id!=10 and i.flow_id between 4000 and 4999 then',
'  null',
'else',
'  ''f?p=4000:1:''||:app_session||''::NO:RP:FB_FLOW_ID,F4000_P1_FLOW:''||i.flow_id||'',''||i.flow_id',
'end application_link,',
'case when :flow_security_group_id!=10 and i.flow_id between 4000 and 4999 then',
'  null',
'else',
'  ''f?p=4000:4150:''||:app_session||''::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:''||i.flow_id||'',''||i.page_id',
'end page_link',
'from wwv_flow_worksheet_notify n,',
'wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'(select ',
'       wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'       wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_VERTICAL'') m_vertical,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_HORIZONTAL'') m_horizontal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A3'') m_a3,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A4'') m_a4,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LEGAL'') m_legal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LETTER'') m_letter,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_CUSTOM'') m_custom,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_TABLOID'') m_tabloid',
'from dual) m',
'where n.worksheet_id = i.id',
'and n.report_id = r.id',
'and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(274054523343299775)
,p_name=>'Interactive Report Subscriptions'
,p_max_row_count=>'100000'
,p_max_row_count_message=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:EMAIL'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>274054523343299775
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274054732028299777)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274054819621299777)
,p_db_column_name=>'NFLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274054901224299778)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055025754299778)
,p_db_column_name=>'NREGION_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Region ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055118775299778)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055229007299778)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Subscribed By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055301825299778)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055406365299778)
,p_db_column_name=>'START_DATE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Start Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055514662299778)
,p_db_column_name=>'END_DATE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'End Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055626342299778)
,p_db_column_name=>'OFFSET_DATE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Offset Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055724675299778)
,p_db_column_name=>'NOTIFY_INTERVAL'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Frequency'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(274103227902682659)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055809517299778)
,p_db_column_name=>'STATUS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(294656516286709966)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274055924639299779)
,p_db_column_name=>'NOTIFY_ERROR'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274056003214299779)
,p_db_column_name=>'EMAIL_FROM'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Email From'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274056114231299779)
,p_db_column_name=>'EMAIL_ADDRESS'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Email To'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274056200590299779)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274056325676299779)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274056415876299779)
,p_db_column_name=>'APPLICATION_LINK'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Application Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274056507071299779)
,p_db_column_name=>'PAGE_LINK'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Page Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(274100414545640594)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802595409307223)
,p_db_column_name=>'DOWNLOAD_FORMAT'
,p_display_order=>31
,p_column_identifier=>'V'
,p_column_label=>'Format'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802651518307224)
,p_db_column_name=>'STRIP_RICH_TEXT'
,p_display_order=>41
,p_column_identifier=>'W'
,p_column_label=>'Strip Rich Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802744628307225)
,p_db_column_name=>'DATA_ONLY'
,p_display_order=>51
,p_column_identifier=>'X'
,p_column_label=>'Data Only'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802814708307226)
,p_db_column_name=>'PDF_PAGE_SIZE'
,p_display_order=>61
,p_column_identifier=>'Y'
,p_column_label=>'Pdf Page Size'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802904468307227)
,p_db_column_name=>'PDF_PAGE_ORIENTATION'
,p_display_order=>71
,p_column_identifier=>'Z'
,p_column_label=>'Pdf Page Orientation'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3803077226307228)
,p_db_column_name=>'PDF_ACCESSIBLE'
,p_display_order=>81
,p_column_identifier=>'AA'
,p_column_label=>'Pdf Accessible'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4162727686589922)
,p_db_column_name=>'SKIP_NO_DATA_FOUND'
,p_display_order=>91
,p_column_identifier=>'AB'
,p_column_label=>'Skip if No Data Found'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(274101128679663957)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'2741012'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:WORKSPACE:NFLOW_ID:NPAGE_ID:REGION_NAME:APPLICATION_USER:NOTIFY_INTERVAL:EMAIL_ADDRESS:CREATED_ON:CREATED_BY:STATUS:DOWNLOAD_FORMAT'
,p_sort_column_1=>'CREATED_ON'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1199225378493189312)
,p_plug_name=>'Subscriptions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'This report displays subscriptions created by end users using Interactive reports in the instance.  Subscriptions can be deleted.'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(274096506831583379)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(274054417366299775)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.:129,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(274100010016611306)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(274054417366299775)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(274118217644806344)
,p_branch_action=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(274100010016611306)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(274117516362791706)
,p_validation_name=>'must select subscription to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Subscription must be selected to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(274100010016611306)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199174726823878423)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(274054417366299775)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199174894473878424)
,p_event_id=>wwv_flow_imp.id(1199174726823878423)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(274117809866800453)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_delete_list varchar2(32767);',
'begin',
'    l_delete_list := wwv_flow_utilities.table_to_string(wwv_flow.g_f01);',
'    -- loop through hidden subscription id, if found in delete list, delete',
'    for i in 1..wwv_flow.g_f02.count',
'    loop',
'        if instr(l_delete_list,wwv_flow.g_f02(i),1) > 0 then',
'            wwv_flow_ir.builder_delete_subscription (',
'                p_workspace_id        => wwv_flow.g_f03(i),',
'                p_subscription_id     => wwv_flow.g_f02(i) );',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to remove subscription.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(274100010016611306)
,p_process_success_message=>'The subscription(s) removed.'
,p_internal_uid=>274117809866800453
);
end;
/
prompt --application/pages/page_00130
begin
wwv_flow_imp_page.create_page(
 p_id=>130
,p_name=>'Security'
,p_alias=>'SECURITY'
,p_step_title=>'Security'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766702444596508)
,p_step_template=>wwv_flow_imp.id(704456563630760825)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_config_sec.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15278408311776983)
,p_plug_name=>'Session Timeout'
,p_region_name=>'sessiontimeout'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19444600150915683)
,p_plug_name=>'HTTP Protocol'
,p_region_name=>'HTTPS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Warning:</strong>',
'<em>Require HTTPS</em> will make &PRODUCT_NAME. unreachable by the HTTP protocol.',
'Before enabling this setting, ensure that the HTTPS protocol is enabled and configured correctly on your server.'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46267619456679028)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(195775112470763477)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47633503888931997)
,p_plug_name=>'Security'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47634100990931998)
,p_plug_name=>'Security'
,p_region_name=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Configure service level security settings typically used to lock down a production service.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47634329213931998)
,p_plug_name=>'Password Policy'
,p_region_name=>'P'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Manage password policy for &PRODUCT_NAME. users (workspace administrators, developers, and end users) in all workspaces.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(73979710971500445)
,p_plug_name=>'Start Div'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_source=>'<div id="ContentArea" style="display:none;">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(73979900344500446)
,p_plug_name=>'End Div'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>180
,p_plug_source=>'</div>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91386804125361972)
,p_plug_name=>'Region and Web Service Excluded Domains'
,p_region_name=>'U'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(125782409759878809)
,p_plug_name=>'Real Application Security'
,p_region_name=>'RAS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(495347036629866231)
,p_plug_name=>'Authentication Control'
,p_region_name=>'LOGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16335907971250620)
,p_plug_name=>'General Settings'
,p_region_name=>'SETTINGS'
,p_parent_plug_id=>wwv_flow_imp.id(495347036629866231)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>150
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Manage security settings for developer and end user login.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47634507195931998)
,p_plug_name=>'Development Environment Settings'
,p_region_name=>'G'
,p_parent_plug_id=>wwv_flow_imp.id(495347036629866231)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Manage security settings for workspace administrator and workspace developer accounts.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(155891929306865755)
,p_name=>'Development Environment Authentication Schemes'
,p_parent_plug_id=>wwv_flow_imp.id(495347036629866231)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>170
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_auth.id,',
'       trunc(display_auth.id) base_id,',
'       display_auth.name,',
'       help_text description,',
'       case active_auth.scheme_type',
'         when display_auth.scheme_type then consts.is_current',
'         else consts.not_current',
'       end is_current',
'  from wwv_flow_authentications display_auth,',
'       ( select active_auth.id,',
'                active_auth.flow_id,',
'                active_auth.scheme_type',
'           from wwv_flow_authentications active_auth,',
'                wwv_flows f',
'          where f.security_group_id      = 10',
'            and f.id                     = 4050',
'            and active_auth.id                = f.authentication_id',
'            and active_auth.security_group_id = f.security_group_id ) active_auth,',
'       ( select wwv_flow_lang.system_message(''CURRENT'') is_current,',
'                wwv_flow_lang.system_message(''NOT_CURRENT'') not_current,',
'                nvl(wwv_flow_lang.get_translated_application_id, 4050) translated_flow_id',
'           from sys.dual ) consts',
' where display_auth.security_group_id = 10',
'   and display_auth.flow_id           = consts.translated_flow_id',
'   and trunc(display_auth.id)         <> active_auth.id',
'   and display_auth.scheme_type       not like ''%CLOUD_IDM''',
'   and ( display_auth.scheme_type not like ''%.SSO''',
'         or exists ( select null',
'                       from sys.user_objects',
'                      where object_type = ''PACKAGE''',
'                        and object_name = ''WWV_FLOW_CUSTOM_AUTH_SSO'' ))',
'   and ( display_auth.scheme_type not like ''%.SAML''',
'         or (select wwv_flow_public_key_util.is_supported_yn from sys.dual)=''Y'' )',
' order by display_auth.name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(155892215448865778)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'<span class="u-VisuallyHidden">&EDIT.</span>'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:136:&SESSION.::&DEBUG.::P136_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit" aria-hidden="true"></span>'
,p_column_link_attr=>'aria-label="&EDIT." class="a-Button"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(155892315338865782)
,p_query_column_id=>2
,p_column_alias=>'BASE_ID'
,p_column_display_sequence=>2
,p_column_heading=>'BASE_ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(155892418427865782)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(155892520999865782)
,p_query_column_id=>4
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>4
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(155896407785993308)
,p_query_column_id=>5
,p_column_alias=>'IS_CURRENT'
,p_column_display_sequence=>5
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(517218991177696240)
,p_plug_name=>'Workspace Isolation'
,p_region_name=>'Q'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Configure isolation and resource limitation default values for all workspaces.',
'Override these default values at workspace level.'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617449319814764841)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Manage settings that apply to the entire &PRODUCT_NAME. instance.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(799822118800262985)
,p_plug_name=>'Security Second Level Tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_imp.id(799821322334262935)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(169533626431592276)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47636632210932000)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47633503888931997)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47636805241932002)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47633503888931997)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168522406143945325)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1405441760336501)
,p_name=>'P130_SESSION_TIMEOUT_WARN_SEC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(15278408311776983)
,p_prompt=>'Session Timeout Warning in Seconds'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS_SMALL'
,p_lov=>'.'||wwv_flow_imp.id(1501535454230180)||'.'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The session timeout warning time defines (in seconds) how long before a session times out (either maximum session length, or maximum session idle time), to warn the user. For the maximum session idle time warning, the user will have the opportunit'
||'y to extend the session. For maximum session length warning, the user will be prompted to save any work, to avoid loss of data when the session maximum time is reached.</p>',
'<p>Note: This setting is superseded by the corresponding workspace level setting and application level setting.</p>',
'<p>',
'<ul>',
'    <li>Enter a positive integer to control the warning time for sessions used by applications in this &PRODUCT_NAME. instance.</li>',
'    <li>Enter 0 to switch off session timeout warnings.</li>',
'    <li>Leave the value empty in order to revert to the default value of 5 minutes (300 seconds).</li>',
'</ul>  ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1706073863756301)
,p_name=>'P130_AI_BUILDER_PROXY'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_prompt=>'App Builder Proxy for AI Services'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this field to specify a proxy server to be used by Generative AI Services in App Builder.</p>',
'<p>If no proxy server is configured for the Generative AI Services used in App Builder, the Instance Proxy of &PRODUCT_NAME. is used.</p>',
'<p>Example:</p>',
'<ul>',
'    <li><code>http://www-proxy.example.com</code></li>',
'    <li><code>http://www-proxy.example.com:8080</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1716130266659201)
,p_name=>'P130_AI_IS_ENABLED'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_item_default=>'Y'
,p_prompt=>'AI Enabled'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to enabled the usage of AI Services in this APEX instance. Note that AI Services can further be restricted at Workspace-level.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1800594777884701)
,p_name=>'P130_ALLOW_PERSISTENT_AUTH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_item_default=>'N'
,p_prompt=>'Allow Persistent Auth'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select <strong>Yes</strong> to enable persistent authentication on this instance. With persistent authentication enabled, new applications created as Progressive Web Apps will have a <strong>Remember me</strong> feature on the login page.</p>',
'<p>Select <strong>No</strong> to disable persistent authentication on this instance.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1800636823884702)
,p_name=>'P130_PERS_AUTH_LIFETIME_DAYS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_item_default=>'30'
,p_prompt=>'Persistent Authentication Lifetime Days'
,p_format_mask=>'9990'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Maximum number of days user can login using Persistent Authentication before having to enter credentials again.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2511911448281725)
,p_name=>'P130_DISABLED_APPS_LIST'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_prompt=>'Disabled Apps'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a comma-separated list of application IDs which should be disabled. Example: <strong>100,101,102</strong>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3610136082242201)
,p_name=>'P130_DISABLE_APPS_LOGIN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_item_default=>'N'
,p_prompt=>'Disable Apps Login'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DISABLE_APPS_LOGIN'
,p_lov=>'.'||wwv_flow_imp.id(2284565770730489)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to disable access to all &PRODUCT_NAME. applications. To only disable some applications select <strong>Only for specific Apps</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13778107968094341)
,p_name=>'P130_INSTANCE_PROXY'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_prompt=>'Instance Proxy'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this field to specify a proxy server to be used by the &PRODUCT_NAME. instance.</p>',
'<p>Using a proxy server may be required for REST requests, for instance when REST Data Sources or the <code>APEX_WEB_SERVICE</code> ',
'package is used. If no port is specified, &PRODUCT_NAME. assumes port <strong>80</strong>.</p>',
'<p>This attribute overrides all proxy server settings done on the application level; once ',
'an <em>Instance Proxy</em> is configured, proxy server attributes on the application level have no effect.</p>',
'<p>For example:</p>',
'<ul>',
'    <li><code>http://www-proxy.example.com</code></li>',
'    <li><code>http://www-proxy.example.com:8080</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13778824721108564)
,p_name=>'P130_OUTBOUND_HTTPS'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(19444600150915683)
,p_item_default=>'N'
,p_prompt=>'Require Outbound HTTPS'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'Select <strong>Yes</strong> to require all outbound traffic from an &PRODUCT_NAME. instance to use the HTTPS protocol.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15060228156098057)
,p_name=>'P130_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15278408311776983)
,p_prompt=>'Maximum Session Length in Seconds'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(15314811390892155)||'.'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines how long (in seconds) sessions can exist and be used by applications in this &PRODUCT_NAME. instance. This setting is superseded',
'by the corresponding workspace level setting and application level setting.',
'',
'<ul>',
'    <li>Enter a positive integer to control how long a session can exist.</li>',
'    <li>Enter 0 to have sessions exist indefinitely.</li>',
'    <li>Leave the value empty in order to revert to the default value of 8 hours (28800 seconds).</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15060417898104569)
,p_name=>'P130_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15278408311776983)
,p_prompt=>'Maximum Session Idle Time in Seconds'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(15314811390892155)||'.'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Session Idle Time is the time between the last page request and the next page request. This setting is superseded by the corresponding workspace level setting and application level setting.',
'',
'<ul>',
'    <li>Enter a positive integer to control the default idle time for sessions used by applications in this &PRODUCT_NAME. instance.</li>',
'    <li>Leave the value empty in order to revert to the default value of 1 hour (3600 seconds).</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16337406502269055)
,p_name=>'P130_LOGIN_THROTTLE_DELAY'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(16335907971250620)
,p_prompt=>'Delay after failed login attempts in Seconds'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'After failed logins, &PRODUCT_NAME. will display a countdown of this number times the number of failed login attempts, before it accepts new login attempts with the same username.',
'<p/>',
'Enter 0 to disable the countdown and allow immediate access.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_02=>'99'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18969210051656230)
,p_name=>'P130_REQUIRE_HTTPS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(19444600150915683)
,p_item_default=>'N'
,p_prompt=>'Require HTTPS'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRE_HTTPS'
,p_lov=>'.'||wwv_flow_imp.id(403484377450328143)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Options include:',
'<ul>',
'<li><strong>Always</strong>: Enforces HTTPS for all applications (including the &PRODUCT_NAME. development and administration applications) to require HTTPS.',
'If set to Always, the Strict-Transport-Security Max Age attribute displays. Use this field to specify the time period in seconds during which the browser shall access the server with HTTPS only.</li>',
'<li><strong>Development and Administration</strong>: Forces all internal applications within &PRODUCT_NAME. (that is, App Builder, SQL Workshop, Instance Administration and so on) to require HTTPS.</li>',
'<li><strong>Application specific</strong>: Makes HTTPS dependent on the "Secure" session cookie attribute in the authentication schemes of your applications.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21799626940198644)
,p_name=>'P130_ALLOW_PUBLIC_FILE_UPLOAD'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_item_default=>'N'
,p_prompt=>'Allow Public File Upload'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to permit unauthenticated users to upload files in applications that provide file upload controls. Select <strong>No</strong> to prevent unauthenticated users from uploading files in applications that provide file upload c'
||'ontrols.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47637030913932004)
,p_name=>'P130_WORKSPACE_NAME_USR_COOKIE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_item_default=>'Y'
,p_prompt=>'Set Workspace Cookie'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select <strong>Yes</strong> to enable &PRODUCT_NAME. to save persistent cookies in the browser.',
'Select <strong>No</strong> to prevent persistent cookies from being sent.',
'</p>',
'<p>',
'&PRODUCT_NAME. uses the following persistent cookies:',
'<ul>',
'<li>ORA_WWV_REMEMBER_UN: The development environment login page stores the Workspace and Username data in this cookie. It is used to populate these attributes with default values, when you log in again.</li>        ',
'<li>LOGIN_USERNAME_COOKIE: Customer application login pages use this cookie to store the Username. It is used to populate the attribute with a default value, when customers log in again.</li>    ',
'<li>ORA_WWV_REMEMBER_LANG: When using language selection in the development environment, &PRODUCT_NAME. stores the language and territory in this cookie. It is used to automatically show the application in the selected language when the application i'
||'s used next time.</li>',
'</ul>',
'</p>',
'<p>',
'If your computer has already received these cookies, you can physically remove them from their persistent location on disk using browser tools or system utilities. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47646415366932012)
,p_name=>'P130_DISABLE_ADMIN_LOGIN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_item_default=>'N'
,p_prompt=>'Disable Administrator Login'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select <strong>Yes</strong> to disable administrator access to &PRODUCT_NAME. Administration Services.',
'When Administration Services are disabled, you can only use <code>APEX_INSTANCE_ADMIN</code> API to manage',
'this &PRODUCT_NAME. instance.</p>',
'<p>If you need to restore access to &PRODUCT_NAME. Administration Services, set <code>DISABLE_ADMIN_LOGIN</code>',
'instance parameter to <strong>N</strong> using <code>APEX_INSTANCE_ADMIN.set_parameter</code> API.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47646911123932013)
,p_name=>'P130_RESTRICT_IP_RANGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_prompt=>'Restrict Access by IP Address'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'To restrict access to the &PRODUCT_NAME. development environment and Administration Services to a specific range of IP addresses, enter a comma-delimited list of IP addresses.',
'<p>If necessary, you can use an asterisk (*) as a wildcard, but do not include additional numeric values after wildcard characters. For example, 138.*.41.2 is <i>not</i> a valid value.',
'<p>IP addresses can be entered from one to four levels. For example:  ',
'<ul>',
'<li>141, 141.*</li>',
'<li>192.128.23.1</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47647419618932013)
,p_name=>'P130_DISABLE_WORKSPACE_LOGIN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_item_default=>'N'
,p_prompt=>'Disable Workspace Login'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select <strong>Yes</strong> to disable developer access to &PRODUCT_NAME. applications such as',
'App Builder and SQL Workshop.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47647919390932013)
,p_name=>'P130_ACCOUNT_LIFETIME_DAYS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(47634507195931998)
,p_prompt=>'Account Password Lifetime (days)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a positive integer for the maximum number of days a developer or administrator account password may be used before the account expires. The default value is 45 days.</p>',
'<p>This setting applies to accounts used to access the &PRODUCT_NAME. administration and development environment only. It does not apply to end-user accounts used by applications developed in &PRODUCT_NAME..</p>',
'<p>However, this setting is used as the default workspace-level <strong>End User Account Lifetime</strong> preference, which workspace administrators can change. The workspace-level preference applies to the accounts within that workspace.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47649932493932015)
,p_name=>'P130_USER_MAX_LOGIN_FAILURES'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(47634507195931998)
,p_prompt=>'Maximum Login Failures Allowed'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a positive integer for the maximum number of consecutive unsuccessful authentication attempts allowed before a developer or administrator account is locked. The default value is 4.</p>',
'',
'<p>This setting applies to accounts used to access the &PRODUCT_NAME. administration and development environment.</p>',
'',
'<p>The workspace level <strong>Maximum Login Failures Allowed</strong> preference can be specified to a more specific value.  If both instance-level and workspace-level preferences are specified, the lower of the two values will apply.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47650422637932015)
,p_name=>'P130_EXPIRE_FND_USER_ACCOUNTS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(47634507195931998)
,p_item_default=>'N'
,p_prompt=>'Require User Account Expiration and Locking'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>&PRODUCT_NAME. user account expiration and locking features apply to end-user accounts created using the &PRODUCT_NAME. end-user account management interface.</p>',
'<p>Select <strong>Yes</strong> to enable &PRODUCT_NAME. user account expiration and locking features across all workspaces. This selection prevents the same feature from being disabled at the workspace level.</p>',
'<p>Select <strong>No</strong> to relinquish control to each Workspace administrator.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47650925096932015)
,p_name=>'P130_PW_MIN_LENGTH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_prompt=>'Minimum Password Length'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>3
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a number to set a minimum character length for passwords for workspace administrator, developer, and end user accounts.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47651414651932016)
,p_name=>'P130_PW_ONE_NUMERIC'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'N'
,p_prompt=>'Must Contain At Least One Numeric Character'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to require that workspace administrator, developer, and end user account passwords contain at least one Arabic numeric character (for example, 0,1,2,3,4,5,6,7,8,9).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47651903529932016)
,p_name=>'P130_PW_ALPHA_CHARS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ '
,p_prompt=>'Alphabetic Characters'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>2
,p_cAttributes=>'nowrap="nowrap"'
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter new or edit the existing alphabetic characters. This is the set of characters used in password validations involving alphabetic characters. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47652625102932017)
,p_name=>'P130_PW_NOT_LIKE_USERNAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'N'
,p_prompt=>'Must Not Contain Username'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to prevent workspace administrator, developer, and end user account passwords from containing the username.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47653123193932018)
,p_name=>'P130_PW_ONE_LOWER_CASE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'N'
,p_prompt=>'Must Contain At Least One Lower Case Character'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to require that workspace administrator, developer, and end user account passwords contain at least one lowercase alphabetic character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47653613129932018)
,p_name=>'P130_PW_ONE_ALPHA'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'N'
,p_prompt=>'Must Contain At Least One Alphabetic Character'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to require that workspace administrator, developer, and end user account passwords contain at least one alphabetic character as specified in the Alphabetic Characters field below.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47654118447932018)
,p_name=>'P130_PW_NEW_DIFFERS_BY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_prompt=>'Minimum Password Differences'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the number of differences required between old and new passwords. The passwords are compared character by character, and each difference that occurs in any position counts toward the required minimum difference. ',
'<p>This setting applies to accounts for workspace administrators, developers, and end users. '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47654617743932018)
,p_name=>'P130_PW_ONE_PUNCTUATION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'N'
,p_prompt=>'Must Contain At Least One Punctuation Character'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to require that workspace administrator, developer, and end user account passwords contain at least one punctuation character as specified in the Punctuation Characters field below.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47655120422932019)
,p_name=>'P130_PW_PUNCTUATION_CHARS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'!"#$%&()``*+,-/:;<=>?_'
,p_prompt=>'Punctuation Characters'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>25
,p_cMaxlength=>2000
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter new or edit existing punctuation characters. This is the set of characters used in password validations involving punctuation characters.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47655613669932019)
,p_name=>'P130_PW_ONE_UPPER_CASE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'N'
,p_prompt=>'Must Contain At Least One Upper Case Character'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to require that workspace administrator, developer, and end user account passwords contain at least one uppercase alphabetic character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47656132356932019)
,p_name=>'P130_PW_NOT_LIKE_WS_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'N'
,p_prompt=>'Must Not Contain Workspace Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to prevent workspace administrator, developer, and end user account passwords from containing the workspace name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47656601012932020)
,p_name=>'P130_PW_NOT_LIKE_WORDS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'oracle:hello:welcome:guest:user:database'
,p_prompt=>'Must Not Contain'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter words, separated by colons, that workspace administrator, developer, and end user account passwords must not contain. These words may not appear in the password in any combination of upper- or lowercase. ',
'<p>This feature improves security by preventing the creation of simple, easy-to-guess passwords based on words like "hello", "guest", "welcome", and so on.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47657120063932020)
,p_name=>'P130_STRONG_SITE_ADMIN_PWD'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_item_default=>'N'
,p_prompt=>'Service Administrator Password Policy'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SITE ADMIN PASSWORD OPTION'
,p_lov=>'.'||wwv_flow_imp.id(25698924524085246)||'.'
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a password policy for &PRODUCT_NAME. service administrators:<br/>',
'<ul>',
'<li><strong>Use policy specified in Workspace Password Policy</strong> - Applies the password rules specified above in Workspace Password Policy to service administrator passwords.</li>',
'<li><strong>Use default strong password policy</strong> - Requires that service administrator passwords meet these restrictions:</li>',
'<ul>',
'<li>consist of at least six characters</li>',
'<li>contain at least one lowercase alphabetic character, one uppercase alphabetic character, one numeric digit, and one punctuation character</li>',
'<li>cannot include the username</li>',
'<li>cannot include the word "internal"</li>',
'<li>cannot contain any words shown in the Must Not Contain field specified above in Workspace Password Policy</li>',
'</ul>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(91387829059369221)
,p_name=>'P130_BAD_URLS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(91386804125361972)
,p_prompt=>'Domain Must Not Contain'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter domains (not including the port), separated by colons, that should not be allowed in regions of type URL or accessed as a web service. For example:',
'<pre>example.com:example.net:example.org</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(125785225487919808)
,p_name=>'P130_ALLOW_RAS'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(125782409759878809)
,p_item_default=>'N'
,p_prompt=>'Allow Real Application Security'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select <strong>Yes</strong> to enable Real Application Security support for applications.',
'If Real Application Security is configured in an application''s authentication scheme,',
'&PRODUCT_NAME. creates a Real Application Security session for a new &PRODUCT_NAME. session and automatically',
'attaches to it.',
'<p/>',
'Select <strong>No</strong> to disable Real Application Security.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(182544230023543041)
,p_name=>'P130_BUILDER_AUTH'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(47634507195931998)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Workspace Authentication Scheme'
,p_source=>'wwv_flow_authentication_dev.get_internal_scheme_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ACCESSIBILITY_MODE'
,p_lov=>'.'||wwv_flow_imp.id(1141279207071321310)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'The current authentication scheme for &PRODUCT_NAME. Administration Services and the &PRODUCT_NAME. development environment.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(182581525998551347)
,p_name=>'P130_SSO_LOGOUT_URL'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(16335907971250620)
,p_prompt=>'Single Sign-On Logout URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the URL &PRODUCT_NAME. redirects to in order to trigger a logout from the Single Sign-On server.',
'&PRODUCT_NAME. automatically appends "?p_done_url=...login url...".',
'</p>',
'<p>Example:</p>',
'<pre>https://login.example.com/pls/orasso/orasso.wwsso_app_admin.ls_logout</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(244018932039989237)
,p_name=>'P130_LOGIN_THROTTLE_METHODS'
,p_is_required=>true
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(16335907971250620)
,p_prompt=>'Method for computing the Delay'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOGIN THROTTLE METHODS'
,p_lov=>'.'||wwv_flow_imp.id(244019724554013154)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select a method for computing the delay for failed logins.',
'The computation methods are based on recent data in the Login Access Log.',
'</p>',
'',
'<ul>',
'<li><em>Username and Client IP Address</em>:',
'Count failed login attempts from the same user and the same client IP address.',
'This method can prevent password guessing of the same username from the same client.',
'It is the least restrictive method.',
'</li>',
'',
'<li><em>Username</em>:',
'Count failed login attempts from the same user, independent of the client IP address.',
'This method can prevent password guessing of the same username, independent of the client.',
'</li>',
'',
'<li><em>Client IP Address</em>:',
'Count failed login attempts from the client IP address, independent of the username.',
'This method can prevent password guessing of different usernames from the same client.',
'</li>',
'',
'<li><em>Username or Client IP Address</em>:',
'Compute both failed login attempts by <em>Username</em> and failed login attempts by <em>Client IP Address</em>,',
'then take the maximum.',
'This is the most restrictive method.',
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(245896310903818453)
,p_name=>'P130_INBOUND_PROXIES'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(16335907971250620)
,p_prompt=>'Inbound Proxy Servers'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a comma-separated list of IP addresses for well-known proxy servers, through which requests come in.',
'&PRODUCT_NAME. uses this list to compute the actual client address from the HTTP Headers <em>X-Forwarded-For</em> and <em>REMOTE_ADDR</em>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366798407533246711)
,p_name=>'P130_PASSWORD_HASH_FUNCTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(47634329213931998)
,p_prompt=>'Password Hash Function'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'HASH_FUNCTION'
,p_lov=>'.'||wwv_flow_imp.id(366796514610241309)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Most Secure'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a hash function that &PRODUCT_NAME. uses to generate one way hash strings for workspace user passwords.',
'<p/>',
'The <strong>SHA-2</strong> algorithms are only supported on RDBMS 12c or above.',
'<strong>Most Secure</strong> automatically selects the most secure algorithm available and is the recommended setting.',
'On 12c or above, this evaluates to <strong>SHA-2, 512 bit</strong> and on 11g,',
'<strong>SHA-1</strong> is the most secure algorithm.',
'The <strong>MD5</strong> algorithm is deprecated and should not be used anymore.',
'<p/>',
'If you need to export workspace users on 12c and import them on a 11g database,',
'this setting should be lowered to <strong>SHA-1</strong>.',
'Otherwise, the hash values can not be verified on 11g.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(367947311075071643)
,p_name=>'P130_CHECKSUM_HASH_FUNCTION'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_prompt=>'Checksum Hash Function'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'HASH_FUNCTION'
,p_lov=>'.'||wwv_flow_imp.id(366796514610241309)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Most Secure'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a hash function that &PRODUCT_NAME. uses to generate one way hash strings for checksums.',
'<p/>',
'The <strong>SHA-2</strong> algorithms are only supported on Oracle Database 12<em>c</em> or later.',
'<strong>Most Secure</strong> automatically selects the most secure algorithm available. Therefore, Oracle recommends this setting.',
'On Oracle Database 12<em>c</em> or later, this evaluates to <strong>SHA-2, 512 bit</strong> and on Oracle Database 11<em>g</em>,',
'<strong>SHA-1</strong> is the most secure algorithm.',
'Since the <strong>MD5</strong> algorithm is deprecated, Oracle does not recommend this setting.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(384790103050553247)
,p_name=>'P130_REJOIN_EXISTING_SESSIONS'
,p_is_required=>true
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_prompt=>'Rejoin Sessions'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REJOIN_EXISTING_SESSIONS'
,p_lov=>'.'||wwv_flow_imp.id(492748357556507488)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this attribute to control if &PRODUCT_NAME. should support application URLs that do not contain session IDs.',
'When rejoin sessions is enabled, &PRODUCT_NAME. will attempt to use the session cookie to join an existing session, when a URL does not contain a session ID.',
'</p>',
'<p>Possible values include:',
'</p>',
'<ul>',
'    <li><strong>Disabled</strong>: ',
'      If the URL does not contain a session ID &PRODUCT_NAME. creates a new session.',
'    </li>',
'    <li><strong>Enabled for Public Sessions</strong>: ',
'      If the URL goes to a public page and does not contain a session ID &PRODUCT_NAME. attempts to utilize the existing session cookie established for that application.',
'      For applications with both public and authenticated pages, a session ID is defined after the end user authenticates. ',
'      &PRODUCT_NAME. only joins via the cookie when the session is not yet authenticated.',
'    </li>',
'    <li><strong>Enabled for All Sessions</strong>: ',
'      If the URL does not contain a session ID &PRODUCT_NAME. attempts to utilize the existing session cookie established for that application, providing the following conditions are met:',
'      <ul>',
'        <li>Session State Protection is enabled for the application and the URL includes a valid checksum. ',
'        For public bookmarks, the most restrictive item level protection must be either <em>Unrestricted</em> or <em>Checksum Required - Application Level</em>.</li>',
'        <li>OR, the URL does not contain payload (a request parameter, clear cache or data value pairs).</li>',
'      </ul>',
'      This setting also requires that <em>Embed In Frames</em> is set to <em>Allow from same origin</em> or to <em>Deny</em> for the application.',
'    </li>',
'</ul>',
'<p><em><strong>Note:</em></strong> Enabling rejoin sessions exposes your application to possible security breaches, ',
'  as it can enable attackers to take over existing end user sessions. ',
'To learn more, see the <em>Rejoin Sessions</em> sections in "Managing Application Security" in the App Builder User''s Guide.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(402391282626267518)
,p_name=>'P130_HTTP_STS_MAX_AGE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(19444600150915683)
,p_prompt=>'Strict-Transport-Security Max Age'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the time period in seconds during which the browser shall access the server with HTTPS only.',
'If you specify a value greater than 0,',
'&PRODUCT_NAME. sends the HTTP header',
'<pre>',
'  Strict-Transport-Security: max-age=NNN',
'</pre>',
'on each response, where NNN is the time period given in this attribute.',
'The header tells browsers which support it to always request pages of this host via HTTPS,',
'for the given time period.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(402398009003374821)
,p_name=>'P130_HTTP_RESPONSE_HEADERS'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(19444600150915683)
,p_prompt=>'HTTP Response Headers'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter additional HTTP response headers that &PRODUCT_NAME. should send on each request, for all applications.',
'Developers can specify additional headers at application level.',
'Each header has to start on a new line.',
'Note that support for various headers differs between browsers.',
'</p>',
'<p>',
'One important security related header is <code>Content-Security-Policy</code>. Sending this header can significantly reduce the risk of cross site scripting (XSS) and related attacks. Here is an example:',
'<pre>',
'  Content-Security-Policy: default-src ''self'' ''unsafe-inline'' ''unsafe-eval'' #CDN#; object-src ''self''; img-src ''self'' data:;',
'</pre>',
'Note that &PRODUCT_NAME. generates inline JavaScript and CSS so the policy value needs to allow these. &PRODUCT_NAME. automatically replaces the string <code>#CDN#</code> with a space separated list of supported content delivery networks.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(517219119539696241)
,p_name=>'P130_ALLOW_HOSTNAMES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(517218991177696240)
,p_prompt=>'Allow Hostnames'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>255
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter a comma separated list of hostnames that can be used to access this instance.',
'This attribute can be used to specify which DNS aliases of the web server can be used',
'with applications.',
'You can configure more specific values that override this one at workspace level.',
'If you enter one or more hostnames,',
'the incoming HTTP request URL''s hostname part must match one of the listed hostnames.',
'</p>',
'<p>',
'For example, you can register the DNS alias "hr.example.com" for your web server "www.example.com".',
'The instance value of <em>Allowed Hostnames</em> can be set to "www.example.com".',
'If you then set the HR workspace''s <em>Allow Hostnames</em> to "hr.example.com",',
'users have to access HR applications via "hr.example.com" and all other applications of',
'this instance via "www.example.com".',
'With this configuration, the browser''s <strong>Same Origin security policy</strong>',
'provides a client-side barrier between HR applications',
'and other applications of the instance, which run in another browser tab or window.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(517219667745696245)
,p_name=>'P130_RM_CONSUMER_GROUP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(517218991177696240)
,p_prompt=>'Resource Consumer Group'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Database Resource Manager consumer group to be used for all page events on the instance.',
'You can configure more specific values that override this one at workspace level.',
'At the beginning of every request, the &PRODUCT_NAME. engine switches the current consumer group of the current',
'database session to the consumer group that is defined at workspace or instance level.',
'This applies to both executing applications as well as any',
'of the applications used within the &PRODUCT_NAME. development environment.',
'',
'<p />',
'',
'The privilege to switch to this consumer group must be granted to either PUBLIC or the &PRODUCT_NAME. schema.',
'This privilege is typically granted using the procedure DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(517220102538696246)
,p_name=>'P130_QOS_MAX_WORKSPACE_REQ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(517218991177696240)
,p_prompt=>'Maximum Concurrent Workspace Requests'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the maximum number of concurrent page events that &PRODUCT_NAME. supports for all applications.',
'You can configure a more specific value at workspace level.',
'Instead of processing a page event, &PRODUCT_NAME. shows an error message when the limit is already reached.',
'</p>',
'<p>',
'&PRODUCT_NAME. keeps track of workspace requests by querying the CLIENT_INFO column of GV$SESSION.',
'This tracking will not work if developers overwrite CLIENT_INFO, e.g. with a call to DBMS_APPLICATION_INFO.SET_CLIENT_INFO.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(517220644490696246)
,p_name=>'P130_QOS_MAX_SESSION_REQUESTS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(517218991177696240)
,p_prompt=>'Maximum Concurrent Session Requests'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the maximum number of concurrent page events that &PRODUCT_NAME. supports for each session for applications in this instance.',
'You can configure a more specific value at the workspace level.',
'Instead of processing a new page event, &PRODUCT_NAME. shows an error message when the limit is already reached.',
'Alternatively, you can use the Concurrent Session Requests Kill Timeout attribute to kill an active database session, to process the new page event.',
'</p>',
'<p>',
'&PRODUCT_NAME. keeps track of session requests by querying the CLIENT_IDENTIFIER column of GV$SESSION.',
'This tracking will not work if developers overwrite CLIENT_IDENTIFIER, e.g. with a call to DBMS_SESSION.SET_IDENTIFIER.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(517221174023696247)
,p_name=>'P130_QOS_MAX_SESSION_KILL_TO'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(517218991177696240)
,p_prompt=>'Concurrent Session Requests Kill Timeout'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If a new page event comes in that is outside the limits of Maximum Concurrent Session Requests, &PRODUCT_NAME. can execute <code>alter system kill session</code> on the oldest active database session which processes another page event for this &PRODU'
||'CT_NAME. session. The Concurrent Session Requests Kill Timeout attribute specifies the number of seconds a database process has to be active, before it can be killed. If you leave this attribute empty, &PRODUCT_NAME. will not kill any database sessio'
||'ns.',
'</p>',
'<p>',
'<strong>Warning:</strong> Killing sessions can cause problems with the application server''s database session pool.    ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(538533433403939920)
,p_name=>'P130_INSTANCE_NO_PROXY_DOMAINS'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_prompt=>'Instance No Proxy Domains'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this field to specify a list of hosts and domains for which no proxy should be used. For example:</p>',
'<pre>internal.example.com,local.example.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(556474331897031379)
,p_name=>'P130_USERNAME_VALIDATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(47634507195931998)
,p_prompt=>'Username Validation Expression'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a regular expression to validate the usernames of developers and administrators. Enter * to bypass the validation.',
'<p>',
'Example (validates that the username is an email address):<br/>',
'<pre>',
'^[[:alnum:]._%-]+@[[:alnum:].-]+\.[[:alpha:]]{2,4}$',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(582421603229226504)
,p_name=>'P130_MAX_WEBSERVICE_REQUESTS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(517218991177696240)
,p_prompt=>'Maximum Web Service Requests'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the maximum number of web service requests that &PRODUCT_NAME. supports for each workspace in this instance. You can configure a more specific value at the workspace level.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(620835000719373113)
,p_name=>'P130_WORKSPACE_MAX_FILE_BYTES'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(517218991177696240)
,p_prompt=>'Maximum Size of Files in Workspace'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the total size (in bytes) of all files that can be uploaded to a workspace. You can configure a more specific value at workspace level.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741568985781681323)
,p_name=>'P130_UNHANDLED_ERRORS'
,p_is_required=>true
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(47634100990931998)
,p_item_default=>'N'
,p_prompt=>'Unhandled Errors'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UNHANDLED ERRORS'
,p_lov=>'.'||wwv_flow_imp.id(818371130728427287)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this attribute to control how &PRODUCT_NAME. displays the results of unhandled errors.  When &PRODUCT_NAME. encounters an unhandled error during processing, an error page will be displayed to the end user of the application.  From a security s'
||'tandpoint, it is often better to not display these messages and error codes to the end user and simply return a HTTP 400 (Bad Request) error code to the client browser.',
'</p>',
'<p>Possible values include:',
'</p>',
'<ul>',
'    <li><strong>Show Error Page</strong>: ',
'      This is the default behavior.  For any error or exception which is not handled by the error processing of an application, display to the end user the specific error and error code on an error page.',
'    </li>',
'    <li><strong>Return HTTP 400</strong>: ',
'      When an unhandled error is encountered, return an HTTP 400 status to the client browser of the end user.',
'    </li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47662111179932031)
,p_validation_name=>'P130_EXPIRE_FND_USER_ACCOUNTS'
,p_validation_sequence=>10
,p_validation=>'P130_EXPIRE_FND_USER_ACCOUNTS'
,p_validation2=>'YN'
,p_validation_type=>'ITEM_IN_VALIDATION_IN_STRING2'
,p_error_message=>'Value out of range.'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(47650422637932015)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47661530661932030)
,p_validation_name=>'max login failures positive integer'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P130_USER_MAX_LOGIN_FAILURES );',
'    if l_number = abs(trunc(l_number)) and l_number > 0 then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_validation_condition=>'P130_USER_MAX_LOGIN_FAILURES'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(47649932493932015)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47661914041932030)
,p_validation_name=>'account lifetime days positive integer'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P130_ACCOUNT_LIFETIME_DAYS );',
'    if l_number = abs(trunc(l_number)) and l_number > 0 then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_validation_condition=>'P130_ACCOUNT_LIFETIME_DAYS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(47647919390932013)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47661715832932030)
,p_validation_name=>'P130_PW_MIN_LENGTH  positive integer'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P130_PW_MIN_LENGTH );',
'    if l_number >= 0 and l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_validation_condition=>'P130_PW_MIN_LENGTH'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(47650925096932015)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47661111116932029)
,p_validation_name=>'P130_NEW_DIFFERS_BY  positive int or zero'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P130_PW_NEW_DIFFERS_BY );',
'    if l_number is null or l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(47654118447932018)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15063329653306616)
,p_validation_name=>'P130_MAX_SESSION_LENGTH_SEC'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P130_MAX_SESSION_LENGTH_SEC is null ',
'       or to_number(:P130_MAX_SESSION_LENGTH_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(15060228156098057)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15063504158308694)
,p_validation_name=>'P130_MAX_SESSION_IDLE_SEC'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P130_MAX_SESSION_IDLE_SEC is null ',
'       or to_number(:P130_MAX_SESSION_IDLE_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(15060417898104569)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1405537360336502)
,p_validation_name=>'P130_SESSION_TIMEOUT_WARN_SEC'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P130_SESSION_TIMEOUT_WARN_SEC is null ',
'       or to_number(:P130_SESSION_TIMEOUT_WARN_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(1405441760336501)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(498599028906577030)
,p_validation_name=>'P130_USER_MAX_LOGIN_FAILURES not null'
,p_validation_sequence=>90
,p_validation=>'P130_USER_MAX_LOGIN_FAILURES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified, even when "Require User Account Expiration and Locking" is set to No.'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(47649932493932015)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(498599704103579333)
,p_validation_name=>'P130_ACCOUNT_LIFETIME_DAYS not null'
,p_validation_sequence=>100
,p_validation=>'P130_ACCOUNT_LIFETIME_DAYS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified, even when "Require User Account Expiration and Locking" is set to No.'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(47647919390932013)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(244019626204007152)
,p_validation_name=>'P130_LOGIN_THROTTLE_METHODS'
,p_validation_sequence=>110
,p_validation=>'P130_LOGIN_THROTTLE_METHODS'
,p_validation2=>'^USERNAME|IP|USERNAME_IP|USERNAME:IP$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must have values out of USERNAME, IP and USERNAME_IP'
,p_when_button_pressed=>wwv_flow_imp.id(47636805241932002)
,p_associated_item=>wwv_flow_imp.id(244018932039989237)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(245896807341956895)
,p_validation_name=>'P130_INBOUND_PROXIES'
,p_validation_sequence=>120
,p_validation=>'P130_INBOUND_PROXIES'
,p_validation2=>'^(([0-9]{1,3}(\.[0-9]{1,3}){3})|([a-fA-F0-9]{0,4}([:.][a-fA-F0-9]{0,4}){3,7}),?)*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must contain a comma-separated list of IPv4 or IPv6 addresses.'
,p_associated_item=>wwv_flow_imp.id(245896310903818453)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2512410615281730)
,p_validation_name=>'P130_DISABLED_APPS_LIST'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P130_DISABLED_APPS_LIST is not null',
'and',
'regexp_like(:P130_DISABLED_APPS_LIST, ''^\d+(?,\d+)*$'')'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a comma-separated list of numeric application IDs.'
,p_validation_condition=>'P130_DISABLE_APPS_LOGIN'
,p_validation_condition2=>'LIST'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2511911448281725)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(182648918164558490)
,p_name=>'en/dis Oracle Single Sign-On'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_BUILDER_AUTH'
,p_condition_element=>'P130_BUILDER_AUTH'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SSO'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(182649215360558490)
,p_event_id=>wwv_flow_imp.id(182648918164558490)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_BUILDER_AUTH_SSO_LOGOUT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(182649406402558490)
,p_event_id=>wwv_flow_imp.id(182648918164558490)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_BUILDER_AUTH_SSO_LOGOUT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(182798709076574791)
,p_event_id=>wwv_flow_imp.id(182648918164558490)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ALERT'
,p_attribute_01=>'Please remember to create single sign-on Users, otherwise you will lock everybody out!'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(557878209667545379)
,p_name=>'hide username validation'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_BUILDER_AUTH'
,p_condition_element=>'P130_BUILDER_AUTH'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'APEX'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557878506052545382)
,p_event_id=>wwv_flow_imp.id(557878209667545379)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_USERNAME_VALIDATION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557878701806545382)
,p_event_id=>wwv_flow_imp.id(557878209667545379)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_USERNAME_VALIDATION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(402391795667306463)
,p_name=>'en/dis P130_HTTP_STS_MAX_AGE'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_HTTP_STS'
,p_condition_element=>'P130_HTTP_STS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(402392064260306472)
,p_event_id=>wwv_flow_imp.id(402391795667306463)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(402392899885311931)
,p_event_id=>wwv_flow_imp.id(402391795667306463)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(402393062428316425)
,p_event_id=>wwv_flow_imp.id(402391795667306463)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'1'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(402398804834394459)
,p_name=>'en/dis P130_HTTP_CSP_POLICY'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_HTTP_CSP'
,p_condition_element=>'P130_HTTP_CSP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(402399199507394459)
,p_event_id=>wwv_flow_imp.id(402398804834394459)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_CSP_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(402399336712394460)
,p_event_id=>wwv_flow_imp.id(402398804834394459)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_CSP_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(403539113314034942)
,p_name=>'en/dis P130_HTTP_STS_MAX_AGE'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_REQUIRE_HTTPS'
,p_condition_element=>'P130_REQUIRE_HTTPS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'A'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(403539406261034944)
,p_event_id=>wwv_flow_imp.id(403539113314034942)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(403539793681039063)
,p_event_id=>wwv_flow_imp.id(403539113314034942)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(538533525580939921)
,p_name=>'Instance Proxy'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_INSTANCE_PROXY'
,p_condition_element=>'P130_INSTANCE_PROXY'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(538533641768939922)
,p_event_id=>wwv_flow_imp.id(538533525580939921)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_INSTANCE_NO_PROXY_DOMAINS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(538533728417939923)
,p_event_id=>wwv_flow_imp.id(538533525580939921)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_INSTANCE_NO_PROXY_DOMAINS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(538533811903939924)
,p_event_id=>wwv_flow_imp.id(538533525580939921)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_INSTANCE_NO_PROXY_DOMAINS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1800821538884704)
,p_name=>'show/hide Persistent Auth lifetime'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_ALLOW_PERSISTENT_AUTH'
,p_condition_element=>'P130_ALLOW_PERSISTENT_AUTH'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1800925286884705)
,p_event_id=>wwv_flow_imp.id(1800821538884704)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_PERS_AUTH_LIFETIME_DAYS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1801012656884706)
,p_event_id=>wwv_flow_imp.id(1800821538884704)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_PERS_AUTH_LIFETIME_DAYS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2512048984281726)
,p_name=>'Disabled Apps'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_DISABLE_APPS_LOGIN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2512196438281727)
,p_event_id=>wwv_flow_imp.id(2512048984281726)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_DISABLED_APPS_LIST'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P130_DISABLE_APPS_LOGIN'
,p_client_condition_expression=>'LIST'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2512254603281728)
,p_event_id=>wwv_flow_imp.id(2512048984281726)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_DISABLED_APPS_LIST'
,p_client_condition_type=>'NOT_EQUALS'
,p_client_condition_element=>'P130_DISABLE_APPS_LOGIN'
,p_client_condition_expression=>'LIST'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2288326767766301)
,p_event_id=>wwv_flow_imp.id(2512048984281726)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_DISABLED_APPS_LIST'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NOT_EQUALS'
,p_client_condition_element=>'P130_DISABLE_APPS_LOGIN'
,p_client_condition_expression=>'LIST'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(47662222355932032)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Authentication',
'--',
':P130_WORKSPACE_NAME_USR_COOKIE := nvl(wwv_flow_platform.get_preference(''WORKSPACE_NAME_USER_COOKIE''),''Y'');',
':P130_ALLOW_PERSISTENT_AUTH     := nvl(wwv_flow_platform.get_preference(''ALLOW_PERSISTENT_AUTHENTICATION''),''N'');',
':P130_PERS_AUTH_LIFETIME_DAYS   := nvl(wwv_flow_platform.get_preference(''PERSISTENT_AUTHENTICATION_MAX_DAYS''),''30'');',
':P130_DISABLE_ADMIN_LOGIN       := wwv_flow_platform.get_preference( p_preference_name => ''DISABLE_ADMIN_LOGIN'' );',
':P130_DISABLE_WORKSPACE_LOGIN   := wwv_flow_platform.get_preference( p_preference_name => ''DISABLE_WORKSPACE_LOGIN'' );',
':P130_DISABLE_APPS_LOGIN        := nvl(wwv_flow_platform.get_preference(''DISABLE_APPS_LOGIN''), ''N'');',
'if :P130_DISABLE_APPS_LOGIN not in (''Y'', ''N'') then',
'    :P130_DISABLED_APPS_LIST := :P130_DISABLE_APPS_LOGIN;',
'    :P130_DISABLE_APPS_LOGIN := ''LIST'';',
'end if;',
':P130_ALLOW_PUBLIC_FILE_UPLOAD  := wwv_flow_platform.get_preference( p_preference_name => ''ALLOW_PUBLIC_FILE_UPLOAD'' );',
':P130_AI_IS_ENABLED             := wwv_flow_platform.get_preference( p_preference_name => ''AI_IS_ENABLED'' );',
':P130_AI_BUILDER_PROXY          := wwv_flow_platform.get_preference( p_preference_name => ''AI_BUILDER_PROXY'' );',
':P130_RESTRICT_IP_RANGE         := wwv_flow_platform.get_preference( p_preference_name => ''RESTRICT_IP_RANGE'' );',
':P130_INSTANCE_PROXY            := wwv_flow_platform.get_preference( p_preference_name => ''INSTANCE_PROXY'' );',
':P130_INSTANCE_NO_PROXY_DOMAINS := wwv_flow_platform.get_preference( p_preference_name => ''INSTANCE_NO_PROXY_DOMAINS'' );',
':P130_CHECKSUM_HASH_FUNCTION    := wwv_flow_platform.get_preference(''CHECKSUM_HASH_FUNCTION'');',
':P130_REJOIN_EXISTING_SESSIONS  := wwv_flow_platform.get_preference(''REJOIN_EXISTING_SESSIONS'');',
':P130_UNHANDLED_ERRORS          := wwv_flow_platform.get_preference(''HTTP_ERROR_STATUS_ON_ERROR_PAGE_ENABLED'');',
'--',
'-- HTTP Protocol',
'--',
':P130_REQUIRE_HTTPS         := wwv_flow_platform.get_preference(p_preference_name => ''REQUIRE_HTTPS'' );',
':P130_HTTP_STS_MAX_AGE      := wwv_flow_platform.get_preference(p_preference_name => ''HTTP_STS_MAX_AGE'');',
':P130_OUTBOUND_HTTPS        := wwv_flow_platform.get_preference(p_preference_name => ''REQUIRE_OUT_HTTPS'' );',
':P130_HTTP_RESPONSE_HEADERS := wwv_flow_platform.get_preference(p_preference_name => ''HTTP_RESPONSE_HEADERS'');',
'--',
'-- RAS',
'--',
':P130_ALLOW_RAS := wwv_flow_platform.get_preference( p_preference_name => ''ALLOW_RAS'' );',
'--',
'-- Session Timeout',
'--',
':P130_MAX_SESSION_IDLE_SEC        := nvl(wwv_flow_platform.get_preference( p_preference_name => ''MAX_SESSION_IDLE_SEC''),3600);',
':P130_MAX_SESSION_LENGTH_SEC      := nvl(wwv_flow_platform.get_preference( p_preference_name => ''MAX_SESSION_LENGTH_SEC''),28800);',
':P130_SESSION_TIMEOUT_WARN_SEC    := nvl(wwv_flow_platform.get_preference( p_preference_name => ''SESSION_TIMEOUT_WARNING_SEC''),180);',
'--',
'-- Quality Of Service',
'--',
':P130_ALLOW_HOSTNAMES          := wwv_flow_platform.get_preference( p_preference_name => ''ALLOW_HOSTNAMES'');',
':P130_RM_CONSUMER_GROUP        := wwv_flow_platform.get_preference( p_preference_name => ''RM_CONSUMER_GROUP'');',
':P130_QOS_MAX_WORKSPACE_REQ    := wwv_flow_platform.get_preference( p_preference_name => ''QOS_MAX_WORKSPACE_REQUESTS'');',
':P130_QOS_MAX_SESSION_REQUESTS := wwv_flow_platform.get_preference( p_preference_name => ''QOS_MAX_SESSION_REQUESTS'');',
':P130_QOS_MAX_SESSION_KILL_TO  := wwv_flow_platform.get_preference( p_preference_name => ''QOS_MAX_SESSION_KILL_TIMEOUT '');',
':P130_WORKSPACE_MAX_FILE_BYTES := wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_MAX_FILE_BYTES'');',
':P130_MAX_WEBSERVICE_REQUESTS  := wwv_flow_platform.get_preference( p_preference_name => ''MAX_WEBSERVICE_REQUESTS'');',
'--',
'-- Region and Web Service Excluded Domains',
'--',
':P130_BAD_URLS                 := wwv_flow_platform.get_preference( p_preference_name => ''BAD_URLS'');',
'--',
'-- Authentication Control',
'--',
':P130_LOGIN_THROTTLE_DELAY     := wwv_flow_platform.get_preference(''LOGIN_THROTTLE_DELAY'');',
':P130_LOGIN_THROTTLE_METHODS   := wwv_flow_platform.get_preference(''LOGIN_THROTTLE_METHODS'');',
':P130_INBOUND_PROXIES          := wwv_flow_platform.get_preference(''INBOUND_PROXIES'');',
':P130_SSO_LOGOUT_URL            := wwv_flow_platform.get_preference(''SSO_LOGOUT_URL'');',
':P130_USERNAME_VALIDATION       := nvl(wwv_flow_platform.get_preference(''USERNAME_VALIDATION''),''^[[:alnum:]._%-]+@[[:alnum:].-]+\.[[:alpha:]]{2,4}$'');',
':P130_EXPIRE_FND_USER_ACCOUNTS := wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS'');',
':P130_USER_MAX_LOGIN_FAILURES  := nvl(wwv_flow_platform.get_preference(''MAX_LOGIN_FAILURES''),''4'');',
':P130_ACCOUNT_LIFETIME_DAYS    := nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),''45'');',
'',
':P130_PASSWORD_HASH_FUNCTION   := wwv_flow_platform.get_preference(''PASSWORD_HASH_FUNCTION'');',
':P130_STRONG_SITE_ADMIN_PWD    := wwv_flow_platform.get_preference(''STRONG_SITE_ADMIN_PASSWORD'');',
':P130_PW_MIN_LENGTH            := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_MIN_LENGTH'');',
':P130_PW_NEW_DIFFERS_BY        := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_NEW_DIFFERS_BY'');',
':P130_PW_ONE_ALPHA             := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_ALPHA'');',
':P130_PW_ONE_NUMERIC           := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_NUMERIC'');',
':P130_PW_ONE_PUNCTUATION       := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_PUNCTUATION'');',
':P130_PW_ONE_UPPER_CASE        := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_UPPER_CASE'');',
':P130_PW_ONE_LOWER_CASE        := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_LOWER_CASE'');',
':P130_PW_NOT_LIKE_USERNAME     := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_NOT_LIKE_USERNAME'');',
':P130_PW_NOT_LIKE_WS_NAME      := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_NOT_LIKE_WS_NAME'');',
':P130_PW_NOT_LIKE_WORDS        := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_NOT_LIKE_WORDS'');',
':P130_PW_ALPHA_CHARS           := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ALPHA_CHARACTERS'');',
':P130_PW_PUNCTUATION_CHARS     := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_PUNCTUATION_CHARACTERS'');'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>47662222355932032
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(47662403843932033)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Security',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_NAME_USER_COOKIE'',',
'                                  p_preference_value => :P130_WORKSPACE_NAME_USR_COOKIE);',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_PERSISTENT_AUTHENTICATION'',',
'                                  p_preference_value => :P130_ALLOW_PERSISTENT_AUTH);',
'wwv_flow_platform.set_preference( p_preference_name => ''PERSISTENT_AUTHENTICATION_MAX_DAYS'',',
'                                  p_preference_value => nvl(:P130_PERS_AUTH_LIFETIME_DAYS,30));',
'wwv_flow_platform.set_preference( p_preference_name => ''DISABLE_ADMIN_LOGIN'',',
'                                  p_preference_value => :P130_DISABLE_ADMIN_LOGIN );',
'wwv_flow_platform.set_preference( p_preference_name => ''DISABLE_WORKSPACE_LOGIN'',',
'                                  p_preference_value => :P130_DISABLE_WORKSPACE_LOGIN );',
'wwv_flow_platform.set_preference( p_preference_name => ''DISABLE_APPS_LOGIN'',',
'                                  p_preference_value => case when :P130_DISABLE_APPS_LOGIN in (''Y'', ''N'') ',
'                                                             then :P130_DISABLE_APPS_LOGIN',
'                                                             else :P130_DISABLED_APPS_LIST',
'                                                        end );',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_PUBLIC_FILE_UPLOAD'',',
'                                  p_preference_value => :P130_ALLOW_PUBLIC_FILE_UPLOAD );',
'wwv_flow_platform.set_preference( p_preference_name => ''AI_IS_ENABLED'',',
'                                  p_preference_value => :P130_AI_IS_ENABLED );',
'wwv_flow_platform.set_preference( p_preference_name => ''RESTRICT_IP_RANGE'',',
'                                  p_preference_value => :P130_RESTRICT_IP_RANGE );',
'wwv_flow_platform.set_preference( p_preference_name => ''AI_BUILDER_PROXY'',',
'                                  p_preference_value => :P130_AI_BUILDER_PROXY );',
'wwv_flow_platform.set_preference( p_preference_name => ''INSTANCE_PROXY'',',
'                                  p_preference_value => :P130_INSTANCE_PROXY );',
'wwv_flow_platform.set_preference( p_preference_name => ''INSTANCE_NO_PROXY_DOMAINS'',',
'                                  p_preference_value => :P130_INSTANCE_NO_PROXY_DOMAINS );',
'wwv_flow_platform.set_preference( p_preference_name => ''CHECKSUM_HASH_FUNCTION'',',
'                                  p_preference_value => :P130_CHECKSUM_HASH_FUNCTION );',
'wwv_flow_platform.set_preference( p_preference_name => ''REJOIN_EXISTING_SESSIONS'',',
'                                  p_preference_value => :P130_REJOIN_EXISTING_SESSIONS );',
'                                  ',
'wwv_flow_platform.set_preference( p_preference_name => ''HTTP_ERROR_STATUS_ON_ERROR_PAGE_ENABLED'',',
'                                  p_preference_value => :P130_UNHANDLED_ERRORS );                                                                    ',
'--',
'-- HTTP Protocol',
'--',
'wwv_flow_platform.set_preference( p_preference_name  => ''REQUIRE_HTTPS'',',
'                                  p_preference_value => :P130_REQUIRE_HTTPS );',
'wwv_flow_platform.set_preference( p_preference_name  => ''HTTP_STS_MAX_AGE'',',
'                                  p_preference_value => :P130_HTTP_STS_MAX_AGE );',
'wwv_flow_platform.set_preference( p_preference_name  => ''REQUIRE_OUT_HTTPS'',',
'                                  p_preference_value => :P130_OUTBOUND_HTTPS );',
'wwv_flow_platform.set_preference( p_preference_name  => ''HTTP_RESPONSE_HEADERS'',',
'                                  p_preference_value => :P130_HTTP_RESPONSE_HEADERS );',
'--',
'-- RAS',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_RAS'',',
'                                  p_preference_value => :P130_ALLOW_RAS );',
'--',
'-- Quality Of Service',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_HOSTNAMES'',',
'                                  p_preference_value => :P130_ALLOW_HOSTNAMES );',
'wwv_flow_platform.set_preference( p_preference_name => ''RM_CONSUMER_GROUP'',',
'                                  p_preference_value => :P130_RM_CONSUMER_GROUP );',
'wwv_flow_platform.set_preference( p_preference_name => ''QOS_MAX_WORKSPACE_REQUESTS'',',
'                                  p_preference_value => :P130_QOS_MAX_WORKSPACE_REQ );',
'wwv_flow_platform.set_preference( p_preference_name => ''QOS_MAX_SESSION_REQUESTS'',',
'                                  p_preference_value => :P130_QOS_MAX_SESSION_REQUESTS );',
'wwv_flow_platform.set_preference( p_preference_name => ''QOS_MAX_SESSION_KILL_TIMEOUT'',',
'                                  p_preference_value => :P130_QOS_MAX_SESSION_KILL_TO );',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_MAX_FILE_BYTES'',',
'                                  p_preference_value => :P130_WORKSPACE_MAX_FILE_BYTES );',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_WEBSERVICE_REQUESTS'',',
'                                  p_preference_value => :P130_MAX_WEBSERVICE_REQUESTS );',
'--',
'-- General Authentication Control',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''LOGIN_THROTTLE_DELAY'',',
'                                  p_preference_value => :P130_LOGIN_THROTTLE_DELAY );',
'wwv_flow_platform.set_preference( p_preference_name => ''LOGIN_THROTTLE_METHODS'',',
'                                  p_preference_value => :P130_LOGIN_THROTTLE_METHODS );',
'wwv_flow_platform.set_preference( p_preference_name => ''INBOUND_PROXIES'',',
'                                  p_preference_value => :P130_INBOUND_PROXIES );',
'wwv_flow_platform.set_preference( p_preference_name => ''SSO_LOGOUT_URL'',',
'                                  p_preference_value => :P130_SSO_LOGOUT_URL );',
'--',
'-- Workspace Authentication Control',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''USERNAME_VALIDATION'',',
'                                  p_preference_value => :P130_USERNAME_VALIDATION );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''EXPIRE_FND_USER_ACCOUNTS'',',
'                                  p_preference_value => :P130_EXPIRE_FND_USER_ACCOUNTS );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_LOGIN_FAILURES'',',
'                                  p_preference_value => nvl(:P130_USER_MAX_LOGIN_FAILURES,4) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''ACCOUNT_LIFETIME_DAYS'',',
'                                  p_preference_value => nvl(:P130_ACCOUNT_LIFETIME_DAYS,45) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_HASH_FUNCTION'',',
'                                  p_preference_value => :P130_PASSWORD_HASH_FUNCTION );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''STRONG_SITE_ADMIN_PASSWORD'',',
'                                  p_preference_value => nvl(:P130_STRONG_SITE_ADMIN_PWD,''N'') );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_MIN_LENGTH'',',
'                                  p_preference_value => nvl(:P130_PW_MIN_LENGTH,0) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_NEW_DIFFERS_BY'',',
'                                  p_preference_value => nvl(:P130_PW_NEW_DIFFERS_BY,0) );',
'--                                 ',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_ALPHA'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_ALPHA,''N'') );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_NUMERIC'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_NUMERIC,''N'') );  ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_PUNCTUATION'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_PUNCTUATION,''N'') ); ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_UPPER_CASE'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_UPPER_CASE,''N'') ); ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_LOWER_CASE'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_LOWER_CASE,''N'') ); ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_NOT_LIKE_USERNAME'',',
'                                  p_preference_value => nvl(:P130_PW_NOT_LIKE_USERNAME,''N'') );   ',
'--                                ',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_NOT_LIKE_WS_NAME'',',
'                                  p_preference_value => nvl(:P130_PW_NOT_LIKE_WS_NAME,''N'') );  ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_NOT_LIKE_WORDS'',',
'                                  p_preference_value => substr(ltrim(rtrim(replace(replace(replace(',
'                                                            :P130_PW_NOT_LIKE_WORDS,'' '',null),chr(10),null),chr(13),null))),1,4000));',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_PUNCTUATION_CHARACTERS'',',
'                                  p_preference_value => substr(ltrim(rtrim(replace(replace(replace(',
'                                                            :P130_PW_PUNCTUATION_CHARS,'' '',null),chr(10),null),chr(13),null))),1,4000));',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ALPHA_CHARACTERS'',',
'                                  p_preference_value => substr(ltrim(rtrim(replace(replace(replace(',
'                                                            :P130_PW_ALPHA_CHARS,'' '',null),chr(10),null),chr(13),null))),1,4000));',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''BAD_URLS'',',
'                                  p_preference_value => substr(ltrim(rtrim(replace(replace(replace(',
'                                                            :P130_BAD_URLS,'' '',null),chr(10),null),chr(13),null))),1,4000));',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_SESSION_IDLE_SEC'',',
'                                  p_preference_value => nvl(:P130_MAX_SESSION_IDLE_SEC,3600) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_SESSION_LENGTH_SEC'',',
'                                  p_preference_value => nvl(:P130_MAX_SESSION_LENGTH_SEC,28800) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''SESSION_TIMEOUT_WARNING_SEC'',',
'                                  p_preference_value => nvl(:P130_SESSION_TIMEOUT_WARN_SEC,300) );',
'--',
'wwv_flow_authorization.reset_cache (',
'    p_save_state => true );',
'--',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save Security settings.'
,p_process_when_button_id=>wwv_flow_imp.id(47636805241932002)
,p_process_success_message=>'Security settings saved.'
,p_internal_uid=>47662403843932033
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(47662604945932033)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'130'
,p_internal_uid=>47662604945932033
);
end;
/
prompt --application/pages/page_00131
begin
wwv_flow_imp_page.create_page(
 p_id=>131
,p_name=>'Instance Settings'
,p_alias=>'INSTANCE-SETTINGS'
,p_step_title=>'Instance Settings'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216766702444596508)
,p_step_template=>wwv_flow_imp.id(704456563630760825)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_env.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5023375720816204)
,p_plug_name=>'Application Gallery'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21674091578910608)
,p_plug_name=>'Administrator Digest'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51160113641211250)
,p_plug_name=>'Email'
,p_region_name=>'EMAIL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51160527136211251)
,p_plug_name=>'Workspace Creation'
,p_region_name=>'SELFSERVICE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51160911256211251)
,p_plug_name=>'Instance Settings'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(51162104747211252)
,p_name=>'Workspace Change Request Size'
,p_region_name=>'CHANGE_WORKSPACE_SIZE'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.hidden(5,wwv_flow_escape.html(s.id)) || htmldb_item.text(6, wwv_flow_escape.html(s.req_size), 25) display_req_size,',
'       htmldb_item.select_list_from_lov(7, wwv_flow_escape.html(s.display), ''YES_NO_RETURNS_Y_OR_N'',null,''NO'') display,',
'       to_number(s.req_size),       htmldb_item.radiogroup(8,wwv_flow_escape.html(s.id),decode(s.default_size,''Y'',s.id,0)) default_selection',
'  from  wwv_flow_workspace_req_size s',
' where s.request_type = ''C'''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(51162400177211252)
,p_query_column_id=>1
,p_column_alias=>'DISPLAY_REQ_SIZE'
,p_column_display_sequence=>1
,p_column_heading=>'Size in Megabytes'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(51162324177211252)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Display'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(51162514609211253)
,p_query_column_id=>3
,p_column_alias=>'TO_NUMBER(S.REQ_SIZE)'
,p_column_display_sequence=>3
,p_column_heading=>'To Number(S.Req Size)'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(51478902378846758)
,p_query_column_id=>4
,p_column_alias=>'DEFAULT_SELECTION'
,p_column_display_sequence=>4
,p_column_heading=>'Default'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51162614555211253)
,p_plug_name=>'Report Printing'
,p_region_name=>'REPORT_PRINTING'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51162800040211253)
,p_plug_name=>'Wallet'
,p_region_name=>'WALLET'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(262166935173555047)
,p_plug_name=>'SSL Wallet In Use'
,p_parent_plug_id=>wwv_flow_imp.id(51162800040211253)
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_wallet wwv_flow_security.t_wallet := wwv_flow_security.get_wallet;    ',
'begin',
'',
'    if    l_wallet.wallet_path                                               is not null',
'       and wwv_flow_platform.get_preference (p_preference_name => ''WALLET_PATH'') is null ',
'    then        ',
'        return ''<p><strong>''',
'               || wwv_flow_lang_dev.builder_message(''4050_131_SSL_WALLET_PROPERTY'')',
'               || '' (<code>'' || l_wallet.wallet_path || ''</code>)''',
'               || ''</strong></p>'' ',
'               || wwv_flow_lang_dev.builder_message(''4050_131_WALLET_ALTERNATIVE'');',
'    end if;    ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_wallet wwv_flow_security.t_wallet := wwv_flow_security.get_wallet;',
'begin',
'    if  wwv_flow_platform.get_preference (p_preference_name  => ''WALLET_PATH'') is null and l_wallet.wallet_path is not null then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(262167048159555048)
,p_plug_name=>'Wallet Items'
,p_parent_plug_id=>wwv_flow_imp.id(51162800040211253)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(51163027227211253)
,p_name=>'New Workspace Request Size'
,p_region_name=>'NEW_WORKSPACE_SIZE'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       htmldb_item.hidden(1,wwv_flow_escape.html(s.id)) || htmldb_item.text(2, wwv_flow_escape.html(s.req_size), 25) display_req_size,',
'       htmldb_item.select_list_from_lov(3, wwv_flow_escape.html(s.display), ''YES_NO_RETURNS_Y_OR_N'',null,''NO'') display,',
'       to_number(s.req_size) req_size,       htmldb_item.radiogroup(4,s.id,decode(wwv_flow_escape.html(s.default_size),''Y'',s.id,0)) default_selection',
'  from  wwv_flow_workspace_req_size s',
' where s.request_type = ''N'''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(51163431134211253)
,p_query_column_id=>1
,p_column_alias=>'DISPLAY_REQ_SIZE'
,p_column_display_sequence=>1
,p_column_heading=>'Size in Megabytes'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(51163223408211253)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Display'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(51163314175211253)
,p_query_column_id=>3
,p_column_alias=>'REQ_SIZE'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(51474332113827028)
,p_query_column_id=>4
,p_column_alias=>'DEFAULT_SELECTION'
,p_column_display_sequence=>3
,p_column_heading=>'Default'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(102772806051895487)
,p_plug_name=>'Email Provisioning'
,p_region_name=>'EMAIL_PROVISIONING'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(103242102881123907)
,p_plug_name=>'Storage'
,p_region_name=>'STORAGE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203127322177179431)
,p_plug_name=>'Application ID Range'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222734572394034402)
,p_plug_name=>'Workflow Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(319958722234296913)
,p_plug_name=>'Background Jobs'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472895007879833572)
,p_plug_name=>'Anchor'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(195775112470763477)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(473748116639968529)
,p_plug_name=>'Help'
,p_region_name=>'HELP'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617449002845759911)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Manage settings that apply to the entire &PRODUCT_NAME. instance.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51164000306211254)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(51160911256211251)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51164206531211254)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(51160911256211251)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168826527481409095)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1402891439294845)
,p_name=>'P131_BACKGRND_MIN_EXEC_CADENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(319958722234296913)
,p_prompt=>'Minimum Execution Cadence (Minutes)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the minimal execution cadence (in minutes) for Automation and REST Synchronization jobs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1813675799420704)
,p_name=>'P131_BG_PAGE_PROC_JOB_CLASS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(319958722234296913)
,p_prompt=>'Background Page Process Job Class'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Identify the DBMS_SCHEDULER Job Class for Background Page Processing jobs to run in.',
'    This allows to assign these jobs to a specific Resource Manager Consumer group. If not set, the job class <strong>SYS.DEFAULT_JOB_CLASS</strong> will be used. For more information on job classes, consult the Oracle Database Administrators Guide.',
'</p>',
'<p>',
'    Example. Execute with DBA privileges:',
'</p>',
'<pre>',
'-- 1. create the job class',
'--   ',
'begin ',
'    dbms_scheduler.create_job_class(',
'         job_class_name          => ''MY_BACKGROUND_PROCESS_CLASS'', ',
'         -- this assumes that a RES_MGR_LOW_PRIO_GROUP consumer group exists',
'         resource_consumer_group => ''RES_MGR_LOW_PRIO_GROUP'', ',
'         comments                => ''This is a job class for background page processing.'' );',
'end;',
'/',
'',
'-- 2. grant EXECUTE privilege on the job class to the APEX engine user',
'--',
'grant execute on MY_BACKGROUND_PROCESS_CLASS to apex_NNNNNN',
'/',
'',
'-- 3. configure the job class here or use APEX_INSTANCE_ADMIN.SET_PARAMETER',
'--',
'begin ',
'    apex_instance_admin.set_parameter( ',
'        p_parameter => ''BACKGROUND_PROCESS_JOB_CLASS'', ',
'        p_value     => ''MY_BACKGROUND_PROCESS_CLASS'' ); ',
'end;',
'/',
'</pre>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1960858158397223)
,p_name=>'P131_WF_RETENTION_DAYS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(222734572394034402)
,p_item_default=>'30'
,p_prompt=>'Workflow Retention Period Days'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the number of days for which completed workflow instances will be retained in the instance before being purged. This value cannot be greater than 100 days. Default value is 30 days.'
,p_attribute_01=>'0'
,p_attribute_02=>'100'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003417795897530)
,p_name=>'P131_MAX_MAIL_QUEUE_ROWS'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'Maximum Emails Processed per Workspace'
,p_format_mask=>'9999999999'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the number of email messages that will be processed from the queue per workspace during each invocation of the <code>ORACLE_APEX_MAIL_QUEUE</code> scheduler job.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'1000000'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2814368091275621)
,p_name=>'P131_DOCGEN_OBS_NAMESPACE'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'Object Storage Namespace'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The Object Storage namespace serves as the top-level container for all buckets and objects. At account creation time, each Oracle Cloud Infrastructure (OCI) tenant is assigned one unique system-generated and immutable Object Storage namespace name. T'
||'his information can be found in the OCI console.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2814432712275622)
,p_name=>'P131_DOCGEN_COMPARTMENT_OCID'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'Object Storage Bucket Compartment OCID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>90
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specifies the Oracle Cloud Identifier (OCID) of the compartment where the Oracle Document Generator Pre-built Function is located.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2814551085275623)
,p_name=>'P131_DOCGEN_OS_ENDPOINT'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'Object Storage Bucket Endpoint'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>90
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specifies the base URL endpoint for the Oracle Object Storage bucket.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2814674979275624)
,p_name=>'P131_DOCGEN_FUNCTION_OCID'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'Function OCID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>90
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specifies the Oracle Cloud Identity (OCID) of the Oracle Document Generator Pre-Built function. This can be found in the Oracle Cloud Infrastructure (OCI) console.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2814793637275625)
,p_name=>'P131_DOCGEN_FUNCTION_URI'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'Function Endpoint'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>90
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specifies the base URL endpoint of the Oracle Document Generator Pre-Built function. This can be found in the Oracle Cloud Infrastructure (OCI) console.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2816022202275638)
,p_name=>'P131_DOCGEN_CLOUD_CREDENTIAL'
,p_item_sequence=>315
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'Cloud Credential'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specifies the cloud credential to use for Oracle Object Storage bucket management and use of the Oracle Document Generator Pre-built function.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3044413246294304)
,p_name=>'P131_CHANGE_WALLET_PWD'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(262167048159555048)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5023424890816205)
,p_name=>'P131_GALLERY_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5023375720816204)
,p_prompt=>'File URLs'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the URLs which will be used as a installation source for &PRODUCT_NAME. application gallery. The URLs should point to valid endpoints returning JSON format, which describe the sample or starter apps to list. Each URL should be separated by a'
||' new line.</p>',
'<p>For a detailed description on how this is implemented and how the JSON structure should look like, please visit the official &PRODUCT_NAME. documentation.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5736822385779722)
,p_name=>'P131_AUTOAPPROVE_STORAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(103242102881123907)
,p_item_default=>'N'
,p_prompt=>'Automatically Approve Requests'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<= '' || req_size ||''MB'' d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'   and display = ''Y''',
' order by to_number(r)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Never'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Automatically approve storage requests up to the selected size. ',
'<br /><br />',
'<strong>Note:</strong> The Workspace Provisioning Method must be set to Automatic for this feature to be enabled. If Provisioning Method is Manual or Request then no storage requests will be automatically approved.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7089675838289027)
,p_name=>'P131_GALLERY_BACKGRND_INSTALL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5023375720816204)
,p_prompt=>'Enable Background Installation'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>This enables installation of gallery applications in the background. So you don''t have to wait until an app finishes with installation.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20135520532712091)
,p_name=>'P131_INSTANCE_URL'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'&PRODUCT_NAME. Instance URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the URL to this &PRODUCT_NAME. instance, including the trailing slash after the Context Root. This setting is used for system-generated emails.</p>',
'',
'<p>For example: <code>https://www.example.com/apex/</code></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'Default URL'
,p_quick_pick_value_01=>'&P131_INSTANCE_URL_DEFAULT.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20136029536714683)
,p_name=>'P131_IMAGES_URL'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'&PRODUCT_NAME. Images URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the full URL to the images directory of this &PRODUCT_NAME. instance, including the trailing slash after',
'the images directory. This setting is used for system-generated emails.</p>',
'',
'<p>For example: <code>https://www.example.com/i/</code></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'Default URL'
,p_quick_pick_value_01=>'&P131_IMAGES_URL_DEFAULT.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21674153872910609)
,p_name=>'P131_DEFAULT_REPORTING_PERIOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(21674091578910608)
,p_prompt=>'Default Reporting Period (Days)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Administrator Digest Default Report is defined as the time interval for which by default, the reports and charts will show data, whenever a page has the time interval option displayed.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21674202445910610)
,p_name=>'P131_MAX_REPORTING_PERIOD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(21674091578910608)
,p_prompt=>'Maximum Reporting Period (Days)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><p>The Administrator Digest Maximum Reporting Period is defined as the time interval for which the data ',
'is stored inside the metrics tables.</p>',
'<p>Data older than the required time time interval is removed.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21674347266910611)
,p_name=>'P131_WKSP_FREE_SPACE_LIMIT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(21674091578910608)
,p_prompt=>'Workspace Free Space Limit (%)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The instance administrator can set up a threshold for the workspaces free space.',
'Once the threshold is crossed, the workspaces subject to this exception will be listed in the report.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22928323079012302)
,p_name=>'P131_EMAIL_CONFIG_VALID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(51160911256211251)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27397518631059800)
,p_name=>'P131_SMTP_USERNAME'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'SMTP Authentication Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a username if your SMTP server requires authentication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27397701447064365)
,p_name=>'P131_SMTP_PASSWORD'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'SMTP Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a password if your SMTP server requires authentication.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27398215309143987)
,p_name=>'P131_SMTP_TLS_MODE'
,p_is_required=>true
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'Use SSL/TLS'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P131_SMTP_TLS_MODE'
,p_lov=>'.'||wwv_flow_imp.id(44180513498106696)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&PRODUCT_NAME. supports secure SMTP connections. Options include:',
'<ul>',
'<li><strong>Yes</strong> - A secure connection with SSL/TLS is made before SMTP communication.</li>',
'<li><strong>After connection is established</strong> - &PRODUCT_NAME. sends the SMTP command <code>STARTTLS</code> immediately after the connection is opened.</li>',
'<li><strong>No</strong> - A non-secure connection is opened.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38853230345769930)
,p_name=>'P131_BIGFILE_TABLESPACES'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(103242102881123907)
,p_item_default=>'N'
,p_prompt=>'Bigfile Tablespaces'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_display_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If Bigfile Tablespaces is enabled, tablespaces provisioned with &PRODUCT_NAME. are created as bigfile tablespaces.  A bigfile tablespace is a tablespace with a single, but very large datafile. Traditional smallfile tablespaces, in contrast, can co'
||'ntain multiple datafiles, but the files cannot be as large.</p>',
'',
'<p>Using bigfile tablespaces on platforms that do not support large file sizes is not recommended and can limit tablespace capacity. Refer to your operating system specific documentation for information about maximum supported file sizes.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38854402902780924)
,p_name=>'P131_ENCRYPTED_TABLESPACES'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(103242102881123907)
,p_item_default=>'N'
,p_prompt=>'Encrypted Tablespaces'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_display_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If Encrypted Tablespaces is enabled, tablespaces provisioned with &PRODUCT_NAME. are created as encrypted',
'tablespaces using the Oracle database feature Transparent Data Encryption (TDE).  TDE encrypts sensitive data stored',
'in data files. To prevent unauthorized decryption, TDE stores the encryption keys in a security module external to',
'the database.</p>',
'',
'<p>To be able to exploit this feature in &PRODUCT_NAME., an encryption wallet must be created and with a master encryption',
'key set.  Additionally, the encryption wallet will need to be open before provisioning a new &PRODUCT_NAME. workspace.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51168829641211258)
,p_name=>'P131_SERVICE_REQUEST_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(51160527136211251)
,p_item_default=>'MANUAL'
,p_prompt=>'Provisioning Method:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PROVISIONING.STATUS'
,p_lov=>'.'||wwv_flow_imp.id(87819917137094037)||'.'
,p_read_only_when=>'P131_EMAIL_CONFIG_VALID'
,p_read_only_when2=>'N'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the workspace request and creation process. Options include:</p>',
'',
'<ul>',
'<li><strong>Manual</strong> - An &PRODUCT_NAME. administrator must manually create new workspaces and notify the Workspace administrator of the login information.</li>',
'<li><strong>Request</strong> - Users can request a workspace. If an administrator approves, a message containing a link to validate the user''s email address is sent. Workspaces are created upon email validation.</li>',
'<li><strong>Automatic</strong> - Works similar to <strong>Request</strong> except requests are automatically approved with no administrator review required.</li>',
'</ul>',
'',
'<p>To enable automatic approval of storage requests, Provisioning Method must be set to <strong>Automatic</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51169810102211258)
,p_name=>'P131_SMTP_FROM'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'Default Email From Address'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Defines the "From" address for tasks that generate email, such as approving a provision request or resetting a password.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51170329748211259)
,p_name=>'P131_SMTP_HOST_ADDRESS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'SMTP Host Address'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Defines the server address of the SMTP server. By default, this is set to <code>localhost</code>. If you are using another server as an SMTP relay, change this parameter to that server''s address. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51170811596211259)
,p_name=>'P131_SMTP_HOST_PORT'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'SMTP Host Port'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Defines the port the SMTP server listens to for mail requests. The default setting is <code>25</code>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51175812830211262)
,p_name=>'P131_PRINT_SVR_HOST'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'Host Address'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specifies the host address of the print server converting engine.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51176319252211263)
,p_name=>'P131_PRINT_SVR_PORT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'Port'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the port of the print server engine.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51176814346211263)
,p_name=>'P131_PRINT_SVR_SCRIPT'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'Script'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This setting defines the script that is the print server engine.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51185628873211268)
,p_name=>'P131_WALLET_PATH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(262167048159555048)
,p_prompt=>'Wallet Path'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A wallet is a password-protected container that is used to store authentication and signing credentials. The Oracle wallet is used for all HTTP requests over Secured Socket Layer (SSL), namely HTTPS.<p />',
'',
'Enter the path to the wallet on the file system in the format:',
'',
'<pre>file:&lt;directory-path&gt;</pre>',
'',
'Examples:',
'<ul>',
'<li>Windows-based system: <pre>file:c:\WINNT\Profiles\&lt;username&gt;\WALLETS</pre></li>',
'<li>UNIX-based system: <pre>file:/home/&lt;username&gt;/wallets</pre></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51185817336211269)
,p_name=>'P131_WALLET_PWD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(262167048159555048)
,p_prompt=>'Wallet Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>45
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the password needed to open the Oracle wallet. You do not need to provide a password for',
'auto-login wallets, but must select the <strong>Auto-login Wallet</strong> option to indicate that',
'you are using an auto-login wallet.'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51186010724211269)
,p_name=>'P131_PRINT_SVR_PROTOCOL'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_item_default=>'http'
,p_prompt=>'Protocol'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P16.PRINTSVR.PROTOCOL'
,p_lov=>'.'||wwv_flow_imp.id(41576101209699161)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether the print server uses HTTP or HTTPS protocol.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64572769329929401)
,p_name=>'P131_GETTING_STARTED'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(473748116639968529)
,p_item_default=>'N'
,p_prompt=>'Display Getting Started content'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When enabled, Getting Started information will be displayed on the homepage and other pages.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(66036410030684131)
,p_name=>'P131_PRINT_BIB_LICENSED'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_item_default=>'STANDARD'
,p_prompt=>'Print Server'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BIPUBLISHER_SUPPORT'
,p_lov=>'.'||wwv_flow_imp.id(66524307689014582)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the appropriate option:',
'<ul>',
'<li><strong>None</strong> - Select this option if you are using native printing. Custom report layouts are not supported.</li>',
'<li><strong>Oracle REST Data Services</strong> - Select this option if you are using Oracle REST Data Services 2.0 or newer. This option enables you to use the basic printing functionality, which includes creating report queries and printing report r'
||'egions using the default templates provided in &PRODUCT_NAME. and using your own customized XSL-FO templates. This option is no longer supported as of &PRODUCT_NAME. 19.2.</li>',
'<li><strong>External (Apache FOP)</strong> - Select this option if you are using Apache FOP on an external J2EE server. This option enables you to use the basic printing functionality, which includes creating report queries and printing report region'
||'s using the default templates provided in &PRODUCT_NAME. and using your own customized XSL-FO templates.</li>',
'<li><strong>Oracle BI Publisher</strong> - Select this option if you are using a licensed version of Oracle BI Publisher. This option enables you to take report query results and convert them from XML to RTF format using Oracle BI Publisher. Select t'
||'his option if you want to upload your own customized RTF or XSL-FO templates for printing reports within &PRODUCT_NAME..</li>',
'<li><strong>APEX Office Print</strong> - Select this option if you are using APEX Office Print. This option enables you to use the basic printing functionality, which includes creating report queries and printing report regions using the default temp'
||'lates provided in &PRODUCT_NAME..</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(102775409346934271)
,p_name=>'P131_DISABLE_WS_PROV'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(102772806051895487)
,p_prompt=>'Email Provisioning'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WS_PROVISIONING_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(113228404836854036)||'.'
,p_cHeight=>1
,p_read_only_when=>'P131_EMAIL_CONFIG_VALID'
,p_read_only_when2=>'N'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selecting <strong>Disabled</strong> displays a message you provide that explains why workspace provisioning is disabled.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(102999118515639517)
,p_name=>'P131_DISABLE_WS_MSG'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(102772806051895487)
,p_prompt=>'Message'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>3
,p_read_only_when=>'P131_EMAIL_CONFIG_VALID'
,p_read_only_when2=>'N'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When email provisioning has been disabled, text entered here displays to any user that clicks on a workspace provisioning link. This message should explain that provisioning is currently disabled and when it will be available again.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(103236805427058416)
,p_name=>'P131_REQ_NEW_SCHEMA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(103242102881123907)
,p_prompt=>'Require New Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'Determines if a user requesting a workspace can select an existing schema or must request a new schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115182056127633146)
,p_name=>'P131_INSTANCE_URL_DEFAULT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115182263011633148)
,p_name=>'P131_IMAGES_URL_DEFAULT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(137126007769887471)
,p_name=>'P131_NOTIFICATION_EMAIL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(51160527136211251)
,p_prompt=>'Notification Email Address'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>2000
,p_read_only_when=>'P131_EMAIL_CONFIG_VALID'
,p_read_only_when2=>'N'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the email address to receive notification email messages for new workspace requests and change workspace requests. If not specified, no workspace request notification email messages is sent.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138925711619515767)
,p_name=>'P131_DELETE_UPLOADED_FILES'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(103242102881123907)
,p_prompt=>'Delete Uploaded Files After (days)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the number of days after which &PRODUCT_NAME. automatically deletes uploaded files. This automatic deletion process runs across all workspaces in the &PRODUCT_NAME. instance. The types of files that are deleted includes:</p>',
'',
'<ul>',
'<li>Application Export</li>',
'<li>CSS Export</li>',
'<li>Images Export</li>',
'<li>Page Export</li>',
'<li>Plug-in</li>',
'<li>Script Export</li>',
'<li>Spreadsheet / Text Data Import</li>',
'<li>Static Files Export</li>',
'<li>Themes</li>',
'<li>UI Defaults</li>',
'<li>Workspace Export</li>',
'<li>XML Data Import</li>',
'</ul>',
'',
'<p>This setting must be a positive, whole number.  If this setting is null, then no files will be automatically deleted by &PRODUCT_NAME.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'10000'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183851252666893723)
,p_name=>'P131_API_KEY'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_prompt=>'API Key'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Print Server API Key.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203128029832230759)
,p_name=>'P131_APPLICATION_ID_MIN'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(203127322177179431)
,p_item_default=>'100'
,p_prompt=>'ID Minimum'
,p_source=>'100'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<em>ID Minimum</em> and <em>ID Maximum</em>',
'define the allowed range for APEX application IDs.',
'Enter the lower bound into <em>ID Minimum</em>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'100'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203128222931233942)
,p_name=>'P131_APPLICATION_ID_MAX'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(203127322177179431)
,p_prompt=>'ID Maximum'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<em>ID Minimum</em> and <em>ID Maximum</em>',
'define the allowed range for APEX application IDs.',
'Enter the upper bound into <em>ID Maximum</em>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(222734644042034403)
,p_name=>'P131_RETENTION_PERIOD_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(222734572394034402)
,p_item_default=>'7'
,p_prompt=>'Task Retention Period Days'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the number of days for which completed human tasks will be retained in the instance before being purged. This value cannot be greater than 30 days. Default value is 7 days.'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(262166863470555046)
,p_name=>'P131_SMTP_PASSWORD_CONFIRM'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'Confirm SMTP Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the SMTP password again to confirm.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(262167158590555049)
,p_name=>'P131_WALLET_AUTO_LOGIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(262167048159555048)
,p_prompt=>'Auto-login Wallet'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select this option if your Oracle wallet is an auto-login wallet. Auto-login wallets do not require',
'a password to open.'))
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(262167250023555050)
,p_name=>'P131_WALLET_PWD_CONFIRM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(262167048159555048)
,p_prompt=>'Confirm Wallet Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>45
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the wallet password again to confirm.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(319958832716296914)
,p_name=>'P131_BACKGROUND_JOB_CLASS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(319958722234296913)
,p_prompt=>'Background Job Class'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Identify the DBMS_SCHEDULER Job Class for Automation, REST Synchronization, Human Task Expiry and Report Notification jobs to run in.',
'    This allows to assign these jobs to a specific Resource Manager Consumer group. If not set, the job class <strong>SYS.DEFAULT_JOB_CLASS</strong> will be used. For more information on job classes, consult the Oracle Database Administrators Guide.',
'</p>',
'<p>',
'    Example. Execute with DBA privileges:',
'</p>',
'<pre>',
'-- 1. create the job class',
'--   ',
'begin ',
'    dbms_scheduler.create_job_class(',
'         job_class_name          => ''MY_LOADER_CLASS'', ',
'         -- this assumes that a RES_MGR_LOW_PRIO_GROUP consumer group exists',
'         resource_consumer_group => ''RES_MGR_LOW_PRIO_GROUP'', ',
'         comments                => ''This is a job class for SQL Workshop Data Loading jobs'' );',
'end;',
'/',
'',
'-- 2. grant EXECUTE privilege on the job class to the APEX engine user',
'--',
'grant execute on MY_LOADER_CLASS to apex_NNNNNN',
'/',
'',
'-- 3. configure the job class here or use APEX_INSTANCE_ADMIN.SET_PARAMETER',
'--',
'begin ',
'    apex_instance_admin.set_parameter( ',
'        p_parameter => ''BACKGROUND_JOB_CLASS'', ',
'        p_value     => ''MY_LOADER_CLASS'' ); ',
'end;',
'/',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(342227708889542932)
,p_name=>'P131_CHANGE_SMTP_PWD'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473369805402061276)
,p_name=>'P131_AUTOEXTEND_TABLESPACES'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(103242102881123907)
,p_item_default=>'N'
,p_prompt=>'Auto Extend Tablespaces'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_display_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'If Auto Extend Tablespaces is enabled, tablespaces provisioned with &PRODUCT_NAME. are created with a data file that is one tenth the requested size. The data file will automatically extend up to the requested size. For example, if a user requests a '
||'100 MB workspace, the initial size of the datafile will be 10 MB and it ill automatically extend up to a maximum size of 100 MB.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473830021272979396)
,p_name=>'P131_SYSTEM_HELP_URL'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(473748116639968529)
,p_prompt=>'Help URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter the URL which will be presented to users when they click the "Help" link from within the &PRODUCT_NAME. development environment.  This value does not normally need to be modified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(621102739327076424)
,p_name=>'P131_PRINT_SVR_TIMEOUT'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(51162614555211253)
,p_item_default=>'300'
,p_prompt=>'Print Timeout'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the transfer timeout for communicating with the print server in seconds.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(663452589767166116)
,p_name=>'P131_INSTANCE_TABLESPACE'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_imp.id(103242102881123907)
,p_prompt=>'Instance Tablespace'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_display_when=>'not wwv_flow_global.g_cloud'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of an existing data tablespace, or comma separated list of tablespaces, to use for the database user for all new workspaces. When not set, a new tablespace will be created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(950438226578435659)
,p_name=>'P131_WORKSPACE_EMAIL_MAXIMUM'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(51160113641211250)
,p_prompt=>'Maximum Emails per Workspace'
,p_format_mask=>'9999999999'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Defines the number of email messages that can be sent with the <code>APEX_MAIL</code> API per workspace in a 24-hour period.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'10000000'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(301180743814550004)
,p_computation_sequence=>10
,p_computation_item=>'P131_CHANGE_WALLET_PWD'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- wallet path filled in (exists already or new), but we are changing the wallet password',
'(:P131_WALLET_PATH is not null and (:P131_WALLET_PWD is not null or :P131_WALLET_PWD_CONFIRM is not null))',
'or',
'-- wallet path removed, we will update wallet password to NULL',
'(:P131_WALLET_PATH is null and ',
'wwv_flow_crypto.aes_decrypt_hex (',
'    wwv_flow_platform.get_preference( p_preference_name => ''WALLET_PWD'' ),',
'    sys.wwv_flow_key.g_key ) is not null)',
'-- wallet password wants to be removed for auto-login',
'or :P131_WALLET_AUTO_LOGIN = ''Y'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(301180804673550005)
,p_computation_sequence=>20
,p_computation_item=>'P131_WALLET_PWD'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:P131_WALLET_PATH is null ',
'and ',
'wwv_flow_crypto.aes_decrypt_hex (',
'    wwv_flow_platform.get_preference( p_preference_name => ''WALLET_PWD'' ),',
'    sys.wwv_flow_key.g_key ) is not null)',
'or :P131_WALLET_AUTO_LOGIN = ''Y'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(301180975101550006)
,p_computation_sequence=>30
,p_computation_item=>'P131_WALLET_PWD_CONFIRM'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:P131_WALLET_PATH is null ',
'and ',
'wwv_flow_crypto.aes_decrypt_hex (',
'    wwv_flow_platform.get_preference( p_preference_name => ''WALLET_PWD'' ),',
'    sys.wwv_flow_key.g_key ) is not null)',
'or :P131_WALLET_AUTO_LOGIN = ''Y'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(342227857468542933)
,p_computation_sequence=>40
,p_computation_item=>'P131_CHANGE_SMTP_PWD'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- username filled in (exists already or new), but we are changing the password',
'(:P131_SMTP_USERNAME is not null and (:P131_SMTP_PASSWORD is not null or :P131_SMTP_PASSWORD_CONFIRM is not null))',
'or',
'-- username removed, we will update password to NULL',
'(:P131_SMTP_USERNAME is null and ',
'wwv_flow_crypto.aes_decrypt_hex (',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_PASSWORD'' ),',
'    sys.wwv_flow_key.g_key ) is not null)'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(395969783618132297)
,p_computation_sequence=>50
,p_computation_item=>'P131_SMTP_PASSWORD'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P131_SMTP_USERNAME is null ',
'and ',
'wwv_flow_crypto.aes_decrypt_hex (',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_PASSWORD'' ),',
'    sys.wwv_flow_key.g_key ) is not null'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(301181050614550007)
,p_computation_sequence=>60
,p_computation_item=>'P131_SMTP_PASSWORD_CONFIRM'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P131_SMTP_USERNAME is null ',
'and ',
'wwv_flow_crypto.aes_decrypt_hex (',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_PASSWORD'' ),',
'    sys.wwv_flow_key.g_key ) is not null'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(115182358999633149)
,p_computation_sequence=>10
,p_computation_item=>'P131_INSTANCE_URL_DEFAULT'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.host_url( ''APEX_PATH'' )'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(115182498308633150)
,p_computation_sequence=>20
,p_computation_item=>'P131_IMAGES_URL_DEFAULT'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.host_url( ''IMGPRE'' )'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(22928451529012303)
,p_computation_sequence=>10
,p_computation_item=>'P131_EMAIL_CONFIG_VALID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if wwv_flow_mail.is_email_configured then',
'        return ''Y'';',
'    else',
'        return ''N'';',
'    end if;',
'end;'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(103000728820661486)
,p_validation_name=>'P131_DISABLE_WS_MSG'
,p_validation_sequence=>10
,p_validation=>'P131_DISABLE_WS_MSG'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please enter a message to display to users because workspace provisioning has been disabled.'
,p_validation_condition=>'P131_DISABLE_WS_PROV'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(102999118515639517)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(51188322273211271)
,p_validation_name=>'P131_SMTP_HOST_PORT positive integer'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P131_SMTP_HOST_PORT );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(51170811596211259)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(51188718999211271)
,p_validation_name=>'P131_PRINT_SVR_PORT positive integer'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P131_PRINT_SVR_PORT);',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_validation_condition=>'P131_PRINT_SVR_PORT'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(51176319252211263)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57855403575150538)
,p_validation_name=>'Validate numbers for workspace request size'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'    l_dummy  number;',
'begin',
'    for i in 1..wwv_flow.g_f01.count loop',
'        begin',
'            l_dummy := to_number(wwv_flow.g_f02(i));',
'        exception',
'            when others then',
'                l_result := FALSE;',
'        end;',
'    end loop;',
'    return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'New workspace request size must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57860227124157419)
,p_validation_name=>'Validate numbers for workspace change request size'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'    l_dummy  number;',
'begin',
'    for i in 1..wwv_flow.g_f05.count loop',
'        begin',
'            l_dummy := to_number(wwv_flow.g_f06(i));',
'        exception',
'            when others then',
'                l_result := FALSE;',
'        end;',
'    end loop;',
'    return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Workspace change request size must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57865902583178701)
,p_validation_name=>'Validate one size displayed for New Workspace Request'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := FALSE;',
'begin',
'    for i in 1..wwv_flow.g_f01.count loop',
'        if wwv_flow.g_f03(i) = ''Y'' then',
'            l_result := TRUE;',
'            exit;',
'        end if;',
'    end loop;',
'   return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'At least one new workspace request size must be displayed.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57870422107193812)
,p_validation_name=>'Validate one size displayed for Workspace Change Request'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := FALSE;',
'begin',
'    for i in 1..wwv_flow.g_f05.count loop',
'        if wwv_flow.g_f07(i) = ''Y'' then',
'            l_result := TRUE;',
'            exit;',
'        end if;',
'    end loop;',
'   return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'At least one workspace change request size must be displayed.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57880021807222056)
,p_validation_name=>'Validate default size is displayed for New Workspace Request'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'begin',
'    for i in 1..wwv_flow.g_f01.count loop',
'        if wwv_flow.g_f04(1) = wwv_flow.g_f01(i) then',
'            if wwv_flow.g_f03(i) = ''N'' then',
'                l_result := FALSE;',
'                exit;',
'            end if;',
'        end if;',
'    end loop;',
'   return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The default new workspace request size must be displayed.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57883425532242100)
,p_validation_name=>'Validate default size is displayed for Workspace Change Request'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'begin',
'    for i in 1..wwv_flow.g_f05.count loop',
'        if wwv_flow.g_f08(1) = wwv_flow.g_f05(i) then',
'            if wwv_flow.g_f07(i) = ''N'' then',
'                l_result := FALSE;',
'                exit;',
'            end if;',
'        end if;',
'    end loop;',
'   return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The default workspace change request size must be displayed.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(139697330628568620)
,p_validation_name=>'P131_DELETE_UPLOADED_FILES must be positive, whole number'
,p_validation_sequence=>100
,p_validation=>'P131_DELETE_UPLOADED_FILES'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Delete Uploaded Files After setting must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(138925711619515767)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(208085229932907015)
,p_validation_name=>'P131_APPLICATION_ID_MIN'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   :P131_APPLICATION_ID_MAX is null',
'or :P131_APPLICATION_ID_MIN is not null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Enter a Minimum ID if a Maximum ID is specified'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(203128029832230759)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(621102866377076425)
,p_validation_name=>'transfer timeout in seconds'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P131_PRINT_SVR_TIMEOUT);',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Transfer timeout must be a number greater than 0.'
,p_associated_item=>wwv_flow_imp.id(621102739327076424)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(301181105115550008)
,p_validation_name=>'Validate SMTP passwords match'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P131_CHANGE_SMTP_PWD = ''Y'' then',
'    -- reset password to null if we are removing the username',
'    if :P131_SMTP_USERNAME is null and wwv_flow_crypto.aes_decrypt_hex (',
'        wwv_flow_platform.get_preference( p_preference_name => ''SMTP_PASSWORD'' ),',
'        sys.wwv_flow_key.g_key ) is not null then ',
'        return true;',
'    -- password changed and do not match',
'    elsif :P131_SMTP_PASSWORD <> :P131_SMTP_PASSWORD_CONFIRM or :P131_SMTP_PASSWORD_CONFIRM is null or :P131_SMTP_PASSWORD is null then ',
'        :P131_CHANGE_SMTP_PWD := null;',
'        return false;',
'    else ',
'        return true;',
'    end if;',
'else ',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'SMTP passwords do not match.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(262166863470555046)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(301181261363550009)
,p_validation_name=>'Validate Wallet passwords match'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P131_CHANGE_WALLET_PWD = ''Y'' then',
'    -- ignore password with auto login',
'    if :P131_WALLET_AUTO_LOGIN = ''Y'' then ',
'        return true;',
'    -- reset password to null if we are removing the path',
'    elsif :P131_WALLET_PATH is null and wwv_flow_crypto.aes_decrypt_hex (',
'        wwv_flow_platform.get_preference( p_preference_name => ''WALLET_PWD'' ),',
'        sys.wwv_flow_key.g_key ) is not null then ',
'        return true;',
'    -- password changed and do not match',
'    elsif :P131_WALLET_PWD <> :P131_WALLET_PWD_CONFIRM or :P131_WALLET_PWD is null or :P131_WALLET_PWD_CONFIRM is null then ',
'        :P131_CHANGE_WALLET_PWD := null;',
'        return false;',
'    else ',
'        return true;',
'    end if;',
'else ',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Wallet passwords do not match.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(262167250023555050)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23600297257863818)
,p_validation_name=>'Default Reporting Period > 0'
,p_validation_sequence=>150
,p_validation=>':P131_DEFAULT_REPORTING_PERIOD > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Default Reporting Period must be greater than 0.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(21674153872910609)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23600350295863819)
,p_validation_name=>'Maximum Reporting Period > Default Reporting Period'
,p_validation_sequence=>160
,p_validation=>':P131_MAX_REPORTING_PERIOD > 0 and to_number(:P131_MAX_REPORTING_PERIOD) >= to_number(:P131_DEFAULT_REPORTING_PERIOD)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Maximum Reporting Period must be greater than or equal to the default reporting period.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(21674202445910610)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23600476281863820)
,p_validation_name=>'Free Space Limit > 0'
,p_validation_sequence=>170
,p_validation=>':P131_WKSP_FREE_SPACE_LIMIT > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Workspace Free Space Limit must be greater than 0.'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(21674347266910611)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2816140928275639)
,p_validation_name=>'Cloud Credential Required'
,p_validation_sequence=>180
,p_validation=>'P131_DOCGEN_CLOUD_CREDENTIAL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P131_PRINT_BIB_LICENSED'
,p_validation_condition2=>'DOCUMENT_GENERATOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(2816022202275638)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2816216029275640)
,p_validation_name=>'Namespace Required'
,p_validation_sequence=>190
,p_validation=>'P131_DOCGEN_OBS_NAMESPACE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P131_PRINT_BIB_LICENSED'
,p_validation_condition2=>'DOCUMENT_GENERATOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(2814368091275621)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2816394615275641)
,p_validation_name=>'Compartment OCID Required'
,p_validation_sequence=>200
,p_validation=>'P131_DOCGEN_COMPARTMENT_OCID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P131_PRINT_BIB_LICENSED'
,p_validation_condition2=>'DOCUMENT_GENERATOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(2814432712275622)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2816487627275642)
,p_validation_name=>'OS Endpoint Required'
,p_validation_sequence=>210
,p_validation=>'P131_DOCGEN_OS_ENDPOINT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P131_PRINT_BIB_LICENSED'
,p_validation_condition2=>'DOCUMENT_GENERATOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(2814551085275623)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2816521075275643)
,p_validation_name=>'Function OCID Required'
,p_validation_sequence=>220
,p_validation=>'P131_DOCGEN_FUNCTION_OCID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P131_PRINT_BIB_LICENSED'
,p_validation_condition2=>'DOCUMENT_GENERATOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(2814674979275624)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2816661786275644)
,p_validation_name=>'Function Endpoint Required'
,p_validation_sequence=>230
,p_validation=>'P131_DOCGEN_FUNCTION_URI'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P131_PRINT_BIB_LICENSED'
,p_validation_condition2=>'DOCUMENT_GENERATOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(51164206531211254)
,p_associated_item=>wwv_flow_imp.id(2814793637275625)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8024913989822393)
,p_name=>'disable print settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P131_PRINT_BIB_LICENSED'
,p_condition_element=>'P131_PRINT_BIB_LICENSED'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'APEX_LISTENER, NONE, DOCUMENT_GENERATOR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8025226260822401)
,p_event_id=>wwv_flow_imp.id(8024913989822393)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_PRINT_SVR_PROTOCOL,P131_PRINT_SVR_HOST,P131_PRINT_SVR_PORT,P131_PRINT_SVR_SCRIPT,P131_PRINT_SVR_TIMEOUT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8025428770822403)
,p_event_id=>wwv_flow_imp.id(8024913989822393)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_PRINT_SVR_PROTOCOL,P131_PRINT_SVR_HOST,P131_PRINT_SVR_PORT,P131_PRINT_SVR_SCRIPT,P131_PRINT_SVR_TIMEOUT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(189719304618358023)
,p_event_id=>wwv_flow_imp.id(8024913989822393)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_PRINT_SVR_PROTOCOL,P131_PRINT_SVR_HOST,P131_PRINT_SVR_PORT,P131_PRINT_SVR_SCRIPT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(183851346897893724)
,p_name=>'Enable API Key'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P131_PRINT_BIB_LICENSED'
,p_condition_element=>'P131_PRINT_BIB_LICENSED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AOP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(183851482372893725)
,p_event_id=>wwv_flow_imp.id(183851346897893724)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_API_KEY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(183851593197893726)
,p_event_id=>wwv_flow_imp.id(183851346897893724)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_API_KEY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(301180477013550001)
,p_name=>'Disable Wallet Password'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P131_WALLET_AUTO_LOGIN'
,p_condition_element=>'P131_WALLET_AUTO_LOGIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(301180502419550002)
,p_event_id=>wwv_flow_imp.id(301180477013550001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_WALLET_PWD,P131_WALLET_PWD_CONFIRM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(301180641861550003)
,p_event_id=>wwv_flow_imp.id(301180477013550001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_WALLET_PWD,P131_WALLET_PWD_CONFIRM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2814852022275626)
,p_name=>'Show/Hide DocGen Settings'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P131_PRINT_BIB_LICENSED'
,p_condition_element=>'P131_PRINT_BIB_LICENSED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DOCUMENT_GENERATOR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2814928741275627)
,p_event_id=>wwv_flow_imp.id(2814852022275626)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_DOCGEN_OBS_NAMESPACE,P131_DOCGEN_COMPARTMENT_OCID,P131_DOCGEN_OS_ENDPOINT,P131_DOCGEN_FUNCTION_OCID,P131_DOCGEN_FUNCTION_URI,P131_DOCGEN_CLOUD_CREDENTIAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2815094752275628)
,p_event_id=>wwv_flow_imp.id(2814852022275626)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_DOCGEN_OBS_NAMESPACE,P131_DOCGEN_COMPARTMENT_OCID,P131_DOCGEN_OS_ENDPOINT,P131_DOCGEN_FUNCTION_OCID,P131_DOCGEN_FUNCTION_URI,P131_DOCGEN_CLOUD_CREDENTIAL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(51189632142211272)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P131_SERVICE_REQUEST_FLOW := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SERVICE_REQUEST_FLOW'' );',
'',
':P131_INSTANCE_URL := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''EMAIL_INSTANCE_URL'' );',
'',
':P131_INSTANCE_TABLESPACE := ',
'     wwv_flow_platform.get_preference( p_preference_name => ''INSTANCE_TABLESPACE'');',
'',
':P131_IMAGES_URL := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''EMAIL_IMAGES_URL'' );',
'',
':P131_DISABLE_WS_PROV := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''DISABLE_WS_PROV'' );',
'',
'if nvl(:P131_DISABLE_WS_PROV,''x'') = ''Y'' then',
'   :P131_DISABLE_WS_MSG := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''DISABLE_WS_MSG'' );',
'end if;',
'',
':P131_req_new_schema := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''REQ_NEW_SCHEMA'' );',
'',
':P131_SMTP_FROM := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_FROM'' );',
'',
':P131_SMTP_HOST_ADDRESS := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_HOST_ADDRESS'' );',
'',
':P131_SMTP_HOST_PORT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_HOST_PORT'' );',
'',
':P131_SMTP_USERNAME := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_USERNAME'' );',
'',
':P131_SMTP_PASSWORD := ',
'    wwv_flow_crypto.aes_decrypt_hex (',
'        wwv_flow_platform.get_preference( p_preference_name => ''SMTP_PASSWORD'' ),',
'        sys.wwv_flow_key.g_key );',
'',
':P131_SMTP_PASSWORD_CONFIRM := ',
'    wwv_flow_crypto.aes_decrypt_hex (',
'        wwv_flow_platform.get_preference( p_preference_name => ''SMTP_PASSWORD'' ),',
'        sys.wwv_flow_key.g_key );',
'',
':P131_SMTP_TLS_MODE := ',
'    nvl(wwv_flow_platform.get_preference( p_preference_name => ''SMTP_TLS_MODE'' ), ''N'');',
'',
':P131_PRINT_BIB_LICENSED  := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_BIB_LICENSED'' );',
'',
':P131_PRINT_SVR_PROTOCOL := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_PROTOCOL'' );',
'',
':P131_PRINT_SVR_HOST := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_HOST'' );',
'',
':P131_PRINT_SVR_PORT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_PORT'' );',
'',
':P131_PRINT_SVR_SCRIPT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_SCRIPT'' );',
'',
':P131_API_KEY := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_API_KEY'' );',
'',
':P131_PRINT_SVR_TIMEOUT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_TIMEOUT'' );',
'',
'--DocGen Parameters  ',
':P131_DOCGEN_CLOUD_CREDENTIAL :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DOCGEN_CREDENTIAL'' );',
'',
':P131_DOCGEN_OBS_NAMESPACE :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DOCGEN_OS_NAMESPACE'' );',
'',
':P131_DOCGEN_COMPARTMENT_OCID :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DOCGEN_OS_BUCKET_COMPARTMENT_OCID'' );',
'',
':P131_DOCGEN_OS_ENDPOINT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''DOCGEN_OS_ENDPOINT'' );',
'',
':P131_DOCGEN_FUNCTION_OCID :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DOCGEN_FUNCTION_OCID'' );',
'',
':P131_DOCGEN_FUNCTION_URI :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DOCGEN_INVOKE_ENDPOINT'' );',
'--',
'',
':P131_BIGFILE_TABLESPACES :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''BIGFILE_TABLESPACES_ENABLED'' );',
'',
':P131_ENCRYPTED_TABLESPACES :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''ENCRYPTED_TABLESPACES_ENABLED'' );',
'',
':P131_AUTOAPPROVE_STORAGE := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''AUTOAPPROVE_STORAGE_LIMIT'' );',
'',
'declare',
'    l_wallet wwv_flow_security.t_wallet := wwv_flow_security.get_wallet;',
'begin',
'    -- :P131_WALLET_PATH := l_wallet.wallet_path;',
'    -- :P131_WALLET_PWD := l_wallet.wallet_pwd;',
'    :P131_WALLET_PATH := wwv_flow_platform.get_preference( p_preference_name => ''WALLET_PATH'' );',
'    :P131_WALLET_PWD := l_wallet.wallet_pwd;',
'    :P131_WALLET_PWD_CONFIRM := l_wallet.wallet_pwd;',
'    if :P131_WALLET_PWD is null then',
'        :P131_WALLET_AUTO_LOGIN := ''Y'';',
'    end if;',
'end;',
'',
':P131_NOTIFICATION_EMAIL :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''NOTIFICATION_EMAIL'' );',
'',
':P131_AUTOEXTEND_TABLESPACES :=     ',
'    wwv_flow_platform.get_preference( p_preference_name => ''AUTOEXTEND_TABLESPACES'' );',
'',
':P131_DELETE_UPLOADED_FILES :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DELETE_UPLOADED_FILES_AFTER_DAYS'' );',
'',
':P131_GALLERY_FILE_URLS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''GALLERY_FILE_URLS'' );',
'',
':P131_GALLERY_BACKGRND_INSTALL :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''GALLERY_BACKGROUND_INSTALL'' );',
'    ',
':P131_SYSTEM_HELP_URL :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''SYSTEM_HELP_URL'' );',
'',
':P131_GETTING_STARTED := ',
'    wwv_flow_platform.get_preference( p_preference_name  => ''GETTING_STARTED_ENABLED'' );',
'',
':P131_WORKSPACE_EMAIL_MAXIMUM :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_EMAIL_MAXIMUM'' );',
'',
':P131_MAX_MAIL_QUEUE_ROWS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''MAX_MAIL_QUEUE_ROWS'' );',
'',
':P131_APPLICATION_ID_MIN :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''APPLICATION_ID_MIN'' );',
'',
':P131_APPLICATION_ID_MAX :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''APPLICATION_ID_MAX'' );',
'    ',
':P131_BACKGROUND_JOB_CLASS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''BACKGROUND_JOB_CLASS'' );',
'',
':P131_BG_PAGE_PROC_JOB_CLASS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''BACKGROUND_PROCESS_JOB_CLASS'' );',
'    ',
':P131_BACKGRND_MIN_EXEC_CADENCE :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''BACKGROUND_MIN_EXECUTION_CADENCE'' );',
'    ',
':P131_RETENTION_PERIOD_DAYS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''TASK_RETENTION_PERIOD_DAYS'' );',
'',
':P131_WF_RETENTION_DAYS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKFLOW_RETENTION_PERIOD_DAYS'' );',
'',
'-- Administrator Digest (feature #4087)',
':P131_DEFAULT_REPORTING_PERIOD :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'' );',
'',
':P131_MAX_REPORTING_PERIOD :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''ADMIN_DIGEST_MAX_REPORTING_PERIOD'' );',
'',
':P131_WKSP_FREE_SPACE_LIMIT :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_FREE_SPACE_LIMIT'' );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>51189632142211272
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(51189800276211273)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* replaced with call to set_provisioning_method()',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''SERVICE_REQUEST_FLOW'',',
'    p_preference_value => :P131_SERVICE_REQUEST_FLOW );',
'*/',
'',
'wwv_flow_admin_api.set_provisioning_method(',
'    p_method => :P131_SERVICE_REQUEST_FLOW );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''EMAIL_INSTANCE_URL'',',
'    p_preference_value => :P131_INSTANCE_URL );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''EMAIL_IMAGES_URL'',',
'    p_preference_value => :P131_IMAGES_URL );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''DISABLE_WS_PROV'',',
'    p_preference_value => :P131_DISABLE_WS_PROV );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''INSTANCE_TABLESPACE'',',
'    p_preference_value => :P131_INSTANCE_TABLESPACE );',
'    ',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''BACKGROUND_JOB_CLASS'',',
'    p_preference_value => :P131_BACKGROUND_JOB_CLASS );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''BACKGROUND_PROCESS_JOB_CLASS'',',
'    p_preference_value => :P131_BG_PAGE_PROC_JOB_CLASS );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''BACKGROUND_MIN_EXECUTION_CADENCE'',',
'    p_preference_value => :P131_BACKGRND_MIN_EXEC_CADENCE );',
'',
'if nvl(:P131_DISABLE_WS_PROV,''x'') = ''Y'' then',
'   wwv_flow_platform.set_preference(',
'       p_preference_name  => ''DISABLE_WS_MSG'',',
'       p_preference_value => :P131_DISABLE_WS_MSG );',
'end if;',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''REQ_NEW_SCHEMA'',',
'    p_preference_value => :P131_req_new_schema );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SMTP_FROM'',',
'    p_preference_value => :P131_SMTP_FROM );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''SMTP_HOST_ADDRESS'',',
'    p_preference_value => :P131_SMTP_HOST_ADDRESS );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SMTP_HOST_PORT'',',
'    p_preference_value => :P131_SMTP_HOST_PORT );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SMTP_USERNAME'',',
'    p_preference_value => :P131_SMTP_USERNAME );',
'',
'if :P131_CHANGE_SMTP_PWD = ''Y'' then',
'    wwv_flow_platform.set_preference(',
'        p_preference_name  => ''SMTP_PASSWORD'',',
'        p_preference_value => wwv_flow_crypto.aes_encrypt_hex (',
'                              p_src => :P131_SMTP_PASSWORD,',
'                              p_key => sys.wwv_flow_key.g_key ) );',
'end if;',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SMTP_TLS_MODE'',',
'    p_preference_value => :P131_SMTP_TLS_MODE );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''PRINT_BIB_LICENSED'',',
'    p_preference_value => :P131_PRINT_BIB_LICENSED );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_PROTOCOL'',',
'    p_preference_value => :P131_PRINT_SVR_PROTOCOL );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_HOST'',',
'    p_preference_value => :P131_PRINT_SVR_HOST );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_PORT'',',
'    p_preference_value => :P131_PRINT_SVR_PORT );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_SCRIPT'',',
'    p_preference_value => :P131_PRINT_SVR_SCRIPT );',
'    ',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_TIMEOUT'',',
'    p_preference_value => :P131_PRINT_SVR_TIMEOUT );    ',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_API_KEY'',',
'    p_preference_value => :P131_API_KEY );',
'',
' --DocGen Settings   ',
' wwv_flow_platform.set_preference(',
'    p_preference_name  => ''DOCGEN_CREDENTIAL'',',
'    p_preference_value => :P131_DOCGEN_CLOUD_CREDENTIAL );',
'    ',
' wwv_flow_platform.set_preference(',
'    p_preference_name  => ''DOCGEN_OS_NAMESPACE'',',
'    p_preference_value => :P131_DOCGEN_OBS_NAMESPACE );',
'',
' wwv_flow_platform.set_preference(',
'    p_preference_name  => ''DOCGEN_OS_BUCKET_COMPARTMENT_OCID'',',
'    p_preference_value => :P131_DOCGEN_COMPARTMENT_OCID );',
'',
' wwv_flow_platform.set_preference(',
'    p_preference_name  => ''DOCGEN_OS_ENDPOINT'',',
'    p_preference_value => :P131_DOCGEN_OS_ENDPOINT );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''DOCGEN_FUNCTION_OCID'',',
'    p_preference_value => :P131_DOCGEN_FUNCTION_OCID );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''DOCGEN_INVOKE_ENDPOINT'',',
'    p_preference_value => :P131_DOCGEN_FUNCTION_URI );',
'--',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''AUTOEXTEND_TABLESPACES'',',
'    p_preference_value => :P131_AUTOEXTEND_TABLESPACES );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''AUTOAPPROVE_STORAGE_LIMIT'',',
'    p_preference_value => :P131_AUTOAPPROVE_STORAGE );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''DELETE_UPLOADED_FILES_AFTER_DAYS'',',
'    p_preference_value => :P131_DELETE_UPLOADED_FILES );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''GALLERY_FILE_URLS'',',
'    p_preference_value => :P131_GALLERY_FILE_URLS );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''GALLERY_BACKGROUND_INSTALL'',',
'    p_preference_value => :P131_GALLERY_BACKGRND_INSTALL );',
'    ',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SYSTEM_HELP_URL'',',
'    p_preference_value => :P131_SYSTEM_HELP_URL );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''GETTING_STARTED_ENABLED'',',
'    p_preference_value => :P131_GETTING_STARTED );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''WORKSPACE_EMAIL_MAXIMUM'',',
'    p_preference_value => :P131_WORKSPACE_EMAIL_MAXIMUM );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''MAX_MAIL_QUEUE_ROWS'',',
'    p_preference_value => :P131_MAX_MAIL_QUEUE_ROWS );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''BIGFILE_TABLESPACES_ENABLED'',',
'    p_preference_value => :P131_BIGFILE_TABLESPACES );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''ENCRYPTED_TABLESPACES_ENABLED'',',
'    p_preference_value => :P131_ENCRYPTED_TABLESPACES );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''APPLICATION_ID_MIN'',',
'    p_preference_value => :P131_APPLICATION_ID_MIN );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''APPLICATION_ID_MAX'',',
'    p_preference_value => :P131_APPLICATION_ID_MAX );',
'',
' wwv_flow_platform.set_preference(',
'    p_preference_name  => ''TASK_RETENTION_PERIOD_DAYS'',',
'    p_preference_value => :P131_RETENTION_PERIOD_DAYS);',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''WORKFLOW_RETENTION_PERIOD_DAYS'',',
'    p_preference_value => :P131_WF_RETENTION_DAYS);',
'   ',
'',
'declare',
'    l_wallet wwv_flow_security.t_wallet;',
'begin',
'    l_wallet := wwv_flow_security.get_wallet;',
'    l_wallet.wallet_path := :P131_WALLET_PATH;',
'    if :P131_CHANGE_WALLET_PWD = ''Y'' then',
'        l_wallet.wallet_pwd  := :P131_WALLET_PWD;',
'    end if;',
'    wwv_flow_security.set_wallet(l_wallet);',
'end;',
'',
'--',
'-- Update the rows for new workspace request sizes',
'--',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'    update wwv_flow_workspace_req_size',
'       set req_size = wwv_flow.g_f02(i),',
'           display = wwv_flow.g_f03(i),',
'           default_size = decode(wwv_flow.g_f04(1),wwv_flow.g_f01(i),''Y'',''N'')',
'     where id = wwv_flow.g_f01(i);',
'end loop;',
'',
'--',
'-- Update the rows for new workspace request sizes',
'--',
'for i in 1..wwv_flow.g_f05.count loop',
'    update wwv_flow_workspace_req_size',
'       set req_size = wwv_flow.g_f06(i),',
'           display = wwv_flow.g_f07(i),',
'           default_size = decode(wwv_flow.g_f08(1),wwv_flow.g_f05(i),''Y'',''N'')',
'     where id = wwv_flow.g_f05(i);',
'end loop;',
'',
'-- Administrator Digest (feature #4087)',
'wwv_flow_platform.set_preference(',
'    p_preference_name => ''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'',',
'    p_preference_value => :P131_DEFAULT_REPORTING_PERIOD );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name => ''ADMIN_DIGEST_MAX_REPORTING_PERIOD'',',
'    p_preference_value => :P131_MAX_REPORTING_PERIOD );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name => ''WORKSPACE_FREE_SPACE_LIMIT'',',
'    p_preference_value => :P131_WKSP_FREE_SPACE_LIMIT );',
'',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save Instance settings.'
,p_process_when_button_id=>wwv_flow_imp.id(51164206531211254)
,p_process_success_message=>'Instance settings saved.'
,p_internal_uid=>51189800276211273
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(51190008410211273)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'131'
,p_internal_uid=>51190008410211273
);
end;
/
prompt --application/pages/page_00132
begin
wwv_flow_imp_page.create_page(
 p_id=>132
,p_name=>'System Message'
,p_alias=>'SYSTEM-MESSAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'System Message'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216766702444596508)
,p_step_template=>wwv_flow_imp.id(721103220819687982)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'450'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_env_sec.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51277208235355971)
,p_plug_name=>'System Message'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>150
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955889433218997305)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955889525421997306)
,p_plug_name=>'System Message'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51281510605355975)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(955889433218997305)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51281700671355975)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(955889433218997305)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168507923702817963)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51284327975355978)
,p_name=>'P132_CUSTOM_SYSTEM_MESSAGE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(51277208235355971)
,p_prompt=>'Message'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter the text to be displayed on the &PRODUCT_NAME. home pages. This text can include HTML.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(206355098017953023)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(51281510605355975)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(206355114399953024)
,p_event_id=>wwv_flow_imp.id(206355098017953023)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(51307110864355993)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- System message',
'--',
':P132_CUSTOM_SYSTEM_MESSAGE := wwv_flow_platform.get_preference( p_preference_name => ''SYSTEM_MESSAGE'' );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>51307110864355993
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(51307320446355994)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- If custom system message, then set the actual message to be displayed.',
'--',
'if trim( :P132_CUSTOM_SYSTEM_MESSAGE ) is not null then',
'    wwv_flow_platform.set_preference( p_preference_name  => ''SYSTEM_MESSAGE'',',
'                                      p_preference_value => trim( :P132_CUSTOM_SYSTEM_MESSAGE ) );',
'else',
'    --',
'    -- Otherwise, clear out the message.',
'    --',
'    wwv_flow_platform.set_preference( p_preference_name => ''SYSTEM_MESSAGE'',',
'                                      p_preference_value => null );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to update System Message.'
,p_process_when_button_id=>wwv_flow_imp.id(51281700671355975)
,p_process_success_message=>'System Message updated.'
,p_internal_uid=>51307320446355994
);
end;
/
prompt --application/pages/page_00133
begin
wwv_flow_imp_page.create_page(
 p_id=>133
,p_name=>'Workspace Purge Settings'
,p_alias=>'WORKSPACE-PURGE-SETTINGS'
,p_step_title=>'Workspace Purge Settings'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(704456563630760825)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_purge_wrkspc.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(499047717270425788)
,p_plug_name=>'Workspace Purge Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505870209144885310)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Workspaces that are inactive for more than the <strong>Days Inactive</strong> are candidates for purging.  If the workspace continues to be inactive and a workspace administrator does not indicate that they wish to have their workspace retained wi'
||'thin <strong>Days Until Purge</strong>, the workspace will be purged.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1000726106612503643)
,p_plug_name=>'Workspace Purge Settings'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(505870712392895770)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_button_name=>'MONITOR_ACTIVITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Monitor Activity'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:99::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(499039317740409355)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1000726106612503643)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(499039505384409356)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1000726106612503643)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(499041117486416415)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499058222306540814)
,p_name=>'P133_ENABLED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_item_default=>'N'
,p_prompt=>'Enabled'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enabling the Workspace Purge process will result in a database job running nightly which will examine your instance for inactive workspaces, notify the workspace administrators via an email message that their workspaces will be purged, and give the w'
||'orkspace administrators an option to not have their workspace purged.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499080721463729720)
,p_name=>'P133_ADMIN_EMAIL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_item_default=>'wwv_flow_platform.get_preference( p_preference_name => ''SMTP_FROM'' )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Purge Administration Email Address'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the email address that will be used for the Workspace Purge process.  This email address will be used as the "From" address in email messages sent to workspace administrators.  It will also be used on the Workspace Purge page, for users to cont'
||'act if they have questions or issues.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499096026442740631)
,p_name=>'P133_SUMMARY_EMAIL_TO'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_item_default=>'wwv_flow_platform.get_preference( p_preference_name => ''NOTIFICATION_EMAIL'' )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Send Summary Email To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a comma-separated list of email addresses to receive the Automatic Workspace Purge daily summary report via email.  If no email addresses are specified, no summary report will be generated.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499096813067746221)
,p_name=>'P133_DAYS_TO_PURGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_item_default=>'10'
,p_prompt=>'Days Until Purge'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the number of days a workspace administrator is given between the first notification email that their workspace will be purged and when it is actually purged.  For example, a value of ''10'' means that each workspace administrator is notified via'
||' email that their workspace will be purged in 10 days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499097827743759953)
,p_name=>'P133_REMINDER_DAYS_IN_ADVANCE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_item_default=>'3'
,p_prompt=>'Reminder Days In Advance'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the number of days before a workspace is to be purged to send a reminder email to the workspace administrator.  This number must be less than the Days Until Purge value.  For example, if a value of ''3'' is specified, a reminder email is sent to '
||'each workspace administrator 3 days before their workspace will be purged.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499098203979762532)
,p_name=>'P133_DAYS_INACTIVE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_item_default=>'45'
,p_prompt=>'Days Inactive'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the number of days of inactivity for the Workspace Purge process to mark a workspace as inactive.  Inactive means that no one has logged into the workspace, nor has any application in the workspace been used during this period.  For example, a '
||'value of ''45'' means that a workspace will be deemed ''Inactive'' if it has not been used in the last 45 days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499098415754765978)
,p_name=>'P133_GRACE_PERIOD_DAYS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_item_default=>'45'
,p_prompt=>'Grace Period (Days)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the number of days a workspace administrator is given when the workspace is considered inactive again.  This only applies to inactive workspaces which have previously been marked as inactive and the workspace administrator indicated to not purg'
||'e the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499098709997773731)
,p_name=>'P133_MAX_RUN_HOURS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_prompt=>'Maximum Execution Time (Hours)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the maximum amount of time, in hours, that the Workspace Purge process can run per day.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499098922464777386)
,p_name=>'P133_MAX_WORKSPACES'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_prompt=>'Maximum Number of Workspaces'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the maximum number of workspaces that can be purged by the Workspace Purge process during each execution.  For example, if the value of ''Maximum Number of Workspaces'' is set to ''1'', then up to 1 workspace can be purged per day by the Workspace '
||'Purge process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499099100432780444)
,p_name=>'P133_MAX_EMAILS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_prompt=>'Maximum Number of Emails'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the maximum number of emails that can be sent by the Workspace Purge process during each execution.  For example, if the value of ''Maximum Number of Emails'' is set to ''10'', then up to 10 emails will be sent per day by the Workspace Purge proces'
||'s.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(502998908381251930)
,p_name=>'P133_PURGE_LANG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(499047717270425788)
,p_item_default=>'wwv_flow.g_browser_language'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Language'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGES_INSTALLED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lang_name, flow_language from ',
'(select (select max( translated_lang_name) from wwv_flow_languages l where l.lang_id = f.flow_language) lang_name, flow_language',
'  from wwv_flows f',
' where id = 4411',
'   and security_group_id = 10',
' union',
' select (select max(translated_lang_name) from wwv_flow_languages l where l.lang_id = f.flow_language) lang_name, flow_language',
'   from wwv_flows f',
'  where security_group_id = 10',
'    and id in ',
'      ( select translation_flow_id',
'          from wwv_flow_language_map',
'         where security_group_id = 10',
'           and primary_language_flow_id = 4411)',
'  order by 1)'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the language to be used in the emails generated from the Workspace Purge process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(502716121149177100)
,p_validation_name=>'P133_ADMIN_EMAIL'
,p_validation_sequence=>20
,p_validation=>'P133_ADMIN_EMAIL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(499080721463729720)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(502716430845179900)
,p_validation_name=>'P133_DAYS_INACTIVE'
,p_validation_sequence=>30
,p_validation=>'P133_DAYS_INACTIVE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(499098203979762532)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(502716603272181381)
,p_validation_name=>'P133_DAYS_TO_PURGE'
,p_validation_sequence=>40
,p_validation=>'P133_DAYS_TO_PURGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(499096813067746221)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(502717308813183024)
,p_validation_name=>'P133_GRACE_PERIOD_DAYS'
,p_validation_sequence=>50
,p_validation=>'P133_GRACE_PERIOD_DAYS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(499098415754765978)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(502717515046184868)
,p_validation_name=>'P133_REMINDER_DAYS_IN_ADVANCE'
,p_validation_sequence=>60
,p_validation=>'P133_REMINDER_DAYS_IN_ADVANCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(499097827743759953)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(502677028187037234)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_ENABLED'',',
'                                  p_preference_value => :P133_ENABLED );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_LANG'',',
'                                  p_preference_value => :P133_PURGE_LANG );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_ADMIN_EMAIL'',',
'                                  p_preference_value => :P133_ADMIN_EMAIL );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_SUMMARY_EMAIL_TO'',',
'                                  p_preference_value => :P133_SUMMARY_EMAIL_TO );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_DAYS_TO_PURGE'',',
'                                  p_preference_value => :P133_DAYS_TO_PURGE );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_REMINDER_DAYS_IN_ADVANCE'',',
'                                  p_preference_value => :P133_REMINDER_DAYS_IN_ADVANCE );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_DAYS_INACTIVE'',',
'                                  p_preference_value => :P133_DAYS_INACTIVE );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_GRACE_PERIOD_DAYS'',',
'                                  p_preference_value => :P133_GRACE_PERIOD_DAYS );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_MAX_RUN_HOURS'',',
'                                  p_preference_value => :P133_MAX_RUN_HOURS );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_MAX_WORKSPACES'',',
'                                  p_preference_value => :P133_MAX_WORKSPACES );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_MAX_EMAILS'',',
'                                  p_preference_value => :P133_MAX_EMAILS );',
'--'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save workspace purge settings.'
,p_process_when_button_id=>wwv_flow_imp.id(499039505384409356)
,p_process_success_message=>'Workspace purge settings saved.'
,p_internal_uid=>502677028187037234
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(502505801129001088)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Purge Preference Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P133_ENABLED := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_ENABLED'' );',
':P133_ADMIN_EMAIL := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_ADMIN_EMAIL'' );',
':P133_SUMMARY_EMAIL_TO := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_SUMMARY_EMAIL_TO'' );',
':P133_DAYS_TO_PURGE := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_DAYS_TO_PURGE'' );',
':P133_REMINDER_DAYS_IN_ADVANCE := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_REMINDER_DAYS_IN_ADVANCE'' );',
':P133_DAYS_INACTIVE := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_DAYS_INACTIVE'' );',
':P133_GRACE_PERIOD_DAYS := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_GRACE_PERIOD_DAYS'' );',
':P133_MAX_RUN_HOURS := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_MAX_RUN_HOURS'' );',
':P133_MAX_WORKSPACES := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_MAX_WORKSPACES'' );',
':P133_MAX_EMAILS := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_MAX_EMAILS'' );',
':P133_PURGE_LANG := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_LANG'' );',
'--',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>502505801129001088
);
end;
/
prompt --application/pages/page_00135
begin
wwv_flow_imp_page.create_page(
 p_id=>135
,p_name=>'Create Multiple Workspaces'
,p_alias=>'CREATE-MULTIPLE-WORKSPACES'
,p_step_title=>'Create Multiple Workspaces'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931243707245169747)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388175530101368961)
,p_plug_name=>'Create Multiple Workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(388175723863368963)
,p_name=>'Workspace Administrators'
,p_parent_plug_id=>wwv_flow_imp.id(388175530101368961)
,p_display_sequence=>30
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lower(c001) username, ',
'       lower(c002) email, ',
'       c003 workspace,',
'       c013 schema,',
'       c006 tab,',
'       c007 quota,',
'       c009 consumer_group,',
'       c010 invite,',
'       c011 auto_purge,',
'       decode(c012,null,null,substr(c012,1,5)||''...'') comments,',
'       SEQ_ID',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388175927775368964)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>2
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388176006661368964)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>3
,p_column_heading=>'Email'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388177113081368964)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388313116913954235)
,p_query_column_id=>4
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>13
,p_column_heading=>'Database Schema'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388176624329368964)
,p_query_column_id=>5
,p_column_alias=>'TAB'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388176311196368964)
,p_query_column_id=>6
,p_column_alias=>'QUOTA'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388176121257368964)
,p_query_column_id=>7
,p_column_alias=>'CONSUMER_GROUP'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388176210056368964)
,p_query_column_id=>8
,p_column_alias=>'INVITE'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388176931692368964)
,p_query_column_id=>9
,p_column_alias=>'AUTO_PURGE'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388177027338368964)
,p_query_column_id=>10
,p_column_alias=>'COMMENTS'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(388176806010368964)
,p_query_column_id=>11
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388177705986368965)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_source=>'<p>The following workspaces have been provisioned. Please make a note of this information.</p>'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388177907687368965)
,p_plug_name=>'create multiple workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(203141106443364145)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388178122034368965)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752112983897695873)
,p_plug_name=>'Create Multiple Workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(388178328415368965)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(388178122034368965)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(388178720999368966)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(388178122034368965)
,p_button_name=>'DONE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Done'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_00136
begin
wwv_flow_imp_page.create_page(
 p_id=>136
,p_name=>'Developer Authentication Scheme'
,p_alias=>'DEVELOPER-AUTHENTICATION-SCHEME'
,p_step_title=>'Developer Authentication Scheme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_config_sec.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(39564106377656610)
,p_plug_name=>'SAML for Internal and Workspace Applications: Identity Provider Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P136_SCHEME_TYPE'
,p_plug_display_when_cond2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117761677507717707)
,p_plug_name=>'OAuth2 Credentials'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P136_SCHEME_TYPE'
,p_plug_display_when_cond2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(141706009970230961)
,p_plug_name=>'Edit Authentication Scheme'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_AUTHENTICATIONS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_FORM'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(141708219487230974)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Authentication is the process of establishing each user''s identity before they can access your application.',
'</p>',
'<p>',
'Use this page to edit authentication schemes and specify which one internal &PRODUCT_NAME. applications use. The authentication scheme designated as "Current" determines how applications identify and verify the developer. Depending upon the selected '
||'authentication scheme type, you can configure various settings to fine-tune authentication behavior.',
'</p>',
'<p>',
'<strong>NOTE:</strong> Even for external authentication schemes (for example, <em>HTTP Header Variable</em>), you have to make sure that users exist as developers or administrators in the workspaces. Otherwise, &PRODUCT_NAME. will not be able to veri'
||'fy in which workspace a user is allowed to work.'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(156067817002093304)
,p_plug_name=>'Authentication Scheme Attributes'
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(815130519409112136)
,p_plug_name=>'SAML for Internal and Workspace Applications: APEX Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P136_SCHEME_TYPE'
,p_plug_display_when_cond2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(155890431859815022)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_button_name=>'APPLY_CHANGES_MAKE_CURRENT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Make Current Scheme'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P136_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(141706417848230962)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P136_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(141706218852230961)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(141710320697230988)
,p_branch_action=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1505421063996625)
,p_name=>'P136_SAML_APEX_CALLBACK_URLS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(815130519409112136)
,p_prompt=>'Supported Callback URLs'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter APEX callback URLs (separated by newlines)',
'if this APEX instance should support integration via multiple domains.',
'When redirecting to the identity provider for login,',
'APEX sends <code>AssertionConsumerServiceIndex="nnn"</code>',
'in the authentication request,',
'where <code>nnn</code> is the index of the current callback URL in this list, starting at 0.',
'</p><p>',
'This attribute is optional if the APEX instance only needs to support integration with a single domain.',
'</p><p>',
'Example:',
'</p>',
'<pre>',
'https://sales.example.com/ords/apex_authentication.saml_callback',
'https://hr.example.com/ords/apex_authentication.saml_callback',
'https://tech.example.com/ords/apex_authentication.saml_callback',
'</pre>',
'<p>',
'When a user attempts to login to <code>https://tech.example.com/ords/f?p=100:1</code>,',
'APEX sends <code>AssertionConsumerServiceIndex="2"</code>',
'in the authentication request.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(117762395154717714)
,p_name=>'P136_CRED_CLIENT_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(117761677507717707)
,p_prompt=>'Client ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the client ID of your authentication provider.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(117762443712717715)
,p_name=>'P136_CRED_CLIENT_SECRET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(117761677507717707)
,p_prompt=>'Client Secret'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the client secret of your authentication provider.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(117763368155717724)
,p_name=>'P136_CRED_CLIENT_SEC_CONFIRM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(117761677507717707)
,p_prompt=>'Confirm Client Secret'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the client secret of your authentication provider.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(117763681380717727)
,p_name=>'P136_CRED_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(117761677507717707)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141707016770230962)
,p_name=>'P136_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141711223243254442)
,p_name=>'P136_ATTRIBUTE_01'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 01'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141711404480263230)
,p_name=>'P136_SCHEME_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_source=>'SCHEME_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143974801921352400)
,p_name=>'P136_ATTRIBUTE_02'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 02'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143975428866355033)
,p_name=>'P136_ATTRIBUTE_03'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 03'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143975621534358519)
,p_name=>'P136_ATTRIBUTE_04'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 04'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143975817652360226)
,p_name=>'P136_ATTRIBUTE_05'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 05'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143976014417361794)
,p_name=>'P136_ATTRIBUTE_06'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 06'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143976210320363634)
,p_name=>'P136_ATTRIBUTE_07'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 07'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143976406438365461)
,p_name=>'P136_ATTRIBUTE_08'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 08'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143976609660379220)
,p_name=>'P136_ATTRIBUTE_09'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 09'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143976804053381753)
,p_name=>'P136_ATTRIBUTE_10'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 10'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143977013098392741)
,p_name=>'P136_ATTRIBUTE_11'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 11'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143977209432394478)
,p_name=>'P136_ATTRIBUTE_12'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 12'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143977405550396288)
,p_name=>'P136_ATTRIBUTE_13'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 13'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143977601884397924)
,p_name=>'P136_ATTRIBUTE_14'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 14'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143977831202399571)
,p_name=>'P136_ATTRIBUTE_15'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(156067817002093304)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Attribute 15'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(1405202261752384510)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(156067131462078761)
,p_name=>'P136_HELP_TEXT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(156069915490101393)
,p_name=>'P136_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(156137816805994124)
,p_name=>'P136_PLSQL_CODE'
,p_source_data_type=>'CLOB'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'PL/SQL Code'
,p_source=>'PLSQL_CODE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a PL/SQL anonymous block of code that contains procedures for pre- and post-authentication entry points.',
'',
'To improve performance, you can also store this code in a PL/SQL package in the database.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(156138131889002313)
,p_name=>'P136_PRE_AUTH_PROCESS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Pre-Authentication Procedure Name'
,p_source=>'PRE_AUTH_PROCESS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the name of a procedure to be executed after the login page is submitted and just before credentials verification is performed. ',
'The procedure can be defined in the PL/SQL Code attribute or within the database.',
'',
'Authentication schemes where user credentials checking is done outside of &PRODUCT_NAME. typically do not execute the ',
'Pre-Authentication procedure. Examples are HTTP Header Variable, Oracle Application Server Single Sign-On and ',
'custom authentication schemes that use <code>apex_authentication.post_login</code> instead of <code>apex_authentication.login</code>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(156138323047006368)
,p_name=>'P136_POST_AUTH_PROCESS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_item_source_plug_id=>wwv_flow_imp.id(141706009970230961)
,p_prompt=>'Post-Authentication Procedure Name'
,p_source=>'POST_AUTH_PROCESS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'Specify the name of a procedure to be executed by the &PRODUCT_NAME. login procedure (login API) after the authentication step (login credentials verification). The login procedure will execute this code after it performs its normal duties, which inc'
||'lude setting a cookie and registering the session, but before it redirects to the desired application page. The procedure can be defined in the "PL/SQL Code" attribute or within the database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(311341122602167701)
,p_name=>'P136_SAML_NAMEID_FORMAT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(815130519409112136)
,p_prompt=>'NameID Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the expected format of the <code>NameID</code> attribute.',
'If empty, &PRODUCT_NAME. assumes <code>urn:oasis:names:tc:SAML:2.0:nameid-format:persistent</code>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815130824560112139)
,p_name=>'P136_SAML_ENABLED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(815130519409112136)
,p_prompt=>'Enable SAML for Applications'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enable if workspace applications should be able to use SAML authentication.',
'Note that you can enable any other authentication scheme for internal applications, but still use SAML in applications if this attribute is enabled.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815130946631112140)
,p_name=>'P136_SAML_IP_ISSUER'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(39564106377656610)
,p_prompt=>'Issuer'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the "Issuer" attribute from the identity provider''s metadata.',
'<p/>',
'Example: https://login.example.com/oam/fed'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131007729112141)
,p_name=>'P136_SAML_IP_SIGNING_CERT'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(39564106377656610)
,p_prompt=>'Signing Certificate'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the certificate from the identity provider''s metadata.',
'<p/>',
'Example:',
'<pre>',
'<p/>',
'Example:',
'<pre>',
'-----BEGIN CERTIFICATE-----',
'MIIDVzCCAj+gAwIBAgIJAJVYart+UJrOMA0GCSqGSIb3DQEBCwUAMEIxCzAJBgNV',
'...',
'Vva8Fj5O8YgtlYKKMmCZKYZC0nMNVRjI3A7cL71ffE7JKMI43EqaTg7m1Q==',
'-----END CERTIFICATE-----',
'</pre>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131129986112142)
,p_name=>'P136_SAML_IP_SIGNING_CERT2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(39564106377656610)
,p_prompt=>'Alternative Signing Certificate'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter an alternative certificate from the identity provider''s metadata.',
'<p/>',
'Example:',
'<pre>',
'<p/>',
'Example:',
'<pre>',
'-----BEGIN CERTIFICATE-----',
'MIIDVzCCAj+gAwIBAgIJAJVYart+UJrOMA0GCSqGSIb3DQEBCwUAMEIxCzAJBgNV',
'...',
'Vva8Fj5O8YgtlYKKMmCZKYZC0nMNVRjI3A7cL71ffE7JKMI43EqaTg7m1Q==',
'-----END CERTIFICATE-----',
'</pre>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131297577112143)
,p_name=>'P136_SAML_SIGN_IN_URL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(39564106377656610)
,p_prompt=>'Sign-In URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the identity provider''s sign in URL.',
'<p/>',
'Example: https://login.example.com/oamfed/idp/samlv20'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131363004112144)
,p_name=>'P136_SAML_SIGN_OUT_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(39564106377656610)
,p_prompt=>'Sign-Out URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the identity provider''s sign out URL. If empty, it defaults to the sign in URL, which is normally sufficient.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131455681112145)
,p_name=>'P136_SAML_SP_ISSUER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(815130519409112136)
,p_prompt=>'Issuer'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the "Issuer" attribute that &PRODUCT_NAME. sends. It defaults to the callback URL (https://apex.example.com/ords/apex_authentication.saml_callback), which is normally sufficient.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131541700112146)
,p_name=>'P136_SAML_USERNAME_ATTRIBUTE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(815130519409112136)
,p_prompt=>'Username Attribute'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'SAML responses can contain additional attributes about the user. If set, &PRODUCT_NAME. uses that attribute''s value as the username. By default, &PRODUCT_NAME. uses the assertion subject''s NameID attribute.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131628561112147)
,p_name=>'P136_SAML_APEX_CERTIFICATE'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(815130519409112136)
,p_prompt=>'Certificate'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the primary certificate of the &PRODUCT_NAME. side.',
'<p/>',
'Example:',
'<pre>',
'-----BEGIN CERTIFICATE-----',
'MIIDVzCCAj+gAwIBAgIJAJVYart+UJrOMA0GCSqGSIb3DQEBCwUAMEIxCzAJBgNV',
'...',
'Vva8Fj5O8YgtlYKKMmCZKYZC0nMNVRjI3A7cL71ffE7JKMI43EqaTg7m1Q==',
'-----END CERTIFICATE-----',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131705621112148)
,p_name=>'P136_SAML_APEX_CERTIFICATE2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(815130519409112136)
,p_prompt=>'Alternative Certificate'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the alternative certificate of the &PRODUCT_NAME. side.',
'<p/>',
'Example:',
'<pre>',
'-----BEGIN CERTIFICATE-----',
'MIIDVzCCAj+gAwIBAgIJAJVYart+UJrOMA0GCSqGSIb3DQEBCwUAMEIxCzAJBgNV',
'...',
'Vva8Fj5O8YgtlYKKMmCZKYZC0nMNVRjI3A7cL71ffE7JKMI43EqaTg7m1Q==',
'-----END CERTIFICATE-----',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131844777112149)
,p_name=>'P136_SAML_APEX_PRIVATE_KEY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(815130519409112136)
,p_prompt=>'Private Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the private key of the &PRODUCT_NAME. side.',
'Note that &PRODUCT_NAME. does not display an existing private key,',
'but you can enter a new one.',
'<p/>',
'Example:',
'<pre>',
'-----BEGIN PRIVATE KEY-----',
'MIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQDVksEJGbmdG4D/',
'...',
'3tUtCQOnuWFjkj7n9h3dZSl8',
'-----END PRIVATE KEY-----',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815131929854112150)
,p_name=>'P136_SAML_APEX_PRIVATE_KEY2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(815130519409112136)
,p_prompt=>'Alternative Private Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the alternative private key of the &PRODUCT_NAME. side.',
'Note that &PRODUCT_NAME. does not display an existing private key,',
'but you can enter a new one.',
'<p/>',
'Example:',
'<pre>',
'-----BEGIN PRIVATE KEY-----',
'MIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQDVksEJGbmdG4D/',
'...',
'3tUtCQOnuWFjkj7n9h3dZSl8',
'-----END PRIVATE KEY-----',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(143089014295981941)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id   => wwv_flow.g_flow_id,',
'        p_plugin_type      => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_plugin_name      => :P136_SCHEME_TYPE,',
'        p_attribute_scope  => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix => ''P136_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_when_button_pressed=>wwv_flow_imp.id(141706417848230962)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(117763404786717725)
,p_validation_name=>'Verify Client Secret'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P136_CRED_CLIENT_SEC_CONFIRM is not null',
'and :P136_CRED_CLIENT_SECRET = :P136_CRED_CLIENT_SEC_CONFIRM'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Client Secret not properly confirmed, enter your Client Secret two times exactly the same.'
,p_validation_condition=>'P136_CRED_CLIENT_SECRET'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(141706417848230962)
,p_associated_item=>wwv_flow_imp.id(117762443712717715)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(39563314659656602)
,p_validation_name=>'Parse SAML_IP_SIGNING_CERT'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_public_key_util.is_certificate (',
'    p_src => :P136_SAML_IP_SIGNING_CERT )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Invalid certificate'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(141706417848230962)
,p_associated_item=>wwv_flow_imp.id(815131007729112141)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(39563442524656603)
,p_validation_name=>'Parse SAML_IP_SIGNING_CERT2'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_public_key_util.is_certificate (',
'    p_src => :P136_SAML_IP_SIGNING_CERT2 )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Invalid certificate'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(141706417848230962)
,p_associated_item=>wwv_flow_imp.id(815131129986112142)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(39563529487656604)
,p_validation_name=>'Parse P136_SAML_APEX_CERTIFICATE'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_public_key_util.is_certificate (',
'    p_src => :P136_SAML_APEX_CERTIFICATE )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Invalid certificate'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(141706417848230962)
,p_associated_item=>wwv_flow_imp.id(815131628561112147)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(39563679484656605)
,p_validation_name=>'Parse P136_SAML_APEX_CERTIFICATE2'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_public_key_util.is_certificate (',
'    p_src => :P136_SAML_APEX_CERTIFICATE2 )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Invalid certificate'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(141706417848230962)
,p_associated_item=>wwv_flow_imp.id(815131705621112148)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(39563731704656606)
,p_validation_name=>'P136_SAML_SIGN_IN_URL Is URL'
,p_validation_sequence=>80
,p_validation=>'P136_SAML_SIGN_IN_URL'
,p_validation2=>'http[s]?://.*'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Please enter a URL that starts with http:// or https://.'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(141706417848230962)
,p_associated_item=>wwv_flow_imp.id(815131297577112143)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(39563891685656607)
,p_validation_name=>'P136_SAML_SIGN_OUT_URL Is URL'
,p_validation_sequence=>90
,p_validation=>'P136_SAML_SIGN_OUT_URL'
,p_validation2=>'http[s]?://.*'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Please enter a URL that starts with http:// or https://.'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(141706417848230962)
,p_associated_item=>wwv_flow_imp.id(815131363004112144)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(161096405621281308)
,p_name=>'Make current'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(155890431859815022)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(161096729476281309)
,p_event_id=>wwv_flow_imp.id(161096405621281308)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Changing the current authentication scheme can render &PRODUCT_NAME. development environment inaccessible if parameters and the web server are not configured correctly. In case of problems, you can set the internal authentication scheme back to th'
||'e default with</p>',
'',
'<p><code>apex_instance_admin.set_parameter(&#x27;APEX_BUILDER_AUTHENTICATION&#x27;,&#x27;APEX&#x27;);</code></p>',
'',
'<p>Are you sure that you want to change the current authentication scheme now?</p>'))
,p_attribute_05=>'ui-dialog--notificationLarge'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(161096925872283827)
,p_event_id=>wwv_flow_imp.id(161096405621281308)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'APPLY_CHANGES_MAKE_CURRENT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2607171756019001)
,p_process_sequence=>10
,p_process_point=>'AFTER_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add Javascript code for Plugins'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P136_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_application_id      => wwv_flow.g_flow_id,',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_type_page_item_name => ''P136_SCHEME_TYPE'',',
'        p_page_item_prefix    => ''P136_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2607171756019001
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(141709817048230987)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(141706009970230961)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process Row of WWV_FLOW_AUTHENTICATIONS'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_process_error_message=>'Error processing Authentication.'
,p_process_when_button_id=>wwv_flow_imp.id(141706417848230962)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>141709817048230987
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(117763597814717726)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Credential'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.p136_save_credential (',
'    p_id            => :P136_CRED_ID,',
'    p_client_id     => :P136_CRED_CLIENT_ID,',
'    p_client_secret => :P136_CRED_CLIENT_SECRET );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(141706417848230962)
,p_process_when=>'P136_CRED_CLIENT_SECRET'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>117763597814717726
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(39563203481656601)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save SAML Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.p136_save_saml_attributes (',
'    p_saml_enabled                 => :P136_SAML_ENABLED,',
'    p_saml_ip_issuer               => :P136_SAML_IP_ISSUER,',
'    p_saml_ip_signing_certificate  => :P136_SAML_IP_SIGNING_CERT,',
'    p_saml_ip_signing_certificate2 => :P136_SAML_IP_SIGNING_CERT2,',
'    p_saml_sign_in_url             => :P136_SAML_SIGN_IN_URL,',
'    p_saml_sign_out_url            => :P136_SAML_SIGN_OUT_URL,',
'    p_saml_nameid_format           => :P136_SAML_NAMEID_FORMAT,',
'    p_saml_sp_issuer               => :P136_SAML_SP_ISSUER,',
'    p_saml_username_attribute      => :P136_SAML_USERNAME_ATTRIBUTE,',
'    p_saml_apex_certificate        => :P136_SAML_APEX_CERTIFICATE,',
'    p_saml_apex_certificate2       => :P136_SAML_APEX_CERTIFICATE2,',
'    p_saml_apex_private_key        => :P136_SAML_APEX_PRIVATE_KEY,',
'    p_saml_apex_private_key2       => :P136_SAML_APEX_PRIVATE_KEY2,',
'    p_saml_apex_callback_urls      => :P136_SAML_APEX_CALLBACK_URLS );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(141706417848230962)
,p_process_when=>'P136_SCHEME_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_internal_uid=>39563203481656601
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(151902109875088387)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'push changes to other schemes of same type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.internal_push_changes (',
'    p_authentication_id => :P136_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>151902109875088387
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(155890807311821474)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'make current authentication scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.internal_make_current (',
'    p_authentication_id => :P136_ID );',
'--',
'-- reload placeholder item for create/edit user password region',
'--',
':F4050_PASSWORD_REGION_TITLE := wwv_flow_lang.system_message (',
'                                    ''APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.''||',
'                                    replace(wwv_flow_authentication_dev.get_internal_authentication,''DB'',''LDAP'')||',
'                                    ''-AUTH'');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(155890431859815022)
,p_process_success_message=>'Current authentication scheme for internal applications has been changed. You may have to create additional workspace developers and administrators, to successfully log in.'
,p_internal_uid=>155890807311821474
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(117761779144717708)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(141706009970230961)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Developer Authentication Scheme'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>117761779144717708
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(117761548349717706)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Credentials'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.p136_fetch_credential (',
'    p_id        => :P136_CRED_ID,',
'    p_client_id => :P136_CRED_CLIENT_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P136_SCHEME_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_internal_uid=>117761548349717706
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(815130652541112137)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch SAML Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.p136_fetch_saml_attributes (',
'    p_saml_enabled                 => :P136_SAML_ENABLED,',
'    p_saml_ip_issuer               => :P136_SAML_IP_ISSUER,',
'    p_saml_ip_signing_certificate  => :P136_SAML_IP_SIGNING_CERT,',
'    p_saml_ip_signing_certificate2 => :P136_SAML_IP_SIGNING_CERT2,',
'    p_saml_sign_in_url             => :P136_SAML_SIGN_IN_URL,',
'    p_saml_sign_out_url            => :P136_SAML_SIGN_OUT_URL,',
'    p_saml_nameid_format           => :P136_SAML_NAMEID_FORMAT,',
'    p_saml_sp_issuer               => :P136_SAML_SP_ISSUER,',
'    p_saml_username_attribute      => :P136_SAML_USERNAME_ATTRIBUTE,',
'    p_saml_apex_certificate        => :P136_SAML_APEX_CERTIFICATE,',
'    p_saml_apex_certificate2       => :P136_SAML_APEX_CERTIFICATE2,',
'    p_saml_apex_private_key        => :P136_SAML_APEX_PRIVATE_KEY,',
'    p_saml_apex_private_key2       => :P136_SAML_APEX_PRIVATE_KEY2,',
'    p_saml_apex_callback_urls      => :P136_SAML_APEX_CALLBACK_URLS );',
''))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P136_SCHEME_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_internal_uid=>815130652541112137
);
end;
/
prompt --application/pages/page_00137
begin
wwv_flow_imp_page.create_page(
 p_id=>137
,p_name=>'Top 10 Workspaces'
,p_alias=>'TOP-10-WORKSPACES'
,p_step_title=>'Top 10 Workspaces'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1761218334857168235)
,p_plug_name=>'Top Applications'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(880628551033290603)
,p_region_id=>wwv_flow_imp.id(1761218334857168235)
,p_chart_type=>'bar'
,p_height=>'320'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(880629728907290607)
,p_chart_id=>wwv_flow_imp.id(880628551033290603)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'from (',
'    select sum(page_events) Page_Events,',
'    NVL((select max(SHORT_NAME ) from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID  = h.WORKSPACE_ID ),''Unknown'') App_Name',
'    from WWV_FLOW_LOG_HISTORY h',
'    where log_day > sysdate - (NVL(:P137_SINCE,7)+1)',
'    group by h.WORKSPACE_ID',
'    order by 1 desc) ',
'where rownum <= 10'))
,p_ajax_items_to_submit=>'P137_SINCE'
,p_items_value_column_name=>'PAGE_EVENTS'
,p_group_name_column_name=>'APP_NAME'
,p_items_label_column_name=>'APP_NAME'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(880628974255290606)
,p_chart_id=>wwv_flow_imp.id(880628551033290603)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(880629374523290606)
,p_chart_id=>wwv_flow_imp.id(880628551033290603)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2232511086998620885)
,p_name=>'Workspaces Activity Detail'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       errors,',
'       workspace_id,',
'       (select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id) workspace_name,',
'       development_activity,',
'       runtime_activity,',
'       RANK() OVER (ORDER BY "Page Events" desc) ws_rank',
'from (',
'select sum(page_events) "Page Events",',
'    workspace_id, max(log_day) most_recent_event,',
'    sum(CASE WHEN application_id BETWEEN 4000 AND 5000 THEN page_events else 0 end) development_activity,',
'    sum(CASE WHEN application_id NOT BETWEEN 4000 AND 5000 THEN page_events else 0 end) runtime_activity,',
'    sum(ERROR_COUNT) errors',
'from WWV_FLOW_LOG_HISTORY ',
'where log_day > sysdate - (NVL(:P137_SINCE,7)+1)',
'group by workspace_id',
'order by 1 desc) x',
'where rownum < 101',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P137_SINCE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>101
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825586844014000626)
,p_query_column_id=>1
,p_column_alias=>'Page Events'
,p_column_display_sequence=>3
,p_column_heading=>'Page Events'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825514289073601246)
,p_query_column_id=>2
,p_column_alias=>'ERRORS'
,p_column_display_sequence=>7
,p_column_heading=>'Errors'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825588434276000627)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE_ID'
,p_column_display_sequence=>8
,p_column_heading=>'Workspace ID'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825588841133000627)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825512102229601225)
,p_query_column_id=>5
,p_column_alias=>'DEVELOPMENT_ACTIVITY'
,p_column_display_sequence=>5
,p_column_heading=>'Development Activity'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825512231698601226)
,p_query_column_id=>6
,p_column_alias=>'RUNTIME_ACTIVITY'
,p_column_display_sequence=>6
,p_column_heading=>'Runtime Activity'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825593242951000629)
,p_query_column_id=>7
,p_column_alias=>'WS_RANK'
,p_column_display_sequence=>1
,p_column_heading=>'Rank'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3399440007607788189)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(825605541633063665)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3399440007607788189)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:RR,137::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(880630806348290610)
,p_name=>'P137_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3399440007607788189)
,p_item_default=>'7'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(390436229055898138)
,p_name=>'Refresh Regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P137_SINCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(390436382517898139)
,p_event_id=>wwv_flow_imp.id(390436229055898138)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-region'
);
end;
/
prompt --application/pages/page_00138
begin
wwv_flow_imp_page.create_page(
 p_id=>138
,p_name=>'Activity Summary'
,p_alias=>'ACTIVITY-SUMMARY'
,p_step_title=>'Activity Summary'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(390436644901898142)
,p_plug_name=>'Workspace Activity'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with x',
'as',
'(',
'    select trunc(sysdate) - rownum log_day, ',
'           30 considered_active',
'    from dual',
'    connect by level <= NVL(:P138_SINCE,7)',
'    order by 1 desc)',
'select * from',
'(',
'select x.log_day, ',
'       (select count(distinct workspace_id)   ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_workspaces,',
'       (select sum(page_events)   ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) window_page_events,',
'       (select count(distinct application_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id not between 4000 and 5000 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_applications,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id not between 4000 and 5000 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) workspaces_with_active_apps,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id in (4000,4020) and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_appbuilder,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4500 and ',
'              DISTINCT_PAGES > 1 and',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_sqlworkshop,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id in (4020) and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_create_app,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4850 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_rest,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4300 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_data_workshop,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4600 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_team_dev,',
'       x.log_day - considered_active window_start,',
'       x.log_day window_end',
'from x',
') y',
'order by 1 desc',
''))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_ajax_items_to_submit=>'P138_SINCE'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(390436714047898143)
,p_region_id=>wwv_flow_imp.id(390436644901898142)
,p_chart_type=>'line'
,p_title=>'Workspace Activity Trailing 30 Days'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(390436877343898144)
,p_chart_id=>wwv_flow_imp.id(390436714047898143)
,p_seq=>10
,p_name=>'Active Workspaces'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_WORKSPACES'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(831944451410695401)
,p_chart_id=>wwv_flow_imp.id(390436714047898143)
,p_seq=>30
,p_name=>'App Builder'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_APPBUILDER'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(831944583172695402)
,p_chart_id=>wwv_flow_imp.id(390436714047898143)
,p_seq=>40
,p_name=>'REST Workshop'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_REST'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(831944652308695403)
,p_chart_id=>wwv_flow_imp.id(390436714047898143)
,p_seq=>50
,p_name=>'SQL Workshop'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_SQLWORKSHOP'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(831944755855695404)
,p_chart_id=>wwv_flow_imp.id(390436714047898143)
,p_seq=>60
,p_name=>'Team Development'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_TEAM_DEV'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(390436972856898145)
,p_chart_id=>wwv_flow_imp.id(390436714047898143)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(390437059060898146)
,p_chart_id=>wwv_flow_imp.id(390436714047898143)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(390437404321898150)
,p_chart_id=>wwv_flow_imp.id(390436714047898143)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_title=>'Page Events'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(581427921268177850)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Overview provides real time data. Top applications and development activity is reported from the daily summarized activity log. </p>',
'<p>Top applications are APEX applications excluding the design time developer interface.</p>',
'<p>Reports are limited to 200 rows.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(825511736357601221)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(831944814412695405)
,p_plug_name=>'Page Events'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with events_per_day as',
'(',
'select',
'  h.log_day,',
'  sum(page_events) page_events',
'from   WWV_FLOW_LOG_HISTORY h',
'where  h.log_day >= sysdate-NVL(:P138_SINCE,7)',
'group by h.log_day',
'),',
'rolling30 as',
'(',
'select',
'  log_day,',
'  sum(page_events) over ( order by log_day range between 30 preceding and current row) as last_30_days',
'from events_per_day',
'),',
'x as (',
'    select trunc(sysdate) - rownum log_day',
'    from dual',
'    connect by level <= NVL(:P138_SINCE,7)',
')   ',
'select x.log_day,',
'       nvl(last_value(r.last_30_days ignore nulls) over ( order by x.log_day ),0) as last_30_days',
'from   x, rolling30 r',
'where  x.log_day = r.log_day(+)',
'order by 1',
''))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_ajax_items_to_submit=>'P138_SINCE'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(831945070251695407)
,p_region_id=>wwv_flow_imp.id(831944814412695405)
,p_chart_type=>'line'
,p_title=>'Page Events Trailing 30 Days'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(831945101909695408)
,p_chart_id=>wwv_flow_imp.id(831945070251695407)
,p_seq=>10
,p_name=>'Page Events'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'LAST_30_DAYS'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(831945638565695413)
,p_chart_id=>wwv_flow_imp.id(831945070251695407)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(831945797163695414)
,p_chart_id=>wwv_flow_imp.id(831945070251695407)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(831945802132695415)
,p_chart_id=>wwv_flow_imp.id(831945070251695407)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_title=>'Page Events'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(861306615814654928)
,p_plug_name=>'Detailed Activity Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(831980164720776427)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1807086836541256590)
,p_name=>'Overview'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>22
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--cols a-BadgeList--3cols:a-BadgeList--medium'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with x as (',
'select to_char(count(*),''999G999G999G999G990'') total_page_views, ',
'       to_char(count(distinct flow_id),''999G999G999G999G990'')  active_apps, ',
'       to_char(count(distinct userid),''999G999G999G999G990'')  distinct_users,',
'       to_char(count(distinct flow_id),''999G999G999G999G990'') active_workspaces',
'  from wwv_flow_activity_log',
' where time_stamp >= sysdate - (NVL(:P138_SINCE,7)+1)',
'    ),',
'y as (',
' select ',
'     (select to_char(count(*),''999G999G999G999G990'') from wwv_flow_companies) workspace_count,',
'     (select to_char(count(*),''999G999G999G999G990'') from wwv_flows) app_count,',
'     (select to_char(count(*),''999G999G999G999G990'') from wwv_flow_provision_company where PROJECT_STATUS = ''APPROVED'' ',
'     and request_date >= sysdate - (NVL(:P138_SINCE,7)+1)) workspaces_approved,',
'     (select to_char(count(*),''999G999G999G999G990'') from wwv_flow_provision_company where PROJECT_STATUS = ''PURGED'' ',
'     and request_date >= sysdate - (NVL(:P138_SINCE,7)+1)) workspaces_purged,',
'     (select to_char(count(*),''999G999G999G999G990'') tbp',
'      from wwv_purge_workspaces',
'      where status in (''NEW'',''STAGE1'',''STAGE2'')',
'      and date_to_purge between sysdate and sysdate + 7) to_be_purged_1w',
' from dual',
')',
'select x.total_page_views,',
'       x.active_apps,',
'       y.app_count total_apps,',
'       x.distinct_users active_users,',
'       x.active_workspaces,',
'       y.workspace_count total_workspaces,',
'       y.workspaces_approved,',
'       y.workspaces_purged,',
'       y.to_be_purged_1w',
'from x, y'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P138_SINCE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805663950138677747)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(758054754169278415)
,p_query_column_id=>1
,p_column_alias=>'TOTAL_PAGE_VIEWS'
,p_column_display_sequence=>1
,p_column_heading=>'Total page events'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(758055086804278418)
,p_query_column_id=>2
,p_column_alias=>'ACTIVE_APPS'
,p_column_display_sequence=>3
,p_column_heading=>'Active apps'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(758055605099278424)
,p_query_column_id=>3
,p_column_alias=>'TOTAL_APPS'
,p_column_display_sequence=>4
,p_column_heading=>'Total apps'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(758055764419278425)
,p_query_column_id=>4
,p_column_alias=>'ACTIVE_USERS'
,p_column_display_sequence=>2
,p_column_heading=>'Active users'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(758055157005278419)
,p_query_column_id=>5
,p_column_alias=>'ACTIVE_WORKSPACES'
,p_column_display_sequence=>5
,p_column_heading=>'Active workspaces'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(758055806732278426)
,p_query_column_id=>6
,p_column_alias=>'TOTAL_WORKSPACES'
,p_column_display_sequence=>6
,p_column_heading=>'Total workspaces'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(758055423236278422)
,p_query_column_id=>7
,p_column_alias=>'WORKSPACES_APPROVED'
,p_column_display_sequence=>7
,p_column_heading=>'Workspaces approved'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(758055543547278423)
,p_query_column_id=>8
,p_column_alias=>'WORKSPACES_PURGED'
,p_column_display_sequence=>8
,p_column_heading=>'Workspaces purged'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(825511851915601222)
,p_query_column_id=>9
,p_column_alias=>'TO_BE_PURGED_1W'
,p_column_display_sequence=>9
,p_column_heading=>'To be purged - 1 week'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4280073096315101852)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(390437227575898148)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(390436644901898142)
,p_button_name=>'VIEW_DETAILS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Details'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:153:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(581427897662177849)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4280073096315101852)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.:RR,138::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(880633731011313664)
,p_name=>'P138_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4280073096315101852)
,p_item_default=>'7'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(390436011156898136)
,p_name=>'Refresh Regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P138_SINCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(390436159952898137)
,p_event_id=>wwv_flow_imp.id(390436011156898136)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-region'
);
end;
/
prompt --application/pages/page_00139
begin
wwv_flow_imp_page.create_page(
 p_id=>139
,p_name=>'Manage Web Service Activity Log'
,p_alias=>'MANAGE-WEB-SERVICE-ACTIVITY-LOG'
,p_step_title=>'Manage Web Service Activity Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(685765931892976233)
,p_plug_name=>'Delete Web Service Activity Log Entries'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_dev number := 0;    ',
'begin',
'    select count(*)',
'    into c_dev',
'    from wwv_flow_webservice_log;',
'    ',
'    return ''<p>''',
'           || wwv_flow_lang_dev.builder_message(''4050_139_WEB_SERVICE_ACTIVITY_LOG'') || '': ''',
'           || to_char(c_dev,''999,999,999,990'')',
'           || ''</p>'';    ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1701789643422596067)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1703260876618371756)
,p_plug_name=>'Web Service Activity Log'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This &PRODUCT_NAME. instance can be configured to log web service activity.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(620804032051072188)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1701789643422596067)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Entries'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(620804455539072191)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1701789643422596067)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(620805938503072198)
,p_branch_name=>'Go To Page 139'
,p_branch_action=>'139'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(620804032051072188)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(620802973440072180)
,p_name=>'P139_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(685765931892976233)
,p_prompt=>'Delete entries this number of days and older:'
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_imp.id(87720511660244788)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Purge entries older than this number of days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(620805415839072197)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_webservice_log1$',
'where request_date < (sysdate - nvl(:p139_time,31));',
'delete from wwv_flow_webservice_log2$',
'where request_date < (sysdate - nvl(:p139_time,31));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error purging Web Service Activity Log.'
,p_process_when_button_id=>wwv_flow_imp.id(620804032051072188)
,p_process_success_message=>'Web Service Activity Log purged.'
,p_internal_uid=>620805415839072197
);
end;
/
prompt --application/pages/page_00140
begin
wwv_flow_imp_page.create_page(
 p_id=>140
,p_name=>'Native Component Utilization Report'
,p_alias=>'NATIVE-COMPONENT-UTILIZATION-REPORT'
,p_step_title=>'Native Component Utilization Report'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(84539284934706818)
,p_plug_name=>'Report'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEXcc_p140 */',
'    security_group_id,',
'    (select short_name from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = p.security_group_id) workspace,',
'    flow_id,',
'    (select name from wwv_flows f where f.id = p.flow_id) application,',
'    sum(decode(plug_source_type, ''NATIVE_JET_CHART'', 1, 0))        jc_count,',
'    sum(decode(plug_source_type, ''NATIVE_IG'', 1, 0))               ig_count,',
'    sum(decode(plug_source_type, ''NATIVE_IR'', 1, 0))               ir_count,',
'    sum(decode(plug_source_type, ''NATIVE_SQL_REPORT'', 1, 0))       cr_count,',
'    sum(decode(plug_source_type, ''NATIVE_CALENDAR'', 1, 0))         cal_count,',
'    sum(decode(plug_source_type, ''NATIVE_CSS_CALENDAR'', 1, 0))     cssc_count,',
'    sum(decode(plug_source_type, ''NATIVE_PLSQL'', 1, 0))            pl_count,',
'    sum(decode(plug_source_type, ''NATIVE_DISPLAY_SELECTOR'', 1, 0)) ds_count,',
'    sum(decode(plug_source_type, ''NATIVE_TABFORM'', 1, 0))          tf_count,',
'    sum(decode(plug_source_type, ''NATIVE_STATIC'', 1, 0))           ns_count,',
'    sum(decode(plug_source_type, ''NATIVE_JSTREE'', 1, 0))           jst_count,',
'    sum(decode(plug_source_type, ''NATIVE_BREADCRUMB'', 1, 0))       nb_count,',
'    sum(decode(plug_source_type, ''NATIVE_LIST'', 1, 0))             nl_count',
'from wwv_flow_page_plugs p',
'where security_group_id != 10 and',
'   plug_source_type  in (',
'      ''NATIVE_JET_CHART'', ''NATIVE_IG'', ''NATIVE_IR'', ''NATIVE_SQL_REPORT'', ',
'      ''NATIVE_CALENDAR'', ''NATIVE_PLSQL'', ''NATIVE_CSS_CALENDAR'',',
'      ''NATIVE_TABFORM'',''NATIVE_DISPLAY_SELECTOR'',''NATIVE_CSS_CALENDAR'',',
'      ''NATIVE_JSTREE'',''NATIVE_STATIC'', ''NATIVE_BREADCRUMB'', ''NATIVE_LIST'')',
'group by security_group_id, flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(84539367321706819)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>84539367321706819
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84541134438706837)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>10
,p_column_identifier=>'R'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84541290053706838)
,p_db_column_name=>'APPLICATION'
,p_display_order=>20
,p_column_identifier=>'S'
,p_column_label=>'Application'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84539442962706820)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84539514266706821)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>40
,p_column_identifier=>'B'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84539676154706822)
,p_db_column_name=>'JC_COUNT'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>'JET Charts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84539735475706823)
,p_db_column_name=>'IG_COUNT'
,p_display_order=>60
,p_column_identifier=>'D'
,p_column_label=>'Interactive Grids'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84539830573706824)
,p_db_column_name=>'IR_COUNT'
,p_display_order=>70
,p_column_identifier=>'E'
,p_column_label=>'Interactive Reports'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84539970222706825)
,p_db_column_name=>'CR_COUNT'
,p_display_order=>80
,p_column_identifier=>'F'
,p_column_label=>'Classic Reports'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84540020048706826)
,p_db_column_name=>'CAL_COUNT'
,p_display_order=>90
,p_column_identifier=>'G'
,p_column_label=>'Classic Calendars'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84541076822706836)
,p_db_column_name=>'CSSC_COUNT'
,p_display_order=>100
,p_column_identifier=>'Q'
,p_column_label=>'CSS Calendars'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84540185317706827)
,p_db_column_name=>'PL_COUNT'
,p_display_order=>110
,p_column_identifier=>'H'
,p_column_label=>'PL/SQL Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84540360844706829)
,p_db_column_name=>'DS_COUNT'
,p_display_order=>130
,p_column_identifier=>'J'
,p_column_label=>'Display Selectors'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84540448009706830)
,p_db_column_name=>'TF_COUNT'
,p_display_order=>140
,p_column_identifier=>'K'
,p_column_label=>'Tabular Forms'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84540690326706832)
,p_db_column_name=>'NS_COUNT'
,p_display_order=>160
,p_column_identifier=>'M'
,p_column_label=>'Static Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84540794520706833)
,p_db_column_name=>'JST_COUNT'
,p_display_order=>170
,p_column_identifier=>'N'
,p_column_label=>'Javascript Trees'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84540864185706834)
,p_db_column_name=>'NB_COUNT'
,p_display_order=>180
,p_column_identifier=>'O'
,p_column_label=>'Breadcrumbs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84540973307706835)
,p_db_column_name=>'NL_COUNT'
,p_display_order=>190
,p_column_identifier=>'P'
,p_column_label=>'Lists'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(155387267120197809)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1553873'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SECURITY_GROUP_ID:FLOW_ID:WORKSPACE:APPLICATION:JC_COUNT:IG_COUNT:IR_COUNT:CR_COUNT:CAL_COUNT:PL_COUNT:DS_COUNT:TF_COUNT:NS_COUNT:JST_COUNT:NB_COUNT:NL_COUNT:CSSC_COUNT:'
,p_sort_column_1=>'WORKSPACE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'APPLICATION'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
end;
/
prompt --application/pages/page_00141
begin
wwv_flow_imp_page.create_page(
 p_id=>141
,p_name=>'Application Hash by Day'
,p_alias=>'APPLICATION-HASH-BY-DAY'
,p_step_title=>'Application Hash by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(420391910446831714)
,p_plug_name=>'Application Hash by Day'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    WORKSPACE_ID workspace,',
'    WORKSPACE_NAME workspace_name,',
'    APPLICATION_ID applications,',
'    APPLICATION_NAME application_name,',
'    nvl(decode(instr(additional_attributes,''"hash":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8),'','')-2)),null)  application_hash',
'from WWV_FLOW_LOG_HISTORY h',
'where instr(additional_attributes,''"hash":'') > 0',
''))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(420392112669831717)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>420392112669831717
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219063789436336973)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219064113077336974)
,p_db_column_name=>'DAY'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Day'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219064567381336975)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219070135037336989)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219070507206336989)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219070978694336990)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>165
,p_column_identifier=>'T'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219063342368336971)
,p_db_column_name=>'APPLICATION_HASH'
,p_display_order=>325
,p_column_identifier=>'AR'
,p_column_label=>'Application Hash'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(420393912741831737)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'2190717'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:DAY:WORKSPACE_NAME:APPLICATIONS:APPLICATION_NAME:APPLICATION_HASH:'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'DISTINCT_PAGES'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219072159957336999)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(420391910446831714)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:77,RIR::'
);
end;
/
prompt --application/pages/page_00142
begin
wwv_flow_imp_page.create_page(
 p_id=>142
,p_name=>'Create Workspace'
,p_alias=>'CREATE-WORKSPACE1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_inline_css=>'.is-disabled {opacity: .5}'
,p_step_template=>wwv_flow_imp.id(721103220819687982)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
,p_dialog_height=>'450'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_env_sec.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2368720617541210)
,p_plug_name=>'New Schema'
,p_region_css_classes=>'a-Wizard-regionHeader'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P142_NEW_USER_YN'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2368835258541211)
,p_plug_name=>'Existing Schema'
,p_region_css_classes=>'a-Wizard-regionHeader'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>20
,p_plug_source=>'Identify an existing database user to use with your new workspace. This will allow applications in your workspace to access data stored within this schema.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P142_NEW_USER_YN'
,p_plug_display_when_cond2=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206356585666953038)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--stacked:is-collapsed:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(721115784857730284)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(553411572570635317)
,p_plug_name=>'Create Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>30
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(553411969444635320)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1340496247377483380)
,p_plug_name=>'Create Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(384607787358486094)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(553411969444635320)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2330107185372602)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(553411969444635320)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(384608102047486098)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(553411969444635320)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(384610182674486116)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1605719027242533)
,p_name=>'P142_ADMIN_PWD'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(553411572570635317)
,p_prompt=>'Workspace Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a password for the workspace administrator.</p>',
'',
'<p>Autonomous Database requires strong passwords. The password you specify must meet the default password complexity rules.</p>',
'',
'<ul>',
'    <li>The password must be between 12 and 30 characters long and must include at least one uppercase letter, one lowercase letter, and one numeric character.</li>',
'',
'    <li>The password cannot contain the username.</li>',
'',
'    <li>The password cannot be one of the last four passwords used for the same username.</li>',
'',
'    <li>The password cannot contain the double quote (") character.</li>',
'',
'    <li>The password must not be the same password that is set less than 24 hours ago.</li>    ',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52034952058715305)
,p_name=>'P142_PASSWORD'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(206356585666953038)
,p_prompt=>'Database Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_tag_attributes=>'autocomplete="new-password"'
,p_display_when=>'P142_NEW_USER_YN'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a password for the workspace database user.</p>',
'',
'<p>Autonomous Database requires strong passwords. The password you specify must meet the default password complexity rules.</p>',
'',
'<ul>',
'    <li>The password must be between 12 and 30 characters long and must include at least one uppercase letter, one lowercase letter, and one numeric character.</li>',
'',
'    <li>The password cannot contain the username.</li>',
'',
'    <li>The password cannot be one of the last four passwords used for the same username.</li>',
'',
'    <li>The password cannot contain the double quote (") character.</li>',
'',
'    <li>The password must not be the same password that is set less than 24 hours ago.</li>    ',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52035228106715308)
,p_name=>'P142_NEW_USER_YN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(553411572570635317)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(384610700214515462)
,p_name=>'P142_DATABASE_USER'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(553411572570635317)
,p_prompt=>'Database User'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.username d, a.username r ',
'  from wwv_flow_admin_all_schemas a',
' where a.restricted_to_workspace is null',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_css_classes=>'u-textUpper'
,p_display_when=>'P142_NEW_USER_YN'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the existing database user for the workspace. Applications will be created against database objects from this schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(384611825796547479)
,p_name=>'P142_COMPANY'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(553411572570635317)
,p_prompt=>'Workspace Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>30
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a name for the workspace. A workspace is  a shared work area where multiple developers can build applications.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(384612667869558383)
,p_name=>'P142_SECURITY_GROUP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(206356585666953038)
,p_prompt=>'Workspace ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Leave Workspace ID blank to have the new Workspace ID automatically generated.  A Workspace ID must be a positive integer greater than 100000.',
'<br /><br />',
'The Workspace ID is typically only specified when you wish to have a workspace with the identical Workspace ID among two or more &PRODUCT_NAME. instances.  It is not common to specify the Workspace ID when manually creating a workspace.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(663452492781166115)
,p_name=>'P142_ADMIN'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(553411572570635317)
,p_prompt=>'Workspace Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the username of the workspace administrator.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(206356635743953039)
,p_computation_sequence=>10
,p_computation_item=>'P142_DATABASE_USER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P142_DATABASE_USER)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384620781272788403)
,p_validation_name=>'reserved company name'
,p_validation_sequence=>10
,p_validation=>'nvl(upper(:P142_COMPANY),''x'') not in (''INTERNAL'',''UNKNOWN'',''CSS'',''JAVASCRIPT'',''THEMES'',''TUTORIAL'',''XML'',''DOC'',''DP'',''TEMPLATES'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Workspace is a reserved name, request denied.'
,p_when_button_pressed=>wwv_flow_imp.id(384607787358486094)
,p_associated_item=>wwv_flow_imp.id(384611825796547479)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384621098980790776)
,p_validation_name=>'company already exists or requested'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_provision_company',
'            where company_name = upper(:P142_COMPANY)',
'  ) loop',
'  return false;',
'  exit;',
'end loop;',
'for c1 in (select null',
'             from wwv_flow_companies',
'            where short_name = upper(:P142_COMPANY) ) loop',
'   return false;',
'   exit;',
'end loop;',
'',
'if not nvl(length(trim(:P142_COMPANY)),0) > 0 then',
'  return false;',
'end if;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Workspace name already exists'
,p_validation_condition=>'P142_COMPANY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(384607787358486094)
,p_associated_item=>wwv_flow_imp.id(384611825796547479)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384621373688792305)
,p_validation_name=>'Invalid characters in workspace name'
,p_validation_sequence=>30
,p_validation=>'P142_COMPANY'
,p_validation2=>'<>/:'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Invalid #LABEL#.'
,p_when_button_pressed=>wwv_flow_imp.id(384607787358486094)
,p_associated_item=>wwv_flow_imp.id(384611825796547479)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9962836510494926)
,p_validation_name=>'reserved schema name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- This database schema exists (this validation wouldn''t run otherwise). Confirm that this schema',
'-- is eligible to be selected for any workspace or for this specific workspace.',
'for c1 in (select null',
'             from wwv_flow_admin_all_schemas',
'            where username = :P142_DATABASE_USER',
'              and (restricted_to_workspace is null',
'                   or restricted_to_workspace = upper(:P142_COMPANY)))',
'loop',
'    return null;',
'end loop;',
'',
'return wwv_flow_lang.runtime_message(p_name => ''WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'',',
'                                     p0     => :P142_DATABASE_USER);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.all_users',
' where username = :P142_DATABASE_USER'))
,p_validation_condition_type=>'EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(384607787358486094)
,p_associated_item=>wwv_flow_imp.id(384610700214515462)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384623220944823230)
,p_validation_name=>'security group id not exists'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where provisioning_company_id = :P142_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Workspace ID already exists.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'begin',
'  l_num := to_number(nvl(:P142_SECURITY_GROUP_ID,''1''));',
'  return true;',
'exception when others then',
'  return false;',
'end;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(384607787358486094)
,p_associated_item=>wwv_flow_imp.id(384612667869558383)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384623543336826352)
,p_validation_name=>'P142_SECURITY_GROUP_ID'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sgid  number;',
'begin',
'    l_sgid := to_number(:P142_SECURITY_GROUP_ID);',
'    if abs(trunc(l_sgid)) = l_sgid then',
'        return l_sgid >= 100000;',
'    else',
'        return FALSE;',
'    end if;',
'exception when others then',
'    return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Workspace ID must be a positive integer greater than 100000.'
,p_validation_condition=>'P142_SECURITY_GROUP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(384607787358486094)
,p_associated_item=>wwv_flow_imp.id(384612667869558383)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384616042224738712)
,p_validation_name=>'Password not null'
,p_validation_sequence=>70
,p_validation=>'P142_ADMIN_PWD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must provide a password for the workspace administrator database user.'
,p_associated_item=>wwv_flow_imp.id(1605719027242533)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384615872128738710)
,p_validation_name=>'Validate Password'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.password_validation(',
'           p_username => :P142_DATABASE_USER,',
'           p_password => :P142_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The password does not conform to the database password complexity rules.'
,p_validation_condition=>'nvl(:P142_NEW_USER_YN,''N'')=''Y'' and :P142_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1605859236242534)
,p_validation_name=>'Validate Password WKSP'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.password_validation(',
'           p_username => :P142_ADMIN,',
'           p_password => :P142_ADMIN_PWD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The password does not conform to the database password complexity rules.'
,p_validation_condition=>'P142_ADMIN_PWD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(1605719027242533)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(384614956128738701)
,p_name=>'Set P142_COMPANY'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P142_DATABASE_USER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(384615054939738702)
,p_event_id=>wwv_flow_imp.id(384614956128738701)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P142_COMPANY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'upper(:P142_DATABASE_USER)'
,p_attribute_07=>'P142_DATABASE_USER'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(206356296564953035)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(384608102047486098)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(206356366822953036)
,p_event_id=>wwv_flow_imp.id(206356296564953035)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(52035076390715306)
,p_name=>'Set New User YN'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P142_DATABASE_USER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52035186175715307)
,p_event_id=>wwv_flow_imp.id(52035076390715306)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P142_NEW_USER_YN'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_user_yn varchar2(1) := ''Y'';',
'begin',
'    for c1 in (',
'        select null',
'          from sys.all_users a',
'         where a.username = upper(:P142_DATABASE_USER)',
'    ) loop',
'        l_new_user_yn := ''N'';',
'    end loop;',
'    return l_new_user_yn;',
'end;'))
,p_attribute_07=>'P142_DATABASE_USER'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(384609241818486114)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_schema_name         varchar2(256);',
'    l_p1                  varchar2(256)  := wwv_flow_provision.get_random_password(16);',
'    l_username_asserted   varchar2(4000) := wwv_flow_assert.enquote_name(upper(:P142_ADMIN));',
'    l_password_asserted   varchar2(4000) := wwv_flow_assert.enquote_name(:P142_ADMIN_PWD);',
'    l_sql                 varchar2(32767);',
'    user_exists           exception;',
'    pragma exception_init(user_exists,-01920);',
'begin',
'   if nvl(:P142_NEW_USER_YN,''Y'') = ''N'' then',
'       l_schema_name := :P142_DATABASE_USER;',
'       l_p1          := null;',
'   else',
'       l_schema_name := substr(wwv_flow_platform.get_preference(''SELF_SERVICE_SCHEMA_PREFIX'')',
'           ||wwv_flow_provisioning.generate_schema_for_workspace(:P142_COMPANY),1,128);',
'',
'       -- ',
'       -- This generated database user could already exist in the case that a workspace was removed, and ',
'       -- then attempted to be recreated. Check if the user exists in dba_users and then call ',
'       -- generate_schema_for_workspace again using this username to get a generated license plate style ',
'       -- schema name. (bug 34370679)',
'       --',
'       for c1 in (select null',
'                    from sys.dba_users',
'                   where username = l_schema_name) loop',
'            l_schema_name := substr(wwv_flow_platform.get_preference(''SELF_SERVICE_SCHEMA_PREFIX'')',
'               ||wwv_flow_provisioning.generate_schema_for_workspace(l_schema_name),1,128);',
'        end loop;',
'   end if;',
'',
'   if :P142_SECURITY_GROUP_ID is null then',
'       :P142_SECURITY_GROUP_ID := wwv_flow_id.next_val;',
'   end if;',
'   ',
'   if nvl(:P142_NEW_USER_YN,''N'') = ''Y'' and :P142_PASSWORD is not null then',
'       l_p1 := :P142_PASSWORD;',
'   end if;',
'',
'    wwv_flow_provisioning.auto_provision_company(',
'        p_company_name        => :P142_COMPANY,',
'        p_schema_name         => l_schema_name,',
'        p_schema_password     => l_p1,',
'        p_admin_password      => :P142_ADMIN_PWD,',
'        p_admin_userid        => :P142_ADMIN,',
'        p_security_group_id   => :P142_SECURITY_GROUP_ID',
'    );',
'    ',
'    update wwv_flow_fnd_user',
'       set FIRST_PASSWORD_USE_OCCURRED = ''Y'',',
'           CHANGE_PASSWORD_ON_FIRST_USE = ''N''',
'     where user_name = upper(:P142_ADMIN)',
'       and security_group_id = :P142_SECURITY_GROUP_ID;',
'',
'    --',
'    -- Create workspace administrator DB user if builder auth is DB',
'    -- allow this user to already exist  ',
'    --',
'    l_sql := ''create user ''||l_username_asserted||'' identified by ''||l_password_asserted;',
'',
'    begin',
'        if nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB'' then',
'            execute immediate l_sql;',
'        end if;',
'    exception ',
'        when user_exists then',
'            null;',
'    end;    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating workspace.'
,p_process_when_button_id=>wwv_flow_imp.id(384607787358486094)
,p_process_success_message=>'Workspace created. Sign out of Administration Services and sign in to <a href="f?p=4550:1:::::F4550_P1_COMPANY,F4550_P1_USERNAME:&P142_COMPANY!ATTR.,&P142_ADMIN!ATTR.">&P142_COMPANY!HTML.</a> to begin building applications.'
,p_internal_uid=>384609241818486114
);
end;
/
prompt --application/pages/page_00143
begin
wwv_flow_imp_page.create_page(
 p_id=>143
,p_name=>'Create Workspace'
,p_alias=>'CREATE-WORKSPACE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Workspace'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
,p_dialog_height=>'430'
,p_protection_level=>'C'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1604983532242525)
,p_plug_name=>'Create Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1605497193242530)
,p_plug_name=>'How would you like to create your workspace?'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2330006507372601)
,p_plug_name=>'Workspace Options'
,p_region_css_classes=>'u-Block--hero mnw640'
,p_region_sub_css_classes=>'a-MediaList--buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_imp.id(2335847754387056)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(1104606511149216228)
,p_translate_title=>'N'
,p_plug_header=>'<h1 class="u-Block-title">How would you like to create your workspace?</h1>'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="a-Dialog-textContent" style="margin-top:24px">',
'An APEX workspace is a shared work area where multiple developers can build applications.',
'A database schema will contain your applications'' data.',
'If you are just getting started, choose the <strong>New Schema</strong> option.',
'</p>'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1605699601242532)
,p_name=>'P143_WKSP_OPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1604983532242525)
,p_item_default=>'S'
,p_prompt=>'Workspace Option'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ADB_WORKSPACE_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(2316651525357529)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00144
begin
wwv_flow_imp_page.create_page(
 p_id=>144
,p_name=>'Data Loading Jobs'
,p_alias=>'DATA-LOADING-JOBS'
,p_step_title=>'Data Loading Jobs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(218528064999706512)
,p_plug_name=>'Data Loading Jobs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    j.job_name,',
'    j.state,',
'    substr( j.job_name, 18 ) as dataload_job_id,',
'    wwv_flow_utilities.prepare_url( ''f?p=4050:145:'' || :APP_SESSION || ''::::P145_JOB_NAME:''|| job_name ) as link,    ',
'    j.comments,',
'    j.start_date,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 ) as workspace_id,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,2,''i'',2 ) as workspace_user,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,3,''i'',2 ) as table_owner,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,4,''i'',2 ) as table_name,',
'    c.display_name',
'from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'and job_name like ''ORACLE_APEX_DTLD$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(218528160760706513)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No active SQL Workshop Data Loading jobs.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>218528160760706513
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218528250253706514)
,p_db_column_name=>'JOB_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'DBMS_SCHEDULER Job Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218528371017706515)
,p_db_column_name=>'DATALOAD_JOB_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'&nbsp;'
,p_column_link=>'#LINK#'
,p_column_linktext=>'Stop'
,p_column_link_attr=>'class="a-Button a-Button--iconTextButton"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218528575173706517)
,p_db_column_name=>'START_DATE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Started'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218528492404706516)
,p_db_column_name=>'COMMENTS'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>'Details'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218528693715706518)
,p_db_column_name=>'STATE'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Job State'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218528711746706519)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Workspace Id'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218528880092706520)
,p_db_column_name=>'TABLE_OWNER'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Table Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218528948474706521)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218529097388706522)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>100
,p_column_identifier=>'I'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218529172770706523)
,p_db_column_name=>'WORKSPACE_USER'
,p_display_order=>110
,p_column_identifier=>'J'
,p_column_label=>'Workspace User'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(384102019184736250)
,p_db_column_name=>'LINK'
,p_display_order=>120
,p_column_identifier=>'K'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(284064556498223011)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'2840646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DATALOAD_JOB_ID:JOB_NAME:DISPLAY_NAME:WORKSPACE_USER:TABLE_OWNER:TABLE_NAME:START_DATE:STATE:'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(335463803332351501)
,p_name=>'Stop Job Dialog closed.'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(218528064999706512)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(335463917606351502)
,p_event_id=>wwv_flow_imp.id(335463803332351501)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(218528064999706512)
);
end;
/
prompt --application/pages/page_00145
begin
wwv_flow_imp_page.create_page(
 p_id=>145
,p_name=>'Stop Data Loading Job'
,p_alias=>'STOP-DATA-LOADING-JOB'
,p_page_mode=>'MODAL'
,p_step_title=>'Stop Data Loading Job'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(218529958866706531)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(218530043769706532)
,p_plug_name=>'Stop Job'
,p_region_css_classes=>'a-Alert--inlineDialog'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Are you sure to stop Data Loading Job &P145_JOB_NAME.?'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from user_scheduler_jobs',
'where job_name = :P145_JOB_NAME'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(218530855375706540)
,p_plug_name=>'Job already finished'
,p_region_css_classes=>'a-Alert--inlineDialog'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Data Loading Job &P145_JOB_NAME. has already finished.'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from user_scheduler_jobs',
'where job_name = :P145_JOB_NAME'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(218530154317706533)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(218529958866706531)
,p_button_name=>'STOP_JOB'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Stop Job'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from user_scheduler_jobs',
'where job_name = :P145_JOB_NAME'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(218530224732706534)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(218529958866706531)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(218530747187706539)
,p_name=>'P145_JOB_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(218530043769706532)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(218530365994706535)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(218530224732706534)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(218530460090706536)
,p_event_id=>wwv_flow_imp.id(218530365994706535)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(218530537372706537)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Stop Job'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    sys.dbms_scheduler.stop_job( job_name => :P145_JOB_NAME );',
'end;',
'   '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(218530154317706533)
,p_process_success_message=>'Data Loading Job &P145_JOB_NAME. stopped.'
,p_internal_uid=>218530537372706537
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(218530651319706538)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(218530154317706533)
,p_internal_uid=>218530651319706538
);
end;
/
prompt --application/pages/page_00147
begin
wwv_flow_imp_page.create_page(
 p_id=>147
,p_name=>'Backup Log'
,p_alias=>'BACKUP-LOG'
,p_step_title=>'Backup Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784309333645873)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(239497587857621454)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'The Backup Log reports when a backup job ran, the number of applications backed up by the job, and the elapsed time required to backup the applications.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(239901767442654202)
,p_plug_name=>'Backup Log'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.batch_id,  regexp_substr (b.duration, ''\d{2}:\d{2}:\d{2}\.\d{3}'') as duration, b.comments, b.created_on, count(*) as app_count',
'from wwv_flow_backup_log b',
'join wwv_flow_backup_log d on (d.batch_id = b.batch_id)',
'where b.application_id is null',
'and d.application_id is not null',
'group by b.batch_id, b.duration, b.comments, b.created_on;'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(239901875559654202)
,p_name=>'Automatic File Delete Log'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'JOEL'
,p_internal_uid=>239901875559654202
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8001499918535609)
,p_db_column_name=>'BATCH_ID'
,p_display_order=>12
,p_column_identifier=>'J'
,p_column_label=>'Batch'
,p_column_link=>'f?p=&APP_ID.:151:&SESSION.::&DEBUG.:RP,151:P151_BATCH_ID:#BATCH_ID#'
,p_column_linktext=>'#BATCH_ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8001751453535612)
,p_db_column_name=>'COMMENTS'
,p_display_order=>42
,p_column_identifier=>'M'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8001803945535613)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>52
,p_column_identifier=>'N'
,p_column_label=>'Created On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8002286775535617)
,p_db_column_name=>'APP_COUNT'
,p_display_order=>72
,p_column_identifier=>'P'
,p_column_label=>'Number of Application Backups'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8002377664535618)
,p_db_column_name=>'DURATION'
,p_display_order=>82
,p_column_identifier=>'Q'
,p_column_label=>'Duration'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(239917682717654367)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'779284'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'BATCH_ID:APP_COUNT:CREATED_ON:DURATION:'
,p_sort_column_1=>'DELETED_ON'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1251855180856756044)
,p_plug_name=>'Backup Log'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(77923751191380757)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1251855180856756044)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:RIR,124::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(77924110747380760)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1251855180856756044)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Truncate'
,p_button_position=>'NEXT'
,p_confirm_message=>'Do you really want to truncate the Backup Log?'
,p_confirm_style=>'danger'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(77929972153380794)
,p_branch_action=>'f?p=&FLOW_ID.:147:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(77929007382380791)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_backup_log;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating log.'
,p_process_when_button_id=>wwv_flow_imp.id(77924110747380760)
,p_process_success_message=>'Successfully truncated log.'
,p_internal_uid=>77929007382380791
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(77929427811380792)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(77923751191380757)
,p_internal_uid=>77929427811380792
);
end;
/
prompt --application/pages/page_00148
begin
wwv_flow_imp_page.create_page(
 p_id=>148
,p_name=>'Dictionary Cache'
,p_alias=>'DICTIONARY-CACHE'
,p_step_title=>'Dictionary Cache'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60096224377984114)
,p_plug_name=>'APEX Data Dictionary Cached Objects'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       APX_CACHE_DATE,',
'       APX_COL_CACHE_DATE,',
'       APX_WORKSPACE,',
'       APX_WORKSPACE_CREATED,',
'       APX_WORKSPACE_LAST_LOGIN,',
'       APX_WORKSPACE_STATUS,',
'       OBJECT_ID,',
'       OBJECT_OWNER,',
'       OBJECT_NAME,',
'       OBJECT_PREFIX,',
'       OBJECT_TYPE,',
'       OBJECT_CREATED,',
'       OBJECT_LAST_DDL_TIME,',
'       OBJECT_PK_COLUMNS,',
'       DISPLAY_COL_1,',
'       DISPLAY_COL_2,',
'       TAB_LAST_ANALYZED,',
'       TAB_CACHE_NUM_ROWS,',
'       DEFAULT_QUERY,',
'       PREFIX_REMOVED_TAB_NAME,',
'       SINGULAR_DISPLAY_LABEL,',
'       PLURAL_DISPLAY_LABEL,',
'       DESCRIPTION,',
'       GEOMETRY_TYPE,',
'       decode(HAS_FK_REFERENCES,''Y'',m.yes,''N'',m.n,HAS_FK_REFERENCES)     HAS_FK_REFERENCES,',
'       decode(HAS_PRIMARY_KEY_YN,''Y'',m.yes,''N'',m.n,HAS_PRIMARY_KEY_YN)   HAS_PRIMARY_KEY_YN,',
'       decode(HAS_LONG_COLUMNS_YN,''Y'',m.yes,''N'',m.n,HAS_LONG_COLUMNS_YN) HAS_LONG_COLUMNS_YN',
'  from WWV_DICTIONARY_CACHE_OBJ co,',
'      (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
'  where SECURITY_GROUP_ID = :P148_WORKSPACE_ID',
'  and SECURITY_GROUP_ID not in (0,10,11,12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(60096364688984115)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>60096364688984115
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60096429759984116)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60096548710984117)
,p_db_column_name=>'APX_CACHE_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Cache Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60096621794984118)
,p_db_column_name=>'APX_COL_CACHE_DATE'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Column Cache Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60096705053984119)
,p_db_column_name=>'APX_WORKSPACE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60096948060984121)
,p_db_column_name=>'APX_WORKSPACE_CREATED'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Workspace Created'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097027543984122)
,p_db_column_name=>'APX_WORKSPACE_LAST_LOGIN'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Workspace Last Login'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097154206984123)
,p_db_column_name=>'APX_WORKSPACE_STATUS'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Workspace Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097297620984124)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Object Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097394102984125)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Object Owner'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097428309984126)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Object Name'
,p_column_link=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,149:P149_OBJECT_CACHE_ID:#ID#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097542185984127)
,p_db_column_name=>'OBJECT_PREFIX'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Object Prefix'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097603274984128)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097764975984129)
,p_db_column_name=>'OBJECT_CREATED'
,p_display_order=>140
,p_column_identifier=>'N'
,p_column_label=>'Object Created'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097859601984130)
,p_db_column_name=>'OBJECT_LAST_DDL_TIME'
,p_display_order=>150
,p_column_identifier=>'O'
,p_column_label=>'Last Data Definition'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60097913039984131)
,p_db_column_name=>'OBJECT_PK_COLUMNS'
,p_display_order=>160
,p_column_identifier=>'P'
,p_column_label=>'Primary Key Columns'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(579565817708721526)
,p_db_column_name=>'DISPLAY_COL_1'
,p_display_order=>170
,p_column_identifier=>'Z'
,p_column_label=>'Primary Display Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(579565969446721527)
,p_db_column_name=>'DISPLAY_COL_2'
,p_display_order=>180
,p_column_identifier=>'AA'
,p_column_label=>'Secondary Display Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098042827984132)
,p_db_column_name=>'TAB_LAST_ANALYZED'
,p_display_order=>190
,p_column_identifier=>'Q'
,p_column_label=>'Statistics Gathered'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098113789984133)
,p_db_column_name=>'TAB_CACHE_NUM_ROWS'
,p_display_order=>200
,p_column_identifier=>'R'
,p_column_label=>'Number of Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098200570984134)
,p_db_column_name=>'DEFAULT_QUERY'
,p_display_order=>210
,p_column_identifier=>'S'
,p_column_label=>'Default Query'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'CLOB'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098368409984135)
,p_db_column_name=>'PREFIX_REMOVED_TAB_NAME'
,p_display_order=>220
,p_column_identifier=>'T'
,p_column_label=>'Prefix Removed Table Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098447224984136)
,p_db_column_name=>'SINGULAR_DISPLAY_LABEL'
,p_display_order=>230
,p_column_identifier=>'U'
,p_column_label=>'Singular Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098580548984137)
,p_db_column_name=>'PLURAL_DISPLAY_LABEL'
,p_display_order=>240
,p_column_identifier=>'V'
,p_column_label=>'Plural Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1431050897132104)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>250
,p_column_identifier=>'AC'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(564900691516013101)
,p_db_column_name=>'GEOMETRY_TYPE'
,p_display_order=>260
,p_column_identifier=>'AB'
,p_column_label=>'Geometry Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(564921851272063247)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098678821984138)
,p_db_column_name=>'HAS_FK_REFERENCES'
,p_display_order=>270
,p_column_identifier=>'W'
,p_column_label=>'Has Foreign Key References'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098728006984139)
,p_db_column_name=>'HAS_PRIMARY_KEY_YN'
,p_display_order=>280
,p_column_identifier=>'X'
,p_column_label=>'Has Primary Key'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098825711984140)
,p_db_column_name=>'HAS_LONG_COLUMNS_YN'
,p_display_order=>290
,p_column_identifier=>'Y'
,p_column_label=>'Has Long Columns'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(524776460298161421)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5247765'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_report_columns=>'OBJECT_NAME:OBJECT_OWNER:TAB_CACHE_NUM_ROWS:OBJECT_PK_COLUMNS:OBJECT_PREFIX:PREFIX_REMOVED_TAB_NAME:SINGULAR_DISPLAY_LABEL:PLURAL_DISPLAY_LABEL:HAS_FK_REFERENCES:HAS_PRIMARY_KEY_YN:OBJECT_CREATED:TAB_LAST_ANALYZED:APX_CACHE_DATE:'
,p_sort_column_1=>'OBJECT_NAME'
,p_sort_direction_1=>'ASC'
,p_sum_columns_on_break=>'TAB_CACHE_NUM_ROWS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1049900178760634715)
,p_plug_name=>'Workspace Dictionary Cache Filter'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>2
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(525110925345577129)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1049900178760634715)
,p_button_name=>'analyze_refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Gather Statistics and Refresh Cache'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(525108173850577101)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1049900178760634715)
,p_button_name=>'refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Refresh Cache Only'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(525111487137577134)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(60096224377984114)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(525095890207396166)
,p_name=>'P148_WORKSPACE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1049900178760634715)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name, PROVISIONING_COMPANY_ID',
'from WWV_FLOW_COMPANIES',
'order by 1'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(525108317868577103)
,p_name=>'workspace'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P148_WORKSPACE_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(525108467585577104)
,p_event_id=>wwv_flow_imp.id(525108317868577103)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(525108226704577102)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.builder_set_workspace_cache (',
'    p_workspace_id            => :P148_WORKSPACE_ID,',
'    p_gather_stats            => false,',
'    p_max_cache_stale_seconds => 5,     -- seconds',
'    p_max_tables_per_schema   => 1000,  -- tables',
'    p_stats_mode              => ''estimate'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(525108173850577101)
,p_internal_uid=>525108226704577102
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(525111048901577130)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats_analyze'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.builder_set_workspace_cache (',
'    p_workspace_id            => :P148_WORKSPACE_ID,',
'    p_gather_stats            => true,',
'    p_max_stats_age_seconds   => 10,',
'    p_max_cache_stale_seconds => 10,     -- seconds',
'    p_max_tables_per_schema   => 1000,   -- tables',
'    p_stats_mode              => ''estimate'',',
'    p_max_elap_exec_time_sec  => 600     -- if it takes 10 minutes, exit',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(525110925345577129)
,p_process_success_message=>'Statistics Computed for Selected Workspace'
,p_internal_uid=>525111048901577130
);
end;
/
prompt --application/pages/page_00149
begin
wwv_flow_imp_page.create_page(
 p_id=>149
,p_name=>'Data Dictionary Cache Table Columns'
,p_alias=>'DATA-DICTIONARY-CACHE-TABLE-COLUMNS'
,p_step_title=>'Data Dictionary Cache Table Columns'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(524803615085238539)
,p_plug_name=>'Report Filters'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(525111938241577139)
,p_name=>'Table Details'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_sub_css_classes=>'a-AVPList--leftAligned'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       APX_CACHE_DATE,',
'       OBJECT_NAME,',
'       DESCRIPTION,',
'       OBJECT_TYPE,',
'       OBJECT_CREATED,',
'       OBJECT_PK_COLUMNS,',
'       TAB_LAST_ANALYZED,',
'       TAB_CACHE_NUM_ROWS,',
'       decode(HAS_FK_REFERENCES,''Y'',m.yes,''N'',m.n,HAS_FK_REFERENCES)     HAS_FK_REFERENCES',
'  from WWV_DICTIONARY_CACHE_OBJ co,',
'      (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
' where id = :P149_OBJECT_CACHE_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805670753642677848)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No data found'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(525112016945577140)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(525112126586577141)
,p_query_column_id=>2
,p_column_alias=>'APX_CACHE_DATE'
,p_column_display_sequence=>42
,p_column_heading=>'Cache Date'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(525113084679577150)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1431117254132105)
,p_query_column_id=>4
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>12
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(562146788838879302)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>22
,p_column_heading=>'Object Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(562146817766879303)
,p_query_column_id=>6
,p_column_alias=>'OBJECT_CREATED'
,p_column_display_sequence=>32
,p_column_heading=>'Object Created'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(562147050273879305)
,p_query_column_id=>7
,p_column_alias=>'OBJECT_PK_COLUMNS'
,p_column_display_sequence=>62
,p_column_heading=>'Primary Key Columns'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(562147161214879306)
,p_query_column_id=>8
,p_column_alias=>'TAB_LAST_ANALYZED'
,p_column_display_sequence=>52
,p_column_heading=>'Statistics Gathered'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(562147255245879307)
,p_query_column_id=>9
,p_column_alias=>'TAB_CACHE_NUM_ROWS'
,p_column_display_sequence=>72
,p_column_heading=>'Rows'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(562147795985879312)
,p_query_column_id=>10
,p_column_alias=>'HAS_FK_REFERENCES'
,p_column_display_sequence=>82
,p_column_heading=>'Foreign Key References'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(562148217569879317)
,p_name=>'Column Queries'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select FILTERABLE_SCORE, ',
'       decode(RECOMMEND_CHART_TYPE,''PIE'',m.PIE_CHART,''BAR'',m.BAR_CHART,RECOMMEND_CHART_TYPE) RECOMMEND_CHART_TYPE,',
'       decode(FK_CHART_QUERY,',
'              null,',
'              ''select "''||COLUMN_NAME||''", count(*) c ''||chr(10)||',
'              ''from "''||TABLE_NAME||''" ''||chr(10)||',
'              ''group by "''||COLUMN_NAME||''" ''||chr(10)||',
'              ''order by 2 desc'',FK_CHART_QUERY) chart_query',
'from WWV_DICTIONARY_CACHE_COL,',
'        (select wwv_flow_lang.system_message(''BAR_CHART'')   BAR_CHART,',
'                wwv_flow_lang.system_message(''PIE_CHART'')   PIE_CHART',
'         from dual) m',
'where OBJECT_CACHE_ID = :P149_OBJECT_CACHE_ID and ',
'     FILTERABLE_SCORE >= 20 and',
'     (DATA_TYPE in (''VARCHAR'',''VARCHAR2'',''CHAR'') or FK_CHART_QUERY is not null)',
'order by FILTERABLE_SCORE desc'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 x',
'from WWV_DICTIONARY_CACHE_COL',
'where OBJECT_CACHE_ID = :P149_OBJECT_CACHE_ID and ',
'     FILTERABLE_SCORE >= 20 and',
'     (DATA_TYPE in (''VARCHAR'',''VARCHAR2'',''CHAR'') or FK_CHART_QUERY is not null)'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(565825012543226210)
,p_query_column_id=>1
,p_column_alias=>'FILTERABLE_SCORE'
,p_column_display_sequence=>1
,p_column_heading=>'Relevance'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(562148362693879318)
,p_query_column_id=>2
,p_column_alias=>'RECOMMEND_CHART_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Chart Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(562148951029879324)
,p_query_column_id=>3
,p_column_alias=>'CHART_QUERY'
,p_column_display_sequence=>3
,p_column_heading=>'Query'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<pre>#CHART_QUERY#</pre>'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(565824800545226208)
,p_plug_name=>'Table Query'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'   for c1 in ( ',
'       select sys.dbms_lob.substr(DEFAULT_QUERY,32767,1) DEFAULT_QUERY',
'         from WWV_DICTIONARY_CACHE_OBJ',
'        where id = :P149_OBJECT_CACHE_ID )                ',
'   loop',
'    return ''<pre class="padding-md">''',
'           || wwv_flow_escape.html(c1.DEFAULT_QUERY)',
'           || ''</pre>'';            ',
'    end loop;    ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_ajax_items_to_submit=>'P149_OBJECT_CACHE_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(584885052401216767)
,p_plug_name=>'Data Dictionary Column Cache'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       OBJECT_CACHE_ID,',
'       APX_CACHE_DATE,',
'       OWNER_NAME,',
'       TABLE_NAME,',
'       COLUMN_NAME,',
'       DATA_TYPE_DISPLAY,',
'       DATA_TYPE,',
'       DATA_LENGTH,',
'       DATA_SCALE,',
'       DATA_PRECISION,',
'       has_char_semantics_yn,',
'       NULLABLE,',
'       DENSITY,',
'       NUM_NULLS,',
'       LAST_ANALYZED,',
'       AVG_COL_LEN,',
'       NUM_DISTINCT,',
'       COLUMN_ID,',
'       --',
'       decode(ITEM_DISPLAY_AS,',
'          ''TEXT'',m.m_text,',
'          ''NUMBER'',m.m_number,',
'          ''CHECKBOX'',m.checkbox,',
'          ''DATE_PICKER'',m.date_picker,',
'          ''TEXTAREA'',m.TEXTAREA,',
'          ITEM_DISPLAY_AS)',
'          ITEM_DISPLAY_AS,',
'       decode(FILTER_DISPLAY_AS,''CHECKBOX'',m.checkbox,',
'          ''RANGE'',m.range,',
'          ''DATE_PICKER'',m.date_picker,',
'          FILTER_DISPLAY_AS)',
'          FILTER_DISPLAY_AS,',
'       --',
'       LABEL,',
'       FORMAT_MASK,',
'       --',
'       decode(RECOMMEND_DISP_ON_RPT_YN,    ''Y'',m.yes,''N'',m.n) RECOMMEND_DISP_ON_RPT_YN,',
'       decode(RECOMMEND_DISP_ON_FORMS_YN,  ''Y'',m.yes,''N'',m.n) RECOMMEND_DISP_ON_FORMS_YN,',
'       decode(HAS_LEADING_IDX_YN,          ''Y'',m.yes,''N'',m.n) HAS_LEADING_IDX_YN,    ',
'       decode(IS_SINGLE_COL_PK_YN,         ''Y'',m.yes,''N'',m.n) IS_SINGLE_COL_PK_YN,',
'       decode(FILTER_GLOBAL_SEARCHABLE_YN, ''Y'',m.yes,''N'',m.n) facet_search_col_yn,',
'       decode(SINGLE_COL_UNIQUE_CON_YN,    ''Y'',m.yes,''N'',m.n) SINGLE_COL_UNIQUE_CON_YN,',
'       decode(IS_VIRTUALLY_UNIQUE_YN,      ''Y'',m.yes,''N'',m.n) IS_VIRTUALLY_UNIQUE_YN,',
'       --',
'       PK_POSITION,',
'       is_identity_yn,',
'       IS_FK_YN,',
'       IS_FK_INDEXED_YN,',
'       DRILL_DOWN_TABLE,',
'       DRILL_DOWN_DISPLAY_COLUMN,',
'       DRILL_DOWN_RETURN_COLUMN,',
'       LOW_VALUE,',
'       HIGH_VALUE,',
'       LOW_NUMBER,',
'       HIGH_NUMBER,',
'       LOW_DATE,',
'       HIGH_DATE,',
'       FILTERABLE_SCORE,',
'       NUM_NOT_NULL,',
'       PCT_NULL,',
'       RECOMMEND_CHART_TYPE,',
'       FK_CHART_QUERY,',
'       CHART_LABEL_COLUMN,',
'       CHART_VALUE_COLUMN,',
'       COLUMN_QUERY,',
'       STATIC_LOV',
'  from WWV_DICTIONARY_CACHE_COL cc,',
'        (select wwv_flow_lang.system_message(''F4000.NO'')    n,',
'                wwv_flow_lang.system_message(''F4000.YES'')   yes,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_CHECKBOX'')    checkbox,',
'                wwv_flow_lang.system_message(''APEX.IG.RANGE'')                range,',
'                wwv_flow_lang.system_message(''ITEM_NAME.TEXT'')               m_text,',
'                wwv_flow_lang.system_message(''WS_NUMBER'')                    m_number,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_DATE_PICKER'') date_picker,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_RADIOGROUP'')  RADIOGROUP,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_TEXTAREA'')    TEXTAREA',
'         from dual) m',
'  where OBJECT_CACHE_ID = :P149_OBJECT_CACHE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(584885192712216768)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>584885192712216768
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524789425659232668)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524789817808232670)
,p_db_column_name=>'APX_CACHE_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Cache Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60098945549984141)
,p_db_column_name=>'OBJECT_CACHE_ID'
,p_display_order=>30
,p_column_identifier=>'Z'
,p_column_label=>'Object Cache ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60099016342984142)
,p_db_column_name=>'OWNER_NAME'
,p_display_order=>40
,p_column_identifier=>'AA'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60099148004984143)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>50
,p_column_identifier=>'AB'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60099212143984144)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>60
,p_column_identifier=>'AC'
,p_column_label=>'Column Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524800787276238510)
,p_db_column_name=>'LABEL'
,p_display_order=>70
,p_column_identifier=>'AS'
,p_column_label=>'Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60099350774984145)
,p_db_column_name=>'DATA_TYPE_DISPLAY'
,p_display_order=>80
,p_column_identifier=>'AD'
,p_column_label=>'Display As'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60099436968984146)
,p_db_column_name=>'DATA_TYPE'
,p_display_order=>90
,p_column_identifier=>'AE'
,p_column_label=>'Data Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60099578575984147)
,p_db_column_name=>'DATA_LENGTH'
,p_display_order=>100
,p_column_identifier=>'AF'
,p_column_label=>'Data Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60099698797984148)
,p_db_column_name=>'DATA_SCALE'
,p_display_order=>110
,p_column_identifier=>'AG'
,p_column_label=>'Data Scale'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60099777889984149)
,p_db_column_name=>'DATA_PRECISION'
,p_display_order=>120
,p_column_identifier=>'AH'
,p_column_label=>'Data Precision'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(606264386193993803)
,p_db_column_name=>'HAS_CHAR_SEMANTICS_YN'
,p_display_order=>130
,p_column_identifier=>'BW'
,p_column_label=>'Uses Character Semantics'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60099827535984150)
,p_db_column_name=>'NULLABLE'
,p_display_order=>140
,p_column_identifier=>'AI'
,p_column_label=>'Nullable'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524799872884238501)
,p_db_column_name=>'DENSITY'
,p_display_order=>150
,p_column_identifier=>'AJ'
,p_column_label=>'Density'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524799948789238502)
,p_db_column_name=>'NUM_NULLS'
,p_display_order=>160
,p_column_identifier=>'AK'
,p_column_label=>'Number of Nulls'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524800002669238503)
,p_db_column_name=>'LAST_ANALYZED'
,p_display_order=>170
,p_column_identifier=>'AL'
,p_column_label=>'Statistics Gathered'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524800171102238504)
,p_db_column_name=>'AVG_COL_LEN'
,p_display_order=>180
,p_column_identifier=>'AM'
,p_column_label=>'Average Data Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524800211104238505)
,p_db_column_name=>'NUM_DISTINCT'
,p_display_order=>190
,p_column_identifier=>'AN'
,p_column_label=>'Distinct'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524800302405238506)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>200
,p_column_identifier=>'AO'
,p_column_label=>'Column ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524800453878238507)
,p_db_column_name=>'ITEM_DISPLAY_AS'
,p_display_order=>210
,p_column_identifier=>'AP'
,p_column_label=>'Item Display'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524800584988238508)
,p_db_column_name=>'FILTER_DISPLAY_AS'
,p_display_order=>220
,p_column_identifier=>'AQ'
,p_column_label=>'Facet Display'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524800822260238511)
,p_db_column_name=>'FORMAT_MASK'
,p_display_order=>230
,p_column_identifier=>'AT'
,p_column_label=>'Format Mask'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524800904796238512)
,p_db_column_name=>'RECOMMEND_DISP_ON_RPT_YN'
,p_display_order=>240
,p_column_identifier=>'AU'
,p_column_label=>'Recommend Display on Report'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801041508238513)
,p_db_column_name=>'RECOMMEND_DISP_ON_FORMS_YN'
,p_display_order=>250
,p_column_identifier=>'AV'
,p_column_label=>'Recommend Display on Forms'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801144818238514)
,p_db_column_name=>'HAS_LEADING_IDX_YN'
,p_display_order=>260
,p_column_identifier=>'AW'
,p_column_label=>'Has Leading Index'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801224945238515)
,p_db_column_name=>'IS_SINGLE_COL_PK_YN'
,p_display_order=>270
,p_column_identifier=>'AX'
,p_column_label=>'Single Column Primary Key'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801373558238516)
,p_db_column_name=>'PK_POSITION'
,p_display_order=>280
,p_column_identifier=>'AY'
,p_column_label=>'Primary Key Position'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(606264461819993804)
,p_db_column_name=>'IS_IDENTITY_YN'
,p_display_order=>290
,p_column_identifier=>'BX'
,p_column_label=>'Identity Column'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801410753238517)
,p_db_column_name=>'SINGLE_COL_UNIQUE_CON_YN'
,p_display_order=>300
,p_column_identifier=>'AZ'
,p_column_label=>'Unique Constraint'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801565830238518)
,p_db_column_name=>'IS_VIRTUALLY_UNIQUE_YN'
,p_display_order=>310
,p_column_identifier=>'BA'
,p_column_label=>'Is Virtually Unique'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801666963238519)
,p_db_column_name=>'IS_FK_YN'
,p_display_order=>320
,p_column_identifier=>'BB'
,p_column_label=>'Is Foreign Key'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801738525238520)
,p_db_column_name=>'IS_FK_INDEXED_YN'
,p_display_order=>330
,p_column_identifier=>'BC'
,p_column_label=>'Foreign Key Indexed'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801865482238521)
,p_db_column_name=>'DRILL_DOWN_TABLE'
,p_display_order=>340
,p_column_identifier=>'BD'
,p_column_label=>'Drill Down Table'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524801907346238522)
,p_db_column_name=>'DRILL_DOWN_DISPLAY_COLUMN'
,p_display_order=>350
,p_column_identifier=>'BE'
,p_column_label=>'Drill Down Display Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802097646238523)
,p_db_column_name=>'DRILL_DOWN_RETURN_COLUMN'
,p_display_order=>360
,p_column_identifier=>'BF'
,p_column_label=>'Drill Down Return Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802187839238524)
,p_db_column_name=>'LOW_VALUE'
,p_display_order=>370
,p_column_identifier=>'BG'
,p_column_label=>'Low Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802265102238525)
,p_db_column_name=>'HIGH_VALUE'
,p_display_order=>380
,p_column_identifier=>'BH'
,p_column_label=>'High Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802344292238526)
,p_db_column_name=>'LOW_NUMBER'
,p_display_order=>390
,p_column_identifier=>'BI'
,p_column_label=>'Low Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802414098238527)
,p_db_column_name=>'HIGH_NUMBER'
,p_display_order=>400
,p_column_identifier=>'BJ'
,p_column_label=>'High Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802586684238528)
,p_db_column_name=>'LOW_DATE'
,p_display_order=>410
,p_column_identifier=>'BK'
,p_column_label=>'Low Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802693693238529)
,p_db_column_name=>'HIGH_DATE'
,p_display_order=>420
,p_column_identifier=>'BL'
,p_column_label=>'High Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802798505238530)
,p_db_column_name=>'FILTERABLE_SCORE'
,p_display_order=>430
,p_column_identifier=>'BM'
,p_column_label=>'Faceted Search Score'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(606264590935993805)
,p_db_column_name=>'FACET_SEARCH_COL_YN'
,p_display_order=>440
,p_column_identifier=>'BY'
,p_column_label=>'Facet Searchable Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802852545238531)
,p_db_column_name=>'NUM_NOT_NULL'
,p_display_order=>450
,p_column_identifier=>'BN'
,p_column_label=>'Not Null'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524802955741238532)
,p_db_column_name=>'PCT_NULL'
,p_display_order=>460
,p_column_identifier=>'BO'
,p_column_label=>'Percent Null'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524803068508238533)
,p_db_column_name=>'RECOMMEND_CHART_TYPE'
,p_display_order=>470
,p_column_identifier=>'BP'
,p_column_label=>'Recommend Chart'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524803149342238534)
,p_db_column_name=>'FK_CHART_QUERY'
,p_display_order=>480
,p_column_identifier=>'BQ'
,p_column_label=>'Foreign Key Chart Query'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524803270358238535)
,p_db_column_name=>'CHART_LABEL_COLUMN'
,p_display_order=>490
,p_column_identifier=>'BR'
,p_column_label=>'Chart Label Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524803382264238536)
,p_db_column_name=>'CHART_VALUE_COLUMN'
,p_display_order=>500
,p_column_identifier=>'BS'
,p_column_label=>'Chart Value Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524803459631238537)
,p_db_column_name=>'COLUMN_QUERY'
,p_display_order=>510
,p_column_identifier=>'BT'
,p_column_label=>'Column Query'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524803507332238538)
,p_db_column_name=>'STATIC_LOV'
,p_display_order=>520
,p_column_identifier=>'BU'
,p_column_label=>'Static List of Values'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1049565288321394074)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5247990'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COLUMN_ID:COLUMN_NAME:LABEL:FILTERABLE_SCORE:DATA_TYPE:ITEM_DISPLAY_AS:FILTER_DISPLAY_AS:DENSITY:AVG_COL_LEN:NUM_DISTINCT:NUM_NULLS:PCT_NULL:LAST_ANALYZED:APX_CACHE_DATE:'
,p_sort_column_1=>'COLUMN_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'FILTERABLE_SCORE'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'OBJECT_NAME'
,p_sort_direction_3=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(525315256234977749)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(524803615085238539)
,p_button_name=>'gather_stats'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Gather Statistics and Refresh Cache'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(525111820549577138)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(524803615085238539)
,p_button_name=>'refresh_cache'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Refresh Cache Only'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(525111344357577133)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(584885052401216767)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(524803758352238540)
,p_name=>'P149_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(524803615085238539)
,p_prompt=>'Table Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select OBJECT_NAME',
'from wwv_dictionary_cache_obj',
'where id = :P149_OBJECT_CACHE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(525110886602577128)
,p_name=>'P149_OBJECT_CACHE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(524803615085238539)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(525303525750948617)
,p_name=>'P149_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(524803615085238539)
,p_prompt=>'Table Owner'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_owner',
'from wwv_dictionary_cache_obj',
'where id = :P149_OBJECT_CACHE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(525108740586577107)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh table cache with stats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_new_object_cache_id number;',
'begin',
'    l_new_object_cache_id := wwv_dictionary_cache_dev.builder_reset_object_cache(',
'                                 p_workspace_id             => :P148_WORKSPACE_ID,',
'                                 p_object_id                => :P149_OBJECT_CACHE_ID,',
'                                 p_cache_fk_references      => true,',
'                                 p_gather_stats             => true );',
'                                 ',
'    :P149_OBJECT_CACHE_ID := l_new_object_cache_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(525315256234977749)
,p_internal_uid=>525108740586577107
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(525111566533577135)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_new_object_cache_id number;',
'begin',
'    l_new_object_cache_id := wwv_dictionary_cache_dev.builder_reset_object_cache(',
'                                 p_workspace_id             => :P148_WORKSPACE_ID,',
'                                 p_object_id                => :P149_OBJECT_CACHE_ID,',
'                                 p_cache_fk_references      => true,',
'                                 p_gather_stats             => false );',
'                                 ',
'    :P149_OBJECT_CACHE_ID := l_new_object_cache_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(525111820549577138)
,p_internal_uid=>525111566533577135
);
end;
/
prompt --application/pages/page_00150
begin
wwv_flow_imp_page.create_page(
 p_id=>150
,p_name=>'Data Dictionary Cache - Workspaces'
,p_alias=>'DATA-DICTIONARY-CACHE-WORKSPACES'
,p_step_title=>'Data Dictionary Cache - Workspaces'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(585156988233310532)
,p_plug_name=>'Data Dictionary - Workspaces'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       PROVISIONING_COMPANY_ID,',
'       DISPLAY_NAME workspace_name,',
'       --',
'       (select count(*) ',
'        from WWV_DICTIONARY_CACHE_OBJ d ',
'        where d.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) cached_objects,',
'        --',
'       (select count(distinct OBJECT_OWNER) ',
'        from WWV_DICTIONARY_CACHE_OBJ d ',
'        where d.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) schemas,',
'        --',
'        (select max(OBJECT_LAST_DDL_TIME) x',
'        from WWV_DICTIONARY_CACHE_OBJ d ',
'        where d.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) last_ddl_time,',
'        --',
'        (select max(APX_CACHE_DATE) x',
'        from WWV_DICTIONARY_CACHE_OBJ d ',
'        where d.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) last_cache_time ',
'  from WWV_FLOW_COMPANIES c',
'where PROVISIONING_COMPANY_ID not in (0,10,11,12)',
' '))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(585157128544310533)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>585157128544310533
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(525061346641326421)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524804085454238543)
,p_db_column_name=>'PROVISIONING_COMPANY_ID'
,p_display_order=>20
,p_column_identifier=>'Z'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524804145713238544)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>30
,p_column_identifier=>'AA'
,p_column_label=>'Workspace'
,p_column_link=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.:RP,148:P148_WORKSPACE_ID:#PROVISIONING_COMPANY_ID#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524804250665238545)
,p_db_column_name=>'CACHED_OBJECTS'
,p_display_order=>40
,p_column_identifier=>'AB'
,p_column_label=>'Cached Objects'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524804319247238546)
,p_db_column_name=>'SCHEMAS'
,p_display_order=>50
,p_column_identifier=>'AC'
,p_column_label=>'Schema Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524804473203238547)
,p_db_column_name=>'LAST_DDL_TIME'
,p_display_order=>60
,p_column_identifier=>'AD'
,p_column_label=>'Last Data Definition'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524804508974238548)
,p_db_column_name=>'LAST_CACHE_TIME'
,p_display_order=>70
,p_column_identifier=>'AE'
,p_column_label=>'Last Dictionary Cache'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1049837224153487839)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5250709'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:CACHED_OBJECTS:SCHEMAS:LAST_DDL_TIME:LAST_CACHE_TIME:PROVISIONING_COMPANY_ID:'
,p_sort_column_1=>'WORKSPACE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'OBJECT_NAME'
,p_sort_direction_2=>'ASC'
,p_sum_columns_on_break=>'CACHED_OBJECTS:SCHEMAS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(525111272338577132)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(585156988233310532)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP,150,RIR::'
);
end;
/
prompt --application/pages/page_00151
begin
wwv_flow_imp_page.create_page(
 p_id=>151
,p_name=>'Backup Log Details'
,p_alias=>'BACKUP-LOG-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Backup Log Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784309333645873)
,p_step_template=>wwv_flow_imp.id(721098050798687927)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(318102195946685150)
,p_plug_name=>'Backup Log'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.batch_id, b.application_id, b.security_group_id, regexp_substr (b.duration, ''\d{2}:\d{2}:\d{2}\.\d{3}'') as duration, b.created_on',
'from wwv_flow_backup_log b',
'where b.application_id is not null',
'and b.batch_id = :P151_BATCH_ID;'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(318102304063685150)
,p_name=>'Automatic File Delete Log'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'JOEL'
,p_internal_uid=>318102304063685150
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(78201382123031006)
,p_db_column_name=>'BATCH_ID'
,p_display_order=>12
,p_column_identifier=>'J'
,p_column_label=>'Batch Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(78202100719031010)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>52
,p_column_identifier=>'N'
,p_column_label=>'Created On'
,p_column_type=>'DATE'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(78202992687031011)
,p_db_column_name=>'DURATION'
,p_display_order=>82
,p_column_identifier=>'Q'
,p_column_label=>'Duration'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8002552665535620)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>92
,p_column_identifier=>'R'
,p_column_label=>'Application Id'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8002664121535621)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>102
,p_column_identifier=>'S'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(318118111221685315)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'782033'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SECURITY_GROUP_ID:APPLICATION_ID:CREATED_ON:DURATION:'
,p_sort_column_1=>'DELETED_ON'
,p_sort_direction_1=>'DESC'
,p_break_on=>'SECURITY_GROUP_ID'
,p_break_enabled_on=>'SECURITY_GROUP_ID'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78203725704031019)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(318102195946685150)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:151:&SESSION.::&DEBUG.:RIR,124::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78205478605031033)
,p_branch_action=>'f?p=&FLOW_ID.:151:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8002447137535619)
,p_name=>'P151_BATCH_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(318102195946685150)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78204980627031031)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(78203725704031019)
,p_internal_uid=>78204980627031031
);
end;
/
prompt --application/pages/page_00152
begin
wwv_flow_imp_page.create_page(
 p_id=>152
,p_name=>'Faceted Workspace Search'
,p_alias=>'FACETED-WORKSPACE-SEARCH'
,p_step_title=>'Faceted Workspace Search'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(500583153011311249)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(470837694635277726)
,p_plug_name=>'Active Facets'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472532155894148648)
,p_plug_name=>'Facets'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(500561639362993025)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'current_facets_selector', '#active_facets',
  'show_charts', 'N',
  'show_current_facets', 'E',
  'show_total_row_count', 'N')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(500561639362993025)
,p_name=>'Workspaces'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select /*+ MATERIALIZE */ c.short_name  workspace, ',
'       c.PROVISIONING_COMPANY_ID,',
'       nvl((select sum(PAGE_EVENTS) from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID),0) page_views, ',
'       nvl((select sum(PAGE_EVENTS) from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID and log_day >= sysdate - 30),0) page_views_30d, ',
'       nvl((select sum(PAGE_EVENTS) from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID and log_day >= sysdate - 90),0) page_views_90d, ',
'       nvl((select count(*) from wwv_flows f where f.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID),0) applications,',
'       (select max(log_day) from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID) last_archived_view,',
'       decode(nvl((select 1 from dual where exists (',
'           select 1 from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID and log_day >= sysdate - 30)),',
'                  0),0,sm.t_no,sm.t_yes) views_30_yn,',
'       decode(nvl((select 1 from dual where exists (',
'           select 1 from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID and log_day >= sysdate - 90)),',
'                  0),0,sm.t_no,sm.t_yes) views_90_yn',
'      from wwv_flow_companies c ,',
'           (select wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'                   wwv_flow_lang.system_message(''F4000.NO'') t_no',
'              from sys.dual) sm',
'     where c.provisioning_company_id not in (11, 12)',
'    )',
'    select * from data'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>100000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472531603993148643)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(626566385737636306)
,p_query_column_id=>2
,p_column_alias=>'PROVISIONING_COMPANY_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Workspace ID'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472531751247148644)
,p_query_column_id=>3
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>5
,p_column_heading=>'Total Page Events'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(626566502195636308)
,p_query_column_id=>4
,p_column_alias=>'PAGE_VIEWS_30D'
,p_column_display_sequence=>3
,p_column_heading=>'Page Views 30d'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(626566142865636304)
,p_query_column_id=>5
,p_column_alias=>'PAGE_VIEWS_90D'
,p_column_display_sequence=>4
,p_column_heading=>'Page Events (90 Days)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472531917964148646)
,p_query_column_id=>6
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(626566489982636307)
,p_query_column_id=>7
,p_column_alias=>'LAST_ARCHIVED_VIEW'
,p_column_display_sequence=>6
,p_column_heading=>'Last Archived View'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(626566791364636310)
,p_query_column_id=>8
,p_column_alias=>'VIEWS_30_YN'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(626566887180636311)
,p_query_column_id=>9
,p_column_alias=>'VIEWS_90_YN'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(390433810159898114)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(470837694635277726)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:RR,152::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472532298348148649)
,p_name=>'P152_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(472532155894148648)
,p_prompt=>'Search'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_filter_values=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(626565882430636301)
,p_name=>'P152_PAGE_VIEWS'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(472532155894148648)
,p_prompt=>'Total Page Events'
,p_source=>'PAGE_VIEWS'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:0 - 9;|10,10 - 99;10|100,100 - 499;100|500,500 - 2k;500|2000,2k - 10k;2000|10000,10k - 100k;10000|100000,100k - 1m;100000|1000000,1m - 10m;1000000|10000000,> 10m;10000000|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>100
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(626565997188636302)
,p_name=>'P152_APPLICATIONS'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(472532155894148648)
,p_prompt=>'Applications'
,p_source=>'APPLICATIONS'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:0;|1,1;1|2,2 - 5;2|6,6 - 10;6|11,11 - 20;11|21,21 - 50;21|51,> 50;51|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>100
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(626566259962636305)
,p_name=>'P152_PAGE_VIEWS_90D'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(472532155894148648)
,p_prompt=>'Page Events 90 Days'
,p_source=>'PAGE_VIEWS_90D'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:0 - 9;|10,10 - 99;10|100,100 - 499;100|500,500 - 2k;500|2000,2k - 10k;2000|10000,10k - 100k;10000|100000,100k - 1m;100000|1000000,1m - 10m;1000000|10000000,> 10m;10000000|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>100
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(626566664921636309)
,p_name=>'P152_PAGE_VIEWS_30D'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(472532155894148648)
,p_prompt=>'Page Events 30 Days'
,p_source=>'PAGE_VIEWS_30D'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:0 - 9;|10,10 - 99;10|100,100 - 499;100|500,500 - 2k;500|2000,2k - 10k;2000|10000,10k - 100k;10000|100000,100k - 1m;100000|1000000,1m - 10m;1000000|10000000,> 10m;10000000|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>100
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(626567084198636313)
,p_name=>'P152_VIEWS_90_YN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(472532155894148648)
,p_prompt=>'Events last 90 days'
,p_source=>'VIEWS_90_YN'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(626567162994636314)
,p_name=>'P152_VIEWS_30_YN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(472532155894148648)
,p_prompt=>'Events last 30 days'
,p_source=>'VIEWS_30_YN'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
end;
/
prompt --application/pages/page_00153
begin
wwv_flow_imp_page.create_page(
 p_id=>153
,p_name=>'Activity Over Time Detail'
,p_alias=>'ACTIVITY-OVER-TIME-DETAIL'
,p_step_title=>'Activity Over Time Detail'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(831359903391183020)
,p_plug_name=>'Activity Over Time'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with x',
'as ',
'(',
'    select trunc(sysdate) - rownum log_day, 30 considered_active',
'    from wwv_flow_steps',
'    where rownum <= (365 * 5)',
'    order by 1 desc)',
'select * from ',
'(',
'select x.log_day, ',
'       (select count(distinct workspace_id)   ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_workspaces,',
'       (select sum(page_events)   ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) window_page_events,',
'       (select count(distinct application_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id not between 4000 and 5000 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_applications,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id not between 4000 and 5000 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) workspaces_with_active_apps,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id in (4000,4020) and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_appbuilder,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4500 and ',
'              DISTINCT_PAGES > 1 and',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_sqlworkshop,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id in (4020) and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_create_app,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4850 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_rest,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4300 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_data_workshop,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4600 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_team_dev,',
'       x.log_day - considered_active window_start,',
'       x.log_day window_end',
'from x',
') y',
'where active_workspaces > 0',
'order by 1 desc'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Activity Over Time'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(831945954734695416)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SHAKEEB'
,p_internal_uid=>831945954734695416
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946090471695417)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946146502695418)
,p_db_column_name=>'ACTIVE_WORKSPACES'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Active Workspaces'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946239289695419)
,p_db_column_name=>'WINDOW_PAGE_EVENTS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946305425695420)
,p_db_column_name=>'ACTIVE_APPLICATIONS'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Active Applications'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946467970695421)
,p_db_column_name=>'WORKSPACES_WITH_ACTIVE_APPS'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Workspaces with Active Apps'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946575983695422)
,p_db_column_name=>'ACTIVE_APPBUILDER'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'App  Builder'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946606755695423)
,p_db_column_name=>'ACTIVE_SQLWORKSHOP'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'SQL Workshop'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946726803695424)
,p_db_column_name=>'ACTIVE_CREATE_APP'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Create App Wizard'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946875472695425)
,p_db_column_name=>'ACTIVE_REST'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'REST Workshop'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831946949484695426)
,p_db_column_name=>'ACTIVE_DATA_WORKSHOP'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Data Workshop'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831947063923695427)
,p_db_column_name=>'ACTIVE_TEAM_DEV'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Team Development'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831947111922695428)
,p_db_column_name=>'WINDOW_START'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Start Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(831947203623695429)
,p_db_column_name=>'WINDOW_END'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'End Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(831990603502783353)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'8319907'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:ACTIVE_WORKSPACES:WINDOW_PAGE_EVENTS:ACTIVE_APPLICATIONS:WORKSPACES_WITH_ACTIVE_APPS:ACTIVE_APPBUILDER:ACTIVE_SQLWORKSHOP:ACTIVE_CREATE_APP:ACTIVE_REST:ACTIVE_DATA_WORKSHOP:ACTIVE_TEAM_DEV'
);
end;
/
prompt --application/pages/page_00155
begin
wwv_flow_imp_page.create_page(
 p_id=>155
,p_name=>'Application Activity'
,p_alias=>'APPLICATION-ACTIVITY'
,p_step_title=>'Application Activity'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1663598275521083786)
,p_plug_name=>'Application Activity'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       errors,',
'       "App Name",',
'       "App ID",',
'       most_recent_event,',
'       max_daily_active_pages,',
'      (select count(*) from wwv_flow_steps s where s.flow_id = "App ID" and s.security_group_id = x.workspace_id) page_count,',
'       workspace_id,',
'       nvl((select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id),t_not_available) workspace_name,',
'       RANK() OVER (ORDER BY "Page Events" desc) app_rank',
'from (',
'select sum(page_events) "Page Events",',
'    sum(ERROR_COUNT) errors,',
'    nvl((select max(name) from wwv_flows where id = application_id),t_not_available) "App Name",',
'    APPLICATION_ID "App ID", ',
'    workspace_id, ',
'    max(log_day) most_recent_event,',
'    t_not_available,',
'    max(DISTINCT_PAGES) max_daily_active_pages',
'from WWV_FLOW_LOG_HISTORY h,',
'     (select wwv_flow_lang.system_message(''NOT AVAILABLE'') t_not_available from dual) sm',
'where log_day > sysdate - (NVL(:P155_SINCE,7)+1)',
'  and application_id not between 4000 and 5000',
'group by application_id, workspace_id, t_not_available',
'order by 1 desc) x',
'',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P155_SINCE'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Activity Over Time'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1664184326864596182)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SHAKEEB'
,p_internal_uid=>1664184326864596182
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825644454061263240)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'V'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825643893722263234)
,p_db_column_name=>'App Name'
,p_display_order=>30
,p_column_identifier=>'P'
,p_column_label=>'App Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825643696428263232)
,p_db_column_name=>'Page Events'
,p_display_order=>40
,p_column_identifier=>'N'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825643773065263233)
,p_db_column_name=>'ERRORS'
,p_display_order=>50
,p_column_identifier=>'O'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825643971058263235)
,p_db_column_name=>'App ID'
,p_display_order=>60
,p_column_identifier=>'Q'
,p_column_label=>'App ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825644176799263237)
,p_db_column_name=>'MAX_DAILY_ACTIVE_PAGES'
,p_display_order=>80
,p_column_identifier=>'S'
,p_column_label=>'Max Daily Active Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825644281404263238)
,p_db_column_name=>'PAGE_COUNT'
,p_display_order=>90
,p_column_identifier=>'T'
,p_column_label=>'Page Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825644312126263239)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>100
,p_column_identifier=>'U'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825644506590263241)
,p_db_column_name=>'APP_RANK'
,p_display_order=>110
,p_column_identifier=>'W'
,p_column_label=>'Rank'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825644016062263236)
,p_db_column_name=>'MOST_RECENT_EVENT'
,p_display_order=>120
,p_column_identifier=>'R'
,p_column_label=>'Most Recent'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1664228975632684119)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'8322441'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APP_RANK:WORKSPACE_NAME:App Name:App ID:Page Events:ERRORS:MOST_RECENT_EVENT:'
,p_sort_column_1=>'APP_RANK'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5112343547996051513)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(832270736677949662)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5112343547996051513)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:155:&SESSION.::&DEBUG.:RR,155::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(832271128497949664)
,p_name=>'P155_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5112343547996051513)
,p_item_default=>'7'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(825644664644263242)
,p_name=>'refresh regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P155_SINCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(825644798450263243)
,p_event_id=>wwv_flow_imp.id(825644664644263242)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1663598275521083786)
);
end;
/
prompt --application/pages/page_00156
begin
wwv_flow_imp_page.create_page(
 p_id=>156
,p_name=>'Developer Activity Detail'
,p_alias=>'DEVELOPER-ACTIVITY-DETAIL'
,p_step_title=>'Developer Activity Detail'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2496103078767098096)
,p_plug_name=>'Developer Activity'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       app_builder_events,',
'       create_app_events,',
'       sql_workshop_events,',
'       team_development_events,',
'       workspace_admin_events,',
'       most_recent_event,',
'       rest_workshop_events,',
'       login_page_events,',
'       scheme_login_events,',
'       productivity_apps_events,',
'       data_workshop_events,',
'       app_migration_events,',
'       new_service_events,',
'       workspace_id,',
'       (select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id) workspace_name,',
'        RANK() OVER (ORDER BY "Page Events" desc) ws_rank',
'from (',
'select sum(page_events) "Page Events",',
'    sum(decode(application_id,4000,page_events,0)) app_builder_events,',
'    sum(decode(application_id,4020,page_events,0)) create_app_events,',
'    sum(decode(application_id,4500,page_events,0)) sql_workshop_events,',
'    sum(decode(application_id,4600,page_events,0)) team_development_events,',
'    sum(decode(application_id,4350,page_events,0)) workspace_admin_events,',
'    sum(decode(application_id,4850,page_events,0)) rest_workshop_events,',
'    sum(decode(application_id,4550,page_events,0)) login_page_events,',
'    sum(decode(application_id,4155,page_events,0)) scheme_login_events,',
'    sum(decode(application_id,4750,page_events,0)) productivity_apps_events,',
'    sum(decode(application_id,4300,page_events,0)) data_workshop_events,',
'    sum(decode(application_id,4400,page_events,0)) app_migration_events,',
'    sum(decode(application_id,4700,page_events,0)) new_service_events,',
'    workspace_id, max(log_day) most_recent_event',
'from WWV_FLOW_LOG_HISTORY ',
'where log_day > sysdate - (NVL(:P156_SINCE,7)+1)',
'  and application_id  between 4000 and 5000',
'group by workspace_id',
') x',
'',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P156_SINCE'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Activity Over Time'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2496689130110610492)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SHAKEEB'
,p_internal_uid=>2496689130110610492
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832510007230014316)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'V'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832506597343014313)
,p_db_column_name=>'Page Events'
,p_display_order=>40
,p_column_identifier=>'N'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832509614387014315)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>100
,p_column_identifier=>'U'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832508419778014314)
,p_db_column_name=>'MOST_RECENT_EVENT'
,p_display_order=>120
,p_column_identifier=>'R'
,p_column_label=>'Most Recent'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825644830421263244)
,p_db_column_name=>'APP_BUILDER_EVENTS'
,p_display_order=>130
,p_column_identifier=>'X'
,p_column_label=>'App Builder'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825644970303263245)
,p_db_column_name=>'CREATE_APP_EVENTS'
,p_display_order=>140
,p_column_identifier=>'Y'
,p_column_label=>'Create App'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825645069798263246)
,p_db_column_name=>'SQL_WORKSHOP_EVENTS'
,p_display_order=>150
,p_column_identifier=>'Z'
,p_column_label=>'SQL Workshop'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825645142547263247)
,p_db_column_name=>'TEAM_DEVELOPMENT_EVENTS'
,p_display_order=>160
,p_column_identifier=>'AA'
,p_column_label=>'Team Development'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825645229683263248)
,p_db_column_name=>'WORKSPACE_ADMIN_EVENTS'
,p_display_order=>170
,p_column_identifier=>'AB'
,p_column_label=>'Workspace Administration'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825645307459263249)
,p_db_column_name=>'REST_WORKSHOP_EVENTS'
,p_display_order=>180
,p_column_identifier=>'AC'
,p_column_label=>'REST Workshop'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(825645441008263250)
,p_db_column_name=>'LOGIN_PAGE_EVENTS'
,p_display_order=>190
,p_column_identifier=>'AD'
,p_column_label=>'Login Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832512186655014901)
,p_db_column_name=>'SCHEME_LOGIN_EVENTS'
,p_display_order=>200
,p_column_identifier=>'AE'
,p_column_label=>'Scheme Login'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832512228167014902)
,p_db_column_name=>'PRODUCTIVITY_APPS_EVENTS'
,p_display_order=>210
,p_column_identifier=>'AF'
,p_column_label=>'Productivity Apps'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832512364258014903)
,p_db_column_name=>'DATA_WORKSHOP_EVENTS'
,p_display_order=>220
,p_column_identifier=>'AG'
,p_column_label=>'Data Workshop'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832512407516014904)
,p_db_column_name=>'APP_MIGRATION_EVENTS'
,p_display_order=>230
,p_column_identifier=>'AH'
,p_column_label=>'App Migration'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832512531962014905)
,p_db_column_name=>'NEW_SERVICE_EVENTS'
,p_display_order=>240
,p_column_identifier=>'AI'
,p_column_label=>'New Service'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832512778150014907)
,p_db_column_name=>'WS_RANK'
,p_display_order=>260
,p_column_identifier=>'AK'
,p_column_label=>'Rank'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2496733778878698429)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'8325108'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WS_RANK:WORKSPACE_NAME:Page Events:APP_BUILDER_EVENTS:CREATE_APP_EVENTS:SQL_WORKSHOP_EVENTS:TEAM_DEVELOPMENT_EVENTS:WORKSPACE_ADMIN_EVENTS:REST_WORKSHOP_EVENTS:PRODUCTIVITY_APPS_EVENTS:DATA_WORKSHOP_EVENTS:MOST_RECENT_EVENT'
,p_sort_column_1=>'APP_RANK'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5944848351242065823)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(832505402655014311)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5944848351242065823)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:RR,156::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(832505807624014311)
,p_name=>'P156_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5944848351242065823)
,p_item_default=>'7'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(832511281525014317)
,p_name=>'refresh regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P156_SINCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(832511754901014318)
,p_event_id=>wwv_flow_imp.id(832511281525014317)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2496103078767098096)
);
end;
/
prompt --application/pages/page_00157
begin
wwv_flow_imp_page.create_page(
 p_id=>157
,p_name=>'Runtime Application Activity'
,p_alias=>'RUNTIME-APPLICATION-ACTIVITY'
,p_step_title=>'Runtime Application Activity'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3329112700151283490)
,p_plug_name=>'Runtime Application Activity'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       errors,',
'       workspace_id,',
'       (select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id) workspace_name,',
'       active_applications,',
'       (select count(*) from wwv_flows f where f.security_group_id = x.workspace_id) applications,',
'       RANK() OVER (ORDER BY "Page Events" desc) ws_rank',
'from (',
'select sum(page_events) "Page Events",',
'    sum(ERROR_COUNT) errors,',
'    max(DISTINCT_PAGES) active_pages,',
'    workspace_id, ',
'    max(log_day) most_recent_event,',
'    count(distinct APPLICATION_ID) active_applications',
'from WWV_FLOW_LOG_HISTORY ',
'where log_day > sysdate - (NVL(:P157_SINCE,7)+1)',
'  and application_id NOT between 4000 and 5000',
'group by workspace_id',
') x',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P157_SINCE'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Activity Over Time'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3329698751494795886)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SHAKEEB'
,p_internal_uid=>3329698751494795886
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(833015386511185403)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'V'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(833014104522185402)
,p_db_column_name=>'Page Events'
,p_display_order=>40
,p_column_identifier=>'N'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(833014952781185403)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>100
,p_column_identifier=>'U'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(833018152225185405)
,p_db_column_name=>'WS_RANK'
,p_display_order=>260
,p_column_identifier=>'AK'
,p_column_label=>'Rank'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832512879303014908)
,p_db_column_name=>'ERRORS'
,p_display_order=>270
,p_column_identifier=>'AL'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832512924066014909)
,p_db_column_name=>'ACTIVE_APPLICATIONS'
,p_display_order=>280
,p_column_identifier=>'AM'
,p_column_label=>'Active Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(832513065669014910)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>290
,p_column_identifier=>'AN'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3329743400262883823)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'8330185'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WS_RANK:WORKSPACE_NAME:Page Events::ERRORS:ACTIVE_APPLICATIONS:APPLICATIONS'
,p_sort_column_1=>'WS_RANK'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'APP_RANK'
,p_sort_direction_2=>'ASC'
,p_sum_columns_on_break=>'Page Events:ERRORS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6777857972626251217)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(833010248746185395)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(6777857972626251217)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:157:&SESSION.::&DEBUG.:RR,157::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(833010639330185397)
,p_name=>'P157_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6777857972626251217)
,p_item_default=>'7'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(833018956496185407)
,p_name=>'refresh regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P157_SINCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(833019424037185407)
,p_event_id=>wwv_flow_imp.id(833018956496185407)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3329112700151283490)
);
end;
/
prompt --application/pages/page_00158
begin
wwv_flow_imp_page.create_page(
 p_id=>158
,p_name=>'Available Updates (ADB)'
,p_alias=>'DEFER-UPGRADE'
,p_page_mode=>'MODAL'
,p_step_title=>'Available Updates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_inline_css=>'.a-Wizard-regionBody { padding: 12px 12px 0 12px }'
,p_step_template=>wwv_flow_imp.id(721098050798687927)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
,p_dialog_height=>'320'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1977121301299032781)
,p_plug_name=>'Defer Upgrade'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_defer_days      constant number        := to_number(:P158_DEFER_DAYS);',
'    c_free_instance   constant varchar2(4)   := ''FREE'';',
'    c_state_running   constant varchar2(9)   := ''RUNNING'';',
'    c_state_scheduled constant varchar2(9)   := ''SCHEDULED'';',
'    l_instance_type   varchar2(4);',
'    l_upgrade_status  wwv_flow_cloud_db_services.t_upgrade_status;',
'    l_result          wwv_flow_t_clob_writer := wwv_flow_t_clob_writer();',
'begin',
'    l_instance_type := case upper(substr(sys_context(''userenv'', ''instance_name''), 1, 1))',
'                            when ''F'' then c_free_instance',
'                            else ''PAID''',
'                       end;',
'    l_upgrade_status := wwv_flow_cloud_db_services.get_upgrade_status;',
'',
'    if l_upgrade_status.state = c_state_running then',
'        l_result.prn(wwv_flow_lang_dev.builder_message(',
'            ''F4050_P158_UPGRADING'',',
'            :PRODUCT_NAME,',
'            l_upgrade_status.upgrade_version,',
'            3));',
'',
'    elsif l_upgrade_status.state = c_state_scheduled then',
'        l_result.prn(wwv_flow_lang_dev.builder_message(',
'            ''F4050_P158_UPGRADE_NOW'',',
'            :PRODUCT_NAME,',
'            l_upgrade_status.upgrade_version,',
'            ''https://apex.oracle.com/adb-latest'',',
'            to_char(l_upgrade_status.upgrade_date, :LONG_DATE_FORMAT)));',
'',
'    else',
'        if l_instance_type = c_free_instance then',
'            -- Note, this should never happen',
'            l_result.prn(''<p>'' ||',
'                      wwv_flow_lang_dev.builder_message(''F4050_P158_INTRO_TEXT'', :PRODUCT_NAME, c_defer_days) ||',
'                      ''</p>'');',
'        else',
'            l_result.prn(wwv_flow_lang_dev.builder_message(''F4050_P158_PAID_ADB_INTRO_TEXT'', :PRODUCT_NAME));',
'        end if;',
'    end if;',
'    l_result.flush;',
'    return l_result.get_value;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_translate_title=>'N'
,p_plug_column_width=>'foo'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1977121358179032782)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(663451924482166110)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1977121358179032782)
,p_button_name=>'UPGRADE_NOW'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upgrade Now'
,p_button_position=>'CREATE'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(833874292607465348)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1977121358179032782)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if upper(substr(sys_context(''userenv'', ''instance_name''), 1, 1)) = ''F'' then',
'        -- Free databases have no ability to change the Upgrade Window',
'        return false;',
'    elsif wwv_flow_cloud_db_services.get_upgrade_status().state in (''SCHEDULED'', ''RUNNING'') then',
'        -- Don''t allow to change the Upgrade Window while the upgrade is scheduled or is',
'        -- in progress (this change will have no impact on the current upgade anyway)',
'        return false;',
'    end if;',
'',
'    return true;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(735033421901168729)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1977121358179032782)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Learn more about upgrades'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/adb-upgrade'');'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-info'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(663451758078166108)
,p_branch_name=>'refresh page 3'
,p_branch_action=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(222858335888540011)
,p_name=>'P158_DEFER_DAYS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1977121301299032781)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(833873008562465345)
,p_name=>'P158_UPGRADE_DEFERRED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1977121301299032781)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Upgrade Window'
,p_source=>'coalesce(wwv_flow_platform.get_preference(''UPGRADE_DEFERRED''), ''N'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang_dev.builder_message(''F4050_P158_UPGRADE_WINDOW_LOV'', wwv_flow_platform.get_preference(''UPGRADE_DEFER_DAYS'')) as dv,',
'       ''N'' as rv',
'  from sys.dual',
' union all',
'select wwv_flow_lang_dev.builder_message(''F4050_P158_UPGRADE_WINDOW_LOV'', wwv_flow_platform.get_preference(''UPGRADE_DEFER_DAYS_MAX'')) as dv,',
'       ''Y'' as rv ',
'  from sys.dual'))
,p_tag_css_classes=>'apex-button-group'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if upper(substr(sys_context(''userenv'', ''instance_name''), 1, 1)) = ''F'' then',
'        -- Free databases have no ability to change the Upgrade Window',
'        return false;',
'    elsif wwv_flow_cloud_db_services.get_upgrade_status().state in (''SCHEDULED'', ''RUNNING'') then',
'        -- Don''t allow to change the Upgrade Window while the upgrade is scheduled or is',
'        -- in progress (this change will have no impact on the current upgade anyway)',
'        return false;',
'    end if;',
'',
'    return true;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>This attribute determines the upgrade window for all future &PRODUCT_NAME. upgrades for this instance.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(222858456450540012)
,p_computation_sequence=>10
,p_computation_item=>'P158_DEFER_DAYS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce(wwv_flow_platform.get_preference(''UPGRADE_DEFER_DAYS''),30)'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(833875019791465351)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set UPGRADE_DEFERRED'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference( p_preference_name  => ''UPGRADE_DEFERRED'',',
'                                  p_preference_value => :P158_UPGRADE_DEFERRED );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(833874292607465348)
,p_process_success_message=>'&PRODUCT_NAME. upgrade preference updated.'
,p_internal_uid=>833875019791465351
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(663452058759166111)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Upgrade Now'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sql varchar2(255);',
'begin',
'    if wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'' then',
'        l_sql := '' begin sys.wwv_util_''||wwv_flow.g_flow_schema_owner||''.adb_upgrade_now; end;'';',
'        execute immediate l_sql;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(663451924482166110)
,p_process_success_message=>'&PRODUCT_NAME. upgrade has started.'
,p_internal_uid=>663452058759166111
);
end;
/
prompt --application/pages/page_00161
begin
wwv_flow_imp_page.create_page(
 p_id=>161
,p_name=>'REST Synchronization Log'
,p_alias=>'REST-SYNCHRONIZATION-LOG'
,p_step_title=>'REST Synchronization Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784309333645873)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*.break-url {',
'    word-break: break-all;',
'}*/'))
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(671821573063112246)
,p_plug_name=>'Synchronization Log'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'The REST Synchronization Log contains detailed information about  REST synchronizations executed by this &PRODUCT_NAME. instance: Application ID, REST Data Source name, rows processed, HTTP requests made and the start and end timestamps.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(671821984450112249)
,p_plug_name=>'REST Synchronization Log'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(813763380651628325)
,p_plug_name=>'REST Synchronization Log'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.flow_id,',
'       m.name,',
'       l.web_src_sync_static_id,',
'       wwv_flow_lang.system_message( ''APEX.WEBSRC.SYNC.STATUS_'' || l.status ) as status,',
'       l.start_timestamp,',
'       extract( SECOND from l.end_timestamp - l.start_timestamp ) +',
'       extract( MINUTE from l.end_timestamp - l.start_timestamp ) * 60 +',
'       extract( HOUR   from l.end_timestamp - l.start_timestamp ) * 3600 as seconds_elapsed,',
'       l.processed_row_count,',
'       ( select count(*) from wwv_flow_webservice_log wl where wl.web_src_sync_id = l.synchronization_id ) as http_requests,',
'       ( select sum(resp_content_length)  from wwv_flow_webservice_log wl where wl.web_src_sync_id = l.synchronization_id ) as bytes,',
'       l.sync_to_table_owner,',
'       l.sync_to_table_name,',
'       c.short_name',
'from  wwv_flow_websource_sync_log l, wwv_flow_web_src_modules m, wwv_flow_companies c',
'where c.provisioning_company_id = l.security_group_id',
'  and l.web_src_module_id    = m.id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(813763490773628325)
,p_name=>'Mail Log'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>813763490773628325
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1366953305648938)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>80
,p_column_identifier=>'U'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5904329369682543)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>90
,p_column_identifier=>'AA'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5904421254682544)
,p_db_column_name=>'NAME'
,p_display_order=>100
,p_column_identifier=>'AB'
,p_column_label=>'REST Source Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5904515056682545)
,p_db_column_name=>'WEB_SRC_SYNC_STATIC_ID'
,p_display_order=>110
,p_column_identifier=>'AC'
,p_column_label=>'Sync Step'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5904661125682546)
,p_db_column_name=>'STATUS'
,p_display_order=>120
,p_column_identifier=>'AD'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5904759209682547)
,p_db_column_name=>'START_TIMESTAMP'
,p_display_order=>130
,p_column_identifier=>'AE'
,p_column_label=>'Started '
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'CENTER'
,p_format_mask=>'YYYY/MM/DD HH24:MI:SS TZR'
,p_tz_dependent=>'Y'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5904922739682549)
,p_db_column_name=>'PROCESSED_ROW_COUNT'
,p_display_order=>150
,p_column_identifier=>'AG'
,p_column_label=>'Rows Processed'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5905085620682550)
,p_db_column_name=>'SYNC_TO_TABLE_OWNER'
,p_display_order=>160
,p_column_identifier=>'AH'
,p_column_label=>'Table Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1371184912674201)
,p_db_column_name=>'SYNC_TO_TABLE_NAME'
,p_display_order=>170
,p_column_identifier=>'AI'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1371263048674202)
,p_db_column_name=>'HTTP_REQUESTS'
,p_display_order=>180
,p_column_identifier=>'AJ'
,p_column_label=>'HTTP Requests'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1371383782674203)
,p_db_column_name=>'BYTES'
,p_display_order=>190
,p_column_identifier=>'AK'
,p_column_label=>'Bytes'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1371453152674204)
,p_db_column_name=>'SECONDS_ELAPSED'
,p_display_order=>200
,p_column_identifier=>'AL'
,p_column_label=>'Seconds Elapsed'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999990D0'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(813764694844629264)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'13693'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:FLOW_ID:NAME:WEB_SRC_SYNC_STATIC_ID:STATUS:START_TIMESTAMP:PROCESSED_ROW_COUNT:SYNC_TO_TABLE_OWNER:SYNC_TO_TABLE_NAME:HTTP_REQUESTS:BYTES:SECONDS_ELAPSED:'
,p_sort_column_1=>'REQUEST_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'LAST_UPDATED_ON'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'SINCE_DATE'
,p_sort_direction_3=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1364690535648928)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(671821984450112249)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.:RIR,121::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1365077527648929)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(671821984450112249)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Truncate'
,p_button_position=>'CREATE'
,p_confirm_message=>'Do you really want to truncate the REST Synchronization Log?'
,p_confirm_style=>'danger'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1370600991648952)
,p_branch_action=>'f?p=&FLOW_ID.:161:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1369755842648950)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_websource_sync_log1$;',
'delete from wwv_flow_websource_sync_log2$;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating REST Synchronization Log.'
,p_process_when_button_id=>wwv_flow_imp.id(1365077527648929)
,p_process_success_message=>'Successfully truncated REST Synchronization Log.'
,p_internal_uid=>1369755842648950
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1370173185648951)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(1364690535648928)
,p_internal_uid=>1370173185648951
);
end;
/
prompt --application/pages/page_00162
begin
wwv_flow_imp_page.create_page(
 p_id=>162
,p_name=>'Manage REST Synchronization Log'
,p_alias=>'MANAGE-REST-SYNC-LOG'
,p_step_title=>'Manage REST Synchronization Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(687175365399927299)
,p_plug_name=>'Delete REST Synchronization Log Entries'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_dev number := 0;    ',
'begin',
'    select count(*)',
'      into c_dev',
'      from wwv_flow_websource_sync_log;',
'    ',
'    return ''<p>''',
'           || wwv_flow_lang_dev.builder_message(''4050_162_WEB_SOURCE_SYNC_LOG'') || '': ''',
'           || to_char(c_dev,''999,999,999,990'')',
'           || ''</p>'';    ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1703199076929547133)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1704670310125322822)
,p_plug_name=>'REST Synchronization Log'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This &PRODUCT_NAME. instance can be configured to log REST synchronizations.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1411162732951093)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1703199076929547133)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Entries'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1411581743951094)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1703199076929547133)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1412751734951112)
,p_branch_name=>'Go To Page 162'
,p_branch_action=>'162'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(1411162732951093)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1410051469951086)
,p_name=>'P162_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(687175365399927299)
,p_prompt=>'Delete entries this number of days and older:'
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_imp.id(87720511660244788)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Purge entries older than this number of days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1412265643951111)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_websource_sync_log1$',
'where start_timestamp < (localtimestamp - numtodsinterval(nvl(:p162_time,31), ''DAY''));',
'delete from wwv_flow_websource_sync_log2$',
'where start_timestamp < (localtimestamp - numtodsinterval(nvl(:p162_time,31), ''DAY''));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error purging Web Service Activity Log.'
,p_process_when_button_id=>wwv_flow_imp.id(1411162732951093)
,p_process_success_message=>'Web Service Activity Log purged.'
,p_internal_uid=>1412265643951111
);
end;
/
prompt --application/pages/page_00163
begin
wwv_flow_imp_page.create_page(
 p_id=>163
,p_name=>'Import Workspace'
,p_alias=>'IMPORT-WORKSPACE'
,p_step_title=>'Import Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44752928830688498)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44755004167775947)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(202654431224384775)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(79863815294295743)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44756515866873949)
,p_plug_name=>'Invalid export file'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_source=>'<p>The export file has been imported into the repository, but it is not a valid workspace export.</p>'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.is_company_export(:P163_FILE_ID) = false'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44757316437940400)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(44758222502979988)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(165852216817050925)
,p_plug_name=>'File Imported'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.is_company_export(:P163_FILE_ID) = true'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The export file has been imported successfully.</p>',
'<p>If you wish to install this workspace now, click <strong>Install</strong>.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113024376695873)
,p_plug_name=>'Import Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(79848401947178315)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44752928830688498)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(53559826117651901)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44752928830688498)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(53562040315656070)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44752928830688498)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install'
,p_button_position=>'NEXT'
,p_button_condition=>'wwv_flow_imp_parser.is_company_export(:P163_FILE_ID)'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(53787635215429074)
,p_branch_action=>'f?p=&FLOW_ID.:277:&SESSION.::&DEBUG.:277,165:P277_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(53562040315656070)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53575939070740849)
,p_name=>'P163_FILE_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(93372831129235626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(53792036385438823)
,p_validation_name=>'only internal can import company'
,p_validation_sequence=>10
,p_validation=>':flow_security_group_id = 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Only internal workspace can install workspace information.'
,p_validation_condition=>'P460_FILE_TYPE'
,p_validation_condition2=>'COMPANY_EXPORT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(53562040315656070)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00165
begin
wwv_flow_imp_page.create_page(
 p_id=>165
,p_name=>'Install Workspace'
,p_alias=>'INSTALL-WORKSPACE'
,p_step_title=>'Install Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44774026779615134)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(44806708563745373)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44774229895616022)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47834934594717909)
,p_plug_name=>'Install Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47835339096719184)
,p_plug_name=>'Install Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'A workspace will be created if it does not exist, and all users will be imported.  '
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113142732695873)
,p_plug_name=>'Install Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47838938188728411)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44774229895616022)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P165_WS_EXISTS'
,p_button_condition2=>'N'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47836225721724856)
,p_button_sequence=>15
,p_button_plug_id=>wwv_flow_imp.id(44774229895616022)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47840213385730684)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44774229895616022)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install Workspace'
,p_button_position=>'CREATE'
,p_button_condition=>'P165_WS_EXISTS'
,p_button_condition2=>'N'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47840534124730685)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(47840213385730684)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45255124812664433)
,p_name=>'P165_WS_EXISTS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(47834934594717909)
,p_item_default=>'N'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47842236587737441)
,p_name=>'P165_LOGGED_IN_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47834934594717909)
,p_item_default=>'&COMPANY.'
,p_prompt=>'Logged in As:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'You are logged in as this workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47844625075752996)
,p_name=>'P165_IMP_COMPANY_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47834934594717909)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Install File Workspace ID:'
,p_source=>'P277_IMP_COMPANY_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'This is the workspace ID obtained from the workspace export file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48276826242931230)
,p_name=>'P165_IMP_COMPANY'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(47834934594717909)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Install File Workspace Name:'
,p_source=>'wwv_flow_imp_parser.get_workspace_name(p_file_id => :P277_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'This is the workspace name obtained from the workspace export file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48413732634219929)
,p_name=>'P165_COMPANY_EXISTS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(47834934594717909)
,p_prompt=>'Workspace Exists:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicates if a workspace having the same name as that obtained from the workspace export file currently exists.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48414716835224801)
,p_name=>'P165_COMPANY_ACTION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(47834934594717909)
,p_prompt=>'Request:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicates whether the workspace will be installed or not.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48421828918275617)
,p_name=>'P165_IMP_COMPANY_SCHEMA'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(47834934594717909)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Install File Workspace Schema:'
,p_source=>'wwv_flow_imp_parser.get_schema_provisioned (p_file_id => :P277_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the file which contains the workspace install script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189039725972495323)
,p_name=>'P165_PRIMARY_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(47834934594717909)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Primary Schema:'
,p_source=>'P277_SCHEMA'
,p_source_type=>'ITEM'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provisioning.validate_schema_name(p_schema => :P277_SCHEMA,',
'  p_workspace_name => wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID))'))
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'This will be the primary schema for the installed workspace. The schema will be created if that was requested. This schema is sometimes referred to as the first schema provisioned for the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(53852128186644629)
,p_validation_name=>'only internal can import company'
,p_validation_sequence=>10
,p_validation=>':flow_security_group_id = 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Only internal workspace can install workspace information.'
,p_when_button_pressed=>wwv_flow_imp.id(47840213385730684)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48219913570295031)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create company schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_p varchar2(256) := v(''P277_SCHEMA_PASSWORD'');',
'begin',
'  wwv_flow.update_cache_with_write(''P277_SCHEMA_PASSWORD'',null);',
'  wwv_flow_provision.provision_company(',
'      p_company         => :P277_SCHEMA,',
'      p_sgid            => :P277_IMP_COMPANY_ID,',
'      p_password        => l_p,',
'      p_quota           => :P277_QUOTA );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating workspace schema.'
,p_process_when_button_id=>wwv_flow_imp.id(47840213385730684)
,p_process_when=>':P277_EXISTING = ''0'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Workspace schema created.'
,p_internal_uid=>48219913570295031
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(47863923943046073)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'import company'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.parse (',
'     p_file_id         => :P277_FILE_ID,',
'     p_parse_as_schema => wwv_flow.g_flow_schema_owner',
'     );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error installing workspace.'
,p_process_when_button_id=>wwv_flow_imp.id(47840213385730684)
,p_process_success_message=>'Workspace installed.'
,p_internal_uid=>47863923943046073
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48233814197465485)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update provisioned schemas'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_found boolean := false;',
'    l_first_schema wwv_flow_companies.first_schema_provisioned%type := upper(:P277_SCHEMA);',
'begin',
'    if wwv_flow_provisioning.site_admin_is_restricted and ',
'      wwv_flow_provisioning.restricted_schema(p_schema => l_first_schema,',
'          p_workspace_name => wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID)) then',
'      l_first_schema := ''INVALID'';',
'    end if;',
'    update wwv_flow_companies',
'      set FIRST_SCHEMA_PROVISIONED = l_first_schema',
'      where PROVISIONING_COMPANY_ID = :P277_IMP_COMPANY_ID;',
'    for c1 in ',
'      (select schema from wwv_flow_company_schemas where security_group_id = :P277_IMP_COMPANY_ID ',
'       and schema = upper(:P277_SCHEMA)) loop',
'       l_found := true;',
'    end loop;',
'    if not l_found then',
'      insert into wwv_flow_company_schemas (security_group_id,schema)  ',
'        values(:P277_IMP_COMPANY_ID,:P277_SCHEMA);',
'    end if;',
'    if wwv_flow_provisioning.site_admin_is_restricted then',
'        for c1 in ',
'          (select id from wwv_flow_company_schemas ',
'              where security_group_id = :P277_IMP_COMPANY_ID and',
'              wwv_flow_provisioning.restricted_schema_i(schema,',
'                wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID)) = 1) loop',
'           delete wwv_flow_company_schemas where id = c1.id;           ',
'        end loop;',
'    end if;    ',
'    for c1 in ',
'      (select id from wwv_flow_company_schemas ',
'          where security_group_id = :P277_IMP_COMPANY_ID and',
'          not exists (select 1 from sys.dba_users where username = schema)) loop',
'       delete wwv_flow_company_schemas where id = c1.id;           ',
'    end loop;        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting provisioned schemas.'
,p_process_when_button_id=>wwv_flow_imp.id(47840213385730684)
,p_internal_uid=>48233814197465485
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(359772209428648663)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P277_SCHEMA_PASSWORD'
,p_process_when_button_id=>wwv_flow_imp.id(47840213385730684)
,p_internal_uid=>359772209428648663
);
end;
/
prompt --application/pages/page_00173
begin
wwv_flow_imp_page.create_page(
 p_id=>173
,p_name=>'Imported Workspace Export Files'
,p_alias=>'IMPORTED-WORKSPACE-EXPORT-FILES'
,p_step_title=>'Imported Workspace Export Files'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'function p173_Delete(){',
'if (apex.jQuery("input:checked").length == 0) {',
'  apex.submit(''Delete'');',
'} else {',
'  apex.confirm(htmldb_delete_message,''Delete'');',
'}',
'}'))
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49518022356125296)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>5
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(78240022072921217)
,p_name=>'Imported Workspace Export Files'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' q varchar2(32767) := null;',
' l_workspace_export varchar2(400);',
' l_install         varchar2(200);',
'',
'begin',
'',
'select wwv_flow_lang.system_message(''F4050.WORKSPACE_EXPORT'')',
'  into l_workspace_export',
'  from dual;',
'',
'select wwv_flow_lang.system_message(''F4050.INSTALL'')',
'  into l_install',
'  from dual;',
'',
'  l_workspace_export := replace(l_workspace_export,chr(39),chr(39)||chr(39));',
'',
'  q:=''select '';  ',
'  q:=q||''''''<INPUT TYPE="checkbox" NAME="f01" VALUE="''''||id||''''">'''' cb, '';',
'  q:=q||''title, '';',
'  q:=q||''mime_type, '';',
'  q:=q||''doc_size, '';',
'  q:=q||''created_by, '';',
'  q:=q||''created_on co, '';',
'  q:=q||''decode(file_type,''''COMPANY_EXPORT'''',''''''||l_workspace_export||'''''') filetype, '';',
'  q:=q||''id, '';',
'  q:=q||''htf.anchor(''''f?p=&FLOW_ID.:277:&SESSION.:::277,165:P277_FILE_ID:''''||',
'    id,''''''||l_install||'''''') action, '';',
'  q:=q||''created_on + delete_after_days to_be_deleted '';',
'  q:=q||''from WWV_FLOW_FILE_OBJECTS$, (select wwv_flow_platform.get_preference(''''DELETE_UPLOADED_FILES_AFTER_DAYS'''') delete_after_days from dual) x  '';',
'  q:=q||''where /*security_group_id = :flow_security_group_id and*/  '';',
'  q:=q||''   deleted_as_of = to_date(''''01.01.0001'''',''''MM.DD.YYYY'''') and '';',
'  q:=q||''  file_type = ''''COMPANY_EXPORT'''''';',
'  return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(833359513519625692)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No exports found.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'arrow_down_gray_light.gif'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image=>'arrow_up_gray_light.gif'
,p_query_desc_image_attr=>' width="13" height="12" '
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 31-JUL-2001 13:40:41'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739309529422421)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739518518422421)
,p_query_column_id=>2
,p_column_alias=>'TITLE'
,p_column_display_sequence=>2
,p_column_heading=>'Export Title'
,p_use_as_row_header=>'N'
,p_column_link=>'p?n=#ID#'
,p_column_linktext=>'#TITLE#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739636254422421)
,p_query_column_id=>3
,p_column_alias=>'MIME_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'MIME Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739736741422421)
,p_query_column_id=>4
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>4
,p_column_heading=>'Size'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739836227422422)
,p_query_column_id=>5
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>5
,p_column_heading=>'Created By'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739914100422422)
,p_query_column_id=>6
,p_column_alias=>'CO'
,p_column_display_sequence=>6
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_column_css_style=>'white-space: nowrap;'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(79831208892981636)
,p_query_column_id=>7
,p_column_alias=>'FILETYPE'
,p_column_display_sequence=>9
,p_column_heading=>'File Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48740121990422422)
,p_query_column_id=>8
,p_column_alias=>'ID'
,p_column_display_sequence=>7
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(53489613183364312)
,p_query_column_id=>9
,p_column_alias=>'ACTION'
,p_column_display_sequence=>8
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(175468831839456833)
,p_query_column_id=>10
,p_column_alias=>'TO_BE_DELETED'
,p_column_display_sequence=>10
,p_column_heading=>'To Be Deleted'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(78242129508922453)
,p_plug_name=>'Workspace Export Files'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>To download a Workspace Export File to your computer, click the export title.  To install the file, click the <strong>Install</strong> action link.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78283825369247714)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(49518022356125296)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:p173_Delete();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47003309260720447)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(49518022356125296)
,p_button_name=>'IMPORT_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Import File'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78241025735921225)
,p_branch_action=>'173'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(78294233672258872)
,p_validation_name=>'File Selection Not Null'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Files to delete must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(78283825369247714)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2613209217735336)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Set Item P277_SCHEMA_PASSWORD to null'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P277_SCHEMA_PASSWORD'
,p_internal_uid=>2613209217735336
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49561131144137374)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>49561131144137374
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78289512334253555)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'forall i in 1..wwv_flow.g_f01.count',
'    delete from wwv_flow_file_objects$',
'     where id = wwv_flow.g_f01(i)',
'     and file_type in (''COMPANY_EXPORT'');',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting file(s).'
,p_process_when_button_id=>wwv_flow_imp.id(78283825369247714)
,p_process_success_message=>'File(s) deleted.'
,p_internal_uid=>78289512334253555
);
end;
/
prompt --application/pages/page_00181
begin
wwv_flow_imp_page.create_page(
 p_id=>181
,p_name=>'Automation Log'
,p_alias=>'AUTOMATION-LOG'
,p_step_title=>'Automation Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784309333645873)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*.break-url {',
'    word-break: break-all;',
'}*/'))
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(673230794801484126)
,p_plug_name=>'Automation Log'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'The Automation Log contains detailed information about automations executed by this &PRODUCT_NAME. instance: Application ID, Automation name, rows processed successfully and rows processed with errors.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(673231206188484129)
,p_plug_name=>'Automation Log'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(815172602390000205)
,p_plug_name=>'Automation Log'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.flow_id,',
'       a.name,',
'       l.status,',
'       l.start_timestamp,',
'       extract( SECOND from l.end_timestamp - l.start_timestamp ) +',
'       extract( MINUTE from l.end_timestamp - l.start_timestamp ) * 60 +',
'       extract( HOUR   from l.end_timestamp - l.start_timestamp ) * 3600 as seconds_elapsed,',
'       l.successful_row_count,',
'       l.error_row_count,',
'       c.short_name',
'from  wwv_flow_automation_log l, wwv_flow_automations a, wwv_flow_companies c',
'where c.provisioning_company_id = l.security_group_id',
'  and l.automation_id           = a.id (+)',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(815172712512000205)
,p_name=>'Mail Log'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>815172712512000205
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1411212363371995)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>80
,p_column_identifier=>'U'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1413129271372044)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>90
,p_column_identifier=>'AA'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1413570251372044)
,p_db_column_name=>'NAME'
,p_display_order=>100
,p_column_identifier=>'AB'
,p_column_label=>'Automation Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1414326870372045)
,p_db_column_name=>'STATUS'
,p_display_order=>120
,p_column_identifier=>'AD'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1581480830428587)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1414710595372045)
,p_db_column_name=>'START_TIMESTAMP'
,p_display_order=>130
,p_column_identifier=>'AE'
,p_column_label=>'Started '
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'YYYY/MM/DD HH24:MI:SS TZR'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1412719348372044)
,p_db_column_name=>'SECONDS_ELAPSED'
,p_display_order=>200
,p_column_identifier=>'AL'
,p_column_label=>'Seconds Elapsed'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999990D0'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1403077046294847)
,p_db_column_name=>'SUCCESSFUL_ROW_COUNT'
,p_display_order=>210
,p_column_identifier=>'AM'
,p_column_label=>'Successful Rows'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1403113152294848)
,p_db_column_name=>'ERROR_ROW_COUNT'
,p_display_order=>220
,p_column_identifier=>'AN'
,p_column_label=>'Error Rows'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(815173916583001144)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'14159'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:FLOW_ID:NAME:STATUS:START_TIMESTAMP:SECONDS_ELAPSED::SUCCESSFUL_ROW_COUNT:ERROR_ROW_COUNT'
,p_sort_column_1=>'REQUEST_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'LAST_UPDATED_ON'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'SINCE_DATE'
,p_sort_direction_3=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1410153513371976)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(673231206188484129)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.:RIR,121::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1410584309371986)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(673231206188484129)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Truncate'
,p_button_position=>'CREATE'
,p_confirm_message=>'Do you really want to truncate the Automation Log?'
,p_confirm_style=>'danger'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1417271818372086)
,p_branch_action=>'f?p=&FLOW_ID.:181:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1416397216372082)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_automation_msg_log1$;',
'delete from wwv_flow_automation_log1$;',
'delete from wwv_flow_automation_msg_log2$;',
'delete from wwv_flow_automation_log2$;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error truncating Automation Log.'
,p_process_when_button_id=>wwv_flow_imp.id(1410584309371986)
,p_process_success_message=>'Successfully truncated Automation Log.'
,p_internal_uid=>1416397216372082
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1416799164372085)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(1410153513371976)
,p_internal_uid=>1416799164372085
);
end;
/
prompt --application/pages/page_00182
begin
wwv_flow_imp_page.create_page(
 p_id=>182
,p_name=>'Manage Automation Log'
,p_alias=>'MANAGE-AUTOMATION-LOG'
,p_step_title=>'Manage Automation Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216783731365642767)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
,p_help_text=>'AEADM/adm_logs.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(688760584507364699)
,p_plug_name=>'Delete Automation Log Entries'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_dev number := 0;    ',
'begin',
'    select count(*)',
'      into c_dev',
'      from wwv_flow_automation_log;',
'    ',
'    return ''<p>''',
'           || wwv_flow_lang_dev.builder_message(''4050_182_AUTOMATION_LOG'') || '': ''',
'           || to_char(c_dev,''999,999,999,990'')',
'           || ''</p>'';    ',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1704784296036984533)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1706255529232760222)
,p_plug_name=>'Automation Log'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This &PRODUCT_NAME. instance can be configured to log automations executions.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1587017782437430)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1704784296036984533)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Entries'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1587421169437431)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1704784296036984533)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1588636771437446)
,p_branch_name=>'Go To Page 182'
,p_branch_action=>'182'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(1587017782437430)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1585811381437422)
,p_name=>'P182_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(688760584507364699)
,p_prompt=>'Delete entries this number of days and older:'
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_imp.id(87720511660244788)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Purge entries older than this number of days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1588165486437445)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_automation_msg_log1$',
'where message_timestamp < (localtimestamp - numtodsinterval(nvl(:p182_time,31), ''DAY''));',
'delete from wwv_flow_automation_msg_log2$',
'where message_timestamp < (localtimestamp - numtodsinterval(nvl(:p182_time,31), ''DAY''));',
'',
'delete from wwv_flow_automation_log1$',
'where start_timestamp < (localtimestamp - numtodsinterval(nvl(:p182_time,31), ''DAY''));',
'delete from wwv_flow_automation_log2$',
'where start_timestamp < (localtimestamp - numtodsinterval(nvl(:p182_time,31), ''DAY''));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error purging Automation Log.'
,p_process_when_button_id=>wwv_flow_imp.id(1587017782437430)
,p_process_success_message=>'Automation Log purged.'
,p_internal_uid=>1588165486437445
);
end;
/
prompt --application/pages/page_00191
begin
wwv_flow_imp_page.create_page(
 p_id=>191
,p_name=>'Background Executions'
,p_alias=>'BACKGROUND-EXECUTIONS'
,p_step_title=>'Background Executions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216784004831644541)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1869655291911731)
,p_plug_name=>'All Background Executions'
,p_region_name=>'all_background_executions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select e.id,',
'       c.display_name,',
'       e.flow_id as bg_app_id,',
'       e.page_id,',
'       p.process_name      bg_process_name,',
'       cp.process_name     child_process_name,',
'       e.started_from_session_id,',
'       e.cloned_work_session_id,    ',
'       e.request,',
'       s.username,',
'       e.status,',
'       e.sofar,',
'       e.totalwork,',
'       case when e.status in ( ''SCHEDULED'', ''EXECUTING'', ''ENQUEUED'' ) then e.id end as terminate_button,',
'       e.created_on,',
'       e.last_updated_on,',
'       e.security_group_id  ',
'  from wwv_flow_step_processing p,',
'       wwv_flow_step_processing cp,',
'       wwv_flow_process_bg_execs$ e,',
'       wwv_flow_sessions$         s,',
'       wwv_flow_companies         c',
' where p.security_group_id       = e.security_group_id',
'   and p.flow_id                 = e.flow_id',
'   and p.id                      = e.process_id',
'    --',
'   and cp.security_group_id (+)     = e.security_group_id',
'   and cp.flow_id           (+)     = e.flow_id',
'   and cp.id                (+)     = e.current_exec_process_id',
'    --',
'   and s.security_group_id (+)     = e.security_group_id',
'   and s.id                (+)     = e.started_from_session_id',
'    --',
'   and e.security_group_id         = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'All Background Executions'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1869880402911733)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CCZARSKI'
,p_internal_uid=>1869880402911733
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1870086749911735)
,p_db_column_name=>'ID'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Execution ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2013180639377402)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>40
,p_column_identifier=>'S'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2014765115377418)
,p_db_column_name=>'BG_APP_ID'
,p_display_order=>50
,p_column_identifier=>'U'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:192:&SESSION.::&DEBUG.::P192_FLOW_ID,P192_SECURITY_GROUP_ID:#BG_APP_ID#,#SECURITY_GROUP_ID#'
,p_column_linktext=>'#BG_APP_ID#'
,p_column_link_attr=>'title="Show all Executions for Application #BG_APP_ID#"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1870234516911737)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>60
,p_column_identifier=>'D'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1870346769911738)
,p_db_column_name=>'BG_PROCESS_NAME'
,p_display_order=>70
,p_column_identifier=>'E'
,p_column_label=>'Background Process'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1870467092911739)
,p_db_column_name=>'CHILD_PROCESS_NAME'
,p_display_order=>80
,p_column_identifier=>'F'
,p_column_label=>'Currently Executing'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1871300402911748)
,p_db_column_name=>'STARTED_FROM_SESSION_ID'
,p_display_order=>90
,p_column_identifier=>'O'
,p_column_label=>'Session ID'
,p_column_link=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.:RP,:P67_SESSION_ID:#STARTED_FROM_SESSION_ID#'
,p_column_linktext=>'#STARTED_FROM_SESSION_ID#'
,p_column_link_attr=>'title="Show Details for session #STARTED_FROM_SESSION_ID#"'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1870549553911740)
,p_db_column_name=>'CLONED_WORK_SESSION_ID'
,p_display_order=>100
,p_column_identifier=>'G'
,p_column_label=>'Work Session ID'
,p_column_link=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.::P67_SESSION_ID:#CLONED_WORK_SESSION_ID#'
,p_column_linktext=>'#CLONED_WORK_SESSION_ID#'
,p_column_link_attr=>'title="Show Details for session #CLONED_WORK_SESSION_ID#"'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1871432280911749)
,p_db_column_name=>'USERNAME'
,p_display_order=>110
,p_column_identifier=>'P'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1870691233911741)
,p_db_column_name=>'STATUS'
,p_display_order=>120
,p_column_identifier=>'H'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(2050649672720692)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1871195846911746)
,p_db_column_name=>'REQUEST'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Request'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1870721896911742)
,p_db_column_name=>'SOFAR'
,p_display_order=>140
,p_column_identifier=>'I'
,p_column_label=>'So far'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1870892126911743)
,p_db_column_name=>'TOTALWORK'
,p_display_order=>150
,p_column_identifier=>'J'
,p_column_label=>'Total work'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1870973843911744)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>160
,p_column_identifier=>'K'
,p_column_label=>'Started'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1871069333911745)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>170
,p_column_identifier=>'L'
,p_column_label=>'Last Change'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1869974986911734)
,p_db_column_name=>'TERMINATE_BUTTON'
,p_display_order=>180
,p_column_identifier=>'A'
,p_column_label=>'Action'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if ?TERMINATE_BUTTON/}',
'<button data-terminate-id="#ID#" data-terminate-app-id="#BG_APP_ID#" data-terminate-ws-id="#SECURITY_GROUP_ID#" ',
'        type="button" title="Terminate Execution ID #ID#" aria-label="Terminate Execution ID #ID#" class="a-Button a-Button--danger a-Button--small terminate-execution">',
'        <span aria-hidden="true">Terminate</span>',
'</button>',
'{endif/}'))
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2013809890377409)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>190
,p_column_identifier=>'T'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2000088577254803)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'20001'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:DISPLAY_NAME:BG_APP_ID:PAGE_ID:BG_PROCESS_NAME:STARTED_FROM_SESSION_ID:USERNAME:STATUS:LAST_UPDATED_ON:TERMINATE_BUTTON:'
,p_sort_column_1=>'LAST_UPDATED_ON'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5410509093157689)
,p_plug_name=>'Background Executions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page lists page process background executions for all workspaces managed by this service.</p>',
'<p>Running Executions show a button within the <strong>Action</strong> column, which allows to terminate ',
'   this specific execution.</p>',
'<p>Clicking on the <em>ID</em> in the <strong>Application</strong> column will open a dialog, which shows a summary of all background executions for this application, along with a button to terminate them all.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'contentinfo'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2014594257377416)
,p_branch_action=>'f?p=&APP_ID.:191:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2013517718377406)
,p_name=>'P191_TERMINATE_EXECUTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1869655291911731)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2013627375377407)
,p_name=>'P191_TERMINATE_APP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1869655291911731)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2013717469377408)
,p_name=>'P191_TERMINATE_WORKSPACE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1869655291911731)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2013280996377403)
,p_name=>'Terminate Execution'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.terminate-execution'
,p_bind_type=>'live'
,p_bind_delegate_to_selector=>'#all_background_executions'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2013349223377404)
,p_event_id=>wwv_flow_imp.id(2013280996377403)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to terminate that background execution?'
,p_attribute_03=>'danger'
,p_attribute_06=>'Terminate'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2013486671377405)
,p_event_id=>wwv_flow_imp.id(2013280996377403)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P191_TERMINATE_EXECUTION_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$( this.triggeringElement ).data( "terminate-id" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2013924583377410)
,p_event_id=>wwv_flow_imp.id(2013280996377403)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P191_TERMINATE_APP_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$( this.triggeringElement ).data( "terminate-app-id" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2014012259377411)
,p_event_id=>wwv_flow_imp.id(2013280996377403)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P191_TERMINATE_WORKSPACE_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$( this.triggeringElement ).data( "terminate-ws-id" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2014424460377415)
,p_event_id=>wwv_flow_imp.id(2013280996377403)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'TERMINATE_EXECUTION'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2016360712377434)
,p_name=>'Refresh Report after dialog close'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1869655291911731)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2016401789377435)
,p_event_id=>wwv_flow_imp.id(2016360712377434)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1869655291911731)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2014662118377417)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Terminate Execution'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_process_bg.abort(',
'    p_security_group_id => :P191_TERMINATE_WORKSPACE_ID,         ',
'    p_application_id    => :P191_TERMINATE_APP_ID,',
'    p_execution_id      => :P191_TERMINATE_EXECUTION_ID );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'TERMINATE_EXECUTION'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Background Execution ID &P191_TERMINATE_EXECUTION_ID. terminated.'
,p_internal_uid=>2014662118377417
);
end;
/
prompt --application/pages/page_00192
begin
wwv_flow_imp_page.create_page(
 p_id=>192
,p_name=>'Active Background Executions'
,p_alias=>'ACTIVE-EXECUTIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Active Background Executions'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2014967925377420)
,p_name=>'Active Background Executions'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select e.status,',
'       count( e.id )                              as background_executions,',
'       count( distinct e.started_from_session_id) as distinct_sessions',
'  from wwv_flow_process_bg_execs$ e',
' where e.security_group_id = :P192_SECURITY_GROUP_ID',
'   and e.flow_id           = :P192_FLOW_ID',
'   and e.status in ( ''ENQUEUED'',''SCHEDULED'',''EXECUTING'' )',
' group by e.status'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No active background executions found for application &P192_FLOW_ID..'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2015117851377422)
,p_query_column_id=>1
,p_column_alias=>'STATUS'
,p_column_display_sequence=>20
,p_column_heading=>'Status'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(2050649672720692)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2015236866377423)
,p_query_column_id=>2
,p_column_alias=>'BACKGROUND_EXECUTIONS'
,p_column_display_sequence=>30
,p_column_heading=>'Background Executions'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2015364517377424)
,p_query_column_id=>3
,p_column_alias=>'DISTINCT_SESSIONS'
,p_column_display_sequence=>40
,p_column_heading=>'Distinct Sessions'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2015646423377427)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2015868343377429)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2015646423377427)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2015757968377428)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2015646423377427)
,p_button_name=>'TERMINATE_ALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Terminate Executions for App &P192_FLOW_ID.'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_process_bg_execs$ e',
' where e.security_group_id = :P192_SECURITY_GROUP_ID',
'   and e.flow_id           = :P192_FLOW_ID',
'   and e.status in ( ''ENQUEUED'',''SCHEDULED'',''EXECUTING'' )'))
,p_button_condition_type=>'EXISTS'
,p_button_css_classes=>'ui-button--danger'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2015486975377425)
,p_name=>'P192_SECURITY_GROUP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2014967925377420)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2015566374377426)
,p_name=>'P192_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2014967925377420)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2015916629377430)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2015868343377429)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2016022507377431)
,p_event_id=>wwv_flow_imp.id(2015916629377430)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2016195134377432)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Terminate all active executions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_execs in (',
'        select id',
'          from wwv_flow_process_bg_execs$',
'         where flow_id           = :P192_FLOW_ID',
'           and security_group_id = :P192_SECURITY_GROUP_ID',
'           and status in ( ''ENQUEUED'', ''SCHEDULED'', ''EXECUTING'' ) )',
'    loop',
'        wwv_flow_process_bg.abort(',
'            p_security_group_id => :P192_SECURITY_GROUP_ID,         ',
'            p_application_id    => :P192_FLOW_ID,',
'            p_execution_id      => l_execs.id );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2015757968377428)
,p_process_success_message=>'All active background executions for application &P192_FLOW_ID. terminated.'
,p_internal_uid=>2016195134377432
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2016264972377433)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2016264972377433
);
end;
/
prompt --application/pages/page_00277
begin
wwv_flow_imp_page.create_page(
 p_id=>277
,p_name=>'Install Workspace'
,p_alias=>'INSTALL-WORKSPACE1'
,p_step_title=>'Install Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44762414687138585)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(44806708563745373)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44763124645160393)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48176739757943065)
,p_plug_name=>'Schema Information'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_header=>'Choose whether the schema to be used by this workspace already exists and then enter the schema name.  If the schema does not exist, enter a password for it and choose the size of the associated tablespace to be created.  Click the <strong>Next</stro'
||'ng> button to continue.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113264001695874)
,p_plug_name=>'Install Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48177713223944782)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(44763124645160393)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48179628114949129)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44763124645160393)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48179934045949130)
,p_branch_action=>'f?p=&FLOW_ID.:278:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48179628114949129)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48180827899958515)
,p_name=>'P277_EXISTING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48176739757943065)
,p_item_default=>'0'
,p_prompt=>'Re-use existing schema?'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.1_OR_0'
,p_lov=>'.'||wwv_flow_imp.id(87817312158083090)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify if you wish to reuse an existing database schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48182621104966064)
,p_name=>'P277_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(48176739757943065)
,p_prompt=>'Schema Name'
,p_source=>'wwv_flow_imp_parser.get_schema_provisioned (p_file_id => :P277_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       username d,',
'       username r',
'  from wwv_flow_admin_all_schemas s',
' where restricted_to_workspace is null',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the name of an existing database schema if you are reusing an existing schema for the workspace. Enter the name of a database schema to be created if you want a new schema created and assigned to the workspace. The name must be a valid Oracle d'
||'atabase schema name. Certain schema names may not be available for assignment to workspaces. This is determined by the &PRODUCT_NAME. site administrator and database administrators at each site.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48183232878969473)
,p_name=>'P277_SCHEMA_PASSWORD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(48176739757943065)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'If you elect to create a new schema, enter a password for the schema. The password may be changed at any time after schema creation using standard tools without affecting the operation of &PRODUCT_NAME..'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48184219503975036)
,p_name=>'P277_QUOTA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(48176739757943065)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''C''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Space Quota (MB)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
' order by to_number(req_size)'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'If creating a new schema, select the maximum size of the tablespace to be associated with that schema.  This limit can later be adjusted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48315238971303971)
,p_name=>'P277_IMP_COMPANY_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(48176739757943065)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p277_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53807517254452276)
,p_name=>'P277_FILE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(48176739757943065)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48269636491849041)
,p_computation_sequence=>10
,p_computation_item=>'P277_EXISTING'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = wwv_flow_imp_parser.get_schema_provisioned (:P277_file_ID)'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48205936501206990)
,p_validation_name=>'check if schema exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = upper(:P277_SCHEMA)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Schema does not exist.'
,p_validation_condition=>':P277_EXISTING = ''1'' and :P277_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(48179628114949129)
,p_associated_item=>wwv_flow_imp.id(48182621104966064)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48206824858213114)
,p_validation_name=>'schema name required'
,p_validation_sequence=>10
,p_validation=>'P277_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Schema must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(48179628114949129)
,p_associated_item=>wwv_flow_imp.id(48182621104966064)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48207414253219488)
,p_validation_name=>'check if schema doesn''t exist'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = upper(:P277_SCHEMA)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Schema already exists.'
,p_validation_condition=>':P277_EXISTING = ''0'' and :P277_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(48179628114949129)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48208237109226103)
,p_validation_name=>'password required'
,p_validation_sequence=>10
,p_validation=>'P277_SCHEMA_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Password must be specified.'
,p_validation_condition=>':P277_EXISTING = ''0'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(48179628114949129)
,p_associated_item=>wwv_flow_imp.id(48183232878969473)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48208822695231456)
,p_validation_name=>'quota not 0'
,p_validation_sequence=>10
,p_validation=>'P277_QUOTA'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Quota must be specified.'
,p_validation_condition=>':P277_EXISTING = ''0'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(48179628114949129)
,p_associated_item=>wwv_flow_imp.id(48184219503975036)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(79842714274096727)
,p_validation_name=>'is workspace export'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_imp_parser.is_company_export(:P277_FILE_ID) = true'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'File is not a valid workspace export file.'
,p_when_button_pressed=>wwv_flow_imp.id(48179628114949129)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(183433405098755253)
,p_validation_name=>'schema not reserved'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_provisioning.reserved_schema(p_schema =>   ',
'    upper(:P277_SCHEMA)) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Primary schema requested for workspace is reserved.'
,p_when_button_pressed=>wwv_flow_imp.id(48179628114949129)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(183434421505769421)
,p_validation_name=>'schema not restricted'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (wwv_flow_provisioning.site_admin_is_restricted and',
'     wwv_flow_provisioning.restricted_schema(upper(:P277_SCHEMA),',
'        wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID))) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The requested schema is restricted. Restricted schemas cannot be assigned to workspaces.'
,p_when_button_pressed=>wwv_flow_imp.id(48179628114949129)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1214618732513490893)
,p_name=>'Reuse Schema'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P277_EXISTING'
,p_condition_element=>'P277_EXISTING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1214619022528490894)
,p_event_id=>wwv_flow_imp.id(1214618732513490893)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P277_SCHEMA_PASSWORD,P277_QUOTA'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1214619214307490894)
,p_event_id=>wwv_flow_imp.id(1214618732513490893)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P277_SCHEMA_PASSWORD,P277_QUOTA'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2613332895735337)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Set Item P277_SCHEMA_PASSWORD to null'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P277_SCHEMA_PASSWORD'
,p_internal_uid=>2613332895735337
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48416722507235934)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine company import action'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_done boolean := false;',
'  l_company_cnt pls_integer := 0;',
'  l_workspace_name varchar2(255) :=  upper(wwv_flow_imp_parser.get_workspace_name(:P277_FILE_ID));',
'begin',
'  for c1 in (select count(*) cnt',
'             from wwv_flow_companies',
'             where provisioning_company_id = :P277_IMP_COMPANY_ID',
'             or short_name = l_workspace_name)',
'  loop',
'    l_company_cnt := c1.cnt;',
'  end loop;',
'  ',
'  if l_company_cnt = 0 then',
'    :P165_COMPANY_EXISTS := wwv_flow_lang.system_message(''F4000.NO'');',
'    :P165_COMPANY_ACTION := wwv_flow_lang.system_message(''F4050.WS_TOBE_CREATED'');',
'    :P165_WS_EXISTS := ''N'';',
'  else  ',
'      :P165_COMPANY_EXISTS := wwv_flow_lang.system_message(''F4000.YES'');  ',
'      :P165_WS_EXISTS := ''Y'';',
'      for c1 in (select 1',
'                 from wwv_flow_companies',
'                 where provisioning_company_id = :P277_IMP_COMPANY_ID',
'                 and short_name = l_workspace_name)',
'      loop',
'        l_done := true;',
'        :P165_COMPANY_ACTION := wwv_flow_lang.system_message(''F4050.WS_EXISTS'');',
'      end loop;',
'      ',
'      if not l_done then',
'          for c1 in (select 1',
'                     from wwv_flow_companies',
'                     where provisioning_company_id != :P277_IMP_COMPANY_ID',
'                     and short_name = l_workspace_name)',
'          loop',
'            l_done := true;',
'            :P165_COMPANY_ACTION := wwv_flow_lang.system_message(''F4050.WSNAME_EXISTS'');',
'          end loop;',
'          ',
'          if not l_done then',
'              for c1 in (select 1',
'                         from wwv_flow_companies',
'                         where provisioning_company_id = :P277_IMP_COMPANY_ID',
'                         and short_name != l_workspace_name)',
'              loop',
'                :P165_COMPANY_ACTION := wwv_flow_lang.system_message(''F4050.WSID_EXISTS'');',
'              end loop; ',
'          end if;',
'      end if;   ',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>48416722507235934
);
end;
/
prompt --application/pages/page_00278
begin
wwv_flow_imp_page.create_page(
 p_id=>278
,p_name=>'Install Workspace'
,p_alias=>'INSTALL-WORKSPACE2'
,p_step_title=>'Install Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44769711139506518)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(44806708563745373)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44770620274518637)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(73838711357869610)
,p_plug_name=>'Verify'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Installing a workspace from an imported file will run as a privileged user. Therefore, it is important that you trust the source of the imported file.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188853515443356856)
,p_plug_name=>'Schema Assignment Status'
,p_region_template_options=>'#DEFAULT#:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>60
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_4050_ui.schema_assignment_status(',
'            p_file_id        => :P277_FILE_ID,',
'            p_schema         => :P277_SCHEMA,',
'            p_imp_company_id => :P277_IMP_COMPANY_ID,',
'            p_schema_exists  => case :P277_EXISTING',
'                                    when 1 then true',
'                                    else false',
'                                end );'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113393905695874)
,p_plug_name=>'Install Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73839503943869615)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44770620274518637)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73839910398869615)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(44770620274518637)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:277:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73839113159869612)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44770620274518637)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(44772801495559707)
,p_branch_action=>'f?p=&APP_ID.:165:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(73839503943869615)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73841032039869622)
,p_name=>'P278_PROCEED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(188853515443356856)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Check to proceed with the installation of the workspace which will have full access to the primary schema shown and additional schemas as indicated.'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Yes'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73841817383869626)
,p_validation_name=>'must check proceed'
,p_validation_sequence=>10
,p_validation=>'nvl(:P278_PROCEED,''No'') = ''Yes'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Must check to proceed.'
,p_when_button_pressed=>wwv_flow_imp.id(73839503943869615)
,p_associated_item=>wwv_flow_imp.id(73841032039869622)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
end;
/
prompt --application/pages/page_00280
begin
wwv_flow_imp_page.create_page(
 p_id=>280
,p_name=>'Environment Banner'
,p_alias=>'ENVIRONMENT-BANNER'
,p_page_mode=>'MODAL'
,p_step_title=>'Environment Banner'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2700645148653301)
,p_plug_name=>'Define Environment Banner'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(171512435967812715)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(182275369038854302)
,p_plug_name=>'INSTANCE BANNER INTRO'
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--info:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'You can define an instance-level environment banner to easily differentiate between multiple &PRODUCT_NAME. instances. The banner will be displayed throughout the &PRODUCT_NAME. development environment.'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2706665346663469)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(171512435967812715)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2707032211663471)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(171512435967812715)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2701753005653312)
,p_branch_name=>'Go To Page &LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2701043767653305)
,p_name=>'P280_BANNER_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2700645148653301)
,p_prompt=>'Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a short descriptive label that will be displayed in this environment banner.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2701247028653307)
,p_name=>'P280_BANNER_COLOR'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2700645148653301)
,p_prompt=>'Color'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P280_ENV_BANNER_COLORS'
,p_lov=>'.'||wwv_flow_imp.id(2805702200728881)||'.'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_css_classes=>'a-EnvBanner-colorSelector'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select an accent color for the banner message. This color will also be applied to the developer toolbar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'8'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2701648028653311)
,p_name=>'P280_ENABLE_BANNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2700645148653301)
,p_prompt=>'Enable Banner'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to enable environment banner for this &PRODUCT_NAME. instance.</p>',
'',
'<p>When enabled, the banner will display throughout the &PRODUCT_NAME. development environment.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(883418470222822204)
,p_name=>'P280_BANNER_POS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2700645148653301)
,p_prompt=>'Position'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P280_ENV_BANNER_POS'
,p_lov=>'.'||wwv_flow_imp.id(147094582352565991)||'.'
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the banner display position.'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2417567561910715)
,p_validation_name=>'if enabled, label required'
,p_validation_sequence=>10
,p_validation=>'P280_BANNER_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P280_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2706665346663469)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2417648621910716)
,p_validation_name=>'if enabled, color required'
,p_validation_sequence=>20
,p_validation=>'P280_BANNER_COLOR'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P280_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2706665346663469)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(883418551112822205)
,p_validation_name=>'if enabled, position required'
,p_validation_sequence=>30
,p_validation=>'P280_BANNER_POS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P280_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2706665346663469)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2700876795653303)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2707032211663471)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2700988910653304)
,p_event_id=>wwv_flow_imp.id(2700876795653303)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2417288077910712)
,p_name=>'toggle  label and color'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P280_ENABLE_BANNER'
,p_condition_element=>'P280_ENABLE_BANNER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2417392466910713)
,p_event_id=>wwv_flow_imp.id(2417288077910712)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P280_BANNER_LABEL,P280_BANNER_COLOR,P280_BANNER_POS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2417489734910714)
,p_event_id=>wwv_flow_imp.id(2417288077910712)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P280_BANNER_LABEL,P280_BANNER_COLOR,P280_BANNER_POS'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2701197792653306)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save environment banner settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''ENV_BANNER_ENABLE'',',
'    p_preference_value => :P280_ENABLE_BANNER );',
'if :P280_ENABLE_BANNER = ''Y'' then',
'    -- If environment banner enabled, set the preference value',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_LABEL'',',
'        p_preference_value => :P280_BANNER_LABEL );',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_COLOR'',',
'        p_preference_value => :P280_BANNER_COLOR );',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_POS'',',
'        p_preference_value => :P280_BANNER_POS );',
'else',
'    -- Otherwise, clear out the settings',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_LABEL'',',
'        p_preference_value => null );',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_COLOR'',',
'        p_preference_value => null );',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_POS'',',
'        p_preference_value => null );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Environment banner settings saved.'
,p_internal_uid=>2701197792653306
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2701815482653313)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch environment banner settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P280_ENABLE_BANNER := coalesce( wwv_flow_platform.get_preference( p_preference_name => ''ENV_BANNER_ENABLE'' ), ''N'' );',
':P280_BANNER_LABEL := wwv_flow_platform.get_preference( p_preference_name => ''ENV_BANNER_LABEL'' );',
':P280_BANNER_COLOR := wwv_flow_platform.get_preference( p_preference_name => ''ENV_BANNER_COLOR'' );',
':P280_BANNER_POS   := coalesce( wwv_flow_platform.get_preference( p_preference_name => ''ENV_BANNER_POS'' ), ''LEFT'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2701815482653313
);
end;
/
prompt --application/pages/page_00400
begin
wwv_flow_imp_page.create_page(
 p_id=>400
,p_name=>'Build Status'
,p_alias=>'BUILD-STATUS'
,p_step_title=>'Build Status'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(275228225185505839)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_bld_status.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179857814095000652)
,p_plug_name=>'Build Status'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this report to review and change the Build Status attribute of any application in this &PRODUCT_NAME. instance.</p>',
'',
'<p>When an application''s Build Status is set to "Run and Build Application", developers in the application''s workspace may use the App Builder to edit and alter the application definition. When an application''s Build Status is set to "Run Application'
||' Only", the App Builder can see that the application exists, but the details cannot be viewed or edited in any way. End users can still run this application.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472838728637137224)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P400a */',
'       f.ID,',
'       f.id as application,',
'       c.short_name as SECURITY_GROUP_ID,',
'       f.OWNER,',
'       f.NAME,',
'       f.BUILD_STATUS,',
'       f.last_updated_on,',
'       (select count(*) from wwv_flow_steps where flow_id = f.id) as pages',
'  from WWV_FLOWS f,',
'       WWV_FLOW_COMPANIES c',
' where f.security_group_id = c.provisioning_company_id',
'   and f.security_group_id not in (10, 11, 12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472838830978137224)
,p_name=>'Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472839026320137263)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472839221209137270)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472839112824137269)
,p_db_column_name=>'APPLICATION'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:P4001_ID,P4001_ATTRIBUTE:#ID#,Build'
,p_column_linktext=>'#APPLICATION#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472839401842137273)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472839314318137271)
,p_db_column_name=>'OWNER'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Parsing Schema'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472839503103137274)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Build Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(244320808989852457)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472839609286137275)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472839718429137276)
,p_db_column_name=>'PAGES'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472839932576138380)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316714359536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:SECURITY_GROUP_ID:APPLICATION:NAME:OWNER:BUILD_STATUS:LAST_UPDATED_ON:PAGES'
,p_sort_column_1=>'SECURITY_GROUP_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'APPLICATION'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(244305721912824543)
,p_computation_sequence=>10
,p_computation_item=>'P4001_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(222857701376540005)
,p_name=>'Dialog closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(472838728637137224)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(222857882841540006)
,p_event_id=>wwv_flow_imp.id(222857701376540005)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(472838728637137224)
);
end;
/
prompt --application/pages/page_00401
begin
wwv_flow_imp_page.create_page(
 p_id=>401
,p_name=>'Parsing Schemas'
,p_alias=>'PARSING-SCHEMAS'
,p_step_title=>'Parsing Schemas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(275228225185505839)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_app_parse_as.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74314867812006649)
,p_plug_name=>'Schema Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20828148654638359)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179855710932971339)
,p_plug_name=>'Parsing Schemas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use this report to identify the current parsing schema of each application in any workspace. This attribute identifies the Oracle database schema whose privileges are used when &PRODUCT_NAME. dynamically executes the application''s SQL and PL/SQL c'
||'ode at runtime.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472846306399177022)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P401a */',
'ID, ',
'(select short_name  from WWV_FLOW_COMPANIES where PROVISIONING_COMPANY_ID = f.security_group_id) SECURITY_GROUP_ID,',
'OWNER,',
'"NAME"',
'from WWV_FLOWS f',
'where f.security_group_id not in (10, 11, 12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472846424011177022)
,p_name=>'Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472846808824177027)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>'Parsing Schema'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472846720499177026)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472846630839177025)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472846918998177028)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472847104487177578)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316832284536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:OWNER:SECURITY_GROUP_ID'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'OWNER'
,p_sort_direction_2=>'ASC'
);
end;
/
prompt --application/pages/page_00460
begin
wwv_flow_imp_page.create_page(
 p_id=>460
,p_name=>'Import Workspace'
,p_alias=>'IMPORT-WORKSPACE1'
,p_step_title=>'Import Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_exprt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44759932077048957)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(44758222502979988)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(721136580461780231)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45313433799096703)
,p_plug_name=>'Import Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45313828464096704)
,p_plug_name=>'Import Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(202654431224384775)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Select the file you wish to import into the export repository. Once the file is imported, you can install the workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(58921039077841151)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(202654431224384775)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(79863815294295743)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(255043524592205262)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113457730695874)
,p_plug_name=>'Import Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721130822791730313)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45314324875096707)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(255043524592205262)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45314634840096707)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(255043524592205262)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(45316039608096712)
,p_branch_action=>'f?p=&FLOW_ID.:163:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(45314634840096707)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45314136696096704)
,p_name=>'P460_FILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(45313433799096703)
,p_prompt=>'Import file'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Use the Browse button to identify the workspace export file you wish to add to the export repository.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_06=>'Y'
,p_attribute_08=>'inline'
,p_attribute_12=>'INLINE'
,p_item_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47823437609586317)
,p_validation_name=>'file not null'
,p_validation_sequence=>10
,p_validation=>'P460_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'File must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(45314634840096707)
,p_associated_item=>wwv_flow_imp.id(45314136696096704)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(46711940675496390)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload export file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_title     varchar2(4000) := null;',
'  l_start     number := 0;',
'begin',
'  l_start := instr(:P460_FILE,''/'',1)+1;',
'  l_title := substr(:P460_FILE,l_start);',
'  --',
'  -- save file attributes',
'  --',
'  update wwv_flow_file_objects$ ',
'  set    title = l_title,',
'         file_type = ''COMPANY_EXPORT'', ',
'         description = l_title||'' upload'',',
'         security_group_id = :flow_security_group_id,      ',
'         mime_type = ''application/text'',',
'         created_by = :flow_user',
'  where name = :P460_FILE;           ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error uploading export file.'
,p_process_when_button_id=>wwv_flow_imp.id(45314634840096707)
,p_process_success_message=>'Export file uploaded.'
,p_internal_uid=>46711940675496390
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(53577817515753555)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set p163_file_id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P460_FILE)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'  :P163_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(45314634840096707)
,p_internal_uid=>53577817515753555
);
end;
/
prompt --application/pages/page_00461
begin
wwv_flow_imp_page.create_page(
 p_id=>461
,p_name=>'Export Workspace'
,p_alias=>'EXPORT-WORKSPACE'
,p_step_title=>'Export Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_exprt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(81345113041600234)
,p_plug_name=>'Identify Workspace'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_plug_query_row_template=>wwv_flow_imp.id(81008210556197147)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|2,3,4\1|',
'',
'&nbsp;:',
'',
'<font color="black" class="nounderline">Schema</font>:',
'',
'<font color="black" class="nounderline">Company</font>:',
'',
'<font color="black" class="nounderline">CompanyID</font>'))
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'EXPORT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(81350720528600259)
,p_plug_name=>'Export Workspace'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Provide a workspace name and click <strong>Export Workspace</strong> to continue.</p>'
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'EXPORT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(81389602375977783)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(79863815294295743)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(81637012348652051)
,p_plug_name=>'Export Workspace'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Click <strong>Save File</strong> to export the selected workspace to a file. Click <strong>Cancel</strong> to return to Workspace Administration.</p>',
'<p>Do not include Team Development data if you wish to import the workspace into a runtime only environment.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'EXPORT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(81719123560014772)
,p_plug_name=>'Export Workspace'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'EXPORT'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You have selected the workspace <strong>&P461_WORKSPACE.</strong> to be exported to a file. Click <strong>Save File</strong> to proceed.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955891698622997327)
,p_plug_name=>'New'
,p_parent_plug_id=>wwv_flow_imp.id(81719123560014772)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(81615605843555548)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(81345113041600234)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:461::'
,p_button_condition=>'EXPORT'
,p_button_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(81625912647623713)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(81345113041600234)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export Workspace'
,p_button_position=>'CREATE'
,p_button_condition=>'EXPORT'
,p_button_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(81367606709666813)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(955891698622997327)
,p_button_name=>'EXPORT'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save File'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.submit(''EXPORT'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(81611420210521837)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(955891698622997327)
,p_button_name=>'DONE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:461::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(81690503989971319)
,p_branch_action=>'f?p=&FLOW_ID.:461:&SESSION.:EXPORT:&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(81625912647623713)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2300102571866943)
,p_name=>'P461_INCLUDE_TEAM_DEVELOPMENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(81719123560014772)
,p_item_default=>'Y'
,p_prompt=>'Include Team Development'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Set to <strong>Yes</strong> if you want to include Team Development data like Labels, Milestones, Templates, Issues and  Feedback in your workspace export file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2402459024991821)
,p_name=>'P461_INCLUDE_EXTENSION_LINKS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(81719123560014772)
,p_item_default=>'Y'
,p_prompt=>'Include Extension Links'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157992123774592395)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Set to <strong>Yes</strong> if you want to include Extension Links data in your workspace export file.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(81351023663600263)
,p_name=>'P461_WORKSPACE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(81345113041600234)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.WORKSPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(175838302006261649)
,p_name=>'P461_FILE_CHARSET'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(81719123560014772)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(175798011541253458)||'.'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the specified character set the for export file. When importing this file, you will need to specify the same character set. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1796417910368006108)
,p_name=>'P461_MINIMAL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(81719123560014772)
,p_item_default=>'MIN'
,p_prompt=>'Export Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2046991831712786495)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Set to <strong>Full</strong> only if you want to replicate to another instance all workspace artifacts including SQL Scripts, SQL Command History, saved SQL, user preferences, developer login history, email logs, and UI defaults. In most cases, you s'
||'hould not change the default value <strong>Minimal</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(478209805683252492)
,p_validation_name=>'P461_WORKSPACE exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id != 0',
'  and upper(:P461_WORKSPACE) = SHORT_NAME'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Must select valid Workspace.'
,p_validation_condition=>'P461_WORKSPACE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(81625912647623713)
,p_associated_item=>wwv_flow_imp.id(81351023663600263)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(81370514936688072)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_orig_sgid number := wwv_flow_security.g_security_group_id;',
'begin',
'  for c1 in (select provisioning_company_id  ',
'    from wwv_flow_companies ',
'    where short_name = upper(:P461_WORKSPACE)) loop',
'    wwv_flow_security.g_security_group_id := c1.provisioning_company_id;',
'  end loop;',
'  --',
'  sys.htp.init;',
'  wwv_flow.g_page_text_generated := true;',
'  wwv_flow_fnd_user_api.g_mime_shown := true;',
'  ',
'  wwv_flow_utilities.print_download_header(',
'    p_mime_type =>     ''application/x-sql'',',
'    p_file_name =>      :P461_WORKSPACE || ''.sql'',',
'    p_is_attachment => true',
'  );  ',
'  ',
'  sys.owa_util.http_header_close;',
'  --',
'  wwv_flow_utilities.export_workspace (',
'      p_workspace_id             => wwv_flow_security.g_security_group_id,',
'      p_format                   => ''UNIX'',',
'      p_include_team_development => (nvl(:P461_INCLUDE_TEAM_DEVELOPMENT, ''Y'') = ''Y''),',
'      p_include_extension_links  => (nvl(:P461_INCLUDE_EXTENSION_LINKS, ''Y'') = ''Y''),',
'      p_minimal                  => (nvl(:P461_MINIMAL,''x'') = ''MIN'') );',
'  --',
'  wwv_flow.g_page_text_generated := true;',
'  wwv_flow.g_unrecoverable_error := true;',
'  wwv_flow_security.g_security_group_id := l_orig_sgid;',
'  --',
'exception when others then',
'  wwv_flow_security.g_security_group_id := l_orig_sgid;',
'  raise;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error exporting workspace.'
,p_process_when_button_id=>wwv_flow_imp.id(81367606709666813)
,p_process_when=>'EXPORT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Workspace exported.'
,p_internal_uid=>81370514936688072
);
end;
/
prompt --application/pages/page_00500
begin
wwv_flow_imp_page.create_page(
 p_id=>500
,p_name=>'Application Changes by Workspace'
,p_alias=>'APPLICATION-CHANGES-BY-WORKSPACE'
,p_step_title=>'Application Changes by Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472857622906290870)
,p_plug_name=>'Application Changes by Workspace'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P500a */ c.provisioning_company_id security_group_id,',
'       c.short_name,count(s.schema) schemas,',
'       -- apps',
'       max(f.apps) apps,max(f.pages) pages,',
'       max(f.last_updated_on) last_updated_on,',
'       --mail',
'       max(nvl(m.mail_sent,0)) mail_sent,',
'       -- page views',
'       max(nvl(pv.page_views,0)) page_views,',
'       max(nvl(pv.end_users,0)) end_users,',
'       max(nvl(pv.total_elap,0)) total_elap,',
'       max(nvl(pv.avg_page_view_time,0)) avg_page_view_time,',
'       max(nvl(dv.d_page_views,0)) d_page_views,',
'       max(nvl(pv.distinct_ip,0)) distinct_ip',
'  from wwv_flow_companies c, wwv_flow_company_schemas s,',
'       -- flows and pages',
'       (select f1.security_group_id,',
'               count(distinct f1.id) apps,',
'               count(p1.id) pages,',
'               max(f1.last_updated_on) last_updated_on',
'          from wwv_flow_steps p1, wwv_flows f1',
'         where f1.security_group_id = p1.security_group_id',
'           and p1.flow_id = f1.id',
'         group by f1.security_group_id) f,',
'       -- email',
'       (select security_group_id,count(*) mail_sent',
'          from wwv_flow_mail_log',
'         group by security_group_id) m,',
'       -- app page views',
'       (select security_group_id,count(*) page_views,count(distinct userid) end_users,',
'               sum(elap) total_elap,avg(ELAP) avg_page_view_time,',
'               count(distinct IP_ADDRESS) distinct_ip',
'          from wwv_flow_activity_log',
'         where (flow_id > 4999 or flow_id < 4000)',
'         group by security_group_id) pv,',
'       -- developer page views',
'       (select security_group_id,count(*) d_page_views',
'          from wwv_flow_activity_log',
'         where flow_id between 4000 and 4999',
'         group by security_group_id) dv',
' where s.security_group_id = c.provisioning_company_id',
'   and c.provisioning_company_id > 10',
'   and c.provisioning_company_id = f.security_group_id',
'   and c.provisioning_company_id = m.security_group_id(+)',
'   and c.provisioning_company_id = pv.security_group_id(+)',
'   and c.provisioning_company_id = dv.security_group_id(+)',
'   and c.provisioning_company_id <> 11',
' group by c.provisioning_company_id,c.short_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472857730758290870)
,p_name=>'Application Changes by Workspace'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472857903552290887)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858029095290888)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_link=>'f?p=&APP_ID.:501:&SESSION.:REPORT:&DEBUG.:501:P501_SGID:#SECURITY_GROUP_ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858116192290889)
,p_db_column_name=>'SCHEMAS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Schemas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858225817290890)
,p_db_column_name=>'APPS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858318712290892)
,p_db_column_name=>'PAGES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858404727290893)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Most Recent Update'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858503358290894)
,p_db_column_name=>'MAIL_SENT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Mail Sent'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858627932290895)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858715333290896)
,p_db_column_name=>'END_USERS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'End Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858811769290897)
,p_db_column_name=>'TOTAL_ELAP'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Total Page View Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472858910412290898)
,p_db_column_name=>'AVG_PAGE_VIEW_TIME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Average Page View Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472859006752290899)
,p_db_column_name=>'D_PAGE_VIEWS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Developer Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472859111689290900)
,p_db_column_name=>'DISTINCT_IP'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Distinct IP Addresses'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472859204674291233)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1316918398536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:SCHEMAS:APPS:PAGES:PAGE_VIEWS:END_USERS:DISTINCT_IP:TOTAL_ELAP:AVG_PAGE_VIEW_TIME:LAST_UPDATED_ON:D_PAGE_VIEWS:MAIL_SENT'
,p_sort_column_1=>'APPS'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1080989578091523928)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(472857622906290870)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:RP,RIR,500:::'
);
end;
/
prompt --application/pages/page_00501
begin
wwv_flow_imp_page.create_page(
 p_id=>501
,p_name=>'Workspace Activity Details'
,p_alias=>'WORKSPACE-ACTIVITY-DETAILS'
,p_step_title=>'Workspace Activity Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216662902659587159)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22547304320952975)
,p_name=>'Workspace Details'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    x   varchar2(32767) := null;',
'begin',
'    x:= ''',
'    select c.provisioning_company_id security_group_id,',
'           c.short_name,count(s.schema) schemas,',
'           -- apps',
'           max(f.apps) apps,max(f.pages) pages,',
'           max(f.last_updated_on) last_updated_on,',
'           --mail',
'           max(nvl(m.mail_sent,0)) mail_sent,',
'           max(nvl(mq.mail_count,0)) mail_in_queue,',
'           -- page views',
'           max(nvl(pv.page_views,0)) page_views,',
'           max(nvl(pv.end_users,0)) end_users,',
'           max(nvl(pv.total_elap,0)) total_elap,',
'           max(nvl(pv.avg_page_view_time,0)) avg_page_view_time,',
'           max(nvl(dv.d_page_views,0)) d_page_views,',
'           max(nvl(dv.act_developers,0)) act_developers       ',
'      from wwv_flow_companies c, wwv_flow_company_schemas s,',
'           -- flows and pages',
'           (select f1.security_group_id,',
'                   count(distinct f1.id) apps,',
'                   count(p1.id) pages,',
'                   max(f1.last_updated_on) last_updated_on',
'              from wwv_flow_steps p1, wwv_flows f1',
'             where f1.security_group_id = p1.security_group_id',
'               and p1.flow_id = f1.id',
'             group by f1.security_group_id) f,',
'           -- email',
'           (select security_group_id,count(*) mail_sent',
'              from wwv_flow_mail_log',
'             group by security_group_id) m,',
'           -- email queue',
'           (select security_group_id,count(*) mail_count',
'              from wwv_flow_mail_queue',
'             where last_updated_on < sysdate - 1',
'             group by security_group_id) mq,',
'             -- app page views',
'           (select security_group_id,count(*) page_views,count(distinct userid) end_users,',
'                   sum(elap) total_elap,avg(ELAP) avg_page_view_time',
'                      from wwv_flow_activity_log',
'                     where (flow_id > 4999 or flow_id < 4000)',
'                     group by security_group_id) pv,',
'             -- developer page views',
'           (select security_group_id,count(*) d_page_views,count(distinct userid) act_developers',
'                      from wwv_flow_activity_log',
'                     where flow_id between 4000 and 4999',
'                     group by security_group_id) dv',
'     where s.security_group_id = c.provisioning_company_id '';',
'     if :P501_SEARCH is not null then',
'        x:=x||'' and upper(c.short_name) like ''''%''''||upper(:P501_SEARCH)||''''%'''' '';',
'     end if;',
'     x:=x||''',
'       and c.provisioning_company_id = :P501_SGID',
'       and c.provisioning_company_id = f.security_group_id',
'       and c.provisioning_company_id = m.security_group_id(+)',
'       and c.provisioning_company_id = mq.security_group_id(+)',
'       and c.provisioning_company_id = pv.security_group_id(+)',
'       and c.provisioning_company_id = dv.security_group_id(+)',
'     group by c.provisioning_company_id,c.short_name '';',
'',
'    return x;',
'end;',
'     '))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(22621917280199870)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_item=>'P501_ROWS'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>15000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22547503569952980)
,p_query_column_id=>1
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>1
,p_column_heading=>'SECURITY_GROUP_ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22547605797952980)
,p_query_column_id=>2
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_when_condition=>'f?p=4050:14:&SESSION.:REPORT:NO:14:SGID:#ID#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22547829529952980)
,p_query_column_id=>3
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>3
,p_column_heading=>'Schemas'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22547705746952980)
,p_query_column_id=>4
,p_column_alias=>'APPS'
,p_column_display_sequence=>4
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22548016245952981)
,p_query_column_id=>5
,p_column_alias=>'PAGES'
,p_column_display_sequence=>5
,p_column_heading=>'Pages'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22548102604952981)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>10
,p_column_heading=>'Most Recent Update'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22547928028952980)
,p_query_column_id=>7
,p_column_alias=>'MAIL_SENT'
,p_column_display_sequence=>14
,p_column_heading=>'Mail Sent'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22548211462952981)
,p_query_column_id=>8
,p_column_alias=>'MAIL_IN_QUEUE'
,p_column_display_sequence=>13
,p_column_heading=>'Mail In <br />Queue Over <br />1 Day'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22548322899952981)
,p_query_column_id=>9
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>6
,p_column_heading=>'Page<br />Views'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22548424140952981)
,p_query_column_id=>10
,p_column_alias=>'END_USERS'
,p_column_display_sequence=>7
,p_column_heading=>'Number of End Users'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22548531510952981)
,p_query_column_id=>11
,p_column_alias=>'TOTAL_ELAP'
,p_column_display_sequence=>8
,p_column_heading=>'Total Page View Time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G990D9'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22548604426952981)
,p_query_column_id=>12
,p_column_alias=>'AVG_PAGE_VIEW_TIME'
,p_column_display_sequence=>9
,p_column_heading=>'Average Page View Time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G990D9'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22548711632952981)
,p_query_column_id=>13
,p_column_alias=>'D_PAGE_VIEWS'
,p_column_display_sequence=>11
,p_column_heading=>'Developer<br />Page<br /> Views'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22548827859952982)
,p_query_column_id=>14
,p_column_alias=>'ACT_DEVELOPERS'
,p_column_display_sequence=>12
,p_column_heading=>'Active Developers'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22562529150986872)
,p_name=>'Schemas'
,p_template=>wwv_flow_imp.id(721115784857730284)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.schema,df.bytes/1024/1024 size_mb,',
'       o.tables,o.views,o.packages,o.procedures,o.functions',
'  from wwv_flow_companies c, wwv_flow_company_schemas s,',
'        sys.dba_users u, sys.dba_data_files df,',
'        (select owner,',
'                count(decode(object_type,''TABLE'',1,''MATERIALIZED VIEW'',1)) tables,',
'                count(decode(object_type,''VIEW'',1)) views,',
'                count(decode(object_type,''PACKAGE'',1)) packages,',
'                count(decode(object_type,''PROCEDURE'',1)) procedures,',
'                count(decode(object_type,''FUNCTION'',1)) functions',
'           from sys.dba_objects a, wwv_flow_company_schemas s1',
'          where s1.security_group_id = :P501_SGID',
'            and s1.schema = a.owner',
'            and a.object_type in (''TABLE'',''MATERIALIZED VIEW'',''VIEW'',''PACKAGE'',''PROCEDURE'',''FUNCTION'')',
'          group by a.owner) o          ',
' where s.security_group_id = c.provisioning_company_id ',
'   and c.provisioning_company_id = :P501_SGID',
'   and u.username = s.schema',
'   and u.default_tablespace = df.tablespace_name',
'   and o.owner = u.username'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Schemas found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22562808087986878)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22569512574010449)
,p_query_column_id=>2
,p_column_alias=>'SIZE_MB'
,p_column_display_sequence=>2
,p_column_heading=>'Size (MB)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G990D9'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23499620413597463)
,p_query_column_id=>3
,p_column_alias=>'TABLES'
,p_column_display_sequence=>3
,p_column_heading=>'Tables'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23499701273597463)
,p_query_column_id=>4
,p_column_alias=>'VIEWS'
,p_column_display_sequence=>4
,p_column_heading=>'Views'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23500831973610243)
,p_query_column_id=>5
,p_column_alias=>'PACKAGES'
,p_column_display_sequence=>5
,p_column_heading=>'Packages'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23500906437610243)
,p_query_column_id=>6
,p_column_alias=>'PROCEDURES'
,p_column_display_sequence=>6
,p_column_heading=>'Procedures'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23501023387610243)
,p_query_column_id=>7
,p_column_alias=>'FUNCTIONS'
,p_column_display_sequence=>7
,p_column_heading=>'Functions'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22635832565309520)
,p_name=>'Applications'
,p_template=>wwv_flow_imp.id(721115784857730284)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f1.id,f1.name,',
'       count(p1.id) pages,',
'       max(f1.last_updated_on) last_updated_on,',
'       max(nvl(pv.page_views,0)) page_views,',
'       max(nvl(end_users,0)) end_users,',
'       max(nvl(total_elap,0)) total_elap,',
'       max(nvl(avg_page_view_time,0)) avg_page_view_time,',
'       max(nvl(latest_changes,0)) latest_changes, ',
'       max(nvl(act_developers,0)) act_developers',
' from wwv_flow_steps p1, wwv_flows f1,',
'                   (select flow_id,count(*) page_views,count(distinct userid) end_users,',
'                           sum(elap) total_elap,avg(ELAP) avg_page_view_time',
'                      from wwv_flow_activity_log',
'                     where security_group_id = :P501_SGID',
'                     group by flow_id) pv,',
'           (select flow_id,count(id) latest_changes,count(distinct FLOW_USER) act_developers',
'              from WWV_FLOW_BUILDER_AUDIT_TRAIL',
'             where security_group_id = :P501_SGID',
'               and audit_date > trunc(sysdate - 7)',
'             group by flow_id ) a',
'where :P501_SGID = f1.security_group_id',
'       and f1.id = p1.flow_id',
'       and f1.id = pv.flow_id(+)',
'       and f1.id = a.flow_id(+)',
'group by f1.name,f1.id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Applications found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23496432394515738)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22636100280309530)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22636203092309530)
,p_query_column_id=>3
,p_column_alias=>'PAGES'
,p_column_display_sequence=>3
,p_column_heading=>'Pages'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22636320699309531)
,p_query_column_id=>4
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>4
,p_column_heading=>'Last<br /> Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22647825125345216)
,p_query_column_id=>5
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>5
,p_column_heading=>'Page <br />Views'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22647921593345216)
,p_query_column_id=>6
,p_column_alias=>'END_USERS'
,p_column_display_sequence=>9
,p_column_heading=>'End<br />Users'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22648010587345216)
,p_query_column_id=>7
,p_column_alias=>'TOTAL_ELAP'
,p_column_display_sequence=>6
,p_column_heading=>'Total Page<br />View Time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G990D9'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22648128286345216)
,p_query_column_id=>8
,p_column_alias=>'AVG_PAGE_VIEW_TIME'
,p_column_display_sequence=>7
,p_column_heading=>'Average<br /> Page <br />View Time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G990D9'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22669100200413779)
,p_query_column_id=>9
,p_column_alias=>'LATEST_CHANGES'
,p_column_display_sequence=>8
,p_column_heading=>'Changes in <br />Last 7 Days'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22669204938413779)
,p_query_column_id=>10
,p_column_alias=>'ACT_DEVELOPERS'
,p_column_display_sequence=>10
,p_column_heading=>'Active <br />Developers'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(23504624625702720)
,p_name=>'Mail Sent'
,p_template=>wwv_flow_imp.id(721115784857730284)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mail_to,mail_subj,last_updated_on',
'  from wwv_flow_mail_log',
' where security_group_id = :P501_SGID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Sent Mail found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23504903559702727)
,p_query_column_id=>1
,p_column_alias=>'MAIL_TO'
,p_column_display_sequence=>1
,p_column_heading=>'To'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23505001594702727)
,p_query_column_id=>2
,p_column_alias=>'MAIL_SUBJ'
,p_column_display_sequence=>2
,p_column_heading=>'Subject'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23505113305702727)
,p_query_column_id=>3
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>3
,p_column_heading=>'Sent on'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(23507724887721798)
,p_name=>'Mail in Queue'
,p_template=>wwv_flow_imp.id(721115784857730284)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mail_to,mail_subj,last_updated_on',
'  from wwv_flow_mail_queue',
' where security_group_id = :P501_SGID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Mail in Queue found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23508028120721802)
,p_query_column_id=>1
,p_column_alias=>'MAIL_TO'
,p_column_display_sequence=>1
,p_column_heading=>'To'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23508131834721802)
,p_query_column_id=>2
,p_column_alias=>'MAIL_SUBJ'
,p_column_display_sequence=>2
,p_column_heading=>'Subject'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23508201647721802)
,p_query_column_id=>3
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>3
,p_column_heading=>'Sent'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(23526615593823115)
,p_name=>'Developers'
,p_template=>wwv_flow_imp.id(721115784857730284)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select u.email_address,u.first_name,u.last_name,',
'       count(t.id) changes',
'  from wwv_flow_developers d,wwv_flow_fnd_user u,',
'       wwv_flow_builder_audit_trail t',
' where d.user_id = u.user_id',
'   and t.flow_user(+) = u.user_name',
'   and d.security_group_id = :P501_SGID',
' group by u.email_address,u.first_name,u.last_name'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Developers found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23528901656838001)
,p_query_column_id=>1
,p_column_alias=>'EMAIL_ADDRESS'
,p_column_display_sequence=>1
,p_column_heading=>'Email'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23527025585823120)
,p_query_column_id=>2
,p_column_alias=>'FIRST_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'First Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23527131181823120)
,p_query_column_id=>3
,p_column_alias=>'LAST_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Last Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23527223558823120)
,p_query_column_id=>4
,p_column_alias=>'CHANGES'
,p_column_display_sequence=>4
,p_column_heading=>'Changes'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22550506916952996)
,p_branch_action=>'f?p=&FLOW_ID.:501:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22551518367955360)
,p_name=>'P501_SGID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(22547304320952975)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22550308257952994)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'P501_GO,P501_SEARCH'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>22550308257952994
);
end;
/
prompt --application/pages/page_00555
begin
wwv_flow_imp_page.create_page(
 p_id=>555
,p_name=>'Public Themes'
,p_alias=>'PUBLIC-THEMES'
,p_step_title=>'Public Themes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(3931176884177111905)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138015530198611860)
,p_plug_name=>'Public Themes'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>By creating a public theme, you add it to the theme repository. Public themes are available when you create an application or when you create a theme for an existing application.</p>',
'<p>You create a public theme by selecting a theme from within a workspace and application. Once created, you cannot edit a public theme directly. To edit a public theme, create an application based off the theme, edit the theme within that applicatio'
||'n, and then create a new public theme with the updated application theme. If the old theme is no longer needed, delete it.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472913831407970593)
,p_plug_name=>'Public Themes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.id,',
'       t.theme_id,',
'       t.theme_name,',
'       ''<img src="''||decode(nvl(t.CUSTOM_IMAGE,''N''),''N'',',
'          m.ip||''htmldb/icons/ws_theme.png'',',
'         ''wwv_flow_utilities.get_theme_file?p_id=''||t.id||''&''||',
'         ''p_app_id=''||flow_id)||''" width="150" height="80" alt="" />''',
'       theme_image,',
'       t.theme_description,',
'       t.flow_id application_id,',
'       (select count(*) from wwv_flow_templates where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) page_templates,',
'       (select count(*) from WWV_FLOW_BUTTON_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) button_templates,',
'       (select count(*) from WWV_FLOW_CAL_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) calendar_templates,',
'       (select count(*) from WWV_FLOW_FIELD_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) label_templates,',
'       (select count(*) from WWV_FLOW_LIST_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) list_templates,',
'       (select count(*) from WWV_FLOW_MENU_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) breadcrumb_templates,',
'       (select count(*) from WWV_FLOW_PAGE_PLUG_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) region_templates,',
'       (select count(*) from WWV_FLOW_ROW_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) report_templates,',
'       (select count(*) from WWV_FLOW_POPUP_LOV_TEMPLATE where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) POPUP_LOV_template,',
'       decode(nvl(t.CUSTOM_IMAGE,''N''),''N'',',
'          m.ip||''htmldb/icons/ws_theme.png'',',
'         ''wwv_flow_utilities.get_theme_file?p_id=''||t.id||''&''||',
'         ''p_app_id=''||t.flow_id)',
'         img,',
'       t.theme_name image_alt,',
'       ''f?p=4050:42:''||:app_session||''::::P42_ID:''|| t.id image_url,',
'       t.theme_name||'' - ''||t.theme_id image_text',
'  from wwv_flow_themes t,',
'       (select v(''IMAGE_PREFIX'') ip from dual) m',
' where t.theme_security_group_id is null',
'   and t.security_group_id = 11',
'   and t.flow_id in (select id from wwv_flows where application_type = ''STANDARD'' and security_group_id = 11)',
'   and t.theme_id > 99'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(472913908256970593)
,p_name=>'Workspace Themes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_link_column=>'IMAGE_URL'
,p_icon_view_img_src_column=>'IMG'
,p_icon_view_label_column=>'IMAGE_TEXT'
,p_icon_view_alt_text=>'#IMAGE_ALT#'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472914227983970604)
,p_db_column_name=>'THEME_ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472914327199970605)
,p_db_column_name=>'THEME_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.::P42_ID:#ID#'
,p_column_linktext=>'#THEME_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472914417204970606)
,p_db_column_name=>'THEME_IMAGE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472914504507970607)
,p_db_column_name=>'THEME_DESCRIPTION'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472914604665970608)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Workspace <br />Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472914719936970609)
,p_db_column_name=>'PAGE_TEMPLATES'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Page<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472914816346970611)
,p_db_column_name=>'BUTTON_TEMPLATES'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Button<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472914924536970612)
,p_db_column_name=>'CALENDAR_TEMPLATES'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Calendar<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472915030342970613)
,p_db_column_name=>'LABEL_TEMPLATES'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Label<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472915100138970614)
,p_db_column_name=>'LIST_TEMPLATES'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'List<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472915200253970615)
,p_db_column_name=>'BREADCRUMB_TEMPLATES'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>'Breadcrumb<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472915308766970616)
,p_db_column_name=>'REGION_TEMPLATES'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Region<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472915426426970617)
,p_db_column_name=>'REPORT_TEMPLATES'
,p_display_order=>13
,p_column_identifier=>'N'
,p_column_label=>'Report<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472915522119970618)
,p_db_column_name=>'POPUP_LOV_TEMPLATE'
,p_display_order=>14
,p_column_identifier=>'O'
,p_column_label=>'Popup LOV<br />Template'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472914132092970603)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472918912507984112)
,p_db_column_name=>'IMG'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472919002293984114)
,p_db_column_name=>'IMAGE_ALT'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Image Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472919131467984115)
,p_db_column_name=>'IMAGE_URL'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Image Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472919207424984116)
,p_db_column_name=>'IMAGE_TEXT'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Image Text'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(472950628222998059)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1317009692536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'THEME_ID:THEME_NAME:THEME_IMAGE:THEME_DESCRIPTION:APPLICATION_ID:PAGE_TEMPLATES:BUTTON_TEMPLATES:CALENDAR_TEMPLATES:LABEL_TEMPLATES:LIST_TEMPLATES:BREADCRUMB_TEMPLATES:REGION_TEMPLATES:REPORT_TEMPLATES:POPUP_LOV_TEMPLATE:ID:IMG:IMAGE_ALT:IMAGE_URL:IM'
||'AGE_TEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(472972504505029059)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(472913831407970593)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138085025043740205)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(472913831407970593)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Public Theme'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:47,48,51::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(138020924841611867)
,p_branch_action=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00900
begin
wwv_flow_imp_page.create_page(
 p_id=>900
,p_name=>'Welcome Splash'
,p_alias=>'WELCOME-SPLASH'
,p_step_title=>'Welcome to Oracle APEX'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Hide breadcrumb bar */',
'.a-ControlBar.apex-instance-admin {display: none;}',
'',
'/* Set Large Icon Size */',
'.a-Alert--wizard .a-Alert-icon .a-Icon.large-icon {width: 96px;height: 96px;}'))
,p_step_template=>wwv_flow_imp.id(721099117305687972)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52036166580715317)
,p_plug_name=>'Welcome to &PRODUCT_NAME.!'
,p_icon_css_classes=>'large-icon gi-icon-apex-logo-icon'
,p_region_template_options=>'a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(829706609080810173)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Before you get started, please take a moment to create a workspace. A workspace is a shared work area where multiple developers can build applications.</p>',
'',
'<p>Once created, sign in to your workspace to begin building applications. Return to Administration Services to create additional workspaces or to manage this &PRODUCT_NAME. instance.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(52036219048715318)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(52036166580715317)
,p_button_name=>'CREATE_WORKSPACE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(206356434016953037)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(52036166580715317)
,p_button_name=>'CREATE_WORKSPACE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:RP,142:LAST_VIEW:3'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
);
end;
/
prompt --application/pages/page_01000
begin
wwv_flow_imp_page.create_page(
 p_id=>1000
,p_name=>'Administrator Digest'
,p_alias=>'ADMINISTRATOR-DIGEST-DASHBOARD'
,p_step_title=>'Administrator Digest'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Report-cell[headers="DELTA"] {width: 96px; white-space: nowrap;}',
'.a-Report-cell[headers="ICON"]  {width: 20%;}',
'.a-Report-cell[headers="TOTAL"] {width: 20%;}'))
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3000113066736701)
,p_plug_name=>'Workload'
,p_region_sub_css_classes=>'instance-admin'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2800747079731824)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(517410251255325302)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(19094863632011741)
,p_name=>'Workspace Users'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>70
,p_region_css_classes=>'a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with wksp_users_stats as (',
'    select count(case',
'                     when wu.creation_date between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'')',
'                                           and trunc(sysdate) - 1/24/3600',
'                     then wu.user_id',
'                 end) as wksp_users_total_1x,',
'           count(wu.user_id) as wksp_users_total      ',
'      from wwv_flow_workspace_users wu,',
'           wwv_flow_companies ws',
'     where ws.provisioning_company_id = wu.workspace_id',
'       and ws.provisioning_company_id not in (0, 10, 11, 12)',
'       and wu.creation_date <= trunc(sysdate) - 1/24/3600 )     ',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label       ',
' from (',
'    select 1                                                                       as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_TOTAL_WORKSPACE_USERS'') as stats_category,',
'           null                                                                    as label_class,',
'           nvl(wksp_users_total, 0)                                              as total,',
'           case when nvl(wksp_users_total_1x, 0) != 0',
'                then nvl(wksp_users_total, 0) - nvl(wksp_users_total_1x, 0)',
'                else 0',
'           end                                                                     as delta',
'      from wksp_users_stats )'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No workspace users found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19094999231011742)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19095021144011743)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19095114744011744)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19095352968011746)
,p_query_column_id=>4
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19095226284011745)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19095449300011747)
,p_query_column_id=>6
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21011526643759847)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17878987604529939)
,p_plug_name=>'Workspace Users'
,p_parent_plug_id=>wwv_flow_imp.id(19094863632011741)
,p_region_css_classes=>'apex-col--topBorder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>95
,p_plug_new_grid_row=>false
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(17879037694529940)
,p_region_id=>wwv_flow_imp.id(17878987604529939)
,p_chart_type=>'combo'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'top'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_no_data_found_message=>'No Workspace Users found.'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(17879295592529942)
,p_chart_id=>wwv_flow_imp.id(17879037694529940)
,p_seq=>10
,p_name=>'Total Users'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7))',
'select sum(case when ws.provisioning_company_id not in (0, 10, 11, 12)',
'                 and u.creation_date is not null',
'                 and u.creation_date < dg.log_day + 1 then 1',
'                else 0',
'           end) as wksp_users_value,',
'       dg.log_day as wksp_users_label',
'  from wwv_flow_workspace_users u,',
'       wwv_flow_companies      ws,',
'       day_gen                 dg',
' where ws.provisioning_company_id = u.workspace_id (+)',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'WKSP_USERS_VALUE'
,p_items_label_column_name=>'WKSP_USERS_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>3
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(17879127343529941)
,p_chart_id=>wwv_flow_imp.id(17879037694529940)
,p_seq=>20
,p_name=>'Users Created per Day'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7) )',
'select sum(case when wu.creation_date >= dg.log_day and wu.creation_date < dg.log_day + 1 then 1',
'                else 0',
'           end) as wksp_users_value,',
'       dg.log_day as wksp_users_label',
'  from wwv_flow_workspace_users wu,',
'       wwv_flow_companies       ws,',
'       day_gen                  dg',
' where ws.provisioning_company_id = wu.workspace_id (+)',
'   and ws.provisioning_company_id not in (0, 10, 11, 12)',
'   and wu.creation_date is not null',
'   and dg.log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'WKSP_USERS_VALUE'
,p_items_label_column_name=>'WKSP_USERS_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(17879395014529943)
,p_chart_id=>wwv_flow_imp.id(17879037694529940)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(17879449743529944)
,p_chart_id=>wwv_flow_imp.id(17879037694529940)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(17879502458529945)
,p_chart_id=>wwv_flow_imp.id(17879037694529940)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'start'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'on'
,p_splitter_position=>.65
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(19095695410011749)
,p_name=>'Workspace Schemas'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>80
,p_region_css_classes=>'a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with wksp_schemas_stats as (',
'    select count(case',
'                     when a.created between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'')',
'                                    and trunc(sysdate) - 1/24/3600',
'                     then s.id',
'                 end) as wksp_schema_total_1x,',
'           count(s.id) as wksp_schema_total',
'       from wwv_flow_company_schemas s,',
'            sys.all_users a',
'      where a.username = s.schema (+)',
'        and s.security_group_id not in (0, 10, 11, 12)',
'        and a.created <= trunc(sysdate) - 1/24/3600 )     ',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label       ',
' from (',
'    select 1                                                              as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_WKSP_SCHEMAS'') as stats_category,',
'           null                                                           as label_class,',
'           nvl(wksp_schema_total, 0)                                      as total,',
'           case when nvl(wksp_schema_total_1x, 0) != 0',
'                then nvl(wksp_schema_total, 0) - nvl(wksp_schema_total_1x, 0)',
'                else 0',
'           end                                                            as delta',
'      from wksp_schemas_stats )'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No workspace schemas found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(19095695410011749)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19095743816011750)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19309414672170901)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19539689087219522)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19309749340170904)
,p_query_column_id=>4
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19309644090170903)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19309821414170905)
,p_query_column_id=>6
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21011676230759848)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17878219704529932)
,p_plug_name=>'Workspace Schemas'
,p_parent_plug_id=>wwv_flow_imp.id(19095695410011749)
,p_region_css_classes=>'apex-col--topBorder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>105
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(17878359425529933)
,p_region_id=>wwv_flow_imp.id(17878219704529932)
,p_chart_type=>'combo'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'top'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_no_data_found_message=>'No Workspace Schemas found.'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(17878557052529935)
,p_chart_id=>wwv_flow_imp.id(17878359425529933)
,p_seq=>10
,p_name=>'Total Schemas'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7) )',
'select sum(case when ws.provisioning_company_id not in (0, 10, 11, 12)',
'                 and u.created < dg.log_day + 1 then 1',
'                else 0',
'           end) as schema_value,',
'       dg.log_day as schema_label',
'  from wwv_flow_company_schemas s,',
'       wwv_flow_companies      ws,',
'       sys.all_users            u,',
'       day_gen                 dg',
' where s.security_group_id = ws.provisioning_company_id (+)',
'   and s.schema = u.username (+)',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'SCHEMA_VALUE'
,p_items_label_column_name=>'SCHEMA_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>3
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(17878408250529934)
,p_chart_id=>wwv_flow_imp.id(17878359425529933)
,p_seq=>20
,p_name=>'Schemas Created per Day'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7))      ',
'select sum(case when a.created >= dg.log_day and a.created < dg.log_day + 1 then 1',
'                else 0',
'           end) as schema_value,',
'       dg.log_day as schema_label',
'  from wwv_flow_company_schemas s,',
'       wwv_flow_companies       w,',
'       sys.all_users            a,',
'       day_gen                 dg',
' where s.security_group_id = w.provisioning_company_id (+)',
'   and s.schema = a.username (+)',
'   and w.provisioning_company_id not in (0, 10, 11, 12)',
'   and dg.log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'SCHEMA_VALUE'
,p_items_label_column_name=>'SCHEMA_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(17878622793529936)
,p_chart_id=>wwv_flow_imp.id(17878359425529933)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(17878751866529937)
,p_chart_id=>wwv_flow_imp.id(17878359425529933)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(17878835235529938)
,p_chart_id=>wwv_flow_imp.id(17878359425529933)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'start'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'on'
,p_splitter_position=>.65
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(19310056020170907)
,p_name=>'Applications'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>60
,p_region_css_classes=>'a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with app_stats as (',
'    select count(case',
'                     when f.created_on between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'')',
'                                       and trunc(sysdate) - 1/24/3600',
'                     then f.id',
'                 end) as app_total_1x,',
'           count(f.id) as app_total',
'       from wwv_flows f',
'      where f.security_group_id not in (0, 10, 11, 12)',
'        and f.id not between 4000 and 4999',
'        and f.created_on <= trunc(sysdate) - 1/24/3600 )     ',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label       ',
' from (',
'    select 1                                                                    as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_TOTAL_APPLICATIONS'') as stats_category,',
'           null                                                                 as label_class,',
'           nvl(app_total, 0)                                                  as total,',
'           case when nvl(app_total_1x, 0) != 0',
'                then nvl(app_total, 0) - nvl(app_total_1x, 0)',
'                else 0',
'           end                                                                  as delta',
'      from app_stats )'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No applications found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(19310056020170907)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19310173804170908)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19310213187170909)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19310396755170910)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19310514879170912)
,p_query_column_id=>4
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19310484714170911)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19310619406170913)
,p_query_column_id=>6
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21011478369759846)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19094206820011735)
,p_plug_name=>'Applications'
,p_parent_plug_id=>wwv_flow_imp.id(19310056020170907)
,p_region_css_classes=>'apex-col--topBorder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>105
,p_plug_new_grid_row=>false
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19094373891011736)
,p_region_id=>wwv_flow_imp.id(19094206820011735)
,p_chart_type=>'combo'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'top'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_no_data_found_message=>'No applications found.'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19351095215715505)
,p_chart_id=>wwv_flow_imp.id(19094373891011736)
,p_seq=>20
,p_name=>'Total Applications'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7) )',
'select sum(case when f.security_group_id not in (0, 10, 11, 12)',
'                 and f.id not between 4000 and 4999',
'                 and f.created_on < dg.log_day + 1 then 1',
'                else 0',
'           end) as app_value,',
'       dg.log_day as app_label',
'  from wwv_flows f,',
'       day_gen   dg',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>3
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19351124857715506)
,p_chart_id=>wwv_flow_imp.id(19094373891011736)
,p_seq=>30
,p_name=>'Applications Created per Day'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7) )',
'select sum(case when f.created_on >= dg.log_day and f.created_on < dg.log_day + 1 then 1 else 0 end) as app_value,',
'       dg.log_day as app_label',
'  from wwv_flows   f,',
'       day_gen    dg',
' where f.security_group_id not in (0, 10, 11, 12)',
'   and f.id not between 4000 and 4999',
'   and dg.log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19094513642011738)
,p_chart_id=>wwv_flow_imp.id(19094373891011736)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19094646802011739)
,p_chart_id=>wwv_flow_imp.id(19094373891011736)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19094780305011740)
,p_chart_id=>wwv_flow_imp.id(19094373891011736)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'start'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'on'
,p_splitter_position=>.65
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(19311258649170919)
,p_name=>'User Scheduler Jobs'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>90
,p_region_css_classes=>'a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with jobs_stats as (           ',
'    select count(distinct case',
'                              when d.actual_start_date between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'')',
'                                                       and trunc(sysdate) - 1/24/3600',
'                              then d.job_name',
'                          end) as jobs_cnt_1x,',
'           count(distinct d.job_name) as jobs_cnt              ',
'      from sys.dba_scheduler_job_run_details d',
'     where d.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'       and d.owner not in (select username',
'                             from sys.dba_users',
'                            where oracle_maintained = ''Y'')',
'       and d.actual_start_date between trunc(sysdate) - :AI_MAX_REPORTING_PERIOD and trunc(sysdate) - 1/24/3600',
'    union all',
'    select count(distinct case',
'                              when al.start_timestamp between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'')',
'                                                      and trunc(sysdate) - 1/24/3600',
'                              then al.automation_id',
'                          end) as jobs_cnt_1x,    ',
'           count(distinct al.automation_id) as jobs_cnt',
'      from wwv_flow_automation_log al',
'     where al.start_timestamp <= trunc(sysdate) - 1/24/3600',
'    union all',
'    select count(distinct case',
'                              when sl.start_timestamp between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'')',
'                                                      and trunc(sysdate) - 1/24/3600',
'                              then sl.web_src_module_id',
'                          end) as jobs_cnt_1x,    ',
'           count(distinct sl.web_src_module_id) as jobs_cnt',
'      from wwv_flow_websource_sync_log sl',
'     where sl.start_timestamp <= trunc(sysdate) - 1/24/3600 ),',
'aggr_jobs as (',
'    select sum(jobs_cnt_1x) as jobs_cnt_1x,',
'           sum(jobs_cnt) as jobs_cnt',
'      from jobs_stats)   ',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label       ',
' from (',
'    select 1                                                           as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_USER_JOBS'') as stats_category,',
'           null                                                        as label_class,',
'           nvl(jobs_cnt, 0)                                            as total,',
'           case when nvl(jobs_cnt_1x, 0) != 0',
'                then nvl(jobs_cnt, 0) - nvl(jobs_cnt_1x, 0)',
'                else 0',
'           end                                                         as delta',
'      from aggr_jobs )'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No user scheduled jobs found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(19311258649170919)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19311392397170920)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19311446392170921)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19539742742219523)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19311714524170924)
,p_query_column_id=>4
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19311657145170923)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19311830632170925)
,p_query_column_id=>6
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21011753328759849)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19312029953170927)
,p_plug_name=>'User Scheduler Jobs'
,p_parent_plug_id=>wwv_flow_imp.id(19311258649170919)
,p_region_css_classes=>'apex-col--topBorder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>115
,p_plug_new_grid_row=>false
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19312115877170928)
,p_region_id=>wwv_flow_imp.id(19312029953170927)
,p_chart_type=>'combo'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'top'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_no_data_found_message=>'No User Scheduled Jobs found.'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19541185221219537)
,p_chart_id=>wwv_flow_imp.id(19312115877170928)
,p_seq=>20
,p_name=>'User Scheduler Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'      from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7)),',
'jobs_stats as (',
'    select sum(sm.jobs_run_cnt) as total_jobs_run,',
'           trunc(sm.log_day)    as job_date',
'      from wwv_schema_aggr_metrics  sm       ',
'     where sm.schema not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'       and sm.log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by sm.log_day',
'    union all',
'    select count(distinct al.automation_id) as total_jobs_run,',
'           trunc(al.start_timestamp) as job_date',
'      from wwv_flow_automation_log al',
'     where al.start_timestamp between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by trunc(al.start_timestamp)',
'    union all',
'    select count(distinct sl.web_src_module_id) as total_jobs_run,',
'           trunc(sl.start_timestamp) as job_date',
'      from wwv_flow_websource_sync_log sl',
'     where sl.start_timestamp between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by trunc(sl.start_timestamp))    ',
'select nvl(sum(js.total_jobs_run), 0) as jobs_value,',
'       dg.log_day as jobs_label',
'  from jobs_stats js,',
'       day_gen    dg',
' where dg.log_day = js.job_date (+)',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'JOBS_VALUE'
,p_items_label_column_name=>'JOBS_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>3
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19541939207219545)
,p_chart_id=>wwv_flow_imp.id(19312115877170928)
,p_seq=>30
,p_name=>'Successful Scheduler Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'      from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7)),',
'jobs_stats as (',
'    select sum(m.jobs_run_cnt - m.jobs_failed_logs_cnt) as successful_jobs_cnt,',
'           m.log_day  as job_date',
'      from wwv_schema_aggr_metrics m     ',
'     where m.schema not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'       and m.log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by m.log_day',
'    union all',
'    select count(distinct al.automation_id) as total_jobs_run,',
'           trunc(al.start_timestamp) as job_date',
'      from wwv_flow_automation_log al',
'     where al.status = ''SUCCESS''',
'       and al.start_timestamp between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by trunc(al.start_timestamp)',
'    union all',
'    select count(distinct sl.web_src_module_id) as total_jobs_run,',
'           trunc(sl.start_timestamp) as job_date',
'      from wwv_flow_websource_sync_log sl',
'     where sl.status = ''SUCCESS''',
'       and sl.start_timestamp between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by trunc(sl.start_timestamp))    ',
'select nvl(sum(js.successful_jobs_cnt), 0) as jobs_value,',
'       dg.log_day as jobs_label',
'  from jobs_stats js,',
'       day_gen    dg',
' where dg.log_day = js.job_date (+)',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'JOBS_VALUE'
,p_items_label_column_name=>'JOBS_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19541272640219538)
,p_chart_id=>wwv_flow_imp.id(19312115877170928)
,p_seq=>40
,p_name=>'Failed Scheduler Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'      from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7)),',
'jobs_stats as (',
'    select sum(m.jobs_failed_logs_cnt) as failed_jobs_cnt,',
'           m.log_day as job_date',
'      from wwv_schema_aggr_metrics  m      ',
'     where m.schema not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'       and m.log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by m.log_day',
'    union all',
'    select count(distinct al.automation_id) as total_jobs_run,',
'           trunc(al.start_timestamp) as job_date',
'      from wwv_flow_automation_log al',
'     where al.status in (''NO_ACTION'', ''INCOMPLETE'', ''FAILURE'', ''ABORTED'')',
'       and al.start_timestamp between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by trunc(al.start_timestamp)',
'    union all',
'    select count(distinct sl.web_src_module_id) as total_jobs_run,',
'           trunc(sl.start_timestamp) as job_date',
'      from wwv_flow_websource_sync_log sl',
'     where sl.status in (''INCOMPLETE'', ''FAILURE'', ''ABORTED'')',
'       and sl.start_timestamp between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by trunc(sl.start_timestamp))    ',
'select nvl(sum(js.failed_jobs_cnt), 0) as jobs_value,',
'       dg.log_day as jobs_label',
'  from jobs_stats js,',
'       day_gen    dg',
' where dg.log_day = js.job_date (+)',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'JOBS_VALUE'
,p_items_label_column_name=>'JOBS_LABEL'
,p_color=>'#e77076'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19312334556170930)
,p_chart_id=>wwv_flow_imp.id(19312115877170928)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19312448286170931)
,p_chart_id=>wwv_flow_imp.id(19312115877170928)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19312586278170932)
,p_chart_id=>wwv_flow_imp.id(19312115877170928)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'start'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'on'
,p_splitter_position=>.65
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(19312954346170936)
,p_name=>'System Scheduler Jobs'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>100
,p_region_css_classes=>'a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with instance_jobs as (',
'    select count(distinct case when d.actual_start_date between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'')',
'                                                        and trunc(sysdate) - 1/24/3600',
'                                    then job_name end) as jobs_stats_1x,',
'           count(distinct job_name) as jobs_stats',
'    from sys.dba_scheduler_job_run_details d',
'   where d.owner in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'     and d.status in (''SUCCEEDED'', ''FAILED'')',
'     and (d.job_name not like ''APEX$PROCESS_EXEC_%''',
'         and d.job_name not like ''APEX$AUTOMATION_%''',
'         and d.job_name not like ''APEX$SYNC_REST_SOURCE_%''',
'         and d.job_name not like ''TASK$EXP$%''',
'         and d.job_name not like ''TASK$EXPIRE_%''',
'         and d.job_name not like ''ORACLE_APEX_DTLD$%'')',
'     and d.actual_start_date between trunc(sysdate) - :AI_MAX_REPORTING_PERIOD',
'                             and  trunc(sysdate) - 1/24/3600)     ',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label       ',
' from (',
'    select 1                                                               as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_INSTANCE_JOBS'') as stats_category,',
'           null                                                            as label_class,',
'           nvl(jobs_stats, 0)                                              as total,',
'           case when nvl(jobs_stats_1x, 0) != 0',
'                then nvl(jobs_stats, 0) - nvl(jobs_stats_1x, 0)',
'                else 0',
'           end                                                             as delta',
'      from instance_jobs )'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Instance Scheduled Jobs found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19313047688170937)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19313197690170938)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19539834807219524)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19313300507170940)
,p_query_column_id=>4
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19313274614170939)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19313457446170941)
,p_query_column_id=>6
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21011824267759850)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19541308930219539)
,p_plug_name=>'System Scheduler Jobs'
,p_parent_plug_id=>wwv_flow_imp.id(19312954346170936)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>135
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19541420057219540)
,p_region_id=>wwv_flow_imp.id(19541308930219539)
,p_chart_type=>'combo'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'top'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19541556319219541)
,p_chart_id=>wwv_flow_imp.id(19541420057219540)
,p_seq=>10
,p_name=>'Total System Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'      from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7)),',
'instance_jobs as (',
'    select count(distinct d.job_name) as scheduled_jobs_value,',
'           trunc(d.actual_start_date) as scheduled_jobs_label',
'      from sys.dba_scheduler_job_run_details d',
'     where d.owner in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'       and d.status in (''SUCCEEDED'',''FAILED'')',
'       and (d.job_name not like ''APEX$PROCESS_EXEC_%''',
'           and d.job_name not like ''APEX$AUTOMATION_%''',
'           and d.job_name not like ''APEX$SYNC_REST_SOURCE_%''',
'           and d.job_name not like ''TASK$EXP$%''',
'           and d.job_name not like ''TASK$EXPIRE_%''',
'           and d.job_name not like ''ORACLE_APEX_DTLD$%'')',
'       and d.actual_start_date between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'    group by trunc(d.actual_start_date))',
'select nvl(ij.scheduled_jobs_value, 0) as scheduled_jobs_value,',
'       dg.log_day',
'  from instance_jobs ij,',
'       day_gen       dg',
' where dg.log_day = ij.scheduled_jobs_label (+)',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'SCHEDULED_JOBS_VALUE'
,p_items_label_column_name=>'LOG_DAY'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>3
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19542086086219546)
,p_chart_id=>wwv_flow_imp.id(19541420057219540)
,p_seq=>20
,p_name=>'Successful System Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'      from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7)),',
'instance_jobs as (',
'select count(distinct d.job_name) as scheduled_jobs_value,',
'       trunc(d.actual_start_date) as scheduled_jobs_label',
'  from sys.dba_scheduler_job_run_details d',
' where d.owner in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'   and d.status = ''SUCCEEDED''',
'   and (d.job_name not like ''APEX$PROCESS_EXEC_%''',
'       and d.job_name not like ''APEX$AUTOMATION_%''',
'       and d.job_name not like ''APEX$SYNC_REST_SOURCE_%''',
'       and d.job_name not like ''TASK$EXP$%''',
'       and d.job_name not like ''TASK$EXPIRE_%''',
'       and d.job_name not like ''ORACLE_APEX_DTLD$%'')',
'   and d.actual_start_date between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'group by trunc(d.actual_start_date))',
'select nvl(ij.scheduled_jobs_value, 0) as scheduled_jobs_value,',
'       dg.log_day',
'  from instance_jobs ij,',
'       day_gen       dg',
' where dg.log_day = ij.scheduled_jobs_label (+)',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'SCHEDULED_JOBS_VALUE'
,p_items_label_column_name=>'LOG_DAY'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19541862702219544)
,p_chart_id=>wwv_flow_imp.id(19541420057219540)
,p_seq=>30
,p_name=>'Failed System Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'      from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7)),',
'instance_jobs as (',
'select count(distinct d.job_name) as scheduled_jobs_value,',
'       trunc(d.actual_start_date) as scheduled_jobs_label',
'  from sys.dba_scheduler_job_run_details d',
' where d.owner in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'   and d.status = ''FAILED''',
'   and (d.job_name not like ''APEX$PROCESS_EXEC_%''',
'       and d.job_name not like ''APEX$AUTOMATION_%''',
'       and d.job_name not like ''APEX$SYNC_REST_SOURCE_%''',
'       and d.job_name not like ''TASK$EXP$%''',
'       and d.job_name not like ''TASK$EXPIRE_%''',
'       and d.job_name not like ''ORACLE_APEX_DTLD$%'')',
'   and d.actual_start_date between to_timestamp(:P1000_START_INTERVAL, ''&DATE_TIME_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'group by trunc(d.actual_start_date))',
'select nvl(ij.scheduled_jobs_value, 0) as scheduled_jobs_value,',
'       dg.log_day',
'  from instance_jobs ij,',
'       day_gen       dg',
' where dg.log_day = ij.scheduled_jobs_label (+)',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'SCHEDULED_JOBS_VALUE'
,p_items_label_column_name=>'LOG_DAY'
,p_color=>'#e77076'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19541668952219542)
,p_chart_id=>wwv_flow_imp.id(19541420057219540)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19541744174219543)
,p_chart_id=>wwv_flow_imp.id(19541420057219540)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19977936180203405)
,p_chart_id=>wwv_flow_imp.id(19541420057219540)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'start'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'on'
,p_splitter_position=>.65
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(19351554307715510)
,p_name=>'Database Links'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>110
,p_region_css_classes=>'a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_grid_column_span=>4
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with dblinks_stats as (',
'    select sum(case',
'                   when db.created between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'')',
'                                   and trunc(sysdate) - 1/24/3600',
'                   then 1',
'                   else 0',
'               end) as db_links_cnt_1x,',
'           count(*) as db_links_cnt    ',
'      from sys.dba_db_links db',
'     where db.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'       and db.owner not in (select username',
'                              from sys.dba_users',
'                             where oracle_maintained = ''Y'')     ',
'       and db.created <= trunc(sysdate) - 1/24/3600 )     ',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label       ',
' from (',
'    select 1                                                         as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_DBLINKS'') as stats_category,',
'           null                                                      as label_class,',
'           nvl(db_links_cnt, 0)                                      as total,',
'           case when nvl(db_links_cnt_1x, 0) != 0',
'                then nvl(db_links_cnt, 0) - nvl(db_links_cnt_1x, 0)',
'                else 0',
'           end                                                       as delta',
'      from dblinks_stats )'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Database Links found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(19351554307715510)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19351640151715511)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19351793620715512)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19539903469219525)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19351983889715514)
,p_query_column_id=>4
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19351823793715513)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19352071061715515)
,p_query_column_id=>6
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23137982168760001)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19352233812715517)
,p_plug_name=>'Database Links'
,p_parent_plug_id=>wwv_flow_imp.id(19351554307715510)
,p_region_css_classes=>'apex-col--topBorder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>135
,p_plug_new_grid_row=>false
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19352344280715518)
,p_region_id=>wwv_flow_imp.id(19352233812715517)
,p_chart_type=>'combo'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'top'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_no_data_found_message=>'No Database Links found.'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19978127007203407)
,p_chart_id=>wwv_flow_imp.id(19352344280715518)
,p_seq=>10
,p_name=>'Total Database Links'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7))',
'select sum(case when db.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'                 and db.owner not in (select username',
'                                        from sys.dba_users',
'                                       where oracle_maintained = ''Y'')',
'                 and db.created < dg.log_day + 1 then 1',
'                else 0',
'           end) as db_links_value,',
'       dg.log_day as db_links_label',
'  from sys.dba_db_links db,',
'       day_gen          dg',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'DB_LINKS_VALUE'
,p_items_label_column_name=>'DB_LINKS_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>3
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19978085827203406)
,p_chart_id=>wwv_flow_imp.id(19352344280715518)
,p_seq=>20
,p_name=>'Database Links Created per Day'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7))',
'    select sum(case when db.created >= dg.log_day and db.created < dg.log_day + 1 then 1',
'                    else 0',
'               end) as db_links_value,',
'           dg.log_day as db_links_label',
'      from sys.dba_db_links db,',
'           day_gen          dg',
'     where db.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'       and db.owner not in (select username',
'                              from sys.dba_users',
'                             where oracle_maintained = ''Y'')',
'       and dg.log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'DB_LINKS_VALUE'
,p_items_label_column_name=>'DB_LINKS_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19352691900715521)
,p_chart_id=>wwv_flow_imp.id(19352344280715518)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19352734266715522)
,p_chart_id=>wwv_flow_imp.id(19352344280715518)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19352870963715523)
,p_chart_id=>wwv_flow_imp.id(19352344280715518)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'start'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'on'
,p_splitter_position=>.65
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(19353120211715526)
,p_name=>'Workspaces with &AI_WORKSPACE_FREE_SPACE_LIMIT.% Free Space Remaining'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>120
,p_region_css_classes=>'a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with workspace_schemas_stats_1x as (',
'    select log_day,',
'           security_group_id,',
'           sum(data_file_size) as total_space,',
'           sum(free_space) as free_space',
'      from wwv_schema_aggr_metrics  m,',
'           wwv_flow_company_schemas s',
'     where s.schema = m.schema ',
'       and s.security_group_id not in (0, 10, 11, 12)',
'       and log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by log_day,',
'           security_group_id ),',
'workspace_schemas_stats as (',
'    select log_day,',
'           security_group_id,',
'           sum(data_file_size) as total_space,',
'           sum(free_space) as free_space',
'      from wwv_schema_aggr_metrics  m,',
'           wwv_flow_company_schemas s',
'     where s.schema (+) = m.schema',
'       and s.security_group_id not in (0, 10, 11, 12)',
'       and log_day <= trunc(sysdate) - 1/24/3600',
'  group by log_day,',
'           security_group_id ),',
'workspace_schemas as (',
'    select count(distinct security_group_id) as wksp_cnt_free_space_1x,',
'           0 as wksp_cnt_free_space',
'      from workspace_schemas_stats_1x',
'     where (free_space / nullif(total_space, 0)) * 100 < :AI_WORKSPACE_FREE_SPACE_LIMIT',
'     union all',
'    select 0 as wksp_cnt_free_space_1x,',
'           count(distinct security_group_id) as wksp_cnt_free_space',
'      from workspace_schemas_stats )     ',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label       ',
' from (',
'    select 1                                                                  as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_TOTAL_WORKSPACES'') as stats_category,',
'           null                                                               as label_class,',
'           nvl(sum(b.wksp_cnt_free_space), 0)                                 as total,',
'           case when nvl(sum(b.wksp_cnt_free_space_1x), 0) != 0',
'                then nvl(sum(b.wksp_cnt_free_space), 0) - nvl(sum(b.wksp_cnt_free_space_1x), 0)',
'                else 0',
'           end                                                                as delta',
'      from workspace_schemas b )',
'',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Workspace exceeding the free space limit found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(19353120211715526)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19353233298715527)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19353373327715528)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19540030930219526)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19353501722715530)
,p_query_column_id=>4
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19353459384715529)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19353601348715531)
,p_query_column_id=>6
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23138065158760002)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19540252026219528)
,p_plug_name=>'Workspace Free Space'
,p_parent_plug_id=>wwv_flow_imp.id(19353120211715526)
,p_region_css_classes=>'apex-col--topBorder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>145
,p_plug_new_grid_row=>false
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19540394046219529)
,p_region_id=>wwv_flow_imp.id(19540252026219528)
,p_chart_type=>'combo'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'top'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_no_data_found_message=>'No Workspaces found under the Free Space limit.'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19540859744219534)
,p_chart_id=>wwv_flow_imp.id(19540394046219529)
,p_seq=>10
,p_name=>'Total Workspaces'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7) )',
'select sum(case when ws.provisioning_company_id not in (0, 10, 11, 12)',
'                 and created_on < dg.log_day + 1 then 1',
'                else 0',
'           end) as wksp_value,',
'       dg.log_day as wksp_label',
'  from wwv_flow_companies      ws,',
'       day_gen                 dg',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'WKSP_VALUE'
,p_items_label_column_name=>'WKSP_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>3
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19540991567219535)
,p_chart_id=>wwv_flow_imp.id(19540394046219529)
,p_seq=>20
,p_name=>'Workspaces with &AI_WORKSPACE_FREE_SPACE_LIMIT.% Free Space Remaining'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7) ),',
'workspace_space as (',
'    select distinct ws.provisioning_company_id as workspace_id,',
'           sum(data_file_size) as total,',
'           sum(free_space) as free_space,',
'           log_day',
'      from wwv_schema_aggr_metrics  m,',
'           wwv_flow_company_schemas s,',
'           wwv_flow_companies      ws         ',
'     where ws.provisioning_company_id = s.security_group_id',
'       and s.schema = m.schema',
'       and s.security_group_id not in (0, 10, 11, 12)',
'       and m.log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600',
'  group by ws.provisioning_company_id,',
'           m.log_day',
'    having sum(free_space) / nullif(sum(data_file_size), 0) * 100 <  :AI_WORKSPACE_FREE_SPACE_LIMIT)',
'select count(w.workspace_id) as wksp_free_space_value,',
'       dg.log_day as wksp_free_space_label',
'  from workspace_space w,',
'       day_gen        dg',
' where dg.log_day = w.log_day (+)',
'group by dg.log_day',
'order by 2   '))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'WKSP_FREE_SPACE_VALUE'
,p_items_label_column_name=>'WKSP_FREE_SPACE_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19540547042219531)
,p_chart_id=>wwv_flow_imp.id(19540394046219529)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19540652370219532)
,p_chart_id=>wwv_flow_imp.id(19540394046219529)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19540741783219533)
,p_chart_id=>wwv_flow_imp.id(19540394046219529)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'start'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'on'
,p_splitter_position=>.65
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20494060240535522)
,p_plug_name=>'Metrics Details'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The charts display the totals and the trend over the default reporting period.</p>',
'<p>Click the right arrow to see detailed reports.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32612267200807920)
,p_plug_name=>'Top Activity'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(12200122728308114)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37318856068645661)
,p_name=>'Workspaces'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>50
,p_region_css_classes=>'a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with wksp_stats as (',
'    select count(case',
'                    when ws.created_on between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'')',
'                                       and trunc(sysdate) - 1/24/3600',
'                    then ws.id',
'                 end) as wksp_total_1x,',
'           count(ws.id) as wksp_total        ',
'      from wwv_flow_companies ws',
'     where ws.provisioning_company_id not in (0, 10, 11, 12)',
'       and ws.created_on <= trunc(sysdate) - 1/24/3600 )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                  as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_TOTAL_WORKSPACES'') as stats_category,',
'           null                                                               as label_class,',
'           nvl(wksp_total, 0)                                                 as total,',
'           case when nvl(wksp_total_1x, 0) != 0',
'                then nvl(wksp_total, 0) - nvl(wksp_total_1x, 0)',
'                else 0',
'           end                                                                as delta                                                                ',
'      from wksp_stats )'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No workspaces found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(37318856068645661)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19301513614967766)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19301943709967766)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19539539623219521)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19302722982967768)
,p_query_column_id=>4
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19303125793967768)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19303505685967769)
,p_query_column_id=>6
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21011322483759845)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37303344096253973)
,p_plug_name=>'Workspaces'
,p_parent_plug_id=>wwv_flow_imp.id(37318856068645661)
,p_region_css_classes=>'apex-col--topBorder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>70
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19285394374576073)
,p_region_id=>wwv_flow_imp.id(37303344096253973)
,p_chart_type=>'combo'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'top'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_no_data_found_message=>'No Workspaces found.'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19350628609715501)
,p_chart_id=>wwv_flow_imp.id(19285394374576073)
,p_seq=>10
,p_name=>'Total Workspaces'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7) )',
'select sum(case when ws.provisioning_company_id not in (0, 10, 11, 12)',
'                 and created_on < dg.log_day + 1 then 1',
'                else 0',
'           end) as wksp_value,',
'       dg.log_day as wksp_label',
'  from wwv_flow_companies ws,',
'       day_gen            dg',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'WKSP_VALUE'
,p_items_label_column_name=>'WKSP_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>3
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19287624610576077)
,p_chart_id=>wwv_flow_imp.id(19285394374576073)
,p_seq=>20
,p_name=>'Workspaces Created per Day'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:AI_DEFAULT_REPORTING_PERIOD, 7))      ',
'select sum(case when ws.created_on >= dg.log_day and ws.created_on < dg.log_day + 1 then 1',
'                else 0',
'           end) as wksp_value,',
'       dg.log_day as wksp_label',
'  from wwv_flow_companies ws,',
'       day_gen            dg',
' where ws.provisioning_company_id not in (0, 10, 11, 12)',
'   and dg.log_day between to_date(:P1000_START_INTERVAL, ''&DATE_FORMAT.'') and trunc(sysdate) - 1/24/3600     ',
'group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1000_START_INTERVAL'
,p_series_type=>'lineWithArea'
,p_items_value_column_name=>'WKSP_VALUE'
,p_items_label_column_name=>'WKSP_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>2
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19285801657576075)
,p_chart_id=>wwv_flow_imp.id(19285394374576073)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19286488289576075)
,p_chart_id=>wwv_flow_imp.id(19285394374576073)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19287037544576076)
,p_chart_id=>wwv_flow_imp.id(19285394374576073)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'start'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'on'
,p_splitter_position=>.65
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188060306511788092)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Administrator Digest dashboard provides an overview of the key instance activity',
'metrics and how these metrics change over time. Review these metrics periodically to identify',
'performance anomalies.</p>',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19310837658170915)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(37318856068645661)
,p_button_name=>'WKSP_VIEW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Workspaces'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.:1005::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19310950489170916)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(19094863632011741)
,p_button_name=>'WKSP_USERS_VIEW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Users'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1006:&SESSION.::&DEBUG.:1006::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19311013439170917)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(19095695410011749)
,p_button_name=>'WKSP_SCHEMAS_VIEW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Schemas'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:1004::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19311173028170918)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(19310056020170907)
,p_button_name=>'APPS_VIEW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Applications'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1007:&SESSION.::&DEBUG.:1007::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19312612918170933)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(19311258649170919)
,p_button_name=>'USER_JOBS_VIEW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Jobs'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1012:&SESSION.::&DEBUG.:1012::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19352996866715524)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_imp.id(19312954346170936)
,p_button_name=>'INSTANCE_JOBS_VIEW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Instance Jobs'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1027:&SESSION.::&DEBUG.:1027::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19353085746715525)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_imp.id(19351554307715510)
,p_button_name=>'DB_LINKS_VIEW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Database Links'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1014:&SESSION.::&DEBUG.:1014::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19353874883715533)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_imp.id(19353120211715526)
,p_button_name=>'WKSP_FREE_VIEW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'View Workspaces with  &AI_WORKSPACE_FREE_SPACE_LIMIT.% Free Space Remaining'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1015:&SESSION.::&DEBUG.:1015::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21007759050759809)
,p_name=>'P1000_START_INTERVAL'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(15340150077841401)
,p_computation_sequence=>10
,p_computation_item=>'P1000_START_INTERVAL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'to_char(trunc(sysdate) - wwv_flow_platform.get_preference(',
'                            p_preference_name => ''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD''), ''&DATE_FORMAT.'') as start_date'))
);
end;
/
prompt --application/pages/page_01001
begin
wwv_flow_imp_page.create_page(
 p_id=>1001
,p_name=>'Workspace Metrics'
,p_alias=>'WORKSPACE-METRICS'
,p_step_title=>'Workspace Metrics'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22651323523307891)
,p_plug_name=>'Workspace Activity Metrics'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select log_day,',
'       workspace_id,',
'       workspace_name,',
'       admin_user_accounts_cnt,',
'       dev_user_accounts_cnt,',
'       end_user_accounts_cnt,',
'       locked_user_accounts,',
'       distinct_users_cnt,',
'       page_events_cnt,',
'       daily_max_active_pages,',
'       login_cnt,',
'       failed_logins_cnt,',
'       created_apps_cnt,',
'       removed_apps_cnt,',
'       accessed_apps_cnt,',
'       errors_cnt,',
'       emails_sent_cnt,',
'       distinct_sessions_cnt,',
'       distinct_ip_addresses_cnt,',
'       web_service_req_cnt,',
'       web_service_req_limit_reached,',
'       render_time_10pct_sec,',
'       render_time_avg_sec,',
'       render_time_median_sec,',
'       render_time_90pct_sec,',
'       render_time_max_sec,',
'       workspace_size as workspace_size_mb,',
'       case when workspace_size < 100 then ''LT100''',
'            when workspace_size between 100 and 500 then ''100-500''',
'            when workspace_size between 500 and 1000 then ''500-1000''',
'            when workspace_size between 1000 and 5000 then ''1000-5000''',
'            when workspace_size between 5000 and 10000 then ''5000-10000''',
'            else ''GT10000''',
'       end as workspace_size',
'  from wwv_workspace_aggr_metrics wm'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Workspace Activity Metrics'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(22652082486307899)
,p_no_data_found_message=>'No Workspace Metrics found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>22652082486307899
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9048527637597901)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9021533074106902)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'AA'
,p_column_label=>'Workspace Name'
,p_column_link=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:1030:P1030_WORKSPACE_ID:#WORKSPACE_ID#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9021673127106903)
,p_db_column_name=>'ADMIN_USER_ACCOUNTS_CNT'
,p_display_order=>30
,p_column_identifier=>'AB'
,p_column_label=>'Admin Accounts'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9021789646106904)
,p_db_column_name=>'DEV_USER_ACCOUNTS_CNT'
,p_display_order=>40
,p_column_identifier=>'AC'
,p_column_label=>'Developer Accounts'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9021890678106905)
,p_db_column_name=>'END_USER_ACCOUNTS_CNT'
,p_display_order=>50
,p_column_identifier=>'AD'
,p_column_label=>'End User Accounts'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9021950901106906)
,p_db_column_name=>'LOCKED_USER_ACCOUNTS'
,p_display_order=>60
,p_column_identifier=>'AE'
,p_column_label=>'Locked User Accounts'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022047935106907)
,p_db_column_name=>'DISTINCT_USERS_CNT'
,p_display_order=>70
,p_column_identifier=>'AF'
,p_column_label=>'Distinct Users'
,p_column_link=>'f?p=&APP_ID.:1010:&SESSION.::&DEBUG.:1010:P1010_LOG_DAY,P1010_WORKSPACE_ID:#LOG_DAY#,#WORKSPACE_ID#'
,p_column_linktext=>'#DISTINCT_USERS_CNT#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022151583106908)
,p_db_column_name=>'PAGE_EVENTS_CNT'
,p_display_order=>80
,p_column_identifier=>'AG'
,p_column_label=>'Page Events'
,p_column_link=>'f?p=&APP_ID.:1024:&SESSION.::&DEBUG.:1024:P1024_LOG_DAY,P1024_WORKSPACE_ID:#LOG_DAY#,#WORKSPACE_ID#'
,p_column_linktext=>'#PAGE_EVENTS_CNT#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022257393106909)
,p_db_column_name=>'DAILY_MAX_ACTIVE_PAGES'
,p_display_order=>90
,p_column_identifier=>'AH'
,p_column_label=>'Daily Maximum Active Pages'
,p_column_link=>'f?p=&APP_ID.:1011:&SESSION.::&DEBUG.:1011:P1011_LOG_DAY,P1011_WORKSPACE_ID:#LOG_DAY#,#WORKSPACE_ID#'
,p_column_linktext=>'#DAILY_MAX_ACTIVE_PAGES#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022347514106910)
,p_db_column_name=>'LOGIN_CNT'
,p_display_order=>100
,p_column_identifier=>'AI'
,p_column_label=>'Login Attempts'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022493893106911)
,p_db_column_name=>'FAILED_LOGINS_CNT'
,p_display_order=>110
,p_column_identifier=>'AJ'
,p_column_label=>'Failed Logins'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022523974106912)
,p_db_column_name=>'CREATED_APPS_CNT'
,p_display_order=>120
,p_column_identifier=>'AK'
,p_column_label=>'Created Apps'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022611847106913)
,p_db_column_name=>'REMOVED_APPS_CNT'
,p_display_order=>130
,p_column_identifier=>'AL'
,p_column_label=>'Removed Apps'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022745496106914)
,p_db_column_name=>'ACCESSED_APPS_CNT'
,p_display_order=>140
,p_column_identifier=>'AM'
,p_column_label=>'Accessed Apps'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022879724106915)
,p_db_column_name=>'ERRORS_CNT'
,p_display_order=>150
,p_column_identifier=>'AN'
,p_column_label=>'Errors'
,p_column_link=>'f?p=&APP_ID.:1018:&SESSION.::&DEBUG.:1018:P1018_LOG_DAY,P1018_WORKSPACE_ID:#LOG_DAY#,#WORKSPACE_ID#'
,p_column_linktext=>'#ERRORS_CNT#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9022908453106916)
,p_db_column_name=>'EMAILS_SENT_CNT'
,p_display_order=>160
,p_column_identifier=>'AO'
,p_column_label=>'Emails Sent'
,p_column_link=>'f?p=&APP_ID.:1017:&SESSION.::&DEBUG.:1017:P1017_LOG_DAY,P1017_WORKSPACE_ID:#LOG_DAY#,#WORKSPACE_ID#'
,p_column_linktext=>'#EMAILS_SENT_CNT#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9023014357106917)
,p_db_column_name=>'DISTINCT_SESSIONS_CNT'
,p_display_order=>170
,p_column_identifier=>'AP'
,p_column_label=>'Distinct Sessions'
,p_column_link=>'f?p=&APP_ID.:1016:&SESSION.::&DEBUG.:1016:P1016_LOG_DAY,P1016_WORKSPACE_ID:#LOG_DAY#,#WORKSPACE_ID#'
,p_column_linktext=>'#DISTINCT_SESSIONS_CNT#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9023150529106918)
,p_db_column_name=>'DISTINCT_IP_ADDRESSES_CNT'
,p_display_order=>180
,p_column_identifier=>'AQ'
,p_column_label=>'Distinct IP Addresses'
,p_column_link=>'f?p=&APP_ID.:1019:&SESSION.::&DEBUG.:1019:P1019_LOG_DAY,P1019_WORKSPACE_ID:#LOG_DAY#,#WORKSPACE_ID#'
,p_column_linktext=>'#DISTINCT_IP_ADDRESSES_CNT#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9023279630106919)
,p_db_column_name=>'WEB_SERVICE_REQ_CNT'
,p_display_order=>190
,p_column_identifier=>'AR'
,p_column_label=>'Web Service Requests'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(143461067216545801)
,p_db_column_name=>'WEB_SERVICE_REQ_LIMIT_REACHED'
,p_display_order=>200
,p_column_identifier=>'BF'
,p_column_label=>'Web Service Requests Limit Reached'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if WEB_SERVICE_REQ_LIMIT_REACHED/}',
'<span aria-hidden="true" class="a-Icon icon-warning u-danger-text"></span> Yes',
'{else/}',
'No',
'{endif/}'))
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9023483299106921)
,p_db_column_name=>'RENDER_TIME_10PCT_SEC'
,p_display_order=>210
,p_column_identifier=>'AT'
,p_column_label=>'Render Time (10th Percentile)'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9023593370106922)
,p_db_column_name=>'RENDER_TIME_AVG_SEC'
,p_display_order=>220
,p_column_identifier=>'AU'
,p_column_label=>'Render Time (Average)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9023644008106923)
,p_db_column_name=>'RENDER_TIME_MEDIAN_SEC'
,p_display_order=>230
,p_column_identifier=>'AV'
,p_column_label=>'Render Time (Median)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9023730248106924)
,p_db_column_name=>'RENDER_TIME_90PCT_SEC'
,p_display_order=>240
,p_column_identifier=>'AW'
,p_column_label=>'Render Time (90th Percentile)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9023886058106925)
,p_db_column_name=>'RENDER_TIME_MAX_SEC'
,p_display_order=>250
,p_column_identifier=>'AX'
,p_column_label=>'Render Time (Maximum)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20494209553535524)
,p_db_column_name=>'WORKSPACE_SIZE_MB'
,p_display_order=>260
,p_column_identifier=>'BD'
,p_column_label=>'Workspace Size (MB)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20711530147431126)
,p_db_column_name=>'WORKSPACE_SIZE'
,p_display_order=>270
,p_column_identifier=>'BC'
,p_column_label=>'Workspace Size (Grouping)'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(20891720183467722)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21008625313759818)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>280
,p_column_identifier=>'BE'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(22855435372620068)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'138104'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'LOG_DAY:WORKSPACE_NAME:ADMIN_USER_ACCOUNTS_CNT:DEV_USER_ACCOUNTS_CNT:END_USER_ACCOUNTS_CNT:DISTINCT_USERS_CNT:PAGE_EVENTS_CNT:DAILY_MAX_ACTIVE_PAGES:LOGIN_CNT:CREATED_APPS_CNT:ACCESSED_APPS_CNT:ERRORS_CNT:EMAILS_SENT_CNT:DISTINCT_SESSIONS_CNT:DISTINC'
||'T_IP_ADDRESSES_CNT:WEB_SERVICE_REQ_CNT:WEB_SERVICE_REQ_LIMIT_REACHED:RENDER_TIME_AVG_SEC:RENDER_TIME_MEDIAN_SEC:RENDER_TIME_MAX_SEC:WORKSPACE_SIZE_MB:'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(53448868394057351)
,p_plug_name=>'Workspace Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20824651862610331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208894760332004571)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Workspace Metrics report includes the overall activity and daily aggregated event metrics at workspace level.</p>',
'<p>Render Time aggregated values are defined in seconds.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01002
begin
wwv_flow_imp_page.create_page(
 p_id=>1002
,p_name=>'Instance Metrics'
,p_alias=>'INSTANCE-METRICS'
,p_step_title=>'Instance Metrics'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13607735723710028)
,p_plug_name=>'Instance Metrics'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select log_day,',
'       created_workspaces_cnt,',
'       removed_workspaces_cnt,',
'       db_links_cnt,',
'       current_apex_version,',
'       current_db_version,',
'       database_errors_cnt,',
'       case when log_day <= trunc(sysdate) - 14',
'              or database_errors_cnt = 0 then ''u-hidden''',
'       end as has_link_class',
'  from wwv_instance_aggr_metrics'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Instance Metrics'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(13607823590710029)
,p_no_data_found_message=>'No Instance Metrics found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>13607823590710029
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13607964632710030)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13608035790710031)
,p_db_column_name=>'CREATED_WORKSPACES_CNT'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Created Workspaces'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13608192984710032)
,p_db_column_name=>'REMOVED_WORKSPACES_CNT'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Removed Workspaces'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13608338900710034)
,p_db_column_name=>'CURRENT_APEX_VERSION'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Current APEX Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13608488778710035)
,p_db_column_name=>'CURRENT_DB_VERSION'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Current Database Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5801184240845801)
,p_db_column_name=>'DB_LINKS_CNT'
,p_display_order=>70
,p_column_identifier=>'H'
,p_column_label=>'Database Links'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5801228614845802)
,p_db_column_name=>'DATABASE_ERRORS_CNT'
,p_display_order=>80
,p_column_identifier=>'I'
,p_column_label=>'Database Errors'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
,p_required_patch=>wwv_flow_imp.id(115385817770766958)
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17812751852992301)
,p_db_column_name=>'HAS_LINK_CLASS'
,p_display_order=>90
,p_column_identifier=>'J'
,p_column_label=>'Errors (Last 14 days)'
,p_column_link=>'f?p=&APP_ID.:1031:&SESSION.::&DEBUG.:1031:P1031_DATE:#LOG_DAY#'
,p_column_linktext=>'View Errors'
,p_column_link_attr=>'class="#HAS_LINK_CLASS#"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
,p_required_patch=>wwv_flow_imp.id(115385817770766958)
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(13815635205110239)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'138157'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:CREATED_WORKSPACES_CNT:REMOVED_WORKSPACES_CNT:DB_LINKS_CNT:DATABASE_ERRORS_CNT::HAS_LINK_CLASS'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17575805364551813)
,p_plug_name=>'Instance Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(17630360313346135)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204843930770497602)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Instance Metrics report includes the daily aggregated metrics for this &PRODUCT_NAME. instance.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01003
begin
wwv_flow_imp_page.create_page(
 p_id=>1003
,p_name=>'Schema Metrics'
,p_alias=>'SCHEMA-METRICS'
,p_step_title=>'Schema Metrics'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13606284281710013)
,p_plug_name=>'Schema Metrics'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with add_trend as (',
'select log_day,',
'       schema,',
'       data_file_cnt,',
'       data_file_size,',
'       free_space,',
'       used_space,       ',
'       jobs_run_cnt,',
'       jobs_elapsed_time_total_sec,',
'       jobs_failed_logs_cnt,',
'       job_elapsed_time_10pct_sec,',
'       job_elapsed_time_avg_sec,',
'       job_elapsed_time_median_sec,',
'       job_elapsed_time_90pct_sec,',
'       job_elapsed_time_max_sec,',
'       min_interval_time_sec,',
'       db_links_cnt--,',
'       --lag(used_space) over (partition by schema order by log_day) as prevday_used_space',
'  from wwv_schema_aggr_metrics )',
'  select log_day,',
'         schema,',
'         data_file_cnt,',
'         data_file_size / 1024 / 1024 / 1024 as data_file_size,',
'         free_space / 1024 / 1024 / 1024 as free_space,',
'         used_space / 1024 / 1024 / 1024 as used_space,       ',
'         jobs_run_cnt,',
'         jobs_elapsed_time_total_sec,',
'         jobs_failed_logs_cnt,',
'         job_elapsed_time_10pct_sec,',
'         job_elapsed_time_avg_sec,',
'         job_elapsed_time_median_sec,',
'         job_elapsed_time_90pct_sec,',
'         job_elapsed_time_max_sec,',
'         min_interval_time_sec,',
'         db_links_cnt--,',
'         --nvl((used_space - prevday_used_space) * 100 / prevday_used_space, 0) as trend_used_space',
'    from add_trend'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Schema Metrics'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(13607043244710021)
,p_no_data_found_message=>'No Schema Metrics found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>13607043244710021
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13607141666710022)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13607201109710023)
,p_db_column_name=>'SCHEMA'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13607404420710025)
,p_db_column_name=>'DATA_FILE_SIZE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Data File Size (GB)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13607572287710026)
,p_db_column_name=>'FREE_SPACE'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Free Space (GB)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13607613782710027)
,p_db_column_name=>'USED_SPACE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Used Space (GB)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23622157717140830)
,p_db_column_name=>'DATA_FILE_CNT'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Data File'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23622202779140831)
,p_db_column_name=>'JOBS_RUN_CNT'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Jobs Run'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23622600033140835)
,p_db_column_name=>'DB_LINKS_CNT'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'Database Links'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5801390913845803)
,p_db_column_name=>'JOBS_ELAPSED_TIME_TOTAL_SEC'
,p_display_order=>120
,p_column_identifier=>'S'
,p_column_label=>'Jobs Elapsed Time (Total)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5801434065845804)
,p_db_column_name=>'JOBS_FAILED_LOGS_CNT'
,p_display_order=>130
,p_column_identifier=>'T'
,p_column_label=>'Jobs Failures'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5801564312845805)
,p_db_column_name=>'JOB_ELAPSED_TIME_10PCT_SEC'
,p_display_order=>140
,p_column_identifier=>'U'
,p_column_label=>'Job Elapsed Time (10th Percentile)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5801665483845806)
,p_db_column_name=>'JOB_ELAPSED_TIME_AVG_SEC'
,p_display_order=>150
,p_column_identifier=>'V'
,p_column_label=>'Job Elapsed Time (Average)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5801741496845807)
,p_db_column_name=>'JOB_ELAPSED_TIME_MEDIAN_SEC'
,p_display_order=>160
,p_column_identifier=>'W'
,p_column_label=>'Job Elapsed Time (Median)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5801893637845808)
,p_db_column_name=>'JOB_ELAPSED_TIME_90PCT_SEC'
,p_display_order=>170
,p_column_identifier=>'X'
,p_column_label=>'Job Elapsed Time (90th Percentile)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5801969387845809)
,p_db_column_name=>'JOB_ELAPSED_TIME_MAX_SEC'
,p_display_order=>180
,p_column_identifier=>'Y'
,p_column_label=>'Job Elapsed Time (Maximum)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5802044473845810)
,p_db_column_name=>'MIN_INTERVAL_TIME_SEC'
,p_display_order=>190
,p_column_identifier=>'Z'
,p_column_label=>'Minimum Time Interval between Jobs'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(13810396131022190)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'138104'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:SCHEMA:DATA_FILE_CNT:DATA_FILE_SIZE:FREE_SPACE:USED_SPACE:DB_LINKS_CNT:JOBS_RUN_CNT:JOBS_FAILED_LOGS_CNT:JOBS_ELAPSED_TIME_TOTAL_SEC:JOB_ELAPSED_TIME_10PCT_SEC:JOB_ELAPSED_TIME_MEDIAN_SEC:JOB_ELAPSED_TIME_AVG_SEC:JOB_ELAPSED_TIME_90PCT_SEC:JO'
||'B_ELAPSED_TIME_MAX_SEC:MIN_INTERVAL_TIME_SEC:'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74315434727009187)
,p_plug_name=>'Schema Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20828148654638359)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229761057968955687)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Schema Metrics report includes the overall activity and daily aggregated event metrics at schema level.</p>',
'<p>The jobs aggregated values are defined in seconds.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01004
begin
wwv_flow_imp_page.create_page(
 p_id=>1004
,p_name=>'Workspace Schemas'
,p_alias=>'WORKSPACE-SCHEMAS'
,p_step_title=>'Workspace Schemas'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17866030805893631)
,p_plug_name=>'Schemas'
,p_icon_css_classes=>'icon-sc-list'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ws.provisioning_company_id                        as workspace_id,',
'       ws.short_name                                     as workspace_name,',
'       s.schema,',
'       case when au.username is not null',
'            then ''Y''',
'            else null',
'       end                                               as schema_exists,',
'       case when au.username is not null',
'            then wwv_flow_lang_dev.builder_message(''APEXDEV.PE.YES'')',
'            else wwv_flow_lang_dev.builder_message(''APEXDEV.PE.NO'')',
'       end                                               as schema_exists_message,',
'       case when s.schema = ws.first_schema_provisioned',
'            then ''Y''',
'            else null',
'       end                                               as first_schema_provisioned,',
'       case when s.schema = ws.first_schema_provisioned',
'            then wwv_flow_lang_dev.builder_message(''APEXDEV.PE.YES'')',
'            else wwv_flow_lang_dev.builder_message(''APEXDEV.PE.NO'')',
'       end                                               as first_schema_prov_message,',
'       au.created',
'  from wwv_flow_company_schemas s,',
'       wwv_flow_companies ws,',
'       sys.all_users au',
' where s.security_group_id = ws.provisioning_company_id',
'   and s.schema = au.username',
'   and s.security_group_id not in (0, 10, 11, 12)',
'   and au.created between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                  and trunc(sysdate) - 1/24/3600',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Schemas'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(17866104932893632)
,p_no_data_found_message=>'No Schemas found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>17866104932893632
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17866403624893635)
,p_db_column_name=>'SCHEMA'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17867349135893644)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>40
,p_column_identifier=>'F'
,p_column_label=>'Workspace Name'
,p_column_link=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:1030:P1030_WORKSPACE_ID:#WORKSPACE_ID#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17867481469893645)
,p_db_column_name=>'SCHEMA_EXISTS'
,p_display_order=>50
,p_column_identifier=>'G'
,p_column_label=>'Schema Exists'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if SCHEMA_EXISTS/}',
'    <span role="img" aria-label="#SCHEMA_EXISTS_MESSAGE#" class="a-Icon icon-check-circle-s u-success-text"></span>',
'{else/}<span role="img" aria-label="#SCHEMA_EXISTS_MESSAGE#" class="a-Icon icon-error u-danger-text"></span>',
'{endif/}'))
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17867549888893646)
,p_db_column_name=>'FIRST_SCHEMA_PROVISIONED'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>'First Schema Provisioned'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if FIRST_SCHEMA_PROVISIONED/}',
'    <span role="img" aria-label="#FIRST_SCHEMA_PROV_MESSAGE#" class="a-Icon icon-check-circle-s u-success-text"></span>',
'{else/}<span role="img" aria-label="#FIRST_SCHEMA_PROV_MESSAGE#" class="a-Icon icon-error u-danger-text"></span>',
'{endif/}'))
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17577333386551828)
,p_db_column_name=>'CREATED'
,p_display_order=>70
,p_column_identifier=>'I'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21009845601759830)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23138101247760003)
,p_db_column_name=>'SCHEMA_EXISTS_MESSAGE'
,p_display_order=>90
,p_column_identifier=>'K'
,p_column_label=>'Schema Exists Message'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23138254151760004)
,p_db_column_name=>'FIRST_SCHEMA_PROV_MESSAGE'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'First Schema Prov Message'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(18202158310823879)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'182022'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SCHEMA:WORKSPACE_NAME:SCHEMA_EXISTS:FIRST_SCHEMA_PROVISIONED:CREATED::WORKSPACE_ID:SCHEMA_EXISTS_MESSAGE:FIRST_SCHEMA_PROV_MESSAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74316008191011475)
,p_plug_name=>'Schema Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20828148654638359)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(381997512081812770)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Workspace Schemas report provides information on newly created schemas during the default reporting period.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01005
begin
wwv_flow_imp_page.create_page(
 p_id=>1005
,p_name=>'Active Workspaces'
,p_alias=>'ACTIVE-WORKSPACES'
,p_step_title=>'Active Workspaces'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17804372063705538)
,p_plug_name=>'Workspaces'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select h.workspace_id,',
'       h.workspace_name,',
'       count(distinct (case when h.application_id not between 4000 and 4999',
'                           then h.application_id',
'                       end))                 as apps_cnt,',
'       nvl(sum(h.page_events), 0)            as page_events_cnt,',
'       nvl(max(h.distinct_pages), 0)         as distinct_pages_cnt,',
'       nvl(max(h.distinct_users), 0)         as distinct_users_cnt,',
'       nvl(sum(h.distinct_sessions), 0)      as distinct_sessions_cnt,',
'       nvl(sum(h.workspace_login_events), 0) as wksp_login_events_cnt,       ',
'       nvl(sum(h.error_count), 0)            as errors_cnt',
'  from wwv_flow_log_history h ',
' where h.workspace_id not in (0, 10, 11, 12)',
'   and h.log_day between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                 and trunc(sysdate) - 1/24/3600                          ',
'group by h.workspace_id,',
'         h.workspace_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Workspaces'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(17804444956705539)
,p_no_data_found_message=>'No workspaces found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>17804444956705539
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17804722741705542)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Workspace Name'
,p_column_link=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:1030:P1030_WORKSPACE_ID:#WORKSPACE_ID#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17829790757759514)
,p_db_column_name=>'APPS_CNT'
,p_display_order=>220
,p_column_identifier=>'Y'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17829882443759515)
,p_db_column_name=>'PAGE_EVENTS_CNT'
,p_display_order=>230
,p_column_identifier=>'Z'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17829937579759516)
,p_db_column_name=>'DISTINCT_PAGES_CNT'
,p_display_order=>240
,p_column_identifier=>'AA'
,p_column_label=>'Maximum Distinct Pages'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17830046917759517)
,p_db_column_name=>'DISTINCT_USERS_CNT'
,p_display_order=>250
,p_column_identifier=>'AB'
,p_column_label=>'Maximum Daily Users'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17830119879759518)
,p_db_column_name=>'DISTINCT_SESSIONS_CNT'
,p_display_order=>260
,p_column_identifier=>'AC'
,p_column_label=>'Distinct Sessions'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17830280912759519)
,p_db_column_name=>'WKSP_LOGIN_EVENTS_CNT'
,p_display_order=>270
,p_column_identifier=>'AD'
,p_column_label=>'Workspace Login Events'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17577083251551825)
,p_db_column_name=>'ERRORS_CNT'
,p_display_order=>280
,p_column_identifier=>'AE'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21009407150759826)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>290
,p_column_identifier=>'AF'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(17841041612760021)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'178411'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:APPS_CNT:PAGE_EVENTS_CNT:DISTINCT_PAGES_CNT:DISTINCT_USERS_CNT:DISTINCT_SESSIONS_CNT:WKSP_LOGIN_EVENTS_CNT::ERRORS_CNT:WORKSPACE_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74287097768332594)
,p_plug_name=>'Workspace Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20824651862610331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229732664515278562)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Active Workspaces report includes the overall activity metrics per workspace during the default reporting period.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01006
begin
wwv_flow_imp_page.create_page(
 p_id=>1006
,p_name=>'Workspace Users'
,p_alias=>'WORKSPACE-USERS'
,p_step_title=>'Workspace Users'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17830378003759520)
,p_plug_name=>'Workspace Users'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ws.provisioning_company_id                      as workspace_id,',
'       ws.short_name                                   as workspace_name,',
'       wu."USER",',
'       wu."eMail"                                      as email_address,',
'       wu.dev_type                                     as account_type,',
'       wu.last_login,',
'       wu.expiration,',
'       wu.account_expiry,',
'       (select count(*)',
'          from wwv_flow_user_access_log_v l',
'         where upper(l.login_name) = upper(wu."USER")) as login_attempts,',
'       wu.failed_access_attempts,       ',
'       wu.allow_app_building,',
'       wu.allow_sql_workshop,',
'       wu.allow_team_devopment                         as allow_team_development,',
'       wu.creation_date,',
'       wu.created_by',
'  from wwv_flow_workspace_users wu,',
'       wwv_flow_companies ws',
' where ws.provisioning_company_id = wu.workspace_id',
'   and ws.provisioning_company_id not in (0, 10, 11, 12)',
'   and wu.creation_date between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                        and trunc(sysdate) - 1/24/3600'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Workspace Users'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(17864496998893615)
,p_no_data_found_message=>'No Workspace Users found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>17864496998893615
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17864569523893616)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Workspace Name'
,p_column_link=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:1030,RIR:P1030_WORKSPACE_ID:#WORKSPACE_ID#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17864615644893617)
,p_db_column_name=>'USER'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17577180200551826)
,p_db_column_name=>'EMAIL_ADDRESS'
,p_display_order=>30
,p_column_identifier=>'P'
,p_column_label=>'Email Address'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17865858473893629)
,p_db_column_name=>'ACCOUNT_TYPE'
,p_display_order=>40
,p_column_identifier=>'N'
,p_column_label=>'Account Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17864895905893619)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Last Login'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17864932007893620)
,p_db_column_name=>'EXPIRATION'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Expiration'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17865078866893621)
,p_db_column_name=>'ACCOUNT_EXPIRY'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Account Expiry'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18407647938273942)
,p_db_column_name=>'LOGIN_ATTEMPTS'
,p_display_order=>80
,p_column_identifier=>'O'
,p_column_label=>'Login Attempts'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17865139631893622)
,p_db_column_name=>'FAILED_ACCESS_ATTEMPTS'
,p_display_order=>90
,p_column_identifier=>'G'
,p_column_label=>'Failed Access Attempts'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17865302330893624)
,p_db_column_name=>'ALLOW_APP_BUILDING'
,p_display_order=>100
,p_column_identifier=>'I'
,p_column_label=>'Allow APP Building'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17865496886893625)
,p_db_column_name=>'ALLOW_SQL_WORKSHOP'
,p_display_order=>110
,p_column_identifier=>'J'
,p_column_label=>'Allow SQL Workshop'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17865501137893626)
,p_db_column_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_display_order=>120
,p_column_identifier=>'K'
,p_column_label=>'Allow Team Development'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17865627738893627)
,p_db_column_name=>'CREATION_DATE'
,p_display_order=>130
,p_column_identifier=>'L'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17865787310893628)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>140
,p_column_identifier=>'M'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21009323080759825)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>150
,p_column_identifier=>'Q'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(17901418196948205)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'179015'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:EMAIL_ADDRESS:ACCOUNT_TYPE:EXPIRATION:ACCOUNT_EXPIRY:LOGIN_ATTEMPTS:FAILED_ACCESS_ATTEMPTS:ALLOW_APP_BUILDING:ALLOW_SQL_WORKSHOP:ALLOW_TEAM_DEVELOPMENT:CREATION_DATE:CREATED_BY::WORKSPACE_ID'
,p_sort_column_1=>'WORKSPACE_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(136877391182978332)
,p_plug_name=>'User Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20829938868705277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(381997811386814390)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Workspace Users report includes the overall access information for users created during the default reporting period.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01007
begin
wwv_flow_imp_page.create_page(
 p_id=>1007
,p_name=>'Active Applications'
,p_alias=>'ACTIVE-APPLICATIONS'
,p_step_title=>'Active Applications'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17867631758893647)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select h.workspace_id,',
'       h.workspace_name,',
'       h.application_id,',
'       h.application_name,',
'       (select count(*)',
'          from wwv_flow_steps s',
'         where s.flow_id = h.application_id)                          as app_pages,',
'       nvl(sum(h.page_events), 0)                                     as page_events,',
'       nvl(max(h.distinct_pages), 0)                                  as max_daily_pages,',
'       nvl(max(h.distinct_users), 0)                                  as max_distinct_users, ',
'       count(l.authentication_result)                                 as login_attempts,',
'       sum(decode(nvl(authentication_result, 0), 0, 0, 1))            as failed_logins_cnt   ',
'  from wwv_flow_log_history       h,       ',
'       wwv_flow_user_access_log_v l',
' where h.workspace_id = l.security_group_id',
'   and h.application_id = l.application',
'   and h.workspace_id not in (0, 10, 11, 12)',
'   and h.application_id not between 4000 and 4999',
'   and h.log_day between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                 and trunc(sysdate) - 1/24/3600',
'group by h.workspace_id,',
'         h.workspace_name,',
'         h.application_id,',
'         h.application_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Applications'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(19619008176330109)
,p_no_data_found_message=>'No Applications found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>19619008176330109
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19619274038330111)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>10
,p_column_identifier=>'B'
,p_column_label=>'Workspace Name'
,p_column_link=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:1030:P1030_WORKSPACE_NAME:#WORKSPACE_NAME#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19619358075330112)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>20
,p_column_identifier=>'C'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19619407752330113)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>30
,p_column_identifier=>'D'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17577474475551829)
,p_db_column_name=>'APP_PAGES'
,p_display_order=>40
,p_column_identifier=>'K'
,p_column_label=>'Application Pages'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19619172707330110)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>50
,p_column_identifier=>'A'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19619799874330116)
,p_db_column_name=>'MAX_DAILY_PAGES'
,p_display_order=>60
,p_column_identifier=>'G'
,p_column_label=>'Maximum Daily Accessed Pages'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19620023150330119)
,p_db_column_name=>'MAX_DISTINCT_USERS'
,p_display_order=>70
,p_column_identifier=>'J'
,p_column_label=>'Maximum Distinct Users'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19619876502330117)
,p_db_column_name=>'LOGIN_ATTEMPTS'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Login Attempts'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19619929045330118)
,p_db_column_name=>'FAILED_LOGINS_CNT'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Failed Logins'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21009727894759829)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(19632080752438803)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'196321'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:APPLICATION_ID:APPLICATION_NAME:APP_PAGES:PAGE_EVENTS:MAX_DAILY_PAGES:MAX_DISTINCT_USERS:LOGIN_ATTEMPTS:FAILED_LOGINS_CNT:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20624595799951943)
,p_plug_name=>'Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(20826645134625313)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251269611669139733)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Active Applications report provides the overall activity metrics for applications in this &PRODUCT_NAME. instance during the default reporting period.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01010
begin
wwv_flow_imp_page.create_page(
 p_id=>1010
,p_name=>'Distinct Users'
,p_alias=>'DISTINCT-USERS'
,p_page_mode=>'MODAL'
,p_step_title=>'Distinct Users'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19981508241203441)
,p_plug_name=>'Distinct Users'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct al.userid,',
'       to_date(al.time_stamp, ''&DATE_FORMAT.'') as log_day,',
'       count(distinct al.flow_id) as application_cnt,',
'       upper(ws.short_name) as workspace_name',
'  from wwv_flow_activity_log al,',
'       wwv_flow_companies    ws,',
'       wwv_flows              f,',
'       (select to_date(:P1010_LOG_DAY,''&DATE_FORMAT.'') log_day_format',
'          from sys.dual)      d',
' where ws.provisioning_company_id = al.security_group_id',
'   and f.security_group_id = al.security_group_id',
'   and f.id = al.flow_id',
'   and al.time_stamp >= d.log_day_format',
'   and al.time_stamp < d.log_day_format + 1',
'   and al.security_group_id = nvl(:P1010_WORKSPACE_ID, 0)',
'   and al.flow_id not between 4000 and 4999',
'   and al.step_id is not null',
'group by al.userid,',
'         to_date(al.time_stamp, ''&DATE_FORMAT.''),',
'         upper(ws.short_name)'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1010_LOG_DAY,P1010_WORKSPACE_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Distinct Users'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(19981636471203442)
,p_no_data_found_message=>'No Workspace Users found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>19981636471203442
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20621715345951915)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>10
,p_column_identifier=>'U'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20620941932951907)
,p_db_column_name=>'USERID'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'User ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19981731167203443)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23138428243760006)
,p_db_column_name=>'APPLICATION_CNT'
,p_display_order=>50
,p_column_identifier=>'W'
,p_column_label=>'Applications Accessed'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(20639861251059362)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'206399'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:USERID:WORKSPACE_NAME::APPLICATION_CNT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20621571378951913)
,p_name=>'P1010_LOG_DAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(19981508241203441)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20621685480951914)
,p_name=>'P1010_WORKSPACE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(19981508241203441)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_01011
begin
wwv_flow_imp_page.create_page(
 p_id=>1011
,p_name=>'Daily Pages'
,p_alias=>'DAILY-PAGES'
,p_page_mode=>'MODAL'
,p_step_title=>'Daily Pages'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20621801231951916)
,p_plug_name=>'Maximum Daily Pages'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(distinct',
'           case when al.step_id is not null',
'           then al.step_id end)                    as daily_max_active_pages,',
'           to_date(al.time_stamp, ''&DATE_FORMAT.'') as log_day,',
'           al.flow_id                              as application_id,',
'           f.name                                  as application_name,',
'           upper(ws.short_name)                    as workspace_name    ',
'      from wwv_flow_activity_log al,',
'           wwv_flow_companies    ws,     ',
'           wwv_flows              f,',
'           (select to_date(:P1011_LOG_DAY,''&DATE_FORMAT.'') as log_day_format',
'              from sys.dual)      d',
'     where ws.provisioning_company_id = al.security_group_id (+)',
'       and f.security_group_id        = al.security_group_id (+)',
'       and f.id                       = al.flow_id (+)',
'       and al.flow_id not between 4000 and 4999',
'       and al.time_stamp >= d.log_day_format',
'       and al.time_stamp < d.log_day_format + 1',
'       and al.security_group_id = nvl(:P1011_WORKSPACE_ID, 0)',
'group by to_date(al.time_stamp, ''&DATE_FORMAT.''),',
'         al.flow_id,',
'         f.name,',
'         upper(ws.short_name)'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1011_LOG_DAY,P1011_WORKSPACE_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Maximum Daily Pages'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(20621977741951917)
,p_no_data_found_message=>'No Accessed Pages found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>20621977741951917
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20622040730951918)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20622182006951919)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20622265257951920)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20622944427951927)
,p_db_column_name=>'DAILY_MAX_ACTIVE_PAGES'
,p_display_order=>40
,p_column_identifier=>'J'
,p_column_label=>'Daily Maximum Active Pages'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20623065196951928)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>50
,p_column_identifier=>'K'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(20653648500369283)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'206537'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:WORKSPACE_NAME:APPLICATION_ID:APPLICATION_NAME:DAILY_MAX_ACTIVE_PAGES:'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20623144670951929)
,p_name=>'P1011_LOG_DAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20621801231951916)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20623222265951930)
,p_name=>'P1011_WORKSPACE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20621801231951916)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_01012
begin
wwv_flow_imp_page.create_page(
 p_id=>1012
,p_name=>'User Scheduler Jobs'
,p_alias=>'USER-SCHEDULER-JOBS'
,p_step_title=>'User Scheduler Jobs'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34388596853268995)
,p_plug_name=>'Scheduler Jobs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="white-space:nowrap;"'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with all_user_jobs as (',
'    select log_date,',
'           owner,',
'           job_name,',
'           status,',
'           actual_start_date,',
'           run_duration,',
'           extract(second from run_duration)',
'                       + extract(minute from run_duration) * 60',
'                       + extract(hour from run_duration) * 60 * 60',
'                       + extract(day from run_duration) * 60 * 60 * 24 as job_run_time',
'      from sys.dba_scheduler_job_run_details',
'     where owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'       and owner not in (select username',
'                           from sys.dba_users',
'                          where oracle_maintained = ''Y'')',
'       and status in (''SUCCEEDED'', ''FAILED'')',
'       and actual_start_date between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                             and trunc(sysdate) - 1/24/3600 )',
'    select owner,',
'           job_name,',
'           status,',
'           min(log_date) as min_log_date,',
'           max(log_date) as max_log_date,       ',
'           avg(job_run_time) as avg_run_time,',
'           max(job_run_time) as max_run_time,',
'           min(job_run_time) as min_run_time',
'      from all_user_jobs  ',
'  group by owner,',
'           job_name,',
'           status'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Scheduler Jobs'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(34388624171268996)
,p_no_data_found_message=>'No Scheduler Jobs found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>34388624171268996
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17397498344062378)
,p_db_column_name=>'OWNER'
,p_display_order=>20
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17397899494062379)
,p_db_column_name=>'JOB_NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Job Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17398224295062379)
,p_db_column_name=>'STATUS'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17399449279062380)
,p_db_column_name=>'AVG_RUN_TIME'
,p_display_order=>50
,p_column_identifier=>'F'
,p_column_label=>'Average Run Time'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17399892040062381)
,p_db_column_name=>'MAX_RUN_TIME'
,p_display_order=>60
,p_column_identifier=>'G'
,p_column_label=>'Maximum Run Time'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17400234832062381)
,p_db_column_name=>'MIN_RUN_TIME'
,p_display_order=>70
,p_column_identifier=>'H'
,p_column_label=>'Minimum Run Time'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21674649209910614)
,p_db_column_name=>'MIN_LOG_DATE'
,p_display_order=>80
,p_column_identifier=>'L'
,p_column_label=>'Minimum Log Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21674758102910615)
,p_db_column_name=>'MAX_LOG_DATE'
,p_display_order=>90
,p_column_identifier=>'M'
,p_column_label=>'Maximum Log Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(34763746408711883)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'173667'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>20
,p_report_columns=>'OWNER:JOB_NAME:STATUS:AVG_RUN_TIME:MAX_RUN_TIME:MIN_RUN_TIME'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34771217180908046)
,p_plug_name=>'Automations'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with all_automations as (',
'    select a.id as automation_id,',
'           a.name as automation_name,',
'           f.workspace as workspace_name,',
'           f.application_name,      ',
'           a.static_id,',
'           a.polling_interval as automation_schedule,',
'           a.polling_last_run_timestamp as automation_last_run,',
'           a.polling_next_run_timestamp as automation_next_run,',
'           al.status as automation_status,',
'           a.result_type,',
'           al.start_timestamp,',
'           al.end_timestamp,',
'           extract(second from (end_timestamp - start_timestamp))',
'                           + extract(minute from (end_timestamp - start_timestamp)) * 60',
'                           + extract(hour from (end_timestamp - start_timestamp)) * 60 * 60',
'                           + extract(day from (end_timestamp - start_timestamp)) * 60 * 60 * 24 as automation_run_time',
'      from wwv_flow_authorized_restricted f,',
'           wwv_flow_automations           a,',
'           wwv_flow_automation_log        al',
'     where a.flow_id           = f.application_id',
'       and a.security_group_id = f.workspace_id                       ',
'       and a.id                = al.automation_id',
'       and al.start_timestamp between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                                  and trunc(sysdate) - 1/24/3600',
'       and a.polling_status = ''ACTIVE'' )',
'    select fa.automation_id,',
'           fa.automation_name,',
'           fa.workspace_name,',
'           fa.application_name,',
'           fa.static_id,',
'           fa.automation_status,',
'           fa.automation_schedule,',
'           min(fa.start_timestamp) as min_automation_date,',
'           max(fa.start_timestamp) as max_automation_date,',
'           fa.result_type,',
'           min(fa.automation_run_time) as min_automation_duration,',
'           percentile_disc(0.1) within group (order by fa.automation_run_time) as automation_10pct_sec,',
'           avg(fa.automation_run_time) as avg_automation_duration,',
'           percentile_disc(0.9) within group (order by fa.automation_run_time) as automation_90pct_sec,',
'           max(fa.automation_run_time) as max_automation_duration,',
'           count(aa.id) as actions_count',
'      from all_automations fa,',
'           wwv_flow_automation_actions aa',
'     where fa.automation_id = aa.automation_id',
'     group by fa.automation_id,',
'           fa.automation_name,',
'           fa.workspace_name,',
'           fa.application_name,',
'           fa.static_id,',
'           fa.automation_status,',
'           fa.automation_schedule,',
'           fa.result_type'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Automations'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(34771261043908047)
,p_no_data_found_message=>'No Automations found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>34771261043908047
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17404825374237649)
,p_db_column_name=>'AUTOMATION_ID'
,p_display_order=>20
,p_column_identifier=>'G'
,p_column_label=>'Automation ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17402574580237646)
,p_db_column_name=>'AUTOMATION_NAME'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'Automation Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17402831672237646)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>40
,p_column_identifier=>'B'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17403213759237647)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17403630032237648)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>60
,p_column_identifier=>'D'
,p_column_label=>'Static ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17404079831237648)
,p_db_column_name=>'AUTOMATION_SCHEDULE'
,p_display_order=>70
,p_column_identifier=>'E'
,p_column_label=>'Automation Schedule'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17404464852237649)
,p_db_column_name=>'RESULT_TYPE'
,p_display_order=>80
,p_column_identifier=>'F'
,p_column_label=>'Result Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17405211698237650)
,p_db_column_name=>'AUTOMATION_STATUS'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Automation Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17406431719237652)
,p_db_column_name=>'MIN_AUTOMATION_DURATION'
,p_display_order=>100
,p_column_identifier=>'K'
,p_column_label=>'Minimum Duration'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17406877076237653)
,p_db_column_name=>'AUTOMATION_10PCT_SEC'
,p_display_order=>110
,p_column_identifier=>'L'
,p_column_label=>'Duration (10th Percentile)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17407242955237654)
,p_db_column_name=>'AVG_AUTOMATION_DURATION'
,p_display_order=>120
,p_column_identifier=>'M'
,p_column_label=>'Duration (Average)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17407676298237654)
,p_db_column_name=>'AUTOMATION_90PCT_SEC'
,p_display_order=>130
,p_column_identifier=>'N'
,p_column_label=>'Duration (90th Percentile)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17408035971237655)
,p_db_column_name=>'MAX_AUTOMATION_DURATION'
,p_display_order=>140
,p_column_identifier=>'O'
,p_column_label=>'Maximum Duration'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17408435872237655)
,p_db_column_name=>'ACTIONS_COUNT'
,p_display_order=>150
,p_column_identifier=>'P'
,p_column_label=>'Actions Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20494642019535528)
,p_db_column_name=>'MIN_AUTOMATION_DATE'
,p_display_order=>160
,p_column_identifier=>'T'
,p_column_label=>'Minimum Automation Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20494724049535529)
,p_db_column_name=>'MAX_AUTOMATION_DATE'
,p_display_order=>170
,p_column_identifier=>'U'
,p_column_label=>'Maximum Automation Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(34786752666136121)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'173846'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUTOMATION_NAME:WORKSPACE_NAME:APPLICATION_NAME:AUTOMATION_STATUS:RESULT_TYPE:MIN_AUTOMATION_DURATION:AUTOMATION_10PCT_SEC:AVG_AUTOMATION_DURATION:AUTOMATION_90PCT_SEC:MAX_AUTOMATION_DURATION:ACTIONS_COUNT:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34780154535909234)
,p_plug_name=>'REST Synchronizations'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with all_rest_synchronizations as (',
'    select m.id as module_id,',
'           m.name as module_name,',
'           f.workspace as workspace_name,',
'           f.application_name,           ',
'           sl.web_src_sync_static_id as sync_step_static_id,',
'           decode(sl.is_job,',
'                  ''Y'', wwv_flow_lang_dev.builder_message(''APEXDEV.PE.YES''),',
'                  ''N'', wwv_flow_lang_dev.builder_message(''APEXDEV.PE.NO''),',
'                  sl.is_job ) as is_job,',
'           sl.status as status_code,',
'           sl.start_timestamp,',
'           sl.end_timestamp,',
'           extract(second from (sl.end_timestamp - sl.start_timestamp))',
'                           + extract(minute from (sl.end_timestamp - sl.start_timestamp)) * 60',
'                           + extract(hour from (sl.end_timestamp - sl.start_timestamp)) * 60 * 60',
'                           + extract(day from (sl.end_timestamp - sl.start_timestamp)) * 60 * 60 * 24 as rest_sync_run_time           ',
'      from wwv_flow_web_src_modules       m,',
'           wwv_flow_authorized_restricted f,           ',
'           wwv_flow_websource_sync_log    sl',
'     where f.workspace_id           = m.security_group_id',
'       and f.application_id         = m.flow_id',
'       and m.id                     = sl.web_src_module_id',
'       and sl.start_timestamp between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                                  and trunc(sysdate) - 1/24/3600 )',
'    select module_id,',
'           module_name,',
'           workspace_name,',
'           application_name,',
'           sync_step_static_id,',
'           is_job,',
'           status_code,',
'           min(rs.start_timestamp) as min_rest_synchronization,',
'           max(rs.start_timestamp) as max_rest_synchronization,',
'           min(rest_sync_run_time) as min_rest_sync_duration,',
'           percentile_disc(0.1) within group (order by rest_sync_run_time) as rest_sync_10pct_sec,',
'           avg(rest_sync_run_time) as avg_rest_sync_duration,',
'           percentile_disc(0.9) within group (order by rest_sync_run_time) as rest_sync_90pct_sec,',
'           max(rest_sync_run_time) as max_rest_sync_duration,',
'           count(ss.id) as steps_count',
'      from all_rest_synchronizations rs,',
'           wwv_flow_web_src_sync_steps ss',
'     where ss.web_src_module_id (+) = rs.module_id',
'  group by module_id,',
'           module_name,',
'           workspace_name,',
'           application_name,',
'           sync_step_static_id,',
'           is_job,',
'           status_code'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'REST Synchronizations'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(34780223046909235)
,p_no_data_found_message=>'No REST Synchronizations found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>34780223046909235
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17410287011238815)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>20
,p_column_identifier=>'C'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9603878115675202)
,p_db_column_name=>'SYNC_STEP_STATIC_ID'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Sync Step Static ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17411865477238817)
,p_db_column_name=>'IS_JOB'
,p_display_order=>40
,p_column_identifier=>'G'
,p_column_label=>'IS Job'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17412690620238817)
,p_db_column_name=>'STATUS_CODE'
,p_display_order=>50
,p_column_identifier=>'I'
,p_column_label=>'Status Code'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17372468796670436)
,p_db_column_name=>'MODULE_ID'
,p_display_order=>60
,p_column_identifier=>'N'
,p_column_label=>'Module ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17372574277670437)
,p_db_column_name=>'MODULE_NAME'
,p_display_order=>70
,p_column_identifier=>'O'
,p_column_label=>'Module Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17372604876670438)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>80
,p_column_identifier=>'P'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17372964031670441)
,p_db_column_name=>'MIN_REST_SYNC_DURATION'
,p_display_order=>90
,p_column_identifier=>'S'
,p_column_label=>'Minimum Duration'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17373072670670442)
,p_db_column_name=>'REST_SYNC_10PCT_SEC'
,p_display_order=>100
,p_column_identifier=>'T'
,p_column_label=>'Duration (10th Percentile)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17373101268670443)
,p_db_column_name=>'AVG_REST_SYNC_DURATION'
,p_display_order=>110
,p_column_identifier=>'U'
,p_column_label=>'Average Duration'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17373290535670444)
,p_db_column_name=>'REST_SYNC_90PCT_SEC'
,p_display_order=>120
,p_column_identifier=>'V'
,p_column_label=>'Duration (90th Percentile)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17373336471670445)
,p_db_column_name=>'MAX_REST_SYNC_DURATION'
,p_display_order=>130
,p_column_identifier=>'W'
,p_column_label=>'Maximum Duration'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17373437403670446)
,p_db_column_name=>'STEPS_COUNT'
,p_display_order=>140
,p_column_identifier=>'X'
,p_column_label=>'Steps Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20494870587535530)
,p_db_column_name=>'MIN_REST_SYNCHRONIZATION'
,p_display_order=>150
,p_column_identifier=>'AB'
,p_column_label=>'Minimum REST Synchronization Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20494937296535531)
,p_db_column_name=>'MAX_REST_SYNCHRONIZATION'
,p_display_order=>160
,p_column_identifier=>'AC'
,p_column_label=>'Maximum REST Synchronization Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(34794353126137313)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'173852'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>20
,p_report_columns=>'MODULE_NAME:WORKSPACE_NAME:APPLICATION_NAME:STATUS_CODE:MIN_REST_SYNC_DURATION:REST_SYNC_10PCT_SEC:AVG_REST_SYNC_DURATION:REST_SYNC_90PCT_SEC:MAX_REST_SYNC_DURATION:STEPS_COUNT:MIN_REST_SYNCHRONIZATION:MAX_REST_SYNCHRONIZATION:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37814931236428217)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(38314653540525866)
,p_name=>'Scheduler Jobs'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>80
,p_region_css_classes=>'margin-top-md'
,p_region_sub_css_classes=>'a-AVPList--rightAligned'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(sum(case when j.status =''SUCCEEDED'' then 1 else 0 end ), 0) as successful_jobs_total,',
'       nvl(sum(case when j.status = ''FAILED'' then 1 else 0 end ), 0) as failed_jobs_total,',
'       count(distinct j.owner) as users_total',
'  from (',
'        select distinct jd.owner,',
'               jd.job_name,',
'               jd.status',
'          from sys.dba_scheduler_job_run_details jd',
'         where jd.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'           and jd.owner not in (select username',
'                                  from sys.dba_users',
'                                 where oracle_maintained = ''Y'')',
'           and actual_start_date between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                                 and trunc(sysdate) - 1/24/3600 ) j'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805670753642677848)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21674498775910612)
,p_query_column_id=>1
,p_column_alias=>'SUCCESSFUL_JOBS_TOTAL'
,p_column_display_sequence=>10
,p_column_heading=>'Successful'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21674512628910613)
,p_query_column_id=>2
,p_column_alias=>'FAILED_JOBS_TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Failed'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21675253508910620)
,p_query_column_id=>3
,p_column_alias=>'USERS_TOTAL'
,p_column_display_sequence=>30
,p_column_heading=>'Distinct Job Users'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(42429627042249787)
,p_name=>'Automations'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>90
,p_region_css_classes=>'margin-top-md'
,p_region_sub_css_classes=>'a-AVPList--rightAligned'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(sum(case when j.status = ''SUCCESS'' then 1 else 0 end ), 0) as successful_automations_total,',
'       nvl(sum(case when j.status in (''INCOMPLETE'', ''FAILURE'', ''ABORTED'') then 1 else 0 end ), 0) as failed_automations_total,',
'       count(j.id) as automations_total',
'      from ( ',
'            select a.id,',
'                   al.status',
'              from wwv_flow_automations     a,',
'                   wwv_flow_automation_log al',
'            where a.id             = al.automation_id',
'              and a.polling_status = ''ACTIVE''',
'              and al.status in (''SUCCESS'', ''INCOMPLETE'', ''FAILURE'', ''ABORTED'')',
'              and al.start_timestamp between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                                         and trunc(sysdate) - 1/24/3600 ) j'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805670753642677848)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21675602572910624)
,p_query_column_id=>1
,p_column_alias=>'SUCCESSFUL_AUTOMATIONS_TOTAL'
,p_column_display_sequence=>40
,p_column_heading=>'Successful'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21675744895910625)
,p_query_column_id=>2
,p_column_alias=>'FAILED_AUTOMATIONS_TOTAL'
,p_column_display_sequence=>50
,p_column_heading=>'Failed'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21675172586910619)
,p_query_column_id=>3
,p_column_alias=>'AUTOMATIONS_TOTAL'
,p_column_display_sequence=>30
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(42614073642338164)
,p_name=>'REST Synchronizations'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>100
,p_region_css_classes=>'margin-top-md'
,p_region_sub_css_classes=>'a-AVPList--rightAligned'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(sum(case when j.status = ''SUCCESS'' then 1 else 0 end ), 0) as successful_restsync_total,',
'       nvl(sum(case when j.status in (''INCOMPLETE'', ''FAILURE'', ''ABORTED'') then 1 else 0 end ), 0) as failed_restsync_total,',
'       count(j.id) as rest_sync_total',
'  from (',
'        select m.id,',
'               sl.status',
'          from wwv_flow_web_src_modules     m,          ',
'               wwv_flow_websource_sync_log sl',
'         where m.id            = sl.web_src_module_id',
'           and m.sync_is_active = ''Y''',
'           and sl.status in (''SUCCESS'', ''INCOMPLETE'', ''FAILURE'', ''ABORTED'')',
'           and sl.start_timestamp between trunc(sysdate) - :AI_DEFAULT_REPORTING_PERIOD',
'                                      and trunc(sysdate) - 1/24/3600 ) j'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805670753642677848)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21675309321910621)
,p_query_column_id=>1
,p_column_alias=>'SUCCESSFUL_RESTSYNC_TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Successful'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21675429156910622)
,p_query_column_id=>2
,p_column_alias=>'FAILED_RESTSYNC_TOTAL'
,p_column_display_sequence=>30
,p_column_heading=>'Failed'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21675537182910623)
,p_query_column_id=>3
,p_column_alias=>'REST_SYNC_TOTAL'
,p_column_display_sequence=>10
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(209822668206780475)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The reports are based on aggregated values for the scheduled processes such as Database Scheduler jobs, Automations,',
'REST Synchronizations running in the <strong>default reporting</strong> time interval.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01014
begin
wwv_flow_imp_page.create_page(
 p_id=>1014
,p_name=>'User Database Links'
,p_alias=>'USER-DATABASE-LINKS'
,p_step_title=>'User Database Links'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17435388879911937)
,p_plug_name=>'All Database links'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,',
'       db_link,',
'       username,',
'       host,',
'       created,',
'       hidden,',
'       shard_internal,',
'       valid,',
'       case when valid = ''YES'' then t.t_yes',
'            else t.t_no',
'       end as valid_message',
'  from sys.dba_db_links dl,',
'       (select wwv_flow_lang_dev.builder_message(''APEXDEV.PE.YES'') as t_yes,',
'               wwv_flow_lang_dev.builder_message(''APEXDEV.PE.NO'')  as t_no',
'          from sys.dual) t',
' where owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'   and owner not in (select username',
'                       from dba_users',
'                      where oracle_maintained = ''Y'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1014_SCHEMA_OWNER'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'All Database links'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(17435473823911938)
,p_no_data_found_message=>'No Database Links found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>17435473823911938
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17435554339911939)
,p_db_column_name=>'OWNER'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17435694240911940)
,p_db_column_name=>'DB_LINK'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Database Link'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17435728710911941)
,p_db_column_name=>'USERNAME'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17435822338911942)
,p_db_column_name=>'HOST'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Host'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17435968239911943)
,p_db_column_name=>'CREATED'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17436063670911944)
,p_db_column_name=>'HIDDEN'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Hidden'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17436119802911945)
,p_db_column_name=>'SHARD_INTERNAL'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Shard Internal'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17436296450911946)
,p_db_column_name=>'VALID'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Valid'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case VALID/}',
'{when YES/}',
'<span role="img" aria-label="#VALID_MESSAGE#" class="a-Icon icon-check-circle-s u-success-text"></span>',
'{otherwise/}',
'<span role="img" aria-label="#VALID_MESSAGE#" class="a-Icon icon-error u-danger-text"></span>',
'{endcase/}'))
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23304496309666702)
,p_db_column_name=>'VALID_MESSAGE'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Valid Message'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(17551326345409362)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'175514'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OWNER:DB_LINK:USERNAME:HOST:CREATED:HIDDEN:SHARD_INTERNAL:VALID:VALID_MESSAGE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204987757366762622)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The report displays all database links created in this instance excluding the system database links.</p>',
'<p><a rel="noopener noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/sqlrf/CREATE-DATABASE-LINK.html">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21007685433759808)
,p_name=>'P1014_SCHEMA_OWNER'
,p_item_sequence=>40
,p_source=>'return wwv_flow.g_flow_schema_owner;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_01015
begin
wwv_flow_imp_page.create_page(
 p_id=>1015
,p_name=>'Workspace with &AI_WORKSPACE_FREE_SPACE_LIMIT.% Free Space Remaining'
,p_alias=>'WORKSPACE-FREE-SPACE'
,p_step_title=>'Workspace with &AI_WORKSPACE_FREE_SPACE_LIMIT.% Free Space Remaining'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23623831021140847)
,p_plug_name=>'Workspace Space < &AI_WORKSPACE_FREE_SPACE_LIMIT. %'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with schema_mapping as (',
'    select c.provisioning_company_id as workspace_id,',
'           c.short_name as workspace_name,',
'           listagg(cs.schema, '', '') within group (order by cs.schema) as existing_schemas,',
'           sum(sm.data_file_size) as data_filesize_total,',
'           sum(sm.free_space) as free_space_total',
'      from wwv_flow_companies c,',
'           wwv_flow_company_schemas cs,',
'           wwv_schema_aggr_metrics sm',
'     where cs.security_group_id = c.provisioning_company_id',
'       and cs.schema = sm.schema',
'       and c.provisioning_company_id not in (0, 10, 11, 12)',
'       and log_day = (select max(log_day)',
'                        from wwv_schema_aggr_metrics w',
'                       where w.schema = sm.schema)',
'  group by c.provisioning_company_id,',
'           c.short_name )',
'    select workspace_id,',
'           workspace_name,',
'           existing_schemas,',
'           data_filesize_total / 1024 / 1024 / 1024 as data_filesize_total,',
'           free_space_total / 1024 / 1024 / 1024 as free_space_total,',
'           trunc((free_space_total / data_filesize_total) * 100, 2) as free_space_percentage',
'      from schema_mapping',
'     where trunc(free_space_total / nullif(data_filesize_total, 0) * 100, 2) < :AI_WORKSPACE_FREE_SPACE_LIMIT',
'                ',
'',
'',
'       '))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Workspace Space < &AI_WORKSPACE_FREE_SPACE_LIMIT. %'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(23623904357140848)
,p_no_data_found_message=>'No Workspaces exceeded the threshold within the specified time frame.'
,p_max_rows_per_page=>'20'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>23623904357140848
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23624008510140849)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Workspace Name'
,p_column_link=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:1030:P1030_WORKSPACE_ID:#WORKSPACE_ID#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23624139105140850)
,p_db_column_name=>'EXISTING_SCHEMAS'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Existing Schemas'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26404456714521801)
,p_db_column_name=>'DATA_FILESIZE_TOTAL'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Data Filesize Total'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26404556861521802)
,p_db_column_name=>'FREE_SPACE_TOTAL'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Free Space Total'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9714806494389303)
,p_db_column_name=>'FREE_SPACE_PERCENTAGE'
,p_display_order=>50
,p_column_identifier=>'G'
,p_column_label=>'Free Space  (%)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21009946948759831)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(26411356813524802)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'264114'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>20
,p_report_columns=>'WORKSPACE_NAME:EXISTING_SCHEMAS:DATA_FILESIZE_TOTAL:FREE_SPACE_TOTAL:FREE_SPACE_PERCENTAGE::WORKSPACE_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(221936546146660547)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Instance Administrator can configure a threshold to monitor free space available to workspaces.</p>',
'<p>Workspaces that exceed the configured threshold within the default reporting period are listed here.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01016
begin
wwv_flow_imp_page.create_page(
 p_id=>1016
,p_name=>'Sessions'
,p_alias=>'SESSIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Sessions'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18923393290096339)
,p_plug_name=>'Sessions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct al.session_id,',
'       s.created_on,',
'       s.username,',
'       upper(ws.short_name) as workspace_name,',
'       s.remote_addr,',
'       s.idle_timeout_on,',
'       s.life_timeout_on,',
'       s.is_subscription_session',
' from wwv_flow_activity_log al,',
'      wwv_flow_sessions$     s,',
'      wwv_flow_companies    ws,',
'      (select to_date(:P1016_LOG_DAY,''&DATE_FORMAT.'') as log_day_format',
'         from sys.dual)      d',
'where ws.provisioning_company_id = s.security_group_id (+)',
'  and ws.provisioning_company_id = al.security_group_id (+)',
'  and s.id (+)                   = al.session_id',
'  and al.time_stamp >= log_day_format',
'  and al.time_stamp < log_day_format + 1',
'  and al.security_group_id = nvl(:P1016_WORKSPACE_ID, 0)'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1016_LOG_DAY,P1016_WORKSPACE_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Sessions'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(18923478630096340)
,p_no_data_found_message=>'No sessions found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>18923478630096340
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18924365396096349)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>10
,p_column_identifier=>'B'
,p_column_label=>'Created On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18924262517096348)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>20
,p_column_identifier=>'A'
,p_column_label=>'Session ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18924406354096350)
,p_db_column_name=>'USERNAME'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19090862854011701)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19090998107011702)
,p_db_column_name=>'REMOTE_ADDR'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Remote Addr'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19091002563011703)
,p_db_column_name=>'IDLE_TIMEOUT_ON'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Idle Timeout On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19091189893011704)
,p_db_column_name=>'LIFE_TIMEOUT_ON'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Life Timeout On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19091293578011705)
,p_db_column_name=>'IS_SUBSCRIPTION_SESSION'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Is Subscription Session'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(19099975062123247)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'191000'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SESSION_ID:CREATED_ON:USERNAME:WORKSPACE_NAME:REMOTE_ADDR:IDLE_TIMEOUT_ON:LIFE_TIMEOUT_ON:IS_SUBSCRIPTION_SESSION'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19091380744011706)
,p_name=>'P1016_WORKSPACE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(18923393290096339)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22829653173802348)
,p_name=>'P1016_LOG_DAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18923393290096339)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_01017
begin
wwv_flow_imp_page.create_page(
 p_id=>1017
,p_name=>'Emails Sent'
,p_alias=>'EMAILS-SENT'
,p_page_mode=>'MODAL'
,p_step_title=>'Emails Sent'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23602217958095022)
,p_plug_name=>'Emails'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ml.mail_to,',
'       ml.mail_from,',
'       ml.mail_subj,',
'       ml.mail_cc,',
'       ml.mail_bcc,',
'       ml.mail_message_send_begin,',
'       ml.mail_message_send_end,',
'       ml.mail_body_size,',
'       ml.mail_attachment_count,',
'       ml.last_updated_by,',
'       ml.last_updated_on,',
'       upper(ws.short_name) as workspace_name',
'  from wwv_flow_mail_log  ml,',
'       wwv_flow_companies ws,',
'       (select to_date(:P1017_LOG_DAY,''&DATE_FORMAT.'') as log_day_format',
'          from sys.dual )  d',
' where ws.provisioning_company_id = ml.security_group_id (+)',
'   and ml.flow_id not in (0, 10, 11, 12)',
'   and ml.last_updated_on >= d.log_day_format',
'   and ml.last_updated_on < d.log_day_format + 1',
'   and ml.security_group_id = nvl(:P1017_WORKSPACE_ID, 0)'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1017_LOG_DAY,P1017_WORKSPACE_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Emails'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(23602311787095023)
,p_no_data_found_message=>'No Emails found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>23602311787095023
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23602688979095026)
,p_db_column_name=>'MAIL_TO'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'To'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23602761887095027)
,p_db_column_name=>'MAIL_FROM'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23602988271095029)
,p_db_column_name=>'MAIL_SUBJ'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Subject'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23603097306095030)
,p_db_column_name=>'MAIL_CC'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'CC'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23603194017095031)
,p_db_column_name=>'MAIL_BCC'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'BCC'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23603331238095033)
,p_db_column_name=>'MAIL_MESSAGE_SEND_BEGIN'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Message Send Begin'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23603453705095034)
,p_db_column_name=>'MAIL_MESSAGE_SEND_END'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Message Send End'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23603564755095035)
,p_db_column_name=>'MAIL_BODY_SIZE'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Body Size'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23603709547095037)
,p_db_column_name=>'MAIL_ATTACHMENT_COUNT'
,p_display_order=>140
,p_column_identifier=>'N'
,p_column_label=>'Attachment Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23604044742095040)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>170
,p_column_identifier=>'Q'
,p_column_label=>'Last Updated On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23604446299095044)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>180
,p_column_identifier=>'R'
,p_column_label=>'Last Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20623858538951936)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>190
,p_column_identifier=>'U'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(23618486632126122)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'236185'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_NAME:MAIL_TO:MAIL_FROM:MAIL_SUBJ:MAIL_CC:MAIL_BCC:MAIL_MESSAGE_SEND_BEGIN:MAIL_MESSAGE_SEND_END:MAIL_BODY_SIZE:MAIL_ATTACHMENT_COUNT:LAST_UPDATED_ON:LAST_UPDATED_BY:'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20623928129951937)
,p_name=>'P1017_WORKSPACE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(23602217958095022)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23604750228095047)
,p_name=>'P1017_LOG_DAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(23602217958095022)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_01018
begin
wwv_flow_imp_page.create_page(
 p_id=>1018
,p_name=>'Errors'
,p_alias=>'ERRORS'
,p_page_mode=>'MODAL'
,p_step_title=>'Errors'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22829759448802349)
,p_plug_name=>'Errors'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select al.time_stamp        as log_day,',
'       upper(ws.short_name) as workspace_name,',
'       al.flow_id           as application_id,',
'       f.name               as application_name,',
'       userid,',
'       session_id,       ',
'       sqlerrm as error_message,',
'       sqlerrm_component_type,',
'       sqlerrm_component_name',
'  from wwv_flow_activity_log al,',
'       wwv_flow_companies    ws,',
'       wwv_flows              f,',
'       (select to_date(:P1018_LOG_DAY,''&DATE_FORMAT.'') as log_day_format',
'          from sys.dual )     d',
' where ws.provisioning_company_id = al.security_group_id (+)',
'   and f.security_group_id        = al.security_group_id (+)',
'   and f.id                       = al.flow_id (+)',
'   and al.flow_id not between 4000 and 4999',
'   and sqlerrm is not null',
'   and al.time_stamp >= d.log_day_format',
'   and al.time_stamp < d.log_day_format + 1',
'   and al.security_group_id = nvl(:P1018_WORKSPACE_ID, 0)'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1018_LOG_DAY,P1018_WORKSPACE_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Errors'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(22829842650802350)
,p_no_data_found_message=>'No errors found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>22829842650802350
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23621256943140821)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>10
,p_column_identifier=>'Z'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23619375345140802)
,p_db_column_name=>'USERID'
,p_display_order=>40
,p_column_identifier=>'U'
,p_column_label=>'User ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23619528528140804)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>50
,p_column_identifier=>'V'
,p_column_label=>'Session ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23621562780140824)
,p_db_column_name=>'ERROR_MESSAGE'
,p_display_order=>60
,p_column_identifier=>'AC'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23620467124140813)
,p_db_column_name=>'SQLERRM_COMPONENT_TYPE'
,p_display_order=>70
,p_column_identifier=>'X'
,p_column_label=>'SQL Error Message Component Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23620556245140814)
,p_db_column_name=>'SQLERRM_COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'Y'
,p_column_label=>'SQL Error Message Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18923288288096338)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>90
,p_column_identifier=>'AF'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20623324811951931)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>100
,p_column_identifier=>'AG'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20623458093951932)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>110
,p_column_identifier=>'AH'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(23808973183174910)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'238090'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:ERROR_MESSAGE:SQLERRM_COMPONENT_TYPE:SQLERRM_COMPONENT_NAME:USERID:SESSION_ID::WORKSPACE_NAME:APPLICATION_ID:APPLICATION_NAME'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18923155717096337)
,p_name=>'P1018_WORKSPACE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22829759448802349)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23602190829095021)
,p_name=>'P1018_LOG_DAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(22829759448802349)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01019
begin
wwv_flow_imp_page.create_page(
 p_id=>1019
,p_name=>'IP Addresses'
,p_alias=>'IP-ADDRESSES'
,p_page_mode=>'MODAL'
,p_step_title=>'IP Addresses'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(43493448501431986)
,p_plug_name=>'IP Addresses'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct al.ip_address,',
'       to_date(al.time_stamp, ''&DATE_FORMAT.'') as log_day,',
'       upper(ws.short_name)                    as workspace_name,',
'       count(distinct session_id)              as sessions_count',
'  from wwv_flow_activity_log     al,',
'       wwv_flow_companies        ws,',
'       (select to_date(:P1019_LOG_DAY,''&DATE_FORMAT.'') as log_day_format',
'          from sys.dual )         d          ',
' where ws.provisioning_company_id = al.security_group_id (+)',
'   and al.flow_id not between 4000 and 4999',
'   and al.ip_address is not null',
'   and al.time_stamp >= d.log_day_format',
'   and al.time_stamp < d.log_day_format + 1 ',
'   and al.security_group_id = nvl(:P1019_WORKSPACE_ID, -1)',
'group by al.ip_address,',
'         to_date(al.time_stamp, ''&DATE_FORMAT.''),',
'         upper(ws.short_name)',
'         '))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1019_LOG_DAY,P1019_WORKSPACE_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'IP Addresses'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(43493531703431987)
,p_no_data_found_message=>'No IP Addresses found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>43493531703431987
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20666785721629648)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>10
,p_column_identifier=>'Z'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20663940395629646)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>90
,p_column_identifier=>'AF'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20623614591951934)
,p_db_column_name=>'IP_ADDRESS'
,p_display_order=>100
,p_column_identifier=>'AI'
,p_column_label=>'IP Address'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20623734727951935)
,p_db_column_name=>'SESSIONS_COUNT'
,p_display_order=>110
,p_column_identifier=>'AJ'
,p_column_label=>'Sessions Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(44472662235804547)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'238090'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY::WORKSPACE_NAME:IP_ADDRESS:SESSIONS_COUNT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20667835698629655)
,p_name=>'P1019_LOG_DAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(43493448501431986)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20668211890629657)
,p_name=>'P1019_WORKSPACE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(43493448501431986)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01020
begin
wwv_flow_imp_page.create_page(
 p_id=>1020
,p_name=>'Top Workspaces'
,p_alias=>'TOP-WORKSPACES'
,p_step_title=>'Top Workspaces'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9802490714093724)
,p_plug_name=>'Workspaces'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with time_frame as (',
'    select case',
'           when :P1020_SINCE < 100',
'           then trunc(sysdate) - nvl(:P1020_SINCE, :AI_DEFAULT_REPORTING_PERIOD)',
'           else to_date(:P1020_START_DATE)',
'           end start_interval_1x,',
'           case',
'           when :P1020_SINCE < 100',
'           then trunc(sysdate) - 1/24/3600',
'           else to_date(:P1020_END_DATE)',
'           end end_interval_1x',
'      from sys.dual ),',
'all_wksp as (',
'    select wm.workspace_id,',
'           wm.workspace_name,',
'           sum(case',
'                   when wm.log_day between tf.start_interval_1x and tf.end_interval_1x',
'                       then wm.page_events_cnt',
'                   else 0',
'               end)                      as page_events_cnt_1x,',
'           max(case',
'                   when wm.log_day between tf.start_interval_1x and tf.end_interval_1x',
'                       then wm.distinct_users_cnt',
'               end)                      as max_distinct_users_1x,',
'           sum(case',
'                   when wm.log_day between tf.start_interval_1x and tf.end_interval_1x',
'                       then wm.distinct_sessions_cnt',
'                   else 0',
'               end)                      as distinct_sessions_cnt_1x,',
'           sum(case',
'                   when wm.log_day between tf.start_interval_1x and tf.end_interval_1x',
'                       then wm.errors_cnt',
'                   else 0',
'               end)                      as errors_count_1x,           ',
'           max(case',
'                  when wm.log_day between tf.start_interval_1x and tf.end_interval_1x',
'                       then wm.workspace_size',
'                  end)                   as workspace_size_1x,',
'           sum(wm.page_events_cnt)       as page_events_cnt,',
'           max(wm.distinct_users_cnt)    as max_distinct_users,',
'           sum(wm.distinct_sessions_cnt) as distinct_sessions_cnt,',
'           sum(wm.errors_cnt)            as errors_count,           ',
'           max(wm.workspace_size)        as workspace_size',
'      from wwv_workspace_aggr_metrics wm,',
'           time_frame                 tf',
'     where wm.log_day <= trunc(sysdate) - 1',
'  group by workspace_id,',
'           workspace_name ), ',
'order_wksp as (',
'    select row_number() over( order by page_events_cnt_1x desc,',
'                                       max_distinct_users_1x desc,',
'                                       distinct_sessions_cnt_1x desc,',
'                                       errors_count_1x desc,',
'                                       workspace_size_1x desc ) as workspace_order,',
'           workspace_id,',
'           workspace_name,',
'           page_events_cnt_1x,',
'           trunc(nvl(page_events_cnt_1x, 0)/nullif(page_events_cnt, 0) * 100, 2)              as pg_page_events,',
'           max_distinct_users_1x,',
'           trunc(nvl(max_distinct_users_1x, 0)/nullif(max_distinct_users, 0) * 100, 2)        as pg_distinct_users,',
'           distinct_sessions_cnt_1x,',
'           trunc( nvl(distinct_sessions_cnt_1x, 0)/nullif(distinct_sessions_cnt, 0) * 100, 2) as pg_distinct_sessions,',
'           errors_count_1x,',
'           trunc(nvl(errors_count_1x, 0)/nullif(errors_count, 0) * 100, 2)                    as pg_errors_count,',
'           workspace_size_1x,',
'           trunc(nvl(workspace_size_1x, 0)/nullif(workspace_size, 0) * 100, 2)                as pg_workspace_size',
'      from all_wksp)',
'   select workspace_order           as workspace_rank,',
'           workspace_id,',
'           workspace_name,',
'           page_events_cnt_1x       as page_events_cnt,',
'           pg_page_events,',
'           max_distinct_users_1x    as max_distinct_users,',
'           pg_distinct_users,',
'           distinct_sessions_cnt_1x as distinct_sessions_cnt,',
'           pg_distinct_sessions,',
'           errors_count_1x          as errors_count,',
'           pg_errors_count,           ',
'           workspace_size_1x        as workspace_size,',
'           pg_workspace_size',
'      from order_wksp',
'     where workspace_order <= :P1020_TOP_N_WORKSPACES'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1020_SINCE,P1020_START_DATE,P1020_END_DATE,P1020_TOP_N_WORKSPACES'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Workspaces'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10407228098361225)
,p_no_data_found_message=>'No workspaces found.'
,p_max_rows_per_page=>'30'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>10407228098361225
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10407369890361226)
,p_db_column_name=>'WORKSPACE_RANK'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Rank'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10407845330361231)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'F'
,p_column_label=>'Workspace Name'
,p_column_link=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:1030,RIR:P1030_WORKSPACE_ID:#WORKSPACE_ID#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10407406117361227)
,p_db_column_name=>'PAGE_EVENTS_CNT'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19979796524203423)
,p_db_column_name=>'PG_PAGE_EVENTS'
,p_display_order=>40
,p_column_identifier=>'K'
,p_column_label=>'Page Events (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:#34aadc:#c7c7cc:'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19900027937518001)
,p_db_column_name=>'DISTINCT_SESSIONS_CNT'
,p_display_order=>50
,p_column_identifier=>'J'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19979958378203425)
,p_db_column_name=>'PG_DISTINCT_SESSIONS'
,p_display_order=>60
,p_column_identifier=>'M'
,p_column_label=>'Sessions (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16989947662206611)
,p_db_column_name=>'MAX_DISTINCT_USERS'
,p_display_order=>70
,p_column_identifier=>'H'
,p_column_label=>'Maximum Daily Users'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19979824759203424)
,p_db_column_name=>'PG_DISTINCT_USERS'
,p_display_order=>80
,p_column_identifier=>'L'
,p_column_label=>'Daily Users (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10407762174361230)
,p_db_column_name=>'ERRORS_COUNT'
,p_display_order=>90
,p_column_identifier=>'E'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19980039001203426)
,p_db_column_name=>'PG_ERRORS_COUNT'
,p_display_order=>120
,p_column_identifier=>'N'
,p_column_label=>'Errors (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20494483428535526)
,p_db_column_name=>'WORKSPACE_SIZE'
,p_display_order=>130
,p_column_identifier=>'P'
,p_column_label=>'Workspace Size (MB)'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20494556895535527)
,p_db_column_name=>'PG_WORKSPACE_SIZE'
,p_display_order=>140
,p_column_identifier=>'Q'
,p_column_label=>'Workspace Size (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21009192409759823)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>150
,p_column_identifier=>'R'
,p_column_label=>'Workspace Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(13295341112651963)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'132954'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'WORKSPACE_RANK:WORKSPACE_NAME:PAGE_EVENTS_CNT:PG_PAGE_EVENTS:DISTINCT_SESSIONS_CNT:PG_DISTINCT_SESSIONS:MAX_DISTINCT_USERS:PG_DISTINCT_USERS:ERRORS_COUNT:PG_ERRORS_COUNT::WORKSPACE_SIZE:PG_WORKSPACE_SIZE:WORKSPACE_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10408085405361233)
,p_plug_name=>'Buttons Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41302821141676390)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The report shows the top workspaces based on the metrics retained within it for a specified time interval.</p>',
'<p>All graph columns display the metric percentage based on the aggregated value for the selected time interval and the',
'total.</p>',
'<p>The data for the following reports is based on the metrics gathered once per day, except the current date.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74287703860339635)
,p_plug_name=>'Workspace Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20824651862610331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23395463250904061)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(10408085405361233)
,p_button_name=>'SET'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'t-Button--noUI'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9791829145656071)
,p_name=>'P1020_SINCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(10408085405361233)
,p_item_default=>'return wwv_flow_platform.get_preference(p_preference_name => ''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ADMIN_DIGEST.RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct d, t from (',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.DAY'')          d,    1 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''2'' ) d,    2 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''7'' ) d,    7 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''15'') d,   15 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''30'') d,   30 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''45'') d,   45 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''60'') d,   60 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''90'') d,   90 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message (',
'           case default_reporting_period',
'                when 1 then ''APEX.TIME.DAY''',
'                else ''APEX.TIME.N_DAYS''',
'           end,',
'           default_reporting_period) as d,',
'       default_reporting_period as t',
'  from (select to_number(wwv_flow_platform.get_preference(''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'')) default_reporting_period',
'          from sys.dual)',
'union all',
'select wwv_flow_lang_dev.builder_message(''CUSTOM'') d, 100 t from sys.dual)',
'order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18920960584096315)
,p_name=>'P1020_TOP_N_WORKSPACES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(10408085405361233)
,p_item_default=>'5'
,p_prompt=>'Rank'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ADMIN_DIGEST.TOP_N_ACTIVITY'
,p_lov=>'.'||wwv_flow_imp.id(18953694156990390)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19888780567730884)
,p_name=>'P1020_START_DATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(10408085405361233)
,p_prompt=>'Start'
,p_format_mask=>'&DATE_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'ITEM'
,p_attribute_08=>'P1020_END_DATE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19889073986738196)
,p_name=>'P1020_END_DATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(10408085405361233)
,p_prompt=>'End'
,p_format_mask=>'&DATE_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'ITEM'
,p_attribute_05=>'P1020_START_DATE'
,p_attribute_06=>'STATIC'
,p_attribute_07=>'&P1020_MAX_DATE.'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23307169474666729)
,p_name=>'P1020_MAX_DATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(10408085405361233)
,p_source=>'return trunc(sysdate) - 1;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(19891538201803213)
,p_name=>'Show/Hide Custom'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_SINCE'
,p_condition_element=>'P1020_SINCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'100'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19891968600803215)
,p_event_id=>wwv_flow_imp.id(19891538201803213)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_START_DATE,P1020_END_DATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19892464807803215)
,p_event_id=>wwv_flow_imp.id(19891538201803213)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_START_DATE,P1020_END_DATE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(19978415167203410)
,p_name=>'Refresh Region'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(23395463250904061)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19978552630203411)
,p_event_id=>wwv_flow_imp.id(19978415167203410)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-region'
);
end;
/
prompt --application/pages/page_01021
begin
wwv_flow_imp_page.create_page(
 p_id=>1021
,p_name=>'Top Applications'
,p_alias=>'TOP-APPLICATIONS'
,p_step_title=>'Top Applications'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9804561253093745)
,p_plug_name=>'Applications'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with time_frame as (',
'    select case',
'           when :P1021_SINCE < 100',
'           then trunc(sysdate) - nvl(:P1021_SINCE, :AI_DEFAULT_REPORTING_PERIOD)',
'           else to_date(:P1021_START_DATE)',
'           end start_interval_1x,',
'           case',
'           when :P1021_SINCE < 100',
'           then trunc(sysdate) - 1/24/3600',
'           else to_date(:P1021_END_DATE)',
'           end end_interval_1x',
'      from sys.dual ),',
'all_apps_1x as (',
'    select a.workspace_id,',
'           a.workspace_name,',
'           a.application_id,',
'           a.application_name,',
'           sum(a.page_events) as page_events_total,',
'           max(a.distinct_pages) as max_distinct_pages,',
'           max(a.distinct_users) as max_distinct_users,',
'           sum(a.distinct_sessions) as distinct_sessions_total,',
'           sum(a.error_count) as error_count_total                ',
'      from wwv_flow_log_history a,',
'           time_frame          tf',
'     where a.workspace_id not in (0, 10, 11, 12)',
'       and a.application_id not between 4000 and 4999',
'       and a.log_day between tf.start_interval_1x and tf.end_interval_1x',
'  group by a.workspace_id,',
'           a.workspace_name,',
'           a.application_id,',
'           a.application_name ),',
'all_apps as (',
'    select a.workspace_id,',
'           a.workspace_name,',
'           a.application_id,',
'           a.application_name,',
'           sum(a.page_events) as page_events_total,',
'           max(a.distinct_pages) as max_distinct_pages,',
'           max(a.distinct_users) as max_distinct_users,',
'           sum(a.distinct_sessions) as distinct_sessions_total,',
'           sum(a.error_count) as error_count_total                ',
'      from wwv_flow_log_history a',
'     where a.workspace_id not in (0, 10, 11, 12)',
'       and a.application_id not between 4000 and 4999',
'       and a.log_day <= trunc(sysdate) - 1',
'  group by a.workspace_id,',
'           a.workspace_name,',
'           a.application_id,',
'           a.application_name ),',
'    order_apps as (',
'        select row_number() over (order by b.page_events_total desc,',
'                                           b.max_distinct_pages desc,',
'                                           b.max_distinct_users desc,',
'                                           b.distinct_sessions_total desc,',
'                                           b.error_count_total desc) as app_order,',
'               b.workspace_id,',
'               b.workspace_name,',
'               b.application_name,',
'               b.page_events_total,',
'               trunc(nvl(b.page_events_total, 0)/nullif(d.page_events_total, 0) * 100, 2)             as pg_page_events,',
'               b.max_distinct_pages,',
'               trunc(nvl(b.max_distinct_pages, 0)/nullif(d.max_distinct_pages, 0) * 100, 2)           as pg_distinct_pages,',
'               b.max_distinct_users,',
'               trunc(nvl(b.max_distinct_users, 0)/nullif(d.max_distinct_users, 0) * 100, 2)           as pg_distinct_users,',
'               b.distinct_sessions_total,',
'               trunc(nvl(b.distinct_sessions_total, 0)/nullif(d.distinct_sessions_total, 0) * 100, 2) as pg_distinct_sessions,',
'               b.error_count_total,',
'               trunc(nvl(b.error_count_total, 0)/nullif(d.error_count_total, 0) * 100, 2)             as pg_error_count,',
'               (select count(s.id)',
'                  from wwv_flow_steps s',
'                 where s.flow_id = b.application_id',
'                   and ((:P1021_SINCE < 100 and s.created_on <= trunc(sysdate) - 1)',
'                    or (:P1021_SINCE = 100 and s.created_on <= :P1021_END_DATE))) as app_pages',
'          from all_apps_1x   b,',
'               all_apps      d',
'         where d.workspace_id = b.workspace_id',
'           and d.application_id = b.application_id',
'           and d.workspace_name is not null',
'           and d.application_name is not null',
'           and b.page_events_total < d.page_events_total )',
'        select app_order app_rank,',
'               workspace_id,           ',
'               workspace_name,',
'               application_name,',
'               page_events_total,',
'               pg_page_events,',
'               max_distinct_pages,',
'               pg_distinct_pages,',
'               max_distinct_users,',
'               pg_distinct_users,',
'               distinct_sessions_total,',
'               pg_distinct_sessions,               ',
'               error_count_total,',
'               pg_error_count,',
'               app_pages',
'        from order_apps',
'       where app_order <= :P1021_TOP_N_APPLICATIONS  '))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1021_SINCE,P1021_START_DATE,P1021_END_DATE,P1021_TOP_N_APPLICATIONS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Applications'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(16761006969096121)
,p_no_data_found_message=>'No Applications found.'
,p_max_rows_per_page=>'30'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>16761006969096121
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16761160832096122)
,p_db_column_name=>'APP_RANK'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Rank'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16761259823096123)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_link=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:1030:P1030_WORKSPACE_ID:#WORKSPACE_ID#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16761382743096124)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16990188646206613)
,p_db_column_name=>'APP_PAGES'
,p_display_order=>40
,p_column_identifier=>'N'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16761973437096130)
,p_db_column_name=>'PAGE_EVENTS_TOTAL'
,p_display_order=>50
,p_column_identifier=>'I'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19979234190203418)
,p_db_column_name=>'PG_PAGE_EVENTS'
,p_display_order=>60
,p_column_identifier=>'P'
,p_column_label=>'Page Events (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16762034988096131)
,p_db_column_name=>'MAX_DISTINCT_PAGES'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Maximum Daily Pages'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19979389303203419)
,p_db_column_name=>'PG_DISTINCT_PAGES'
,p_display_order=>90
,p_column_identifier=>'Q'
,p_column_label=>'Daily Pages (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16762174972096132)
,p_db_column_name=>'MAX_DISTINCT_USERS'
,p_display_order=>100
,p_column_identifier=>'K'
,p_column_label=>'Maximum Daily Users'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19979439535203420)
,p_db_column_name=>'PG_DISTINCT_USERS'
,p_display_order=>110
,p_column_identifier=>'R'
,p_column_label=>'Daily Users (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19900108137518002)
,p_db_column_name=>'DISTINCT_SESSIONS_TOTAL'
,p_display_order=>130
,p_column_identifier=>'O'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19979589921203421)
,p_db_column_name=>'PG_DISTINCT_SESSIONS'
,p_display_order=>150
,p_column_identifier=>'S'
,p_column_label=>'Sessions (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16762372944096134)
,p_db_column_name=>'ERROR_COUNT_TOTAL'
,p_display_order=>160
,p_column_identifier=>'M'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19979695282203422)
,p_db_column_name=>'PG_ERROR_COUNT'
,p_display_order=>170
,p_column_identifier=>'T'
,p_column_label=>'Errors (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21009222200759824)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>180
,p_column_identifier=>'U'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(16969762917033200)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'169698'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APP_RANK:WORKSPACE_NAME:APPLICATION_NAME:APP_PAGES:PAGE_EVENTS_TOTAL:PG_PAGE_EVENTS:MAX_DISTINCT_PAGES:PG_DISTINCT_PAGES:DISTINCT_SESSIONS_TOTAL:PG_DISTINCT_SESSIONS:MAX_DISTINCT_USERS:PG_DISTINCT_USERS:ERROR_COUNT_TOTAL:PG_ERROR_COUNT::WORKSPACE_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27391106697487289)
,p_plug_name=>'Buttons Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41303127762677278)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The report shows the top applications based on the metrics retained within it for a specified time interval.</p>',
'<p>All graph columns display the metric percentage based on the aggregated value for the selected time interval and the',
'total.</p>',
'<p>The data for the following reports is based on the Metrics gathered once per day, except the current date.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41495543352989638)
,p_plug_name=>'Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(20826645134625313)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(27525012681104508)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23395125090901454)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(27391106697487289)
,p_button_name=>'SET'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'t-Button--noUI'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16983748312126057)
,p_name=>'P1021_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(27391106697487289)
,p_item_default=>'return wwv_flow_platform.get_preference(p_preference_name => ''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ADMIN_DIGEST.RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct d, t from (',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.DAY'')          d,    1 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''2'' ) d,    2 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''7'' ) d,    7 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''15'') d,   15 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''30'') d,   30 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''45'') d,   45 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''60'') d,   60 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''90'') d,   90 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message (',
'           case default_reporting_period',
'                when 1 then ''APEX.TIME.DAY''',
'                else ''APEX.TIME.N_DAYS''',
'           end,',
'           default_reporting_period) as d,',
'       default_reporting_period as t',
'  from (select to_number(wwv_flow_platform.get_preference(''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'')) default_reporting_period',
'          from sys.dual)',
'union all',
'select wwv_flow_lang_dev.builder_message(''CUSTOM'') d, 100 t from sys.dual)',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19023239462753234)
,p_name=>'P1021_TOP_N_APPLICATIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(27391106697487289)
,p_item_default=>'5'
,p_prompt=>'Rank'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ADMIN_DIGEST.TOP_N_ACTIVITY'
,p_lov=>'.'||wwv_flow_imp.id(18953694156990390)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19911850879738946)
,p_name=>'P1021_START_DATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(27391106697487289)
,p_prompt=>'Start'
,p_format_mask=>'&DATE_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'ITEM'
,p_attribute_08=>'P1021_END_DATE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19912193098741148)
,p_name=>'P1021_END_DATE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(27391106697487289)
,p_prompt=>'End'
,p_format_mask=>'&DATE_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'ITEM'
,p_attribute_05=>'P1021_START_DATE'
,p_attribute_06=>'STATIC'
,p_attribute_07=>'&P1021_MAX_DATE.'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23307276623666730)
,p_name=>'P1021_MAX_DATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(27391106697487289)
,p_source=>'return trunc(sysdate) - 1;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(19910422249733529)
,p_name=>'Show/Hide Custom'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1021_SINCE'
,p_condition_element=>'P1021_SINCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'100'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19910800669733532)
,p_event_id=>wwv_flow_imp.id(19910422249733529)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1021_START_DATE,P1021_END_DATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19911320686733532)
,p_event_id=>wwv_flow_imp.id(19910422249733529)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1021_START_DATE,P1021_END_DATE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20311668563830618)
,p_name=>'Refresh Region'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(23395125090901454)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20312040199830623)
,p_event_id=>wwv_flow_imp.id(20311668563830618)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-region'
);
end;
/
prompt --application/pages/page_01024
begin
wwv_flow_imp_page.create_page(
 p_id=>1024
,p_name=>'Page Events'
,p_alias=>'PAGE-EVENTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Page Events'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20001636574064315)
,p_plug_name=>'Page Events'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="white-space:nowrap;"'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select al.time_stamp as log_day,',
'       ws.short_name as workspace_name,',
'       f.id as application_id,',
'       f.name as application_name,',
'       al.step_id as page,',
'       al.session_id,',
'       al.debug_page_view_id,',
'       al.ip_address',
'  from wwv_flow_activity_log al,',
'       wwv_flow_companies    ws,',
'       wwv_flows              f,',
'       (select to_date(:P1024_LOG_DAY,''&DATE_FORMAT.'') as log_day_format',
'          from sys.dual )     d',
' where ws.provisioning_company_id = al.security_group_id',
'   and f.security_group_id = al.security_group_id',
'   and f.id = al.flow_id   ',
'   and al.flow_id not between 4000 and 4999',
'   and al.time_stamp >= log_day_format',
'   and al.time_stamp < log_day_format + 1',
'   and al.security_group_id = nvl(:P1024_WORKSPACE_ID, 0)'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1024_LOG_DAY,P1024_WORKSPACE_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Page Events'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(20001782268064316)
,p_no_data_found_message=>'No Page Events found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>20001782268064316
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18922825798096334)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>10
,p_column_identifier=>'AD'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18922444347096330)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'Z'
,p_column_label=>'Workspace Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18922572068096331)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>30
,p_column_identifier=>'AA'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18922644663096332)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>40
,p_column_identifier=>'AB'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18922718894096333)
,p_db_column_name=>'PAGE'
,p_display_order=>50
,p_column_identifier=>'AC'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20002506943064324)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>'Session ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20003705549064336)
,p_db_column_name=>'DEBUG_PAGE_VIEW_ID'
,p_display_order=>70
,p_column_identifier=>'T'
,p_column_label=>'Debug Page View ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20003866316064337)
,p_db_column_name=>'IP_ADDRESS'
,p_display_order=>80
,p_column_identifier=>'U'
,p_column_label=>'IP Address'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(23211423679001871)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'232115'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:WORKSPACE_NAME:APPLICATION_ID:APPLICATION_NAME:PAGE:SESSION_ID:DEBUG_PAGE_VIEW_ID:IP_ADDRESS:'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18922986187096335)
,p_name=>'P1024_WORKSPACE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20001636574064315)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20004352731064342)
,p_name=>'P1024_LOG_DAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20001636574064315)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01025
begin
wwv_flow_imp_page.create_page(
 p_id=>1025
,p_name=>'Events'
,p_alias=>'EVENTS'
,p_step_title=>'Events'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26405112650521808)
,p_plug_name=>'Events'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select e.log_timestamp,',
'       e.log_day,',
'       e.username,',
'       et.category_name,',
'       et.event_static_id,',
'       e.attributes_values_json as json_col,',
'       wwv_flow_event_metrics_int.get_event_message(',
'           p_event_static_id  => et.event_static_id,',
'           p_attribute_values => e.attributes_values_json ) as message,',
'       e.session_id,',
'       e.database_session_id,',
'       e.instance_id      ',
'  from wwv_flow_events_log e,',
'       wwv_flow_event_types et',
' where et.id = e.event_type_id',
'           ',
'',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Events'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(26405290405521809)
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>26405290405521809
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26405337382521810)
,p_db_column_name=>'LOG_TIMESTAMP'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Log Timestamp'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17574990072551804)
,p_db_column_name=>'USERNAME'
,p_display_order=>30
,p_column_identifier=>'U'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17574820718551803)
,p_db_column_name=>'CATEGORY_NAME'
,p_display_order=>40
,p_column_identifier=>'T'
,p_column_label=>'Category Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17574793892551802)
,p_db_column_name=>'EVENT_STATIC_ID'
,p_display_order=>50
,p_column_identifier=>'S'
,p_column_label=>'Event Static ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17576269652551817)
,p_db_column_name=>'MESSAGE'
,p_display_order=>90
,p_column_identifier=>'V'
,p_column_label=>'Message'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17576398658551818)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>100
,p_column_identifier=>'W'
,p_column_label=>'Session ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26405914274521816)
,p_db_column_name=>'DATABASE_SESSION_ID'
,p_display_order=>110
,p_column_identifier=>'G'
,p_column_label=>'Database Session ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17576493757551819)
,p_db_column_name=>'INSTANCE_ID'
,p_display_order=>120
,p_column_identifier=>'X'
,p_column_label=>'Instance ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21010334640759835)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>130
,p_column_identifier=>'Y'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21011028741759842)
,p_db_column_name=>'JSON_COL'
,p_display_order=>140
,p_column_identifier=>'AA'
,p_column_label=>'JSON Column'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'CLOB'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(27210271442044337)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'272103'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_TIMESTAMP:USERNAME:CATEGORY_NAME:MESSAGE:SESSION_ID:DATABASE_SESSION_ID:INSTANCE_ID:'
,p_sort_column_1=>'LOG_TIMESTAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225629430724241085)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Events report displays the workspace events performed within an APEX request or via APEX public APIs.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01026
begin
wwv_flow_imp_page.create_page(
 p_id=>1026
,p_name=>'Configure Email Restrictions'
,p_alias=>'CONFIGURE-EMAIL-RESTRICTIONS'
,p_step_title=>'Configure Email Restrictions'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26407351339521830)
,p_plug_name=>'Block List'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with email_patterns_check as (',
'    select c.short_name as workspace_name,',
'           u.alt as email_address',
'      from wwv_flow_workspace_users u,',
'           wwv_flow_companies c',
'     where c.provisioning_company_id = u.workspace_id )',
'select id,',
'       block_pattern,',
'       comments,',
'       case when (select count(*)',
'                    from email_patterns_check',
'                   where upper(email_address) like upper(block_pattern) ) > 0',
'                then to_char((select count(*)',
'                                from email_patterns_check',
'                               where upper(email_address) like upper(block_pattern) ))',
'            else ''0''',
'       end as invalid_email_patterns_cnt,',
'       created_on,',
'       created_by,',
'       last_updated_on,',
'       last_updated_by',
'  from wwv_flow_prov_email_patterns'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Block List'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(18153458119147043)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Patterns found.'
,p_max_rows_per_page=>'50'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>18153458119147043
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18153597015147044)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19977599220203401)
,p_db_column_name=>'BLOCK_PATTERN'
,p_display_order=>20
,p_column_identifier=>'J'
,p_column_label=>'Pattern'
,p_column_link=>'f?p=&APP_ID.:1034:&SESSION.::&DEBUG.:1034:P1034_ID:#ID#'
,p_column_linktext=>'#BLOCK_PATTERN#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18153712924147046)
,p_db_column_name=>'COMMENTS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18920344371096309)
,p_db_column_name=>'INVALID_EMAIL_PATTERNS_CNT'
,p_display_order=>40
,p_column_identifier=>'I'
,p_column_label=>'Matches'
,p_column_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:12,RIR:IRLIKE_EMAIL:#BLOCK_PATTERN#'
,p_column_linktext=>'#INVALID_EMAIL_PATTERNS_CNT#'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18153806648147047)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Created On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18153935731147048)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18154053986147049)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Last Updated On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18154153664147050)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Last Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(18915027406988502)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'189151'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'BLOCK_PATTERN:COMMENTS:CREATED_ON:CREATED_BY:LAST_UPDATED_ON:LAST_UPDATED_BY:INVALID_EMAIL_PATTERNS_CNT:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(178876054655205513)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Add restrictions for email patterns used to auto/self provision a workspace.</p>',
'<p>Block email patterns should be saved in the following format: <strong>%@example.com</strong> </p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18919581635096301)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(26407351339521830)
,p_button_name=>'ADD_PATTERN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Pattern'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1034:&SESSION.::&DEBUG.:1034::'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18920788789096313)
,p_name=>'Refresh on Create/Edit'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(26407351339521830)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18920809404096314)
,p_event_id=>wwv_flow_imp.id(18920788789096313)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Block List'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(26407351339521830)
);
end;
/
prompt --application/pages/page_01027
begin
wwv_flow_imp_page.create_page(
 p_id=>1027
,p_name=>'System Scheduler Jobs'
,p_alias=>'SYSTEM-SCHEDULER-JOBS'
,p_step_title=>'System Scheduler Jobs'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.job-action {',
'white-space: pre-line;',
'font-family: SFMono-Regular, Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace;',
'font-size: 11px;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(54807944848281028)
,p_plug_name=>'System Scheduler Jobs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="white-space:nowrap;"'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,',
'       job_name,',
'       job_type,',
'       job_action,',
'       start_date,',
'       repeat_interval,',
'       enabled,',
'       auto_drop,',
'       state,',
'       job_priority,',
'       run_count,',
'       failure_count,',
'       last_start_date,',
'       last_run_duration,',
'       next_run_date,',
'       instance_id,',
'       comments',
'  from sys.dba_scheduler_jobs',
' where owner in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'System Scheduler Jobs'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(54808065480281029)
,p_max_rows_per_page=>'20'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>54808065480281029
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38005769136853425)
,p_db_column_name=>'OWNER'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38006169588853430)
,p_db_column_name=>'JOB_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Job Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38006503380853430)
,p_db_column_name=>'JOB_TYPE'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Job Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38006917142853430)
,p_db_column_name=>'JOB_ACTION'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Job Action'
,p_column_html_expression=>'<span class="job-action">#JOB_ACTION#</span>'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38007362015853431)
,p_db_column_name=>'START_DATE'
,p_display_order=>160
,p_column_identifier=>'P'
,p_column_label=>'Start Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38007728958853431)
,p_db_column_name=>'REPEAT_INTERVAL'
,p_display_order=>170
,p_column_identifier=>'Q'
,p_column_label=>'Repeat Interval'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38008189176853432)
,p_db_column_name=>'ENABLED'
,p_display_order=>270
,p_column_identifier=>'AA'
,p_column_label=>'Enabled'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38008588563853432)
,p_db_column_name=>'AUTO_DROP'
,p_display_order=>280
,p_column_identifier=>'AB'
,p_column_label=>'Auto Drop'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38008914449853433)
,p_db_column_name=>'STATE'
,p_display_order=>310
,p_column_identifier=>'AE'
,p_column_label=>'State'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38009375680853433)
,p_db_column_name=>'JOB_PRIORITY'
,p_display_order=>320
,p_column_identifier=>'AF'
,p_column_label=>'Job Priority'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38009783963853433)
,p_db_column_name=>'RUN_COUNT'
,p_display_order=>330
,p_column_identifier=>'AG'
,p_column_label=>'Run Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38010138719853433)
,p_db_column_name=>'FAILURE_COUNT'
,p_display_order=>360
,p_column_identifier=>'AJ'
,p_column_label=>'Failure Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38010512877853433)
,p_db_column_name=>'LAST_START_DATE'
,p_display_order=>400
,p_column_identifier=>'AN'
,p_column_label=>'Last Start Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38010917062853434)
,p_db_column_name=>'LAST_RUN_DURATION'
,p_display_order=>410
,p_column_identifier=>'AO'
,p_column_label=>'Last Run Duration'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'OTHER'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38011343710853434)
,p_db_column_name=>'NEXT_RUN_DATE'
,p_display_order=>420
,p_column_identifier=>'AP'
,p_column_label=>'Next Run Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38011714501853434)
,p_db_column_name=>'INSTANCE_ID'
,p_display_order=>590
,p_column_identifier=>'BG'
,p_column_label=>'Instance ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38012126134853434)
,p_db_column_name=>'COMMENTS'
,p_display_order=>620
,p_column_identifier=>'BJ'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(55831864397559354)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'178265'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>20
,p_report_columns=>'OWNER:JOB_NAME:JOB_TYPE:JOB_ACTION:START_DATE:REPEAT_INTERVAL:ENABLED:AUTO_DROP:STATE:JOB_PRIORITY:RUN_COUNT:FAILURE_COUNT:LAST_START_DATE:LAST_RUN_DURATION:NEXT_RUN_DATE:INSTANCE_ID:COMMENTS'
,p_break_on=>'0:0:0:0:0'
,p_break_enabled_on=>'0:0:0:0:0'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(357255041082393550)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>The report displays all system jobs used on the instance.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01028
begin
wwv_flow_imp_page.create_page(
 p_id=>1028
,p_name=>'Instance Failed Jobs'
,p_alias=>'INSTANCE-FAILED-JOBS'
,p_step_title=>'Instance Failed Jobs'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57636413967256869)
,p_plug_name=>'Failed Jobs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select job_name,',
'       log_date,',
'       status,',
'       actual_start_date,',
'       run_duration,',
'       cpu_used',
'  from sys.dba_scheduler_job_run_details',
' where owner in (''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'   and status = ''FAILED''',
'   --and trunc(log_date) >= trunc(sysdate) - 6'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Failed Jobs'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(57636544458256870)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>57636544458256870
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38015208258926739)
,p_db_column_name=>'JOB_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Job Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38015609602926739)
,p_db_column_name=>'LOG_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Log Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38016001925926739)
,p_db_column_name=>'STATUS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38016440259926740)
,p_db_column_name=>'ACTUAL_START_DATE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Actual Start Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38016874939926740)
,p_db_column_name=>'RUN_DURATION'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Run Duration'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'OTHER'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(38017251280926740)
,p_db_column_name=>'CPU_USED'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'CPU Used'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'OTHER'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(57698708483738914)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'196838'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'JOB_NAME:LOG_DATE:STATUS:ACTUAL_START_DATE:RUN_DURATION:CPU_USED'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57637533757255675)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57640216397258327)
,p_plug_name=>'Jobs Trend'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(38018284981928187)
,p_region_id=>wwv_flow_imp.id(57640216397258327)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'on'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>false
,p_show_row=>false
,p_show_start=>false
,p_show_end=>false
,p_show_progress=>false
,p_show_baseline=>false
,p_legend_rendered=>'on'
,p_legend_title=>'Jobs Trend'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>false
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(38019997246928191)
,p_chart_id=>wwv_flow_imp.id(38018284981928187)
,p_seq=>10
,p_name=>'Successful Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) as jobs,',
'       to_char(log_date, ''MM/DD/YYYY'') as log_day',
'  from sys.dba_scheduler_job_run_details',
' where owner in (''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'   and status = ''SUCCEEDED''',
'group by to_char(log_date, ''MM/DD/YYYY'')'))
,p_items_value_column_name=>'JOBS'
,p_items_label_column_name=>'LOG_DAY'
,p_color=>'#1860cb'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(38020532161928192)
,p_chart_id=>wwv_flow_imp.id(38018284981928187)
,p_seq=>20
,p_name=>'Failed Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) as jobs,',
'       to_char(log_date, ''MM/DD/YYYY'') as log_day',
'  from sys.dba_scheduler_job_run_details',
' where owner in (''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'   and status = ''FAILED''',
'group by to_char(log_date, ''MM/DD/YYYY'')'))
,p_items_value_column_name=>'JOBS'
,p_items_label_column_name=>'LOG_DAY'
,p_color=>'#d43b3b'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(38018766531928188)
,p_chart_id=>wwv_flow_imp.id(38018284981928187)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(38019319819928189)
,p_chart_id=>wwv_flow_imp.id(38018284981928187)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_01029
begin
wwv_flow_imp_page.create_page(
 p_id=>1029
,p_name=>'Summary Dashboard'
,p_alias=>'SUMMARY-DASHBOARD'
,p_step_title=>'Summary Dashboard'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Report-cell[headers="DELTA"] {width: 96px; white-space: nowrap;}',
'.a-Report-cell[headers="ICON"]  {width: 20%;}',
'.a-Report-cell[headers="TOTAL"] {width: 20%;}',
'',
'/* Styling Header */',
'.dashboard-controls.a-ButtonRegion--withItems .apex-item-wrapper--single-checkbox  {',
'    margin: 4px 0;',
'}',
'.dashboard-controls.a-ButtonRegion--withItems .apex-col {',
'    margin-bottom: 0;',
'}',
'.dashboard-controls.a-ButtonRegion--withItems .apex-row {',
'    padding-bottom: 0;',
'}',
'.dashboard-controls.a-ButtonRegion--withItems .apex-item-wrapper--single-checkbox .a-Form-labelContainer {',
'    display: none;',
'}'))
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(13351402456757110)
,p_name=>'User Scheduler Jobs'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>75
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with jobs_stats_1x as (',
'    select sum(case when j.status in (''SUCCEEDED'', ''SUCCESS'') then 1 else 0 end ) as successful_jobs_total,',
'           sum(case when j.status in (''FAILED'', ''NO_ACTION'', ''INCOMPLETE'', ''FAILURE'', ''ABORTED'') then 1 else 0 end )    as failed_jobs_total',
'      from (',
'          select distinct jd.owner,',
'                 jd.job_name,',
'                 jd.status',
'            from sys.dba_scheduler_job_run_details jd',
'           where jd.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'             and jd.owner not in (select username',
'                                    from sys.dba_users',
'                                   where oracle_maintained = ''Y'')',
'             and jd.log_date between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'          union all ',
'          select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'                 to_char(al.automation_id),',
'                 al.status',
'            from wwv_flow_automation_log al',
'          where al.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'          union all',
'          select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'                 to_char(sl.web_src_module_id),',
'                 sl.status',
'            from wwv_flow_websource_sync_log sl',
'           where sl.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'             ) j ),',
'jobs_stats_2x as (',
'    select sum(case when j.status in (''SUCCEEDED'', ''SUCCESS'') then 1 else 0 end ) as successful_jobs_total,',
'           sum(case when j.status in (''FAILED'', ''NO_ACTION'', ''INCOMPLETE'', ''FAILURE'', ''ABORTED'') then 1 else 0 end )    as failed_jobs_total',
'      from (',
'          select distinct jd.owner,',
'                 jd.job_name,',
'                 jd.status',
'            from sys.dba_scheduler_job_run_details jd',
'           where jd.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'             and jd.owner not in (select username',
'                                    from sys.dba_users',
'                                   where oracle_maintained = ''Y'')',
'             and jd.log_date between to_timestamp(:P1029_START_TIME_INTERVAL_2X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_2X, ''&DATE_TIME_FORMAT.'')',
'          union all ',
'          select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'                 to_char(al.automation_id),',
'                 al.status',
'            from wwv_flow_automation_log al',
'          where al.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_2X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_2X, ''&DATE_TIME_FORMAT.'')                                                                 ',
'          union all',
'          select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'                 to_char(sl.web_src_module_id),',
'                 sl.status',
'            from wwv_flow_websource_sync_log sl',
'           where sl.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_2X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_2X, ''&DATE_TIME_FORMAT.'')                                                                 ',
'            ) j )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                 as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_SUCCESSJOBS'')     as stats_category,',
'           null                                                              as label_class,',
'           nvl(b.successful_jobs_total, 0)                                   as total,',
'           nvl(b.successful_jobs_total, 0) - nvl(d.successful_jobs_total, 0) as delta',
'      from jobs_stats_1x b,',
'           jobs_stats_2x d',
'    union all',
'    select 2                                                            as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_FAILEDJOBS'') as stats_category,',
'           null                                                         as label_class,',
'           nvl(b.failed_jobs_total, 0)                                  as total,',
'           nvl(b.failed_jobs_total, 0) - nvl(d.failed_jobs_total, 0)    as delta',
'      from jobs_stats_1x b,',
'           jobs_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150792245147016)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150804627147017)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_html_expression=>'#TOTAL#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150937011147018)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17876173484529911)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18151052407147019)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18151137719147020)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18151265420147021)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23304737141666705)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32947234040421605)
,p_plug_name=>'Jobs - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(13351402456757110)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>40
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(13325269692091467)
,p_region_id=>wwv_flow_imp.id(32947234040421605)
,p_chart_type=>'lineWithArea'
,p_height=>'180'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(13326985883091469)
,p_chart_id=>wwv_flow_imp.id(13325269692091467)
,p_seq=>10
,p_name=>'Successful Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day      as jobs_label,',
'       count(job_name) as jobs_value',
'  from (',
'        select distinct jd.owner,',
'               jd.job_name,',
'               trunc(jd.log_date) as log_date',
'         from sys.dba_scheduler_job_run_details jd',
'        where jd.status = ''SUCCEEDED''',
'          and jd.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'          and jd.owner not in (select username',
'                                 from sys.dba_users',
'                                where oracle_maintained = ''Y'')',
'          and jd.log_date between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'    union all',
'    select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'           to_char(al.automation_id),',
'           trunc(al.start_timestamp)',
'      from wwv_flow_automation_log al',
'     where al.status = ''SUCCESS''              ',
'       and al.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'    union all',
'    select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'           to_char(sl.web_src_module_id),',
'           trunc(sl.start_timestamp)',
'      from wwv_flow_websource_sync_log sl',
'     where sl.status = ''SUCCESS''              ',
'      and sl.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'        ) j,',
'       day_gen dg       ',
' where dg.log_day = j.log_date (+)',
'group by dg.log_day',
'order by 1',
''))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'JOBS_VALUE'
,p_items_label_column_name=>'JOBS_LABEL'
,p_color=>'#508223'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162087719007715309)
,p_chart_id=>wwv_flow_imp.id(13325269692091467)
,p_seq=>20
,p_name=>'Successful Jobs - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as jobs_label,',
'       count(job_name)    as jobs_value',
'  from (',
'        select distinct jd.owner,',
'               jd.job_name,',
'               trunc(jd.log_date) as log_date',
'         from sys.dba_scheduler_job_run_details jd',
'        where jd.status = ''SUCCEEDED''',
'          and jd.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'          and jd.owner not in (select username',
'                                 from sys.dba_users',
'                                where oracle_maintained = ''Y'')',
'          and jd.log_date between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'    union all',
'    select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'           to_char(al.automation_id),',
'           trunc(al.start_timestamp)',
'      from wwv_flow_automation_log al',
'     where al.status = ''SUCCESS''              ',
'       and al.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'    union all',
'    select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'           to_char(sl.web_src_module_id),',
'           trunc(sl.start_timestamp)',
'      from wwv_flow_websource_sync_log sl',
'     where sl.status = ''SUCCESS''              ',
'      and sl.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'        ) j       ',
' where j.log_date = trunc(sysdate) - 2',
''))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'JOBS_VALUE'
,p_items_label_column_name=>'JOBS_LABEL'
,p_color=>'#508223'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(13327517480091470)
,p_chart_id=>wwv_flow_imp.id(13325269692091467)
,p_seq=>30
,p_name=>'Failed Jobs'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day      as jobs_label,',
'       count(job_name) as jobs_value',
'  from (',
'        select distinct jd.owner,',
'               jd.job_name,',
'               trunc(jd.log_date) as log_date',
'         from sys.dba_scheduler_job_run_details jd',
'        where jd.status = ''FAILED''',
'          and jd.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'          and jd.owner not in (select username',
'                                 from sys.dba_users',
'                                where oracle_maintained = ''Y'')',
'          and jd.log_date between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'    union all',
'    select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'           to_char(al.automation_id),',
'           trunc(al.start_timestamp)',
'      from wwv_flow_automation_log al',
'     where al.status in (''NO_ACTION'', ''INCOMPLETE'', ''FAILURE'', ''ABORTED'')              ',
'       and al.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'    union all',
'    select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'           to_char(sl.web_src_module_id),',
'           trunc(sl.start_timestamp)',
'      from wwv_flow_websource_sync_log sl',
'     where sl.status in (''INCOMPLETE'', ''FAILURE'', ''ABORTED'')              ',
'      and sl.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'        ) j,',
'       day_gen dg       ',
' where dg.log_day = j.log_date (+)',
'group by dg.log_day',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'JOBS_VALUE'
,p_items_label_column_name=>'JOBS_LABEL'
,p_color=>'#d63b25'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162087893398715310)
,p_chart_id=>wwv_flow_imp.id(13325269692091467)
,p_seq=>40
,p_name=>'Failed Jobs - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as jobs_label,',
'       count(job_name)    as jobs_value',
'  from (',
'        select distinct jd.owner,',
'               jd.job_name,',
'               trunc(jd.log_date) as log_date',
'         from sys.dba_scheduler_job_run_details jd',
'        where jd.status = ''FAILED''',
'          and jd.owner not in (''ORDS_METADATA'', ''SYS'', sys_context(''USERENV'',''CURRENT_USER''))',
'          and jd.owner not in (select username',
'                                 from sys.dba_users',
'                                where oracle_maintained = ''Y'')',
'          and jd.log_date between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'    union all',
'    select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'           to_char(al.automation_id),',
'           trunc(al.start_timestamp)',
'      from wwv_flow_automation_log al',
'     where al.status in (''NO_ACTION'', ''INCOMPLETE'', ''FAILURE'', ''ABORTED'')              ',
'       and al.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'    union all',
'    select distinct sys_context(''USERENV'',''CURRENT_USER''),',
'           to_char(sl.web_src_module_id),',
'           trunc(sl.start_timestamp)',
'      from wwv_flow_websource_sync_log sl',
'     where sl.status in (''INCOMPLETE'', ''FAILURE'', ''ABORTED'')              ',
'      and sl.start_timestamp between to_timestamp(:P1029_START_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'') and to_timestamp(:P1029_END_TIME_INTERVAL_1X, ''&DATE_TIME_FORMAT.'')',
'        ) j       ',
' where j.log_date = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'JOBS_VALUE'
,p_items_label_column_name=>'JOBS_LABEL'
,p_color=>'#d63b25'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(13325775006091468)
,p_chart_id=>wwv_flow_imp.id(13325269692091467)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(13326306333091468)
,p_chart_id=>wwv_flow_imp.id(13325269692091467)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(16512368767229525)
,p_name=>'Emails'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>120
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messaging_stats as (',
'    select ',
'        sum(case when m.mail_message_created between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                        as created,',
'        sum(case when m.mail_message_created between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                        as created_interval,',
'        sum(case when m.mail_message_send_end between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                        as send_end,',
'        sum(case when m.mail_message_send_end between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                        as send_end_interval,',
'        sum(case when m.mail_send_error is not null',
'                  and m.mail_message_created between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                 then 1',
'                else 0',
'            end )                                                                                                        as mail_errors,',
'        sum(case when m.mail_send_error is not null',
'                  and m.mail_message_created between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end)                                                                                                         as mail_errors_interval',
'    from wwv_flow_mail_log m ),',
'messaging_queue_stats as (',
'    select ',
'        sum(case when m.mail_message_created between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end)                                                                                                        as created,',
'        sum(case when m.mail_message_created between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                       as created_interval',
'      from wwv_flow_mail_queue m )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                               as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_EMAIL_CREATED'') as stats_category,',
'           null                                                            as label_class,',
'           nvl(created, 0)                                                 as total,',
'           nvl(created, 0) - nvl(created_interval, 0)                      as delta',
'      from messaging_stats',
'    union all     ',
'    select 2                                                              as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_EMAIL_QUEUED'') as stats_category,',
'           null                                                           as label_class,',
'           nvl(created, 0)                                                as total,',
'           null                                                           as delta',
'      from messaging_queue_stats',
'    union all ',
'    select 3                                                            as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_EMAIL_SENT'') as stats_category,',
'           null                                                         as label_class,',
'           nvl(send_end, 0)                                             as total,',
'           nvl(send_end, 0) - nvl(send_end_interval, 0)                 as delta',
'      from messaging_stats',
'    union all ',
'    select 4                                                       as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_ERROR'') as stats_category,',
'           ''u-danger-text''                                         as label_class,',
'           nvl(mail_errors, 0)                                     as total,',
'           nvl(mail_errors, 0) - nvl(mail_errors_interval, 0)      as delta',
'      from messaging_stats )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(16512368767229525)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150143056147010)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150285476147011)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150309698147012)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17877483568529924)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150494791147013)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150524684147014)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150613239147015)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305241206666710)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16512736491229529)
,p_plug_name=>'Emails Sent - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(16512368767229525)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>30
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(16512870029229530)
,p_region_id=>wwv_flow_imp.id(16512736491229529)
,p_chart_type=>'lineWithArea'
,p_height=>'180'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(16512933421229531)
,p_chart_id=>wwv_flow_imp.id(16512870029229530)
,p_seq=>10
,p_name=>'Email Sent'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day as emails_label,',
'       nvl(sum(wm.emails_sent_cnt), 0) as emails_value   ',
'  from wwv_workspace_aggr_metrics wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'group by dg.log_day',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'EMAILS_VALUE'
,p_items_label_column_name=>'EMAILS_LABEL'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088738100715319)
,p_chart_id=>wwv_flow_imp.id(16512870029229530)
,p_seq=>20
,p_name=>'Email Sent - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as emails_label,',
'       nvl(sum(wm.emails_sent_cnt), 0) as emails_value   ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'EMAILS_VALUE'
,p_items_label_column_name=>'EMAILS_LABEL'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(16513110780229533)
,p_chart_id=>wwv_flow_imp.id(16512870029229530)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(16513049748229532)
,p_chart_id=>wwv_flow_imp.id(16512870029229530)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(17577741369551832)
,p_name=>'APEX Repository User Accounts'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>100
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with user_accounts_stats_1x as (',
'    select max(wm.admin_user_accounts_cnt) + max(wm.dev_user_accounts_cnt) + max(wm.end_user_accounts_cnt) as user_accounts_total,',
'           max(wm.admin_user_accounts_cnt)                                                                 as admin_user_accounts_cnt,',
'           max(wm.dev_user_accounts_cnt)                                                                   as dev_user_accounts_cnt,',
'           max(wm.end_user_accounts_cnt)                                                                   as end_user_accounts_cnt,',
'           wm.workspace_name',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'  group by wm.workspace_name ),',
'user_accounts_stats_2x as (',
'    select max(wm.admin_user_accounts_cnt) + max(wm.dev_user_accounts_cnt) + max(wm.end_user_accounts_cnt) as user_accounts_total,',
'           max(wm.admin_user_accounts_cnt)                                                                 as admin_user_accounts_cnt,',
'           max(wm.dev_user_accounts_cnt)                                                                   as dev_user_accounts_cnt,',
'           max(wm.end_user_accounts_cnt)                                                                   as end_user_accounts_cnt,',
'           wm.workspace_name',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'  group by wm.workspace_name )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                               as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_ADMIN_ACCOUNT'')                 as stats_category,',
'           null                                                                            as label_class,',
'           nvl(sum(b.admin_user_accounts_cnt), 0)                                          as total,',
'           nvl(sum(b.admin_user_accounts_cnt), 0) - nvl(sum(d.admin_user_accounts_cnt), 0) as delta',
'      from user_accounts_stats_1x b,',
'           user_accounts_stats_2x d',
'     where b.workspace_name = d.workspace_name (+)',
'    union all',
'    select 2                                                                           as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_DEV_ACCOUNT'')               as stats_category,',
'           null                                                                        as label_class,',
'           nvl(sum(b.dev_user_accounts_cnt), 0)                                        as total,',
'           nvl(sum(b.dev_user_accounts_cnt), 0) - nvl(sum(d.dev_user_accounts_cnt), 0) as delta',
'      from user_accounts_stats_1x b,',
'           user_accounts_stats_2x d',
'     where b.workspace_name = d.workspace_name (+)                ',
'    union all',
'    select 3                                                                           as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_ENDUSER_ACCOUNT'')           as stats_category,',
'           null                                                                        as label_class,',
'           nvl(sum(b.end_user_accounts_cnt), 0)                                        as total,',
'           nvl(sum(b.end_user_accounts_cnt), 0) - nvl(sum(d.end_user_accounts_cnt), 0) as delta',
'      from user_accounts_stats_1x b,',
'           user_accounts_stats_2x d',
'     where b.workspace_name = d.workspace_name (+) )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17578996087551844)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17579018012551845)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17579549605551850)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17876977354529919)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17579235615551847)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17579341168551848)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17579414916551849)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23304914474666707)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17578197999551836)
,p_plug_name=>'User Accounts - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(17577741369551832)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>70
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(17578252840551837)
,p_region_id=>wwv_flow_imp.id(17578197999551836)
,p_chart_type=>'lineWithArea'
,p_height=>'180'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'on'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(17578376444551838)
,p_chart_id=>wwv_flow_imp.id(17578252840551837)
,p_seq=>10
,p_name=>'Administrator Accounts'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select user_accounts_label,',
'       user_accounts_value',
'   from (',
'    select dg.log_day as user_accounts_label,',
'           nvl(sum(admin_user_accounts_cnt), 0) as user_accounts_value     ',
'           from wwv_workspace_aggr_metrics wm,',
'                day_gen            dg',
'          where dg.log_day = wm.log_day (+)',
'            and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'    group by dg.log_day )',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_VALUE'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#35cfb8'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088293014715314)
,p_chart_id=>wwv_flow_imp.id(17578252840551837)
,p_seq=>20
,p_name=>'Administrator Accounts - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as user_accounts_label,',
'       nvl(sum(admin_user_accounts_cnt), 0) as user_accounts_value     ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_VALUE'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#35cfb8'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(17578487298551839)
,p_chart_id=>wwv_flow_imp.id(17578252840551837)
,p_seq=>30
,p_name=>'Developer Accounts'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select user_accounts_label,',
'       user_accounts_value',
'   from (',
'    select dg.log_day as user_accounts_label,',
'           nvl(sum(dev_user_accounts_cnt), 0) as user_accounts_value       ',
'           from wwv_workspace_aggr_metrics wm,',
'                day_gen                    dg',
'          where dg.log_day = wm.log_day (+)           ',
'            and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'    group by dg.log_day)',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_VALUE'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#8692de'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088338580715315)
,p_chart_id=>wwv_flow_imp.id(17578252840551837)
,p_seq=>40
,p_name=>'Developer Accounts - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as user_accounts_label,',
'       nvl(sum(dev_user_accounts_cnt), 0) as user_accounts_value       ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_VALUE'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#8692de'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(17578547136551840)
,p_chart_id=>wwv_flow_imp.id(17578252840551837)
,p_seq=>50
,p_name=>'End User Accounts'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select user_accounts_label,',
'       user_accounts_value',
'   from (',
'    select dg.log_day as user_accounts_label,',
'           nvl(sum(end_user_accounts_cnt), 0) as user_accounts_value       ',
'           from wwv_workspace_aggr_metrics wm,',
'                day_gen                    dg',
'          where dg.log_day = wm.log_day (+)           ',
'            and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'    group by dg.log_day)',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_VALUE'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#d88e51'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088490622715316)
,p_chart_id=>wwv_flow_imp.id(17578252840551837)
,p_seq=>60
,p_name=>'End User Accounts - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as user_accounts_label,',
'       nvl(sum(end_user_accounts_cnt), 0) as user_accounts_value       ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_VALUE'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#d88e51'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(17578637872551841)
,p_chart_id=>wwv_flow_imp.id(17578252840551837)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(17578735720551842)
,p_chart_id=>wwv_flow_imp.id(17578252840551837)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(17578847212551843)
,p_chart_id=>wwv_flow_imp.id(17578252840551837)
,p_axis=>'y2'
,p_is_rendered=>'off'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18017983079677901)
,p_name=>'Page Events'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>40
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with page_events_stats_1x as (',
'    select sum(page_events_cnt) as page_events_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'    ),',
'page_events_stats_2x as (',
'    select sum(page_events_cnt) as page_events_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date( :P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'    )     ',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                             as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_PAGE_EVENTS'') as stats_category,',
'           null                                                          as label_class,',
'           nvl(b.page_events_total, 0)                                   as total,',
'           nvl(b.page_events_total, 0) - nvl(d.page_events_total, 0)     as delta',
'      from page_events_stats_1x b,',
'           page_events_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(18017983079677901)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18018939042677911)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18019054443677912)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18019145998677913)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17876655955529916)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18019212195677914)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18019338337677915)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18019407466677916)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23304329271666701)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18018309223677905)
,p_plug_name=>'Page Events - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(18017983079677901)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(18018487530677906)
,p_region_id=>wwv_flow_imp.id(18018309223677905)
,p_chart_type=>'lineWithArea'
,p_height=>'180'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18018543865677907)
,p_chart_id=>wwv_flow_imp.id(18018487530677906)
,p_seq=>20
,p_name=>'Page Events'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select pe_label,',
'       pe_value',
'   from (',
'    select dg.log_day as pe_label,',
'           nvl(sum(wm.page_events_cnt), 0) as pe_value       ',
'      from wwv_workspace_aggr_metrics wm,',
'           day_gen                    dg',
'     where dg.log_day = wm.log_day (+)',
'       and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X  ',
'    group by dg.log_day )',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'PE_VALUE'
,p_items_label_column_name=>'PE_LABEL'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162087258366715304)
,p_chart_id=>wwv_flow_imp.id(18018487530677906)
,p_seq=>30
,p_name=>'Page Events - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as pe_label,',
'       nvl(sum(wm.page_events_cnt), 0) as pe_value  ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'PE_VALUE'
,p_items_label_column_name=>'PE_LABEL'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18018685151677908)
,p_chart_id=>wwv_flow_imp.id(18018487530677906)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18018716496677909)
,p_chart_id=>wwv_flow_imp.id(18018487530677906)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18018898492677910)
,p_chart_id=>wwv_flow_imp.id(18018487530677906)
,p_axis=>'y2'
,p_is_rendered=>'off'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18019537124677917)
,p_name=>'Login Attempts'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>70
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with connection_attempts_stats_1x as (',
'    select sum(login_cnt - failed_logins_cnt) as successful_login_total,',
'           sum(failed_logins_cnt)             as failed_login_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'    ),',
'connection_attempts_stats_2x as (',
'     select sum(login_cnt - failed_logins_cnt) as successful_login_total,',
'           sum(failed_logins_cnt)             as failed_login_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')     ',
'    )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                   as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_SUCCESSLOGIN'')      as stats_category,',
'           null                                                                as label_class,',
'           nvl(b.successful_login_total, 0)                                    as total,',
'           nvl(b.successful_login_total, 0) - nvl(d.successful_login_total, 0) as delta',
'      from connection_attempts_stats_1x b,',
'           connection_attempts_stats_2x d',
'    union all',
'    select 2                                                              as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_FAILEDLOGINS'') as stats_category,',
'           null                                                           as label_class,',
'           nvl(b.failed_login_total, 0)                                   as total,',
'           nvl(b.failed_login_total, 0) - nvl(d.failed_login_total, 0)    as delta',
'      from connection_attempts_stats_1x b,',
'           connection_attempts_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(18019537124677917)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18020594663677927)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18020651049677928)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18020757263677929)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17876821781529918)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18020848269677930)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18020957698677931)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18021084211677932)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23304601262666704)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18019975952677921)
,p_plug_name=>'Login Attempts - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(18019537124677917)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>40
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(18020031801677922)
,p_region_id=>wwv_flow_imp.id(18019975952677921)
,p_chart_type=>'lineWithArea'
,p_height=>'180'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18020183648677923)
,p_chart_id=>wwv_flow_imp.id(18020031801677922)
,p_seq=>10
,p_name=>'Successful Logins'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select sl_label,',
'       sl_value',
'   from (',
'    select dg.log_day as sl_label,',
'           nvl(sum(wm.login_cnt - wm.failed_logins_cnt), 0) as sl_value       ',
'      from wwv_workspace_aggr_metrics wm,',
'           day_gen                    dg',
'     where dg.log_day = wm.log_day (+)',
'       and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X ',
'    group by dg.log_day )',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SL_VALUE'
,p_items_label_column_name=>'SL_LABEL'
,p_color=>'#508223'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162087515941715307)
,p_chart_id=>wwv_flow_imp.id(18020031801677922)
,p_seq=>20
,p_name=>'Successful Logins - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as sl_label,',
'       nvl(sum(wm.login_cnt - wm.failed_logins_cnt), 0) as sl_value       ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SL_VALUE'
,p_items_label_column_name=>'SL_LABEL'
,p_color=>'#508223'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18020235500677924)
,p_chart_id=>wwv_flow_imp.id(18020031801677922)
,p_seq=>30
,p_name=>'Failed Logins'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day as fl_label,',
'       nvl(sum(wm.failed_logins_cnt), 0) as fl_value       ',
'  from wwv_workspace_aggr_metrics wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'  group by dg.log_day',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'FL_VALUE'
,p_items_label_column_name=>'FL_LABEL'
,p_color=>'#d63b25'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162087680947715308)
,p_chart_id=>wwv_flow_imp.id(18020031801677922)
,p_seq=>40
,p_name=>'Failed Logins - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as fl_label,',
'       nvl(sum(wm.failed_logins_cnt), 0) as fl_value       ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'FL_VALUE'
,p_items_label_column_name=>'FL_LABEL'
,p_color=>'#d63b25'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18020377484677925)
,p_chart_id=>wwv_flow_imp.id(18020031801677922)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18020408418677926)
,p_chart_id=>wwv_flow_imp.id(18020031801677922)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18021133280677933)
,p_name=>'Errors'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>140
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with errors_stats_1x as (',
'    select sum(errors_cnt) as errors_cnt_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')    ',
'    ),',
'errors_stats_2x as (',
'    select sum(errors_cnt) as errors_cnt_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')    ',
'    )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                       as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_ERROR'') as stats_category,',
'           null                                                    as label_class,',
'           nvl(b.errors_cnt_total, 0)                              as total,',
'           nvl(b.errors_cnt_total, 0) - nvl(d.errors_cnt_total, 0) as delta',
'      from errors_stats_1x b,',
'           errors_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18022035071677942)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18022109636677943)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18022243358677944)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17877371891529923)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18022335141677945)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18022487124677946)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18022592685677947)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305360518666711)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18021560631677937)
,p_plug_name=>'Errors - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(18021133280677933)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>40
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(18021697117677938)
,p_region_id=>wwv_flow_imp.id(18021560631677937)
,p_chart_type=>'lineWithArea'
,p_height=>'280'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18021784455677939)
,p_chart_id=>wwv_flow_imp.id(18021697117677938)
,p_seq=>10
,p_name=>'Errors'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day as errors_label,',
'       nvl(sum(wm.errors_cnt), 0) as errors_value   ',
'  from wwv_workspace_aggr_metrics wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'group by dg.log_day',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_SINCE,P1029_START_DATE,P1029_END_DATE,P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'ERRORS_VALUE'
,p_items_label_column_name=>'ERRORS_LABEL'
,p_color=>'#d63b25'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088824418715320)
,p_chart_id=>wwv_flow_imp.id(18021697117677938)
,p_seq=>20
,p_name=>'Errors - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as errors_label,',
'       nvl(sum(wm.errors_cnt), 0) as errors_value   ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_SINCE,P1029_START_DATE,P1029_END_DATE,P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'ERRORS_VALUE'
,p_items_label_column_name=>'ERRORS_LABEL'
,p_color=>'#d63b25'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18021830454677940)
,p_chart_id=>wwv_flow_imp.id(18021697117677938)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18021962909677941)
,p_chart_id=>wwv_flow_imp.id(18021697117677938)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18022610633677948)
,p_name=>'Web Service Requests'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>50
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with web_service_req_stats_1x as (',
'    select sum(web_service_req_cnt) as web_service_req_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'    ),',
'web_service_req_stats_2x as (',
'    select sum(web_service_req_cnt) as web_service_req_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'    )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                 as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_WEBSRV_REQUESTS'') as stats_category,',
'           null                                                              as label_class,',
'           nvl(b.web_service_req_total, 0)                                   as total,',
'           nvl(b.web_service_req_total, 0) - nvl(d.web_service_req_total, 0) as delta',
'      from web_service_req_stats_1x b,',
'           web_service_req_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18102287804332107)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18102327536332108)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18102428600332109)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17876718898529917)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18102568190332110)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18102658792332111)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18102722389332112)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23304536530666703)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18151333550147022)
,p_plug_name=>'Web Service Requests - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(18022610633677948)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>10
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(18151400356147023)
,p_region_id=>wwv_flow_imp.id(18151333550147022)
,p_chart_type=>'lineWithArea'
,p_height=>'180'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18151501387147024)
,p_chart_id=>wwv_flow_imp.id(18151400356147023)
,p_seq=>10
,p_name=>'Web Service Requests'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select wbr_label,',
'       wbr_value',
'   from (',
'    select dg.log_day as wbr_label,',
'           nvl(sum(wm.web_service_req_cnt), 0) as wbr_value       ',
'      from wwv_workspace_aggr_metrics wm,',
'           day_gen                    dg',
'     where dg.log_day = wm.log_day (+)',
'       and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'    group by dg.log_day)',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'WBR_VALUE'
,p_items_label_column_name=>'WBR_LABEL'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162087470854715306)
,p_chart_id=>wwv_flow_imp.id(18151400356147023)
,p_seq=>20
,p_name=>'Web Service Requests - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as wbr_label,',
'       nvl(sum(wm.web_service_req_cnt), 0) as wbr_value       ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'WBR_VALUE'
,p_items_label_column_name=>'WBR_LABEL'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18151671041147025)
,p_chart_id=>wwv_flow_imp.id(18151400356147023)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18151702533147026)
,p_chart_id=>wwv_flow_imp.id(18151400356147023)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18151803735147027)
,p_chart_id=>wwv_flow_imp.id(18151400356147023)
,p_axis=>'y2'
,p_is_rendered=>'off'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18102833722332113)
,p_name=>'Applications'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>80
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_applications as (',
'    select sum(case when f.created_on between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                    then 1',
'                    else 0',
'               end) as apps_total_1x,',
'           sum(case when f.created_on between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                    then 1',
'                    else 0',
'               end ) as apps_total_2x,',
'           ws.short_name as workspace_name',
'      from wwv_flows           f,',
'           wwv_flow_companies ws',
'     where ws.provisioning_company_id = f.security_group_id',
'  group by ws.short_name ),',
'applications_stats_1x as (',
'    select sum(wm.created_apps_cnt) as created_apps_total,',
'           sum(wm.removed_apps_cnt) as removed_apps_total,',
'           wm.workspace_name',
'      from wwv_workspace_aggr_metrics wm',
'      where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'  group by wm.workspace_name ),',
'applications_stats_2x as (',
'    select sum(wm.created_apps_cnt) as created_apps_total,',
'           sum(wm.removed_apps_cnt) as removed_apps_total,',
'           wm.workspace_name',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'  group by wm.workspace_name )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                     as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_CREATED_APPS'')        as stats_category,',
'           null                                                                  as label_class,',
'           nvl(sum(b.created_apps_total), 0)                                     as total,',
'           nvl(sum(b.created_apps_total), 0) - nvl(sum(d.created_apps_total), 0) as delta',
'      from applications_stats_1x b,',
'           applications_stats_2x d',
'     where b.workspace_name = d.workspace_name',
'     union all',
'     select 2                                                                    as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_REMOVED_APPS'')        as stats_category,',
'           null                                                                  as label_class,',
'           nvl(sum(b.removed_apps_total), 0)                                     as total,',
'           nvl(sum(b.removed_apps_total), 0) - nvl(sum(d.removed_apps_total), 0) as delta',
'      from applications_stats_1x b,',
'           applications_stats_2x d',
'     where b.workspace_name = d.workspace_name',
'     union all',
'     select 3                                                                      as sort_order,',
'            wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_TOTAL_APPLICATIONS'')   as stats_category,',
'           null                                                                    as label_class,',
'           nvl(sum(ta.apps_total_1x), 0)                                           as total,',
'           nvl(sum(ta.apps_total_1x), 0) - nvl(sum(ta.apps_total_2x), 0)           as delta',
'      from total_applications ta )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(18102833722332113)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18103993856332124)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18104043465332125)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18104199585332126)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17877009957529920)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18104247371332127)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18104372753332128)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18104433389332129)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23304860621666706)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18103228839332117)
,p_plug_name=>'Applications - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(18102833722332113)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>60
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(18103362457332118)
,p_region_id=>wwv_flow_imp.id(18103228839332117)
,p_chart_type=>'lineWithArea'
,p_height=>'180'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'on'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18103459478332119)
,p_chart_id=>wwv_flow_imp.id(18103362457332118)
,p_seq=>10
,p_name=>'Created Applications'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day as app_label,',
'       nvl(sum(wm.created_apps_cnt), 0) as app_value       ',
'  from wwv_workspace_aggr_metrics wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'group by dg.log_day',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#508223'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162087968265715311)
,p_chart_id=>wwv_flow_imp.id(18103362457332118)
,p_seq=>20
,p_name=>'Created Applications - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as app_label,',
'       nvl(sum(wm.created_apps_cnt), 0) as app_value       ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#508223'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18103591122332120)
,p_chart_id=>wwv_flow_imp.id(18103362457332118)
,p_seq=>30
,p_name=>'Removed Applications'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day as app_label,',
'       sum(wm.removed_apps_cnt) as app_value       ',
'  from wwv_workspace_aggr_metrics wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'group by dg.log_day',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#d63b25'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088082002715312)
,p_chart_id=>wwv_flow_imp.id(18103362457332118)
,p_seq=>40
,p_name=>'Removed Applications - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as app_label,',
'       sum(wm.removed_apps_cnt) as app_value       ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#d63b25'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18103691466332121)
,p_chart_id=>wwv_flow_imp.id(18103362457332118)
,p_seq=>50
,p_name=>'Total Applications'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day as app_label,',
'       count(f.id) as app_value       ',
'  from wwv_flows   f,',
'       day_gen    dg',
' where dg.log_day = f.created_on (+)',
'   and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'group by dg.log_day',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088146708715313)
,p_chart_id=>wwv_flow_imp.id(18103362457332118)
,p_seq=>60
,p_name=>'Total Applications - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as app_label,',
'       count(f.id) as app_value       ',
'  from wwv_flows   f',
' where f.created_on = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18103850557332123)
,p_chart_id=>wwv_flow_imp.id(18103362457332118)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18103757848332122)
,p_chart_id=>wwv_flow_imp.id(18103362457332118)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18104536876332130)
,p_name=>'Sessions'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>100
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with distinct_sessions_stats_1x as (',
'    select sum(distinct_sessions_cnt) as distinct_sessions_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'    ),',
'distinct_sessions_stats_2x as (',
'    select sum(distinct_sessions_cnt) as distinct_sessions_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')    ',
'    )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                     as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_SESSIONS'')            as stats_category,',
'           null                                                                  as label_class,',
'           nvl(b.distinct_sessions_total, 0)                                     as total,',
'           nvl(b.distinct_sessions_total, 0) - nvl(d.distinct_sessions_total, 0) as delta',
'      from distinct_sessions_stats_1x b,',
'           distinct_sessions_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(18104536876332130)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18106353782332148)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18106487428332149)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18106573751332150)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17877246621529922)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18149244179147001)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18149315141147002)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18149404841147003)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305043043666708)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18104952741332134)
,p_plug_name=>'Sessions - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(18104536876332130)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>50
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(18105021785332135)
,p_region_id=>wwv_flow_imp.id(18104952741332134)
,p_chart_type=>'lineWithArea'
,p_height=>'180'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18105116562332136)
,p_chart_id=>wwv_flow_imp.id(18105021785332135)
,p_seq=>10
,p_name=>'Sessions'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day as session_label,',
'       nvl(sum(wm.distinct_sessions_cnt), 0) as session_value       ',
'  from wwv_workspace_aggr_metrics wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'group by dg.log_day',
'order by 1'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SESSION_VALUE'
,p_items_label_column_name=>'SESSION_LABEL'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088592347715317)
,p_chart_id=>wwv_flow_imp.id(18105021785332135)
,p_seq=>20
,p_name=>'Sessions - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as session_label,',
'       nvl(sum(wm.distinct_sessions_cnt), 0) as session_value       ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SESSION_VALUE'
,p_items_label_column_name=>'SESSION_LABEL'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18105267876332137)
,p_chart_id=>wwv_flow_imp.id(18105021785332135)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18105317883332138)
,p_chart_id=>wwv_flow_imp.id(18105021785332135)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18105459539332139)
,p_name=>'IP Addresses'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>110
,p_region_css_classes=>'js-refresh-report a-Region--dashBG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with distinct_ip_addresses_stats_1x as (',
'    select sum(distinct_ip_addresses_cnt) as distinct_ip_addresses_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')    ',
'    ),',
'distinct_ip_addresses_stats_2x as (',
'    select sum(distinct_ip_addresses_cnt) as distinct_ip_addresses_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.log_day between to_date(:P1029_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1029_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')     ',
'    )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                             as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_IP_ADDRESS'')                  as stats_category,',
'           null                                                                          as label_class,',
'           nvl(b.distinct_ip_addresses_total, 0)                                         as total,',
'           nvl(b.distinct_ip_addresses_total, 0) - nvl(d.distinct_ip_addresses_total, 0) as delta',
'      from distinct_ip_addresses_stats_1x b,',
'           distinct_ip_addresses_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_2X'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18149515346147004)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18149652386147005)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18149740219147006)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17877193678529921)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18149894400147007)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18149994481147008)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18150035145147009)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305161141666709)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18105816743332143)
,p_plug_name=>'IP Addresses - Chart'
,p_parent_plug_id=>wwv_flow_imp.id(18105459539332139)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>40
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(18105956277332144)
,p_region_id=>wwv_flow_imp.id(18105816743332143)
,p_chart_type=>'lineWithArea'
,p_height=>'180'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(18106058234332145)
,p_chart_id=>wwv_flow_imp.id(18105956277332144)
,p_seq=>10
,p_name=>'IP Addresses'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'    select nvl(sum(wm.distinct_ip_addresses_cnt), 0) as ip_addresses_value,',
'           dg.log_day as ip_addresses_label       ',
'      from wwv_workspace_aggr_metrics wm,',
'           day_gen                    dg',
'     where dg.log_day = wm.log_day (+)',
'       and dg.log_day between :P1029_START_TIME_INTERVAL_1X and :P1029_END_TIME_INTERVAL_1X',
'    group by dg.log_day',
'order by 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'IP_ADDRESSES_VALUE'
,p_items_label_column_name=>'IP_ADDRESSES_LABEL'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088600703715318)
,p_chart_id=>wwv_flow_imp.id(18105956277332144)
,p_seq=>20
,p_name=>'IP Addresses - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(sum(wm.distinct_ip_addresses_cnt), 0) as ip_addresses_value,',
'       trunc(sysdate) - 1 as ip_addresses_label       ',
'  from wwv_workspace_aggr_metrics wm',
' where wm.log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1029_START_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'IP_ADDRESSES_VALUE'
,p_items_label_column_name=>'IP_ADDRESSES_LABEL'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1029_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18106148034332146)
,p_chart_id=>wwv_flow_imp.id(18105956277332144)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(18106231794332147)
,p_chart_id=>wwv_flow_imp.id(18105956277332144)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41302176503673703)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Summary Dashboard displays the total metric values within the specified time interval.',
'The delta values show how individual metrics have changed from the preceding time interval -',
'in percent or absolute numbers. For example, the past seven days are compared with the',
'preceding seven days.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(183922726376711483)
,p_plug_name=>'Button Bar'
,p_region_css_classes=>'dashboard-controls'
,p_region_template_options=>'a-ButtonRegion--withItems:a-ButtonRegion--noUI:a-ButtonRegion--accessibleTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23350394339579691)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_button_name=>'SET'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'t-Button--noUI'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15412507890885377)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1029:&SESSION.::&DEBUG.:1029,RIR::'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15412938616885381)
,p_name=>'P1029_SINCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_platform.get_preference(',
'           p_preference_name => ''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'');'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ADMIN_DIGEST.RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct d, t from (',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.DAY'')          d,    1 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''2'' ) d,    2 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''7'' ) d,    7 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''15'') d,   15 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''30'') d,   30 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''45'') d,   45 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''60'') d,   60 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''90'') d,   90 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message (',
'           case default_reporting_period',
'                when 1 then ''APEX.TIME.DAY''',
'                else ''APEX.TIME.N_DAYS''',
'           end,',
'           default_reporting_period) as d,',
'       default_reporting_period as t',
'  from (select to_number(wwv_flow_platform.get_preference(''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'')) default_reporting_period',
'          from sys.dual)',
'union all',
'select wwv_flow_lang_dev.builder_message(''CUSTOM'') d, 100 t from sys.dual)',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17876287463529912)
,p_name=>'P1029_DELTA_PCT_YN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_item_default=>'Y'
,p_prompt=>'Display delta as percentage'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18921770134096323)
,p_name=>'P1029_START_DATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_prompt=>'Start'
,p_format_mask=>'MM/DD/YYYY'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'ITEM'
,p_attribute_08=>'P1029_END_DATE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18921805252096324)
,p_name=>'P1029_END_DATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_prompt=>'End'
,p_format_mask=>'MM/DD/YYYY'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'ITEM'
,p_attribute_05=>'P1029_START_DATE'
,p_attribute_06=>'ITEM'
,p_attribute_08=>'P1029_MAX_DATE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21007857120759810)
,p_name=>'P1029_START_TIME_INTERVAL_1X'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21008345376759815)
,p_name=>'P1029_START_TIME_INTERVAL_2X'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21010543920759837)
,p_name=>'P1029_END_TIME_INTERVAL_1X'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21011178320759843)
,p_name=>'P1029_END_TIME_INTERVAL_2X'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23307071434666728)
,p_name=>'P1029_MAX_DATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_source=>'return trunc(sysdate) - 1;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162087126607715303)
,p_name=>'P1029_LAST_DAY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(183922726376711483)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(162087392276715305)
,p_computation_sequence=>10
,p_computation_item=>'P1029_LAST_DAY'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(log_day)',
'  from wwv_workspace_aggr_metrics'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(17876322879529913)
,p_name=>'Toggle Delta Percent or Value'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(23350394339579691)
,p_condition_element=>'P1029_DELTA_PCT_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(17876442387529914)
,p_event_id=>wwv_flow_imp.id(17876322879529913)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".js-delta-pct").show();',
'apex.jQuery(".js-delta-value").hide();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(17876579971529915)
,p_event_id=>wwv_flow_imp.id(17876322879529913)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".js-delta-pct").hide();',
'apex.jQuery(".js-delta-value").show();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18922124842096327)
,p_name=>'Show/Hide Custom'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1029_SINCE'
,p_condition_element=>'P1029_SINCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'100'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18922236360096328)
,p_event_id=>wwv_flow_imp.id(18922124842096327)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show all dates'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1029_START_DATE,P1029_END_DATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18922327284096329)
,p_event_id=>wwv_flow_imp.id(18922124842096327)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide all dates'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1029_START_DATE,P1029_END_DATE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(17880046384529950)
,p_name=>'Refresh Regions'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(23350394339579691)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21673910093910607)
,p_event_id=>wwv_flow_imp.id(17880046384529950)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1029_START_TIME_INTERVAL_1X := case when :P1029_SINCE < 100 then trunc(sysdate) - nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD)',
'                                      when :P1029_SINCE = 100 then to_date( :P1029_START_DATE, ''&DATE_FORMAT.'')',
'                                 end;',
':P1029_END_TIME_INTERVAL_1X   := case when :P1029_SINCE < 100',
'                                          then',
'                                              case when :P1029_LAST_DAY = trunc(sysdate) - 1',
'                                                       then trunc(sysdate) - 1',
'                                                   else trunc(sysdate) - 2',
'                                              end                                  ',
'                                      when :P1029_SINCE = 100 then to_date( :P1029_END_DATE, ''&DATE_FORMAT.'')',
'                                 end;',
':P1029_START_TIME_INTERVAL_2X := case when :P1029_SINCE < 100 then trunc(sysdate) - nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD) * 2',
'                                      when :P1029_SINCE = 100 then to_date( :P1029_START_DATE, ''&DATE_FORMAT.'') - trunc(to_date( :P1029_END_DATE, ''&DATE_FORMAT.'') - to_date(:P1029_START_DATE, ''&DATE_FORMAT.''))',
'                                 end;',
':P1029_END_TIME_INTERVAL_2X := case when :P1029_SINCE < 100 then trunc(sysdate) - nvl(:P1029_SINCE, :AI_DEFAULT_REPORTING_PERIOD) - 1',
'                                    when :P1029_SINCE = 100 then to_date( :P1029_START_DATE, ''&DATE_FORMAT.'') - 1',
'                               end;'))
,p_attribute_02=>'P1029_SINCE,P1029_START_DATE,P1029_END_DATE'
,p_attribute_03=>'P1029_START_TIME_INTERVAL_1X,P1029_START_TIME_INTERVAL_2X,P1029_END_TIME_INTERVAL_1X,P1029_END_TIME_INTERVAL_2X'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23598895457863804)
,p_event_id=>wwv_flow_imp.id(17880046384529950)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Reports'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-report'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23598924224863805)
,p_event_id=>wwv_flow_imp.id(17880046384529950)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Charts'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-chart'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20711065510431121)
,p_name=>'Format Delta after Refresh'
,p_event_sequence=>60
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.js-refresh-chart, .js-refresh-report'
,p_condition_element=>'P1029_DELTA_PCT_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20711200740431123)
,p_event_id=>wwv_flow_imp.id(20711065510431121)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".js-delta-pct").show();',
'apex.jQuery(".js-delta-value").hide();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20711372035431124)
,p_event_id=>wwv_flow_imp.id(20711065510431121)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".js-delta-pct").hide();',
'apex.jQuery(".js-delta-value").show();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(23309168630666749)
,p_name=>'Refresh'
,p_event_sequence=>70
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20710878997431119)
,p_event_id=>wwv_flow_imp.id(23309168630666749)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Reports'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-report'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20710963567431120)
,p_event_id=>wwv_flow_imp.id(23309168630666749)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Charts'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-chart'
);
end;
/
prompt --application/pages/page_01030
begin
wwv_flow_imp_page.create_page(
 p_id=>1030
,p_name=>'Workspace Details'
,p_alias=>'WORKSPACE--DETAILS'
,p_step_title=>'Workspace Details'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Report-cell[headers="DELTA"] {width: 96px; white-space: nowrap;}',
'.a-Report-cell[headers="ICON"]  {width: 20%;}',
'.a-Report-cell[headers="TOTAL"] {width: 20%;}',
'',
'/* Styling Header */',
'.dashboard-controls.a-ButtonRegion--withItems .apex-item-wrapper--single-checkbox  {',
'    margin: 4px 0;',
'}',
'.dashboard-controls.a-ButtonRegion--withItems .apex-col {',
'    margin-bottom: 0;',
'}',
'.dashboard-controls.a-ButtonRegion--withItems .apex-row {',
'    padding-bottom: 0;',
'}',
'.dashboard-controls.a-ButtonRegion--withItems .apex-item-wrapper--single-checkbox .a-Form-labelContainer {',
'    display: none;',
'}'))
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13355214356757148)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19539330836219519)
,p_plug_name=>'Dashboard'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(36238108527875066)
,p_name=>'Emails'
,p_parent_plug_id=>wwv_flow_imp.id(19539330836219519)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>130
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with ',
'messaging_stats as (',
'    select ',
'        sum(case when m.mail_message_created between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                        as created,',
'        sum(case when m.mail_message_created between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                        as created_interval,',
'        sum(case when m.mail_message_send_end between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                        as send_end,',
'        sum(case when m.mail_message_send_end between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                        as send_end_interval,',
'        sum(case when m.mail_send_error is not null',
'                  and m.mail_message_created between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                then 1',
'                else 0',
'            end )                                                                                                        as mail_errors,',
'        sum(case when m.mail_send_error is not null',
'                  and m.mail_message_created between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end)                                                                                                        as mail_errors_interval',
'    from wwv_flow_mail_log m',
'   where m.security_group_id = :P1030_WORKSPACE_ID ),',
'messaging_queue_stats as (',
'    select ',
'        sum(case when m.mail_message_created between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end)                                                                                                        as created,',
'        sum(case when m.mail_message_created between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                 then 1',
'                 else 0',
'            end )                                                                                                       as created_interval',
'      from wwv_flow_mail_queue m',
'     where m.security_group_id = :P1030_WORKSPACE_ID )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                               as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_EMAIL_CREATED'') as stats_category,',
'           null                                                            as label_class,',
'           nvl(created, 0)                                                 as total,',
'           nvl(created, 0) - nvl(created_interval, 0)                      as delta',
'      from messaging_stats',
'    union all',
'    select 2                                                              as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_EMAIL_QUEUED'') as stats_category,',
'           null                                                           as label_class,',
'           nvl(created, 0)                                                as total,',
'           null                                                           as delta',
'      from messaging_queue_stats',
'    union all     ',
'    select 3                                                             as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_EMAIL_SENT'') as stats_category,',
'           null                                                          as label_class,',
'           nvl(send_end, 0)                                              as total,',
'           nvl(send_end, 0) - nvl(send_end_interval, 0)                  as delta',
'      from messaging_stats',
'    union all ',
'    select 4                                                      as sort_order,',
'          wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_ERROR'') as stats_category,',
'          ''u-danger-text''                                         as label_class,',
'           nvl(mail_errors, 0)                                    as total,',
'           nvl(mail_errors, 0) - nvl(mail_errors_interval, 0)     as delta',
'      from messaging_stats )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(36238108527875066)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19726452100645543)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19726828446645543)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19727279319645544)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19726087177645542)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19727656232645544)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19728033870645545)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19728442819645546)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23306274206666720)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(36238476251875070)
,p_plug_name=>'Emails Sent'
,p_parent_plug_id=>wwv_flow_imp.id(36238108527875066)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>200
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19729059745645547)
,p_region_id=>wwv_flow_imp.id(36238476251875070)
,p_chart_type=>'lineWithArea'
,p_height=>'200'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19730793989645548)
,p_chart_id=>wwv_flow_imp.id(19729059745645547)
,p_seq=>10
,p_name=>'Email Sent'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select nvl(wm.emails_sent_cnt, 0) as emails_value,',
'       dg.log_day as emails_label   ',
'  from (select emails_sent_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and ((:P1030_SINCE < 100 and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X)',
'    or (:P1030_SINCE = 100  and dg.log_day between :P1030_START_DATE and :P1030_END_DATE ) )',
'order by 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'EMAILS_VALUE'
,p_items_label_column_name=>'EMAILS_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162090223751715334)
,p_chart_id=>wwv_flow_imp.id(19729059745645547)
,p_seq=>20
,p_name=>'Email Sent - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select emails_sent_cnt as emails_value,',
'       trunc(sysdate) - 1 as emails_label',
'  from wwv_workspace_aggr_metrics',
' where workspace_id = :P1030_WORKSPACE_ID',
'   and log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'EMAILS_VALUE'
,p_items_label_column_name=>'EMAILS_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19729526511645547)
,p_chart_id=>wwv_flow_imp.id(19729059745645547)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19730195720645547)
,p_chart_id=>wwv_flow_imp.id(19729059745645547)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37130699813956908)
,p_name=>'APEX Repository User Accounts'
,p_parent_plug_id=>wwv_flow_imp.id(19539330836219519)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>120
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with user_accounts_stats_1x as (',
'    select max(wm.admin_user_accounts_cnt) + max(wm.dev_user_accounts_cnt) + max(wm.end_user_accounts_cnt) as user_accounts_total,',
'           max(wm.admin_user_accounts_cnt)                                                                 as admin_user_accounts_cnt,',
'           max(wm.dev_user_accounts_cnt)                                                                   as dev_user_accounts_cnt,',
'           max(wm.end_user_accounts_cnt)                                                                   as end_user_accounts_cnt',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') ),',
'user_accounts_stats_2x as (',
'    select max(wm.admin_user_accounts_cnt) + max(wm.dev_user_accounts_cnt) + max(wm.end_user_accounts_cnt) as user_accounts_total,',
'           max(wm.admin_user_accounts_cnt)                                                                 as admin_user_accounts_cnt,',
'           max(wm.dev_user_accounts_cnt)                                                                   as dev_user_accounts_cnt,',
'           max(wm.end_user_accounts_cnt)                                                                   as end_user_accounts_cnt',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
'  from (',
'    select 1                                                                               as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_ADMIN_ACCOUNT'')                 as stats_category,',
'           null                                                                            as label_class,',
'           nvl(sum(b.admin_user_accounts_cnt), 0)                                          as total,',
'           nvl(sum(b.admin_user_accounts_cnt), 0) - nvl(sum(d.admin_user_accounts_cnt), 0) as delta',
'      from user_accounts_stats_1x b,',
'           user_accounts_stats_2x d',
'    union all',
'    select 2                                                                           as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_DEV_ACCOUNT'')               as stats_category,',
'           null                                                                        as label_class,',
'           nvl(sum(b.dev_user_accounts_cnt), 0)                                        as total,',
'           nvl(sum(b.dev_user_accounts_cnt), 0) - nvl(sum(d.dev_user_accounts_cnt), 0) as delta',
'      from user_accounts_stats_1x b,',
'           user_accounts_stats_2x d                ',
'    union all',
'    select 3                                                                           as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_ENDUSER_ACCOUNT'')           as stats_category,',
'           null                                                                        as label_class,',
'           nvl(sum(b.end_user_accounts_cnt), 0)                                        as total,',
'           nvl(sum(b.end_user_accounts_cnt), 0) - nvl(sum(d.end_user_accounts_cnt), 0) as delta',
'      from user_accounts_stats_1x b,',
'           user_accounts_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19553683684405078)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19554092658405079)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19555626895405081)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19553294953405077)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19554458541405080)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19554873252405080)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19555235693405081)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23306147009666719)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32023450173223221)
,p_plug_name=>'User Accounts'
,p_parent_plug_id=>wwv_flow_imp.id(37130699813956908)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>140
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(16656646700311210)
,p_region_id=>wwv_flow_imp.id(32023450173223221)
,p_chart_type=>'lineWithArea'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(16658958154311213)
,p_chart_id=>wwv_flow_imp.id(16656646700311210)
,p_seq=>10
,p_name=>'Administrator Accounts'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select nvl(admin_user_accounts_cnt, 0) as user_accounts_total,',
'       dg.log_day as user_accounts_label',
'  from (select admin_user_accounts_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2',
'',
'       '))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_TOTAL'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089961816715331)
,p_chart_id=>wwv_flow_imp.id(16656646700311210)
,p_seq=>20
,p_name=>'Administrator Accounts - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select admin_user_accounts_cnt as user_accounts_total,',
'       trunc(sysdate) - 1 as user_accounts_label',
'  from wwv_workspace_aggr_metrics',
' where workspace_id = :P1030_WORKSPACE_ID',
'   and log_day = trunc(sysdate) - 2',
'       '))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_TOTAL'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(16659569947311214)
,p_chart_id=>wwv_flow_imp.id(16656646700311210)
,p_seq=>30
,p_name=>'Developer Accounts'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select nvl(wm.dev_user_accounts_cnt, 0) as user_accounts_total,',
'       dg.log_day as user_accounts_label',
'  from (select dev_user_accounts_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2',
'',
'       '))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_TOTAL'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162090036643715332)
,p_chart_id=>wwv_flow_imp.id(16656646700311210)
,p_seq=>40
,p_name=>'Developer Accounts - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dev_user_accounts_cnt as user_accounts_total,',
'       trunc(sysdate) - 1 as user_accounts_label',
'  from wwv_workspace_aggr_metrics',
' where workspace_id = :P1030_WORKSPACE_ID',
'   and log_day = trunc(sysdate) - 2',
'',
'       '))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_TOTAL'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#437c94'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(16660124095311214)
,p_chart_id=>wwv_flow_imp.id(16656646700311210)
,p_seq=>50
,p_name=>'End User Accounts'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select nvl(wm.end_user_accounts_cnt, 0) as user_accounts_total,',
'       dg.log_day as user_accounts_label',
'  from (select end_user_accounts_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2',
'',
'       '))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_TOTAL'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#e77076'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162090171356715333)
,p_chart_id=>wwv_flow_imp.id(16656646700311210)
,p_seq=>60
,p_name=>'End User Accounts - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select end_user_accounts_cnt as user_accounts_total,',
'       trunc(sysdate) - 1 as user_accounts_label',
'  from wwv_workspace_aggr_metrics',
' where workspace_id = :P1030_WORKSPACE_ID',
'   and log_day = trunc(sysdate) - 2',
'',
'       '))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'USER_ACCOUNTS_TOTAL'
,p_items_label_column_name=>'USER_ACCOUNTS_LABEL'
,p_color=>'#e77076'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(16657149722311211)
,p_chart_id=>wwv_flow_imp.id(16656646700311210)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(16657712121311212)
,p_chart_id=>wwv_flow_imp.id(16656646700311210)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(16658323737311212)
,p_chart_id=>wwv_flow_imp.id(16656646700311210)
,p_axis=>'y2'
,p_is_rendered=>'off'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37589456438215319)
,p_name=>'Page Events'
,p_parent_plug_id=>wwv_flow_imp.id(19539330836219519)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>50
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with page_events_stats_1x as (',
'    select sum(page_events_cnt) as page_events_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')    ',
'    ),',
'page_events_stats_2x as (',
'    select sum(page_events_cnt) as page_events_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')    ',
'    )     ',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'            else null',
'       end as label',
' from (',
'    select 1                                                             as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_PAGE_EVENTS'') as stats_category,',
'           null                                                          as label_class,',
'           nvl(b.page_events_total, 0)                                   as total,',
'           nvl(b.page_events_total, 0) - nvl(d.page_events_total, 0)     as delta',
'      from page_events_stats_1x b,',
'           page_events_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(37589456438215319)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19572129038537420)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19572509076537420)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19572966985537421)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19571733452537419)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19573328549537421)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19573743096537421)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19574192740537422)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305459873666712)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23617215763656563)
,p_plug_name=>'Page Events'
,p_parent_plug_id=>wwv_flow_imp.id(37589456438215319)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>60
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(13396913570650536)
,p_region_id=>wwv_flow_imp.id(23617215763656563)
,p_chart_type=>'lineWithArea'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(13399211108650540)
,p_chart_id=>wwv_flow_imp.id(13396913570650536)
,p_seq=>10
,p_name=>'Page Events'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'    select nvl(wm.page_events_cnt, 0) as page_events_total,',
'           dg.log_day as page_events_label',
'      from (select page_events_cnt,',
'                   log_day',
'              from wwv_workspace_aggr_metrics',
'             where workspace_id = :P1030_WORKSPACE_ID) wm,',
'           day_gen                    dg',
'     where dg.log_day = wm.log_day (+)',
'       and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2',
'',
'       '))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'PAGE_EVENTS_TOTAL'
,p_items_label_column_name=>'PAGE_EVENTS_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162088998543715321)
,p_chart_id=>wwv_flow_imp.id(13396913570650536)
,p_seq=>20
,p_name=>'Page Events - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_events_cnt as page_events_total,',
'       trunc(sysdate) - 1 as page_events_label',
'  from wwv_workspace_aggr_metrics',
' where workspace_id = :P1030_WORKSPACE_ID',
'   and log_day = trunc(sysdate) - 2',
'       '))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'PAGE_EVENTS_TOTAL'
,p_items_label_column_name=>'PAGE_EVENTS_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(13397419719650538)
,p_chart_id=>wwv_flow_imp.id(13396913570650536)
,p_axis=>'y2'
,p_is_rendered=>'off'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'on'
,p_splitter_position=>.7
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(13398036796650539)
,p_chart_id=>wwv_flow_imp.id(13396913570650536)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(13398611344650539)
,p_chart_id=>wwv_flow_imp.id(13396913570650536)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37597204515216787)
,p_name=>'Web Service Requests'
,p_parent_plug_id=>wwv_flow_imp.id(19539330836219519)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>60
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with web_service_req_stats_1x as (',
'    select sum(web_service_req_cnt) as web_service_req_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') ),',
'web_service_req_stats_2x as (',
'    select sum(web_service_req_cnt) as web_service_req_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                 as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_WEBSRV_REQUESTS'') as stats_category,',
'           null                                                              as label_class,',
'           nvl(b.web_service_req_total, 0)                                   as total,',
'           nvl(b.web_service_req_total, 0) - nvl(d.web_service_req_total, 0) as delta',
'      from web_service_req_stats_1x b,',
'           web_service_req_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19574896238538840)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19575203305538840)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19576020321538841)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19575638895538841)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19576466372538841)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19576846216538842)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19577228258538842)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305551744666713)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30084469186363865)
,p_plug_name=>'Web Service Requests'
,p_parent_plug_id=>wwv_flow_imp.id(37597204515216787)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>80
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(16669851474503463)
,p_region_id=>wwv_flow_imp.id(30084469186363865)
,p_chart_type=>'lineWithArea'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(16671503050503465)
,p_chart_id=>wwv_flow_imp.id(16669851474503463)
,p_seq=>10
,p_name=>'Web Service Requests'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))      ',
'select nvl(wm.web_service_req_cnt, 0) as wbr_value,',
'       dg.log_day as wbr_label       ',
'  from (select web_service_req_cnt,',
'               log_day',
'         from wwv_workspace_aggr_metrics',
'        where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'WBR_VALUE'
,p_items_label_column_name=>'WBR_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089097539715322)
,p_chart_id=>wwv_flow_imp.id(16669851474503463)
,p_seq=>20
,p_name=>'Web Service Requests - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select web_service_req_cnt as wbr_value,',
'       trunc(sysdate) - 1 as wbr_label',
'  from wwv_workspace_aggr_metrics',
' where workspace_id = :P1030_WORKSPACE_ID',
'   and log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'WBR_VALUE'
,p_items_label_column_name=>'WBR_LABEL'
,p_color=>'#437c94'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(16670376291503464)
,p_chart_id=>wwv_flow_imp.id(16669851474503463)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(16670932000503465)
,p_chart_id=>wwv_flow_imp.id(16669851474503463)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37608412639392655)
,p_name=>'Errors'
,p_parent_plug_id=>wwv_flow_imp.id(19539330836219519)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>90
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with errors_stats_1x as (',
'    select sum(errors_cnt) as errors_cnt_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') ),',
'errors_stats_2x as (',
'    select sum(errors_cnt) as errors_cnt_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                       as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_ERROR'') as stats_category,',
'           null                                                    as label_class,',
'           nvl(b.errors_cnt_total, 0)                              as total,',
'           nvl(b.errors_cnt_total, 0) - nvl(d.errors_cnt_total, 0) as delta',
'      from errors_stats_1x b,',
'           errors_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19587564716714722)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19587951265714723)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19588344235714723)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19589132773714724)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19589544412714724)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19589995886714724)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19588758451714723)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305886082666716)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23811688141016261)
,p_plug_name=>'Errors'
,p_parent_plug_id=>wwv_flow_imp.id(37608412639392655)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>100
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(13403330877655023)
,p_region_id=>wwv_flow_imp.id(23811688141016261)
,p_chart_type=>'lineWithArea'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(13405082998655024)
,p_chart_id=>wwv_flow_imp.id(13403330877655023)
,p_seq=>10
,p_name=>'Errors'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select nvl(wm.errors_cnt, 0) as errors_value,',
'       dg.log_day as errors_label',
'  from (select errors_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'ERRORS_VALUE'
,p_items_label_column_name=>'ERRORS_LABEL'
,p_color=>'#e77076'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089313425715325)
,p_chart_id=>wwv_flow_imp.id(13403330877655023)
,p_seq=>20
,p_name=>'Errors - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select errors_cnt as errors_value,',
'       trunc(sysdate) - 1 as errors_label',
'  from wwv_workspace_aggr_metrics',
' where workspace_id = :P1030_WORKSPACE_ID',
'   and log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'ERRORS_VALUE'
,p_items_label_column_name=>'ERRORS_LABEL'
,p_color=>'#e77076'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19540154837219527)
,p_chart_id=>wwv_flow_imp.id(13403330877655023)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(13403802334655023)
,p_chart_id=>wwv_flow_imp.id(13403330877655023)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(13404401946655023)
,p_chart_id=>wwv_flow_imp.id(13403330877655023)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37614788764451797)
,p_name=>'Login Attempts'
,p_parent_plug_id=>wwv_flow_imp.id(19539330836219519)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>100
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with connection_attempts_stats_1x as (',
'    select sum(login_cnt - failed_logins_cnt) as successful_login_total,',
'           sum(failed_logins_cnt)             as failed_login_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') ),',
'connection_attempts_stats_2x as (',
'     select sum(login_cnt - failed_logins_cnt) as successful_login_total,',
'           sum(failed_logins_cnt)             as failed_login_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date( :P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                   as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_SUCCESSLOGIN'')      as stats_category,',
'           null                                                                as label_class,',
'           nvl(b.successful_login_total, 0)                                    as total,',
'           nvl(b.successful_login_total, 0) - nvl(d.successful_login_total, 0) as delta',
'      from connection_attempts_stats_1x b,',
'           connection_attempts_stats_2x d',
'    union all',
'    select 2                                                              as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_FAILEDLOGINS'') as stats_category,',
'           null                                                           as label_class,',
'           nvl(b.failed_login_total, 0)                                   as total,',
'           nvl(b.failed_login_total, 0) - nvl(d.failed_login_total, 0)    as delta',
'      from connection_attempts_stats_1x b,',
'           connection_attempts_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(37614788764451797)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19595938365773881)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19596344276773881)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19596786968773882)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19595527713773880)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19597134111773882)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19597583376773882)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19597964450773883)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305918455666717)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23116515576042333)
,p_plug_name=>'Login Attempts'
,p_parent_plug_id=>wwv_flow_imp.id(37614788764451797)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>220
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(13400163745653012)
,p_region_id=>wwv_flow_imp.id(23116515576042333)
,p_chart_type=>'lineWithArea'
,p_height=>'200'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(13401838507653013)
,p_chart_id=>wwv_flow_imp.id(13400163745653012)
,p_seq=>10
,p_name=>'Successful Logins'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select nvl(wm.login_cnt - wm.failed_logins_cnt, 0) as sl_value,',
'       dg.log_day as sl_label',
'  from (select login_cnt,',
'               failed_logins_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SL_VALUE'
,p_items_label_column_name=>'SL_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089443495715326)
,p_chart_id=>wwv_flow_imp.id(13400163745653012)
,p_seq=>20
,p_name=>'Successful Logins - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select login_cnt - failed_logins_cnt as sl_value,',
'       log_day as sl_label',
'  from (select login_cnt,',
'               failed_logins_cnt,',
'               trunc(sysdate) - 1 as log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID',
'           and log_day = trunc(sysdate) - 2)'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SL_VALUE'
,p_items_label_column_name=>'SL_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(13402412320653014)
,p_chart_id=>wwv_flow_imp.id(13400163745653012)
,p_seq=>30
,p_name=>'Failed Logins'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select nvl(wm.failed_logins_cnt, 0) as sl_value,',
'       dg.log_day as sl_label',
'  from (select failed_logins_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SL_VALUE'
,p_items_label_column_name=>'SL_LABEL'
,p_color=>'#e77076'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089546404715327)
,p_chart_id=>wwv_flow_imp.id(13400163745653012)
,p_seq=>40
,p_name=>'Failed Logins - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select failed_logins_cnt as sl_value,',
'       log_day as sl_label',
'  from (select failed_logins_cnt,',
'               trunc(sysdate) - 1 as log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID',
'           and log_day = trunc(sysdate) - 2)'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SL_VALUE'
,p_items_label_column_name=>'SL_LABEL'
,p_color=>'#e77076'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(13400697574653012)
,p_chart_id=>wwv_flow_imp.id(13400163745653012)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(13401243537653013)
,p_chart_id=>wwv_flow_imp.id(13400163745653012)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37701201461108808)
,p_name=>'Applications'
,p_parent_plug_id=>wwv_flow_imp.id(19539330836219519)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>110
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_applications as (',
'    select sum(case when f.created_on between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'                    then 1',
'                    else 0',
'               end) as apps_total_1x,',
'           sum(case when f.created_on between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date( :P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'')',
'                    then 1',
'                    else 0',
'               end) as apps_total_2x',
'      from wwv_flows           f,',
'           wwv_flow_companies ws',
'     where ws.provisioning_company_id = f.security_group_id',
'       and ws.provisioning_company_id = :P1030_WORKSPACE_ID ),',
'applications_stats_1x as (',
'    select sum(wm.created_apps_cnt) as created_apps_total,',
'           sum(wm.removed_apps_cnt) as removed_apps_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') ),',
'applications_stats_2x as (',
'    select sum(wm.created_apps_cnt) as created_apps_total,',
'           sum(wm.removed_apps_cnt) as removed_apps_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date( :P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                     as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_CREATED_APPS'')        as stats_category,',
'           null                                                                  as label_class,',
'           nvl(sum(b.created_apps_total), 0)                                     as total,',
'           nvl(sum(b.created_apps_total), 0) - nvl(sum(d.created_apps_total), 0) as delta',
'      from applications_stats_1x b,',
'           applications_stats_2x d',
'     union all',
'     select 2                                                                    as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_REMOVED_APPS'')        as stats_category,',
'           null                                                                  as label_class,',
'           nvl(sum(b.removed_apps_total), 0)                                     as total,',
'           nvl(sum(b.removed_apps_total), 0) - nvl(sum(d.removed_apps_total), 0) as delta',
'      from applications_stats_1x b,',
'           applications_stats_2x d',
'     union all',
'     select 3                                                                      as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_TOTAL_APPLICATIONS'')    as stats_category,',
'           null                                                                    as label_class,',
'           nvl(sum(ta.apps_total_1x), 0)                                           as total,',
'           nvl(sum(ta.apps_total_1x), 0) - nvl(sum(ta.apps_total_2x), 0)           as delta',
'      from total_applications ta )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(37701201461108808)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19598630746776696)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19599059937776696)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19599444785776697)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19601020163776699)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19599824448776697)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19600276827776698)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19600695022776698)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23306017097666718)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37816363925968047)
,p_plug_name=>'Applications'
,p_parent_plug_id=>wwv_flow_imp.id(37701201461108808)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>120
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19713444953635933)
,p_region_id=>wwv_flow_imp.id(37816363925968047)
,p_chart_type=>'lineWithArea'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'on'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19715159775635935)
,p_chart_id=>wwv_flow_imp.id(19713444953635933)
,p_seq=>10
,p_name=>'Created Applications'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select nvl(wm.created_apps_cnt, 0) as app_value,',
'       dg.log_day as app_label       ',
'  from (select created_apps_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089634282715328)
,p_chart_id=>wwv_flow_imp.id(19713444953635933)
,p_seq=>20
,p_name=>'Created Applications - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select created_apps_cnt as app_value,',
'       log_day as app_label       ',
'  from (select created_apps_cnt,',
'               trunc(sysdate) - 1 as log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID',
'           and log_day = trunc(sysdate) - 2)'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19715756404635936)
,p_chart_id=>wwv_flow_imp.id(19713444953635933)
,p_seq=>30
,p_name=>'Removed Applications'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day as app_label,',
'       nvl(wm.removed_apps_cnt, 0) as app_value       ',
'  from (select removed_apps_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 1'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#e77076'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089732518715329)
,p_chart_id=>wwv_flow_imp.id(19713444953635933)
,p_seq=>40
,p_name=>'Removed Applications - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select log_day as app_label,',
'       removed_apps_cnt as app_value       ',
'  from (select removed_apps_cnt,',
'               trunc(sysdate) - 1 as log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID',
'           and log_day = trunc(sysdate) - 2)'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#e77076'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19716328170635936)
,p_chart_id=>wwv_flow_imp.id(19713444953635933)
,p_seq=>50
,p_name=>'Total Applications'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day  as app_label,',
'       count(f.id) as app_value       ',
'  from wwv_flows           f,',
'       wwv_flow_companies ws,',
'       day_gen            dg',
' where ws.provisioning_company_id = f.security_group_id',
'   and dg.log_day = f.created_on (+)',
'   and ws.provisioning_company_id = :P1030_WORKSPACE_ID',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'group by dg.log_day',
'order by 1'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089890045715330)
,p_chart_id=>wwv_flow_imp.id(19713444953635933)
,p_seq=>60
,p_name=>'Total Applications - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(sysdate) - 1 as app_label,',
'       count(f.id) as app_value       ',
'  from wwv_flows           f,',
'       wwv_flow_companies ws',
' where ws.provisioning_company_id = f.security_group_id',
'   and ws.provisioning_company_id = :P1030_WORKSPACE_ID',
'   and f.created_on = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'APP_VALUE'
,p_items_label_column_name=>'APP_LABEL'
,p_color=>'#437c94'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19713967386635934)
,p_chart_id=>wwv_flow_imp.id(19713444953635933)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19714562235635934)
,p_chart_id=>wwv_flow_imp.id(19713444953635933)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37821489662970255)
,p_name=>'Sessions'
,p_parent_plug_id=>wwv_flow_imp.id(19539330836219519)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>70
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with distinct_sessions_stats_1x as (',
'    select sum(distinct_sessions_cnt) as distinct_sessions_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'        and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') ),',
'distinct_sessions_stats_2x as (',
'    select sum(distinct_sessions_cnt) as distinct_sessions_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date( :P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                     as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_SESSIONS'')            as stats_category,',
'           null                                                                  as label_class,',
'           nvl(b.distinct_sessions_total, 0)                                     as total,',
'           nvl(b.distinct_sessions_total, 0) - nvl(d.distinct_sessions_total, 0) as delta',
'      from distinct_sessions_stats_1x b,',
'           distinct_sessions_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(37821489662970255)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19717689350638126)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19718005928638126)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19718466820638127)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19717253172638126)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19718849648638127)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19719269944638127)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19719653970638128)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305662135666714)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37821905527970259)
,p_plug_name=>'Sessions'
,p_parent_plug_id=>wwv_flow_imp.id(37821489662970255)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>160
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19720392208638129)
,p_region_id=>wwv_flow_imp.id(37821905527970259)
,p_chart_type=>'lineWithArea'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19722026566638130)
,p_chart_id=>wwv_flow_imp.id(19720392208638129)
,p_seq=>10
,p_name=>'Sessions'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select nvl(wm.distinct_sessions_cnt, 0) as session_value,',
'       dg.log_day as session_label      ',
'  from (select distinct_sessions_cnt,',
'               log_day',
'         from wwv_workspace_aggr_metrics',
'        where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SESSION_VALUE'
,p_items_label_column_name=>'SESSION_LABEL'
,p_color=>'#437c94'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089156126715323)
,p_chart_id=>wwv_flow_imp.id(19720392208638129)
,p_seq=>20
,p_name=>'Sessions - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct_sessions_cnt as session_value,',
'       trunc(sysdate) - 1 as session_label',
'   from wwv_workspace_aggr_metrics',
'  where workspace_id = :P1030_WORKSPACE_ID',
'    and log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'SESSION_VALUE'
,p_items_label_column_name=>'SESSION_LABEL'
,p_color=>'#437c94'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19720850525638129)
,p_chart_id=>wwv_flow_imp.id(19720392208638129)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19721433357638129)
,p_chart_id=>wwv_flow_imp.id(19720392208638129)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>1
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37828132685975981)
,p_name=>'IP Addresses'
,p_parent_plug_id=>wwv_flow_imp.id(19539330836219519)
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>80
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with distinct_ip_addresses_stats_1x as (',
'    select sum(distinct_ip_addresses_cnt) as distinct_ip_addresses_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') ),',
'distinct_ip_addresses_stats_2x as (',
'    select sum(distinct_ip_addresses_cnt) as distinct_ip_addresses_total',
'      from wwv_workspace_aggr_metrics wm',
'     where wm.workspace_id = :P1030_WORKSPACE_ID',
'       and wm.log_day between to_date(:P1030_START_TIME_INTERVAL_2X , ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_2X, ''&DATE_FORMAT.'') )',
'select stats_category,',
'       total,',
'       trim(to_char(delta,''999G999G999G999G999G999G990'')) as delta,',
'       to_char(round((delta / nullif(total,0)) * 100), ''999G999G999G999G999G999G990'') || case when total != 0 then ''%''',
'                                                                                         end as delta_pct,',
'       label_class,',
'       case when delta >  0 then ''up-arrow''',
'            when delta <  0 then ''down-arrow''',
'            else '' u-hidden''',
'       end as icon, ',
'       case when delta >  0 then ''u-success-text''',
'            when delta <  0 then ''u-danger-text''',
'            else '' u-hidden''',
'       end as class,',
'       case when delta >  0 then wwv_flow_lang_dev.builder_message(''UP'')',
'            when delta <  0 then wwv_flow_lang_dev.builder_message(''DOWN'')',
'       end as label',
' from (',
'    select 1                                                                             as sort_order,',
'           wwv_flow_lang_dev.builder_message(''ADMIN_DIGEST_IP_ADDRESS'')                  as stats_category,',
'           null                                                                          as label_class,',
'           nvl(b.distinct_ip_addresses_total, 0)                                         as total,',
'           nvl(b.distinct_ip_addresses_total, 0) - nvl(d.distinct_ip_addresses_total, 0) as delta',
'      from distinct_ip_addresses_stats_1x b,',
'           distinct_ip_addresses_stats_2x d )',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19723341902643843)
,p_query_column_id=>1
,p_column_alias=>'STATS_CATEGORY'
,p_column_display_sequence=>10
,p_column_heading=>'Stats Category'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'<span class="#LABEL_CLASS#">#STATS_CATEGORY#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19723712418643844)
,p_query_column_id=>2
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>20
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19724155581643844)
,p_query_column_id=>3
,p_column_alias=>'DELTA'
,p_column_display_sequence=>30
,p_column_heading=>'Delta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DELTA/}',
'{when 0/}',
'&nbsp',
'{otherwise/}',
'{if DELTA_PCT/}',
'<div class="#CLASS#">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{else/}',
'<div class="#CLASS#">',
'    <span class="js-delta-value">',
'    <span class="a-Icon icon-#ICON#" role="img" aria-label="#LABEL#"></span>',
'    </span>',
'    <span class="js-delta-pct">#DELTA_PCT#</span>',
'    <span class="js-delta-value">#DELTA#</span>',
'</div>',
'{endif/}',
'{endcase/}'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19722982523643843)
,p_query_column_id=>4
,p_column_alias=>'DELTA_PCT'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19724530665643845)
,p_query_column_id=>5
,p_column_alias=>'LABEL_CLASS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19724941665643845)
,p_query_column_id=>6
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19725337824643846)
,p_query_column_id=>7
,p_column_alias=>'CLASS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23305793556666715)
,p_query_column_id=>8
,p_column_alias=>'LABEL'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37882136596897910)
,p_plug_name=>'IP Addresses'
,p_parent_plug_id=>wwv_flow_imp.id(37828132685975981)
,p_region_css_classes=>'apex-col--topBorder js-refresh-chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>180
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(19776657452565768)
,p_region_id=>wwv_flow_imp.id(37882136596897910)
,p_chart_type=>'lineWithArea'
,p_height=>'240'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'on'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'mixedFrequency'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(19778389562565769)
,p_chart_id=>wwv_flow_imp.id(19776657452565768)
,p_seq=>10
,p_name=>'IP Addresses'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with day_gen as (',
'    select trunc(sysdate) - rownum log_day',
'    from sys.dual',
'    connect by level <= nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD))',
'select dg.log_day as ip_addresses_label,',
'       nvl(wm.distinct_ip_addresses_cnt, 0) as ip_addresses_value       ',
'  from (select distinct_ip_addresses_cnt,',
'               log_day',
'          from wwv_workspace_aggr_metrics',
'         where workspace_id = :P1030_WORKSPACE_ID) wm,',
'       day_gen                    dg',
' where dg.log_day = wm.log_day (+)',
'   and dg.log_day between :P1030_START_TIME_INTERVAL_1X and :P1030_END_TIME_INTERVAL_1X',
'order by 1'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'IP_ADDRESSES_VALUE'
,p_items_label_column_name=>'IP_ADDRESSES_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(162089217864715324)
,p_chart_id=>wwv_flow_imp.id(19776657452565768)
,p_seq=>20
,p_name=>'IP Addresses - Last day estimate'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct_ip_addresses_cnt as ip_addresses_value,',
'       trunc(sysdate) - 1 as ip_addresses_label',
'  from wwv_workspace_aggr_metrics',
' where workspace_id = :P1030_WORKSPACE_ID',
'   and log_day = trunc(sysdate) - 2'))
,p_ajax_items_to_submit=>'P1030_SINCE,P1030_WORKSPACE_ID,P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X'
,p_items_value_column_name=>'IP_ADDRESSES_VALUE'
,p_items_label_column_name=>'IP_ADDRESSES_LABEL'
,p_color=>'#4c825c'
,p_line_style=>'dashed'
,p_line_width=>1
,p_line_type=>'curved'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P1030_LAST_DAY != trunc(sysdate) - 1'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19777149074565768)
,p_chart_id=>wwv_flow_imp.id(19776657452565768)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(19777738235565768)
,p_chart_id=>wwv_flow_imp.id(19776657452565768)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20895925605519503)
,p_plug_name=>'Workspace Details'
,p_region_css_classes=>'js-refresh-report'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517376500704206647)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(16596666461707206)
,p_name=>'Workspace Details 1'
,p_parent_plug_id=>wwv_flow_imp.id(20895925605519503)
,p_template=>wwv_flow_imp.id(517376500704206647)
,p_display_sequence=>40
,p_region_css_classes=>'js-refresh-report'
,p_region_sub_css_classes=>'a-AVPList--rightAligned'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(admin_user_accounts_cnt), 0) as admin_user_accounts_cnt,',
'       nvl(max(dev_user_accounts_cnt), 0) as dev_user_accounts_cnt,',
'       nvl(max(end_user_accounts_cnt), 0) as end_user_accounts_cnt,',
'       nvl(max(locked_user_accounts), 0) as locked_user_accounts,',
'       nvl(max(distinct_users_cnt), 0) as distinct_users_cnt,',
'       nvl(sum(page_events_cnt), 0) as page_events_cnt,       ',
'       nvl(sum(login_cnt), 0) as login_cnt,',
'       nvl(sum(failed_logins_cnt), 0) as failed_logins_cnt',
'  from wwv_workspace_aggr_metrics',
' where log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') ',
'   and workspace_id = :P1030_WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805670753642677848)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16596925492707209)
,p_query_column_id=>1
,p_column_alias=>'ADMIN_USER_ACCOUNTS_CNT'
,p_column_display_sequence=>30
,p_column_heading=>'Admin User Accounts'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16597043002707210)
,p_query_column_id=>2
,p_column_alias=>'DEV_USER_ACCOUNTS_CNT'
,p_column_display_sequence=>40
,p_column_heading=>'Dev User Accounts'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16597180704707211)
,p_query_column_id=>3
,p_column_alias=>'END_USER_ACCOUNTS_CNT'
,p_column_display_sequence=>50
,p_column_heading=>'End User Accounts'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16597216826707212)
,p_query_column_id=>4
,p_column_alias=>'LOCKED_USER_ACCOUNTS'
,p_column_display_sequence=>60
,p_column_heading=>'Locked User Accounts'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16597346502707213)
,p_query_column_id=>5
,p_column_alias=>'DISTINCT_USERS_CNT'
,p_column_display_sequence=>70
,p_column_heading=>'Distinct Users'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16597424872707214)
,p_query_column_id=>6
,p_column_alias=>'PAGE_EVENTS_CNT'
,p_column_display_sequence=>80
,p_column_heading=>'Page Events'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21007391874759805)
,p_query_column_id=>7
,p_column_alias=>'LOGIN_CNT'
,p_column_display_sequence=>100
,p_column_heading=>'Logins'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21007519381759807)
,p_query_column_id=>8
,p_column_alias=>'FAILED_LOGINS_CNT'
,p_column_display_sequence=>110
,p_column_heading=>'Failed Logins'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20711639963431127)
,p_name=>'Workspace Details 2'
,p_parent_plug_id=>wwv_flow_imp.id(20895925605519503)
,p_template=>wwv_flow_imp.id(517376500704206647)
,p_display_sequence=>50
,p_region_css_classes=>'js-refresh-report'
,p_region_sub_css_classes=>'a-AVPList--rightAligned'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(daily_max_active_pages), 0) as daily_max_active_pages,       ',
'       nvl(sum(created_apps_cnt), 0) as created_apps_cnt,',
'       nvl(sum(removed_apps_cnt), 0) as removed_apps_cnt,',
'       nvl(max(accessed_apps_cnt), 0) as accessed_apps_cnt,',
'       nvl(sum(errors_cnt), 0) as errors_cnt,',
'       nvl(sum(emails_sent_cnt), 0) as emails_sent_cnt,',
'       nvl(sum(distinct_sessions_cnt), 0) as distinct_sessions_cnt,',
'       nvl(max(distinct_ip_addresses_cnt), 0) as distinct_ip_addresses_cnt',
'  from wwv_workspace_aggr_metrics',
' where log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') ',
'   and workspace_id = :P1030_WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805670753642677848)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21007492846759806)
,p_query_column_id=>1
,p_column_alias=>'DAILY_MAX_ACTIVE_PAGES'
,p_column_display_sequence=>180
,p_column_heading=>'Daily Maximum Active Pages'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20712724066431138)
,p_query_column_id=>2
,p_column_alias=>'CREATED_APPS_CNT'
,p_column_display_sequence=>110
,p_column_heading=>'Created Apps'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20712898423431139)
,p_query_column_id=>3
,p_column_alias=>'REMOVED_APPS_CNT'
,p_column_display_sequence=>120
,p_column_heading=>'Removed Apps'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20712970631431140)
,p_query_column_id=>4
,p_column_alias=>'ACCESSED_APPS_CNT'
,p_column_display_sequence=>130
,p_column_heading=>'Accessed Apps'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20713025633431141)
,p_query_column_id=>5
,p_column_alias=>'ERRORS_CNT'
,p_column_display_sequence=>140
,p_column_heading=>'Errors'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20713165173431142)
,p_query_column_id=>6
,p_column_alias=>'EMAILS_SENT_CNT'
,p_column_display_sequence=>150
,p_column_heading=>'Emails Sent'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20713283179431143)
,p_query_column_id=>7
,p_column_alias=>'DISTINCT_SESSIONS_CNT'
,p_column_display_sequence=>160
,p_column_heading=>'Distinct Sessions'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20713341276431144)
,p_query_column_id=>8
,p_column_alias=>'DISTINCT_IP_ADDRESSES_CNT'
,p_column_display_sequence=>170
,p_column_heading=>'Distinct IP Addresses'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20896086563519504)
,p_name=>'Workspace Details 3'
,p_parent_plug_id=>wwv_flow_imp.id(20895925605519503)
,p_template=>wwv_flow_imp.id(517376500704206647)
,p_display_sequence=>60
,p_region_css_classes=>'js-refresh-report'
,p_region_sub_css_classes=>'a-AVPList--rightAligned'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>9
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(sum(web_service_req_cnt), 0) as web_service_req_cnt,',
'       decode(nvl(max(web_service_req_limit_reached), ''N''), ''Y'', wwv_flow_lang_dev.builder_message(''APEXDEV.PE.YES''),',
'              ''N'', wwv_flow_lang_dev.builder_message(''APEXDEV.PE.NO'')) as web_service_req_limit_reached,   ',
'       nvl(max(render_time_10pct_sec), 0) as render_time_10pct_sec,',
'       nvl(max(render_time_avg_sec), 0) as render_time_avg_sec,',
'       nvl(max(render_time_median_sec), 0) as render_time_median_sec,',
'       nvl(max(render_time_90pct_sec), 0) as render_time_90pct_sec,',
'       nvl(max(render_time_max_sec), 0) as render_time_max_sec,',
'       nvl(max(workspace_size), 0) as workspace_size',
'  from wwv_workspace_aggr_metrics',
' where log_day between to_date(:P1030_START_TIME_INTERVAL_1X, ''&DATE_FORMAT.'') and to_date(:P1030_END_TIME_INTERVAL_1X, ''&DATE_FORMAT.'')',
'   and workspace_id = :P1030_WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_WORKSPACE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805670753642677848)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20897882446519522)
,p_query_column_id=>1
,p_column_alias=>'WEB_SERVICE_REQ_CNT'
,p_column_display_sequence=>180
,p_column_heading=>'Web Service Requests'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(143461178312545802)
,p_query_column_id=>2
,p_column_alias=>'WEB_SERVICE_REQ_LIMIT_REACHED'
,p_column_display_sequence=>190
,p_column_heading=>'Web Service Requests Limit Reached'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20898082362519524)
,p_query_column_id=>3
,p_column_alias=>'RENDER_TIME_10PCT_SEC'
,p_column_display_sequence=>200
,p_column_heading=>'Render Time (10th Percentile)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20898114450519525)
,p_query_column_id=>4
,p_column_alias=>'RENDER_TIME_AVG_SEC'
,p_column_display_sequence=>210
,p_column_heading=>'Render Time  (Average)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20898213336519526)
,p_query_column_id=>5
,p_column_alias=>'RENDER_TIME_MEDIAN_SEC'
,p_column_display_sequence=>220
,p_column_heading=>'Render Time (Median)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20898376974519527)
,p_query_column_id=>6
,p_column_alias=>'RENDER_TIME_90PCT_SEC'
,p_column_display_sequence=>230
,p_column_heading=>'Render Time (90th Percentile)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20898447845519528)
,p_query_column_id=>7
,p_column_alias=>'RENDER_TIME_MAX_SEC'
,p_column_display_sequence=>240
,p_column_heading=>'Render Time  (Maximum)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20494387914535525)
,p_query_column_id=>8
,p_column_alias=>'WORKSPACE_SIZE'
,p_column_display_sequence=>250
,p_column_heading=>'Workspace Size'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23822860249179669)
,p_plug_name=>'Buttons Bar'
,p_region_css_classes=>'dashboard-controls'
,p_region_template_options=>'a-ButtonRegion--withItems:a-ButtonRegion--wizard:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41302557593674652)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>230
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>The reports display the totals for a specific metric within a certain time interval. The delta value records the difference between the specified time interval for example last 7 days (when 7 days are selected) and the previous 7 days.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23389715442795366)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_button_name=>'SET'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'t-Button--noUI'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20510977115718917)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:1030,RIR::'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13415464792818442)
,p_name=>'P1030_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_platform.get_preference(',
'           p_preference_name => ''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'');'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ADMIN_DIGEST.RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct d, t from (',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.DAY'')          d,    1 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''2'' ) d,    2 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''7'' ) d,    7 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''15'') d,   15 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''30'') d,   30 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''45'') d,   45 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''60'') d,   60 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''90'') d,   90 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message (',
'           case default_reporting_period',
'                when 1 then ''APEX.TIME.DAY''',
'                else ''APEX.TIME.N_DAYS''',
'           end,',
'           default_reporting_period) as d,',
'       default_reporting_period as t',
'  from (select to_number(wwv_flow_platform.get_preference(''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'')) default_reporting_period',
'          from sys.dual)',
'union all',
'select wwv_flow_lang_dev.builder_message(''CUSTOM'') d, 100 t from sys.dual)',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19571218941534690)
,p_name=>'P1030_DELTA_PCT_YN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_item_default=>'Y'
,p_prompt=>'Display delta as percentage'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20510319270692252)
,p_name=>'P1030_START_DATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_prompt=>'Start'
,p_format_mask=>'&DATE_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'ITEM'
,p_attribute_08=>'P1030_END_DATE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20510691951700351)
,p_name=>'P1030_END_DATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_prompt=>'End'
,p_format_mask=>'&DATE_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'ITEM'
,p_attribute_05=>'P1030_START_DATE'
,p_attribute_06=>'ITEM'
,p_attribute_08=>'P1030_MAX_DATE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21008733229759819)
,p_name=>'P1030_WORKSPACE_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21008893441759820)
,p_name=>'P1030_WORKSPACE_NAME'
,p_item_sequence=>20
,p_prompt=>'Workspace: '
,p_source=>'return wwv_flow_security.find_company_name(:P1030_WORKSPACE_ID);'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21010855976759840)
,p_name=>'P1030_END_TIME_INTERVAL_1X'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21596949745834122)
,p_name=>'P1030_START_TIME_INTERVAL_1X'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21597251319837152)
,p_name=>'P1030_START_TIME_INTERVAL_2X'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23040629657353898)
,p_name=>'P1030_END_TIME_INTERVAL_2X'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23307389963666731)
,p_name=>'P1030_MAX_DATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_source=>'return trunc(sysdate) - 1;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183128618077811108)
,p_name=>'P1030_LAST_DAY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(23822860249179669)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(162090373647715335)
,p_computation_sequence=>10
,p_computation_item=>'P1030_LAST_DAY'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(log_day)',
'  from wwv_workspace_aggr_metrics'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20546012170363739)
,p_name=>'Show/Hide Custom'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1030_SINCE'
,p_condition_element=>'P1030_SINCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'100'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20546442452363740)
,p_event_id=>wwv_flow_imp.id(20546012170363739)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_START_DATE,P1030_END_DATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20546989527363741)
,p_event_id=>wwv_flow_imp.id(20546012170363739)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_START_DATE,P1030_END_DATE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(19581541514623873)
,p_name=>'Toggle Delta Percent or Value'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(23389715442795366)
,p_condition_element=>'P1030_DELTA_PCT_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19581994851623875)
,p_event_id=>wwv_flow_imp.id(19581541514623873)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".js-delta-pct").show();',
'apex.jQuery(".js-delta-value").hide();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19582459307623875)
,p_event_id=>wwv_flow_imp.id(19581541514623873)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".js-delta-pct").hide();',
'apex.jQuery(".js-delta-value").show();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(21655362217647149)
,p_name=>'Format Delta after Refresh'
,p_event_sequence=>40
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.js-refresh-chart, .js-refresh-report'
,p_condition_element=>'P1030_DELTA_PCT_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21655786501647150)
,p_event_id=>wwv_flow_imp.id(21655362217647149)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".js-delta-pct").hide();',
'apex.jQuery(".js-delta-value").show();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21656236902647150)
,p_event_id=>wwv_flow_imp.id(21655362217647149)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".js-delta-pct").show();',
'apex.jQuery(".js-delta-value").hide();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20793001911991714)
,p_name=>'Refresh Regions'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(23389715442795366)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21673793170910605)
,p_event_id=>wwv_flow_imp.id(20793001911991714)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1030_START_TIME_INTERVAL_1X := case when :P1030_SINCE < 100 then trunc(sysdate) - nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD)',
'                                      when :P1030_SINCE = 100 then :P1030_START_DATE',
'                                 end;',
':P1030_END_TIME_INTERVAL_1X   := case when :P1030_SINCE < 100',
'                                          then',
'                                              case when :P1030_LAST_DAY = trunc(sysdate) - 1',
'                                                       then trunc(sysdate) - 1',
'                                                   else trunc(sysdate) - 2',
'                                              end',
'                                      when :P1030_SINCE = 100 then :P1030_END_DATE',
'                                 end;',
':P1030_START_TIME_INTERVAL_2X := case when :P1030_SINCE < 100 then trunc(sysdate) - nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD) * 2',
'                                      when :P1030_SINCE = 100 then to_date( :P1030_START_DATE, ''&DATE_FORMAT.'') - trunc(to_date( :P1030_END_DATE, ''&DATE_FORMAT.'') - to_date(:P1030_START_DATE, ''&DATE_FORMAT.''))',
'                                 end;',
':P1030_END_TIME_INTERVAL_2X   := case when :P1030_SINCE < 100 then trunc(sysdate) - nvl(:P1030_SINCE, :AI_DEFAULT_REPORTING_PERIOD) - 1',
'                                      when :P1030_SINCE = 100 then to_date( :P1030_START_DATE, ''&DATE_FORMAT.'') - 1',
'                                 end;'))
,p_attribute_02=>'P1030_SINCE,P1030_START_DATE,P1030_END_DATE'
,p_attribute_03=>'P1030_START_TIME_INTERVAL_1X,P1030_END_TIME_INTERVAL_1X,P1030_START_TIME_INTERVAL_2X,P1030_END_TIME_INTERVAL_2X'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20793473620991716)
,p_event_id=>wwv_flow_imp.id(20793001911991714)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Reports'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-report'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23598670676863802)
,p_event_id=>wwv_flow_imp.id(20793001911991714)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Charts'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-chart'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(23308958946666747)
,p_name=>'Refresh'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23309050589666748)
,p_event_id=>wwv_flow_imp.id(23308958946666747)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Reports'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-report'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20793954472991716)
,p_event_id=>wwv_flow_imp.id(23308958946666747)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Charts'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-chart'
);
end;
/
prompt --application/pages/page_01031
begin
wwv_flow_imp_page.create_page(
 p_id=>1031
,p_name=>'Database Errors'
,p_alias=>'DATABASE-ERRORS'
,p_step_title=>'Database Errors'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_step_template=>wwv_flow_imp.id(500583153011311249)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(115385817770766958)
,p_protection_level=>'C'
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(17812889939992302)
,p_name=>'Database Errors'
,p_template=>wwv_flow_imp.id(721125879764730304)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch:a-Report--rowHighlight'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select v.originating_timestamp,',
'       v.host_id,',
'       v.host_address,',
'       v.message_level,',
'       v.message_id,',
'       v.message_group,',
'       v.error_instance_id,',
'       v.error_instance_sequence,',
'       v.message_text,',
'       v.problem_key,',
'       v.container_name,',
'       t.db_error_code,',
'       null error_display,',
'       wwv_flow_event_metrics_int.get_error_message(p_error_code => substr(t.db_error_code, instr(t.db_error_code, ''-'') + 2)) as error_message,',
'       wwv_flow_lang_dev.builder_message(''APEX.ADMIN_DIGEST.CONTAINER'') as container_msg,',
'       wwv_flow_lang_dev.builder_message(''APEX.ADMIN_DIGEST.HOST_ID'') as host_id_msg,',
'       wwv_flow_lang_dev.builder_message(''APEX.ADMIN_DIGEST.MESSAGE_LEVEL'') as message_level_msg,',
'       wwv_flow_lang_dev.builder_message(''APEX.ADMIN_DIGEST.MESSAGE_GROUP'') as message_group_msg,',
'       wwv_flow_lang_dev.builder_message(''APEX.ADMIN_DIGEST.MESSAGE_ID'') as message_id_msg,',
'       wwv_flow_lang_dev.builder_message(''APEX.ADMIN_DIGEST.ERRINSTANCE'') as error_instance_id_msg,',
'       wwv_flow_lang_dev.builder_message(''APEX.ADMIN_DIGEST.ERRINSTANCE'') as error_instance_sequence_msg,',
'       wwv_flow_lang_dev.builder_message(''APEX.ADMIN_DIGEST.PROBLEMKEY'') as problem_key_msg',
'  from v$diag_alert_ext v, wwv_database_error_types t',
' where to_char(to_timestamp_tz(v.originating_timestamp, ''DD-MON-RR  HH:MI:SS.FF AM TZR''), ''&DATE_FORMAT.'') = :P1031_DATE',
'   and v.message_text like ''%'' || t.db_error_code || ''%''',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1031_DATE'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No Database Errors found for the selected date.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17814109851992315)
,p_query_column_id=>1
,p_column_alias=>'ORIGINATING_TIMESTAMP'
,p_column_display_sequence=>10
,p_column_heading=>'Originating Timestamp'
,p_use_as_row_header=>'N'
,p_column_css_class=>'u-nowrap'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17814256902992316)
,p_query_column_id=>2
,p_column_alias=>'HOST_ID'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17814382048992317)
,p_query_column_id=>3
,p_column_alias=>'HOST_ADDRESS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17814435711992318)
,p_query_column_id=>4
,p_column_alias=>'MESSAGE_LEVEL'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17814594007992319)
,p_query_column_id=>5
,p_column_alias=>'MESSAGE_ID'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17814652539992320)
,p_query_column_id=>6
,p_column_alias=>'MESSAGE_GROUP'
,p_column_display_sequence=>100
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17814749624992321)
,p_query_column_id=>7
,p_column_alias=>'ERROR_INSTANCE_ID'
,p_column_display_sequence=>110
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17814894452992322)
,p_query_column_id=>8
,p_column_alias=>'ERROR_INSTANCE_SEQUENCE'
,p_column_display_sequence=>120
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17814992219992323)
,p_query_column_id=>9
,p_column_alias=>'MESSAGE_TEXT'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17815077160992324)
,p_query_column_id=>10
,p_column_alias=>'PROBLEM_KEY'
,p_column_display_sequence=>130
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17815182395992325)
,p_query_column_id=>11
,p_column_alias=>'CONTAINER_NAME'
,p_column_display_sequence=>140
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17815745772992331)
,p_query_column_id=>12
,p_column_alias=>'DB_ERROR_CODE'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17815880172992332)
,p_query_column_id=>13
,p_column_alias=>'ERROR_DISPLAY'
,p_column_display_sequence=>40
,p_column_heading=>'Error Details'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<code>#MESSAGE_TEXT#</code><br />',
'<small>',
'#CONTAINER_MSG#: #CONTAINER_NAME# &middot; #HOST_ID_MSG#: #HOST_ID# (#HOST_ADDRESS#) &middot; ',
'#MESSAGE_LEVEL_MSG#: #MESSAGE_LEVEL#',
'',
'{if MESSAGE_GROUP/}',
'&middot; #MESSAGE_GROUP_MSG# #MESSAGE_GROUP#',
'{endif/}',
'',
'{if MESSAGE_ID/}',
'&middot; #MESSAGE_ID_MSG# #MESSAGE_ID#',
'{endif/}',
'',
'{if ERROR_INSTANCE_ID/}',
'&middot; #ERROR_INSTANCE_ID_MSG#: #ERROR_INSTANCE_ID#',
'{endif/}',
'',
'{if ERROR_INSTANCE_SEQUENCE/}',
'&middot; #ERROR_INSTANCE_SEQUENCE_MSG#: #ERROR_INSTANCE_SEQUENCE#',
'{endif/}',
'',
'{if PROBLEM_KEY/}',
'&middot; #PROBLEM_KEY_MSG#: #PROBLEM_KEY#',
'{endif/}',
'</small>'))
,p_heading_alignment=>'LEFT'
,p_report_column_width=>800
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17815969433992333)
,p_query_column_id=>14
,p_column_alias=>'ERROR_MESSAGE'
,p_column_display_sequence=>30
,p_column_heading=>'Error Message'
,p_use_as_row_header=>'Y'
,p_column_css_class=>'u-nowrap'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23599488409863810)
,p_query_column_id=>15
,p_column_alias=>'CONTAINER_MSG'
,p_column_display_sequence=>150
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23599514943863811)
,p_query_column_id=>16
,p_column_alias=>'HOST_ID_MSG'
,p_column_display_sequence=>160
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23599698061863812)
,p_query_column_id=>17
,p_column_alias=>'MESSAGE_LEVEL_MSG'
,p_column_display_sequence=>170
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23599737122863813)
,p_query_column_id=>18
,p_column_alias=>'MESSAGE_GROUP_MSG'
,p_column_display_sequence=>180
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23599819553863814)
,p_query_column_id=>19
,p_column_alias=>'MESSAGE_ID_MSG'
,p_column_display_sequence=>190
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23599993032863815)
,p_query_column_id=>20
,p_column_alias=>'ERROR_INSTANCE_ID_MSG'
,p_column_display_sequence=>200
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23600070523863816)
,p_query_column_id=>21
,p_column_alias=>'ERROR_INSTANCE_SEQUENCE_MSG'
,p_column_display_sequence=>210
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23600163825863817)
,p_query_column_id=>22
,p_column_alias=>'PROBLEM_KEY_MSG'
,p_column_display_sequence=>220
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17815246650992326)
,p_plug_name=>'Filter'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(17812889939992302)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'compact_numbers_threshold', '10000',
  'display_chart_for_top_n_values', '10',
  'show_charts', 'Y',
  'show_current_facets', 'N',
  'show_total_row_count', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17816060025992334)
,p_plug_name=>'Search'
,p_region_css_classes=>'a-Region--noTopBorder apex-col--bottomBorder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194212455979174222)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This report monitors all database errors recorded on a selected date. In order to manage which error types are tracked, use the Database Error Types link below.</p>',
'<p>The errors are retrieved from the database view, V$DIAG_ALERT_EXT which retains errors for the last 14 days.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13419687011860433)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194212455979174222)
,p_button_name=>'DATABASE_ERROR_TYPES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Database Error Types'
,p_button_redirect_url=>'f?p=&APP_ID.:1032:&SESSION.::&DEBUG.:1032::'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13421324774860450)
,p_name=>'P1031_DATE'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15367736861912005)
,p_name=>'P1031_DB_ERROR_CODE'
,p_item_sequence=>30
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17815328145992327)
,p_name=>'P1031_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17815246650992326)
,p_prompt=>'Search'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'ROW'
,p_attribute_02=>'PAGE_ITEM'
,p_attribute_03=>'P1031_SEARCH_UI'
,p_fc_show_chart=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17815609862992330)
,p_name=>'P1031_DB_ERROR_CODE_UI'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17815246650992326)
,p_prompt=>'Error Code'
,p_source=>'DB_ERROR_CODE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>false
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17816182969992335)
,p_name=>'P1031_SEARCH_UI'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17816060025992334)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
end;
/
prompt --application/pages/page_01032
begin
wwv_flow_imp_page.create_page(
 p_id=>1032
,p_name=>'Database Error Types'
,p_alias=>'DATABASE-ERROR-TYPES'
,p_page_mode=>'MODAL'
,p_step_title=>'Database Error Types'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let actions = apex.region("db_errors").call("getActions");',
'actions.hide("single-row-view");',
'actions.hide("row-duplicate");',
'actions.hide("row-add-row");',
'actions.hide("row-refresh");',
'actions.hide("row-revert");'))
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(115385817770766958)
,p_protection_level=>'C'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13419754638860434)
,p_plug_name=>'Database Error Types'
,p_region_name=>'db_errors'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       db_error_code as database_error_code,',
'       comments,',
'       active_yn,',
'       editable',
'  from wwv_database_error_types'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Database Error Types'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13420626128860443)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13420785454860444)
,p_name=>'DATABASE_ERROR_CODE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATABASE_ERROR_CODE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Database Error Code'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>10
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_readonly_condition_type=>'EXPRESSION'
,p_readonly_condition=>':EDITABLE = ''U'''
,p_readonly_condition2=>'PLSQL'
,p_readonly_for_each_row=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13420882525860445)
,p_name=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COMMENTS'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Comments'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13420918286860446)
,p_name=>'ACTIVE_YN'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ACTIVE_YN'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Active'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>40
,p_value_alignment=>'CENTER'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13421187226860448)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(18921665030096322)
,p_name=>'EDITABLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'EDITABLE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'UD'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(23599353538863809)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(13420503529860442)
,p_internal_uid=>13420503529860442
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_edit_row_operations_column=>'EDITABLE'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'There are no database errors codes added yet!'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_COLUMN:SEARCH_FIELD:SAVE'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(15345130620150978)
,p_interactive_grid_id=>wwv_flow_imp.id(13420503529860442)
,p_static_id=>'153452'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(15345330252150979)
,p_report_id=>wwv_flow_imp.id(15345130620150978)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(15345847917150983)
,p_view_id=>wwv_flow_imp.id(15345330252150979)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(13420626128860443)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(15346776056150989)
,p_view_id=>wwv_flow_imp.id(15345330252150979)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(13420785454860444)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>180
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(15347601206150993)
,p_view_id=>wwv_flow_imp.id(15345330252150979)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(13420882525860445)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(15348564236150996)
,p_view_id=>wwv_flow_imp.id(15345330252150979)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(13420918286860446)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>80
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(19041524051162525)
,p_view_id=>wwv_flow_imp.id(15345330252150979)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(18921665030096322)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23636968238455338)
,p_view_id=>wwv_flow_imp.id(15345330252150979)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(23599353538863809)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13421299247860449)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(13419754638860434)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Database Error Types - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>13421299247860449
);
end;
/
prompt --application/pages/page_01033
begin
wwv_flow_imp_page.create_page(
 p_id=>1033
,p_name=>'Database and &PRODUCT_NAME. versions'
,p_alias=>'DB-APEX-VERSIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Database and &PRODUCT_NAME. versions'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(17575099611551805)
,p_name=>'Oracle Database'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select min(log_day) as log_day,',
'       current_db_version',
'  from wwv_instance_aggr_metrics',
'group by current_db_version'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17575145713551806)
,p_query_column_id=>1
,p_column_alias=>'LOG_DAY'
,p_column_display_sequence=>10
,p_column_heading=>'Log Day'
,p_use_as_row_header=>'Y'
,p_column_format=>'&DATE_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17575280580551807)
,p_query_column_id=>2
,p_column_alias=>'CURRENT_DB_VERSION'
,p_column_display_sequence=>20
,p_column_heading=>'Version'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(17575367199551808)
,p_name=>'&PRODUCT_NAME.'
,p_template=>wwv_flow_imp.id(517418631967368160)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select min(log_day) as log_day,',
'       current_apex_version',
'  from wwv_instance_aggr_metrics',
'group by current_apex_version'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(805672157251677851)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17575425521551809)
,p_query_column_id=>1
,p_column_alias=>'LOG_DAY'
,p_column_display_sequence=>10
,p_column_heading=>'Log Day'
,p_use_as_row_header=>'Y'
,p_column_format=>'&DATE_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17575617577551811)
,p_query_column_id=>2
,p_column_alias=>'CURRENT_APEX_VERSION'
,p_column_display_sequence=>20
,p_column_heading=>'Version'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
end;
/
prompt --application/pages/page_01034
begin
wwv_flow_imp_page.create_page(
 p_id=>1034
,p_name=>'Email Pattern'
,p_alias=>'EMAIL-PATTERN'
,p_page_mode=>'MODAL'
,p_step_title=>'Email Pattern'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(721098050798687927)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'360'
,p_dialog_width=>'750'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:3600'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18152438068147033)
,p_plug_name=>'Block Email Patterns'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PROV_EMAIL_PATTERNS'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18919611525096302)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19092836616011721)
,p_plug_name=>'Audit Info'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_plug_template=>wwv_flow_imp.id(721115784857730284)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1034_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18919902249096305)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(18919611525096302)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Pattern'
,p_button_position=>'CREATE'
,p_button_condition=>'P1034_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18920170045096307)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(18919611525096302)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_confirm_message=>'Are you sure you want to delete the &P1034_BLOCK_PATTERN. pattern?'
,p_confirm_style=>'warning'
,p_button_condition=>'P1034_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18919855881096304)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(18919611525096302)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1034_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18152623061147035)
,p_name=>'P1034_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_is_query_only=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_item_source_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18152834423147037)
,p_name=>'P1034_COMMENTS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_item_source_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_prompt=>'Comments'
,p_source=>'COMMENTS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a description for this pattern.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18152966908147038)
,p_name=>'P1034_CREATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(19092836616011721)
,p_item_source_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_prompt=>'Created On'
,p_format_mask=>'&DATE_FORMAT.'
,p_source=>'CREATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18153052934147039)
,p_name=>'P1034_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(19092836616011721)
,p_item_source_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_prompt=>'Created By'
,p_source=>'CREATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18153193673147040)
,p_name=>'P1034_LAST_UPDATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(19092836616011721)
,p_item_source_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_prompt=>'Last Updated On'
,p_format_mask=>'&DATE_FORMAT.'
,p_source=>'LAST_UPDATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18153224510147041)
,p_name=>'P1034_LAST_UPDATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(19092836616011721)
,p_item_source_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_prompt=>'Last Updated By'
,p_source=>'LAST_UPDATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19977636166203402)
,p_name=>'P1034_BLOCK_PATTERN'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_item_source_plug_id=>wwv_flow_imp.id(18152438068147033)
,p_item_default=>'%'
,p_prompt=>'Pattern'
,p_source=>'BLOCK_PATTERN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(721133598269759785)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a block pattern. It prevents auto/self provisioning of a workspace for an email address using the listed pattern.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18919721477096303)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(18152438068147033)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process - Block Email Patterns'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>18919721477096303
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18920619280096312)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>18920619280096312
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18152572202147034)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(18152438068147033)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize Form - Block Email Patterns'
,p_internal_uid=>18152572202147034
);
end;
/
prompt --application/pages/page_01035
begin
wwv_flow_imp_page.create_page(
 p_id=>1035
,p_name=>'Top Users'
,p_alias=>'TOP-USERS'
,p_step_title=>'Top Users'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(11152563947112359)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29819330577483999)
,p_plug_name=>'Users'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with time_frame as (',
'    select case when :P1035_SINCE < 100',
'                then trunc(sysdate) - nvl(:P1035_SINCE, :AI_DEFAULT_REPORTING_PERIOD)',
'                else to_date(:P1035_START_DATE)',
'           end start_interval_1x,',
'           case when :P1035_SINCE < 100',
'                then trunc(sysdate) - 1/24/3600',
'                else to_date(:P1035_END_DATE)',
'           end end_interval_1x',
'      from sys.dual ),',
'all_users as (',
'    select a.userid,',
'           sum(case',
'                   when a.time_stamp between tf.start_interval_1x and tf.end_interval_1x',
'                       then 1',
'                   else 0',
'               end)                               as page_events_total_1x,',
'           sum(case',
'                   when a.time_stamp between tf.start_interval_1x and tf.end_interval_1x',
'                       then decode(a.page_view_type, 2, 1, 0)',
'                   else 0',
'               end)                               as page_views_1x,',
'           count(distinct case',
'                   when a.time_stamp between tf.start_interval_1x and tf.end_interval_1x',
'                       then a.session_id',
'                   end)                           as distinct_sessions_total_1x,',
'           sum(case',
'                   when a.time_stamp between tf.start_interval_1x and tf.end_interval_1x',
'                       then decode(sqlerrm, null, 0, 1)',
'                   else 0',
'               end)                               as error_count_total_1x,',
'           count(distinct case',
'                              when a.time_stamp between tf.start_interval_1x and tf.end_interval_1x',
'                                  then a.flow_id',
'                              end)                as apps_count_1x,',
'           count(*)                               as page_events_total,',
'           sum(decode(a.page_view_type, 2, 1, 0)) as page_views,',
'           count(distinct a.session_id)           as distinct_sessions_total,',
'           sum(decode(sqlerrm, null, 0, 1))       as error_count_total,',
'           count(distinct a.flow_id)              as apps_count                                   ',
'      from wwv_flow_activity_log a,',
'           time_frame           tf',
'     where a.security_group_id not in (0, 10, 11, 12)',
'       and a.flow_id not between 4000 and 4999',
'       and a.time_stamp <= trunc(sysdate) - 1/24/3600',
'  group by a.userid ),',
'order_apps as (',
'     select row_number() over (order by page_events_total_1x desc,',
'                                        page_views_1x desc,',
'                                        distinct_sessions_total_1x desc,',
'                                        error_count_total_1x desc,',
'                                        apps_count_1x desc) as user_order,',
'            userid,                            ',
'            page_events_total_1x,',
'            trunc(nvl(page_events_total_1x, 0)/nullif(page_events_total, 0) * 100, 2) as pg_page_events,',
'            page_views_1x,',
'            trunc(nvl(page_views_1x, 0)/nullif(page_views, 0) * 100, 2) as pg_page_views,',
'            distinct_sessions_total_1x,',
'            trunc(nvl(distinct_sessions_total_1x, 0)/nullif(distinct_sessions_total, 0) * 100, 2) as pg_distinct_sessions_total,',
'            error_count_total_1x,',
'            trunc(nvl(error_count_total_1x, 0)/nullif(error_count_total, 0) * 100, 2) as pg_error_count_total,',
'            apps_count_1x,',
'            trunc(nvl(apps_count_1x, 0)/nullif(apps_count, 0) * 100, 2) as pg_apps_count',
'       from all_users )',
'select user_order user_rank, ',
'       userid,',
'       page_events_total_1x       as page_events_total,',
'       pg_page_events,',
'       page_views_1x              as page_views,',
'       pg_page_views,',
'       distinct_sessions_total_1x as distinct_sessions_total,',
'       pg_distinct_sessions_total,',
'       error_count_total_1x       as error_count_total,',
'       pg_error_count_total,',
'       apps_count_1x              as apps_count,',
'       pg_apps_count',
' from order_apps',
'where user_order <= :P1035_TOP_N_USERS'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P1035_SINCE,P1035_START_DATE,P1035_END_DATE,P1035_TOP_N_USERS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Users'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(36775776293486375)
,p_no_data_found_message=>'No users found.'
,p_max_rows_per_page=>'30'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>true
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ANDRDOBR'
,p_internal_uid=>36775776293486375
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19980489596203430)
,p_db_column_name=>'USERID'
,p_display_order=>20
,p_column_identifier=>'R'
,p_column_label=>'User ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19980548947203431)
,p_db_column_name=>'PAGE_EVENTS_TOTAL'
,p_display_order=>30
,p_column_identifier=>'S'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19980637966203432)
,p_db_column_name=>'PG_PAGE_EVENTS'
,p_display_order=>40
,p_column_identifier=>'T'
,p_column_label=>'Page Events (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19980775268203433)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>50
,p_column_identifier=>'U'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19980847935203434)
,p_db_column_name=>'PG_PAGE_VIEWS'
,p_display_order=>60
,p_column_identifier=>'V'
,p_column_label=>'Page Views (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19980928882203435)
,p_db_column_name=>'DISTINCT_SESSIONS_TOTAL'
,p_display_order=>70
,p_column_identifier=>'W'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19981042885203436)
,p_db_column_name=>'PG_DISTINCT_SESSIONS_TOTAL'
,p_display_order=>80
,p_column_identifier=>'X'
,p_column_label=>'Sessions (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19981101695203437)
,p_db_column_name=>'ERROR_COUNT_TOTAL'
,p_display_order=>90
,p_column_identifier=>'Y'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20491995759535501)
,p_db_column_name=>'PG_ERROR_COUNT_TOTAL'
,p_display_order=>100
,p_column_identifier=>'AB'
,p_column_label=>'Errors (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19981213049203438)
,p_db_column_name=>'APPS_COUNT'
,p_display_order=>110
,p_column_identifier=>'Z'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19981313026203439)
,p_db_column_name=>'PG_APPS_COUNT'
,p_display_order=>130
,p_column_identifier=>'AA'
,p_column_label=>'Applications (%)'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:::'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(20492099924535502)
,p_db_column_name=>'USER_RANK'
,p_display_order=>140
,p_column_identifier=>'AC'
,p_column_label=>'Rank'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(36984532241423454)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'169698'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>30
,p_report_columns=>'USER_RANK:USERID:PAGE_EVENTS_TOTAL:PG_PAGE_EVENTS:PAGE_VIEWS:PG_PAGE_VIEWS:DISTINCT_SESSIONS_TOTAL:PG_DISTINCT_SESSIONS_TOTAL:ERROR_COUNT_TOTAL:PG_ERROR_COUNT_TOTAL:APPS_COUNT:PG_APPS_COUNT:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41303421808678868)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The report shows the top users based on the metrics retained within it for a specified time interval.</p>',
'<p>All graph columns display the metric percentage based on the aggregated value for the selected time interval and the',
'total.</p>',
'<p>The data for the following reports is based on the Metrics gathered once per day, except the current date.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47403127083870451)
,p_plug_name=>'Buttons Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(95149552041195975)
,p_plug_name=>'User Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(20829938868705277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(202626814415270397)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23395739256905909)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(47403127083870451)
,p_button_name=>'SET'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'t-Button--noUI'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20012733145383170)
,p_name=>'P1035_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47403127083870451)
,p_item_default=>'return wwv_flow_platform.get_preference(p_preference_name => ''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ADMIN_DIGEST.RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct d, t from (',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.DAY'')          d,    1 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''2'' ) d,    2 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''7'' ) d,    7 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''15'') d,   15 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''30'') d,   30 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''45'') d,   45 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''60'') d,   60 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message(''APEX.TIME.N_DAYS'', ''90'') d,   90 t from sys.dual union all',
'select wwv_flow_lang_dev.builder_message (',
'           case default_reporting_period',
'                when 1 then ''APEX.TIME.DAY''',
'                else ''APEX.TIME.N_DAYS''',
'           end,',
'           default_reporting_period) as d,',
'       default_reporting_period as t',
'  from (select to_number(wwv_flow_platform.get_preference(''ADMIN_DIGEST_DEFAULT_REPORTING_PERIOD'')) default_reporting_period',
'          from sys.dual)',
'union all',
'select wwv_flow_lang_dev.builder_message(''CUSTOM'') d, 100 t from sys.dual)',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20013139894383172)
,p_name=>'P1035_TOP_N_USERS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47403127083870451)
,p_item_default=>'5'
,p_prompt=>'Rank'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ADMIN_DIGEST.TOP_N_ACTIVITY'
,p_lov=>'.'||wwv_flow_imp.id(18953694156990390)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20013559365383173)
,p_name=>'P1035_START_DATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(47403127083870451)
,p_prompt=>'Start'
,p_format_mask=>'&DATE_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'ITEM'
,p_attribute_08=>'P1035_END_DATE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20013992877383173)
,p_name=>'P1035_END_DATE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(47403127083870451)
,p_prompt=>'End Date'
,p_format_mask=>'&DATE_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'ITEM'
,p_attribute_05=>'P1035_START_DATE'
,p_attribute_06=>'STATIC'
,p_attribute_07=>'&P1035_MAX_DATE.'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23306777827666725)
,p_name=>'P1035_MAX_DATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(47403127083870451)
,p_source=>'return trunc(sysdate) - 1;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20395013325219093)
,p_name=>'Show/Hide Custom'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1035_SINCE'
,p_condition_element=>'P1035_SINCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'100'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20395435455219097)
,p_event_id=>wwv_flow_imp.id(20395013325219093)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1035_START_DATE,P1035_END_DATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20395916288219097)
,p_event_id=>wwv_flow_imp.id(20395013325219093)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1035_START_DATE,P1035_END_DATE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20396323070220778)
,p_name=>'Refresh Region'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(23395739256905909)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20396733100220779)
,p_event_id=>wwv_flow_imp.id(20396323070220778)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-region'
);
end;
/
prompt --application/pages/page_04001
begin
wwv_flow_imp_page.create_page(
 p_id=>4001
,p_name=>'Edit Application/Build Status'
,p_alias=>'EDIT-APPLICATION-BUILD-STATUS'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Status'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'350'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_bld_status.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(244297732473824476)
,p_plug_name=>'Edit Status'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721130166613730309)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955891016107997321)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(244298131468824477)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(955891016107997321)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P4001_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(244298330675824481)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(955891016107997321)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6524523357975521)
,p_name=>'P4001_APPLICATION_STATUS'
,p_item_sequence=>61
,p_item_plug_id=>wwv_flow_imp.id(244297732473824476)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Status'
,p_source=>'FLOW_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_FLOW_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(85746300886317667)||'.'
,p_cHeight=>1
,p_display_when=>':P4001_ATTRIBUTE = ''Application'' or :P4001_ATTRIBUTE is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies whether or not the application is available or unavailable for use. <p>',
'Options include:<br>',
'<ul>',
'<li><strong>Available</strong> - Application is available with no restrictions.</li>',
'<li><strong>Available with Developer Toolbar</strong> - Application is available for use. For developers, the Developer Toolbar is included on each page. Requires the developer to be logged in to the App Builder in the same browser session.</li>',
'<li><strong>Available to Developers Only</strong> - Application is available to users having developer privileges.</li>',
'<li><strong>Restricted Access</strong> - Application is available to developers named in Restrict to comma separated user list.</li>',
'<li><strong>Unavailable</strong> - Application cannot be run or edited. The message in Message for unavailable application displays when users attempt to access the application.</li>',
'<li><strong>Unavailable (Status Shown with PL/SQL)</strong> - Application cannot be run or edited.</li>',
'<li><strong>Unavailable (Redirect to URL)</strong> - Application cannot be run. The user is linked to the URL entered in Message for unavailable application.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Identifies the build status of the current application.  If the current status does not allow editing, then developers are locked out of the application.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6524743208975523)
,p_name=>'P4001_ATTRIBUTE'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(244297732473824476)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(244299330227824486)
,p_name=>'P4001_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(244297732473824476)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(244299726832824494)
,p_name=>'P4001_SECURITY_GROUP_ID'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(244297732473824476)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace:'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''F4050_SHOW_ALL_WORKSPACES'')||',
''' -'' d, 0 r from dual union all',
'select wwv_flow_escape.html(short_name)||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the workspace name and ID.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(244300515591824500)
,p_name=>'P4001_OWNER'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_imp.id(244297732473824476)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parsing Schema:'
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the database schema that this application will parse SQL statements as.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(244301232268824502)
,p_name=>'P4001_NAME'
,p_item_sequence=>41
,p_item_plug_id=>wwv_flow_imp.id(244297732473824476)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies application name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(244302030007824504)
,p_name=>'P4001_BUILD_STATUS'
,p_item_sequence=>51
,p_item_plug_id=>wwv_flow_imp.id(244297732473824476)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Build Status'
,p_source=>'BUILD_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(244320808989852457)||'.'
,p_cHeight=>1
,p_display_when=>':P4001_ATTRIBUTE = ''Build'' or :P4001_ATTRIBUTE is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a Build Status. Options include:</p>',
'<ul>',
'<li><strong>Run Application Only</strong> - Developers can only run an application. Application will appear in the list of applications shown in the App Builder for the workspace, but cannot be edited in any way.</li>',
'<li><strong>Run and Build Application</strong> - Developers can both run and edit an application. Application will appear in the App Builder''s list of applications for the workspace.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Identifies the build status of the current application.  If the current status does not allow editing, then developers are locked out of the application.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(244300201396824498)
,p_validation_name=>'P4001_SECURITY_GROUP_ID not null'
,p_validation_sequence=>2
,p_validation=>'P4001_SECURITY_GROUP_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Security Group Id must have some value.'
,p_associated_item=>wwv_flow_imp.id(244299726832824494)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(244300910172824501)
,p_validation_name=>'P4001_OWNER not null'
,p_validation_sequence=>6
,p_validation=>'P4001_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Owner must have some value.'
,p_associated_item=>wwv_flow_imp.id(244300515591824500)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(244301701272824502)
,p_validation_name=>'P4001_NAME not null'
,p_validation_sequence=>7
,p_validation=>'P4001_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application must have some value.'
,p_associated_item=>wwv_flow_imp.id(244301232268824502)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(222857324280540001)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(244298330675824481)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(222857445143540002)
,p_event_id=>wwv_flow_imp.id(222857324280540001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(244302528363824510)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOWS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'P4001_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>244302528363824510
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(359906830604609955)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_security.g_security_group_id := :P4001_SECURITY_GROUP_ID;',
'',
'update wwv_flows',
'   set build_status = nvl(:P4001_BUILD_STATUS, build_status),',
'       flow_status  = nvl(:P4001_APPLICATION_STATUS, flow_status)',
' where id = :P4001_ID',
'   and security_group_id = :P4001_SECURITY_GROUP_ID;',
'',
'wwv_flow_security.g_security_group_id := 10;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to process row of table WWV_FLOWS.'
,p_process_when_button_id=>wwv_flow_imp.id(244298131468824477)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>359906830604609955
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(222857971181540007)
,p_process_sequence=>11
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(244298131468824477)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>222857971181540007
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_imp_page.create_page(
 p_id=>8000
,p_name=>'Workspace Search'
,p_alias=>'WORKSPACE-SEARCH'
,p_step_title=>'Workspace Search'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(721098416706687971)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_srch.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29812203483293080)
,p_plug_name=>'Workspaces'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(721125879764730304)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ID,',
'    PROVISIONING_COMPANY_ID,',
'    SHORT_NAME,',
'    FIRST_SCHEMA_PROVISIONED,',
'    ALLOW_PLSQL_EDITING,',
'    LAST_LOGIN,',
'    EXPIRE_FND_USER_ACCOUNTS,',
'    ACCOUNT_LIFETIME_DAYS,',
'    FND_USER_MAX_LOGIN_FAILURES,',
'    BUILDER_NOTIFICATION_MESSAGE,',
'    (select count(*) from wwv_flows f where f.security_group_id = w.PROVISIONING_COMPANY_ID) Applications,',
'    (select count(*) from WWV_FLOW_COMPANY_SCHEMAS f where f.SECURITY_GROUP_ID = w.PROVISIONING_COMPANY_ID) schemas,',
'    nvl((select ''YES'' from dual where exists (select 1 from WWV_FLOW_SESSIONS$ s where s.SECURITY_GROUP_ID = w.PROVISIONING_COMPANY_ID)),''NO'') active_sessions',
'from WWV_FLOW_COMPANIES w',
'where PROVISIONING_COMPANY_ID not in (0,10,11,12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(29812322315293080)
,p_name=>'Workspaces'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29812514805293088)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29812613782293090)
,p_db_column_name=>'PROVISIONING_COMPANY_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace ID'
,p_column_type=>'NUMBER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29812729987293090)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Workspace'
,p_column_link=>'f?p=&APP_ID.:8001:&SESSION.::&DEBUG.:8001:P8001_WORKSPACE_ID:#PROVISIONING_COMPANY_ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29812813321293090)
,p_db_column_name=>'FIRST_SCHEMA_PROVISIONED'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'First Schema Provisioned'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29812901281293091)
,p_db_column_name=>'ALLOW_PLSQL_EDITING'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Allow PL/SQL Editing'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29813015705293091)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Last Login'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29813108595293092)
,p_db_column_name=>'EXPIRE_FND_USER_ACCOUNTS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Expired'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29813211663293092)
,p_db_column_name=>'ACCOUNT_LIFETIME_DAYS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Account Lifetime Days'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29813308615293092)
,p_db_column_name=>'FND_USER_MAX_LOGIN_FAILURES'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Maximum Login Failures'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29813431684293092)
,p_db_column_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Builder Notification Message'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29817130683334112)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29819407312365146)
,p_db_column_name=>'SCHEMAS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Schemas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29859420874189997)
,p_db_column_name=>'ACTIVE_SESSIONS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Active Sessions'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(110344620122166929)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(29813520463293321)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1317102257536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SHORT_NAME:FIRST_SCHEMA_PROVISIONED:LAST_LOGIN:PROVISIONING_COMPANY_ID:APPLICATIONS:SCHEMAS:ACTIVE_SESSIONS'
,p_sort_column_1=>'SHORT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1080989625371523929)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(29812203483293080)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:RP,RIR,8000:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30179614848846477)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(29812203483293080)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(357640153218810948)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(29812203483293080)
,p_button_name=>'CREATE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372670814202760)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:142:LAST_VIEW:8000'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>-wwv_flow_imp.id(3913175260740993520)
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29946031991896157)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'8000'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_08001
begin
wwv_flow_imp_page.create_page(
 p_id=>8001
,p_name=>'Workspace'
,p_alias=>'WORKSPACE'
,p_step_title=>'Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216765317551591446)
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_srch.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29818204757354956)
,p_plug_name=>'Workspace Details'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>20
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_workspace_reports.get_report_workspace_usage (',
'           p_time_frame_DWMY   => nvl(:P8001_REPORTING_PERIOD,''W''),',
'           p_date_format       => :DATE_TIME_FORMAT,',
'           p_security_group_id => :P8001_WORKSPACE_ID );',
''))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_ajax_items_to_submit=>'P8001_REPORTING_PERIOD,P8001_WORKSPACE_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30187402353965943)
,p_plug_name=>'hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(29794925290987920)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180424225671454717)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(721110277025730268)
,p_plug_display_sequence=>15
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180504904780290631)
,p_plug_name=>'Workspace Details'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(517418631967368160)
,p_plug_display_sequence=>110
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This page shows key workspace attributes.  You can email this report using the email button on top of the page.',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(180729515289344564)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(180424225671454717)
,p_button_name=>'P8001_GO'
,p_button_static_id=>'P8001_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Set'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29945712598890529)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(180424225671454717)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30183916458913195)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(180424225671454717)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Edit Workspace'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:78:P78_PROVISIONING_COMPANY_ID:&P8001_WORKSPACE_ID.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184031721530143625)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(180424225671454717)
,p_button_name=>'EMAIL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Email'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.::P76_REPORTING_PERIOD,P76_WORKSPACE_ID:&P8001_REPORTING_PERIOD.,&P8001_WORKSPACE_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30182823469896286)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(180424225671454717)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_image_alt=>'Edit Name'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.::P78_PROVISIONING_COMPANY_ID:&P8001_WORKSPACE_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29944501339849457)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(180424225671454717)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29944016445844390)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(180424225671454717)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(517373248988202760)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29944320254845455)
,p_branch_action=>'f?p=&APP_ID.:8001:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29820129261380917)
,p_name=>'P8001_WORKSPACE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30187402353965943)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30185725855944331)
,p_name=>'P8001_WORKSPACE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(30187402353965943)
,p_use_cache_before_default=>'NO'
,p_source=>'select wwv_flow_escape.html(short_name) n from wwv_flow_companies where provisioning_company_id = :P8001_WORKSPACE_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180729332473340047)
,p_name=>'P8001_REPORTING_PERIOD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(180424225671454717)
,p_item_default=>'W'
,p_prompt=>'Reporting Period'
,p_source=>'W'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_imp.id(180726228364333770)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify reporting period'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(29948927414989445)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'next and previous navigation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare n varchar2(255); i number := 0;',
'begin',
'   select max(short_name) into n',
'   from WWV_FLOW_COMPANIES ',
'   where PROVISIONING_COMPANY_ID = :P8001_WORKSPACE_ID;',
'',
'if v(''REQUEST'') = ''NEXT'' then',
'   for c1 in (select PROVISIONING_COMPANY_ID',
'       from WWV_FLOW_COMPANIES',
'       where SHORT_NAME > n and PROVISIONING_COMPANY_ID not in (0,10,11)',
'       order by short_name) loop',
'       i := c1.PROVISIONING_COMPANY_ID;',
'       exit;',
'   end loop;',
'elsif v(''REQUEST'') = ''PREVIOUS'' then',
'   for c1 in (select PROVISIONING_COMPANY_ID',
'       from WWV_FLOW_COMPANIES',
'       where SHORT_NAME < n and PROVISIONING_COMPANY_ID not in (0,10,11)',
'       order by short_name desc) loop',
'       i := c1.PROVISIONING_COMPANY_ID;',
'       exit;',
'   end loop;',
'else',
'   i := :P8001_WORKSPACE_ID;',
'end if;',
'if i > 0 then',
':P8001_WORKSPACE_ID := i;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>29948927414989445
);
end;
/
prompt --application/pages/page_08011
begin
wwv_flow_imp_page.create_page(
 p_id=>8011
,p_name=>'Login Page'
,p_alias=>'LOGIN'
,p_step_title=>'Oracle APEX Internal Administration - Log In'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(517336519765126407)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(38543621788954541)
,p_plug_name=>'Oracle APEX Internal Administration'
,p_region_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(38545727848954559)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(38543621788954541)
,p_button_name=>'LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(517372214551202759)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Log In'
,p_button_position=>'CREATE'
,p_button_alignment=>'LEFT'
,p_grid_new_row=>'Y'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38544067168954546)
,p_name=>'P8011_USERNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(38543621788954541)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>100
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38544435607954549)
,p_name=>'P8011_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(38543621788954541)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>40
,p_cMaxlength=>100
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38544886798954550)
,p_name=>'P8011_REMEMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(38543621788954541)
,p_prompt=>'Remember username'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>'wwv_flow_authentication_api.persistent_cookies_enabled'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(721133390982759781)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38546534520954564)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_api.send_login_username_cookie (',
'    p_username => lower(:P8011_USERNAME),',
'    p_consent  => :P8011_REMEMBER = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>38546534520954564
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38546136119954562)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_api.login(',
'    p_username => :P8011_USERNAME,',
'    p_password => :P8011_PASSWORD );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>38546136119954562
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38547344548954564)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page(s) Cache'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>38547344548954564
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38546985930954564)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P8011_USERNAME := wwv_flow_authentication_api.get_login_username_cookie;',
':P8011_REMEMBER := case when :P8011_USERNAME is not null then ''Y'' end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>38546985930954564
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_imp_shared.create_install(
 p_id=>wwv_flow_imp.id(732350836269449234)
);
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_imp.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false)
);
commit;
end;
/
set verify on feedback on define on
prompt  ...done
