prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- Oracle APEX export file
--
-- You should run this script using a SQL client connected to the database as
-- the owner (parsing schema) of the application or as a database user with the
-- APEX_ADMINISTRATOR_ROLE role.
--
-- This export file has been automatically generated. Modifying this file is not
-- supported by Oracle and can lead to unexpected application and/or instance
-- behavior now or in the future.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_imp.import_begin (
 p_version_yyyy_mm_dd=>'2024.05.31'
,p_release=>'24.1.0'
,p_default_workspace_id=>10
,p_default_application_id=>4350
,p_default_id_offset=>0
,p_default_owner=>'APEX_240100'
);
end;
/
 
prompt APPLICATION 4350 - Oracle APEX Workspace Administration
--
-- Application Export:
--   Application:     4350
--   Name:            Oracle APEX Workspace Administration
--   Exported By:     APEX_240100
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    123
--       Items:                  286
--       Computations:            26
--       Validations:             94
--       Processes:              114
--       Regions:                408
--       Buttons:                229
--       Dynamic Actions:         51
--     Shared Components:
--       Logic:
--         Items:                  8
--         Processes:              1
--         Computations:           4
--         Build Options:          3
--       Navigation:
--         Lists:                 33
--         Breadcrumbs:            1
--           Entries:            115
--         NavBar Entries:         4
--       Security:
--         Authentication:         1
--         Authorization:         15
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                10
--           Region:              38
--           Label:               12
--           List:                14
--           Popup LOV:            1
--           Calendar:             2
--           Breadcrumb:           2
--           Button:              13
--           Report:               9
--         LOVs:                  68
--         Shortcuts:              3
--         Plug-ins:              13
--       PWA:
--       Globalization:
--         Messages:              13
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--   Version:         24.1.0
--   Instance ID:     1000197243005302
--

prompt --application/delete_application
begin
wwv_flow_imp.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_imp_workspace.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_240100')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Workspace Administration')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'WORKSPACE-ADMIN')
,p_application_group=>wwv_flow_imp.id(91050719712959059)
,p_application_group_name=>'APEX Product'
,p_application_group_comment=>'Applications shipped with the APEX product distribution'
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt=>'59558075A3FE81DB011B5D7DBE6C1948FC163FC46B10F1DAAA23B861B1AB4902'
,p_checksum_salt_last_reset=>'19990804000000'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_accessible_read_only=>'N'
,p_session_state_commits=>'IMMEDIATE'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_documentation_banner=>'Oracle APEX Workspace administration user interface.  Allows APEX developers designated as workspace administrators the ability to manage their workspace and developers.'
,p_authentication_id=>wwv_flow_imp.id(539691214090646644)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 24.1.0'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'W'
,p_pass_ecid=>'N'
,p_security_scheme=>wwv_flow_imp.id(1367105411776376234)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_substitution_string_01=>'LOGOUT'
,p_substitution_value_01=>'Logout'
,p_substitution_string_02=>'PRODUCT_NAME'
,p_substitution_value_02=>'Oracle APEX'
,p_substitution_string_03=>'MSG_COMPANY'
,p_substitution_value_03=>'Workspace: &COMPANY.'
,p_substitution_string_04=>'MSG_LANGUAGE'
,p_substitution_value_04=>'Language'
,p_substitution_string_05=>'MSG_COPYRIGHT'
,p_substitution_value_05=>'Copyright &copy; 1999, 2024, Oracle and/or its affiliates.'
,p_substitution_string_06=>'MSG_USER'
,p_substitution_value_06=>'User'
,p_substitution_string_07=>'MSG_JSCRIPT'
,p_substitution_value_07=>'You must run this product with JavaScript enabled.'
,p_substitution_string_08=>'MSG_TBL_SUMMARY'
,p_substitution_value_08=>'Page Layout Table'
,p_substitution_string_09=>'DONE'
,p_substitution_value_09=>'Done'
,p_substitution_string_10=>'TOP'
,p_substitution_value_10=>'Top'
,p_substitution_string_11=>'CLOSE'
,p_substitution_value_11=>'Close'
,p_substitution_string_12=>'EDIT'
,p_substitution_value_12=>'Edit'
,p_substitution_string_13=>'DATE_FORMAT'
,p_substitution_value_13=>'mm/dd/yyyy'
,p_substitution_string_14=>'LONG_DATE_FORMAT'
,p_substitution_value_14=>'fmDay, Month dd, yyyy'
,p_substitution_string_15=>'TIME_FORMAT'
,p_substitution_value_15=>'hh:mi:ss AM'
,p_substitution_string_16=>'DATE_TIME_FORMAT'
,p_substitution_value_16=>'mm/dd/yyyy hh:mi:ss AM'
,p_substitution_string_17=>'DELETE_MSG'
,p_substitution_value_17=>'Would you like to perform this delete action?'
,p_substitution_string_18=>'HELP'
,p_substitution_value_18=>'Help'
,p_substitution_string_19=>'MSG_WORKSPACE'
,p_substitution_value_19=>'Workspace'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_print_server_type=>'INSTANCE'
,p_file_storage=>'DB'
,p_is_pwa=>'N'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_imp_shared.create_user_interface(
 p_id=>wwv_flow_imp.id(4350)
,p_theme_id=>3
,p_home_url=>'f?p=4100:1:&SESSION.'
,p_login_url=>'f?p=4550:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>0
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(882616872498402)
,p_name=>'monitor.reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(883603843504111)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Most Viewed Pages over All Applications'
,p_list_item_link_target=>'f?p=&APP_ID.:190:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(886617134517436)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Monthly Calendar of Page Views by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_calendar.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(9402215610184148)
,p_list_item_display_sequence=>33
,p_list_item_link_text=>'Line Chart of Usage by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1027331717491838)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'By Weighted Page Performance'
,p_list_item_link_target=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(231672816230382135)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Page Caching Performance by Application'
,p_list_item_link_target=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_required_patch=>wwv_flow_imp.id(231647503239340557)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(231673121771383712)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Page Caching Performance by Page'
,p_list_item_link_target=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_required_patch=>wwv_flow_imp.id(231647503239340557)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/extension_links_and_subscriptions
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2817792749942896)
,p_name=>'extension links and subscriptions'
,p_list_status=>'PUBLIC'
,p_version_scn=>33426795
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2817976034942897)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Links'
,p_list_item_link_target=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'110'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2827033415009144)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:114:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'114'
);
end;
/
prompt --application/shared_components/navigation/lists/extension_links_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4801328176356944)
,p_name=>'Extension Links Menu'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lev,',
'       label,',
'       target,',
'       null     as is_current,',
'       null     as image,',
'       null     as image_attrib,',
'       null     as image_alt_attribute,',
'       null     as attribute1,',
'       null     as attribute2,',
'       null     as attribute3,',
'       null     as attribute4,',
'       null     as attribute5,',
'       ''_blank'' as attribute6,',
'       null     as attribute7,',
'       null     as attribute8,',
'       null     as attribute9,',
'       null     as attribute10',
'  from (',
'          select 1                          as lev,',
'                 name                       as label,',
'                 wwv_extension.get_url(url) as target,',
'                 null                       as wsname,',
'                 display_sequence',
'            from wwv_extension_links',
'           where security_group_id = :workspace_id',
'          union all',
'          select 1                                           as lev,',
'                 nvl(eg.menu_label, initcap(c.display_name)) as label,',
'                 null                                        as target,',
'                 c.display_name                              as wsname,',
'                 0                                           as display_sequence',
'            from wwv_extension_grants eg, wwv_flow_companies c',
'           where eg.security_group_id           = :workspace_id',
'             and eg.extension_security_group_id = c.provisioning_company_id',
'             and exists (',
'                   select 1',
'                     from wwv_extension_links l',
'                    where l.security_group_id = eg.extension_security_group_id',
'                      and is_public           = ''Y'' )',
'          union all',
'          select 2                             as lev,',
'                 name                          as label,',
'                 wwv_extension.get_url(el.url) as target,',
'                 eg.wsname                     as wsname,',
'                 el.display_sequence',
'            from (',
'                    select eg.*,',
'                           c.display_name as wsname',
'                      from wwv_extension_grants eg, wwv_flow_companies c',
'                     where eg.security_group_id           = :workspace_id',
'                       and eg.extension_security_group_id = c.provisioning_company_id',
'                 )                         eg, wwv_extension_links el',
'           where el.security_group_id = eg.extension_security_group_id',
'             and el.is_public         = ''Y''',
'       )',
' order by wsname nulls first, lev, display_sequence, label'))
,p_list_status=>'PUBLIC'
,p_reference_id=>2000133062045966
,p_version_scn=>40349138
);
end;
/
prompt --application/shared_components/navigation/lists/user_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4869427763068324)
,p_name=>'user reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(182264209824455263)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Schema Tablespace Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(67222825207706896)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Database Privileges by Schema'
,p_list_item_link_target=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4936425863455707)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Workspace Schemas'
,p_list_item_link_target=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47074825204475016)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Report Tablespace Utilization (popup)'
,p_list_item_link_target=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(199868595682626900)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Web Service Activity Log'
,p_list_item_link_target=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2317715159910075)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Archive Of Purged Task Files'
,p_list_item_link_target=>'f?p=&APP_ID.:107:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/task_request_storage
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6621926453040443)
,p_name=>'task.request.storage'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6623112732045993)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Request Storage'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/error_reporting
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(9787313686564805)
,p_name=>'Error Reporting'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(9787701696570857)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Errors'
,p_list_item_link_target=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/p22_application_changes
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(22853420277011168)
,p_name=>'p22 Application Changes'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20238719980680877)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'By Developer'
,p_list_item_link_target=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(9828203951309455)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'By Developer Bar Chart'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_piechart.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1760803479628418008)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'By Developer by Hour'
,p_list_item_link_target=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6684624783765017)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'By Day'
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1175007942169208)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'By Application'
,p_list_item_link_target=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(58181920001360047)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Application Changes, detailed'
,p_list_item_link_target=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(42038019608233730)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'By Day, Monthly View'
,p_list_item_link_target=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_calendar.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(166218023992861164)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Component Utilization Chart'
,p_list_item_link_target=>'f?p=&APP_ID.:97:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_login_access
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(26405214790138770)
,p_name=>'monitor.login_access'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(26405620677140498)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Login Attempts'
,p_list_item_link_target=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(42725912639812593)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Login Attempts by Authentication Result'
,p_list_item_link_target=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10275514161901974)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Developer Login Summary'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_caching
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(41424809053067534)
,p_name=>'Manage Caching'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(41425317018069852)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Purge Cached Regions by Region'
,p_list_item_link_target=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge cache for a region, by selecting one or more regions.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10313118719357406)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'Purge Cached Regions by Application'
,p_list_item_link_target=>'f?p=&APP_ID.:303:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge all cached regions for the specified application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10314514001365509)
,p_list_item_display_sequence=>12
,p_list_item_link_text=>'Purge Cached Regions by Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge all cached regions for the current workspace.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(41425624290071958)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Purge Cached Pages by Page'
,p_list_item_link_target=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge all cached regions on a page, by selecting one or more pages.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10316706991382400)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Purge Cached Pages by Application'
,p_list_item_link_target=>'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge all cached pages for the specified application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10318214741394151)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Purge Expired Cached Pages by Application'
,p_list_item_link_target=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge only cached pages that have expired for the specified application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_workspace
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(41758527939236654)
,p_name=>'Manage Workspace'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(41759000215236656)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Make a Service Request'
,p_list_item_link_target=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:49:::'
,p_list_item_icon=>'icon-admin-service-request'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'Request access to a database schema, additional storage, or  to terminate the workspace.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47234208185608874)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Set Workspace Preferences'
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-admin-workspace-preferences'
,p_list_text_01=>'Configure functionality available to developers within this workspace.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(173249312901228720)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Define Workspace Message'
,p_list_item_link_target=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-admin-edit-announcement'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_text_01=>'Define the workspace message.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(145773694894328470)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Define Environment Banner'
,p_list_item_link_target=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-sc-app-process'
,p_list_text_01=>'Define the workspace-level banner that is displayed on all pages.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'105'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168269607070943956)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Workspace Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-admin-workspace-utilization'
,p_list_text_01=>'View the workspace summary report, including schema and activity details.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'101'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1601259010547468)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Manage Extension Links'
,p_list_item_link_target=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-admin-extension-links'
,p_list_text_01=>'Configure workspace extension links that will be shown in the Extensions menu in the builder''s navigation bar.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'110,112'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_logs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(41778218420271753)
,p_name=>'Manage Logs'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(41778402469271753)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Developer Activity Log'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RP,30:::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'30'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(42463902076904417)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Manage Click Count Log'
,p_list_item_link_target=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'84'
);
end;
/
prompt --application/shared_components/navigation/lists/page_21_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(41809121808367332)
,p_name=>'Page 21 Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492151931609850014)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Saved Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-download-xlif-translation '
,p_list_text_01=>'Review saved reports for applications. Reports, other than Primary Default, can also be deleted.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(48515414990925228)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-subscriptions'
,p_list_text_01=>'Review subscriptions for applications. Any subscriptions can also be deleted.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/administration_home
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(46082227723554970)
,p_name=>'Administration - Home'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46083626824639868)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Manage Service'
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-service'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46082624737563617)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Users and Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-users'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46083204567576672)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Monitor Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-monitor-activity'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_imp.id(47302021031728224)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47341025593948125)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Dashboards'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-dashboards'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_imp.id(47302021031728224)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20635613776358966)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utilization Report'
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'admin-utilization-report'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/dashboards
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(46989621592546067)
,p_name=>'Dashboards'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47002219860895685)
,p_list_item_display_sequence=>8
,p_list_item_link_text=>'Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'33'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46989826094547451)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Users'
,p_list_item_link_target=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'60'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46991211942571754)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'13'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47333325078635734)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Developer Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'71'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47357220547457512)
,p_list_item_display_sequence=>27
,p_list_item_link_text=>'Performance'
,p_list_item_link_target=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'78'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47998210717122914)
,p_list_item_display_sequence=>29
,p_list_item_link_text=>'Applications'
,p_list_item_link_target=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'91'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47392009342570705)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Database'
,p_list_item_link_target=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'79'
);
end;
/
prompt --application/shared_components/navigation/lists/users_and_groups_apex_4_0
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47054717520943020)
,p_name=>'users and groups APEX 4.0'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47055126870945672)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Users'
,p_list_item_link_target=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'55'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47055330333946679)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'53'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(132385410060946836)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Group Assignments'
,p_list_item_link_target=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:RP,51:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_service_manage_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47244730835700645)
,p_name=>'manage service / manage tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(563487671205228278)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Data Dictionary Cache'
,p_list_item_link_target=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:RP,800:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47245532136719927)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Developer Activity and Click Count Logs'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47246012527723718)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Session State'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47246916814734445)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Application Cache'
,p_list_item_link_target=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47252112237827709)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Application Build Status'
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168483331958366150)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'File Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(493060207510038405)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Interactive Report Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_49_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47296115483238304)
,p_name=>'page 49 tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47296330028242448)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Detailed Tablespace Utilization Report'
,p_list_item_link_target=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(177278408603201894)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Sign up for another workspace'
,p_list_item_link_target=>'f?p=4700:2:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference( p_preference_name => ''SERVICE_REQUEST_FLOW'' ) <> ''MANUAL'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/request_train
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47297014014256767)
,p_name=>'request train'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168280130450988464)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Identify Request'
,p_list_item_link_target=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'96'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47297223018259334)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Define Request'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'49,48,50'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47297426827260442)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'69,510,66'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_calendar_views
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47721323591663284)
,p_name=>'monitor activity / calendar views'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47721606407667742)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Changes by Developer'
,p_list_item_link_target=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'20'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47721810909669094)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'New Pages Created by Developer'
,p_list_item_link_target=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'82'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47768504965263316)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Page Changes by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'89'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_session_state_2
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(49193021558761543)
,p_name=>'Manage Session State 2'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49193803030761544)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Recent Sessions'
,p_list_item_link_target=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-recent-sessions'
,p_list_text_01=>'Review recent sessions, with the ability to drill-down into an individual session and view the items stored in session state for that session.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49233018235845734)
,p_list_item_display_sequence=>21
,p_list_item_link_text=>'Session State for Current Session'
,p_list_item_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-report-session-state'
,p_list_text_01=>'View a report of all the items stored in session state for your current session.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49194117294761544)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Purge Sessions by Age'
,p_list_item_link_target=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge the saved session state information that is older than a specified time frame.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49193217092761543)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Purge Session State for Current Session'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge the session state information stored for your current session.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_preferences_home
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(49208419658798799)
,p_name=>'Manage Preferences Home'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49209216188798800)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Preferences by User'
,p_list_item_link_target=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-preferences-by-user'
,p_list_text_01=>'Review preferences saved by individual users.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49237210055852837)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Current User Preferences'
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-report-session-state'
,p_list_text_01=>'View preferences you have saved.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49209526179798800)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Purge Preferences by User'
,p_list_item_link_target=>'f?p=&APP_ID.:46:&SESSION.::&DEBUG.:46:::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge saved preferences for a specific user.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(49208912194798800)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Purge Preferences for Current User'
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>'Purge preferences you have saved.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/environment_monitoring_options
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(56633624548029155)
,p_name=>'environment monitoring options'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(56635027334029158)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'By User Agent'
,p_list_item_link_target=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(56635314999029158)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'By Browser'
,p_list_item_link_target=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(56635603329029158)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'By External Click'
,p_list_item_link_target=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(56635916722029158)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'By Operating System'
,p_list_item_link_target=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_charts
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(61339238287578026)
,p_name=>'monitor.charts'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(383677460582131171)
,p_list_item_display_sequence=>0
,p_list_item_link_text=>'By View - Faceted Search'
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(26641602494492148)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'By View'
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15610782962052240)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'By User'
,p_list_item_link_target=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1760816402430436488)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'By User and Hour'
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(26157704446429203)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'By Application'
,p_list_item_link_target=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30526206851676352)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'By Application and Page'
,p_list_item_link_target=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(9443402534511474)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'By Day'
,p_list_item_link_target=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47745331041053325)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'By Hour'
,p_list_item_link_target=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(196265008149398549)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'By Interactive Report'
,p_list_item_link_target=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.:RIR:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_apex_demo_objects
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(161065115373372140)
,p_name=>'Manage APEX$DEMO Objects'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
end;
/
prompt --application/shared_components/navigation/lists/create_apex_demo_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(161192747617951712)
,p_name=>'Create APEX$Demo progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
end;
/
prompt --application/shared_components/navigation/lists/activity_log_list
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(162250901435797798)
,p_name=>'Activity Log List'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(162251210785800461)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Real Time Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'22'
);
end;
/
prompt --application/shared_components/navigation/lists/summary_log_pages
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(162256322822822923)
,p_name=>'summary log pages'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(397448666726572548)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'By Application by Month'
,p_list_item_link_target=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(162256503352822924)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'By Application by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(219127363831431945)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Application Hash by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(162257102425822925)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'By Application'
,p_list_item_link_target=>'f?p=&APP_ID.:354:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(880569998372629663)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Chart of Workspace Activity by Day'
,p_list_item_link_target=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/component_utilization
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(166186215913459085)
,p_name=>'Component Utilization'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(166186401888459086)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Native Component Utilization Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(166186830094459086)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Native Component Utilization Chart'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/admin_tasks_page_3
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(166211911060758908)
,p_name=>'admin_tasks_page_3'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(16347303877035542)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Change My Password'
,p_list_item_link_target=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:3::#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(1309004604808814)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30385011201348523)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Monitor Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'1'
,p_security_scheme=>wwv_flow_imp.id(178931223495737450)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30385223668352082)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Service'
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'1'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46969711288174181)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Manage User Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46981012486411024)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Create User'
,p_list_item_link_target=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:52,EDIT_USER_PRIVS:::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46981208807419423)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Create Multiple Users'
,p_list_item_link_target=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:99:::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(487230503095185923)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Delete Multiple Users'
,p_list_item_link_target=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:RIR:::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492151212216844406)
,p_list_item_display_sequence=>104
,p_list_item_link_text=>'Manage Interactive Report Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168469522898909489)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Manage Export Repository'
,p_list_item_link_target=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(621160827306560828)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Request a New Workspace'
,p_list_item_link_target=>'f?p=4700:2:&APP_SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(147758823396318362)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Define Environment Banner'
,p_list_item_link_target=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:105:::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_sessions
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(167617332155424156)
,p_name=>'monitor.sessions'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(167617812546427943)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Active Sessions'
,p_list_item_link_target=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(9410309863267579)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Bar Chart of Active Sessions by Hour'
,p_list_item_link_target=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_barchart.png'
,p_list_item_icon_attributes=>'alt="" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_administration_header
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(697508149859311566)
,p_name=>'APEX 5 - Administration (Header)'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697508379122311567)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Administration'
,p_list_item_link_target=>'f?p=4350:1:&APP_SESSION.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697508646749311568)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697508954423311568)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Service'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697509272437311568)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Manage Service'
,p_list_item_link_target=>'f?p=4350:21:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(697508954423311568)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697509589201311568)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(697508954423311568)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697509890224311568)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Make a Service Request'
,p_list_item_link_target=>'f?p=4350:96:&SESSION.::NO:49::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(697508954423311568)
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697510102039311568)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Set Workspace Preferences'
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(697508954423311568)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697510424442311568)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Define Workspace Message'
,p_list_item_link_target=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(697508954423311568)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(180636861560637301)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Define Environment Banner'
,p_list_item_link_target=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:105:P105_LAST_APP_ID,P105_LAST_PAGE_ID:&APP_ID.,&APP_PAGE_ID.:'
,p_parent_list_item_id=>wwv_flow_imp.id(697508954423311568)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697510729732311568)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Workspace Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(697508954423311568)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2802017870399721)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Manage Extension Links'
,p_list_item_link_target=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(697508954423311568)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697511092305311569)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Users and Groups'
,p_list_item_link_target=>'f?p=4350:55:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697511311568311569)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Monitor Activity'
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_imp.id(47302021031728224)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697511632930311569)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dashboards'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_imp.id(47302021031728224)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1253566117341334456)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Change My Password'
,p_list_item_link_target=>'f?p=4350:3:&SESSION.::&DEBUG.:3#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(697513111062314247)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
,p_version_scn=>75556988
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697513395064314247)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentation'
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2105953653789032029)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Discussion Forum'
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2185497476192539882)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Learn More about Oracle APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697514231251314249)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697514582567314249)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'About'
,p_list_item_link_target=>'f?p=4350:9:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_shared_navigation_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(719024906222154750)
,p_name=>'APEX Shared Navigation Menu'
,p_list_status=>'PUBLIC'
,p_reference_id=>2206460728364447
,p_version_scn=>117449631
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2117684418227459)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'App Builder'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'App Builder Drill Down'
,p_list_text_01=>'tab-app-builder'
,p_security_scheme=>wwv_flow_imp.id(178931223495737450)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID in ( 4000, 4020 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2118075611227459)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Create'
,p_list_item_link_target=>'f?p=4000:56:&SESSION.::&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID::'
,p_parent_list_item_id=>wwv_flow_imp.id(2117684418227459)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2118439241227459)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=4000:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_parent_list_item_id=>wwv_flow_imp.id(2117684418227459)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2118813267227460)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::&DEBUG.:4900:FB_FLOW_ID,FB_FLOW_PAGE_ID::'
,p_parent_list_item_id=>wwv_flow_imp.id(2117684418227459)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2119239516227460)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2117684418227459)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2119674218227460)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Workspace Utilities'
,p_parent_list_item_id=>wwv_flow_imp.id(2117684418227459)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2120036172227460)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'All Workspace Utilities'
,p_list_item_link_target=>'f?p=4000:182:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2119674218227460)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2120400992227460)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2119674218227460)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2120899583227460)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Workspace Themes'
,p_list_item_link_target=>'f?p=4000:763:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2119674218227460)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2121260916227460)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Application Groups'
,p_list_item_link_target=>'f?p=4000:722:&SESSION.::&DEBUG.:RP'
,p_parent_list_item_id=>wwv_flow_imp.id(2119674218227460)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2121638308227460)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'&PRODUCT_NAME. Views'
,p_list_item_link_target=>'f?p=4000:714:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2119674218227460)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2122068249227460)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Cross Application Reports'
,p_list_item_link_target=>'f?p=4000:9009:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2119674218227460)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2122482111227461)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL Workshop'
,p_list_item_link_target=>'f?p=4500:3002:&SESSION.'
,p_list_item_icon_alt_attribute=>'SQL Workshop Drill Down'
,p_list_text_01=>'tab-sql-workshop'
,p_security_scheme=>wwv_flow_imp.id(178931519479737472)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'( :APP_ID = 4500 and :APP_PAGE_ID not in ( ''1000'',''8000'',''35'', ''900'' ) ) or :APP_ID in ( 4850, 4300 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2122894482227461)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Object Browser'
,p_list_item_link_target=>'f?p=4500:2000:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2122482111227461)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2123236258227461)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'SQL Commands'
,p_list_item_link_target=>'f?p=4500:1003:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2122482111227461)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2123651177227461)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'SQL Scripts'
,p_list_item_link_target=>'f?p=4500:1004:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2122482111227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Utilities'
,p_parent_list_item_id=>wwv_flow_imp.id(2122482111227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2124483394227461)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'All Utilities'
,p_list_item_link_target=>'f?p=4500:1005:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2124825927227461)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2125237437227461)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Data Workshop'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2125618848227462)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Data Generator'
,p_list_item_link_target=>'f?p=4500:4000:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_security_scheme=>wwv_flow_imp.id(1755479352997432)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2126086424227462)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=4500:1002:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2126460168227462)
,p_list_item_display_sequence=>270
,p_list_item_link_text=>'Quick SQL'
,p_list_item_link_target=>'f?p=4500:1100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2126822250227462)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>'Sample Datasets'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2127237656227462)
,p_list_item_display_sequence=>290
,p_list_item_link_text=>'Generate DDL'
,p_list_item_link_target=>'f?p=4500:12:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2127636449227462)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'UI Defaults'
,p_list_item_link_target=>'f?p=4500:813:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2128088232227462)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Schema Comparison'
,p_list_item_link_target=>'f?p=4500:1350:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2128473684227462)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Methods on Tables'
,p_list_item_link_target=>'f?p=4500:120:&SESSION.:'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2128839930227462)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Recycle Bin'
,p_list_item_link_target=>'f?p=4500:1070:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2129259785227463)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Object Reports'
,p_list_item_link_target=>'f?p=4500:1042:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2129587795227463)
,p_list_item_display_sequence=>350
,p_list_item_link_text=>'About Database'
,p_list_item_link_target=>'f?p=4500:36:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2129918158227463)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Database Monitor'
,p_list_item_link_target=>'f?p=4500:11:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(2124013781227461)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2130337637227463)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'RESTful Services'
,p_list_item_link_target=>'f?p=4850:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2122482111227461)
,p_security_scheme=>wwv_flow_imp.id(802975422996792935)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2130714711227463)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'SQL Developer Web'
,p_list_item_link_target=>'f?p=4500:64:&SESSION.::&DEBUG.:64:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2122482111227461)
,p_security_scheme=>wwv_flow_imp.id(11402876164993917)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2131169295227463)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Team Development'
,p_list_item_link_target=>'f?p=4600:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon_alt_attribute=>'Team Development Drill Down'
,p_list_text_01=>'tab-team-dev'
,p_security_scheme=>wwv_flow_imp.id(178932029578737472)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID in ( 4600, 4650 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2131584211227463)
,p_list_item_display_sequence=>370
,p_list_item_link_text=>'Labels'
,p_list_item_link_target=>'f?p=4600:300:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2131169295227463)
,p_security_scheme=>wwv_flow_imp.id(438804333233472199)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2131964561227463)
,p_list_item_display_sequence=>380
,p_list_item_link_text=>'Milestones'
,p_list_item_link_target=>'f?p=4600:200:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2131169295227463)
,p_security_scheme=>wwv_flow_imp.id(438804333233472199)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2132376369227464)
,p_list_item_display_sequence=>390
,p_list_item_link_text=>'Templates'
,p_list_item_link_target=>'f?p=4600:1000:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2131169295227463)
,p_security_scheme=>wwv_flow_imp.id(438804333233472199)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2132709666227464)
,p_list_item_display_sequence=>400
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=4600:2000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2131169295227463)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2133170445227464)
,p_list_item_display_sequence=>410
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2131169295227463)
,p_security_scheme=>wwv_flow_imp.id(438804333233472199)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2133526534227464)
,p_list_item_display_sequence=>420
,p_list_item_link_text=>'Feedback'
,p_list_item_link_target=>'f?p=4650:8012:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2131169295227463)
,p_security_scheme=>wwv_flow_imp.id(438804333233472199)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2133912620227464)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Gallery'
,p_list_item_link_target=>'f?p=4750:50:&SESSION.'
,p_list_text_01=>'tab-apps'
,p_security_scheme=>wwv_flow_imp.id(438804333233472199)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID = 4750'
,p_list_item_current_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/navigation/listentry
begin
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(812019673460140)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1184708852447990)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SELECT_MANY'
,p_attribute_01=>'separated'
,p_version_scn=>229014979
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1189691036774088)
,p_plugin_type=>'DYNAMIC ACTION'
,p_plugin=>'NATIVE_OPEN_AI_ASSISTANT'
,p_version_scn=>16258453
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(3105547685134205)
,p_plugin_type=>'PROCESS TYPE'
,p_plugin=>'NATIVE_GEOCODING'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_version_scn=>117642104
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(14858900882941039)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(99844733195888905)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(118481070287833028)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_MAP_REGION'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'use_vector_tile_layers', 'Y')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(123213880980478467)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_APEX'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(124389573755989299)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_plugin=>'NATIVE_ADFBC'
,p_version_scn=>37165931336889
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(176128807885506820)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1765072435389712055)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'include_slider', 'N')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1831780149340994154)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'actions_menu_structure', 'IG')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1917632266890939884)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
,p_version_scn=>37165931336884
);
end;
/
prompt --application/shared_components/security/authorizations/apex_builder_workspace_authentication
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(1309004604808814)
,p_name=>'APEX Builder Workspace Authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication = ''APEX'';'
,p_error_message=>'The Development Environment is using external Authentication'
,p_reference_id=>786940505486177571
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_data_generator
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(1755479352997432)
,p_name=>'Flow: DATA_GENERATOR'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'DATA_GENERATOR'
,p_error_message=>'You are not authorized to use Data Generator in SQL Workshop'
,p_reference_id=>2200672316280271
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/is_extension_workspace
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(2811800212733153)
,p_name=>'Is Extension Workspace'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_companies w',
' where nvl(w.is_extension_yn, ''N'') = ''Y''',
'   and w.provisioning_company_id = :flow_security_group_id'))
,p_reference_id=>2808707595563837
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/extension_links_exist
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(4000814836956767)
,p_name=>'Extension Links Exist'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_extension_links',
' where security_group_id = :workspace_id',
'union all',
'select 1',
'  from wwv_extension_links el, wwv_extension_grants eg',
' where eg.security_group_id           = :workspace_id',
'   and eg.extension_security_group_id = el.security_group_id',
'   and el.is_public = ''Y'''))
,p_reference_id=>2801004939760399
,p_version_scn=>41671338
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/sso_authentication
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(6738625560859071)
,p_name=>'SSO authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication not in (''APEX'',''CLOUD_IDM'',''LDAP'',''DB'');'
,p_error_message=>'Builder SSO is not enabled'
,p_reference_id=>6738410669854771
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This authorization scheme checks whether the builder authentication can be used for single sign-on to workspaces. This includes SSO, header-based and LDAP authentication, but not',
'',
'  - APEX: login requires a workspace name',
'  - CLOUD_IDM: external login to IDM, but switching workspaces is not allowed, since the login is for a single tenant only'))
);
end;
/
prompt --application/shared_components/security/authorizations/sql_developer_web_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(11402876164993917)
,p_name=>'SQL Developer Web enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_listener.sql_developer_web_enabled;',
'end;'))
,p_error_message=>'SQL Developer Web link is not enabled for this instance.'
,p_reference_id=>11401467991562895
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(12518728403445471)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>'You are not authorized to administer applications'
,p_reference_id=>12511219858301010
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/user_is_a_developer
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(47302021031728224)
,p_name=>'user is a developer'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_security.user_can_develop_any_flow;'
,p_error_message=>'unable to determine if user is a developer (f4350)'
,p_reference_id=>786938431231163276
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(178931223495737450)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786516029127697713
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(178931519479737472)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'You are not authorized to use SQL Workshop'
,p_reference_id=>786516265251697717
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(178932029578737472)
,p_name=>'APEX 5.0 Team development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>'Team development not enabled for this workspace'
,p_reference_id=>786516861027697723
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(438804333233472199)
,p_name=>'Flow: EDIT'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'You are not authorized to edit applications'
,p_reference_id=>12480509677812756
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(802975422996792935)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786519856057734816
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/service_requests_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(916538108136873611)
,p_name=>'Service Requests Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'' then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>'No privilege for attempted operation.'
,p_reference_id=>786932326296107981
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_administration_app_access
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(1367105411776376234)
,p_name=>'APEX 5.0 Administration App Access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  if :APP_PAGE_ID in (0, 1, 3, 9, 11, 28, 58, 68, 102, 577) then',
'      --',
'      -- approved unrestricted pages for development environment',
'      -- - 0 ....... global page',
'      -- - 1 ....... start page',
'      -- - 3 ....... Edit Profile',
'      -- - 9 ....... about page',
'      -- - 11 ...... current user preferences',
'      -- - 28 ...... purge preferences',
'      -- - 58/68 ... change password',
'      -- - 102 ..... preferences',
'      -- - 577 ..... help',
'      --',
'      return true;',
'',
'  else',
'      --',
'      -- developer or admin',
'      --',
'      return    wwv_flow_authorization.is_authorized_developer (',
'                    p_developer_authorization => ''EDIT'' )',
'             or wwv_flow_authorization.is_authorized_developer (',
'                    p_developer_authorization => ''ADMIN'' );',
'  end if;'))
,p_error_message=>'No privilege for attempted operation.'
,p_reference_id=>1367104867544331898
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(1364606893206165)
,p_icon_sequence=>10
,p_icon_subtext=>'Workspace &COMPANY.'
,p_icon_target=>'f?p=4100:1:&SESSION.'
,p_icon_image_alt=>'Workspace &COMPANY.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(334060323997944127)
,p_icon_sequence=>20
,p_icon_subtext=>'( <span style="text-decoration:underline;">Switch Workspace</span> )'
,p_icon_target=>'f?p=4550:20'
,p_icon_image_alt=>'Switch Workspace'
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond=>'73'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_security_scheme=>wwv_flow_imp.id(6738625560859071)
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(39960115843641093)
,p_icon_sequence=>30
,p_icon_subtext=>'( <span style="text-decoration:underline;">Logout</span> )'
,p_icon_target=>'&LOGOUT_URL.'
,p_icon_image_alt=>'Logout'
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond=>'73'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(203635014114430938)
,p_icon_sequence=>40
,p_icon_subtext=>'Feedback'
,p_icon_target=>'javascript:popupURL(''f?p=4350:102:&SESSION.:::102:P102_APPLICATION_ID,P102_PAGE_ID:&APP_ID.,&APP_PAGE_ID.'');'
,p_nav_entry_is_feedback_yn=>'Y'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
end;
/
prompt --application/shared_components/logic/application_processes/spotlightindex
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(234080313327980030)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'spotlightIndex'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_spotlight_dev.emit_spotlight_search_index(',
'    p_app_id          => wwv_flow.g_x01,',
'    p_advanced_search => wwv_flow.g_x02);'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
,p_version_scn=>36494511
);
end;
/
prompt --application/shared_components/logic/application_items/auth_type
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(344359629554721697)
,p_name=>'AUTH_TYPE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(47267012470443025)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4350_password_region_title
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(288025200211732904)
,p_name=>'F4350_PASSWORD_REGION_TITLE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(61498215760312449)
,p_name=>'FB_FLOW_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'same as flow 4000 fb_flow_id'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_page_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(61665618599751270)
,p_name=>'FB_FLOW_PAGE_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(72751304929301595)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by Custom2 authentication for deep linking support'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/g_user_default_date_format
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(367481423382175901)
,p_name=>'G_USER_DEFAULT_DATE_FORMAT'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This global item is included here, in case the user edits themselves on 4350:56, or via the Preferences dialog in the account mega menu.  For now, though, this item value is really only used in 4500 - to set the default date format for a user in SQL '
||'Workshop.'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/last_view
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(48609214118039317)
,p_name=>'LAST_VIEW'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(47267211793445016)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Unable to compute workspace name.'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/f4350_password_region_title
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(288081418528785501)
,p_computation_sequence=>10
,p_computation_item=>'F4350_PASSWORD_REGION_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_lang.system_message(''APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.''||replace(wwv_flow_authentication_dev.get_internal_authentication,''DB'',''LDAP'')||''-AUTH'')'
,p_compute_when=>'F4350_PASSWORD_REGION_TITLE'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/auth_type
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(344361727169737998)
,p_computation_sequence=>10
,p_computation_item=>'AUTH_TYPE'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_authentication_dev.get_internal_authentication'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/last_view
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(486954604915667072)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'1'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/account_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2740022841418968)
,p_lov_name=>'ACCOUNT STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(2740022841418968)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556990
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2740201351418968)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Locked Accounts'
,p_lov_return_value=>'LOCKED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2741315831435879)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Expired Account'
,p_lov_return_value=>'EXPIRED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2740411765418968)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Unlocked Accounts'
,p_lov_return_value=>'UNLOCKED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2740609662418968)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'My Account'
,p_lov_return_value=>'MY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(12456720246979195)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Developer Accounts'
,p_lov_return_value=>'DEV'
);
end;
/
prompt --application/shared_components/user_interface/lovs/account_lock_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6949526744661130)
,p_lov_name=>'ACCOUNT_LOCK_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(6949526744661130)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556990
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6949718368661130)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Locked'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6949911078661130)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Unlocked'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/activity_log_request_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1569139039593351202)
,p_lov_name=>'ACTIVITY_LOG.REQUEST_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1569139039593351202)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556990
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1569139334794351203)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Other'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1569139617444351205)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Processing'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1569139936155351205)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Rendering'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1569140273759351210)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'AJAX'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1570578733042936737)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Logout'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1570579027818937857)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Authentication Callback'
,p_lov_return_value=>'5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_opt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87986129403049299)
,p_lov_name=>'APPLICATION.OPT'
,p_lov_query=>'.'||wwv_flow_imp.id(87986129403049299)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556990
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87986300136049300)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Applications'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87986529393049300)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Group By Application'
,p_lov_return_value=>'F'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_build_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(128034726363912582)
,p_lov_name=>'APPLICATION_BUILD_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(128034726363912582)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556990
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(128035028761912584)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Run Application Only'
,p_lov_return_value=>'RUN_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(128035201383912585)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Run and Build Application'
,p_lov_return_value=>'RUN_AND_BUILD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/audit_naming
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(27067106427412398)
,p_lov_name=>'AUDIT_NAMING'
,p_lov_query=>'.'||wwv_flow_imp.id(27067106427412398)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556990
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27067418961412413)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Attributes'
,p_lov_return_value=>'WWV_FLOWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27067615785412414)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Page Template'
,p_lov_return_value=>'WWV_FLOW_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27067821285412414)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Navigation Bar'
,p_lov_return_value=>'WWV_FLOW_ICON_BAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27068018297412414)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Application Process'
,p_lov_return_value=>'WWV_FLOW_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27068231633412415)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Application Item'
,p_lov_return_value=>'WWV_FLOW_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27068428780412415)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Application Computation'
,p_lov_return_value=>'WWV_FLOW_COMPUTATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27068600233412415)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Tabs'
,p_lov_return_value=>'WWV_FLOW_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27068829004412415)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Parent Tab'
,p_lov_return_value=>'WWV_FLOW_TOPLEVEL_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27069029470412416)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'List of Values'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES$'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27069224657412416)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Static LOV Values'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES_DATA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192815107467123331)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Breadcrumb Entry'
,p_lov_return_value=>'WWV_FLOW_MENU_OPTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192920211428952731)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Themes'
,p_lov_return_value=>'WWV_FLOW_THEMES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27069403307412416)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Page Attributes'
,p_lov_return_value=>'WWV_FLOW_STEPS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27069616679412416)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Page Button'
,p_lov_return_value=>'WWV_FLOW_STEP_BUTTONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27069821202412416)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Page Branch'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCHES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27070027988412417)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Page Branch Args'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCH_ARGS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27070221339412417)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Page Item'
,p_lov_return_value=>'WWV_FLOW_STEP_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27071724781417713)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Page Computation'
,p_lov_return_value=>'WWV_FLOW_STEP_COMPUTATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27072029975419290)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Page Validation'
,p_lov_return_value=>'WWV_FLOW_STEP_VALIDATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27072303095420909)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Page Process'
,p_lov_return_value=>'WWV_FLOW_STEP_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27072608636422556)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Region Template'
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUG_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27072914523424290)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Row Template'
,p_lov_return_value=>'WWV_FLOW_ROW_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27073219717425765)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'List Template'
,p_lov_return_value=>'WWV_FLOW_LIST_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27073525951427595)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Region Attributes'
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUGS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27073802879430378)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Messages'
,p_lov_return_value=>'WWV_FLOW_MESSAGES$'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27074108074431803)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Build Options'
,p_lov_return_value=>'WWV_FLOW_PATCHES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27074413269433395)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Application Developers (Administration)'
,p_lov_return_value=>'WWV_FLOW_DEVELOPERS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27074718809434925)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Lists'
,p_lov_return_value=>'WWV_FLOW_LISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27075025043436756)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>'List Item'
,p_lov_return_value=>'WWV_FLOW_LIST_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27075332315438853)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>'Effective User ID (Administration)'
,p_lov_return_value=>'WWV_FLOW_EFFECTIVE_USERID_MAP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27075705781440636)
,p_lov_disp_sequence=>29
,p_lov_disp_value=>'Shortcuts'
,p_lov_return_value=>'WWV_FLOW_SHORTCUTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27076012361442576)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Page Item Help Text'
,p_lov_return_value=>'WWV_FLOW_STEP_ITEM_HELP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27076318248444200)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'Authentication Schemes'
,p_lov_return_value=>'WWV_FLOW_AUTHENTICATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27076624481446067)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Entry Points'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27076929330447428)
,p_lov_disp_sequence=>33
,p_lov_disp_value=>'Entry Point Arguments'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINT_ARGS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/available_applications
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(249067832108758740)
,p_lov_name=>'AVAILABLE.APPLICATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556991
);
end;
/
prompt --application/shared_components/user_interface/lovs/background_execution_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1912672796968628)
,p_lov_name=>'BACKGROUND_EXECUTION_STATUS'
,p_reference_id=>1814559837736230
,p_lov_query=>'.'||wwv_flow_imp.id(1912672796968628)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1475246262011986)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Submitted for Execution'
,p_lov_return_value=>'ENQUEUED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1475690098011986)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Scheduler Job Created'
,p_lov_return_value=>'SCHEDULED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1476032179011986)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Executing'
,p_lov_return_value=>'EXECUTING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1476436023011986)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Finished Successfully'
,p_lov_return_value=>'SUCCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1476800999011986)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'ABORTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1477222023011985)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Failed'
,p_lov_return_value=>'FAILED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/build_option_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(140229800819566260)
,p_lov_name=>'BUILD OPTION STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(140229800819566260)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556991
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(140230006090566264)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Exclude'
,p_lov_return_value=>'EXCLUDE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(140230221897566265)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Include'
,p_lov_return_value=>'INCLUDE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cache_mode_page_and_region
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(672366941474304666)
,p_lov_name=>'CACHE_MODE (PAGE AND REGION)'
,p_lov_query=>'.'||wwv_flow_imp.id(672366941474304666)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556991
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(672367283233304668)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'NOCACHE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(672367558201304670)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'CACHE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(672367830895304670)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Cache By User'
,p_lov_return_value=>'USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(672368194869304670)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Cache By Session'
,p_lov_return_value=>'SESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_selector
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(46971429951226857)
,p_lov_name=>'CHART SELECTOR'
,p_lov_query=>'.'||wwv_flow_imp.id(46971429951226857)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556991
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46971618940226861)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Events by Day'
,p_lov_return_value=>'DAY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46971819569226863)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Page Events by Hour'
,p_lov_return_value=>'HOUR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_mult_user_strip_domain
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(486946000320608950)
,p_lov_name=>'CREATE.MULT.USER.STRIP.DOMAIN'
,p_lov_query=>'.'||wwv_flow_imp.id(486946000320608950)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556991
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(486946203862608959)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Set username to full email address'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(486946418606608967)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Exclude @ domain as part of the username'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/debug_level
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(370258657315557256)
,p_lov_name=>'DEBUG_LEVEL'
,p_lov_query=>'.'||wwv_flow_imp.id(370258657315557256)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556991
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370258984893557257)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Error'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370259375821557258)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Warn'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370260147407557258)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Info'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370260586898557259)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Application Enter'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370260960387557259)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Application Trace'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370261795886557259)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'APEX Enter'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370262151966557260)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'APEX Trace'
,p_lov_return_value=>'9'
);
end;
/
prompt --application/shared_components/user_interface/lovs/developer_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(19716823057593749)
,p_lov_name=>'DEVELOPER TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(19716823057593749)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556991
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19717103805593761)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19717515342593765)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/error_components
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(213967127754264881)
,p_lov_name=>'ERROR COMPONENTS'
,p_lov_query=>'.'||wwv_flow_imp.id(213967127754264881)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556991
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213967320847264904)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Numeric Item'
,p_lov_return_value=>'numeric_item'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213967522885264905)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Deep Link'
,p_lov_return_value=>'deep_link'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213967714663264905)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Set Item Process'
,p_lov_return_value=>'set_item_process'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213967927620264905)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Tabular Form Add Process'
,p_lov_return_value=>'add_rows_to_tabular_form'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213968132430264906)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Tabular Form Update Process'
,p_lov_return_value=>'multi_row_update_process'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213968319995264906)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Tabular Form Delete Process'
,p_lov_return_value=>'multi_row_delete_process'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213968503762264906)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Fetch Row Process'
,p_lov_return_value=>'dml_fetch_row_process'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213968724423264906)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Web Service Process'
,p_lov_return_value=>'web_service_process'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213968927764264907)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Process Row Process'
,p_lov_return_value=>'dml_process_row_process'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6204524790478230)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'report'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213969130796264907)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ajax Callback Process'
,p_lov_return_value=>'on_demand_process'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213991320267272102)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Set Item to Preference Computation'
,p_lov_return_value=>'set_item_eq_preference_computation'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217558320349371396)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'PL/SQL Condition'
,p_lov_return_value=>'plsql_condition'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217562125113391685)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'SQL Condition'
,p_lov_return_value=>'sql_condition'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217566117626398980)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exists or Not exists Condition'
,p_lov_return_value=>'exists_condition'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213969326112264907)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Get Next or Previous Primary Key Process'
,p_lov_return_value=>'get_next_or_prev_pk_process'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213969502182264907)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Set Preference Process'
,p_lov_return_value=>'set_preference_process'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213970706415268145)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Query Computation'
,p_lov_return_value=>'query_computation'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213991925115273511)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'SQL or PL/SQL Computation'
,p_lov_return_value=>'sql_or_plsql_computation'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217558927275373351)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'PL/SQL Function Body Condition'
,p_lov_return_value=>'plsql_function_body_condition'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213992700658275906)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'PL/SQL Function Body Computation'
,p_lov_return_value=>'plsql_function_body_computation'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213993708970278348)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'SQL Exists or Not Exists Validation'
,p_lov_return_value=>'exists_noexists_validation'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213994314164279816)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'PL/SQL Error Validation'
,p_lov_return_value=>'plsql_error_validation'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213995019705281413)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Function Body Validation'
,p_lov_return_value=>'function_body_validation'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213997002867286002)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'PL/SQL Function Body Returning Boolean Validation'
,p_lov_return_value=>'function_body_returning_boolean_validation'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213998211525288587)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Branch'
,p_lov_return_value=>'branch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213999116719290082)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Set Item'
,p_lov_return_value=>'set_page_item_source'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(213999821568291451)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Set VPD'
,p_lov_return_value=>'set_vpd'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214000123646292003)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Clear Cache'
,p_lov_return_value=>'clear_cache'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214000527455293116)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Save Session State'
,p_lov_return_value=>'save_session_state'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214000932650294668)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Validation'
,p_lov_return_value=>'error_performing_validations'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214001904037295831)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Validation'
,p_lov_return_value=>'error_performing_after_submit_processes'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214002814080298744)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'PL/SQL expression Condition'
,p_lov_return_value=>'check_cond_plsql_expresion'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214003320660300665)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Function Returning SQL Query'
,p_lov_return_value=>'function_returning_sql_query'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214004324469301777)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Shortcut'
,p_lov_return_value=>'shortcut'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214004928625302922)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'SVG Chart'
,p_lov_return_value=>'svg_chart'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214005332434304022)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Web Service'
,p_lov_return_value=>'web_service'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214005802437304830)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'chart'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214007008324306555)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'PL/SQL Process'
,p_lov_return_value=>'plsql_procedure'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214007511094307342)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'calendar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214007915250308517)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Help Process'
,p_lov_return_value=>'help'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214008318713309562)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'URL Region'
,p_lov_return_value=>'url_region'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214009321483310394)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'List'
,p_lov_return_value=>'list'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214009624600311246)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'List Entry'
,p_lov_return_value=>'list_entry'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(214010231180313173)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>'PL/SQL SQL Function returning SQL Query'
,p_lov_return_value=>'function_returning_sql_query'
);
end;
/
prompt --application/shared_components/user_interface/lovs/expire_user_accounts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4834509455047185)
,p_lov_name=>'EXPIRE USER ACCOUNTS'
,p_lov_query=>'.'||wwv_flow_imp.id(4834509455047185)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556995
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4834812383047193)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Enable'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4835016591047194)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Disable'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/f4350_fnd_group_ids
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(226642419934369326)
,p_lov_name=>'F4350_FND_GROUP_IDS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556995
);
end;
/
prompt --application/shared_components/user_interface/lovs/f4350_p54_fnd_group_ids
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(132393417969824419)
,p_lov_name=>'F4350_P54_FND_GROUP_IDS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
'   and (:F4350_P54_ID is null or id <> :F4350_P54_ID)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556995
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_developers
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(17062423464336902)
,p_lov_name=>'FLOW_DEVELOPERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(USERID) d, USERID r',
'from  WWV_FLOW_developers',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556995
);
end;
/
prompt --application/shared_components/user_interface/lovs/fnd_users
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(17066627882357077)
,p_lov_name=>'FND USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(user_name) d, user_name r',
'from wwv_flow_fnd_user',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556995
);
end;
/
prompt --application/shared_components/user_interface/lovs/fnd_user_ids
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(132392525949820706)
,p_lov_name=>'FND_USER_IDS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(user_name) d, user_id r',
'  from wwv_flow_fnd_user',
' where security_group_id = :flow_security_group_id',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556995
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_no_since
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(488871706659155481)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556995
);
end;
/
prompt --application/shared_components/user_interface/lovs/geometry_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(564913925652056229)
,p_lov_name=>'GEOMETRY_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(564913925652056229)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556995
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564914217900056240)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Points'
,p_lov_return_value=>'POINT'
,p_lov_template=>'#DISPLAY_VALUE#|map-points'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564914657535056250)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lines'
,p_lov_return_value=>'LINE'
,p_lov_template=>'#DISPLAY_VALUE#|map-lines'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564915040581056251)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Polygons'
,p_lov_return_value=>'POLYGON'
,p_lov_template=>'#DISPLAY_VALUE#|map-polygons'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564915422094056251)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Heat Map'
,p_lov_return_value=>'HEATMAP'
,p_lov_template=>'#DISPLAY_VALUE#|map-heatmap'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564915841668056252)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Extruded Polygons'
,p_lov_return_value=>'POLYGON_3D'
,p_lov_template=>'#DISPLAY_VALUE#|map-extruded-polgygons'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(564983430244090637)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Unknown'
,p_lov_return_value=>'UNKNOWN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/group_grantee_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(132386709008105935)
,p_lov_name=>'GROUP_GRANTEE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(132386709008105935)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556996
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(132387009720105943)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'User'
,p_lov_return_value=>'U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(132387327177105947)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Group'
,p_lov_return_value=>'G'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_or_detail
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(135219829572410772)
,p_lov_name=>'ICON OR DETAIL'
,p_lov_query=>'.'||wwv_flow_imp.id(135219829572410772)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556996
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135220002122410781)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Icons'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135220205520410794)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Details'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_interval
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(48455120589630644)
,p_lov_name=>'IR_NOTIFY_INTERVAL'
,p_lov_query=>'.'||wwv_flow_imp.id(48455120589630644)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556996
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48455420960630650)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Daily'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48455617407630651)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Weekly'
,p_lov_return_value=>'W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48455822694630651)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Monthly'
,p_lov_return_value=>'M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_report_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(262470331768456667)
,p_lov_name=>'IR_NOTIFY_REPORT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(262470331768456667)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556996
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(262470696788456682)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Primary Default'
,p_lov_return_value=>'PRIMARY_DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(262471046046456687)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Alternative Default'
,p_lov_return_value=>'ALTERNATIVE_DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(262471483187456688)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Public'
,p_lov_return_value=>'PUBLIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(262471819694456688)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Private'
,p_lov_return_value=>'PRIVATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(619315906303328344)
,p_lov_name=>'IR_NOTIFY_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(619315906303328344)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556996
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(619316124110328372)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Submitted'
,p_lov_return_value=>'SUBMITTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(619316313660328373)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sent'
,p_lov_return_value=>'SENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(619316501456328373)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Error'
,p_lov_return_value=>'ERROR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/issues_fs_limit
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(567784794163789852)
,p_lov_name=>'ISSUES_FS_LIMIT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
' order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'RV'
,p_display_column_name=>'DV'
,p_version_scn=>75556996
);
end;
/
prompt --application/shared_components/user_interface/lovs/license_terms
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87991106556118398)
,p_lov_name=>'LICENSE.TERMS'
,p_lov_query=>'.'||wwv_flow_imp.id(87991106556118398)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556996
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87991314955118399)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'I am not a citizen, national or resident of, and am not under the control of, the government of: Cuba, Iran, Sudan, Iraq, Libya, North Korea, Syria, nor any other country to which the United States has prohibited export.'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87991524166118399)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'I will not download or otherwise export or re-export the Programs, directly or indirectly, to the above mentioned countries nor to citizens, nationals or residents of those countries.'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87991705582118400)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'I am not listed on the United States Department of Treasury lists of Specially Designated Nationals, Specially Designated Terrorists, and Specially Designated Narcotic Traffickers, nor am I listed on the United States Department of Commerce Table of '
||'Denial Orders.'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87991919165118400)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'I will not download or otherwise export or re-export the Programs, directly or indirectly, to persons on the above mentioned lists.'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87992103676118400)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'I will not use the Programs for, and will not allow the Programs to be used for, any purposes prohibited by United States law, including, without limitation, for the development, design, manufacture or production of nuclear, chemical or biological we'
||'apons of mass destruction.'
,p_lov_return_value=>'5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_schemas
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(47395026667651380)
,p_lov_name=>'LIST SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(upper(c.schema)) d, ',
'       upper(c.schema) v',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u ',
'where  c.security_group_id = :flow_security_group_id and ',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :app_user and ',
'       (',
'           u.ALLOW_ACCESS_TO_SCHEMAS is null or ',
'           instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0',
'       )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556996
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(75646032643247381)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556996
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flow_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(473904019503385140)
,p_lov_name=>'LIST_FLOW_STATUS'
,p_reference_id=>634347472712995
,p_lov_query=>'.'||wwv_flow_imp.id(473904019503385140)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741165654528290723)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Available'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741165942786290723)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Available with Developer Toolbar'
,p_lov_return_value=>'AVAILABLE_W_EDIT_LINK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741166239367290723)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Available to Developers Only'
,p_lov_return_value=>'DEVELOPERS_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741166576972290723)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Restricted Access'
,p_lov_return_value=>'RESTRICTED_ACCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741166880777290723)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Unavailable'
,p_lov_return_value=>'UNAVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741167165338290723)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Unavailable (Status Shown with PL/SQL)'
,p_lov_return_value=>'UNAVAILABLE_PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(741167446373290724)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Unavailable (Redirect to URL)'
,p_lov_return_value=>'UNAVAILABLE_URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_status_codes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42705425134693211)
,p_lov_name=>'LOGIN STATUS CODES'
,p_lov_query=>'.'||wwv_flow_imp.id(42705425134693211)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556997
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42705704364693212)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal, successful authentication'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42705921465693213)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unknown Username'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42706121390693213)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Account Locked'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42706310776693213)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Account Expired'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42706524529693213)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Incorrect Password'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42706719666693213)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Password First Use'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42706921482693213)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Maximum Login Attempts Exceeded'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42707119263693213)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Unknown Internal Error'
,p_lov_return_value=>'7'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_a
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87960028308944903)
,p_lov_name=>'MAX_ROWS_A'
,p_lov_query=>'.'||wwv_flow_imp.id(87960028308944903)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556997
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87960228677944903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87960404998944904)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87960630117944904)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87960804805944904)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87961014605944904)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87961204075944904)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87961414470944905)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87961615644944905)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87961828775944905)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_b
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87962402466946929)
,p_lov_name=>'MAX_ROWS_B'
,p_lov_query=>'.'||wwv_flow_imp.id(87962402466946929)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556997
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87962624364946930)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87962825427946930)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87963028889946930)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87963219513946930)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87963422128946931)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87963617026946932)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87963820242946932)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87964018632946932)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87964228487946933)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_c
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87964809046948816)
,p_lov_name=>'MAX_ROWS_C'
,p_lov_query=>'.'||wwv_flow_imp.id(87964809046948816)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556997
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87965020267948816)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87965202237948817)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87965404786948817)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87965623655948817)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87965801422948818)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'40'
,p_lov_return_value=>'40'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87966019499948818)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87966204425948818)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87966405087948818)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87966620020948818)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87966830048948820)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87967016319948821)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87967217418948821)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87967415888948821)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'50000'
,p_lov_return_value=>'50000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_d
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87968118050951423)
,p_lov_name=>'MAX_ROWS_D'
,p_lov_query=>'.'||wwv_flow_imp.id(87968118050951423)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556997
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87968314659951424)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87968522241951424)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87968709744951424)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87968903454951425)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87969114479951425)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87969329781951426)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87969508652951427)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87969708972951427)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87969903261951427)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_or_existing_schema
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(245496725063109254)
,p_lov_name=>'NEW_OR_EXISTING_SCHEMA'
,p_lov_query=>'.'||wwv_flow_imp.id(245496725063109254)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556998
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(245497113141109261)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Request a new schema'
,p_lov_return_value=>'YES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(245496930435109257)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Use an existing schema'
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/operating_systems
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87980828664020704)
,p_lov_name=>'OPERATING.SYSTEMS'
,p_lov_query=>'.'||wwv_flow_imp.id(87980828664020704)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556998
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87981029047020705)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'HP-Tru64Unix'
,p_lov_return_value=>'HP-Tru64Unix'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87981205950020705)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'HP-UX'
,p_lov_return_value=>'HP-UX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87981403269020706)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'IBM-AIX'
,p_lov_return_value=>'IBM-AIX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87981618293020706)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Linux'
,p_lov_return_value=>'Linux'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87981814646020706)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'MS-NT'
,p_lov_return_value=>'MS-NT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87982016496020707)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'MS-WIN2000'
,p_lov_return_value=>'MS-WIN2000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87982226769020707)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'MS-XP'
,p_lov_return_value=>'MS-XP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87982430599020707)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Other'
,p_lov_return_value=>'Other'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87982601452020707)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'OtherUnix'
,p_lov_return_value=>'OtherUnix'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87982816960020707)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Sun-Solaris'
,p_lov_return_value=>'Sun-Solaris'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p105_banner_colors
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2923311877329862)
,p_lov_name=>'P105_BANNER_COLORS'
,p_lov_query=>'.'||wwv_flow_imp.id(2923311877329862)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2923606335329869)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Neutral'
,p_lov_return_value=>'accent-1'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--1" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2924030617329871)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sienna'
,p_lov_return_value=>'accent-2'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--2" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2924482125329871)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Pine'
,p_lov_return_value=>'accent-3'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--3" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2924844373329871)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Teal'
,p_lov_return_value=>'accent-4'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--4" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2925210600329872)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Ocean'
,p_lov_return_value=>'accent-5'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--5" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2925682541329872)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Fog'
,p_lov_return_value=>'accent-6'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--6" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2926003654329872)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Lilac'
,p_lov_return_value=>'accent-7'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--7" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2926498633329872)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Plum'
,p_lov_return_value=>'accent-8'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--8" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1705927812985375)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Rose'
,p_lov_return_value=>'accent-9'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--9" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1706293063985375)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slate'
,p_lov_return_value=>'accent-10'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--10" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1706622516985375)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Pebble'
,p_lov_return_value=>'accent-11'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--11" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1707047271985376)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Beige'
,p_lov_return_value=>'accent-12'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--12" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1707417007985376)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Blue'
,p_lov_return_value=>'accent-13'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--13" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1707841564985376)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Red'
,p_lov_return_value=>'accent-14'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--14" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1708237027985376)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Orange'
,p_lov_return_value=>'accent-15'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--15" title="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1708692327985376)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Green'
,p_lov_return_value=>'accent-16'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--16" title="#DISPLAY_VALUE#"></span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p105_banner_pos
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(146455139760592304)
,p_lov_name=>'P105_BANNER_POS'
,p_lov_query=>'.'||wwv_flow_imp.id(146455139760592304)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(146455485967592300)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Left'
,p_lov_return_value=>'LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(146455844060592294)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Top'
,p_lov_return_value=>'TOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2020_ws_obj_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(628838348305108438)
,p_lov_name=>'P2020_WS_OBJ_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(628838348305108438)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(628838684612108439)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Valid'
,p_lov_return_value=>'VALID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(628838943749108440)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Invalid'
,p_lov_return_value=>'INVALID'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2020_ws_obj_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(628812792905024497)
,p_lov_name=>'P2020_WS_OBJ_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(628812792905024497)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(628813001940024498)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(628813323857024500)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sequence'
,p_lov_return_value=>'SEQUENCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p216_monitor
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(22415219367679656)
,p_lov_name=>'P216_MONITOR'
,p_lov_query=>'.'||wwv_flow_imp.id(22415219367679656)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22415404656679665)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Views'
,p_lov_return_value=>'PV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22416003914684720)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Browser Information'
,p_lov_return_value=>'BI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22416612918687252)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Session State Values'
,p_lov_return_value=>'SS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(228539708561074614)
,p_lov_name=>'PAGE MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(228539708561074614)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(228539924927074625)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamic'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(228540132030074635)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cache Created'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(228540313915074635)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Cached'
,p_lov_return_value=>'R'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(130988608718459028)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Page Processing'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131016603205684510)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Partial Page'
,p_lov_return_value=>'P'
);
end;
/
prompt --application/shared_components/user_interface/lovs/person_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87979323684009856)
,p_lov_name=>'PERSON.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(87979323684009856)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87979519786009857)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Employee'
,p_lov_return_value=>'E'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87979702743009857)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Contractor'
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plsql_editing_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(113937100137241641)
,p_lov_name=>'PLSQL EDITING STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(113937100137241641)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113937313482241642)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allow PL/SQL program unit editing'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113937510829241642)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Do not allow PL/SQL program unit editing'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/preference_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42506917060665623)
,p_lov_name=>'PREFERENCE TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(42506917060665623)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42507201651665624)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Sorting'
,p_lov_return_value=>'SORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42507416214665624)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Other'
,p_lov_return_value=>'OTHER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42507628021665624)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Cross Session Item Value'
,p_lov_return_value=>'ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/preference_window_mgmt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(698047789180011733)
,p_lov_name=>'PREFERENCE_WINDOW_MGMT'
,p_lov_query=>'.'||wwv_flow_imp.id(698047789180011733)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(698048021582011735)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Open in new window if needed to force focus'
,p_lov_return_value=>'FOCUS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(698048351664011737)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Single Window for all applications'
,p_lov_return_value=>'ONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/privileges
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(87973907708976827)
,p_lov_name=>'PRIVILEGES'
,p_lov_query=>'.'||wwv_flow_imp.id(87973907708976827)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87974125418976828)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Administration'
,p_lov_return_value=>'ADMIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87974326105976828)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Browse'
,p_lov_return_value=>'BROWSE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87974520374976829)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Create'
,p_lov_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87974700192976829)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Data Loader'
,p_lov_return_value=>'DATA_LOADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87974908440976829)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'DB Monitor'
,p_lov_return_value=>'DB_MONITOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87975104201976829)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Edit'
,p_lov_return_value=>'EDIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87975319689976830)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Help'
,p_lov_return_value=>'HELP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87975514156976830)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Monitor'
,p_lov_return_value=>'MONITOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87975715979976830)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87975929098976830)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'User Manager'
,p_lov_return_value=>'USER_MANAGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(876530482469714)
,p_lov_name=>'RECENT TIME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556999
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time_archive
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(880120182357116546)
,p_lov_name=>'RECENT_TIME_ARCHIVE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual  union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual  union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual  union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual  union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75556999
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_caching_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42414417202633712)
,p_lov_name=>'REGION CACHING OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(42414417202633712)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42414713865633714)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cached'
,p_lov_return_value=>'CACHED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42414915904633714)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cached By User'
,p_lov_return_value=>'CACHED_BY_USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42415123252633714)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Not Cached'
,p_lov_return_value=>'NOT_CACHED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reporting_period
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(180662003103161233)
,p_lov_name=>'REPORTING PERIOD'
,p_lov_query=>'.'||wwv_flow_imp.id(180662003103161233)||'.'
,p_location=>'STATIC'
,p_version_scn=>75556999
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180662201590161236)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1 Day'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180662407591161239)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'1 Week'
,p_lov_return_value=>'W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180663409336163078)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'2 Weeks'
,p_lov_return_value=>'2W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180662601241161239)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'1 Month'
,p_lov_return_value=>'M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180708018527279245)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'2 Months'
,p_lov_return_value=>'2M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180713228570282104)
,p_lov_disp_sequence=>31.5
,p_lov_disp_value=>'3 Months'
,p_lov_return_value=>'3M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180713023722280779)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'6 Months'
,p_lov_return_value=>'6M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180662822420161239)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'1 Year'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180714418789298237)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'2 Years'
,p_lov_return_value=>'2Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180714621214298964)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'5 Years'
,p_lov_return_value=>'5Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reqeuest_service
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(168289505113227142)
,p_lov_name=>'REQEUEST SERVICE'
,p_lov_query=>'.'||wwv_flow_imp.id(168289505113227142)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557000
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168289817280227144)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Request Schema'
,p_lov_return_value=>'SCHEMA'
,p_lov_template=>'#DISPLAY_VALUE#| icon-request-schema'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168290023589227145)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Request Storage'
,p_lov_return_value=>'STORAGE'
,p_lov_template=>'#DISPLAY_VALUE#| icon-request-storage'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168290203148227145)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Request Termination'
,p_lov_return_value=>'TERMINATION'
,p_lov_template=>'#DISPLAY_VALUE#| icon-request-termination'
);
end;
/
prompt --application/shared_components/user_interface/lovs/request_statuses
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(378143515851142224)
,p_lov_name=>'REQUEST_STATUSES'
,p_lov_query=>'.'||wwv_flow_imp.id(378143515851142224)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557000
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378143812022142228)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'In Progress'
,p_lov_return_value=>'IN_PROGRESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378144114463142229)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Requested'
,p_lov_return_value=>'REQUESTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378144422710142229)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Accepted'
,p_lov_return_value=>'ACCEPTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378144722168142229)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Declined'
,p_lov_return_value=>'DECLINED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378145031757142229)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Approved'
,p_lov_return_value=>'APPROVED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378145330379142229)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Termination in Progress'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378145610822142229)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Termination in Progress'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378145905326142229)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Termination in Progress'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378146205625142229)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Termination in Progress'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378146515175142230)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Termination in Progress'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378146800022142230)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Termination in Progress'
,p_lov_return_value=>'TERMINATION_IN_PROGRESS6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(378147120846142230)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'TERMINATED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1402706982624090)
,p_lov_name=>'SECONDS'
,p_lov_query=>'.'||wwv_flow_imp.id(1402706982624090)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557000
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1403090812624094)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 Minute'
,p_lov_return_value=>'60'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1403420883624096)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'5 Minutes'
,p_lov_return_value=>'300'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1403804695624096)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'10 Minutes'
,p_lov_return_value=>'600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1404259929624097)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'30 Minutes'
,p_lov_return_value=>'1800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1404676599624097)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'1 Hour'
,p_lov_return_value=>'3600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1405062127624098)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'2 Hours'
,p_lov_return_value=>'7200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1405454859624098)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'5 Hours'
,p_lov_return_value=>'18000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1405868110624098)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'10 Hours'
,p_lov_return_value=>'36000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds_small
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1508766038293211)
,p_lov_name=>'SECONDS_SMALL'
,p_lov_query=>'.'||wwv_flow_imp.id(1508766038293211)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557000
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1509043919293211)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 Minute'
,p_lov_return_value=>'60'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1509405530293212)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2 Minutes'
,p_lov_return_value=>'120'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1509881833293213)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3 Minutes'
,p_lov_return_value=>'180'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1510274552293213)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4 Minutes'
,p_lov_return_value=>'240'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1510691299293213)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5 Minutes'
,p_lov_return_value=>'300'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1511001625293214)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'10 Minutes'
,p_lov_return_value=>'600'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_name
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(784569817799474890)
,p_lov_name=>'SERVICE.REQUEST.NAME'
,p_reference_id=>110368323210290856
,p_lov_query=>'.'||wwv_flow_imp.id(784569817799474890)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784573162881474938)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'New Schema'
,p_lov_return_value=>'NEW_SCHEMA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784573584378474939)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Remove Workspace'
,p_lov_return_value=>'REMOVE_EXISTING_SERVICE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784573945933474940)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Remove Schema'
,p_lov_return_value=>'REMOVE_EXISTING_SCHEMA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784574357497474940)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Request Storage'
,p_lov_return_value=>'CHANGE_DB_SIZE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(784574699206474941)
,p_lov_name=>'SERVICE.REQUEST.STATUS'
,p_reference_id=>87755726864223308
,p_lov_query=>'.'||wwv_flow_imp.id(784574699206474941)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784579496484474945)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Approved'
,p_lov_return_value=>'APPROVED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784579845934474945)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Declined'
,p_lov_return_value=>'DECLINED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784580299124474945)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'In Progress'
,p_lov_return_value=>'IN_PROGRESS'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'26'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784580698196474945)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Requested'
,p_lov_return_value=>'REQUESTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784581020670474945)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'TERMINATED'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(784581436523474946)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Accepted'
,p_lov_return_value=>'ACCEPTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_trace_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(370223717115128950)
,p_lov_name=>'SESSION_TRACE_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(370223717115128950)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557000
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(370224060587128958)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SQL Trace'
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_all_or_cached_pages
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42450922059777772)
,p_lov_name=>'SHOW ALL OR CACHED PAGES'
,p_lov_query=>'.'||wwv_flow_imp.id(42450922059777772)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557000
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42451116170777773)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Pages'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42451322267777773)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Cached Pages'
,p_lov_return_value=>'CACHED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_more_columns_checkbox
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(17777219154823135)
,p_lov_name=>'SHOW MORE COLUMNS CHECKBOX'
,p_lov_query=>'.'||wwv_flow_imp.id(17777219154823135)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557000
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17777414218823135)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Show Additional Report Columns'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/team_dev_fs_limit
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2541925202710283317)
,p_lov_name=>'TEAM_DEV_FS_LIMIT'
,p_reference_id=>2541932940202319161
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ts_schema_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(25622114385279132)
,p_lov_name=>'TS_SCHEMA_OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(25622114385279132)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557000
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25622422573279176)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing Schema'
,p_lov_return_value=>'EXISTING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25622617415279177)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'New Schema'
,p_lov_return_value=>'NEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wwv_flow_companies_display_name
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2856395785553625)
,p_lov_name=>'WWV_FLOW_COMPANIES.DISPLAY_NAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name, provisioning_company_id',
'  from wwv_flow_companies c',
' where c.is_extension_yn = ''Y''',
'   and upper(c.short_name) != ''UNKNOWN''',
'   and c.provisioning_company_id not in (10, 11, 12)',
'   and c.provisioning_company_id != :workspace_id',
'   and exists (',
'          select 1',
'            from wwv_extension_links l',
'           where l.security_group_id = c.provisioning_company_id',
'       )   ',
'   and not exists (',
'          select 1',
'            from wwv_extension_grants g',
'           where g.security_group_id           = :workspace_id',
'             and g.extension_security_group_id = c.provisioning_company_id',
'       )'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'PROVISIONING_COMPANY_ID'
,p_display_column_name=>'DISPLAY_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'DISPLAY_NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>34841083
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_or_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(157815226475866526)
,p_lov_name=>'YES_NO_RETURNS_Y_OR_N'
,p_lov_query=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_location=>'STATIC'
,p_version_scn=>75557000
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(157815523644866535)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(157815717308866538)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/pages/page_groups
begin
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(135149912736024812)
,p_group_name=>'Database Administration'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215673320866031164)
,p_group_name=>'External Click Counting'
,p_group_desc=>'Count clicks to an external application.  Report on clicks.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215451130329541858)
,p_group_name=>'Home and Navigation'
,p_group_desc=>'The home page and navigation to various workshops.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215462122626558552)
,p_group_name=>'Log Management'
,p_group_desc=>'Pages dedicated to the management of the page view log tables.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215450408166535437)
,p_group_name=>'Monitoring'
,p_group_desc=>'Workspace monitoring.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215667724760013351)
,p_group_name=>'Provisioning Services'
,p_group_desc=>'Pages related to workspace administrators requesting provisioning services.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(5108313447012897)
,p_group_name=>'Reporting'
,p_group_desc=>'General information reporting, dashboards.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215469304188572178)
,p_group_name=>'Session State Management'
,p_group_desc=>'Reports and manipulation of session state.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215450104703534414)
,p_group_name=>'User Management'
,p_group_desc=>'Manage users and groups.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215677404159045218)
,p_group_name=>'Workspace Reporting'
,p_group_desc=>'Report on workspace application information.'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbs/administration
begin
wwv_flow_imp_shared.create_menu(
 p_id=>wwv_flow_imp.id(4090422833267509)
,p_name=>'administration'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2316911550902882)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Archive of Purged Task Files'
,p_link=>'f?p=&APP_ID.:107:&SESSION.::&DEBUG.:::'
,p_page_id=>107
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2469622445716674)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views By Operating System'
,p_link=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:::'
,p_page_id=>63
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2474403886740449)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Sessions by Browser'
,p_link=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:::'
,p_page_id=>64
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2543467020742969)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Links'
,p_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:::'
,p_page_id=>110
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2543828937749254)
,p_parent_id=>wwv_flow_imp.id(2543467020742969)
,p_short_name=>'Create / Edit Link'
,p_link=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:112::'
,p_page_id=>112
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2826418808002866)
,p_parent_id=>wwv_flow_imp.id(2543467020742969)
,p_short_name=>'Extension Subscriptions'
,p_link=>'f?p=&APP_ID.:114:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>114
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4092600585280040)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Monitor Activity'
,p_link=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_page_id=>22
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4107331322307772)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by User'
,p_link=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:::'
,p_page_id=>25
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4148213370406694)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'External Clicks'
,p_link=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:::'
,p_page_id=>34
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4151832202421647)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by User Agent'
,p_link=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::'
,p_page_id=>37
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4190227850581237)
,p_parent_id=>wwv_flow_imp.id(47260107410925385)
,p_short_name=>'Purge Session State'
,p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::'
,p_page_id=>5
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4195726034599646)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Changes by Application'
,p_link=>'f?p=&FLOW_ID.:38:&SESSION.::&DEBUG.:::'
,p_page_id=>38
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4206226857609277)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Manage Users and Groups'
,p_link=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:::'
,p_page_id=>55
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4209018677616407)
,p_parent_id=>wwv_flow_imp.id(4206226857609277)
,p_short_name=>'Create User'
,p_link=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:::'
,p_page_id=>52
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4271821999882293)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by Application'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>26
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4281101764933173)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Recent Page Views'
,p_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:::'
,p_page_id=>29
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4283911241944016)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by Weighted Page Performance'
,p_link=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_page_id=>31
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4318016496108751)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Monthly Calendar of Page Views by Day'
,p_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_page_id=>27
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4323002682130309)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Developer Activity Log'
,p_link=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_page_id=>30
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4325919922137501)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Manage Service'
,p_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_page_id=>21
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4361400414268083)
,p_parent_id=>wwv_flow_imp.id(47260107410925385)
,p_short_name=>'Purge Sessions'
,p_link=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:::'
,p_page_id=>45
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4363126928271060)
,p_parent_id=>wwv_flow_imp.id(47260107410925385)
,p_short_name=>'Recent Sessions'
,p_link=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::'
,p_page_id=>43
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4364521967273337)
,p_parent_id=>wwv_flow_imp.id(47260107410925385)
,p_short_name=>'Purge Preferences'
,p_link=>'f?p=&APP_ID.:46:&SESSION.::&DEBUG.:::'
,p_page_id=>46
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4365816792275696)
,p_parent_id=>wwv_flow_imp.id(47260107410925385)
,p_short_name=>'Preferences by User'
,p_link=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:::'
,p_page_id=>44
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4375107937294978)
,p_parent_id=>wwv_flow_imp.id(4380108356309988)
,p_short_name=>'User Group'
,p_link=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:::'
,p_page_id=>54
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4380108356309988)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Manage Users and Groups'
,p_link=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:::'
,p_page_id=>53
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4381802749312589)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Manage Users and Groups'
,p_link=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:::'
,p_page_id=>51
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4383226459316770)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Request Storage'
,p_link=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_page_id=>49
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4384618480320519)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Request Service Termination'
,p_link=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:::'
,p_page_id=>50
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4393511782338849)
,p_parent_id=>wwv_flow_imp.id(4206226857609277)
,p_short_name=>'Edit User'
,p_link=>'f?p=&FLOW_ID.:56:&SESSION.'
,p_page_id=>56
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4933731196448238)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Workspace Schemas'
,p_link=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.:::'
,p_page_id=>72
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5909921448840002)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Schema Tablespace Utilization'
,p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
,p_page_id=>2
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7257808624858752)
,p_parent_id=>wwv_flow_imp.id(47260107410925385)
,p_short_name=>'Session State Details'
,p_link=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
,p_page_id=>16
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7259930824863624)
,p_parent_id=>wwv_flow_imp.id(47260107410925385)
,p_short_name=>'Current User Preferences'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7453117390591593)
,p_parent_id=>wwv_flow_imp.id(4283911241944016)
,p_short_name=>'Page Performance'
,p_link=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:::'
,p_page_id=>65
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(9016821830861763)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'About &PRODUCT_NAME.'
,p_link=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_page_id=>9
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(9408012888223819)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Session Activity by Hour'
,p_link=>'f?p=&FLOW_ID.:15:&SESSION.'
,p_page_id=>15
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(9446414777586270)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Set Workspace Preferences'
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10268429641818276)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Developer Login Summary'
,p_link=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::'
,p_page_id=>6
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10585025472876168)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Provisioning: Request Service Termination'
,p_link=>'f?p=&FLOW_ID.:510:&SESSION.'
,p_page_id=>510
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11927127220739284)
,p_parent_id=>wwv_flow_imp.id(4363126928271060)
,p_short_name=>'Session Details'
,p_link=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:::'
,p_page_id=>40
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(17101518098296684)
,p_short_name=>'Views by Page'
,p_link=>'f?p=&FLOW_ID.:32:&SESSION.'
,p_page_id=>32
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(17191212558696158)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Changes, detailed'
,p_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::'
,p_page_id=>42
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(20246528779701431)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Changes by Developer'
,p_link=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::'
,p_page_id=>8
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(20253824023718817)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Changes by Developer'
,p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_page_id=>10
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(20590301090617183)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by Day'
,p_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_page_id=>12
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(20693525446844867)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by Hour'
,p_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_page_id=>14
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22594908160282978)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Changes by Day'
,p_link=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:::'
,p_page_id=>18
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22818825242809738)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Changes by Day'
,p_link=>'f?p=&FLOW_ID.:20:&SESSION.::&DEBUG.:::'
,p_page_id=>20
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(25558521888584227)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by Application and Page'
,p_link=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::'
,p_page_id=>75
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(26445104999779395)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Login Attempts'
,p_link=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RP::'
,p_page_id=>70
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'<span class="u-VisuallyHidden">Administration</span><span class="a-Icon icon-breadcrumb-previous" title="Administration"></span>'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>1
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30025321432264022)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_page_id=>60
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30327713625356854)
,p_parent_id=>wwv_flow_imp.id(4206226857609277)
,p_short_name=>'Create Multiple Users'
,p_link=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:::'
,p_page_id=>99
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30343815513719877)
,p_parent_id=>wwv_flow_imp.id(4206226857609277)
,p_short_name=>'Search Users'
,p_link=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:::'
,p_page_id=>8000
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34516114490236116)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Most Viewed Pages over All Applications'
,p_link=>'f?p=&APP_ID.:190:&SESSION.::&DEBUG.:::'
,p_page_id=>190
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34710616986796822)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Request Database Schema'
,p_link=>'f?p=&FLOW_ID.:48:&SESSION.'
,p_page_id=>48
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(41507328141454714)
,p_parent_id=>wwv_flow_imp.id(47295000777189375)
,p_short_name=>'Purge Cached Regions by Region'
,p_link=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:::'
,p_page_id=>301
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(41692321367095915)
,p_parent_id=>wwv_flow_imp.id(47295000777189375)
,p_short_name=>'Purge Cached Regions by Application'
,p_link=>'f?p=&APP_ID.:303:&SESSION.::&DEBUG.:::'
,p_page_id=>303
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(41861202885553198)
,p_parent_id=>wwv_flow_imp.id(47295000777189375)
,p_short_name=>'Purge Cached Regions by Workspace'
,p_link=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:::'
,p_page_id=>300
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(42341004664643420)
,p_parent_id=>wwv_flow_imp.id(47295000777189375)
,p_short_name=>'Purge Cached Pages by Application'
,p_link=>'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:::'
,p_page_id=>304
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(42426220372298687)
,p_parent_id=>wwv_flow_imp.id(47295000777189375)
,p_short_name=>'Purge Cached Pages by Page'
,p_link=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:::'
,p_page_id=>302
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(42468214129256219)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Click Count Log'
,p_link=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.:::'
,p_page_id=>84
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(42714907058726008)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Login Attempts by Authentication Result'
,p_link=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::'
,p_page_id=>4
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(46991002925568555)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_page_id=>13
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47001932630888950)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_page_id=>33
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47260107410925385)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Session State'
,p_link=>'f?p=&FLOW_ID.:36:&SESSION.'
,p_page_id=>36
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47295000777189375)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Application Cache'
,p_link=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:::'
,p_page_id=>47
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47308310413778595)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Request Storage'
,p_link=>'f?p=&FLOW_ID.:69:&SESSION.'
,p_page_id=>69
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47332515905632680)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_page_id=>71
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47356100656454148)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:::'
,p_page_id=>78
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47393027682585246)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.:::'
,p_page_id=>79
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47723114753679446)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Newly Created Pages'
,p_link=>'f?p=&FLOW_ID.:82:&SESSION.'
,p_page_id=>82
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47745822639055625)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by Hour'
,p_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:::'
,p_page_id=>87
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47768305657260927)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Changes by Day'
,p_link=>'f?p=&FLOW_ID.:89:&SESSION.'
,p_page_id=>89
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48002713439212955)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Dashboards'
,p_link=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::'
,p_page_id=>91
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48516105867959355)
,p_parent_id=>wwv_flow_imp.id(493061632558056672)
,p_short_name=>'Subscriptions'
,p_link=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:::'
,p_page_id=>92
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(49167127607716830)
,p_parent_id=>wwv_flow_imp.id(47260107410925385)
,p_short_name=>'Reset Preferences'
,p_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::'
,p_page_id=>28
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(51200624276230133)
,p_parent_id=>wwv_flow_imp.id(47295000777189375)
,p_short_name=>'Purge Expired Cached Pages by Application'
,p_link=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:::'
,p_page_id=>90
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(65419012862652752)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views By Day Report'
,p_link=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.:::'
,p_page_id=>74
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(67231725243730948)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Database Privileges'
,p_link=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:::'
,p_page_id=>86
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(127643119606506595)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Application Build Status'
,p_link=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:::'
,p_page_id=>41
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162263605460882715)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Activity Log Summary'
,p_link=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:::'
,p_page_id=>352
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162267111917894830)
,p_short_name=>'Activity Log Summary'
,p_link=>'f?p=&FLOW_ID.:353:&SESSION.'
,p_page_id=>353
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162270607148927500)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Activity Log Summary by Application'
,p_link=>'f?p=&APP_ID.:354:&SESSION.::&DEBUG.:::'
,p_page_id=>354
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(166213224187830380)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Native Component Utilization Chart'
,p_link=>'f?p=&APP_ID.:97:&SESSION.'
,p_page_id=>97
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(167555425410082684)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Active Sessions'
,p_link=>'f?p=&FLOW_ID.:7:&SESSION.'
,p_page_id=>7
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(167633330874520798)
,p_parent_id=>wwv_flow_imp.id(167555425410082684)
,p_short_name=>'Session Detail'
,p_link=>'f?p=&FLOW_ID.:19:&SESSION.'
,p_page_id=>19
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(168316116904810067)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Request Service'
,p_link=>'f?p=&FLOW_ID.:96:&SESSION.'
,p_page_id=>96
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(168440510037690155)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Workspace Utilization'
,p_link=>'f?p=&FLOW_ID.:101:&SESSION.'
,p_page_id=>101
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(168471800193925286)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Manage Export Repository'
,p_link=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:::'
,p_page_id=>150
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(173260815365250672)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Workspace Announcement'
,p_link=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:::'
,p_page_id=>35
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(180929821403245891)
,p_parent_id=>wwv_flow_imp.id(168440510037690155)
,p_short_name=>'Email'
,p_link=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.:::'
,p_page_id=>83
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(196301728610881937)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by Interactive Report'
,p_link=>'f?p=&FLOW_ID.:93:&SESSION.'
,p_page_id=>93
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(199842555555432288)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Web Service Activity Log'
,p_link=>'f?p=&APP_ID.:77:&SESSION.'
,p_page_id=>77
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(211677204186361292)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Errors'
,p_link=>'f?p=&FLOW_ID.:62:&SESSION.'
,p_page_id=>62
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(219108507235410015)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Hash by Day'
,p_link=>'f?p=&APP_ID.:103:&SESSION.'
,p_page_id=>103
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(231647913974343694)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Caching Performance by Page'
,p_link=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:::'
,p_page_id=>61
,p_required_patch=>wwv_flow_imp.id(231647503239340557)
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(231670515622363077)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Caching Performance by Application'
,p_link=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.:::'
,p_page_id=>67
,p_required_patch=>wwv_flow_imp.id(231647503239340557)
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(246324709362747681)
,p_parent_id=>wwv_flow_imp.id(34710616986796822)
,p_short_name=>'Confirm Schema Request'
,p_link=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:::'
,p_page_id=>66
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(370346095636891220)
,p_parent_id=>wwv_flow_imp.id(4281101764933173)
,p_short_name=>'Debug Messages'
,p_link=>'f?p=&APP_ID.:24:&SESSION.'
,p_page_id=>24
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(388567689401599597)
,p_short_name=>'Page Zero'
,p_link=>'f?p=&FLOW_ID.:0:&SESSION.'
,p_page_id=>0
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(395882286281059468)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views'
,p_link=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_page_id=>73
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(397449678515589812)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Views by Month'
,p_link=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:RP,80::'
,p_page_id=>80
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(435132825806181421)
,p_parent_id=>wwv_flow_imp.id(27257108953740456)
,p_short_name=>'Set Reporting Timeframe'
,p_link=>'f?p=&FLOW_ID.:59:&SESSION.'
,p_page_id=>59
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(452547101449603350)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'File Utilization'
,p_link=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:::'
,p_page_id=>85
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(486997905678291815)
,p_parent_id=>wwv_flow_imp.id(4206226857609277)
,p_short_name=>'Create Multiple Users'
,p_link=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::'
,p_page_id=>95
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(487218900991020779)
,p_parent_id=>wwv_flow_imp.id(4206226857609277)
,p_short_name=>'Delete Multiple Users'
,p_link=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_page_id=>57
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(492154414688867777)
,p_parent_id=>wwv_flow_imp.id(493061632558056672)
,p_short_name=>'Saved Reports'
,p_link=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:::'
,p_page_id=>98
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(493061632558056672)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Manage Interactive Report Settings'
,p_link=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:::'
,p_page_id=>104
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(563547281943439302)
,p_parent_id=>wwv_flow_imp.id(563644659835658277)
,p_short_name=>'Table Column Cache'
,p_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_page_id=>801
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(563644659835658277)
,p_parent_id=>wwv_flow_imp.id(4325919922137501)
,p_short_name=>'Data Dictionary Cache'
,p_link=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
,p_page_id=>800
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(880570494862638647)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Workspace Activity by Day'
,p_link=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.:RP::'
,p_page_id=>76
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1760797156082373066)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Application Changes by Developer by Hour'
,p_link=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:::'
,p_page_id=>23
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1760815418654431335)
,p_parent_id=>wwv_flow_imp.id(4092600585280040)
,p_short_name=>'Page Views by User by Hour'
,p_link=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::'
,p_page_id=>39
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(2903553321750210)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Wizard Dialog'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,baseDialogClass:''a-Dialog--wizard'',dialogClass:#DIALOG_CSS_CLASSES#,jsDialogClass:true,#DIALOG_A'
||'TTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2906997573750221)
,p_page_template_id=>wwv_flow_imp.id(2903553321750210)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2907418672750221)
,p_page_template_id=>wwv_flow_imp.id(2903553321750210)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2907903808750221)
,p_page_template_id=>wwv_flow_imp.id(2903553321750210)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/done_popup
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(80887301212076531)
,p_theme_id=>3
,p_name=>'[x] Popup'
,p_internal_name=>'DONE_POPUP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8">',
'    <title>#TITLE#</title>',
'    <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'    ',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="aPopupPage">',
'    <noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>#REGION_POSITION_02##REGION_POSITION_03##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##BODY#</div>',
'<div style="text-align:middle;">#REGION_POSITION_08#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden" role="alert">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>19940022257958945
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72734809033039225)
,p_page_template_id=>wwv_flow_imp.id(80887301212076531)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72735308261039225)
,p_page_template_id=>wwv_flow_imp.id(80887301212076531)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72735852304039226)
,p_page_template_id=>wwv_flow_imp.id(80887301212076531)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72736350842039227)
,p_page_template_id=>wwv_flow_imp.id(80887301212076531)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72736800693039227)
,p_page_template_id=>wwv_flow_imp.id(80887301212076531)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72737364238039228)
,p_page_template_id=>wwv_flow_imp.id(80887301212076531)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72737808818039228)
,p_page_template_id=>wwv_flow_imp.id(80887301212076531)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_rw_faceted_search
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(383691245467261189)
,p_theme_id=>3
,p_name=>'APEX RW - Faceted Search'
,p_internal_name=>'APEX_RW_-_FACETED_SEARCH'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES# a-Page--facetedSearch" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div id="main" class="a-Body">',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>383682332851249713
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293453257579956031)
,p_page_template_id=>wwv_flow_imp.id(383691245467261189)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293453784927956031)
,p_page_template_id=>wwv_flow_imp.id(383691245467261189)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293454201063956032)
,p_page_template_id=>wwv_flow_imp.id(383691245467261189)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293454734455956032)
,p_page_template_id=>wwv_flow_imp.id(383691245467261189)
,p_name=>'Facets'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293455296511956032)
,p_page_template_id=>wwv_flow_imp.id(383691245467261189)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293455744256956032)
,p_page_template_id=>wwv_flow_imp.id(383691245467261189)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293456227370956033)
,p_page_template_id=>wwv_flow_imp.id(383691245467261189)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(485889499804058937)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Dialog'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,baseDialogClass:''a-Dialog--uiDialog'',dialogClass:#DIALOG_CSS_CLASSES#,jsDialogClass:true,#DIALOG'
||'_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293482010517977313)
,p_page_template_id=>wwv_flow_imp.id(485889499804058937)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293482574822977313)
,p_page_template_id=>wwv_flow_imp.id(485889499804058937)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293483032493977314)
,p_page_template_id=>wwv_flow_imp.id(485889499804058937)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(692762523503114201)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Edit Screen'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'</header>',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main id="main" class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER.">',
'        <span class="u-vh">&MSG_USER.</span>',
'      </span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE.">',
'        <span class="u-vh">&MSG_WORKSPACE.</span>',
'      </span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE.">',
'        <span class="u-vh">&MSG_LANGUAGE.</span>',
'      </span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293312256174925373)
,p_page_template_id=>wwv_flow_imp.id(692762523503114201)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293312731643925373)
,p_page_template_id=>wwv_flow_imp.id(692762523503114201)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293313262754925374)
,p_page_template_id=>wwv_flow_imp.id(692762523503114201)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293313771848925374)
,p_page_template_id=>wwv_flow_imp.id(692762523503114201)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293314249376925374)
,p_page_template_id=>wwv_flow_imp.id(692762523503114201)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293314796164925375)
,p_page_template_id=>wwv_flow_imp.id(692762523503114201)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293315257480925375)
,p_page_template_id=>wwv_flow_imp.id(692762523503114201)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293315701955925375)
,p_page_template_id=>wwv_flow_imp.id(692762523503114201)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(692762974728114205)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'    #REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'</header>',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div id="main" class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.'' aria-label=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.''><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1503147903768814)
,p_page_template_id=>wwv_flow_imp.id(692762974728114205)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1503680132768815)
,p_page_template_id=>wwv_flow_imp.id(692762974728114205)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1504115458768815)
,p_page_template_id=>wwv_flow_imp.id(692762974728114205)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1504626019768815)
,p_page_template_id=>wwv_flow_imp.id(692762974728114205)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1505132007768815)
,p_page_template_id=>wwv_flow_imp.id(692762974728114205)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1505635463768815)
,p_page_template_id=>wwv_flow_imp.id(692762974728114205)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1506197782768816)
,p_page_template_id=>wwv_flow_imp.id(692762974728114205)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(692763410753114205)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'</header>',
'  <div id="main" class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293164905238857414)
,p_page_template_id=>wwv_flow_imp.id(692763410753114205)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293165475756857414)
,p_page_template_id=>wwv_flow_imp.id(692763410753114205)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293165900452857415)
,p_page_template_id=>wwv_flow_imp.id(692763410753114205)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293166403849857415)
,p_page_template_id=>wwv_flow_imp.id(692763410753114205)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293166983395857415)
,p_page_template_id=>wwv_flow_imp.id(692763410753114205)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293167409806857416)
,p_page_template_id=>wwv_flow_imp.id(692763410753114205)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293167996434857416)
,p_page_template_id=>wwv_flow_imp.id(692763410753114205)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(718401914085176458)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'</header>',
'#REGION_POSITION_08#',
'<main class="a-Main" id="main">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="u-Layout u-Layout--centerVertically">',
'    <div class="a-Wizard a-Wizard--default">',
'      #REGION_POSITION_02#',
'      <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'      <div class="a-Wizard-body">#BODY#</div>',
'      <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'    </div>',
'  </div>',
'</main>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message" role="alert">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="errorMsg" role="region" aria-labelledby="page_warning_id">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''>',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h2 class="u-vh" id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      <div class="a-AlertMessages-messageTitle" id="errorMsg-Message" role="alert">#MESSAGE#</div>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'')'
||';return false;"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3621926750568261)
,p_page_template_id=>wwv_flow_imp.id(718401914085176458)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3622403780568262)
,p_page_template_id=>wwv_flow_imp.id(718401914085176458)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3622982350568262)
,p_page_template_id=>wwv_flow_imp.id(718401914085176458)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3623457077568262)
,p_page_template_id=>wwv_flow_imp.id(718401914085176458)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3623906022568262)
,p_page_template_id=>wwv_flow_imp.id(718401914085176458)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3624427610568262)
,p_page_template_id=>wwv_flow_imp.id(718401914085176458)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3624925993568263)
,p_page_template_id=>wwv_flow_imp.id(718401914085176458)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_workspace_login
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(797610818331805206)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Workspace Login'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN'
,p_is_popup=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$(function() {',
'  $(''a[href*="#"]:not([href="#"])'').click(function() {',
'    if (location.pathname.replace(/^\//,'''') == this.pathname.replace(/^\//,'''') && location.hostname == this.hostname) {',
'      var target = $(this.hash);',
'      target = target.length ? target : $(''[name='' + this.hash.slice(1) +'']'');',
'      if (target.length) {',
'        $(''html,body'').animate({',
'          scrollTop: target.offset().top',
'        }, 500);',
'        return false;',
'      }',
'    }',
'  });',
'});'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Page--login #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'</header>',
'<main class="u-Layout u-Layout--centerVertically a-Login-slide" id="top">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Login-container">',
'  #BODY#',
'  </div>',
'  <div class="a-Login-slideNav a-Login-slideNav--down">',
'    <a href="#info" aria-label="&APP_TEXT$APEX_SCROLL_DOWN." title="&APP_TEXT$APEX_SCROLL_DOWN." class="a-Login-slideNavLink"><span class="a-Icon icon-shuttle-down"></span></a>',
'  </div>',
'</main>',
'<aside class="u-Layout u-Layout--centerVertically a-Login-slide a-Login-slide--secondary" id="info">',
'  <div class="a-Login-secondaryContent">',
'  #REGION_POSITION_03#',
'  </div>',
'  <div class="a-Login-slideNav  a-Login-slideNav--up">',
'    <a href="#top" aria-label="&APP_TEXT$APEX_SCROLL_TO_TOP." title="&APP_TEXT$APEX_SCROLL_TO_TOP." class="a-Login-slideNavLink"><span class="a-Icon icon-shuttle-up"></span></a>',
'  </div>',
'</aside>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="sucessMsg" role="region" aria-labelledby="successMsg-Heading">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h2 id="successMsg-Heading" class="u-vh">#SUCCESS_MESSAGE_HEADING#</h2>',
'      <div class="a-AlertMessages-messageTitle" id="sucessMsg-Message" role="alert">#SUCCESS_MESSAGE#</div>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" aria-label="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'
||''');return false;"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="region" aria-labelledby="errorMsg-Heading" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''>',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h2 class="u-vh" id="errorMsg-Heading" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      <div role="alert" class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</div>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" aria-label="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'')'
||';return false;"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>781632627194221102
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4062513536618671)
,p_page_template_id=>wwv_flow_imp.id(797610818331805206)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4063005700618672)
,p_page_template_id=>wwv_flow_imp.id(797610818331805206)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4063548024618672)
,p_page_template_id=>wwv_flow_imp.id(797610818331805206)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4064066998618672)
,p_page_template_id=>wwv_flow_imp.id(797610818331805206)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4064513040618672)
,p_page_template_id=>wwv_flow_imp.id(797610818331805206)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_workspace_login_secondary_page
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(797616476051845768)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Workspace Login Secondary Page'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_SECONDARY_PAGE'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Page--login #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'<div class="u-Layout u-Layout--centerVertically a-Login-slide" id="top">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Login-container">',
'  #BODY#',
'  </div>',
'</div>',
'#REGION_POSITION_03#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message" role="alert">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140020969796349535)
,p_page_template_id=>wwv_flow_imp.id(797616476051845768)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140021020701349535)
,p_page_template_id=>wwv_flow_imp.id(797616476051845768)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140021199076349534)
,p_page_template_id=>wwv_flow_imp.id(797616476051845768)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140021246433349534)
,p_page_template_id=>wwv_flow_imp.id(797616476051845768)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140021376323349534)
,p_page_template_id=>wwv_flow_imp.id(797616476051845768)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_image_legacy_apex_5_migration
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3791829543328)
,p_template_name=>'HTML image (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_IMAGE_LEGACY_APEX_5_MIGRATION'
,p_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_hot_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_next_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(208548517895320411)
,p_template_name=>'APEX 4.2 - Next Button'
,p_internal_name=>'APEX_4.2_NEXT_BUTTON'
,p_template=>'<button class="aButton nextButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" class="nextBlack" alt=""/></span></button>'
,p_hot_template=>'<button class="aButton hotButton nextButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" class="nextWhite" alt=""/></span></button>'
,p_reference_id=>40780910892272674
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_previous_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(208548713965320411)
,p_template_name=>'APEX 4.2 - Previous Button'
,p_internal_name=>'APEX_4.2_PREVIOUS_BUTTON'
,p_template=>'<button title="#LABEL!ATTR#" class="aButton prevButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevBlack" alt="#LABEL!ATTR#" /></span></button>'
,p_hot_template=>'<button title="#LABEL!ATTR#" class="aButton hotButton prevButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevWhite" alt="#LABEL!ATTR#" /></span></button>'
,p_reference_id=>40781222929295107
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_icon_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(258479618231884825)
,p_template_name=>'APEX 4.2 - Icon Button'
,p_internal_name=>'APEX_4.2_ICON_BUTTON'
,p_template=>'<a href="#LINK#" class="aIconButton" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES# role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" /></a>'
,p_hot_template=>'<a href="#LINK#" class="aIconButton" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES# role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" /></a>'
,p_reference_id=>46198532248154431
,p_translate_this_template=>'N'
,p_theme_class_id=>0
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="xpbutton" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tbody class="FFFFFF">',
'<tr>',
'<td class="L" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'<td class="C"><a href="#LINK#">#LABEL#</a></td>',
'<td class="R" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'</tr>',
'</tbody>',
'</table>'))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_1_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(297663202145957383)
,p_template_name=>'APEX 4.1 - Button'
,p_internal_name=>'APEX_4.1_BUTTON'
,p_template=>'<button class="aButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_hot_template=>'<button class="aButton hotButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_reference_id=>275775519061831382
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="button-gray" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> ',
'',
'',
'<a href="#LINK#" class="button-orange" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> '))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(388537948307476852)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(388538190684476853)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_button_legacy_apex_5_migration
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(485869694622026879)
,p_template_name=>'HTML button (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_BUTTON_LEGACY_APEX_5_MIGRATION'
,p_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_hot_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(486003960305193183)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(486004148112193187)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(486004439750193187)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(486004758462193187)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/dialog_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(486005281398193188)
,p_template_name=>'Dialog Button'
,p_internal_name=>'DIALOG_BUTTON'
,p_template=>'"#LABEL!ATTR#":#BUTTON_ATTRIBUTES#'
,p_reference_id=>428602020814722967
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/no_buttons_no_title
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(18911811464281343)
,p_layout=>'TABLE'
,p_template=>'<table class="htmldbRR" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#"><tbody><tr><td colspan="2" class="B">#BODY#</td></tr></tbody></table>'
,p_page_plug_template_name=>'No Buttons No Title'
,p_internal_name=>'NO_BUTTONS_NO_TITLE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>90546300508951267
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140463944375344552)
,p_plug_template_id=>wwv_flow_imp.id(18911811464281343)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140464047853344551)
,p_plug_template_id=>wwv_flow_imp.id(18911811464281343)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_message_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(29439604845311434)
,p_layout=>'TABLE'
,p_template=>'<div class="a-SystemMessage #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Message Region'
,p_internal_name=>'APEX_5.0_MESSAGE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>29333927116050844
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(229910785944787148)
,p_plug_template_id=>wwv_flow_imp.id(29439604845311434)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(229911276543787148)
,p_plug_template_id=>wwv_flow_imp.id(29439604845311434)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_large
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(30016706698215740)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Rounded Corner Large'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_LARGE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>27763613494297374
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92205655534205894)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92206119546205894)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92206621558205896)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92207144365205896)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92207602273205896)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92208114801205897)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92208606559205897)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92209175412205897)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92209626385205897)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92210197601205898)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92210665817205898)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92211168331205898)
,p_plug_template_id=>wwv_flow_imp.id(30016706698215740)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small_blue_top
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(30017504140215775)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Rounded Corner Small (Blue Top)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL_BLUE_TOP'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>26881811222918187
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92261222676210741)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92261737037210741)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92262287086210741)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92262726307210741)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92263215906210742)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92263748813210742)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92264298064210742)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92264716067210743)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92265214233210743)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92265706425210743)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92266266203210743)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92266707107210744)
,p_plug_template_id=>wwv_flow_imp.id(30017504140215775)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/div_with_id_c_htmldbhid
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(30347228019736370)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'Div  with ID (c:htmldbHID)'
,p_internal_name=>'DIV_WITH_ID_C:HTMLDBHID'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>245224629509817478
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140466777324344549)
,p_plug_template_id=>wwv_flow_imp.id(30347228019736370)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140466862251344549)
,p_plug_template_id=>wwv_flow_imp.id(30347228019736370)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small_gray_top
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(32633710970357971)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Rounded Corner Small (Gray Top)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL_GRAY_TOP'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>32612420016685806
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92285717221260718)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92286214764260718)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92286797690260718)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92287298292260718)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92287750704260719)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92288229836260719)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92288702099260719)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92289213007260719)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92289764101260720)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92290250216260720)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92290706289260720)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92291270211260720)
,p_plug_template_id=>wwv_flow_imp.id(32633710970357971)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar_100
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34074202387975945)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion buttonRegion" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    #BODY#',
'    <span class="aButtonContainer">',
'      #CLOSE##COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#',
'    </span>',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Top Bar (100%)'
,p_internal_name=>'APEX_4.0_TOP_BAR_100%'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17357218626599946
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92492227646295487)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92492737581295487)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92493228802295488)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92493785383295488)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92494287203295488)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92494754757295488)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92495287122295489)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92495787492295489)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92496253311295489)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92496786739295489)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92497287854295490)
,p_plug_template_id=>wwv_flow_imp.id(34074202387975945)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(40275409253350646)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_form_table_attr=>' '
,p_reference_id=>17354206769599941
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135723769948120559)
,p_plug_template_id=>wwv_flow_imp.id(40275409253350646)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135724295709120559)
,p_plug_template_id=>wwv_flow_imp.id(40275409253350646)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(48533119259303364)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Sidebar (Gray Header)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92358340356283228)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92358886924283228)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92359320030283228)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92359851084283228)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92360314747283229)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92360809433283229)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92361397763283229)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92361820354283229)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92362375284283230)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92362811431283230)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92363383852283230)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92363855842283230)
,p_plug_template_id=>wwv_flow_imp.id(48533119259303364)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_reports_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(60932116232746047)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-region" id="#REGION_STATIC_ID#" style="width:100%">',
'  <div class="rc-gray-top"><div class="rc-gray-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Reports Region'
,p_internal_name=>'APEX_4.0_REPORTS_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17354512447599941
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92124700604172788)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92125286220172789)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92125728581172789)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92126240293172789)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92126752686172789)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92127242787172790)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92127711598172790)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92128268016172790)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92128705731172790)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92129266331172791)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92129739623172791)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92130273487172791)
,p_plug_template_id=>wwv_flow_imp.id(60932116232746047)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(79598426990781464)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Sidebar (Gray Header) (2)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92369460096283234)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92369951421283235)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92370429840283235)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92370904858283235)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92371480646283235)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92371941431283236)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92372416984283236)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92372910038283236)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92373494869283236)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92373995560283237)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92374459236283237)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92374996825283237)
,p_plug_template_id=>wwv_flow_imp.id(79598426990781464)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(106671321669750604)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box'
,p_internal_name=>'APEX_4.2_ACTION_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93427885357371979)
,p_plug_template_id=>wwv_flow_imp.id(106671321669750604)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93428340789371980)
,p_plug_template_id=>wwv_flow_imp.id(106671321669750604)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93428805270371980)
,p_plug_template_id=>wwv_flow_imp.id(106671321669750604)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93429311018371980)
,p_plug_template_id=>wwv_flow_imp.id(106671321669750604)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93429871765371980)
,p_plug_template_id=>wwv_flow_imp.id(106671321669750604)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93430353670371981)
,p_plug_template_id=>wwv_flow_imp.id(106671321669750604)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93430829709371981)
,p_plug_template_id=>wwv_flow_imp.id(106671321669750604)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93431363295371981)
,p_plug_template_id=>wwv_flow_imp.id(106671321669750604)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93431848137371982)
,p_plug_template_id=>wwv_flow_imp.id(106671321669750604)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar_99
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(169070213366124294)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="topbar" style="width:99%;clear:both;" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="topbar-top"><div class="topbar-top-r"></div></div>',
'  <div class="topbar-body"><div class="topbar-body-r"><div class="topbar-content">',
'      <div style="float:left">#BODY#</div>',
'      <div style="float:right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</div>',
'   </div></div></div>',
'  <div class="topbar-bottom"><div class="topbar-bottom-r"></div></div>',
'</div>',
'<br />'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Top Bar (99%)'
,p_internal_name=>'APEX_4.0_TOP_BAR_99%'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>169048010062038708
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92553224440298313)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92553756225298313)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92554255535298313)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92554735169298314)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92555230436298314)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92555705184298314)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92556293312298314)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92556619879298315)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92557159595298315)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92557632706298315)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92558197177298316)
,p_plug_template_id=>wwv_flow_imp.id(169070213366124294)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_confirm
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(202306221419259440)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (Confirm)'
,p_internal_name=>'APEX_4.2_ACTION_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93536842226376152)
,p_plug_template_id=>wwv_flow_imp.id(202306221419259440)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93537362974376153)
,p_plug_template_id=>wwv_flow_imp.id(202306221419259440)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93537802028376153)
,p_plug_template_id=>wwv_flow_imp.id(202306221419259440)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93538378091376153)
,p_plug_template_id=>wwv_flow_imp.id(202306221419259440)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93538804304376153)
,p_plug_template_id=>wwv_flow_imp.id(202306221419259440)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93539381378376154)
,p_plug_template_id=>wwv_flow_imp.id(202306221419259440)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93539834452376154)
,p_plug_template_id=>wwv_flow_imp.id(202306221419259440)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93540390719376154)
,p_plug_template_id=>wwv_flow_imp.id(202306221419259440)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93540848395376155)
,p_plug_template_id=>wwv_flow_imp.id(202306221419259440)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(208383713787306085)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Wizard Body'
,p_internal_name=>'APEX_4.2_WIZARD_BODY'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209615589242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93616537752534551)
,p_plug_template_id=>wwv_flow_imp.id(208383713787306085)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93617041660534551)
,p_plug_template_id=>wwv_flow_imp.id(208383713787306085)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_divider
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(208384206154306085)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'<div class="wizardRegionHeading">',
'  <h1>#TITLE#</h1>',
'  <div class="buttonContainer">',
'#EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'  </div>',
'</div>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Wizard Body (Divider)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_DIVIDER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209811475242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93653024908541296)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93653506401541296)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93654064010541296)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93654507278541296)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93655050012541297)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93655530677541297)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93656040359541297)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93656585867541298)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93657063909541298)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93657592076541298)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93658048496541298)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93658538761541299)
,p_plug_template_id=>wwv_flow_imp.id(208384206154306085)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_hide_show
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(208384700309306086)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h1><a href="javascript:void(0);" onclick="$(''##REGION_STATIC_ID#_content'').slideToggle();$(''##REGION_STATIC_ID#_img'').toggleClass(''expanded'');" class="hideShowLink"><img src="#IMAGE_PREFIX#f_spacer.gif" class="hideShow" alt="" id="#REGION_STATIC'
||'_ID#_img"/>#TITLE#</a></h1>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_HIDE/SHOW'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210116661242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93708406265549108)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93708945539549108)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93709457427549108)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93709995969549109)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93710486478549109)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93710910491549109)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93711477821549110)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93711934587549110)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93712425959549110)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93712959433549110)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93713471824549111)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93713939759549111)
,p_plug_template_id=>wwv_flow_imp.id(208384700309306086)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(388531674152470979)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32593024414747551)
,p_plug_template_id=>wwv_flow_imp.id(388531674152470979)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32593572789747551)
,p_plug_template_id=>wwv_flow_imp.id(388531674152470979)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32594073391747552)
,p_plug_template_id=>wwv_flow_imp.id(388531674152470979)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32594568032747552)
,p_plug_template_id=>wwv_flow_imp.id(388531674152470979)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_action_box_warning
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(451939821989914545)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion warningRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Action Box / Wizard Box (Warning)'
,p_internal_name=>'APEX_4.0_ACTION_BOX_WARNING'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>162320107014603380
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60478317229140147)
,p_plug_template_id=>wwv_flow_imp.id(451939821989914545)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60478881485140147)
,p_plug_template_id=>wwv_flow_imp.id(451939821989914545)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60479342420140147)
,p_plug_template_id=>wwv_flow_imp.id(451939821989914545)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60479834941140147)
,p_plug_template_id=>wwv_flow_imp.id(451939821989914545)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60480319112140148)
,p_plug_template_id=>wwv_flow_imp.id(451939821989914545)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60480838026140148)
,p_plug_template_id=>wwv_flow_imp.id(451939821989914545)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60481365117140148)
,p_plug_template_id=>wwv_flow_imp.id(451939821989914545)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60481881125140149)
,p_plug_template_id=>wwv_flow_imp.id(451939821989914545)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60482372094140149)
,p_plug_template_id=>wwv_flow_imp.id(451939821989914545)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_navigation
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(466721715306301967)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion sideNavRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Sidebar Navigation'
,p_internal_name=>'APEX_4.0_SIDEBAR_NAVIGATION'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>456726627253419549
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60515004710151496)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60515581928151496)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60516007551151496)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60516521875151496)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60517091044151497)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60517519114151497)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60518017869151497)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60518510871151497)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60519043941151498)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60519586448151498)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60520068642151498)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60520583922151498)
,p_plug_template_id=>wwv_flow_imp.id(466721715306301967)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(486010891028205826)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>174748721787471587
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32442333712578753)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32442821998578753)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32443347446578754)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32443837552578754)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32444341166578754)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32444887814578755)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32445378638578755)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32445898769578755)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32446373970578755)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32446860654578756)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32447398463578756)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32447873685578756)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32448360575578756)
,p_plug_template_id=>wwv_flow_imp.id(486010891028205826)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_top_buttons
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(486011409944205836)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--left">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--right">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region (Top Buttons)'
,p_internal_name=>'APEX_5.0_REGION_TOP_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174747104640428780
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445072319344571)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445120828344571)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445226401344571)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445300605344571)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445441953344571)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445545990344570)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445606834344570)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445736480344570)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445862235344570)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140445926695344570)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140446048784344570)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140446169979344570)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140446229764344570)
,p_plug_template_id=>wwv_flow_imp.id(486011409944205836)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(486012234812205837)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="toolbar" aria-label="#TITLE!ATTR#" class="a-Toolbar #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Toolbar-items a-Toolbar-items--left">#PREVIOUS#</div>',
'  <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar'
,p_internal_name=>'APEX_5.0_TOOLBAR'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613705533399534
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68595273778251721)
,p_plug_template_id=>wwv_flow_imp.id(486012234812205837)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68595765077251721)
,p_plug_template_id=>wwv_flow_imp.id(486012234812205837)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68596285755251721)
,p_plug_template_id=>wwv_flow_imp.id(486012234812205837)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68596799249251722)
,p_plug_template_id=>wwv_flow_imp.id(486012234812205837)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_left
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(486012902426205838)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--left #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Left)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_LEFT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174628415239478085
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140446787206344569)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140446860299344569)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140446908566344569)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447009997344569)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447105513344569)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447277614344569)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447350980344569)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447417610344568)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447553847344568)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447651530344568)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447733677344568)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447838944344568)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140447945839344568)
,p_plug_template_id=>wwv_flow_imp.id(486012902426205838)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_right
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(486013619316205838)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--right #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Right)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_RIGHT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174629130392501406
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448090596344568)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448115306344568)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448259687344568)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448349720344568)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448475161344567)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448556013344567)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448615589344567)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448709850344567)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448878459344567)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140448986477344567)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140449090237344567)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140449188677344567)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140449206430344567)
,p_plug_template_id=>wwv_flow_imp.id(486013619316205838)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(486014333429205839)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88247799449825396)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88248263809825396)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88248767166825396)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88249247012825397)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88249793576825397)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88250277366825397)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88250733352825398)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88251289609825398)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88251756176825398)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88252236071825398)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88252727911825399)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88253280274825399)
,p_plug_template_id=>wwv_flow_imp.id(486014333429205839)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_hidden_heading
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717841909277073684)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region (Hidden Heading)'
,p_internal_name=>'APEX_5.0_REGION_HIDDEN_HEADING'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>717832816842067694
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88073757095788133)
,p_plug_template_id=>wwv_flow_imp.id(717841909277073684)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88074232564788133)
,p_plug_template_id=>wwv_flow_imp.id(717841909277073684)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(720158679964358138)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 id="#REGION_STATIC_ID#_TITLE" class="u-vh">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>702777601713950915
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214488494826485463)
,p_plug_template_id=>wwv_flow_imp.id(720158679964358138)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214488937185485463)
,p_plug_template_id=>wwv_flow_imp.id(720158679964358138)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(720159283194358177)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88135619470806716)
,p_plug_template_id=>wwv_flow_imp.id(720159283194358177)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88136167442806716)
,p_plug_template_id=>wwv_flow_imp.id(720159283194358177)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(720165508600362771)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region with no UI decoration'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_preset_template_options=>'a-ButtonRegion--noUI'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140475795004344539)
,p_plug_template_id=>wwv_flow_imp.id(720165508600362771)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140475853052344539)
,p_plug_template_id=>wwv_flow_imp.id(720165508600362771)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140475967447344539)
,p_plug_template_id=>wwv_flow_imp.id(720165508600362771)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140476080044344539)
,p_plug_template_id=>wwv_flow_imp.id(720165508600362771)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140476173057344539)
,p_plug_template_id=>wwv_flow_imp.id(720165508600362771)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140476247768344539)
,p_plug_template_id=>wwv_flow_imp.id(720165508600362771)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140476398045344539)
,p_plug_template_id=>wwv_flow_imp.id(720165508600362771)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140476489384344539)
,p_plug_template_id=>wwv_flow_imp.id(720165508600362771)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140476555189344539)
,p_plug_template_id=>wwv_flow_imp.id(720165508600362771)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(720186138525572350)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88189225273816928)
,p_plug_template_id=>wwv_flow_imp.id(720186138525572350)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88189715947816929)
,p_plug_template_id=>wwv_flow_imp.id(720186138525572350)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(797568474776479154)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div role="alert" class="a-Alert-body">#BODY#</div>',
'    </div>',
'    <div class="a-Alert-buttons">#PREVIOUS##CLOSE##CREATE##NEXT#</div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>746362351042209764
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4859192773959725)
,p_plug_template_id=>wwv_flow_imp.id(797568474776479154)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4859668673959726)
,p_plug_template_id=>wwv_flow_imp.id(797568474776479154)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4860112217959726)
,p_plug_template_id=>wwv_flow_imp.id(797568474776479154)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4860686191959726)
,p_plug_template_id=>wwv_flow_imp.id(797568474776479154)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4861196098959726)
,p_plug_template_id=>wwv_flow_imp.id(797568474776479154)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4861676692959726)
,p_plug_template_id=>wwv_flow_imp.id(797568474776479154)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_workspace_login_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(797573769515479165)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Login-region a-Form--stretchInputs #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-Login-header">',
'    <span class="a-Login-logo gi-icon-apex-logo-icon" aria-hidden="true"></span>',
'    <h1 class="a-Login-title" id="#REGION_STATIC_ID#_TITLE">#TITLE#</h1>',
'  </div>',
'  <div class="a-Login-body">',
'    #BODY#',
'  </div>',
'  <div class="a-Login-buttons">',
'    #NEXT#',
'  </div>',
'  <div class="a-Login-links">',
'    #EDIT##CREATE#',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Workspace Login Region'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'form'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>781637364422290692
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53933338290418946)
,p_plug_template_id=>wwv_flow_imp.id(797573769515479165)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53933874281418946)
,p_plug_template_id=>wwv_flow_imp.id(797573769515479165)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53934367376418947)
,p_plug_template_id=>wwv_flow_imp.id(797573769515479165)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53934850989418947)
,p_plug_template_id=>wwv_flow_imp.id(797573769515479165)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(53935375107418947)
,p_plug_template_id=>wwv_flow_imp.id(797573769515479165)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(829445215771671657)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <h2 id="#REGION_STATIC_ID#_heading" class="u-vh a-Region-header">#TITLE#</h2>',
'  #PREVIOUS##BODY##NEXT#',
'</div>',
''))
,p_page_plug_template_name=>'[x] APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>678354360586321695
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1509283299426786)
,p_plug_template_id=>wwv_flow_imp.id(829445215771671657)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1509760568426787)
,p_plug_template_id=>wwv_flow_imp.id(829445215771671657)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1510203258426787)
,p_plug_template_id=>wwv_flow_imp.id(829445215771671657)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1510742586426787)
,p_plug_template_id=>wwv_flow_imp.id(829445215771671657)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_accordion_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(829454386558680645)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Accordion Region'
,p_internal_name=>'APEX_5.0_ACCORDION_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>747596346966613593
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60608798359209446)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60609241091209447)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60609786640209447)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60610261059209447)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60610704436209447)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60611235763209448)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60611794636209448)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60612249807209448)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60612792459209448)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60613291646209448)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60613740090209449)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60614285144209449)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60614763953209449)
,p_plug_template_id=>wwv_flow_imp.id(829454386558680645)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(829458533922680656)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# #REGION_LANDMARK_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>689955986849128825
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1462195499065834)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1462607918065834)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1463116204065834)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1463657902065834)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1464192714065835)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1464643240065835)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1465181804065835)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1465634134065835)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1466154579065836)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1466660262065836)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1467139486065836)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1467672612065836)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1468172183065836)
,p_plug_template_id=>wwv_flow_imp.id(829458533922680656)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_subregion
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(854957815491167190)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="subRegion">',
'<h2>#TITLE#</h2>',
'#BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 4.0 - Sub-Region'
,p_internal_name=>'APEX_4.0_SUBREGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140491369432344523)
,p_plug_template_id=>wwv_flow_imp.id(854957815491167190)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140491488199344523)
,p_plug_template_id=>wwv_flow_imp.id(854957815491167190)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(1029955071738136284)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span aria-hidden="true" class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>698829239393878937
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131692268094047173)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131692742342047174)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131693228667047174)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131693771019047174)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131694247637047175)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131694748871047175)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131695220038047175)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131695761692047175)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131696203320047176)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131696739657047176)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131697214270047176)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131697744580047177)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131698210065047177)
,p_plug_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(17819003571010282)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>32421627622986728
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_large_icons_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(20165427056621106)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_name=>'[EBA] Large Icons List'
,p_internal_name=>'[EBA]_LARGE_ICONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="ebaLargeIcons" width="100%" cellspacing="0" cellpadding="0" border="0" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_reference_id=>20148806760577112
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(38499417503989888)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List (2)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_horizontal_list_with_images
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(77000120193659142)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="current">',
'  <div class="image">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a>',
'  </div>',
'  <div class="label">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'  </div>',
'</div>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="noncurrent">',
'  <div class="image">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a>',
'  </div>',
'  <div class="label">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'  </div>',
'</div>'))
,p_list_template_name=>'APEX 4.0 - Horizontal List with Images'
,p_internal_name=>'APEX_4.0_HORIZONTAL_LIST_WITH_IMAGES'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-list-horizontal">'
,p_list_template_after_rows=>'</div>'
,p_reference_id=>17386714276888490
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(168717528748286543)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs (2)'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_pull_down_tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(187163514263710745)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_list_template_name=>'APEX 4.0 - Pull Down Tabs'
,p_internal_name=>'APEX_4.0_PULL_DOWN_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div id="tabs" class="dhtmlMenuLG">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul id="S#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="aTabs dhtmlSubMenu pulldown-tabs" style="display:none;">',
''))
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_f_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current-first">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_f_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current-first">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_f_item_template_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current-first">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_fi_template_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current-first">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_reference_id=>9651611091899590
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_wizard_progress_bar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(208376827287299755)
,p_list_template_current=>'<li class="#LIST_STATUS#"><span>#TEXT#</span></li>'
,p_list_template_noncurrent=>'<li class="#LIST_STATUS#"><span>#TEXT#</span></li>'
,p_list_template_name=>'APEX 4.2 - Wizard Progress Bar'
,p_internal_name=>'APEX_4.2_WIZARD_PROGRESS_BAR'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardProgress">',
'<ul>'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'</div>'))
,p_reference_id=>42216127932260877
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(388535020971474291)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_a06_label=>'Link Target'
,p_reference_id=>573607518145151423
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(388535333575474292)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a06_label=>'Target'
,p_reference_id=>747588010155545129
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(692750374873071023)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" aria-current="page" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_name=>'[x] APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(717846892308122004)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(720190141563578035)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs_002
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(829468732055693490)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_002
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(829471944455703874)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(6659715068668103)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report from 4999'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/quick_pick_list_items
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(11670410466357416)
,p_row_template_name=>'quick_pick_list_items'
,p_internal_name=>'QUICK_PICK_LIST_ITEMS'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(43021310970202834)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(46765105410141325)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_row_template_one_column
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(47025022336023416)
,p_row_template_name=>'APEX 4.0 - Portlet Row Template (one column)'
,p_internal_name=>'APEX_4.0_PORTLET_ROW_TEMPLATE_ONE_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="report-row">',
'  <div class="report-col-hdr">#1#</div>',
'</div>',
''))
,p_row_template_before_rows=>'<div class="report-portlet" #REPORT_ATTRIBUTES# id="#REGION_ID#"><div class="report-record">'
,p_row_template_after_rows=>'</div></div>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46783029065220201
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(770822958504300751)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(770827785027300814)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(770828451758300816)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(770829717235300818)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# #ARIA_SORT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/label_tag_only
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(4927331448760529)
,p_template_name=>'LABEL Tag Only'
,p_internal_name=>'LABEL_TAG_ONLY'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(7301320786376802)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(107534131274292840)
,p_template_name=>'FormField_Optional'
,p_internal_name=>'FORMFIELD_OPTIONAL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_required
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(107535006471295136)
,p_template_name=>'FormField_Required'
,p_internal_name=>'FORMFIELD_REQUIRED'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>2
,p_reference_id=>17388508175892042
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/htmldb_greenarealabel_c_htmldbgalabel
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(355525708739902293)
,p_template_name=>'htmldb_GreenAreaLabel (c:htmldbGALabel)'
,p_internal_name=>'HTMLDB_GREENAREALABEL_C:HTMLDBGALABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_4_0_top_bar_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(450569121489682306)
,p_template_name=>'APEX 4.0 - Top Bar Label'
,p_internal_name=>'APEX_4.0_TOP_BAR_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(489153051785943514)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(489153170799943531)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_workspace_login_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(797617751200847238)
,p_template_name=>'APEX 5.0 - Workspace Login Label'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon a-Login-iconLabel" aria-hidden="true"></span>',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="u-vh">'))
,p_template_body2=>'</label>'
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#"><div class="a-Form-inputContainer">'
,p_after_item=>'</div></div>'
,p_after_element=>'<span class="a-Login-iconValidation a-Icon icon-check" aria-hidden="true"></span>#ERROR_TEMPLATE#'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span class="u-VisuallyHidden">#CURRENT_ITE'
||'M_HELP_LABEL#</span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>781637020106265852
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(805713983989099558)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(829426714251135780)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(829426906030135803)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' </label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumbs
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(4094616517288262)
,p_name=>'breadcrumbs'
,p_internal_name=>'BREADCRUMBS'
,p_current_page_option=>'<span class="htmldbBreadcrumb">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#" class="htmldbBreadcrumb" title="#NAME#">#NAME#</a>'
,p_between_levels=>'<span class="htmldbBreadcrumbSep"><img alt="" src="#IMAGE_PREFIX#apex/apex_top_sep.gif"></span>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>60115300853820165
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(388538606549481005)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>8
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_imp_shared.create_popup_lov_template(
 p_id=>wwv_flow_imp.id(13478004473367504)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/htmldb_calendar
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(50595123809626578)
,p_cal_template_name=>'HTMLDB Calendar'
,p_internal_name=>'HTMLDB_CALENDAR'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/apex_4_0_default_calander
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(429989326510150689)
,p_cal_template_name=>'APEX 4.0 Default Calander'
,p_internal_name=>'APEX_4.0_DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_imp_shared.create_theme(
 p_id=>wwv_flow_imp.id(75121221408016512)
,p_theme_id=>3
,p_theme_name=>'APEX 4.0'
,p_theme_internal_name=>'APEX_4.0'
,p_navigation_type=>'T'
,p_nav_bar_type=>'NAVBAR'
,p_is_locked=>false
,p_default_page_template=>wwv_flow_imp.id(692763410753114205)
,p_default_dialog_template=>wwv_flow_imp.id(485889499804058937)
,p_error_template=>wwv_flow_imp.id(718401914085176458)
,p_printer_friendly_template=>wwv_flow_imp.id(692762974728114205)
,p_default_button_template=>wwv_flow_imp.id(486003960305193183)
,p_default_region_template=>wwv_flow_imp.id(486010891028205826)
,p_default_report_template=>wwv_flow_imp.id(6659715068668103)
,p_default_label_template=>wwv_flow_imp.id(107534131274292840)
,p_default_menu_template=>wwv_flow_imp.id(388538606549481005)
,p_default_calendar_template=>wwv_flow_imp.id(50595123809626578)
,p_default_list_template=>wwv_flow_imp.id(77000120193659142)
,p_default_nav_list_position=>'TOP'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(3),'')
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/oracle-fonts/oraclesans-apex#MIN#.css?v=#APEX_VERSION#'
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(72331295244515034)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(204023711571766699)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556398380302103261)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556398801399103962)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689640285334993975)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689641104387993975)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689641890550993975)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689643729287993977)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(692750780606071026)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(697086486123403004)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(697256069906708874)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746393654795391886)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746394927367391887)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746395298555391888)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746395536106391888)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746396667408391888)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746396989722391888)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746397289357391888)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746397595401391891)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746397833448391891)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746398369579391892)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746398688326391894)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(770823390186300758)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(770823825914300766)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(770830294703300821)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(770830568775300821)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(770830880737300822)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(770831461915300822)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(797568847627479160)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(797569107979479163)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1511530354426788)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden to Assistive Tech'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829445215771671657)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(697086486123403004)
,p_template_types=>'REGION'
,p_help_text=>'By default, region title is hidden but accessible, use this option to remove the header from accessible interface'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697205003669627560)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_imp.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697205322334627560)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_imp.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697205656478627560)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_imp.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697205962987627560)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_imp.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697206272842627560)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_imp.id(692750780606071026)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697206541642627561)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697206893304627561)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697207116811627561)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697207482365627561)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697207795800627561)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(720168495179362789)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(720165508600362771)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(720168737661362789)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(720165508600362771)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_imp.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(720169093834362789)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(720165508600362771)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_imp.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(720169320057362789)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(720165508600362771)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(720169612442362790)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(720165508600362771)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(720169962201362790)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(720165508600362771)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(720170263853362790)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(720165508600362771)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_imp.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(720170590608362790)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(720165508600362771)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_imp.id(697086486123403004)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746393738081391886)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_imp.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746393946513391887)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_imp.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746394166942391887)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_imp.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746394309853391887)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_imp.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746394522694391887)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_imp.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746394779452391887)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_imp.id(746393654795391886)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746395019878391887)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_imp.id(746394927367391887)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746395380241391888)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_imp.id(746395298555391888)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746395600089391888)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_imp.id(746395536106391888)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746395886384391888)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_imp.id(746395298555391888)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746396068348391888)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_imp.id(746395298555391888)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746396210061391888)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_imp.id(746395298555391888)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746396402377391888)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_imp.id(746395536106391888)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746396798561391888)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_imp.id(746396667408391888)
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746397056950391888)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_imp.id(746396989722391888)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746397329794391888)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_imp.id(746397289357391888)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746397664395391891)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_imp.id(746397595401391891)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746397991614391892)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_imp.id(746397833448391891)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746398179522391892)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_imp.id(746395536106391888)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746398463551391892)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(746398369579391892)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746398734776391894)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_imp.id(746398688326391894)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746398858248391894)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746399096840391894)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_imp.id(746397289357391888)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746399252498391894)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_imp.id(746397595401391891)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746399411992391894)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_imp.id(746397833448391891)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746399588502391894)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(746399637338391898)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770825244829300814)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770825494601300814)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770825628874300814)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770825870229300814)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770826028180300814)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770826263361300814)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770826410150300814)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770826644429300814)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(770823825914300766)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770826826983300814)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770827012098300814)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770827235754300814)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770827447408300814)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770827697507300814)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770822958504300751)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(770823390186300758)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787128846439949734)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770829717235300818)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(770830294703300821)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787129076990949734)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770829717235300818)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(770830568775300821)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787129211664949734)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770829717235300818)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(770830880737300822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787129478553949735)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770829717235300818)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(770830880737300822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787129664604949735)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770829717235300818)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(770830880737300822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787129797417949735)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770829717235300818)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787129942802949735)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770829717235300818)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(770831461915300822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(797570360313479164)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(797568474776479154)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(797570478965479164)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(797568474776479154)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(797570646853479165)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(797568474776479154)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_imp.id(797568847627479160)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(797570895501479165)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(797568474776479154)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_imp.id(797568847627479160)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(797571042081479165)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(797568474776479154)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_imp.id(797568847627479160)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(797571272421479165)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(797568474776479154)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_imp.id(797569107979479163)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(797571447867479165)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(797568474776479154)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_imp.id(797569107979479163)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(797571501534479165)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(797568474776479154)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(797571791611479165)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(797568474776479154)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_imp.id(797568847627479160)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829456396120680656)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829456489387680656)
,p_theme_id=>3
,p_name=>'ADDBOTTOMBORDER'
,p_display_name=>'Add Bottom Border'
,p_display_sequence=>13
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--bottomBorder'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829456523812680656)
,p_theme_id=>3
,p_name=>'ADDLEFTBORDER'
,p_display_name=>'Add Left Border'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--borderLeft'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829456697529680656)
,p_theme_id=>3
,p_name=>'ADDRIGHTBORDER'
,p_display_name=>'Add Right Border'
,p_display_sequence=>11
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--rightBorder'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829456721655680656)
,p_theme_id=>3
,p_name=>'ADDTOPBORDER'
,p_display_name=>'Add Top Border'
,p_display_sequence=>12
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--borderTop'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829456928276680656)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829457167899680656)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829457377910680656)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829457428483680656)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829457686604680656)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829457873432680656)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829458099623680656)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(829458157107680656)
,p_theme_id=>3
,p_name=>'SHOWTOPBUTTON'
,p_display_name=>'Show Top Button'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829454386558680645)
,p_css_classes=>'a-Region--showTopButton'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(926399656957707535)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(388535333575474292)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(926399745454707535)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(388535333575474292)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(940696690156341580)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(720190141563578035)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1199561127830032419)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(746398369579391892)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525661359651182107)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525661463198182107)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525661538921182107)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525661634515182108)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525661803623182108)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(697256069906708874)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525662055051182108)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(697256069906708874)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525664505544182122)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525664603775182122)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525664790107182122)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525664816420182122)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525665087495182122)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(697256069906708874)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525665273167182122)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(697256069906708874)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544816639795478003)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770828451758300816)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544816735968478004)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770828451758300816)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544816822442478004)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(770828451758300816)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544817297983478008)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(11670410466357416)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544817313883478008)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(11670410466357416)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544817462934478008)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(11670410466357416)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554821911032408403)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554822194319408403)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554822304112408403)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554822529201408404)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554822705386408404)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689641104387993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554822968912408404)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554823153887408404)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554823379060408404)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554823546082408404)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554823609760408404)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554823847364408404)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(486010891028205826)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_imp.id(689641890550993975)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554834147729526820)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(829445215771671657)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554834211041526820)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829445215771671657)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554834394928526820)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829445215771671657)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554850993386542287)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554851087148542287)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554851242750542287)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554851473200542287)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554851654292542287)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689641104387993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554851832381542288)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554852037917542288)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554852288217542288)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554852446766542288)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_imp.id(797569107979479163)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554852695350542289)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(829458533922680656)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_imp.id(797569107979479163)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554864460392550809)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554864671291550809)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554864855569550809)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554865036396550809)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689641890550993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554865266775550809)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554865459115550809)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(697086486123403004)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554865662563550810)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554865849887550810)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689643729287993977)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554866021273550810)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689641104387993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554866292270550810)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(1029955071738136284)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689640285334993975)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/globalization/language
begin
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72244704764976154)
,p_translation_flow_id=>4351
,p_translation_flow_language_cd=>'es'
,p_translation_comments=>'Development Service Home - Spanish'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72244808450976154)
,p_translation_flow_id=>4352
,p_translation_flow_language_cd=>'fr'
,p_translation_comments=>'Development Service Home - French'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72244909378976154)
,p_translation_flow_id=>4353
,p_translation_flow_language_cd=>'de'
,p_translation_comments=>'Development Service Home - German'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245003300976154)
,p_translation_flow_id=>4354
,p_translation_flow_language_cd=>'it'
,p_translation_comments=>'Development Service Home - Italian'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245108276976154)
,p_translation_flow_id=>4355
,p_translation_flow_language_cd=>'pt-br'
,p_translation_comments=>'Development Service Home - Brazilian Portuguese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245216034976154)
,p_translation_flow_id=>4356
,p_translation_flow_language_cd=>'zh-cn'
,p_translation_comments=>'Development Service Home - Simplified Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245307105976154)
,p_translation_flow_id=>4357
,p_translation_flow_language_cd=>'zh-tw'
,p_translation_comments=>'Development Service Home - Traditional Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245429065976155)
,p_translation_flow_id=>4358
,p_translation_flow_language_cd=>'ko'
,p_translation_comments=>'Development Service Home - Korean'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245516409976155)
,p_translation_flow_id=>4359
,p_translation_flow_language_cd=>'ja'
,p_translation_comments=>'Development Service Home - Japanese'
,p_direction_right_to_left=>'N'
);
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(140268206065172819)
,p_build_option_name=>'Database Monitoring'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(231647503239340557)
,p_build_option_name=>'Page Caching'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_default_on_export=>'EXCLUDE'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(693461267865622287)
,p_build_option_name=>'Enable APEX Internal Feedback'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_default_on_export=>'EXCLUDE'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2361971006803509)
,p_name=>'4350_P68_CURRENT_PWD'
,p_message_text=>'Provide the current password for &P68_USER_NAME..'
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1916228255992979)
,p_name=>'4350_WKSP_PASSWORD'
,p_message_text=>'Provide additional password for the database schema.'
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783055225879286)
,p_name=>'ABOUT_MLE_CANNOT_CREATE'
,p_message_text=>'Cannot create MLE modules. %0'
,p_version_scn=>1203868999
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783771906799577)
,p_name=>'ABOUT_MLE_CANNOT_EXECUTE'
,p_message_text=>'Cannot execute %0 code. %1'
,p_version_scn=>1203875252
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782848860881135)
,p_name=>'ABOUT_MLE_CAN_CREATE'
,p_message_text=>'Can create MLE modules.'
,p_version_scn=>1203868418
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3135984497004395)
,p_name=>'ABOUT_MLE_CAN_EXECUTE'
,p_message_text=>'Can execute %0 code.'
,p_version_scn=>1203875221
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3135732896026737)
,p_name=>'ABOUT_MLE_DISABLED_APEX'
,p_message_text=>'Within the Builder, %0 has been disabled via the MLE_LANGUAGES Oracle APEX instance parameter.'
,p_version_scn=>1203998313
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3135276239177034)
,p_name=>'ABOUT_MLE_DISABLED_DB'
,p_message_text=>'MLE is disabled at Database Instance level via the system parameter MULTILINGUAL_ENGINE.'
,p_version_scn=>1049616530
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3135447780110401)
,p_name=>'ABOUT_MLE_MISSING_PRIVS'
,p_message_text=>'Missing privileges: %0'
,p_version_scn=>1203979499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3135013626203850)
,p_name=>'ABOUT_MLE_NOT_AVAILABLE'
,p_message_text=>'MLE is not available: %0.'
,p_version_scn=>1203968966
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1422802782384820)
,p_name=>'ABOUT_MLE_SCHEMA'
,p_message_text=>'Schema %0:'
,p_version_scn=>1201694309
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3134667457213655)
,p_name=>'ABOUT_MLE_STATUS_19'
,p_message_text=>'MLE is only available on Oracle Database 21c and above.'
,p_version_scn=>1049367681
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3134831594210408)
,p_name=>'ABOUT_MLE_STATUS_21'
,p_message_text=>'On Oracle Database 21c, MLE is only available for limited use. Oracle recommends the use of MLE on Database 23ai and above.'
,p_version_scn=>1108913785
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/item_help
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(2123222599612374)
,p_shortcut_name=>'ITEM_HELP'
,p_shortcut_type=>'HTML_TEXT'
,p_error_text=>'Unable to show help.'
,p_version_scn=>75557046
,p_shortcut=>'<a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999"><img src="#IMAGE_PREFIX#infoicon_status_gray.gif" width=16 height=16 border=0></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/admin_home
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(75628231717105217)
,p_shortcut_name=>'ADMIN_HOME'
,p_shortcut_type=>'HTML_TEXT'
,p_version_scn=>75557046
,p_shortcut=>'<table><tr><td>&nbsp;</td><td><table bgcolor="#ffffff" cellspacing=0 cellpadding=0 border="1"><tr><td><a href="f?p=4350:3:&SESSION."><img src="#IMAGE_PREFIX#people2.gif" width="100" height="75" border="0"></a><br><font size="-2" face="arial">Admin&nb'
||'sp;Home...</font></td></tr></table></td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(116152925483353324)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75557046
,p_shortcut=>'Would you like to perform this delete action?'
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(539691214090646644)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>540226219724705040
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(12505007847150358)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>'Developer Authorization'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1682263998757953)
,p_plugin_id=>wwv_flow_imp.id(12505007847150358)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1683159567757954)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1683634970757954)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1684133177757954)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1684677188757955)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1685135833757955)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1685605236757955)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1686170116757956)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1686619625757956)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1687181214757957)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1687680265757957)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1688185034757957)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1688631478757958)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1682643477757954)
,p_plugin_attribute_id=>wwv_flow_imp.id(1682263998757953)
,p_display_sequence=>140
,p_display_value=>'DATA_GENERATOR: Ability to access Data Generator in SQL Workshop'
,p_return_value=>'DATA_GENERATOR'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(44506226589251870)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_reference_id=>77082398185639908
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(61354352634419491)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>'Search Box'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513169841697230028)
,p_plugin_id=>wwv_flow_imp.id(61354352634419491)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513170249930230028)
,p_plugin_id=>wwv_flow_imp.id(61354352634419491)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(113748807145665438)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>'INTERNAL Oracle APEX Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113737019268347425
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(118564054404916668)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>'INTERNAL Social Sign-In'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_reference_id=>117694777698093086
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416880257571942540)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416880642926942540)
,p_plugin_attribute_id=>wwv_flow_imp.id(416880257571942540)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416881133344942541)
,p_plugin_attribute_id=>wwv_flow_imp.id(416880257571942540)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416881651897942541)
,p_plugin_attribute_id=>wwv_flow_imp.id(416880257571942540)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416882149243942541)
,p_plugin_attribute_id=>wwv_flow_imp.id(416880257571942540)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416882675245942542)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416880257571942540)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416883016046942542)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416880257571942540)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416883431237942542)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416880257571942540)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416883850005942542)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416880257571942540)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416884282058942543)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Oracle APEX automatically adds the "openid" scope. The authentication '
||'provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416884630445942543)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416885029902942543)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416885498700942544)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416885843758942544)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416886222973942544)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416880257571942540)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416886685512942544)
,p_plugin_attribute_id=>wwv_flow_imp.id(416886222973942544)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416887186335942545)
,p_plugin_attribute_id=>wwv_flow_imp.id(416886222973942544)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416887585639942545)
,p_plugin_attribute_id=>wwv_flow_imp.id(416886222973942544)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416888025151942545)
,p_plugin_attribute_id=>wwv_flow_imp.id(416886222973942544)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416888550718942546)
,p_plugin_id=>wwv_flow_imp.id(118564054404916668)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (for example, "email_verified" for Username Attribute "email"). If the value of this attribute is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356675029883447688)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'INTERNAL Oracle Cloud Identity Management'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749806821809026
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356678220661447691)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>'INTERNAL Database Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749511183746276
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356739011564447745)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>'INTERNAL HTTP Header Variable'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>708795120396802284
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308145776497529788)
,p_plugin_id=>wwv_flow_imp.id(356739011564447745)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308146159296529789)
,p_plugin_id=>wwv_flow_imp.id(356739011564447745)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308146569650529790)
,p_plugin_attribute_id=>wwv_flow_imp.id(308146159296529789)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308147065173529790)
,p_plugin_attribute_id=>wwv_flow_imp.id(308146159296529789)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308147580446529790)
,p_plugin_attribute_id=>wwv_flow_imp.id(308146159296529789)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308148055269529791)
,p_plugin_id=>wwv_flow_imp.id(356739011564447745)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(308146159296529789)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308148453718529791)
,p_plugin_id=>wwv_flow_imp.id(356739011564447745)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(308146159296529789)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308148806749529791)
,p_plugin_id=>wwv_flow_imp.id(356739011564447745)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308149255358529794)
,p_plugin_attribute_id=>wwv_flow_imp.id(308148806749529791)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308149725817529794)
,p_plugin_attribute_id=>wwv_flow_imp.id(308148806749529791)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308150280030529795)
,p_plugin_id=>wwv_flow_imp.id(356739011564447745)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356812805052447803)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'INTERNAL LDAP Directory'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>863910941135523528
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the username and password for authentication against the LDAP directory identified on the login page. Remember, passwords may be case sensitive.</p>',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356813001684447803)
,p_plugin_id=>wwv_flow_imp.id(356812805052447803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356813412150447803)
,p_plugin_id=>wwv_flow_imp.id(356812805052447803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356813831745447803)
,p_plugin_id=>wwv_flow_imp.id(356812805052447803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356814217919447803)
,p_plugin_attribute_id=>wwv_flow_imp.id(356813831745447803)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356814706404447803)
,p_plugin_attribute_id=>wwv_flow_imp.id(356813831745447803)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356815206641447804)
,p_plugin_attribute_id=>wwv_flow_imp.id(356813831745447803)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356815700428447804)
,p_plugin_id=>wwv_flow_imp.id(356812805052447803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356816131324447804)
,p_plugin_id=>wwv_flow_imp.id(356812805052447803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356816504735447804)
,p_plugin_id=>wwv_flow_imp.id(356812805052447803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(356816131324447804)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356816917591447805)
,p_plugin_id=>wwv_flow_imp.id(356812805052447803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356817328277447805)
,p_plugin_id=>wwv_flow_imp.id(356812805052447803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356817719903447805)
,p_plugin_attribute_id=>wwv_flow_imp.id(356817328277447805)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356818206709447805)
,p_plugin_attribute_id=>wwv_flow_imp.id(356817328277447805)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356818717907447807)
,p_plugin_attribute_id=>wwv_flow_imp.id(356817328277447805)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356821829039447810)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'INTERNAL Oracle Application Server Single Sign-On'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113750429890071859
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_html5_bar_chart
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1591049479124636231)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.HTML5_BAR_CHART'
,p_display_name=>'HTML 5 Bar Chart ***'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.HTML5_BAR_CHART'),'#IMAGE_PREFIX#plugins/com.oracle.apex.html5_bar_chart/1.0/')
,p_javascript_file_urls=>'#PLUGIN_FILES#com_oracle_apex_html5_bar_chart.js'
,p_css_file_urls=>'#PLUGIN_FILES#com_oracle_apex_html5_bar_chart.css'
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'FUNCTION RENDER (',
'    P_REGION IN WWV_FLOW_PLUGIN_API.T_REGION,',
'    P_PLUGIN IN WWV_FLOW_PLUGIN_API.T_PLUGIN,',
'    P_IS_PRINTER_FRIENDLY IN BOOLEAN',
') RETURN WWV_FLOW_PLUGIN_API.T_REGION_RENDER_RESULT IS',
'BEGIN',
'    sys.HTP.PRN(''<div id="''||WWV_FLOW_ESCAPE.HTML_ATTRIBUTE(P_REGION.STATIC_ID)||''_chart" class="hbc">'');',
'    sys.HTP.PRN(''</div>'');',
'    ',
'    WWV_FLOW_JAVASCRIPT_API.ADD_ONLOAD_CODE (',
'        P_CODE => ''com_oracle_apex_html5_bar_chart(''||',
'            WWV_FLOW_JAVASCRIPT_API.ADD_VALUE(P_REGION.STATIC_ID)||',
'            ''{''||',
'                -- Why is this attribute needed if is not used?',
'                WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE(',
'                    ''pageItems'', ',
'                    WWV_FLOW_PLUGIN_UTIL.PAGE_ITEM_NAMES_TO_JQUERY(P_REGION.AJAX_ITEMS_TO_SUBMIT)',
'                )||',
'                WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE(',
'                    ''ajaxIdentifier'', ',
'                    WWV_FLOW_PLUGIN_API.GET_AJAX_IDENTIFIER, ',
'                    FALSE, ',
'                    FALSE',
'                )||',
'            ''}''||',
'        '');''',
'    );',
'    ',
'    RETURN NULL;',
'END RENDER;',
'',
'FUNCTION AJAX (',
'    P_REGION IN WWV_FLOW_PLUGIN_API.T_REGION,',
'    P_PLUGIN IN WWV_FLOW_PLUGIN_API.T_PLUGIN',
') RETURN WWV_FLOW_PLUGIN_API.T_REGION_AJAX_RESULT IS',
'    -- Map region attributes to function constants',
'    -- MODERN, CLASSIC',
'    C_CHART_TYPE CONSTANT VARCHAR2(7) := P_REGION.ATTRIBUTE_15;',
'    -- MODERN, MODERN_2, SOLAR, METRO, CUSTOM, COLUMN',
'    C_COLOR_SCHEME CONSTANT VARCHAR2(8) := P_REGION.ATTRIBUTE_17;',
'    C_CUSTOM_CHART_COLORS CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_10;',
'    C_COLOR_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_19;',
'    -- NONE, IMAGE, ICON, INITIALS',
'    C_ICON_TYPE CONSTANT VARCHAR2(8) := case when C_CHART_TYPE = ''ICON'' then P_REGION.ATTRIBUTE_01 end;',
'    C_LABEL_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_02;',
'    C_LABEL_LINK CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_03;',
'    C_VALUE_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_04;',
'    C_VALUE_LINK CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_05;',
'    -- ABOVE, AROUND',
'    C_TEXT_POSITION VARCHAR2(6) := P_REGION.ATTRIBUTE_18;',
'    C_CHART_CSS_CLASSES CONSTANT VARCHAR2(32767) := P_REGION.ATTRIBUTE_06;',
'    C_IMAGE_URL CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_07;',
'    C_CSS_ICON_CLASS_NAME CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_08;',
'    C_INITIALS_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_09;',
'    -- ABSOLUTE, RELATIVE',
'    C_BAR_WIDTH_CALCULATION CONSTANT VARCHAR2(8) := P_REGION.ATTRIBUTE_16;',
'    C_DISPLAY CONSTANT VARCHAR2(19) := P_REGION.ATTRIBUTE_11;',
'    C_PREFIX_FOR_VALUE CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_12;',
'    C_POSTFIX_FOR_VALUE CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_13;',
'    C_MAXIMUM_ROWS CONSTANT NUMBER := P_REGION.ATTRIBUTE_14;',
'    C_MESSAGE_WHEN_NO_DATA_FOUND CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_20;',
'    ',
'    L_COLOR_COLUMN_NUMBER PLS_INTEGER;',
'    L_LABEL_COLUMN_NUMBER PLS_INTEGER;',
'    L_VALUE_COLUMN_NUMBER PLS_INTEGER;',
'    L_INITIALS_COLUMN_NUMBER PLS_INTEGER;',
'    ',
'    L_COLUMN_VALUE_LIST WWV_FLOW_PLUGIN_UTIL.T_COLUMN_VALUE_LIST2;',
'    ',
'    L_COLOR VARCHAR2(4000) := NULL;',
'    L_LABEL VARCHAR2(4000) := NULL;',
'    L_LABEL_LINK VARCHAR2(4000) := NULL;',
'    L_VALUE VARCHAR2(4000) := NULL;',
'    L_VALUE_LINK VARCHAR2(4000) := NULL;',
'    L_IMAGE_URL VARCHAR2(4000) := NULL;',
'    L_CSS_ICON_CLASS_NAME VARCHAR2(4000) := NULL;',
'    L_INITIALS VARCHAR2(4000) := NULL;',
'    L_MESSAGE_WHEN_NO_DATA_FOUND VARCHAR2(4000) := NULL;',
'',
'    L_CUSTOM_CHART_COLORS_TABLE WWV_FLOW_GLOBAL.VC_ARR2;',
'    L_CUSTOM_CHART_COLORS VARCHAR2(32767) := NULL;',
'BEGIN',
'    L_COLUMN_VALUE_LIST := WWV_FLOW_PLUGIN_UTIL.GET_DATA2(',
'        P_SQL_STATEMENT  => P_REGION.SOURCE,',
'        P_MIN_COLUMNS    => 1,',
'        P_MAX_COLUMNS    => NULL,',
'        P_COMPONENT_NAME => P_REGION.NAME,',
'        P_MAX_ROWS => C_MAXIMUM_ROWS',
'    );',
'',
'    L_COLOR_COLUMN_NUMBER := WWV_FLOW_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Color Column'',',
'        P_COLUMN_ALIAS      => C_COLOR_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => C_COLOR_SCHEME = ''COLUMN'',',
'        P_DATA_TYPE         => WWV_FLOW_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    L_LABEL_COLUMN_NUMBER := WWV_FLOW_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Label Column'',',
'        P_COLUMN_ALIAS      => C_LABEL_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => TRUE,',
'        P_DATA_TYPE         => WWV_FLOW_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    L_VALUE_COLUMN_NUMBER := WWV_FLOW_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Value Column'',',
'        P_COLUMN_ALIAS      => C_VALUE_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => TRUE,',
'        P_DATA_TYPE         => WWV_FLOW_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    if C_ICON_TYPE = ''INITIALS'' then',
'        L_INITIALS_COLUMN_NUMBER := WWV_FLOW_PLUGIN_UTIL.GET_COLUMN_NO (',
'            P_ATTRIBUTE_LABEL   => ''Initials Column'',',
'            P_COLUMN_ALIAS      => C_INITIALS_COLUMN,',
'            P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'            P_IS_REQUIRED       => true,',
'            P_DATA_TYPE         => WWV_FLOW_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'        );',
'    end if;',
'    -- Begin output as JSON',
'    sys.OWA_UTIL.MIME_HEADER(''application/json'', FALSE);',
'    sys.HTP.P(''Cache-Control: no-cache'');',
'    sys.HTP.P(''Pragma: no-cache'');',
'    sys.OWA_UTIL.HTTP_HEADER_CLOSE;',
'    ',
'    IF C_COLOR_SCHEME = ''CUSTOM'' THEN',
'        L_CUSTOM_CHART_COLORS_TABLE := HTMLDB_UTIL.STRING_TO_TABLE(CASE WHEN C_CUSTOM_CHART_COLORS IS NOT NULL THEN TRIM(BOTH '''''''' FROM WWV_FLOW_ESCAPE.JS_LITERAL(C_CUSTOM_CHART_COLORS)) END, '':'');',
'        L_CUSTOM_CHART_COLORS := ''"color_scheme":['';',
'        FOR I IN L_CUSTOM_CHART_COLORS_TABLE.FIRST .. L_CUSTOM_CHART_COLORS_TABLE.LAST LOOP',
'            IF I > 1 THEN',
'                L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||'','';',
'            END IF;',
'            L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||''"''||L_CUSTOM_CHART_COLORS_TABLE(I)||''"'';',
'        END LOOP;',
'        L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||''],'';',
'    END IF;',
'',
'    L_MESSAGE_WHEN_NO_DATA_FOUND := WWV_FLOW_ESCAPE.HTML_WHITELIST(',
'        WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                P_VALUE  => C_MESSAGE_WHEN_NO_DATA_FOUND,',
'                P_ESCAPE => FALSE',
'            )',
'        );',
'',
'    sys.HTP.PRN(',
'        ''{''||',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''chart_type'',',
'                C_CHART_TYPE,',
'                FALSE,',
'                TRUE',
'            )',
'    );',
'    sys.HTP.PRN(',
'        WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'            ''message_when_no_data_found'',',
'            L_MESSAGE_WHEN_NO_DATA_FOUND,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    sys.HTP.PRN(',
'        WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'            ''chart_css_class_names'',',
'            C_CHART_CSS_CLASSES,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    sys.HTP.PRN(',
'        WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'            ''icon_type'',',
'            C_ICON_TYPE,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    IF C_COLOR_SCHEME = ''CUSTOM'' THEN',
'        sys.HTP.PRN(',
'            L_CUSTOM_CHART_COLORS',
'        );',
'    ELSE',
'        sys.HTP.PRN(',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''color_scheme'',',
'                C_COLOR_SCHEME,',
'                TRUE,',
'                TRUE',
'            )',
'        );',
'    END IF;',
'    sys.HTP.PRN(',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''text_position'',',
'                C_TEXT_POSITION,',
'                FALSE,',
'                TRUE',
'            )||',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''bar_width_calculation'',',
'                C_BAR_WIDTH_CALCULATION,',
'                FALSE,',
'                TRUE',
'            )||',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''display'',',
'                C_DISPLAY,',
'                FALSE,',
'                TRUE',
'            )||',
'            CASE ',
'            	WHEN C_DISPLAY IN (''VALUE'') THEN',
'					WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'						''prefix_for_value'',',
'						C_PREFIX_FOR_VALUE,',
'						TRUE,',
'						TRUE',
'					)||',
'					WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'						''postfix_for_value'',',
'						C_POSTFIX_FOR_VALUE,',
'						TRUE,',
'						TRUE',
'					)',
'			END||',
'            ''"items":[''',
'    );',
'    ',
'    --FOR L_ROW_NUMBER IN L_COLUMN_VALUE_LIST(1).VALUE_LIST.FIRST .. L_COLUMN_VALUE_LIST(1).VALUE_LIST.LAST LOOP',
'    FOR L_ROW_NUMBER IN 1 .. L_COLUMN_VALUE_LIST(1).VALUE_LIST.COUNT LOOP',
'        BEGIN',
'            WWV_FLOW_PLUGIN_UTIL.SET_COMPONENT_VALUES (',
'                P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'                P_ROW_NUM => L_ROW_NUMBER ',
'            );',
'            ',
'            IF L_ROW_NUMBER > 1 THEN',
'            	sys.HTP.PRN('', '');',
'            END IF;',
'            ',
'            sys.HTP.PRN(''{'');',
'            ',
'            L_LABEL := WWV_FLOW_PLUGIN_UTIL.ESCAPE (',
'                WWV_FLOW_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                    P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_LABEL_COLUMN_NUMBER).DATA_TYPE,',
'                    P_VALUE => L_COLUMN_VALUE_LIST(L_LABEL_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'                ),',
'                P_REGION.ESCAPE_OUTPUT',
'            );',
'            sys.HTP.PRN(',
'            	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    ''label'',',
'                    L_LABEL,',
'                    FALSE',
'            	)',
'            );',
'            L_LABEL_LINK := ',
'                CASE ',
'                    WHEN C_LABEL_LINK IS NOT NULL THEN ',
'                        HTMLDB_UTIL.PREPARE_URL (',
'                            WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                P_VALUE  => C_LABEL_LINK,',
'                                P_ESCAPE => FALSE',
'                            )',
'                        )',
'                END;',
'            sys.HTP.PRN(',
'            	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    ''label_link'',',
'                    L_LABEL_LINK',
'                )',
'            );',
'            L_VALUE := WWV_FLOW_PLUGIN_UTIL.ESCAPE (',
'               WWV_FLOW_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                   P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_VALUE_COLUMN_NUMBER).DATA_TYPE,',
'                   P_VALUE => L_COLUMN_VALUE_LIST(L_VALUE_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'               ),',
'               P_REGION.ESCAPE_OUTPUT',
'            );',
'            sys.HTP.PRN(',
'            	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    ''value'',',
'                    L_VALUE,',
'                    FALSE,',
'                    C_VALUE_LINK IS NOT NULL OR L_COLOR_COLUMN_NUMBER IS NOT NULL OR C_CHART_TYPE = ''ICON''',
'                )',
'            );',
'            L_VALUE_LINK := ',
'                CASE ',
'                    WHEN C_VALUE_LINK IS NOT NULL THEN ',
'                        HTMLDB_UTIL.PREPARE_URL (',
'                            WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                P_VALUE  => C_VALUE_LINK,',
'                                P_ESCAPE => FALSE',
'                            )',
'                        )',
'                END;',
'             sys.HTP.PRN(',
'            	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    ''value_link'',',
'                    L_VALUE_LINK,',
'                    TRUE,',
'                    L_COLOR_COLUMN_NUMBER IS NOT NULL OR C_CHART_TYPE = ''ICON''',
'                )',
'            );',
'            IF L_COLOR_COLUMN_NUMBER IS NOT NULL THEN',
'                L_COLOR := WWV_FLOW_PLUGIN_UTIL.ESCAPE (',
'                   WWV_FLOW_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                       P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_COLOR_COLUMN_NUMBER).DATA_TYPE,',
'                       P_VALUE => L_COLUMN_VALUE_LIST(L_COLOR_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'                   ),',
'                   P_REGION.ESCAPE_OUTPUT',
'                );',
'                sys.HTP.PRN(',
'                    WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                        ''color'',',
'                        L_COLOR,',
'                        FALSE,',
'                        C_CHART_TYPE = ''ICON''',
'                    )',
'                );',
'            END IF;',
'            IF C_ICON_TYPE = ''IMAGE'' THEN',
'				L_IMAGE_URL := ',
'                    CASE ',
'                        WHEN C_IMAGE_URL IS NOT NULL THEN ',
'                            HTMLDB_UTIL.PREPARE_URL (',
'                                WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                    P_VALUE  => C_IMAGE_URL,',
'                                    P_ESCAPE => FALSE',
'                                )',
'                            )',
'                    END;',
'				sys.HTP.PRN(',
'					WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'						''image_url'',',
'						L_IMAGE_URL,',
'						FALSE,',
'						FALSE',
'					)',
'				);',
'			ELSIF C_ICON_TYPE = ''ICON'' THEN',
'				L_CSS_ICON_CLASS_NAME := WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                    P_VALUE  => C_CSS_ICON_CLASS_NAME,',
'                    P_ESCAPE => TRUE',
'                );',
'				sys.HTP.PRN(',
'                	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'						''icon_css_class_name'',',
'						L_CSS_ICON_CLASS_NAME,',
'						FALSE,',
'						FALSE',
'					)',
'				);',
'			ELSIF C_ICON_TYPE = ''INITIALS'' THEN',
'				L_INITIALS := WWV_FLOW_PLUGIN_UTIL.ESCAPE (',
'					WWV_FLOW_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'						P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_INITIALS_COLUMN_NUMBER).DATA_TYPE,',
'						P_VALUE => L_COLUMN_VALUE_LIST(L_INITIALS_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'					),',
'					P_REGION.ESCAPE_OUTPUT',
'				);',
'				sys.HTP.PRN(',
'                	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    	''initials'',',
'	                    L_INITIALS,',
'	                    FALSE,',
'	                    FALSE',
'    	            )',
'    	        );',
'            END IF;',
'            ',
'			sys.HTP.PRN(''}'');',
'            ',
'            WWV_FLOW_PLUGIN_UTIL.CLEAR_COMPONENT_VALUES;',
'        EXCEPTION',
'            WHEN OTHERS THEN',
'                WWV_FLOW_PLUGIN_UTIL.CLEAR_COMPONENT_VALUES;',
'                RAISE;',
'        END;',
'    END LOOP;',
'    sys.HTP.PRN(',
'            '']''||',
'        ''}''',
'    );',
'    ',
'    RETURN NULL;',
'END AJAX;'))
,p_api_version=>1
,p_render_function=>'RENDER'
,p_ajax_function=>'AJAX'
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_reference_id=>5610141522737396215
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>This plugin draws horizontal bar charts containing labels, values and even icons</p>'
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702334718872248058)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Icon Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INITIALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702342810423248065)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>Image</strong>: Adds an image HTML element on the left side of the chart.</li>',
'    <li><strong>CSS Icon</strong>: Unlike the &quot;Image&quot; icon, instead of displaying an image HTML element, it displays an icon with the given CSS class.</li>',
'    <li><strong>Initials</strong>: Opposed to both, the &quot;Image&quot; and &quot;CSS Icon&quot; icons, this one displays a colored circle containing the given initials.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702335171470248059)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702334718872248058)
,p_display_sequence=>10
,p_display_value=>'Image'
,p_return_value=>'IMAGE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702335675058248060)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702334718872248058)
,p_display_sequence=>20
,p_display_value=>'CSS Icon'
,p_return_value=>'ICON'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702336137978248060)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702334718872248058)
,p_display_sequence=>30
,p_display_value=>'Initials'
,p_return_value=>'INITIALS'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702336688801248060)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'attribute_02'
,p_prompt=>'Label Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'<p>A query column from which the label to be displayed is given.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702337000944248061)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'attribute_03'
,p_prompt=>'Label Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>A URL to be opened whenever the label is clicked. This attribute supports substitution strings.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702337476819248061)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'attribute_04'
,p_prompt=>'Value Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'<p>A query column from which the label to be displayed is given. Notice that this value is not displayed on the chart items when the chart has been configured to display the bar width percentage instead.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702337891068248061)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'attribute_05'
,p_prompt=>'Value Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>A URL to be opened whenever the displayed value is clicked. This attribute supports substitution strings.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702338214151248062)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_static_id=>'attribute_06'
,p_prompt=>'Chart CSS Class Names'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'<p>CSS class names to be added to the root element of the chart separated with spaces.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702338638281248062)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>13
,p_static_id=>'attribute_07'
,p_prompt=>'Image URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702334718872248058)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_help_text=>'<p>The Image URL to be displayed as the chart icon. This attribute supports Substitution strings referring to som query column like in <strong>&amp;IMAGE_URL.</strong> which would reference the <strong>IMAGE_URL</strong> column value for each of the '
||'bars presented on the char. Notice that substitutions with no value will be replaced with an empty string.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702339094280248062)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>12
,p_static_id=>'attribute_08'
,p_prompt=>'CSS Icon Class Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702334718872248058)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON'
,p_help_text=>'<p>The Icon CSS Class Name.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702339499744248062)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>14
,p_static_id=>'attribute_09'
,p_prompt=>'Initials Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702334718872248058)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'INITIALS'
,p_help_text=>'<p>A query column from which initials to be displayed as an icon are given.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702339807094248063)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>7
,p_static_id=>'attribute_10'
,p_prompt=>'Custom Chart Colors'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702345651994248067)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'CUSTOM'
,p_help_text=>'<p>A list of CSS supported colors separated by colons.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702340226884248063)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_static_id=>'attribute_11'
,p_prompt=>'Display'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Displays either the item value or the calculated bar width on the right most text in the chart item.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702340619514248063)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702340226884248063)
,p_display_sequence=>10
,p_display_value=>'Value'
,p_return_value=>'VALUE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702341146963248064)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702340226884248063)
,p_display_sequence=>20
,p_display_value=>'Bar Width'
,p_return_value=>'BAR_WIDTH'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702341650689248064)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_static_id=>'attribute_12'
,p_prompt=>'Prefix for Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702340226884248063)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE'
,p_help_text=>'<p>When the value is displayed on the right most side of the chart item. The value of this attribute is prepended to it.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702342001349248064)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_static_id=>'attribute_13'
,p_prompt=>'Postfix for Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702340226884248063)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE'
,p_help_text=>'<p>When the value is displayed on the right most side of the chart item. The value of this attribute is appended to it.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702342462654248065)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_static_id=>'attribute_14'
,p_prompt=>'Maximum Rows'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_help_text=>'<p>The maximum number of items to be displayed inside the region. Notice bar width calculations are made based on the number of items displayed.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702342810423248065)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>4
,p_static_id=>'attribute_15'
,p_prompt=>'Chart Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines how the chart will be displayed. There are two types of chart: </p>',
'<ul>',
'    <li><strong>Icon Chart</strong>: Displays bars with the label and value above and add an icon on the left.</li>',
'    <li><strong>Text Chart</strong>: Displays bars with the label and value either above or inline with the bar.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702343211589248065)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702342810423248065)
,p_display_sequence=>10
,p_display_value=>'Icon Chart'
,p_return_value=>'ICON'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702343724597248066)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702342810423248065)
,p_display_sequence=>20
,p_display_value=>'Text Chart'
,p_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702344281829248066)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>105
,p_static_id=>'attribute_16'
,p_prompt=>'Bar Width Calculation'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ABSOLUTE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Bar widths for each one of the chart items can be calculated in two ways:</p>',
'<ul>',
'    <li><strong>Absolute</strong>: 100% bar width is represented by the maximum value on the displayed chart items.</li>',
'    <li><strong>Relative</strong>: 100% bar width is represented by the sum of the values of all the displayed chart items.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702344685135248067)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702344281829248066)
,p_display_sequence=>10
,p_display_value=>'Absolute'
,p_return_value=>'ABSOLUTE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702345182204248067)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702344281829248066)
,p_display_sequence=>20
,p_display_value=>'Relative'
,p_return_value=>'RELATIVE'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702345651994248067)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>6
,p_static_id=>'attribute_17'
,p_prompt=>'Color Scheme'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MODERN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The colors to be used in the chart bars. There are two special types of configuration: </p>',
'<ul>',
'    <li><strong>Custom</strong>: Provides a text box to receive a colon separated list of css supported colors.</li>',
'</ul>',
'<ul>',
'    <li><strong>Query Column</strong>: Provides a select list with the query columns which expects a css valid color.</li>',
'</ul>',
''))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702346097919248068)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702345651994248067)
,p_display_sequence=>5
,p_display_value=>'Default'
,p_return_value=>'DEFAULT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702346538929248068)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702345651994248067)
,p_display_sequence=>10
,p_display_value=>'Modern'
,p_return_value=>'MODERN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702347083560248069)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702345651994248067)
,p_display_sequence=>20
,p_display_value=>'Modern 2'
,p_return_value=>'MODERN_2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702347505297248069)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702345651994248067)
,p_display_sequence=>30
,p_display_value=>'Solar'
,p_return_value=>'SOLAR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702348056927248069)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702345651994248067)
,p_display_sequence=>40
,p_display_value=>'Metro'
,p_return_value=>'METRO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702348548765248070)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702345651994248067)
,p_display_sequence=>50
,p_display_value=>'Custom'
,p_return_value=>'CUSTOM'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702349044832248070)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702345651994248067)
,p_display_sequence=>60
,p_display_value=>'Query Column'
,p_return_value=>'COLUMN'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702349545275248070)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>55
,p_static_id=>'attribute_18'
,p_prompt=>'Text Position'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AROUND'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702342810423248065)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'TEXT'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When displaying a text chart, two options are available for displaying the label and value texts:</p>',
'<ul>',
'    <li><strong>Above the bar</strong>: The label and value texts are displayed above the bar at the left and right most sides of it respectively.</li>',
'    <li><strong>Inline with the bar</strong>: The label, the bar and the value are displayed in one line on that order.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702349966426248071)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702349545275248070)
,p_display_sequence=>10
,p_display_value=>'Above the bar'
,p_return_value=>'ABOVE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702350427006248071)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702349545275248070)
,p_display_sequence=>20
,p_display_value=>'Inline with the bar'
,p_return_value=>'AROUND'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702350916802248071)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>8
,p_static_id=>'attribute_19'
,p_prompt=>'Chart Colors Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702345651994248067)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'COLUMN'
,p_help_text=>'<p>A query column from which CSS supported colors are given.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702351321939248072)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_static_id=>'attribute_20'
,p_prompt=>'Message When No Data Found'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'No data found.'
,p_is_translatable=>true
,p_help_text=>'<p>Message to be displayed when no data was found.</p>'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(1702355088636248078)
,p_plugin_id=>wwv_flow_imp.id(1591049479124636231)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_wizard_selection
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2180265113361711031)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.WIZARD_SELECTION'
,p_display_name=>'Wizard Selection'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.WIZARD_SELECTION'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_wizard_selection'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_wizard_selection'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:SOURCE:ELEMENT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_reference_id=>3260301366184169092
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2180265308752711037)
,p_plugin_id=>wwv_flow_imp.id(2180265113361711031)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2180265799725711042)
,p_plugin_attribute_id=>wwv_flow_imp.id(2180265308752711037)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'S'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2180266212595711047)
,p_plugin_attribute_id=>wwv_flow_imp.id(2180265308752711037)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'M'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2180266731458711048)
,p_plugin_attribute_id=>wwv_flow_imp.id(2180265308752711037)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'L'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2180267217007711048)
,p_plugin_id=>wwv_flow_imp.id(2180265113361711031)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Submit Page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Select whether or not to submit the page when making a selection'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845155782990834528)
,p_plugin_id=>wwv_flow_imp.id(2180265113361711031)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2448108135531494687)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Add Check All Checkbox'
,p_category=>'MISC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The "Add Check All Checkbox" dynamic action turns a column heading containing the #CHECK_ALL_CHECKBOX# string into an accessible check all style checkbox, that will check and uncheck all the checkboxes in its corresponding column.<p>',
'<p>',
'To use this plug-in, please ensure the following attributes are set:',
'<ol>',
'<li>In the report column, defined ''#CHECK_ALL_CHECKBOX#'' as the Heading value.</li>',
'<li>For the Dynamic Action When attribute, select the report region containing the column.</li>',
'<li>Define the Dynamic Action to fire ''After Refresh'', and the Action to ''Fire on Page Load''. (Both will default appropriately if the Dynamic Action is created by selecting the region in the ''Rendering'' section of Page Designer and creating the Dynam'
||'ic Action from there.</li>',
'<li>This will not handle the accessibility of the checkboxes rendered on each row, this must be done separately in the region source. (See 4000:656 ''Regions'' region for an example).</li>',
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_imp_page.create_page(
 p_id=>0
,p_name=>'Page Zero'
,p_alias=>'PAGE-ZERO'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215451130329541858)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'14'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30352322089771992)
,p_plug_name=>'JS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>4
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'    function submitenter(myfield,e)',
'    {',
'        var keycode;',
'        if (window.event) keycode = window.event.keyCode;',
'        else if (e) keycode = e.which;',
'        else return true;',
'',
'        if (keycode == 13)',
'        {',
'            redirect(''f?p=&APP_ID.:8000:&SESSION.:::RIR:IR_ROWFILTER:''+$v(''P0_SEARCH''));',
'            return false;',
'        }',
'        else',
'            return true;',
'    }',
'    ',
'    function initSearch(searchField) ',
'    {',
'        searchField.value = "";',
'        searchField.style.color = "#000000";',
'    }',
'//-->',
'</script>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388539809791523187)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-workspace-admin'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'68'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388540086737523188)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_imp.id(388539809791523187)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(108685019043074901)
,p_plug_name=>'Navigation Tabs Landmark'
,p_parent_plug_id=>wwv_flow_imp.id(388540086737523188)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'&PRODUCT_NAME.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1582031051259050)
,p_plug_name=>'Application Tabs'
,p_region_name=>'a_Header_menu'
,p_parent_plug_id=>wwv_flow_imp.id(108685019043074901)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>60
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(719024906222154750)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(388535020971474291)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388540217286523188)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_imp.id(388540086737523188)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(',
'    ''<a href="'' ||',
'    wwv_flow_utilities.prepare_url(',
'        ''f?p=4100:1:'' || :APP_SESSION || ''::'' || :DEBUG ) ||',
'    ''" class="a-Header-logo"'' ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''title'',',
'        p_value => wwv_flow_lang.system_message( ''HOME_NAV'' ) ) ||',
'    ''><span role="img" aria-labelledby="labelApexLogo" class="a-Header-apexLogo"><span class="u-vh" id="labelApexLogo">'' ||',
'    wwv_flow_escape.html(',
'        wwv_flow_lang.system_message( ''HOME_NAV'' ) ) ||',
'    ''</span></span></a>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Logo'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388540417683523188)
,p_plug_name=>'APEX 5 - Home Link'
,p_parent_plug_id=>wwv_flow_imp.id(388540086737523188)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388540652992523188)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_imp.id(388539809791523187)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Navigation Bar'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388540854983523188)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_imp.id(388540652992523188)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2401031236991807)
,p_plug_name=>'APEX 5 - Header Extension Menu'
,p_region_name=>'extensionsMenu'
,p_parent_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_location=>null
,p_list_id=>wwv_flow_imp.id(4801328176356944)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(388535333575474292)
,p_translate_title=>'N'
,p_plug_required_role=>wwv_flow_imp.id(4000814836956767)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388566674203594195)
,p_plug_name=>'APEX 5 - Header Administration Menu'
,p_region_name=>'adminMenu'
,p_parent_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(697508149859311566)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(388535333575474292)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486772128588301731)
,p_plug_name=>'APEX 5 - Header Help Menu'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(697513111062314247)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(388535333575474292)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388541051943523188)
,p_plug_name=>'APEX 5 - Header Account'
,p_parent_plug_id=>wwv_flow_imp.id(388540652992523188)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.account_mega_menu (',
'    p_username          => :APP_USER,',
'    p_workspace_id      => :WORKSPACE_ID,',
'    p_session           => :APP_SESSION,',
'    p_logout_url        => :LOGOUT_URL',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Account'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(642566440163156401)
,p_plug_name=>'APEX 5 - Search'
,p_parent_plug_id=>wwv_flow_imp.id(388540652992523188)
,p_region_css_classes=>'a-Header-search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-SearchBox a-SearchBox--noGoButton a-SearchBox--autoExpand a-SearchBox--fill">'');',
'sys.htp.p(''  <div class="a-SearchBox-field">'');',
'sys.htp.p(''    <span class="a-SearchBox-icon"><span class="a-Icon icon-search"></span></span>'');',
'sys.htp.p(''    <label for="P0_SEARCH" class="visuallyhidden">''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.SEARCH'')||''</label>'');',
'sys.htp.p(''    <input type="text" class="a-SearchBox-input" id="P0_SEARCH" placeholder="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.SEARCH.USERS'')||''">'');',
'sys.htp.p(''  </div>'');',
'sys.htp.p(''</div>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388541233076523188)
,p_plug_name=>'APEX 5 - Control Bar'
,p_region_css_classes=>'a-ControlBar apex-workspace-admin'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'1,68'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388541479862523188)
,p_plug_name=>'APEX 5 - Control Bar Left'
,p_parent_plug_id=>wwv_flow_imp.id(388541233076523188)
,p_region_css_classes=>'a-ControlBar-col a-ControlBar-col--noPadding'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388567311021599596)
,p_plug_name=>'APEX 5 - Breadcrumb'
,p_parent_plug_id=>wwv_flow_imp.id(388541479862523188)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_imp.id(4090422833267509)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(388538606549481005)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'1'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388541658700523189)
,p_plug_name=>'APEX 5 - Control Bar Right'
,p_parent_plug_id=>wwv_flow_imp.id(388541233076523188)
,p_region_css_classes=>'a-ControlBar-col'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>100
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(388546581076568901)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(388540417683523188)
,p_button_name=>'Home'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Home'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4100:1:&APP_SESSION.'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-home'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(735034227876168737)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_button_name=>'UPGRADE_AVAILABLE'
,p_button_static_id=>'header-upgradeAvailable'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Upgrade Available'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_AVAILABLE:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-utilities-build-interval'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(735034183175168736)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_button_name=>'UPGRADE_IN_PROGRESS'
,p_button_static_id=>'header-upgradeInProgress'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Upgrading'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_IN_PROGRESS:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''RUNNING'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-ig-refresh u-Animate-spin'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(233600835088079607)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_button_name=>'SPOTLIGHT'
,p_button_static_id=>'header-spotlightSearch'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_image_alt=>'Search'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-search'
,p_button_cattributes=>'data-action="spotlight-search" data-no-update="true"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2401168651991808)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_button_name=>'Extensions'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388537948307476852)
,p_button_image_alt=>'Extensions'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-extension'
,p_button_cattributes=>'data-menu="extensionsMenu_menu"'
,p_security_scheme=>wwv_flow_imp.id(4000814836956767)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(388546746057568903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_button_name=>'Administration'
,p_button_static_id=>'header-adminMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388537948307476852)
,p_button_image_alt=>'Administration'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink a-Button--activeTab tab-admin'
,p_icon_css_classes=>'icon-gears-alt'
,p_button_cattributes=>'data-menu="adminMenu_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(388546906930568903)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_button_name=>'Feedback'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Feedback'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4750:11001:&SESSION.::&DEBUG.:RP,11001:P11001_APPLICATION_ID,P11001_PAGE_ID:&APP_ID.,&APP_PAGE_ID.:'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-comments'
,p_required_patch=>wwv_flow_imp.id(693461267865622287)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(388547181746568903)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(388540854983523188)
,p_button_name=>'Help'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388537948307476852)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_imp_page.create_page(
 p_id=>1
,p_name=>'Administration'
,p_alias=>'ADMINISTRATION'
,p_step_title=>'Administration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_hm.htm'
,p_page_component_map=>'13'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27257417764751845)
,p_plug_name=>'Tasks'
,p_region_css_classes=>'a-Region--stacked a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(166211911060758908)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29223409612811479)
,p_plug_name=>'Workspace Message'
,p_region_css_classes=>'a-Alert--inline'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p>'');',
'wwv_flow_4000_ui.show_workspace_notification (',
'   p_workspace_id       => :flow_security_group_id,',
'   p_session            => :app_session);',
'sys.htp.p(''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Admins always see the region so they can edit the announcement, while',
'-- Developers see the region only when announcement has been defined.',
'wwv_flow_4000_ui.workspace_notification_exists(',
'    p_workspace_id => :flow_security_group_id',
')',
'or wwv_flow_authorization_api.is_authorized(''Flow: ADMIN'')'))
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29444404444314439)
,p_plug_name=>'System Message'
,p_region_css_classes=>'a-SystemMessage a-Region--noTopBorder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_source=>'wwv_flow_4050_ui.show_system_message(p_app_session => :APP_SESSION);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_4050_ui.system_message_exists()'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30612511381129844)
,p_plug_name=>'Page Preferences'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_required_role=>wwv_flow_imp.id(12518728403445471)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(42997223242377527)
,p_name=>'Users'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P1b */',
'   count(*) user_count,',
'   sum(decode(developer_type,null,1,0)) end_user_count,',
'   sum(decode(is_developer,''Y'',1,0)) developer_count,',
'   sum(decode(developer_type,''ADMIN'',1,0)) workspace_admin_count,',
'   sum(decode(greatest(u.CREATION_DATE,sysdate - 1),sysdate -1,0,1)) created_last_24_hours,',
'   sum(decode(greatest(u.CREATION_DATE,sysdate - 7),sysdate -7,0,1)) created_last_week',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer,',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              ''BASIC_DEV''',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              ''ADMIN''',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              ''DEVELOPER''',
'           else',
'              ''UNKNOWN'' ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id'))
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(42997223242377527)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(42997508990377534)
,p_query_column_id=>1
,p_column_alias=>'USER_COUNT'
,p_column_display_sequence=>1
,p_column_heading=>'Users'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(42997608538377535)
,p_query_column_id=>2
,p_column_alias=>'END_USER_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'End Users'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(42997711215377535)
,p_query_column_id=>3
,p_column_alias=>'DEVELOPER_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Application Developers'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(42997926989377535)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_ADMIN_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace Administrators'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46347512034168203)
,p_query_column_id=>5
,p_column_alias=>'CREATED_LAST_24_HOURS'
,p_column_display_sequence=>5
,p_column_heading=>'Created Last 24 Hours'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46347722423171255)
,p_query_column_id=>6
,p_column_alias=>'CREATED_LAST_WEEK'
,p_column_display_sequence=>6
,p_column_heading=>'Created Last Week'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(43023106337252491)
,p_name=>'Activity'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P1c */ ',
'  page_events,',
'  median_elap,',
'  distinct_users,',
'  distinct_sessions,',
'  errors_raised,',
'  distinct_applications,',
'  wwv_flow_4000_ui.get_timeframe(:P1_TIME) reporting_timeframe',
'from',
'(',
'select ',
'    count(*) page_events,',
'    median(elap) median_elap,',
'    count(distinct(userid)) distinct_users,',
'    count(distinct(flow_id)) distinct_applications,',
'    count(distinct(session_id)) distinct_sessions,',
'    sum(decode(sqlerrm,null,0,1)) errors_raised',
'from (',
'select /*+ INDEX(wwv_flow_activity_log1$ WWV_FLOW_ACTIVITY_LOG1$_IDX1) */',
'    elap, userid, flow_id, session_id, sqlerrm',
'  from wwv_flow_activity_log1$',
'where security_group_id = :flow_security_group_id and',
'time_stamp > sysdate - :P1_TIME',
'union all',
'select /*+ INDEX(wwv_flow_activity_log2$ WWV_FLOW_ACTIVITY_LOG2$_IDX1) */',
'    elap, userid, flow_id, session_id, sqlerrm',
'  from wwv_flow_activity_log2$',
'where security_group_id = :flow_security_group_id and',
'time_stamp > sysdate - :P1_TIME',
')',
') r'))
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(43023106337252491)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(43024030925259558)
,p_query_column_id=>1
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_column_heading=>'Page Events'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(43024106979259558)
,p_query_column_id=>2
,p_column_alias=>'MEDIAN_ELAP'
,p_column_display_sequence=>3
,p_column_heading=>'Median Page Time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(43024307318259558)
,p_query_column_id=>3
,p_column_alias=>'DISTINCT_USERS'
,p_column_display_sequence=>5
,p_column_heading=>'Distinct Users'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(43024526001259558)
,p_query_column_id=>4
,p_column_alias=>'DISTINCT_SESSIONS'
,p_column_display_sequence=>6
,p_column_heading=>'Distinct Sessions'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(43024622128259559)
,p_query_column_id=>5
,p_column_alias=>'ERRORS_RAISED'
,p_column_display_sequence=>7
,p_column_heading=>'Errors'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RP,RIR:IRNN_SQLERRM:'
,p_column_linktext=>'#ERRORS_RAISED#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(435137310696295572)
,p_query_column_id=>6
,p_column_alias=>'DISTINCT_APPLICATIONS'
,p_column_display_sequence=>4
,p_column_heading=>'Distinct Applications'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(435137129565263152)
,p_query_column_id=>7
,p_column_alias=>'REPORTING_TIMEFRAME'
,p_column_display_sequence=>1
,p_column_heading=>'Reporting Timeframe'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.:59::'
,p_column_linktext=>'#REPORTING_TIMEFRAME#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46082728200564532)
,p_plug_name=>'Manage Workspace &COMPANY.'
,p_region_sub_css_classes=>'workspace-admin'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(46082227723554970)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(717846892308122004)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46088231420697995)
,p_name=>'Service'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P1a */',
'    :company workspace_name,',
'(',
'select count(*)',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
') as applications,',
'(',
'select count(*)',
'  from wwv_flow_files f, wwv_flow_fnd_user u',
' where u.security_group_id = :flow_security_group_id',
'   and u.user_name = :APP_USER',
'   and f.file_type = ''SCRIPT''',
') as sql_scripts,',
'(',
'select count(*)',
'  from wwv_flow_company_schemas',
' where security_group_id = :flow_security_group_id',
') as schemas,',
'--',
'(select sum(open_requests) open_reqests',
'from',
'(',
'select count(*) open_requests',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id and',
'      project_status = ''REQUESTED''',
'union all',
'select count(*) open_requests',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      m.request_status = ''REQUESTED''',
') q ) open_requests',
'from dual'))
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(46088231420697995)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46089516576722100)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46345109003448326)
,p_query_column_id=>2
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47468531354816438)
,p_query_column_id=>3
,p_column_alias=>'SQL_SCRIPTS'
,p_column_display_sequence=>5
,p_column_heading=>'SQL Scripts'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47468626466816438)
,p_query_column_id=>4
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>6
,p_column_heading=>'Schemas'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47469028977844130)
,p_query_column_id=>5
,p_column_alias=>'OPEN_REQUESTS'
,p_column_display_sequence=>7
,p_column_heading=>'Open Requests'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48537315419306557)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Workspace Administration enables you to manage your account. Depending on your privileges, you can monitor and administer this workspace.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168483501399376268)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46082728200564532)
,p_button_name=>'CHANGE_PW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(297663202145957383)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Change My Password'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:RP,58:::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32641004454198704)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(29223409612811479)
,p_button_name=>'EDIT_ANNOUNCEMENT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Define Workspace Message'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:35::'
,p_icon_css_classes=>'icon-edit'
,p_button_cattributes=>'alt="&EDIT." title="&EDIT." height="16" width="16"'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30527919163801184)
,p_name=>'P1_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30612511381129844)
,p_source=>'select to_number(''0.125'',''9.999'',''NLS_NUMERIC_CHARACTERS='''',.'''''') from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Display real time statistics for this amount of time.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30192404188098919)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_imp_page.create_page(
 p_id=>2
,p_name=>'Schema Tablespace Utilization'
,p_alias=>'SCHEMA-TABLESPACE-UTILIZATION'
,p_step_title=>'Schema Tablespace Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215667724760013351)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5783706478780036)
,p_name=>'Schema to Tablespace Mappings'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>54
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P2a */ a.schema, u.default_tablespace',
'  from wwv_flow_company_schemas a, sys.dba_users u',
' where a.schema            = u.username',
'   and a.schema            = :p2_schema',
'   and a.security_group_id = wwv_flow.get_sgid',
'order by 1'))
,p_display_when_condition=>'P2_SCHEMA'
,p_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(5783706478780036)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5784013471780043)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1475461198068625316)
,p_query_column_id=>2
,p_column_alias=>'DEFAULT_TABLESPACE'
,p_column_display_sequence=>2
,p_column_heading=>'Default tablespace'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5784712365781713)
,p_name=>'Free Space by Tablespace (Megabytes)'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>64
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with ts as (',
'    select distinct tablespace_name',
'      from sys.dba_segments',
'     where owner = :P2_SCHEMA ),',
'ddf as (',
'    select f.file_id,',
'           f.tablespace_name,',
'           f.file_name,',
'           decode (f.autoextensible,',
'            ''YES'', greatest (f.bytes, f.maxbytes), f.bytes) df_size,',
'           decode (f.autoextensible,',
'            ''YES'', case',
'                       when (f.maxbytes > f.bytes)',
'                       then (f.maxbytes - f.bytes)',
'                       else 0',
'                   end, 0 ) growth',
'      from sys.dba_data_files f,',
'           ts',
'     where f.tablespace_name = ts.tablespace_name )',
'select ddf.tablespace_name name,',
'       round ((sum (nvl (freebytes, 0)) + sum (growth))/1024/1024 ) free',
'  from ddf,',
'       (select d.file_id, sum (d.bytes) freebytes',
'          from sys.dba_free_space d,',
'               ts',
'         where d.tablespace_name = ts.tablespace_name',
'         group by file_id) dfs',
' where ddf.file_id = dfs.file_id(+)',
' group by ddf.tablespace_name        '))
,p_display_when_condition=>'P2_SCHEMA'
,p_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(5784712365781713)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5904028247808259)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5904325214808260)
,p_query_column_id=>2
,p_column_alias=>'FREE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5871829174600336)
,p_plug_name=>'Schema Details'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Each workspace has access to one or more database schemas.  This page lists details about each schema.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5873031776638945)
,p_name=>'Workspace Schemas'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P2c */ schema',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11670410466357416)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 07-APR-2004 15:37:37'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5873328941638951)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_column_heading=>'SCHEMA'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::P2_SCHEMA:#SCHEMA#'
,p_column_linktext=>'#SCHEMA#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6624822428048770)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(6621926453040443)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_platform.get_preference( ''SERVICE_REQUESTS_ENABLED'' ) = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(182271012856475081)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>44
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(182440902719115584)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(182271012856475081)
,p_button_name=>'P2_GO'
,p_button_static_id=>'P2_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(182441124506115587)
,p_branch_action=>'f?p=&FLOW_ID.:2:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5875420478645168)
,p_name=>'P2_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(182271012856475081)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(a.schema) d, a.schema r',
'  from wwv_flow_company_schemas a',
' where a.security_group_id = (select wwv_flow.get_sgid from dual)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identify a schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(432753604790034958)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P2_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_process_when=>'P2_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>432753604790034958
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_imp_page.create_page(
 p_id=>3
,p_name=>'Edit Profile'
,p_alias=>'EDIT-PROFILE'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Profile'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'550'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/aadm_users.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(485918486401411525)
,p_plug_name=>'Profile Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 19-FEB-2000 22:09:25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1142730838556397048)
,p_plug_name=>'Profile Photo'
,p_parent_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_header=>'Your profile photo personalizes your activity by showing up in the Top Users list. Add, change, or remove your photo.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1142730993807397049)
,p_plug_name=>'<a name="pwd"></a>&F4350_PASSWORD_REGION_TITLE.'
,p_region_name=>'PWD'
,p_parent_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_header=>'If you wish to change your password, enter a new password. Otherwise, leave the password fields empty and the current password will not be changed.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(485930812856411538)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P3_WEB_PASSWORD := null;',
':F4350_P3_USER_PASSWORD := null;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(485932134912411539)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(534309773003323583)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1142730838556397048)
,p_button_name=>'P3_DELETE'
,p_button_static_id=>'P3_DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Remove Current Photo'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user',
' where user_id = :F4350_P3_USER_ID',
'   and sys.dbms_lob.getlength( profile_image ) > 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(485932789329411544)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(485932134912411539)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4350_P3_USER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(485932354419411539)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(485932134912411539)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485918673324411527)
,p_name=>'F4350_P3_USER_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_use_cache_before_default=>'NO'
,p_source=>'USER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485918831775411527)
,p_name=>'F4350_P3_COMPANY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'a-Form-field a-Form-field--readOnly'
,p_tag_attributes=>' '
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies which workspace this user belongs to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485919355052411527)
,p_name=>'F4350_P3_USER_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Username'
,p_source=>'USER_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'a-Form-field a-Form-field--readOnly'
,p_tag_attributes=>' '
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the username used to log in to the system. Usernames have these restrictions:</p>',
'<ul>',
'    <li>maximum length of 100 characters</li>',
'    <li>no spaces</li>',
'    <li>only these special characters are permitted: @ and periods (.)</li>',
'</ul>',
'<p>The username may also be used to reference user activity using the monitor applications. The bind variable <code>:APP_USER</code> returns the value of the current user when building applications.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485919804537411527)
,p_name=>'F4350_P3_EMAIL_ADDRESS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Email Address'
,p_source=>'EMAIL_ADDRESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="email"'
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_security_scheme=>'!'||wwv_flow_imp.id(6738625560859071)
,p_help_text=>'Specifies the email address for use with general correspondence, notifications about resetting passwords, and so on.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485920363918411527)
,p_name=>'F4350_P3_ORG_EMAIL_ADDRESS'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_use_cache_before_default=>'NO'
,p_source=>'&F4350_P3_EMAIL_ADDRESS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485921331431411529)
,p_name=>'F4350_P3_FIRST_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_use_cache_before_default=>'NO'
,p_prompt=>'First Name'
,p_source=>'FIRST_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="given-name"'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the first or given name to further identify the user. This optional field is used for informational purposes only.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485921884101411529)
,p_name=>'F4350_P3_LAST_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Last Name'
,p_source=>'LAST_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="family-name"'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the last or family name to further identify the user. This optional field is used for informational purposes only.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485933179379411545)
,p_name=>'F4350_P3_WEB_PASSWORD'
,p_item_sequence=>96
,p_item_plug_id=>wwv_flow_imp.id(1142730993807397049)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Enter New Password'
,p_placeholder=>'new password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The password used to log in to the system. Do not enter a password unless you want to change the current password.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485933686391411545)
,p_name=>'F4350_P3_USER_PASSWORD'
,p_item_sequence=>106
,p_item_plug_id=>wwv_flow_imp.id(1142730993807397049)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Confirm Password'
,p_placeholder=>'confirm password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password again. Do not enter a password unless you want to change the current password.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485934109258411546)
,p_name=>'P3_UPDATE_PW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485934575979411546)
,p_name=>'P3_FIRST_PWD_USE_OCCURRED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(485918486401411525)
,p_use_cache_before_default=>'NO'
,p_source=>'FIRST_PASSWORD_USE_OCCURRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(486809306138103564)
,p_name=>'P3_PROFILE_IMAGE'
,p_item_sequence=>86
,p_item_plug_id=>wwv_flow_imp.id(1142730838556397048)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Photo'
,p_source=>'PROFILE_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Select a photo to further identify the user. This optional field is used for informational purposes only. To show an image without any distortion, ideally the image size should be  width should be 32x32. You can replace your existing photo by uploadi'
||'ng a new photo or by clicking the <strong>Delete Current Photo</strong> button. Click the browse button to upload a photo from your hard drive. '
,p_attribute_01=>'DB_COLUMN'
,p_attribute_02=>'PROFILE_MIMETYPE'
,p_attribute_03=>'PROFILE_FILENAME'
,p_attribute_04=>'PROFILE_CHARSET'
,p_attribute_05=>'PROFILE_LAST_UPDATE'
,p_attribute_06=>'N'
,p_attribute_11=>'image/*'
,p_attribute_12=>'DROPZONE_INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(538621678004238307)
,p_name=>'P3_CURRENT_PHOTO'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_imp.id(1142730838556397048)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Photo'
,p_source=>'PROFILE_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_IMAGE'
,p_tag_css_classes=>'u-circlePhoto'
,p_tag_attributes=>'height="64" width="64" alt="Profile image for &F4350_P3_USER_NAME."'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user',
' where user_id = :F4350_P3_USER_ID',
'   and sys.dbms_lob.getlength( profile_image ) > 0'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Displays the photo currently used to identify the user. You can replace your existing photo by uploading a new photo or by clicking the <strong>Remove Current Photo</strong> button.'
,p_attribute_01=>'DB_COLUMN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1000725807551503640)
,p_name=>'F4350_P3_CURRENT_PASSWORD'
,p_item_sequence=>86
,p_item_plug_id=>wwv_flow_imp.id(1142730993807397049)
,p_prompt=>'Enter Current Password'
,p_placeholder=>'current password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="current-password"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
' * require current password if',
' * - builder requires password (e.g. APEX auth - not SSO auth)',
' * - user password has already been changed',
' */',
' ',
'not wwv_flow_authentication_dev.is_builder_password_required (',
'        p_developer_yn => ''N'' )',
' or :P3_FIRST_PWD_USE_OCCURRED=''Y'''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter your current password. Do not enter a password unless you want to change the current password.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1252825859703086130)
,p_name=>'P3_CURRENT_PHOTO_ALT'
,p_item_sequence=>96
,p_item_plug_id=>wwv_flow_imp.id(1142730838556397048)
,p_source=>'wwv_flow_lang.system_message(''USER_PROFILE_IMAGE'',:F4350_P3_USER_NAME)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(485937869389411549)
,p_computation_sequence=>40
,p_computation_item=>'P3_UPDATE_PW'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'length(:F4350_P3_USER_PASSWORD)'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(528338806493397505)
,p_computation_sequence=>50
,p_computation_item=>'F4350_P3_COMPANY'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_security.find_company_name ( p_security_group_id => wwv_flow_security.g_security_group_id );'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(485938428402411550)
,p_validation_name=>'validate email'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_at  number;',
'    l_dot number;',
'begin',
'    l_at  := instr(nvl(:F4350_P3_EMAIL_ADDRESS,''x''),''@'');',
'    l_dot := instr(nvl(:F4350_P3_EMAIL_ADDRESS,''x''),''.'',l_at);',
'',
'    return l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address.'
,p_when_button_pressed=>wwv_flow_imp.id(485932789329411544)
,p_associated_item=>wwv_flow_imp.id(485919804537411527)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_security_scheme=>'!'||wwv_flow_imp.id(6738625560859071)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(485939238468411551)
,p_validation_name=>'if change username, must reset password'
,p_validation_sequence=>105
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select user_name',
'     from wwv_flow_fnd_user',
'    where user_id = :F4350_P3_USER_ID',
'      and security_group_id = :flow_security_group_id )',
'loop',
'   if c1.user_name != :F4350_P3_USER_NAME and',
'      :F4350_P3_WEB_PASSWORD is null then',
'   return false;',
'   else return true;',
'   end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'If you update the Username, you must provide a new password.'
,p_when_button_pressed=>wwv_flow_imp.id(485932789329411544)
,p_associated_item=>wwv_flow_imp.id(485933179379411545)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1223161803819919527)
,p_validation_name=>'Validate Current Password'
,p_validation_sequence=>115
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_api.is_login_password_valid(',
'  p_username=>:APP_USER,',
'  p_password=>:F4350_P3_CURRENT_PASSWORD);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid Current Password'
,p_validation_condition=>'F4350_P3_CURRENT_PASSWORD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(485932789329411544)
,p_associated_item=>wwv_flow_imp.id(1000725807551503640)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1000725983139503641)
,p_validation_name=>'Current Password Must Be Defined'
,p_validation_sequence=>125
,p_validation=>'F4350_P3_CURRENT_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Current password must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
' * require current password if new password given and either',
' * - builder requires password (e.g. APEX auth - not SSO auth)',
' * - user password has already been changed',
' */',
' ',
':F4350_P3_WEB_PASSWORD is not null',
'and (not wwv_flow_authentication_dev.is_builder_password_required (',
'             p_developer_yn => ''N'' )',
'     or :P3_FIRST_PWD_USE_OCCURRED=''Y'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(485932789329411544)
,p_associated_item=>wwv_flow_imp.id(1000725807551503640)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(485939464738411551)
,p_validation_name=>'match password'
,p_validation_sequence=>135
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4350_P3_WEB_PASSWORD != :F4350_P3_USER_PASSWORD then',
'  :F4350_P3_WEB_PASSWORD  := null;',
'  :F4350_P3_USER_PASSWORD := null;',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Confirmation password does not match new password.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P3_WEB_PASSWORD is not null or',
':F4350_P3_USER_PASSWORD is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(485932789329411544)
,p_associated_item=>wwv_flow_imp.id(485933686391411545)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(485939677017411551)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>145
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username       => :F4350_P3_USER_NAME,',
'      p_password       => :F4350_P3_WEB_PASSWORD,',
'      p_old_password   => :F4350_P3_CURRENT_PASSWORD,',
'      p_workspace_name => wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Error'
,p_when_button_pressed=>wwv_flow_imp.id(485932789329411544)
,p_associated_item=>wwv_flow_imp.id(485933179379411545)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'do not run for non-developers in SSO authentication mode'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(485957776630485888)
,p_name=>'Cancel Dialog'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(485932354419411539)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(485958052927485889)
,p_event_id=>wwv_flow_imp.id(485957776630485888)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1223302827707202942)
,p_name=>'Go to Current Password'
,p_event_sequence=>80
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'self.location.hash === "#pwd"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1223303044233202944)
,p_event_id=>wwv_flow_imp.id(1223302827707202942)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4350_P3_CURRENT_PASSWORD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1253547838832954903)
,p_event_id=>wwv_flow_imp.id(1223302827707202942)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Because of the hash tag in the URL, the parent window will also scroll.',
'// Let''s put it back where it was',
'setTimeout( function(){',
'    if ( parent.window.scrollY !== 0 ) {',
'        parent.window.scrollTo( 0, 0 );',
'    }',
'}, 1 );'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(485940145256411552)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
':F4350_P3_ORG_EMAIL_ADDRESS := :F4350_P3_EMAIL_ADDRESS;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>485940145256411552
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(528326649481046882)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Current Image'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_fnd_user',
'   set profile_image = EMPTY_BLOB(),',
'       profile_image_name = null,',
'       profile_mimetype = null,',
'       profile_filename = null,',
'       profile_last_update = null,',
'       profile_charset = null',
' where user_id = :F4350_P3_USER_ID',
'   and security_group_id =  wwv_flow_security.g_security_group_id;',
' commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'There were issues removing the current Profile image.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(534309773003323583)
,p_process_when=>'F4350_P3_USER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Profile image has been successfully removed.'
,p_internal_uid=>528326649481046882
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(485940378778411553)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit User'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_p1                        varchar2(256)               := v(''F4350_P3_WEB_PASSWORD'');',
'  l_p2                        varchar2(256)               := v(''F4350_P3_USER_PASSWORD'');',
'  l_profile_image             blob default empty_blob();',
'begin',
'',
'  -- Retrieve Profile Image Content from Temporary table wwv_flow_files, used by File Browse item',
'  if :P3_PROFILE_IMAGE is not null then',
'      -- Get the uploaded file from the common wwv_flow_files table.',
'      select blob_content',
'        into l_profile_image',
'        from wwv_flow_files',
'       where name = :P3_PROFILE_IMAGE; ',
'  end if;',
'',
'  wwv_flow_fnd_user_api.edit_fnd_user (',
'      p_user_id                      => :F4350_P3_USER_ID,       ',
'      p_first_name                   => :F4350_P3_FIRST_NAME,          ',
'      p_last_name                    => :F4350_P3_LAST_NAME,',
'      p_web_password                 => l_p1,    ',
'      p_new_password                 => l_p2,                     ',
'      p_email_address                => nvl(:F4350_P3_EMAIL_ADDRESS, :F4350_P3_ORG_EMAIL_ADDRESS),',
'      p_first_password_use_occurred  => case when l_p1 is not null then ''Y'' else :P3_FIRST_PWD_USE_OCCURRED end,',
'      p_profile_image                => l_profile_image);',
'     ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error updating user.'
,p_process_when_button_id=>wwv_flow_imp.id(485932789329411544)
,p_process_when=>'F4350_P3_USER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'User "&F4350_P3_USER_NAME." updated.'
,p_internal_uid=>485940378778411553
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(487249722605107455)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Email Address updated'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_product_name  varchar2(500);',
'  l_msg           varchar2(4000);',
'  l_body_html     varchar2(32767) := null;',
'begin',
'',
'  --',
'  -- Mail the change of Email address',
'  --',
'  if :F4350_P3_ORG_EMAIL_ADDRESS <> :F4350_P3_EMAIL_ADDRESS then',
'    l_msg := l_msg || wwv_flow_lang.system_message( ''NEW_EMAIL_ADDRESS'', ',
'                                                    wwv_flow_escape.html( :F4350_P3_USER_NAME ), ',
'                                                    wwv_flow_escape.html( :F4350_P3_COMPANY ), ',
'                                                    wwv_flow_escape.html( :F4350_P3_EMAIL_ADDRESS ),',
'                                                    wwv_flow_utilities.host_url(''SCRIPT'')) || chr(10);',
'        ',
'    l_body_html := wwv_flow_mail.convert_txt_to_html (',
'                       p_txt_message       => l_msg,',
'                       p_security_group_id => :flow_security_group_id );',
'                       ',
'    l_product_name := nvl(v(''PRODUCT_NAME''),''Oracle APEX'');',
'',
'    wwv_flow_mail.send ( ',
'        p_to        => :F4350_P3_ORG_EMAIL_ADDRESS,',
'        p_from      => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),:F4350_P3_ORG_EMAIL_ADDRESS),',
'        p_body      => l_msg,',
'        p_body_html => l_body_html,',
'        p_subj      => wwv_flow_lang.system_message(''CHANGE_PW_REQUEST'',l_product_name) );',
'        ',
'  end if;',
'',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(485932789329411544)
,p_security_scheme=>'!'||wwv_flow_imp.id(6738625560859071)
,p_internal_uid=>487249722605107455
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(485957562238481403)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(485932789329411544)
,p_internal_uid=>485957562238481403
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(528328136769125728)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set User ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- fetch id of current user',
'--',
'select user_id',
'  into :F4350_P3_USER_ID',
'  from wwv_flow_fnd_user',
' where user_name         = wwv_flow_security.g_user',
'   and security_group_id = wwv_flow_security.g_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>528328136769125728
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(528291553770752921)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch User Information DML'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FND_USER'
,p_attribute_03=>'F4350_P3_USER_ID'
,p_attribute_04=>'USER_ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    user_name         = v(''APP_USER'')',
'and security_group_id = v(''WORKSPACE_ID'')'))
,p_internal_uid=>528291553770752921
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_imp_page.create_page(
 p_id=>4
,p_name=>'Login Attempts by Authentication Result'
,p_alias=>'LOGIN-ATTEMPTS-BY-AUTHENTICATION-RESULT'
,p_step_title=>'Login Attempts by Authentication Result'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42713916288726001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47363926027704900)
,p_plug_name=>'Login Attempts'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P4a */',
'  l.attempts,',
'  l.login_name,',
'  l.application,',
'  l.owner,',
'  l.authentication_method,',
'  l.access_date,',
'  l.ip_address,',
'  decode(nvl(l.authentication_result,0),',
'     0,m.AUTH_SUCCESS,',
'     1,m.AUTH_UNKNOWN_USER,',
'     2,m.AUTH_ACCOUNT_LOCKED,',
'     3,m.AUTH_ACCOUNT_EXPIRED,',
'     4,m.AUTH_PASSWORD_INCORRECT,',
'     5,m.AUTH_PASSWORD_FIRST_USE,',
'     6,m.AUTH_ATTEMPTS_EXCEEDED,',
'     7,m.AUTH_INTERNAL_ERROR,',
'     l.authentication_result) authentication_result,',
'     l.authentication_result authentication_result_code',
'from',
'(',
'select ',
'  count(*) attempts,',
'  count(distinct upper(login_name)) login_name,',
'  count(distinct application) application,',
'  count(distinct owner) owner,',
'  count (distinct authentication_method) authentication_method,',
'  count( distinct to_char(access_date,''YYYY.MM.DD'')) access_date,',
'  count( distinct ip_address) ip_address,',
'  nvl(authentication_result,0) authentication_result',
'from   wwv_flow_user_access_log_v l',
'where  security_group_id = :flow_security_group_id',
'and access_date >= sysdate - nvl(:p4_time,1)',
' and ( :P4_APPLICATION is null or application like ''%''||:P4_APPLICATION||''%'')',
'and (:P4_USER is null or lower(login_name) like ''%''||lower(:P4_USER)||''%'')',
'group by nvl(authentication_result,0)',
') l,',
'(select',
'wwv_flow_lang.system_message(''AUTH_SUCCESS'') auth_success,',
'wwv_flow_lang.system_message(''AUTH_UNKNOWN_USER'') auth_unknown_user,',
'wwv_flow_lang.system_message(''AUTH_ACCOUNT_LOCKED'') auth_account_locked,',
'wwv_flow_lang.system_message(''AUTH_ACCOUNT_EXPIRED'') auth_account_expired,',
'wwv_flow_lang.system_message(''AUTH_PASSWORD_INCORRECT'') auth_password_incorrect,',
'wwv_flow_lang.system_message(''AUTH_PASSWORD_FIRST_USE'') auth_password_first_use,',
'wwv_flow_lang.system_message(''AUTH_ATTEMPTS_EXCEEDED'') auth_attempts_exceeded,',
'wwv_flow_lang.system_message(''AUTH_INTERNAL_ERROR'') auth_internal_error',
'from dual) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47364014627704900)
,p_name=>'Login Attempts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47364232661704916)
,p_db_column_name=>'ATTEMPTS'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Attempts'
,p_column_link=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RIR,70:IR_AUTHENTICATION_RESULT_CODE,P70_TIME:#AUTHENTICATION_RESULT_CODE#,&P4_TIME.'
,p_column_linktext=>'#ATTEMPTS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47364309638704923)
,p_db_column_name=>'LOGIN_NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Login Names'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47364405831704923)
,p_db_column_name=>'APPLICATION'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47364505224704924)
,p_db_column_name=>'OWNER'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Application Owners'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47364601629704924)
,p_db_column_name=>'AUTHENTICATION_METHOD'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Authentication Methods'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47364714754704925)
,p_db_column_name=>'ACCESS_DATE'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Login Days'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47364805925704925)
,p_db_column_name=>'IP_ADDRESS'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'IP Addresses'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450633625112963474)
,p_db_column_name=>'AUTHENTICATION_RESULT'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Authentication Result'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340579706612701073)
,p_db_column_name=>'AUTHENTICATION_RESULT_CODE'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Authentication Result Code'
,p_display_in_default_rpt=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47365226378705232)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1307632692536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUTHENTICATION_RESULT:ATTEMPTS:LOGIN_NAME:APPLICATION:OWNER:AUTHENTICATION_METHOD:ACCESS_DATE:IP_ADDRESS:AUTHENTICATION_RESULT_CODE'
,p_sort_column_1=>'AUTHENTICATION_RESULT'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(42715026364726009)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(42713916288726001)
,p_button_name=>'P4_GO'
,p_button_static_id=>'P4_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450597432759842665)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(42713916288726001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42717220135726012)
,p_branch_action=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(42715026364726009)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42717409726726015)
,p_branch_action=>'70'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42715711720726010)
,p_name=>'P4_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(42713916288726001)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'To filter by application, enter an application ID and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42716223347726010)
,p_name=>'P4_USER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(42713916288726001)
,p_prompt=>'Login Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'To filter by Login Name, enter a Login Name and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42736507800886950)
,p_name=>'P4_TIME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(42713916288726001)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_imp_page.create_page(
 p_id=>5
,p_name=>'Purge Session State'
,p_alias=>'PURGE-SESSION-STATE'
,p_step_title=>'Purge Session State'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_help_text=>'AEADM/aadm_purge_session.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41820802378409076)
,p_plug_name=>'Session State'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Session state provides persistence for items. &PRODUCT_NAME. uses a stateless architecture to store session state in the database.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48658815589767957)
,p_plug_name=>'Session State'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select count(*) c from wwv_flow_data where flow_instance = :flow_session) loop',
'sys.htp.p(''<span class="instructiontext">''||wwv_flow_lang.system_message(''F4350_SESSION_STATE'',:flow_session,c1.c) );',
'end loop;',
'sys.htp.p(wwv_flow_lang.system_message(''F4350_RESET_SESSION'') || ''</span>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48661616984968577)
,p_plug_name=>'button box'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(174256217975087222)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48658815589767957)
,p_button_name=>'SessionDetails'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'View Session State'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48658988453771579)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48658815589767957)
,p_button_name=>'ResetCache'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Session State'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48659251907771584)
,p_branch_action=>'5'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(48658988453771579)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48659428631783734)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset-sessionstate'
,p_attribute_01=>'RESET_SESSION_STATE'
,p_process_error_message=>'Unable to purge session state.'
,p_process_when_button_id=>wwv_flow_imp.id(48658988453771579)
,p_process_success_message=>'Session state purged.'
,p_internal_uid=>48659428631783734
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_imp_page.create_page(
 p_id=>6
,p_name=>'Developer Login Summary'
,p_alias=>'DEVELOPER-LOGIN-SUMMARY'
,p_step_title=>'Developer Login Summary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10264909617798279)
,p_plug_name=>'Developer Logins'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P6a */',
'      u.user_id,',
'      u.user_name,',
'      u.email_address "eMail",',
'      u.first_name,',
'      u.last_name,',
'      replace(u.default_schema,''%''||''null%'',null) default_schema,',
'u.DESCRIPTION,',
'u.LAST_AGENT,',
'u.LAST_IP,',
'u.FAILED_ACCESS_ATTEMPTS,',
'decode(nvl(d.is_admin,''N''),''Y'',',
'  m.admin,decode(nvl(d.is_developer,''N''),',
'  ''Y'',m.dev,m.end_user)) dev_type,',
'decode (nvl(d.is_developer,''N''),''Y'',last_login,null) last_login,',
'decode (nvl(d.is_developer,''N''),''Y'',',
'          nvl(builder_login_count,0),null) builder_login_count',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d,',
'    (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes,',
'            wwv_flow_lang.system_message(''PASSWORD_VALID'') password_valid,',
'            wwv_flow_lang.system_message(''PASSWORD_EXPIRED'') password_expired,',
'            wwv_flow_lang.system_message(''NO_DEVELOPER_PRIV'') no_developer_priv,',
'            wwv_flow_lang.system_message(''DEVELOPER'') dev,',
'wwv_flow_lang.system_message(''ADMINISTRATOR'') admin,',
'wwv_flow_lang.system_message(''END_USER'') end_user',
'     from dual) m',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id and',
'     d.is_developer = ''Y'''))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10265008216798279)
,p_name=>'Developer Logins'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_base_pk1=>'USER_ID'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-view.png" class="apex-edit-view" alt="">'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10265215153798286)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'User Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10265331595798286)
,p_db_column_name=>'USER_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10265415681798287)
,p_db_column_name=>'eMail'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Email'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10265526984798287)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'First Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10265626077798287)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Last Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10265728301798287)
,p_db_column_name=>'DEFAULT_SCHEMA'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Default Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10265811005798287)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10265910207798287)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Last Agent'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10266007407798288)
,p_db_column_name=>'LAST_IP'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'IP Address'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10266219176798288)
,p_db_column_name=>'FAILED_ACCESS_ATTEMPTS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Failed Access Attempts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10266319338798288)
,p_db_column_name=>'DEV_TYPE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Developer Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10270413936835709)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Last Login'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10270524884835710)
,p_db_column_name=>'BUILDER_LOGIN_COUNT'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Builder Login Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10266617914799022)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1307702792536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'USER_NAME:DEFAULT_SCHEMA:LAST_IP:DEV_TYPE:LAST_LOGIN:BUILDER_LOGIN_COUNT'
,p_sort_column_1=>'LAST_LOGIN'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'USER_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450634229745974263)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10264909617798279)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_00007
begin
wwv_flow_imp_page.create_page(
 p_id=>7
,p_name=>'Active Sessions'
,p_alias=>'ACTIVE-SESSIONS'
,p_step_title=>'Active Sessions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9412131855285339)
,p_plug_name=>'Active Sessions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sd as (',
'    select	s.ID as "ID",',
'           s.security_group_id,',
'           s.username session_owner,',
'           s.created_on,',
'           count(*) item_cache_count,',
'           count(distinct(d.flow_id)) distinct_applications,',
'           s.remote_addr ip_address,',
'           s.idle_timeout_on,',
'           s.life_timeout_on,',
'           s.session_lang,',
'           s.session_territory,',
'           s.session_time_zone,',
'           s.debug_level,',
'           s.trace_mode',
' from	 WWV_FLOW_DATA d,',
'	     WWV_FLOW_SESSIONS$ s',
' where   s.ID = d.FLOW_INSTANCE (+)',
'   and   s.security_group_id = :flow_security_group_id',
'group by s.ID,',
'         s.security_group_id,',
'         s.username,',
'         s.created_on,',
'         s.remote_addr,',
'         s.idle_timeout_on,',
'         s.life_timeout_on,',
'         s.session_lang,',
'         s.session_territory,',
'         s.session_time_zone,',
'         s.debug_level,',
'         s.trace_mode),',
'     mt as (select l.session_id, max(l.time_stamp) most_recent_view',
'        from WWV_FLOW_ACTIVITY_LOG l',
'       where l.security_group_id = :flow_security_group_id',
'       group by l.session_id)',
'select /* APEX4350P7a */ /*+ FIRST_ROWS(21) */',
'        sd.id,',
'        sd.session_owner,',
'        sd.created_on,',
'        sd.item_cache_count,',
'        sd.ip_address,',
'        mt.most_recent_view,',
'        sd.distinct_applications,',
'        sd.idle_timeout_on,',
'        sd.life_timeout_on,',
'        sd.session_lang,',
'        sd.session_territory,',
'        sd.session_time_zone,',
'        sd.debug_level,',
'        sd.trace_mode',
'  from sd, mt',
' where sd.id = mt.session_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9412205627285339)
,p_name=>'Active Sessions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9412428176285340)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Active Session'
,p_column_link=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:RP,:P19_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9412501728285340)
,p_db_column_name=>'SESSION_OWNER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9412608456285340)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9412708051285340)
,p_db_column_name=>'ITEM_CACHE_COUNT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Session Items'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9412818327285341)
,p_db_column_name=>'IP_ADDRESS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'IP Address'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22432609427809248)
,p_db_column_name=>'MOST_RECENT_VIEW'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Most Recent View'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22435506226827241)
,p_db_column_name=>'DISTINCT_APPLICATIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Distinct Applications'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(265416632100318130)
,p_db_column_name=>'IDLE_TIMEOUT_ON'
,p_display_order=>17
,p_column_identifier=>'H'
,p_column_label=>'Idle Timeout'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(265416784868318131)
,p_db_column_name=>'LIFE_TIMEOUT_ON'
,p_display_order=>27
,p_column_identifier=>'I'
,p_column_label=>'Life Timeout'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(265416893890318132)
,p_db_column_name=>'SESSION_LANG'
,p_display_order=>37
,p_column_identifier=>'J'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(265416996345318133)
,p_db_column_name=>'SESSION_TERRITORY'
,p_display_order=>47
,p_column_identifier=>'K'
,p_column_label=>'Territory'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(265417082583318134)
,p_db_column_name=>'SESSION_TIME_ZONE'
,p_display_order=>57
,p_column_identifier=>'L'
,p_column_label=>'Time Zone'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(265417123142318135)
,p_db_column_name=>'DEBUG_LEVEL'
,p_display_order=>67
,p_column_identifier=>'M'
,p_column_label=>'Debug Level'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(265417254052318136)
,p_db_column_name=>'TRACE_MODE'
,p_display_order=>77
,p_column_identifier=>'N'
,p_column_label=>'Trace Mode'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(370223717115128950)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9413006316285546)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1307803339536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:SESSION_OWNER:CREATED_ON:ITEM_CACHE_COUNT:IP_ADDRESS:MOST_RECENT_VIEW'
,p_sort_column_1=>'MOST_RECENT_VIEW'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'CREATED_ON'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200809731468694255)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(9412131855285339)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:7,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(167564317393131991)
,p_branch_action=>'f?p=&FLOW_ID.:7:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_imp_page.create_page(
 p_id=>8
,p_name=>'Application Changes by Developer'
,p_alias=>'APPLICATION-CHANGES-BY-DEVELOPER'
,p_step_title=>'Application Changes by Developer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6115202769688783)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9830103673330851)
,p_plug_name=>'Application Changes by Developer'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as',
'(',
'select /* APEX4350P8a */ count(*) tpv',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p8_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (:P8_APPLICATION = 0 or flow_id = :P8_APPLICATION)',
')',
'select the_link, developer, page_views, 100*page_views/tpv pct, round(100*page_views/tpv) graph,',
'pages_visited,',
'distinct_applications,',
'''<div class="hour-graph">''||',
'''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-value"'
||'>''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-value"'
||'>''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-value"'
||'>''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-value"'
||'>''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-value"'
||'>''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-value"'
||'>''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-value"'
||'>''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-value"'
||'>''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-value"'
||'>''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-value"'
||'>''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-value"'
||'>''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-value"'
||'>''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-value"'
||'>''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-value"'
||'>''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-value"'
||'>''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-value"'
||'>''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-value"'
||'>''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-value"'
||'>''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-value"'
||'>''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-value"'
||'>''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-value"'
||'>''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-value"'
||'>''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-value"'
||'>''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-value"'
||'>''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'''</div>'' hours',
'from',
'(',
'select ',
'''f?p=4350:42:''||:app_session||'':::RP:P42_USER,P42_TIME:''||flow_user||'',''||:p8_time the_link,',
'  flow_user developer,',
'  count(*) page_views,',
'  count(distinct(page_id)) pages_visited,',
'  count(distinct(flow_id)) distinct_applications,',
'  sum(decode(to_char(audit_date,''HH24''),0,1,0)) h00,',
'  sum(decode(to_char(audit_date,''HH24''),1,1,0)) h01,',
'  sum(decode(to_char(audit_date,''HH24''),2,1,0)) h02,',
'  sum(decode(to_char(audit_date,''HH24''),3,1,0)) h03,',
'  sum(decode(to_char(audit_date,''HH24''),4,1,0)) h04,',
'  sum(decode(to_char(audit_date,''HH24''),5,1,0)) h05,',
'  sum(decode(to_char(audit_date,''HH24''),6,1,0)) h06,',
'  sum(decode(to_char(audit_date,''HH24''),7,1,0)) h07,',
'  sum(decode(to_char(audit_date,''HH24''),8,1,0)) h08,',
'  sum(decode(to_char(audit_date,''HH24''),9,1,0)) h09,',
'  sum(decode(to_char(audit_date,''HH24''),10,1,0)) h10,',
'  sum(decode(to_char(audit_date,''HH24''),11,1,0)) h11,',
'  sum(decode(to_char(audit_date,''HH24''),12,1,0)) h12,',
'  sum(decode(to_char(audit_date,''HH24''),13,1,0)) h13,',
'  sum(decode(to_char(audit_date,''HH24''),14,1,0)) h14,',
'  sum(decode(to_char(audit_date,''HH24''),15,1,0)) h15,',
'  sum(decode(to_char(audit_date,''HH24''),16,1,0)) h16,',
'  sum(decode(to_char(audit_date,''HH24''),17,1,0)) h17,',
'  sum(decode(to_char(audit_date,''HH24''),18,1,0)) h18,',
'  sum(decode(to_char(audit_date,''HH24''),19,1,0)) h19,',
'  sum(decode(to_char(audit_date,''HH24''),20,1,0)) h20,',
'  sum(decode(to_char(audit_date,''HH24''),21,1,0)) h21,',
'  sum(decode(to_char(audit_date,''HH24''),22,1,0)) h22,',
'  sum(decode(to_char(audit_date,''HH24''),23,1,0)) h23',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p8_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (:P8_APPLICATION = 0 or flow_id = :P8_APPLICATION)',
'group by ',
'  flow_user) d, total_page_views,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.APPCHANGES'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9830202023330851)
,p_name=>'Application Changes by Developer'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9830429030330852)
,p_db_column_name=>'THE_LINK'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9830502357330852)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9830612188330852)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Component Changes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9830716530330853)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9830808496330853)
,p_db_column_name=>'GRAPH'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9830926209330853)
,p_db_column_name=>'PAGES_VISITED'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Distinct Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9932001315661346)
,p_db_column_name=>'DISTINCT_APPLICATIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Distinct Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760555872015323225)
,p_db_column_name=>'HOURS'
,p_display_order=>17
,p_column_identifier=>'H'
,p_column_label=>'Activity by Hour'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9831113910331200)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1307925749536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DEVELOPER:PAGE_VIEWS:PCT:GRAPH:PAGES_VISITED:DISTINCT_APPLICATIONS:'
,p_sort_column_1=>'PAGE_VIEWS'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200631711636281729)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(6115202769688783)
,p_button_name=>'P8_SET'
,p_button_static_id=>'P8_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200631503324279375)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(6115202769688783)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_redirect_url=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:8,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(20242415263688933)
,p_branch_action=>'f?p=&FLOW_ID.:8:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20239730370683894)
,p_name=>'P8_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6115202769688783)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'to_number(.25)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47682732034325129)
,p_name=>'P8_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6115202769688783)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cHeight=>1
,p_tag_attributes=>'style="max-width:200px"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_imp_page.create_page(
 p_id=>9
,p_name=>'About &PRODUCT_NAME.'
,p_alias=>'ABOUT'
,p_page_mode=>'MODAL'
,p_step_title=>'About &PRODUCT_NAME.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215451130329541858)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'div.subRegion h2 {',
'	font: bold 13px/20px Arial, sans-serif;',
'	color: #333;',
'}',
'table.aboutReportTop {',
'	padding: 0 0 10px 0;',
'}',
'table.aboutReportTop tr:first-child th,',
'table.aboutReportTop tr:first-child td {',
'border-top: none;',
'}',
'table.aboutReportTop td {',
'padding: 5px;',
'text-align: left;',
'font: normal 12px/16px Arial, sans-serif;',
'color: #333;',
'border-top: 1px solid #DDD;',
'}',
'table.aboutReportTop td.textHere {',
'font-weight: bold;',
'}',
'',
'#memorial { padding: 24px; color: #FFF; background-color: #000; line-height: 1.5; text-align: center; display: flex; flex-direction: column; align-items: center; min-height: 100vh; justify-content: center;}',
'#memorial b { display: block; margin-top: 12px; font-size: 18px; }',
'#memorial p span { opacity: 0.65; display: block; }',
'#memorial .heart { background-image: url(''data:image/svg+xml;base64,PHN2ZyB2ZXJzaW9uPSIxLjEiIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyIgd2lkdGg9IjE2IiBoZWlnaHQ9IjE2IiB2aWV3Qm94PSIwIDAgMTYgMTYiIGZpbGw9InJnYigyMDIsIDc3LCA2MCkiPgo8dGl0bGU+aGVhcnQ8L3'
||'RpdGxlPgo8cGF0aCBkPSJNMTQuODI0IDMuMTc2Yy0xLjU2NC0xLjU2NC00LjExMy0xLjU2NC01LjY3OCAwbC0xLjE0NiAxLjE0Ni0xLjE0Ni0xLjE0NmMtMS41NjQtMS41NjQtNC4xMTMtMS41NjQtNS42NzggMHMtMS41NjQgNC4xMTIgMCA1LjY3OGw2LjQ3MSA2LjQ3MWMwLjA5MyAwLjA5MyAwLjIyIDAuMTQ2IDAuMzUzIDAuMTQ2'
||'czAuMjYtMC4wNTMgMC4zNTQtMC4xNDZsNi40NzEtNi40NzFjMS41NjQtMS41NjYgMS41NjQtNC4xMTMtMC4wMDEtNS42Nzh6Ij48L3BhdGg+Cjwvc3ZnPg==''); background-repeat: no-repeat; background-size: 100%; background-position: center; display: inline-block; width: 24px; height: '
||'24px; margin-bottom: 8px; }',
'#memorial .heart:hover {animation: apexheartpulse 2s infinite ease;}'))
,p_step_template=>wwv_flow_imp.id(485889499804058937)
,p_page_css_classes=>'about-page'
,p_dialog_height=>'500'
,p_dialog_width=>'490'
,p_dialog_attributes=>'scroll:''auto'''
,p_help_text=>'AEADM/aadm_htmldb.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77811317279722052)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-Dialog-about">',
'              <span class="a-Dialog-icon gi-icon-apex-logo-icon"></span>',
'              <span class="a-Dialog-aboutTitle">''||:PRODUCT_NAME||''</span>',
'          </div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1976112228973810)
,p_plug_name=>'Multilingual Engine'
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return wwv_flow_code_exec_mle_dev.get_about_html;'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20123129051163000)
,p_name=>'Database Version'
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select banner_full as banner',
'  from sys.v_$version',
' order by case when banner like ''Oracle%'' then 1 else 2 end, upper(banner)'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No database version information found.'
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20123710246163013)
,p_query_column_id=>1
,p_column_alias=>'BANNER'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space: pre-line'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186769128691535740)
,p_plug_name=>'CGI Environment'
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_4000_ui.print_cgi_env',
' (p_html_table_attr=>''class="u-Report u-Report--stretch u-Report--staticBG u-Report--inline u-Report--firstColLabel" role="presentation" cellpadding="0" cellspacing="0" border="0"'');'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(198701826510091307)
,p_plug_name=>'Character Set'
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table role="presentation" class="u-Report u-Report--staticBG u-Report--stretch u-Report--inline  u-Report--firstColLabel">'');',
'for c1 in (',
'select ''NLS_CHARACTERSET'' n, value v ',
'from sys.nls_database_parameters ',
'where upper(parameter)= ''NLS_CHARACTERSET'') loop',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(c1.n);',
'sys.htp.prn(''<td class="textHere">''||wwv_flow_escape.html(c1.v)||''</td>'');',
'sys.htp.p(''</tr>'');',
'end loop;',
'',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(''DAD CHARACTERSET'');',
'sys.htp.prn(''<td class="textHere">''||',
'   wwv_flow_escape.html(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''</table>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(842425152910300825)
,p_plug_name=>'Database Initialization Parameters'
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table role="presentation" class="u-Report u-Report--staticBG u-Report--stretch u-Report--inline  u-Report--firstColLabel">'');',
'',
'for c1 in (',
'select ''JOB_QUEUE_PROCESSES'' n, value v',
'from sys.v_$parameter where lower(name) = ''job_queue_processes'') loop',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(c1.n);',
'sys.htp.prn(''<td class="textHere">''||',
'   wwv_flow_escape.html(c1.v)||''</td>'');',
'sys.htp.p(''</tr>'');',
'end loop;',
'',
'sys.htp.p(''</table>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(878525955445395737)
,p_plug_name=>'Memorial'
,p_region_name=>'memorial'
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>180
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="heart" aria-hidden="true"></span>',
'<p>In loving memory of <strong>Joel R Kallman</strong> <span>1966-2021</span></p>',
'<p>You are forever in our hearts.</p>',
'<!-- Share your memories on apex.oracle.com/joel -->'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1093539312009113721)
,p_plug_name=>'Details'
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table class="u-Report u-Report--stretch u-Report--staticBG u-Report--inline u-Report--firstColLabel" role="presentation">'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.PRODUCT_BUILD''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(wwv_flows_release)||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.SCHEMA_COMPATIBILITY''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(wwv_flows_version)||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'for c1 in (select patch_version, to_char(installed_on,''&DATE_TIME_FORMAT.'') lddt',
'             from wwv_flow_pses',
'            where installed_on = (select max(installed_on) from wwv_flow_pses) ) loop',
'    sys.htp.p(''<tr>'');',
'    wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.PATCH_VERSION''));',
'    sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.patch_version)||''</td>'');',
'    sys.htp.p(''</tr>'');',
'    sys.htp.p(''<tr>'');',
'    wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.LAST_PATCH_TIME''));',
'    sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.lddt)||''</td>'');',
'    sys.htp.p(''</tr>'');',
'end loop;',
'',
'for c1 in (select to_char(last_ddl_time,''&DATE_TIME_FORMAT.'') as lddt',
'             from sys.dba_objects',
'            where owner = wwv_flow.g_flow_schema_owner',
'              and object_name = ''WWV_FLOW''',
'              and object_type = ''PACKAGE BODY'' ) loop',
'    sys.htp.p(''<tr>'');',
'    wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.LAST_DDL_TIME''));',
'    sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.lddt)||''</td>'');',
'    sys.htp.p(''</tr>'');',
'end loop;',
'',
'for c1 in (select user as u from sys.dual) loop',
'    sys.htp.p(''<tr>'');',
'    wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.HOST_SCHEMA''));',
'    sys.htp.prn(''<td>''||wwv_flow_escape.html(c1.u)||''</td>'');',
'    sys.htp.p(''</tr>'');',
'end loop;',
'',
'sys.htp.tableRowOpen;',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.APPLICATION_OWNER''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(''#FLOW_OWNER#'')||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.WORKSPACE_ID''));',
'sys.htp.prn(''<td>''||wwv_flow_security.g_security_group_id||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'-- wwv_flow.get_company_name returns already escaped output',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.WORKSPACE_NAME''));',
'sys.htp.prn(''<td>''||wwv_flow.get_company_name||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.CURRENT_USER''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(v(''USER''))||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.LANGUAGE_PREFERENCE''));',
'sys.htp.prn(''<td>''||wwv_flow_escape.html(wwv_flow.g_browser_language)||''</td>'');',
'wwv_htp.tableRowClose;',
'',
'sys.htp.p(''<tr>'');',
'wwv_htp.tableData(wwv_flow_lang.system_message(''F4350.CURRENT_TIME_ON_SERVER''));',
'sys.htp.prn(''<td>''||to_char(systimestamp,''&DATE_TIME_FORMAT. TZH:TZM'')||''</td>'');',
'sys.htp.p(''</tr>'');',
'',
'wwv_htp.tableClose;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267106411492305004)
,p_plug_name=>'Copyright Notice '
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>&MSG_COPYRIGHT.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267106527297305005)
,p_plug_name=>'License Restrictions Warranty/Consequential Damages Disclaimer '
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>This software and related documentation are provided under a license agreement containing restrictions on use and disclosure and are protected by intellectual property laws. Except as expressly permitted in your license agreement or allowed by law'
||', you may not use, copy, reproduce, translate, broadcast, modify, license, transmit, distribute, exhibit, perform, publish, or display any part, in any form, or by any means. Reverse engineering, disassembly, or decompilation of this software, unless'
||' required by law for interoperability, is prohibited.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267106619336305006)
,p_plug_name=>'Warranty Disclaimer '
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>The information contained herein is subject to change without notice and is not warranted to be error-free. If you find any errors, please report them to us in writing.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267106773028305007)
,p_plug_name=>'Restricted Rights Notice'
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>If this is software or related documentation that is delivered to the U.S. Government or anyone licensing it on behalf of the U.S. Government, then the following notice is applicable:</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267106847747305008)
,p_plug_name=>'Hazardous Applications Notice '
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>This software or hardware is developed for general use in a variety of information management applications. It is not developed or intended for use in any inherently dangerous applications, including applications that may create a risk of personal'
||' injury. If you use this software or hardware in dangerous applications, then you shall be responsible to take all appropriate fail-safe, backup, redundancy, and other measures to ensure its safe use. Oracle Corporation and its affiliates disclaim an'
||'y liability for any damages caused by use of this software or hardware in dangerous applications.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267106921786305009)
,p_plug_name=>'Trademark Notice '
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Oracle and Java are registered trademarks of Oracle and/or its affiliates. Other names may be trademarks of their respective owners.',
'',
'Intel and Intel Inside are trademarks or registered trademarks of Intel Corporation. All SPARC trademarks are used under license and are trademarks or registered trademarks of SPARC International, Inc. AMD, Epyc, and the AMD logo are trademarks or re'
||'gistered trademarks of Advanced Micro Devices. UNIX is a registered trademark of The Open Group.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267107051355305010)
,p_plug_name=>'Third-Party Content, Products, and Services Disclaimer '
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>This software or hardware and documentation may provide access to or information about content, products, and services from third parties. Oracle Corporation and its affiliates are not responsible for and expressly disclaim all warranties of any k'
||'ind with respect to third-party content, products, and services unless otherwise set forth in an applicable agreement between you and Oracle. Oracle Corporation and its affiliates will not be responsible for any loss, costs, or damages incurred due t'
||'o your access to or use of third-party content, products, or services, except as set forth in an applicable agreement between you and Oracle.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267107170924305011)
,p_plug_name=>'Third-Party Notices '
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Please find Third-Party Notices documentation at:<br /> ',
'<a rel="noopener noreferrer" href="https://apex.oracle.com/thirdparty" target="_blank">https://apex.oracle.com/thirdparty</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267107200044305012)
,p_plug_name=>'Restricted Rights Notice'
,p_parent_plug_id=>wwv_flow_imp.id(77811317279722052)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717841909277073684)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Implemented as PL/SQL region to exclude the following text from translations per Legal (see bug 28606120)',
'htp.p(''<p>U.S. GOVERNMENT END USERS: Oracle programs (including any operating system, integrated software, any programs embedded, installed or activated on delivered hardware, and modifications of such programs) and Oracle computer documentation or o'
||'ther Oracle data delivered to or accessed by U.S. Government end users are "commercial computer software" or "commercial computer software documentation" pursuant to the applicable Federal Acquisition Regulation and agency-specific supplemental regul'
||'ations. As such, the use, reproduction, duplication, release, display, disclosure, modification, preparation of derivative works, and/or adaptation of i) Oracle programs (including any operating system, integrated software, any programs embedded, ins'
||'talled or activated on delivered hardware, and modifications of such programs), ii) Oracle computer documentation and/or iii) other Oracle data, is subject to the rights and limitations specified in the license contained in the applicable contract. T'
||'he terms governing the U.S. Government''''s use of Oracle cloud services are defined by the applicable contract for such services. No other rights are granted to the U.S. Government.</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_imp_page.create_page(
 p_id=>10
,p_name=>'Application Changes by Developer'
,p_alias=>'APPLICATION-CHANGES-BY-DEVELOPER1'
,p_step_title=>'Application Changes by Developer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(131241908734176090)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1591303603291709019)
,p_plug_name=>'Developer activity by developer'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P10a */',
'  null l,',
'  flow_user,',
'  count(*) c',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p10_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (nvl(:p10_application,0) = 0 or flow_id = :p10_application)',
'group by ',
'  flow_user',
'order by 3 desc'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HTML5_BAR_CHART'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'INITIALS',
  'attribute_02', 'FLOW_USER',
  'attribute_04', 'C',
  'attribute_11', 'VALUE',
  'attribute_14', '500',
  'attribute_15', 'TEXT',
  'attribute_16', 'ABSOLUTE',
  'attribute_17', 'MODERN',
  'attribute_18', 'AROUND')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450735531935533076)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(131241908734176090)
,p_button_name=>'P10_SET'
,p_button_static_id=>'P10_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(20263732195741193)
,p_branch_action=>'f?p=&FLOW_ID.:10:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20260920074737670)
,p_name=>'P10_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(131241908734176090)
,p_item_default=>'.25'
,p_prompt=>'Since'
,p_source=>'.25'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to ',
'include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47683931950344036)
,p_name=>'P10_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(131241908734176090)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_imp_page.create_page(
 p_id=>11
,p_name=>'Current User Preferences'
,p_alias=>'PREF'
,p_step_title=>'Current User Preferences'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_user_pref.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46076724243052275)
,p_plug_name=>'Preferences'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    user_id,',
'    preference_name,',
'    attribute_value',
'from WWV_FLOW_PREFERENCES$',
'where user_id = :flow_user',
'and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(46076811301052275)
,p_name=>'Preferences'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(46077020433052289)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(46077103585052295)
,p_db_column_name=>'PREFERENCE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Preference'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(46077204057052295)
,p_db_column_name=>'ATTRIBUTE_VALUE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(46077425281052899)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308028708536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'USER_ID:PREFERENCE_NAME:ATTRIBUTE_VALUE'
,p_sort_column_1=>'PREFERENCE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(174210501299954701)
,p_plug_name=>'User Preferences'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This report shows the preferences set for the current user.  These session state values are retained between connections.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452413709019800121)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46076724243052275)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(122221606249170943)
,p_branch_action=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00012
begin
wwv_flow_imp_page.create_page(
 p_id=>12
,p_name=>'Page Views by Day'
,p_alias=>'PAGE-VIEWS-BY-DAY'
,p_step_title=>'Page Views by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'04'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46757621766940957)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(692991422006464140)
,p_plug_name=>'Page Events by Day'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(692991541290464141)
,p_region_id=>wwv_flow_imp.id(692991422006464140)
,p_chart_type=>'line'
,p_height=>'450'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(692991695243464142)
,p_chart_id=>wwv_flow_imp.id(692991541290464141)
,p_seq=>10
,p_name=>'Show'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(TIME_STAMP) day, to_char(TIME_STAMP,''mm/dd/yyyy'') day_format,',
'       count(*) views',
'from   WWV_FLOW_ACTIVITY_LOG',
'where  security_group_id = :flow_security_group_id and page_mode != ''A''',
'group by trunc(time_stamp),to_char(TIME_STAMP,''mm/dd/yyyy'')',
'order by trunc(time_stamp) desc'))
,p_items_value_column_name=>'VIEWS'
,p_items_label_column_name=>'DAY_FORMAT'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'afterMarker'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(692991991244464145)
,p_chart_id=>wwv_flow_imp.id(692991541290464141)
,p_seq=>20
,p_name=>'Accept'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(TIME_STAMP) day, to_char(TIME_STAMP,''dd/mm/yyyy'') day_format,',
'       count(*) views',
'from   WWV_FLOW_ACTIVITY_LOG',
'where  security_group_id = :flow_security_group_id and page_mode = ''A''',
'group by trunc(time_stamp),to_char(TIME_STAMP,''dd/mm/yyyy'')',
'order by trunc(time_stamp) desc'))
,p_items_value_column_name=>'VIEWS'
,p_items_label_column_name=>'DAY_FORMAT'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'aboveMarker'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692991712252464143)
,p_chart_id=>wwv_flow_imp.id(692991541290464141)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692991826812464144)
,p_chart_id=>wwv_flow_imp.id(692991541290464141)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(46757903889945188)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46757621766940957)
,p_button_name=>'REFRESH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(46972209650230505)
,p_branch_action=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P12_VIEW'
,p_branch_condition_text=>'DAY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(46972816707241959)
,p_branch_action=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P12_VIEW'
,p_branch_condition_text=>'HOUR'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46971321293224408)
,p_name=>'P12_VIEW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(46757621766940957)
,p_use_cache_before_default=>'NO'
,p_item_default=>'DAY'
,p_prompt=>'View'
,p_source=>'DAY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART SELECTOR'
,p_lov=>'.'||wwv_flow_imp.id(46971429951226857)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_imp_page.create_page(
 p_id=>13
,p_name=>'Workspace Activity Dashboard'
,p_alias=>'WORKSPACE-ACTIVITY-DASHBOARD'
,p_step_title=>'Workspace Activity Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46992417268582735)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46994113983619638)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46994605803626706)
,p_name=>'Top Applications'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P13b */ substr(',
'       (select name from wwv_flows where id = application),1,25) application_name,',
'       page_events,',
'       application',
'from (',
'select ',
'    flow_id application,',
'    count(*) page_events',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'(flow_id not between 4000 and 4999 or :flow_security_group_id = 10) and',
'time_stamp > sysdate - :P13_TIME',
'group by flow_id',
'order by 2 desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(46994605803626706)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47022315799968072)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46998018981781834)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46996430446737873)
,p_query_column_id=>3
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46996702442758171)
,p_name=>'Top Users'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P13a */ lower(substr(top_user,1,50)) top_user,',
'        event_count,',
'        top_user full_username',
'from (',
'select ',
'    userid top_user,',
'    count(*) event_count',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'       time_stamp > sysdate - :P13_TIME and',
'(flow_id not between 4000 and 4999 or :flow_security_group_id = 10) and',
'     userid is not null',
'group by userid',
') order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46997232225766749)
,p_query_column_id=>1
,p_column_alias=>'TOP_USER'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46997301255766749)
,p_query_column_id=>2
,p_column_alias=>'EVENT_COUNT'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46997430501766749)
,p_query_column_id=>3
,p_column_alias=>'FULL_USERNAME'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46998326861803030)
,p_name=>'Recent Logins'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P13d */ ',
'  lower(login_name)||'' ''||application login_attempt,',
'  access_date',
'from   wwv_flow_user_access_log_v l',
'where  security_group_id = :flow_security_group_id',
'and access_date >= sysdate - nvl(:P13_TIME,1)',
'order by access_date desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(46998326861803030)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46998916257809499)
,p_query_column_id=>1
,p_column_alias=>'LOGIN_ATTEMPT'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46999007472809499)
,p_query_column_id=>2
,p_column_alias=>'ACCESS_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46999814572837357)
,p_name=>'Recent Errors'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>70
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P13e */ ',
'   substr(	',
'   flow_id||'':''||step_id||'' - ''||',
'     substr((substr(sys.utl_i18n.unescape_reference(SQLERRM),1,30)||'' ''||',
'     substr(sys.utl_i18n.unescape_reference(USERID),1,20)),1,35),',
'     1,35) error_and_user,',
'   TIME_STAMP',
'from WWV_FLOW_ACTIVITY_LOG',
'where   security_group_id = :flow_security_group_id and',
'  sqlerrm is not null and',
'  TIME_STAMP >= sysdate - nvl(:P13_TIME,1)',
'order by TIME_STAMP desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(46999814572837357)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47000330633851422)
,p_query_column_id=>1
,p_column_alias=>'ERROR_AND_USER'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47000415198851422)
,p_query_column_id=>2
,p_column_alias=>'TIME_STAMP'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47007806364967405)
,p_name=>'Top Pages'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P13c */ substr(',
'        application_id||'':''||page_id ||'' ''||',
'        substr((select name ',
'        from wwv_flow_steps ',
'        where id=page_id and flow_id=application_id),1,20),',
'        1,25)',
'       application_page,',
'       page_events',
'from',
'(',
'select ',
'    flow_id application_id,',
'    step_id page_id,',
'    count(*) page_events',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'(flow_id not between 4000 and 4999 or :flow_security_group_id = 10) and',
'time_stamp > sysdate - :P13_TIME',
'group by flow_id, step_id',
'order by 3 desc',
')',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47522024859162462)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_PAGE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47008119491967405)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47029628200141872)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(166211911060758908)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47344306471037176)
,p_plug_name=>'User Activity'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:99%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>View a summary of workspace user activity for the selected timeframe.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955889255851997303)
,p_plug_name=>'Placholder'
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168425924484598602)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46992417268582735)
,p_button_name=>'MONITOR_ACTIVITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Monitor Activity'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(258482011097943097)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(46998326861803030)
,p_button_name=>'MONITOR_LOGINS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Monitor Logins'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'gotoIcon'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(46992700430587274)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46992417268582735)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(258480610204905780)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46999814572837357)
,p_button_name=>'VIEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'View'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'gotoIcon'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(258481411636934581)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(46994605803626706)
,p_button_name=>'VIEW_APPLICATIONS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'View Applications'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'gotoIcon'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(46993519262602210)
,p_branch_action=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46993309565599388)
,p_name=>'P13_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(46992417268582735)
,p_prompt=>'Show'
,p_source=>'select  3/24  from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the reporting timeframe.  Longer timeframes may take longer to display.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_imp_page.create_page(
 p_id=>14
,p_name=>'Page Views by Hour'
,p_alias=>'PAGE-VIEWS-BY-HOUR1'
,p_step_title=>'Page Views by Hour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
,p_page_component_map=>'04'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46754721279855631)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(692992000648464146)
,p_plug_name=>'Page Events by Hour'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>31
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(692992186674464147)
,p_region_id=>wwv_flow_imp.id(692992000648464146)
,p_chart_type=>'line'
,p_height=>'450'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(692992209787464148)
,p_chart_id=>wwv_flow_imp.id(692992186674464147)
,p_seq=>10
,p_name=>'Show'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_date||'' - ''||substr(long_date,9)||'':00'' date_tooltip, short_date||'' ''||substr(long_date,9)||'':00'' short_date_format, nvl(events,0) events from (',
'     select ',
'       count(*) events,',
'       to_char(time_stamp,''YYYYMMDDHH24'') long_date,',
'       to_char(time_stamp,''mm/dd/yyyy'') short_date',
'     from   ',
'       WWV_FLOW_ACTIVITY_LOG l',
'     where',
'       security_group_id = :flow_security_group_id and',
'       page_mode != ''A'' and',
'       time_stamp >= sysdate - 2',
'     group by to_char(time_stamp,''YYYYMMDDHH24''),to_char(time_stamp,''mm/dd/yyyy'')',
'     order by 2 desc)'))
,p_items_value_column_name=>'EVENTS'
,p_items_label_column_name=>'SHORT_DATE_FORMAT'
,p_items_short_desc_column_name=>'DATE_TOOLTIP'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(713094373045315401)
,p_chart_id=>wwv_flow_imp.id(692992186674464147)
,p_seq=>20
,p_name=>'Accept'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_date||'' - ''||substr(long_date,9)||'':00'' date_tooltip, short_date||'' ''||substr(long_date,9)||'':00'' short_date_format, nvl(events,0) events from (',
'     select ',
'       count(*) events,',
'       to_char(time_stamp,''YYYYMMDDHH24'') long_date,',
'       to_char(time_stamp,''mm/dd/yyyy'') short_date',
'     from   ',
'       WWV_FLOW_ACTIVITY_LOG l',
'     where',
'       security_group_id = :flow_security_group_id and',
'       page_mode = ''A'' and',
'       time_stamp >= sysdate - 2',
'     group by to_char(time_stamp,''YYYYMMDDHH24''),to_char(time_stamp,''mm/dd/yyyy'')',
'     order by 2 desc)'))
,p_items_value_column_name=>'EVENTS'
,p_items_label_column_name=>'SHORT_DATE_FORMAT'
,p_items_short_desc_column_name=>'DATE_TOOLTIP'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692992358838464149)
,p_chart_id=>wwv_flow_imp.id(692992186674464147)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'time-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692992481730464150)
,p_chart_id=>wwv_flow_imp.id(692992186674464147)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_step=>100
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'on'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(46754900978859248)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46754721279855631)
,p_button_name=>'REFRESH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(297663202145957383)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(46973210258249523)
,p_branch_action=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P14_VIEW'
,p_branch_condition_text=>'DAY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(21106400138500046)
,p_branch_action=>'f?p=&FLOW_ID.:14:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46754325341800080)
,p_name=>'P14_CURRENT_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(46754721279855631)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Time:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(sysdate,''DL FMTS'') d',
'from dual'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46972609781239990)
,p_name=>'P14_VIEW'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(46754721279855631)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HOUR'
,p_prompt=>'View'
,p_source=>'HOUR'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART SELECTOR'
,p_lov=>'.'||wwv_flow_imp.id(46971429951226857)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00015
begin
wwv_flow_imp_page.create_page(
 p_id=>15
,p_name=>'Session Activity by Hour'
,p_alias=>'SESSION-ACTIVITY-BY-HOUR'
,p_step_title=>'Session Activity by Hour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'04'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(692990466454464130)
,p_plug_name=>'Page views by hour over the last 48 hours'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_column=>1
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_footer=>'<p>Count of distinct sessions with page views over last 48 hours.  Hours displayed are based on the time of the server.</p>'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(692990595257464131)
,p_region_id=>wwv_flow_imp.id(692990466454464130)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(692990638467464132)
,p_chart_id=>wwv_flow_imp.id(692990595257464131)
,p_seq=>10
,p_name=>'Page Views'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_timestamp(r.long_date||'':00'',''YYYYMMDDHH24:MI'') long_date,',
'       r.short_date short_date,',
'       nvl(l.views,0) views',
'from   ',
'    (',
'    select ',
'       count(distinct session_id) views,',
'       to_char(time_stamp,''YYYYMMDDHH24'') long_date',
'     from   ',
'       WWV_FLOW_ACTIVITY_LOG l',
'     where',
'       security_group_id = :flow_security_group_id and',
'       page_mode != ''A'' and',
'       time_stamp >= sysdate - 2',
'     group by to_char(time_stamp,''YYYYMMDDHH24'')) l,',
'     (select to_char((select (sysdate-1)+((rnum)/24) from dual),''HH24'') hr,',
'     				 to_char((select (sysdate-2)+((rnum)/24) from dual),''YYYYMMDDHH24'') long_date,',
'                     to_char((select (sysdate-2)+((rnum)/24) from dual),''mm/dd/yyyy'') short_date,',
'     				 rnum',
'				from',
'				(select rownum rnum ',
'				   from sys.dba_objects ',
'				  where rownum < 49)) r',
' where l.long_date(+) = r.long_date',
' order by r.rnum'))
,p_max_row_count=>250
,p_items_value_column_name=>'VIEWS'
,p_items_label_column_name=>'LONG_DATE'
,p_items_short_desc_column_name=>'SHORT_DATE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692990756467464133)
,p_chart_id=>wwv_flow_imp.id(692990595257464131)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'time-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'on'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(692990871921464134)
,p_chart_id=>wwv_flow_imp.id(692990595257464131)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_imp_page.create_page(
 p_id=>16
,p_name=>'Session State Details'
,p_alias=>'SESSION-STATE-DETAILS'
,p_step_title=>'Session State Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_purge_session.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10298124982245880)
,p_plug_name=>'Session State'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       session_id flow_instance,',
'       item_name  i,',
'       item_value,',
'       session_state_status,',
'       application_id flow_id,',
'       application_name,',
'       page_id,',
'       page_name',
'  from wwv_flow_data_view',
' where session_id = :FLOW_SESSION'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10298231278245880)
,p_name=>'Session State'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10298425155245907)
,p_db_column_name=>'FLOW_INSTANCE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Session'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10298501271245908)
,p_db_column_name=>'I'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Item'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10298701631245908)
,p_db_column_name=>'SESSION_STATE_STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10298809834245908)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10300416585252734)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10302523080273547)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10303115939280913)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22411130140635457)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Item Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10299903771249069)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308130905536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'FLOW_INSTANCE:I:SESSION_STATE_STATUS:FLOW_ID:NAME_LENGTH:APPLICATION_NAME:PAGE_ID:PAGE_NAME:ITEM_VALUE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452409822478775583)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10298124982245880)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(174246003001070427)
,p_branch_action=>'16'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_imp_page.create_page(
 p_id=>17
,p_name=>'Set Workspace Preferences'
,p_alias=>'SET-WORKSPACE-PREFERENCES'
,p_step_title=>'Set Workspace Preferences'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="p17_checkdisable()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
'function p17_checkdisable(){ ',
'var ltext_0 = $x(''P17_EXPIRE_FND_USER_ACCOUNTS_0''); ',
'var ltext_1 = $x(''P17_EXPIRE_FND_USER_ACCOUNTS_1''); ',
'var ltext; ',
'if(ltext_0.checked == true){ltext = ltext_0}else{ltext = ltext_1} ',
'html_DisableOnValue(ltext,''N'',''P17_ACCOUNT_LIFETIME_DAYS'',''P17_USER_MAX_LOGIN_FAILURES'') ',
'} ',
'',
'//-->',
'</script>'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*apex.jQuery(''#P17_WORKSPACE_IMAGE ~ a'').each(function() {',
'    if (this.href.match(/apex_util.get_blob_file/)) {',
'        $x("public_workspace_img").src = this.href;',
'    }',
'});*/'))
,p_step_template=>wwv_flow_imp.id(692762523503114201)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_prefs.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1221407852620126)
,p_plug_name=>'Team Development'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1589815800325020)
,p_plug_name=>'Session Timeout'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5171608747872545)
,p_plug_name=>'Account Login Control'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5181326820057615)
,p_plug_name=>'Set Preferences'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Preferences control functionality for the workspace.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46267907729679029)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40275409253350646)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(113858225820003007)
,p_plug_name=>'Set Workspace Preferences'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--wizard:a-ButtonRegion--noUI:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(173246109288066858)
,p_plug_name=>'SQL Workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(173247816392106815)
,p_plug_name=>'App Builder'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(327482312829627868)
,p_plug_name=>'Team Development'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>Enabling file upload in Team Development will create an APEX$ table.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(113887204096053504)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(113858225820003007)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(113889631108061313)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(113858225820003007)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(113889809101061315)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(113889631108061313)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1221686539620128)
,p_name=>'P17_ALLOW_ISSUE_FILES_YN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1221407852620126)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Enable Issue File Repository'
,p_source=>'ALLOW_ISSUE_FILES_YN'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FILES_YN'')',
'    when ''Y'' then :P17_ALLOW_ISSUE_FILES_YN',
'    else ''N''',
'end;'))
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FILES_YN''), ''N'') = ''N'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to allow files to be uploaded into the Team Development central file repository. Select <strong>No</strong> to not allow files to be uploaded into the central repository. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1221742845620129)
,p_name=>'P17_ISSUE_FS_LIMIT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1221407852620126)
,p_use_cache_before_default=>'NO'
,p_item_default=>'nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Maximum Issue File Size (in MB)'
,p_source=>'ISSUE_FS_LIMIT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ISSUES_FS_LIMIT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_ISSUE_FS_LIMIT''),15728640)',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the maximum file size for any file uploaded into the Team Development central file repository.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1590413138325026)
,p_name=>'P17_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1589815800325020)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Session Length in Seconds'
,p_source=>'MAX_SESSION_LENGTH_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(1402706982624090)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines how long (in seconds) sessions can exist and be used by applications in this workspace. This setting is superseded by the corresponding application level setting.',
'',
'<ul>',
'    <li>Enter a positive integer to control how long a session can exist.</li>',
'    <li>Enter 0 to have sessions exist indefinitely.</li>',
'    <li>Leave the value empty in order to use the time defined at the instance level.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1590581631325027)
,p_name=>'P17_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1589815800325020)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Session Idle Time in Seconds'
,p_source=>'MAX_SESSION_IDLE_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(1402706982624090)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Session Idle Time is the time between the last page request and the next page request. This setting is superseded by the corresponding application level setting.',
'',
'<ul>',
'    <li>Enter a positive integer to control the default idle time for sessions used by applications in this workspace.</li>',
'    <li>Leave the value empty in order to use the idle time defined at the instance level.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1590607064325028)
,p_name=>'P17_SESSION_TIMEOUT_WARN_SEC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1589815800325020)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Session Timeout Warning in Seconds'
,p_source=>'SESSION_TIMEOUT_WARNING_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS_SMALL'
,p_lov=>'.'||wwv_flow_imp.id(1508766038293211)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The session timeout warning time defines (in seconds) how long before a session times out (either maximum session length, or maximum session idle time), to warn the user. For the maximum session idle time warning, the user will have the opportunit'
||'y to extend the session. For maximum session length warning, the user will be prompted to save any work, to avoid loss of data when the session maximum time is reached.</p>',
'<p>Note: This setting is superseded by the corresponding application level setting.</p>',
'<p>',
'    <ul>',
'        <li>Enter a positive integer to control the default idle time for sessions used by applications in this workspace.</li>',
'        <li>Enter 0 to switch off session timeout warnings for sessions used by applications in this workspace.</li>',
'        <li>Leave the value empty in order to use the warning time defined at instance level.</li>',
'    </ul>  ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4828217458002138)
,p_name=>'P17_EXPIRE_FND_USER_ACCOUNTS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5171608747872545)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Account Expiration and Locking:'
,p_source=>'EXPIRE_FND_USER_ACCOUNTS'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case',
'  when wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS'')=''Y'' then ''Y''',
'  else nvl(:P17_EXPIRE_FND_USER_ACCOUNTS,''N'')',
'end'))
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXPIRE USER ACCOUNTS'
,p_lov=>'.'||wwv_flow_imp.id(4834509455047185)||'.'
,p_tag_attributes=>'onchange="p17_checkdisable()"'
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS''),''N'') = ''Y'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Make a selection to determine whether &PRODUCT_NAME. end user accounts can be expired or locked. This feature applies only to',
'end-user accounts created using the &PRODUCT_NAME. user management interface.',
' Available options include:',
'<ul>',
'<li>Enable</li>',
'<li>Disable</li>',
'</ul>',
'This feature provides additional authentication security for applications.',
'If you select <strong>Enable</strong>, user account passwords will expire after a configurable time period,',
'accounts will be locked after a configurable number of authentication failures, and account passwords can be set to expire after the first use.',
'<p>',
'If the &PRODUCT_NAME. administrator for this installation has set the Environment Setting <strong>Require User Account Expiration and Locking</strong> to Yes, this means that the feature must be enabled for all workspaces and the item will display <s'
||'trong>Enable</strong> and cannot be changed by the workspace administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4829116550011426)
,p_name=>'P17_USER_MAX_LOGIN_FAILURES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5171608747872545)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl (',
'    wwv_flow_platform.get_preference(''MAX_LOGIN_FAILURES''),',
'    4 )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Maximum Login Failures Allowed:'
,p_source=>'FND_USER_MAX_LOGIN_FAILURES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>5
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a positive integer to be used as the maximum number of consecutive unsuccessful authentication attempts allowed before an end-user account is locked. If you do not specify a value in this field, the instance-level <strong>Maximum Login Failures'
||' Allowed</strong> Environment Setting will be used. If both instance-level and workspace-level preferences are specified, the lower of the two values will apply.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5483624971767521)
,p_name=>'P17_ACCOUNT_LIFETIME_DAYS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5171608747872545)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl (',
'    wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),',
'    45 )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'End User Account Lifetime (days):'
,p_source=>'ACCOUNT_LIFETIME_DAYS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a positive integer to be used as the maximum number of days an end-user account password may be used before the account is expired. If you do not specify a value in this field, the site-level <strong>Account Password Lifetime</strong> Environme'
||'nt Setting will be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8483028405465485)
,p_name=>'P17_PROVISIONING_COMPANY_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(113858225820003007)
,p_use_cache_before_default=>'NO'
,p_source=>'PROVISIONING_COMPANY_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(113919310002206635)
,p_name=>'P17_PLSQL_EDITING'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(173246109288066858)
,p_use_cache_before_default=>'NO'
,p_prompt=>'PL/SQL Editing:'
,p_source=>'ALLOW_PLSQL_EDITING'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case',
'  when wwv_flow_platform.get_preference(''PLSQL_EDITING'')=''N'' then ''N''',
'  else nvl(:P17_PLSQL_EDITING,''Y'')',
'end'))
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PLSQL EDITING STATUS'
,p_lov=>'.'||wwv_flow_imp.id(113937100137241641)||'.'
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''PLSQL_EDITING''),''Y'') = ''N'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Make a selection to determine whether developers have the ability to edit and compile PL/SQL program units from Object Browser. Available options include:',
'<ul>',
'<li>Allow PL/SQL program unit editing</li>',
'<li>Do not allow PL/SQL program unit editing</li>',
'</ul>',
'This feature is designed to discourage programmers from changing PL/SQL code directly from the Data Dictionary. If you select <strong>Do not allow PL/SQL program unit editing</strong>, developers can still create and replace PL/SQL program units usin'
||'g scripts or the SQL Command Processor.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173267514604352193)
,p_name=>'P17_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(173247816392106815)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Enable App Builder'
,p_source=>'ALLOW_APP_BUILDING_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to enable App Builder use and development for the current workspace. Select <strong>Yes</strong> or <strong>No</strong>.<br><br>',
'This setting also controls the availability of Productivity and Sample Applications for the current workspace.',
'Use App Builder to assemble an application on top of existing database objects such as tables and procedures.  Productivity applications are supported by Oracle.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173268016167390540)
,p_name=>'P17_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(173246109288066858)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Enable SQL Workshop'
,p_source=>'ALLOW_SQL_WORKSHOP_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to enable SQL Workshop in the current workspace. Select <strong>Yes</strong> or <strong>No</strong>.<br>',
'Use the SQL Workshop to access tools for viewing and managing database objects. '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173268926472412387)
,p_name=>'P17_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1221407852620126)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Enable Team Development'
,p_source=>'ALLOW_TEAM_DEVELOPMENT_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to enable Team Development in the current workspace. Select <strong>Yes</strong> or <strong>No</strong>.<br>',
'Team Development enables you to track and manage issues in a conversational fashion. You can classify issue using labels, assign users to issues, link an issue with milestones, and attach files to an issue.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(314428629679648088)
,p_name=>'P17_ALLOW_TEAM_DEV_FILES_YN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1221407852620126)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Enable Feedback File Repository'
,p_source=>'ALLOW_TEAM_DEV_FILES_YN'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FILES_YN'')',
'    when ''Y'' then :P17_ALLOW_TEAM_DEV_FILES_YN',
'    else ''N''',
'end;'))
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FILES_YN''), ''N'') = ''N'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to enable file upload for Feedback. Selecting <strong>Yes</strong> will',
'create a local APEX$ table to store the files.</p>',
'<p>This attribute can only be modified if the feature configuration "Enable Feedback File Repository"',
'is set to "Yes" in &PRODUCT_NAME. Administration Services.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(319101421909723145)
,p_name=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_imp.id(173246109288066858)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Enable RESTful Services'
,p_source=>'ALLOW_RESTFUL_SERVICES_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>'wwv_flow_platform.get_preference(''RESTFUL_SERVICES_ENABLED'') = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether to enable RESTful Services in the current workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(319102415427741291)
,p_name=>'P17_PATH_PREFIX'
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_imp.id(173246109288066858)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Path Prefix'
,p_source=>'PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'not wwv_flow_global.g_cloud'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the URI path prefix to be used to access RESTful Services in the current workspace. The default path prefix value is the name of the workspace.</p>',
'',
'<p>For example, a workspace named <strong>QA_1</strong> could have a path prefix set to <strong>QA</strong>. In this case, the sample RESTful service will be available at:</p>',
'',
'<p><code>https://www.example.com/apex<strong>/qa/</strong>hr/employees/</code></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529293356266976427)
,p_name=>'P17_MANUAL_PATH_PREFIX'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_imp.id(173246109288066858)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Override ORDS Schema Alias'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_pattern varchar2(255);',
'begin',
'    if wwv_flow_global.g_cloud then',
'        return false;',
'    end if;',
'    ',
'    begin',
'        l_pattern := wwv_flow_dynamic_exec.get_first_row_result_varchar2(',
'            p_sql_statement => ''select pattern',
'                                  from user_ords_schemas',
'                                 where upper(pattern) = upper(:P17_PATH_PREFIX)'',',
'            p_parse_as_schema => wwv_flow_user_api.get_default_schema );',
'            ',
'        if l_pattern is not null then ',
'            return true; ',
'        else',
'            return false;',
'        end if;',
'    exception',
'        when others then return false;',
'    end;',
'exception',
'    when others then return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    The default schema for this workspace is enabled for RESTful Services based on the Oracle REST Data Services (ORDS) Repository. A Schema Alias is configured in the ORDS metadata and it should only be changed within <strong>RESTful Services</stron'
||'g> in SQL Workshop. ',
'</p>',
'<p>',
'    Setting this switch to <strong>On</strong> allows you to override the REST Path Prefix only for the &PRODUCT_NAME. Repository. Oracle does <em>not</em> recommend to have different values for the ORDS Schema Alias and the &PRODUCT_NAME. Workspace '
||'Path Prefix.',
'</p>',
'<p>',
'  Unless advised otherwise, keep this switch set to <strong>Off</strong>.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(655281725315073604)
,p_name=>'P17_TEAM_DEV_FS_LIMIT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1221407852620126)
,p_use_cache_before_default=>'NO'
,p_item_default=>'nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Maximum Feedback File Size (in MB)'
,p_source=>'TEAM_DEV_FS_LIMIT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEAM_DEV_FS_LIMIT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the maximum file size for any file uploaded into the Feedback file repository. The default value is 15 MB.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(755295374237836819)
,p_name=>'P17_ALLOW_PACKAGED_APP_INS_YN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(173247816392106815)
,p_use_cache_before_default=>'NO'
,p_source=>'ALLOW_PACKAGED_APP_INS_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5488712607896482)
,p_computation_sequence=>10
,p_computation_item=>'P17_EXPIRE_FND_USER_ACCOUNTS'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS''),''N'') = ''Y''',
'  then return ''Y'';',
'else',
'  return v(''P17_EXPIRE_FND_USER_ACCOUNTS'');',
'end if;'))
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(620836494241373127)
,p_computation_sequence=>10
,p_computation_item=>'P17_PATH_PREFIX'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P17_PATH_PREFIX)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5225431816970359)
,p_validation_name=>'Expire FND User Accounts in Y/N or null'
,p_validation_sequence=>10
,p_validation=>'nvl(:P17_EXPIRE_FND_USER_ACCOUNTS,''N'') in (''Y'',''N'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Value out of range.'
,p_when_button_pressed=>wwv_flow_imp.id(113889631108061313)
,p_associated_item=>wwv_flow_imp.id(4828217458002138)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5500703800083172)
,p_validation_name=>'max login failures positive'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P17_USER_MAX_LOGIN_FAILURES );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_validation_condition=>'P17_USER_MAX_LOGIN_FAILURES'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(113889631108061313)
,p_associated_item=>wwv_flow_imp.id(4829116550011426)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5501825617089452)
,p_validation_name=>'account lifetime positive'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P17_ACCOUNT_LIFETIME_DAYS );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_validation_condition=>'P17_ACCOUNT_LIFETIME_DAYS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(113889631108061313)
,p_associated_item=>wwv_flow_imp.id(5483624971767521)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(319144900453128092)
,p_validation_name=>'Path Prefix Must Have Value'
,p_validation_sequence=>40
,p_validation=>'P17_PATH_PREFIX'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P17_ALLOW_SQL_WORKSHOP_YN = ''Y'' and :P17_ALLOW_RESTFUL_SERVICES_YN = ''Y'' and not wwv_flow_global.g_cloud'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(113889631108061313)
,p_associated_item=>wwv_flow_imp.id(319102415427741291)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(320869816918414854)
,p_validation_name=>'Path Prefix Already Exists'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1',
'             from wwv_flow_companies',
'            where path_prefix = upper(:P17_PATH_PREFIX)',
'             and provisioning_company_id <> :flow_security_group_id ) loop',
'   return false;',
'   exit;',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# already exists.'
,p_validation_condition=>':P17_ALLOW_SQL_WORKSHOP_YN = ''Y'' and :P17_ALLOW_RESTFUL_SERVICES_YN = ''Y'' and not wwv_flow_global.g_cloud'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(113889631108061313)
,p_associated_item=>wwv_flow_imp.id(319102415427741291)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(620836305429373126)
,p_validation_name=>'Restricted Path Prefix Characters'
,p_validation_sequence=>60
,p_validation=>'P17_PATH_PREFIX'
,p_validation2=>'^[ABCDEFGHIJKLMNOPQRSTUVWXYZ[:digit:]_-]+$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must only contain alphanumeric characters, or "-" or "_".'
,p_validation_condition=>':P17_ALLOW_SQL_WORKSHOP_YN = ''Y'' and :P17_ALLOW_RESTFUL_SERVICES_YN = ''Y'' and not wwv_flow_global.g_cloud'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(319102415427741291)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1406037678336507)
,p_validation_name=>'P17_MAX_SESSION_LENGTH_SEC is positive integer'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P17_MAX_SESSION_LENGTH_SEC is null ',
'       or to_number(:P17_MAX_SESSION_LENGTH_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(113889631108061313)
,p_associated_item=>wwv_flow_imp.id(1590413138325026)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1406124020336508)
,p_validation_name=>'P17_MAX_SESSION_IDLE_SEC is positive integer'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P17_MAX_SESSION_IDLE_SEC is null ',
'       or to_number(:P17_MAX_SESSION_IDLE_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(113889631108061313)
,p_associated_item=>wwv_flow_imp.id(1590581631325027)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1406276358336509)
,p_validation_name=>'P17_SESSION_TIMEOUT_WARN_SEC is positive integer'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P17_SESSION_TIMEOUT_WARN_SEC is null ',
'       or to_number(:P17_SESSION_TIMEOUT_WARN_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_when_button_pressed=>wwv_flow_imp.id(113889631108061313)
,p_associated_item=>wwv_flow_imp.id(1590607064325028)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504160631041512755)
,p_name=>'Set PL/SQL Editing'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_SQL_WORKSHOP_YN'
,p_condition_element=>'P17_ALLOW_SQL_WORKSHOP_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504160921379512755)
,p_event_id=>wwv_flow_imp.id(504160631041512755)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PLSQL_EDITING'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(319137025988009917)
,p_event_id=>wwv_flow_imp.id(504160631041512755)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504161117126512756)
,p_event_id=>wwv_flow_imp.id(504160631041512755)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PLSQL_EDITING'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(319137222968011341)
,p_event_id=>wwv_flow_imp.id(504160631041512755)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_RESTFUL_SERVICES_YN,P17_PATH_PREFIX'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(321989200019520191)
,p_event_id=>wwv_flow_imp.id(504160631041512755)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P17_ALLOW_RESTFUL_SERVICES_YN = ''N'' then',
'  return ''Y'';',
'end if;'))
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(321953223841387573)
,p_event_id=>wwv_flow_imp.id(504160631041512755)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(319105500624780088)
,p_name=>'REST = Yes'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_condition_element=>'P17_ALLOW_RESTFUL_SERVICES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(319147932500219616)
,p_event_id=>wwv_flow_imp.id(319105500624780088)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PATH_PREFIX'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(319106230675780091)
,p_event_id=>wwv_flow_imp.id(319105500624780088)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PATH_PREFIX'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(655281866528073605)
,p_name=>'Show/Hide P17_TEAM_DEV_FS_LIMIT'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_TEAM_DEV_FILES_YN'
,p_condition_element=>'P17_ALLOW_TEAM_DEV_FILES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(655281943393073606)
,p_event_id=>wwv_flow_imp.id(655281866528073605)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_TEAM_DEV_FS_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(655282003570073607)
,p_event_id=>wwv_flow_imp.id(655281866528073605)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_TEAM_DEV_FS_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(763672849397287394)
,p_name=>'App Builder Setting Updates Prod and Sample Apps setting'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_APP_BUILDING_YN'
,p_condition_element=>'P17_ALLOW_APP_BUILDING_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(763673102850287396)
,p_event_id=>wwv_flow_imp.id(763672849397287394)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_PACKAGED_APP_INS_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(763673738110292514)
,p_event_id=>wwv_flow_imp.id(763672849397287394)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_PACKAGED_APP_INS_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(529293549089976429)
,p_name=>'Show Hide Path Prefix'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_MANUAL_PATH_PREFIX'
,p_condition_element=>'P17_MANUAL_PATH_PREFIX'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(529293648787976430)
,p_event_id=>wwv_flow_imp.id(529293549089976429)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(529293824678976432)
,p_event_id=>wwv_flow_imp.id(529293549089976429)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1221801671620130)
,p_name=>'Hide/Show Issue File Size'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_ISSUE_FILES_YN'
,p_condition_element=>'P17_ALLOW_ISSUE_FILES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1221961000620131)
,p_event_id=>wwv_flow_imp.id(1221801671620130)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ISSUE_FS_LIMIT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1222032644620132)
,p_event_id=>wwv_flow_imp.id(1221801671620130)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ISSUE_FS_LIMIT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(150596498043090708)
,p_name=>'Hide/show File Repo Items'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_ALLOW_TEAM_DEVELOPMENT_YN'
,p_condition_element=>'P17_ALLOW_TEAM_DEVELOPMENT_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150596537207090709)
,p_event_id=>wwv_flow_imp.id(150596498043090708)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_ISSUE_FILES_YN,P17_ALLOW_TEAM_DEV_FILES_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150596715458090711)
,p_event_id=>wwv_flow_imp.id(150596498043090708)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_ALLOW_ISSUE_FILES_YN,P17_ISSUE_FS_LIMIT,P17_TEAM_DEV_FS_LIMIT,P17_ALLOW_TEAM_DEV_FILES_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150596848658090712)
,p_event_id=>wwv_flow_imp.id(150596498043090708)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(''P17_ALLOW_ISSUE_FILES_YN'')==''Y'') {',
'   $x_Show(''P17_ISSUE_FS_LIMIT'');',
'}',
'',
'if ($v(''P17_ALLOW_TEAM_DEV_FILES_YN'')==''Y'') {',
'   $x_Show(''P17_TEAM_DEV_FS_LIMIT'');',
'}',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3301819794507903)
,p_name=>'toggle label and color'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P17_BANNER_ENABLE'
,p_condition_element=>'P17_BANNER_ENABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3301922574507904)
,p_event_id=>wwv_flow_imp.id(3301819794507903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_BANNER_LABEL,P17_BANNER_COLOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3302093196507905)
,p_event_id=>wwv_flow_imp.id(3301819794507903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P17_BANNER_LABEL,P17_BANNER_COLOR'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(113888522450058819)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'override with instance settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS'')=''Y'' then',
'    :P17_EXPIRE_FND_USER_ACCOUNTS := ''Y'';',
'end if;',
'',
'if wwv_flow_platform.get_preference(''PLSQL_EDITING'') = ''N'' then',
'    :P17_PLSQL_EDITING := ''N'';',
'end if;',
'',
'if wwv_flow_platform.get_preference(''RESTFUL_SERVICES_ENABLED'') = ''N'' then',
'    :P17_ALLOW_RESTFUL_SERVICES_YN := ''N'';',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to apply workspace preferences.'
,p_process_when_button_id=>wwv_flow_imp.id(113889631108061313)
,p_process_success_message=>'Workspace preferences applied.'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
,p_internal_uid=>113888522450058819
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8487030576522859)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Save WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P17_PROVISIONING_COMPANY_ID'
,p_attribute_04=>'PROVISIONING_COMPANY_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(113889631108061313)
,p_process_when=>':P17_PROVISIONING_COMPANY_ID = wwv_flow_security.g_security_group_id'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>8487030576522859
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(317482715965499118)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create team dev file table'
,p_process_sql_clob=>'wwv_flow_team_file.install(p_filesize_quota => :P17_TEAM_DEV_FS_LIMIT);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create APEX$TEAM_DEV_FILE table'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(113889631108061313)
,p_process_when=>'P17_ALLOW_TEAM_DEV_FILES_YN'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_internal_uid=>317482715965499118
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8492310799564500)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set provisioning_company_id'
,p_process_sql_clob=>':P17_PROVISIONING_COMPANY_ID := wwv_flow_security.g_security_group_id;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_internal_uid=>8492310799564500
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9046701053701699)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'fetch wwv_flow_companies'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P17_PROVISIONING_COMPANY_ID'
,p_attribute_04=>'PROVISIONING_COMPANY_ID'
,p_attribute_14=>'N'
,p_internal_uid=>9046701053701699
);
end;
/
prompt --application/pages/page_00018
begin
wwv_flow_imp_page.create_page(
 p_id=>18
,p_name=>'Application Changes by Day'
,p_alias=>'APPLICATION-CHANGES-BY-DAY'
,p_step_title=>'Application Changes by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9837022786686597)
,p_plug_name=>'Developer activity by day'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P18a */',
'         day, to_char(day,''Day'') day_of_week, to_char(day,''Month'') month_of_year, sum(application_changes) application_changes, count(distinct flow_user) developers,',
'100 * (sum(application_changes) / nvl(max(c.total_views),1)) pct,',
'round(100 * (sum(application_changes) / nvl(max(c.total_views),1)))  graph',
'from',
'(',
'select trunc(audit_date) day, flow_user, count(*) application_changes',
'          from wwv_flow_builder_audit_trail',
'         where security_group_id = :flow_security_group_id and',
'     audit_date >= sysdate - :P18_SINCE',
'         group by trunc(audit_date), flow_user',
'         ) x,',
'(select count(*) total_views ',
' from wwv_flow_builder_audit_trail',
' where security_group_id = :flow_security_group_id and',
'     audit_date >= sysdate - :P18_SINCE and',
'     (nvl(:P18_APPLICATION,0) = 0 or flow_id = :P18_APPLICATION)',
') c',
'group by day'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9837112284686597)
,p_name=>'Developer activity by day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9837326990686601)
,p_db_column_name=>'DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT.'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9837516879686602)
,p_db_column_name=>'DEVELOPERS'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Developers'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9837410597686601)
,p_db_column_name=>'APPLICATION_CHANGES'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Component Changes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9837607047686602)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9837709593686602)
,p_db_column_name=>'GRAPH'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:150'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9840017550720187)
,p_db_column_name=>'DAY_OF_WEEK'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Day'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9840115860720188)
,p_db_column_name=>'MONTH_OF_YEAR'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Month'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9838006075688458)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308213413536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DAY_OF_WEEK:MONTH_OF_YEAR:DAY:DEVELOPERS:APPLICATION_CHANGES:PCT:GRAPH'
,p_sort_column_1=>'DAY'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47680424022294433)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201288915809201314)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47680424022294433)
,p_button_name=>'P18_SET'
,p_button_static_id=>'P18_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'APPLY_CHANGES'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201288706805198715)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47680424022294433)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:18,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22676605669426783)
,p_branch_action=>'f?p=&FLOW_ID.:18:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9845330691922599)
,p_name=>'P18_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47680424022294433)
,p_item_default=>'7'
,p_prompt=>'Since'
,p_source=>'7'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47687424293389127)
,p_name=>'P18_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47680424022294433)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_imp_page.create_page(
 p_id=>19
,p_name=>'Session Detail'
,p_alias=>'SESSION-DETAIL'
,p_step_title=>'Session Detail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762523503114201)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_sessions.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2320826139424433)
,p_plug_name=>'Background Processing'
,p_region_name=>'background_processing'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>54
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when e.status in ( ''SCHEDULED'', ''EXECUTING'', ''ENQUEUED'' ) then e.id end as terminate_button,',
'       e.id,',
'       e.flow_id,',
'       e.page_id,',
'       p.process_name      bg_process_name,',
'       cp.process_name     child_process_name,',
'       e.cloned_work_session_id,    ',
'       e.status,',
'       e.sofar,',
'       e.totalwork,',
'       e.created_on,',
'       e.last_updated_on',
'  from wwv_flow_step_processing p,',
'       wwv_flow_step_processing cp,',
'       wwv_flow_process_bg_execs$ e',
' where p.security_group_id       = e.security_group_id',
'   and p.flow_id                 = e.flow_id',
'   and p.id                      = e.process_id',
'    --',
'   and cp.security_group_id (+)     = e.security_group_id',
'   and cp.flow_id           (+)     = e.flow_id',
'   and cp.id                (+)     = e.current_exec_process_id',
'    --      ',
'   and e.security_group_id       = :FLOW_SECURITY_GROUP_ID',
'   and e.started_from_session_id = :P19_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Background Processing'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2320937944424434)
,p_no_data_found_message=>'No background executions found for this session.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_filter=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CCZARSKI'
,p_internal_uid=>2320937944424434
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1867500035911710)
,p_db_column_name=>'ID'
,p_display_order=>20
,p_column_identifier=>'Y'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1867668960911711)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>30
,p_column_identifier=>'Z'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1867798832911712)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>40
,p_column_identifier=>'AA'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1867895034911713)
,p_db_column_name=>'BG_PROCESS_NAME'
,p_display_order=>50
,p_column_identifier=>'AB'
,p_column_label=>'Background Process'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1867969420911714)
,p_db_column_name=>'CHILD_PROCESS_NAME'
,p_display_order=>60
,p_column_identifier=>'AC'
,p_column_label=>'Currently Executing '
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1868557401911720)
,p_db_column_name=>'CLONED_WORK_SESSION_ID'
,p_display_order=>70
,p_column_identifier=>'AI'
,p_column_label=>'Work Session ID'
,p_column_link=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:RR,:P19_ID:#CLONED_WORK_SESSION_ID#'
,p_column_linktext=>'#CLONED_WORK_SESSION_ID#'
,p_column_link_attr=>'title="Go to Session #CLONED_WORK_SESSION_ID#"'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1868059587911715)
,p_db_column_name=>'STATUS'
,p_display_order=>80
,p_column_identifier=>'AD'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1912672796968628)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1868173883911716)
,p_db_column_name=>'SOFAR'
,p_display_order=>90
,p_column_identifier=>'AE'
,p_column_label=>'So far'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1868289277911717)
,p_db_column_name=>'TOTALWORK'
,p_display_order=>100
,p_column_identifier=>'AF'
,p_column_label=>'Total work'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1869524995911730)
,p_db_column_name=>'TERMINATE_BUTTON'
,p_display_order=>110
,p_column_identifier=>'AJ'
,p_column_label=>'Action'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if ?TERMINATE_BUTTON/}',
'<button data-terminate-id="#ID#" data-terminate-app-id="#FLOW_ID#" type="button" title="Terminate Execution ID #ID#" aria-label="Terminate Execution ID #ID#" class="a-Button a-Button--danger a-Button--small terminate-execution">',
'        <span aria-hidden="true">Terminate</span>',
'</button>',
'{endif/}',
'',
''))
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1868329314911718)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>120
,p_column_identifier=>'AG'
,p_column_label=>'Started'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1868434237911719)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>130
,p_column_identifier=>'AH'
,p_column_label=>'Last Change'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1864181896892539)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'19804'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:FLOW_ID:PAGE_ID:BG_PROCESS_NAME:CHILD_PROCESS_NAME:CLONED_WORK_SESSION_ID:STATUS:SOFAR:TOTALWORK:CREATED_ON:LAST_UPDATED_ON:TERMINATE_BUTTON:'
,p_sort_column_1=>'LAST_UPDATED_ON'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22420117774719228)
,p_plug_name=>'Session State Item Values'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>64
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select session_id,',
'       item_name,',
'       item_value,',
'       session_state_status,',
'       application_id application',
'  from wwv_flow_data_view',
' where session_id        = :P19_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(22420231632719228)
,p_name=>'Session State Item Values'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22420407165719244)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Session ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22420517867719244)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Item Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22420626985719244)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Item Value'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22420714744719244)
,p_db_column_name=>'SESSION_STATE_STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22420820054719244)
,p_db_column_name=>'APPLICATION'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(22421025778719420)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308314352536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SESSION_ID:ITEM_NAME:ITEM_VALUE:SESSION_STATE_STATUS:APPLICATION'
,p_sort_column_1=>'APPLICATION'
,p_sort_direction_1=>'ASC NULLS FIRST'
,p_sort_column_2=>'ITEM_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(167635406631549268)
,p_plug_name=>'Session Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>34
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(167911012318802431)
,p_plug_name=>'Page Views'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>44
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.time_stamp,  ',
'       l.elap,  ',
'       l.flow_id                  application,',
'       (select name ',
'          from wwv_flows ',
'        where id = l.flow_id)     application_name,  ',
'       l.step_id                  page, ',
'       p.name                     page_name,',
'       num_rows                   rows_processed,',
'       l.page_view_type,',
'       l.request_value,',
'       l.debug_page_view_id,',
'       l.sqlerrm,',
'       l.ecid',
'  from wwv_flow_activity_log l,',
'       wwv_flow_steps p',
' where l.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and p.id                = l.step_id',
'   and p.flow_id           = l.flow_id',
'    --',
'   and l.session_id        = :P19_ID',
' order by l.time_stamp desc'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_plug_customized=>'1'
,p_plug_customized_name=>'Show Page Views Report'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(370270886963630406)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'15'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CHRISTIAN'
,p_internal_uid=>370270886963630406
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370270968790630407)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Page View'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271085137630408)
,p_db_column_name=>'ELAP'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271113707630409)
,p_db_column_name=>'APPLICATION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271243588630410)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271325538630411)
,p_db_column_name=>'PAGE'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271444106630412)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271557928630413)
,p_db_column_name=>'ROWS_PROCESSED'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Rows Processed'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271636847630414)
,p_db_column_name=>'PAGE_VIEW_TYPE'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Page View Type'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1569139039593351202)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271796589630415)
,p_db_column_name=>'REQUEST_VALUE'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Request Value'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271871497630416)
,p_db_column_name=>'DEBUG_PAGE_VIEW_ID'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Debug ID'
,p_column_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:RP,24:P24_PAGE_VIEW_ID:#DEBUG_PAGE_VIEW_ID#'
,p_column_linktext=>'#DEBUG_PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370271955763630417)
,p_db_column_name=>'SQLERRM'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9163910229091028)
,p_db_column_name=>'ECID'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'ECID'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(370313089353766715)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'3703131'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>15
,p_report_columns=>'TIME_STAMP:ELAP:APPLICATION:APPLICATION_NAME:PAGE:PAGE_NAME:ROWS_PROCESSED:PAGE_VIEW_TYPE:REQUEST_VALUE:DEBUG_PAGE_VIEW_ID:SQLERRM:'
,p_sort_column_1=>'TIME_STAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(173534120886956086)
,p_name=>'Browser Information'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>74
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select min(user_agent) user_agent',
'  from wwv_flow_activity_log',
' where session_id         = :P19_ID ',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and user_agent        is not null'))
,p_customized=>'1'
,p_customized_name=>'Browser Information'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Browser Information found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(173534427356956091)
,p_query_column_id=>1
,p_column_alias=>'USER_AGENT'
,p_column_display_sequence=>1
,p_column_heading=>'User Agent'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(370270399737630401)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40275409253350646)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(370270418652630402)
,p_plug_name=>'Session &P19_ID.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(370270758542630405)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'Use this page to inspect session information and enable session instrumentation.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(370270600890630404)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(370270418652630402)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:RP,7,19::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(370270504762630403)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(370270418652630402)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(23466390469366202)
,p_branch_name=>'Go To Page 7'
,p_branch_action=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  1',
'  from  wwv_flow_sessions$',
' where  id                  = :P19_ID',
'   and  security_group_id   = :FLOW_SECURITY_GROUP_ID'))
,p_branch_comment=>'Redirect to page 7 if the session no longer exists.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1868611887911721)
,p_name=>'P19_EXECUTION_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1869263999911727)
,p_name=>'P19_EXECUTION_APP_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(167636715289551739)
,p_name=>'P19_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Session ID'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(265417466045318138)
,p_name=>'P19_CREATED_ON'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Created'
,p_format_mask=>'SINCE'
,p_source=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(265417543246318139)
,p_name=>'P19_USERNAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Username'
,p_source=>'USERNAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(265417990532318143)
,p_name=>'P19_SESSION_TIME_ZONE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Zone'
,p_source=>'SESSION_TIME_ZONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(265418061774318144)
,p_name=>'P19_SESSION_LANG'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Language'
,p_source=>'SESSION_LANG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(265418121288318145)
,p_name=>'P19_SESSION_TERRITORY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Territory'
,p_source=>'SESSION_TERRITORY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(265418292059318146)
,p_name=>'P19_DEBUG_LEVEL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Debug Level'
,p_source=>'DEBUG_LEVEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DEBUG_LEVEL'
,p_lov=>'.'||wwv_flow_imp.id(370258657315557256)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Disabled'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(265418369440318147)
,p_name=>'P19_TRACE_MODE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Trace Mode'
,p_source=>'TRACE_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION_TRACE_MODE'
,p_lov=>'.'||wwv_flow_imp.id(370223717115128950)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Disabled'
,p_cHeight=>1
,p_display_when=>'nvl(wwv_flow_platform.get_preference(''TRACING_ENABLED''),''Y'') = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(370272835189630426)
,p_name=>'P19_LIFE_TIMEOUT_ON'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Life Timeout'
,p_format_mask=>'SINCE'
,p_source=>'LIFE_TIMEOUT_ON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(370272953055630427)
,p_name=>'P19_IDLE_TIMEOUT_ON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(167635406631549268)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idle Timeout'
,p_format_mask=>'SINCE'
,p_source=>'IDLE_TIMEOUT_ON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1868724179911722)
,p_name=>'Terminate Execution by Click'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.terminate-execution'
,p_bind_type=>'live'
,p_bind_delegate_to_selector=>'#background_processing'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1868815993911723)
,p_event_id=>wwv_flow_imp.id(1868724179911722)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Do you really want to terminate this background execution?',
''))
,p_attribute_03=>'danger'
,p_attribute_06=>'Terminate'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1868957223911724)
,p_event_id=>wwv_flow_imp.id(1868724179911722)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Set Value: P19_EXECUTION_ID'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P19_EXECUTION_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$( this.triggeringElement ).data( "terminate-id" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1869444743911729)
,p_event_id=>wwv_flow_imp.id(1868724179911722)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Set Value: P19_EXECUTION_APP_ID'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P19_EXECUTION_APP_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$( this.triggeringElement ).data( "terminate-app-id" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1869079801911725)
,p_event_id=>wwv_flow_imp.id(1868724179911722)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'TERMINATE_EXECUTION'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(265418580158318149)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Update Session'
,p_attribute_02=>'WWV_FLOW_SESSIONS$'
,p_attribute_03=>'P19_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(370270504762630403)
,p_process_success_message=>'Session Updated.'
,p_internal_uid=>265418580158318149
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1869118035911726)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Terminate Execution'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_process_bg.abort(',
'        p_security_group_id => :FLOW_SECURITY_GROUP_ID,         ',
'        p_application_id    => :P19_EXECUTION_APP_ID,',
'        p_execution_id      => :P19_EXECUTION_ID );',
'end;',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'TERMINATE_EXECUTION'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Background Execution ID &P19_EXECUTION_ID. terminated.'
,p_internal_uid=>1869118035911726
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(265418480221318148)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Session'
,p_attribute_02=>'WWV_FLOW_SESSIONS$'
,p_attribute_03=>'P19_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>265418480221318148
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_imp_page.create_page(
 p_id=>20
,p_name=>'Application Changes by Day'
,p_alias=>'APPLICATION-CHANGES-BY-DAY1'
,p_step_title=>'Application Changes by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'08'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47681802813307159)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47721915411670378)
,p_plug_name=>'monitor activity / calendar views'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47721323591663284)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1119155357036390616)
,p_plug_name=>'Changes by Developer'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P20a */',
'  trunc(audit_date) audit_date,',
'  lower(flow_user) || '' ('' || to_char(count(*),''FM999G999G999G999G990'') || '')'' as display_title',
'from wwv_flow_builder_audit_trail',
'where security_group_id = :flow_security_group_id and',
'   (nvl(:P20_APPLICATION,0) = 0 or flow_id = :P20_APPLICATION) and',
'   audit_date > sysdate - nvl(:P20_SINCE,45)',
'group by trunc(audit_date), flow_user',
'order by 1, 2'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'additional_calendar_views', 'navigation',
  'display_column', 'DISPLAY_TITLE',
  'maximum_events_day', '10',
  'multiple_line_event', 'Y',
  'show_time', 'N',
  'show_tooltip', 'N',
  'show_weekend', 'Y',
  'start_date_column', 'AUDIT_DATE')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450754120469577083)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47681802813307159)
,p_button_name=>'P20_GO'
,p_button_static_id=>'P20_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47707423582587524)
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47705414400547071)
,p_name=>'P20_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47681802813307159)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'45'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47706119595548538)
,p_name=>'P20_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47681802813307159)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00021
begin
wwv_flow_imp_page.create_page(
 p_id=>21
,p_name=>'Manage Service'
,p_alias=>'MANAGE-SERVICE'
,p_step_title=>'Manage Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215667724760013351)
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_deep_linking=>'Y'
,p_help_text=>'AEADM/aadm_mg_service.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10332709377780494)
,p_plug_name=>'Manage Meta Data'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(47244730835700645)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41760803829239203)
,p_plug_name=>'Manage Service'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--noBadge:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(41758527939236654)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42491430107461218)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the Manage Service page to manage service requests, configure workspace preferences, edit announcements, view reports, clear log files and cached content, manage workspace metadata.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(42494607906502196)
,p_name=>'Workspace Schemas'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select schema',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47025022336023416)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(42494607906502196)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(42494926575502200)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47052711371922266)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47255117001847942)
,p_name=>'Service'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    :company workspace_name,',
'(',
'select trim(to_char(count(*),''999G999G999G999G990'')) c',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
') as applications,',
'(',
'select count(*)',
'  from wwv_flow_files f, wwv_flow_fnd_user u',
' where u.security_group_id = :flow_security_group_id',
'   and u.user_name = :APP_USER',
'   and f.file_type = ''SCRIPT''',
') as sql_scripts,',
'(',
'select count(*)',
'  from wwv_flow_company_schemas',
' where security_group_id = :flow_security_group_id',
') as schemas,',
'--',
'(select sum(open_requests)',
'from',
'(',
'select count(*) open_requests',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id and',
'      project_status = ''REQUESTED''',
'union all',
'select count(*) open_requests',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      m.request_status = ''REQUESTED''',
') q ) open_requests',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47255310491847944)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47255925410847950)
,p_query_column_id=>2
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47463231074646060)
,p_query_column_id=>3
,p_column_alias=>'SQL_SCRIPTS'
,p_column_display_sequence=>5
,p_column_heading=>'SQL Scripts'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47463017568642176)
,p_query_column_id=>4
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>6
,p_column_heading=>'Schemas'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47470904838902402)
,p_query_column_id=>5
,p_column_alias=>'OPEN_REQUESTS'
,p_column_display_sequence=>7
,p_column_heading=>'Open Requests'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47470232749892527)
,p_name=>'Recent Service Requests'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    wwv_flow_lang.system_message(''WORKSPACE_REQUEST'') ||'' - ''|| wwv_flow_item.text_from_lov(project_status,''REQUEST_STATUSES'') || '' - '' ||',
'    DATABASE_SIZE||''MB'' the_request,',
'    request_date',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''CHANGE_REQUEST'')||'' ''||m.service_name ||'' - ''||wwv_flow_item.text_from_lov(m.request_status,''REQUEST_STATUSES'')||'' - ''||',
'       m.service_attribute_1 the_request,',
'       m.requested_on',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id',
'order by 2 desc '))
,p_display_when_condition=>'not wwv_flow_global.g_cloud'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47470426188892527)
,p_query_column_id=>1
,p_column_alias=>'THE_REQUEST'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47470505834892527)
,p_query_column_id=>2
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168449430106381735)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'21'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00022
begin
wwv_flow_imp_page.create_page(
 p_id=>22
,p_name=>'Monitor Activity'
,p_alias=>'MONITOR-ACTIVITY'
,p_step_title=>'Monitor Activity'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(868317340432334)
,p_plug_name=>'Page Views'
,p_icon_css_classes=>'icon-util-page-views'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1029955071738136284)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(61339238287578026)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(882110638496600)
,p_plug_name=>'Page View Analysis'
,p_icon_css_classes=>'icon-database-object'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1029955071738136284)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_imp.id(882616872498402)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9786901912561394)
,p_plug_name=>'Application Errors'
,p_icon_css_classes=>'icon-util-bugs'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1029955071738136284)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_imp.id(9787313686564805)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22852102269006022)
,p_plug_name=>'Developer Activity'
,p_icon_css_classes=>'icon-util-developer-activity'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1029955071738136284)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(22853420277011168)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26365204158918140)
,p_plug_name=>'Login Attempts'
,p_icon_css_classes=>'icon-util-login-attempts'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1029955071738136284)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(26405214790138770)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46999427470822221)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(56636630435030858)
,p_plug_name=>'Environment'
,p_icon_css_classes=>'icon-util-attribute-dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1029955071738136284)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(56633624548029155)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162250516888792819)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(167618427091432137)
,p_plug_name=>'Sessions'
,p_icon_css_classes=>'icon-util-recent-sessions'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1029955071738136284)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(167617332155424156)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168441310760704445)
,p_plug_name=>'Workspace Schema & Other Reports'
,p_icon_css_classes=>'icon-util-attribute-dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1029955071738136284)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(4869427763068324)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--rightBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(466730619047324921)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page contains links to reports and charts that enable you to monitor user and developer activity.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1042393970073998159)
,p_plug_name=>'Archived Activity Reports'
,p_icon_css_classes=>'icon-database-object'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1029955071738136284)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(162256322822822923)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(167828924727656009)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(162250516888792819)
,p_button_name=>'VIEW_DASHBOARD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'View Dashboard'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47753609495141634)
,p_branch_action=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00023
begin
wwv_flow_imp_page.create_page(
 p_id=>23
,p_name=>'Application Changes by Developer by Hour'
,p_alias=>'APPLICATION-CHANGES-BY-DEVELOPER-BY-HOUR'
,p_step_title=>'Application Changes by Developer by Hour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1766905126878061686)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1770620027781703754)
,p_plug_name=>'Application Changes by Developer by Hour'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as',
'(',
'select /* APEX4350P23a */ count(*) tpv',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p23_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (:P23_APPLICATION = 0 or flow_id = :P23_APPLICATION)',
')',
'select the_date,',
'       developer, ',
'       page_views,',
'pages_visited,',
'distinct_applications,',
'''<div class="hour-graph">''||',
'''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-value"'
||'>''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-value"'
||'>''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-value"'
||'>''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-value"'
||'>''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-value"'
||'>''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-value"'
||'>''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-value"'
||'>''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-value"'
||'>''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-value"'
||'>''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-value"'
||'>''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-value"'
||'>''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-value"'
||'>''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-value"'
||'>''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-value"'
||'>''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-value"'
||'>''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-value"'
||'>''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-value"'
||'>''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-value"'
||'>''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-value"'
||'>''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-value"'
||'>''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-value"'
||'>''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-value"'
||'>''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-value"'
||'>''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-value"'
||'>''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'''</div>'' hours',
'from',
'(',
'select ',
'    trunc(audit_date) the_date,',
'  flow_user developer,',
'  count(*) page_views,',
'  count(distinct(page_id)) pages_visited,',
'  count(distinct(flow_id)) distinct_applications,',
'  sum(decode(to_char(audit_date,''HH24''),0,1,0)) h00,',
'  sum(decode(to_char(audit_date,''HH24''),1,1,0)) h01,',
'  sum(decode(to_char(audit_date,''HH24''),2,1,0)) h02,',
'  sum(decode(to_char(audit_date,''HH24''),3,1,0)) h03,',
'  sum(decode(to_char(audit_date,''HH24''),4,1,0)) h04,',
'  sum(decode(to_char(audit_date,''HH24''),5,1,0)) h05,',
'  sum(decode(to_char(audit_date,''HH24''),6,1,0)) h06,',
'  sum(decode(to_char(audit_date,''HH24''),7,1,0)) h07,',
'  sum(decode(to_char(audit_date,''HH24''),8,1,0)) h08,',
'  sum(decode(to_char(audit_date,''HH24''),9,1,0)) h09,',
'  sum(decode(to_char(audit_date,''HH24''),10,1,0)) h10,',
'  sum(decode(to_char(audit_date,''HH24''),11,1,0)) h11,',
'  sum(decode(to_char(audit_date,''HH24''),12,1,0)) h12,',
'  sum(decode(to_char(audit_date,''HH24''),13,1,0)) h13,',
'  sum(decode(to_char(audit_date,''HH24''),14,1,0)) h14,',
'  sum(decode(to_char(audit_date,''HH24''),15,1,0)) h15,',
'  sum(decode(to_char(audit_date,''HH24''),16,1,0)) h16,',
'  sum(decode(to_char(audit_date,''HH24''),17,1,0)) h17,',
'  sum(decode(to_char(audit_date,''HH24''),18,1,0)) h18,',
'  sum(decode(to_char(audit_date,''HH24''),19,1,0)) h19,',
'  sum(decode(to_char(audit_date,''HH24''),20,1,0)) h20,',
'  sum(decode(to_char(audit_date,''HH24''),21,1,0)) h21,',
'  sum(decode(to_char(audit_date,''HH24''),22,1,0)) h22,',
'  sum(decode(to_char(audit_date,''HH24''),23,1,0)) h23',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:p23_time,1) and ',
'  security_group_id = :flow_security_group_id and',
'  (:P23_APPLICATION = 0 or flow_id = :P23_APPLICATION)',
'group by ',
'  flow_user, trunc(audit_date)',
') d, ',
'  total_page_views,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.APPCHANGES'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m',
'  '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1770620126131703754)
,p_name=>'Application Changes by Developer'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1770620126131703754
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(756684373254357823)
,p_db_column_name=>'THE_DATE'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Day'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760793840281373040)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760794295093373041)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Component Changes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760795409411373043)
,p_db_column_name=>'PAGES_VISITED'
,p_display_order=>40
,p_column_identifier=>'F'
,p_column_label=>'Distinct Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760795833804373043)
,p_db_column_name=>'DISTINCT_APPLICATIONS'
,p_display_order=>50
,p_column_identifier=>'G'
,p_column_label=>'Distinct Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760796276224373044)
,p_db_column_name=>'HOURS'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>'Activity by Hour'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1770621038018704103)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'17607966'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'THE_DATE:DEVELOPER:HOURS:'
,p_sort_column_1=>'THE_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'PAGE_VIEWS'
,p_sort_direction_2=>'DESC'
,p_break_on=>'THE_DATE:0:0:0:0:0'
,p_break_enabled_on=>'THE_DATE:0:0:0:0:0'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1760790628228372995)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1766905126878061686)
,p_button_name=>'P23_SET'
,p_button_static_id=>'P8_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1760791063081373001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1766905126878061686)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_redirect_url=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:8,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1760797413294373078)
,p_branch_action=>'f?p=&FLOW_ID.:23:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1760791473437373006)
,p_name=>'P23_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1766905126878061686)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'to_number(.25)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1760792302886373021)
,p_name=>'P23_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1766905126878061686)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cHeight=>1
,p_tag_attributes=>'style="max-width:200px"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00024
begin
wwv_flow_imp_page.create_page(
 p_id=>24
,p_name=>'Debug Messages'
,p_alias=>'DEBUG-MESSAGES'
,p_step_title=>'Debug Messages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-IRR-table td {',
'    padding: 4px 8px;',
'}',
'.a-IRR-table td[headers=pct] {',
'    max-width: 120px;',
'}',
'.a-IRR-table td[headers=message] {',
'    max-width: 600px;',
'    overflow-x: auto;',
'}',
'pre {',
'    font-size: 11px;',
'    line-height: 14px;',
'    margin: 0;',
'}',
'.l1, .l2 {',
'    font-weight: bold;',
'    color: red;',
'}',
'.l3 {',
'    font-weight: bold;',
'}'))
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(370273743162630435)
,p_plug_name=>'Debug Messages for Page View ID &P24_PAGE_VIEW_ID.'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(370331955215891191)
,p_plug_name=>'Debug Messages'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>34
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select elapsed_seconds,',
'       execution_time,',
'       message,',
'       message_level,',
'       percent_of_max,',
'       call_stack,',
'       session_id,',
'       flow_id,',
'       page_id,',
'       apex_user,',
'       to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as message_anchor,',
'       message_timestamp',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P24_PAGE_VIEW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p class="padding-sm">Elapsed time columns are reported in seconds.</p>'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(370332345019891192)
,p_name=>'Recent Page Views'
,p_max_row_count=>'100000'
,p_max_row_count_message=>'This query returns more then 100,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_download_filename=>'pagelog'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>370332345019891192
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370334083525891194)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370334833824891195)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Session ID'
,p_column_link=>'f?p=&FLOW_ID.:19:&SESSION.::&DEBUG.:RP,:P19_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370272278628630420)
,p_db_column_name=>'MESSAGE_LEVEL'
,p_display_order=>38
,p_column_identifier=>'AG'
,p_column_label=>'Level'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370272332017630421)
,p_db_column_name=>'MESSAGE'
,p_display_order=>48
,p_column_identifier=>'AH'
,p_column_label=>'Message'
,p_column_html_expression=>'<a name="#MESSAGE_ANCHOR#"></a><pre class="l#MESSAGE_LEVEL#">#MESSAGE#</pre>'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_static_id=>'message'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370272477626630422)
,p_db_column_name=>'CALL_STACK'
,p_display_order=>58
,p_column_identifier=>'AI'
,p_column_label=>'Call Stack'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370272585833630423)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>68
,p_column_identifier=>'AJ'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370273362565630431)
,p_db_column_name=>'ELAPSED_SECONDS'
,p_display_order=>78
,p_column_identifier=>'AL'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D99999'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370273442678630432)
,p_db_column_name=>'EXECUTION_TIME'
,p_display_order=>88
,p_column_identifier=>'AM'
,p_column_label=>'Execution'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D99999'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370273549836630433)
,p_db_column_name=>'PERCENT_OF_MAX'
,p_display_order=>98
,p_column_identifier=>'AN'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:::'
,p_static_id=>'pct'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(370273643623630434)
,p_db_column_name=>'APEX_USER'
,p_display_order=>108
,p_column_identifier=>'AO'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(735031303744168708)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>118
,p_column_identifier=>'AP'
,p_column_label=>'Timestamp'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(815130010357112131)
,p_db_column_name=>'MESSAGE_ANCHOR'
,p_display_order=>128
,p_column_identifier=>'AQ'
,p_column_label=>'Message Anchor'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(370342431106891204)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'3703425'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100000
,p_report_columns=>'ELAPSED_SECONDS:EXECUTION_TIME:MESSAGE:MESSAGE_LEVEL:PERCENT_OF_MAX:MESSAGE_ANCHOR'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
,p_break_on=>'0:0:0'
,p_break_enabled_on=>'0:0:0'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(815129527890112126)
,p_plug_name=>'Debug Chart'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>24
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(815129654988112127)
,p_region_id=>wwv_flow_imp.id(815129527890112126)
,p_chart_type=>'combo'
,p_height=>'120'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'off'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'N'
,p_value_position=>'auto'
,p_sorting=>'value-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(815129747009112128)
,p_chart_id=>wwv_flow_imp.id(815129654988112127)
,p_seq=>10
,p_name=>'New'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#''||to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as link,',
'       page_view_row_number || '' - '' || substr(message, 1, 40) as label,',
'       sum(execution_time) over (order by page_view_row_number) execution_agg',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P24_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
' order by page_view_row_number'))
,p_series_type=>'area'
,p_items_value_column_name=>'EXECUTION_AGG'
,p_items_label_column_name=>'LABEL'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'&LINK.'
,p_link_target_type=>'REDIRECT_URL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(815130112289112132)
,p_chart_id=>wwv_flow_imp.id(815129654988112127)
,p_seq=>20
,p_name=>'Warnings/Errors'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#''||to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as link,',
'       page_view_row_number || '' - '' || substr(message, 1, 40) as label,',
'       1 warnings_errors',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P24_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
'   and message_level <= 2',
' order by page_view_row_number'))
,p_series_type=>'line'
,p_items_value_column_name=>'WARNINGS_ERRORS'
,p_items_label_column_name=>'LABEL'
,p_color=>'#ff0000'
,p_line_style=>'dotted'
,p_line_width=>2
,p_line_type=>'none'
,p_marker_rendered=>'on'
,p_marker_shape=>'circle'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'&LINK.'
,p_link_target_type=>'REDIRECT_URL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(815129869856112129)
,p_chart_id=>wwv_flow_imp.id(815129654988112127)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(815129914598112130)
,p_chart_id=>wwv_flow_imp.id(815129654988112127)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(815130245811112133)
,p_chart_id=>wwv_flow_imp.id(815129654988112127)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(370347559432891227)
,p_branch_action=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(370272753381630425)
,p_name=>'P24_PAGE_VIEW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(370331955215891191)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(370274575345630443)
,p_name=>'P24_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(370273743162630435)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(370274696671630444)
,p_name=>'P24_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(370273743162630435)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(370274705241630445)
,p_name=>'P24_SESSION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(370273743162630435)
,p_prompt=>'Session ID'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(370274820535630446)
,p_name=>'P24_USER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(370273743162630435)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(370274976895630447)
,p_name=>'P24_START_TIMESTAMP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(370273743162630435)
,p_prompt=>'Started'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(370275085933630448)
,p_name=>'P24_ELAPSED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(370273743162630435)
,p_prompt=>'Elapsed'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(370346386219891224)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P24_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(370346714321891226)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P24_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(370347056258891226)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>370347056258891226
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(370274433756630442)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch page view info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select min(flow_id)||case when min(flow_id) <> max(flow_id) then ''->''||max(flow_id) end application,',
'       min(page_id)||case when min(page_id) <> max(page_id) then ''->''||max(page_id) end page,',
'       min(session_id)||case when min(session_id) <> max(session_id) then ''->''||max(session_id) end session_id,',
'       min(apex_user)||case when min(apex_user) <> max(apex_user) then ''->''||max(apex_user) end apex_user,',
'       htmldb_util.get_since_tswtz(min(message_timestamp)) start_timestamp,',
'       to_char(max(elapsed_seconds), ''999G990D9999'') elapsed_seconds',
'  into :P24_APPLICATION,',
'       :P24_PAGE,',
'       :P24_SESSION,',
'       :P24_USER,',
'       :P24_START_TIMESTAMP,',
'       :P24_ELAPSED',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P24_PAGE_VIEW_ID',
'   and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>370274433756630442
);
end;
/
prompt --application/pages/page_00025
begin
wwv_flow_imp_page.create_page(
 p_id=>25
,p_name=>'Page Views by User'
,p_alias=>'PAGE-VIEWS-BY-USER'
,p_step_title=>'Page Views by User'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5180512459865310)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9307603421462905)
,p_plug_name=>'Page Views by User'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_views as',
'(select /* APEX4350P25a */ count(*) tpv ',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P25_DATE',
'and   security_group_id = :flow_security_group_id)',
'select developer, ',
'       page_views, ',
'       page_events,',
'       page_processing,',
'       100* page_events/tpv pct,',
'       round(100* page_events/tpv) graph , ',
'       report_rows, ',
'       CONTENT_LENGTH,',
'       pages distinct_pages,',
'       applications,elapsed_time,',
'       distinct_hours,',
'       distinct_days, ',
'       last_view, ',
'       first_view, ',
'       nvl(cached_pages,0) cached_pages, ',
'       nvl(cached_regions,0) cached_regions, ',
'       average_elapsed_time, partial_page_views,',
'      ''<div class="hour-graph">''||',
'      ''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-'
||'value">''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-'
||'value">''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-'
||'value">''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-'
||'value">''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-'
||'value">''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-'
||'value">''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-'
||'value">''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-'
||'value">''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-'
||'value">''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-'
||'value">''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-'
||'value">''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-'
||'value">''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-'
||'value">''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-'
||'value">''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-'
||'value">''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-'
||'value">''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-'
||'value">''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-'
||'value">''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-'
||'value">''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-'
||'value">''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-'
||'value">''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-'
||'value">''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-'
||'value">''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-'
||'value">''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'      ''</div>'' hours',
'from',
'(',
'select upper(USERID) developer, ',
'       count(*) page_events,',
'       sum(decode(page_mode,''A'',0,1)) page_views,',
'       sum(decode(page_mode,''A'',1,0)) page_processing,',
'       sum(num_rows) report_rows,',
'       count(distinct(flow_id||''.''||step_id)) pages,',
'       count(distinct(flow_id)) applications,',
'      sum(elap) elapsed_time,',
'      avg(elap) average_elapsed_time,',
'      count(distinct to_char(time_stamp,''YYYY.MM.DD.HH24'')) distinct_hours,',
'      count(distinct to_char(time_stamp,''YYYY.MM.DD'')) distinct_days,',
'      max(time_stamp) last_view,',
'      min(time_stamp) first_view,',
'      sum(decode(page_mode,''R'',1,0)) cached_pages,',
'      sum(cached_regions) cached_regions,',
'      sum(decode(page_mode,''P'',1,0)) partial_page_views,',
'      sum(nvl(CONTENT_LENGTH,0)) content_length,',
'      sum(decode(to_char(time_stamp,''HH24''),0,1,0)) h00,',
'      sum(decode(to_char(time_stamp,''HH24''),1,1,0)) h01,',
'      sum(decode(to_char(time_stamp,''HH24''),2,1,0)) h02,',
'      sum(decode(to_char(time_stamp,''HH24''),3,1,0)) h03,',
'      sum(decode(to_char(time_stamp,''HH24''),4,1,0)) h04,',
'      sum(decode(to_char(time_stamp,''HH24''),5,1,0)) h05,',
'      sum(decode(to_char(time_stamp,''HH24''),6,1,0)) h06,',
'      sum(decode(to_char(time_stamp,''HH24''),7,1,0)) h07,',
'      sum(decode(to_char(time_stamp,''HH24''),8,1,0)) h08,',
'      sum(decode(to_char(time_stamp,''HH24''),9,1,0)) h09,',
'      sum(decode(to_char(time_stamp,''HH24''),10,1,0)) h10,',
'      sum(decode(to_char(time_stamp,''HH24''),11,1,0)) h11,',
'      sum(decode(to_char(time_stamp,''HH24''),12,1,0)) h12,',
'      sum(decode(to_char(time_stamp,''HH24''),13,1,0)) h13,',
'      sum(decode(to_char(time_stamp,''HH24''),14,1,0)) h14,',
'      sum(decode(to_char(time_stamp,''HH24''),15,1,0)) h15,',
'      sum(decode(to_char(time_stamp,''HH24''),16,1,0)) h16,',
'      sum(decode(to_char(time_stamp,''HH24''),17,1,0)) h17,',
'      sum(decode(to_char(time_stamp,''HH24''),18,1,0)) h18,',
'      sum(decode(to_char(time_stamp,''HH24''),19,1,0)) h19,',
'      sum(decode(to_char(time_stamp,''HH24''),20,1,0)) h20,',
'      sum(decode(to_char(time_stamp,''HH24''),21,1,0)) h21,',
'      sum(decode(to_char(time_stamp,''HH24''),22,1,0)) h22,',
'      sum(decode(to_char(time_stamp,''HH24''),23,1,0)) h23',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P25_DATE and',
'      security_group_id = :flow_security_group_id',
'group by upper(USERID) ',
') pv, total_views,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p>Elapsed time columns are reported in seconds.</p>'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9307709001462905)
,p_name=>'Page Views by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308031484462911)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'User'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RIR:IR_USERID:#DEVELOPER#'
,p_column_linktext=>'#DEVELOPER#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308206855462912)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308119375462912)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308328702462912)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Processing'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308415410462912)
,p_db_column_name=>'PCT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Percent of Total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308515590462912)
,p_db_column_name=>'GRAPH'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Percent of Total'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:150'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308600863462913)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Report Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308713826462913)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308817645462913)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9309624075462914)
,p_db_column_name=>'AVERAGE_ELAPSED_TIME'
,p_display_order=>11
,p_column_identifier=>'R'
,p_column_label=>'Average Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9308910611462913)
,p_db_column_name=>'ELAPSED_TIME'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9309004373462913)
,p_db_column_name=>'DISTINCT_HOURS'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Distinct Hours'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9309116716462913)
,p_db_column_name=>'DISTINCT_DAYS'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Distinct Days'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9309204584462914)
,p_db_column_name=>'LAST_VIEW'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>'Last View'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9309326606462914)
,p_db_column_name=>'FIRST_VIEW'
,p_display_order=>16
,p_column_identifier=>'O'
,p_column_label=>'First View'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9309703372462914)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>17
,p_column_identifier=>'S'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9309408920462914)
,p_db_column_name=>'CACHED_PAGES'
,p_display_order=>18
,p_column_identifier=>'P'
,p_column_label=>'Cached Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9309514341462914)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>19
,p_column_identifier=>'Q'
,p_column_label=>'Cached Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200270403673529201)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760555663993323223)
,p_db_column_name=>'HOURS'
,p_display_order=>30
,p_column_identifier=>'U'
,p_column_label=>'Activity by Hour'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9309908769463151)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308407681536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DEVELOPER:PAGE_EVENTS:PCT:GRAPH:DISTINCT_PAGES:APPLICATIONS:AVERAGE_ELAPSED_TIME:LAST_VIEW:CONTENT_LENGTH:'
,p_sort_column_1=>'PAGE_EVENTS'
,p_sort_direction_1=>'DESC'
,p_sum_columns_on_break=>'PAGE_EVENTS:PAGE_VIEWS:PAGE_PROCESSING:REPORT_ROWS:PCT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200574906058977363)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5180512459865310)
,p_button_name=>'P25_SET'
,p_button_static_id=>'P25_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200270517871533277)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5180512459865310)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:25,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(131170811232636848)
,p_branch_action=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(874931239464688)
,p_name=>'P25_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5180512459865310)
,p_item_default=>'to_number(.125)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'to_number(.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to ',
'',
'include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00026
begin
wwv_flow_imp_page.create_page(
 p_id=>26
,p_name=>'Page Views by Application'
,p_alias=>'PAGE-VIEWS-BY-APPLICATION'
,p_step_title=>'Page Views by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9290610815383521)
,p_plug_name=>'Activity By Application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P26a */',
'       flow_id application, ',
'       page_events, v, page_processing, u, p, v/u v_per_user, ',
'       decode(v,0,0,v/(:P26_SINCE*24*60*60)) vs, ',
'       e,',
'       m,',
'       min,',
'       mints, ',
'       maxts,',
'       rr report_rows,',
'       sqlerrm errors,',
'       dynamic_views,',
'       cached_views,',
'       cached_regions,',
'       CONTENT_LENGTH,',
'      ''<div class="hour-graph">''||',
'      ''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-'
||'value">''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-'
||'value">''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-'
||'value">''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-'
||'value">''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-'
||'value">''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-'
||'value">''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-'
||'value">''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-'
||'value">''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-'
||'value">''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-'
||'value">''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-'
||'value">''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-'
||'value">''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-'
||'value">''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-'
||'value">''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-'
||'value">''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-'
||'value">''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-'
||'value">''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-'
||'value">''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-'
||'value">''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-'
||'value">''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-'
||'value">''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-'
||'value">''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-'
||'value">''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-'
||'value">''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'      ''</div>'' hours',
'from (',
'select flow_id, ',
'       count(*) page_events,',
'       sum(decode(page_mode,''A'',0,1)) v, ',
'       sum(decode(page_mode,''A'',1,0)) page_processing,',
'       count(distinct userid) u,',
'       avg(elap) e, max(elap) m, min(elap) min,',
'       min(time_stamp) mints, max(time_stamp) maxts,',
'       count(distinct(step_id)) p,',
'       sum(num_rows) rr,',
'       sum(decode(sqlerrm,null,0,1)) sqlerrm,',
'    sum(decode(page_mode,''D'',1,''C'',1,0)) dynamic_views,',
'    sum(decode(page_mode,''D'',0,''C'',0,''A'',0,''P'',1)) cached_views,',
'    sum(cached_regions) cached_regions,',
'    sum(nvl(CONTENT_LENGTH,0)) CONTENT_LENGTH,',
'    sum(decode(to_char(time_stamp,''HH24''),0,1,0)) h00,',
'    sum(decode(to_char(time_stamp,''HH24''),1,1,0)) h01,',
'    sum(decode(to_char(time_stamp,''HH24''),2,1,0)) h02,',
'    sum(decode(to_char(time_stamp,''HH24''),3,1,0)) h03,',
'    sum(decode(to_char(time_stamp,''HH24''),4,1,0)) h04,',
'    sum(decode(to_char(time_stamp,''HH24''),5,1,0)) h05,',
'    sum(decode(to_char(time_stamp,''HH24''),6,1,0)) h06,',
'    sum(decode(to_char(time_stamp,''HH24''),7,1,0)) h07,',
'    sum(decode(to_char(time_stamp,''HH24''),8,1,0)) h08,',
'    sum(decode(to_char(time_stamp,''HH24''),9,1,0)) h09,',
'    sum(decode(to_char(time_stamp,''HH24''),10,1,0)) h10,',
'    sum(decode(to_char(time_stamp,''HH24''),11,1,0)) h11,',
'    sum(decode(to_char(time_stamp,''HH24''),12,1,0)) h12,',
'    sum(decode(to_char(time_stamp,''HH24''),13,1,0)) h13,',
'    sum(decode(to_char(time_stamp,''HH24''),14,1,0)) h14,',
'    sum(decode(to_char(time_stamp,''HH24''),15,1,0)) h15,',
'    sum(decode(to_char(time_stamp,''HH24''),16,1,0)) h16,',
'    sum(decode(to_char(time_stamp,''HH24''),17,1,0)) h17,',
'    sum(decode(to_char(time_stamp,''HH24''),18,1,0)) h18,',
'    sum(decode(to_char(time_stamp,''HH24''),19,1,0)) h19,',
'    sum(decode(to_char(time_stamp,''HH24''),20,1,0)) h20,',
'    sum(decode(to_char(time_stamp,''HH24''),21,1,0)) h21,',
'    sum(decode(to_char(time_stamp,''HH24''),22,1,0)) h22,',
'    sum(decode(to_char(time_stamp,''HH24''),23,1,0)) h23',
'from wwv_flow_activity_log',
'where time_stamp >= sysdate - :P26_SINCE and',
'      security_group_id = :flow_security_group_id ',
'group by flow_id) r,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m',
'where u > 0'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p>Elapsed time columns are reported in seconds.</p>'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9290710598383521)
,p_name=>'Activity By Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9290914669383534)
,p_db_column_name=>'APPLICATION'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RIR:IR_FLOW_ID:#APPLICATION#'
,p_column_linktext=>'#APPLICATION#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291325676383538)
,p_db_column_name=>'U'
,p_display_order=>2
,p_column_identifier=>'E'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291427844383538)
,p_db_column_name=>'P'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291030843383537)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291118900383537)
,p_db_column_name=>'V'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291210445383538)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Page Processing'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291510665383538)
,p_db_column_name=>'V_PER_USER'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Page Views Per User'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291601918383538)
,p_db_column_name=>'VS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Views per Second'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D00000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291727414383538)
,p_db_column_name=>'E'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Average Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'99G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291825367383539)
,p_db_column_name=>'M'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Maximum Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9291915185383540)
,p_db_column_name=>'MIN'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Minimum Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'9G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9292014541383540)
,p_db_column_name=>'MINTS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'First View'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9292120461383541)
,p_db_column_name=>'MAXTS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Last View'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9292231539383541)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Report Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9292315896383541)
,p_db_column_name=>'ERRORS'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Errors'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9292414571383541)
,p_db_column_name=>'DYNAMIC_VIEWS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Dynamic Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9292527076383541)
,p_db_column_name=>'CACHED_VIEWS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Cached Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9292617059383541)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Cached Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200271025621544978)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760555766693323224)
,p_db_column_name=>'HOURS'
,p_display_order=>29
,p_column_identifier=>'T'
,p_column_label=>'Activity by Hour'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9292829407383980)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308508193536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION:U:P:PAGE_EVENTS:E:MAXTS:REPORT_ROWS:ERRORS:CACHED_REGIONS:CONTENT_LENGTH:'
,p_sort_column_1=>'PAGE_EVENTS'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'APPLICATION'
,p_sort_direction_2=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200477803138815713)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200580507536034608)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200477803138815713)
,p_button_name=>'P26_SET'
,p_button_static_id=>'P26_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200580824505039429)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200477803138815713)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:26,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(131128420332626091)
,p_branch_action=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200579710522025924)
,p_name=>'P26_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(200477803138815713)
,p_item_default=>'to_number(.125)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'to_number(.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to ',
'',
'include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9906602353212915)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>9906602353212915
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_imp_page.create_page(
 p_id=>27
,p_name=>'Monthly Calendar of Page Views By Day'
,p_alias=>'MONTHLY-CALENDAR-OF-PAGE-VIEWS-BY-DAY'
,p_step_title=>'Monthly Calendar of Page Views By Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'08'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47775113894360528)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(233523126780054135)
,p_plug_name=>'Page Views by Day'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P27a */',
'       trunc(TIME_STAMP) ts,',
'       t.v||'': ''||to_char(count(*),''999G999G999G990'') || chr(10) ||',
'       t.u||'': ''||to_char(count(distinct upper(USERID)),''999G999G999G990'')|| chr(10) ||',
'       t.a||'': ''||to_char(count(distinct flow_id),''999G999G999G990'')|| chr(10) ||',
'       t.p||'': ''||to_char(count(distinct step_id),''999G999G999G990'') as display',
'    from   WWV_FLOW_ACTIVITY_LOG,',
'(select wwv_flow_lang.system_message(''views'') v,',
'        wwv_flow_lang.system_message(''users'') u,',
'        wwv_flow_lang.system_message(''applications'') a,',
'        wwv_flow_lang.system_message(''pages'') p',
' from dual) t',
'    where  security_group_id = :flow_security_group_id and page_mode != ''A'' and',
'    (nvl(:P27_APPLICATION,0) = 0 or flow_id = :P27_APPLICATION) and',
'    TIME_STAMP > sysdate - nvl(:P27_TIME,7) ',
'group by trunc(time_stamp), t.v, t.u, t.a, t.p'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'additional_calendar_views', 'navigation',
  'display_column', 'DISPLAY',
  'maximum_events_day', '10',
  'multiple_line_event', 'Y',
  'show_time', 'N',
  'show_tooltip', 'N',
  'show_weekend', 'Y',
  'start_date_column', 'TS')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(429994131751180568)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(47775113894360528)
,p_button_name=>'P27_SET'
,p_button_static_id=>'P27_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'APPLY_CHANGES'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(233186907690029293)
,p_branch_action=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47775420235360528)
,p_name=>'P27_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47775113894360528)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'to_number(7)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47775926911360530)
,p_name=>'P27_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47775113894360528)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_imp_page.create_page(
 p_id=>28
,p_name=>'Purge Preferences'
,p_alias=>'PURGE-PREFERENCES'
,p_step_title=>'Purge Preferences'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_user_pref.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49166307683716829)
,p_plug_name=>'Reset User Preferences'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<span class="instructiontext">'');',
'for c1 in (select count(*) c from wwv_flow_preferences$ where user_id = :flow_user and security_group_id = :flow_security_group_id) loop',
'sys.htp.p( wwv_flow_lang.system_message(''F4350_USER_PREFS'',:flow_user,c1.c));',
'end loop;',
'sys.htp.p(wwv_flow_lang.system_message(''F4350_RESET_PREFS'')||''</span>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49186429261744804)
,p_plug_name=>'Preferences'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This report shows the preferences set for the current user. These session state values are retained between connections.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49167831098716830)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(49166307683716829)
,p_button_name=>'ViewPreferences'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'View Preferences'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:pref:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49167427147716830)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(49166307683716829)
,p_button_name=>'ResetPref'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Reset Preferences'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(49179822550733432)
,p_branch_action=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49168016057716831)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'reset user preferences'
,p_attribute_01=>'RESET_USER_PREFERENCES'
,p_process_error_message=>'Unable to reset user preferences.'
,p_process_when_button_id=>wwv_flow_imp.id(49167427147716830)
,p_process_success_message=>'User preferences have been reset (removed).'
,p_internal_uid=>49168016057716831
);
end;
/
prompt --application/pages/page_00029
begin
wwv_flow_imp_page.create_page(
 p_id=>29
,p_name=>'Recent Page Views'
,p_alias=>'RECENT-PAGE-VIEWS'
,p_step_title=>'Recent Page Views'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9294728475405715)
,p_plug_name=>'Recent Page Views'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /*+ FIRST_ROWS(21) */',
'    time_stamp,',
'    elap,',
'    num_rows query_rows,',
'    userid userid, ',
'    flow_id,',
'    (select name from wwv_flows where id = l.flow_id) application_name,',
'    (select name from wwv_flow_steps where id = l.step_id and flow_id = l.flow_id) page_name,',
'    step_id,',
'    session_id,',
'    substr(user_agent,1,100) user_agent,',
'    86400 * (time_stamp - lag(time_stamp) over (order by userid, time_stamp)) thinktime,',
'    sqlerrm,',
'    page_mode page_mode_code,',
'    cached_regions,',
'    decode(page_mode,',
'        ''A'',m.m_PAGE_PROCESSING,',
'        ''C'',m.m_CACHE_CREATED,',
'        ''D'',m.m_DYNAMIC,',
'        ''P'',m.m_PARTIAL_PAGE, ',
'        ''R'',m.m_CACHED,',
'        page_mode) page_mode,',
'   to_char(time_stamp,''YYYYMMDD'') day,',
'   worksheet_id,',
'   ir_search,',
'   CONTENT_LENGTH,',
'   page_view_type,',
'   request_value,',
'   debug_page_view_id,',
'   ecid',
'from WWV_FLOW_ACTIVITY_LOG l,',
'   (select wwv_flow_lang.system_message(''PAGE_PROCESSING'') m_PAGE_PROCESSING,',
'           wwv_flow_lang.system_message(''CACHE_CREATED'') m_CACHE_CREATED,',
'           wwv_flow_lang.system_message(''F4000.DYNAMIC'') m_DYNAMIC,',
'           wwv_flow_lang.system_message(''PARTIAL_PAGE'') m_PARTIAL_PAGE,',
'           wwv_flow_lang.system_message(''CACHED'') m_CACHED',
'    from dual) m',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P29_TIME,1)) and',
'    (nvl(:P29_APPLICATION,0)=0 or :P29_APPLICATION = flow_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p>Elapsed time columns are reported in seconds.</p>'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9294827650405715)
,p_name=>'Recent Page Views'
,p_max_row_count=>'100000'
,p_max_row_count_message=>'This query returns more then 100,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_download_filename=>'pagelog'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9295014155405725)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9295117155405725)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9295310019405725)
,p_db_column_name=>'USERID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9295401265405725)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9295528247405726)
,p_db_column_name=>'STEP_ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9295815278405726)
,p_db_column_name=>'THINKTIME'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Think Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9295623845405726)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Session'
,p_column_link=>'f?p=&FLOW_ID.:19:&SESSION.::&DEBUG.:RP,:P19_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9295706080405726)
,p_db_column_name=>'USER_AGENT'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'User Agent'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9295910992405726)
,p_db_column_name=>'SQLERRM'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9296009036405726)
,p_db_column_name=>'PAGE_MODE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Page Mode'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9296123584405727)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Cached Regions '
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9298118980428251)
,p_db_column_name=>'PAGE_MODE_CODE'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Page Mode Code'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9388006803020796)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9388218924024234)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9916615317476149)
,p_db_column_name=>'DAY'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Day'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30837931182419860)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Selected Report'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30838006696419860)
,p_db_column_name=>'IR_SEARCH'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Interactive Report Search'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200269825228516466)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(36918123274457464)
,p_db_column_name=>'QUERY_ROWS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Query Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475460529806625310)
,p_db_column_name=>'PAGE_VIEW_TYPE'
,p_display_order=>33
,p_column_identifier=>'AD'
,p_column_label=>'Page View Type'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(1569139039593351202)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1569135249109283180)
,p_db_column_name=>'REQUEST_VALUE'
,p_display_order=>43
,p_column_identifier=>'Y'
,p_column_label=>'Request Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1569135368749283180)
,p_db_column_name=>'DEBUG_PAGE_VIEW_ID'
,p_display_order=>53
,p_column_identifier=>'Z'
,p_column_label=>'Debug ID'
,p_column_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:RP,24:P24_PAGE_VIEW_ID:#DEBUG_PAGE_VIEW_ID#'
,p_column_linktext=>'#DEBUG_PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(342360591742652522)
,p_db_column_name=>'ECID'
,p_display_order=>63
,p_column_identifier=>'AE'
,p_column_label=>'ECID'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9296821143409975)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308630099536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TIME_STAMP:ELAP:QUERY_ROWS:USERID:FLOW_ID:STEP_ID:PAGE_VIEW_TYPE:REQUEST_VALUE:DEBUG_PAGE_VIEW_ID:SQLERRM'
,p_sort_column_1=>'TIME_STAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47755428326156622)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200579121127019533)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47755428326156622)
,p_button_name=>'P29_SET'
,p_button_static_id=>'P29_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196197132719904196)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47755428326156622)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:29,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130990623956463449)
,p_branch_action=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47755701430156625)
,p_name=>'P29_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47755428326156622)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'to_number(.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47756221007156625)
,p_name=>'P29_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47755428326156622)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(158494820430118826)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P29_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_associated_item=>wwv_flow_imp.id(22676108663323154)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(158497003245123320)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P29_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_associated_item=>wwv_flow_imp.id(22676713857324576)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(961201412394966)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>961201412394966
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_imp_page.create_page(
 p_id=>30
,p_name=>'Developer Activity Log'
,p_alias=>'DEVELOPER-ACTIVITY-LOG'
,p_step_title=>'Developer Activity Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215462122626558552)
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_logs.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1004413391363499)
,p_plug_name=>'Manage Developer Activity Log'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'   c_click pls_integer := 0;',
'begin',
'   sys.htp.p(''<table class="instructiontext" role="presentation" cellspacing="0" cellpadding="0">'');',
'   -- wwv_flow_builder_audit_trail ',
'   select count(*) into c_dev from wwv_flow_builder_audit_trail ',
'   where security_group_id = :flow_security_group_id;',
'   sys.htp.prn(''<tr><td>''||wwv_flow_lang.system_message(''F4350_DEV_LOG_ENTRIES'')||''</td><td align="right" class="fielddatabold">&nbsp;'');',
'   sys.htp.prn(to_char(c_dev,''999,999,999,999,999,990''));',
'   sys.htp.prn(''</td></tr></table><p />'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>'Developer activity is a log of developer changes to application within this workspace.  The log tracks the developer, the application, the changed component, and the date.  The developer log information is maintained for one month.  Use this page to '
||'purge entries in the developer activity log.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47260804113938827)
,p_plug_name=>'Manage Logs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:50%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(41778218420271753)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6889902515000422)
,p_button_sequence=>15
,p_button_plug_id=>wwv_flow_imp.id(1004413391363499)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2554514135549743)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1004413391363499)
,p_button_name=>'PURGE_DEVELOPER_LOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Developer Log'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1119314682357438)
,p_branch_action=>'30'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1115827233342122)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge builder audit'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_builder_audit_trail ',
'where security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to purge log'
,p_process_when_button_id=>wwv_flow_imp.id(2554514135549743)
,p_process_success_message=>'Purged Developer Activity Log.'
,p_internal_uid=>1115827233342122
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_imp_page.create_page(
 p_id=>31
,p_name=>'Page Views by Weighted Page Performance'
,p_alias=>'PAGE-VIEWS-BY-WEIGHTED-PAGE-PERFORMANCE'
,p_step_title=>'Page Views by Weighted Page Performance'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9772622807334494)
,p_plug_name=>'Weighted Page Performance'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P31a */',
'       flow_id                  application_id, ',
'       step_id                  page_id, ',
'       (select name from wwv_flows where id = l.flow_id) application_name,',
'       (select name from wwv_flow_steps where id = l.step_id and flow_id = l.flow_id) page_name,',
'       count (*)                page_events,',
'       avg(elap)                average_elapsed_time, ',
'       avg(elap)*count(*)       weighted_average,',
'       median(elap)             median_elapsed_time,',
'       median(elap)*count(*)    weighted_median,',
'       (median(elap)*count(*)) - (avg(elap)*count(*)) median_to_avg_delta,',
'       max(elap)                maximum_elapsed_time,',
'       min(elap)                minimum_elapsed_time,',
'       max(elap) - min(elap)    maximum_minimum_delta,',
'       median(content_length)  median_content_length',
'from wwv_flow_activity_log l',
'where security_group_id = :flow_security_group_id and ',
'    (:app_security_group_id = 10 or flow_id not between 4000 and 4999) and',
'    time_stamp >= (sysdate - nvl(:P31_TIME,1)) and',
'    (nvl(:P31_APPLICATION,0) = 0 or flow_id = :P31_APPLICATION)',
'group by flow_id, step_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<br /><p>Elapsed time columns are reported in seconds.  Weighted Average is calculated by multiplying page events by average page rendering time in seconds.  Median Average is calculated by multiplying page events by median page rendering time in sec'
||'onds.  Page events include page rendering and page processing events.</p>'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9772730274334494)
,p_name=>'Weighted Page Performance'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9772901477334499)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9773030460334504)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:65:P65_APPLICATION,P65_PAGE:#APPLICATION_ID#,#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9773123964334504)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9773202731334504)
,p_db_column_name=>'AVERAGE_ELAPSED_TIME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Average Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9773308278334504)
,p_db_column_name=>'WEIGHTED_AVERAGE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Weighted Average'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9773428200334504)
,p_db_column_name=>'MEDIAN_ELAPSED_TIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Median Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9773513323334505)
,p_db_column_name=>'WEIGHTED_MEDIAN'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Weighted Median'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9775813452422841)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9776320294443708)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9779126574473944)
,p_db_column_name=>'MEDIAN_TO_AVG_DELTA'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Median Average Delta'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9779729822484382)
,p_db_column_name=>'MAXIMUM_ELAPSED_TIME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Maximum Elapsed Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9779827213484382)
,p_db_column_name=>'MINIMUM_ELAPSED_TIME'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Minimum Elapsed Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9780325105492393)
,p_db_column_name=>'MAXIMUM_MINIMUM_DELTA'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Maximum Minimum Delta'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201290225421223045)
,p_db_column_name=>'MEDIAN_CONTENT_LENGTH'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Median Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9773603269334713)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308700092536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION_ID:PAGE_ID:PAGE_NAME:PAGE_EVENTS:AVERAGE_ELAPSED_TIME:WEIGHTED_AVERAGE:MEDIAN_ELAPSED_TIME:WEIGHTED_MEDIAN:MEDIAN_CONTENT_LENGTH'
,p_sort_column_1=>'WEIGHTED_AVERAGE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'MAXIMUM_MINIMUM_DELTA'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'WEIGHTED_MEDIAN'
,p_sort_direction_3=>'DESC'
,p_sort_column_4=>'AVERAGE_ELAPSED_TIME'
,p_sort_direction_4=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107716719694045280)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450602812552903078)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(107716719694045280)
,p_button_name=>'P31_SET'
,p_button_static_id=>'P31_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201290305120226615)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(107716719694045280)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:31,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1022424529470850)
,p_branch_action=>'31'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1016914440439483)
,p_name=>'P31_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(107716719694045280)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47771328953327091)
,p_name=>'P31_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(107716719694045280)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00032
begin
wwv_flow_imp_page.create_page(
 p_id=>32
,p_name=>'Views by Page'
,p_alias=>'VIEWS-BY-PAGE'
,p_step_title=>'Views by Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5470717896084547)
,p_name=>'Views By Page'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>21
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as ',
'(',
'select count(*) tpv ',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P32_TIME',
'and   security_group_id = :flow_security_group_id and',
'(userid = :p32_user or nvl(:p32_user,''0'') = ''0'') and',
'flow_id = :p32_flow',
')',
'select page_id, ',
'       (select name from wwv_flow_steps where flow_id = :p32_flow and id = page_id) page_name,',
'       page_views,',
'       100*page_views/tpv pct, ',
'       round(300*page_views/tpv) graph,',
'      report_rows,',
'      elapsed_time',
'from',
'(',
'select step_id page_id, count(*) page_views , sum(num_rows) report_rows, sum(elap) elapsed_time',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P32_TIME',
'and   security_group_id = :flow_security_group_id and',
'(userid = :p32_user or nvl(:p32_user,''0'') = ''0'') and',
'flow_id = :p32_flow',
'group by step_id',
') d, total_page_views'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(6659715068668103)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5471007240084565)
,p_query_column_id=>1
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5479500806145870)
,p_query_column_id=>2
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5471131441084565)
,p_query_column_id=>3
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>3
,p_column_heading=>'Page Views'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5472106945090809)
,p_query_column_id=>4
,p_column_alias=>'PCT'
,p_column_display_sequence=>4
,p_column_heading=>'Percentage'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5472226421090810)
,p_query_column_id=>5
,p_column_alias=>'GRAPH'
,p_column_display_sequence=>5
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div style="width:300px;height:14px;background:#dddddd;border-top:1px solid #aaaaaa;border-left:1px solid #aaaaaa;border-bottom:1px solid #ffffff;border-right:1px solid #ffffff;">',
'<img src="#IMAGE_PREFIX#1px_trans.gif" width="#GRAPH#" height="14" border="0" style="background:#3f863f;"></div>'))
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7706002830600313)
,p_query_column_id=>6
,p_column_alias=>'REPORT_ROWS'
,p_column_display_sequence=>6
,p_column_heading=>'Report Rows'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7706104497600318)
,p_query_column_id=>7
,p_column_alias=>'ELAPSED_TIME'
,p_column_display_sequence=>7
,p_column_heading=>'Elapsed Time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5476109416119971)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17104217220309693)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5476109416119971)
,p_button_name=>'P32_GO'
,p_button_static_id=>'P32_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17109729518351162)
,p_branch_action=>'32'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17103004407306062)
,p_name=>'P32_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5476109416119971)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the timeframe for the search.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17103612025308220)
,p_name=>'P32_FLOW'
,p_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5476109416119971)
,p_item_default=>'0'
,p_prompt=>'Application:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies selected application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17106013195318054)
,p_name=>'P32_USER'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(5476109416119971)
,p_prompt=>'User'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FND USERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(user_name) d, user_name r',
'from wwv_flow_fnd_user',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Users -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify a username to constrain the report'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_imp_page.create_page(
 p_id=>33
,p_name=>'Workspace Dashboard'
,p_alias=>'WORKSPACE-DASHBOARD'
,p_step_title=>'Workspace Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47002328518898200)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47002505100900835)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47003323454906127)
,p_name=>'Service'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P33a */',
'    :company workspace_name,',
'(',
'select count(*)',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
') as applications,',
'(',
'select count(*)',
'  from wwv_flow_files f, wwv_flow_fnd_user u',
' where u.security_group_id = :flow_security_group_id',
'   and u.user_name = :APP_USER',
'   and f.file_type = ''SCRIPT''',
') as sql_scripts,',
'(',
'select count(*)',
'  from wwv_flow_company_schemas',
' where security_group_id = :flow_security_group_id',
') as schemas,',
'--',
'(select sum(open_requests)',
'from',
'(',
'select count(*) open_requests',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id and',
'      project_status = ''REQUESTED''',
'union all',
'select count(*) open_requests',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      m.request_status = ''REQUESTED''',
') q ) open_requests',
'from dual',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47003528304906129)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47004106466906132)
,p_query_column_id=>2
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47031110155184041)
,p_query_column_id=>3
,p_column_alias=>'SQL_SCRIPTS'
,p_column_display_sequence=>5
,p_column_heading=>'SQL Scripts'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47434208162185271)
,p_query_column_id=>4
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>6
,p_column_heading=>'Schemas'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47469209715848022)
,p_query_column_id=>5
,p_column_alias=>'OPEN_REQUESTS'
,p_column_display_sequence=>7
,p_column_heading=>'Open Requests'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47023120479007239)
,p_name=>'Available Schemas'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P33b */ schema',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47023120479007239)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47024118532016069)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47031617128214415)
,p_name=>'Files'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select coalesce (',
'           c.max_file_bytes,',
'           to_number(wwv_flow_platform.get_preference(''WORKSPACE_MAX_FILE_BYTES'')) ) max_s,',
'       f.file_types,',
'       f.s,',
'       f.c',
'  from ( select max_file_bytes',
'           from wwv_flow_companies c',
'          where c.provisioning_company_id = :flow_security_group_id ) c,',
'       ( select count(distinct f.file_type) file_types,',
'                sum(f.file_bytes) s,',
'                sum(f.file_count) c',
'           from wwv_flow_company_filestats f',
'          where f.security_group_id=:flow_security_group_id ) f',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47031617128214415)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(620835445096373117)
,p_query_column_id=>1
,p_column_alias=>'MAX_S'
,p_column_display_sequence=>1
,p_column_heading=>'Maximum File Size'
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191599015501538189)
,p_query_column_id=>2
,p_column_alias=>'FILE_TYPES'
,p_column_display_sequence=>4
,p_column_heading=>'File Types'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(168480132258259834)
,p_query_column_id=>3
,p_column_alias=>'S'
,p_column_display_sequence=>2
,p_column_heading=>'Total File Size'
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(168480211187259834)
,p_query_column_id=>4
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_column_heading=>'File Count'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47409020218009023)
,p_name=>'Recent Service Requests'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P33d */',
'    wwv_flow_lang.system_message(''WORKSPACE_REQUEST'') ||'' - ''|| wwv_flow_item.text_from_lov(project_status,''REQUEST_STATUSES'') || '' - ''||',
'    DATABASE_SIZE||''MB'' the_request,',
'    request_date',
'from WWV_FLOW_PROVISION_COMPANY',
'where ',
'      SECURITY_GROUP_ID = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''CHANGE_REQUEST'')||'' ''||m.service_name ||'' - ''||wwv_flow_item.text_from_lov(m.request_status,''REQUEST_STATUSES'')||'' - ''||',
'       m.service_attribute_1 the_request,',
'       m.requested_on',
'from wwv_flow_provision_serice_mod m, ',
'     wwv_flow_companies c',
'where m.security_group_id = c.provisioning_company_id and',
'      c.PROVISIONING_COMPANY_ID = :flow_security_group_id',
'order by 2 desc '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47409020218009023)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47411608321071843)
,p_query_column_id=>1
,p_column_alias=>'THE_REQUEST'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47411726856071844)
,p_query_column_id=>2
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445571526299029605)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:99%;"'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the Dashboard page to view details about the current workspace and monitor overall workspace activity.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47073006110441131)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47002505100900835)
,p_button_name=>'MANAGE_SERVICES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Manage Service'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168467711714773751)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47002505100900835)
,p_button_name=>'REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Report Utilization'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47003001103900837)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47002505100900835)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47004305924910594)
,p_branch_action=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00034
begin
wwv_flow_imp_page.create_page(
 p_id=>34
,p_name=>'External Clicks'
,p_alias=>'EXTERNAL-CLICKS'
,p_step_title=>'External Clicks'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215673320866031164)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(108236726284086228)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(450803907194232568)
,p_plug_name=>'External Clicks'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P34a */ trunc(CLICKDATE) CLICKDATE,category, count(*) c, FLOW_USER',
'from wwv_flow_clickthru_log',
'where clickdate >= (sysdate - :p34_time)',
'group by trunc(CLICKDATE), category, flow_user'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'You can count clicks from an &PRODUCT_NAME. application to an external site using the procedure APEX_UTIL.COUNT_CLICK, or the shorthand version Procedure Z.'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(450804016593232568)
,p_name=>'External Clicks'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450804304300232575)
,p_db_column_name=>'CATEGORY'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Category'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450804530803232577)
,p_db_column_name=>'FLOW_USER'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450804221494232574)
,p_db_column_name=>'CLICKDATE'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450804405100232576)
,p_db_column_name=>'C'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(450804700551233570)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308822992536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CATEGORY:FLOW_USER:CLICKDATE:C'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1107911902280875)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(108236726284086228)
,p_button_name=>'P34_GO'
,p_button_static_id=>'P34_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450806006223244673)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(108236726284086228)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1104019911256897)
,p_branch_action=>'34'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 29-NOV-2002 15:17:50'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1106521121274075)
,p_name=>'P34_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(108236726284086228)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to ',
'',
'include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00035
begin
wwv_flow_imp_page.create_page(
 p_id=>35
,p_name=>'Workspace Message'
,p_alias=>'WORKSPACE-MESSAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Workspace Message'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="p17_checkdisable()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
'function p17_checkdisable(){ ',
'var ltext_0 = $x(''P17_EXPIRE_FND_USER_ACCOUNTS_0''); ',
'var ltext_1 = $x(''P17_EXPIRE_FND_USER_ACCOUNTS_1''); ',
'var ltext; ',
'if(ltext_0.checked == true){ltext = ltext_0}else{ltext = ltext_1} ',
'html_DisableOnValue(ltext,''N'',''P17_ACCOUNT_LIFETIME_DAYS'',''P17_USER_MAX_LOGIN_FAILURES'') ',
'} ',
'',
'//-->',
'</script>'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_dialog_height=>'320'
,p_dialog_width=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500'
,p_help_text=>'AEADM/aadmin_wrksp_mess.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(173255013158240412)
,p_plug_name=>'Workspace Message'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>30
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(173255902160240415)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(173256329637240416)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(173255902160240415)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(173256126055240416)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(173255902160240415)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(173258603234240426)
,p_branch_name=>'Go To Page &LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(173256126055240416)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173255206337240413)
,p_name=>'P35_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(173255013158240412)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Message'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select builder_notification_message ',
'from wwv_flow_companies ',
'where PROVISIONING_COMPANY_ID = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>1300
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display on the Workspace home page and Administration home page. Click <strong>Apply Changes</strong> to save your changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(173258322158240424)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update WWV_FLOW_COMPANIES',
'   set builder_notification_message = :P35_MESSAGE',
' where PROVISIONING_COMPANY_ID = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to update Workspace Message.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(173256126055240416)
,p_process_success_message=>'Workspace Message updated.'
,p_internal_uid=>173258322158240424
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(722740953443798637)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Cancel Modal'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(173256329637240416)
,p_internal_uid=>722740953443798637
);
end;
/
prompt --application/pages/page_00036
begin
wwv_flow_imp_page.create_page(
 p_id=>36
,p_name=>'Session State'
,p_alias=>'SESSION-STATE'
,p_step_title=>'Session State'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_sessions.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47246122917726657)
,p_plug_name=>'Manage Session State'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(49193021558761543)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47246327765728122)
,p_plug_name=>'Manage Preferences'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(49208419658798799)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47262618836980927)
,p_plug_name=>'Session State'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>5
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Session state is maintained in the database. This report shows recent sessions with links to more detailed session information.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_imp_page.create_page(
 p_id=>37
,p_name=>'Page Views by User Agent'
,p_alias=>'PAGE-VIEWS-BY-USER-AGENT'
,p_step_title=>'Page Views by User Agent'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6102001637631613)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10277804766920989)
,p_plug_name=>'Page Views by Browser'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as',
'(',
'select /* APEX4350P37a */count(*) tpv',
'from wwv_flow_activity_log',
'     where security_group_id = :flow_security_group_id ',
'       and page_mode != ''A''',
'       and time_stamp >= sysdate - nvl(:P37_TIME,1)',
')',
'select d.user_agent, d.page_views, 100*d.page_views/tpv pct, round(100*d.page_views/tpv) graph',
'from',
'(',
'select user_agent, sum(the_count) page_views',
'  from',
'   (select session_id, max(substr(nvl(user_agent,'' Unknown''),1,100)) user_agent, count(*) the_count',
'      from wwv_flow_activity_log l',
'     where security_group_id = :flow_security_group_id ',
'       and page_mode != ''A''',
'       and time_stamp >= sysdate - nvl(:P37_TIME,1)',
'     group by session_id)',
' group by user_agent) d, total_page_views'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10277931910920989)
,p_name=>'Page Views by Browser'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10278118066920992)
,p_db_column_name=>'USER_AGENT'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'User Agent'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10278213834920993)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10278328204920993)
,p_db_column_name=>'PCT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10278404764920993)
,p_db_column_name=>'GRAPH'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10278615116921190)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1308915967536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'USER_AGENT:PAGE_VIEWS:PCT:GRAPH'
,p_sort_column_1=>'PCT'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450801327039203398)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6102001637631613)
,p_button_name=>'P37_GO'
,p_button_static_id=>'P37_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(430039324460377116)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(6102001637631613)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:37,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1150113046770141)
,p_branch_action=>'37'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 29-NOV-2002 16:43:22'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1177821232182544)
,p_name=>'P37_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6102001637631613)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00038
begin
wwv_flow_imp_page.create_page(
 p_id=>38
,p_name=>'Application Changes by Application'
,p_alias=>'APPLICATION-CHANGES-BY-APPLICATION'
,p_step_title=>'Application Changes by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9853502075969658)
,p_plug_name=>'Application Changes by Application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_page_views as',
'(select /* APEX4350P38a */ count(*) tpv',
'from wwv_flow_builder_audit_trail',
'where security_group_id = :flow_security_group_id',
'and audit_date >= sysdate - nvl(:P38_TIME,1)',
'and flow_id is not null)',
'select ',
'the_link, ',
'application, ',
'(select name from wwv_flows where id = application) application_name,',
'page_views, ',
'100*page_views/tpv pct, ',
'round(100*page_views/tpv) graph,',
'''<div class="hour-graph">''||',
'''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-value"'
||'>''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-value"'
||'>''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-value"'
||'>''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-value"'
||'>''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-value"'
||'>''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-value"'
||'>''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-value"'
||'>''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-value"'
||'>''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) else to_char(h07) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-value"'
||'>''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-value"'
||'>''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-value"'
||'>''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-value"'
||'>''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-value"'
||'>''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-value"'
||'>''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-value"'
||'>''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-value"'
||'>''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-value"'
||'>''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-value"'
||'>''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-value"'
||'>''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-value"'
||'>''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-value"'
||'>''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-value"'
||'>''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-value"'
||'>''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-value"'
||'>''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'''</div>'' hours',
'from ',
'(',
'select ''f?p=4350:28:''||:flow_session||''::NO::P28_FLOW,P28_TIME:''||',
'       flow_id||'',''||nvl(:p38_time,''1'') the_link,',
'       flow_id application, ',
'       count(*) page_views,',
'      sum(decode(to_char(audit_date,''HH24''),0,1,0)) h00,',
'      sum(decode(to_char(audit_date,''HH24''),1,1,0)) h01,',
'      sum(decode(to_char(audit_date,''HH24''),2,1,0)) h02,',
'      sum(decode(to_char(audit_date,''HH24''),3,1,0)) h03,',
'      sum(decode(to_char(audit_date,''HH24''),4,1,0)) h04,',
'      sum(decode(to_char(audit_date,''HH24''),5,1,0)) h05,',
'      sum(decode(to_char(audit_date,''HH24''),6,1,0)) h06,',
'      sum(decode(to_char(audit_date,''HH24''),7,1,0)) h07,',
'      sum(decode(to_char(audit_date,''HH24''),8,1,0)) h08,',
'      sum(decode(to_char(audit_date,''HH24''),9,1,0)) h09,',
'      sum(decode(to_char(audit_date,''HH24''),10,1,0)) h10,',
'      sum(decode(to_char(audit_date,''HH24''),11,1,0)) h11,',
'      sum(decode(to_char(audit_date,''HH24''),12,1,0)) h12,',
'      sum(decode(to_char(audit_date,''HH24''),13,1,0)) h13,',
'      sum(decode(to_char(audit_date,''HH24''),14,1,0)) h14,',
'      sum(decode(to_char(audit_date,''HH24''),15,1,0)) h15,',
'      sum(decode(to_char(audit_date,''HH24''),16,1,0)) h16,',
'      sum(decode(to_char(audit_date,''HH24''),17,1,0)) h17,',
'      sum(decode(to_char(audit_date,''HH24''),18,1,0)) h18,',
'      sum(decode(to_char(audit_date,''HH24''),19,1,0)) h19,',
'      sum(decode(to_char(audit_date,''HH24''),20,1,0)) h20,',
'      sum(decode(to_char(audit_date,''HH24''),21,1,0)) h21,',
'      sum(decode(to_char(audit_date,''HH24''),22,1,0)) h22,',
'      sum(decode(to_char(audit_date,''HH24''),23,1,0)) h23',
'from wwv_flow_builder_audit_trail',
'where security_group_id = :flow_security_group_id',
'and audit_date >= sysdate - nvl(:P38_TIME,1)',
'and flow_id is not null',
'group by  ''f?p=4350:28:''||:flow_session||''::NO::P28_FLOW,P28_TIME:''||',
'       flow_id||'',''||nvl(:p38_time,''1''), flow_id',
') pv, total_page_views,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.APPCHANGES'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9853630321969658)
,p_name=>'Application Changes by Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9853807298969667)
,p_db_column_name=>'THE_LINK'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'The Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9853905207969668)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1122614471336989)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9854011889969668)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Component Changes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9854115048969668)
,p_db_column_name=>'PCT'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9854212253969668)
,p_db_column_name=>'GRAPH'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760555978034323226)
,p_db_column_name=>'HOURS'
,p_display_order=>16
,p_column_identifier=>'G'
,p_column_label=>'Activity by Hour'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9855206889972571)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1309012557536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION:APPLICATION_NAME:PAGE_VIEWS:PCT:GRAPH:'
,p_sort_column_1=>'APPLICATION'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'GRAPH'
,p_sort_direction_2=>'ASC'
,p_sum_columns_on_break=>'PAGE_VIEWS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20163722246444952)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450749324578549892)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(20163722246444952)
,p_button_name=>'P38_GO'
,p_button_static_id=>'P38_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450749502892553117)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(20163722246444952)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1169219720138463)
,p_branch_action=>'38'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 29-NOV-2002 17:44:45'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1171000407148095)
,p_name=>'P38_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20163722246444952)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00039
begin
wwv_flow_imp_page.create_page(
 p_id=>39
,p_name=>'Page Views by User and Hour'
,p_alias=>'PAGE-VIEWS-BY-USER-AND-HOUR'
,p_step_title=>'Page Views by User and Hour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1765984845471296621)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1770111936432894216)
,p_plug_name=>'Page Views by User by Hour'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select the_day,',
'       developer, ',
'       page_events,',
'       applications,',
'      ''<div class="hour-graph">''||',
'      ''<span title="''||m.hour_label||''  0, ''||m.message_label||'' ''||ltrim(to_char(h00,''999G999G999''))||''" class="hour''|| case when h00 = 0 then '' is-null'' when h00 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 0</span> <span class="hour-'
||'value">''|| case when h00 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h00/1000),''99999999D0'')) else to_char(h00) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  1, ''||m.message_label||'' ''||ltrim(to_char(h01,''999G999G999''))||''" class="hour''|| case when h01 = 0 then '' is-null'' when h01 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 1</span> <span class="hour-'
||'value">''|| case when h01 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h01/1000),''99999999D0'')) else to_char(h01) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  2, ''||m.message_label||'' ''||ltrim(to_char(h02,''999G999G999''))||''" class="hour''|| case when h02 = 0 then '' is-null'' when h02 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 2</span> <span class="hour-'
||'value">''|| case when h02 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h02/1000),''99999999D0'')) else to_char(h02) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  3, ''||m.message_label||'' ''||ltrim(to_char(h03,''999G999G999''))||''" class="hour''|| case when h03 = 0 then '' is-null'' when h03 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 3</span> <span class="hour-'
||'value">''|| case when h03 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h03/1000),''99999999D0'')) else to_char(h03) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  4, ''||m.message_label||'' ''||ltrim(to_char(h04,''999G999G999''))||''" class="hour''|| case when h04 = 0 then '' is-null'' when h04 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 4</span> <span class="hour-'
||'value">''|| case when h04 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h04/1000),''99999999D0'')) else to_char(h04) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  5, ''||m.message_label||'' ''||ltrim(to_char(h05,''999G999G999''))||''" class="hour''|| case when h05 = 0 then '' is-null'' when h05 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 5</span> <span class="hour-'
||'value">''|| case when h05 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h05/1000),''99999999D0'')) else to_char(h05) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  6, ''||m.message_label||'' ''||ltrim(to_char(h06,''999G999G999''))||''" class="hour''|| case when h06 = 0 then '' is-null'' when h06 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 6</span> <span class="hour-'
||'value">''|| case when h06 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h06/1000),''99999999D0'')) else to_char(h06) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  7, ''||m.message_label||'' ''||ltrim(to_char(h07,''999G999G999''))||''" class="hour''|| case when h07 = 0 then '' is-null'' when h07 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 7</span> <span class="hour-'
||'value">''|| case when h07 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h07/1000),''99999999D0'')) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  8, ''||m.message_label||'' ''||ltrim(to_char(h08,''999G999G999''))||''" class="hour''|| case when h08 = 0 then '' is-null'' when h08 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 8</span> <span class="hour-'
||'value">''|| case when h08 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h08/1000),''99999999D0'')) else to_char(h08) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||''  9, ''||m.message_label||'' ''||ltrim(to_char(h09,''999G999G999''))||''" class="hour''|| case when h09 = 0 then '' is-null'' when h09 > 999 then '' is-over1k'' end ||''"><span class="hour-label"> 9</span> <span class="hour-'
||'value">''|| case when h09 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h09/1000),''99999999D0'')) else to_char(h09) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 10, ''||m.message_label||'' ''||ltrim(to_char(h10,''999G999G999''))||''" class="hour''|| case when h10 = 0 then '' is-null'' when h10 > 999 then '' is-over1k'' end ||''"><span class="hour-label">10</span> <span class="hour-'
||'value">''|| case when h10 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h10/1000),''99999999D0'')) else to_char(h10) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 11, ''||m.message_label||'' ''||ltrim(to_char(h11,''999G999G999''))||''" class="hour''|| case when h11 = 0 then '' is-null'' when h11 > 999 then '' is-over1k'' end ||''"><span class="hour-label">11</span> <span class="hour-'
||'value">''|| case when h11 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h11/1000),''99999999D0'')) else to_char(h11) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 12, ''||m.message_label||'' ''||ltrim(to_char(h12,''999G999G999''))||''" class="hour''|| case when h12 = 0 then '' is-null'' when h12 > 999 then '' is-over1k'' end ||''"><span class="hour-label">12</span> <span class="hour-'
||'value">''|| case when h12 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h12/1000),''99999999D0'')) else to_char(h12) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 13, ''||m.message_label||'' ''||ltrim(to_char(h13,''999G999G999''))||''" class="hour''|| case when h13 = 0 then '' is-null'' when h13 > 999 then '' is-over1k'' end ||''"><span class="hour-label">13</span> <span class="hour-'
||'value">''|| case when h13 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h13/1000),''99999999D0'')) else to_char(h13) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 14, ''||m.message_label||'' ''||ltrim(to_char(h14,''999G999G999''))||''" class="hour''|| case when h14 = 0 then '' is-null'' when h14 > 999 then '' is-over1k'' end ||''"><span class="hour-label">14</span> <span class="hour-'
||'value">''|| case when h14 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h14/1000),''99999999D0'')) else to_char(h14) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 15, ''||m.message_label||'' ''||ltrim(to_char(h15,''999G999G999''))||''" class="hour''|| case when h15 = 0 then '' is-null'' when h15 > 999 then '' is-over1k'' end ||''"><span class="hour-label">15</span> <span class="hour-'
||'value">''|| case when h15 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h15/1000),''99999999D0'')) else to_char(h15) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 16, ''||m.message_label||'' ''||ltrim(to_char(h16,''999G999G999''))||''" class="hour''|| case when h16 = 0 then '' is-null'' when h16 > 999 then '' is-over1k'' end ||''"><span class="hour-label">16</span> <span class="hour-'
||'value">''|| case when h16 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h16/1000),''99999999D0'')) else to_char(h16) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 17, ''||m.message_label||'' ''||ltrim(to_char(h17,''999G999G999''))||''" class="hour''|| case when h17 = 0 then '' is-null'' when h17 > 999 then '' is-over1k'' end ||''"><span class="hour-label">17</span> <span class="hour-'
||'value">''|| case when h17 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h17/1000),''99999999D0'')) else to_char(h17) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 18, ''||m.message_label||'' ''||ltrim(to_char(h18,''999G999G999''))||''" class="hour''|| case when h18 = 0 then '' is-null'' when h18 > 999 then '' is-over1k'' end ||''"><span class="hour-label">18</span> <span class="hour-'
||'value">''|| case when h18 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h18/1000),''99999999D0'')) else to_char(h18) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 19, ''||m.message_label||'' ''||ltrim(to_char(h19,''999G999G999''))||''" class="hour''|| case when h19 = 0 then '' is-null'' when h19 > 999 then '' is-over1k'' end ||''"><span class="hour-label">19</span> <span class="hour-'
||'value">''|| case when h19 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h19/1000),''99999999D0'')) else to_char(h19) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 20, ''||m.message_label||'' ''||ltrim(to_char(h20,''999G999G999''))||''" class="hour''|| case when h20 = 0 then '' is-null'' when h20 > 999 then '' is-over1k'' end ||''"><span class="hour-label">20</span> <span class="hour-'
||'value">''|| case when h20 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h20/1000),''99999999D0'')) else to_char(h20) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 21, ''||m.message_label||'' ''||ltrim(to_char(h21,''999G999G999''))||''" class="hour''|| case when h21 = 0 then '' is-null'' when h21 > 999 then '' is-over1k'' end ||''"><span class="hour-label">21</span> <span class="hour-'
||'value">''|| case when h21 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h21/1000),''99999999D0'')) else to_char(h21) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 22, ''||m.message_label||'' ''||ltrim(to_char(h22,''999G999G999''))||''" class="hour''|| case when h22 = 0 then '' is-null'' when h22 > 999 then '' is-over1k'' end ||''"><span class="hour-label">22</span> <span class="hour-'
||'value">''|| case when h22 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h22/1000),''99999999D0'')) else to_char(h22) end ||''</span></span>''||',
'      ''<span title="''||m.hour_label||'' 23, ''||m.message_label||'' ''||ltrim(to_char(h23,''999G999G999''))||''" class="hour''|| case when h23 = 0 then '' is-null'' when h23 > 999 then '' is-over1k'' end ||''"><span class="hour-label">23</span> <span class="hour-'
||'value">''|| case when h23 > 999 then replace(m.activity_by_hour_message_k,''~'',to_char((h23/1000),''99999999D0'')) else to_char(h23) end ||''</span></span>''||',
'      ''</div>'' hours',
'from',
'(',
'select ',
'       upper(USERID) developer,',
'       trunc(time_stamp) the_day,',
'       count(*) page_events,',
'       count(distinct(flow_id||''.''||step_id)) pages,',
'       count(distinct(flow_id)) applications,',
'      sum(decode(to_char(time_stamp,''HH24''),0,1,0)) h00,',
'      sum(decode(to_char(time_stamp,''HH24''),1,1,0)) h01,',
'      sum(decode(to_char(time_stamp,''HH24''),2,1,0)) h02,',
'      sum(decode(to_char(time_stamp,''HH24''),3,1,0)) h03,',
'      sum(decode(to_char(time_stamp,''HH24''),4,1,0)) h04,',
'      sum(decode(to_char(time_stamp,''HH24''),5,1,0)) h05,',
'      sum(decode(to_char(time_stamp,''HH24''),6,1,0)) h06,',
'      sum(decode(to_char(time_stamp,''HH24''),7,1,0)) h07,',
'      sum(decode(to_char(time_stamp,''HH24''),8,1,0)) h08,',
'      sum(decode(to_char(time_stamp,''HH24''),9,1,0)) h09,',
'      sum(decode(to_char(time_stamp,''HH24''),10,1,0)) h10,',
'      sum(decode(to_char(time_stamp,''HH24''),11,1,0)) h11,',
'      sum(decode(to_char(time_stamp,''HH24''),12,1,0)) h12,',
'      sum(decode(to_char(time_stamp,''HH24''),13,1,0)) h13,',
'      sum(decode(to_char(time_stamp,''HH24''),14,1,0)) h14,',
'      sum(decode(to_char(time_stamp,''HH24''),15,1,0)) h15,',
'      sum(decode(to_char(time_stamp,''HH24''),16,1,0)) h16,',
'      sum(decode(to_char(time_stamp,''HH24''),17,1,0)) h17,',
'      sum(decode(to_char(time_stamp,''HH24''),18,1,0)) h18,',
'      sum(decode(to_char(time_stamp,''HH24''),19,1,0)) h19,',
'      sum(decode(to_char(time_stamp,''HH24''),20,1,0)) h20,',
'      sum(decode(to_char(time_stamp,''HH24''),21,1,0)) h21,',
'      sum(decode(to_char(time_stamp,''HH24''),22,1,0)) h22,',
'      sum(decode(to_char(time_stamp,''HH24''),23,1,0)) h23',
'from  WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - :P39_DATE and',
'      security_group_id = :flow_security_group_id and',
'      userid is not null',
'group by upper(USERID), trunc(time_stamp)',
') pv,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.HOUR'') hour_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'') message_label from dual) m,',
'  (select wwv_flow_lang.system_message(''APEX.ACTIVITY_BY_HOUR.K'',''~'') activity_by_hour_message_k from dual ) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1770112042012894216)
,p_name=>'Page Views by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1770112042012894216
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(756684479750357824)
,p_db_column_name=>'THE_DAY'
,p_display_order=>10
,p_column_identifier=>'V'
,p_column_label=>'Day'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760807004141431322)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760807896667431323)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>30
,p_column_identifier=>'D'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760810192721431327)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1760814568114431332)
,p_db_column_name=>'HOURS'
,p_display_order=>90
,p_column_identifier=>'U'
,p_column_label=>'Activity by Hour'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1770114241780894462)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'17608149'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_report_columns=>'THE_DAY:DEVELOPER:HOURS'
,p_sort_column_1=>'THE_DAY'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'DEVELOPER'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
,p_break_on=>'THE_DAY:0:0:0:0:0'
,p_break_enabled_on=>'THE_DAY:0:0:0:0:0'
,p_sum_columns_on_break=>'PAGE_EVENTS:PAGE_VIEWS:PAGE_PROCESSING:REPORT_ROWS:PCT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1760805001689431312)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1765984845471296621)
,p_button_name=>'P39_SET'
,p_button_static_id=>'P25_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1760805403925431313)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1765984845471296621)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:25,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1760815757934431336)
,p_branch_action=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1760805852429431314)
,p_name=>'P39_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1765984845471296621)
,p_item_default=>'to_number(.125)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'to_number(.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to ',
'',
'include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00040
begin
wwv_flow_imp_page.create_page(
 p_id=>40
,p_name=>'Session Details'
,p_alias=>'SESSION-DETAILS'
,p_step_title=>'Session Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_purge_session.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1187818640219648)
,p_name=>'Session Information'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.ID,',
'       s.cookie_value,',
'       s.CREATED_ON,',
'       s.username,',
'       s.ON_NEW_INSTANCE_FIRED_FOR, ',
'       s.idle_timeout_on,',
'       s.life_timeout_on,',
'       s.SECURITY_GROUP_ID,',
'       c.short_name',
'  from WWV_FLOW_SESSIONS$ s,',
'       wwv_flow_companies c',
'where s.security_group_id = c.provisioning_company_id',
'  and s.security_group_id = :WORKSPACE_ID',
'  and s.id = :P40_SESSION_ID'))
,p_display_when_condition=>'P40_SESSION_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Session not found.'
,p_query_num_rows_type=>'COMPUTED_BUT_NOT_DISPLAYED'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48590718591771072)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Session'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(89507316220587728)
,p_query_column_id=>2
,p_column_alias=>'COOKIE_VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Cookie Value'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48591007320771072)
,p_query_column_id=>3
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>2
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'Day &DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(89507410079587728)
,p_query_column_id=>4
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>6
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48591227385771073)
,p_query_column_id=>5
,p_column_alias=>'ON_NEW_INSTANCE_FIRED_FOR'
,p_column_display_sequence=>3
,p_column_heading=>'Applications Visited'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(89507515994587728)
,p_query_column_id=>6
,p_column_alias=>'IDLE_TIMEOUT_ON'
,p_column_display_sequence=>7
,p_column_heading=>'Idle Timeout On'
,p_use_as_row_header=>'N'
,p_column_format=>'Day &DATE_TIME_FORMAT.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(89507616997587729)
,p_query_column_id=>7
,p_column_alias=>'LIFE_TIMEOUT_ON'
,p_column_display_sequence=>8
,p_column_heading=>'Life Timeout On'
,p_use_as_row_header=>'N'
,p_column_format=>'Day &DATE_TIME_FORMAT.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48591516713771073)
,p_query_column_id=>8
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(89507728617587729)
,p_query_column_id=>9
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>9
,p_column_heading=>'Short Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1274829139181317)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22439802147847987)
,p_plug_name=>'Session State'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_name,',
'       data_item_id   item_id,',
'       application_id flow_id,',
'       application_name,',
'       page_id,',
'       item_value,',
'       session_state_status',
'  from wwv_flow_data_view',
' where session_id        = :P40_SESSION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(22439916909847987)
,p_name=>'Session State'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No session state found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22440113334847990)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Item Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22440227904847990)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Item'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22440630720847991)
,p_db_column_name=>'SESSION_STATE_STATUS'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22440313394847991)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22440505071847991)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22441729952871920)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22443011776904530)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(22440813067848170)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1309212120536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'FLOW_ID:APPLICATION_NAME:PAGE_ID:ITEM_NAME:ITEM_VALUE:SESSION_STATE_STATUS'
,p_sort_column_1=>'FLOW_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC NULLS FIRST'
,p_sort_column_3=>'ITEM_NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(262455543395319703)
,p_name=>'Subscription Referencing This Session'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select r.flow_id application_id,',
'       r.page_id,',
'       ( select pr.plug_name from wwv_flow_page_plugs pr where pr.id = r.region_id ) region_name,',
'       r.name report_name,',
'       r.visibility report_type,',
'       n.owner subscribed_by,',
'       n.status,',
'       n.notify_interval frequency,',
'       n.start_date,',
'       n.end_date,',
'       n.offset_date',
'  from wwv_flow_sessions$ s,',
'       wwv_flow_worksheet_notify n,',
'       wwv_flow_worksheet_rpts_dev r',
'where s.id = n.session_id',
'  and r.id = n.report_id',
'  and s.security_group_id = :WORKSPACE_ID',
'  and s.id = :P40_SESSION_ID'))
,p_display_when_condition=>'P40_IS_SUBSCRIPTION_SESSION'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No subscription found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262455645250319704)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_ID'
,p_column_display_sequence=>10
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:1:&SESSION.::&DEBUG.:RP,:FB_FLOW_ID,F4000_P1_FLOW:#APPLICATION_ID#,#APPLICATION_ID#'
,p_column_linktext=>'#APPLICATION_ID#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262455702788319705)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>20
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:#APPLICATION_ID#,#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262455861558319706)
,p_query_column_id=>3
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>30
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262455990855319707)
,p_query_column_id=>4
,p_column_alias=>'REPORT_NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Report Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262456012512319708)
,p_query_column_id=>5
,p_column_alias=>'REPORT_TYPE'
,p_column_display_sequence=>50
,p_column_heading=>'Report Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(262470331768456667)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262456167717319709)
,p_query_column_id=>6
,p_column_alias=>'SUBSCRIBED_BY'
,p_column_display_sequence=>60
,p_column_heading=>'Subscribed By'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262456294206319710)
,p_query_column_id=>7
,p_column_alias=>'STATUS'
,p_column_display_sequence=>120
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(619315906303328344)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262456329287319711)
,p_query_column_id=>8
,p_column_alias=>'FREQUENCY'
,p_column_display_sequence=>80
,p_column_heading=>'Frequency'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(48455120589630644)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262456405654319712)
,p_query_column_id=>9
,p_column_alias=>'START_DATE'
,p_column_display_sequence=>90
,p_column_heading=>'Start Date'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262456579380319713)
,p_query_column_id=>10
,p_column_alias=>'END_DATE'
,p_column_display_sequence=>100
,p_column_heading=>'End Date'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262456618029319714)
,p_query_column_id=>11
,p_column_alias=>'OFFSET_DATE'
,p_column_display_sequence=>110
,p_column_heading=>'Offset Date'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1272927622171455)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1274829139181317)
,p_button_name=>'P40_GO'
,p_button_static_id=>'P40_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452210802432972277)
,p_button_sequence=>12
,p_button_plug_id=>wwv_flow_imp.id(1274829139181317)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1567803922839518)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(1187818640219648)
,p_button_name=>'DELETE_STATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Remove State'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1576114883908923)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(1187818640219648)
,p_button_name=>'REMOVE_SESSION'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Remove Session'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_user    varchar2(256);',
'  l_session varchar2(256);',
'  l_sgid    number;',
'begin',
'  wwv_flow_security.session_cookie_info_internal(',
'    p_user    => l_user,',
'    p_session => l_session,',
'    p_sgid    => l_sgid);',
'  if :P40_SESSION_ID in (:FLOW_SESSION, l_session) then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(780817511296213041)
,p_branch_action=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1576114883908923)
,p_branch_sequence=>5
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1275500873182590)
,p_branch_action=>'40'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1272319311168970)
,p_name=>'P40_SESSION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1274829139181317)
,p_prompt=>'Session'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' - ''||',
'       nvl(wwv_flow_escape.html(username),',
'           wwv_flow_lang.system_message(''NULL_IN_PAREN'')) a,',
'       id',
'from wwv_flow_sessions$ where security_group_id = :flow_security_group_id ',
'order by created_on desc'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specify which session to view'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(262456773341319715)
,p_name=>'P40_IS_SUBSCRIPTION_SESSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1274829139181317)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(262456854904319716)
,p_computation_sequence=>10
,p_computation_item=>'P40_IS_SUBSCRIPTION_SESSION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select is_subscription_session',
'  from wwv_flow_sessions$',
' where id = :P40_SESSION_ID',
'   and security_group_id = :WORKSPACE_ID;'))
,p_compute_when=>'P40_SESSION_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(262456999858319717)
,p_name=>'Confirm and Remove State'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1567803922839518)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(262457025094319718)
,p_event_id=>wwv_flow_imp.id(262456999858319717)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'This session state is referenced by a report subscription. Removing the state may cause an error when the subscription sends. Are you sure you want to remove?'
,p_attribute_03=>'danger'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P40_IS_SUBSCRIPTION_SESSION'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(262457575870319723)
,p_event_id=>wwv_flow_imp.id(262456999858319717)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_STATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(262457262405319720)
,p_name=>'Confirm and Remove Session'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1576114883908923)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(262457302176319721)
,p_event_id=>wwv_flow_imp.id(262457262405319720)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'This session is referenced by a report subscription. Removing the session will also remove the report subscription. Are you sure you want to remove?'
,p_attribute_03=>'danger'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P40_IS_SUBSCRIPTION_SESSION'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(262457477681319722)
,p_event_id=>wwv_flow_imp.id(262457262405319720)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REMOVE_SESSION'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1283615080262379)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>1283615080262379
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1570021715854150)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete state'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- delete state',
'delete from wwv_flow_data',
' where flow_instance in (',
'        select id',
'          from wwv_flow_sessions$',
'         where id = :P40_SESSION_ID',
'           and security_group_id =:WORKSPACE_ID );',
' ',
' -- delete collection',
'delete from wwv_flow_collections$',
' where session_id = :P40_SESSION_ID',
'   and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error removing session state for &P40_SESSION_ID..'
,p_process_when_button_id=>wwv_flow_imp.id(1567803922839518)
,p_process_success_message=>'Session state for &P40_SESSION_ID. removed.'
,p_internal_uid=>1570021715854150
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1577101161914367)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete session'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- delete session',
'wwv_flow_session.delete_session (',
'    p_id => :P40_SESSION_ID );',
'',
'-- delete subscription',
'if :P40_IS_SUBSCRIPTION_SESSION = ''Y'' then',
'    for l_ir_sub in (',
'        select id',
'        from wwv_flow_worksheet_notify',
'        where session_id = :P40_SESSION_ID',
'          and security_group_id =:WORKSPACE_ID )',
'    loop',
'        wwv_flow_ir.builder_delete_subscription (',
'            p_workspace_id     => :WORKSPACE_ID,',
'            p_subscription_id  => l_ir_sub.id);',
'    end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error removing session.'
,p_process_when_button_id=>wwv_flow_imp.id(1576114883908923)
,p_process_success_message=>'Session removed.'
,p_internal_uid=>1577101161914367
);
end;
/
prompt --application/pages/page_00041
begin
wwv_flow_imp_page.create_page(
 p_id=>41
,p_name=>'Application Build Status'
,p_alias=>'APPLICATION-BUILD-STATUS'
,p_step_title=>'Application Build Status'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_build_status.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(127686007289679931)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452282817862712315)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, build_status, ',
'       htmldb_item.select_list_from_lov(1, build_status,',
'             ''APPLICATION_BUILD_STATUS'',null,''NO'',''%null%'',''%'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''STATUS_LABEL'',name)) || ',
'              htmldb_item.hidden(2,id) build_status2,',
'       flow_status,',
'       htmldb_item.select_list_from_lov(3,flow_status,',
'             ''LIST_FLOW_STATUS'',''NO'',''%null%'',''%'', ''f''||lpad(''''||3,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''BUILD_STATUS_LABEL'',name)) flow_status2,',
'       id app_id, LAST_UPDATED_ON,',
'       decode(group_id,null,null,',
'             (select max(group_name) n ',
'                from wwv_flow_application_groups ',
'               where id = f.group_id)) Groupname',
'  from wwv_flow_visible_flows f',
' where build_status <> ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(452282915693712315)
,p_name=>'Run Only Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452283126086712535)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_link=>'f?p=4000:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#ID#,#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452283207040712537)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452283304109712538)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Build Status'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452283409354712539)
,p_db_column_name=>'APP_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'App_Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452283624250712541)
,p_db_column_name=>'GROUPNAME'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Group'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452283526289712540)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452308503310136246)
,p_db_column_name=>'BUILD_STATUS2'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Build Status'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(128034726363912582)
,p_rpt_show_filter_lov=>'2'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(473822112480267445)
,p_db_column_name=>'FLOW_STATUS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Flow Status'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(473822218842267449)
,p_db_column_name=>'FLOW_STATUS2'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Status'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(473904019503385140)
,p_rpt_show_filter_lov=>'2'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(452284900793728689)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1309306924536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:FLOW_STATUS2:BUILD_STATUS2:GROUPNAME:LAST_UPDATED_ON'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452408919099755753)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(127686007289679931)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(127887103676868191)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(127686007289679931)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(127687732181683054)
,p_branch_action=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(128174803123953163)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update build status'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_id            number;',
'   l_build_status  varchar2(255);',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_id := wwv_flow.g_f02(i);',
'  l_build_status := wwv_flow.g_f01(i);',
'  if l_build_status in (''RUN_AND_BUILD'',''RUN_ONLY'') then',
'  update wwv_flows',
'  set build_status = l_build_status',
'  where id = l_id and',
'        security_group_id = :flow_security_group_id and',
'        build_status != nvl(l_build_status,''x'') and',
'        build_status is not null;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(127887103676868191)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer := 0; l_id number; l_build_status varchar2(255);',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_id := wwv_flow.g_f02(i);',
'  l_build_status := wwv_flow.g_f01(i);',
'  if l_build_status in (''RUN_AND_BUILD'',''RUN_ONLY'') then',
'  for c1 in (select 1 from wwv_flows where id = l_id and',
'             security_group_id = :flow_security_group_id and',
'             build_status != nvl(l_build_status,''x'') and',
'             build_status is not null) loop',
'    c := c + 1;',
'   end loop;',
'  end if;',
'end loop;',
'if c > 0 then return true;',
'else',
'  return false;',
'end if;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Action Processed'
,p_internal_uid=>128174803123953163
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(473866102315330737)
,p_process_sequence=>11
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update status'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_id            number;',
'   l_flow_status   varchar2(30);',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'  l_id := wwv_flow.g_f02(i);',
'  l_flow_status := wwv_flow.g_f03(i);',
'  update wwv_flows',
'  set flow_status = l_flow_status',
'  where id = l_id',
'    and security_group_id = :flow_security_group_id',
'    and l_flow_status != flow_status;',
'end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(127887103676868191)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer := 0; l_id number; l_flow_status varchar2(30);',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'  l_id := wwv_flow.g_f02(i);',
'  l_flow_status := wwv_flow.g_f03(i);',
'  for c1 in (select 1 from wwv_flows where id = l_id and',
'             security_group_id = :flow_security_group_id and',
'             l_flow_status != flow_status) loop',
'    c := c + 1;',
'   end loop;',
'end loop;',
'if c > 0 then return true;',
'else',
'  return false;',
'end if;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Action Processed'
,p_internal_uid=>473866102315330737
);
end;
/
prompt --application/pages/page_00042
begin
wwv_flow_imp_page.create_page(
 p_id=>42
,p_name=>'Application Changes, detailed'
,p_alias=>'APPLICATION-CHANGES-DETAILED'
,p_step_title=>'Application Changes, detailed'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9858324202065705)
,p_plug_name=>'Developer Activity by User'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P42a */',
'  t.flow_user tu, ',
'  t.flow_id flow,',
'  (select name from wwv_flows where id = t.flow_id) application_name,',
'  t.page_id page, ',
'  (select name from wwv_flow_steps where id = t.page_id and flow_id = t.flow_id) page_name,',
'  t.audit_date d,',
'  initcap(',
'  replace(replace(replace(replace(replace(replace(replace(',
'  replace(replace(replace(replace(replace(replace(t.flow_table,',
'     ''LIST_ITEMS'',''List Entry''),',
'     ''WWV_FLOWS'',''Application''),',
'     ''WWV_FLOW_'',null),''_'','' ''),',
'     ''FLOW'',''Application''),',
'     ''SECURITY SCHEMES'',''Authorization Scheme''),',
'     ''LOAD TABLES'',''Data Loading''),',
'     ''PLUGINS'',''Plug-in''),',
'     ''STEP'',''Page''),',
'     ''PLUG'',''Region''),',
'     ''OPTION'',''Entry''),',
'     ''MESSAGES$'',''Text Message''),',
'     ''MENU'',''Breadcrumb'')',
'  ) flow_table,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) c,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK,',
'  t.flow_table apex_table_name,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'  ',
'where  ',
'  t.audit_date >= (sysdate - nvl(:P42_TIME,1)) and',
'  t.security_group_id = :flow_security_group_id and',
'  (nvl(:P42_APPLICATION,0) = 0 or t.flow_id = :P42_APPLICATION)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9858405979065705)
,p_name=>'Developer Activity by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9858700866065713)
,p_db_column_name=>'FLOW'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9858924570065714)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Page'
,p_column_link=>'f?p=4000:4500:#FLOW_SESSION#::::FB_FLOW_ID,FB_FLOW_PAGE_ID:#FLOW#,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9859110322065715)
,p_db_column_name=>'D'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9859217381065715)
,p_db_column_name=>'FLOW_TABLE'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>'Component'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9859327325065715)
,p_db_column_name=>'C'
,p_display_order=>5
,p_column_identifier=>'H'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9858604039065713)
,p_db_column_name=>'TU'
,p_display_order=>6
,p_column_identifier=>'A'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9858808008065713)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>7
,p_column_identifier=>'C'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9859015957065715)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>8
,p_column_identifier=>'E'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47724708709734627)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47724826781734634)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47725028102740289)
,p_db_column_name=>'FLOW_TABLE_PK'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47725222000747936)
,p_db_column_name=>'APEX_TABLE_NAME'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'APEX Table Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47725407024762510)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9859502658065926)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1309410062536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TU:FLOW:APPLICATION_NAME:PAGE:PAGE_NAME:D:FLOW_TABLE:C:COMPONENT_NAME'
,p_sort_column_1=>'D'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(265571819175286412)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450751510988564840)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(265571819175286412)
,p_button_name=>'P42_SET'
,p_button_static_id=>'P42_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47704400763533648)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(265571819175286412)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17183729171655135)
,p_branch_action=>'42'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17177809301639896)
,p_name=>'P42_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(265571819175286412)
,p_item_default=>'1'
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select the timeframe for the search.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47689130789409845)
,p_name=>'P42_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(265571819175286412)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00043
begin
wwv_flow_imp_page.create_page(
 p_id=>43
,p_name=>'Recent Sessions'
,p_alias=>'RECENT-SESSIONS'
,p_step_title=>'Recent Sessions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_help_text=>'AEADM/aadm_purge_session.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1267303896126727)
,p_plug_name=>'Sessions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Session state is maintained in the database.  This report shows recent sessions with links to more detailed session information.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10291912967175450)
,p_plug_name=>'Recent Sessions'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id session_id,',
'    s.username,',
'    s.created_on,',
'    s.created_on s,',
'    s.on_new_instance_fired_for,',
'    s.security_group_id,',
'    s.idle_timeout_on,',
'    s.life_timeout_on,',
'    s.is_subscription_session,',
'    s.remote_addr,',
'    c.short_name',
'from WWV_FLOW_SESSIONS$ s,',
'     wwv_flow_companies c',
'where s.security_group_id = c.provisioning_company_id',
'  and s.security_group_id = :flow_security_group_id',
'  and s.created_on >= sysdate - nvl(:p43_time,1)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10292026503175450)
,p_name=>'Recent Sessions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(262455417119319702)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>10
,p_column_identifier=>'M'
,p_column_label=>'Session'
,p_column_link=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:40:P40_SESSION_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10292410662175460)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>20
,p_column_identifier=>'C'
,p_column_label=>'Creation Date'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10292530731175461)
,p_db_column_name=>'S'
,p_display_order=>30
,p_column_identifier=>'D'
,p_column_label=>'Creation'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10292616396175461)
,p_db_column_name=>'ON_NEW_INSTANCE_FIRED_FOR'
,p_display_order=>40
,p_column_identifier=>'E'
,p_column_label=>'New Instance'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10292716393175461)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>50
,p_column_identifier=>'F'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(89509122031600248)
,p_db_column_name=>'USERNAME'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(89509328057612571)
,p_db_column_name=>'IDLE_TIMEOUT_ON'
,p_display_order=>70
,p_column_identifier=>'I'
,p_column_label=>'Idle Timeout On'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(89509425220612571)
,p_db_column_name=>'LIFE_TIMEOUT_ON'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Life Timeout On'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(32047116366500917)
,p_db_column_name=>'IS_SUBSCRIPTION_SESSION'
,p_display_order=>90
,p_column_identifier=>'N'
,p_column_label=>'Subscription Session'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157815226475866526)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(89509510547612571)
,p_db_column_name=>'REMOTE_ADDR'
,p_display_order=>100
,p_column_identifier=>'K'
,p_column_label=>'Remote Addr'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(89509626443612572)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>110
,p_column_identifier=>'L'
,p_column_label=>'Short Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10294815321186135)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1309514936536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SESSION_ID:CREATED_ON:S:ON_NEW_INSTANCE_FIRED_FOR:SECURITY_GROUP_ID:USERNAME:IDLE_TIMEOUT_ON:LIFE_TIMEOUT_ON:REMOTE_ADDR:SHORT_NAME:'
,p_sort_column_1=>'S'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(122208606764133208)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452206030436952008)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(122208606764133208)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1252821901052158)
,p_branch_action=>'43'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1258011898081713)
,p_name=>'P43_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(122208606764133208)
,p_prompt=>'Show'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00044
begin
wwv_flow_imp_page.create_page(
 p_id=>44
,p_name=>'Preferences by User'
,p_alias=>'PREFERENCES-BY-USER'
,p_step_title=>'Preferences by User'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_help_text=>'AEADM/aadm_user_pref.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10339007894846227)
,p_plug_name=>'Preferences'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_id, preference_name, attribute_value, security_group_id,',
'   preference_type, application',
'from (',
'select ',
'    user_id,',
'    preference_name,',
'    attribute_value,',
'    security_group_id,',
'    decode(substr(attribute_value,1,8),''fsp_sort'',''SORT'',',
'    decode(substr(preference_name,1,16),''PERSISTENT_ITEM_'',''ITEM'',',
'    decode(substr(preference_name,1,3),''FSP'',',
'    decode(substr(preference_name,length(preference_name)-4,5),''_SORT'',''SORT'',''OTHER''),',
'    ''OTHER''))) preference_type,',
'    decode(substr(preference_name,1,3),',
'        ''FSP'',',
'        decode(instr(preference_name,''_''),0,null,substr(preference_name,4,instr(preference_name,''_'')-4)),',
'        null',
'         ) application',
'from WWV_FLOW_PREFERENCES$',
'where security_group_id = :flow_security_group_id',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10339121225846227)
,p_name=>'Preferences'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10339300770846234)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10339410084846235)
,p_db_column_name=>'PREFERENCE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10339532428846235)
,p_db_column_name=>'ATTRIBUTE_VALUE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10339607085846235)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10339714191846235)
,p_db_column_name=>'PREFERENCE_TYPE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Preference Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10339819416846235)
,p_db_column_name=>'APPLICATION'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Application'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10340008563846420)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1309621241536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'USER_ID:PREFERENCE_NAME:ATTRIBUTE_VALUE:SECURITY_GROUP_ID:PREFERENCE_TYPE:APPLICATION'
,p_sort_column_1=>'USER_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PREFERENCE_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452411127803786608)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10339007894846227)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1587125578000668)
,p_branch_action=>'44'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00045
begin
wwv_flow_imp_page.create_page(
 p_id=>45
,p_name=>'Purge Sessions'
,p_alias=>'PURGE-SESSIONS'
,p_step_title=>'Purge Sessions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_help_text=>'AEADM/aadm_purge_session.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1615024869157863)
,p_plug_name=>'Purge Sessions'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_sessions_count pls_integer := 0;',
'   l_old_sessions pls_integer := 0;',
'   l_users pls_integer := 0;',
'begin',
'for c1 in (select count(*) c , count(distinct username) u',
'           from wwv_flow_sessions$ ',
'           where security_group_id = :flow_security_group_id) loop',
'   l_sessions_count := c1.c;',
'   l_users := c1.u;',
'end loop;',
'for c1 in (select count(*) c',
'           from wwv_flow_sessions$ ',
'           where security_group_id = :flow_security_group_id and',
'                 created_on <= (sysdate - nvl(:p45_time,1)) ) loop',
'           l_old_sessions := c1.c;',
'end loop; ',
'sys.htp.p(''<ul>'');',
'--sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_TOTAL_SESSIONS'',:company,l_sessions_count)||''</li>'');',
'sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_TOTAL_SESSIONS2'',to_char(l_sessions_count,''999G999G999G999G990''))||''</li>'');',
'sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_DISTINCT_USERS'',l_users)||''</li>'');',
'if :p45_time >=1 then',
'sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_SESSIONS_OLDER_THAN'',:p45_time,l_old_sessions)||''</li>'');',
'else',
'sys.htp.p(''<li>''||wwv_flow_lang.system_message(''F4350_SESSIONS_OLDER_THAN_MINS'',round(:p45_time*24*60,3),l_old_sessions)||''</li>'');',
'end if;',
'sys.htp.p(''</ul>'');',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>'Sessions are used to maintain user state.<p />'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6896421131024683)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1615024869157863)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1613502921141984)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1615024869157863)
,p_button_name=>'REPORT_SESSIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Report Sessions'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1609312917116469)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1615024869157863)
,p_button_name=>'PURGE_SESSIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Sessions'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1610017072117764)
,p_branch_action=>'45'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1608603220113714)
,p_name=>'P45_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1615024869157863)
,p_prompt=>'Sessions older than:    '
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(107534131274292840)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify a date from which to purge session data.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1624325664290467)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge sessions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_user    varchar2(256);',
'    l_session varchar2(256);',
'    l_sgid    number;',
'begin',
'    wwv_flow_security.session_cookie_info_internal(',
'      p_user    => l_user,',
'      p_session => l_session,',
'      p_sgid    => l_sgid);',
'',
'    delete from wwv_flow_sessions$',
'     where security_group_id = :WORKSPACE_ID',
'       and is_subscription_session = ''N''',
'       and created_on <= ( sysdate - nvl( :P45_TIME, 1 ) )',
'       and id not in (:FLOW_SESSION, l_session);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error removing sessions.'
,p_process_when_button_id=>wwv_flow_imp.id(1609312917116469)
,p_process_success_message=>'Sessions removed.'
,p_internal_uid=>1624325664290467
);
end;
/
prompt --application/pages/page_00046
begin
wwv_flow_imp_page.create_page(
 p_id=>46
,p_name=>'Purge Preferences'
,p_alias=>'PURGE-PREFERENCES1'
,p_step_title=>'Purge Preferences'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215469304188572178)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_help_text=>'AEADM/aadm_user_pref.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1689606689991219)
,p_plug_name=>'Purge Preferences'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for c1 in (select count(*) c, count(distinct user_id) u',
'  from WWV_FLOW_PREFERENCES$',
'  where security_group_id = :flow_security_group_id) loop',
'  sys.htp.p(''<strong>''||wwv_flow_lang.system_message(''F4350_SUMMARY'')||''</strong><br>''||',
'--wwv_flow_lang.system_message(''F4350_PREFS_EXISTS_FOR'',c1.c,c1.u,:company));',
'wwv_flow_lang.system_message(''F4350_PREFS_EXISTS_FOR2'',c1.c,c1.u));',
'  end loop;',
'  sys.htp.p(''<br>&nbsp;<br><strong>''|| wwv_flow_lang.system_message(''F4350_SELECTED_USER'') ||''</strong><br>'');',
'  if :P46_USER is null then',
'    sys.htp.p( wwv_flow_lang.system_message(''F4350_NO_USER_SELECTED'')||''<p />'');',
'  else',
'    for c1 in (select count(*) c',
'  from WWV_FLOW_PREFERENCES$',
'  where security_group_id = :flow_security_group_id and ',
'        user_id = upper(:p46_user) ) loop',
'      sys.htp.p(wwv_flow_lang.system_message(''F4350_USER_HAS_X_PREFS'',wwv_flow_escape.html(:p46_user),c1.c));',
'',
'  end loop;',
'  end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1690324697996432)
,p_plug_name=>'Preferences'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Preferences are state maintained by user and can span sessions.  Preferences can be purged once a user is entered.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1698306052095099)
,p_name=>'User Preferences'
,p_template=>wwv_flow_imp.id(388531674152470979)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    user_id,',
'    preference_name,',
'    attribute_value,',
'    security_group_id',
'from WWV_FLOW_PREFERENCES$',
'where security_group_id = :flow_security_group_id and',
'      user_id = upper(:p46_user)',
'order by preference_name'))
,p_display_when_condition=>'P46_USER'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(6659715068668103)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No preferences found.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48848318967772537)
,p_query_column_id=>1
,p_column_alias=>'USER_ID'
,p_column_display_sequence=>1
,p_column_heading=>'User'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48848426607772537)
,p_query_column_id=>2
,p_column_alias=>'PREFERENCE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Preference'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48848523057772537)
,p_query_column_id=>3
,p_column_alias=>'ATTRIBUTE_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48848615680772537)
,p_query_column_id=>4
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1702529517120847)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1689606689991219)
,p_button_name=>'PURGE_USER_PREFERENCES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Purge User Preferences'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct user_id d',
'  from WWV_FLOW_PREFERENCES$',
' where security_group_id = :flow_security_group_id',
'   and user_id = upper(:P46_USER)'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1693208121019989)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1689606689991219)
,p_button_name=>'REPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Report'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6893815805013744)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1689606689991219)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1691215477003220)
,p_branch_action=>'46'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1692011107011376)
,p_name=>'P46_USER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1689606689991219)
,p_prompt=>'User'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct user_id d, user_id v',
'  from WWV_FLOW_PREFERENCES$',
' where security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify a user for which to purge preferences.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(46075113198002110)
,p_validation_name=>'user valid'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct user_id d',
'  from WWV_FLOW_PREFERENCES$',
' where security_group_id = :flow_security_group_id',
'   and user_id = upper(:P46_USER)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'User does not exist or does not have any preferences.'
,p_validation_condition=>'P46_USER'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1693208121019989)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1704030340130527)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge preferences for user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete ',
'from WWV_FLOW_PREFERENCES$',
'where security_group_id = :flow_security_group_id and',
'      user_id = upper(:p46_user)'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting preferences for user &P46_USER..'
,p_process_when_button_id=>wwv_flow_imp.id(1702529517120847)
,p_process_success_message=>'Deleted preferences for user &P46_USER..'
,p_internal_uid=>1704030340130527
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1713702598169784)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(1693208121019989)
,p_internal_uid=>1713702598169784
);
end;
/
prompt --application/pages/page_00047
begin
wwv_flow_imp_page.create_page(
 p_id=>47
,p_name=>'Application Cache'
,p_alias=>'APPLICATION-CACHE'
,p_step_title=>'Application Cache'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_help_text=>'AEADM/aadmn_mg_cache.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47247130666738439)
,p_plug_name=>'Manage Application Cache'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(41424809053067534)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
);
end;
/
prompt --application/pages/page_00048
begin
wwv_flow_imp_page.create_page(
 p_id=>48
,p_name=>'Request Database Schema - Define Request'
,p_alias=>'REQUEST-DATABASE-SCHEMA-DEFINE-REQUEST'
,p_step_title=>'Request Database Schema - Define Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215667724760013351)
,p_step_template=>wwv_flow_imp.id(718401914085176458)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1993922974139464)
,p_plug_name=>'Identify Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p>'');',
'sys.htp.p(wwv_flow_lang.system_message(''F4350_WORKSPACE_SCHEMAS'')||'':<strong>'');',
'for c1 in (select schema',
'           from wwv_flow_company_schemas',
'           where security_group_id=:flow_security_group_id',
'           order by schema) loop',
'   sys.htp.p (wwv_flow_escape.html(c1.schema));',
'end loop;',
'sys.htp.p(''</strong>'');',
'sys.htp.p(''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>'<input type="text" style="display:none;" />'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32643316621230690)
,p_plug_name=>'request schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720186138525572350)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(47297014014256767)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(720190141563578035)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208559426831334965)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113506440695874)
,p_plug_name=>'Request Database Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720159283194358177)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168313623258767902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208559426831334965)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2006525707187473)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208559426831334965)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2009011986193021)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208559426831334965)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(245533631539678851)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':SR_NAME is null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(245526615721532377)
,p_branch_action=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2009011986193021)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12199828843371901)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2010524107196472)
,p_name=>'SR_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1993922974139464)
,p_prompt=>'Schema Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the name of an existing schema to be assigned to the workspace or the name of a new schema to be created and assigned to the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(245498531773120633)
,p_name=>'P48_NEW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1993922974139464)
,p_item_default=>'YES'
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NEW_OR_EXISTING_SCHEMA'
,p_lov=>'.'||wwv_flow_imp.id(245496725063109254)||'.'
,p_display_when=>'nvl(wwv_flow_platform.get_preference(''REQ_NEW_SCHEMA''),''N'') = ''N'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Create a new schema, or request workspace access to an existing schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(246260024880572305)
,p_computation_sequence=>10
,p_computation_item=>'SR_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:SR_NAME)'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2013003459199990)
,p_validation_name=>'schema name not null'
,p_validation_sequence=>10
,p_validation=>'SR_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Schema name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(2009011986193021)
,p_associated_item=>wwv_flow_imp.id(2010524107196472)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 02-DEC-2002 12:35'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2014803590209500)
,p_validation_name=>'no spaces'
,p_validation_sequence=>20
,p_validation=>'SR_NAME'
,p_validation_type=>'ITEM_CONTAINS_NO_SPACES'
,p_error_message=>'Schema name must not contain spaces.'
,p_validation_condition=>'SR_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(2009011986193021)
,p_associated_item=>wwv_flow_imp.id(2010524107196472)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(245516700774423917)
,p_validation_name=>'no quotes in name'
,p_validation_sequence=>30
,p_validation=>'instr(:SR_NAME,'''''''')+instr(:SR_NAME,''"'') = 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Schema name must not contain quotation marks.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (nvl(:P48_NEW,''YES'') = ''YES'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(2009011986193021)
,p_associated_item=>wwv_flow_imp.id(2010524107196472)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(245518314411437321)
,p_validation_name=>'schema name valid'
,p_validation_sequence=>40
,p_validation=>'wwv_flow_utilities.is_valid_identifier(:SR_NAME)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Schema name is not a valid Oracle identifier.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (nvl(:P48_NEW,''YES'') = ''YES'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(2009011986193021)
,p_associated_item=>wwv_flow_imp.id(2010524107196472)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(245514313063389629)
,p_validation_name=>'schema exists'
,p_validation_sequence=>50
,p_validation=>'select null from sys.all_users where username = upper(:SR_NAME)'
,p_validation_type=>'EXISTS'
,p_error_message=>'Invalid Schema'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (nvl(:P48_NEW,''YES'') = ''NO'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(2009011986193021)
,p_associated_item=>wwv_flow_imp.id(2010524107196472)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(245519627009450426)
,p_validation_name=>'new schema does not exist'
,p_validation_sequence=>60
,p_validation=>'select 1 from sys.dba_users where username = upper(:SR_NAME)'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Invalid Schema'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (nvl(:P48_NEW,''YES'') = ''YES'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(2009011986193021)
,p_associated_item=>wwv_flow_imp.id(2010524107196472)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(245520630949461024)
,p_validation_name=>'new schema not a role'
,p_validation_sequence=>70
,p_validation=>'select null from sys.dba_roles where role = upper(:SR_NAME)'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Invalid Schema'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (nvl(:P48_NEW,''YES'') = ''YES'' and :SR_NAME is not null) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(2009011986193021)
,p_associated_item=>wwv_flow_imp.id(2010524107196472)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(245521603161471970)
,p_validation_name=>'schema is not restricted when admin is restricted'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provision.schema_name_valid(',
'    p_schema            => :SR_NAME,',
'    p_workspace_name    =>  wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Schema is reserved or restricted'
,p_when_button_pressed=>wwv_flow_imp.id(2009011986193021)
,p_associated_item=>wwv_flow_imp.id(2010524107196472)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(245526022863524970)
,p_validation_name=>'new schema not used in existing workspace'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_company_schemas ',
'where schema = upper(:SR_NAME)',
'and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Invalid Schema'
,p_validation_condition=>'SR_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(2009011986193021)
,p_associated_item=>wwv_flow_imp.id(2010524107196472)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00049
begin
wwv_flow_imp_page.create_page(
 p_id=>49
,p_name=>'Request Storage - Define Request'
,p_alias=>'REQUEST-STORAGE-DEFINE-REQUEST'
,p_step_title=>'Request Storage - Define Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215667724760013351)
,p_step_template=>wwv_flow_imp.id(718401914085176458)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47296413190247132)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(47296115483238304)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47297500292262313)
,p_plug_name=>'Train'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720186138525572350)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(47297014014256767)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(720190141563578035)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(100110829319376668)
,p_plug_name=>'Request Storage'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208563318782351569)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113628692695875)
,p_plug_name=>'Request Storage'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720159283194358177)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2032017105289086)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208563318782351569)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2032705116295146)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208563318782351569)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168281130581997999)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208563318782351569)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(916968811824940971)
,p_branch_action=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2032705116295146)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2030628749283010)
,p_name=>'P49_STORAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(100110829319376668)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''C''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Amount of storage to add (MB):'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'   and display = ''Y''',
' order by to_number(d)'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the amount of space to be added.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(19387910105227426)
,p_validation_name=>'Validate storage request size'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'   and display = ''Y''',
'   and req_size = :P49_STORAGE'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Invalid storage amount requested.'
,p_when_button_pressed=>wwv_flow_imp.id(2032705116295146)
,p_associated_item=>wwv_flow_imp.id(2030628749283010)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(663453485838166125)
,p_validation_name=>'Check Max Storage Request'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_storage       number;',
'    l_max_storage   constant number := to_number(wwv_flow_platform.get_preference(''MAX_WKSP_STORAGE_REQ_MB''));',
'begin',
'',
'    select sum(s.database_size) total_storage into l_storage',
'      from (select database_size ',
'              from wwv_flow_provision_company ',
'             where security_group_id = :flow_security_group_id',
'             union all ',
'            select to_number(service_attribute_1) database_size ',
'              from wwv_flow_provision_serice_mod ',
'             where service_name = ''CHANGE_DB_SIZE'' ',
'               and request_status != ''DECLINED'' ',
'               and security_group_id = :flow_security_group_id ) s;',
'',
'    l_storage := l_storage + to_number(:P49_STORAGE);',
'',
'    if l_storage > l_max_storage then',
'        return wwv_flow_lang.system_message(''F4050.DENY_ADD_STORAGE_EMAIL'',:P49_STORAGE,:company);',
'    else',
'        return null;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'wwv_flow_platform.get_preference(''MAX_WKSP_STORAGE_REQ_MB'') is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2032705116295146)
,p_associated_item=>wwv_flow_imp.id(2030628749283010)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_imp_page.create_page(
 p_id=>50
,p_name=>'Request Service Termination - Define Request'
,p_alias=>'REQUEST-SERVICE-TERMINATION-DEFINE-REQUEST'
,p_step_title=>'Request Service Termination - Define Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215667724760013351)
,p_step_template=>wwv_flow_imp.id(718401914085176458)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47463728350673648)
,p_name=>'Applications'
,p_template=>wwv_flow_imp.id(486014333429205839)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id || ''. '' || f.name as name',
'from wwv_flow_visible_flows f',
'where f.build_status != ''RUN_AND_HIDDEN''',
'order by f.id'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_visible_flows f',
'where f.build_status != ''RUN_AND_HIDDEN'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Applications found.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47464210473677951)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(100113926811394963)
,p_name=>'Workspace Service Termination'
,p_template=>wwv_flow_imp.id(720158679964358138)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT ',
'   "WWV_FLOW_COMPANIES"."PROVISIONING_COMPANY_ID" "PROVISIONING_COMPANY_ID", ',
'   "WWV_FLOW_COMPANIES"."SHORT_NAME" "SHORT_NAME", ',
'   "WWV_FLOW_COMPANIES"."FIRST_SCHEMA_PROVISIONED" "FIRST_SCHEMA_PROVISIONED"',
'FROM ',
'   "WWV_FLOW_COMPANIES"',
'WHERE (("WWV_FLOW_COMPANIES"."PROVISIONING_COMPANY_ID" =wwv_flow.get_sgid))'))
,p_header=>'<p>Workspace administrators use this page to request the termination of service.</p>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(100114116170394967)
,p_query_column_id=>1
,p_column_alias=>'PROVISIONING_COMPANY_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(100114228842394967)
,p_query_column_id=>2
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(100114320671394967)
,p_query_column_id=>3
,p_column_alias=>'FIRST_SCHEMA_PROVISIONED'
,p_column_display_sequence=>3
,p_column_heading=>'First Schema Provisioned'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(100115402008397222)
,p_name=>'Schemas'
,p_template=>wwv_flow_imp.id(486014333429205839)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.schema, u.default_tablespace name2',
'  from wwv_flow_company_schemas a, ',
'       sys.dba_users u',
' where a.schema = u.username',
'   and a.security_group_id = wwv_flow.get_sgid',
'order by 1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(100115611210397225)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(175696032163297164)
,p_query_column_id=>2
,p_column_alias=>'NAME2'
,p_column_display_sequence=>2
,p_column_heading=>'Default Tablespace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(100118630059405357)
,p_name=>'Application Developers'
,p_template=>wwv_flow_imp.id(486014333429205839)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select userid as the_name',
'from WWV_FLOW_DEVELOPERS',
'where SECURITY_GROUP_ID = :flow_security_group_id',
'order by userid'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from WWV_FLOW_DEVELOPERS',
'where SECURITY_GROUP_ID = :flow_security_group_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47465607450733862)
,p_query_column_id=>1
,p_column_alias=>'THE_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168316517118822887)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720186138525572350)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(47297014014256767)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(720190141563578035)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208567423546371811)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113739388695875)
,p_plug_name=>'Request Service Termination'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720159283194358177)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168318118550851644)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208567423546371811)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2041318322327334)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208567423546371811)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2042126980329817)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(208567423546371811)
,p_button_name=>'REQUEST_SERVICE_TERMINATION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(917086616803951863)
,p_branch_action=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2042126980329817)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(917202521436962653)
,p_branch_action=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(168318118550851644)
,p_branch_sequence=>20
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_imp_page.create_page(
 p_id=>51
,p_name=>'Group Assignments'
,p_alias=>'GROUP-ASSIGNMENTS'
,p_step_title=>'Group Assignments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_groups.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63231316426439799)
,p_plug_name=>'Group Assignments'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This report lists groups assigned to users and other groups. You can use groups for categorization and to manage privileges.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(132384215654937539)
,p_plug_name=>'users and groups APEX 4 0'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47054717520943020)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441077028778796807)
,p_plug_name=>'Group Assignments'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select grantee_name,',
'       granted_name,',
'       grantee_type,',
'       case grantee_type',
'         when ''U'' then wwv_flow_utilities.prepare_url(''f?p=&APP_ID.:56:'' || :APP_SESSION ||',
'                                                      ''::NO::F4350_P56_USER_ID,LAST_VIEW:'' || grantee_id || '',&APP_PAGE_ID.'')',
'         when ''G'' then wwv_flow_utilities.prepare_url(''f?p=&APP_ID.:54:'' || :APP_SESSION ||',
'                                                      ''::NO::F4350_P54_ID,LAST_VIEW:'' || grantee_id || '',&APP_PAGE_ID.'')',
'       end as grantee_url',
'/*',
'       case granted_security_group_id',
'         when security_group_id then wwv_flow_utilities.prepare_url(''f?p=&APP_ID.:54:'' || :APP_SESSION ||',
'                                                                    ''::NO::F4350_P54_ID,LAST_VIEW:'' || granted_id || '',&APP_PAGE_ID.'')',
'         else ''#''',
'       end as granted_url',
'*/',
'  from wwv_flow_group_grants',
' where security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441077109644796807)
,p_name=>'User Group Assignments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132386230855089063)
,p_db_column_name=>'GRANTEE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Grantee'
,p_column_html_expression=>'<a href="#GRANTEE_URL#">#GRANTEE_NAME#</a>'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132386305744089068)
,p_db_column_name=>'GRANTED_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Group'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132386400368089068)
,p_db_column_name=>'GRANTEE_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(132386709008105935)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(132386503304089068)
,p_db_column_name=>'GRANTEE_URL'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Grantee Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441077718682801782)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1309713026536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'GRANTEE_NAME:GRANTED_NAME:GRANTEE_TYPE:GRANTEE_URL'
,p_sort_column_1=>'GRANTEE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'GRANTED_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(132384701504940813)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(441077028778796807)
,p_button_name=>'VIEW_DASHBOARD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'View Dashboard'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_00052
begin
wwv_flow_imp_page.create_page(
 p_id=>52
,p_name=>'Create User'
,p_alias=>'CREATE-USER'
,p_step_title=>'Create User'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_step_template=>wwv_flow_imp.id(692762523503114201)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_new_users.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4597004638216477)
,p_plug_name=>'Account Privileges'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63567744865578431)
,p_plug_name=>'User Identification'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63571066572605837)
,p_plug_name=>'Users'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this page to control access for &PRODUCT_NAME. application developers, workspace administrators and end users.</p>',
'<p>Developers can create and edit applications as well as create and modify database objects.</p>',
'<p>Workspace administrators can additionally create and edit user accounts, manage groups, manage development services.</p>',
'<p>End users have no development privileges and are defined to provide access control to applications that do not use an external authentication scheme.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(187400734286303164)
,p_plug_name=>'Create User'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(187414449357326556)
,p_plug_name=>'Group Assignments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(504198401567901625)
,p_plug_name=>'&F4350_PASSWORD_REGION_TITLE.'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(762729260417462701)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40275409253350646)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63567961253578435)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(187400734286303164)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(39238412884699357)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(187400734286303164)
,p_button_name=>'CREATE_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63568042920578435)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(187400734286303164)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create User'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(63570246176578443)
,p_branch_action=>'55'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(63568042920578435)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(39244700248733466)
,p_branch_action=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:52,EDIT_USER_PRIVS:P52_DEVELOPER,P52_ADMIN:&P52_DEVELOPER.,&P52_ADMIN.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(39238412884699357)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2748803393523351)
,p_name=>'P52_ACCOUNT_LOCKED'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Set Account Availability'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ACCOUNT_LOCK_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(6949526744661130)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Locked</strong> to prevent the account from being used. Select <strong>Unlocked</strong> to allow the account to be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2749004588523351)
,p_name=>'P52_CHANGE_PWD_ON_FIRST_USE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(504198401567901625)
,p_item_default=>'Y'
,p_prompt=>'Require Change of Password on First Use'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select <strong>Yes</strong> to require the user of this account to change the password immediately after logging in the first time using the current password. This rule applies to the use of this account for workspace administration or development as'
||' well as to use of this account to log in to developed applications.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63568348763578436)
,p_name=>'F4350_P52_USER_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(63567744865578431)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the username used to log in to the system. Usernames have these restrictions: <ul><li>',
'maximum length of 100 characters</li><li>',
'no spaces</li>',
'<li>only these special characters are permitted: @ and periods (.)</li></ul>',
'<p>The username may also be used to reference user activity using the monitor applications. The bind variable <code>:app_user </code>returns the value of the current user when building applications.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63568549286578437)
,p_name=>'F4350_P52_FIRST_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(63567744865578431)
,p_prompt=>'First Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the first or given name to further identify the user. This optional field is used for informational purposes only.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63568751448578438)
,p_name=>'F4350_P52_LAST_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(63567744865578431)
,p_prompt=>'Last Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the last or family name to further identify the user. This optional field is used for informational purposes only.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63568945841578439)
,p_name=>'F4350_P52_DESCRIPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(63567744865578431)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>200
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use this field to record comments about the user for informational purposes only.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63569221717578439)
,p_name=>'F4350_P52_EMAIL_ADDRESS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(63567744865578431)
,p_prompt=>'Email Address'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>240
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify an email address for use with general correspondence, notifications about resetting passwords, and so on.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'LOWER'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63569351113578440)
,p_name=>'F4350_P52_WEB_PASSWORD'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(504198401567901625)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Password'
,p_post_element_text=>' <span class="instructiontext">Passwords are case sensitive</span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a password. Passwords are case sensitive. Developers can change their own passwords. Developers with Administrator privilege can change the passwords of users within the same workspace.'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63569543152578441)
,p_name=>'F4350_P52_GROUP_IDS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(187414449357326556)
,p_prompt=>'Group Assignments:'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'F4350_FND_GROUP_IDS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
' order by 1'))
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The user belongs to the groups that are highlighted. To add a user to the group, click the name so that it is highlighted. To remove a group, click it again to clear the highlighting. </p> ',
'<p>Group assignments enable developers to control access to specific features and functions by groups. ',
'This group functionality is built into App Builder and works best (and most conveniently) with cookie-based authentication. ',
'However, this user group functionality is not portable over different authentication schemas.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(66055244597705294)
,p_name=>'F4350_P52_ALLOW_SCHEMA_ACCESS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_prompt=>'Accessible Schemas (null for all)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a colon-delimited list of schemas for which this developer has permissions when using the SQL Workshop. The list of schemas you enter here restricts the user to a subset of the full set of schemas provisioned for the workspace and determines wh'
||'at schema names the user sees in SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(66067229562721999)
,p_name=>'F4350_P52_DEFAULT_SCHEMA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Specify the default schema used for data browsing, application creation, and SQL script execution. When using workspaces that have more than one schema available, this schema is the default for creating applications, performing SQL queries, and so on'
||'. This feature does not control security, only the user''s preference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(157872609565288125)
,p_name=>'P52_DEVELOPER'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_item_default=>'N'
,p_prompt=>'User is a developer:'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onClick="javascript:if (document.forms[0].P52_ADMIN_0.checked) document.forms[0].P52_DEVELOPER_0.checked = true;"'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify if this user should have developer privileges. Developers must have access to either the App Builder, the SQL Workshop, or both.',
'',
'Components may not be available if they are switched off by Instance Administrators.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(157873517877290564)
,p_name=>'P52_ADMIN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_item_default=>'N'
,p_prompt=>'User is a workspace administrator:'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onClick="javascript:if (document.forms[0].P52_ADMIN_0.checked) document.forms[0].P52_DEVELOPER_0.checked = true;"'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify if this user should have workspace administrator privileges. Administrators are given access to all components. Additionally, they can also manage user accounts, groups, and development services.',
'',
'Components may not be available if they are switched off by Instance Administrators.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180046203499305667)
,p_name=>'P52_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'App Builder Access'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to the App Builder.<br>',
'<br>',
'An Administrator will always have access to the App Builder.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when App Builder Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180046412157308127)
,p_name=>'P52_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'SQL Workshop Access'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to SQL Workshop.<br>',
'<br>',
'An Administrator will always have access to SQL Workshop.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when SQL Workshop Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180047014712318343)
,p_name=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Team Development Access'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                  where provisioning_company_id = :flow_security_group_id',
'                     and NVL(allow_team_development_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a user has access to Team Development.<br>',
'<br>',
'An Administrator will always have access to Team Development.<br>',
'<br>',
'This attribute is always disabled when Team Development Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(240206601092761513)
,p_name=>'F4350_P52_PASSWD_CONFIRM'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(504198401567901625)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Confirm Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the password again.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(367460908194031003)
,p_name=>'P52_DEFAULT_DATE_FORMAT'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(63567744865578431)
,p_prompt=>'Default Date Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the default Oracle date format for the user.  This will control the default date format within SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499933401325546095)
,p_name=>'P52_DISALLOW_APP_BUILDING'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'App Builder Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to the App Builder.<br>',
'<br>',
'An Administrator will always have access to the App Builder.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when App Builder Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499934427298553622)
,p_name=>'P52_DISALLOW_SQL_WORKSHOP'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'SQL Workshop Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to SQL Workshop.<br>',
'<br>',
'An Administrator will always have access to SQL Workshop.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when SQL Workshop Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499934906305556944)
,p_name=>'P52_DISALLOW_TEAM_DEVELOPMENT'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(4597004638216477)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Team Development Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                  where provisioning_company_id = :flow_security_group_id',
'                     and NVL(allow_team_development_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a user has access to Team Development.<br>',
'<br>',
'An Administrator will always have access to Team Development.<br>',
'<br>',
'This attribute is always disabled when Team Development Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(504649626390067456)
,p_name=>'P52_SP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(504198401567901625)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_begin_on_new_line=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(63976551899006266)
,p_validation_name=>'F4350_P52_USER_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4350_P52_USER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Username must be specified.'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(63568348763578436)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-JUN-2001 19:34'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(88216016849515325)
,p_validation_name=>'UserNameValid'
,p_validation_sequence=>20
,p_validation=>'F4350_P52_USER_NAME'
,p_validation2=>'< >'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Invalid Username.'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(63568348763578436)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(69047703326983643)
,p_validation_name=>'user doesn''t already exist'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_fnd_user',
' where user_name = upper(:F4350_P52_USER_NAME)',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'User &F4350_P52_USER_NAME. already exists.'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(63568348763578436)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(63976943003006267)
,p_validation_name=>'F4350_P52_EMAIL_ADDRESS Not Null'
,p_validation_sequence=>40
,p_validation=>'F4350_P52_EMAIL_ADDRESS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Email Address must be specified.'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(63569221717578439)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-JUN-2001 19:34'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(437392827624179971)
,p_validation_name=>'F4350_P52_EMAIL_ADDRESS valid format'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at number;',
'  l_dot number;',
'begin',
'  l_at := instr(nvl(:F4350_P52_EMAIL_ADDRESS,''x''),''@'');',
'  l_dot := instr(nvl(:F4350_P52_EMAIL_ADDRESS,''x''),''.'',l_at);',
'  return l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address.'
,p_validation_condition=>'F4350_P52_EMAIL_ADDRESS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(63569221717578439)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(109107321494746966)
,p_validation_name=>'default schema in accessible schemas'
,p_validation_sequence=>60
,p_validation=>'instr(upper(:F4350_P52_ALLOW_SCHEMA_ACCESS),:F4350_P52_DEFAULT_SCHEMA) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Default Schema must be within Accessible Schemas.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in (''SUBMIT'',''CREATE_ANOTHER'') and ',
':F4350_P52_ALLOW_SCHEMA_ACCESS is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(66067229562721999)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(499468123446723658)
,p_validation_name=>'Developer must have Access'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF nvl(:P52_DEVELOPER,''Y'') = ''Y'' and nvl(:P52_ADMIN,''N'') = ''N'' THEN',
'    IF nvl(:P52_ALLOW_APP_BUILDING_YN,''N'') = ''N''',
'    AND nvl(:P52_ALLOW_SQL_WORKSHOP_YN,''N'') = ''N'' THEN',
'      RETURN FALSE;',
'    END IF;',
'  END IF;',
'',
'  RETURN TRUE;',
'END;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'A Developer must have access to either the App Builder, the SQL Workshop, or both.'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(157872609565288125)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(240211930659779511)
,p_validation_name=>'Validate Password'
,p_validation_sequence=>120
,p_validation=>':F4350_P52_PASSWD_CONFIRM = :F4350_P52_WEB_PASSWORD'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Passwords do not match.  '
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(240206601092761513)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25671017599539184)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username       => :F4350_P52_USER_NAME,',
'      p_password       => :F4350_P52_WEB_PASSWORD,',
'      p_old_password   => null,',
'      p_workspace_name => wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':request in (''SUBMIT'',''CREATE_ANOTHER'') and wwv_flow_authentication_dev.is_builder_password_required (p_developer_yn => :P52_DEVELOPER ) and wwv_flow_authentication_dev.get_internal_authentication <> ''DB'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(63569351113578440)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384616595866738717)
,p_validation_name=>'Validate DB Password'
,p_validation_sequence=>145
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.password_validation(',
'           p_username => upper(:F4350_P52_USER_NAME),',
'           p_password => :F4350_P52_WEB_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Password does not conform to the database password policy.'
,p_validation_condition=>':REQUEST in (''SUBMIT'',''CREATE_ANOTHER'') and :P52_DEVELOPER = ''Y'' and wwv_flow_authentication_dev.get_internal_authentication = ''DB'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(570550019351871809)
,p_validation_name=>'admin / dev username validate'
,p_validation_sequence=>150
,p_validation=>'return regexp_like(:F4350_P52_USER_NAME,wwv_flow_platform.get_preference(''USERNAME_VALIDATION''));'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Username does not match expression defined for the instance.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    nvl(wwv_flow_platform.get_preference(''USERNAME_VALIDATION''),''*'') != ''*''',
'and (:P52_ADMIN = ''Y'' or :P52_DEVELOPER = ''Y'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(63568348763578436)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10406952639361222)
,p_validation_name=>'F4350_P52_EMAIL_ADDRESS valid pattern'
,p_validation_sequence=>160
,p_validation=>'return wwv_flow_instance_admin.is_valid_provisioning_email ( p_email => :F4350_P52_EMAIL_ADDRESS );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address pattern'
,p_validation_condition=>'SUBMIT,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(63569221717578439)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(499427518420684435)
,p_name=>'Set Admin Defaults'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_ADMIN'
,p_condition_element=>'P52_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499427820153684438)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DEVELOPER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499428823786684440)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'FALSE'
,p_action_sequence=>11
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DEVELOPER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504130609805948509)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DEVELOPER'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499429031223684440)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499919627701307745)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'FALSE'
,p_action_sequence=>31
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499428009207684439)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499804524250282146)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499920117574323684)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'FALSE'
,p_action_sequence=>71
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499803201394275502)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499923126672383077)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499923332212384708)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'FALSE'
,p_action_sequence=>91
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499428621934684440)
,p_event_id=>wwv_flow_imp.id(499427518420684435)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(384616999390738721)
,p_name=>'Set Admin Defaults - ADW'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_ADMIN'
,p_condition_element=>'P52_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(384617013498738722)
,p_event_id=>wwv_flow_imp.id(384616999390738721)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(384617289052738724)
,p_event_id=>wwv_flow_imp.id(384616999390738721)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(499429526731686804)
,p_name=>'Set Developer Defaults'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DEVELOPER'
,p_condition_element=>'P52_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499430212016686834)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499430411680686834)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'FALSE'
,p_action_sequence=>11
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499431025041686835)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499429814977686805)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'FALSE'
,p_action_sequence=>21
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499805312607288217)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499807025205301265)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'FALSE'
,p_action_sequence=>51
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150597633713090720)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'FALSE'
,p_action_sequence=>61
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499805929576293162)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150597546514090719)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'FALSE'
,p_action_sequence=>71
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499807709059306138)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'FALSE'
,p_action_sequence=>81
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150597307895090717)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150597453590090718)
,p_event_id=>wwv_flow_imp.id(499429526731686804)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(384618639510738738)
,p_name=>'Set Developer Defaults - ADW'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DEVELOPER'
,p_condition_element=>'P52_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(384618795887738739)
,p_event_id=>wwv_flow_imp.id(384618639510738738)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(384618872797738740)
,p_event_id=>wwv_flow_imp.id(384618639510738738)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(384618907212738741)
,p_event_id=>wwv_flow_imp.id(384618639510738738)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(384619013190738742)
,p_event_id=>wwv_flow_imp.id(384618639510738738)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504051507879708569)
,p_name=>'Disable Disallow App Building'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DISALLOW_APP_BUILDING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504051813577708569)
,p_event_id=>wwv_flow_imp.id(504051507879708569)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DISALLOW_APP_BUILDING'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504052404893717114)
,p_name=>'Disable Disallow SQL Workshop'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DISALLOW_SQL_WORKSHOP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504052727798717115)
,p_event_id=>wwv_flow_imp.id(504052404893717114)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DISALLOW_SQL_WORKSHOP'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504052917360720736)
,p_name=>'Disable Disallow Team Development'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P52_DISALLOW_TEAM_DEVELOPMENT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504053220034720737)
,p_event_id=>wwv_flow_imp.id(504052917360720736)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P52_DISALLOW_TEAM_DEVELOPMENT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9364306003603574)
,p_name=>'set email if user name contains @'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4350_P52_USER_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''F4350_P52_USER_NAME'').match(/@/)!=null'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9364618112603580)
,p_event_id=>wwv_flow_imp.id(9364306003603574)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4350_P52_EMAIL_ADDRESS'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''F4350_P52_USER_NAME'')'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(384616434560738716)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create DB user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_num number;',
'begin',
'    select count(*) into l_num from sys.dba_users where username = upper(:F4350_P52_USER_NAME);',
'    ',
'    if l_num = 0 then',
'        wwv_flow_provision.create_user(',
'            p_username    => upper(:F4350_P52_USER_NAME),',
'            p_password    => :F4350_P52_WEB_PASSWORD );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in (''SUBMIT'',''CREATE_ANOTHER'') and :P52_DEVELOPER = ''Y'' and wwv_flow_authentication_dev.get_internal_authentication = ''DB'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>384616434560738716
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63569943284578442)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create User PL/SQL API Call'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_user_id                      number        := wwv_flow_id.next_val;',
'  l_p                            varchar2(256) := :F4350_P52_WEB_PASSWORD;',
'  l_change_password_on_first_use varchar2(1)   := ''N'';',
'  l_developer_roles              varchar2(255) := NULL;',
'begin',
'  if :P52_CHANGE_PWD_ON_FIRST_USE = ''Y'' then',
'    l_change_password_on_first_use := ''Y'';',
'  end if;',
'  ',
'  wwv_flow.update_cache_with_write(''F4350_P52_WEB_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''F4350_P52_PASSWD_CONFIRM'',null);',
'  ',
'  WWV_FLOW_FND_USER_API.CREATE_FND_USER(',
'      P_USER_ID                      => l_user_id,',
'      P_USER_NAME                    => :F4350_P52_USER_NAME,',
'      P_FIRST_NAME                   => :F4350_P52_FIRST_NAME,',
'      P_LAST_NAME                    => :F4350_P52_LAST_NAME,',
'      P_DESCRIPTION                  => :F4350_P52_DESCRIPTION,',
'      P_EMAIL_ADDRESS                => :F4350_P52_EMAIL_ADDRESS,',
'      P_WEB_PASSWORD                 => l_p,',
'      P_GROUP_IDS                    => :F4350_P52_GROUP_IDS,',
'      P_DEVELOPER_PRIVS              => null,',
'      P_DEFAULT_SCHEMA               => :F4350_P52_DEFAULT_SCHEMA,',
'      p_default_date_format          => :P52_DEFAULT_DATE_FORMAT,',
'      P_ALLOW_ACCESS_TO_SCHEMAS      => :F4350_P52_ALLOW_SCHEMA_ACCESS,',
'      P_ACCOUNT_EXPIRY               => trunc(sysdate),',
'      P_ACCOUNT_LOCKED               => nvl(:P52_ACCOUNT_LOCKED,''N''),',
'      p_failed_access_attempts       =>   0, ',
'      p_change_password_on_first_use => l_change_password_on_first_use,',
'      p_first_password_use_occurred  => ''N'' );',
'',
'  --',
'  -- Set User Component Privileges',
'  --',
'  if :P52_ADMIN = ''Y'' then',
'    wwv_flow_fnd_developer_api.set_component_privs (',
'        P_user_id                   => l_user_id,',
'        p_ALLOW_APP_BUILDING_YN     => ''Y'',',
'        p_ALLOW_SQL_WORKSHOP_YN     => ''Y'',',
'        p_ALLOW_TEAM_DEVELOPMENT_YN => ''Y'');',
'',
'  elsif :P52_DEVELOPER= ''Y'' then',
'    wwv_flow_fnd_developer_api.set_component_privs (',
'        P_user_id                   => l_user_id,',
'        p_ALLOW_APP_BUILDING_YN     => nvl(:P52_ALLOW_APP_BUILDING_YN,''Y''),',
'        p_ALLOW_SQL_WORKSHOP_YN     => nvl(:P52_ALLOW_SQL_WORKSHOP_YN,''Y''),',
'        p_ALLOW_TEAM_DEVELOPMENT_YN => nvl(:P52_ALLOW_TEAM_DEVELOPMENT_YN,''Y'') );',
'',
'  else',
'    wwv_flow_fnd_developer_api.set_component_privs (',
'        P_user_id                   => l_user_id,',
'        p_ALLOW_APP_BUILDING_YN     => ''N'',',
'        p_ALLOW_SQL_WORKSHOP_YN     => ''N'',',
'        p_ALLOW_TEAM_DEVELOPMENT_YN => ''N'');',
'',
'  end if;',
'',
'  --',
'  -- Developer and Admin roles',
'  --',
'  if :P52_ADMIN = ''N'' and :P52_DEVELOPER= ''N'' then',
'    null;',
'  else',
'    -- {Trigger on WWV_FLOW_DEVELOPERS sets all developer roles for ADMINS ',
'    --  irrespective of what set here providing includes ''ADMIN''} ',
'    if :P52_ADMIN = ''Y'' then ',
'      l_developer_roles := ''ADMIN'';',
'    end if;',
'    if nvl(v(''P52_ALLOW_APP_BUILDING_YN''),''Y'') = ''Y'' then ',
'      if l_developer_roles is not null then',
'        l_developer_roles := l_developer_roles||'':'';',
'      end if;',
'      l_developer_roles := l_developer_roles||''CREATE:EDIT:HELP:MONITOR'';',
'    end if;',
'    if nvl(v(''P52_ALLOW_SQL_WORKSHOP_YN''),''Y'') = ''Y'' then',
'      if l_developer_roles is not null then',
'        l_developer_roles := l_developer_roles||'':'';',
'      end if;',
'      l_developer_roles := l_developer_roles||''SQL:MONITOR:DATA_LOADER'';',
'    end if;',
'    wwv_flow_fnd_developer_api.edit_developer_role(',
'      p_id => 1,',
'      p_user_id => l_user_id,',
'      p_user_name => :F4350_P52_USER_NAME,',
'      p_developer_roles => l_developer_roles);',
'  end if;',
'',
'end;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error: #SQLERRM#'
,p_process_when=>'SUBMIT,CREATE_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'User created.'
,p_internal_uid=>63569943284578442
,p_process_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(359780407415827856)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4350_P52_WEB_PASSWORD,F4350_P52_PASSWD_CONFIRM'
,p_internal_uid=>359780407415827856
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(356667601476363227)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'always developer if admin'
,p_process_sql_clob=>':P52_DEVELOPER := ''Y'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P52_ADMIN'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_internal_uid=>356667601476363227
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(356496320516542527)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'generate random password for SSO accounts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P52_WEB_PASSWORD   := wwv_flow_authentication_dev.create_shadow_user_password;',
':F4350_P52_PASSWD_CONFIRM := :F4350_P52_WEB_PASSWORD;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :request in (''SUBMIT'',''CREATE_ANOTHER'')',
'and :F4350_P52_WEB_PASSWORD is null',
'and not wwv_flow_authentication_dev.is_builder_password_required (',
'            p_developer_yn => :P52_DEVELOPER )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>356496320516542527
);
end;
/
prompt --application/pages/page_00053
begin
wwv_flow_imp_page.create_page(
 p_id=>53
,p_name=>'User Groups'
,p_alias=>'USER-GROUPS'
,p_step_title=>'User Groups'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_groups.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34954322794221837)
,p_plug_name=>'Groups'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   ''icon-apex-user'' img,',
'   null alt,',
'''f?p=4350:54:''||:flow_session||''::NO::F4350_P54_ID,LAST_VIEW:''||g.ID||'',53'' link,',
'   g.GROUP_NAME,',
'   g.GROUP_DESC des,',
'   g.id,',
'   (select count(*) from WWV_FLOW_FND_GROUP_USERS u where u.group_id = g.id and u.security_group_id = :flow_security_group_id)',
'    +',
'   (select count(*) from WWV_FLOW_FND_GROUP_GROUPS gg where gg.granted_group_id = g.id and gg.security_group_id = :flow_security_group_id)',
'   member_count',
'from   WWV_FLOW_FND_USER_GROUPS_NOAPP g',
'where g.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P53_VIEW,''ICON'') = ''ICON'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(34954404769221837)
,p_name=>'Groups (Icon View)'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#GROUP_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34954920422221901)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>1
,p_column_identifier=>'D'
,p_column_label=>'Group Name'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34954624173221865)
,p_db_column_name=>'IMG'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34954707553221901)
,p_db_column_name=>'ALT'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34954805025221901)
,p_db_column_name=>'LINK'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34955004281221902)
,p_db_column_name=>'DES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34955120410221902)
,p_db_column_name=>'ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(503921408095649048)
,p_db_column_name=>'MEMBER_COUNT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Member Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(34956410007247564)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1309816211536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'ICON'
,p_report_columns=>'GROUP_NAME:DES:MEMBER_COUNT'
,p_sort_column_1=>'GROUP_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46981912186439286)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(166211911060758908)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829471944455703874)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47055717997952583)
,p_plug_name=>'users and groups APEX 4 0'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47054717520943020)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(829468732055693490)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63111618781819469)
,p_plug_name=>'User Groups'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'User groups enable you to restrict access to various parts of an application. User groups are not portable over different authentication schemes and are primarily useful when using &PRODUCT_NAME. Account Credentials authentication.',
'<p />To edit an existing user group, select it. Click <strong>Create</strong> to create a new group.'))
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(167828701739639874)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34954322794221837)
,p_button_name=>'VIEW_DASHBOARD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'View Dashboard'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2194729132936059)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34954322794221837)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create User Group'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(51105802473026585)
,p_branch_action=>'f?p=&FLOW_ID.:54:&SESSION.::&DEBUG.:54::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2194729132936059)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(136263600341812777)
,p_branch_action=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(63110747673808833)
,p_computation_sequence=>10
,p_computation_item=>'F4350_P101_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2411429028503676)
,p_computation_sequence=>20
,p_computation_item=>'LAST_VIEW'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'53'
,p_compute_when=>'CREATE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00054
begin
wwv_flow_imp_page.create_page(
 p_id=>54
,p_name=>'Create/Edit User Group'
,p_alias=>'CREATE-EDIT-USER-GROUP'
,p_step_title=>'Create/Edit User Group'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_step_template=>wwv_flow_imp.id(692762523503114201)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_groups.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63108043743808817)
,p_plug_name=>'Group Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 17-MAY-2001 00:33:59'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63112545982838982)
,p_plug_name=>'User Groups'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can create user groups to restrict access to various parts of an application. However, user groups are not portable over different authentication schemes. User groups are primarily useful when using &PRODUCT_NAME. workspace authentication.</p>',
'<p>To create a  new user group, identify the group name and an optional description.</p>'))
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(132399701351851203)
,p_plug_name=>'Group Grants'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(187692154521667589)
,p_plug_name=>'User Groups'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>'&F4350_P54_GROUP_NAME.'
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(327483512183656133)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40275409253350646)
,p_plug_display_sequence=>20
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63108356545808819)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(187692154521667589)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63108545013808820)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(187692154521667589)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>'F4350_P54_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63108764367808820)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(187692154521667589)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'F4350_P54_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63108953870808821)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(187692154521667589)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Group'
,p_button_position=>'CREATE'
,p_button_condition=>'F4350_P54_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(242266817857922918)
,p_branch_name=>'Last view'
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63109151798808823)
,p_name=>'F4350_P54_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(63108043743808817)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63109395349808825)
,p_name=>'F4350_P54_GROUP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(63108043743808817)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Group Name'
,p_source=>'GROUP_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter a name for group to be created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63109742671808826)
,p_name=>'F4350_P54_GROUP_DESC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(63108043743808817)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'GROUP_DESC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter a description for the group to be created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(132396514075841416)
,p_name=>'F4350_P54_GRANTED_GROUP_IDS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(132399701351851203)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Groups'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_string.join (',
'    wwv_flow_fnd_user_int.get_group_group_grants (',
'        p_group_id => :F4350_P54_ID ),',
'    '':'' )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'F4350_P54_FND_GROUP_IDS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
'   and (:F4350_P54_ID is null or id <> :F4350_P54_ID)',
' order by 1'))
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'The current group is a member of the groups on the right. To make the current group a member of an additional group, select the group and click <strong>Move</strong>. To remove membership, select the group and click <strong>Remove</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'MOVE'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(168786622708605094)
,p_name=>'P54_ORIG_GROUP_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(63108043743808817)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168796825263615287)
,p_computation_sequence=>10
,p_computation_item=>'P54_ORIG_GROUP_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name from wwv_flow_fnd_user_groups',
' where id = :F4350_P54_ID'))
,p_compute_when=>'F4350_P54_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(137486121551787082)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_group_name (',
'  p_name => :F4350_P54_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''Create'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(63109395349808825)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(68844119894184093)
,p_validation_name=>'group doesn''t already exist'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_fnd_user_groups_noapp',
' where group_name        = :F4350_P54_GROUP_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Group &F4350_P54_GROUP_NAME. already exists.'
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''Create'') and nvl(:P54_ORIG_GROUP_NAME,''-1x0'') != :F4350_P54_GROUP_NAME'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(63109395349808825)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63109949663808827)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_FND_USER_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FND_USER_GROUPS'
,p_attribute_03=>'F4350_P54_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id=:FLOW_SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>63109949663808827
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63110150899808829)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_FND_USER_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FND_USER_GROUPS'
,p_attribute_03=>'F4350_P54_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id=:FLOW_SECURITY_GROUP_ID'
,p_attribute_09=>'F4350_P54_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row of table WWV_FLOW_FND_USER_GROUPS.'
,p_process_success_message=>'Requested action on group &F4350_P54_GROUP_NAME. processed.'
,p_internal_uid=>63110150899808829
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(132921012163290292)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set_group_grants'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_int.set_group_group_grants (',
'    p_group_id          => :F4350_P54_ID,',
'    p_granted_group_ids => wwv_flow_string.split_numbers (',
'                               :F4350_P54_GRANTED_GROUP_IDS,',
'                               '':'' ));'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Apply_Changes,Create'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>132921012163290292
);
end;
/
prompt --application/pages/page_00055
begin
wwv_flow_imp_page.create_page(
 p_id=>55
,p_name=>'Manage Users'
,p_alias=>'MANAGE-USERS'
,p_step_title=>'Manage Users'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_users.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10236218638033455)
,p_plug_name=>'Accounts'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ''icon-apex-user'' as icon_view_class,',
'    alt,',
'    link,',
'    icon_view_name,',
'    user_id,',
'    "USER",',
'    "eMail",',
'    first_name,',
'    last_name,',
'    df, -- default schema',
'    developer,',
'    last_login,',
'    last_login2,',
'    builder_login_count,',
'    ul, -- is user locked?',
'    expiration,',
'    description,',
'    password_lifespan_days,',
'    password_lifespan_accesses,',
'    password_accesses_left,',
'    last_agent,',
'    last_ip,',
'    account_expiry,',
'    failed_access_attempts,',
'    change_password_on_first_use,',
'    first_password_use_occurred,',
'    dev_type,',
'    group_id,',
'    group_name,',
'    last_update_date,',
'    last_updated_by,',
'    creation_date,',
'    created_by,',
'    developer_type,',
'    allow_app_building,',
'    allow_sql_workshop,',
'    allow_team_devopment',
'from wwv_flow_workspace_users',
'where workspace_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10236304983033455)
,p_name=>'Internal Accounts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_VIEW_CLASS#"></span><span class="a-IRR-iconName">#ICON_VIEW_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10236920075033495)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'E'
,p_column_label=>'USER_ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237013673033495)
,p_db_column_name=>'USER'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>'User'
,p_column_link=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:RP:F4350_P56_USER_ID,LAST_VIEW:#USER_ID#,55:'
,p_column_linktext=>'#USER#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237132197033496)
,p_db_column_name=>'eMail'
,p_display_order=>3
,p_column_identifier=>'G'
,p_column_label=>'Email'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237206635033496)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'H'
,p_column_label=>'First Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237325678033496)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Last Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237400246033496)
,p_db_column_name=>'DF'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Default Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237809965033497)
,p_db_column_name=>'UL'
,p_display_order=>7
,p_column_identifier=>'N'
,p_column_label=>'Locked'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10238005252033499)
,p_db_column_name=>'DEV_TYPE'
,p_display_order=>8
,p_column_identifier=>'P'
,p_column_label=>'Account Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237527416033496)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>9
,p_column_identifier=>'K'
,p_column_label=>'Password Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237917271033498)
,p_db_column_name=>'EXPIRATION'
,p_display_order=>10
,p_column_identifier=>'O'
,p_column_label=>'End User Account'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237623779033496)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>'Builder Last Login Date'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10237719465033497)
,p_db_column_name=>'BUILDER_LOGIN_COUNT'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Builder Login Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10236603197033493)
,p_db_column_name=>'ALT'
,p_display_order=>14
,p_column_identifier=>'B'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10236716695033493)
,p_db_column_name=>'LINK'
,p_display_order=>15
,p_column_identifier=>'C'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10236820465033493)
,p_db_column_name=>'ICON_VIEW_NAME'
,p_display_order=>16
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10242328997102158)
,p_db_column_name=>'LAST_LOGIN2'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Builder Last Login'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10249601218188649)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10249711398188650)
,p_db_column_name=>'PASSWORD_LIFESPAN_DAYS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Password Lifespan Days'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10249815190188650)
,p_db_column_name=>'PASSWORD_LIFESPAN_ACCESSES'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Password Lifespan Accesses'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10249915247188650)
,p_db_column_name=>'PASSWORD_ACCESSES_LEFT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Password Accesses Left'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10250027892188659)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Last Agent'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10250112673188659)
,p_db_column_name=>'LAST_IP'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Last IP Address'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10250207006188659)
,p_db_column_name=>'ACCOUNT_EXPIRY'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Account Expiry'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10250324219188659)
,p_db_column_name=>'FAILED_ACCESS_ATTEMPTS'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Failed Access Attempts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10250432727188659)
,p_db_column_name=>'CHANGE_PASSWORD_ON_FIRST_USE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Change Password On First Use'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10250517976188660)
,p_db_column_name=>'FIRST_PASSWORD_USE_OCCURRED'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'First Password Use Occurred'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10256910961219854)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Group Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2987726658504251)
,p_db_column_name=>'LAST_UPDATE_DATE'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2987802854504258)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2987914456504258)
,p_db_column_name=>'CREATION_DATE'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2988019496504258)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19726026576048845)
,p_db_column_name=>'DEVELOPER_TYPE'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'Developer Type'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(179030605646968794)
,p_db_column_name=>'ALLOW_APP_BUILDING'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>'App Builder'
,p_column_type=>'STRING'
,p_display_condition_type=>'FUNCTION_BODY'
,p_display_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_condition2=>'PLSQL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(179030711961968799)
,p_db_column_name=>'ALLOW_SQL_WORKSHOP'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'SQL Workshop'
,p_column_type=>'STRING'
,p_display_condition_type=>'FUNCTION_BODY'
,p_display_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_condition2=>'PLSQL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(179030904660968800)
,p_db_column_name=>'ALLOW_TEAM_DEVOPMENT'
,p_display_order=>38
,p_column_identifier=>'AL'
,p_column_label=>'Team Development'
,p_column_type=>'STRING'
,p_display_condition_type=>'FUNCTION_BODY'
,p_display_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_condition2=>'PLSQL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9297316101992856)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>39
,p_column_identifier=>'AM'
,p_column_label=>'Group Id'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(649535305137618336)
,p_db_column_name=>'ICON_VIEW_CLASS'
,p_display_order=>49
,p_column_identifier=>'AN'
,p_column_label=>'Icon view class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10238325656034902)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1309925508536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'USER:eMail:DEV_TYPE:UL:LAST_LOGIN2:CREATION_DATE:ICON_VIEW_CLASS'
,p_sort_column_1=>'USER'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'LAST_LOGIN2'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46969402630171623)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(166211911060758908)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46988702152512130)
,p_plug_name=>'Manage Users'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.prn(replace(',
'    case when wwv_flow_global.g_cloud and wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'' then wwv_flow_lang.system_message(''USER_TYPE_DESCRIPTION_CLOUD'')',
'         else wwv_flow_lang.system_message(''USER_TYPE_DESCRIPTION'', ''&SYSTEM_HELP_URL.'') end,',
'    ''#IMAGE_PREFIX''||''#'',',
'    :image_prefix));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47053011848931923)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47055403799948453)
,p_plug_name=>'users and groups APEX 4 0'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47054717520943020)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(179031100713986245)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10236218638033455)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:55,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(167827029959610172)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(10236218638033455)
,p_button_name=>'VIEW_DASHBOARD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'View Dashboard'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(44453823677220822)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(10236218638033455)
,p_button_name=>'create_multiple'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_image_alt=>'Create Multiple Users'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:RP,99::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2218831266040742)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(10236218638033455)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create User'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2219115242040743)
,p_branch_action=>'f?p=4350:52:&SESSION.:::52,EDIT_USER_PRIVS'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2218831266040742)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8952907044209733)
,p_branch_action=>'55'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1939534275325928)
,p_computation_sequence=>10
,p_computation_item=>'F4350_P4802_USER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2400705910478090)
,p_computation_sequence=>20
,p_computation_item=>'LAST_VIEW'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'55'
,p_compute_when=>'CREATE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00056
begin
wwv_flow_imp_page.create_page(
 p_id=>56
,p_name=>'Edit User'
,p_alias=>'EDIT-USER'
,p_step_title=>'Edit User'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="javascript">',
'<!--',
'function confirmaction(){',
'        if (document.wwv_flow.F4350_P56_EMAIL_ADDRESS.value != document.wwv_flow.F4350_P56_ORG_EMAIL_ADDRESS.value){',
'	if(confirm("Are you sure you want to change the email address?")){',
'		doSubmit(''ApplyChanges'') ;',
'          }',
'        }else{',
'            doSubmit(''ApplyChanges'') ;',
'        }',
' }',
'//-->',
'</script>'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(document).on (',
'    "apexpagesubmit",',
'    function() {',
'        $(":disabled").removeProp("disabled");',
'        $("#P56_DEVELOPER").removeProp("disabled");',
'    });'))
,p_step_template=>wwv_flow_imp.id(692762523503114201)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_help_text=>'AEADM/aadm_users.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1939534236325904)
,p_plug_name=>'Edit User'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 19-FEB-2000 22:09:25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1939836620202510)
,p_plug_name=>'&PRODUCT_NAME. Users'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This user manager maintains accounts for use by authentication schemes that authenticate against the username and password stored in these accounts.</p>',
'<p>If you want to change a user''s password, enter a new password. Otherwise, leave the password columns null and the current password will not be changed.</p>'))
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R:L:L:L:L:L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2842809782477294)
,p_plug_name=>'Account Privileges'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32838311033428820)
,p_plug_name=>'reset'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P56_WEB_PASSWORD := null;',
':F4350_P56_USER_PASSWORD := null;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33631616489003252)
,p_plug_name=>'Manage Users'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.prn(replace(',
'    case when wwv_flow_global.g_cloud and wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'' then wwv_flow_lang.system_message(''USER_TYPE_DESCRIPTION_CLOUD'')',
'         else wwv_flow_lang.system_message(''USER_TYPE_DESCRIPTION'') end,',
'    ''#IMAGE_PREFIX''||''#'',',
'    :image_prefix));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46268225340679031)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40275409253350646)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63228665418367633)
,p_plug_name=>'Group Assignments'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(96413246392446128)
,p_plug_name=>'User: &F4350_P56_USER_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192198837219940283)
,p_plug_name=>'&F4350_PASSWORD_REGION_TITLE.'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1939534237325907)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(96413246392446128)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1939534238325908)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(96413246392446128)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Delete User'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''Delete'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P56_USER_ID is not null',
' and wwv_flow_fnd_user_int.can_delete_user (',
'         p_user_id => :F4350_P56_USER_ID )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1939534239325908)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(96413246392446128)
,p_button_name=>'ApplyChanges'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmaction();'
,p_button_condition=>'F4350_P56_USER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3911809366516124)
,p_branch_action=>'56'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'ADD_PRIV'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30381123923255056)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534241325916)
,p_name=>'F4350_P56_USER_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534242325916)
,p_name=>'F4350_P56_USER_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_read_only_when=>'F4350_P56_USER_NAME'
,p_read_only_when2=>'&APP_USER.'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the username used to log in to the system. Usernames have these restrictions: <ul><li>',
'maximum length of 100 characters</li><li>',
'no spaces</li>',
'<li>only these special characters are permitted: @ and periods (.)</li></ul>',
'<p>The username may also be used to reference user activity using the monitor applications. The bind variable <code>:app_user </code>returns the value of the current user when building applications.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534251325919)
,p_name=>'F4350_P56_START_DATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534252325919)
,p_name=>'F4350_P56_END_DATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534259325921)
,p_name=>'F4350_P56_EMPLOYEE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534260325921)
,p_name=>'F4350_P56_PERSON_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_item_default=>'E'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534261325921)
,p_name=>'F4350_P56_EMAIL_ADDRESS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_prompt=>'Email Address'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specifies the email address for use with general correspondence, notifications about resetting passwords, and so on.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534264325922)
,p_name=>'F4350_P56_USER_PASSWORD'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Confirm Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password again. Do not enter a password unless you want to change the current password.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534265325922)
,p_name=>'F4350_P56_FIRST_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_prompt=>'First Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the first or given name to further identify the user. This optional field is used for informational purposes only.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939534267325923)
,p_name=>'F4350_P56_WEB_PASSWORD'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Password'
,p_post_element_text=>' <span class="instructiontext">Passwords are case sensitive</span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The password used to log in to the system. Do not enter a password unless you want to change the current password.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939557108193755)
,p_name=>'F4350_P56_COMPANY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_prompt=>'Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies which workspace this user belongs to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1939836784851988)
,p_name=>'F4350_P56_LAST_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_prompt=>'Last Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the last or family name to further identify the user. This optional field is used for informational purposes only.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2729632398336567)
,p_name=>'P56_ACCOUNT_LOCKED'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_item_default=>'N'
,p_prompt=>'Account Availability'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ACCOUNT_LOCK_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(6949526744661130)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Locked</strong> to prevent the account from being used. Select <strong>Unlocked</strong> to enable the account to be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2733307164357615)
,p_name=>'P56_ACCOUNT_EXPIRY'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3419605623465159)
,p_name=>'P56_FAILED_ACCESS_ATTEMPTS'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4174018563862024)
,p_name=>'P56_DESCRIPTION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>200
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Use this field to record comments about the user for informational purposes only.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6646713211577222)
,p_name=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_prompt=>'Require Change of Password on First Use'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select <strong>Yes</strong> to require the user of this account to change the password immediately after logging in the first time using the current password. This rule applies to the use of this account for workspace administration or development as'
||' well as to use of this account to log in to developed applications.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6647326024580973)
,p_name=>'P56_FIRST_PWD_USE_OCCURRED'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6836403653427495)
,p_name=>'P56_EXPIRATION_STATUS1'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_prompt=>'Developer/Administrator Password'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P56_EXPIRATION_STATUS1'
,p_display_when2=>'NA'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates whether password is expired or valid for developer or workspace administrator login.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6844512750836962)
,p_name=>'P56_EXPIRE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expire Password'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'select null d, ''Y'' r from dual'
,p_display_when=>'P56_SHOW_EXPIRE_FLAG'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select this check box to expire the user''s password.  This affects both their developer/administrator login and access as an end user.  If expired, the next time this account is accessed, the user will be required to provide their old password along '
||'with a new password in order to log in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6849820425943301)
,p_name=>'P56_EXPIRATION_STATUS2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_prompt=>'End User Password'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P56_EXPIRATION_STATUS2'
,p_display_when2=>'NA'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates whether password is expired or valid for End User login.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6855306572639406)
,p_name=>'P56_SHOW_EXPIRE_FLAG'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32491914843797683)
,p_name=>'F4350_P56_ORG_EMAIL_ADDRESS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_source=>'&F4350_P56_ORG_EMAIL_ADDRESS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63228442637365892)
,p_name=>'F4350_P56_GROUPS'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(63228665418367633)
,p_prompt=>'Group Assignments'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'F4350_FND_GROUP_IDS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d, id r',
'  from wwv_flow_fnd_user_groups_noapp',
' where security_group_id in (:flow_security_group_id,10)',
' order by 1'))
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Group assignments enable developers to control access to specific features and functions by groups. ',
'This group functionality is built into App Builder and works best (and most conveniently) with <em>&PRODUCT_NAME. Accounts</em> authentication. ',
'</p>',
'<p>',
'The user belongs to the groups on the right.',
'To assign another group to the user,',
'select the group on the left and use the ">" icon to move it to the right.',
'To assign all groups to the user,',
'press the ">>" icon.',
'To remove an assignment,',
'select the group on the right and press the "<" icon.',
'To remove all assignments,',
'press the "<<" icon.',
'</p> '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'MOVE'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'and user_id = :F4350_P56_USER_ID',
'',
''))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65943898362184724)
,p_name=>'F4350_P56_ACCESS_TO_SCHEMAS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_prompt=>'Accessible Schemas (null for all)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter a colon-delimited list of schemas for which this developer has permissions when using the SQL Workshop. The list of schemas you enter here restricts the user to a subset of the full set of schemas provisioned for the workspace and determines wh'
||'at schema names the user sees in SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65973729260237471)
,p_name=>'F4350_P56_DEFAULT_SCHEMA'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_prompt=>'Default Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Specifies the default schema used for data browsing, application creation, and SQL script execution. When using workspaces that have more than one schema available, this schema is the default for creating applications, performing SQL queries, and so '
||'on. This feature does not control security, only the user''s preference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(88564124466917904)
,p_name=>'F4350_P56_DEVELOPER_ROLE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(127630432271025900)
,p_name=>'P56_UPDATE_PW'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(192198837219940283)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(157817015229873453)
,p_name=>'P56_DEVELOPER'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_item_default=>'N'
,p_prompt=>'User is a developer'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify if this user should have developer privileges. Developers must have access to either the App Builder, the SQL Workshop, or both.',
'',
'Components may not be available if they are switched off by Instance Administrators.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(157818110858881656)
,p_name=>'P56_ADMIN'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_item_default=>'N'
,p_prompt=>'User is a workspace administrator'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify if this user should have workspace administrator privileges. Administrators are given access to all components. Additionally, they can also manage user accounts, groups, and development services.',
'',
'Components may not be available if they are switched off by Instance Administrators.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173536824865172817)
,p_name=>'P56_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'App Builder Access'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(ALLOW_APP_BUILDING_YN,''Y'')',
'from wwv_flow_fnd_user ',
'where user_id = :F4350_P56_USER_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to the App Builder.<br>',
'<br>',
'An Administrator will always have access to the App Builder.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when App Builder Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173539020840181069)
,p_name=>'P56_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'SQL Workshop Access'
,p_source=>'select ALLOW_SQL_WORKSHOP_YN from wwv_flow_fnd_user where user_id = :F4350_P56_USER_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to SQL Workshop.<br>',
'<br>',
'An Administrator will always have access to SQL Workshop.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when SQL Workshop Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173548426643201698)
,p_name=>'P56_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Team Development Access'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ALLOW_TEAM_DEVELOPMENT_YN ',
'from wwv_flow_fnd_user ',
'where user_id = :F4350_P56_USER_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a user has access to Team Development.<br>',
'<br>',
'An Administrator will always have access to Team Development.<br>',
'<br>',
'This attribute is always disabled when Team Development Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(367459414269982539)
,p_name=>'P56_DEFAULT_DATE_FORMAT'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(1939534236325904)
,p_prompt=>'Default Date Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the default Oracle date format for the user.  This will control the default date format within SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499924228974449999)
,p_name=>'P56_DISALLOW_APP_BUILDING'
,p_item_sequence=>201
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'App Builder Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to the App Builder.<br>',
'<br>',
'An Administrator will always have access to the App Builder.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when App Builder Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499927725127496225)
,p_name=>'P56_DISALLOW_SQL_WORKSHOP'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'SQL Workshop Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to SQL Workshop.<br>',
'<br>',
'An Administrator will always have access to SQL Workshop.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when SQL Workshop Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(499928914176502544)
,p_name=>'P56_DISALLOW_TEAM_DEVELOPMENT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(2842809782477294)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Team Development Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a user has access to Team Development.<br>',
'<br>',
'An Administrator will always have access to Team Development.<br>',
'<br>',
'This attribute is always disabled when Team Development Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6865929128024449)
,p_computation_sequence=>10
,p_computation_item=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P56_CHANGE_PWD_ON_FIRST_USE,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;',
'',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6867330429043779)
,p_computation_sequence=>20
,p_computation_item=>'P56_EXPIRE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P56_EXPIRE,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6868607489056034)
,p_computation_sequence=>30
,p_computation_item=>'P56_ACCOUNT_LOCKED'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P56_ACCOUNT_LOCKED,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(127631126515033687)
,p_computation_sequence=>40
,p_computation_item=>'P56_UPDATE_PW'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'length(:F4350_P56_USER_PASSWORD)'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(189706509679038825)
,p_validation_name=>'F4350_P56_USER_NAME not null'
,p_validation_sequence=>10
,p_validation=>'F4350_P56_USER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply a username.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(1939534242325916)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(111517930900067043)
,p_validation_name=>'F4350_P56_USER_NAME'
,p_validation_sequence=>20
,p_validation=>'F4350_P56_USER_NAME'
,p_validation2=>'< >'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Invalid Username.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(1939534242325916)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(189791113029531872)
,p_validation_name=>'validate email'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at  number;',
'  l_dot number;',
'begin',
'  l_at  := instr(nvl(:F4350_P56_EMAIL_ADDRESS,''x''),''@'');',
'  l_dot := instr(nvl(:F4350_P56_EMAIL_ADDRESS,''x''),''.'',l_at);',
'  return l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(1939534261325921)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(109168713538170465)
,p_validation_name=>'default schema in accessible schemas'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'instr(upper(:F4350_P56_ACCESS_TO_SCHEMAS),:F4350_P56_DEFAULT_SCHEMA) > 0 or',
'v(''F4350_P56_ACCESS_TO_SCHEMAS'') is null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Default Schema must be within Accessible Schemas.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(65973729260237471)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(159963211620773707)
,p_validation_name=>'can''t remove admin from yourself'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4350_P56_USER_ID = wwv_flow_user_api.get_user_id(:FLOW_USER) and nvl(:P56_ADMIN,''N'') = ''N'' then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You cannot remove admin privilege from yourself.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(157818110858881656)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(499406131374423262)
,p_validation_name=>'Developer must have Access'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF nvl(:P56_DEVELOPER,''Y'') = ''Y'' and nvl(:P56_ADMIN,''N'') = ''N'' THEN',
'    IF nvl(:P56_ALLOW_APP_BUILDING_YN,''N'') = ''N''',
'    AND nvl(:P56_ALLOW_SQL_WORKSHOP_YN,''N'') = ''N'' THEN',
'      RETURN FALSE;',
'    END IF;',
'  END IF;',
'',
'  RETURN TRUE;',
'END;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'A Developer must have access to either the App Builder, the SQL Workshop, or both.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(157817015229873453)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1533378731762979439)
,p_validation_name=>'F4350_P56_USER_NAME unique if changed'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_fnd_user',
' where user_name = upper(:F4350_P56_USER_NAME)',
'   and security_group_id = :flow_security_group_id ',
'   and user_id != :F4350_P56_USER_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Username already exists.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(1939534242325916)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(488436717457786543)
,p_validation_name=>'if change username, must reset password'
,p_validation_sequence=>105
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select user_name',
'     from wwv_flow_fnd_user',
'    where user_id = :F4350_P56_USER_ID',
'      and security_group_id = :flow_security_group_id )',
'loop',
'   if c1.user_name != :F4350_P56_USER_NAME and',
'      :F4350_P56_WEB_PASSWORD is null then',
'   return false;',
'   else return true;',
'   end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'If you update the Username, you must provide a new password.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(1939534267325923)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1939534308824103)
,p_validation_name=>'match password'
,p_validation_sequence=>120
,p_validation=>':F4350_P56_WEB_PASSWORD = :F4350_P56_USER_PASSWORD'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Password not properly confirmed, enter your password two times exactly the same.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P56_WEB_PASSWORD is not null or',
':F4350_P56_USER_PASSWORD is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(1939534264325922)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25666918114501495)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username       => :F4350_P56_USER_NAME,',
'      p_password       => :F4350_P56_WEB_PASSWORD,',
'      p_old_password   => null,',
'      p_workspace_name => wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.is_builder_password_required (',
'    p_developer_yn => :P56_DEVELOPER ) and wwv_flow_authentication_dev.get_internal_authentication <> ''DB'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(1939534267325923)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'do not run for non-developers in SSO authentication mode'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(70798336525897014)
,p_validation_name=>'Validate DB Password'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4350_P56_WEB_PASSWORD is null then',
'    return false;',
'else',
'    return wwv_flow_security.password_validation(',
'               p_username => upper(:F4350_P56_USER_NAME),',
'               p_password => :F4350_P56_WEB_PASSWORD );',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The password does not conform to the database password complexity rules.'
,p_validation_condition=>'return :REQUEST = ''ApplyChanges'' and :P56_DEVELOPER = ''Y'' and :F4350_P56_DEVELOPER_ROLE is null and wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_associated_item=>wwv_flow_imp.id(1939534267325923)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(91867243893317510)
,p_validation_name=>'F4350_P56_EMAIL_ADDRESS valid pattern'
,p_validation_sequence=>150
,p_validation=>'return wwv_flow_instance_admin.is_valid_provisioning_email ( p_email => :F4350_P56_EMAIL_ADDRESS );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address pattern. Please provide a valid email address.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(1939534261325921)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(36064507470423302)
,p_validation_name=>'Check accessible schema names'
,p_validation_sequence=>160
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P56_ACCESS_TO_SCHEMAS is null',
'    or not exists (',
'            select upper(column_value) as schema',
'              from table( wwv_flow_string.split(:F4350_P56_ACCESS_TO_SCHEMAS,'':'') ) ',
'            minus',
'            select schema',
'              from wwv_flow_company_schemas',
'             where security_group_id = :flow_security_group_id )'))
,p_validation2=>'SQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Only schemas assigned to the workspace are allowed.'
,p_when_button_pressed=>wwv_flow_imp.id(1939534239325908)
,p_associated_item=>wwv_flow_imp.id(65943898362184724)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(499209416736012184)
,p_name=>'Set Admin Defaults'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_ADMIN'
,p_condition_element=>'P56_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(364738319517328603)
,p_event_id=>wwv_flow_imp.id(499209416736012184)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DEVELOPER,P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499840224680613417)
,p_event_id=>wwv_flow_imp.id(499209416736012184)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DEVELOPER,P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(364738260492328602)
,p_event_id=>wwv_flow_imp.id(499209416736012184)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DEVELOPER,P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(499225332629064137)
,p_name=>'Set Developer Defaults'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DEVELOPER'
,p_condition_element=>'P56_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(364738126056328601)
,p_event_id=>wwv_flow_imp.id(499225332629064137)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(364738550708328605)
,p_event_id=>wwv_flow_imp.id(499225332629064137)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(364738433387328604)
,p_event_id=>wwv_flow_imp.id(499225332629064137)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(499347501358272656)
,p_event_id=>wwv_flow_imp.id(499225332629064137)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_ALLOW_APP_BUILDING_YN,P56_ALLOW_SQL_WORKSHOP_YN,P56_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(82670098641701898)
,p_name=>'Set Admin Defaults - ADW'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_ADMIN'
,p_condition_element=>'P56_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82670436864701912)
,p_event_id=>wwv_flow_imp.id(82670098641701898)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82671427031701914)
,p_event_id=>wwv_flow_imp.id(82670098641701898)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(82672318133704761)
,p_name=>'Set Developer Defaults - ADW'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DEVELOPER'
,p_condition_element=>'P56_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82672793706704761)
,p_event_id=>wwv_flow_imp.id(82672318133704761)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82673259140704761)
,p_event_id=>wwv_flow_imp.id(82672318133704761)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82673735178704762)
,p_event_id=>wwv_flow_imp.id(82672318133704761)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82674260816704764)
,p_event_id=>wwv_flow_imp.id(82672318133704761)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'ITEM_IS_NULL'
,p_server_condition_expr1=>'F4350_P56_USER_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(168246085352411202)
,p_name=>'Disable Disallow App Building'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DISALLOW_APP_BUILDING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(168246110055411203)
,p_event_id=>wwv_flow_imp.id(168246085352411202)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DISALLOW_APP_BUILDING'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(168246439075411206)
,p_name=>'Disable Disallow SQL Workshop'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DISALLOW_SQL_WORKSHOP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(168246509636411207)
,p_event_id=>wwv_flow_imp.id(168246439075411206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DISALLOW_SQL_WORKSHOP'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(168246664883411208)
,p_name=>'Disable Disallow Team Development'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P56_DISALLOW_TEAM_DEVELOPMENT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(168246709948411209)
,p_event_id=>wwv_flow_imp.id(168246664883411208)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P56_DISALLOW_TEAM_DEVELOPMENT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1939534268325924)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_api.fetch_fnd_user (',
'     p_user_id       => :F4350_P56_USER_ID,',
'     p_company       => :F4350_P56_COMPANY,',
'     p_user_name     => :F4350_P56_USER_NAME,',
'     p_first_name    => :F4350_P56_FIRST_NAME,',
'     p_last_name     => :F4350_P56_LAST_NAME,',
'     p_web_password  => :F4350_P56_WEB_PASSWORD,',
'     p_email_address => :F4350_P56_EMAIL_ADDRESS,',
'     p_start_date    => :F4350_P56_START_DATE,',
'     p_end_date      => :F4350_P56_END_DATE,',
'     p_employee_id   => :F4350_P56_EMPLOYEE_ID,',
'     p_allow_access_to_schemas => :F4350_P56_ACCESS_TO_SCHEMAS,',
'     p_person_type     => :F4350_P56_PERSON_TYPE,',
'     p_default_schema  => :F4350_P56_DEFAULT_SCHEMA,',
'     p_groups          => :F4350_P56_GROUPS,',
'     p_developer_role  => :F4350_P56_DEVELOPER_ROLE,',
'     p_description     => :P56_DESCRIPTION,',
'     p_account_expiry  => :P56_ACCOUNT_EXPIRY,',
'     p_account_locked  => :P56_ACCOUNT_LOCKED,',
'     p_failed_access_attempts => :P56_FAILED_ACCESS_ATTEMPTS,',
'     p_change_password_on_first_use => :P56_CHANGE_PWD_ON_FIRST_USE,',
'     p_first_password_use_occurred => :P56_FIRST_PWD_USE_OCCURRED',
'     );',
'',
'for c1 in (select default_date_format',
'             from wwv_flow_fnd_user',
'            where user_id = :F4350_P56_USER_ID',
'              and security_group_id =  :flow_security_group_id) loop',
'    :P56_DEFAULT_DATE_FORMAT := c1.default_date_format;',
'    exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching user information.'
,p_process_when=>'F4350_P56_USER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>1939534268325924
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(157783521762846932)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_site_account_lifetime number := ',
'    nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),45);',
'  l_workspace_account_lifetime number;',
'  l_account_last_updated date;',
'  l_dev_admin_expired boolean := false;',
'  l_end_user_expired boolean := false;',
'  l_found boolean := false;',
'begin',
':F4350_P56_ORG_EMAIL_ADDRESS := :F4350_P56_EMAIL_ADDRESS;',
'if :F4350_P56_DEVELOPER_ROLE is null then',
'  :P56_DEVELOPER := ''N'';',
'  :P56_ADMIN := ''N'';',
'elsif instr(:F4350_P56_DEVELOPER_ROLE,''ADMIN'') > 0 then',
'  :P56_DEVELOPER := ''Y'';',
'  :P56_ADMIN := ''Y'';',
'else',
'  :P56_DEVELOPER := ''Y'';',
'  :P56_ADMIN := ''N'';',
'end if;',
'--',
'-- account expiration notices',
'--',
'l_account_last_updated := nvl(:P56_ACCOUNT_EXPIRY, trunc(sysdate));',
'for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where provisioning_company_id = :flow_security_group_id) loop',
'  l_workspace_account_lifetime := nvl(c1.account_lifetime_days,l_site_account_lifetime);',
'end loop;',
'',
':P56_SHOW_EXPIRE_FLAG := ''N'';',
'if :P56_DEVELOPER = ''Y'' then',
'  if l_account_last_updated + l_site_account_lifetime < sysdate then',
'    l_dev_admin_expired := true;',
'    :P56_EXPIRATION_STATUS1 := wwv_flow_lang.system_message(''EXPIRED'');',
'  else',
'    :P56_EXPIRATION_STATUS1 := wwv_flow_lang.system_message(''VALID'');',
'    :P56_SHOW_EXPIRE_FLAG := ''Y'';',
'  end if;',
'else',
'  :P56_EXPIRATION_STATUS1 := ''NA'';',
'end if;',
'',
'for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where (',
'             EXPIRE_FND_USER_ACCOUNTS = ''Y'' or ',
'             wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS'') = ''Y'')',
'           and provisioning_company_id = :flow_security_group_id) loop',
'  l_found := true;',
'  if l_account_last_updated + l_workspace_account_lifetime < sysdate then',
'    l_end_user_expired := true;',
'    :P56_EXPIRATION_STATUS2 := wwv_flow_lang.system_message(''EXPIRED'');',
'  else',
'    :P56_EXPIRATION_STATUS2 := wwv_flow_lang.system_message(''VALID'');',
'    :P56_SHOW_EXPIRE_FLAG := ''Y'';',
'  end if;',
'end loop;',
'if not l_found then',
'  :P56_EXPIRATION_STATUS2 := ''NA'';',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>157783521762846932
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(70800964830989107)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create DB user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_num number;',
'    l_sql varchar2(32767);',
'begin',
'    select count(*) into l_num from sys.dba_users where username = upper(:F4350_P56_USER_NAME);',
'    ',
'    if l_num = 0 then',
'        wwv_flow_provision.create_user(',
'            p_username    => upper(:F4350_P56_USER_NAME),',
'            p_password    => :F4350_P56_WEB_PASSWORD );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST = ''ApplyChanges'' and :P56_DEVELOPER = ''Y'' and :F4350_P56_DEVELOPER_ROLE is null and wwv_flow_authentication_dev.get_internal_authentication = ''DB'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>70800964830989107
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1939534269325925)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'edit user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_p1 varchar2(256) := v(''F4350_P56_WEB_PASSWORD'');',
'  l_p2 varchar2(256) := v(''F4350_P56_USER_PASSWORD'');',
'  l_msg varchar2(4000);',
'  l_body_html varchar2(32767) := null;',
'  l_product_name      varchar2(500);',
'  l_developer_roles varchar2(255) := null;',
'  l_ALLOW_APP_BUILDING_YN         varchar2(1);',
'  l_ALLOW_SQL_WORKSHOP_YN         varchar2(1);',
'  l_ALLOW_TEAM_DEVELOPMENT_YN     varchar2(1);',
'begin',
'    if :F4350_P56_DEFAULT_SCHEMA is not null then',
'        wwv_flow_sw_api.check_priv(p_schema=>:F4350_P56_DEFAULT_SCHEMA);',
'    end if;',
'',
'    if nvl(:P56_ADMIN,''N'') = ''Y'' or nvl(:P56_DEVELOPER,''N'') = ''Y'' then',
'        l_ALLOW_APP_BUILDING_YN     := nvl(v(''P56_ALLOW_APP_BUILDING_YN''),''Y'');',
'        l_ALLOW_SQL_WORKSHOP_YN     := nvl(v(''P56_ALLOW_SQL_WORKSHOP_YN''),''Y'');',
'        l_ALLOW_TEAM_DEVELOPMENT_YN := nvl(v(''P56_ALLOW_TEAM_DEVELOPMENT_YN''),''Y'');  ',
'    else',
'        l_ALLOW_APP_BUILDING_YN     := nvl(v(''P56_ALLOW_APP_BUILDING_YN''),''N'');',
'        l_ALLOW_SQL_WORKSHOP_YN     := nvl(v(''P56_ALLOW_SQL_WORKSHOP_YN''),''N'');',
'        l_ALLOW_TEAM_DEVELOPMENT_YN := nvl(v(''P56_ALLOW_TEAM_DEVELOPMENT_YN''),''N'');  ',
'    end if;',
'',
' --   l_ALLOW_TEAM_DEVELOPMENT_YN := case when :P56_ADMIN = ''N'' and :P56_DEVELOPER = ''N'' then ''N'' else nvl(v(''P56_ALLOW_TEAM_DEVELOPMENT_YN''),''Y'') end;',
'    ',
'    wwv_flow.update_cache_with_write(''F4350_P56_WEB_PASSWORD'',null);',
'    wwv_flow.update_cache_with_write(''F4350_P56_USER_PASSWORD'',null);',
'    ',
'    wwv_flow_fnd_developer_api.edit_fnd_user (',
'     p_user_id                      => :F4350_P56_USER_ID,           ',
'     p_user_name                    => :F4350_P56_USER_NAME,         ',
'     p_first_name                   => :F4350_P56_FIRST_NAME,          ',
'     p_last_name                    => :F4350_P56_LAST_NAME,',
'     p_web_password                 => l_p1,    ',
'     p_new_password                 => l_p2,                     ',
'     p_email_address                => :F4350_P56_EMAIL_ADDRESS,       ',
'     p_allow_access_to_schemas      => :F4350_P56_ACCESS_TO_SCHEMAS,   ',
'     p_default_schema               => :F4350_P56_DEFAULT_SCHEMA, ',
'     p_default_date_format          => :P56_DEFAULT_DATE_FORMAT,',
'     p_group_ids                    => :F4350_P56_GROUPS,',
'     P_DESCRIPTION                  => :P56_DESCRIPTION,',
'     --',
'     P_ACCOUNT_EXPIRY               => :P56_ACCOUNT_EXPIRY,',
'     P_ACCOUNT_LOCKED               => :P56_ACCOUNT_LOCKED,',
'     p_change_password_on_first_use => :P56_CHANGE_PWD_ON_FIRST_USE,',
'     p_first_password_use_occurred  => case when l_p1 is not null then ''N'' else :P56_FIRST_PWD_USE_OCCURRED end,',
'     --',
'     p_ALLOW_APP_BUILDING_YN        => l_ALLOW_APP_BUILDING_YN,',
'     p_ALLOW_SQL_WORKSHOP_YN        => l_ALLOW_SQL_WORKSHOP_YN,',
'     p_ALLOW_TEAM_DEVELOPMENT_YN    =>  l_ALLOW_TEAM_DEVELOPMENT_YN ',
'    );',
'',
'  --',
'  -- Mail the change of Email address',
'  --',
'  If :F4350_P56_ORG_EMAIL_ADDRESS <> :F4350_P56_EMAIL_ADDRESS then',
'        l_msg := l_msg || wwv_flow_lang.system_message( ''NEW_EMAIL_ADDRESS'', ',
'                                                        wwv_flow_escape.html( :F4350_P56_USER_NAME ), ',
'                                                        wwv_flow_escape.html( :F4350_P56_COMPANY ), ',
'                                                        wwv_flow_escape.html( :F4350_P56_EMAIL_ADDRESS ),',
'                                                        wwv_flow_utilities.host_url(''SCRIPT'')) || chr(10);',
'    ',
'        l_body_html := wwv_flow_mail.convert_txt_to_html (',
'                       p_txt_message       => l_msg,',
'                       p_security_group_id => :flow_security_group_id );',
'    l_product_name := nvl(v(''PRODUCT_NAME''),''Oracle APEX'');',
'',
'    wwv_flow_mail.send ( p_to        => :F4350_P56_ORG_EMAIL_ADDRESS,',
'                         p_from      => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),:F4350_P56_ORG_EMAIL_ADDRESS),',
'                         p_body      => l_msg,',
'                         p_body_html => l_body_html,',
'                         p_subj      => wwv_flow_lang.system_message(''CHANGE_PW_REQUEST'',l_product_name) );',
'  end if;',
'',
'  --',
'  -- Developer and Admin roles',
'  --',
'  if nvl(:P56_ADMIN,''N'') = ''N'' and nvl(:P56_DEVELOPER,''N'') = ''N'' then',
'    delete from wwv_flow_developers where user_id = :F4350_P56_USER_ID;',
'  else',
'    -- {Trigger on WWV_FLOW_DEVELOPERS sets all developer roles for ADMINS ',
'    --  irrespective of what set here providing includes ''ADMIN''} ',
'    if nvl(:P56_ADMIN,''N'') = ''Y'' then ',
'      l_developer_roles := l_developer_roles||''ADMIN:CREATE:EDIT:HELP:MONITOR:SQL:MONITOR:DATA_LOADER'';',
'    else',
'        if nvl(v(''P56_ALLOW_APP_BUILDING_YN''),''Y'') = ''Y'' then ',
'          if l_developer_roles is not null then',
'            l_developer_roles := l_developer_roles||'':'';',
'          end if;',
'          l_developer_roles := l_developer_roles||''CREATE:EDIT:HELP:MONITOR'';',
'        end if;',
'        if nvl(v(''P56_ALLOW_SQL_WORKSHOP_YN''),''Y'') = ''Y'' then',
'          if l_developer_roles is not null then',
'            l_developer_roles := l_developer_roles||'':'';',
'          end if;',
'          l_developer_roles := l_developer_roles||''SQL:MONITOR:DATA_LOADER'';',
'        end if;',
'    end if;',
'    wwv_flow_fnd_developer_api.edit_developer_role(',
'             p_id              => 1,',
'             p_user_id         => :F4350_P56_USER_ID,',
'             p_user_name       => :F4350_P56_USER_NAME,',
'             p_developer_roles => l_developer_roles);',
'  end if;',
'',
'  --',
'  -- If the current user is the one being edited in this workspace, then also',
'  -- update the session state value for the user default date format',
'  --',
'  if :APP_USER = upper(:F4350_P56_USER_NAME) then',
'      if trim(:P56_DEFAULT_DATE_FORMAT) is null then',
'          :G_USER_DEFAULT_DATE_FORMAT := :DATE_FORMAT;      ',
'      else',
'          :G_USER_DEFAULT_DATE_FORMAT := :P56_DEFAULT_DATE_FORMAT;',
'      end if;',
'  end if;',
'  ',
'',
'  commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error updating user.'
,p_process_when_button_id=>wwv_flow_imp.id(1939534239325908)
,p_process_success_message=>'User "&F4350_P56_USER_NAME." updated.'
,p_internal_uid=>1939534269325925
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(50610502602911549)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_api.remove_fnd_user(',
'             p_user_id => :F4350_P56_USER_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting &F4350_P56_USER_NAME..'
,p_process_when_button_id=>wwv_flow_imp.id(1939534238325908)
,p_process_success_message=>'User &F4350_P56_USER_NAME. deleted.'
,p_internal_uid=>50610502602911549
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(359782111702838596)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4350_P56_WEB_PASSWORD,F4350_P56_USER_PASSWORD'
,p_internal_uid=>359782111702838596
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6871003183243994)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'expire account'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_site_account_lifetime      number := nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),45);',
'  l_workspace_account_lifetime number;',
'  l_account_last_updated       date;',
'  l_account_next_updated       date;',
'begin',
'  l_account_last_updated := nvl(:P56_ACCOUNT_EXPIRY, trunc(sysdate));',
'  for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'              where provisioning_company_id = :flow_security_group_id)',
'  loop',
'      l_workspace_account_lifetime := nvl(c1.account_lifetime_days,l_site_account_lifetime);',
'  end loop;',
'  l_account_next_updated := trunc(sysdate) - greatest(l_workspace_account_lifetime,l_site_account_lifetime);',
'',
'  update wwv_flow_fnd_user ',
'     set account_expiry = l_account_next_updated ',
'   where :F4350_P56_USER_ID = user_id',
'     and security_group_id = :flow_security_group_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(1939534239325908)
,p_process_when=>':P56_EXPIRE = ''Y'' and nvl(:P56_UPDATE_PW,0) = 0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>6871003183243994
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(356667829527371372)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'always developer if admin'
,p_process_sql_clob=>':P56_DEVELOPER := ''Y'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P56_ADMIN'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_internal_uid=>356667829527371372
);
end;
/
prompt --application/pages/page_00057
begin
wwv_flow_imp_page.create_page(
 p_id=>57
,p_name=>'Delete Multiple Users'
,p_alias=>'DELETE-MULTIPLE-USERS'
,p_step_title=>'Delete Multiple Users'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_del_multi_users.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(487212527825020723)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(487213714635020731)
,p_plug_name=>'Users'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when u."USER"=:APP_USER then',
'               null',
'           else',
'               wwv_flow_item.checkbox(1,wwv_flow_escape.html(user_id),''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(u."USER"))||''"'')',
'       end c,',
'       alt,',
'       "USER",',
'       "eMail",',
'       first_name,',
'       last_name,',
'       df, -- default schema',
'       developer,',
'       last_login,',
'       last_login2,',
'       builder_login_count,',
'       ul, -- is user locked?',
'       expiration,',
'       description,',
'       password_lifespan_days,',
'       password_lifespan_accesses,',
'       password_accesses_left,',
'       last_agent,',
'       last_ip,',
'       account_expiry,',
'       failed_access_attempts,',
'       change_password_on_first_use,',
'       first_password_use_occurred,',
'       dev_type,',
'       group_id,',
'       group_name,',
'       last_update_date,',
'       last_updated_by,',
'       creation_date,',
'       created_by,',
'       allow_app_building,',
'       allow_sql_workshop,',
'       allow_team_devopment',
'  from wwv_flow_workspace_users u',
' where workspace_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(487213921192020742)
,p_name=>'Internal Accounts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487215710241020761)
,p_db_column_name=>'USER'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>'User'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487215802188020762)
,p_db_column_name=>'eMail'
,p_display_order=>3
,p_column_identifier=>'G'
,p_column_label=>'Email'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487215931922020762)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'H'
,p_column_label=>'First Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216002599020762)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Last Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216119102020763)
,p_db_column_name=>'DF'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Default Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216529936020763)
,p_db_column_name=>'UL'
,p_display_order=>7
,p_column_identifier=>'N'
,p_column_label=>'Locked'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216719903020764)
,p_db_column_name=>'DEV_TYPE'
,p_display_order=>8
,p_column_identifier=>'P'
,p_column_label=>'Account Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216201732020763)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>9
,p_column_identifier=>'K'
,p_column_label=>'Password Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216623847020764)
,p_db_column_name=>'EXPIRATION'
,p_display_order=>10
,p_column_identifier=>'O'
,p_column_label=>'End User Account'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216317773020763)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>'Builder Last Login Date'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216402426020763)
,p_db_column_name=>'BUILDER_LOGIN_COUNT'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Builder Login Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487215318605020760)
,p_db_column_name=>'ALT'
,p_display_order=>14
,p_column_identifier=>'B'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216811649020764)
,p_db_column_name=>'LAST_LOGIN2'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Builder Last Login'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487216902657020764)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487217002481020765)
,p_db_column_name=>'PASSWORD_LIFESPAN_DAYS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Password Lifespan Days'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487217129654020765)
,p_db_column_name=>'PASSWORD_LIFESPAN_ACCESSES'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Password Lifespan Accesses'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487217219249020765)
,p_db_column_name=>'PASSWORD_ACCESSES_LEFT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Password Accesses Left'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487217314732020765)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Last Agent'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487217421986020766)
,p_db_column_name=>'LAST_IP'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Last IP Address'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487217508236020766)
,p_db_column_name=>'ACCOUNT_EXPIRY'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Account Expiry'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487217618067020766)
,p_db_column_name=>'FAILED_ACCESS_ATTEMPTS'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Failed Access Attempts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487217731681020766)
,p_db_column_name=>'CHANGE_PASSWORD_ON_FIRST_USE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Change Password On First Use'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487214111454020755)
,p_db_column_name=>'FIRST_PASSWORD_USE_OCCURRED'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'First Password Use Occurred'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487214203186020756)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Group ID'
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487214320781020756)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Group Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487214407401020757)
,p_db_column_name=>'LAST_UPDATE_DATE'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487214531320020757)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487214627862020758)
,p_db_column_name=>'CREATION_DATE'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487214728627020758)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487214921039020759)
,p_db_column_name=>'ALLOW_APP_BUILDING'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>'App Builder'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487215009223020759)
,p_db_column_name=>'ALLOW_SQL_WORKSHOP'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'SQL Workshop'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487215206440020759)
,p_db_column_name=>'ALLOW_TEAM_DEVOPMENT'
,p_display_order=>38
,p_column_identifier=>'AL'
,p_column_label=>'Team Development'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487221529442070599)
,p_db_column_name=>'C'
,p_display_order=>39
,p_column_identifier=>'AM'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(487217800880020767)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310022603536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'C:USER:eMail:DEV_TYPE:LAST_LOGIN2:CREATION_DATE'
,p_sort_column_1=>'USER'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'LAST_LOGIN2'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(487212710054020727)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(487213714635020731)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Users'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(487213112910020728)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(487213714635020731)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(487219710852020784)
,p_branch_action=>'57'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(487228209066168747)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Must select at least one user to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(487212710054020727)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199175162192878427)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(487213714635020731)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199175204816878428)
,p_event_id=>wwv_flow_imp.id(1199175162192878427)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(487229823742182498)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete users'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   wwv_flow_fnd_user_api.remove_fnd_user(',
'             p_user_id => to_number(wwv_flow.g_f01(i)));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'User(s) failed to be deleted.'
,p_process_when_button_id=>wwv_flow_imp.id(487212710054020727)
,p_process_success_message=>'User(s) deleted.'
,p_internal_uid=>487229823742182498
);
end;
/
prompt --application/pages/page_00058
begin
wwv_flow_imp_page.create_page(
 p_id=>58
,p_name=>'Change Password'
,p_alias=>'CHANGE-PASSWORD'
,p_page_mode=>'MODAL'
,p_step_title=>'Change Password'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_inline_css=>'#htmldbMessageHolder {position: inherit !important; margin: -10px auto 12px auto !important};'
,p_step_template=>wwv_flow_imp.id(485889499804058937)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32840111164438374)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4350_P58_PASSWORD := null;',
':F4350_P58_CONFIRM_PASSWORD := null;',
':P58_ENTER_CURRENT_PASSWORD := null;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(97733238886811092)
,p_plug_name=>'Change Password'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'CONFIRM'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(970051444988740602)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(97747647431861977)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(970051444988740602)
,p_button_name=>'Save'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'CONFIRM'
,p_button_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(97746535656858507)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(970051444988740602)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Close'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(167163108516013325)
,p_branch_action=>'f?p=&APP_ID.:58:&SESSION.:CONFIRM:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(97737538442826474)
,p_name=>'F4350_P58_USER_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(97733238886811092)
,p_prompt=>'Username:'
,p_source=>':flow_user'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of the user to have password changed'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(97738659564831832)
,p_name=>'F4350_P58_PASSWORD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(97733238886811092)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Enter New Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the new password'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(97739354173834336)
,p_name=>'F4350_P58_CONFIRM_PASSWORD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(97733238886811092)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Confirm New Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Reenter the new password'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195381121107968260)
,p_name=>'P58_ENTER_CURRENT_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(97733238886811092)
,p_prompt=>'Enter Current Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter your current password.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(458944904898444327)
,p_validation_name=>':FLOW_USER is not null'
,p_validation_sequence=>10
,p_validation=>'FLOW_USER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'The username has not been set correctly. Please close your browser completely and try to change your password again.'
,p_associated_item=>wwv_flow_imp.id(97737538442826474)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Implemented on Display Only field due to issues with Username being null in some instances. Issue often reported on apex.oracle.com with users being unable to change their password until they have restarted their browser -- David Peake',
''))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(195491431842321459)
,p_validation_name=>'P58_ENTER_CURRENT_PASSWORD'
,p_validation_sequence=>20
,p_validation=>'P58_ENTER_CURRENT_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Password must be specified.'
,p_associated_item=>wwv_flow_imp.id(195381121107968260)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(97742065159844461)
,p_validation_name=>'F4350_P58_PASSWORD Not Null'
,p_validation_sequence=>30
,p_validation=>'F4350_P58_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Password must be specified.'
,p_associated_item=>wwv_flow_imp.id(97738659564831832)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 07-AUG-2002 16:59'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(97742336858844466)
,p_validation_name=>'F4350_P58_CONFIRM_PASSWORD Not Null'
,p_validation_sequence=>40
,p_validation=>'F4350_P58_CONFIRM_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Confirm Password must be specified.'
,p_associated_item=>wwv_flow_imp.id(97739354173834336)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 07-AUG-2002 16:59'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(97743950494851241)
,p_validation_name=>'passwd = confirm passwd'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4350_P58_PASSWORD != :F4350_P58_CONFIRM_PASSWORD then',
'  :F4350_P58_PASSWORD := null;',
'  :F4350_P58_CONFIRM_PASSWORD := null;',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Confirmation password does not match password.'
,p_validation_condition=>':F4350_P58_PASSWORD is not null and :F4350_P58_CONFIRM_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(97739354173834336)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(195618500159768013)
,p_validation_name=>'Validate Current Password'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_api.is_login_password_valid(',
'  p_username=>:APP_USER,',
'  p_password=>:P58_ENTER_CURRENT_PASSWORD);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid Password'
,p_validation_condition=>'P58_ENTER_CURRENT_PASSWORD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(195381121107968260)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(97500109914962040)
,p_validation_name=>'strong password'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username              => :F4350_P58_USER_NAME,',
'      p_password              => :F4350_P58_PASSWORD,',
'      p_old_password          => :P58_ENTER_CURRENT_PASSWORD,',
'      p_workspace_name        => ',
'              wwv_flow_security.find_company_name(:WORKSPACE_ID));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Error'
,p_validation_condition=>':F4350_P58_PASSWORD is not null and :F4350_P58_CONFIRM_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(97738659564831832)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(97750634955873614)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change password'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_p varchar2(256) := v(''F4350_P58_PASSWORD'');',
'begin',
'  wwv_flow.update_cache_with_write(''F4350_P58_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''F4350_P58_CONFIRM_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''P58_ENTER_CURRENT_PASSWORD'',null);',
'  wwv_flow_imp.g_fnd_user_password_action := true;',
'  update wwv_flow_fnd_user ',
'    set web_password = l_p',
'  where security_group_id = :flow_security_group_id ',
'    and user_id = (select user_id ',
'                    from wwv_flow_fnd_user ',
'                   where security_group_id = :flow_security_group_id ',
'                     and user_name = :flow_user);',
'  wwv_flow_imp.g_fnd_user_password_action := false;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing password.'
,p_process_when=>':F4350_P58_PASSWORD = :F4350_P58_CONFIRM_PASSWORD'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Password changed.'
,p_internal_uid=>97750634955873614
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(60831518199464683)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'58'
,p_internal_uid=>60831518199464683
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(970051351448740601)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(97746535656858507)
,p_internal_uid=>970051351448740601
);
end;
/
prompt --application/pages/page_00059
begin
wwv_flow_imp_page.create_page(
 p_id=>59
,p_name=>'Set Reporting Timeframe'
,p_alias=>'SET-REPORTING-TIMEFRAME'
,p_step_title=>'Set Reporting Timeframe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_hm.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(435132419277175057)
,p_plug_name=>'Set Reporting Timeframe'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(435134109039200452)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(435132419277175057)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(435134317383200454)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(435132419277175057)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(435134722545204415)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435133125746186382)
,p_name=>'P59_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(435132419277175057)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Show'
,p_source=>'nvl(:P1_TIME,.125)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Display real time statistics for this amount of time.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(435135231895207087)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set reporting Timeframe'
,p_process_sql_clob=>':P1_TIME := :P59_TIME;'
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'Action Processed'
,p_internal_uid=>435135231895207087
);
end;
/
prompt --application/pages/page_00060
begin
wwv_flow_imp_page.create_page(
 p_id=>60
,p_name=>'User Dashboard'
,p_alias=>'USER-DASHBOARD'
,p_step_title=>'User Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30379719851234976)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(166211911060758908)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(38499417503989888)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(33618923744803860)
,p_name=>'Recently Created'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P60d */',
'      substr(lower(u.user_name),1,50) user_name,',
'      u.CREATION_DATE,',
'      u.USER_ID,',
'      u.email_address "eMail"',
'from  WWV_FLOW_FND_USER u',
'where security_group_id = :flow_security_group_id',
'and (:AUTH_TYPE=''APEX'' or not exists (select null from wwv_flow_developers d where u.user_id = d.user_id and u.security_group_id = d.security_group_id))',
'order by creation_date desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No users found.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(33618923744803860)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33619332489803868)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4350:56:&SESSION.::&DEBUG.:EDIT_USER_PRIVS:F4350_P56_USER_ID,LAST_VIEW:#USER_ID#,60'
,p_column_linktext=>'#USER_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33619518264803868)
,p_query_column_id=>2
,p_column_alias=>'CREATION_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46860326857226944)
,p_query_column_id=>3
,p_column_alias=>'USER_ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46860401547226946)
,p_query_column_id=>4
,p_column_alias=>'eMail'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46746423788487369)
,p_name=>'Workspace Users'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P60b */',
'   count(*) user_count,',
'   sum(decode(developer_type,null,1,0)) end_user_count,',
'   sum(decode(is_developer,''Y'',1,0)) developer_count,',
'   sum(decode(developer_type,''ADMIN'',1,0)) workspace_admin_count,',
'   sum(decode(greatest(u.CREATION_DATE,sysdate - 1),sysdate -1,0,1)) created_last_24_hours,',
'   sum(decode(greatest(u.CREATION_DATE,sysdate - 7),sysdate -7,0,1)) created_last_week',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer,',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              ''BASIC_DEV''',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              ''ADMIN''',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              ''DEVELOPER''',
'           else',
'              ''UNKNOWN'' ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(46746423788487369)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46746605762487374)
,p_query_column_id=>1
,p_column_alias=>'USER_COUNT'
,p_column_display_sequence=>1
,p_column_heading=>'Users'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46746713956487375)
,p_query_column_id=>2
,p_column_alias=>'END_USER_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'End Users'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46746831538487375)
,p_query_column_id=>3
,p_column_alias=>'DEVELOPER_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Application Developers'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46747023926487375)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_ADMIN_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace Administrators'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46747130355487375)
,p_query_column_id=>5
,p_column_alias=>'CREATED_LAST_24_HOURS'
,p_column_display_sequence=>5
,p_column_heading=>'Created Last 24 Hours'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46747226758487375)
,p_query_column_id=>6
,p_column_alias=>'CREATED_LAST_WEEK'
,p_column_display_sequence=>6
,p_column_heading=>'Created Last Week'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46762420099120193)
,p_name=>'User Groups'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P60c */',
'   g.group_name,',
'   count(*) user_count',
'from  WWV_FLOW_FND_USER_GROUPS_NOAPP g,',
'      WWV_FLOW_FND_GROUP_USERS u',
'where g.security_group_id = :flow_security_group_id',
'  and g.id = u.group_id(+)',
'group by g.group_name',
'order by count(*) desc, upper(g.group_name)'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No groups found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46767109411145456)
,p_query_column_id=>1
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Group Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46767228078145460)
,p_query_column_id=>2
,p_column_alias=>'USER_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'User Count'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46994318485620885)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47004408825920869)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47026829183038160)
,p_name=>'Your Account'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P60a */',
'       substr(:app_user,1,50) your_username,',
'       substr(:company,1,50) workspace,',
'       (select substr(EMAIL_ADDRESS,1,50)',
'        from WWV_FLOW_FND_USER',
'       where SECURITY_GROUP_ID = :flow_security_group_id and ',
'            USER_NAME= :app_user and rownum = 1) email,',
'       (select creation_date',
'        from WWV_FLOW_FND_USER',
'       where SECURITY_GROUP_ID = :flow_security_group_id and ',
'             USER_NAME= :app_user and rownum = 1) user_created,',
'       (select ',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              wwv_flow_lang.system_message(''NO'')',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              wwv_flow_lang.system_message(''YES'')',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              wwv_flow_lang.system_message(''NO'')',
'           else',
'              wwv_flow_lang.system_message(''NO'') ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id and USERID = :app_user and rownum = 1) user_privilege,',
'       (select ',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              wwv_flow_lang.system_message(''NO'')',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              wwv_flow_lang.system_message(''YES'')',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              wwv_flow_lang.system_message(''YES'')',
'           else',
'              wwv_flow_lang.system_message(''NO'')',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id and USERID = :app_user and rownum = 1) application_Developer',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No development activity'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47027413731043129)
,p_query_column_id=>1
,p_column_alias=>'YOUR_USERNAME'
,p_column_display_sequence=>1
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47028506851069487)
,p_query_column_id=>2
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>3
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47028800927115137)
,p_query_column_id=>3
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>6
,p_column_heading=>'Email Address'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47028915848115137)
,p_query_column_id=>4
,p_column_alias=>'USER_CREATED'
,p_column_display_sequence=>5
,p_column_heading=>'User Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47027507283043129)
,p_query_column_id=>5
,p_column_alias=>'USER_PRIVILEGE'
,p_column_display_sequence=>2
,p_column_heading=>'Workspace Administrator'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47027606772043129)
,p_query_column_id=>6
,p_column_alias=>'APPLICATION_DEVELOPER'
,p_column_display_sequence=>4
,p_column_heading=>'Application Developer'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47343220276012869)
,p_plug_name=>'Users and Groups'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>View a summary of workspace users.  Activity attributes are displayed based on the selected timeframe.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47628322357056758)
,p_name=>'User Status'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>70
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P60e */',
'     sum(',
'         case ',
'         when (wwv_flow_fnd_user_api.end_user_account_days_left(',
'               wwv_flow_user_api.get_username(user_id)) > 0) ',
'         then 1',
'         else 0',
'         end) valid_passwords,',
'     sum(',
'         case ',
'         when (wwv_flow_fnd_user_api.end_user_account_days_left(',
'               wwv_flow_user_api.get_username(user_id)) > 0) ',
'         then 0',
'         else 1',
'         end) expired_passwords,',
'     sum(decode(nvl(u.account_locked,''N''),''Y'',1,0)) locked_accounts,',
'     sum(decode(nvl(u.account_locked,''N''),''Y'',0,1)) unlocked_accounts,',
'     sum(decode(u.email_address,null,1,0)) no_email_specified',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer,',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              ''BASIC_DEV''',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              ''ADMIN''',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              ''DEVELOPER''',
'           else',
'              ''UNKNOWN'' ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47628322357056758)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47629025820057702)
,p_query_column_id=>1
,p_column_alias=>'VALID_PASSWORDS'
,p_column_display_sequence=>1
,p_column_heading=>'Valid Passwords'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47629127065057702)
,p_query_column_id=>2
,p_column_alias=>'EXPIRED_PASSWORDS'
,p_column_display_sequence=>2
,p_column_heading=>'Expired Passwords'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47629710152072093)
,p_query_column_id=>3
,p_column_alias=>'LOCKED_ACCOUNTS'
,p_column_display_sequence=>3
,p_column_heading=>'Locked Accounts'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47629828778072093)
,p_query_column_id=>4
,p_column_alias=>'UNLOCKED_ACCOUNTS'
,p_column_display_sequence=>4
,p_column_heading=>'Unlocked Accounts'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47630110629081753)
,p_query_column_id=>5
,p_column_alias=>'NO_EMAIL_SPECIFIED'
,p_column_display_sequence=>5
,p_column_heading=>'No Email Specified'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955889190717997302)
,p_plug_name=>'Placholder'
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(167828417885635073)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47004408825920869)
,p_button_name=>'MANAGE_USERS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_image_alt=>'Manage Users'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
,p_security_scheme=>wwv_flow_imp.id(12518728403445471)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47004908790920880)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47004408825920869)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47005119561923913)
,p_branch_action=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30218521333841738)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'60'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00061
begin
wwv_flow_imp_page.create_page(
 p_id=>61
,p_name=>'Page Caching Performance by Page'
,p_alias=>'PAGE-CACHING-PERFORMANCE-BY-PAGE'
,p_step_title=>'Page Caching Performance by Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(231623005580185250)
,p_name=>'Cached Page Performance'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    flow_id,',
'    step_id,',
'    count(*),',
'    sum(decode(page_mode,''D'',1,''C'',1,0)) dynamic_views,',
'    avg(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_avg,',
'    min(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_min,',
'    max(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_max,',
'    sum(decode(page_mode,''R'',1,0)) cached_views,',
'    avg(decode(page_mode,''R'',elap,null)) cached_views_avg,',
'    min(decode(page_mode,''R'',elap,null)) cached_views_min,',
'    max(decode(page_mode,''R'',elap,null)) cached_views_max',
'from WWV_FLOW_ACTIVITY_LOG',
'where security_group_id = :flow_security_group_id and ',
'      time_stamp >= sysdate - nvl(:p61_time,1) and',
'      (:p61_user is null or instr(userid,upper(:p61_user)) > 0 ) and',
'      (:p61_flow is null or flow_id = :p61_flow) and',
'      (:p61_page is null or step_id = :p61_page) and',
'      (:flow_security_group_id = 10 or flow_id not between 4000 and 4999)',
'group by flow_id, step_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(6659715068668103)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_item=>'P61_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 29-NOV-2002 09:59:34'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231623604289185255)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231623725824185255)
,p_query_column_id=>2
,p_column_alias=>'STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231636620283250883)
,p_query_column_id=>3
,p_column_alias=>'COUNT(*)'
,p_column_display_sequence=>3
,p_column_heading=>'Views'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231630720105212957)
,p_query_column_id=>4
,p_column_alias=>'DYNAMIC_VIEWS'
,p_column_display_sequence=>4
,p_column_heading=>'Dynamic Views'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231630813154212957)
,p_query_column_id=>5
,p_column_alias=>'DYNAMIC_VIEWS_AVG'
,p_column_display_sequence=>5
,p_column_heading=>'Average'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231630929661212957)
,p_query_column_id=>6
,p_column_alias=>'DYNAMIC_VIEWS_MIN'
,p_column_display_sequence=>6
,p_column_heading=>'Minimum'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231631001189212958)
,p_query_column_id=>7
,p_column_alias=>'DYNAMIC_VIEWS_MAX'
,p_column_display_sequence=>7
,p_column_heading=>'Maximum'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231631106423212958)
,p_query_column_id=>8
,p_column_alias=>'CACHED_VIEWS'
,p_column_display_sequence=>8
,p_column_heading=>'Cached Views'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231631201524212958)
,p_query_column_id=>9
,p_column_alias=>'CACHED_VIEWS_AVG'
,p_column_display_sequence=>9
,p_column_heading=>'Average'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231631330699212958)
,p_query_column_id=>10
,p_column_alias=>'CACHED_VIEWS_MIN'
,p_column_display_sequence=>10
,p_column_heading=>'Minimum'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231631420325212958)
,p_query_column_id=>11
,p_column_alias=>'CACHED_VIEWS_MAX'
,p_column_display_sequence=>11
,p_column_heading=>'Maximum'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(231624522756185257)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(231627203542185270)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(231624522756185257)
,p_button_name=>'P61_GO'
,p_button_static_id=>'P61_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(231628005946185275)
,p_branch_action=>'61'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231624727504185257)
,p_name=>'P61_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(231624522756185257)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select the timeframe for the search.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231625218731185265)
,p_name=>'P61_USER'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(231624522756185257)
,p_prompt=>'User'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'To filter by user, enter a username and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231625727901185266)
,p_name=>'P61_FLOW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(231624522756185257)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'To filter by application, enter an application ID and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231626200649185267)
,p_name=>'P61_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(231624522756185257)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specify a page to constrain the report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231626702193185269)
,p_name=>'P61_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(231624522756185257)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,50,100,200,500,1000,5000'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the number of rows to display and click <strong>Go</strong>.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231627401261185271)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P61_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_associated_item=>wwv_flow_imp.id(231625727901185266)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231627607194185273)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P61_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_associated_item=>wwv_flow_imp.id(231626200649185267)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(231627813188185273)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>231627813188185273
);
end;
/
prompt --application/pages/page_00062
begin
wwv_flow_imp_page.create_page(
 p_id=>62
,p_name=>'Application Errors'
,p_alias=>'APPLICATION-ERRORS'
,p_step_title=>'Application Errors'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9823818362293578)
,p_plug_name=>'Application Errors'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P62a */ /*+ FIRST_ROWS(21) */',
'	 utl_i18n.unescape_reference(sqlerrm) sqlerrm, -- prevent over-escaping; column has Escape Special Characters = true',
'	 USERID,',
'	 FLOW_ID application,',
'	 STEP_ID page,',
'	 SESSION_ID,',
'	 TIME_STAMP,',
'     sqlerrm_component_type,',
'     sqlerrm_component_name,',
'     debug_page_view_id',
' from WWV_FLOW_ACTIVITY_LOG',
'where security_group_id = :flow_security_group_id',
'  and sqlerrm is not null',
'  and time_stamp >= sysdate - nvl(:P62_TIME,1)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9823928358293578)
,p_name=>'Application Errors'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9824329546293581)
,p_db_column_name=>'APPLICATION'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9824418129293581)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9824204038293581)
,p_db_column_name=>'USERID'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9824603394293582)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9824105979293581)
,p_db_column_name=>'SQLERRM'
,p_display_order=>5
,p_column_identifier=>'A'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9824714138293582)
,p_db_column_name=>'SQLERRM_COMPONENT_TYPE'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Context'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9824832214293582)
,p_db_column_name=>'SQLERRM_COMPONENT_NAME'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Component'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9824506005293582)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>8
,p_column_identifier=>'E'
,p_column_label=>'Session'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RR,29:IREQ_SESSION_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(787517387018850122)
,p_db_column_name=>'DEBUG_PAGE_VIEW_ID'
,p_display_order=>18
,p_column_identifier=>'I'
,p_column_label=>'Debug ID'
,p_column_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:RP,24:P24_PAGE_VIEW_ID:#DEBUG_PAGE_VIEW_ID#'
,p_column_linktext=>'#DEBUG_PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9825015463293844)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310103760536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION:PAGE:USERID:TIME_STAMP:SQLERRM:SQLERRM_COMPONENT_TYPE:SQLERRM_COMPONENT_NAME:SESSION_ID:DEBUG_PAGE_VIEW_ID'
,p_sort_column_1=>'TIME_STAMP'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(211672831474340524)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450636024120991561)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(211672831474340524)
,p_button_name=>'P62_GO'
,p_button_static_id=>'P62_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184358929848038872)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(211672831474340524)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:62,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(211681529393379974)
,p_branch_action=>'f?p=&FLOW_ID.:62:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211692922395432530)
,p_name=>'P62_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(211672831474340524)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to ',
'',
'include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00063
begin
wwv_flow_imp_page.create_page(
 p_id=>63
,p_name=>'Page Views By Operating System'
,p_alias=>'PAGE-VIEWS-BY-OPERATING-SYSTEM'
,p_step_title=>'Page Views By Operating System'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10287529721985354)
,p_plug_name=>'Page Views By Operating System'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_count as',
'(select /* APEX4350P63a */ count(*) a ',
'from wwv_flow_activity_log ',
'where security_group_id = :flow_security_group_id and ',
'time_stamp >= sysdate - nvl(:P63_TIME,1)) ',
'select os, page_views , 100*page_views/total_count.a pct, round(100*page_views/total_count.a) graph',
'from (',
'select ',
' x.os, ',
' sum(x.c) page_views',
'from',
'(',
'select session_id, max(decode(user_agent,null,''  '',',
'       nvl(',
'       decode(instr(lower(user_agent),''mac os x''),0,'''',''Mac OS X'')||',
'       decode(instr(lower(user_agent),''linux''),0,'''',''Linux'')||',
'       decode(instr(lower(user_agent),''windows nt 5.0''),0,'''',''Windows 2000'')||',
'       decode(instr(lower(user_agent),''windows nt 5.1''),0,'''',''Windows XP'')||',
'       decode(instr(lower(user_agent),''windows nt 7.0''),0,'''',''Windows 7'')||',
'       decode(instr(lower(user_agent),''windows nt 6.0''),0,'''',''Windows Vista'')||',
'       decode(instr(lower(user_agent),''windows nt 6.1''),0,'''',''Windows 7'')||',
'       decode(instr(lower(user_agent),''windows nt 6.2''),0,'''',''Windows 8'')||',
'       decode(instr(lower(user_agent),''windows nt 6.3''),0,'''',''Windows 8.1'')||    ',
'       decode(instr(lower(user_agent),''windows nt 10.0''),0,'''',''Windows 10''),',
'       ''Other''))) os, count(*) c',
'from wwv_flow_activity_log',
'where security_group_id = :flow_security_group_id',
'       and page_mode != ''A''',
'       and time_stamp >= sysdate - nvl(:P63_TIME,1)',
'group by session_id',
') x',
'group by os) d, total_count'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10287608164985354)
,p_name=>'Page Views By Operating System'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10287804767985355)
,p_db_column_name=>'OS'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Operating System'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10287902469985355)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10288021409985356)
,p_db_column_name=>'PCT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10288102347985356)
,p_db_column_name=>'GRAPH'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10288308760985571)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310203159536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OS:PAGE_VIEWS:PCT:GRAPH'
,p_sort_column_1=>'PCT'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107705722979008325)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450807025270250213)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(107705722979008325)
,p_button_name=>'P63_GO'
,p_button_static_id=>'P63_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(430061325545405776)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(107705722979008325)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:63,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(450807202005250214)
,p_branch_action=>'f?p=&FLOW_ID.:63:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3176719630549097)
,p_name=>'P63_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(107705722979008325)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00064
begin
wwv_flow_imp_page.create_page(
 p_id=>64
,p_name=>'Page Views by Browser'
,p_alias=>'PAGE-VIEWS-BY-BROWSER'
,p_step_title=>'Page Views by Browser'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10282703232952066)
,p_plug_name=>'Page Views By Browser'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_count as',
'(select /* APEX4350P64a */ count(*) a ',
'from wwv_flow_activity_log ',
'where security_group_id = :flow_security_group_id and ',
'user_agent is not null and',
'time_stamp >= sysdate - nvl(:P64_TIME,1)) ',
'select os, page_views , 100*page_views/total_count.a pct, round(100*page_views/total_count.a) graph',
'from (',
'select ',
' x.os, ',
' sum(x.c) page_views',
'from',
'(',
'select session_id, max(',
'       (case ',
'          when instr(lower(user_agent),''msie'') > 0 then ''MSIE''',
'          when instr(lower(user_agent),''firefox'') > 0 then ''Firefox''',
'          when instr(lower(user_agent),''chrome'') > 0 then ''Chrome''',
'          when instr(lower(user_agent),''opera'') > 0 then ''Opera''',
'          when instr(lower(user_agent),''applewebkit'') > 0 then ''Safari''',
'          when instr(lower(user_agent),''safari'') > 0 then ''Safari''',
'          else ''Other''',
'       end ) ) os,',
'       count(*) c',
'from wwv_flow_activity_log',
'where security_group_id = :flow_security_group_id',
'       and user_agent is not null',
'       and time_stamp >= sysdate - nvl(:P64_TIME,1)',
'group by session_id',
') x',
'group by os) d, total_count'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p>User agent is only logged for the first view of a user session.</p>'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10282831738952066)
,p_name=>'Page Views By Browser'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10283021922952070)
,p_db_column_name=>'OS'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Browser'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10283123000952070)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10283225584952070)
,p_db_column_name=>'PCT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Percentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10283319370952070)
,p_db_column_name=>'GRAPH'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10284405251956198)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310318576536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OS:PAGE_VIEWS:PCT:GRAPH'
,p_sort_column_1=>'PCT'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(108232131347078237)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200776422932625565)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(108232131347078237)
,p_button_name=>'P64_SET'
,p_button_static_id=>'P64_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200776004578620262)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(108232131347078237)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:64,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3189523196682526)
,p_branch_action=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3187912114679378)
,p_name=>'P64_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(108232131347078237)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00065
begin
wwv_flow_imp_page.create_page(
 p_id=>65
,p_name=>'Page Performance'
,p_alias=>'PAGE-PERFORMANCE'
,p_step_title=>'Page Views by User'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7431322625516464)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(7431522370516465)
,p_name=>'Page Views'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id, step_id, elap, userid , num_rows, time_stamp, session_id',
'from wwv_flow_activity_log',
'    where time_stamp >= (sysdate - :P65_DATE) ',
'    and security_group_id = :flow_security_group_id',
'    and (:app_security_group_id = 10 or flow_id not between 4000 and 4999)',
'  and flow_id = :P65_APPLICATION and step_id = :P65_page'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(6659715068668103)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_item=>'P65_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7434815944525496)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7434928870525496)
,p_query_column_id=>2
,p_column_alias=>'STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7435011919525496)
,p_query_column_id=>3
,p_column_alias=>'ELAP'
,p_column_display_sequence=>3
,p_column_heading=>'Elapsed Time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D0000'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7435117103525496)
,p_query_column_id=>4
,p_column_alias=>'USERID'
,p_column_display_sequence=>4
,p_column_heading=>'User'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7448511751571566)
,p_query_column_id=>5
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>5
,p_column_heading=>'Report Rows'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7448627754571566)
,p_query_column_id=>6
,p_column_alias=>'TIME_STAMP'
,p_column_display_sequence=>6
,p_column_heading=>'Date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7454300024596530)
,p_query_column_id=>7
,p_column_alias=>'SESSION_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Session'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4350:19:&SESSION.::NO:RP,:P19_ID:#SESSION_ID#'
,p_column_linktext=>'#SESSION_ID#'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7432704933516474)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(7431322625516464)
,p_button_name=>'65_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7433631510516483)
,p_branch_action=>'65'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
,p_branch_comment=>'Generated 28-NOV-2002 23:10:50'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7432206165516470)
,p_name=>'P65_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7431322625516464)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'to_number(.25)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select the timeframe for the search.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7432925561516475)
,p_name=>'P65_ROWS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(7431322625516464)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,50,100,200,500,1000,5000'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the number of rows to display and click <strong>Go</strong>.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7441403870550395)
,p_name=>'P65_APPLICATION'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(7431322625516464)
,p_prompt=>'Application:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies selected application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7442009411551982)
,p_name=>'P65_PAGE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(7431322625516464)
,p_prompt=>'Page:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies selected page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7433417398516480)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>7433417398516480
);
end;
/
prompt --application/pages/page_00066
begin
wwv_flow_imp_page.create_page(
 p_id=>66
,p_name=>'Request Database Schema - Confirm'
,p_alias=>'REQUEST-DATABASE-SCHEMA-CONFIRM'
,p_step_title=>'Request Database Schema - Confirm'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(718401914085176458)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32643808441237723)
,p_plug_name=>'request schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720186138525572350)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(47297014014256767)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(720190141563578035)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177082418885844451)
,p_plug_name=>'Confirmation'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208560620383342557)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113874768695875)
,p_plug_name=>'Request Database Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720159283194358177)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177083008639844469)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208560620383342557)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177082609759844459)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208560620383342557)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177082802719844469)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(208560620383342557)
,p_button_name=>'Finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(177087718493844511)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(177087913566844514)
,p_branch_action=>'48'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(177083008639844469)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(177084702792844486)
,p_name=>'P66_RESTRICTED_SCHEMA_WARNING'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(177082418885844451)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Warning'
,p_post_element_text=>'<p />'
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4700.P26_WARN_RESTRICTED_SCHEMA'',p0=>v(''PRODUCT_NAME''))'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from dual where',
' wwv_flow_provisioning.restricted_schema_i(:SR_NAME,wwv_flow_security.find_company_name(:WORKSPACE_ID)) = ''1'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(805713983989099558)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(177084927778844486)
,p_name=>'P66_SHARED_SCHEMA_WARNING'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(177082418885844451)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Warning'
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4700.P26_WARN_SHARED_SCHEMA'',p0=>v(''PRODUCT_NAME''))'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_display_when=>'select 1 from wwv_flow_company_schemas where schema = upper(:SR_NAME)'
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(805713983989099558)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(246264012675587717)
,p_name=>'P66_REQUEST'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(177082418885844451)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Request'
,p_post_element_text=>'<p />'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P48_NEW,''YES'')=''YES'' then',
'return wwv_flow_lang.system_message(p_name=>''F4350.CONFIRM_SCHEMA_NEW'',p0=>:SR_NAME);',
'else',
'return wwv_flow_lang.system_message(p_name=>''F4350.CONFIRM_SCHEMA_EXISTING'',p0=>:SR_NAME);',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(805713983989099558)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(245495300905083394)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'make request'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provisioning.make_modification_request (',
'    p_service_name        => ''NEW_SCHEMA'',',
'    p_service_attribute_1 => upper(:SR_NAME),',
'    p_service_attribute_2 => wwv_flow_user_api.get_email(p_username => upper(wwv_flow.g_user)));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error submitting request to provision additional workspace schema'
,p_process_when_button_id=>wwv_flow_imp.id(177082802719844469)
,p_process_success_message=>'Request to provision additional workspace schema submitted.'
,p_security_scheme=>wwv_flow_imp.id(916538108136873611)
,p_internal_uid=>245495300905083394
);
end;
/
prompt --application/pages/page_00067
begin
wwv_flow_imp_page.create_page(
 p_id=>67
,p_name=>'Page Caching Performance by Application'
,p_alias=>'PAGE-CACHING-PERFORMANCE-BY-APPLICATION'
,p_step_title=>'Page Caching Performance by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(231651204956355825)
,p_name=>'Cached Application Performance'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    flow_id,',
'    count(*),',
'    sum(decode(page_mode,''D'',1,''C'',1,0)) dynamic_views,',
'    avg(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_avg,',
'    min(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_min,',
'    max(decode(page_mode,''D'',elap,''C'',elap,null)) dynamic_views_max,',
'    sum(decode(page_mode,''R'',1,0)) cached_views,',
'    avg(decode(page_mode,''R'',elap,null)) cached_views_avg,',
'    min(decode(page_mode,''R'',elap,null)) cached_views_min,',
'    max(decode(page_mode,''R'',elap,null)) cached_views_max',
'from WWV_FLOW_ACTIVITY_LOG',
'where security_group_id = :flow_security_group_id and ',
'      time_stamp >= sysdate - nvl(:p67_time,1) and',
'      (:p67_user is null or instr(userid,upper(:p67_user)) > 0 ) and',
'      (:p67_flow is null or flow_id = :p67_flow) and',
'      (:flow_security_group_id = 10 or flow_id not between 4000 and 4999)',
'group by flow_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(6659715068668103)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_item=>'P67_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_comment=>'generated 29-NOV-2002 09:59:34'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231652312962355827)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231651421644355826)
,p_query_column_id=>2
,p_column_alias=>'COUNT(*)'
,p_column_display_sequence=>2
,p_column_heading=>'Views'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231651531679355826)
,p_query_column_id=>3
,p_column_alias=>'DYNAMIC_VIEWS'
,p_column_display_sequence=>3
,p_column_heading=>'Dynamic Views'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231651603288355826)
,p_query_column_id=>4
,p_column_alias=>'DYNAMIC_VIEWS_AVG'
,p_column_display_sequence=>4
,p_column_heading=>'Average'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231651728696355826)
,p_query_column_id=>5
,p_column_alias=>'DYNAMIC_VIEWS_MIN'
,p_column_display_sequence=>5
,p_column_heading=>'Minimum'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231651801794355827)
,p_query_column_id=>6
,p_column_alias=>'DYNAMIC_VIEWS_MAX'
,p_column_display_sequence=>6
,p_column_heading=>'Maximum'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231651918587355827)
,p_query_column_id=>7
,p_column_alias=>'CACHED_VIEWS'
,p_column_display_sequence=>7
,p_column_heading=>'Cached Views'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231652014723355827)
,p_query_column_id=>8
,p_column_alias=>'CACHED_VIEWS_AVG'
,p_column_display_sequence=>8
,p_column_heading=>'Average'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231652119430355827)
,p_query_column_id=>9
,p_column_alias=>'CACHED_VIEWS_MIN'
,p_column_display_sequence=>9
,p_column_heading=>'Minimum'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(231652206725355827)
,p_query_column_id=>10
,p_column_alias=>'CACHED_VIEWS_MAX'
,p_column_display_sequence=>10
,p_column_heading=>'Maximum'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(231652725358355828)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(231655430238355834)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(231652725358355828)
,p_button_name=>'P67_GO'
,p_button_static_id=>'P67_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(231656209964355838)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231652925714355829)
,p_name=>'P67_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(231652725358355828)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select the timeframe for the search.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231653429287355830)
,p_name=>'P67_USER'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(231652725358355828)
,p_prompt=>'User'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'To filter by user, enter a username and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231653924321355831)
,p_name=>'P67_FLOW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(231652725358355828)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'To filter by application, enter an application ID and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231654901550355833)
,p_name=>'P67_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(231652725358355828)
,p_item_default=>'15'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,50,100,200,500,1000,5000'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the number of rows to display and click <strong>Go</strong>.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231655810439355835)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P67_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_associated_item=>wwv_flow_imp.id(231653924321355831)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231655612507355834)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P67_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_associated_item=>wwv_flow_imp.id(231654413812355832)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(231656019846355836)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>231656019846355836
);
end;
/
prompt --application/pages/page_00068
begin
wwv_flow_imp_page.create_page(
 p_id=>68
,p_name=>'change password'
,p_alias=>'CHANGE-PASSWORD1'
,p_step_title=>'Change Password'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_javascript_code_onload=>'$("#P68_CONFIRM_PASSWORD_CONTAINER .a-Login-iconValidation.icon-check").attr("id","confirm_check");'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.password-heading,',
'.password-desc {',
'    padding: 0 8px;',
'    font-size: 14px;',
'    line-height: 1.5;',
'}',
'',
'.password-desc {',
'    opacity: 0.85;',
'    font-size: 12px;',
'}',
'.password-region {',
'    margin-bottom: 8px;',
'}',
'.a-Login-body .password-region .a-Form-inputContainer {',
'    padding-bottom: 8px;',
'}'))
,p_step_template=>wwv_flow_imp.id(797616476051845768)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_protection_level=>'C'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8156126956870309)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_PASSWORD := null;',
':P68_CONFIRM_PASSWORD := null;',
':P68_ENTER_CURRENT_PASSWORD := null;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8156307899870309)
,p_plug_name=>'Change Password'
,p_region_css_classes=>'a-Form--stretchInputs'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797573769515479165)
,p_plug_display_sequence=>14
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'CONFIRM'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2367803431541201)
,p_plug_name=>'Workspace Password'
,p_parent_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_region_css_classes=>'password-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>125
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P68_USER_SGID is not null and nvl(:P68_DB_USER_EXISTS,''N'') = ''N'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2367991743541202)
,p_plug_name=>'Database Password'
,p_parent_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_region_css_classes=>'password-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>135
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2 class="password-heading">Database Password</h2>',
'<p class="password-desc">You will use this password to connect to the database.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB''',
'    and nvl(:P68_IS_END_USER,''N'') = ''N'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2368400006541207)
,p_plug_name=>'Workspace Password Text'
,p_parent_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>115
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2 class="password-heading">APEX Workspace Password</h2>',
'<p class="password-desc">You will use this password to sign in to the APEX workspace.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB''',
'and :P68_ASK_CURRENT = ''N'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2368578094541208)
,p_plug_name=>'User Exists Message'
,p_parent_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>85
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2 class="password-heading">APEX Workspace Password</h2>',
'<p class="password-desc">This user is already associated with another APEX workspace. Please enter your existing workspace password.</p>',
'',
''))
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P68_DB_USER_EXISTS'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2368622454541209)
,p_plug_name=>'Current Password Container'
,p_parent_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>95
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P68_DB_USER_EXISTS'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620834693002373109)
,p_plug_name=>'Restricted End User Access'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_region_attributes=>'style="width:auto;"'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>&P68_USER_NAME., since you are not a developer in this workspace, you can only change your password on this page.</p>'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P68_IS_END_USER'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8156708906870311)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_button_name=>'Save'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Change Password'
,p_button_position=>'NEXT'
,p_button_condition=>'P68_USER_SGID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(620834709155373110)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_button_name=>'RETURN_TO_LOGIN'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Return to Sign In Page'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4550:1:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1602772543242503)
,p_name=>'P68_DB_USER_EXISTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1603040805242506)
,p_name=>'P68_WKSP_SCHEMA'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1604042953242516)
,p_name=>'P68_WKSP_PASSWORD'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2367991743541202)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Database Password'
,p_placeholder=>'Database Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(797617751200847238)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1604113800242517)
,p_name=>'P68_WKSP_CONFIRM_PASSWORD'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2367991743541202)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Confirm Database Password'
,p_placeholder=>'Confirm Database Password'
,p_post_element_text=>'<span class="a-Login-iconValidation a-Icon icon-error is-danger confirm-error"></span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(797617751200847238)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8157104633870312)
,p_name=>'P68_USER_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_css_classes=>'u-textLower'
,p_tag_attributes=>'autocomplete="username"'
,p_display_when=>'P68_USER_SGID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(797617751200847238)
,p_item_css_classes=>'icon-login-username'
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8157624556870314)
,p_name=>'P68_PASSWORD'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2367803431541201)
,p_use_cache_before_default=>'NO'
,p_prompt=>'New Password'
,p_placeholder=>'New Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(797617751200847238)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Test'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8158108037870314)
,p_name=>'P68_CONFIRM_PASSWORD'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2367803431541201)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Confirm Password'
,p_placeholder=>'Confirm Password'
,p_post_element_text=>'<span class="a-Login-iconValidation a-Icon icon-error is-danger confirm-error"></span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(797617751200847238)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8158623021870315)
,p_name=>'P68_ENTER_CURRENT_PASSWORD'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2368622454541209)
,p_prompt=>'Current Password'
,p_placeholder=>'Current Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="current-password"'
,p_display_when=>':P68_ASK_CURRENT = ''Y'' or nvl(:P68_DB_USER_EXISTS,''N'') = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(797617751200847238)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12371025948321672)
,p_name=>'P68_USER_SGID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(620834876264373111)
,p_name=>'P68_IS_END_USER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1617424838043257710)
,p_name=>'P68_ASK_CURRENT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1617425085874257712)
,p_name=>'P68_USER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8156307899870309)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(492140308650710920)
,p_validation_name=>'P68_USER_NAME'
,p_validation_sequence=>1
,p_validation=>'P68_USER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Your Username is not available. Please close your browser completely. After restarting your browser, your Username should be displayed correctly.'
,p_when_button_pressed=>wwv_flow_imp.id(8156708906870311)
,p_associated_item=>wwv_flow_imp.id(8157104633870312)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8159816351870318)
,p_validation_name=>'passwd = confirm passwd'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P68_PASSWORD != :P68_CONFIRM_PASSWORD then',
'  :P68_PASSWORD := null;',
'  :P68_CONFIRM_PASSWORD := null;',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Confirmation password does not match password.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_PASSWORD is not null and :P68_CONFIRM_PASSWORD is not null',
'and :REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8158108037870314)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1605913054242535)
,p_validation_name=>'wksp passwd = confirm wksp passw'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P68_WKSP_PASSWORD != :P68_WKSP_CONFIRM_PASSWORD then',
'  :P68_WKSP_PASSWORD := null;',
'  :P68_WKSP_CONFIRM_PASSWORD := null;',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Confirmation password does not match password.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_WKSP_PASSWORD is not null and :P68_WKSP_CONFIRM_PASSWORD is not null',
'and :REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1604113800242517)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8160202229870318)
,p_validation_name=>'Validate Current Password'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P68_DB_USER_EXISTS,''N'') = ''N'' then',
'    return wwv_flow_security.is_workspace_password_valid (',
'               p_workspace_id => :P68_USER_SGID,',
'               p_username     => :P68_USER_NAME,',
'               p_password     => :P68_ENTER_CURRENT_PASSWORD );',
'else',
'    begin',
'        return sys.wwv_flow_val.verify_user (',
'                   username => :P68_USER_NAME,',
'                   password =>  :P68_ENTER_CURRENT_PASSWORD ) = sys.wwv_flow_val.valid_user;',
'    exception when others then',
'        return false;',
'    end;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid Password'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_ENTER_CURRENT_PASSWORD is not null',
'and :REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'')',
'and :P68_ASK_CURRENT = ''Y'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8158623021870315)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25683811693736222)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_workspace_name   varchar2(4000) := wwv_flow_security.find_company_name(:P68_USER_SGID);',
'  l_use_strong_rules boolean;',
'begin',
'  l_use_strong_rules := nvl(wwv_flow_platform.get_preference(''STRONG_SITE_ADMIN_PASSWORD''),''N'') = ''Y''',
'                        and l_workspace_name = ''INTERNAL'';',
'  return wwv_flow_security.strong_password_validation (',
'      p_username              => :P68_USER_NAME,',
'      p_password              => :P68_PASSWORD,',
'      p_old_password          => :P68_ENTER_CURRENT_PASSWORD,',
'      p_workspace_name        => l_workspace_name,',
'      p_use_strong_rules      => l_use_strong_rules );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'') and nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''APEX'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1604451430242520)
,p_validation_name=>'Validate DB Password'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.password_validation(',
'           p_username => :P68_USER_NAME,',
'           p_password => :P68_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The password does not conform to the database password complexity rules.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB'' ',
'and :P68_DB_USER_EXISTS = ''N'' and :P68_PASSWORD is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(8156708906870311)
,p_associated_item=>wwv_flow_imp.id(8157624556870314)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1604608871242522)
,p_validation_name=>'Validate WKSP Password'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.password_validation(',
'           p_username => :P68_USER_NAME,',
'           p_password => :P68_WKSP_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The password does not conform to the database password complexity rules.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB''',
'and :P68_WKSP_PASSWORD is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(8156708906870311)
,p_associated_item=>wwv_flow_imp.id(1604042953242516)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(374506600102087826)
,p_name=>'New Password Match'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P68_CONFIRM_PASSWORD,P68_PASSWORD'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keyup'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1805352665551104)
,p_event_id=>wwv_flow_imp.id(374506600102087826)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( $("#P68_CONFIRM_PASSWORD").val() === $("#P68_PASSWORD").val() ) {',
'    $("#P68_CONFIRM_PASSWORD_CONTAINER .icon-check").show();',
'    $("#P68_CONFIRM_PASSWORD_CONTAINER .confirm-error").hide();',
'    $("#P68_CONFIRM_PASSWORD").attr("aria-invalid","false");',
'} else {',
'    $("#P68_CONFIRM_PASSWORD_CONTAINER .icon-check").hide();',
'    $("#P68_CONFIRM_PASSWORD_CONTAINER .confirm-error").show();',
'    $("#P68_CONFIRM_PASSWORD").attr("aria-invalid","true");',
'}',
'',
'// when confirm password is empty, set aria-invalid to false',
'// to provide same behaviour for both visual and screen reader users',
'if ( $("#P68_CONFIRM_PASSWORD").val() === "" ){',
'    $("#P68_CONFIRM_PASSWORD").attr("aria-invalid","false");    ',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2368102391541204)
,p_name=>'Workspace Password Match'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P68_WKSP_CONFIRM_PASSWORD,P68_WKSP_PASSWORD'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keyup'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2368288449541205)
,p_event_id=>wwv_flow_imp.id(2368102391541204)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( $("#P68_WKSP_CONFIRM_PASSWORD").val() === $("#P68_WKSP_PASSWORD").val() ) {',
'    $("#P68_WKSP_CONFIRM_PASSWORD_CONTAINER .icon-check").show();',
'    $("#P68_WKSP_CONFIRM_PASSWORD_CONTAINER .confirm-error").hide();',
'    $("#P68_WKSP_CONFIRM_PASSWORD").attr("aria-invalid","false");',
'} else {',
'    $("#P68_WKSP_CONFIRM_PASSWORD_CONTAINER .icon-check").hide();',
'    $("#P68_WKSP_CONFIRM_PASSWORD_CONTAINER .confirm-error").show();',
'    $("#P68_WKSP_CONFIRM_PASSWORD").attr("aria-invalid","true");',
'}',
'',
'// when confirm password is empty, set aria-invalid to false',
'// to provide same behaviour for both visual and screen reader users',
'if ( $("#P68_WKSP_CONFIRM_PASSWORD").val() === "" ){',
'    $("#P68_WKSP_CONFIRM_PASSWORD").attr("aria-invalid","false");    ',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8160323013870319)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change password'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_login.change_password_and_log_in (',
'    p_workspace_id => :P68_USER_SGID,',
'    p_username     => :P68_USER_NAME,',
'    p_new_password => :P68_PASSWORD );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing password.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_PASSWORD = :P68_CONFIRM_PASSWORD ',
'and :REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'')',
'and nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') <> ''DB'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Password changed.'
,p_internal_uid=>8160323013870319
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1604755858242523)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'DB User Management'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_username_asserted varchar2(4000) := wwv_flow_assert.enquote_name(:P68_USER_NAME);',
'    l_password_asserted varchar2(4000) := wwv_flow_assert.enquote_name(:P68_PASSWORD);',
'    l_wkspsch_asserted  varchar2(4000) := wwv_flow_assert.enquote_name(:P68_WKSP_SCHEMA);',
'    l_wksppass_asserted varchar2(4000) := wwv_flow_assert.enquote_name(:P68_WKSP_PASSWORD);',
'    l_sql               varchar2(32767);',
'begin',
'    --',
'    -- When the DB user does not yet exist   ',
'    --',
'    if :P68_DB_USER_EXISTS = ''N'' then',
'',
'        l_sql := ''create user ''||l_username_asserted||'' identified by ''||l_password_asserted;',
'',
'        execute immediate l_sql;',
'',
'    end if;',
'',
'    --',
'    --Modify workspace user password     ',
'    --',
'    l_sql := ''alter user ''||l_wkspsch_asserted||'' identified by ''||l_wksppass_asserted;',
'',
'    execute immediate l_sql;',
'',
'    wwv_flow_login.change_password_and_log_in (',
'        p_workspace_id => :P68_USER_SGID,',
'        p_username     => :P68_USER_NAME,',
'        p_new_password => nvl(:P68_PASSWORD, :P68_ENTER_CURRENT_PASSWORD) );',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing password.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P68_WKSP_PASSWORD = :P68_WKSP_CONFIRM_PASSWORD',
'and :REQUEST in (''P68_CONFIRM_PASSWORD'',''Save'',''P68_WKSP_PASSWORD'')',
'and nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB''',
'and nvl(:P68_IS_END_USER,''N'') = ''N'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Password changed.'
,p_internal_uid=>1604755858242523
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1617424418589257706)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Is End User'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_user in ( select user_name,',
'                       security_group_id',
'                  from wwv_flow_fnd_user',
'                 where user_id = :P68_USER_ID )',
'loop',
'    :P68_USER_SGID   := l_user.security_group_id;',
'    :P68_USER_NAME   := l_user.user_name;',
'    :P68_IS_END_USER := case',
'                        when l_user.security_group_id=''10'' then ''N'' /*instance admin*/',
'                        when wwv_flow_fnd_user_int.get_user_roles (',
'                                 p_security_group_id => l_user.security_group_id,',
'                                 p_username          => l_user.user_name ) is null',
'                        then ''Y''',
'                        else ''N''',
'                        end;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid User Code'
,p_process_when=>'P68_USER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>1617424418589257706
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1602801574242504)
,p_process_sequence=>25
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Is DB User'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cnt number := 0;',
'begin',
'    select count(*) into l_cnt',
'      from sys.dba_users',
'     where username = :P68_USER_NAME;',
'',
'    if l_cnt = 0 then ',
'        :P68_DB_USER_EXISTS := ''N'';',
'    else',
'        :P68_DB_USER_EXISTS := ''Y'';',
'        :P68_ASK_CURRENT := ''Y'';',
'    end if;',
'',
'    for c1 in (select first_schema_provisioned ',
'                 from wwv_flow_companies',
'                where provisioning_company_id = :P68_USER_SGID ) loop',
'        :P68_WKSP_SCHEMA := c1.first_schema_provisioned;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1602801574242504
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12359720551314582)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set notification'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P68_IS_END_USER = ''N'' and nvl(:REQUEST,''xy5993-'') <> ''CONFIRM'' then ',
'    if nvl(:P68_DB_USER_EXISTS,''N'') = ''N'' then',
'        wwv_flow.g_notification := wwv_flow_lang.system_message(''PASSWORD_MUST_BE_CHANGED'');',
'    else',
'        wwv_flow.g_notification := wwv_flow_lang.system_message(''4350_P68_CURRENT_PWD'');',
'    end if;',
'',
'    if nvl(wwv_flow_platform.get_preference(''APEX_BUILDER_AUTHENTICATION''), ''APEX'') = ''DB'' then',
'        wwv_flow.g_notification :=  wwv_flow.g_notification ||'' ''||wwv_flow_lang.system_message(''4350_WKSP_PASSWORD'');',
'    end if;',
'',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>12359720551314582
);
end;
/
prompt --application/pages/page_00069
begin
wwv_flow_imp_page.create_page(
 p_id=>69
,p_name=>'Request Storage - Confirm'
,p_alias=>'REQUEST-STORAGE-CONFIRM'
,p_step_title=>'Request Storage - Confirm'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215667724760013351)
,p_step_template=>wwv_flow_imp.id(718401914085176458)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47302007175663547)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720186138525572350)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(47297014014256767)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(720190141563578035)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47302213587663566)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(47296115483238304)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47305100924725759)
,p_plug_name=>'Request Storage'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Please confirm your request.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208565622723362124)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752113900410695875)
,p_plug_name=>'Request Storage'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720159283194358177)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47307221272750562)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208565622723362124)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47303014767663580)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208565622723362124)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47303213706663589)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208565622723362124)
,p_button_name=>'ADJUST_STORAGE_SIZE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Request Storage'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47304431358663641)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47303412447663590)
,p_name=>'P69_STORAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47305100924725759)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''C''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Amount of storage to add (MB):'
,p_source=>'&P49_STORAGE.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the amount of space which will be required.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47304023468663624)
,p_validation_name=>'Validate storage request size'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'   and display = ''Y''',
'   and req_size = :P49_STORAGE'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Invalid storage amount requested.'
,p_when_button_pressed=>wwv_flow_imp.id(47303213706663589)
,p_associated_item=>wwv_flow_imp.id(47303412447663590)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(47304116019663631)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'request change of size'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_changesize  number := :P49_STORAGE;',
'begin',
'  wwv_flow_provisioning.make_modification_request (',
'      p_service_name        => ''CHANGE_DB_SIZE'',',
'      p_service_attribute_1 => l_changesize,',
'      p_service_attribute_2 => wwv_flow_user_api.get_email(p_username => upper(wwv_flow.g_user)));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error requesting additional storage.'
,p_process_when_button_id=>wwv_flow_imp.id(47303213706663589)
,p_process_success_message=>'You have requested an additional &P49_STORAGE. MB of storage.'
,p_security_scheme=>wwv_flow_imp.id(916538108136873611)
,p_internal_uid=>47304116019663631
);
end;
/
prompt --application/pages/page_00070
begin
wwv_flow_imp_page.create_page(
 p_id=>70
,p_name=>'Login Attempts'
,p_alias=>'LOGIN-ATTEMPTS'
,p_step_title=>'Login Attempts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12733116132664461)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(450591815485785448)
,p_plug_name=>'Logins'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P70a */',
'upper(login_name) login_name,',
'application,',
'owner,',
'decode(authentication_method,''FND_ACCOUNT'',v(''PRODUCT_NAME''),',
'  ''CUSTOM'',wwv_flow_lang.system_message(''CUSTOM_AUTH_SCHEME_DESC''),',
'  ''$SITE_INTERNAL$'',wwv_flow_lang.system_message(''SERVICE_LOGIN''),',
'  ''$WORKSPACE_INTERNAL$'',wwv_flow_lang.system_message(''WORKSPACE_LOGIN''),',
'  ''DB ACCOUNT'',wwv_flow_lang.system_message(''DBACCOUNT_AUTH_SCHEME_DESC''),',
'  ''LDAP'',wwv_flow_lang.system_message(''LDAP_AUTH_SCHEME_DESC''),',
'   authentication_method) authentication_method,',
' access_date,',
'access_date access_date2,',
' ip_address,',
' remote_user,',
'decode(nvl(authentication_result,0),',
'0,m.AUTH_SUCCESS,',
'1,m.AUTH_UNKNOWN_USER,',
'2,m.AUTH_ACCOUNT_LOCKED,',
'3,m.AUTH_ACCOUNT_EXPIRED,',
'4,m.AUTH_PASSWORD_INCORRECT,',
'5,m.AUTH_PASSWORD_FIRST_USE,',
'6,m.AUTH_ATTEMPTS_EXCEEDED,',
'7,m.AUTH_INTERNAL_ERROR,',
'authentication_result) authentication_result,',
'custom_status_text,',
'authentication_result authentication_result_code',
'from   wwv_flow_user_access_log_v l,',
'(select',
'wwv_flow_lang.system_message(''AUTH_SUCCESS'') auth_success,',
'wwv_flow_lang.system_message(''AUTH_UNKNOWN_USER'') auth_unknown_user,',
'wwv_flow_lang.system_message(''AUTH_ACCOUNT_LOCKED'') auth_account_locked,',
'wwv_flow_lang.system_message(''AUTH_ACCOUNT_EXPIRED'') auth_account_expired,',
'wwv_flow_lang.system_message(''AUTH_PASSWORD_INCORRECT'') auth_password_incorrect,',
'wwv_flow_lang.system_message(''AUTH_PASSWORD_FIRST_USE'') auth_password_first_use,',
'wwv_flow_lang.system_message(''AUTH_ATTEMPTS_EXCEEDED'') auth_attempts_exceeded,',
'wwv_flow_lang.system_message(''AUTH_INTERNAL_ERROR'') auth_internal_error',
'from dual) m',
'where  security_group_id = :flow_security_group_id',
'and access_date >= sysdate - nvl(:p70_time,1)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'This report shows the recent logins to applications in this workspace . All end user logins to applications that use the &PRODUCT_NAME. login API in their authentication scheme are logged.'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(450591914456785448)
,p_name=>'Logins'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450592121502785460)
,p_db_column_name=>'LOGIN_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450592213656785462)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450592331673785463)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Application<br />Owner'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450592401150785464)
,p_db_column_name=>'AUTHENTICATION_METHOD'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Authentication<br />Method'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450592509011785465)
,p_db_column_name=>'ACCESS_DATE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Login Date'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450592622993785466)
,p_db_column_name=>'ACCESS_DATE2'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Login Time'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450592915591785469)
,p_db_column_name=>'AUTHENTICATION_RESULT'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Authentication Result'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450592722758785467)
,p_db_column_name=>'IP_ADDRESS'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'IP Address'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450593010180785469)
,p_db_column_name=>'CUSTOM_STATUS_TEXT'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Custom<br />Status'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450592816468785468)
,p_db_column_name=>'REMOTE_USER'
,p_display_order=>10
,p_column_identifier=>'H'
,p_column_label=>'Session<br />User'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340735915925751020)
,p_db_column_name=>'AUTHENTICATION_RESULT_CODE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Authentication Result Code'
,p_display_in_default_rpt=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(450593613404789820)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310428154536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOGIN_NAME:APPLICATION:AUTHENTICATION_METHOD:ACCESS_DATE:ACCESS_DATE2:AUTHENTICATION_RESULT:IP_ADDRESS:CUSTOM_STATUS_TEXT:AUTHENTICATION_RESULT_CODE'
,p_sort_column_1=>'ACCESS_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'LOGIN_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12734905755664463)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(12733116132664461)
,p_button_name=>'P70_GO'
,p_button_static_id=>'P70_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450595927040803209)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(12733116132664461)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42735601566885113)
,p_name=>'P70_TIME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12733116132664461)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00071
begin
wwv_flow_imp_page.create_page(
 p_id=>71
,p_name=>'Developer Activity Dashboard'
,p_alias=>'DEVELOPER-ACTIVITY-DASHBOARD'
,p_step_title=>'Developer Activity Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47329131074632655)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47329309079632659)
,p_name=>'Top Pages'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P71c */ application||'':''||page_id||'' - ''||',
'       substr((select name ',
'               from wwv_flow_steps ',
'               where flow_id = q.application and id = q.page_id and security_group_id = :flow_security_group_id),1,20)',
'       application_page, ',
'       page_events',
'from (',
'select ',
'  flow_id application,',
'  page_id page_id,',
'  count(*) page_events',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id and',
'  flow_id is not null and',
'  page_id is not null',
'group by ',
'  flow_id, page_id',
'order by count(*) desc) q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47337230207807503)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_PAGE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47337328266807503)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47329800292632669)
,p_name=>'Recent Changes'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX4350P71d */ lower(substr(developer,1,35)) developer,',
'       audit_date',
'from (',
'select ',
'  flow_id||'':''||page_id||'' - ''||flow_user developer,',
'  audit_date ',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id',
'order by audit_date desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47329800292632669)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47338028869835547)
,p_query_column_id=>1
,p_column_alias=>'DEVELOPER'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47338100649835547)
,p_query_column_id=>2
,p_column_alias=>'AUDIT_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47330216560632671)
,p_name=>'Top Applications'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P71b */ application||'': ''||',
'       substr((select name from wwv_flows where id = q.application and security_group_id = :flow_security_group_id),1,20)',
'       application, ',
'       page_events',
'from (',
'select ',
'  flow_id application,',
'  count(*) page_events',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id and',
'  flow_id is not null',
'group by ',
'  flow_id',
'order by count(*) desc) q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47330216560632671)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47330424910632671)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47330518229632671)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47330824997632672)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47331015612632673)
,p_name=>'Top Developers'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P71a */  lower(substr(developer,1,25)) developer,',
'       page_events events',
'from (',
'select ',
'  flow_user developer,',
'  count(*) page_events',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id and',
'  flow_user is not null',
'group by ',
'  flow_user',
'order by count(*) desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47335420286738415)
,p_query_column_id=>1
,p_column_alias=>'DEVELOPER'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47337022804795953)
,p_query_column_id=>2
,p_column_alias=>'EVENTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47331502407632675)
,p_name=>'Recent Applications Edits'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>70
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(application||'': ''||',
'       substr((select name from wwv_flows where id = q.application),1,40),',
'       1,35)',
'       application, ',
'       audit_date',
'from (',
'select ',
'  flow_id application,',
'  max(audit_date) audit_date',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - nvl(:P71_TIME,.125) and ',
'  security_group_id = :flow_security_group_id',
'group by',
'   flow_id',
'order by 2 desc) q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47331502407632675)
,p_plug_column_width=>' apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47338609738848986)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47338704519848986)
,p_query_column_id=>2
,p_column_alias=>'AUDIT_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47345001407045172)
,p_plug_name=>'Developer Activity'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:99%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>View a summary of developer application and page changes for the selected timeframe.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168426205915602709)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47329131074632655)
,p_button_name=>'MONITOR_ACTIVITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Monitor Activity'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47332605505632683)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47329131074632655)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47333103023632698)
,p_branch_action=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47332823415632688)
,p_name=>'P71_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47329131074632655)
,p_prompt=>'Show'
,p_source=>'select  3/24  t from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the reporting timeframe.  Longer timeframes may take longer to display.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00072
begin
wwv_flow_imp_page.create_page(
 p_id=>72
,p_name=>'Workspace Schemas'
,p_alias=>'WORKSPACE-SCHEMAS'
,p_step_title=>'Workspace Schemas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215677404159045218)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4926714172433408)
,p_plug_name=>'Workspace Schemas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Your workspace has the privilege to parse SQL statements using the following database schemas. Note that the terms database schema and database user can be used interchangeably.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47080910170530643)
,p_plug_name=>'Workspace Schemas'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P72a */',
'    schema,',
'    (select count(*) from sys.dba_sys_privs where grantee = c.schema) privs,',
'    (select count(*) from wwv_flows ',
'     where security_group_id = :flow_security_group_id and ',
'     owner = c.schema) flows',
'from WWV_FLOW_COMPANY_SCHEMAS c',
'where security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Workspace Schemas'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47081002154530643)
,p_name=>'Workspace Schemas'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47081224767530656)
,p_db_column_name=>'SCHEMA'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47081323558530662)
,p_db_column_name=>'PRIVS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'DB Privileges'
,p_column_link=>'f?p=&FLOW_ID.:86:#FLOW_SESSION#:::RP:P86_SCHEMA:#SCHEMA#'
,p_column_linktext=>'#PRIVS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47081404348530663)
,p_db_column_name=>'FLOWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47081622180530933)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310512221536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SCHEMA:PRIVS:FLOWS'
,p_sort_column_1=>'SCHEMA'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4910310827337046)
,p_branch_action=>'72'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00073
begin
wwv_flow_imp_page.create_page(
 p_id=>73
,p_name=>'Recent Page Views Faceted Search'
,p_alias=>'RECENT-PAGE-VIEWS-FACETED-SEARCH'
,p_step_title=>'Recent Page Views Faceted Search'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(383691245467261189)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(392834092731162901)
,p_name=>'Recent Page Views'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>24
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /*+ FIRST_ROWS(21) */',
'    time_stamp,',
'    elap *1000 milliseconds,',
'    num_rows query_rows,',
'    userid userid, ',
'    (select id||''. ''||name from wwv_flows where id = l.flow_id) application_name,',
'    (select id||''. ''||name from wwv_flow_steps where id = l.step_id and flow_id = l.flow_id) page_name,',
'    decode(sqlerrm,null,m.m_NO,m.m_YES) error_raised,',
'      case l.page_view_type',
'         when 0 then m.m_other',
'         when 1 then m.m_processing',
'         when 2 then m.m_rendering',
'         when 3 then m.m_ajax',
'         when 4 then m.m_logout',
'         when 5 then m.auth_callback',
'         end   page_view_type,',
'    case WHEN elap * 1000 >= 10000 then ''> 10 ''||m.m_seconds',
'            WHEN elap * 1000 >= 5000 then ''5 - 10 ''||m.m_seconds',
'            WHEN elap * 1000 >= 2000 then ''2 - 5 ''||m.m_seconds',
'            WHEN elap * 1000 >= 1000 then ''1 - 2 ''||m.m_seconds',
'            WHEN elap * 1000 >= 750  then ''750 - 1000 ''||m.m_ms',
'            WHEN elap * 1000 >= 500  then ''500 - 750 ''||m.m_ms',
'            WHEN elap * 1000 >= 250  then ''250 - 500 ''||m.m_ms',
'            WHEN elap * 1000 >= 100  then ''100 - 250 ''||m.m_ms',
'            WHEN elap * 1000 >= 50   then ''50 - 100 ''||m.m_ms',
'            else ''< 50 ''||m.m_ms end performance_bucket,',
'    case when time_stamp >= sysdate - (1/24) then ''< 1 ''||m.m_hour',
'            when time_stamp >= sysdate - (1/12) then ''1 - 2 ''||m.m_hours',
'            when time_stamp >= sysdate - (1/3)  then ''2 - 8 ''||m.m_hours',
'            when time_stamp >= sysdate - 1      then ''8 - 24 ''||m.m_hours',
'            when time_stamp >= sysdate - 2      then ''1 - 2 ''||m.m_days',
'            when time_stamp >= sysdate - 7      then ''2 - 7 ''||m.m_days',
'            else ''> 7 ''||m.m_days end timeframe_bucket,',
'     sqlerrm',
'from WWV_FLOW_ACTIVITY_LOG l,',
'   (select wwv_flow_lang.system_message(''SECONDS'') m_seconds,',
'           wwv_flow_lang.system_message(''HOURS'') m_hours,',
'           wwv_flow_lang.system_message(''HOUR'') m_hour,',
'           wwv_flow_lang.system_message(''DAYS'') m_days,',
'           wwv_flow_lang.system_message(''F4350_AJAX'') m_ajax,',
'           wwv_flow_lang.system_message(''PE.PROPERTY.CHART_RENDERING.PROMPT'') m_rendering,',
'           wwv_flow_lang.system_message(''PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'') m_processing,',
'           wwv_flow_lang.system_message(''WWV_FLOW.LOGOUT'') m_logout,',
'           wwv_flow_lang.system_message(''F4350_AUTHENTICATION_CALLBACK'') auth_callback,',
'           wwv_flow_lang.system_message(''NO'') m_NO,',
'           wwv_flow_lang.system_message(''YES'') m_YES,',
'           wwv_flow_lang.system_message(''OTHER'') m_other,',
'           wwv_flow_lang.system_message(''MILLISECONDS_MS'') m_ms',
'    from dual) m',
'where security_group_id = :WORKSPACE_ID and ',
'      --flow_id not between 4000 and 4999 and',
'      time_stamp > sysdate - 7'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916432889655196610)
,p_query_column_id=>1
,p_column_alias=>'TIME_STAMP'
,p_column_display_sequence=>1
,p_column_heading=>'Time Stamp'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916435386992196635)
,p_query_column_id=>2
,p_column_alias=>'MILLISECONDS'
,p_column_display_sequence=>5
,p_column_heading=>'Time (ms)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916433073859196612)
,p_query_column_id=>3
,p_column_alias=>'QUERY_ROWS'
,p_column_display_sequence=>9
,p_column_heading=>'Query Rows'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916433140709196613)
,p_query_column_id=>4
,p_column_alias=>'USERID'
,p_column_display_sequence=>2
,p_column_heading=>'User'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916433325586196615)
,p_query_column_id=>5
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916433464429196616)
,p_query_column_id=>6
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916435474183196636)
,p_query_column_id=>7
,p_column_alias=>'ERROR_RAISED'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916436739682196649)
,p_query_column_id=>8
,p_column_alias=>'PAGE_VIEW_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916436212110196644)
,p_query_column_id=>9
,p_column_alias=>'PERFORMANCE_BUCKET'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916436397298196645)
,p_query_column_id=>10
,p_column_alias=>'TIMEFRAME_BUCKET'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(916436574370196647)
,p_query_column_id=>11
,p_column_alias=>'SQLERRM'
,p_column_display_sequence=>11
,p_column_heading=>'Error Message'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(793348069796898716)
,p_plug_name=>'Report Actions'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(916435595575196637)
,p_plug_name=>'Search'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(392834092731162901)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'current_facets_selector', '#active_facets',
  'show_charts', 'N',
  'show_current_facets', 'E',
  'show_total_row_count', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(397462569634814101)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(793348069796898716)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:RR,73::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(383554456377757409)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(916435693556196638)
,p_name=>'P73_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(916435595575196637)
,p_prompt=>'Search'
,p_source=>'USERID,APPLICATION_NAME,PAGE_NAME,PAGE_VIEW_TYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_filter_values=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(916435751364196639)
,p_name=>'P73_PAGE_VIEW_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(916435595575196637)
,p_prompt=>'Type'
,p_source=>'PAGE_VIEW_TYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(916435948347196641)
,p_name=>'P73_APPLICATION_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(916435595575196637)
,p_prompt=>'Application'
,p_source=>'APPLICATION_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(916436002720196642)
,p_name=>'P73_USERID'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(916435595575196637)
,p_prompt=>'User'
,p_source=>'USERID'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(916436197252196643)
,p_name=>'P73_ERROR_RAISED'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(916435595575196637)
,p_prompt=>'Error Raised'
,p_source=>'ERROR_RAISED'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(916436433845196646)
,p_name=>'P73_PERFORMANCE_BUCKET'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(916435595575196637)
,p_prompt=>'Performance'
,p_source=>'PERFORMANCE_BUCKET'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(383553283775757406)
,p_validation_name=>'flows is numeric'
,p_validation_sequence=>10
,p_validation=>'P73_FLOW'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(383553612865757408)
,p_validation_name=>'page is numeric'
,p_validation_sequence=>20
,p_validation=>'P73_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(383553973273757408)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>383553973273757408
);
end;
/
prompt --application/pages/page_00074
begin
wwv_flow_imp_page.create_page(
 p_id=>74
,p_name=>'Page Views By Day Report'
,p_alias=>'DAILY_USAGE'
,p_step_title=>'Page Views By Day Report'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9414725804303289)
,p_plug_name=>'Daily Usage '
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P74a */',
'       the_date,',
'       to_char(the_date,''YYYYMMDD'') passable_date,',
'       to_char(the_date,''Day'') day_of_week,',
'       to_number(to_char(the_date,''D'')) day_of_week_numeric,',
'       to_char(the_date,''Month'') month,',
'       flows applications,',
'       users users,',
'       avg_time,',
'       max_time,',
'       graph pct_of_total,',
'       cached_regions cached_region_views,',
'       cached_pages cached_page_views,',
'       hits page_events,',
'       page_views,',
'       page_posts,',
'       sessions,',
'       ip_addresses,',
'       content_length',
'from (',
'select ',
'  trunc(time_stamp) the_date,',
'  count(1) hits,',
'  sum(decode(page_mode,''A'',1,0)) page_posts,',
'  sum(decode(page_mode,''A'',0,1)) page_views,',
'  count(distinct l.FLOW_ID) flows,',
'  count(distinct l.USERID) users,',
'  count(distinct l.session_id) sessions,',
'  count(distinct l.ip_address) ip_addresses,',
'  avg(l.ELAP) avg_time,',
'  max(l.ELAP) max_time,',
'  ceil(greatest(trunc(100*to_number(count(1)))/nvl(l2.total_hits,1))) graph,',
'  sum(cached_regions) cached_regions,',
'  sum(decode(page_mode,''R'',1,0)) cached_pages,',
'  sum(nvl(content_length,0)) content_length',
'from wwv_flow_activity_log l, ',
'   ( select count(1) total_hits ',
'     from   wwv_flow_activity_log ',
'     where time_stamp >= sysdate - :P74_DATE and  ',
'            security_group_id = :app_security_group_id) l2',
'where security_group_id = :app_security_group_id and',
'          time_stamp >= sysdate - :P74_DATE ',
'group by trunc(time_stamp), to_char(time_stamp,''YYYYMMDD''), l2.total_hits',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9414825652303289)
,p_name=>'Daily Usage '
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9415509703303291)
,p_db_column_name=>'USERS'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9415600783303291)
,p_db_column_name=>'AVG_TIME'
,p_display_order=>5
,p_column_identifier=>'G'
,p_column_label=>'Average Time'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9415725607303292)
,p_db_column_name=>'MAX_TIME'
,p_display_order=>6
,p_column_identifier=>'H'
,p_column_label=>'Maximum Time'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FM999G999G999G999G990D0'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9415103029303291)
,p_db_column_name=>'PASSABLE_DATE'
,p_display_order=>8
,p_column_identifier=>'B'
,p_column_label=>'Date'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9418708487342884)
,p_db_column_name=>'THE_DATE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Date'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RIR,CIR:IR_DAY:#PASSABLE_DATE#'
,p_column_linktext=>'#THE_DATE#'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9420118230374155)
,p_db_column_name=>'DAY_OF_WEEK'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Day'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9420204189374156)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9420308298374156)
,p_db_column_name=>'PCT_OF_TOTAL'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Percent of Total'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:#cccccc:#777777:150'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9420426120374156)
,p_db_column_name=>'CACHED_REGION_VIEWS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Cached Region Views'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9420512515374156)
,p_db_column_name=>'CACHED_PAGE_VIEWS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Cached Page Views'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9422317107392664)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9425419924421856)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9425532175421856)
,p_db_column_name=>'PAGE_POSTS'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Page Posts'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9426020056431402)
,p_db_column_name=>'SESSIONS'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9426111688431403)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'IP Addresses'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9426826420442721)
,p_db_column_name=>'MONTH'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Month'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200592112694083310)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(143461276492545803)
,p_db_column_name=>'DAY_OF_WEEK_NUMERIC'
,p_display_order=>34
,p_column_identifier=>'Y'
,p_column_label=>'Day of Week'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9416203115303484)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310628364536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'THE_DATE:DAY_OF_WEEK:PAGE_VIEWS:PCT_OF_TOTAL:PAGE_POSTS:PAGE_EVENTS:SESSIONS:IP_ADDRESSES:APPLICATIONS:USERS:AVG_TIME:CONTENT_LENGTH:DAY_OF_WEEK_NUMERIC'
,p_sort_column_1=>'THE_DATE'
,p_sort_direction_1=>'DESC'
,p_sum_columns_on_break=>'PAGE_VIEWS:PAGE_POSTS:PAGE_EVENTS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200589313686055284)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200590311175055291)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200589313686055284)
,p_button_name=>'P74_SET'
,p_button_static_id=>'P74_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200589513125055288)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200589313686055284)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.:74,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65688607487081499)
,p_name=>'P74_MONTH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(200589313686055284)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65689110950082561)
,p_name=>'P74_YEAR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(200589313686055284)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200589727148055289)
,p_name=>'P74_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(200589313686055284)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to ',
'',
'include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00075
begin
wwv_flow_imp_page.create_page(
 p_id=>75
,p_name=>'Page Views by Application and Page'
,p_alias=>'PAGE-VIEWS-BY-APPLICATION-AND-PAGE'
,p_step_title=>'Page Views By Application And Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9333706545598192)
,p_plug_name=>'Recent Page Views'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P75a */',
'    flow_id application_id,',
'    (select name from wwv_flows where l.flow_id = id) application_name,',
'    step_id page_id,',
'    (select name from wwv_flow_steps where l.flow_id = flow_id and id = l.step_id)',
'       page_name,',
'    avg(elap) average_elapsed,',
'    count(distinct userid) distinct_users,',
'    count(distinct session_id) distinct_sessions,',
'    sum(decode(page_mode,''D'',1,''C'',1,0)) dynamic_views,',
'    sum(decode(page_mode,''D'',0,''C'',0,''A'',0,''P'',0,1)) static_views,',
'    sum(decode(page_mode,''A'',1,0)) page_processing,',
'    count(*) page_events,',
'    sum(decode(page_mode,''A'',0,1)) page_views,',
'    sum(decode(page_mode,''P'',1,0)) partial_page_views,',
'    sum(cached_regions) cached_regions,',
'    sum(nvl(CONTENT_LENGTH,0)) CONTENT_LENGTH',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and ',
'      time_stamp >= sysdate - nvl(:p75_time,1) ',
'group by flow_id, step_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p>Elapsed time columns are reported in seconds.</p>'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9333811522598192)
,p_name=>'Recent Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_download_filename=>'pagelog.csv'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334010730598193)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334107402598194)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334205659598194)
,p_db_column_name=>'AVERAGE_ELAPSED'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Average Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334327729598194)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Distinct Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334407901598194)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Distinct Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334824883598195)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>6
,p_column_identifier=>'I'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334928340598195)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>7
,p_column_identifier=>'J'
,p_column_label=>'Page Views'
,p_column_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:29,RIR:IR_FLOW_ID,IR_STEP_ID:#APPLICATION_ID#,#PAGE_ID#'
,p_column_linktext=>'#PAGE_VIEWS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334720032598195)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page Processing'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334504581598194)
,p_db_column_name=>'DYNAMIC_VIEWS'
,p_display_order=>9
,p_column_identifier=>'F'
,p_column_label=>'Dynamic Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9334604255598194)
,p_db_column_name=>'STATIC_VIEWS'
,p_display_order=>10
,p_column_identifier=>'G'
,p_column_label=>'Cached Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9335018746598195)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9335132030598195)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Cached Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1841307827980708)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1841404754980714)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200274628485602553)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Content Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9335421339599256)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310729332536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION_ID:PAGE_ID:AVERAGE_ELAPSED:DISTINCT_USERS:DISTINCT_SESSIONS:PAGE_EVENTS:PARTIAL_PAGE_VIEWS:CACHED_REGIONS:PAGE_NAME'
,p_sort_column_1=>'PAGE_EVENTS'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25557900928584220)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(187863112933130731)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(25557900928584220)
,p_button_name=>'P75_SET'
,p_button_static_id=>'P75_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200274719958609605)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(25557900928584220)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:75,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(131136302502658767)
,p_branch_action=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25558617894584228)
,p_name=>'P75_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(25557900928584220)
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Restrict the report to a specific time frame. Identify the amount of time to ',
'',
'include in your report and click <strong>Go</strong>.<p />',
'If you select 1 day then only the last 24 hours displays.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00076
begin
wwv_flow_imp_page.create_page(
 p_id=>76
,p_name=>'Workspace Activity by Day'
,p_alias=>'WORKSPACE-ACTIVITY-BY-DAY'
,p_step_title=>'Workspace Activity by Day'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'04'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(880560319171598064)
,p_plug_name=>'Workspace Activity by Day'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(880560786780598064)
,p_region_id=>wwv_flow_imp.id(880560319171598064)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_initial_zooming=>'first'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'on'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(880561968177598065)
,p_chart_id=>wwv_flow_imp.id(880560786780598064)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(LOG_DAY,''yyyy.mm.dd'') LOG_DAY_FORMAT,',
'       sum(page_events) PAGE_EVENTS,',
'       to_char(LOG_DAY,''yyyy.mm.dd'') ||'' - ''||sum(page_events) TOOLTIP',
' from WWV_FLOW_LOG_HISTORY ',
' where workspace_id = :flow_security_group_id and',
'       log_day >= sysdate - (NVL(:P76_SINCE,365)+1)',
'group by LOG_DAY',
'',
'',
'',
'',
''))
,p_items_value_column_name=>'PAGE_EVENTS'
,p_group_name_column_name=>'LOG_DAY_FORMAT'
,p_items_label_column_name=>'LOG_DAY_FORMAT'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(880561169222598065)
,p_chart_id=>wwv_flow_imp.id(880560786780598064)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(880561594966598065)
,p_chart_id=>wwv_flow_imp.id(880560786780598064)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1638624795426924351)
,p_plug_name=>'Button Region'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(880570927407645943)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1638624795426924351)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(880571397489645944)
,p_name=>'P76_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1638624795426924351)
,p_item_default=>'365'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual  union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual  union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual  union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual  union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00077
begin
wwv_flow_imp_page.create_page(
 p_id=>77
,p_name=>'Web Service Activity Log'
,p_alias=>'WEB-SERVICE-ACTIVITY-LOG'
,p_step_title=>'Web Service Activity Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(199844885760455501)
,p_plug_name=>'Web Service Activity Log'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(l.url,''/'',''/<wbr>'') "url", ',
'       l.http_method,',
'       l.content_length,',
'       l.status_code,',
'       l.resp_content_length,',
'       l.elapsed_sec,',
'       l.flow_user application_user,',
'       l.request_date,',
'       l.ecid,',
'       l.activity_log_id,',
'       l.ai_remote_server_id,',
'       l.ai_tokens_consumed',
' from wwv_flow_webservice_log l',
'where l.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(199844958697455502)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'JASON'
,p_internal_uid=>199844958697455502
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(199845091982455503)
,p_db_column_name=>'url'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(199845180444455504)
,p_db_column_name=>'HTTP_METHOD'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'HTTP Method'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(199845263521455505)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Content Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(199845341616455506)
,p_db_column_name=>'STATUS_CODE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Status Code'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(199845450932455507)
,p_db_column_name=>'RESP_CONTENT_LENGTH'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Resp Content Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(199845552594455508)
,p_db_column_name=>'ELAPSED_SEC'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Elapsed Sec'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(199845685374455509)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Application User'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(199845831100455511)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Request Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(66731307601543501)
,p_db_column_name=>'ECID'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'ECID'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(66731463240543502)
,p_db_column_name=>'ACTIVITY_LOG_ID'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Activity Log ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6001602555741201)
,p_db_column_name=>'AI_REMOTE_SERVER_ID'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'AI Remote Server ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6001748971741202)
,p_db_column_name=>'AI_TOKENS_CONSUMED'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Total Tokens'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(199854188191463256)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1998542'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'url:HTTP_METHOD:CONTENT_LENGTH:STATUS_CODE:RESP_CONTENT_LENGTH:ELAPSED_SEC:APPLICATION_USER:REQUEST_DATE::AI_REMOTE_SERVER_ID:AI_TOKENS_CONSUMED'
,p_sort_column_1=>'REQUEST_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(199842848545432289)
,p_branch_action=>'77'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00078
begin
wwv_flow_imp_page.create_page(
 p_id=>78
,p_name=>'Page Performance Dashboard'
,p_alias=>'PAGE-PERFORMANCE-DASHBOARD'
,p_step_title=>'Page Performance Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47352717485454057)
,p_plug_name=>'Page Performance'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Page performance for the worst performing pages is calculated by multiplying page events by median elapsed server page generation time.  Page events include page gets, page posts, and partial page gets.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47353109345454129)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47354527507454133)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169333713395245920)
,p_plug_name=>'Page Performance'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P78a */',
'       application_id,',
'       page_id,',
'       substr((select name ',
'                 from wwv_flows ',
'                 where id = q.application_id),1,30) application_name,',
'       substr((select name ',
'                 from wwv_flow_steps ',
'                 where id = q.page_id ',
'                 and flow_id = q.application_id),1,30) page_name,',
'       page_events,',
'       median_elapsed_time,',
'       page_events * median_elapsed_time weighted_cost',
'from',
'(',
'select flow_id                  application_id, ',
'       step_id                  page_id, ',
'       count(*)                 page_events,',
'       median(elap)             median_elapsed_time,',
'       median(elap)*count(*)    weighted_median',
'from wwv_flow_activity_log l',
'where security_group_id = :flow_security_group_id and ',
'    (:app_security_group_id = 10 or flow_id not between 4000 and 4999) and',
'    time_stamp >= (sysdate - nvl(:P78_TIME,.125))',
'group by flow_id, step_id',
'order by 5 desc',
') q'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(169333814048245920)
,p_name=>'Highest Weighted (Page events multiplied by median elapsed time)'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169334007414245927)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169334426112254508)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169334527617254511)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169334629806254511)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169334708691254512)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169334821938254512)
,p_db_column_name=>'MEDIAN_ELAPSED_TIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Median Elapsed Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169335527629264440)
,p_db_column_name=>'WEIGHTED_COST'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Weighted Cost'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(169335112738260044)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310806881536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION_ID:APPLICATION_NAME:PAGE_ID:PAGE_NAME:PAGE_EVENTS:MEDIAN_ELAPSED_TIME:WEIGHTED_COST'
,p_sort_column_1=>'WEIGHTED_COST'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'MEDIAN_ELAPSED_TIME'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168428423455674045)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47353109345454129)
,p_button_name=>'MONITOR_ACTIVITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Monitor Activity'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184360719768083311)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47353109345454129)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:78,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47356225121454151)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47353109345454129)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47357006428454166)
,p_branch_action=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47356408929454155)
,p_name=>'P78_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47353109345454129)
,p_prompt=>'Show'
,p_source=>'select  3/24  t from dual'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the reporting timeframe.  Longer timeframes may take longer to display.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00079
begin
wwv_flow_imp_page.create_page(
 p_id=>79
,p_name=>'Database Dashboard'
,p_alias=>'DATABASE-DASHBOARD'
,p_step_title=>'Database Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5108313447012897)
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47385826626567270)
,p_plug_name=>'Database'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>View a summary of database objects by schema.  Row counts are based on database table statistics.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47386011360567273)
,p_name=>'Recently Created Tables'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P79c */ object_name,',
'       created, ',
'       object_id',
'from sys.dba_objects',
'where ',
'      object_name not like ''BIN$%'' and',
'      owner = :P79_SCHEMA and',
'      object_type = ''TABLE''',
'order by created desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47386011360567273)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47392204279578734)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47392309148578736)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>2
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47392418555578739)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Object ID'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47386915474567281)
,p_name=>'Recently Modified Program Units'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P79a */ object_name||'' - ''||lower(object_type) object_name,',
'       the_date',
'from (',
'select object_name,',
'       object_type,',
'       nvl(last_ddl_time,created) the_date, ',
'       object_id',
'       --owner, ',
'       --last_DDL_time, ',
'       --object_type',
'from sys.dba_objects',
'where ',
'      object_name not like ''BIN$%'' and',
'      owner = :P79_SCHEMA and',
'      object_type in (''PACKAGE'',''PACKAGE BODY'',''PROCEDURE'',''FUNCTION'',''TRIGGER'')',
'order by nvl(last_ddl_time,created) desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47397730785699847)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47398210830703565)
,p_query_column_id=>2
,p_column_alias=>'THE_DATE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47387531298567282)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47387719649567283)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:99%;"'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47388326573567284)
,p_name=>'Object Counts'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P79b */ object_type,',
'       count_of_objects',
'from (',
'select ',
'       object_type,',
'       count(*) count_of_objects',
'from sys.dba_objects',
'where ',
'      object_name not like ''BIN$%'' and',
'      owner = :P79_SCHEMA and',
'      object_type in (',
'        ''PACKAGE'',',
'        ''PACKAGE BODY'',',
'        ''PROCEDURE'',',
'        ''FUNCTION'',',
'        ''TRIGGER'',',
'        ''SEQUENCE'',',
'        ''VIEW'',',
'        ''TABLE'',',
'        ''SEQUNCE'',',
'        ''DATABASE LINK'',',
'        ''SYNONYM'',',
'        ''INDEX'')',
'group by object_type',
'order by 2 desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47388326573567284)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47401812786770361)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47401921711770361)
,p_query_column_id=>2
,p_column_alias=>'COUNT_OF_OBJECTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47389605673567291)
,p_name=>'Top Tables by Row Count'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>60
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P79d */ table_name,',
'       num_rows',
'from (',
'select table_name,',
'       num_rows',
'from sys.dba_tables',
'where owner = :P79_SCHEMA and',
'      table_name not like ''DR$%IDX%'' and',
'      num_rows is not null',
'order by 2 desc',
') q',
'where rownum < 8'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47389605673567291)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47403912318836436)
,p_query_column_id=>1
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47403521191829525)
,p_query_column_id=>2
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47390120449567291)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47387719649567283)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47391730194567302)
,p_branch_action=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47395210652665698)
,p_name=>'P79_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47387719649567283)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(upper(c.schema)) d, ',
'       upper(c.schema) v',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u ',
'where  c.security_group_id = :flow_security_group_id and ',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :app_user and ',
'       (',
'           u.ALLOW_ACCESS_TO_SCHEMAS is null or ',
'           instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0',
'       )'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168453819941445045)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'79'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(432754229162051527)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P79_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>432754229162051527
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(47395713339685353)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set schema'
,p_process_sql_clob=>':P79_SCHEMA := upper(wwv_flow_user_api.get_default_schema);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P79_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>47395713339685353
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(432754418904057984)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P79_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>432754418904057984
);
end;
/
prompt --application/pages/page_00080
begin
wwv_flow_imp_page.create_page(
 p_id=>80
,p_name=>'By Application By Month'
,p_alias=>'BY-APPLICATION-BY-MONTH'
,p_step_title=>'By Application By Month'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(383691245467261189)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(395885337124084611)
,p_plug_name=>'Search'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(788752398959361811)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'current_facets_selector', '#active_facets',
  'show_charts', 'N',
  'show_current_facets', 'E',
  'show_total_row_count', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(395885828777084616)
,p_plug_name=>'Report Actions'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(788752398959361811)
,p_name=>'Page View Summary'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>24
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /*+ FIRST_ROWS(21) */',
'    to_char(log_day,''YYYY.MM'') Log_month,',
'    APPLICATION_ID||''. ''||APPLICATION_NAME APPLICATION_NAME,',
'    sum(page_events) PAGE_EVENTS,',
'    max(distinct_pages) MAX_DAILY_PAGES,',
'    max(DISTINCT_USERS) max_daily_users,',
'    max(DISTINCT_SESSIONS) max_daily_sessions,',
'    sum(ERROR_COUNT) errors_raised,',
'    median(AVERAGE_RENDER_TIME)*1000 median_elap,',
'    case WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 10000 then ''> 10 ''||m.m_seconds',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 5000 then ''5 - 10 ''||m.m_seconds',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 2000 then ''2 - 5 ''||m.m_seconds',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 1000 then ''1 - 2 ''||m.m_seconds',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 750  then ''750 - 1000 ''||m.m_ms',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 500  then ''500 - 750 ''||m.m_ms',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 250  then ''250 - 500 ''||m.m_ms',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 100  then ''100 - 250 ''||m.m_ms',
'         WHEN median(AVERAGE_RENDER_TIME) * 1000 >= 50   then ''50 - 100 ''||m.m_ms',
'         else ''< 50 ''||m.m_ms end performance_bucket,',
'     application_id',
'from WWV_FLOW_LOG_HISTORY h,',
'   (select wwv_flow_lang.system_message(''SECONDS'') m_seconds,',
'           wwv_flow_lang.system_message(''HOURS'') m_hours,',
'           wwv_flow_lang.system_message(''HOUR'') m_hour,',
'           wwv_flow_lang.system_message(''DAYS'') m_days,',
'           wwv_flow_lang.system_message(''F4350_AJAX'') m_ajax,',
'           wwv_flow_lang.system_message(''PE.PROPERTY.CHART_RENDERING.PROMPT'') m_rendering,',
'           wwv_flow_lang.system_message(''PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'') m_processing,',
'           wwv_flow_lang.system_message(''WWV_FLOW.LOGOUT'') m_logout,',
'           wwv_flow_lang.system_message(''F4350_AUTHENTICATION_CALLBACK'') auth_callback,',
'           wwv_flow_lang.system_message(''NO'') m_NO,',
'           wwv_flow_lang.system_message(''YES'') m_YES,',
'           wwv_flow_lang.system_message(''MILLISECONDS_MS'') m_ms',
'    from dual) m',
'where workspace_id = :flow_security_group_id',
'group by to_char(log_day,''YYYY.MM''), application_name, APPLICATION_ID, m.m_seconds, m.m_seconds, m.m_ms',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395884466766084602)
,p_query_column_id=>1
,p_column_alias=>'LOG_MONTH'
,p_column_display_sequence=>2
,p_column_heading=>'Month'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:RR,352:IR_APPLICATION_ID,IR_LOG_MONTH:#APPLICATION_ID#,#LOG_MONTH#'
,p_column_linktext=>'#LOG_MONTH#'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395921419795198916)
,p_query_column_id=>2
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395884687226084604)
,p_query_column_id=>3
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>3
,p_column_heading=>'Page Events'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395884805831084606)
,p_query_column_id=>4
,p_column_alias=>'MAX_DAILY_PAGES'
,p_column_display_sequence=>4
,p_column_heading=>'Maximum Pages Referenced'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395884944043084607)
,p_query_column_id=>5
,p_column_alias=>'MAX_DAILY_USERS'
,p_column_display_sequence=>5
,p_column_heading=>'Maximum Daily Users'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395885034466084608)
,p_query_column_id=>6
,p_column_alias=>'MAX_DAILY_SESSIONS'
,p_column_display_sequence=>6
,p_column_heading=>'Maximum Daily Sessions'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395885182569084609)
,p_query_column_id=>7
,p_column_alias=>'ERRORS_RAISED'
,p_column_display_sequence=>7
,p_column_heading=>'Errors Raised'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395886047493084618)
,p_query_column_id=>8
,p_column_alias=>'MEDIAN_ELAP'
,p_column_display_sequence=>8
,p_column_heading=>'Median Time (ms)'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395886153093084619)
,p_query_column_id=>9
,p_column_alias=>'PERFORMANCE_BUCKET'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395886499842084622)
,p_query_column_id=>10
,p_column_alias=>'APPLICATION_ID'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(395885954644084617)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(395885828777084616)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:RR,80::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395885452726084612)
,p_name=>'P80_APPLICATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(395885337124084611)
,p_prompt=>'Application'
,p_source=>'APPLICATION_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395885526647084613)
,p_name=>'P80_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(395885337124084611)
,p_prompt=>'Search'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_filter_values=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395885643103084614)
,p_name=>'P80_LOG_MONTH'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(395885337124084611)
,p_prompt=>'Month'
,p_source=>'LOG_MONTH'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>24
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395886286146084620)
,p_name=>'P80_PERFORMANCE_BUCKET'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(395885337124084611)
,p_prompt=>'Median Performance'
,p_source=>'PERFORMANCE_BUCKET'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>20
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
end;
/
prompt --application/pages/page_00082
begin
wwv_flow_imp_page.create_page(
 p_id=>82
,p_name=>'Application Changes by Day'
,p_alias=>'APPLICATION-CHANGES-BY-DAY2'
,p_step_title=>'Application Changes by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'08'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47714431819630069)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47714818455630078)
,p_plug_name=>'New Pages Created by Developer'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select created_on, ',
'       flow_id || '':'' || id || ''. '' || name || '' ('' || lower(created_by) || '')'' as display_title',
'  from wwv_flow_steps',
' where security_group_id = :flow_security_group_id',
'   and (nvl(:P82_APPLICATION,0) = 0 or flow_id = :P82_APPLICATION)',
'   and created_on > sysdate - nvl(:P82_SINCE,45)',
' order by trunc(created_on), flow_id, id'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'additional_calendar_views', 'navigation',
  'display_column', 'DISPLAY_TITLE',
  'maximum_events_day', '10',
  'multiple_line_event', 'Y',
  'show_time', 'N',
  'show_tooltip', 'N',
  'show_weekend', 'Y',
  'start_date_column', 'CREATED_ON')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47722122683672427)
,p_plug_name=>'monitor activity / calendar views'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47721323591663284)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450757429520608018)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47714431819630069)
,p_button_name=>'P82_SET'
,p_button_static_id=>'P82_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47716525087630105)
,p_branch_action=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47715423374630085)
,p_name=>'P82_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47714431819630069)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'45'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47715921153630087)
,p_name=>'P82_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47714431819630069)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00083
begin
wwv_flow_imp_page.create_page(
 p_id=>83
,p_name=>'Email Report'
,p_alias=>'EMAIL-REPORT'
,p_step_title=>'Email Report'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_service.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180925501846212191)
,p_plug_name=>'Email'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(180926025265217801)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(180925501846212191)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(180926216468217806)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(180925501846212191)
,p_button_name=>'email'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Email'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(180927714099233541)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180926505657221589)
,p_name=>'P83_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(180925501846212191)
,p_prompt=>'To'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select email_address ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id and ',
'      user_name = :app_user;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter valid email addresses. Separate multiple entries with a comma.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180926910491221594)
,p_name=>'P83_SUBJECT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(180925501846212191)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Subject'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(',
'           ''WORKSPACE_WORKSPACE_SUMMARY'',',
'           coalesce(display_name, short_name)) m',
'from wwv_flow_companies',
'where provisioning_company_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter text that describes the message.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180927122293221594)
,p_name=>'P83_BODY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(180925501846212191)
,p_prompt=>'Body'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter optional body text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180935011937251769)
,p_name=>'P83_REPORTING_PERIOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(180925501846212191)
,p_item_default=>'D'
,p_prompt=>'Reporting Period'
,p_source=>'W'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_imp.id(180662003103161233)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a time interval for the report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(852015655140525052)
,p_validation_name=>'P83_TO Not Null'
,p_validation_sequence=>10
,p_validation=>'P83_TO'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Email Address must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(180926216468217806)
,p_associated_item=>wwv_flow_imp.id(180926505657221589)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-JUN-2001 19:34'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(852015845228527563)
,p_validation_name=>'P83_TO valid format'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at number;',
'  l_dot number;',
'begin',
'  l_at := instr(nvl(:P83_TO,''x''),''@'');',
'  l_dot := instr(nvl(:P83_TO,''x''),''.'',l_at);',
'  return l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address.'
,p_validation_condition=>'P83_TO'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(180926216468217806)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(180952012507668237)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'send email'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4350_ui.p83_send_ws_usage_mail (',
'    p_to               => :P83_TO,',
'    p_subject          => :P83_SUBJECT,',
'    p_body             => :P83_BODY,',
'    p_reporting_period => :P83_REPORTING_PERIOD,',
'    p_date_time_format => :DATE_TIME_FORMAT );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(180926216468217806)
,p_process_success_message=>'Email sent to &P83_TO.'
,p_internal_uid=>180952012507668237
);
end;
/
prompt --application/pages/page_00084
begin
wwv_flow_imp_page.create_page(
 p_id=>84
,p_name=>'Click Count Log'
,p_alias=>'CLICK-COUNT-LOG'
,p_step_title=>'Click Count Log'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215462122626558552)
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_mg_logs.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42467211201256215)
,p_plug_name=>'Manage Click Count Log'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'   c_click pls_integer := 0;',
'begin',
'   sys.htp.prn(''<table class="instructiontext" role="presentation" cellspacing="0" cellpadding="0">'');',
'   -- WWV_FLOW_CLICKTHRU_LOG$',
'   select count(*) into c_click from WWV_FLOW_CLICKTHRU_LOG;',
'   sys.htp.prn(''<tr><td>''||wwv_flow_lang.system_message(''F4350_CLICKTHRU_LOG_ENTRIES'')||''&nbsp;</td><td align="right" class="fielddatabold">'');',
'   sys.htp.prn(to_char(c_click,''999G999G999G999G990'')||''</td></tr></table><p />'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42467400750256217)
,p_plug_name=>'Click Count Log'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Use this page to purge entries from the click count log.  The click count log maintains counts of clicks to external sites.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47261006537939619)
,p_plug_name=>'Manage Logs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:50%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(41778218420271753)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(42468326851256219)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(42467211201256215)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(42468703382256220)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(42467211201256215)
,p_button_name=>'PURGE_CLICK_LOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Click Log'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42469424294256221)
,p_branch_action=>'84'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(42469115669256220)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'puge click through log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_clickthru_log$',
'where security_group_id = :flow_security_group_id;',
'delete from wwv_flow_clickthru_log2$',
'where security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to purge click through log.'
,p_process_when_button_id=>wwv_flow_imp.id(42468703382256220)
,p_process_success_message=>'Click through log purged.'
,p_internal_uid=>42469115669256220
);
end;
/
prompt --application/pages/page_00085
begin
wwv_flow_imp_page.create_page(
 p_id=>85
,p_name=>'File Utilization'
,p_alias=>'FILE-UTILIZATION'
,p_step_title=>'File Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_wrkspc_rprt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452551108492691311)
,p_plug_name=>'Files'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(file_type) file_type,',
'       sum(file_bytes) s,',
'       sum(file_count) c,',
'       max(file_newest) newest_file,',
'       min(file_oldest) oldest_file',
'  from wwv_flow_company_filestats',
' where security_group_id = :flow_security_group_id',
' group by file_type'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(452551212367691311)
,p_name=>'Files'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452551430431691329)
,p_db_column_name=>'FILE_TYPE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'File Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452551509577691331)
,p_db_column_name=>'S'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Total File Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452551631735691332)
,p_db_column_name=>'C'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'File Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452557317497814833)
,p_db_column_name=>'NEWEST_FILE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Newest File'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452557404080814835)
,p_db_column_name=>'OLDEST_FILE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Oldest File'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(452551720296692674)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1310916026536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'FILE_TYPE:C:S:NEWEST_FILE:OLDEST_FILE'
,p_sort_column_1=>'S'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'FILE_TYPE'
,p_sort_direction_2=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452552119519711425)
,p_plug_name=>'File Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Each Workspace is allocated a certain amount of storage.  Files can quickly fill up that space.  Use this report to identify areas using excessive storage.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452553408961746157)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(452551108492691311)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00086
begin
wwv_flow_imp_page.create_page(
 p_id=>86
,p_name=>'Database Privileges'
,p_alias=>'DATABASE-PRIVILEGES'
,p_step_title=>'Database Privileges'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215677404159045218)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5565405532403790)
,p_plug_name=>'Database Privileges Report Selection'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47242027449673013)
,p_plug_name=>'Database Privileges'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P86a */ grantee, privilege ',
'from sys.dba_sys_privs ',
'where grantee = :P86_SCHEMA'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Database Privileges'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47242113516673013)
,p_name=>'Database Privileges'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47242412834673034)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Privilege'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47242300127673028)
,p_db_column_name=>'GRANTEE'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Grantee'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47242602176673444)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1311027805536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PRIVILEGE:GRANTEE'
,p_sort_column_1=>'PRIVILEGE'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(67348921856914073)
,p_plug_name=>'Database Privileges'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>To execute DDL and DML using the SQL Workshop, the selected database schema needs specific database privileges. For example, to create a table, the selected schema would need the Create Table privilege.</p> <p>In Oracle Database Server versions be'
||'fore 10.2.0.3, these privileges must be granted directly to the schema. In Oracle Database Server versions 10.2.0.3 and later, these privileges may be granted to the schema directly or through a role in order for the SQL Workshop to be able to perfor'
||'m the operation using the selected schema.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(67233501836737996)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5565405532403790)
,p_button_name=>'P86_GO'
,p_button_static_id=>'P86_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450809001075271602)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5565405532403790)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(67234817766742659)
,p_branch_action=>'f?p=&FLOW_ID.:86:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(67232723176734667)
,p_name=>'P86_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5565405532403790)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    wwv_flow_escape.html(schema) d, schema r',
'from WWV_FLOW_COMPANY_SCHEMAS',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Specify which schema to view privileges for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(190090924272869615)
,p_computation_sequence=>10
,p_computation_item=>'P86_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select first_schema_provisioned from wwv_flow_companies where provisioning_company_id = :flow_security_group_id'
,p_compute_when=>'P86_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(432754600335062133)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P86_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_internal_uid=>432754600335062133
);
end;
/
prompt --application/pages/page_00087
begin
wwv_flow_imp_page.create_page(
 p_id=>87
,p_name=>'Page Views by Hour'
,p_alias=>'PAGE-VIEWS-BY-HOUR'
,p_step_title=>'Page Views by Hour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47740509929035806)
,p_plug_name=>'Activity By Application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P87a */',
'       flow_id application_id,',
'       to_char(time_stamp,''YYYY.MM.DD HH24'') hour,',
'       count(*) page_views ,',
'       sum(num_rows) report_rows,',
'       count(distinct(flow_id||''.''||step_id)) pages,',
'      sum(elap) elapsed_time,',
'      avg(elap) avg_elapsed_time,',
'      median(elap) median_elapsed_time,',
'      count(distinct session_id) sessions,',
'      count(distinct userid) distinct_users,',
'    sum(decode(page_mode,''R'',1,0)) pages_from_cache,',
'    sum(decode(page_mode,''A'',0,1)) just_page_views,',
'    sum(decode(page_mode,''A'',1,0)) page_processing,',
'    sum(cached_regions) regions_from_cache,',
'    count(distinct to_char(time_stamp,''YYYYMMDDHH24MI'')) distinct_minutes,',
'    max(t.c) total_page_events,',
'    100 * count(*) / max(t.c) pct_of_total,',
'    100 * count(*) / max(t.c) graph',
'from  WWV_FLOW_ACTIVITY_LOG l,',
'    (select count(*) c',
'     from WWV_FLOW_ACTIVITY_LOG',
'     where ',
'        (nvl(:P87_APPLICATION,0)=0 or flow_id = :P87_APPLICATION )',
'        and time_stamp >= sysdate - nvl(:P87_TIME,1)',
'        and   security_group_id = :flow_security_group_id) t',
'where ',
'(nvl(:P87_APPLICATION,0)=0 or flow_id = :P87_APPLICATION ) ',
'and time_stamp >= sysdate - nvl(:P87_TIME,1)',
'and   security_group_id = :flow_security_group_id',
'group by flow_id, to_char(time_stamp,''YYYY.MM.DD HH24'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p>Elapsed time columns are reported in seconds.</p>'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47740701180035807)
,p_name=>'Activity By Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47741128249035810)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Page Processing'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47742116882035814)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Report Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47743412902038553)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47743526533038555)
,p_db_column_name=>'HOUR'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Hour'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47743604701038562)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47743727872038562)
,p_db_column_name=>'PAGES'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47743802111038563)
,p_db_column_name=>'ELAPSED_TIME'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990D999'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47743905822038563)
,p_db_column_name=>'AVG_ELAPSED_TIME'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Avg Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744003940038564)
,p_db_column_name=>'MEDIAN_ELAPSED_TIME'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Median Elapsed Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990D999'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744119550038564)
,p_db_column_name=>'SESSIONS'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744232433038565)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744311335038566)
,p_db_column_name=>'PAGES_FROM_CACHE'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Cached Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744419283038566)
,p_db_column_name=>'JUST_PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744511617038567)
,p_db_column_name=>'REGIONS_FROM_CACHE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Cached Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744612380038567)
,p_db_column_name=>'DISTINCT_MINUTES'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Distinct Minutes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744723311038568)
,p_db_column_name=>'TOTAL_PAGE_EVENTS'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744807922038568)
,p_db_column_name=>'PCT_OF_TOTAL'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Pct of Total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47744906853038569)
,p_db_column_name=>'GRAPH'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47742614116035817)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1311126093536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'HOUR:APPLICATION_ID:PAGES:GRAPH:PAGE_VIEWS:ELAPSED_TIME:MEDIAN_ELAPSED_TIME:TOTAL_PAGE_EVENTS:REPORT_ROWS'
,p_sort_column_1=>'HOUR'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'PAGE_EVENTS'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'APPLICATION'
,p_sort_direction_3=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47746323899060711)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(429959221652073590)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47746323899060711)
,p_button_name=>'P87_SET'
,p_button_static_id=>'P87_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47747618500060722)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47746323899060711)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:RIR,87::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47743018719035824)
,p_branch_action=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47746611640060714)
,p_name=>'P87_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47746323899060711)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'to_number(.25)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47747104482060716)
,p_name=>'P87_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47746323899060711)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(47742722259035817)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>47742722259035817
);
end;
/
prompt --application/pages/page_00088
begin
wwv_flow_imp_page.create_page(
 p_id=>88
,p_name=>'Detailed Tablespace Utilization Report'
,p_alias=>'DETAILED-TABLESPACE-UTILIZATION-REPORT'
,p_page_mode=>'MODAL'
,p_step_title=>'Detailed Tablespace Utilization Report'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215677404159045218)
,p_step_template=>wwv_flow_imp.id(485889499804058937)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'300'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(100071023152204639)
,p_name=>'Tablespace Utilization'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with workspace_tablespace as',
'    ( select distinct default_tablespace',
'        from sys.dba_users',
'       where username in ',
'             (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = (select wwv_flow.get_sgid from sys.dual where rownum = 1))',
'    )',
'select tm.tablespace_name name,',
'       tm.tablespace_size * ts.block_size bytes,',
'       (tm.tablespace_size-tm.used_space) * ts.block_size free,',
'       tm.used_space * ts.block_size used,',
'       tm.used_percent pct_used',
'  from workspace_tablespace wt,',
'       sys.dba_tablespaces  ts,',
'       sys.dba_tablespace_usage_metrics tm',
' where wt.default_tablespace = ts.tablespace_name',
'   and ts.tablespace_name    = tm.tablespace_name',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P4651a */ name, bytes, bytes-free used, free, (bytes-free)/bytes*100 pct_used from',
'(select t.tablespace_name name,',
'       ( select sum(user_blocks * t.block_size)',
'             from sys.dba_data_files',
'            where tablespace_name = t.tablespace_name ) bytes,',
'       ( select sum(bytes)',
'             from sys.dba_free_space',
'            where tablespace_name = t.tablespace_name ) free ',
'   from sys.dba_tablespaces t',
'  where tablespace_name in (select default_tablespace',
'           from sys.dba_users where username in (select schema from wwv_flow_company_schemas',
'           where security_group_id= (select wwv_flow.get_sgid ',
'                                       from dual ',
'                                      where rownum = 1))))',
'  order by 1  '))
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26776828303573819)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Tablespace Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(100071521567204659)
,p_query_column_id=>2
,p_column_alias=>'BYTES'
,p_column_display_sequence=>2
,p_column_heading=>'Bytes'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(100071715083204660)
,p_query_column_id=>3
,p_column_alias=>'FREE'
,p_column_display_sequence=>4
,p_column_heading=>'Amount Free'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(100071603085204659)
,p_query_column_id=>4
,p_column_alias=>'USED'
,p_column_display_sequence=>3
,p_column_heading=>'Amount Used'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(100071820491204660)
,p_query_column_id=>5
,p_column_alias=>'PCT_USED'
,p_column_display_sequence=>5
,p_column_heading=>'Percentage Used'
,p_use_as_row_header=>'N'
,p_column_format=>'999D99'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(722742080310798648)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722742223736798650)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(722742080310798648)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2171305307718550621)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(722742223736798650)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2171305796821550623)
,p_event_id=>wwv_flow_imp.id(2171305307718550621)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00089
begin
wwv_flow_imp_page.create_page(
 p_id=>89
,p_name=>'Page Changes by Day'
,p_alias=>'PAGE-CHANGES-BY-DAY'
,p_step_title=>'Page Changes by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'08'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47765501589258984)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47765923866258985)
,p_plug_name=>'Page Changes by Day'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select last_updated_on,',
'       flow_id || '':'' || id || ''. '' || name as display_title',
'  from wwv_flow_steps',
' where security_group_id = :flow_security_group_id',
'   and (nvl(:P89_APPLICATION,0) = 0 or flow_id = :P89_APPLICATION)',
'   and last_updated_on > sysdate - nvl(:P89_SINCE,45)',
' order by trunc(last_updated_on), flow_id, id'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'additional_calendar_views', 'navigation',
  'display_column', 'DISPLAY_TITLE',
  'maximum_events_day', '10',
  'multiple_line_event', 'Y',
  'show_time', 'N',
  'show_tooltip', 'N',
  'show_weekend', 'Y',
  'start_date_column', 'LAST_UPDATED_ON')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47766328642258989)
,p_plug_name=>'monitor activity / calendar views'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47721323591663284)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450759905110638890)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47765501589258984)
,p_button_name=>'P89_GO'
,p_button_static_id=>'P89_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47767811663259012)
,p_branch_action=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47766701303258999)
,p_name=>'P89_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47765501589258984)
,p_item_default=>'to_number(.25)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Since'
,p_source=>'45'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''90 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 90/(24*60) t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4/24  t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 5/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 10/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''16 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 16/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 21 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 45 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 70 t from dual union all',
'select ''20 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 140 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Restrict the report to a specific time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47767221639259000)
,p_name=>'P89_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47765501589258984)
,p_item_default=>'0'
,p_prompt=>'Application'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE.APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Applications -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter report output to include all applications or a specific application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00090
begin
wwv_flow_imp_page.create_page(
 p_id=>90
,p_name=>'Purge Expired Cached Pages by Application'
,p_alias=>'PURGE-EXPIRED-CACHED-PAGES-BY-APPLICATION'
,p_step_title=>'Purge Expired Cached Pages by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_pg.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51199603672230132)
,p_plug_name=>'Purge Expired Cached Pages by Application'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51200911677230134)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(51199603672230132)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51200726672230133)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(51199603672230132)
,p_button_name=>'PURGE_CACHED_REGIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Expired'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(51201901360230135)
,p_branch_action=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51201119105230134)
,p_name=>'P90_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(51199603672230132)
,p_item_default=>'0'
,p_prompt=>'Application:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||''. ''||wwv_flow_escape.html(f.name)||'' (''||count(*)||'')'' n, f.id ',
'from wwv_flows f,',
'     wwv_flow_page_cache c',
'where f.security_group_id = :flow_security_group_id and',
'      f.security_group_id = c.security_group_id and',
'      f.id = c.flow_id and',
'      c.region_id is null',
'group by f.id, f.name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the application to purge expired pages from the page cache.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(51201628317230134)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Expired'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select id ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id and ',
'id = :P90_APPLICATION) loop',
'   wwv_flow_utilities.cache_purge_stale (p_application=>c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Process'
,p_process_when=>'P90_APPLICATION'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_process_success_message=>'Action Processed'
,p_internal_uid=>51201628317230134
);
end;
/
prompt --application/pages/page_00091
begin
wwv_flow_imp_page.create_page(
 p_id=>91
,p_name=>'Application Dashboard'
,p_alias=>'APPLICATION-DASHBOARD'
,p_step_title=>'Application Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5108313447012897)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_activity.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47992107522118726)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>View a summary of applications.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47993227283118731)
,p_name=>'Recently Created'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P91c */ id||''. ''||substr(name,1,35)',
'       name,',
'       created_on',
'  from wwv_flow_visible_flows f',
' where f.created_on is not null',
'   and f.build_status != ''RUN_AND_HIDDEN''',
' order by created_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47993227283118731)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47998706346131055)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47998826225131055)
,p_query_column_id=>2
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47994503004118734)
,p_plug_name=>'Dashboards'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(46989621592546067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47994726036118735)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47996205859118740)
,p_name=>'Application Groups'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P91b */',
'   g.group_name,',
'   (select count(*) from wwv_flows f where f.group_id = g.id) app_count',
'from wwv_flow_application_groups g',
'where security_group_id = :flow_security_group_id',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46765105410141325)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No groups found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47996205859118740)
,p_plug_column_width=>'apex-col--leftBorder '
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47996432056118740)
,p_query_column_id=>1
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Group Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48001220076201311)
,p_query_column_id=>2
,p_column_alias=>'APP_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'App Count'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(48003712551255842)
,p_name=>'Workspace Summary'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P91a */',
'(',
'select count(*)',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
') as applications,',
'(',
'select count(*)',
'  from wwv_flow_visible_flows f,',
'       wwv_flow_steps p',
' where f.id = p.flow_id',
'   and f.security_group_id = p.security_group_id',
'   and f.build_status != ''RUN_AND_HIDDEN''',
') as pages,',
'(',
' select count(*)',
'  from wwv_flow_themes t',
' where theme_security_group_id = :flow_security_group_id',
'   and security_group_id = 11',
') as workspace_themes',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48004019225255934)
,p_query_column_id=>1
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>1
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48005022032268031)
,p_query_column_id=>2
,p_column_alias=>'PAGES'
,p_column_display_sequence=>2
,p_column_heading=>'Pages'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48008721780324751)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE_THEMES'
,p_column_display_sequence=>3
,p_column_heading=>'Workspace Themes'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47996609303118741)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47994726036118735)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47997709504118768)
,p_branch_action=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168453117732434905)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'91'
);
end;
/
prompt --application/pages/page_00092
begin
wwv_flow_imp_page.create_page(
 p_id=>92
,p_name=>'Interactive Report Subscriptions'
,p_alias=>'INTERACTIVE-REPORT-SUBSCRIPTIONS'
,p_step_title=>'Interactive Report Subscriptions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_ir_notifi.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48027402901804000)
,p_plug_name=>'Subscriptions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1, n.id, null,null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'       wwv_flow_lang_dev.builder_message(''IR_SUBSCRIPTION_LABEL'',i.flow_id,i.page_id,n.owner)) id,',
'       i.flow_id nflow_id,',
'       i.page_id npage_id,',
'       (select pr.plug_name from wwv_flow_page_plugs pr where pr.id = i.region_id) region_name,',
'       n.session_id,',
'       n.owner    application_user,',
'       n.language language,',
'       decode(n.download_format,',
'           ''XLSX'',''Excel'',',
'           n.download_format) download_format,',
'       decode(n.strip_rich_text,',
'           ''Y'',m.m_yes,',
'           ''N'',m.m_no) strip_rich_text,',
'       decode(n.data_only,',
'           ''Y'',m.m_yes,',
'           ''N'',m.m_no,',
'           m.m_no) data_only,',
'       decode(n.pdf_page_size,',
'           ''A3'',m.m_a3,',
'           ''A4'',m.m_a4,',
'           ''LEGAL'',m.m_legal,',
'           ''LETTER'',m.m_letter,',
'           ''CUSTOM'',m.m_custom,',
'           ''TABLOID'',m.m_tabloid,',
'           pdf_page_size) pdf_page_size,',
'       decode(n.pdf_page_orientation,',
'           ''VERTICAL'',m.m_vertical,',
'           ''HORIZONTAL'',m.m_horizontal,',
'           pdf_page_orientation) pdf_page_orientation,',
'       decode(n.pdf_accessible,',
'           ''Y'',m.m_yes,',
'           ''N'',m.m_no) pdf_accessible,',
'       decode(n.skip_no_data_found,',
'           ''Y'',m.m_yes,',
'           ''N'',m.m_no) skip_no_data_found,',
'       n.start_date,',
'       n.end_date,',
'       n.offset_date,',
'       n.notify_interval,',
'       n.status,',
'       n.notify_error,',
'       n.email_from,',
'       n.email_address,',
'       n.created_by,',
'       n.created_on',
'  from wwv_flow_worksheet_notify n,',
'       wwv_flow_worksheets i,',
'       wwv_flow_worksheet_rpts r,',
'       (select wwv_flow_lang_dev.builder_message(''F4000.YES'') m_yes,',
'               wwv_flow_lang_dev.builder_message(''F4000.NO'') m_no,',
'               wwv_flow_lang_dev.builder_message(''APEXIR_PDF_ORIENTATION_VERTICAL'') m_vertical,',
'               wwv_flow_lang_dev.builder_message(''APEXIR_PDF_ORIENTATION_HORIZONTAL'') m_horizontal,',
'               wwv_flow_lang_dev.builder_message(''APEXIR_PDF_PAGE_SIZE_A3'') m_a3,',
'               wwv_flow_lang_dev.builder_message(''APEXIR_PDF_PAGE_SIZE_A4'') m_a4,',
'               wwv_flow_lang_dev.builder_message(''APEXIR_PDF_PAGE_SIZE_LEGAL'') m_legal,',
'               wwv_flow_lang_dev.builder_message(''APEXIR_PDF_PAGE_SIZE_LETTER'') m_letter,',
'               wwv_flow_lang_dev.builder_message(''APEXIR_PDF_PAGE_SIZE_CUSTOM'') m_custom,',
'               wwv_flow_lang_dev.builder_message(''APEXIR_PDF_PAGE_SIZE_TABLOID'') m_tabloid',
'          from dual) m',
' where n.worksheet_id = i.id',
'   and n.report_id = r.id',
'   and n.security_group_id = :flow_security_group_id',
'   and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(48027503431804000)
,p_name=>'Interactive Reports with Notification'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No subscription found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:EMAIL'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48511609702866940)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'AA'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48527911620681091)
,p_db_column_name=>'NFLOW_ID'
,p_display_order=>2
,p_column_identifier=>'AB'
,p_column_label=>'Application'
,p_column_link=>'f?p=4000:1:&SESSION.::&DEBUG.:RP,:FB_FLOW_ID,F4000_P1_FLOW:#NFLOW_ID#,#NFLOW_ID#'
,p_column_linktext=>'#NFLOW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48528022095681092)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>3
,p_column_identifier=>'AC'
,p_column_label=>'Page'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.:Y,:FB_FLOW_ID,FB_FLOW_PAGE_ID:#NFLOW_ID#,#NPAGE_ID#'
,p_column_linktext=>'#NPAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48446920926555091)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>4
,p_column_identifier=>'X'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(218135830707197801)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>14
,p_column_identifier=>'AS'
,p_column_label=>'Session'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(167816820814522394)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>24
,p_column_identifier=>'AE'
,p_column_label=>'Subscribed By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48028419846804017)
,p_db_column_name=>'NOTIFY_INTERVAL'
,p_display_order=>34
,p_column_identifier=>'H'
,p_column_label=>'Frequency'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(48455120589630644)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48029015454804020)
,p_db_column_name=>'EMAIL_ADDRESS'
,p_display_order=>44
,p_column_identifier=>'N'
,p_column_label=>'Email To'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48457108858666691)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>54
,p_column_identifier=>'Z'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48457014187666690)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>64
,p_column_identifier=>'Y'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619313810684318613)
,p_db_column_name=>'STATUS'
,p_display_order=>84
,p_column_identifier=>'AI'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(619315906303328344)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619313907524318614)
,p_db_column_name=>'NOTIFY_ERROR'
,p_display_order=>94
,p_column_identifier=>'AJ'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619446121222909742)
,p_db_column_name=>'START_DATE'
,p_display_order=>104
,p_column_identifier=>'AK'
,p_column_label=>'Start Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619446215230909743)
,p_db_column_name=>'END_DATE'
,p_display_order=>114
,p_column_identifier=>'AL'
,p_column_label=>'End Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(619446306135909743)
,p_db_column_name=>'OFFSET_DATE'
,p_display_order=>124
,p_column_identifier=>'AM'
,p_column_label=>'Offset Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18808423409746055)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>154
,p_column_identifier=>'AQ'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18808508451746058)
,p_db_column_name=>'EMAIL_FROM'
,p_display_order=>164
,p_column_identifier=>'AR'
,p_column_label=>'Email From'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3801935667307217)
,p_db_column_name=>'DOWNLOAD_FORMAT'
,p_display_order=>174
,p_column_identifier=>'AT'
,p_column_label=>'Format'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802033977307218)
,p_db_column_name=>'STRIP_RICH_TEXT'
,p_display_order=>184
,p_column_identifier=>'AU'
,p_column_label=>'Strip Rich Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802168392307219)
,p_db_column_name=>'DATA_ONLY'
,p_display_order=>194
,p_column_identifier=>'AV'
,p_column_label=>'Data Only'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802232092307220)
,p_db_column_name=>'PDF_PAGE_SIZE'
,p_display_order=>204
,p_column_identifier=>'AW'
,p_column_label=>'Pdf Page Size'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802391362307221)
,p_db_column_name=>'PDF_PAGE_ORIENTATION'
,p_display_order=>214
,p_column_identifier=>'AX'
,p_column_label=>'Pdf Page Orientation'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3802434756307222)
,p_db_column_name=>'PDF_ACCESSIBLE'
,p_display_order=>224
,p_column_identifier=>'AY'
,p_column_label=>'Pdf Accessible'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4162892338589923)
,p_db_column_name=>'SKIP_NO_DATA_FOUND'
,p_display_order=>234
,p_column_identifier=>'AZ'
,p_column_label=>'Skip if No Data Found'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(48029612185804474)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1311214437536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NFLOW_ID:NPAGE_ID:REGION_NAME:SESSION_ID:APPLICATION_USER:NOTIFY_INTERVAL:EMAIL_ADDRESS:CREATED_ON:CREATED_BY:STATUS:DOWNLOAD_FORMAT'
,p_sort_column_1=>'NFLOW_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'NPAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'REGION_NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452527601203308717)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48027402901804000)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--gapRight'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48508510217829186)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(48027402901804000)
,p_button_name=>'DELETE_ALL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Delete All'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'javascript:apex.confirm(''&DELETE_MSG.'',''DELETE_ALL'')'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_worksheet_notify',
'where security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48507810647810417)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(48027402901804000)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_worksheet_notify',
'where security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48508132288810418)
,p_branch_action=>'f?p=&FLOW_ID.:92:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48507810647810417)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48508824512829187)
,p_branch_name=>'Go To Page 92'
,p_branch_action=>'f?p=&FLOW_ID.:92:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48508510217829186)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(172208015461138088)
,p_branch_name=>'Go To Page &LAST_VIEW.'
,p_branch_action=>'f?p=&FLOW_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48510019137850696)
,p_validation_name=>'must select notification to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Subscription must be selected to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(48507810647810417)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199175378251878429)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(48027402901804000)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199175471012878430)
,p_event_id=>wwv_flow_imp.id(1199175378251878429)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48507407746800061)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for l_ir_sub in (',
'        select id',
'        from wwv_flow_worksheet_notify',
'        where id = wwv_flow.g_f01(i)',
'        and security_group_id = :WORKSPACE_ID )           ',
'    loop',
'        wwv_flow_ir.builder_delete_subscription(',
'            p_workspace_id    => :WORKSPACE_ID,',
'            p_subscription_id => l_ir_sub.id );',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to remove subscription.'
,p_process_when_button_id=>wwv_flow_imp.id(48507810647810417)
,p_process_success_message=>'The subscription(s) removed.'
,p_internal_uid=>48507407746800061
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48509131688835426)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete all'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_ir_sub in (',
'    select id',
'      from wwv_flow_worksheet_notify',
'     where security_group_id = :WORKSPACE_ID )           ',
'loop',
'    wwv_flow_ir.builder_delete_subscription (',
'        p_workspace_id     => :WORKSPACE_ID,',
'        p_subscription_id  => l_ir_sub.id );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete subscriptions.'
,p_process_when_button_id=>wwv_flow_imp.id(48508510217829186)
,p_process_success_message=>'All subscriptions for the current workspace deleted.'
,p_internal_uid=>48509131688835426
);
end;
/
prompt --application/pages/page_00093
begin
wwv_flow_imp_page.create_page(
 p_id=>93
,p_name=>'Page Views by Interactive Report'
,p_alias=>'PAGE-VIEWS-BY-INTERACTIVE-REPORT'
,p_step_title=>'Page Views by Interactive Report'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196294221377763742)
,p_plug_name=>'Page Views by Interactive Report'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P93a */',
'       x.application_id,',
'       x.page_id,',
'       x.report_id,',
'       x.report_type,',
'       x.report_name,',
'       x.owner,',
'       x.userid,',
'       x.workspace,',
'       max(x.time_stamp) maxts',
'from',
'(select l.flow_id application_id,',
'       l.step_id page_id,',
'       l.ir_report_id report_id,',
'       case when r.is_default = ''Y''then ',
'            decode(r.application_user,',
'                   ''APXWS_DEFAULT'',sm.primary_def, ',
'                   ''APXWS_ALTERNATIVE'',sm.alt_def)',
'            when r.is_default = ''N'' and r.status = ''PUBLIC'' then',
'                sm.spublic',
'            when r.is_default = ''N'' and r.status = ''PRIVATE'' then',
'                 sm.private',
'       end report_type, ',
'       case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'           wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'       else',
'           r.name',
'       end report_name,',
'       decode(r.application_user,',
'              ''APXWS_DEFAULT'',null,',
'              ''APXWS_ALTERNATIVE'',null,',
'              r.application_user) owner,              ',
'       l.time_stamp,',
'       l.userid,',
'       (select short_name from wwv_flow_companies where provisioning_company_id=l.security_group_id) workspace',
'from wwv_flow_activity_log l,',
'     wwv_flow_worksheets w,',
'     wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary_def,',
'             wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alt_def,             ',
'             wwv_flow_lang.system_message(''SAVED_REPORTS.PRIVATE'') private,',
'             wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') spublic',
'      from dual) sm     ',
'where w.id = r.worksheet_id',
'and w.flow_id = l.flow_id',
'and w.page_id = l.step_id',
'and l.ir_report_id = r.id',
'and w.security_group_id = :flow_security_group_id',
'and l.ir_report_id is not null) x',
'group by x.application_id,x.page_id,x.report_id,x.report_type,x.report_name,x.owner, x.userid, x.workspace'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(196294324251763742)
,p_name=>'Page Views by Interactive Report'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196294501230763753)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196294602758763754)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196294717883763755)
,p_db_column_name=>'REPORT_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Report Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196294832326763755)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Report Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196294901177763756)
,p_db_column_name=>'REPORT_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Report Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196295028099763757)
,p_db_column_name=>'OWNER'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196333027540154323)
,p_db_column_name=>'USERID'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Viewed By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196350416449425550)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>':flow_security_group_id = 10'
,p_display_condition2=>'PLSQL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196295106259763758)
,p_db_column_name=>'MAXTS'
,p_display_order=>9
,p_column_identifier=>'G'
,p_column_label=>'Last View'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(196295219052764029)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1311326669536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION_ID:PAGE_ID:REPORT_TYPE:REPORT_NAME:OWNER:USERID:WORKSPACE:MAXTS'
,p_sort_column_1=>'MAXTS'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196335608456196129)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196336009280205827)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(196335608456196129)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.:93,RIR::'
);
end;
/
prompt --application/pages/page_00095
begin
wwv_flow_imp_page.create_page(
 p_id=>95
,p_name=>'Create Multiple Users'
,p_alias=>'CREATE-MULTIPLE-USERS'
,p_step_title=>'Create Multiple Users'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(718401914085176458)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_users.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(487003305223414569)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(487004000637432136)
,p_name=>'Valid Users'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 username, c002 email',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No valid email addresses found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(487004330571432146)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>1
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(487004403742432150)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>2
,p_column_heading=>'Email'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(487004809987434849)
,p_name=>'Invalid Users'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 username, c002 email, c003 error',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_INVALID''',
'order by c001'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No invalid data found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(487005024748434852)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>1
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(487005101831434852)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>2
,p_column_heading=>'Email'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(487040628734818656)
,p_query_column_id=>3
,p_column_alias=>'ERROR'
,p_column_display_sequence=>3
,p_column_heading=>'Error'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(755295582942836821)
,p_plug_name=>'Create Multiple Users'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720159283194358177)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(487006116960465275)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(487003305223414569)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(487006524000465276)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(487003305223414569)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Valid Users'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(487006324723465276)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(487003305223414569)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(487084306271190673)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(487041729211828298)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Users'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_api.create_user_from_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_web_password              => :P99_WEB_PASSWORD,',
'    p_allow_access_to_schemas   => :P99_ALLOW_ACCESS_TO_SCHEMAS,',
'    p_default_schema            => :P99_DEFAULT_SCHEMA,',
'    p_developer                 => :P99_DEVELOPER,',
'    p_admin                     => :P99_ADMIN,',
'    p_allow_app_building_yn     => nvl(:P99_ALLOW_APP_BUILDING_YN,''Y''),',
'    p_allow_sql_workshop_yn     => nvl(:P99_ALLOW_SQL_WORKSHOP_YN,''Y''),',
'    p_allow_team_development_yn => nvl(:P99_ALLOW_TEAM_DEVELOPMENT_YN,''Y''));',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unexpected Error Creating Users'
,p_process_success_message=>'Users Created'
,p_internal_uid=>487041729211828298
);
end;
/
prompt --application/pages/page_00096
begin
wwv_flow_imp_page.create_page(
 p_id=>96
,p_name=>'Request Service - Identify Request'
,p_alias=>'REQUEST-SERVICE-IDENTIFY-REQUEST'
,p_step_title=>'Request Service - Identify Request'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215667724760013351)
,p_step_template=>wwv_flow_imp.id(718401914085176458)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168274915363961081)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720186138525572350)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(47297014014256767)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(720190141563578035)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168275112410961086)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(47296115483238304)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168278722008976619)
,p_plug_name=>'Identify Request'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(185602275935580522)
,p_name=>'Service Request History'
,p_template=>wwv_flow_imp.id(829458533922680656)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SERVICE_NAME,',
'       SERVICE_ATTRIBUTE_1,',
'       REQUESTED_ON,',
'       REQUESTED_BY,',
'       LAST_STATUS_CHANGE_ON,',
'       LAST_STATUS_CHANGE_BY,',
'       REQUEST_STATUS,',
'       case',
'       when request_comments is null',
'       then null',
'       when regexp_like(request_comments,''^\d+$'')',
'       then wwv_flow_lang.system_message (',
'                ''APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'',',
'                request_comments )',
'       else request_comments',
'       end request_comments',
'  from WWV_FLOW_PROVISION_SERICE_MOD',
' where security_group_id = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(770829717235300818)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4391117861432846649)
,p_query_column_id=>1
,p_column_alias=>'SERVICE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Requested Change'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(784569817799474890)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4391117950492846650)
,p_query_column_id=>2
,p_column_alias=>'SERVICE_ATTRIBUTE_1'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(829739099475116201)
,p_query_column_id=>3
,p_column_alias=>'REQUESTED_ON'
,p_column_display_sequence=>3
,p_column_heading=>'Requested On'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(829739142343116202)
,p_query_column_id=>4
,p_column_alias=>'REQUESTED_BY'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(829739231203116203)
,p_query_column_id=>5
,p_column_alias=>'LAST_STATUS_CHANGE_ON'
,p_column_display_sequence=>5
,p_column_heading=>'Last Status Change On'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(829739377532116204)
,p_query_column_id=>6
,p_column_alias=>'LAST_STATUS_CHANGE_BY'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(829739479526116205)
,p_query_column_id=>7
,p_column_alias=>'REQUEST_STATUS'
,p_column_display_sequence=>7
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(378143515851142224)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(829739545295116206)
,p_query_column_id=>8
,p_column_alias=>'REQUEST_COMMENTS'
,p_column_display_sequence=>8
,p_column_heading=>'Comments'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208402307523310453)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752114026620695876)
,p_plug_name=>'Request Service'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720159283194358177)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168290619658231382)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208402307523310453)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168290808223231383)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208402307523310453)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168291020616231383)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208402307523310453)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168314820535795538)
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P96_SERVICE'
,p_branch_condition_text=>'STORAGE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168315100234799114)
,p_branch_action=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P96_SERVICE'
,p_branch_condition_text=>'TERMINATION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168315408545801461)
,p_branch_name=>'Go To Page 48'
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:48::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P96_SERVICE'
,p_branch_condition_text=>'SCHEMA'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168277330803961102)
,p_branch_action=>'69'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(168291628100243235)
,p_name=>'P96_SERVICE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(168278722008976619)
,p_item_default=>'STORAGE'
,p_prompt=>'Identify the type of service you would like to request:'
,p_source=>'STORAGE'
,p_source_type=>'STATIC'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'REQEUEST SERVICE'
,p_lov=>'.'||wwv_flow_imp.id(168289505113227142)||'.'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a service change request and click <strong>Next</strong>.'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00097
begin
wwv_flow_imp_page.create_page(
 p_id=>97
,p_name=>'Native Component Utilization Chart'
,p_alias=>'NATIVE-COMPONENT-UTILIZATION-CHART'
,p_step_title=>'Native Component Utilization Chart'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'04'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166213497169830380)
,p_plug_name=>'Native Component Utilization Chart'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(166213878845830380)
,p_region_id=>wwv_flow_imp.id(166213497169830380)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'value-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>false
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(166215517076830381)
,p_chart_id=>wwv_flow_imp.id(166213878845830380)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''FLASHMAP'', wwv_flow_lang.system_message(''FLASHMAP''),',
'           ''FLASH_MAP'', wwv_flow_lang.system_message(''FLASHMAP''),',
'           ''FLASH_CHART5'', wwv_flow_lang.system_message(''FLASH_CHART5''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           ''FACETED_SEARCH'',wwv_flow_lang.system_message(''FACETED_SEARCH''),',
'           ''FORM'',wwv_flow_lang.system_message(''FORM''),',
'           ''CARDS'',wwv_flow_lang.system_message(''REGION_NAME.NATIVE_CARDS''),',
'           ''DYNAMIC_CONTENT'', wwv_flow_lang.system_message(''REGION_NAME.NATIVE_DYNAMIC_CONTENT''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from   wwv_flow_page_plugs r',
'where  plug_source_type not like ''PLUGIN%'' and ',
'       security_group_id = :flow_security_group_id',
'group by substr(plug_source_type,8)',
'order by 2 desc',
''))
,p_max_row_count=>1000
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_group_short_desc_column_name=>'REGION_TYPE'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(166214383419830380)
,p_chart_id=>wwv_flow_imp.id(166213878845830380)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>true
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(166214910253830381)
,p_chart_id=>wwv_flow_imp.id(166213878845830380)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00098
begin
wwv_flow_imp_page.create_page(
 p_id=>98
,p_name=>'Saved Interactive Reports'
,p_alias=>'SAVED-INTERACTIVE-REPORTS'
,p_step_title=>'Saved Interactive Reports'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_ir_notifi.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492167616838140245)
,p_plug_name=>'Saved Reports'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'case when r.is_default!=''Y'' or r.application_user!=''APXWS_DEFAULT'' then',
'    wwv_flow_item.checkbox(1, r.id,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''REPORT_LABEL'',case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'    wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'else',
'    wwv_flow_escape.html(r.name)',
'end))',
'end id,',
'i.flow_id napp_id,',
'i.page_id npage_id,',
'i.region_id nregion_id,',
'(select plug_name from wwv_flow_page_plugs where id = i.region_id) region_name,',
'case when r.is_default = ''Y''then ',
'     decode(r.application_user,',
'            ''APXWS_DEFAULT'',sm.primary_def, ',
'            ''APXWS_ALTERNATIVE'',sm.alt_def)',
'     when r.is_default = ''N'' and r.status = ''PUBLIC'' then',
'         sm.spublic',
'     when r.is_default = ''N'' and r.status = ''PRIVATE'' then',
'         sm.private',
'end report_type, ',
'case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'    wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'else',
'    r.name',
'end name,',
'decode(r.application_user,',
'       ''APXWS_DEFAULT'',null,',
'       ''APXWS_ALTERNATIVE'',null,',
'       r.application_user) owner,',
'substr(r.description,1,50) description,        ',
'r.report_alias report_alias,',
'(select short_name from wwv_flow_companies where provisioning_company_id =r.security_group_id) workspace',
'from wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'(select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary_def,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alt_def,               ',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIVATE'') private,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') spublic',
' from sys.dual) sm',
'where r.worksheet_id = i.id',
'and r.session_id is null',
'and r.security_group_id = :flow_security_group_id',
'and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(492167702514140245)
,p_name=>'Saved Reports'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492167909521140253)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492168003007140253)
,p_db_column_name=>'NAPP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_link=>'f?p=4000:1:&SESSION.::NO:RP:FB_FLOW_ID,F4000_P1_FLOW:#NAPP_ID#,#NAPP_ID#'
,p_column_linktext=>'#NAPP_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492168331066140254)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page'
,p_column_link=>'f?p=4000:4500:&SESSION.::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:#NAPP_ID#,#NPAGE_ID#'
,p_column_linktext=>'#NPAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492168423761140254)
,p_db_column_name=>'NREGION_ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Region ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492168526042140254)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Region Name'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.:1:FB_FLOW_ID,F4000_P1_FLOW,FB_FLOW_PAGE_ID:#NAPP_ID#,#NAPP_ID#,#NPAGE_ID##5110:#NREGION_ID#'
,p_column_linktext=>'#REGION_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492168807889140255)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Report Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492168920154140255)
,p_db_column_name=>'NAME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Report Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492169023789140255)
,p_db_column_name=>'OWNER'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492169119427140255)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492169224320140256)
,p_db_column_name=>'REPORT_ALIAS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Report Alias'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492169405190140256)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Workspace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>':flow_security_group_id = 10'
,p_display_condition2=>'PLSQL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(492169621818140504)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1311510827536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAPP_ID:NPAGE_ID:REGION_NAME:REPORT_TYPE:NAME:REPORT_ALIAS:OWNER:WORKSPACE'
,p_sort_column_1=>'NAPP_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'NPAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'REPORT_TYPE'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(492130606552564654)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(492167616838140245)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(492130017533564651)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(492167616838140245)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_worksheet_rpts',
'where security_group_id = :flow_security_group_id',
'and session_id is null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(492131426696564661)
,p_branch_action=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(492130807596564657)
,p_validation_name=>'must select report to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Report must be selected to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(492130017533564651)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199175567534878431)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(492167616838140245)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199175632656878432)
,p_event_id=>wwv_flow_imp.id(1199175567534878431)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(492131213822564659)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for l_ir_rpt in (',
'        select id, worksheet_id',
'          from wwv_flow_worksheet_rpts',
'         where id = wwv_flow.g_f01(i)',
'           and security_group_id = :WORKSPACE_ID )',
'    loop',
'        wwv_flow_ir.builder_delete_saved_report (',
'            p_workspace_id => :WORKSPACE_ID,',
'            p_worksheet_id => l_ir_rpt.worksheet_id,',
'            p_report_id    => l_ir_rpt.id ) ;        ',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to remove report.'
,p_process_when_button_id=>wwv_flow_imp.id(492130017533564651)
,p_process_success_message=>'The report(s) removed.'
,p_internal_uid=>492131213822564659
);
end;
/
prompt --application/pages/page_00099
begin
wwv_flow_imp_page.create_page(
 p_id=>99
,p_name=>'Create Multiple Users'
,p_alias=>'CREATE-MULTIPLE-USERS1'
,p_step_title=>'Create Multiple Users'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(718401914085176458)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_help_text=>'AEADM/aadm_new_users_multi.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30327808490361225)
,p_plug_name=>'Users'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>24
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To create multiple users at once, enter or copy and paste email addresses separated by commas, semicolons, or new lines.  ',
'',
'<p>Note that the password you specify will be assigned to each user and users will need to change their passwords upon login.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(473029411149560842)
,p_plug_name=>'Account Privileges'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>34
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(473038025479574436)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(504234007342045185)
,p_plug_name=>'&F4350_PASSWORD_REGION_TITLE.'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>44
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(755295411614836820)
,p_plug_name=>'Create Multiple Users'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720159283194358177)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30328532039368082)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(473038025479574436)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30328722239368083)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(473038025479574436)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30329122127374620)
,p_branch_action=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30328117494363863)
,p_name=>'P99_USERS'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30327808490361225)
,p_prompt=>'List of Email Addresses'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter or copy and paste email addresses separated by commas, semicolons, or new lines. Note that if you copy and paste email addresses from email messages, extraneous text will be filtered out.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473029603549560853)
,p_name=>'P99_ALLOW_ACCESS_TO_SCHEMAS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_prompt=>'Accessible Schemas (null for all)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a colon-delimited list of schemas for which this developer has permissions when using the SQL Workshop. The list of schemas you enter here restricts the user to a subset of the full set of schemas provisioned for the workspace and determines wh'
||'at schema names the user sees in SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473030100858560866)
,p_name=>'P99_DEFAULT_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_cHeight=>1
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Specify the default schema used for data browsing, application creation, and SQL script execution. When using workspaces that have more than one schema available, this schema is the default for creating applications, performing SQL queries, and so on'
||'. This feature does not control security, only the user''s preference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473030704653560869)
,p_name=>'P99_DEVELOPER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_item_default=>'N'
,p_prompt=>'Users are developers'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DEVELOPER TYPE'
,p_lov=>'.'||wwv_flow_imp.id(19716823057593749)||'.'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_authentication_dev.can_edit_builder_users',
'  or wwv_flow_authentication_dev.get_internal_authentication = wwv_flow_authentication_dev.c_internal_scheme_db'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify if these users should have developer privileges. Developers can create and modify applications and database objects.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473031302367560872)
,p_name=>'P99_ADMIN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_item_default=>'N'
,p_prompt=>'Users are workspace administrators'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_authentication_dev.can_edit_builder_users ',
'  or wwv_flow_authentication_dev.get_internal_authentication = wwv_flow_authentication_dev.c_internal_scheme_db'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify if these users should have workspace administrator privileges. Like developers, workspace administrators can create and modify applications and database objects. Additionally, they can also manage user accounts, groups, and development servic'
||'es.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473031924854560874)
,p_name=>'P99_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'App Builder Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to the App Builder.<br>',
'<br>',
'An Administrator will always have access to the App Builder.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when App Builder Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473033110373560878)
,p_name=>'P99_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'SQL Workshop Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to SQL Workshop.<br>',
'<br>',
'An Administrator will always have access to SQL Workshop.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when SQL Workshop Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473033703172560879)
,p_name=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Team Development Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''Y'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a user has access to Team Development.<br>',
'<br>',
'An Administrator will always have access to Team Development.<br>',
'<br>',
'This attribute is always disabled when Team Development Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473035819699564808)
,p_name=>'P99_WEB_PASSWORD'
,p_is_required=>true
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(504234007342045185)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Password'
,p_post_element_text=>' <span class="instructiontext">Passwords are case sensitive</span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a password. Passwords are case sensitive. Developers can change their own passwords. Developers with Administrator privilege can change the passwords of users within the same workspace.'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 24-MAY-2001 18:02:15'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473036413910564809)
,p_name=>'P99_PASSWD_CONFIRM'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(504234007342045185)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Confirm Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the password again.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(486482110592743896)
,p_name=>'P99_MSG'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(486718608551113029)
,p_name=>'P99_STRIP_DOMAIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(30327808490361225)
,p_item_default=>'N'
,p_prompt=>'Usernames'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE.MULT.USER.STRIP.DOMAIN'
,p_lov=>'.'||wwv_flow_imp.id(486946000320608950)||'.'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include the full email address or exclude the domain name. Options include:',
'<ul>',
'<li>Set username to full email address - Includes the full email address.</li>',
'<li>Exclude @ domain as part of the username - Removes all text after the @ symbol (for example, <code>user1@example.com</code> becomes <code>user1</code>).</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(504099131099566705)
,p_name=>'P99_DISALLOW_APP_BUILDING'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_item_default=>'N'
,p_prompt=>'App Builder Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_app_building_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to the App Builder.<br>',
'<br>',
'An Administrator will always have access to the App Builder.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when App Builder Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(504113220550677208)
,p_name=>'P99_DISALLOW_SQL_WORKSHOP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'SQL Workshop Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_sql_workshop_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a developer has access to SQL Workshop.<br>',
'<br>',
'An Administrator will always have access to SQL Workshop.<br>',
'A Developer must have access to either the App Builder, the SQL Workshop, or both.<br>',
'<br>',
'This attribute is always disabled when SQL Workshop Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(504113703020681605)
,p_name=>'P99_DISALLOW_TEAM_DEVELOPMENT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(473029411149560842)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Team Development Access'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select 1 from WWV_FLOW_COMPANIES',
'                where provisioning_company_id = :flow_security_group_id',
'                  and NVL(allow_team_development_yn,''Y'') = ''N'') ',
'    loop',
'        return true;',
'    end loop;',
'    return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether a user has access to Team Development.<br>',
'<br>',
'An Administrator will always have access to Team Development.<br>',
'<br>',
'This attribute is always disabled when Team Development Access is disabled for the workspace by an Administrator.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(504139727785076630)
,p_validation_name=>'Developer must have Access'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF :P99_DEVELOPER = ''Y'' THEN',
'    IF :P99_ALLOW_APP_BUILDING_YN = ''N''',
'    AND :P99_ALLOW_SQL_WORKSHOP_YN = ''N'' THEN',
'      RETURN FALSE;',
'    END IF;',
'  END IF;',
'',
'  RETURN TRUE;',
'END;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'A Developer must have access to either the App Builder, the SQL Workshop, or both.'
,p_when_button_pressed=>wwv_flow_imp.id(30328722239368083)
,p_associated_item=>wwv_flow_imp.id(473030704653560869)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(487087823895242993)
,p_validation_name=>'Passwords match'
,p_validation_sequence=>20
,p_validation=>'P99_WEB_PASSWORD'
,p_validation2=>'&P99_PASSWD_CONFIRM.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'Password and confirmation do not match.'
,p_validation_condition=>'P99_WEB_PASSWORD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(30328722239368083)
,p_associated_item=>wwv_flow_imp.id(473035819699564808)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1617426223151257724)
,p_validation_name=>'Password Verification'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_separator_chars varchar2(20) := unistr(''\0009\000a\000d ,;:<>'');',
'begin',
'    if :P99_STRIP_DOMAIN = ''Y'' then',
'        l_separator_chars := l_separator_chars||''@'';',
'    end if;',
'    return wwv_flow_security.strong_password_validation(',
'          p_username       => -- extract 1st username',
'                              regexp_substr (',
'                                  :P99_users,',
'                                  ''^[''||l_separator_chars||'']+'' ),',
'          p_password       => :P99_WEB_PASSWORD,',
'          p_old_password   => null,',
'          p_workspace_name => wwv_flow_security.find_company_name(:WORKSPACE_ID));',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'xx'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10407122373361224)
,p_validation_name=>'Check email addresses for valid pattern'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_4350_ui.check_email_list_pattern(',
'           p_users_email => :P99_USERS );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address pattern found. Please provide a valid email addresses list.'
,p_when_button_pressed=>wwv_flow_imp.id(30328722239368083)
,p_associated_item=>wwv_flow_imp.id(30328117494363863)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504127119886904125)
,p_name=>'Set Admin Defaults'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_ADMIN'
,p_condition_element=>'P99_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_da_event_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SSC :',
'PLSQL EXPRESSION ',
'',
'not wwv_flow_authentication_dev.can_edit_builder_users'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504127423599904126)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DEVELOPER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504127611210904126)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DEVELOPER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504129619240932237)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504130425950943648)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DEVELOPER'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504128813221921032)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504128015861912409)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504130030321935430)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504130203441937125)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504129232615926716)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504128429367916303)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504129407812928935)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504128603179918211)
,p_event_id=>wwv_flow_imp.id(504127119886904125)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504136521242027451)
,p_name=>'Set Developer Defaults'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DEVELOPER'
,p_condition_element=>'P99_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504136819618027452)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504137000309027452)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504137606829032716)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504139120250055506)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504137400941031026)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504138910554052775)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504138003843041353)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504139504451060487)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'FALSE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150597732539090721)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150597942201090723)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'FALSE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150597836503090722)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(150598056886090724)
,p_event_id=>wwv_flow_imp.id(504136521242027451)
,p_event_result=>'FALSE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504142015280120362)
,p_name=>'Disable Disallow App Building'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DISALLOW_APP_BUILDING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504142315878120363)
,p_event_id=>wwv_flow_imp.id(504142015280120362)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DISALLOW_APP_BUILDING'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504142932249125214)
,p_name=>'Disable Disallow SQL Workshop'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DISALLOW_SQL_WORKSHOP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504143205311125215)
,p_event_id=>wwv_flow_imp.id(504142932249125214)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DISALLOW_SQL_WORKSHOP'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(504143702036135420)
,p_name=>'Disable Disallow Team Development'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DISALLOW_TEAM_DEVELOPMENT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(504144016081135421)
,p_event_id=>wwv_flow_imp.id(504143702036135420)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DISALLOW_TEAM_DEVELOPMENT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(486696024809616323)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create collection of user names'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_user_api.create_user_coll_from_csv (',
'    p_users => :p99_users,',
'    p_security_group_id => :flow_security_group_id,',
'    p_strip_domain => :P99_STRIP_DOMAIN );',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(30328722239368083)
,p_internal_uid=>486696024809616323
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(487181205520836565)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'init collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.CREATE_OR_TRUNCATE_COLLECTION (''BULK_USER_INVALID'');',
'wwv_flow_collection.CREATE_OR_TRUNCATE_COLLECTION (''BULK_USER_CREATE'');'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>487181205520836565
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_imp_page.create_page(
 p_id=>101
,p_name=>'Workspace Utilization'
,p_alias=>'WORKSPACE-UTILIZATION'
,p_step_title=>'Workspace Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_wrkspc_rprt.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168460915364538362)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179695032676844855)
,p_plug_name=>'Workspace Summary Report'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_workspace_reports.report_workspace_usage (',
'    p_security_group_id => :flow_security_group_id,',
'    p_time_frame_DWMY => :P101_REPORTING_PERIOD,',
'    p_date_format => :DATE_TIME_FORMAT);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180924728812199858)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This report summarizes workspace activity and contents.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168466525819721064)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168460915364538362)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(180927325396227273)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168460915364538362)
,p_button_name=>'EMAIL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Email'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.:83:P83_REPORTING_PERIOD:&P101_REPORTING_PERIOD.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168906114987545321)
,p_branch_action=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180661715523136421)
,p_name=>'P101_REPORTING_PERIOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(168460915364538362)
,p_item_default=>'D'
,p_prompt=>'Show'
,p_source=>'D'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_imp.id(180662003103161233)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a time interval.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(188411624638171691)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'21'
,p_compute_when=>'LAST_VIEW'
,p_compute_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_00102
begin
wwv_flow_imp_page.create_page(
 p_id=>102
,p_name=>'Preferences'
,p_alias=>'PREFERENCES'
,p_page_mode=>'MODAL'
,p_step_title=>'Preferences'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="javascript">',
'<!--',
'function confirmaction(){',
'        if (document.wwv_flow.F4350_P56_EMAIL_ADDRESS.value != document.wwv_flow.F4350_P56_ORG_EMAIL_ADDRESS.value){',
'	if(confirm("Are you sure you want to change the email address?")){',
'		doSubmit(''ApplyChanges'') ;',
'          }',
'        }else{',
'            doSubmit(''ApplyChanges'') ;',
'        }',
' }',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(485889499804058937)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'480'
,p_dialog_width=>'720'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/aadm_users.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(488532238706405715)
,p_plug_name=>'Edit Preferences'
,p_region_css_classes=>'a-Form a-Form--small a-Form--dialog'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_imp.id(1939532588110833)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 19-FEB-2000 22:09:25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(488545976130405767)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(488546592296405774)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(488545976130405767)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4350_P102_USER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(488546199036405767)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(488545976130405767)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2710247103383927)
,p_name=>'P102_REVOKE_AI_CONSENT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(488532238706405715)
,p_prompt=>'Revoke Generative AI Consent'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'        wwv_flow_ai.is_enabled',
'and not wwv_flow_ai.is_user_consent_needed'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When using Generative AI features within the APEX development environment, you will be asked to provide consent. This setting enables you to revoke your consent. If you choose to revoke your consent, APEX will prompt you for consent again the next ti'
||'me you attempt to utilize Generative AI.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(385808991793243614)
,p_name=>'P102_WINDOW_MGMT_MODE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(488532238706405715)
,p_prompt=>'Run application in new window'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_preferences.get_preference(''APEX_WINDOW_MGMT_MODE''), ''FOCUS'') = ''FOCUS'' then',
'  return ''Y'';',
'else',
'  return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify how &PRODUCT_NAME. manages windows or tabs when running applications from the App Builder.</p>',
'<p>This option only impacts you when using Mozilla Firefox and Microsoft Internet Explorer, and has no effect when ',
'using other browsers, such as Google Chrome and Apple Safari. When set to <strong>On</strong>, the default,',
'browser preferences are ignored and a new window always opens. When set to <strong>Off</strong>, the ',
'runtime application opens in a new window or tab based on Browser preferences. ',
'Mozilla Firefox and Microsoft Internet Explorer generally do not set focus to another tab in the same',
'window, except when that tab is first launched.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(488533148621405743)
,p_name=>'F4350_P102_USER_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(488532238706405715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Username'
,p_source=>'USER_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'a-Form-field a-Form-field--readOnly'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the username used to log in to the system. Usernames have these restrictions:</p>',
'<ul>',
'    <li>maximum length of 100 characters</li>',
'    <li>no spaces</li>',
'    <li>only these special characters are permitted: @ and periods (.)</li>',
'</ul>',
'<p>The username may also be used to reference user activity using the monitor applications. The bind variable <code>:APP_USER</code> returns the value of the current user when building applications.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(488536626516405749)
,p_name=>'P102_DEFAULT_DATE_FORMAT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(488532238706405715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Date Format'
,p_source=>'DEFAULT_DATE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the default Oracle date format for the user.  This will control the default date format within SQL Workshop.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(488537560001405751)
,p_name=>'F4350_P102_DEFAULT_SCHEMA'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(488532238706405715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Schema'
,p_source=>'DEFAULT_SCHEMA'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'',
'from   wwv_flow_company_schemas',
'',
'where  security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_read_only_when=>'not wwv_flow_authentication_dev.can_edit_builder_users'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Specifies the default schema used for data browsing, application creation, and SQL script execution. When using workspaces that have more than one schema available, this schema is the default for creating applications, performing SQL queries, and so '
||'on. This feature does not control security, only the user''s preference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(517712894932154580)
,p_name=>'F4350_P102_USER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(488532238706405715)
,p_use_cache_before_default=>'NO'
,p_source=>'USER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(655324308017394132)
,p_name=>'P102_UNICODE_CSV_DOWNLOAD'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(488532238706405715)
,p_item_default=>'N'
,p_prompt=>'Unicode CSV Downloads'
,p_source=>'F4500_CSV_DOWNLOAD_UNICODE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify whether to provide SQL Workshop CSV downloads in Unicode. This does only affect SQL Workshop and not custom applications.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(702957815921571307)
,p_name=>'P102_WINDOW_MGMT_SHARE_WINDOW'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(488532238706405715)
,p_prompt=>'Use single window to run all applications'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_preferences.get_preference(''APEX_WINDOW_MGMT_SHARE_WINDOW'') = ''Y'' then',
'  return ''Y'';',
'else',
'  return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether different applications reuse the same application runtime window or tab.</p>',
'<p>If set to <strong>On</strong> then each application you run, from the App Builder, ',
'will reuse a window or tab used for running the previous application.',
'If set to <strong>Off</strong> then each application you run will be opened in its own window or tab.</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(517711537090061237)
,p_computation_sequence=>10
,p_computation_item=>'F4350_P102_USER_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_security.g_user'
,p_compute_when_type=>'NEVER'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(488574979206479852)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(488546199036405767)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(488575269793479854)
,p_event_id=>wwv_flow_imp.id(488574979206479852)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(488836287971036219)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :F4350_P102_DEFAULT_SCHEMA is not null then',
'        wwv_flow_sw_api.check_priv(p_schema=>:F4350_P102_DEFAULT_SCHEMA);',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(488546592296405774)
,p_internal_uid=>488836287971036219
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(488835539302014014)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Save User Preferences'
,p_attribute_02=>'WWV_FLOW_FND_USER'
,p_attribute_03=>'F4350_P102_USER_ID'
,p_attribute_04=>'USER_ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    user_name         = :APP_USER',
'and security_group_id = :WORKSPACE_ID'))
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(488546592296405774)
,p_process_success_message=>'Preferences saved.'
,p_internal_uid=>488835539302014014
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(488554112604405798)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Session Date Format'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'  --',
'  -- If the current user is the one being edited in this workspace, then also',
'  -- update the session state value for the user default date format',
'  --',
'  if :APP_USER = upper(:F4350_P102_USER_NAME) then',
'      if trim(:P102_DEFAULT_DATE_FORMAT) is null then',
'          :G_USER_DEFAULT_DATE_FORMAT := :DATE_FORMAT;      ',
'      else',
'          :G_USER_DEFAULT_DATE_FORMAT := :P102_DEFAULT_DATE_FORMAT;',
'      end if;',
'      HTMLDB_UTIL.SET_SESSION_STATE (''G_USER_DEFAULT_DATE_FORMAT'',v(''G_USER_DEFAULT_DATE_FORMAT''));',
'  end if;',
'  ',
'  commit;',
'  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error updating user.'
,p_process_when_button_id=>wwv_flow_imp.id(488546592296405774)
,p_process_success_message=>'User "&F4350_P102_USER_NAME." updated.'
,p_internal_uid=>488554112604405798
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(385809079149243615)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Window Mgmt Preferences'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_preferences.set_preference(',
'        p_preference => ''APEX_WINDOW_MGMT_MODE'',',
'        p_value      => case when :P102_WINDOW_MGMT_MODE = ''Y'' then ''FOCUS'' ',
'                          else ''BROWSER'' ',
'                        end);',
'',
'    wwv_flow_preferences.set_preference(',
'        p_preference => ''APEX_WINDOW_MGMT_SHARE_WINDOW'',',
'        p_value      => :P102_WINDOW_MGMT_SHARE_WINDOW );',
'',
'    wwv_flow_session_state.clear_all_state_for_name(',
'        p_item_name      => ''P0_WINDOW_MGMT_MODE'',',
'        p_application_id => 4000 );',
'',
'    wwv_flow_session_state.clear_all_state_for_name(',
'        p_item_name      => ''P0_WINDOW_MGMT_SHARE_WINDOW'',',
'        p_application_id => 4000 );',
'',
'    wwv_flow_session_state.clear_all_state_for_name(',
'        p_item_name      => ''P0_WINDOW_MGMT_MODE'',',
'        p_application_id => 4750 );',
'',
'    wwv_flow_session_state.clear_all_state_for_name(',
'        p_item_name      => ''P0_WINDOW_MGMT_SHARE_WINDOW'',',
'        p_application_id => 4750 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(488546592296405774)
,p_internal_uid=>385809079149243615
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(655324481856394133)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Unicode CSV Download preference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P102_UNICODE_CSV_DOWNLOAD = ''Y'' then',
'        wwv_flow_preferences.set_preference(',
'            p_preference => ''F4500_CSV_DOWNLOAD_UNICODE'',',
'            p_value      => ''Y'' );',
'    else',
'        wwv_flow_preferences.remove_preference(',
'            p_preference => ''F4500_CSV_DOWNLOAD_UNICODE'' );',
'    end if;',
'end;',
'        '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(488546592296405774)
,p_internal_uid=>655324481856394133
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2709364720383918)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Revoke AI User Consent'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ai.revoke_user_consent (',
'    p_user_name      => :APP_USER,',
'    p_application_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P102_REVOKE_AI_CONSENT'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_process_success_message=>'Generative AI consent revoked.'
,p_internal_uid=>2709364720383918
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(690210945477382214)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>690210945477382214
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(488575454565484164)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>488575454565484164
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(488576740665547455)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch User Information'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FND_USER'
,p_attribute_03=>'F4350_P102_USER_ID'
,p_attribute_04=>'USER_ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    user_name         = :APP_USER',
'and security_group_id = :WORKSPACE_ID'))
,p_internal_uid=>488576740665547455
);
end;
/
prompt --application/pages/page_00103
begin
wwv_flow_imp_page.create_page(
 p_id=>103
,p_name=>'Application Hash by Day'
,p_alias=>'APPLICATION-HASH-BY-DAY'
,p_step_title=>'Application Hash by Day'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(381353083347254854)
,p_plug_name=>'Application Hash by Day'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    APPLICATION_NAME,',
'    LOG_DAY,',
'    WORKSPACE_ID,',
'    APPLICATION_ID,',
'    nvl(decode(instr(additional_attributes,''"hash":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8),'','')-2)),null)  application_hash',
'from  WWV_FLOW_LOG_HISTORY ',
'where workspace_id = :flow_security_group_id',
'      and instr(additional_attributes,''"hash":'') > 0'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Application Hash by Day'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(381353182660254854)
,p_name=>'Activity Log Summary'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>381353182660254854
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219094448124410000)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219094853991410000)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219095282350410001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219094052812410000)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>184
,p_column_identifier=>'V'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(219101612145410007)
,p_db_column_name=>'APPLICATION_HASH'
,p_display_order=>194
,p_column_identifier=>'W'
,p_column_label=>'Application Hash'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(381355162363255039)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'2191076'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:WORKSPACE_ID:APPLICATION_ID:APPLICATION_NAME:APPLICATION_HASH:'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219108010573410014)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(381353083347254854)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00104
begin
wwv_flow_imp_page.create_page(
 p_id=>104
,p_name=>'Manage Interactive Report Settings'
,p_alias=>'MANAGE-INTERACTIVE-REPORT-SETTINGS'
,p_step_title=>'Manage Interactive Report Settings'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_ir_notifi.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(493061118723051127)
,p_plug_name=>'Manage Interactive Report Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(41809121808367332)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692750374873071023)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(493062125087062445)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>These utilities allow for the reporting and deletion of saved interactive report settings and email subscriptions.  These settings can be created by end users using interactive reports.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_00105
begin
wwv_flow_imp_page.create_page(
 p_id=>105
,p_name=>'Workspace Environment Banner'
,p_alias=>'ENVIRONMENT-BANNER'
,p_page_mode=>'MODAL'
,p_step_title=>'Workspace Environment Banner'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_dialog_width=>'640'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145785163484283101)
,p_plug_name=>'Define Workspace Environment Banner'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>24
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145785616730283106)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>24
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177716258227191001)
,p_plug_name=>'Instance Banner Enabled'
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>14
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Note: The environment banner for this &PRODUCT_NAME. instance is currently <strong>enabled</strong>. ',
'You can override this instance-level banner by setting a workspace-level banner below.'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'coalesce( wwv_flow_platform.get_preference( ''ENV_BANNER_ENABLE'' ), ''N'' ) = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(145786002247283110)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(145785616730283106)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(145785711767283107)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(145785616730283106)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(145793944165217003)
,p_branch_name=>'Go To Last App Page'
,p_branch_action=>'f?p=&P105_LAST_APP_ID.:&P105_LAST_PAGE_ID.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(37558976854756301)
,p_name=>'P105_LAST_APP_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(145785163484283101)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(37559074768756302)
,p_name=>'P105_LAST_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(145785163484283101)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(145785230216283102)
,p_name=>'P105_ENABLE_BANNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(145785163484283101)
,p_prompt=>'Enable Banner'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to enable environment banner for this workspace.</p>',
'<p>When enabled, the banner will display throughout the &PRODUCT_NAME. development environment.</p>'))
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(145785403480283104)
,p_name=>'P105_BANNER_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(145785163484283101)
,p_prompt=>'Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a short descriptive label that will be displayed in this environment banner. For example:</p>',
'<ul>',
'    <li>APEX 21.2 Apps</li>',
'    <li>Marvel UAT</li>',
'    <li>JKALLMAN Prod Env</li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(145785572990283105)
,p_name=>'P105_BANNER_COLOR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(145785163484283101)
,p_prompt=>'Color'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P105_BANNER_COLORS'
,p_lov=>'.'||wwv_flow_imp.id(2923311877329862)||'.'
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_css_classes=>'a-EnvBanner-colorSelector'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select a background color for the banner message. This color will also be applied to the developer toolbar.'
,p_attribute_01=>'8'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(883418688394822206)
,p_name=>'P105_BANNER_POS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(145785163484283101)
,p_prompt=>'Position'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P105_BANNER_POS'
,p_lov=>'.'||wwv_flow_imp.id(146455139760592304)||'.'
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the banner display position.'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(145793748330217001)
,p_validation_name=>'if enabled, label required'
,p_validation_sequence=>10
,p_validation=>'P105_BANNER_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P105_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(145786002247283110)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(145793847377217002)
,p_validation_name=>'if enabled, color required'
,p_validation_sequence=>20
,p_validation=>'P105_BANNER_COLOR'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P105_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(145786002247283110)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(145785800019283108)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(145785711767283107)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(145785965618283109)
,p_event_id=>wwv_flow_imp.id(145785800019283108)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(145802697662189309)
,p_name=>'toggle banner configuration'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P105_ENABLE_BANNER'
,p_condition_element=>'P105_ENABLE_BANNER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(145802764549189310)
,p_event_id=>wwv_flow_imp.id(145802697662189309)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P105_BANNER_POS,P105_BANNER_LABEL,P105_BANNER_COLOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(145802834921189311)
,p_event_id=>wwv_flow_imp.id(145802697662189309)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P105_BANNER_POS,P105_BANNER_LABEL,P105_BANNER_COLOR'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(145802598642189308)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save env banner'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_companies',
'   set env_banner_yn = :P105_ENABLE_BANNER,',
'       env_banner_label = :P105_BANNER_LABEL,',
'       env_banner_color = :P105_BANNER_COLOR,',
'       env_banner_pos   = :P105_BANNER_POS',
' where PROVISIONING_COMPANY_ID = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save workspace level environment banner.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'The workspace level environment banner saved.'
,p_internal_uid=>145802598642189308
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(145802470467189307)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch workspace env banner'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_env_banner in (',
'    select env_banner_yn,',
'           env_banner_label,',
'           env_banner_color,',
'           env_banner_pos',
'      from wwv_flow_companies',
'     where provisioning_company_id = :flow_security_group_id )',
'loop',
'    :P105_ENABLE_BANNER := l_env_banner.env_banner_yn;',
'    :P105_BANNER_LABEL  := l_env_banner.env_banner_label;',
'    :P105_BANNER_COLOR  := l_env_banner.env_banner_color;',
'    :P105_BANNER_POS    := coalesce( l_env_banner.env_banner_pos, ''LEFT'' );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>145802470467189307
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(145803082296189313)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'if disabled, set pos, label, color to NULL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P105_BANNER_POS   := null;',
':P105_BANNER_LABEL := null;',
':P105_BANNER_COLOR := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(145786002247283110)
,p_process_when=>'P105_ENABLE_BANNER'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'N'
,p_internal_uid=>145803082296189313
);
end;
/
prompt --application/pages/page_00107
begin
wwv_flow_imp_page.create_page(
 p_id=>107
,p_name=>'Archive of Purged Task Files'
,p_alias=>'PURGED-TASKS-FILES'
,p_step_title=>'Archive of Purged Task Files'
,p_reload_on_submit=>'A'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(215677404159045218)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_help_text=>'Files containing archive of purged human tasks in JSON format.'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1705561586273908)
,p_plug_name=>'Purged Task Files'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1, wwv_flow_escape.html(id)) as cb,',
'       id,',
'       security_group_id,',
'       filename,',
'       mime_type,',
'       round( sys.dbms_lob.getLength(blob_content))  as file_size,',
'       file_charset,',
'       sys.dbms_lob.getLength(blob_content) as blob_content,',
'       last_updated             as updated,',
'       lower(updated_by)        as updated_by,',
'       created_on               as created,',
'       lower(created_by)        as created_by',
'  from wwv_flow_file_objects$',
' where security_group_id = :WORKSPACE_ID',
'   and file_type         = ''TASKS_ARCHIVE'''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Purged Task Files'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1705615197273909)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Tasks have been purged yet for this workspace.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>1705615197273909
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1705795696273910)
,p_db_column_name=>'CB'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1705800085273911)
,p_db_column_name=>'ID'
,p_display_order=>20
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1705982531273912)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1706004830273913)
,p_db_column_name=>'FILENAME'
,p_display_order=>40
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1706156983273914)
,p_db_column_name=>'MIME_TYPE'
,p_display_order=>50
,p_column_identifier=>'A'
,p_column_label=>'Mime Type'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2261739976557313)
,p_db_column_name=>'FILE_SIZE'
,p_display_order=>60
,p_column_identifier=>'B'
,p_column_label=>'File Size'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1706300262273916)
,p_db_column_name=>'FILE_CHARSET'
,p_display_order=>70
,p_column_identifier=>'A'
,p_column_label=>'File Charset'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1706431010273917)
,p_db_column_name=>'BLOB_CONTENT'
,p_display_order=>80
,p_column_identifier=>'A'
,p_column_label=>'Archive File'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'DOWNLOAD:WWV_FLOW_FILE_OBJECTS$:BLOB_CONTENT:ID:SECURITY_GROUP_ID:MIME_TYPE:FILENAME:::attachment:#FILENAME#:'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1706527283273918)
,p_db_column_name=>'UPDATED'
,p_display_order=>90
,p_column_identifier=>'A'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1706691092273919)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>100
,p_column_identifier=>'A'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1706793474273920)
,p_db_column_name=>'CREATED'
,p_display_order=>110
,p_column_identifier=>'A'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1706877360273921)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>120
,p_column_identifier=>'A'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2400250319932910)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'24003'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CB:BLOB_CONTENT:FILE_SIZE:CREATED:CREATED_BY:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1708318183273936)
,p_plug_name=>'Archive of Purged Task Files'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Purged Tasks Files contain all completed, cancelled and errored tasks across the workspace archived in the form of JSON. </p>',
'',
'<p>Use this page to download and delete the purged tasks files.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1706955558273922)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1705561586273908)
,p_button_name=>'DELETE_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Delete All'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1707078466273923)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1705561586273908)
,p_button_name=>'DELETE_CHECKED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1707160314273924)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1705561586273908)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:107:&SESSION.::&DEBUG.:107,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1707235566273925)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1705561586273908)
,p_button_name=>'DOWNLOAD_ZIP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Download Zip'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1707374159273926)
,p_name=>'Delete All'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1706955558273922)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1707499941273927)
,p_event_id=>wwv_flow_imp.id(1707374159273926)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all files?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1707630582273929)
,p_event_id=>wwv_flow_imp.id(1707374159273926)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_ALL'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1707793762273930)
,p_name=>'Delete Checked'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1707078466273923)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1707870041273931)
,p_event_id=>wwv_flow_imp.id(1707793762273930)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all the checked files?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1707997360273932)
,p_event_id=>wwv_flow_imp.id(1707793762273930)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_CHECKED'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1708040431273933)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_DOWNLOAD'
,p_process_name=>'Download Zip'
,p_attribute_01=>'Y'
,p_attribute_02=>'f&WORKSPACE_ID._purged_task_files.zip'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select blob_content,',
'       filename',
'  from wwv_flow_file_objects$',
' where security_group_id = :WORKSPACE_ID',
'   and file_type = ''TASKS_FILE'''))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1707235566273925)
,p_internal_uid=>1708040431273933
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1708139847273934)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete All'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_file_objects$',
' where file_type = ''TASKS_FILE''',
'   and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1706955558273922)
,p_process_success_message=>'Files deleted'
,p_internal_uid=>1708139847273934
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1708205185273935)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'forall i in 1 .. wwv_flow.g_f01.count',
'    delete from wwv_flow_file_objects$',
'     where id = wwv_flow.g_f01(i)',
'       and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1707078466273923)
,p_process_success_message=>'Files Deleted'
,p_internal_uid=>1708205185273935
);
end;
/
prompt --application/pages/page_00110
begin
wwv_flow_imp_page.create_page(
 p_id=>110
,p_name=>'Links'
,p_alias=>'LINKS'
,p_step_title=>'Links'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(692763410753114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_protection_level=>'C'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1647568036649818)
,p_plug_name=>'Extension Links'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_location=>null
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Extension Links are URLs to an external site, an Oracle APEX application in another workspace, or an application in the current workspace that can be added to the Extension Menu within the Administration menu in the main toolbar. Extension Links w'
||'ill always open in a new browser tab, and support a specific set of substitution strings.</p>',
'<p>For more information on link URLs and a list of available substitution strings, reference the column help.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4107708538590219)
,p_plug_name=>'Links'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       url,',
'       description,',
'       display_sequence,',
'       is_public',
'  from wwv_extension_links',
' where security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Links'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802363032892302)
,p_name=>'IS_PUBLIC'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_PUBLIC'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Public'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(157815226475866526)
,p_lov_display_extra=>true
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_security_scheme=>wwv_flow_imp.id(2811800212733153)
,p_help_text=>'Public links are visible in the Extensions menu of subscribing workspaces.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4107921024590221)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading=>'Edit'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>30
,p_value_alignment=>'CENTER'
,p_stretch=>'N'
,p_link_target=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.::P112_ID:&ID.'
,p_link_text=>'<span role="img" class="a-Icon icon-edit" title="&EDIT." aria-label="&EDIT."></span>'
,p_link_attributes=>'class="a-Button a-Button--noUI"'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}   '))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4108106104590223)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Label'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'The label of this link as it appears in the Extensions menu.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4108271796590224)
,p_name=>'URL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'URL'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'URL'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a URL target for this link.</p>',
'<p>You can enter an URL to either external website or application or reference an &PRODUCT_NAME. application in your workspace. The links will always open in a new browser tab.</p>',
'<p><strong>External links</strong></p>',
'<p>Links to external sites must contain the https:// or https:// prefix. Any valid link is accepted, including parameters and fragments. The URL can contain any of the available Substitution Strings available (see list below).</p>',
'<p><strong>Internal Links</strong></p>',
'<p>A link to an internal application is called Extension Application and has the following prerequisites:',
'<ul>',
'<li>the application''s Authentication Scheme needs to be of type "Builder Extension Sign-In"</li>',
'<li>the URL has to be public in order for other workspaces to be able to subscribe to it</li>',
'<li>the URL must contain the Session ID parameter and Substitution String</li>',
'</ul>',
'An internal link can either be the full URL or the relative path of the application, without the server domain and port.',
'</p>',
'<p><strong>Examples</strong></p>',
'<p>Full URL: <pre>https://xxx.example.com:8080/apex/app-alias?session=&amp;APP_SESSION_ID.</pre>',
'</p>',
'<p>Relative URL: <pre>/apex/app-alias?session=&amp;APP_SESSION_ID.</pre></p>',
'<p></p>',
'<p><strong>Substitution Strings</strong></p>',
'<p>',
'Syntax: &amp;SUBSTITUTION_STRING.',
'<dl>',
'<dt>EXT_WORKSPACE_NAME</dt>',
'<dd>Name of the Workspace from where the Link is opened.</dd>',
'<dt>EXT_WORKSPACE_ID</dt>',
'<dd>Workspace ID (Security Group ID) of the Workspace from where the Link is opened.</dd>',
'<dt>EXT_APP_ID</dt>',
'<dd>The Application ID of the app that the developer currently has opened. If no application has been opened in a Builder session yet, this value is empty.</dd>',
'<dt>EXT_APP_NAME</dt>',
'<dd>The Application Name of the app that the developer currently has opened. If no application has been opened in a Builder session yet, this value is empty.</dd>',
'<dt>EXT_APP_ALIAS</dt>',
'<dd>The Application Alias of the app that the developer currently has opened. If no application has been opened in a Builder session yet, this value is empty.</dd>',
'<dt>EXT_PAGE_ID</dt>',
'<dd>The Page ID of the app that the developer currently has opened in the Page Builder. If no page has been opened in Page Builder during the session yet, this value is empty.</dd>',
'<dt>EXT_PAGE_NAME</dt>',
'<dd>The Page Name of the app that the developer currently has opened in the Page Builder. If no page has been opened in Page Builder during the session yet, this value is empty.</dd>',
'<dt>EXT_PAGE_ALIAS</dt>',
'<dd>The Page Alias of the app that the developer currently has opened in the Page Builder. If no page has been opened in Page Builder during the session yet, this value is empty.</dd>',
'<dt>APP_USER</dt>',
'<dd>The current user/developer.</dd>',
'<dt>APP_SESSION_ID</dt>',
'<dd>The current session ID.</dd>',
'</dl>',
'</p>'))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4108307653590225)
,p_name=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DESCRIPTION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Description'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_column_comment=>'Use this field to record comments about the link for informational purposes only.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4108403647590226)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>40
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'FUNCTION_BODY'
,p_default_language=>'PLSQL'
,p_default_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  s number;',
'begin',
'  select max(DISPLAY_SEQUENCE)',
'    into s',
'    from WWV_EXTENSION_LINKS ',
'   where security_group_id = :WORKSPACE_ID;',
'  s := nvl(s,0);',
'  s := trunc(s) + 10;',
'  return s;',
'end;'))
,p_duplicate_value=>false
,p_include_in_export=>true
,p_help_text=>'Specify the sequence for this link. The sequence determines the order in the Extensions menu.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4108981140590231)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4109054795590232)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(4107815450590220)
,p_internal_uid=>4107815450590220
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No links defined.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:ACTIONS_MENU:RESET:SAVE'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(2508721843087368)
,p_interactive_grid_id=>wwv_flow_imp.id(4107815450590220)
,p_static_id=>'25088'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(2508966369087370)
,p_report_id=>wwv_flow_imp.id(2508721843087368)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2509403863087386)
,p_view_id=>wwv_flow_imp.id(2508966369087370)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(4107921024590221)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>57
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2510363522087393)
,p_view_id=>wwv_flow_imp.id(2508966369087370)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(4108106104590223)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2511135303087397)
,p_view_id=>wwv_flow_imp.id(2508966369087370)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(4108271796590224)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>620
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2512058838087400)
,p_view_id=>wwv_flow_imp.id(2508966369087370)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(4108307653590225)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>736
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2512943133087403)
,p_view_id=>wwv_flow_imp.id(2508966369087370)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(4108403647590226)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>98
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2518726356114850)
,p_view_id=>wwv_flow_imp.id(2508966369087370)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(4108981140590231)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2810025520631531)
,p_view_id=>wwv_flow_imp.id(2508966369087370)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(2802363032892302)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>73.5
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49872712478881138)
,p_plug_name=>'Links and Subscriptions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(2817792749942896)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4109277395590234)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4107708538590219)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Link'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:112::'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4109158988590233)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(4107708538590219)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Links Report - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4109158988590233
);
end;
/
prompt --application/pages/page_00112
begin
wwv_flow_imp_page.create_page(
 p_id=>112
,p_name=>'Link Details'
,p_alias=>'LINK-DETAILS'
,p_step_title=>'Link Details'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(692762523503114201)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2555256139975510)
,p_plug_name=>'Link Entry Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>14
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2556076857975518)
,p_plug_name=>'Link Entry'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>34
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the link entry.  Each entry is typically a valid URL.</p>',
'<p>Links will appear in the Builder''s Extensions menu.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4109471740590236)
,p_plug_name=>'Link'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>24
,p_query_type=>'TABLE'
,p_query_table=>'WWV_EXTENSION_LINKS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2555095745975508)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(2555256139975510)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2555178438975509)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(2555256139975510)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(388538190684476853)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2554525887975503)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2555256139975510)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2554669463975504)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2555256139975510)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'P112_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4110799314590249)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2555256139975510)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P112_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4110853776590250)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2555256139975510)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P112_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2555739749975515)
,p_branch_name=>'Goto Previous'
,p_branch_action=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:112:P112_ID:&P112_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2555095745975508)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2555976904975517)
,p_branch_name=>'Goto Next'
,p_branch_action=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:112:P112_ID:&P112_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2555178438975509)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2554404349975502)
,p_branch_name=>'Goto Page 110'
,p_branch_action=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2554838335975506)
,p_name=>'P112_ID_NEXT'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2554926305975507)
,p_name=>'P112_ID_PREV'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2802859165892307)
,p_name=>'P112_IS_PUBLIC'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>73
,p_item_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_source_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_default=>'N'
,p_prompt=>'Public'
,p_source=>'IS_PUBLIC'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(157815226475866526)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_security_scheme=>wwv_flow_imp.id(2811800212733153)
,p_help_text=>'Public links are visible in the Extensions menu of subscribing workspaces.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4109619888590238)
,p_name=>'P112_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_source_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4109705009590239)
,p_name=>'P112_SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>33
,p_item_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_source_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_default=>':WORKSPACE_ID'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4109822466590240)
,p_name=>'P112_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>43
,p_item_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_source_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The label of this link as it appears in the Extensions menu.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4109959726590241)
,p_name=>'P112_URL'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>63
,p_item_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_source_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_prompt=>'URL'
,p_placeholder=>'https://xxx.example.com?param1=value1&param2=value2&...'
,p_source=>'URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a URL target for this link.</p>',
'<p>You can enter an URL to either external website or application or reference an &PRODUCT_NAME. application in your workspace. The links will always open in a new browser tab.</p>',
'<p><strong>External links</strong></p>',
'<p>Links to external sites must contain the https:// or https:// prefix. Any valid link is accepted, including parameters and fragments. The URL can contain any of the available Substitution Strings available (see list below).</p>',
'<p><strong>Internal Links</strong></p>',
'<p>A link to an internal application is called Extension Application and has the following prerequisites:',
'<ul>',
'<li>the application''s Authentication Scheme needs to be of type "Builder Extension Sign-In"</li>',
'<li>the URL has to be public in order for other workspaces to be able to subscribe to it</li>',
'<li>the URL must contain the Session ID parameter and Substitution String</li>',
'</ul>',
'An internal link can either be the full URL or the relative path of the application, without the server domain and port.',
'</p>',
'<p><strong>Examples</strong></p>',
'<p>Full URL: <pre>https://xxx.example.com:8080/apex/app-alias?session=&amp;APP_SESSION_ID.</pre>',
'</p>',
'<p>Relative URL: <pre>/apex/app-alias?session=&amp;APP_SESSION_ID.</pre></p>',
'<p></p>',
'<p><strong>Substitution Strings</strong></p>',
'<p>',
'Syntax: &amp;SUBSTITUTION_STRING.',
'<dl>',
'<dt>EXT_WORKSPACE_NAME</dt>',
'<dd>Name of the Workspace from where the Link is opened.</dd>',
'<dt>EXT_WORKSPACE_ID</dt>',
'<dd>Workspace ID (Security Group ID) of the Workspace from where the Link is opened.</dd>',
'<dt>EXT_APP_ID</dt>',
'<dd>The Application ID of the app that the developer currently has opened. If no application has been opened in a Builder session yet, this value is empty.</dd>',
'<dt>EXT_APP_NAME</dt>',
'<dd>The Application Name of the app that the developer currently has opened. If no application has been opened in a Builder session yet, this value is empty.</dd>',
'<dt>EXT_APP_ALIAS</dt>',
'<dd>The Application Alias of the app that the developer currently has opened. If no application has been opened in a Builder session yet, this value is empty.</dd>',
'<dt>EXT_PAGE_ID</dt>',
'<dd>The Page ID of the app that the developer currently has opened in the Page Builder. If no page has been opened in Page Builder during the session yet, this value is empty.</dd>',
'<dt>EXT_PAGE_NAME</dt>',
'<dd>The Page Name of the app that the developer currently has opened in the Page Builder. If no page has been opened in Page Builder during the session yet, this value is empty.</dd>',
'<dt>EXT_PAGE_ALIAS</dt>',
'<dd>The Page Alias of the app that the developer currently has opened in the Page Builder. If no page has been opened in Page Builder during the session yet, this value is empty.</dd>',
'<dt>APP_USER</dt>',
'<dd>The current user/developer.</dd>',
'<dt>APP_SESSION_ID</dt>',
'<dd>The current session ID.</dd>',
'</dl>',
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4110057718590242)
,p_name=>'P112_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>83
,p_item_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_source_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>43
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Use this field to record comments about the link for informational purposes only.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4110195965590243)
,p_name=>'P112_DISPLAY_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>53
,p_item_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_source_plug_id=>wwv_flow_imp.id(4109471740590236)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  s number;',
'begin',
'  select max(DISPLAY_SEQUENCE)',
'    into s',
'    from WWV_EXTENSION_LINKS ',
'   where security_group_id = :WORKSPACE_ID;',
'  s := nvl(s,0);',
'  s := trunc(s) + 10;',
'  return s;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Display Sequence'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the display sequence for this link entry. The sequence determines the display order in the Extensions menu.'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4110615594590248)
,p_validation_name=>'is_numeric_sequence'
,p_validation_sequence=>10
,p_validation=>'P112_DISPLAY_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'sequence value must be numeric'
,p_validation_condition=>':REQUEST not in (''CANCEL'',''DELETE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(4110195965590243)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2559077849975548)
,p_validation_name=>'NAME must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_extension_links',
' where security_group_id = :workspace_id',
'   and name = :P112_NAME',
'   and (   :P112_ID is null',
'        or id != :P112_ID )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Link name already exists. Name must be unique.'
,p_associated_item=>wwv_flow_imp.id(4109822466590240)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2555318069975511)
,p_name=>'Enable Previous Button'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P112_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2555464410975512)
,p_event_id=>wwv_flow_imp.id(2555318069975511)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2555095745975508)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2555507553975513)
,p_name=>'Enable Next Button'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P112_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2555676214975514)
,p_event_id=>wwv_flow_imp.id(2555507553975513)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2555178438975509)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2554366253975501)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(4109471740590236)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process Row of WWV_EXTENSION_LINKS'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2554366253975501
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2557298977975530)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(4109471740590236)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize Form Link Details'
,p_attribute_01=>'P112_ID_NEXT'
,p_attribute_02=>'P112_ID_PREV'
,p_internal_uid=>2557298977975530
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2554746976975505)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_EXTENSION_LINKS'
,p_attribute_03=>'P112_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'DISPLAY_SEQUENCE'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P112_ID_NEXT'
,p_attribute_10=>'P112_ID_PREV'
,p_attribute_14=>'security_group_id = :WORKSPACE_ID'
,p_internal_uid=>2554746976975505
);
end;
/
prompt --application/pages/page_00114
begin
wwv_flow_imp_page.create_page(
 p_id=>114
,p_name=>'Extension Subscriptions'
,p_alias=>'EXTENSION-SUBSCRIPTIONS'
,p_step_title=>'Extension Subscriptions'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1645909907649802)
,p_plug_name=>'Hidden Items'
,p_region_attributes=>'style="display:none"'
,p_plug_display_sequence=>40
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6928375544593060)
,p_plug_name=>'Subscriptions'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.id,',
'       g.security_group_id,',
'       g.extension_security_group_id,',
'       g.menu_label,',
'       g.has_read_access,',
'       c.display_name extension_workspace_name',
'  from wwv_extension_grants g, wwv_flow_companies c',
' where g.security_group_id = :workspace_id       ',
' and   g.extension_security_group_id = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Subscriptions'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2803467959892313)
,p_max_row_count=>'1000000'
,p_allow_save_rpt_public=>'Y'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_select_columns=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_notify=>'Y'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CROKITTA'
,p_internal_uid=>2803467959892313
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2803570941892314)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2803641402892315)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2803765240892316)
,p_db_column_name=>'EXTENSION_SECURITY_GROUP_ID'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Extension Workspace'
,p_column_link=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:115:P115_ID:#ID#'
,p_column_linktext=>'#EXTENSION_WORKSPACE_NAME#'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
,p_help_text=>'The workspace whose published links are shown in the extension menu of your workspace.'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2803830636892317)
,p_db_column_name=>'MENU_LABEL'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Menu Label'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
,p_help_text=>'Optional label of the parent menu item of all published links from the extension workspace. If not specified, the name of the extension workspace becomes the label.'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2803969978892318)
,p_db_column_name=>'HAS_READ_ACCESS'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Has Read Access'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(157815226475866526)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
,p_help_text=>'Indicates whether the specified extension workspace is allowed to access the metadata of your workspace through the APEX repository views.'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2804243300892321)
,p_db_column_name=>'EXTENSION_WORKSPACE_NAME'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Extension Workspace Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2888400191665568)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'28885'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:SECURITY_GROUP_ID:EXTENSION_SECURITY_GROUP_ID:MENU_LABEL:HAS_READ_ACCESS:EXTENSION_WORKSPACE_NAME'
,p_sort_column_1=>'EXTENSION_SECURITY_GROUP_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52693379484883979)
,p_plug_name=>'Links and Subscriptions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(2817792749942896)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168717528748286543)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1645817355649801)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1645909907649802)
,p_button_name=>'OPEN_DIALOG'
,p_button_static_id=>'openDialogButton'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Open Dialog'
,p_button_redirect_url=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:115::'
,p_button_cattributes=>'style="display:none"'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1926894707879743)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6928375544593060)
,p_button_name=>'ADD'
,p_button_static_id=>'addButton'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Subscription'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1927125298879746)
,p_name=>'P114_EXTENSIONS_AVAILABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6928375544593060)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1927570614879750)
,p_name=>'P114_DIALOG_URL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6928375544593060)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2804585902892324)
,p_name=>'refresh report after Add Subscription'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1645817355649801)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2804673648892325)
,p_event_id=>wwv_flow_imp.id(2804585902892324)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6928375544593060)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1646038689649803)
,p_event_id=>wwv_flow_imp.id(2804585902892324)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  into :P114_EXTENSIONS_AVAILABLE',
'  from wwv_flow_companies c',
' where c.is_extension_yn = ''Y''',
'   and upper(c.short_name) != ''UNKNOWN''',
'   and c.provisioning_company_id not in (10, 11, 12)',
'   and c.provisioning_company_id <> :workspace_id',
'   and exists (',
'          select 1',
'            from wwv_extension_links l',
'           where l.security_group_id = c.provisioning_company_id',
'       )   ',
'   and not exists (',
'          select 1',
'            from wwv_extension_grants g',
'           where g.security_group_id           = :workspace_id',
'             and g.extension_security_group_id = c.provisioning_company_id',
'       );',
''))
,p_attribute_02=>'P114_EXTENSIONS_AVAILABLE'
,p_attribute_03=>'P114_EXTENSIONS_AVAILABLE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1646181737649804)
,p_name=>'refresh report after Edit/Delete Subscription'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(6928375544593060)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1646263544649805)
,p_event_id=>wwv_flow_imp.id(1646181737649804)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6928375544593060)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1646366449649806)
,p_event_id=>wwv_flow_imp.id(1646181737649804)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  into :P114_EXTENSIONS_AVAILABLE',
'  from wwv_flow_companies c',
' where c.is_extension_yn = ''Y''',
'   and upper(c.short_name) != ''UNKNOWN''',
'   and c.provisioning_company_id not in (10, 11, 12)',
'   and c.provisioning_company_id <> :workspace_id',
'   and exists (',
'          select 1',
'            from wwv_extension_links l',
'           where l.security_group_id = c.provisioning_company_id',
'       )   ',
'   and not exists (',
'          select 1',
'            from wwv_extension_grants g',
'           where g.security_group_id           = :workspace_id',
'             and g.extension_security_group_id = c.provisioning_company_id',
'       );',
''))
,p_attribute_02=>'P114_EXTENSIONS_AVAILABLE'
,p_attribute_03=>'P114_EXTENSIONS_AVAILABLE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1926947776879744)
,p_name=>'open modal page'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1926894707879743)
,p_condition_element=>'P114_EXTENSIONS_AVAILABLE'
,p_triggering_condition_type=>'GREATER_THAN'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1927029810879745)
,p_event_id=>wwv_flow_imp.id(1926947776879744)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#openDialogButton").trigger("click")'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1927372987879748)
,p_event_id=>wwv_flow_imp.id(1926947776879744)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'No Extensions available to add to menu'
,p_action=>'NATIVE_ALERT'
,p_attribute_01=>'There are currently no workspaces available to add additional menu items to your extension menu.'
,p_attribute_02=>'No Extensions available'
,p_attribute_03=>'information'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1927258340879747)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get available extensions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  into :P114_EXTENSIONS_AVAILABLE',
'  from wwv_flow_companies c',
' where c.is_extension_yn = ''Y''',
'   and upper(c.short_name) != ''UNKNOWN''',
'   and c.provisioning_company_id not in (10, 11, 12)',
'   and c.provisioning_company_id <> :workspace_id',
'   and exists (',
'          select 1',
'            from wwv_extension_links l',
'           where l.security_group_id = c.provisioning_company_id',
'       )   ',
'   and not exists (',
'          select 1',
'            from wwv_extension_grants g',
'           where g.security_group_id           = :workspace_id',
'             and g.extension_security_group_id = c.provisioning_company_id',
'       );',
'',
':P114_DIALOG_URL := htmldb_util.prepare_url (',
'                        p_url                => ''f?p='' || :APP_ID || '':115:''|| :APP_SESSION||''::NO:115::'',',
'                        p_triggering_element => ''#addButton'' );       ',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1927258340879747
);
end;
/
prompt --application/pages/page_00115
begin
wwv_flow_imp_page.create_page(
 p_id=>115
,p_name=>'Subscribe to Extension Workspace'
,p_alias=>'SUBSCRIBE-TO-EXTENSION-WORKSPACE'
,p_page_mode=>'MODAL'
,p_step_title=>'Subscribe to Extension Workspace'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(2903553321750210)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_dialog_height=>'350'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:300'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5719906420124636)
,p_plug_name=>'Subscribe to Extension Workspace'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_EXTENSION_GRANTS'
,p_query_where=>'security_group_id = :workspace_id'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2804184499892320)
,p_plug_name=>'Form Elements'
,p_parent_plug_id=>wwv_flow_imp.id(5719906420124636)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5724105956124646)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2869636759571027)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5724105956124646)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2869209150571027)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5724105956124646)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_confirm_message=>'Would you like to unsubscribe from extension workspace &P115_WORKSPACE_NAME.?'
,p_confirm_style=>'warning'
,p_button_condition=>'P115_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2870015849571027)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5724105956124646)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P115_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2870446694571027)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(5724105956124646)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Subscribe'
,p_button_position=>'NEXT'
,p_button_condition=>'P115_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1926287601879737)
,p_name=>'P115_WORKSPACE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2804184499892320)
,p_prompt=>'Extension Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P115_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The workspace whose published links are shown in the extension menu of your workspace.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5720866792124641)
,p_name=>'P115_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2804184499892320)
,p_item_source_plug_id=>wwv_flow_imp.id(5719906420124636)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5721256736124644)
,p_name=>'P115_SECURITY_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2804184499892320)
,p_item_source_plug_id=>wwv_flow_imp.id(5719906420124636)
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5721935696124648)
,p_name=>'P115_EXTENSION_SGID'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2804184499892320)
,p_item_source_plug_id=>wwv_flow_imp.id(5719906420124636)
,p_prompt=>'Extension Workspace'
,p_source=>'EXTENSION_SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WWV_FLOW_COMPANIES.DISPLAY_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name, provisioning_company_id',
'  from wwv_flow_companies c',
' where c.is_extension_yn = ''Y''',
'   and upper(c.short_name) != ''UNKNOWN''',
'   and c.provisioning_company_id not in (10, 11, 12)',
'   and c.provisioning_company_id != :workspace_id',
'   and exists (',
'          select 1',
'            from wwv_extension_links l',
'           where l.security_group_id = c.provisioning_company_id',
'       )   ',
'   and not exists (',
'          select 1',
'            from wwv_extension_grants g',
'           where g.security_group_id           = :workspace_id',
'             and g.extension_security_group_id = c.provisioning_company_id',
'       )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- select workspace -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the workspace whose published links you want to include in the extension menu of your workspace.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5722379832124648)
,p_name=>'P115_MENU_LABEL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2804184499892320)
,p_item_source_plug_id=>wwv_flow_imp.id(5719906420124636)
,p_prompt=>'Menu Label Overwrite'
,p_source=>'MENU_LABEL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'By default, the name of the extension workspace becomes the parent menu item of all published links. You can enter a different label for the parent menu item here.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5722800734124649)
,p_name=>'P115_HAS_READ_ACCESS'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2804184499892320)
,p_item_source_plug_id=>wwv_flow_imp.id(5719906420124636)
,p_item_default=>'N'
,p_prompt=>'Has Read Access'
,p_source=>'HAS_READ_ACCESS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Indicate whether the specified extension workspace is allowed to access the metadata of your workspace through the APEX repository views.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2871470896571035)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2869636759571027)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2871940490571036)
,p_event_id=>wwv_flow_imp.id(2871470896571035)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1926371744879738)
,p_name=>'Hide LOV when edit'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P115_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1926480236879739)
,p_event_id=>wwv_flow_imp.id(1926371744879738)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_EXTENSION_SGID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2868548409571026)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(5719906420124636)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Subscribe to Extension Workspace'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2868548409571026
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2871052905571034)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2871052905571034
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2868183255571026)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(5719906420124636)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Subscribe to Extension Workspace'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2868183255571026
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1926565988879740)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get workspace name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name',
'  into :P115_WORKSPACE_NAME',
'  from wwv_flow_companies',
' where provisioning_company_id = :P115_EXTENSION_SGID;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P115_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>1926565988879740
);
end;
/
prompt --application/pages/page_00150
begin
wwv_flow_imp_page.create_page(
 p_id=>150
,p_name=>'Manage Export Repository'
,p_alias=>'MANAGE-EXPORT-REPOSITORY'
,p_step_title=>'Manage Export Repository'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_export_repos.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168469924987916319)
,p_plug_name=>'Export Repository'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ''<input type="checkbox" NAME="f01" VALUE="''||id||''">'' cb,',
'    flow_id application_id,',
'    decode(',
'       (select count(*) from wwv_flows f where d.flow_id = f.id and f.security_group_id = :flow_security_group_id),',
'       0,''No'',''Yes'') application_exists,',
'    nvl(title, name) title,',
'    mime_type,',
'    sys.dbms_lob.getlength(blob_content) download,',
'    sys.dbms_lob.getlength(blob_content) file_size,',
'    created_by,',
'    created_on,',
'    file_type,',
'    id',
'from WWV_FLOW_FILE_OBJECTS$ d',
'where security_group_id = :flow_security_group_id and',
'deleted_as_of = to_date(''01.01.0001'',''MM.DD.YYYY'')'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(168470000722916319)
,p_name=>'Manage Export Repository'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168470207926916321)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Delete'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168470313889916324)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168470414959916324)
,p_db_column_name=>'APPLICATION_EXISTS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Application Exists'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168470530188916324)
,p_db_column_name=>'TITLE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Title'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1146879893424737848)
,p_db_column_name=>'DOWNLOAD'
,p_display_order=>14
,p_column_identifier=>'K'
,p_column_label=>'Download'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_format_mask=>'DOWNLOAD:WWV_FLOW_FILE_OBJECTS$:BLOB_CONTENT:ID::MIME_TYPE:FILENAME:::attachment:#TITLE#:'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168470622836916325)
,p_db_column_name=>'MIME_TYPE'
,p_display_order=>24
,p_column_identifier=>'E'
,p_column_label=>'Mime Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168470709960916325)
,p_db_column_name=>'FILE_SIZE'
,p_display_order=>34
,p_column_identifier=>'F'
,p_column_label=>'File Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168470800258916326)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>44
,p_column_identifier=>'G'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168470923329916326)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>54
,p_column_identifier=>'H'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168471007452916327)
,p_db_column_name=>'FILE_TYPE'
,p_display_order=>64
,p_column_identifier=>'I'
,p_column_label=>'File Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168471117925916327)
,p_db_column_name=>'ID'
,p_display_order=>74
,p_column_identifier=>'J'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(168471214372916491)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1311816742536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CB:APPLICATION_ID:APPLICATION_EXISTS:DOWNLOAD:MIME_TYPE:FILE_SIZE:CREATED_BY:CREATED_ON:FILE_TYPE:'
,p_sort_column_1=>'CREATED_ON'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'FILE_SIZE'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(434337900505154290)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168469924987916319)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:150,RIR,RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(434341411680214256)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168469924987916319)
,p_button_name=>'DELETE_REQUESTED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(434341232674210836)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete requested'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'forall i in 1..wwv_flow.g_f01.count',
'    delete from wwv_flow_file_objects$',
'     where id = wwv_flow.g_f01(i) and',
'           security_group_id = :flow_security_group_id',
'   ;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(434341411680214256)
,p_process_success_message=>'Selected Files Deleted'
,p_internal_uid=>434341232674210836
);
end;
/
prompt --application/pages/page_00190
begin
wwv_flow_imp_page.create_page(
 p_id=>190
,p_name=>'Most Viewed Pages over All Applications'
,p_alias=>'A'
,p_step_title=>'Most Viewed Pages over All Applications'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450408166535437)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9344821301743320)
,p_plug_name=>'Top Page Views'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4350P190a */',
'      flow_id,',
'      (select name from wwv_flows where id = x.flow_id) name,',
'      step_id,',
'      rnk,cnt, ( rtr * 100) rtr, ',
'      round(( rtr * 100)) graph,',
'      (select name from wwv_flow_steps where id = x.step_id and flow_id = x.flow_id) page_name,',
' (select decode(PAGE_COMPONENT_MAP,',
'         ''01'',sm.apex_tabular_form,',
'         ''02'',sm.apex_form,',
'         ''03'',sm.apex_report,',
'         ''04'',sm.apex_chart,',
'         ''05'',sm.apex_web_service,',
'         ''06'',sm.apex_nav_page,',
'         ''07'',sm.apex_tree,',
'         ''08'',sm.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',sm.apex_dynamic_html,',
'         ''11'',sm.apex_static_html,',
'         ''12'',sm.apex_login,',
'         ''13'',sm.apex_home,',
'         ''14'',sm.apex_zero,',
'         ''15'',sm.apex_empty_page,',
'         ''16'',sm.apex_dynamic_form,',
'         ''17'',sm.apex_wizard_form,',
'         ''18'',sm.apex_interactive_rpt,',
'         ''unknown'') page_type from wwv_flow_steps where id = x.step_id and flow_id = x.flow_id) page_type',
'  from(',
'    select flow_id,step_id,cnt,',
'           dense_rank() over(order by cnt desc) rnk,',
'           ratio_to_report(cnt) over () rtr',
'      from (',
'        select flow_id,step_id,count(*) cnt',
'          from wwv_flow_activity_log l',
'         where security_group_id = :FLOW_SECURITY_GROUP_ID and page_mode != ''A''',
'         group by flow_id,step_id',
'        having exists',
'                 (select 1',
'                    from wwv_flows',
'                   where id = l.flow_id',
'                     and security_group_id = :FLOW_SECURITY_GROUP_ID))',
'      ) x,',
'(select ',
'           wwv_flow_lang.system_message(''REPORT'') apex_report,',
'           wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'           wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'           wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'           wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'           wwv_flow_lang.system_message(''Dynamic HTML'') apex_dynamic_html,',
'           wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'           wwv_flow_lang.system_message(''HTML'') apex_html,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'           wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'           wwv_flow_lang.system_message(''CALENDAR_TYPE'') apex_calendar,',
'           wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'           wwv_flow_lang.system_message(''HOME'') apex_home,',
'           wwv_flow_lang.system_message(''PAGE_ZERO'') apex_zero,',
'           wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'           wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'           wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'           wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'           wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'           wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'           wwv_flow_lang.system_message(''AUTO_FIRST_ITEM'') auto_first_item,',
'           wwv_flow_lang.system_message(''NO_URL_ACCESS'') NO_URL_ACCESS,',
'           wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'           wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'           wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'           wwv_flow_lang.system_message(''Unassigned'') t_unassigned',
'       from dual)  sm',
' where rnk < to_number(:P190_N) + 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p>Page Processing entries are omitted.</p>'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9344928950743320)
,p_name=>'Top Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9345110175743323)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9345202962743323)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9345305868743323)
,p_db_column_name=>'STEP_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9345426864743323)
,p_db_column_name=>'RNK'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Rank'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9345505548743323)
,p_db_column_name=>'CNT'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9345608395743324)
,p_db_column_name=>'RTR'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'% Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9345707890743324)
,p_db_column_name=>'GRAPH'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:150'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9380508609926649)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9384030389980303)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Page Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(9345929884743570)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1311907100536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_report_columns=>'FLOW_ID:NAME:STEP_ID:PAGE_NAME:PAGE_TYPE:RNK:CNT:RTR:GRAPH'
,p_sort_column_1=>'RNK'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'CNT'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30380917465045384)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30491307413316931)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(30380917465045384)
,p_button_name=>'P190_GO'
,p_button_static_id=>'P190_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200658627668418842)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(30380917465045384)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:190:&SESSION.::&DEBUG.:190,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30495310445336766)
,p_branch_action=>'f?p=&FLOW_ID.:190:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30479428275304064)
,p_name=>'P190_N'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30380917465045384)
,p_item_default=>'10'
,p_prompt=>'Top (page views)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>4
,p_cattributes_element=>'valign="top"'
,p_tag_attributes=>'style="padding:0px; "'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153170799943531)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the number of pages for which to display the top page views.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47504127115684653)
,p_validation_name=>'CheckNumber'
,p_validation_sequence=>10
,p_validation=>'P190_N'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric.'
,p_associated_item=>wwv_flow_imp.id(30479428275304064)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00300
begin
wwv_flow_imp_page.create_page(
 p_id=>300
,p_name=>'Purge Cached Regions by Workspace'
,p_alias=>'PURGE-CACHED-REGIONS-BY-WORKSPACE'
,p_step_title=>'Purge Cached Regions By Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_reg.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41860601486553192)
,p_plug_name=>'Purge Cached Regions by Workspace'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41861530818553199)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(41860601486553192)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41861331112553199)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(41860601486553192)
,p_button_name=>'PURGE_CACHED_REGIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge All Cached Regions'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(41862518476553203)
,p_branch_action=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41861715868553200)
,p_name=>'P300_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(41860601486553192)
,p_item_default=>'0'
,p_prompt=>'Count of Cached Regions:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the number of cached regions that will be purged.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(148453911726971659)
,p_computation_sequence=>10
,p_computation_item=>'P300_APPLICATION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'from wwv_flows f,',
'     wwv_flow_page_cache c',
'where f.security_group_id = :flow_security_group_id and',
'      f.security_group_id = c.security_group_id and',
'      f.id = c.flow_id and',
'      c.region_id is not null'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(41862208989553202)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Cached Regions by workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select id ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id)',
'loop',
'   wwv_flow_page_cache_api.purge_regions_by_app (p_application=>c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Purge Cached Regions'
,p_process_when_button_id=>wwv_flow_imp.id(41861331112553199)
,p_process_when=>'P300_APPLICATION'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_process_success_message=>'All Cached Regions Purged'
,p_internal_uid=>41862208989553202
);
end;
/
prompt --application/pages/page_00301
begin
wwv_flow_imp_page.create_page(
 p_id=>301
,p_name=>'Purge Cached Regions by Region'
,p_alias=>'PURGE-CACHED-REGIONS-BY-REGION'
,p_step_title=>'Purge Cached Regions by Region'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_reg.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10306117384310103)
,p_plug_name=>'Manage Cached Regions'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(388531674152470979)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   HTMLDB_ITEM.CHECKBOX(1, r.id,null,null, '':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''PURGE_LABEL'', r.plug_name)) cb,',
'   c.flow_id application_id,',
'   (select name from wwv_flows where id = c.flow_id) application_name,',
'   c.page_id, ',
'   (select name from wwv_flow_steps where flow_id = c.flow_id and id = c.page_id) page_name,',
'   c.region_id, ',
'   r.plug_name region_name,',
'       decode(r.PLUG_SOURCE_TYPE,',
'        ''PLSQL_PROCEDURE'',m.plsql,',
'        ''SIMPLE_CHART'',m.HTML_CHART,',
'        ''SQL_QUERY'',m.Report,',
'        ''STATIC_TEXT'',m.html_slash_text,',
'        ''STATIC_TEXT_ESCAPE_SC'',m.text_esc,',
'        ''STATIC_TEXT_WITH_SHORTCUTS'',m.html_text_with_shortcuts,',
'        ''STRUCTURED_QUERY'',m.Report,',
'        ''FUNCTION_RETURNING_SQL_QUERY'',m.Report,',
'        ''SVG_CHART'',m.svg_chart,',
'        ''TREE'',m.tree,',
'        ''UPDATABLE_SQL_QUERY'',m.tabular_form,',
'        ''URL'',''URL'',',
'        decode(substr(r.PLUG_SOURCE_TYPE,1,1),''M'',m.Breadcrumb,m.list))',
'                                         region_type,',
'   c.language, ',
'  sys.dbms_lob.getlength(c.page_text) text_length, ',
'  to_char(c.cached_on,''YYYY.MM.DD HH24:MI:SS'') cached_on, ',
'  round((sysdate - c.cached_on) * 3600 * 24,0) cache_age_in_seconds, ',
'    r.PLUG_CACHING_MAX_AGE_IN_SEC - round((sysdate - c.cached_on) * 3600 * 24,0) max_age_in_seconds,',
'  decode(greatest((sysdate - c.cached_on) * 3600 * 24,r.PLUG_CACHING_MAX_AGE_IN_SEC),r.PLUG_CACHING_MAX_AGE_IN_SEC,m.Unexpired,m.Expired) cache_status,',
'  r.PLUG_CACHING caching_method,',
'decode(decode(r.PLUG_CACHE_WHEN,null,''N'',''0'',''N'',''Y''),''N'',null,''<img src="#IMAGE_PREFIX#htmldb/builder/check_small_black.gif" border="0" height="15" width="15" alt="">'')',
'   conditional',
'from wwv_flow_page_cache c,',
'     wwv_flow_page_plugs r,',
'(select',
'   wwv_flow_lang.system_message(''F4500_P2610_EXPIRED'') expired,',
'   wwv_flow_lang.system_message(''UNEXPIRED'') unexpired,',
'   wwv_flow_lang.system_message(''PLSQL'') plsql,',
'   wwv_flow_lang.system_message(''HTML_CHART'') html_chart,',
'   wwv_flow_lang.system_message(''REPORT'') report,',
'   wwv_flow_lang.system_message(''HTML_SLASH_TEXT'') html_slash_text,',
'   wwv_flow_lang.system_message(''LAYOUT.HTML_TEXT_ESCAPE_SC'') text_esc,',
'   wwv_flow_lang.system_message(''HTML_TEXT_WITH_SHORTCUTS'')',
'      html_text_with_shortcuts,',
'   wwv_flow_lang.system_message(''F4000_SVG_CHART'') svg_chart,',
'   wwv_flow_lang.system_message(''F4000_TREE'') tree,',
'   wwv_flow_lang.system_message(''F4000.LIST_INITCAP'') list,',
'   wwv_flow_lang.system_message(''BREADCRUMB'') Breadcrumb,',
'   wwv_flow_lang.system_message(''TABULAR_FORM'') tabular_form',
' from dual) m',
'where c.region_id = r.id and',
'      c.flow_id = r.flow_id and',
'      c.security_group_id = :flow_security_group_id and ',
'      c.region_id is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10306229448310103)
,p_name=>'Manage Cached Regions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10306421748310114)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Purge'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10306512108310114)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10306624180310114)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10306721504310114)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10306829907310114)
,p_db_column_name=>'REGION_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Region'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10306904667310115)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Region Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10307019944310115)
,p_db_column_name=>'REGION_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Region Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10307126409310115)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10307205454310115)
,p_db_column_name=>'TEXT_LENGTH'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Text Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10307314483310115)
,p_db_column_name=>'CACHED_ON'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Cached'
,p_column_type=>'STRING'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10307429626310115)
,p_db_column_name=>'CACHE_AGE_IN_SECONDS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Cache Age'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10307501893310115)
,p_db_column_name=>'MAX_AGE_IN_SECONDS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Timeout'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10307625649310116)
,p_db_column_name=>'CACHE_STATUS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10307705887310116)
,p_db_column_name=>'CACHING_METHOD'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Method'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(672366941474304666)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10307931291310116)
,p_db_column_name=>'CONDITIONAL'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10311300580342753)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10308120834310756)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1312029311536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CB:APPLICATION_ID:PAGE_ID:PAGE_NAME:REGION_NAME:REGION_TYPE:LANGUAGE:TEXT_LENGTH:CACHED_ON:CACHE_AGE_IN_SECONDS:MAX_AGE_IN_SECONDS:CACHE_STATUS:CACHING_METHOD:CONDITIONAL'
,p_sort_column_1=>'APPLICATION_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'REGION_NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452473524714012768)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10306117384310103)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41674312075061773)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(10306117384310103)
,p_button_name=>'PURGE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(41517719933473648)
,p_branch_action=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(41681201255077529)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Puge Checked Regions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for j in 1..wwv_flow.g_f01.count loop',
'    for c1 in (select flow_id, id from wwv_flow_page_plugs',
'        where id = to_number(wwv_flow.g_f01(j)) and',
'              security_group_id = :flow_security_group_id) loop',
'      wwv_flow_page_cache_api.purge_regions_by_id (',
'        p_application => c1.flow_id,',
'        p_region_id => c1.id);',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Purge Cached Regions'
,p_process_success_message=>'Cached Regions Purged'
,p_internal_uid=>41681201255077529
);
end;
/
prompt --application/pages/page_00302
begin
wwv_flow_imp_page.create_page(
 p_id=>302
,p_name=>'Purge Cached Pages by Page'
,p_alias=>'PURGE-CACHED-PAGES-BY-PAGE'
,p_step_title=>'Purge Cached Pages by Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_pg.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10320916435416902)
,p_plug_name=>'Manage Cached Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>12
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    htmldb_item.checkbox(1,id2) cb,',
'    flow_id application,',
'    (select name from wwv_flows where id = flow_id) application_name,',
'    id,',
'    name,',
'    cache_mode,',
'    cache_timeout_seconds timeout,',
'    cache_when_condition_type conditional,',
'    cached_pages,',
'    most_recent_cache',
'from',
'(',
'select ID,',
'       rowid id2,',
'       flow_id,',
'       NAME,',
'       cache_mode,',
'       cache_timeout_seconds,',
'       decode(cache_when_condition_type,',
'              null,null,',
'              ''<img src="#IMAGE_PREFIX#htmldb/builder/check_small_black.gif" border="0" height="15" width="15" alt="">'') cache_when_condition_type,',
'       (select count(*) from wwv_flow_page_cache where flow_id = s.flow_id and page_id = s.id and security_group_id = :flow_security_group_id) cached_pages,',
'       (select max(cached_on) co from wwv_flow_page_cache where flow_id = s.flow_id and page_id = s.id and security_group_id = :flow_security_group_id) most_recent_cache',
'from WWV_FLOW_STEPS s',
'where id = abs(id)',
'  and s.security_group_id = :flow_security_group_id',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(10321019377416902)
,p_name=>'Manage Cached Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10321208647416903)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Purge'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10321324196416904)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10321426141416905)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10321505286416905)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10322006408416906)
,p_db_column_name=>'CACHED_PAGES'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Cached Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10322110865416906)
,p_db_column_name=>'MOST_RECENT_CACHE'
,p_display_order=>8
,p_column_identifier=>'J'
,p_column_label=>'Most Recent'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10321700406416905)
,p_db_column_name=>'TIMEOUT'
,p_display_order=>9
,p_column_identifier=>'F'
,p_column_label=>'Timeout'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10321926064416905)
,p_db_column_name=>'CONDITIONAL'
,p_display_order=>10
,p_column_identifier=>'H'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10323023099424920)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(672358706301300327)
,p_db_column_name=>'CACHE_MODE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Cache Mode'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(672366941474304666)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10322328855417122)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1312126293536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CB:APPLICATION:ID:NAME:CACHED_PAGES:MOST_RECENT_CACHE:TIMEOUT:CONDITIONAL:APPLICATION_NAME:CACHE_MODE'
,p_sort_column_1=>'APPLICATION'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(452494407764159218)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10320916435416902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(42426332383298687)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(10320916435416902)
,p_button_name=>'PURGE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42429221514298690)
,p_branch_action=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(42428913706298689)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Puge Checked Regions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for j in 1..wwv_flow.g_f01.count loop',
'    for c1 in (select flow_id, id from wwv_flow_steps',
'        where rowid = wwv_flow.g_f01(j) and',
'              security_group_id = :flow_security_group_id) loop',
'      wwv_flow_page_cache_api.purge_by_page (',
'        p_application => c1.flow_id,',
'        p_page => c1.id,',
'        p_user_name => null);',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Purge Cached Regions'
,p_process_when_button_id=>wwv_flow_imp.id(42426332383298687)
,p_process_success_message=>'Cached Regions Purged'
,p_internal_uid=>42428913706298689
);
end;
/
prompt --application/pages/page_00303
begin
wwv_flow_imp_page.create_page(
 p_id=>303
,p_name=>'Purge Cached Regions by Application'
,p_alias=>'PURGE-CACHED-REGIONS-BY-APPLICATION'
,p_step_title=>'Purge Cached Regions by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_reg.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41695813638100063)
,p_plug_name=>'Purge Cached Regions by Application'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41722502434163040)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(41695813638100063)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41709609660136734)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(41695813638100063)
,p_button_name=>'PURGE_CACHED_REGIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Cached Regions'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(41711215547138478)
,p_branch_action=>'f?p=&APP_ID.:303:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41705405242116590)
,p_name=>'P303_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(41695813638100063)
,p_item_default=>'0'
,p_prompt=>'Application:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||''. ''||wwv_flow_escape.html(f.name)||'' (''||count(*)||'')'' n, f.id ',
'from wwv_flows f,',
'     wwv_flow_page_cache c',
'where f.security_group_id = :flow_security_group_id and',
'      f.security_group_id = c.security_group_id and',
'      f.id = c.flow_id and',
'      c.region_id is not null',
'group by f.id, f.name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the application to purge all cached regions from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(41715118795148887)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Cached Regions by Application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select id ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id and ',
'id = :P303_APPLICATION) loop',
'   wwv_flow_utilities.purge_regions_by_app (p_application=>c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Purge Cached Regions'
,p_process_when=>'P303_APPLICATION'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_process_success_message=>'Cached Regions Purged'
,p_internal_uid=>41715118795148887
);
end;
/
prompt --application/pages/page_00304
begin
wwv_flow_imp_page.create_page(
 p_id=>304
,p_name=>'Purge Cached Pages by Application'
,p_alias=>'PURGE-CACHED-PAGES-BY-APPLICATION'
,p_step_title=>'Purge Cached Pages by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_cache_pg.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42340424785643419)
,p_plug_name=>'Purge Cached Pages by Application'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(42341306028643420)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(42340424785643419)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(42341112259643420)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(42340424785643419)
,p_button_name=>'PURGE_CACHED_REGIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Cached Pages'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42342314925643421)
,p_branch_action=>'f?p=&APP_ID.:304:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42341519571643420)
,p_name=>'P304_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(42340424785643419)
,p_item_default=>'0'
,p_prompt=>'Application:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||''. ''||wwv_flow_escape.html(f.name)||'' (''||count(*)||'')'' n, f.id ',
'from wwv_flows f,',
'     wwv_flow_page_cache c',
'where f.security_group_id = :flow_security_group_id and',
'      f.security_group_id = c.security_group_id and',
'      f.id = c.flow_id and',
'      c.region_id is null',
'group by f.id, f.name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the application to purge all cached pages from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(42342010845643421)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Cached Pages by Application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select id ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id and ',
'id = :P304_APPLICATION) loop',
'   wwv_flow_utilities.cache_purge_by_application (p_application=>c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Purge Cached Pages'
,p_process_when=>'P304_APPLICATION'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_process_success_message=>'Cached Pages Purged'
,p_internal_uid=>42342010845643421
);
end;
/
prompt --application/pages/page_00352
begin
wwv_flow_imp_page.create_page(
 p_id=>352
,p_name=>'Activity Log Summary'
,p_alias=>'ACTIVITY-LOG-SUMMARY'
,p_step_title=>'Activity Log Summary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162260122382844861)
,p_plug_name=>'Activity Log Summary'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    APPLICATION_NAME,',
'    LOG_DAY,',
'    to_char(log_day,''YYYY.MM'') log_month,',
'    WORKSPACE_ID,',
'    APPLICATION_ID,',
'    PAGE_EVENTS,',
'    PAGE_VIEWS,',
'    PAGE_ACCEPTS,',
'    PARTIAL_PAGE_VIEWS,',
'    ROWS_FETCHED,',
'    IR_SEARCHES,',
'    DISTINCT_PAGES,',
'    DISTINCT_USERS,',
'    DISTINCT_SESSIONS,',
'    AVERAGE_RENDER_TIME,',
'    MEDIAN_RENDER_TIME,',
'    MAXIMUM_RENDER_TIME,',
'    TOTAL_RENDER_TIME,',
'    ERROR_COUNT,',
'    content_length,',
'    public_page_events,',
'    additional_attributes,',
'    nvl(decode(instr(additional_attributes,''"hash":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8),'','')-2)),null)  application_hash,',
'    nvl(decode(instr(additional_attributes,''"pages":''),0,''0'',',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"pages":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"pages":'')+8),'','')-1)),''0'')  pages,',
'    nvl(decode(instr(additional_attributes,''"jetCharts":''),0,''0'',',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"jetCharts":'')+12,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"jetCharts":'')+12),'','')-1)),''0'') jetcharts,',
'    nvl(decode(instr(additional_attributes,''"interactiveReports":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveReports":'')+21,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveReports":'')+21),'','')-1)),''0'')  interactiveReports,',
'    nvl(decode(instr(additional_attributes,''"classicReports":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"classicReports":'')+length(''classicReports'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"classicReports":'')+length(''classicReports'')+3),'','')-1)),''0'')  classicReports,',
'    nvl(decode(instr(additional_attributes,''"interactiveGrids":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveGrids":'')+length(''interactiveGrids'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveGrids":'')+length(''interactiveGrids'')+3),'','')-1)),''0'')  interactiveGrids,',
'    nvl(decode(instr(additional_attributes,''"aclUsers":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"aclUsers":'')+length(''aclUsers'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"aclUsers":'')+length(''aclUsers'')+3),'','')-1)),''0'')  aclUsers,        ',
'    nvl(decode(instr(additional_attributes,''"appSettings":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"appSettings":'')+length(''appSettings'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"appSettings":'')+length(''appSettings'')+3),'','')-1)),''0'')  appSettings,          ',
'    nvl(decode(instr(additional_attributes,''"buildOptions":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"buildOptions":'')+length(''buildOptions'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"buildOptions":'')+length(''buildOptions'')+3),'','')-1)),''0'')  buildOptions,         ',
'    nvl(decode(instr(additional_attributes,''"emailTemplates":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"emailTemplates":'')+length(''emailTemplates'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"emailTemplates":'')+length(''emailTemplates'')+3),'','')-1)),''0'')  emailTemplates,         ',
'    nvl(decode(instr(additional_attributes,''"plugins":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"plugins":'')+length(''plugins'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"plugins":'')+length(''plugins'')+3),'','')-1)),''0'')  plugins,        ',
'    nvl(decode(instr(additional_attributes,''"tabularForms":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"tabularForms":'')+length(''tabularForms'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"tabularForms":'')+length(''tabularForms'')+3),'','')-1)),''0'')  tabularForms',
'from WWV_FLOW_LOG_HISTORY ',
'where workspace_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Activity Log Summary'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(162260221695844861)
,p_name=>'Activity Log Summary'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162260401162844862)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Log Day'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162260508477844863)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162260600823844863)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162260732507844864)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582264628062682817)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>14
,p_column_identifier=>'T'
,p_column_label=>'Public Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162260817985844864)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>24
,p_column_identifier=>'E'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162260902753844864)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>34
,p_column_identifier=>'F'
,p_column_label=>'Page Accepts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162261002694844865)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>44
,p_column_identifier=>'G'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162261206726844866)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>64
,p_column_identifier=>'I'
,p_column_label=>'Rows Fetched'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162261301710844866)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>74
,p_column_identifier=>'J'
,p_column_label=>'IR Searches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162261406930844867)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>84
,p_column_identifier=>'K'
,p_column_label=>'Active Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162261527481844867)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>94
,p_column_identifier=>'L'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162261618519844867)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>104
,p_column_identifier=>'M'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162261703810844868)
,p_db_column_name=>'AVERAGE_RENDER_TIME'
,p_display_order=>114
,p_column_identifier=>'N'
,p_column_label=>'Average Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162261813499844868)
,p_db_column_name=>'MEDIAN_RENDER_TIME'
,p_display_order=>124
,p_column_identifier=>'O'
,p_column_label=>'Median Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162261905907844869)
,p_db_column_name=>'MAXIMUM_RENDER_TIME'
,p_display_order=>134
,p_column_identifier=>'P'
,p_column_label=>'Maximum Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162262025277844869)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>144
,p_column_identifier=>'Q'
,p_column_label=>'Total Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162262111135844869)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>154
,p_column_identifier=>'R'
,p_column_label=>'Error Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201285925412147292)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>164
,p_column_identifier=>'S'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84538686011706812)
,p_db_column_name=>'ADDITIONAL_ATTRIBUTES'
,p_display_order=>174
,p_column_identifier=>'U'
,p_column_label=>'Additional Attributes'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84538829661706814)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>184
,p_column_identifier=>'V'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176253754674916937)
,p_db_column_name=>'APPLICATION_HASH'
,p_display_order=>194
,p_column_identifier=>'W'
,p_column_label=>'Application Hash'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176253802394916938)
,p_db_column_name=>'PAGES'
,p_display_order=>204
,p_column_identifier=>'X'
,p_column_label=>'Pages'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176253901895916939)
,p_db_column_name=>'JETCHARTS'
,p_display_order=>214
,p_column_identifier=>'Y'
,p_column_label=>'JET Charts'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176254060245916940)
,p_db_column_name=>'INTERACTIVEREPORTS'
,p_display_order=>224
,p_column_identifier=>'Z'
,p_column_label=>'Interactive Reports'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176254116102916941)
,p_db_column_name=>'CLASSICREPORTS'
,p_display_order=>234
,p_column_identifier=>'AA'
,p_column_label=>'Classic Reports'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176254290645916942)
,p_db_column_name=>'INTERACTIVEGRIDS'
,p_display_order=>244
,p_column_identifier=>'AB'
,p_column_label=>'Interactive Grids'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176254381122916943)
,p_db_column_name=>'ACLUSERS'
,p_display_order=>254
,p_column_identifier=>'AC'
,p_column_label=>'ACL Users'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176254476997916944)
,p_db_column_name=>'APPSETTINGS'
,p_display_order=>264
,p_column_identifier=>'AD'
,p_column_label=>'Application Settings'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176254504216916945)
,p_db_column_name=>'BUILDOPTIONS'
,p_display_order=>274
,p_column_identifier=>'AE'
,p_column_label=>'Build Options'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176254650832916946)
,p_db_column_name=>'EMAILTEMPLATES'
,p_display_order=>284
,p_column_identifier=>'AF'
,p_column_label=>'Email Templates'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176254768246916947)
,p_db_column_name=>'PLUGINS'
,p_display_order=>294
,p_column_identifier=>'AG'
,p_column_label=>'Plugins'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176254969597916949)
,p_db_column_name=>'TABULARFORMS'
,p_display_order=>314
,p_column_identifier=>'AI'
,p_column_label=>'Tabular Forms'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(395886365186084621)
,p_db_column_name=>'LOG_MONTH'
,p_display_order=>324
,p_column_identifier=>'AJ'
,p_column_label=>'Log Month'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(162262201398845046)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1312228437536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:APPLICATION_ID:APPLICATION_NAME:PAGE_EVENTS:DISTINCT_SESSIONS:MEDIAN_RENDER_TIME:LOG_MONTH'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
,p_sum_columns_on_break=>'PAGE_EVENTS:DISTINCT_SESSIONS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450813015470464956)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(162260122382844861)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(486004758462193187)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:352:&SESSION.::&DEBUG.:RR,RIR::'
,p_icon_css_classes=>'icon-undo'
);
end;
/
prompt --application/pages/page_00353
begin
wwv_flow_imp_page.create_page(
 p_id=>353
,p_name=>'Activity Log Summary'
,p_alias=>'ACTIVITY-LOG-SUMMARY1'
,p_step_title=>'Activity Log Summary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162264332021892953)
,p_plug_name=>'Activity Log Summary'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    WORKSPACE_ID,',
'    count(distinct APPLICATION_ID) applications,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'where workspace_id = :flow_security_group_id',
'group by LOG_DAY, workspace_id'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(162264515119892954)
,p_name=>'Activity Log Summary'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162264604274892956)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Log Date'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162264720651892957)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162264928769892957)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162265007935892958)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162265104003892958)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Page Accepts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162265211713892959)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162265430194892959)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Rows Fetched'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162265515694892960)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'IR Searches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162265626522892960)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Distinct Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162265711965892961)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Distinct Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162265801323892961)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Distinct Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162266206251892963)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Total Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162266325784892963)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Error Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162267612358914457)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(168906831310578374)
,p_db_column_name=>'DAY'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Day'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201285117877126238)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582264703034682818)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>31
,p_column_identifier=>'V'
,p_column_label=>'Public Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(162266419283892964)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1312304056536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOG_DAY:DAY:PAGE_EVENTS:PUBLIC_PAGE_EVENTS:PAGE_VIEWS:ROWS_FETCHED:DISTINCT_PAGES:DISTINCT_USERS:DISTINCT_SESSIONS:TOTAL_RENDER_TIME:CONTENT_LENGTH'
,p_sort_column_1=>'LOG_DAY'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450811631699441244)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(162264332021892953)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:353:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(169323723183650261)
,p_branch_action=>'f?p=&APP_ID.:353:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00354
begin
wwv_flow_imp_page.create_page(
 p_id=>354
,p_name=>'Activity Log Summary by Application'
,p_alias=>'ACTIVITY-LOG-SUMMARY-BY-APPLICATION'
,p_step_title=>'Activity Log Summary by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wrkspc_activity.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162268108872925636)
,p_plug_name=>'Activity Log Summary'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>14
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    application_id,',
'    application_id||''. ''||(select name from wwv_flows where id = application_id) application_name,',
'    WORKSPACE_ID,',
'    count(distinct log_day) days,',
'    min(log_day)     since_date,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(total_render_time)/sum(page_events) avg_elap_time,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'where workspace_id = :flow_security_group_id and',
'log_day >= sysdate - (NVL(:P354_SINCE,365)+1)',
'group by application_id, workspace_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Activity Log Summary'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(162268324547925637)
,p_name=>'Activity Log Summary'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162268510942925638)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Workspace'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162268612852925638)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162268710082925639)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162268807643925639)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Page Accepts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162268923860925640)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Partial Page Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162269128509925640)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Rows Fetched'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162269209021925641)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'IR Searches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162269305309925641)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Distinct Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162269400875925642)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Distinct Users'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162269513271925642)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Distinct Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162269615521925642)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Total Render Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162269717928925643)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Error Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162271418161935037)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162271523526935038)
,p_db_column_name=>'DAYS'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Days'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162271718984944751)
,p_db_column_name=>'SINCE_DATE'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Since Date'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(180654932380933226)
,p_db_column_name=>'AVG_ELAP_TIME'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Average Time'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(180659706033048576)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201286518879173836)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Content'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(582264873008682819)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>34
,p_column_identifier=>'Y'
,p_column_label=>'Public Page Events'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(162269929348925644)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1312430037536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION_NAME:DAYS:PAGE_EVENTS:PUBLIC_PAGE_EVENTS:ROWS_FETCHED:DISTINCT_PAGES:DISTINCT_SESSIONS:AVG_ELAP_TIME:CONTENT_LENGTH'
,p_sort_column_1=>'PAGE_EVENTS'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'LOG_DAY'
,p_sort_direction_2=>'DESC'
,p_sum_columns_on_break=>'PAGE_EVENTS:PUBLIC_PAGE_EVENTS:WEBSHEET_VIEWS:ROWS_FETCHED:DISTINCT_SESSIONS:CONTENT_LENGTH'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(758054138318278409)
,p_plug_name=>'Button Region'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(758054330875278411)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(758054138318278409)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Set'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450812207720453197)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(162268108872925636)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:354:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(758054273020278410)
,p_name=>'P354_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(758054138318278409)
,p_item_default=>'365'
,p_prompt=>'Since'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual  union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual  union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual  union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual  union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00510
begin
wwv_flow_imp_page.create_page(
 p_id=>510
,p_name=>'Provisioning: Request Service Termination'
,p_alias=>'PROVISIONING-REQUEST-SERVICE-TERMINATION'
,p_step_title=>'Request Service Termination - Confirm'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215667724760013351)
,p_step_template=>wwv_flow_imp.id(718401914085176458)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_request.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2052917115364783)
,p_plug_name=>'Confirm Service Termination'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720158679964358138)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page allows the administrator of a workspace to request the termination of the service they are currently connected to.<br/><br/>',
'',
'<strong>IMPORTANT!</strong>: All data, database objects, database schemas, tablespaces, applications, scripts, files, etc will be removed when your service is terminated.</p>',
'',
'<p>Verify that you would like to terminate your service.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168317330063836088)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(720186138525572350)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(47297014014256767)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(720190141563578035)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208569609956386814)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752114113873695876)
,p_plug_name=>'Request Service Termination'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(720159283194358177)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2055131313368908)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208569609956386814)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2056209627372145)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208569609956386814)
,p_button_name=>'TERMINATE_SERVICE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminate Service'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2056515355372147)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(2056209627372145)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57798221433994955)
,p_validation_name=>'terminate service request exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from WWV_FLOW_PROVISION_SERICE_MOD',
' where request_status = ''REQUESTED''',
'   and service_name = ''REMOVE_EXISTING_SERVICE''',
'   and SECURITY_GROUP_ID = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'A service termination request already exists for this workspace.'
,p_when_button_pressed=>wwv_flow_imp.id(2056209627372145)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2058222440375829)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'terminate service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_provisioning.make_modification_request(',
'    p_security_group_id    => :flow_security_group_id,',
'    p_service_name         => ''REMOVE_EXISTING_SERVICE'',',
'    p_service_attribute_2  => wwv_flow_user_api.get_email(p_username => upper(wwv_flow.g_user)));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error submitting service termination request.'
,p_process_when_button_id=>wwv_flow_imp.id(2056209627372145)
,p_process_success_message=>'Service termination request submitted.'
,p_security_scheme=>wwv_flow_imp.id(916538108136873611)
,p_internal_uid=>2058222440375829
);
end;
/
prompt --application/pages/page_00577
begin
wwv_flow_imp_page.create_page(
 p_id=>577
,p_name=>'Help'
,p_alias=>'HELP'
,p_step_title=>'Help'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(80887301212076531)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107606024046537921)
,p_plug_name=>'Find'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(797568474776479154)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use these controls to specify query criteria and then click <strong>Go</strong>.<p/>',
'',
'Many reports include a <strong>Display</strong> control. Use this list to select the maximum number of rows to display per page. Once set, this setting remains intact for the current session. Some reports also include a <strong>View</strong> control.'
||' Use this list to specify how the page displays. Available View options include:<p/>',
'<ul>',
'<li><strong>Icons</strong> (the default) provides an uncluttered simple layout and displays each item as a large icon.</li>',
'<li><strong>Details</strong> provides more details and displays each item as a line in a report. ',
'</ul>',
'',
'Unless otherwise noted, all queries are case insensitive. Wildcards are not necessary.<p/>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107843910343762607)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(107606024046537921)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:window.close();'
);
end;
/
prompt --application/pages/page_00800
begin
wwv_flow_imp_page.create_page(
 p_id=>800
,p_name=>'Data Dictionary Cache'
,p_alias=>'DATA-DICTIONARY-CACHE'
,p_step_title=>'Data Dictionary Cache'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(5108313447012897)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(562149085230879325)
,p_plug_name=>'APEX Data Dictionary Cached Objects'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       APX_CACHE_DATE,',
'       APX_COL_CACHE_DATE,',
'       OBJECT_ID,',
'       OBJECT_OWNER,',
'       OBJECT_NAME,',
'       OBJECT_PREFIX,',
'       OBJECT_TYPE,',
'       OBJECT_CREATED,',
'       OBJECT_LAST_DDL_TIME,',
'       OBJECT_PK_COLUMNS,',
'       DISPLAY_COL_1,',
'       DISPLAY_COL_2,',
'       TAB_LAST_ANALYZED,',
'       TAB_CACHE_NUM_ROWS,',
'       PREFIX_REMOVED_TAB_NAME,',
'       SINGULAR_DISPLAY_LABEL,',
'       PLURAL_DISPLAY_LABEL,',
'       DESCRIPTION,',
'       GEOMETRY_TYPE,',
'       decode(HAS_FK_REFERENCES,''Y'',m.yes,''N'',m.n,HAS_FK_REFERENCES)     HAS_FK_REFERENCES,',
'       decode(HAS_PRIMARY_KEY_YN,''Y'',m.yes,''N'',m.n,HAS_PRIMARY_KEY_YN)   HAS_PRIMARY_KEY_YN,',
'       decode(HAS_LONG_COLUMNS_YN,''Y'',m.yes,''N'',m.n,HAS_LONG_COLUMNS_YN) HAS_LONG_COLUMNS_YN',
'  from WWV_DICTIONARY_CACHE_OBJ co,',
'      (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
'  where SECURITY_GROUP_ID = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(562149154323879326)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y_OF_Z'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>562149154323879326
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562149235754879327)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562149394679879328)
,p_db_column_name=>'APX_CACHE_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Apx Cache Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562149449289879329)
,p_db_column_name=>'APX_COL_CACHE_DATE'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Cache Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562149995631879334)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Object Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562150022397879335)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Object Owner'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562150118797879336)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Object Name'
,p_column_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:RP,801:P801_OBJECT_CACHE_ID:#ID#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562150275189879337)
,p_db_column_name=>'OBJECT_PREFIX'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Object Prefix'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562150340069879338)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562150467501879339)
,p_db_column_name=>'OBJECT_CREATED'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Object Created'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562150569991879340)
,p_db_column_name=>'OBJECT_LAST_DDL_TIME'
,p_display_order=>140
,p_column_identifier=>'N'
,p_column_label=>'Object Last Ddl Time'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562150620019879341)
,p_db_column_name=>'OBJECT_PK_COLUMNS'
,p_display_order=>150
,p_column_identifier=>'O'
,p_column_label=>'Primary Key Columns'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(579566043165721528)
,p_db_column_name=>'DISPLAY_COL_1'
,p_display_order=>160
,p_column_identifier=>'Y'
,p_column_label=>'Primary Display Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(579566131649721529)
,p_db_column_name=>'DISPLAY_COL_2'
,p_display_order=>170
,p_column_identifier=>'Z'
,p_column_label=>'Secondary Display Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562150773491879342)
,p_db_column_name=>'TAB_LAST_ANALYZED'
,p_display_order=>180
,p_column_identifier=>'P'
,p_column_label=>'Statistics Gathered'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562150886525879343)
,p_db_column_name=>'TAB_CACHE_NUM_ROWS'
,p_display_order=>190
,p_column_identifier=>'Q'
,p_column_label=>'Number of Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562151049130879345)
,p_db_column_name=>'PREFIX_REMOVED_TAB_NAME'
,p_display_order=>200
,p_column_identifier=>'S'
,p_column_label=>'Prefix Removed Tab Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562151141348879346)
,p_db_column_name=>'SINGULAR_DISPLAY_LABEL'
,p_display_order=>210
,p_column_identifier=>'T'
,p_column_label=>'Singular Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562151298567879347)
,p_db_column_name=>'PLURAL_DISPLAY_LABEL'
,p_display_order=>220
,p_column_identifier=>'U'
,p_column_label=>'Plural Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1430822503132102)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>230
,p_column_identifier=>'AB'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(564900753579013102)
,p_db_column_name=>'GEOMETRY_TYPE'
,p_display_order=>240
,p_column_identifier=>'AA'
,p_column_label=>'Geometry Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(564913925652056229)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562151310865879348)
,p_db_column_name=>'HAS_FK_REFERENCES'
,p_display_order=>250
,p_column_identifier=>'V'
,p_column_label=>'Has Foreign Key References'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562151464931879349)
,p_db_column_name=>'HAS_PRIMARY_KEY_YN'
,p_display_order=>260
,p_column_identifier=>'W'
,p_column_label=>'Has Primary Key'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(562151538805879350)
,p_db_column_name=>'HAS_LONG_COLUMNS_YN'
,p_display_order=>270
,p_column_identifier=>'X'
,p_column_label=>'Has Long Columns Yn'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(563508467581277904)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5635085'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OBJECT_NAME:OBJECT_OWNER:TAB_CACHE_NUM_ROWS:OBJECT_PK_COLUMNS:OBJECT_PREFIX:SINGULAR_DISPLAY_LABEL:PLURAL_DISPLAY_LABEL:HAS_FK_REFERENCES:HAS_PRIMARY_KEY_YN:OBJECT_CREATED:TAB_LAST_ANALYZED:APX_COL_CACHE_DATE:'
,p_sort_column_1=>'OBJECT_CREATED'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(563501190102271401)
,p_plug_name=>'Workspace Dictionary Cache Filter'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>2
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(563501331978271403)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(563501190102271401)
,p_button_name=>'analyze_refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Gather Statistics and Refresh Cache'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(563501541561271405)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(563501190102271401)
,p_button_name=>'refresh_only'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Refresh Cache Only'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(563501759262271407)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.set_workspace_cache(',
'    p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'    p_gather_stats            => false,',
'    p_max_cache_stale_seconds => 2,  ',
'    p_max_tables_per_schema   => 1000);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(563501541561271405)
,p_internal_uid=>563501759262271407
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(563501842267271408)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats_analyze'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.set_workspace_cache(',
'    p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'    p_gather_stats            => true,',
'    p_max_stats_age_seconds   => 10,',
'    p_max_cache_stale_seconds => 10,    -- seconds',
'    p_max_tables_per_schema   => 1000,   -- tables',
'    p_stats_mode              => ''estimate'',',
'    p_max_elap_exec_time_sec  => 600     -- seconds to exit exit',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(563501331978271403)
,p_internal_uid=>563501842267271408
);
end;
/
prompt --application/pages/page_00801
begin
wwv_flow_imp_page.create_page(
 p_id=>801
,p_name=>'Table Column Cache'
,p_alias=>'TABLE-COLUMN-CACHE'
,p_step_title=>'Table Column Cache'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(5108313447012897)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(563550339948454910)
,p_name=>'Table Details'
,p_template=>wwv_flow_imp.id(486010891028205826)
,p_display_sequence=>24
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_sub_css_classes=>'a-AVPList--leftAligned'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       APX_CACHE_DATE,',
'       OBJECT_NAME,',
'       DESCRIPTION,',
'       OBJECT_TYPE,',
'       OBJECT_CREATED,',
'       OBJECT_LAST_DDL_TIME,',
'       OBJECT_PK_COLUMNS,',
'       TAB_LAST_ANALYZED,',
'       TAB_CACHE_NUM_ROWS,',
'       decode(HAS_FK_REFERENCES,''Y'',m.yes,''N'',m.n,HAS_FK_REFERENCES)     HAS_FK_REFERENCES',
'  from WWV_DICTIONARY_CACHE_OBJ co,',
'      (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
' where id = :P801_OBJECT_CACHE_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(43021310970202834)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563550404021454911)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563550536479454912)
,p_query_column_id=>2
,p_column_alias=>'APX_CACHE_DATE'
,p_column_display_sequence=>52
,p_column_heading=>'Cache Date'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563550925216454916)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1430960694132103)
,p_query_column_id=>4
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>12
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563551070383454917)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>22
,p_column_heading=>'Object Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563551193585454918)
,p_query_column_id=>6
,p_column_alias=>'OBJECT_CREATED'
,p_column_display_sequence=>32
,p_column_heading=>'Object Created'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563551279071454919)
,p_query_column_id=>7
,p_column_alias=>'OBJECT_LAST_DDL_TIME'
,p_column_display_sequence=>42
,p_column_heading=>'Object Last DDL'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563551382932454920)
,p_query_column_id=>8
,p_column_alias=>'OBJECT_PK_COLUMNS'
,p_column_display_sequence=>72
,p_column_heading=>'Primary Key Columns'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563551438728454921)
,p_query_column_id=>9
,p_column_alias=>'TAB_LAST_ANALYZED'
,p_column_display_sequence=>62
,p_column_heading=>'Statistics Gathered'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563551597874454922)
,p_query_column_id=>10
,p_column_alias=>'TAB_CACHE_NUM_ROWS'
,p_column_display_sequence=>82
,p_column_heading=>'Rows'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(563551727262454924)
,p_query_column_id=>11
,p_column_alias=>'HAS_FK_REFERENCES'
,p_column_display_sequence=>92
,p_column_heading=>'Has Foreign Key References'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(581927513832097302)
,p_plug_name=>'Table Query'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>34
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select sys.dbms_lob.substr(DEFAULT_QUERY,32767,1) DEFAULT_QUERY',
'  from WWV_DICTIONARY_CACHE_OBJ',
' where id = :P801_OBJECT_CACHE_ID ) ',
'loop',
'',
'    sys.htp.prn(''<pre class="padding-md">'');',
'    sys.htp.prn(wwv_flow_escape.html(c1.DEFAULT_QUERY));',
'    sys.htp.prn(''</pre>'');',
'',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1125686563202318612)
,p_plug_name=>'Data Dictionary Column Cache'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(829445215771671657)
,p_plug_display_sequence=>14
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       OBJECT_CACHE_ID,',
'       APX_CACHE_DATE,',
'       OWNER_NAME,',
'       TABLE_NAME,',
'       COLUMN_NAME,',
'       DATA_TYPE_DISPLAY,',
'       lower(data_type) DATA_TYPE,',
'       DATA_LENGTH,',
'       DATA_SCALE,',
'       DATA_PRECISION,',
'       has_char_semantics_yn,',
'       NULLABLE,',
'       DENSITY,',
'       NUM_NULLS,',
'       LAST_ANALYZED,',
'       AVG_COL_LEN,',
'       NUM_DISTINCT,',
'       COLUMN_ID,',
'       --',
'       decode(ITEM_DISPLAY_AS,',
'          ''TEXT'',m.m_text,',
'          ''NUMBER'',m.m_number,',
'          ''CHECKBOX'',m.checkbox,',
'          ''DATE_PICKER'',m.date_picker,',
'          ''TEXTAREA'',m.TEXTAREA,',
'          ITEM_DISPLAY_AS)',
'          ITEM_DISPLAY_AS,',
'       decode(FILTER_DISPLAY_AS,''CHECKBOX'',m.checkbox,',
'          ''RANGE'',m.range,',
'          ''DATE_PICKER'',m.date_picker,',
'          FILTER_DISPLAY_AS)',
'          FILTER_DISPLAY_AS,',
'       --',
'       LABEL,',
'       FORMAT_MASK,',
'       --',
'       decode(RECOMMEND_DISP_ON_RPT_YN,    ''Y'',m.yes,''N'',m.n) RECOMMEND_DISP_ON_RPT_YN,',
'       decode(RECOMMEND_DISP_ON_FORMS_YN,  ''Y'',m.yes,''N'',m.n) RECOMMEND_DISP_ON_FORMS_YN,',
'       decode(HAS_LEADING_IDX_YN,          ''Y'',m.yes,''N'',m.n) HAS_LEADING_IDX_YN,    ',
'       decode(IS_SINGLE_COL_PK_YN,         ''Y'',m.yes,''N'',m.n) IS_SINGLE_COL_PK_YN,',
'       --',
'       PK_POSITION,',
'       is_identity_yn,',
'       IS_FK_YN,',
'       IS_FK_INDEXED_YN,',
'       LOW_VALUE,',
'       HIGH_VALUE,',
'       LOW_NUMBER,',
'       HIGH_NUMBER,',
'       LOW_DATE,',
'       HIGH_DATE,',
'       FILTERABLE_SCORE,',
'       PCT_NULL',
'  from WWV_DICTIONARY_CACHE_COL cc,',
'        (select wwv_flow_lang.system_message(''F4000.NO'')    n,',
'                wwv_flow_lang.system_message(''F4000.YES'')   yes,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_CHECKBOX'')    checkbox,',
'                wwv_flow_lang.system_message(''APEX.IG.RANGE'')                range,',
'                wwv_flow_lang.system_message(''ITEM_NAME.TEXT'')               m_text,',
'                wwv_flow_lang.system_message(''WS_NUMBER'')                    m_number,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_DATE_PICKER'') date_picker,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_RADIOGROUP'')  RADIOGROUP,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_TEXTAREA'')    TEXTAREA',
'         from dual) m',
'  where OBJECT_CACHE_ID = :P801_OBJECT_CACHE_ID',
'  and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1125686632295318613)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1125686632295318613
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563538059581439289)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563538486455439290)
,p_db_column_name=>'APX_CACHE_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Cache Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563501928066271409)
,p_db_column_name=>'OBJECT_CACHE_ID'
,p_display_order=>30
,p_column_identifier=>'Y'
,p_column_label=>'Object Cache ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502020761271410)
,p_db_column_name=>'OWNER_NAME'
,p_display_order=>40
,p_column_identifier=>'Z'
,p_column_label=>'Owner Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502124363271411)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>50
,p_column_identifier=>'AA'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502272165271412)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>60
,p_column_identifier=>'AB'
,p_column_label=>'Column Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502370236271413)
,p_db_column_name=>'DATA_TYPE_DISPLAY'
,p_display_order=>70
,p_column_identifier=>'AC'
,p_column_label=>'Item Display'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502488541271414)
,p_db_column_name=>'DATA_TYPE'
,p_display_order=>80
,p_column_identifier=>'AD'
,p_column_label=>'Data Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502584445271415)
,p_db_column_name=>'DATA_LENGTH'
,p_display_order=>90
,p_column_identifier=>'AE'
,p_column_label=>'Data Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502698655271416)
,p_db_column_name=>'DATA_SCALE'
,p_display_order=>100
,p_column_identifier=>'AF'
,p_column_label=>'Data Scale'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502778121271417)
,p_db_column_name=>'DATA_PRECISION'
,p_display_order=>110
,p_column_identifier=>'AG'
,p_column_label=>'Data Precision'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(606264190961993801)
,p_db_column_name=>'HAS_CHAR_SEMANTICS_YN'
,p_display_order=>120
,p_column_identifier=>'BO'
,p_column_label=>'Uses Character Semantics'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157815226475866526)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502846649271418)
,p_db_column_name=>'NULLABLE'
,p_display_order=>130
,p_column_identifier=>'AH'
,p_column_label=>'Nullable'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157815226475866526)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563502977339271419)
,p_db_column_name=>'DENSITY'
,p_display_order=>140
,p_column_identifier=>'AI'
,p_column_label=>'Density'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503037550271420)
,p_db_column_name=>'NUM_NULLS'
,p_display_order=>150
,p_column_identifier=>'AJ'
,p_column_label=>'Number of Nulls'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503199017271421)
,p_db_column_name=>'LAST_ANALYZED'
,p_display_order=>160
,p_column_identifier=>'AK'
,p_column_label=>'Statistics Gathered'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503270403271422)
,p_db_column_name=>'AVG_COL_LEN'
,p_display_order=>170
,p_column_identifier=>'AL'
,p_column_label=>'Average Data Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503389059271423)
,p_db_column_name=>'NUM_DISTINCT'
,p_display_order=>180
,p_column_identifier=>'AM'
,p_column_label=>'Distinct'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503428867271424)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>190
,p_column_identifier=>'AN'
,p_column_label=>'Column ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503576029271425)
,p_db_column_name=>'ITEM_DISPLAY_AS'
,p_display_order=>200
,p_column_identifier=>'AO'
,p_column_label=>'Item Display'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503665016271426)
,p_db_column_name=>'FILTER_DISPLAY_AS'
,p_display_order=>210
,p_column_identifier=>'AP'
,p_column_label=>'Facet Display'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503706778271427)
,p_db_column_name=>'LABEL'
,p_display_order=>220
,p_column_identifier=>'AQ'
,p_column_label=>'Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503829018271428)
,p_db_column_name=>'FORMAT_MASK'
,p_display_order=>230
,p_column_identifier=>'AR'
,p_column_label=>'Format Mask'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563503938940271429)
,p_db_column_name=>'RECOMMEND_DISP_ON_RPT_YN'
,p_display_order=>240
,p_column_identifier=>'AS'
,p_column_label=>'Recommend Disp On Rpt Yn'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563504041407271430)
,p_db_column_name=>'RECOMMEND_DISP_ON_FORMS_YN'
,p_display_order=>250
,p_column_identifier=>'AT'
,p_column_label=>'Recommend Disp On Forms Yn'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563504123489271431)
,p_db_column_name=>'HAS_LEADING_IDX_YN'
,p_display_order=>260
,p_column_identifier=>'AU'
,p_column_label=>'Has Leading Idx Yn'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563504211806271432)
,p_db_column_name=>'IS_SINGLE_COL_PK_YN'
,p_display_order=>270
,p_column_identifier=>'AV'
,p_column_label=>'Single Column Primary Key'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563504605701271436)
,p_db_column_name=>'PK_POSITION'
,p_display_order=>280
,p_column_identifier=>'AZ'
,p_column_label=>'Primary Key Position'
,p_column_type=>'NUMBER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(606264262564993802)
,p_db_column_name=>'IS_IDENTITY_YN'
,p_display_order=>290
,p_column_identifier=>'BP'
,p_column_label=>'Identity Column'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(157815226475866526)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563504716242271437)
,p_db_column_name=>'IS_FK_YN'
,p_display_order=>300
,p_column_identifier=>'BA'
,p_column_label=>'Foreign Key'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563504893078271438)
,p_db_column_name=>'IS_FK_INDEXED_YN'
,p_display_order=>310
,p_column_identifier=>'BB'
,p_column_label=>'Foreign Key Indexed'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563505263626271442)
,p_db_column_name=>'LOW_VALUE'
,p_display_order=>320
,p_column_identifier=>'BF'
,p_column_label=>'Low Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563505307307271443)
,p_db_column_name=>'HIGH_VALUE'
,p_display_order=>330
,p_column_identifier=>'BG'
,p_column_label=>'High Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563505431326271444)
,p_db_column_name=>'LOW_NUMBER'
,p_display_order=>340
,p_column_identifier=>'BH'
,p_column_label=>'Low Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563505571837271445)
,p_db_column_name=>'HIGH_NUMBER'
,p_display_order=>350
,p_column_identifier=>'BI'
,p_column_label=>'High Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563505667750271446)
,p_db_column_name=>'LOW_DATE'
,p_display_order=>360
,p_column_identifier=>'BJ'
,p_column_label=>'Low Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563505789428271447)
,p_db_column_name=>'HIGH_DATE'
,p_display_order=>370
,p_column_identifier=>'BK'
,p_column_label=>'High Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563505823249271448)
,p_db_column_name=>'FILTERABLE_SCORE'
,p_display_order=>380
,p_column_identifier=>'BL'
,p_column_label=>'Faceted Search Score'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(563506094284271450)
,p_db_column_name=>'PCT_NULL'
,p_display_order=>390
,p_column_identifier=>'BN'
,p_column_label=>'Percent Null'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1127045945552717191)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5635456'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COLUMN_ID:COLUMN_NAME:LABEL:FILTERABLE_SCORE:DATA_TYPE:ITEM_DISPLAY_AS:FILTER_DISPLAY_AS:DENSITY:AVG_COL_LEN:NUM_DISTINCT:NUM_NULLS:PCT_NULL:LAST_ANALYZED:APX_CACHE_DATE:'
,p_sort_column_1=>'COLUMN_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1127038668073710688)
,p_plug_name=>'Workspace Dictionary Cache Filter'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(720165508600362771)
,p_plug_display_sequence=>2
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(563546320122439299)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1127038668073710688)
,p_button_name=>'analyze_refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Gather Statistics and Refresh Cache'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(563546787400439301)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1127038668073710688)
,p_button_name=>'refresh_only'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(486003960305193183)
,p_button_image_alt=>'Refresh Cache Only'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563550051497454907)
,p_name=>'P801_OBJECT_CACHE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1127038668073710688)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563550130372454908)
,p_name=>'P801_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1127038668073710688)
,p_prompt=>'Table Owner'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_owner',
'from wwv_dictionary_cache_obj',
'where id = :P801_OBJECT_CACHE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563550297380454909)
,p_name=>'P801_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1127038668073710688)
,p_prompt=>'Table Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select OBJECT_NAME',
'from wwv_dictionary_cache_obj',
'where id = :P801_OBJECT_CACHE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(489153051785943514)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(563547427786439302)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_new_object_cache_id number;',
'begin',
'    l_new_object_cache_id := wwv_dictionary_cache_dev.builder_reset_object_cache(',
'                                 p_workspace_id             => :WORKSPACE_ID,',
'                                 p_object_id                => :P801_OBJECT_CACHE_ID,',
'                                 p_cache_fk_references      => true,',
'                                 p_gather_stats             => false );',
'                                 ',
'    :P801_OBJECT_CACHE_ID := l_new_object_cache_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(563546787400439301)
,p_internal_uid=>563547427786439302
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(563547818193439303)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats_analyze'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_new_object_cache_id number;',
'begin',
'    l_new_object_cache_id := wwv_dictionary_cache_dev.builder_reset_object_cache(',
'                                 p_workspace_id             => :WORKSPACE_ID,',
'                                 p_object_id                => :P801_OBJECT_CACHE_ID,',
'                                 p_cache_fk_references      => true,',
'                                 p_gather_stats             => true );',
'                                 ',
'    :P801_OBJECT_CACHE_ID := l_new_object_cache_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(563546320122439299)
,p_internal_uid=>563547818193439303
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_imp_page.create_page(
 p_id=>8000
,p_name=>'Search Users'
,p_alias=>'SEARCH-USERS'
,p_step_title=>'Search Users'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215450104703534414)
,p_step_template=>wwv_flow_imp.id(692762974728114205)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12518728403445471)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/aadm_users.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30339228864719822)
,p_plug_name=>'Accounts'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(486010891028205826)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'case ',
'     -- unlocked, expired',
'     when (nvl(u.account_locked,''N'') = ''N'' and ',
'            ((wwv_flow_fnd_user_api.workspace_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)) <= 0) or',
'            (nvl(wwv_flow_fnd_user_api.end_user_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)),1) <= 0))) ',
'     then ''#IMAGE_PREFIX#htmldb/icons/user_''||',
'          decode(nvl(d.is_admin,''N''),''Y'',''red'',',
'          decode(nvl(d.is_developer,''N''),''Y'',''yellow'',''green''))',
'          ||''_exp.gif''',
'     -- locked, expired',
'     when (nvl(u.account_locked,''N'') = ''Y'' and ',
'            ((wwv_flow_fnd_user_api.workspace_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)) <= 0) or',
'            (nvl(wwv_flow_fnd_user_api.end_user_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)),1) <= 0))) ',
'     then ''#IMAGE_PREFIX#htmldb/icons/user_''||',
'          decode(nvl(d.is_admin,''N''),''Y'',''red'',',
'          decode(nvl(d.is_developer,''N''),''Y'',''yellow'',''green''))',
'          ||''_locked_exp.gif''',
'     -- locked, unexpired',
'     when (nvl(u.account_locked,''N'') = ''Y'' and ',
'            (wwv_flow_fnd_user_api.workspace_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)) > 0) and',
'            (nvl(wwv_flow_fnd_user_api.end_user_account_days_left(',
'            wwv_flow_user_api.get_username(user_id)),1) > 0)) ',
'     then ''#IMAGE_PREFIX#htmldb/icons/user_''||',
'          decode(nvl(d.is_admin,''N''),''Y'',''red'',',
'          decode(nvl(d.is_developer,''N''),''Y'',''yellow'',''green''))',
'          ||''_locked.gif''',
'else',
'    -- unlocked and unexpired',
'    ''#IMAGE_PREFIX#htmldb/icons/user_''||',
'    decode(nvl(d.is_admin,''N''),''Y'',''red'',',
'    decode(nvl(d.is_developer,''N''),''Y'',''yellow'',''green''))||''.gif''',
'end icon_view_icon,',
'u.email_address alt,',
'''f?p=4350:56:''||:flow_session||',
'   ''::NO:EDIT_USER_PRIVS:F4350_P56_USER_ID,LAST_VIEW:''||USER_ID||'',55:'' link,',
'replace(replace(replace(u.user_name,''_'','' ''),''.'',''. ''),''@'',''@ '') icon_view_name,',
'-- ',
'      USER_ID,',
'      u.user_name "USER",',
'      u.email_address "eMail",',
'      u.first_name,',
'      u.last_name,',
'      replace(u.default_schema,''%''||''null%'',null) df,',
'      decode(nvl(d.is_developer,''N''),''Y'', (select case',
'              when (wwv_flow_fnd_user_api.workspace_account_days_left(',
'                    wwv_flow_user_api.get_username(user_id)) > 0) ',
'              then m.password_valid',
'	      else m.password_expired',
'              end expiration from dual),',
'             m.no_developer_priv) developer,',
'      decode (nvl(d.is_developer,''N''),''Y'',last_login,null) last_login,',
'      decode (nvl(d.is_developer,''N''),''Y'',last_login,null) last_login2,',
'      decode (nvl(d.is_developer,''N''),''Y'',',
'          nvl(builder_login_count,0),null) builder_login_count,',
'      decode(nvl(u.account_locked,''N''),''Y'',m.yes,m.n)ul,',
'     case ',
'     when (wwv_flow_fnd_user_api.end_user_account_days_left(',
'           wwv_flow_user_api.get_username(user_id)) > 0) ',
'     then m.password_valid',
'     else m.password_expired',
'    end expiration,',
'u.DESCRIPTION,',
'u.PASSWORD_LIFESPAN_DAYS,',
'u.PASSWORD_LIFESPAN_ACCESSES,',
'u.PASSWORD_ACCESSES_LEFT,',
'u.LAST_AGENT,',
'u.LAST_IP,',
'u.ACCOUNT_EXPIRY,',
'u.FAILED_ACCESS_ATTEMPTS,',
'u.CHANGE_PASSWORD_ON_FIRST_USE,',
'u.FIRST_PASSWORD_USE_OCCURRED,  ',
'decode(nvl(d.is_admin,''N''),''Y'',',
'  m.admin,decode(nvl(d.is_developer,''N''),',
'  ''Y'',m.dev,m.end_user)) dev_type,',
'(select group_id from WWV_FLOW_FND_GROUP_USERS where user_id = u.user_id) group_id,',
'(select GROUP_NAME from WWV_FLOW_FND_USER_GROUPS where id = (select group_id from WWV_FLOW_FND_GROUP_USERS where user_id = u.user_id)) group_name,',
'LAST_UPDATE_DATE,',
'LAST_UPDATED_BY,',
'CREATION_DATE,',
'CREATED_BY,',
'nvl(d.developer_type,''END_USER'') developer_type',
'from  WWV_FLOW_FND_USER u,',
'   (select USERID,',
'           decode(instr(DEVELOPER_ROLE,''ADMIN''),0,''N'',''Y'') is_admin,',
'           ''Y'' is_developer,',
'           case ',
'           when instr(DEVELOPER_ROLE,''BASIC_DEV'') > 0 then',
'              ''BASIC_DEV''',
'           when instr(DEVELOPER_ROLE,''ADMIN'') > 0 then',
'              ''ADMIN''',
'           when instr(DEVELOPER_ROLE,''CREATE'') > 0 then',
'              ''DEVELOPER''',
'           else',
'              ''UNKNOWN'' ',
'           end developer_type',
'    from WWV_FLOW_DEVELOPERS',
'    where security_group_id = :flow_security_group_id) d,',
'    (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes,',
'            wwv_flow_lang.system_message(''PASSWORD_VALID'') password_valid,',
'            wwv_flow_lang.system_message(''PASSWORD_EXPIRED'') password_expired,',
'            wwv_flow_lang.system_message(''NO_DEVELOPER_PRIV'') no_developer_priv,',
'            wwv_flow_lang.system_message(''DEVELOPER'') dev,',
'            wwv_flow_lang.system_message(''ADMINISTRATOR'') admin,',
'            wwv_flow_lang.system_message(''END_USER'') end_user,',
'            wwv_flow_lang.system_message(''BASIC_DEVELOPER'') basic_developer',
'     from dual) m',
'where ',
'     u.user_name = d.userid(+) and',
'     u.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(30339431409719823)
,p_name=>'Internal Accounts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'LINK'
,p_icon_view_img_src_column=>'ICON_VIEW_ICON'
,p_icon_view_label_column=>'ICON_VIEW_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340720658719851)
,p_db_column_name=>'USER_ID'
,p_display_order=>1
,p_column_identifier=>'E'
,p_column_label=>'Edit'
,p_column_link=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.::F4350_P56_USER_ID,LAST_VIEW:#USER_ID#,55'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="">'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340807591719851)
,p_db_column_name=>'USER'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>'User'
,p_column_link=>'f?p=4350:57:&SESSION.::NO::P57_USERID,LAST_VIEW:#USER_ID#,60'
,p_column_linktext=>'#USER#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340932657719851)
,p_db_column_name=>'eMail'
,p_display_order=>3
,p_column_identifier=>'G'
,p_column_label=>'Email'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341007259719852)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'H'
,p_column_label=>'First Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341115903719852)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Last Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341216671719852)
,p_db_column_name=>'DF'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Default Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341624479719853)
,p_db_column_name=>'UL'
,p_display_order=>7
,p_column_identifier=>'N'
,p_column_label=>'Locked'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341829960719853)
,p_db_column_name=>'DEV_TYPE'
,p_display_order=>8
,p_column_identifier=>'P'
,p_column_label=>'Account Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341312303719852)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>9
,p_column_identifier=>'K'
,p_column_label=>'Password Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341701840719853)
,p_db_column_name=>'EXPIRATION'
,p_display_order=>10
,p_column_identifier=>'O'
,p_column_label=>'End User Account'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341408222719852)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>'Builder Last Login Date'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341508580719852)
,p_db_column_name=>'BUILDER_LOGIN_COUNT'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Builder Login Count'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30339525401719843)
,p_db_column_name=>'ICON_VIEW_ICON'
,p_display_order=>13
,p_column_identifier=>'A'
,p_column_label=>'Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340415388719850)
,p_db_column_name=>'ALT'
,p_display_order=>14
,p_column_identifier=>'B'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340501058719850)
,p_db_column_name=>'LINK'
,p_display_order=>15
,p_column_identifier=>'C'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340605855719850)
,p_db_column_name=>'ICON_VIEW_NAME'
,p_display_order=>16
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30341917359719853)
,p_db_column_name=>'LAST_LOGIN2'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Builder Last Login'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30342016012719853)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30342114024719853)
,p_db_column_name=>'PASSWORD_LIFESPAN_DAYS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Password Lifespan Days'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30342220166719854)
,p_db_column_name=>'PASSWORD_LIFESPAN_ACCESSES'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Password Lifespan Accesses'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30342300491719854)
,p_db_column_name=>'PASSWORD_ACCESSES_LEFT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Password Accesses Left'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30342415979719854)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Last Agent'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30342519574719854)
,p_db_column_name=>'LAST_IP'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Last IP Address'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30342607632719854)
,p_db_column_name=>'ACCOUNT_EXPIRY'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Account Expiry'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30342708175719854)
,p_db_column_name=>'FAILED_ACCESS_ATTEMPTS'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Failed Access Attempts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30342831491719855)
,p_db_column_name=>'CHANGE_PASSWORD_ON_FIRST_USE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Change Password On First Use'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30339605976719848)
,p_db_column_name=>'FIRST_PASSWORD_USE_OCCURRED'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'First Password Use Occurred'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30339725059719848)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Group ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30339818967719849)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Group Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30339918103719849)
,p_db_column_name=>'LAST_UPDATE_DATE'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340030221719849)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340122309719849)
,p_db_column_name=>'CREATION_DATE'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340227868719849)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30340317761719850)
,p_db_column_name=>'DEVELOPER_TYPE'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'Developer Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(30342924435719855)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1312622728536648'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'USER_ID:USER:eMail:DF:UL:DEV_TYPE:DEVELOPER:ICON_VIEW_ICON:ALT:LINK:ICON_VIEW_NAME:LAST_LOGIN2:GROUP_ID:CREATION_DATE:DEVELOPER_TYPE'
,p_sort_column_1=>'USER'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'CREATION_DATE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'LAST_LOGIN2'
,p_sort_direction_3=>'DESC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30345026463719899)
,p_branch_action=>'8000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30344406934719892)
,p_computation_sequence=>1
,p_computation_item=>'F4350_P4802_USER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30344615543719895)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'55'
,p_compute_when=>'CREATE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_imp_shared.create_install(
 p_id=>wwv_flow_imp.id(821866967507785957)
);
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_imp.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false)
);
commit;
end;
/
set verify on feedback on define on
prompt  ...done
